/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 * Omar Halabi
 * e-mail: oha@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/



//#include <unistd.h>
//#include <sys/time.h>
#include <sys/socket.h>

#include "Transport.h"

int receive(int fd,
		   char*  data,
		   int length,
		   int flags)
{
    int totalSoFar = 0;
    int numBytes = 0;
    unsigned char * copy = data;

    if (flags != MSG_PEEK)
    {
      do 
      {

	numBytes = recv(fd, (char *)copy, length, flags);

	if (numBytes == -1)
	    return numBytes;
	
	copy += numBytes;
	totalSoFar = totalSoFar + numBytes;
	length = length - numBytes;
      } while( length != 0 );
      return totalSoFar;
    }
    else
    {
      int numTries = 0;
      numBytes = recv(fd, (char *)data, length, flags);
      while (numBytes != length && numTries++ < 10)
      {
#ifdef WIN32
        Sleep(1000);
#else
        sleep(1);
#endif
        numBytes = recv(fd, (char *)data, length, flags);
      }
      return numBytes;
    }
};
			   
