/*---------------------------------------------------------------------------
 * Name: adaptor.c
 *
 */
#ifdef USE_TTMAN
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h> 
#include <string.h>

#include "if_ttman.h"

char tm_usgtxt[] =
"GCI-ETS (GW) together with TSP1-FE\n"
"Usage: ttcnclt [-h] [-v...] tc-name conf-name"
"\n"
"	-h		print this info\n"
"	-v		verbose, more v's give more verbosity\n"
"	tc-name		name of the test component \n"
"	conf-name	name of the test configuration\n";

static FIFO_t fifo;
static int 	TestCaseRun=FALSE;
static int	parametersReadIn=FALSE;
static int      cancel_exec_flag=FALSE; 
static int	error_code;
static char*    RunningTestCaseName;
static AsnList	myParam;
char	*conf_name;
#endif

#include        <iostream.h>
#ifndef         WIN32
#include        <stdio.h>
#include        <ctype.h>
#include        <string.h>
#include        <strings.h>
#include        <sys/time.h>
#include        <sys/types.h>
#include        <sys/socket.h>
#include        <netinet/in.h>
#include        <arpa/inet.h>
#include        <netdb.h>
#include        <fcntl.h>
#include        <sys/stat.h>		/* For FIFO-I/O */
#include        <signal.h>
#include 	<sys/wait.h>
#include	<unistd.h>
#include        <errno.h>
#include        <math.h>
#include        <assert.h>
#include        <strings.h>
#include        <stdlib.h>
#include        <malloc.h>
#include 	<sys/select.h>
#else
#include         <winsock.h>
#endif
#include        "gci.h"
#include 	"s_type.h"
#include 	"s_decl.h"
#include 	"s_constr.h"
#include 	"s_dyn.h"
#include 	"s_aux.h"
#include        <iiop.hh>
#include        <perfor.h>
#include        <Myadaptor.h>


int VERBOSITY=1;
#define DO_VERBOSE
#ifdef DO_VERBOSE
void verbose_print(int level, char *fmt,...)
 {
	va_list         ap;
	if (VERBOSITY >= level) {
		va_start(ap, fmt);
		vinform(fmt, ap);
		va_end(ap);
	}
};

#define VERBOSE(F)	verbose_print F
#define CHECK(C,F)	if(!(C)) verbose_print F
#define VERBOSE_PRINT(L,N,F)                 	       
#define BUG(F)		bug F
#define WARN(F) 	warn F
#define ERRORS(F) 	error F
#define MKSTR(S)	#S
#endif

// Indication of an error
#define WRONG_OBJ_REF "-1"
#define ERROR_IND -1

#define PAR_FILE_NAME "TSPar"
#define REFFILE_SUFFIX ".ref"
#define LOG_FILE_NAME "ETS.log"



/************************************************************
 * 
 *
 *     veriable declaration und timer
 *
 *
 **********************************************************/

#define INITIAL_SEED 11;
#define TRUE  1
#define FALSE 0 
#define n  200
#define MSG_LENGTH  12
#define N sizeof(long)
char refFile[100];  
char Objkey_refFile[100];
enum protocolTypes { TCPIP, IIOP };
int body;
IOR * sIOR = 0;
ProfileBody * sBody;

struct giop_version
{
  char MIN;
  char MAJ;
 };
 
 int Tshort_value = 10;

typedef struct PCO
{
   char * Name;
   int Id;
   int protocolType;
   int InStream;
   int OutStream;
   struct PCO * Next;
} MyPCO;
 
MyPCO * PCOList;
MyPCO * prevPco;

/*************************user operation**************************/

void sendRequest(GciValue * obj, int fd);
void sendRequest_1_1(GciValue * obj, int fd);
void sendRequest_1_2(GciValue * obj, int fd);
void sendLocaterequest(GciValue * obj, int fd);
void sendLocaterequest_1_2(GciValue * obj, int fd);
void sendCancelrequest(GciValue * obj, int fd);

char * MessageEncode(GciValue * Obj);
GciStatus MessageDecode(int PCOD,  unsigned char * buffer);
int addPCO_CP(MyPCO * aPCOCP);
int setPCOCPStream(int aPCOid, int fd);
int writeOnPCO(int fd, char * msg);
MyPCO * findPCO_CP(int aPCOid);
GciStatus CreateReceiveObject(int PCOD, int Type, unsigned char * aMsg);

 extern "C"
 {
  char * getreffilename();
  char * getobjkey_refFilename();
  char *  objkeyior_analyze();
  char *  ior_analyze();
  int sockRead (int sockfd, char *ptr, int len);
  GciValue* select_ReqID();
  //GciValue* getType_ID();
  GciValue* getServerHost();
  GciValue* getServerPort();
  GciValue* getServerObjKey();
  GciValue* tcpConnectionEstabl( GciValue * host, GciValue *  port);
  GciValue* tcpConnectionClose();
 }

vsOrbSeqOctet& getObjectKey()
{
  IOR * sIOR = 0;
  ProfileBody * sBody;
  char * rcvbuf;
  rcvbuf =  objkeyior_analyze(); // ior_analyze();
  sIOR = new IOR(rcvbuf);
  sBody = sIOR->extractInternetTag();
  return(sBody->objectKey()); 
}

void sendLocaterequest(GciValue * obj, int fd)
{
  int msgLen;
  unsigned char * buffer; 

  IIOPLocateRequestMessage locReq(obj);
  locReq.marshall();
  
  msgLen = locReq.getMarshalledBufferLen();
  buffer = locReq.getMarshalledBuffer();
  locReq.updateStreamLength(msgLen);
  #ifndef WIN32
  write( fd, buffer, msgLen);
 
#else
  send(fd, (char *)buffer, msgLen, 0);
 
#endif
 
  // return 0;
}


void sendLocaterequest_1_2(GciValue * obj, int fd)
{
  int msgLen;
  unsigned char * buffer; 

  IIOPLocateRequestMessage_1_2 locReq(obj);
  locReq.marshall();
  
  msgLen = locReq.getMarshalledBufferLen();
  buffer = locReq.getMarshalledBuffer();
  locReq.updateStreamLength(msgLen);
  #ifndef WIN32
  write( fd, (void *)buffer, msgLen);
#else
  send(fd, (char *)buffer, msgLen, 0);
#endif 
  //  return 0;
}


void  sendRequest(GciValue * obj, int fd)
{
 
  int msgLen;
  int numbytes = 0;
  unsigned char * buffer; 

  IIOPRequestMessage reqMsg(obj);
  reqMsg.marshall();

 
  msgLen = reqMsg.getMarshalledBufferLen();
  buffer = reqMsg.getMarshalledBuffer();
  reqMsg.updateStreamLength(msgLen);
#ifndef WIN32
  write( fd, buffer, msgLen);
#else
  send(fd, (char *)buffer, msgLen, 0);
#endif
  //return 0;
}




void sendRequest_1_1(GciValue * obj, int fd)
{
  int msgLen;
  unsigned char * buffer; 

  IIOPRequestMessage_1_1 reqMsg(obj);
  reqMsg.marshall();
 
  msgLen = reqMsg.getMarshalledBufferLen();
  buffer = reqMsg.getMarshalledBuffer();
  reqMsg.updateStreamLength(msgLen);
 
#ifndef WIN32
  write( fd, buffer, msgLen);
#else
  send(fd, (char *)buffer, msgLen, 0);
#endif
 
  // return 0;
}


void  sendRequest_1_2(GciValue * obj, int fd)
{
  int msgLen;
  unsigned char * buffer; 

  IIOPRequestMessage_1_2 reqMsg(obj);
  reqMsg.marshall();
  
  msgLen = reqMsg.getMarshalledBufferLen();
  buffer = reqMsg.getMarshalledBuffer();
  reqMsg.updateStreamLength(msgLen);
 
#ifndef WIN32
  write( fd, buffer, msgLen);
 
#else
  send(fd, (char *)buffer, msgLen, 0);
  
#endif
  // return 0;
}


void sendCancelRequest(GciValue * obj, int fd)
{
  int msgLen;
  unsigned char * buffer; 

  IIOPCancelRequestMessage canMsg(obj);
  canMsg.marshall();
  
  msgLen = canMsg.getMarshalledBufferLen();
  buffer = canMsg.getMarshalledBuffer();
  canMsg.updateStreamLength(msgLen);
  
#ifndef WIN32
  write( fd, (void *)buffer, msgLen);
#else
  send(fd, (char *)buffer, msgLen, 0);
#endif

  //return 0;
}

/*int sendFragment(GciValue * obj, int fd)
{ 
  int msgLen;
  unsigned char * buffer; 
  IIOPFragmentMessage frgReq(obj);
  frgReq.marshall();
  msgLen = frgReq.getMarshalledBufferLen();
  buffer = frgReq.getMarshalledBuffer();
  frgReq.updateStreamLength(msgLen);
  write( fd, buffer, msgLen);
  return 0;
}
*/

GciStatus CreatePCOsAndTimers()
{

  MyPCO * aPco;
 


 aPco = (MyPCO*) malloc(sizeof(MyPCO));
 
 aPco->Id = GcLTPCO1D;
 aPco->protocolType = TCPIP;
 aPco->InStream = 0;
 aPco->OutStream = 0;
 aPco->Next = NULL;
 addPCO_CP(aPco);
 
 AdInitTimers ();
  return(GciOk);

}

int addPCO_CP(MyPCO * aPCOCP)
{

   if(PCOList == NULL)
      PCOList = aPCOCP; /* first PCO in the list */
   else
     prevPco->Next = aPCOCP;

   prevPco = aPCOCP;

   return 0;
}

int setPCOCPStream(int aPCOid,int fd)
{
   MyPCO * aPCO;

   for(aPCO = PCOList; aPCO != NULL; aPCO = aPCO->Next)
     if(aPCO->Id == aPCOid)
       {
	  aPCO->InStream = fd;
	  aPCO->OutStream = fd;
	   break;
       }


   return 0;
}

MyPCO * findPCO_CP(int aPCOid)
{
   MyPCO * aPCO;

   for(aPCO = PCOList; aPCO != NULL; aPCO = aPCO->Next)
     if(aPCO->Id == aPCOid)
       {
	  break;
       }

   return aPCO;
}

/*************************************************************************
 *                             Local user operations
 *************************************************************************/
char * getobjkey_refFilename()
{

 
  printf("\nEnter the refFile for the ObjectKey name  : ");
  cin >> Objkey_refFile;
  
  return Objkey_refFile;

}


char * getreffilename()
{

  printf("\nEnter the refFile name : ");
  
  cin >> refFile;
  return refFile;

}


char *  objkeyior_analyze()
{
  
  
  FILE * datei; 
  char zeile[600]; 
  char  sp[600];	
  datei = fopen( Objkey_refFile, "r" ); 
  fgets( zeile, 500, datei );
	
       while( ! feof(datei) )
        {
	  fgets( zeile, 500 , datei );
	}
	      
       
	return (strcpy(sp, zeile)); //sp;
	free(sp);
	fclose(datei);
}   	    

char *  ior_analyze()
{
  
  
  FILE * datei; 
  char zeile[600]; 
  char  sp[600];	
  datei = fopen( refFile, "r" ); 
  fgets( zeile, 500, datei );
	
       while( ! feof(datei) )
        {
	  fgets( zeile, 500 , datei );
	}
	      
       
	return (strcpy(sp, zeile)); //sp;
	free(sp);
	fclose(datei);
}   	    



/**************************************************************************
 *                  Test suite Operation Definitions 
 ***************************************************************************/

GciValue* select_ReqID()
{
  GciValue * theValue;
  long   ReqID_id;
  
  ReqID_id = random();

  theValue =  GciMkINTEGER(ReqID_id);
  return(theValue);
                             
 }

GciValue* getServerPort()
{
  
  GciValue * theValue;
  CORBA::UShort   portId;
 char * rcvbuf;
  rcvbuf = ior_analyze();
  sIOR = new IOR(rcvbuf);
  sBody = sIOR->extractInternetTag();
  portId = sBody->port();
  theValue = GciMkINTEGER(portId);
  return(theValue);
  

}


GciValue* getServerHost()
{
  GciValue * theValue;
  char *   hostId;
  char * rcvbuf;
  rcvbuf = ior_analyze();
  sIOR = new IOR(rcvbuf);
  sBody = sIOR->extractInternetTag();
  hostId = sBody->host();
  theValue = GciMkGraphicString(hostId);
  return(theValue);
  

}

GciValue* getServerObjKey()
{
 char * ok1;
GciValue * theValue; 
 

ok1 = "";
theValue = GciMkGraphicString(ok1);
return(theValue);
}

GciValue* tcpConnectionEstabl( GciValue * targ_host, GciValue *  targ_port )
    
{
  
  
  GciValue * theValue;
  int sockfd;
  struct sockaddr_in server_addr;
  struct hostent *hp;
 
  
  if((  sockfd = socket (AF_INET, SOCK_STREAM, 0)) < 0)
    {
      perror ("ERROR opening socketin sockConnect");
      exit(1);  
    }
 

  server_addr.sin_family = AF_INET;
  server_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  server_addr.sin_port = htons (GciGetINTEGER(targ_port));
  hp = gethostbyname (GciGetGraphicString(targ_host));
  memcpy (&server_addr.sin_addr, hp->h_addr, hp->h_length);
 
if (connect (sockfd, (struct sockaddr *) &server_addr, sizeof (server_addr)) < 0) 
    {
      perror ("Socket verbinden");
      exit(1);
    }

    setPCOCPStream( GcLTPCO1D, sockfd);
    theValue =  GciMkINTEGER(sockfd);  
    
    return theValue ;

  
  /*

   int sockfd;
   int ServerLen;
   struct sockaddr_in   server_addr;
   GciValue* theValue; 
  
   bzero (( char*)&server_addr, sizeof(server_addr));
   server_addr.sin_family=AF_INET;      
   server_addr.sin_port= htons(GciGetINTEGER(targ_port));
   server_addr.sin_addr.s_addr = inet_addr(GciGetGraphicString(targ_host));
   sockfd  = socket (PF_INET, SOCK_STREAM, 0);
  
   if( sockfd < 0)
     {
       perror("ERROR opening socketin sockConnect \n");
       exit(1);
     }
   
   if ( connect ( sockfd, (struct sockaddr *)&server_addr,
		  sizeof(server_addr)) < 0)
     {
       perror("ERROR connecting to server \n");
       close(sockfd);
       sleep(1);

     }
   setPCOCPStream( GcLTPCO1D, sockfd);
   theValue =  GciMkINTEGER(sockfd); 
   printf(" THE TCPCONNECTION IS END\n");  
   return theValue ;
   
  */

}

GciValue* tcpConnectionClose()
{
 GciValue* theValue; 
 close(0);
 theValue = GciMkBOOLEAN(TRUE);
 return theValue;
  
}



int writeOnPCO(int fd , char * msg)
{

  write(fd, msg, strlen(msg));

  fprintf(stderr,"written on PCO/CP socket %d : %s \n", fd, msg);

  

  return 0;
}

//-----------------
// TTman adaptation|
//-----------------
#ifdef USE_TTMAN

/*
 * remove  all its nodes, and the the dataElemnts. 
 * This is taken from the snacc distribution and modified
 */
void SetOctet(AsnOcts * F, char *s)
{
  if (ASNOCTS_PRESENT(F)) {
    FreeAsnOcts(F);
  }
  F->octs = (char *) Asn1Alloc(strlen(s) + 1);
  strcpy(F->octs, s);
  F->octetLen = strlen(F->octs);
};

void AsnListClear(AsnList * L)
{
  AsnListFirst(L);
  while (L->count > 0) {
    Asn1Free(CURR_LIST_ELMT(L));
    AsnListRemove(L);
  }
};

void CopyParam(Param * FROM, Param * TO)
{
  Param          *tmpParam;
  tmpParam =  (Param *) Asn1Alloc(sizeof(Param));
  SetOctet(&(TO)->param_id, FROM->param_id.octs);
  SetOctet(&(TO)->param_value, FROM->param_value.octs);
};

void CopyParamList(AsnList * FROM, AsnList * TO)
{
  Param          *tmpParam;
  Param         **H;

  for (FROM->curr = FROM->first; 
       (FROM->curr &&  (tmpParam = (Param *) FROM->curr->data)); 
       FROM->curr = FROM->curr->next)
    {    
      H = (Param **) AsnListAppend(TO);
      *H = (Param *) Asn1Alloc(sizeof(Param));
      CopyParam(tmpParam, *H);
    }
};


#define SEND_TPI(PDU)				\
   tpi_outfunc((PDU));				\
  if((PDU))  FreeTPI_PDUs((PDU));

# define SEND_TPI_FINAL_VERDICT(VERDICT, ERROR)					\
{										\
	TPI_PDUs *ppdu;								\
	ppdu= (TPI_PDUs *) Asn1Alloc(sizeof(TPI_PDUs));					\
	ppdu->choiceId = TPI_PDUs::TPI_PDUS_TPI_FINAL_VERDICT;				\
	ppdu->a.tpi_final_verdict = (TPI_FINAL_VERDICT_Body*) Asn1Alloc(sizeof(TPI_FINAL_VERDICT_Body));	\
	ppdu->a.tpi_final_verdict->verdict_value = (VerdictValue) (VERDICT);	\
	ppdu->a.tpi_final_verdict->error_code = (FeErrorCode) (ERROR);		\
	SEND_TPI(ppdu);								\
};

# define SEND_TPI_CREATED(ERROR)					\
{									\
	TPI_PDUs *ppdu;							\
	ppdu= (TPI_PDUs *) Asn1Alloc(sizeof(TPI_PDUs));				\
	ppdu->choiceId = TPI_PDUs::TPI_PDUS_TPI_CREATED;				\
	ppdu->a.tpi_created = (TPI_CREATED_Body*) Asn1Alloc(sizeof(TPI_CREATED_Body));	\
	ppdu->a.tpi_created->error_code = (FeErrorCode) (ERROR);	\
	SEND_TPI(ppdu);							\
};

# define SEND_TPI_CANCELED(ERROR)					\
{									\
	TPI_PDUs *ppdu;							\
	ppdu= (TPI_PDUs *) Asn1Alloc(sizeof(TPI_PDUs));				\
	ppdu->choiceId = TPI_PDUs::TPI_PDUS_TPI_CANCELED;				\
	ppdu->a.tpi_canceled = (TPI_CANCELED_Body*) Asn1Alloc(sizeof(TPI_CANCELED_Body));	\
	ppdu->a.tpi_canceled->error_code = (FeErrorCode) (ERROR);	\
	SEND_TPI(ppdu);							\
};

# define SEND_TPI_CREATE(TCOID, TEST_CASE_ID, TREE_ID, PARAM)		\
{									\
	TPI_PDUs *ppdu;							\
	Param         **H;						\
									\
	ppdu= (TPI_PDUs *) Asn1Alloc(sizeof(TPI_PDUs));				\
	ppdu->choiceId = TPI_PDUs::TPI_PDUS_TPI_CREATE;				\
	ppdu->a.tpi_create = Asn1Alloc(sizeof(TPI_CREATE_Body));	\
	SetOctet(&ppdu->a.tpi_create->tco_id, (TCOID));			\
	SetOctet(&ppdu->a.tpi_create->test_case_id, (TEST_CASE_ID));	\
	SetOctet(&ppdu->a.tpi_create->tree, (TREE_ID));		\
        ppdu->a.tpi_create->param_list = AsnListNew(sizeof(void *));	\
/* Right now, all parameters are stored as list in the first parameter */  \
	H = (Param **) AsnListAppend(ppdu->a.tpi_create->param_list);		\
	*H = (Param *) Asn1Alloc(sizeof(Param));					\
	SetOctet(&(*H)->param_id,"");					\
	SetOctet(&(*H)->param_value, (PARAM));				\
	SEND_TPI(ppdu);							\
};

# define SEND_TPI_INFO(TCOID, CP_ID, COORD_MSG)				\
{									\
	TPI_PDUs *ppdu;							\
									\
	ppdu= (TPI_PDUs *) Asn1Alloc(sizeof(TPI_PDUs));				\
	ppdu->choiceId = TPI_PDUs::TPI_PDUS_TPI_INFO_REQ;				\
	ppdu->a.tpi_info_req = Asn1Alloc(sizeof(TPI_INFO_REQ_Body));	\
	SetOctet(&ppdu->a.tpi_info_req->tco_id, (TCOID));		\
	SetOctet(&ppdu->a.tpi_info_req->cp_id, (CP_ID));		\
	SetOctet(&ppdu->a.tpi_info_req->msg, (COORD_MSG));		\
	SEND_TPI(ppdu);							\
};


/*--------------------------------------------------------------------- 
 *
 * Name: openFIFO
 *
 * Description:
 *  Open the named pipes (aka FIFO) created by the parent
 *  e.g. FIFO_NAME = /tmp/tsp1MTC.3456_out
 *  Note: in and out refer to the parent, hence reading from "*_out" and
 *  writing to "*_in"
 * 
 * Return Value: int
 *	 0 	if ok
 *	-1	else
 */
int openFIFO()
{
  int length;
  char str_pid[20];
  sprintf(str_pid,".%d",(int) getpid());
  
  length = strlen(LOCATION)+strlen(fifo.myTcoId)+strlen("_out")+strlen(str_pid);
  
  if(length > MAX_STR_LEN) {
    BUG(("The FIFO-name is too long. total_length %d vs. MAX_STR_LEN %d. \n"
	 "Aborting...", length, MAX_STR_LEN));
  }
  
  strcpy(fifo.fifo_out,"");
  strcat(fifo.fifo_out, LOCATION);
  strcat(fifo.fifo_out, fifo.myTcoId);
  strcat(fifo.fifo_out, str_pid);
  strcpy(fifo.fifo_in, fifo.fifo_out);
  strcat(fifo.fifo_in, "_out");
  strcat(fifo.fifo_out, "_in");
  
  

  if((fifo.readfd = open(fifo.fifo_in,0)) < 0 ) {
    PERROR(("can't open FIFO for reading"));
    perror("eTC terminating");
    exit(-1);
  }
  if((fifo.writefd = open(fifo.fifo_out,1)) < 0) {
    PERROR(("can't open FIFO for writing"));
    perror("eTC terminating");
    exit(-1);
  }
  
  return(0);
};


/*--------------------------------------------------------------------- 
 *
 * Name: fifo_outfunc
 *
 * Description:
 *	Function is called either from the tpi_outfunc or the gci_outfunc.
 *	It builds the message, tags the type and send it across the 
 * 	Fifo
 *
 * Return Value:  = 0 - on success
 *	         != 0 - else
 */
int fifo_outfunc(int type, char *buf, int len)
{
  Mesg 	*mesg;
  /* Build a message suitable for transmission across the FIFO*/
  mesg = (Mesg *) malloc(sizeof(Mesg));
  mesg->mesg_len = len;
  mesg->mesg_type = type;
  if( len > MAXMESGDATA ) {
    PERROR(("Data to transmit over FIFO too long. MAXMESGDATA = %d",MAXMESGDATA));
    return(-1);
  }
  memcpy(mesg->mesg_data, buf, mesg->mesg_len);
  /* Write the PDU on the line */
  if (mesg_send(fifo.writefd, mesg) < 0) {
    perror("write");
    return(-1);
  }
  free(mesg);
  return(0);
  
}



void fifo_infunc(int fd, int mask, void *vtpi_infunc)
{
  Mesg 		*rcvBuf;
  int		size;
  
  /* no input paramters are expected, therefore ignoring varg */
  
  rcvBuf = (Mesg *) malloc(MAXMESGDATA+MESGHDRSIZE);
  if ((size =   mesg_recv(fd, rcvBuf, DATAGRAM_SERVICE)) < 0) {	
    PERROR (("eTC: fifo_infunc - read error %s",fifo.myTcoId));
    return;
  }
  if (!size) {
    /* The FIFO was closed at the other end.
       It looks like the FrontEnd does not exist anymore 
       Therefore .. */     
    poll_unregister(fifo.readfd);
    /* Close the fd's */
    close(fifo.readfd);
    close(fifo.writefd);
    /* Terminate */
    exit(0);
  }
  VERBOSE((3,"eTC %s: Received something on the FIFO", fifo.myTcoId));
  /* 1st check whether GciPDU or TpiPdu */
  if(rcvBuf->mesg_type == TPI_PDU) {
    TPI_PDUs 	decoded_pdu;
    jmp_buf 	env;
    int 		decode_err;
    AsnLen 		decoded_len;
    SBuf 		buf;
    int 		val;
    
    SBufInstallData (&buf, (char *) rcvBuf->mesg_data, rcvBuf->mesg_len);
    decoded_len = 0;
    decode_err = FALSE;
    if ((val = setjmp (env)) == 0) {
      BDecTPI_PDUs (&buf, &decoded_pdu, &decoded_len, env);
    } else {
      decode_err = TRUE;
      VERBOSE((1,"eTC %s: ERROR - TPI-Decode routines returned %d\n", fifo.myTcoId, val));
    }
    /* processing of tpi_pdu is done here */
    tpi_infunc(&decoded_pdu); /* Calling the appropriate tpi_infunc */
  } else if (rcvBuf->mesg_type == GCI_PDU) {
    /* The only GCI-PDU defined for now is the GCI-SET-PARAMETER Pdu */
    GCI_PDUs 	decoded_pdu;
    jmp_buf 	env;
    int 		decode_err;
    AsnLen 		decoded_len;
    SBuf 		buf;
    int 		val;
    
    SBufInstallData (&buf, (char *) rcvBuf->mesg_data, rcvBuf->mesg_len);
    decoded_len = 0;
    decode_err = FALSE;
    if ((val = setjmp (env)) == 0) {
      BDecGCI_PDUs (&buf, &decoded_pdu, &decoded_len, env);
    } else {
      decode_err = TRUE;
      VERBOSE((1,"eTC %s: ERROR - Decode routines returned %d\n", fifo.myTcoId, val));
    }
    /* processing of tpi_pdu is done here, because only one PDU is defined */
    if (decoded_pdu.choiceId != GCI_PDUs::GCI_PDUS_GCI_SET_PARAMETER) {
      WARN(("eTC %s: GCI-PDU is not GCI-SET-PARAMETER and therefore not supported",fifo.myTcoId));	
    }
    AsnListClear(&myParam);
    CopyParamList(decoded_pdu.a.gci_set_parameter->param_list, &myParam);
    FreeGCI_PDUs(&decoded_pdu);
    parametersReadIn = TRUE;
  } else {
    VERBOSE((1,"eTC %s: Received something on FIFO %s which is neither TPI-PDU nor GCI-PDU",fifo.myTcoId, fifo.fifo_in));
  }
  return;
}



/*
 * tpi_out -
 * 
 * This function is called whenever a tpi_pdu 
 * should be transmitted.
 */

void tpi_outfunc(TPI_PDUs *pdu)
{
  char            data[MAXMESGDATA];
  SBuf            outputBuf;
  unsigned long int encodedLen;
  
  /* Convert the TPI_PDU to a buffer. */
  SBufInit(&outputBuf, data, sizeof(data));
  SBufResetInWriteRvsMode(&outputBuf);
  /* encode the PDU. The result is in outputBuf */
  encodedLen = BEncTPI_PDUs(&outputBuf, pdu);
  /* after encoding a value ALWAYS check for write error in the buffer. */
  if ((encodedLen <= 0) || (SBufWriteError(&outputBuf))) {
    panic(("failed to encode TPI_PDU"));
  }
  
  fifo_outfunc(TPI_PDU, SBufDataPtr(&outputBuf), SBufDataLen(&outputBuf));
  return;
};


/*--------------------------------------------------------------------- 
 *
 * Name: tpi_infunc
 *
 * Description:
 * 	Processing of an incoming TPI-PDU
 * 
 * Return Value: void */

void tpi_infunc(TPI_PDUs *m)
{
  int ver = 3; /* The verdict */
    
  switch(m->choiceId) 
    {
    case TPI_PDUs::TPI_PDUS_TPI_CREATE:	
      VERBOSE((3,"eTC %s: received TPI_CREATE", fifo.myTcoId));
      error_code = ERROK;
      cancel_exec_flag = FALSE;
      GciInit(); 	/* Hopefully the parameters are allready there */
      CreatePCOsAndTimers();
      SEND_TPI_CREATED(error_code);
      if(error_code != ERROK) 
	{
	  VERBOSE((1,"eTC %s: Error %d occured in GciInit(). Aborting TC Creation. Waiting for new creation", fifo.myTcoId, error_code)); 
	  return;
	}
      if(RunningTestCaseName) 
	free(RunningTestCaseName);
      RunningTestCaseName = strdup(m->a.tpi_create->test_case_id.octs);
      if (strcmp(m->a.tpi_create->tree.octs, "")==0) 
	{
	  /* If the treeId is emtpy, then I've to be the MTC */
	  VERBOSE((3,"eTC %s: Tree of TPI_CREATE is empty. I've to be the MTC", fifo.myTcoId));
	  ver = GciStartTestCase(RunningTestCaseName);
	  SEND_TPI_FINAL_VERDICT(ver, ERROK);
      
	  /* Clean-up */
	  if(RunningTestCaseName) 
	    { 
	      free(RunningTestCaseName);
	      RunningTestCaseName = (char *) NULL;
	    }
	  TestCaseRun = TRUE;

	} 
      else 
	{ 
	  /* I'm a PTC */
	  /* C-TTCN unused */
	}
      AdCleanUp();
      break;
    
    case TPI_PDUs::TPI_PDUS_TPI_INFO_IND:
      /* C-TTCN unused 
      GciReceive(getPCOId(m->a.tpi_info_ind->cp_id.octs),GeneralStringDecode(m->a.tpi_info_ind->msg.octs));
      */
      break;
    case TPI_PDUs::TPI_PDUS_TPI_LAST_VERDICT:
      /* C-TTCN unused */
      break;
    case TPI_PDUs::TPI_PDUS_TPI_UPDATE_VERDICT:
      /* Not implemented in GCI */
      WARN(("Update Verdicts are not implemented in GCI"));
    break;
    
    case TPI_PDUs::TPI_PDUS_TPI_CANCEL:
      cancel_exec_flag = TRUE;
      SEND_TPI_CANCELED(ERROK);
      break;
    case TPI_PDUs::TPI_PDUS_TPI_UPDATED_VERDICT:
    case TPI_PDUs::TPI_PDUS_TPI_FINAL_VERDICT:
    case TPI_PDUs::TPI_PDUS_TPI_CANCELED:
    case TPI_PDUs::TPI_PDUS_TPI_INFO_REQ:
    case TPI_PDUs::TPI_PDUS_TPI_CREATED:
    default:	
      WARN(("eTC %s: This TPI-Message should not be received",fifo.myTcoId));
    }
};

#endif




/*---------------------------------------------------------------------------
 *
 *	CONSTANT DEFINITIONS
 */

/*--------------------------------------------------------------------- 
 * Name: logStream
 *
 * Description: 
 *  Used for logging by GciLog and GciLogPrint. 
 *  Assigned a value in main().
 */

FILE * logStream;

extern "C"
{
  GciValue* GciReadTSPar(char* par, char* pRef);
  
};

/*---------------------------------------------------------------------------
 *
 * Name: AdBLOCKING_SNAPSHOT
 *
 * Description:
 *
 *  If defined as 0, the GciSnapshot function polls the input channel, 
 *  else it waits for external events: 
 */

#define AdBLOCKING_SNAPSHOT	1
/*---------------------------------------------------------------------------
 *
 * Name: AdLEXICAL_DEBUG
 *
 * Description:
 *
 *   If defined as 1, the LEXICAL ANALYZER prints debug information, else
 *   the scanning of input on the PCO is quiet.
 */

#define AdLEXICAL_DEBUG		0

/*---------------------------------------------------------------------------
 *
 * Name: AD_TIMER_RUNNING, AD_TIMER_STOPPED
 *
 * Description:
 *
 *  These are the two states initialized timers can be in.
 */

#define AD_TIMER_RUNNING		0
#define AD_TIMER_STOPPED		-1


/*------------------------------------------------------------
 *  Name: Timer Implementation
 *  Author: T. Vassiliou-Gioles
 *  Date: October, 1998
 *	
 * Adaptation layers list of all the timers , plus the systems starting 
 * time. The system can run for 24 Days, before wrapping the timers. 
 * The clock resolution is approximately +- 5 ms, depending on the systems
 * clock resolution and load.
 */

static struct AdTimeStruct *AdTimerList;
static struct timeval AdStartTime;

/* Primitives  */

void 
AdInitTimers ()
{
  gettimeofday (&AdStartTime, (void *) 0L);
  AdTimerList = (struct AdTimeStruct *) 0L;
}

long 
AdGetElapsedTime ()
{				/* return unit = ms */
  struct timeval tv;
  long s, us;
  gettimeofday (&tv, (void *) 0L);
  s = tv.tv_sec - AdStartTime.tv_sec;
  us = tv.tv_usec - AdStartTime.tv_usec;
  if (us < 0)
    {
      us += 1000000;
      s -= 1;
    }
  return s * 1000 + us / 1000;
}

AdTimeStruct *
AdCreateTimer (int id)
{
  struct AdTimeStruct *newTimer;
  newTimer = (struct AdTimeStruct *) malloc (sizeof (struct AdTimeStruct));
  newTimer->Id = id;
  newTimer->hd = AD_TIMER_STOPPED;
  newTimer->StartTime = newTimer->Duration = 0;
  newTimer->Unit = 0;
  newTimer->Next = (AdTimeStruct *) AdTimerList;
  AdTimerList = newTimer;
  return newTimer;
}

void 
AdRemoveAllTimers ()
{
     AdTimeStruct *timer;
     while (AdTimerList) {
	  timer = AdTimerList;
	  /* If a timer is running stop it first */
	  if(timer->hd >= 0) poll_stop_timer(timer->hd);
	  AdTimerList = timer->Next;
	  free (timer);
     }
}

struct AdTimeStruct *
AdGetTimer (int timerd)
{
  struct AdTimeStruct *timer;
  for (timer = AdTimerList; timer; timer = timer->Next)
    if (timer->Id == timerd)
      return timer;
  return (AdCreateTimer (timerd));	/* we had no such timer before 
					   - create a new one */
}

struct AdTimeStruct *
AdGetTimerFormHd (int timerd)
{
  struct AdTimeStruct *timer;
  for (timer = AdTimerList; timer; timer = timer->Next)
    if (timer->hd == timerd)
      return timer;
  return (NULL);	/* we had no such timer before 
			   - return NULL */
}


/* List of the PCOs */




/*---------------------------------------------------------------------------
 *	Other Adaptaptation layer functions
 */

void 
AdInit ()
{
 
  AdInitTimers ();
}

void 
AdExit ()
{
 
  AdRemoveAllTimers ();
}

#define TX 1
#define RX 0
void show_hex(unsigned char *hexstring, int len, int direction, char *pco_name)
{
	int i;

	if (direction == TX) {
		printf("\nTX PDU-HEX send at %s:\n",pco_name);
	} else {
		printf("\nRX PDU-HEX received at %s:\n",pco_name);
	}

	printf("(%d OCTETS): %s\t", len, !len?"-":"");
	for(i=0;i<len;i++) {
		printf("%2.2x ", hexstring[i]);
		if( (i+1) % 16 == 0) printf("\n\t\t");
	}
	printf("\n\n\n");
}

int getComponentId( char *comp)
{
	int  i;

	for(i = 0; i < GciGetNoOfComponents( CurrentGciConf); i++)
		if(!strcmp(GciGetComponentName(GciGetComponent(CurrentGciConf, i)), comp))
			return (GciGetComponent(CurrentGciConf, i)->Id);
	return(-1);
}

int getPCOId( char *PCOName)
{
  int i;
    
  for( i = GcFirstPCOD; i < GcFirstPCOD + IcNoOfPCOs + IcNoOfCPs; i++) 
    if( ! strcmp( GciGetPCOName( i), PCOName))
      return i;
  return -1;
}



void
sigchld()
{
	int             result;
	result = wait((int *) 0);
	VERBOSE((0,"One SAAL terminated"));
	return;
}



/*--------------------------------------------------------------------- 
 *
 * Name: pco_infunc
 *
 * Description:
 * 	Processing of an incoming PDU at a pco, while a testcase is
 *	runnning. In this case the tanya-packetfile format has to be read.
 * 
 * Return Value: void 
 */
void
pco_infunc(int fd, int mask UNUSED, void *varg UNUSED) {
     struct AdPCOStruct *pco;

     /* Determine the PCO with help of the fd */
     pco = AdGetPCOFromFds(fd);
     
     if(!pco) panic("PCO for file-descriptor %d not found. Aborting !!!",fd);
     VERBOSE((0,"Received something on PCO %s",GciGetPCOName(pco->Id)));
     
     GeneralDecode();
}

/*--------------------------------------------------------------------- */
 
/*---------------------------------------------------------------------------
 *	GCI INTERFACE CODE
 *
 *	The routines specified in the GCI interface model
 */


/*-------------------------------------------------------------------------
 * Name: GciSend
 *
 * Description:
 * 
 *	Encode and send the data in the same operation.
 */

GciStatus 
GciSend (int pcod, GciValue * object)
{
    
 /****	pco = AdGetPCO (pcod);***/
 MyPCO * Pco = PCOList;        /* PCOList */
  
 
  while(Pco != NULL && Pco->Id != pcod)    
    Pco = Pco->Next;
 
   if(Pco != NULL)
      {
	
	switch(GciGetType(object))
	  {
	      	  
	  case GcCORBA__GIOP__LocateRequestD:
	      
	      sendLocaterequest(object, Pco->OutStream);
	      break;
	  
	  case GcCORBA__GIOP__LocateRequest_1_1D:
	      
	      sendLocaterequest(object, Pco->OutStream);
	      break;
 
	  case GcCORBA__GIOP__LocateRequest_1_2D:
	      
	      sendLocaterequest_1_2(object, Pco->OutStream);
	      break;


	  case GcCORBA__GIOP__REQUESTD:
	    
	    sendRequest(object, Pco->OutStream);
	    
	    break; 

	  case GcCORBA__GIOP__REQUEST_1_1D:

	    sendRequest_1_1(object, Pco->OutStream);
	    break; 

	  case GcCORBA__GIOP__REQUEST_1_2D:

	    // printf(" IN THE GCISEND REQUEST_1_2\n");
	    sendRequest_1_2(object, Pco->OutStream);
	    //printf(" AFTER THE GCISEND REQUEST_1_2\n");	    
	    break; 


	  case GcCORBA__GIOP__CancelRequestD:
	   
	    sendCancelRequest(object, Pco->OutStream);
	    break;

	  default:
	    fprintf(stderr, "messgeEncode: Unknown type!!!\n");
	    break; 
	    
	  }
	}	
   else
     
     return GciNotOk;
     
   
  
   return GciOk;




}

/*-------------------------------------------------------------------------
 * Name:	GciImplicitSend
 * Author:	
 *
 * Description: 
 *		Not implemented
 *
 * Return Value: GciStatus (GciOk or GciNotOk)
 */

GciStatus 
GciImplicitSend (GciValue * msg UNUSED)
{
#ifdef CCGPRINT
  CCGPRINT ("Function GciImplicitSend in file: ",
	    __FILE__, " is not written!\n");
#endif

  return GciNotOk;
}


/* ------------------------------------------------------------
 * Name: GeneralDecode
 * Author: T. Vassiliou-Gioles,
 * Date: October, 1998
 *	
 *	This function decodes a message that is read in from 
 *	file descriptor fd.
 *	Return Value:
 *	= 0   	success;
 *	!= 0 	not successfull;
 */


void 
GeneralDecode()

 {

int rbufLen; 
  unsigned char  temp_buffer[100];
  int ipos;
  MyPCO * Pco;
  MyPCO * thePCO_CP;
  int msgLength = 0;
  fd_set readfds;
  int readLength;
  int chunkLength;
  int nextLength;
  msgType aMsg;
 
 
  
   for(Pco = PCOList; Pco != NULL; Pco = Pco->Next)
     {
      msgLength = sizeof(struct msgType);
      
      if(Pco->Id == GcLTPCO1D)
	{
	  chunkLength = msgLength;
	  nextLength = msgLength;
	  readLength = 0; 
	  ipos = 0;

	  do
	    {
	       AdUpdateTimers();
	     rbufLen =  recv(Pco->InStream,  (char *) temp_buffer, 100, MSG_PEEK);
	     
	      if(chunkLength > 0)
		{
		  memcpy(&aMsg.u.buffer[ipos], temp_buffer,chunkLength);
		  ipos += chunkLength;
		  nextLength -= chunkLength;
		  readLength += chunkLength;
		}
	    }while (readLength < chunkLength); 

 IIOPMessageHeader msgHdr( temp_buffer, 12);
	 if(msgHdr.unmarshall() == -1)
    {
      perror("TRANSPORT ERROR IN THE GCISNAPSHOT FCT.\n");
    }

	  if( !MessageDecode(Pco->Id,  temp_buffer))
	    fprintf(stderr, "GciSnapshot: could not decode !!!\n");
	}
	
    }
  
  return GciOk;


    
}

/*-------------------------------------------------------------------------
 *
 *MessageDecoing
 *
 *
 *------------------------------------------------------------------------*/
GciStatus MessageDecode(int PCOD,   unsigned char * aMsg)
{     

  IIOPMessageHeader msgHdr( aMsg, 12);


  if(msgHdr.unmarshall() == -1)
    {
      perror("TRANSPORT ERROR\n");
    }
  
  switch(msgHdr.m_MsgType)
    {
    case 1:
      switch(msgHdr.m_Ver.m_Minor)
	{
	case 0:
	  
	  if(CreateReceiveObject(PCOD, GcCORBA__GIOP__REPLYD , aMsg))
	    {
	      
	      // fprintf(stderr,"R: [Receive] %s \n", aMsg);
	      return GciOk;
	    }
	  else
	    return GciNotOk;
	  break;
	  
	  
	case 1:
	  if(CreateReceiveObject(PCOD, GcCORBA__GIOP__REPLY_1_1D , aMsg))
	    {
	      
	      // fprintf(stderr,"R: [Receive] %s \n", aMsg);
	      return GciOk;
	    }
	  else
	    return GciNotOk;
	  break;
	  
	case 2:
	  if(CreateReceiveObject(PCOD, GcCORBA__GIOP__REPLY_1_2D , aMsg))
	    {
	      
	      // fprintf(stderr,"R: [Receive] %s \n", aMsg);
	      return GciOk;
	    }
	  else
	    return GciNotOk;
	  break;
	  
	}
      break;
    

    case 4:
      switch(msgHdr.m_Ver.m_Minor)
	{
	case 0:


	  if(CreateReceiveObject(PCOD, GcCORBA__GIOP__LocateReplyD, aMsg))
	    {
	      
	      // fprintf(stderr,"R: [Receive] %s \n",aMsg);
	      return GciOk;
	    }
	  else
	    return GciNotOk;
	  break;
	case 1:

	  if(CreateReceiveObject(PCOD, GcCORBA__GIOP__LocateReply_1_1D, aMsg))
	    {
	      
	      // fprintf(stderr,"R: [Receive] %s \n",aMsg);
	      return GciOk;
	    }
      else
	return GciNotOk;
      break;

	case 2:
	  if(CreateReceiveObject(PCOD, GcCORBA__GIOP__LocateReply_1_2D, aMsg))
	    {
	      
	      // fprintf(stderr,"R: [Receive] %s \n",aMsg);
	      return GciOk;
	    }
      else
	return GciNotOk;
      break;
	}
break;


    case 6:
      switch(msgHdr.m_Ver.m_Minor)
	{
	case 0:
	  
	  if(CreateReceiveObject(PCOD, GcCORBA__GIOP__MessageErrorD , aMsg))
	    {
	      // fprintf(stderr,"R: [Receive] %s \n", aMsg);
	      return GciOk;
	    }
	  else
	    return GciNotOk;
	  break;
	  
	case 1:
	  
	  if(CreateReceiveObject(PCOD, GcCORBA__GIOP__MessageError_1_1D , aMsg))
	    {
	      //  fprintf(stderr,"R: [Receive] %s \n", aMsg);
	      return GciOk;
	    }
	  else
	    return GciNotOk;
	  break;	
	case 2:
	  
	  if(CreateReceiveObject(PCOD, GcCORBA__GIOP__MessageError_1_2D , aMsg))
	    {
	      // fprintf(stderr,"R: [Receive] %s \n", aMsg);
	      return GciOk;
	    }
	  else
	    return GciNotOk;
	  break;
	}
      break;
      
      
    case 7:
      
      
      if(CreateReceiveObject(PCOD, GcCORBA__GIOP__FRAGMENT_1_1D , aMsg))
	{
	  
	  
	  // fprintf(stderr,"R: [Receive] %s \n", aMsg);
	  return GciOk;
	}
      else
	return GciNotOk;
      break;
      
      
    default: 
      fprintf(stderr, "MessageDecode: Unknown type !!!\n");
      break;
    }
}




/*-------------------------------------------------------------------
 *
 *CreateReceiveObject()
 *
 ---------------------------------------------------------------------*/

GciStatus CreateReceiveObject(int PCOD, int Type, unsigned char * Msg)
{
  GciValue * tmp ;
  GciValue * tmp1;
  GciValue * tmp11;
  GciValue * tmp12;
  GciValue * tmp2;
  GciValue * tmp3;
  GciValue * tmp4;
  char   charValue[6];
  char   c1[4];
  
   
  
  IIOPMessageHeader msgHdr((unsigned char *) Msg,  12);
  IIOPLocateReplyMessage locReply( Msg, 100);
  IIOPReplyMessage replyMsg( Msg, 100 );
  IIOPReplyMessage_1_1 replyMsg_1( Msg, 100 );
  IIOPReplyMessage_1_2 replyMsg_2( Msg, 100 );
  switch(Type)
    {
    case GcCORBA__GIOP__REPLYD:

      
       tmp = GciMkSEQUENCE(2);
       GciSetType(Type, tmp);
       tmp1 = GciMkSEQUENCE(5);
       replyMsg.unmarshall();
       c1[0] = replyMsg.m_Cookie[0];
       c1[1] = replyMsg.m_Cookie[1];
       c1[2] = replyMsg.m_Cookie[2];
       c1[3] = replyMsg.m_Cookie[3];

       strncpy(charValue, &c1[0], 4);
       charValue[4] = '\0';
       GciSetField(tmp1, 1, GciMkVisibleString(charValue));
       tmp12 = GciMkSEQUENCE(2);
       GciSetType(GcCORBA__GIOPHEADER__VersionD,tmp12);
       sprintf(charValue, "%02o", replyMsg.m_Ver.m_Major);
       GciSetField(tmp12, 1, GciMkOCTET_STRING(charValue));
       sprintf(charValue, "%02o", replyMsg.m_Ver.m_Minor);     
       GciSetField(tmp12, 2, GciMkOCTET_STRING(charValue)); 
       GciSetField(tmp1, 2, tmp12); 
       GciSetField(tmp1, 3, GciMkBOOLEAN(replyMsg.m_ByteSex));
       sprintf(charValue, "%02o", replyMsg.m_MsgType); 
       GciSetField(tmp1, 4, GciMkOCTET_STRING(charValue));
       GciSetField(tmp1, 5 ,GciMkINTEGER(replyMsg.m_Size));
       GciSetField(tmp,1,tmp1);
       tmp2 = GciMkSEQUENCE(3);
       GciSetType(GcCORBA__GIOP__RepHead__ReplyHeaderD, tmp2); 
       GciSetField(tmp2, 2, GciMkINTEGER(replyMsg.m_RequestId));
       GciSetField(tmp2, 3, GciMkENUMERATED(replyMsg.m_ReplyStatus));
       GciSetField(tmp, 2, tmp2);
       GciReceive(PCOD, tmp);
       return GciOk;
       break;
       
    case GcCORBA__GIOP__REPLY_1_1D:

      tmp = GciMkSEQUENCE(2);
      GciSetType(Type, tmp);
      tmp1 = GciMkSEQUENCE(5);
      replyMsg_1.unmarshall();
      c1[0] = replyMsg_1.m_Cookie[0];
      c1[1] = replyMsg_1.m_Cookie[1];
      c1[2] = replyMsg_1.m_Cookie[2];
      c1[3] = replyMsg_1.m_Cookie[3];

      strncpy(charValue, &c1[0], 4);
      charValue[4] = '\0';
      GciSetField(tmp1, 1, GciMkVisibleString(charValue));
      tmp12 = GciMkSEQUENCE(2);
      GciSetType(GcCORBA__GIOPHEADER__VersionD,tmp12);
      sprintf(charValue, "%02o", replyMsg_1.m_Ver.m_Major);
      GciSetField(tmp12, 1, GciMkOCTET_STRING(charValue));
      sprintf(charValue, "%02o", replyMsg_1.m_Ver.m_Minor);     
      GciSetField(tmp12, 2, GciMkOCTET_STRING(charValue)); 
      GciSetField(tmp1, 2, tmp12); 
      sprintf(charValue, "%02o", replyMsg_1.m_Flags); 
      GciSetField(tmp1, 3, GciMkOCTET_STRING(charValue));
      sprintf(charValue, "%02o", replyMsg_1.m_MsgType); 
      GciSetField(tmp1, 4, GciMkOCTET_STRING(charValue));
      GciSetField(tmp1, 5 ,GciMkINTEGER(replyMsg_1.m_Size));
      GciSetField(tmp,1,tmp1);
      tmp2 = GciMkSEQUENCE(3);
      GciSetType(GcCORBA__GIOP__RepHead__ReplyHeaderD, tmp2); 
      GciSetField(tmp2, 2, GciMkINTEGER(replyMsg_1.m_RequestId));
      GciSetField(tmp2, 3, GciMkENUMERATED(replyMsg_1.m_ReplyStatus));
      GciSetField(tmp, 2, tmp2);
      GciReceive(PCOD, tmp);
      return GciOk;
      break;
      
    case GcCORBA__GIOP__REPLY_1_2D:
      
      tmp = GciMkSEQUENCE(2);
      GciSetType(Type, tmp);
      tmp1 = GciMkSEQUENCE(5);
      replyMsg_2.unmarshall();
      c1[0] = replyMsg_2.m_Cookie[0];
      c1[1] = replyMsg_2.m_Cookie[1];
      c1[2] = replyMsg_2.m_Cookie[2];
      c1[3] = replyMsg_2.m_Cookie[3];
      strncpy(charValue, &c1[0], 4);
      charValue[4] = '\0';
      GciSetField(tmp1, 1, GciMkVisibleString(charValue));
      
      tmp12 = GciMkSEQUENCE(2);
      GciSetType(GcCORBA__GIOPHEADER__VersionD,tmp12);
      sprintf(charValue, "%02o", replyMsg_2.m_Ver.m_Major);
      GciSetField(tmp12, 1, GciMkOCTET_STRING(charValue));
      sprintf(charValue, "%02o", replyMsg_2.m_Ver.m_Minor);     
      GciSetField(tmp12, 2, GciMkOCTET_STRING(charValue)); 
      GciSetField(tmp1, 2, tmp12); 
      sprintf(charValue, "%02o", replyMsg_2.m_Flags); 
      GciSetField(tmp1, 3, GciMkOCTET_STRING(charValue));
      sprintf(charValue, "%02o", replyMsg_2.m_MsgType); 
      GciSetField(tmp1, 4, GciMkOCTET_STRING(charValue));
      GciSetField(tmp1, 5 ,GciMkINTEGER(replyMsg_2.m_Size));
      GciSetField(tmp,1,tmp1);
      tmp2 = GciMkSEQUENCE(3);
      GciSetType(GcCORBA__GIOP__RepHead__ReplyHeader_1_2D, tmp2); 
      GciSetField(tmp2, 1, GciMkINTEGER(replyMsg_2.m_RequestId));
      GciSetField(tmp2, 2, GciMkENUMERATED(replyMsg_2.m_ReplyStatus));
      GciSetField(tmp, 2, tmp2);
      GciReceive(PCOD, tmp);
      return GciOk;
      break;
      
      
      
    case GcCORBA__GIOP__LocateReplyD:
      
      tmp = GciMkSEQUENCE(2);
      GciSetType(Type, tmp);
      tmp1 = GciMkSEQUENCE(5);
      locReply.unmarshall();
      c1[0] = locReply.m_Cookie[0];
      c1[1] = locReply.m_Cookie[1];
      c1[2] = locReply.m_Cookie[2];
      c1[3] = locReply.m_Cookie[3];

      strncpy(charValue, &c1[0], 4);
      charValue[4] = '\0';
      GciSetField(tmp1, 1, GciMkVisibleString(charValue));
      tmp12 = GciMkSEQUENCE(2);
      GciSetType(GcCORBA__GIOPHEADER__VersionD,tmp12);
      sprintf(charValue, "%02o", locReply.m_Ver.m_Major);
      GciSetField(tmp12, 1, GciMkOCTET_STRING(charValue));
      sprintf(charValue, "%02o", locReply.m_Ver.m_Minor);     
      GciSetField(tmp12, 2, GciMkOCTET_STRING(charValue)); 
      GciSetField(tmp1, 2, tmp12); 
      GciSetField(tmp1, 3, GciMkBOOLEAN(locReply.m_ByteSex));
      sprintf(charValue, "%02o", locReply.m_MsgType); 
      GciSetField(tmp1, 4, GciMkOCTET_STRING(charValue));
      GciSetField(tmp1, 5 ,GciMkINTEGER(locReply.m_Size));
      GciSetField(tmp,1,tmp1);
      tmp2 = GciMkSEQUENCE(2);
      GciSetType(GcCORBA__GIOP__LocateReply__LocateReplyHeaderD,tmp2); 
      GciSetField(tmp2, 1, GciMkINTEGER(locReply.m_RequestId));
      GciSetField(tmp2, 2,  GciMkENUMERATED(locReply.m_LocateStatus));
      GciSetField(tmp, 2, tmp2);
      GciReceive(PCOD, tmp);
      return GciOk;
      break;


case GcCORBA__GIOP__LocateReply_1_1D:
      
      tmp = GciMkSEQUENCE(2);
      GciSetType(Type, tmp);
      tmp1 = GciMkSEQUENCE(5);
      locReply.unmarshall();
      c1[0] = locReply.m_Cookie[0];
      c1[1] = locReply.m_Cookie[1];
      c1[2] = locReply.m_Cookie[2];
      c1[3] = locReply.m_Cookie[3];

      strncpy(charValue, &c1[0], 4);
      charValue[4] = '\0';
      GciSetField(tmp1, 1, GciMkVisibleString(charValue));
      tmp12 = GciMkSEQUENCE(2);
      GciSetType(GcCORBA__GIOPHEADER__VersionD,tmp12);
      sprintf(charValue, "%02o", locReply.m_Ver.m_Major);
      GciSetField(tmp12, 1, GciMkOCTET_STRING(charValue));
      sprintf(charValue, "%02o", locReply.m_Ver.m_Minor);     
      GciSetField(tmp12, 2, GciMkOCTET_STRING(charValue)); 
      GciSetField(tmp1, 2, tmp12); 
      sprintf(charValue, "%02o", locReply.m_Flags); 
      GciSetField(tmp1, 3, GciMkOCTET_STRING(charValue));
      sprintf(charValue, "%02o", locReply.m_MsgType); 
      GciSetField(tmp1, 4, GciMkOCTET_STRING(charValue));
      GciSetField(tmp1, 5 ,GciMkINTEGER(locReply.m_Size));
      GciSetField(tmp,1,tmp1);
      tmp2 = GciMkSEQUENCE(2);
      GciSetType(GcCORBA__GIOP__LocateReply__LocateReplyHeaderD,tmp2); 
      GciSetField(tmp2, 1, GciMkINTEGER(locReply.m_RequestId));
      GciSetField(tmp2, 2,  GciMkENUMERATED(locReply.m_LocateStatus));
      GciSetField(tmp, 2, tmp2);
      GciReceive(PCOD, tmp);
      return GciOk;
      break;

case GcCORBA__GIOP__LocateReply_1_2D:
 
      tmp = GciMkSEQUENCE(2);
      GciSetType(Type, tmp);
      tmp1 = GciMkSEQUENCE(5);
      locReply.unmarshall();
     
      c1[0] = locReply.m_Cookie[0];
      c1[1] = locReply.m_Cookie[1];
      c1[2] = locReply.m_Cookie[2];
      c1[3] = locReply.m_Cookie[3];
      strncpy(charValue, &c1[0], 4);
      charValue[4] = '\0';
      GciSetField(tmp1, 1, GciMkVisibleString(charValue));
      tmp12 = GciMkSEQUENCE(2);
      GciSetType(GcCORBA__GIOPHEADER__VersionD,tmp12);
      sprintf(charValue, "%02o", locReply.m_Ver.m_Major);
      GciSetField(tmp12, 1, GciMkOCTET_STRING(charValue));
      sprintf(charValue, "%02o", locReply.m_Ver.m_Minor);     
      GciSetField(tmp12, 2, GciMkOCTET_STRING(charValue)); 
      GciSetField(tmp1, 2, tmp12); 
      sprintf(charValue, "%02o", locReply.m_Flags); 
      GciSetField(tmp1, 3, GciMkOCTET_STRING(charValue));
      sprintf(charValue, "%02o", locReply.m_MsgType); 
      GciSetField(tmp1, 4, GciMkOCTET_STRING(charValue));
      GciSetField(tmp1, 5 ,GciMkINTEGER(locReply.m_Size));
      GciSetField(tmp,1,tmp1);
      tmp2 = GciMkSEQUENCE(2);
      GciSetType(GcCORBA__GIOP__LocateReply__LocateReplyHeaderD,tmp2); 
      GciSetField(tmp2, 1, GciMkINTEGER(locReply.m_RequestId));
      GciSetField(tmp2, 2,  GciMkENUMERATED(locReply.m_LocateStatus));
      GciSetField(tmp, 2, tmp2);
      GciReceive(PCOD, tmp);
      return GciOk;
      break;

   
    case GcCORBA__GIOP__MessageErrorD:
      
      tmp = GciMkSEQUENCE(1);
      GciSetType(Type, tmp);
      tmp1 = GciMkSEQUENCE(5);
      msgHdr.unmarshall();
      c1[0] = msgHdr.m_Cookie[0];
      c1[1] = msgHdr.m_Cookie[1];
      c1[2] = msgHdr.m_Cookie[2];
      c1[3] = msgHdr.m_Cookie[3];
      strncpy(charValue, &c1[0], 4);
      charValue[4] = '\0';
      GciSetField(tmp1, 1, GciMkVisibleString(charValue));

      
      tmp12 = GciMkSEQUENCE(2);
      GciSetType(GcCORBA__GIOPHEADER__VersionD, tmp12);
      sprintf(charValue, "%02o", msgHdr.m_Ver.m_Major);
      GciSetField(tmp12, 1, GciMkOCTET_STRING(charValue));
      sprintf(charValue, "%02o", msgHdr.m_Ver.m_Minor);
      GciSetField(tmp12, 2, GciMkOCTET_STRING(charValue));
      GciSetField(tmp1, 2, tmp12); 
      GciSetField(tmp1, 3, GciMkBOOLEAN(msgHdr.m_ByteSex));
      sprintf(charValue, "%02o", msgHdr.m_MsgType);
      GciSetField(tmp1, 4, GciMkOCTET_STRING(charValue));
      GciSetField(tmp1, 5 ,GciMkINTEGER(msgHdr.m_Size));
      GciSetField(tmp, 1, tmp1);
      GciReceive(PCOD, tmp);
      return GciOk;
      break;  
 
 case GcCORBA__GIOP__MessageError_1_1D:
      
      tmp = GciMkSEQUENCE(1);
      GciSetType(Type, tmp);
      tmp1 = GciMkSEQUENCE(5);
      msgHdr.unmarshall();
      c1[0] = msgHdr.m_Cookie[0];
      c1[1] = msgHdr.m_Cookie[1];
      c1[2] = msgHdr.m_Cookie[2];
      c1[3] = msgHdr.m_Cookie[3];
      strncpy(charValue, &c1[0], 4);
      charValue[4] = '\0';
      GciSetField(tmp1, 1, GciMkVisibleString(charValue));
      tmp12 = GciMkSEQUENCE(2);
      GciSetType(GcCORBA__GIOPHEADER__VersionD, tmp12);
      sprintf(charValue, "%02o", msgHdr.m_Ver.m_Major);
      GciSetField(tmp12, 1, GciMkOCTET_STRING(charValue));
      sprintf(charValue, "%02o", msgHdr.m_Ver.m_Minor);
      GciSetField(tmp12, 2, GciMkOCTET_STRING(charValue));
      GciSetField(tmp1, 2, tmp12); 
      sprintf(charValue, "%02o", msgHdr.m_Flags);
      GciSetField(tmp1, 4, GciMkOCTET_STRING(charValue));
      sprintf(charValue, "%02o", msgHdr.m_MsgType);
      GciSetField(tmp1, 4, GciMkOCTET_STRING(charValue));
      GciSetField(tmp1, 5 ,GciMkINTEGER(msgHdr.m_Size));
      GciSetField(tmp, 1, tmp1);
      GciReceive(PCOD, tmp);
      delete Msg; 
      return GciOk;
      break;    


    case GcCORBA__GIOP__MessageError_1_2D:
      
      tmp = GciMkSEQUENCE(1);
      GciSetType(Type, tmp);
      tmp1 = GciMkSEQUENCE(5);
      msgHdr.unmarshall();
      c1[0] = msgHdr.m_Cookie[0];
      c1[1] = msgHdr.m_Cookie[1];
      c1[2] = msgHdr.m_Cookie[2];
      c1[3] = msgHdr.m_Cookie[3];
      
      strncpy(charValue, &c1[0], 4);
      charValue[4] = '\0';
      GciSetField(tmp1, 1, GciMkVisibleString(charValue));
      
      tmp12 = GciMkSEQUENCE(2);
      GciSetType(GcCORBA__GIOPHEADER__VersionD, tmp12);
      sprintf(charValue, "%02o", msgHdr.m_Ver.m_Major);
      GciSetField(tmp12, 1, GciMkOCTET_STRING(charValue));
      sprintf(charValue, "%02o", msgHdr.m_Ver.m_Minor);
      GciSetField(tmp12, 2, GciMkOCTET_STRING(charValue));
      GciSetField(tmp1, 2, tmp12); 
      sprintf(charValue, "%02o", msgHdr.m_Flags);
      GciSetField(tmp1, 4, GciMkOCTET_STRING(charValue));
      sprintf(charValue, "%02o", msgHdr.m_MsgType);
      GciSetField(tmp1, 4, GciMkOCTET_STRING(charValue));
      GciSetField(tmp1, 5 ,GciMkINTEGER(msgHdr.m_Size));
      GciSetField(tmp, 1, tmp1);
      GciReceive(PCOD, tmp);
      delete Msg; 
      return GciOk;
      break;    






    }
}



/*-------------------------------------------------------------------------
 * Name: GciSnapshot
 * Author: Lars Mats
 *
 * Description:
 *
 *	Collects all the file descriptors and checks the earliest timeout,
 *	using them, then call the select function in order to wait for an
 *	external event. If AdBLOCKING_SNAPSHOT is defined as zero, the
 *	snapshot function effectuates a poll, otherwise it will wait.
 *
 *	After having performed the select call, all PCOs and timers are
 *	checked if anyhing has happened which requires a change of the system
 *	state (i.e. a receive event or a timeout).
 *
 * Return Value: 
 *
 *	GciStatus (GciOK or GciNotOk) 
 */

GciStatus 
GciSnapshot ()
{
     cancel_exec_flag = FALSE;
     poll_dispatch(1);
     if(cancel_exec_flag) {
	  return(GciNotOk);
     }
     return (GciOk);
}


/*-------------------------------------------------------------------------
 * Name: GciStartTimer
 * Author: T. Vassiliou-Gioles
 * Date: October, 1998
 *
 * Description:
 * 	This function is called from the rpoll library whenever a timeout
 *	occurs. 
 *
 * Return Value: 
 * 	Void
 */
static void
timer_timeout(int t_id, void *varg)
{
     struct AdTimeStruct *timer;
     
     if((timer = AdGetTimerFormHd(t_id)))
     {
	 VERBOSE((4, "eTC %s: Timeout occurred for hd %d, timer name %s", fifo.myTcoId, t_id, timer ? GciGetTimerName(timer->Id) : "(unknown)" ));     
	 timer->hd = AD_TIMER_STOPPED;
	 GciTimeout (timer->Id);
     }
};


/*-------------------------------------------------------------------------
 * Name: GciStartTimer
 * Author: Lars Mats, T. Vassiliou-Gioles
 *
 * Description:
 * 	Starts a timer with help of the rpoll library.
 *
 * Return Value: 
 * 
 *	       GciStatus ( GciOk  or  GciNotOk )
 */

GciStatus 
GciStartTimer (int timerd, long timerVal, int unit)
{
     struct AdTimeStruct *timer;

     timer = AdGetTimer (timerd);
     timer->StartTime = AdGetElapsedTime ();
     timer->Unit = unit;

     switch (timer->Unit) {
       case Gcimin:
	     timer->Duration = timerVal * 60000;
	     break;
       case Gcis:
	     timer->Duration = timerVal * 1000;
	     break;
       case Gcims:
	     timer->Duration = timerVal;
	     break;
       case Gcius:
	     timer->Duration = timerVal / 1000;
	     break;
       case Gcins:
	     timer->Duration = timerVal / 1000000;
	     break;
       case Gcips:
	     timer->Duration = timerVal / 1000000000;
	     break;
       default:
	     fprintf (stderr, "GciStartTimer: Error: Illegal timer unit specified.\n");
	     return GciNotOk;
     }
     VERBOSE((4, "eTC %s: Starting timer %s (ID: %d) (%d msec)",fifo.myTcoId, GciGetTimerName(timerd), timerd, timer->Duration));
     timer->hd = poll_start_timer(timer->Duration, 0, timer_timeout, NULL);
     return GciOk;
}


/*-------------------------------------------------------------------------
 * Name: GciCancelTimer
 * Author: Lars Mats 
 *
 * Description:
 * 
 *
 * Return Value: GciStatus (GciOk or GciNotOk)
 * 
 *
 */

GciStatus 
GciCancelTimer (int timerd)
{
     struct AdTimeStruct *timer;

     if (timerd == -1) {
	  /* Cancel all timers */
	 VERBOSE((4, "eTC %s: Canceling all timers",fifo.myTcoId));
	  AdRemoveAllTimers ();
	  return GciOk;
     }

     timer = AdGetTimer (timerd);
  
     if (timer->hd >= 0) {
	 VERBOSE((4, "eTC %s: Stopping timer %s. ",fifo.myTcoId, GciGetTimerName(timer->Id)));
	 poll_stop_timer(timer->hd);
	 timer->hd = AD_TIMER_STOPPED;
     } else {
	  WARN(("Timer %s  is not running but shall  be stopped", GciGetTimerName(timer->Id)));
     }
     return GciOk;
}


/*-------------------------------------------------------------------------
 * Name: GciReadTimer
 * Author: Lars Mats 
 *
 * Description:
 * 
 *
 * Return Value: Duration (Positive long integer)
 * 
 *
 */

long 
GciReadTimer (int timerd)
{
  struct AdTimeStruct *timer;
  long timeelapsed;
  timeelapsed = AdGetElapsedTime () - timer->StartTime;
  timer = AdGetTimer (timerd);
  switch (timer->Unit)
    {
    case Gcimin:
      return timeelapsed / 60000;
    case Gcis:
      return timeelapsed / 1000;
    case Gcims:
      return timeelapsed;
    case Gcius:
      return timeelapsed * 1000;
    case Gcins:
      return timeelapsed * 1000000;
    case Gcips:
      return timeelapsed * 1000000000;
    default:
      fprintf (stderr, "GciReadTimer: Error: Illegal timer unit.\n");
      return 0;
    }
  /* not reached */
}


/*-------------------------------------------------------------------------
 * Name:   GciLogPrint
 * Author: Lars Mats 
 *
 * Description:
 *        Encapsulation of printf for the GciLog function
 *
 * Return Value: none
 *
 */

void 
GciLogPrint (char *string, char *logString, int isRow)
{
  int maxWithCol1 = 30;
  int maxWithCol2 = 5;

  if (isRow)
    {
      fprintf (AdLogStream, "%-*sRow: %s\n",
	       maxWithCol1,
	       string,
	       logString);
    }
  else
    {
      fprintf (AdLogStream, "%-*s%s\n",
	       maxWithCol1 + maxWithCol2,
	       string,
	       logString);
    }
}


/*-------------------------------------------------------------------------
 * Name:	GciLog
 * Author:	CCG 96
 *
 * Description:
 *
 *	Logs an error message on the log stream
 *
 * Return Value: GciStatus (GciOk or GciNotOk)
 */

GciStatus 
GciLog (int logId, char *logString)
{

  switch (logId)
    {
    case IcLogMatchValue:
      fprintf (AdLogStream, "%s\n", logString);
      break;
    case IcLogNoMatchValue:
      fprintf (AdLogStream, "Failed %s\n", logString);
      break;
    case IcLogMessage:
      fprintf (AdLogStream, "%s\n", logString);
      break;
    case GciLogStartTC:
      GciLogPrint ("Start Test Case:", logString, 0);
      break;
    case GciLogStopTC:
      GciLogPrint ("Test Case ended:", logString, 0);
      break;
    case GciLogStartDEF:
      GciLogPrint ("Start Default:", logString, 0);
      break;
    case GciLogStopDEF:
      GciLogPrint ("Default ended:", logString, 0);
      break;
    case GciLogVerdict:
      GciLogPrint ("Final verdict:", logString, 0);
      break;
    case GciLogPVerdict:
      GciLogPrint ("Preliminary verdict:", logString, 0);
      break;
    case GciLogMatch:
      GciLogPrint ("Line matched:", logString, 0);
      break;
    case GciLogNOMatch:
/*       GciLogPrint ("Line not matched:", logString, 0); */
      break;
    case GciLogSendE:
      GciLogPrint ("Send event:", logString, 1);
      break;
    case GciLogRecE:
      GciLogPrint ("Receive event:", logString, 1);
      break;
    case GciLogOtherE:
      GciLogPrint ("Otherwise event:", logString, 1);
      break;
    case GciLogTimeoutE:
      GciLogPrint ("TimeOut:", logString, 1);
      break;
    case GciLogAssign:
      GciLogPrint ("Assignment:", logString, 1);
      break;
    case GciLogStartT:
      GciLogPrint ("StartTimer:", logString, 1);
      break;
    case GciLogStopT:
      GciLogPrint ("StopTimer:", logString, 0);
      break;
    case GciLogCancelT:
      GciLogPrint ("CancelTimer:", logString, 1);
      break;
    case GciLogReadT:
      GciLogPrint ("ReadTimer:", logString, 1);
      break;
    case GciLogAttach:
      GciLogPrint ("Attach:", logString, 1);
      break;
    case GciLogImplSend:
      GciLogPrint ("ImplicitSend:", logString, 1);
      break;
    case GciLogGoto:
      GciLogPrint ("Goto:", logString, 1);
      break;
    case GciLogRec:
      GciLogPrint ("Received on PCO:", logString, 0);
      break;
    case GciLogTimeout:
      GciLogPrint ("Timed out Timer:", logString, 0);
      break;
    default:
      fprintf (AdLogStream, "Log descriptor %d string %s not implemented!\n"
	       ,logId, logString);
      fflush (AdLogStream);
      return GciNotOk;
      break;
    }

  fflush (AdLogStream);
  return GciOk;

}


/*-------------------------------------------------------------------------
 * Name: GciCreate
 * Author: <name>
 *
 * Description:
 *  Not implemented
 *
 * Return Value: GciStatus (OK or Not_Ok)
 * 
 *
 */

GciStatus 
GciCreate( int comp, char* tree, GciValue* args )
{
  int  i;
  char* 	encoded_params;

  encoded_params = (char*) malloc(MSG_BUF_SIZE);
  for( i = 0; i < GciGetNoOfComponents( CurrentGciConf); i++) {
    GciComponent* component = NULL;
    component = GciGetComponent( CurrentGciConf, i); 
    if( GciGetComponentDescriptor( component) == comp) {
	    /* OK, here is the interesting part */
	    encoded_params = GeneralStringEncode( args);
	    SEND_TPI_CREATE(GciGetComponentName( component), RunningTestCaseName, tree, encoded_params);
      return GciOk;
    }
  }
  WARN(("eTC %s: Failed to find component in current configuration\n",fifo.myTcoId));
  /* exit( 1); */
  return GciNotOk;
}


/*-------------------------------------------------------------------------
 * Name: GciConfig
 * Author: <name>
 *
 * Description:
 *
 *	Not currently implemented ... used for Concurrent TTCN
 *
 * Return Value: 
 *
 *	GciStatus (OK or Not_Ok)
 */

GciStatus 
GciConfig ( GciConf conf )
{
  return GciOk;
}


/*-------------------------------------------------------------------------
 * Name: GciReadTSPar
 * Author: Theofanis Vassiliou-Gioles
 *
 * Description:
 * 
 *
 * Return Value: GciStatus (GciOk or GciNotOk)
 * 
 *
 */

#ifdef USE_TTMAN
GciValue* GciReadTSPar( char *par, char *pRef )
{
  GciValue *v;
  Param	 *tmpParam;

  /* Where the parameters already read in ?*/

  VERBOSE((0,"eTC %s: GciReadTSPar entered"));
  if(!parametersReadIn) 
    {
      VERBOSE((0,"eTC %s: We didn't receive parameters yet"));
      error_code = ERRBADSE;
      return((GciValue *) NULL);
    }

  cout<<"GciReadTSPar."<<endl;
 
  for (myParam.curr = myParam.first; 
       (myParam.curr &&  (tmpParam = (Param *) myParam.curr->data)); 
       myParam.curr = myParam.curr->next)
    {
      if(strcmp(tmpParam->param_id.octs, par) == 0) 
	{
	  if((v=GeneralStringDecode(tmpParam->param_value.octs)) == NULL) 
	    {
	      VERBOSE((0,"eTC %s: GciReadTSPar: Fatal: Failed parsing test suite parameter."));
	    }
	  return(v);
	}
    }
  return((GciValue *) NULL);
}

#else

GciValue* GciReadTSPar( char* par, char* pRef )
{
  
   GciValue * theParmValue;
  GciValue * pth;
  char * tmp;

 if(strcmp(par, "GcTlong_value") == 0)
    {
       theParmValue = GciMkINTEGER(30);
       
       return theParmValue;
    }
  
 if(strcmp(par, "GcTshort_value") == 0)
    {
       theParmValue = GciMkINTEGER(10);
       
       return theParmValue;
    }
 
   if(strcmp(par, "GcPath"))
    { 
      
     
      theParmValue = GciMkGraphicString(refFile);
      
      tmp = GciGetPrintableString(theParmValue);
     
      return theParmValue;
    }
 if(strcmp(par, "GcPath"))
    { 
      
     
      theParmValue = GciMkGraphicString(Objkey_refFile);
      
      tmp = GciGetPrintableString(theParmValue);
     
      return theParmValue;
    }



  printf("GciReadTSPar: should not come here - checking the parameter name\n");
  return NULL;
  
}








/*-------------------------------------------------------------------------
 * Name: main
 * Author: T. Vassiliou-Gioles
 * Date: October, 1998
 *
 * Description:
 * 
 *	This function implements a test suite for a test suite written in
 *	plain TTCN. It is assumed that this progam is not called stand alone
 *	but started from a TSP1-FrontEnd, so that communication can take
 *	place over FIFOs.
 *	
 *	TSP1 and therefore communication over FIFO for non-concurrent TTCN
 *	is a little bit overweighted but simplifies the solution of a test 
 *	manager because the TSP1 libraries can be used. 
 *
 */
#ifdef USE_TTMAN
int main( int argc, char *argv[])
{
	extern char 	*optarg;	/* For getopt */
	extern int 	optind;		/* For getopt */
	int		opt;
	struct sigaction sa;

	fprintf(stderr,"\n");
	while((opt = getopt(argc, argv, "hv:")) != EOF)
		switch(opt) {

		  case 'h':
			fprintf(stderr, usgtxt);
			exit(0);
		  case 'v':
			VERBOSITY=atoi(optarg);;
			break;
		  case '?':
			fprintf(stderr, usgtxt);
			exit(-1);
		}

	if((argc-optind < 2)) {
		fprintf(stderr, usgtxt);
		exit(-1);
	};



 	if ((logStream = fopen( "ETS.log", "w")) == NULL)  
 		fprintf( stderr, "eTC: Can't open LogFile\n");

	if(strlen(argv[optind]) > MAX_STR_LEN) {
		ERRORS(("Passed parameter, i.e. TestComponent too long. MAX_STR_LEN = %d", MAX_STR_LEN));
 		return(-1);
	} else {
		/* initializing fifo */
		bzero(&fifo,sizeof(fifo));
		strcpy(fifo.myTcoId, argv[optind]);
		VERBOSE((1,"eTC %s: my TCO_ID is '%s'",fifo.myTcoId,fifo.myTcoId));
	}

	optind++;

	if(!argv[optind]) {
		ERRORS(("eTC %s: No session_id, i.e. configuration given. Terminating", fifo.myTcoId));
		return(-1);
	} else 
	{
	    conf_name = strdup(argv[optind]);
	    VERBOSE((1,"eTC %s: TestSuite will run with configuration %s",fifo.myTcoId,argv[optind]));
	}

	if(openFIFO()) 
	{
	    ERRORS(("eTC %s: couldn't open FIFO's. Terminating",fifo.myTcoId));
		return(-1);
	}
	fifo.read_hd = poll_register (fifo.readfd, fifo_infunc, NULL, POLL_IN);

	InitNibbleMem(512, 512);
	RunningTestCaseName=NULL;
	error_code = ERROK;

	/*
	 *  By default use stdout for logging.
	 */

	AdLogStream = stdout;
	AdParameterFile = stdin;

	/*
	 * Initiation of the TTCN code is done after receiving a TPI-CREATE to ensure that parameters are already there.
	 */

	/*
	 * Initialize the Adaption system
	 */
	AdInit ();

	/* 
	 * Initialize the PCOs of this test component
	 */

	/* Catch SIGCLD */
	sa.sa_handler = sigchld;
	sigemptyset(&sa.sa_mask);
	sa.sa_flags = SA_RESTART;
	if (sigaction(SIGCLD, &sa, NULL))
		panic("Tester: sigaction(SIGCLD): %s", strerror(errno));

	while(1)
		poll_dispatch(1);



	/* close files etc. */

	AdExit ();

	return 0;
}
#else
int main(int argc, char **argv)
{
   
  int i, ver;
  char **list;
  char name[255];
  char *verdicts[] = { "FAIL", "INCONCLUSIVE", "PASS", "NONE" };
  
  /* logStream = stdout; */
  if ( ( logStream = fopen( "ETS.log", "w" ) ) == NULL )
    {
      fprintf( stderr, "main : Could not open log file!!!\n" );
      exit( 0 );
    }
  
  getreffilename();
  getobjkey_refFilename();
  
  GciInit( );
  
  CreatePCOsAndTimers();
  list = GciGetTestCaseList();
  printf("Available Test Cases :\n\n");
  for (i = 0; list[i] != NULL; ++i)
    printf("%s\n", list[i]);
  printf("\nEnter test case name : ");
  cin >> name;
  printf("main: starting test case %s\n", name); 
  ver = GciStartTestCase(name);
  fprintf(stderr, "\nFINAL VERDICT = %s\n", verdicts[ver]);
  fclose(logStream);  
  return 0;
  
}


/* End of File. */



