/*--------------------------------------------------------------------
 * Name:   gci.c
 * Author: ITEX C-Code Generator
 * 
 * Copyright 1991-1999 Telelogic AB, All rights reserved.
 *
 * This Program is owned by Telelogic and is protected by national
 * copyright laws and international copyright treaties. Telelogic
 * grants you the right to use this Program on one computer or in one
 * local computer network at any one time.  Under this License you may
 * only modify the source code for the purpose of adapting it to your
 * environment. You must reproduce and include any copyright and
 * trademark notices on all copies of the source code.  You may not
 * use, copy, merge, modify or transfer the Program except as provided
 * in this License.  Telelogic does not warrant that the Program will
 * meet your requirements or that the operation of the Program will be
 * uninterrupted and error free. You are solely responsible that the
 * selection of the Program and the modification of the source code
 * will achieve your intended results and that the results are
 * actually obtained.
 */


#include <string.h>
#include <stdio.h>
#include "gci.h"

#ifdef GENMSC
#include "mscgen.h"
#endif

#define NAME_FIELD 0

/*--------------------------------------------------------------------
 * External functions and variables used in this file.
 */

extern GciStatus GciConfig(GciConf);
extern GciStatus GciLog(int, char *);
extern GciStatus IcConfig(GciConf);
extern void IcConcurrentInit(void);
extern void IcConcurrentCleanup(void);

extern VcPCOQueue *IcGetPCO(int pco_d);
extern VcTimerType *IcGetTimer(int timer_d);
extern VcPTCType *IcGetPTC(int ptc_d);
extern VcPCOQueue IcPCOList[];
extern int GcFirstPCOD;
extern int GcFirstTimerD;

extern char *IcTestCaseList[];
extern char *IcTestGroupList[];

extern const int GcTestCaseD;
extern const int GcTestGroupD;
extern const int GcTestStepD;
extern const int GcLocalTreeD;
extern const int GcMTCD;
extern const int GcPTCD;
extern int IcSymTabLen;

extern int IcSetVerdict(int);

extern int IcInitTypes(void);
extern int IcInitDecls(void);

extern int IcNoOfTimers;
extern int IcNoOfPCOs;
extern int IcNoOfCPs;

/*--------------------------------------------------------------------
 * The actual implementation of the GCI interface.
 */

/*--------------------------------------------------------------------
 * Name:   GciMkINTEGER
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a INTEGER in the ccg value
 * representation.
 */

GciValue * GciMkINTEGER(long i)
{
  return (GciValue *) VcMkINTEGER((VcBaseVal) i);
}

/*--------------------------------------------------------------------
 * Name:   GciGetINTEGER
 * Author: ITEX C-Code Generator 
 *
 */

long GciGetINTEGER(GciValue * value)
{
  return VcGetINTEGER((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkBOOLEAN
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a BOOLEAN in the ccg value
 * representation.
 */

GciValue * GciMkBOOLEAN(int bool)
{
  return (GciValue *) VcMkBOOLEAN((VcBaseVal) bool);
}

/*--------------------------------------------------------------------
 * Name:   GciGetBOOLEAN
 * Author: ITEX C-Code Generator 
 *
 */

Bool GciGetBOOLEAN(GciValue * value)
{
  return VcGetBOOLEAN((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkREAL(int mantissa, int base, int exponent);
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a REAL in the ccg value
 * representation.
 */

GciValue * GciMkREAL(int mantissa, int base, int exponent)
{
  return (GciValue *) VcMkREAL((VcBaseVal) mantissa,
    (VcBaseVal) base,
    (VcBaseVal) exponent);
}

/*--------------------------------------------------------------------
 * Name:   GciGetREAL
 * Author: ITEX C-Code Generator 
 *
 */

GciReal * GciGetREAL(GciValue * value)
{
  return VcGetREAL((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkBIT_STRING
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a BITSTRING in the value
 * representation.
 */

GciValue * GciMkBIT_STRING(const char *str)
{
  return (GciValue *) VcMkBIT_STRING((VcString) str);
}

/*--------------------------------------------------------------------
 * Name:   GciGetBIT_STRING
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetBIT_STRING(GciValue * value)
{
  return VcGetBIT_STRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkHEXSTRING
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a HEXSTRING in the ccg
 * value representation.
 */

GciValue * GciMkHEXSTRING(const char *str)
{
  return (GciValue *) VcMkHEXSTRING((VcString) str);
}

/*--------------------------------------------------------------------
 * Name:   GciGetHEXSTRING
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetHEXSTRING(GciValue * value)
{
  return VcGetHEXSTRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name: GciMkOCTET_STRING(const char * str);
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a OCTETSTRING in the ccg
 * value representation.
 */

GciValue * GciMkOCTET_STRING(const char *str)
{
  return (GciValue *) VcMkOCTET_STRING((VcString) str);
}

/*--------------------------------------------------------------------
 * Name:   GciGetOCTET_STRING
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetOCTET_STRING(GciValue * value)
{
  return VcGetOCTET_STRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkNumericString
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a NumericString in the ccg
 * value representation.
 */

GciValue * GciMkNumericString(const char *str)
{
  return (GciValue *) VcSetType(VcNumericString, VcMkCSTRING((VcString) str));
}

/*--------------------------------------------------------------------
 * Name:   GciGetNumericString
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetNumericString(GciValue * value)
{
  return VcGetCSTRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkPrintableString
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a PrintableString in the
 * ccg value representation.
 */

GciValue * GciMkPrintableString(const char *str)
{
  GciValue *tmp;
  
  tmp = (GciValue *) VcMkCSTRING((VcString) str);
  tmp = (GciValue *) VcSetType(VcPrintableString, tmp);
  
  return tmp;
}

/*--------------------------------------------------------------------
 * Name:   GciGetPrintableString
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetPrintableString(GciValue * value)
{
  return VcGetCSTRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkTeletexString
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a TeletexString in the ccg
 * value representation.
 */

GciValue * GciMkTeletexString(const char *str)
{
  GciValue *tmp;
  
  tmp = (GciValue *) VcMkCSTRING((VcString) str);
  tmp = (GciValue *) VcSetType(VcTeletexString, tmp);
  
  return tmp;
}

/*--------------------------------------------------------------------
 * Name:   GciGetTeletexString
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetTeletexString(GciValue * value)
{
  return VcGetCSTRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkVideotexString
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a VideotexString.
 *
 * Return Value:
 * TeletexString in the ccg value representation.
 *
 */

GciValue * GciMkVideotexString(const char *str)
{
  GciValue *tmp;
  
  tmp = (GciValue *) VcMkCSTRING((VcString) str);
  tmp = (GciValue *) VcSetType(VcVideotexString, tmp);
  
  return tmp;
}

/*--------------------------------------------------------------------
 * Name:   GciGetVideotexString
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetVideotexString(GciValue * value)
{
  return VcGetCSTRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkVisibleString
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a VisibleString in the ccg
 * value representation.
 */

GciValue * GciMkVisibleString(const char *str)
{
  GciValue *tmp;
  
  tmp = (GciValue *) VcMkCSTRING((VcString) str);
  tmp = (GciValue *) VcSetType(VcVisibleString, tmp);
  
  return tmp;
}

/*--------------------------------------------------------------------
 * Name:   GciGetVisibleString
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetVisibleString(GciValue * value)
{
  return VcGetCSTRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkIA5String
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a IA5String in the ccg
 * value representation.
 */

GciValue * GciMkIA5String(const char *str)
{
  GciValue *tmp;
  
  tmp = (GciValue *) VcMkCSTRING((VcString) str);
  tmp = (GciValue *) VcSetType(VcIA5String, tmp);
  
  return tmp;
}

/*--------------------------------------------------------------------
 * Name:   GciGetIA5String
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetIA5String(GciValue * value)
{
  return VcGetCSTRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkT61String
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a NumericString in the ccg
 * value representation.
 */

GciValue * GciMkT61String(const char *str)
{
  GciValue *tmp;
  
  tmp = (GciValue *) VcMkCSTRING((VcString) str);
  tmp = (GciValue *) VcSetType(VcT61String, tmp);
  
  return tmp;
}

/*--------------------------------------------------------------------
 * Name:   GciGetT61String
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetT61String(GciValue * value)
{
  return VcGetCSTRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkISO646String
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a NumericString in the ccg
 * value representation.
 */

GciValue * GciMkISO646String(const char *str)
{
  GciValue *tmp;
  
  tmp = (GciValue *) VcMkCSTRING((VcString) str);
  tmp = (GciValue *) VcSetType(VcISO646String, tmp);
  
  return tmp;
}

/*--------------------------------------------------------------------
 * Name:   GciGetISO646String
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetISO646String(GciValue * value)
{
  return VcGetCSTRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkGraphicString
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a GraphicString in the ccg
 * value representation.
 */

GciValue * GciMkGraphicString(const char *str)
{
  GciValue *tmp;
  
  tmp = (GciValue *) VcMkCSTRING((VcString) str);
  tmp = (GciValue *) VcSetType(VcGraphicString, tmp);
  
  return tmp;
}

/*--------------------------------------------------------------------
 * Name:   GciGetGraphicString
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetGraphicString(GciValue * value)
{
  return VcGetCSTRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkGeneralString
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a GeneralString in the ccg
 * value representation.
 */

GciValue * GciMkGeneralString(const char *str)
{
  GciValue *tmp;
  
  tmp = (GciValue *) VcMkCSTRING((VcString) str);
  tmp = (GciValue *) VcSetType(VcGeneralString, tmp);
  
  return tmp;
}

/*--------------------------------------------------------------------
 * Name:   GciGetGeneralString
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetGeneralString(GciValue * value)
{
  return VcGetCSTRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkGeneralizedTime
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a GeneralString in the ccg
 * value representation.
 */

GciValue * GciMkGeneralizedTime(char *str)
{
  GciValue *tmp;
  
  tmp = VcMkGeneralizedTime(str);
  return tmp;
}

/*--------------------------------------------------------------------
 * Name:   GciGetGeneralizedTime
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetGeneralizedTime(GciValue * value)
{
  return VcGetCSTRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkUTCTime
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a GeneralString in the ccg
 * value representation.
 */

GciValue * GciMkUTCTime(char *str)
{
  GciValue *tmp;
  
  tmp = VcMkUTCTime(str);
  return tmp;
}

/*--------------------------------------------------------------------
 * Name:   GciGetUTCTime
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetUTCTime(GciValue * value)
{
  return VcGetCSTRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkENUMERATED
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a Enumerated in the ccg
 * value representation.
 */

GciValue * GciMkENUMERATED(int value)
{
  return (GciValue *) VcMkENUMERATED((VcBaseVal) value);
}

/*--------------------------------------------------------------------
 * Name:   GciGetENUMERATED
 * Author: ITEX C-Code Generator 
 *
 */

int GciGetENUMERATED(GciValue * value)
{
  return VcGetINTEGER((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkCHOICE
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a Choice in the ccg value
 * representation.
 */

GciValue * GciMkCHOICE(char *name, GciValue * value)
{
  return (GciValue *) VcMkCHOICE((VcValue *) value, (VcString) name);
}

/*--------------------------------------------------------------------
 * Name:   GciGetCHOICE
 * Author: ITEX C-Code Generator 
 *
 */

GciValue * GciGetCHOICE(GciValue * value)
{
  return VcGetCHOICE("", NULL, (VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciGetCHOICEName
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetCHOICEName(GciValue * value)
{
  return (char *) VcGetCHOICEName((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkObjectDescriptor
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a ObjectDescriptor in the
 * ccg value representation.
 */

GciValue * GciMkObjectDescriptor(const char *str)
{
  return (GciValue *) VcMkObjectDescriptor((VcString) str);
}

/*--------------------------------------------------------------------
 * Name:   GciGetObjectDescriptor
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetObjectDescriptor(GciValue * value)
{
  return VcGetCSTRING((VcValue *) value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkNULL
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a NULL element in the ccg
 * value representation.
 */

GciValue * GciMkNULL(void)
{
  return (GciValue *) VcMkNULL();
}

/*--------------------------------------------------------------------
 * Name:   GciGetNULL
 * Author: ITEX C-Code Generator 
 *
 */

int GciGetNULL(GciValue * value)
{
  return VcGetINTEGER(value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkANY
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a Any element in the ccg
 * value representation.
 */

GciValue * GciMkANY(GciValue * value)
{
  return (GciValue *) VcMkANY(value);
}

/*--------------------------------------------------------------------
 * Name:   GciGetANY
 * Author: ITEX C-Code Generator 
 *
 */

GciValue * GciGetANY(GciValue * value)
{
  return (GciValue *) VcGetANY(value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkR_TYPE
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a R_TYPE element in the
 * ccg value representation.
 */

GciValue * GciMkR_TYPE(int elem)
{
  return (GciValue *) VcMkR_TYPE(elem);
}

/*--------------------------------------------------------------------
 * Name:   GciGetR_TYPE
 * Author: ITEX C-Code Generator 
 *
 */

int GciGetR_TYPE(GciValue * value)
{
  return VcGetINTEGER(value);
}

/*--------------------------------------------------------------------
 * Name:   GciMkPDU
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and return a PDU element in the ccg
 * value representation.
 */

GciValue * GciMkPDU(GciValue * value)
{
  return (GciValue *) VcMkPDU(value);
}

/*--------------------------------------------------------------------
 * Name:   GciGetPDU
 * Author: ITEX C-Code Generator 
 *
 */

GciValue * GciGetPDU(GciValue * value)
{
  return (GciValue *) VcGetPDU(value);
}

/*--------------------------------------------------------------------
 * Name:   GciGetType
 * Author: ITEX C-Code Generator 
 *
 * Get type of value.  Return a integer describing the type.
 */

int GciGetType(GciValue * value)
{
  VcType *type;
  
  if ((type = VcGetType((VcValue *) value)) == NULL) {
    fprintf(stderr, "GciGetType : Type for value is NULL!\n");
    return VcUndefinedD;
  }
  return VcGetName(type);
}

/*--------------------------------------------------------------------
 * Name:   GciGetBaseType
 * Author: ITEX C-Code Generator 
 *
 * Get the descriptor of the base type from which the type of an object
 * is derived. 
 */

int GciGetBaseType(GciValue * value)
{
  VcType *type;
  
  if ((type = VcGetType((VcValue *) value)) == NULL) {
    fprintf(stderr, "GciGetBaseType : Type for value is NULL!\n");
    return VcUndefinedD;
  }
  return (int) VcGetBaseType(type);
}

/*--------------------------------------------------------------------
 * Name:   GciSetType
 * Author: ITEX C-Code Generator 
 *
 * Set a value to the given type.  Return the same value changed to
 * the given type.
 */

GciValue * GciSetType(int type, GciValue * val)
{
  VcType *tmp = VcTag2Type(type);
  if (tmp != NULL)
    return VcSetType(tmp, val);
  else {
    tmp = IcSymTabStr2Type(IcSymTabTag2Str(type));
    if (tmp != NULL)
      return VcSetType(tmp, val);
    else
      fprintf(stderr, "GciSetType: Type %d not found! Returning NULL.\n", type);
  }
  return NULL;
}

/*--------------------------------------------------------------------
 * Name:   VcTagType 
 * Author: ITEX C-Code Generator 
 *
 * Set a tag to the type of the value.  Return the same value with its
 * type changed.
 */

GciValue * GciTagType(char class, int tag, Bool implicit, GciValue * value)
{
  if (VcGetType((VcValue *) value) != NULL)
    VcTagType(class, tag, implicit, VcGetType((VcValue *) value));
  return value;
}

/*--------------------------------------------------------------------
 * Name:   GciGetTag
 * Author: ITEX C-Code Generator 
 *
 * Get the tag from the typed value at depth n.  An integer denoting
 * the tag value
 */

int GciGetTag(GciValue * value, int depth)
{
  VcType *type = VcGetType((VcValue *) value);
  
  while (depth-- > 0) {
    if (type == NULL)
      return -1;
    type = VcGetParent(type);
  }
  return VcGetTag(type);
}

/*--------------------------------------------------------------------
 * Name:   GciGetClass
 * Author: ITEX C-Code Generator 
 *
 * Get the tag classfrom the typed value at depth d A char denoting
 * the tag class. Possible values are:
 *  0 - NONE
 *  1 - UNIVERSAL
 *  2 - APPLICATION
 *  3 - PRIVATE
 *  4 - CONTEXT
 */

char GciGetClass(GciValue * value, int depth)
{
  VcType *type = VcGetType((VcValue *) value);
  
  while (depth-- > 0) {
    if (type == NULL)
      return -1;
    type = VcGetParent(type);
  }
    
  return VcGetClass(type);
}

/*--------------------------------------------------------------------
 * Name:   GciGetImplicit
 * Author: ITEX C-Code Generator 
 *
 * Get the Implicit flag from the typed value on depth d A boolean
 * denoting if the tag is defined implicit or not
 */

Bool GciGetImplicit(GciValue * value, int depth)
{
  VcType *type = VcGetType((VcValue *) value);
  
  while (depth-- > 0) {
    if (type == NULL)
      return -1;
    type = VcGetParent(type);
  }
  return VcGetImplicit(type);
}

GciValue*  GciMkOBJECT_IDENTIFIER()
{
  return (GciValue*) VcMkOBJECT_IDENTIFIER(NULL); /*Create empty OBJ ID.*/
}


GciValue* GciAddOBJECT_IDENTIFIERComponent(GciValue* oid, int comp)
{
  return (GciValue*) VcAddOBJID_Component((VcValue*) oid, comp);
}


int GciOBJECT_IDENTIFIERSize(GciValue* value)
{
  return VcGetOBJID_Size((VcValue*) value);
}


int GciGetOBJECT_IDENTIFIERComponent(GciValue* oid, int index)
{
  return VcGetOBJID_Component( (VcValue*) oid, index);
}


/*--------------------------------------------------------------------
 * Name:   GciMkSEQUENCE
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation, which makes a SEQUENCE, SET.  Return
 * the SEQUENCE, SET.
 */

GciValue * GciMkSEQUENCE(int size)
{
  return (GciValue *) VcMkSEQUENCE(size);
}

/*--------------------------------------------------------------------
 * Name:   GciSetField
 * Author: ITEX C-Code Generator 
 *
 * To set the field pointed out by index to value fld.  The same seq
 * with a the field pointed out by index changed to fld.
 */

GciValue * GciSetField(GciValue * sequence, int index, GciValue * field)
{
  return (GciValue *)
    VcSetField((VcValue *) field, index, (VcValue *) sequence);
}

/*--------------------------------------------------------------------
 * Name:   GciGetField
 * Author: ITEX C-Code Generator 
 *
 * Get the field pointed out by index in seq.  Return the field
 * pointed out by index.
 */

GciValue * GciGetField(GciValue * sequence, int index)
{
  return (GciValue *) VcGetField(index, (VcValue *) sequence);
}

/*--------------------------------------------------------------------
 * Name:   GciSeqSize
 * Author: ITEX C-Code Generator 
 *
 * Count the number of fields in seq.  Return the number of fields.
 */

int GciSeqSize(GciValue * sequence)
{
  return VcSeqSize((VcValue *) sequence);
}

/*--------------------------------------------------------------------
 * Name:   GciMkSEQUENCEOF
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and get a SEQUENCE OF, SET OF.
 * Return the SEQUENCE OF, SET OF.
 */

GciValue * GciMkSEQUENCEOF(void)
{
  return (GciValue *) VcMkSEQUENCE_OF(VcUndefined);
}

/*--------------------------------------------------------------------
 * Name:   GciMkSET
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and get a SEQUENCE OF, SET OF.
 * Return the SEQUENCE OF, SET OF.
 */

GciValue *GciMkSET(int size)
{
  return (GciValue *) VcMkSET(size);
}

/*--------------------------------------------------------------------
 * Name:   GciMkSETOF
 * Author: ITEX C-Code Generator 
 *
 * Call the value representation and get a SEQUENCE OF, SET OF.
 * Return the SEQUENCE OF, SET OF.
 */

GciValue * GciMkSETOF(void)
{
  return (GciValue *) VcMkSET_OF(VcUndefined);
}

/*--------------------------------------------------------------------
 * Name:   GciAddElem
 * Author: ITEX C-Code Generator 
 *
 * Add an element elem to the SEQUENCE, SET seqOf.  Return the SeqOf
 * with a new field elem.
 */

GciValue * GciAddElem(GciValue * sequence_of, GciValue * element)
{
  return (GciValue *) VcAddElemZ((VcValue *) element, (VcValue *) sequence_of);
}

/*--------------------------------------------------------------------
 * Name:   GciGetElem
 * Author: ITEX C-Code Generator 
 *
 * Get the field pointed out by index in the seqOf.
 */

GciValue * GciGetElem(GciValue * sequence_of, int index)
{
  return (GciValue *) VcGetField(index + 1, (VcValue *) sequence_of);
}

/*--------------------------------------------------------------------
 * Name:   GciSeqOfSize
 * Author: ITEX C-Code Generator 
 *
 * count how many fields there are in the SEQUENCE OF, SET OF seq.
 * The size of the SEQUENCE OF, SET OF.
 */

int GciSeqOfSize(GciValue * sequence_of)
{
  return VcSeqOfSize((VcValue *) sequence_of);
  
}

/*--------------------------------------------------------------------
 * Name:   GciTimeout
 * Author: ITEX C-Code Generator 
 *
 * This function is used to mark a given timer as timed out.
 */

GciStatus GciTimeout(int timerd)
{
  VcTimerType *timer;
  
#ifdef DEBUG_GCI
  fprintf(stderr, "Inside GciTimeout...\n");
#endif
  
  if ((timer = IcGetTimer(timerd)) == NULL) {
    fprintf(stderr, "GciTimeout: Illegal timer descriptor %d. The operation is ignored.\n",  timerd);
    return GciNotOk;
  }
  
  timer->Status = VcSTATUSTO;
  GciLog(GciLogTimeout, timer->Name);
  return GciOk;
}

/*--------------------------------------------------------------------
 * Name:   GciReceive
 * Author: ITEX C-Code Generator 
 *
 * This function is used to mark that a given object has been received
 * on a given PCO.
 */

GciStatus GciReceive(int PCOD, GciValue * Obj)
{
  VcPCOQueueObject *tmp, *queue;
  
#ifdef DEBUG_GCI
  fprintf(stderr, "Inside GciReceive...\n");
#endif
  
  if (GcFirstPCOD > PCOD || PCOD >= GcFirstPCOD + IcNoOfPCOs + IcNoOfCPs) {
    fprintf(stderr, "GciReceive: Illegal PCO Descriptor %d, operation is ignored.\n", PCOD);
    return GciNotOk;
  }
  
  tmp = (struct VcPCOQueueObject *)
    VCMALLOC(sizeof(struct VcPCOQueueObject), "GciReceive(Queue Object)");
  
  tmp->sender = context;    /* Only relevant for CMs. */
  tmp->First  = Obj;
  tmp->Next   = NULL;
  
  if ((queue = IcGetPCO(PCOD)->Queue) == NULL)
    IcGetPCO(PCOD)->Queue = tmp;
  else {
    while (queue->Next != NULL)
      queue = queue->Next;
    queue->Next = tmp;
  }
  
#ifdef GENMSC
  /* Only log for PCOs, CPs are handled by IcSend function */
  if ( PCOD < GcFirstPCOD + IcNoOfPCOs )/* Could use IcIsCP(PCOD) */
    MscOut( MscReceiveMessage, GciGetPCOName( PCOD ), 
	    IcGetNameOfComponentOwningPCO( PCOD ),
	    Obj, NULL );
#endif

  return GciOk;
}

/*--------------------------------------------------------------------
 * Name:   GciDone
 * Author: ITEX C-Code Generator 
 *
 * This function shall be called when a PTC has finished execution.
 */

GciStatus GciDone(int PTCD)
{
  VcPTCType *tmp;
  
#ifdef DEBUG_GCI
  fprintf(stderr, "Inside GciDone...\n");
#endif /* DEBUG_GCI */
  
  tmp = IcGetPTC(PTCD);
  tmp->Status = VcSTATUSDONE;
  IcSetAllReady();
  
#ifdef GENMSC
  {
    /* Note that this may not be all that successful for distributed
       concurrent TTCN, but there seems to be no straight-forward way
       of associating a PTC name with the descriptor. It does work
       under internal concurrency... Besides, there is limited use of
       MSC logging in the distributed concurrent mode */
    MscDoneComponent( IcGetComponentName() );
  }
#endif

  return GciOk;
}

/*--------------------------------------------------------------------
 * Name:   GciSetVerdict
 * Author: ITEX C-Code Generator 
 *
 * This function sets a verdict.
 */

GciStatus GciSetVerdict(GciVerdict ver)
{
#ifdef DEBUG_GCI
  fprintf(stderr, "Inside GciSetVerdict...\n");
#endif /* DEBUG_GCI */
  
  IcSetVerdict(ver);
  
  return GciOk;
}

/*--------------------------------------------------------------------
 * Name:   GciStatus GciInit
 * Author: ITEX C-Code Generator
 *
 * GCI function called to initialize the TTCN Runtime Behaviour.
 */

GciStatus GciInit(void)
{
  int i;
  
  for (i = 0; i < IcNoOfPCOs; ++i)
    IcPCOList[i].Type = NULL;

  VcInitMem();

  VcBaseTypes();
  
  if (!IcInitTypes())
    return GciNotOk;

  if (!IcInitDecls())
    return GciNotOk;

  
#ifdef GENMSC
  MscInit();
#endif

  return GciOk;
}

/*--------------------------------------------------------------------
 * Name:   GciStatus GciExit
 * Author: ITEX C-Code Generator
 *
 * GCI function called to shut down the TTCN Runtime environment.
 * Should probably also free any heap memory and such that is left
 * over...
 */

GciStatus GciExit(void)
{
#ifdef GENMSC
  MscExit();
#endif
  return GciOk;
}

/*--------------------------------------------------------------------
 * Name:   GciIsSelected
 * Author: ITEX C-Code Generator 
 *
 * This function evaluates the selection expression for a given Test 
 * Case or Test Group and returns:
 *
 *   (int) 1 if the test cases/groups selection expression evaluates to TRUE
 *   (int) 0 if it evaluates to FALSE or if the object is of the wrong type 
 *           or not present in the suite.
 */

int GciIsSelected( const char * TestCaseOrGroupName )
{
  IcSymTabEntry *entry = NULL;
  
  for ( entry = IcSymTab; entry != NULL && entry->Name != NULL; ++entry) {
    if ( (entry->Type == GcTestCaseD || entry->Type == GcTestGroupD) && 
      strcmp(entry->Name, TestCaseOrGroupName) == 0 ) {
      /* Calculate the selection expressions value, if present */
      if ( entry->Val == NULL || GciGetBOOLEAN(*entry->Val) )
        return 1;
      else
        break;
    }
  }
  
  /* Not found, not selected or not of the correct type */
  return 0;
}



/*--------------------------------------------------------------------
 * Name:   GciCheckParent
 * Author: ITEX C-Code Generator 
 *
 */

static
int GciCheckParent(const char *name)
{
  char **group = NULL, **member = NULL;
  IcSymTabEntry *entry = NULL;  
  
  /* Find the group that contains the name (the parent).  First we
   * loop over all the groups. */
  
  for (group = GciGetTestCaseGroupList(); *group; ++group) {
    
    /* Find the current group in the symbol table */
    
    for (entry = IcSymTab; entry && entry->Name; ++entry) {
      if (entry->Type == GcTestGroupD && strcmp(entry->Name, *group) == 0) {
        
        /* If the current group is found in the symbol table, we look
         * through it's members for the given name. */
        
        for (member = entry->tgList; *member; ++member) {
          if (strcmp(name, *member) == 0) {
            
            /* If we find the name we know that the current group is
             * the parent of the given name. We nw see if the group is
             * selected. If it is, we have to check it's parent as
             * well. If it isn't we are done. */
             
            if (GciIsSelected(*group))
              return GciCheckParent(*group);
            else
              return 0;
          }
        }
      }
    }
  }
  
  /* We didn't find a parent group for the given name. This means that
   * we return true (1). */
  
  return 1;
}

/*--------------------------------------------------------------------
 * Name:   GciStartTestCase
 * Author: ITEX C-Code Generator 
 *
 * This functions shall start the execution of the given test case or
 * test group specified by the incoming argument.  */

GciVerdict GciStartTestCase(const char *TestCaseOrGroupName)
{
  static int part_of_group = 0;
  
  GciVerdict Verdict = GciNone;
  IcSymTabEntry *entry = NULL;
  IcECB Ecb;
  
  /* Set the global verdict to none before we execute each test case.
   * The total verdict of a testgroup will be kept and checked in a
   * function local variable (Verdict and tmpVerdict). */
  
  IcGlobalVerdict = IcNone;
  
  /* Execute the testcase/s. */
  
  for (entry = IcSymTab; entry != NULL && entry->Name != NULL ; ++entry ) {
    if ((entry->Type == GcTestCaseD || entry->Type == GcTestStepD) && 
      strcmp(entry->Name, TestCaseOrGroupName) == 0) {
      int GroupIsSelected;
      
      Ecb.status = 0;
      
      /* This check is to make sure that we don't run individually
       * started test-cases that are part of a test group with a
       * selection expression that's false. We only need to check this
       * if we start the test case explicitly. */
      
      GroupIsSelected = (part_of_group <= 0) ? GciCheckParent(entry->Name) : 1;
      
      if (GroupIsSelected && GciIsSelected(TestCaseOrGroupName)) {
        int timerd = 0;
        
	IcConcurrentInit(); 
        IcConfig(entry->config);
/*         IcConcurrentInit(); */
        IcClearPCOs();
        GciLog(GciLogStartTC, (char*)TestCaseOrGroupName);  
        
        IcInitTimers();

#ifdef GENMSC
	MscStartTestCase ( IcGetComponentName(), TestCaseOrGroupName );
#endif

        Verdict = entry->Behav(&Ecb);

#ifdef GENMSC
	MscFinalVerdict( IcGetComponentName(), IcVerdict2Str( Verdict ));
	MscStopTestCase( IcGetComponentName() );
#endif

        GciLog(GciLogStopTC, (char*)TestCaseOrGroupName);

        /* Here we cancel all timers. This is neccesary since the
         * timers are local to the test-cases. Each test case should
         * get a fresh copy of all timers. The way we do it here is
         * that we assume that the timers are OK when we start.  This
         * means that we have to reset the timers after we have
         * executed a test-case. */
        
         IcCancelTimer(GcANY_TIMERD, 0, NULL);

         IcConcurrentCleanup();
      }
      else
        Verdict = GciNone;

      return Verdict;
    }
    else if (entry->Type == GcTestGroupD && strcmp(entry->Name, TestCaseOrGroupName) == 0) {
      int ParentIsSelected = (part_of_group <= 0) ? GciCheckParent(entry->Name) : 1;
      
      ++part_of_group;
      
      if (ParentIsSelected && GciIsSelected(TestCaseOrGroupName)) {
        char **List = (entry->tgList);
        GciLog(GciLogStartTC, (char*)TestCaseOrGroupName);
        while (*List != NULL) {
          char *name = *List++;
          GciVerdict tmp = GciStartTestCase(name);
          if (tmp < Verdict)
            Verdict = tmp;
        }
        GciLog(GciLogStopTC, (char*)TestCaseOrGroupName);
      }
      else
        Verdict = GciNone;
      
      --part_of_group;
      
      return Verdict;
    }
  }
  
  return Verdict;
}

/*--------------------------------------------------------------------
 * Name:   GciGetTestCaseList
 * Author: ITEX C-Code Generator 
 *
 * This function returns a list of the available test cases.  */

GciTCList * GciGetTestCaseList(void)
{
  return IcTestCaseList;
}

/*--------------------------------------------------------------------
 * Name:   GciGetTestCaseGroupList
 * Author: ITEX C-Code Generator 
 *
 * This function returns a list of the available test groups.
 */

GciTCList * GciGetTestCaseGroupList(void)
{
  return IcTestGroupList;
}

/*--------------------------------------------------------------------
 * Name:   GciGetValue
 * Author: ITEX C-Code Generator 
 *
 * This function returns the value of the given object.
 */

GciValue * GciGetValue(const char *value)
{
  int i = 0;
  
  while (IcSymTab[i].Name != NULL && (strcmp(IcSymTab[i].Name, value) != 0))
    i++;
  
  if (IcSymTab[i].Name == NULL || 
    IcSymTab[i].Val == NULL ||
    IcSymTab[i].Type == GcTestCaseD ||
    IcSymTab[i].Type == GcTestStepD ||
    IcSymTab[i].Type == GcTestGroupD) {
    fprintf( stderr, "Warning: GciGetValue: Illegal identifier\n");
    return NULL;
  }
  
  return *IcSymTab[i].Val;
}

/*--------------------------------------------------------------------
 * Name:   int GciGetNoOfTimers
 * Author: ITEX C-Code Generator 
 *
 */

int GciGetNoOfTimers(void)
{
  return IcNoOfTimers;
}

/*--------------------------------------------------------------------
 * Name:   int GciGetNoOfPCOs
 * Author: ITEX C-Code Generator 
 *
 */

int GciGetNoOfPCOs(void)
{
  int i, amount = 0;
  
  for (i = 0; i < IcNoOfPCOs; ++i)
    if (IcPCOList[i].Type != NULL)
      amount++;
    
    return amount;
}

/*--------------------------------------------------------------------
 * Name:   GciGetTimerName
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetTimerName(int TimerD)
{
#ifdef DEBUG_GCI
  fprintf(stderr, "Inside GciGetTimerName...\n");
#endif
  
  return IcGetTimer(TimerD)->Name;
}

/*--------------------------------------------------------------------
 * Name:   GciGetPCO
 * Author: ITEX C-Code Generator 
 *
 */

int GciGetPCO(int index)
{
  int i, amount = 0;
  
  if (index < 0 || index >= IcNoOfPCOs)
  {
    fprintf(stderr, "GciGetPCO: Warning: PCO index out of bounds.\n");
    return -1;
  }
  
  for (i = 0; i < IcNoOfPCOs; i++)
    if (IcPCOList[i].Type != NULL) {
      if (index == amount)
        return GcFirstPCOD + i;
      amount++;
    }
  return -1;
}

/*--------------------------------------------------------------------
 * Name:   GciGetTimer
 * Author: ITEX C-Code Generator 
 *
 */

int GciGetTimer(int index)
{
  if (index < 0 || index >= IcNoOfTimers)
  {
    fprintf(stderr, "GciGetTimer: Warning: Timer index out of bounds.!\n");
    return -1;
  }
  
  /* Offset from context mapped timer identifier. */
  return ConvertTimerIdtoContextId(GcFirstTimerD) + index;
}

/*--------------------------------------------------------------------
 * Name:   GciGetPCOIndex
 * Author: ITEX C-Code Generator 
 *
 */

int GciGetPCOIndex(int desc)
{
  int i, amount = 0;
  
  if (desc < GcFirstPCOD || desc >= GcFirstPCOD + IcNoOfPCOs)
  {
    fprintf(stderr, "GciGetPCOIndex: Not a PCO descriptor!\n");
    return -1;
  }
  
  for (i = GcFirstPCOD; i < desc; i++)
    if (IcPCOList[i - GcFirstPCOD].Type != NULL)
      amount++;
    
  return amount;
}

/*--------------------------------------------------------------------
 * Name:   GciGetTimerIndex
 * Author: ITEX C-Code Generator 
 *
 */

int GciGetTimerIndex(int TimerD)
{
  /* Transform context mapped timer to a defined identifier. */

  TimerD = ConvertContextIdToTimerId(TimerD);
  
  if (TimerD < GcFirstTimerD || TimerD >= GcFirstTimerD + IcNoOfTimers)
  {
    fprintf(stderr, "GciGetTimerIndex: Not a timer descriptor!\n");
    return -1;
  }
  
  return TimerD - GcFirstTimerD;
}

/*--------------------------------------------------------------------
 * Name:   GciGetPCOName
 * Author: ITEX C-Code Generator 
 *
 */

char * GciGetPCOName(int PCOD)
{
#ifdef DEBUG_GCI
  fprintf(stderr, "Inside GciGetPCOName...\n");
#endif
  
  return IcGetPCO(PCOD)->Name;
}

/*--------------------------------------------------------------------
 * Name:   const char *GciGetTypeNameString
 * Author: ITEX C-Code Generator
 *
 * This function tries to get the textual representation of the given
 * type-name (descriptor).  If it can't be found an string containing
 * an informative message is returned.
 */

const char * GciGetTypeNameString(int descriptor)
{
  const char *name;
  
  if ((name = VcTag2Str(descriptor)) != NULL)
    return name;
  else if ((name = IcSymTabTag2Str(descriptor)) != NULL)
    return name;
  else
    return "<Unknown Type>";
}

/*--------------------------------------------------------------------
 * Name:   const char *GciGetTypeNameString
 * Author: ITEX C-Code Generator
 *
 * This function tries to look up the type name (descriptor) given its
 * textual representation.  If it can't find the name it returns
 * VcUndefinedD.
 */

int GciGetTypeDescriptor(const char *name)
{
  int descriptor;
  
  if ((descriptor = VcGetName(IcSymTabStr2Type(name))) != VcUndefinedD)
    return descriptor;
  else if ((descriptor = VcGetName(VcStr2Type(name))) != VcUndefinedD)
    return descriptor;
  else
    return VcUndefinedD;
}

/*--------------------------------------------------------------------
 *
 *
 */

int GciGetOMIT(GciValue *value)
{
  return VcGetValueAttribute(VcOMITATTR, value);
}

/*-------------------------------------------------------------------------
 * The following functions are functions for concurrency. Most of them are
 * present to allow a user to get information about a given configuration.
 */

/*--------------------------------------------------------------------
 * Name:   GciStartTestComponent
 * Author: ITEX C-Code Generator 
 *
 * This function unpacks the argument list and starts the local tree,
 * making the assumption that the tree is the behaviour of a test case
 * component. Failing to call this function with such arguments, will
 * be pretty likely to cause a crash.
 *
 */

GciVerdict GciStartTestComponent(char *TreeName, GciValue * args)
{
  IcECB Ecb;
  int i = IcSymTabLen;
  
  while (i >= 0) {
    if ((IcSymTab[i].Type == GcTestStepD || IcSymTab[i].Type == GcLocalTreeD) &&
        strcmp(IcSymTab[i].Name, TreeName) == 0) {
      Ecb.status = 0;
      
      GciLog(GciLogStartTC, TreeName);
      
      /* Reset the Test Case variables. This should be done for
       * every PTC according to the standard. */
      if (!IcInternalConcurrency()) 
      {
	  IcStatusCreate(NULL);
	  VcResetTCVars();
      }
      
      do {
        switch (GciSeqSize(args)) {
        case 0:
          IcSymTab[i].Behav(&Ecb);
          break;
        case 1:
          IcSymTab[i].Behav(GciGetField(args, 1), &Ecb);
          break;
        case 2:
          IcSymTab[i].Behav(GciGetField(args, 1), GciGetField(args, 2), &Ecb);
          break;
        case 3:
          IcSymTab[i].Behav(GciGetField(args, 1),
            GciGetField(args, 2),
            GciGetField(args, 3),
            &Ecb);
          break;
        case 4:
          IcSymTab[i].Behav(GciGetField(args, 1),
            GciGetField(args, 2),
            GciGetField(args, 3),
            GciGetField(args, 4),
            &Ecb);
          break;
        case 5:
          IcSymTab[i].Behav(GciGetField(args, 1),
            GciGetField(args, 2),
            GciGetField(args, 3),
            GciGetField(args, 4),
            GciGetField(args, 5),
            &Ecb);
          break;
        case 6:
          IcSymTab[i].Behav(GciGetField(args, 1),
            GciGetField(args, 2),
            GciGetField(args, 3),
            GciGetField(args, 4),
            GciGetField(args, 5),
            GciGetField(args, 6),
            &Ecb);
          break;
        case 7:
          IcSymTab[i].Behav(GciGetField(args, 1),
            GciGetField(args, 2),
            GciGetField(args, 3),
            GciGetField(args, 4),
            GciGetField(args, 5),
            GciGetField(args, 6),
            GciGetField(args, 7),
            &Ecb);
          break;
        case 8:
          IcSymTab[i].Behav(GciGetField(args, 1),
            GciGetField(args, 2),
            GciGetField(args, 3),
            GciGetField(args, 4),
            GciGetField(args, 5),
            GciGetField(args, 6),
            GciGetField(args, 7),
            GciGetField(args, 8),
            &Ecb);
          break;
        default:
          fprintf(stderr, "gci.c:%d: Sorry, too many parameters to PTC.\n", __LINE__);
          return IcFAIL;
        }
        if (IcGetEcbStatus(&Ecb) == IcNOMATCH1 && !IcSnapshot())
          IcSetEcbStatus( &Ecb, IcEXECUTIONSTOPPED, 0);
      } while (IcGetEcbStatus(&Ecb) == IcNOMATCH1);

      /* Cancel all running timers in PTC! */
      IcCancelTimer(GcANY_TIMERD, 0, NULL);

      GciLog(GciLogStopTC, TreeName);
      
      return IcGetVerdict();
    }
    
    --i;
  }
  fprintf(stderr, "No such test component as %s!\n", TreeName);
  return IcFAIL;
}


/*-------------------------------------------------------------------------
 * Name:    GciGetNoOfComponents
 * Creator: ITEX C-Code Generator
 *
 * Description:
 *  This function returns the number of components in a given configuration.
 *
 */

int GciGetNoOfComponents(GciConf conf)
{
  int i;
  
  for (i = 0; conf[i] != NULL; i++)
    ;
  
  return i;
}

/*-------------------------------------------------------------------------
 * Name:    GciGetComponent
 * Creator: ITEX C-Code Generator
 *
 * Description:
 *  This function returns the indexed component from a given configuration.
 *
 */

GciComponent * GciGetComponent(GciConf conf, int index)
{
  if ((index < 0) || (index > GciGetNoOfComponents(conf))) {
    fprintf(stderr, "GciGetComponent: Incorrect component index!\n");
    return NULL;
  }
  return conf[index];
}

/*-------------------------------------------------------------------------
 * Name:    GciGetComponentName
 * Creator: ITEX C-Code Generator
 *
 * Description:
 *  This function returns the name of the given component.
 *
 */

char * GciGetComponentName(GciComponent * comp)
{
  if (comp == NULL) {
    fprintf(stderr, "GciGetComponentName: NULL component received!\n");
    return NULL;
  }
  return comp->Name;
}

/*-------------------------------------------------------------------------
 * Name:    GciGetComponentDescriptor
 * Creator: ITEX C-Code Generator
 *
 * Description:
 *  This function returns the descriptor of the given component.
 *
 */

int GciGetComponentDescriptor(GciComponent * comp)
{
  if (comp == NULL) {
    fprintf(stderr, "GciGetComponentdescriptor: NULL component received!\n");
    return 0;
  }
  return comp->Id;
}

/*-------------------------------------------------------------------------
 * Name:    GciGetComponentType
 * Creator: ITEX C-Code Generator
 *
 * Description:
 *  This function returns the type of the given component.
 *
 */

int GciGetComponentType(GciComponent * comp)
{
  int i;
  
  if (comp == NULL) {
    fprintf(stderr, "GciGetComponentDescriptor: NULL component received!\n");
    return 0;
  }
  
  for (i = 0; i < IcSymTabLen; ++i)
    if (!strcmp(comp->Name, IcSymTab[i].Name))
      return IcSymTab[i].Type == GcMTCD ? GciMTC : GciPTC;
  
  return -1;
}

/*-------------------------------------------------------------------------
 * Name:    GciGetComponentCPs
 * Creator: ITEX C-Code Generator
 *
 * Description:
 *  This function returns the CPs used by the given component.
 *
 */

char ** GciGetComponentCPs(GciComponent * comp)
{
  if (comp == NULL) {
    fprintf(stderr, "GciGetComponentCPs: NULL component received!\n");
    return NULL;
  }
  return comp->UsedCPs;
}

/*-------------------------------------------------------------------------
 * Name:    GciGetComponentPCOs
 * Creator: ITEX C-Code Generator
 *
 * Description:
 *  This function returns the PCOs used by the given component.
 *
 */

char ** GciGetComponentPCOs(GciComponent * comp)
{
  if (comp == NULL) {
    fprintf(stderr, "GciGetComponentPCOs: NULL component received!\n");
    return NULL;
  }
  return comp->UsedPCOs;
}

/*-------------------------------------------------------------------------
 * Name:    Gci
 * Creator: ITEX C-Code Generator
 *
 * Description:
 */

unsigned GciGetMemberCount(int type)
{
  return VcGetMemberCount(type);
}

/*-------------------------------------------------------------------------
 * Name:    Gci
 * Creator: ITEX C-Code Generator
 *
 * Description:
 */

int GciGetMemberType(int type, unsigned index)
{
  return VcGetMemberType(type, index);
}

/*-------------------------------------------------------------------------
 * Name:    Gci
 * Creator: ITEX C-Code Generator
 *
 * Description:
 */

const char *GciGetMemberName(int type, unsigned index)
{
  return VcGetMemberName(type, index);
}

/* End of File */
