// **********************************************************************
//
// Copyright (c) 1999
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <Hello_impl.h>
#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

CORBA::ORB_ptr  orb;

short returnValue()
{
  short tau;
  tau = 4;
  return(tau);
}


void
Hello_impl::say_hello()
  throw(CORBA::SystemException)
{
  cout << "Hello World!" << endl;
}

void
Hello_impl::lookForValue() 
  throw(Hello::NoValid, CORBA::SystemException)
{
  if(returnValue() < 5)
    throw Hello::NoValid();
}

double
Hello_impl::returnDouble()
  throw(CORBA::SystemException)
{
  double numb;
  numb = 2.2 + 2;
  return numb;
}


long
Hello_impl::returnLong()
  throw(CORBA::SystemException)
{
  long numb;
  numb = 2 + 2;
  return numb;
}

unsigned long
Hello_impl::returnUlong()
  throw(CORBA::SystemException)
{
  unsigned long numb;
  numb = 2 + 2;
  return numb;
}

float
Hello_impl::returnFloat()
  throw(CORBA::SystemException)
{
  float numb;
  numb = 2 + 2;
  return numb;
}

long long 
Hello_impl::returnLonglong()
  throw(CORBA::SystemException)
{
  long long numb;
  numb = 2 + 2;
  return numb;
}



unsigned long long 
Hello_impl::returnUlonglong()
  throw(CORBA::SystemException)
{
  unsigned long long numb;
  numb = 2 + 2;
  return numb;
}

char
Hello_impl::returnChar()
  throw(CORBA::SystemException)
{
  char numb;
  numb = 'D';
  return numb;
}

bool
Hello_impl::returnBoolean()
  throw(CORBA::SystemException)
{
  bool numb;
  numb = TRUE;
  return numb;
}

shortType
Hello_impl::returnShort()
  throw(CORBA::SystemException)
{
 short numb;
 numb = 2 + 2;
 return numb;
}

unsigned short
Hello_impl::returnUshort()
  throw(CORBA::SystemException)
{
  unsigned short numb;
  numb = 2 + 2;
  return numb;
}

unsigned char 
Hello_impl::returnOctet()
  throw(CORBA::SystemException)
{
  unsigned char numb;
  numb = '2';
  return numb;
}

zahl 
Hello_impl::returnStruct()
  throw(CORBA::SystemException)
{
  zahl    num;
  num.day     = 4;
  num.hour    = 6;
  return     num;
}

size 
Hello_impl::returnEnum()
  throw(CORBA::SystemException)
{
  return     SMALL;
}

char * 
Hello_impl::returnString()
  throw(CORBA::SystemException)
{
  return CORBA::string_dup("HelloWorld");
}

wchar_t *
Hello_impl::returnWstring()
  throw(CORBA::SystemException)
{
  return  CORBA::wstring_dup(L"HelloWorld");
}

Hello::longSeq *
Hello_impl::returnSequence()
  throw(CORBA::SystemException)
{
  
  Hello::longSeq_var  v = new Hello::longSeq(10);
  v -> length(10);
  for(CORBA::ULong i = 0 ; i < 10 ; i++)
    v[i] = i;
  return v._retn();
}

Hello::U  *
Hello_impl::returnUnion()
  throw(CORBA::SystemException)
{
  Hello::U * my_u = new Hello::U();
  my_u ->long_mem(99);
  return my_u;
}

Hello::LongArray_slice  *
Hello_impl::returnArray()
  throw(CORBA::SystemException)
{

  Hello::LongArray_var la = Hello::LongArray_alloc();
  for (CORBA::ULong i = 1; i < 4 ; i++)
    {
      la[i] = i;
    } 
  return la;
}
          
CORBA::Any*
Hello_impl::returnTKWstring()
    throw(CORBA::SystemException)
{
  
  CORBA::Any aAny;
  wchar_t  * hi;
  hi = CORBA::wstring_dup(L"HelloWorld");
  aAny <<= hi;
  return new CORBA::Any(aAny); 

}

CORBA::Any*
Hello_impl::returnTKStruct()
    throw(CORBA::SystemException)
{
  
  CORBA::Any aAny;
  zahl   num;
  num.day     = 4;
  num.hour    = 6;
  aAny <<= num;
  return new CORBA::Any(aAny); 

}

CORBA::Any*
Hello_impl::returnTKUnion()
    throw(CORBA::SystemException)
{
  
  CORBA::Any aAny;
  Hello::U * my_u = new Hello::U();
  my_u ->long_mem(99);
  aAny <<= my_u;
  return new CORBA::Any(aAny); 

}

CORBA::Any*
Hello_impl::returnTKEnum()
    throw(CORBA::SystemException)
{
  
  CORBA::Any aAny;
  aAny <<= SMALL;
  return new CORBA::Any(aAny); 

}

CORBA::Any*
Hello_impl::returnTKSequence()
    throw(CORBA::SystemException)
{
  
  CORBA::Any aAny;
  Hello::longSeq_var  v = new Hello::longSeq(10);
  v -> length(10);
  for(CORBA::ULong i = 0 ; i < 10 ; i++)
    v[i] = i;
  aAny <<=  v._retn();
  return new CORBA::Any(aAny); 

}

CORBA::Any*
Hello_impl::returnTKArray()
    throw(CORBA::SystemException)
{
  
  CORBA::Any aAny;
  Hello::LongArray_var la = Hello::LongArray_alloc();
  for (CORBA::ULong i = 1; i < 4 ; i++)
    {
      la[i] = i;
    } 
  aAny <<=  la;
  return new CORBA::Any(aAny); 

}



