/******************************************************************** 
 * Copyright (c) 2000                                               *
 * GMD FOKUS                                                        *
 * Kaiserin-Augusta-Allee 31                                        *
 * 10589 Berlin                                                     *
 * Germany                                                          *
 * Tel: +49-30-3463-7000                                            *
 * Fax: +49-30-3463-8000                                            *
 *                                                                  *        
 * All rights reserved. No part of this source code may be          *
 * reproduced, stored in a retrieval system, or transmitted,        *
 * in any form or by any means, electronic, mechanical,             *
 * photocopying, recording or otherwise,                            *
 * except as stated in the end-user licence agreement,              * 
 * without the prior permission of the copyright owners.            *
 *                                                                  *
 * Project: CORVAL2                                                 *
 *                                                                  *
 * Contact:                                                         *
 * Mang Li                                                          *
 * e-mail: m.li@fokus.gmd.de                                        *
 *                                                                  *
 * Date: Oct. 2000                                                  *
 ********************************************************************/

 /*********************************************************************
 *                                                                    *
 *    Name:   adPCO.h                                                 *
 *                                                                    *
 *    Author: Mang Li                                                 *
 *            GMD Fokus, TIP                                          *
 *                                                                    *
 *    Description: This file contains the declaration of              *
 *        the class AdPCOList to support the local management of      *
 *        PCOs and CPs.                                               *
 *                                                                    *
 *********************************************************************/


#define ISTRUE 0
#define ISFALSE 1

struct AdPCOStruct
{
  int pcoID;
  char* pcoName;
  AdPCOStruct* next;
};


class AdPCOList
{
private:

  AdPCOStruct* theList_;

  // Get the appropriate descriptor of the PCO name
  int nameToId(const char* pconame);
  
public:
  AdPCOList();
  ~AdPCOList();

  // Reset the PCO list
  void resetPCOs();

  // Add a PCO by ID
  void addPCObyID(int pcod);

  // Add a PCO by name
  void addPCObyName(const char* pconame);

  // Get the PCO ID
  int getPCOId(const char* pconame);

  // Check whether the PCO is already included in the list
  int pcoIsReady(const char* pconame, int pcod);
  
};
