/******************************************************************** 
 * Copyright (c) 2000                                               *
 * GMD FOKUS                                                        *
 * Kaiserin-Augusta-Allee 31                                        *
 * 10589 Berlin                                                     *
 * Germany                                                          *
 * Tel: +49-30-3463-7000                                            *
 * Fax: +49-30-3463-8000                                            *
 *                                                                  *        
 * All rights reserved. No part of this source code may be          *
 * reproduced, stored in a retrieval system, or transmitted,        *
 * in any form or by any means, electronic, mechanical,             *
 * photocopying, recording or otherwise,                            *
 * except as stated in the end-user licence agreement,              * 
 * without the prior permission of the copyright owners.            *
 *                                                                  *
 * Project: CORVAL2                                                 *
 *                                                                  *
 * Contact:                                                         *
 * Mang Li                                                          *
 * e-mail: m.li@fokus.gmd.de                                        *
 *                                                                  *
 * Date: Oct. 2000                                                  *
 ********************************************************************/


 /*********************************************************************
 *                                                                    *
 *    Name:   adTiemr.h                                               *
 *                                                                    *
 *    Author: Mang Li                                                 *
 *            GMD Fokus, TIP                                          *
 *                                                                    *
 *    Description: This file contains the declaration of              *
 *        the class AdTiemrList to support the local management of    *
 *        timers.                                                     *
 *                                                                    *
 *********************************************************************/


#define ISTRUE 0
#define ISFALSE 1
#define STOPPED 0
#define RUNNING 1

struct AdTimerStruct
{
  int timerID;
  int unit;
  long duration;
  struct timeval startTime;
  int status;
  AdTimerStruct* next;
};


class AdTimerList
{
private:

  AdTimerStruct* theList_;
  
public:
  AdTimerList();
  ~AdTimerList();

  // Reset the Timer list
  void resetTimers();

  // Add a Timer by ID
  GciStatus addTimerbyID(int tid, long timerval, int unit);

  // Stop a timer
  GciStatus stopTimer(int tid);
  
  // Get the actual value of a timer
  long readTimer(int tid);
  
  // Check timeout of timers and return the descriptor
  // of the first timer found
  int timeout();
    
};
