/******************************************************************** 
 * Copyright (c) 2000                                               *
 * GMD FOKUS                                                        *
 * Kaiserin-Augusta-Allee 31                                        *
 * 10589 Berlin                                                     *
 * Germany                                                          *
 * Tel: +49-30-3463-7000                                            *
 * Fax: +49-30-3463-8000                                            *
 *                                                                  *        
 * All rights reserved. No part of this source code may be          *
 * reproduced, stored in a retrieval system, or transmitted,        *
 * in any form or by any means, electronic, mechanical,             *
 * photocopying, recording or otherwise,                            *
 * except as stated in the end-user licence agreement,              * 
 * without the prior permission of the copyright owners.            *
 *                                                                  *
 * Project: CORVAL2                                                 *
 *                                                                  *
 * Contact:                                                         *
 * Mang Li                                                          *
 * e-mail: m.li@fokus.gmd.de                                        *
 *                                                                  *
 * Date: Oct. 2000                                                  *
 ********************************************************************/

/*********************************************************************
 *                                                                    *
 *    Name:  GatewayMain_impl.h                                       *
 *                                                                    *
 *    Author: Mang Li                                                 *
 *            GMD Fokus, TIP                                          *
 *                                                                    *
 *    Description: This header file contains the declaration of the   *
 *        class TOR_GatewayMain_impl.                               *
 *                                                                    *
 *********************************************************************/

#include "Gateway_skel.h"

//For registration of value factories
#include "obv_test.h"

class TOR_GatewayMain_impl : public POA_TOR::GatewayMain
{

public:

  TOR_GatewayMain_impl(const CORBA::ORB_ptr, PortableServer::POA_ptr, const PortableServer::POAManager_ptr, OBVTest::TestValueSaver_ptr);
  ~TOR_GatewayMain_impl();

private:

  CORBA::String_var componentID_;
  
  CORBA::ORB_var orb_;
  PortableServer::POA_var poa_;
  PortableServer::POAManager_var poamgr_;
  
  // The PCO/CP list
  TOR::GWConnections_var PCOList_;

  // The CM queue
  TOR::GWMsgQueue_var cmQueue_;

  // For value factory registration
  OBVTest::TestValueSaver_var saver_;
  
public:

  // Support for concurrent TTCN
  // Operation used by GatewayMain objects to exchange CMs
  virtual void here_is_a_CM(const TOR::GWMessage& msg)
    throw(CORBA::SystemException);

public:
  
  // Operations public to TTCN-based test systems

  // Initialization.
  virtual TOR::GWStatus GWInit()
    throw(CORBA::SystemException);

  // Destroy the current instance
  virtual void GWDestroy()
    throw(CORBA::SystemException);

  // Pre-configuration for the associated test component.
  virtual TOR::GWStatus GWConfigure(CORBA::Boolean concurrent,
                                   const TOR::GWComponentConfig& config)
    throw(CORBA::SystemException);

  // Add an individual connection for the associated test component.
  virtual TOR::GWStatus GWAddConnection(const TOR::GWConnInfo& connInfo)
    throw(CORBA::SystemException);

  // Dispatch a message to the SUT or another test component
  virtual TOR::GWStatus GWSend(const char* pcoID,
                              const TOR::GWMessage& msg)
    throw(CORBA::SystemException);

  // Poll for an incoming message from the SUT or another test component
  virtual TOR::GWMsgFlag GWReceive(CORBA::String_out pcoID,
                                  TOR::GWMessage_out msg)
    throw(CORBA::SystemException);
   
};


  
