/******************************************************************** 
 * Copyright (c) 2000                                               *
 * GMD FOKUS                                                        *
 * Kaiserin-Augusta-Allee 31                                        *
 * 10589 Berlin                                                     *
 * Germany                                                          *
 * Tel: +49-30-3463-7000                                            *
 * Fax: +49-30-3463-8000                                            *
 *                                                                  *        
 * All rights reserved. No part of this source code may be          *
 * reproduced, stored in a retrieval system, or transmitted,        *
 * in any form or by any means, electronic, mechanical,             *
 * photocopying, recording or otherwise,                            *
 * except as stated in the end-user licence agreement,              * 
 * without the prior permission of the copyright owners.            *
 *                                                                  *
 * Project: CORVAL2                                                 *
 *                                                                  *
 * Contact:                                                         *
 * Mang Li                                                          *
 * e-mail: m.li@fokus.gmd.de                                        *
 *                                                                  *
 * Date: Oct. 2000                                                  *
 ********************************************************************/

/* obv_test_impl.h */

#include "obv_test_skel.h"

class TestInterfaceA_impl;
class TestInterfaceB_impl;
class TestInterfaceC_impl;
class TestInterfaceD_impl;
class TestValueA_impl;
class TestValueAFactory_impl;
class TestValueB_impl;
class TestValueBFactory_impl;
class TestValueC_impl;
class TestValueCFactory_impl;
class TestValueD_impl;
class TestValueDFactory_impl;

class TestValueSaver_impl;
class TestHelper_impl;

//
// TestInterfaceA_impl
//

class TestInterfaceA_impl : public virtual POA_OBVTest::TestInterfaceA
{
public:
  TestInterfaceA_impl(OBVTest::TestValueSaver_ptr);
  ~TestInterfaceA_impl();

private:
  // For value factory registration
  OBVTest::TestValueSaver_var saver_;
  
public:

  virtual OBVTest::Res val_sub_intf(OBVTest::TestInterfaceB_ptr ifb)
    throw(CORBA::SystemException);

  virtual OBVTest::Res val_sub_val(OBVTest::TestValueD* vla)
    throw(CORBA::SystemException);

  virtual OBVTest::Res sub_abstr_intf(OBVTest::TestAbstrInterfaceA_ptr abif)
    throw(CORBA::SystemException);

  virtual OBVTest::TestValueSaver_ptr get_value_saver()
    throw(CORBA::SystemException);
  
};

//
// TestInterfaceB_impl
//

class TestInterfaceB_impl : public virtual POA_OBVTest::TestInterfaceB
{
public:

  virtual void pong();

};

//
// TestInterfaceC_impl
//

class TestInterfaceC_impl : public virtual POA_OBVTest::TestInterfaceC

{
public:
  TestInterfaceC_impl(CORBA::ORB_ptr, OBVTest::TestValueSaver_ptr);
  ~TestInterfaceC_impl();

private:
  CORBA::ORB_var orb_;
  OBVTest::TestValueSaver_var saver_;
  
public:

  virtual OBVTest::Res hello(CORBA::String_out) throw(CORBA::SystemException);
  
  virtual OBVTest::Res in_shortbox(OBVTest::TestShortBox* b,
                                   CORBA::Short_out value) 
    throw(CORBA::SystemException);
  
  virtual OBVTest::Res out_shortbox(CORBA::Short value,
                                    OBVTest::TestShortBox_out b)
    throw(CORBA::SystemException);
  
  virtual OBVTest::Res in_ushortbox(OBVTest::TestUShortBox* b,
                                    CORBA::UShort_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_ushortbox(CORBA::UShort value,
                                     OBVTest::TestUShortBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_longbox(OBVTest::TestLongBox* b,
                                    CORBA::Long_out value)
    throw(CORBA::SystemException);
  
  virtual OBVTest::Res out_longbox(CORBA::Long value,
                                     OBVTest::TestLongBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_ulongbox(OBVTest::TestULongBox* b,
                                     CORBA::ULong_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_ulongbox(CORBA::ULong value,
                                      OBVTest::TestULongBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_llongbox(OBVTest::TestLLongBox* b,
                                     CORBA::LongLong_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_llongbox(CORBA::LongLong value,
                                      OBVTest::TestLLongBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_ullongbox(OBVTest::TestULLongBox* b,
                                      CORBA::ULongLong_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_ullongbox(CORBA::ULongLong value,
                                       OBVTest::TestULLongBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_booleanbox(OBVTest::TestBooleanBox* b,
                                       CORBA::Boolean_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_booleanbox(CORBA::Boolean value,
                                        OBVTest::TestBooleanBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_octetbox(OBVTest::TestOctetBox* b,
                                     CORBA::Octet_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_octetbox(CORBA::Octet value,
                                      OBVTest::TestOctetBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_charbox(OBVTest::TestCharBox* b,
                                    CORBA::Char_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_charbox(CORBA::Char value,
                                     OBVTest::TestCharBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_wcharbox(OBVTest::TestWCharBox* b,
                                     CORBA::WChar_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_wcharbox(CORBA::WChar value,
                                      OBVTest::TestWCharBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_floatbox(OBVTest::TestFloatBox* b,
                                     CORBA::Float_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_floatbox(CORBA::Float value,
                                      OBVTest::TestFloatBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_doublebox(OBVTest::TestDoubleBox* b,
                                      CORBA::Double_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_doublebox(CORBA::Double value,
                                       OBVTest::TestDoubleBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_stringbox(OBVTest::TestStringBox* b,
                                      CORBA::String_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_stringbox(const char* value,
                                       OBVTest::TestStringBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_enumbox(OBVTest::TestEnumBox* b,
                                    OBVTest::TestEnum_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_enumbox(OBVTest::TestEnum value,
                                     OBVTest::TestEnumBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_arraybox(OBVTest::TestArrayBox* b,
                                     OBVTest::TestArray_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_arraybox(const OBVTest::TestArray value,
                                      OBVTest::TestArrayBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_fstructbox(OBVTest::TestFixStructBox* b,
                                       OBVTest::TestFixStruct_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_fstructbox(const OBVTest::TestFixStruct& value,
                                        OBVTest::TestFixStructBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_vstructbox(OBVTest::TestVarStructBox* b,
                                       OBVTest::TestVarStruct_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_vstructbox(const OBVTest::TestVarStruct& value,
                                        OBVTest::TestVarStructBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_funionbox(OBVTest::TestFixUnionBox* b,
                                      OBVTest::TestFixUnion_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_funionbox(const OBVTest::TestFixUnion& value,
                                       OBVTest::TestFixUnionBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_vunionbox(OBVTest::TestVarUnionBox* b,
                                      OBVTest::TestVarUnion_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_vunionbox(const OBVTest::TestVarUnion& value,
                                       OBVTest::TestVarUnionBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_shseqbox(OBVTest::TestShSeqBox* b,
                                     OBVTest::TestShSeq_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_shseqbox(const OBVTest::TestShSeq& value,
                                      OBVTest::TestShSeqBox_out b)
    throw(CORBA::SystemException);

  virtual OBVTest::Res in_strseqbox(OBVTest::TestStrSeqBox* b,
                                      OBVTest::TestStrSeq_out value)
    throw(CORBA::SystemException);

  virtual OBVTest::Res out_strseqbox(const OBVTest::TestStrSeq& value,
                                       OBVTest::TestStrSeqBox_out b)
    throw(CORBA::SystemException);
  
  virtual OBVTest::Res in_anybox(OBVTest::TestAnyBox* b,
                                   CORBA::Any_out value)
    throw(CORBA::SystemException);
  
  virtual OBVTest::Res out_anybox(const CORBA::Any& value,
                                    OBVTest::TestAnyBox_out b)
    throw(CORBA::SystemException);
  
  virtual OBVTest::Res val_in_struct(OBVTest::TestValueA* v,CORBA::Long n,
                                       OBVTest::TestValMbStruct_out s)
    throw(CORBA::SystemException);
  
  virtual OBVTest::Res val_out_struct(const OBVTest::TestValMbStruct& s,
                                        OBVTest::TestValueA_out v)
    throw(CORBA::SystemException);
  
  virtual OBVTest::TestValueSaver_ptr get_value_saver()
    throw(CORBA::SystemException);
  
};


//
// TestInterfaceD_impl
//

class TestInterfaceD_impl : public virtual POA_OBVTest::TestInterfaceD
{
private:
  const char* myname_;

public:
  TestInterfaceD_impl(const char*);
  ~TestInterfaceD_impl();
  
  virtual void describe_it(CORBA::String_out id);  
};


//
// TestValueA_impl
//

class TestValueA_impl: public virtual OBV_OBVTest::TestValueA,
                       public virtual CORBA::DefaultValueRefCountBase
{
private:
  const char* myname_;
  
protected:
  TestValueA_impl();
  TestValueA_impl(const char*);
  ~TestValueA_impl();

  friend class TestValueAFactory_impl;
  
public:
  virtual CORBA::ValueBase * _copy_value(){ }
  virtual void print();
  virtual OBVTest::TestValueA* change(OBVTest::TestValueA* inval,
                             OBVTest::TestValueA*& ioval,
                             OBVTest::TestValueA_out outval);
};

//
//TestValueAFactory_impl
//

class TestValueAFactory_impl : public virtual OBVTest::TestValueA_init
{
  virtual CORBA::ValueBase* create_for_unmarshal();
public:
  virtual OBVTest::TestValueA* create(const char* name);
};


//
// TestValueB_impl
//

class TestValueB_impl: public virtual OBV_OBVTest::TestValueB,
                       public virtual CORBA::DefaultValueRefCountBase
{
private:
  const char* myname_;
  
protected:
  TestValueB_impl();
  TestValueB_impl(const char*);
  ~TestValueB_impl();

  friend class TestValueBFactory_impl;
  
public:
  virtual void describe_it(CORBA::String_out id);
  virtual CORBA::ValueBase * _copy_value(){ }
};

//
//TestValueBFactory_impl
//

class TestValueBFactory_impl : public virtual OBVTest::TestValueB_init
{
  virtual CORBA::ValueBase* create_for_unmarshal();
public:
  virtual OBVTest::TestValueB* create(const char* name);
};

//
// TestValueC_impl
//

class TestValueC_impl : public virtual POA_OBVTest::TestValueC,
                        public virtual OBV_OBVTest::TestValueC,
                        public virtual PortableServer::ValueRefCountBase

{
private:
  const char* myname_;
  
protected:
  TestValueC_impl();
  TestValueC_impl(const char*);
  ~TestValueC_impl();

  friend class TestValueCFactory_impl;
  
public:  
  virtual void ping();
  virtual CORBA::ValueBase * _copy_value(){ }
  virtual void pong();
};


//
//TestValueCFactory_impl
//

class TestValueCFactory_impl : public virtual OBVTest::TestValueC_init
{
  virtual CORBA::ValueBase* create_for_unmarshal();
public:
  virtual OBVTest::TestValueC* create(const char* name);
};

//
// TestValueD_impl
//

class TestValueD_impl: public virtual OBV_OBVTest::TestValueD,
                       public virtual CORBA::DefaultValueRefCountBase
{
private:
  CORBA::Long myid_;
  
protected:
  TestValueD_impl();
  TestValueD_impl(CORBA::Long);
  ~TestValueD_impl();

  friend class TestValueDFactory_impl;
  
public:
  virtual CORBA::ValueBase * _copy_value(){ }
  virtual void id(CORBA::Long d);
  virtual CORBA::Long id();
  virtual void print();
  virtual OBVTest::TestValueA* change(OBVTest::TestValueA* inval,
                             OBVTest::TestValueA*& ioval,
                             OBVTest::TestValueA_out outval);
};

//
//TestValueDFactory_impl
//

class TestValueDFactory_impl : public virtual OBVTest::TestValueD_init
{
  virtual CORBA::ValueBase* create_for_unmarshal();
public:
  virtual OBVTest::TestValueD* create(CORBA::Long id);
};


//
//TestValueSaver_impl
//

class TestValueSaver_impl : public virtual POA_OBVTest::TestValueSaver
{
private:
  CORBA::ORB_var orb_;
  CORBA::Repository_var repository_;
public:
  TestValueSaver_impl(CORBA::ORB_ptr orb);
  ~TestValueSaver_impl();

  virtual void register_all_factories()
    throw(CORBA::SystemException);

  virtual void register_this_factory(const char* id)
    throw(CORBA::SystemException);

  virtual void unregister_this_factory(const char* id)
    throw(CORBA::SystemException);
};

class TestHelper_impl : public virtual POA_OBVTest::TestHelper
{
 private:
  CORBA::ORB_var orb_;
  OBVTest::TestValueSaver_var saver_;
 public:
  TestHelper_impl(CORBA::ORB_ptr orb, OBVTest::TestValueSaver_ptr);
  virtual void make_call(const char* ifid, const char* opid, 
			 OBVTest::Res_out rst)
    throw(CORBA::SystemException);
  virtual OBVTest::TestValueSaver_ptr get_value_saver()
    throw(CORBA::SystemException);
};
