//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#define TRUE 1 
#define FALSE 0

typedef void Status;
typedef unsigned long Flags;

static const Flags ARG_IN;
static const Flags ARG_OUT;
static const Flags ARG_INOUT;
static const Flags OUT_LIST_MEMORY;
static const Flags IN_COPY_VALUE;
static const Flags INV_NO_RESPONSE;
static const Flags INV_TERM_ON_ERR;
static const Flags RESP_NO_WAIT;
static const Flags DEPENDENT_LIST;
static const Flags CTX_RESTRICT_SCOPE;
static const Flags CTX_DELETE_DESCENDENTS;

typedef char *Identifier;
typedef char *RepositoryId;

typedef char Char;
typedef unsigned char Octet;
typedef unsigned char Boolean;
typedef short Short;
typedef unsigned short UShort;
typedef long Long;
typedef unsigned long ULong;
typedef float Float;
typedef double Double;
#ifndef WIN32
typedef long long LongLong;
typedef unsigned long long ULongLong;
#else
typedef __int64 LongLong;
typedef unsigned __int64 ULongLong;
#endif

typedef long double LongDouble;
typedef wchar_t WChar;


// Useful forward declarations
class TypeCode;
typedef TypeCode * TypeCode_ptr;

class Object;
typedef Object * Object_ptr;

class Environment;
typedef Environment * Environment_ptr;

class NamedValue;
typedef NamedValue * NamedValue_ptr;

class NVList;
typedef NVList * NVList_ptr;

class Context;
typedef Context * Context_ptr;

class ContextList;
typedef ContextList * ContextList_ptr;

class Request;
typedef Request * Request_ptr;

class ExceptionList;
typedef ExceptionList * ExceptionList_ptr;

//class ImplementationDef;
typedef int ImplementationDef;
typedef ImplementationDef * ImplementationDef_ptr;

class InterfaceDef;
typedef InterfaceDef * InterfaceDef_ptr;

class OperationDef;
typedef OperationDef * OperationDef_ptr;

class ORB;
typedef ORB * ORB_ptr;

class ServerRequest;
typedef ServerRequest * ServerRequest_ptr;


class String_var
{ 

public:
    String_var();
    String_var( char *p);
    String_var( const char *p);
    String_var( const String_var &s);
    ~String_var();

    String_var &operator=( char *p);
    String_var &operator=( const char *p);
    String_var &operator=( const String_var &s);
    operator char*();
    operator const char*() const;
    char &operator[]( ULong index);
    char operator[]( ULong index) const;
};

static char *string_alloc(ULong len);
static char *string_dup(const char *);
static void string_free(char *);

