//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/c++/inc/Context.hh
//
// Modifications:
// $Log: Context.hh,v $
// Revision 1.1.1.1  2000/02/09 17:07:08  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.1.1.1  1997/07/21 12:26:50  stephen
// Initial vsOrb code base
//
//

class Context
{

public:
    const char *context_name(VSORB_ENV2) const;
    Context_ptr parent(VSORB_ENV2) const;

    Status create_child( const char*, Context_ptr& VSORB_ENV);

    Status set_one_value( const char*, const Any& VSORB_ENV);
    Status set_values( NVList_ptr VSORB_ENV);
    Status delete_values( const char* VSORB_ENV);
    Status get_values( const char*, Flags, const char*, NVList_ptr& VSORB_ENV);
    
    static Context_ptr _duplicate(VSORB_ENV2);
    static Context_ptr _nil(VSORB_ENV2);
};

typedef T_var<Context> Context_var;
 

