//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

class ORB
{

public:

    class RequestSeq { // unbounded sequence
	public:
	RequestSeq();
	RequestSeq(ULong max);
	RequestSeq(ULong max, ULong length, Request_ptr *data,
		   Boolean release=FALSE);
	RequestSeq(const RequestSeq&);
	~RequestSeq( );

	RequestSeq &operator=(const RequestSeq&);
	ULong maximum( VSORB_ENV2 ) const;
	void length(ULong VSORB_ENV);
	ULong length( VSORB_ENV2 ) const;
	Request_ptr &operator[](ULong index);
	const Request_ptr &operator[](ULong index) const;

	static Request_ptr *allocbuf(ULong nelems VSORB_ENV);	
	static void freebuf(Request_ptr * VSORB_ENV);
    };

    char *object_to_string( Object_ptr VSORB_ENV);
    Object_ptr string_to_object( const char* VSORB_ENV);

    Status create_list( Long, NVList_ptr& VSORB_ENV);
    Status create_operation_list( OperationDef_ptr, NVList_ptr& VSORB_ENV);
    Status create_named_value( NamedValue_ptr& VSORB_ENV);
    Status create_exception_list( ExceptionList_ptr& VSORB_ENV);
    Status create_context_list( ContextList_ptr& VSORB_ENV);

    Status get_default_context( Context_ptr& VSORB_ENV);
    Status create_environment(Environment_ptr& VSORB_ENV );

    Status send_multiple_requests_oneway( const RequestSeq& VSORB_ENV);
    Status send_multiple_requests_deferred( const RequestSeq& VSORB_ENV);
    Boolean poll_next_response( VSORB_ENV2 );
    Status get_next_response( Request_ptr& VSORB_ENV);

    // OA initialization
    typedef char * OAid;

    // Template C++ binding for OA init op
    // <OA>_ptr <OA>_init( int * argc, char ** argv, OAid oa_identifier);

    // Obtaining initial object references
    typedef char* ObjectId;
    class ObjectIdList { // unbounded sequence
	public:
	ObjectIdList( );
	ObjectIdList(ULong max);
	ObjectIdList(ULong max, ULong length, char **data,
		     Boolean release = FALSE);
	ObjectIdList(const ObjectIdList &);
	~ObjectIdList( );

	ObjectIdList &operator=(const ObjectIdList&);
	ULong maximum( VSORB_ENV2 ) const;
	void length(ULong VSORB_ENV);
	ULong length( VSORB_ENV2 ) const;
	const ObjectId &operator[](ULong index) const;
	ObjectId &operator[](ULong index);

	static char **allocbuf(ULong nelems VSORB_ENV);
	static void freebuf(char ** VSORB_ENV);
    };

    TypeCode_ptr create_struct_tc (RepositoryId id, 
				   Identifier name, 
				   StructMemberSeq& members  VSORB_ENV);

    TypeCode_ptr create_union_tc (RepositoryId id, 
				  Identifier name, 
				  TypeCode_ptr discriminator_type, 
				  UnionMemberSeq& members  VSORB_ENV);

    TypeCode_ptr create_enum_tc (RepositoryId id, 
				 Identifier name, 
				 EnumMemberSeq& members  VSORB_ENV);

    TypeCode_ptr create_alias_tc (RepositoryId id, 
				  Identifier name, 
				  TypeCode_ptr original_type  VSORB_ENV);

    TypeCode_ptr create_exception_tc (RepositoryId id, 
				      Identifier name, 
				      StructMemberSeq& members  VSORB_ENV);

    TypeCode_ptr create_interface_tc (RepositoryId id, 
				      Identifier name  VSORB_ENV);

    TypeCode_ptr create_string_tc (ULong bound  VSORB_ENV);

    TypeCode_ptr create_sequence_tc (ULong bound, 
				     TypeCode_ptr element_type  VSORB_ENV);

    TypeCode_ptr create_recursive_sequence_tc (ULong bound, 
					       ULong offset  VSORB_ENV);

    TypeCode_ptr create_array_tc (ULong length, 
				  TypeCode_ptr element_type  VSORB_ENV);

    
    class InvalidName : public virtual UserException{ };

    ObjectIdList *list_initial_services( VSORB_ENV2 );
    Object_ptr resolve_initial_references( const char *identifier VSORB_ENV);

    static ORB_ptr _duplicate( VSORB_ENV2 );
    static ORB_ptr _nil( VSORB_ENV2 );
};

typedef char* ORBid;
static ORB_ptr ORB_init(int& argc,char** argv, const char* orb_identifier VSORB_ENV);


typedef T_var<ORB> ORB_var;
 

