//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/c++/inc/Request.hh
//
// Modifications:
// $Log: Request.hh,v $
// Revision 1.1.1.1  2000/02/09 17:07:09  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.1.1.1  1997/07/21 12:26:50  stephen
// Initial vsOrb code base
//
//

class Request
{

public:
    Object_ptr target ( VSORB_ENV2 ) const;
    char *operation ( VSORB_ENV2 ) const;
    NVList_ptr arguments ( VSORB_ENV2 );
    NamedValue_ptr result ( VSORB_ENV2 );
    Environment_ptr env ( VSORB_ENV2 );
    ExceptionList_ptr exceptions ( VSORB_ENV2 );
    ContextList_ptr contexts ( VSORB_ENV2 );
    
    void ctx( Context_ptr VSORB_ENV);
    Context_ptr ctx ( VSORB_ENV2 ) const;
    
    // argument manipulation helper functions
    Any &add_in_arg ( VSORB_ENV2 );
    Any &add_in_arg( const char* name VSORB_ENV);
    Any &add_inout_arg ( VSORB_ENV2 );
    Any &add_inout_arg( const char* name VSORB_ENV);
    Any &add_out_arg ( VSORB_ENV2 );
    Any &add_out_arg( const char* name VSORB_ENV);
    void set_return_type( TypeCode_ptr tc VSORB_ENV);
    Any &return_value ( VSORB_ENV2 );
    
    Status invoke ( VSORB_ENV2 );
    Status send_oneway ( VSORB_ENV2 );
    Status send_deferred ( VSORB_ENV2 );
    Status get_response ( VSORB_ENV2 );
    Boolean poll_response ( VSORB_ENV2 );
    
    static Request_ptr _duplicate ( VSORB_ENV2 );
    static Request_ptr _nil ( VSORB_ENV2 );
};

typedef T_var<Request> Request_var;
 

