//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/c++/inc/TypeCode.hh
//
// Modifications:
// $Log: TypeCode.hh,v $
// Revision 1.1.1.1  2000/02/09 17:07:09  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.2  1997/08/20 12:37:15  james
// _narrow method added to exceptions
//
//

enum TCKind {
    tk_null,      tk_void,  tk_short,
    tk_long,      tk_ushort,  tk_ulong,
    tk_float,     tk_double,  tk_boolean,
    tk_char,      tk_octet,   tk_any,
    tk_TypeCode,    tk_Principal,
    tk_objref,  tk_struct,      tk_union,
    tk_enum,    tk_string,      tk_sequence,
    tk_array, tk_alias, tk_except,
    tk_longlong, tk_longdouble, tk_wstring, tk_wchar
  };


class TypeCode
{

public:

		class Bounds : public virtual UserException { 
			public:
			static Bounds *_narrow(Exception *);
		};
		class BadKind : public virtual UserException { 
			public:
			static BadKind *_narrow(Exception *);
		};

    TCKind kind(VSORB_ENV2) const;
    Boolean equal( TypeCode_ptr VSORB_ENV) const;

    const char* id(VSORB_ENV2) const;
    const char* name(VSORB_ENV2) const;
    
    ULong member_count(VSORB_ENV2) const;
    const char* member_name( ULong index VSORB_ENV) const;
    
    TypeCode_ptr member_type( ULong index VSORB_ENV) const;
    
    Any *member_label( ULong index VSORB_ENV) const;
    TypeCode_ptr discriminator_type(VSORB_ENV2) const;
    Long default_index(VSORB_ENV2) const;
    ULong length(VSORB_ENV2) const;
    
    TypeCode_ptr content_type(VSORB_ENV2) const;
    
    Long param_count(VSORB_ENV2) const;
    Any *parameter( Long VSORB_ENV) const;
    
    static TypeCode_ptr _duplicate(VSORB_ENV2);
    static TypeCode_ptr _nil(VSORB_ENV2);
};


static const TypeCode_ptr _tc_null;
static const TypeCode_ptr _tc_void;
static const TypeCode_ptr _tc_short;
static const TypeCode_ptr _tc_long;
static const TypeCode_ptr _tc_ushort;
static const TypeCode_ptr _tc_ulong;
static const TypeCode_ptr _tc_float;
static const TypeCode_ptr _tc_double;
static const TypeCode_ptr _tc_boolean;
static const TypeCode_ptr _tc_char;
static const TypeCode_ptr _tc_octet;
static const TypeCode_ptr _tc_any;
static const TypeCode_ptr _tc_TypeCode;
static const TypeCode_ptr _tc_Principal;
static const TypeCode_ptr _tc_Object;
static const TypeCode_ptr _tc_string;
static const TypeCode_ptr _tc_CORBA_NamedValue;
static const TypeCode_ptr _tc_CORBA_InterfaceDescription;
static const TypeCode_ptr _tc_CORBA_OperationDescription;
static const TypeCode_ptr _tc_CORBA_AttributeDescription;
static const TypeCode_ptr _tc_CORBA_ParameterDescription;
static const TypeCode_ptr _tc_CORBA_ModuleDescription;
static const TypeCode_ptr _tc_CORBA_ConstantDescription;
static const TypeCode_ptr _tc_CORBA_ExceptionDescription;
static const TypeCode_ptr _tc_CORBA_TypeDescription;
static const TypeCode_ptr _tc_CORBA_InterfaceDef_FullInterfaceDescription;
static const TypeCode_ptr _tc_longlong;
static const TypeCode_ptr _tc_ulonglong;
static const TypeCode_ptr _tc_longdouble;
static const TypeCode_ptr _tc_wchar;
static const TypeCode_ptr _tc_wstring;


