//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#ifndef VSORB_REFERENCE_HEADER
#define VSORB_REFERENCE_HEADER

#if VSORB_NON_EH

#define VSORB_ENV , Environment &env
#define VSORB_SRC_ENV , CORBA::Environment &env

#define VSORB_ENV2  Environment &env
#define VSORB_SRC_ENV2  CORBA::Environment &env

#else

#define VSORB_ENV
#define VSORB_SRC_ENV

#define VSORB_ENV2
#define VSORB_SRC_ENV2

#endif

#include <stddef.h>

//
// Template'd var support
//

template <class T> class T_var
{
	T *t;

public:
    T_var(): t(0) { }
    T_var(T *a) : t(a) { }
    T_var(const T_var &a) : t(a.t) { }
    ~T_var(){ }
    T_var &operator=(T *a) { t = a; return *this; }
    T_var &operator=(const T_var &a) { t = a.t; return *this; }
    T *operator->() { return t; }
		operator T *() { return t; }
};

//
// release flag is hardcoded to zero. Really should
// use FALSE but we're at global scope so defining
// TRUE and FALSE here is a bad idea
//


class CORBA
{
public:
    
#include "Basic.hh"

#ifdef WIN32

template <class T> class T_sequence
{
	T *t;

public:
    T_sequence() : t(0) { }
    T_sequence(ULong) : t(0) { }
    T_sequence(ULong, T *,
	       Boolean) : t(0) { }
    T_sequence(const T_sequence &s) : t(s.t) { }
    ~T_sequence() { }

    T_sequence &operator=(const T_sequence&) { return *this; }
    ULong maximum() const { return 0; }
    void length(ULong) { }
    ULong length() const { return 0; }
    T &operator[](ULong) { static T t; return t; }
    const T &operator[](ULong) const { static T t; return t; }

    static T * allocbuf(ULong) { static T x; return &x; }
    static void freebuf(T *) { }
};

#endif

#ifndef WIN32

template <class T> class T_sequence
{
	T *t;

public:
    T_sequence() : t(0) { }
    T_sequence(CORBA::ULong) : t(0) { }
    T_sequence(CORBA::ULong, CORBA::ULong, T *,
	       CORBA::Boolean) : t(0) { }
    T_sequence(const T_sequence &) { }
    ~T_sequence() { }

    T_sequence &operator=(const T_sequence&) { return *this; }
    CORBA::ULong maximum() const { return 0; }
    void length(CORBA::ULong){ }
    CORBA::ULong length() const { return 0; }
    T &operator[](CORBA::ULong) { static T x; return x; }
    const T &operator[](CORBA::ULong) const { static T x; return x; }

    static T * allocbuf(CORBA::ULong) { static T x; return &x; }
    static void freebuf(T *) { }
};

#endif

#include "Any.hh"
#include "Exceptions.hh"
#include "Environment.hh"
#include "ExceptionList.hh"
#include "NamedValue.hh"
#include "NVList.hh"
#include "Context.hh"
#include "ContextList.hh"
#include "Request.hh"
#include "Principal.hh"
#include "Object.hh"
#include "TypeCode.hh"
#include "IR.hh"
#include "ORB.hh"
#include "DSI.hh"

};

#endif // VSORB_REFERENCE_HEADER
