//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/c++/lib/Exceptions.cpp
//
// Modifications:
// $Log: Exceptions.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:07:10  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.2  1997/08/20 12:36:49  james
// _narrow method added to exceptions
//
//

#include <vsorbref.hh>

CORBA::Exception::Exception (const Exception&) { };
CORBA::Exception::~Exception () { };
CORBA::Exception& 
CORBA::Exception::operator= (const Exception&) 
{ 
	static CORBA::Exception t;
	return t;
};
CORBA::Exception::Exception () { };

CORBA::UserException::UserException() { };
CORBA::UserException::UserException( const UserException &) { };
CORBA::UserException::~UserException() { };
CORBA::UserException &
CORBA::UserException::operator=( const UserException &) 
{ 
	static CORBA::UserException t;
	return t;
};
CORBA::UserException *
CORBA::UserException::_narrow(CORBA::Exception *) { return (CORBA::UserException *)0;};


CORBA::Any &
CORBA::UnknownUserException::exception() 
{
	static CORBA::Any t;
	return t;
};
CORBA::UnknownUserException *
CORBA::UnknownUserException::_narrow(CORBA::Exception *) { return (CORBA::UnknownUserException *)0;};


CORBA::SystemException::SystemException() { };
CORBA::SystemException::SystemException(const SystemException &) { };
CORBA::SystemException::SystemException(ULong , CompletionStatus )
{ };
CORBA::SystemException::~SystemException() { };

CORBA::SystemException&
CORBA::SystemException::operator=(const SystemException &) 
{ 
	static CORBA::SystemException t;
	return t;
};

CORBA::ULong 
CORBA::SystemException::minor() const
{
	return 0;
}

void 
CORBA::SystemException::minor(CORBA::ULong) { }
	

CORBA::CompletionStatus
CORBA::SystemException::completed() const 
{ 
	return COMPLETED_YES;
};

void 
CORBA::SystemException::completed(CORBA::CompletionStatus) { };
CORBA::SystemException *
CORBA::SystemException::_narrow(CORBA::Exception *) { return (CORBA::SystemException *)0;};

CORBA::UNKNOWN::UNKNOWN() { };
CORBA::UNKNOWN::UNKNOWN(const SystemException &) { };
CORBA::UNKNOWN::UNKNOWN(ULong , CompletionStatus ) { };
CORBA::UNKNOWN *
CORBA::UNKNOWN::_narrow(CORBA::Exception *) { return (CORBA::UNKNOWN *)0;};

CORBA::BAD_PARAM::BAD_PARAM() { };
CORBA::BAD_PARAM::BAD_PARAM(const SystemException &) { };
CORBA::BAD_PARAM::BAD_PARAM(ULong , CompletionStatus ) { };
CORBA::BAD_PARAM *
CORBA::BAD_PARAM::_narrow(CORBA::Exception *) { return (CORBA::BAD_PARAM *)0;};

CORBA::NO_MEMORY::NO_MEMORY() { };
CORBA::NO_MEMORY::NO_MEMORY(const SystemException &) { };
CORBA::NO_MEMORY::NO_MEMORY(ULong , CompletionStatus ) { };
CORBA::NO_MEMORY *
CORBA::NO_MEMORY::_narrow(CORBA::Exception *) { return (CORBA::NO_MEMORY *)0;};

CORBA::IMP_LIMIT::IMP_LIMIT() { };
CORBA::IMP_LIMIT::IMP_LIMIT(const SystemException &) { };
CORBA::IMP_LIMIT::IMP_LIMIT(ULong , CompletionStatus ) { };
CORBA::IMP_LIMIT *
CORBA::IMP_LIMIT::_narrow(CORBA::Exception *) { return (CORBA::IMP_LIMIT *)0;};

CORBA::COMM_FAILURE::COMM_FAILURE() { };
CORBA::COMM_FAILURE::COMM_FAILURE(const SystemException &) { };
CORBA::COMM_FAILURE::COMM_FAILURE(ULong , CompletionStatus ) { };
CORBA::COMM_FAILURE *
CORBA::COMM_FAILURE::_narrow(CORBA::Exception *) { return (CORBA::COMM_FAILURE *)0;};

CORBA::INV_OBJREF::INV_OBJREF() { };
CORBA::INV_OBJREF::INV_OBJREF(const SystemException &) { };
CORBA::INV_OBJREF::INV_OBJREF(ULong , CompletionStatus ) { };
CORBA::INV_OBJREF *
CORBA::INV_OBJREF::_narrow(CORBA::Exception *) { return (CORBA::INV_OBJREF *)0;};

CORBA::NO_PERMISSION::NO_PERMISSION() { };
CORBA::NO_PERMISSION::NO_PERMISSION(const SystemException &) { };
CORBA::NO_PERMISSION::NO_PERMISSION(ULong , CompletionStatus ) { };
CORBA::NO_PERMISSION *
CORBA::NO_PERMISSION::_narrow(CORBA::Exception *) { return (CORBA::NO_PERMISSION *)0;};

CORBA::INTERNAL::INTERNAL() { };
CORBA::INTERNAL::INTERNAL(const SystemException &) { };
CORBA::INTERNAL::INTERNAL(ULong , CompletionStatus ) { };
CORBA::INTERNAL *
CORBA::INTERNAL::_narrow(CORBA::Exception *) { return (CORBA::INTERNAL *)0;};

CORBA::MARSHAL::MARSHAL() { };
CORBA::MARSHAL::MARSHAL(const SystemException &) { };
CORBA::MARSHAL::MARSHAL(ULong , CompletionStatus ) { };
CORBA::MARSHAL *
CORBA::MARSHAL::_narrow(CORBA::Exception *) { return (CORBA::MARSHAL *)0;};

CORBA::INITIALIZE::INITIALIZE() { };
CORBA::INITIALIZE::INITIALIZE(const SystemException &) { };
CORBA::INITIALIZE::INITIALIZE(ULong , CompletionStatus ) { };
CORBA::INITIALIZE *
CORBA::INITIALIZE::_narrow(CORBA::Exception *) { return (CORBA::INITIALIZE *)0;};

CORBA::NO_IMPLEMENT::NO_IMPLEMENT() { };
CORBA::NO_IMPLEMENT::NO_IMPLEMENT(const SystemException &) { };
CORBA::NO_IMPLEMENT::NO_IMPLEMENT(ULong , CompletionStatus ) { };
CORBA::NO_IMPLEMENT *
CORBA::NO_IMPLEMENT::_narrow(CORBA::Exception *) { return (CORBA::NO_IMPLEMENT *)0;};

CORBA::BAD_TYPECODE::BAD_TYPECODE() { };
CORBA::BAD_TYPECODE::BAD_TYPECODE(const SystemException &) { };
CORBA::BAD_TYPECODE::BAD_TYPECODE(ULong , CompletionStatus ) { };
CORBA::BAD_TYPECODE *
CORBA::BAD_TYPECODE::_narrow(CORBA::Exception *) { return (CORBA::BAD_TYPECODE *)0;};

CORBA::BAD_OPERATION::BAD_OPERATION() { };
CORBA::BAD_OPERATION::BAD_OPERATION(const SystemException &) { };
CORBA::BAD_OPERATION::BAD_OPERATION(ULong , CompletionStatus ) { };
CORBA::BAD_OPERATION *
CORBA::BAD_OPERATION::_narrow(CORBA::Exception *) { return (CORBA::BAD_OPERATION *)0;};

CORBA::NO_RESOURCES::NO_RESOURCES() { };
CORBA::NO_RESOURCES::NO_RESOURCES(const SystemException &) { };
CORBA::NO_RESOURCES::NO_RESOURCES(ULong , CompletionStatus ) { };
CORBA::NO_RESOURCES *
CORBA::NO_RESOURCES::_narrow(CORBA::Exception *) { return (CORBA::NO_RESOURCES *)0;};

CORBA::NO_RESPONSE::NO_RESPONSE() { };
CORBA::NO_RESPONSE::NO_RESPONSE(const SystemException &) { };
CORBA::NO_RESPONSE::NO_RESPONSE(ULong , CompletionStatus ) { };
CORBA::NO_RESPONSE *
CORBA::NO_RESPONSE::_narrow(CORBA::Exception *) { return (CORBA::NO_RESPONSE *)0;};

CORBA::PERSIST_STORE::PERSIST_STORE() { };
CORBA::PERSIST_STORE::PERSIST_STORE(const SystemException &) { };
CORBA::PERSIST_STORE::PERSIST_STORE(ULong , CompletionStatus ) { };
CORBA::PERSIST_STORE *
CORBA::PERSIST_STORE::_narrow(CORBA::Exception *) { return (CORBA::PERSIST_STORE *)0;};

CORBA::BAD_INV_ORDER::BAD_INV_ORDER() { };
CORBA::BAD_INV_ORDER::BAD_INV_ORDER(const SystemException &) { };
CORBA::BAD_INV_ORDER::BAD_INV_ORDER(ULong , CompletionStatus ) { };
CORBA::BAD_INV_ORDER *
CORBA::BAD_INV_ORDER::_narrow(CORBA::Exception *) { return (CORBA::BAD_INV_ORDER *)0;};

CORBA::TRANSIENT::TRANSIENT() { };
CORBA::TRANSIENT::TRANSIENT(const SystemException &) { };
CORBA::TRANSIENT::TRANSIENT(ULong , CompletionStatus ) { };
CORBA::TRANSIENT *
CORBA::TRANSIENT::_narrow(CORBA::Exception *) { return (CORBA::TRANSIENT *)0;};

CORBA::FREE_MEM::FREE_MEM() { };
CORBA::FREE_MEM::FREE_MEM(const SystemException &) { };
CORBA::FREE_MEM::FREE_MEM(ULong , CompletionStatus ) { };
CORBA::FREE_MEM *
CORBA::FREE_MEM::_narrow(CORBA::Exception *) { return (CORBA::FREE_MEM *)0;};

CORBA::INV_IDENT::INV_IDENT() { };
CORBA::INV_IDENT::INV_IDENT(const SystemException &) { };
CORBA::INV_IDENT::INV_IDENT(ULong , CompletionStatus ) { };
CORBA::INV_IDENT *
CORBA::INV_IDENT::_narrow(CORBA::Exception *) { return (CORBA::INV_IDENT *)0;};

CORBA::INV_FLAG::INV_FLAG() { };
CORBA::INV_FLAG::INV_FLAG(const SystemException &) { };
CORBA::INV_FLAG::INV_FLAG(ULong , CompletionStatus ) { };
CORBA::INV_FLAG *
CORBA::INV_FLAG::_narrow(CORBA::Exception *) { return (CORBA::INV_FLAG *)0;};

CORBA::INTF_REPOS::INTF_REPOS() { };
CORBA::INTF_REPOS::INTF_REPOS(const SystemException &) { };
CORBA::INTF_REPOS::INTF_REPOS(ULong , CompletionStatus ) { };
CORBA::INTF_REPOS *
CORBA::INTF_REPOS::_narrow(CORBA::Exception *) { return (CORBA::INTF_REPOS *)0;};

CORBA::BAD_CONTEXT::BAD_CONTEXT() { };
CORBA::BAD_CONTEXT::BAD_CONTEXT(const SystemException &) { };
CORBA::BAD_CONTEXT::BAD_CONTEXT(ULong , CompletionStatus ) { };
CORBA::BAD_CONTEXT *
CORBA::BAD_CONTEXT::_narrow(CORBA::Exception *) { return (CORBA::BAD_CONTEXT *)0;};

CORBA::OBJ_ADAPTER::OBJ_ADAPTER() { };
CORBA::OBJ_ADAPTER::OBJ_ADAPTER(const SystemException &) { };
CORBA::OBJ_ADAPTER::OBJ_ADAPTER(ULong , CompletionStatus ) { };
CORBA::OBJ_ADAPTER *
CORBA::OBJ_ADAPTER::_narrow(CORBA::Exception *) { return (CORBA::OBJ_ADAPTER *)0;};

CORBA::DATA_CONVERSION::DATA_CONVERSION() { };
CORBA::DATA_CONVERSION::DATA_CONVERSION(const SystemException &) { };
CORBA::DATA_CONVERSION::DATA_CONVERSION(ULong , CompletionStatus ) { };
CORBA::DATA_CONVERSION *
CORBA::DATA_CONVERSION::_narrow(CORBA::Exception *) { return (CORBA::DATA_CONVERSION *)0;};

CORBA::OBJECT_NOT_EXIST::OBJECT_NOT_EXIST() { };
CORBA::OBJECT_NOT_EXIST::OBJECT_NOT_EXIST(const SystemException &) { };
CORBA::OBJECT_NOT_EXIST::OBJECT_NOT_EXIST(ULong , CompletionStatus ) { };
CORBA::OBJECT_NOT_EXIST *
CORBA::OBJECT_NOT_EXIST::_narrow(CORBA::Exception *) { return (CORBA::OBJECT_NOT_EXIST *)0;};

