//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/iiop/inc/find.hh
//
// Modifications:
// $Log: find.hh,v $
// Revision 1.1.1.1  2000/02/09 17:07:10  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.8  1998/09/04 15:39:01  james
// findTypeCodeDef prototype modified
//
// Revision 1.7  1998/08/28 14:52:13  james
// BuildFullyScopedName added
//
// Revision 1.6  1998/05/11 09:45:12  stephen
// Search operations now operate on a Node&.
//
//

#ifndef VSORB_FIND_HH
#define VSORB_FIND_HH

#include <node.hh>
#include <literals.hh>
#include <grammar.hh>
#include <utilities.hh>
#include <constexpr.hh>
#include <iiop.hh>
#include <ernie.hh>
#include <tet_api.h>

extern Specification specification;
extern Ernie ernie;

Node * findAttrDef(const _Identifier &name, Node &ptr);
Node * findOpDef(const _Identifier &name, Node &ptr);
Node * findTypeCodeDef(unsigned long max = 0);

Node * findElementSpec(Node &ptr, ExprValue exp, Node *& defaultNode);
Node * findCaseLabel(Node &ptr,int number);

Node * getTypeByNumber(Node &ptr,int n);
Node * getTypeByNumberInternal(Node & ptr,int &n);
int findNextFAS(Node * child, Node * parent);
void BuildFullyScopedName(Node &ptr,_ScopedName &sn);

#endif

