//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#ifndef VSORB_ERNIE_HH
#define VSORB_ERNIE_HH

class Ernie
{
    
private:
    CORBA::ULong m_zranx,m_zrany,m_zranz,m_zranc,m_zrann;
    
    CORBA::ULong 		lastULong;
    CORBA::Long 		lastLong;
    CORBA::Short 		lastShort;
    CORBA::UShort 	lastUShort;
    CORBA::Boolean 	lastBoolean;
    CORBA::Octet 		lastOctet;
    CORBA::Char 		lastChar;
    CORBA::Float 		lastFloat;
    CORBA::Double	 	lastDouble;
    char* 		      lastString;

    CORBA::ULong    inoutMode;
    CORBA::ULong    sequenceCount;

public:
    CORBA::ULong    anyCount;

    Ernie(void);
    virtual ~Ernie(void);

    void seed(CORBA::ULong newVal);
    void seed(char *newVal);
    void seed(const char *newVal);
    void mode(CORBA::ULong m);

    CORBA::ULong seed(void);

    CORBA::ULong getSequenceLength(CORBA::ULong bound);

    CORBA::ULong randULong(void);
    CORBA::ULong getULong(void);
    CORBA::ULong getULongAgain(void);
    CORBA::Long getLong(void);
    CORBA::Long getLongAgain(void);
    CORBA::UShort getUShort(void);
    CORBA::UShort getUShortAgain(void);
    CORBA::Short randShort(void);
    CORBA::Short getShort(void);
    CORBA::Short getShortAgain(void);
    CORBA::Boolean getBoolean(void);
    CORBA::Boolean getBooleanAgain(void);
    CORBA::Octet getOctet(void);
    CORBA::Octet getOctetAgain(void);
    CORBA::Char randChar(void);
    CORBA::Char getChar(void);
    CORBA::Char getCharAgain(void);
    CORBA::Float getFloat(void);
    CORBA::Float getFloatAgain(void);
    CORBA::Double getDouble(void);
    CORBA::Double getDoubleAgain(void);
    char* getString(int,int);
    char* getString(void);
    char* getString(int);
    char* getStringAgain(void);

    int checkULong(const CORBA::ULong);
    int checkLong(const CORBA::Long);
    int checkUShort(const CORBA::UShort);
    int checkShort(const CORBA::Short);
    int checkBoolean(const CORBA::Boolean);
    int checkOctet(const CORBA::Octet);
    int checkChar(const CORBA::Char);
    int checkFloat(const CORBA::Float);
    int checkDouble(const CORBA::Double);
    int checkString(const char*);
    int checkString(const char*,int);

};

char *ULongToString(CORBA::ULong);
char *LongToString(CORBA::Long);
char *UShortToString(CORBA::UShort);
char *ShortToString(CORBA::Short);
const char *BooleanToString(CORBA::Boolean);
char *OctetToString(CORBA::Octet);
char *CharToString(CORBA::Char);
char *FloatToString(CORBA::Float);
char *DoubleToString(CORBA::Double);
char *StringToString(char*);

#endif
