//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/utils/nodes/include/constexpr.hh
//
// Modifications:
// $Log: constexpr.hh,v $
// Revision 1.1.1.1  2000/02/09 17:07:13  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.1  1997/10/06 11:35:42  james
// Initial Sources
//
//

#ifndef _CONSTEXPR_HH
#define _CONSTEXPR_HH

#include "node.hh"

class ConstExp : public ChoiceNode
{
public:
  ConstExp();
  ConstExp(Node *p, RecursionCount r);

#ifdef GENERATOR_FUNCTIONS
  int Next();
#endif
};


class OrExpr : public ChoiceNode
{
public:
  OrExpr();
  OrExpr(Node *p, RecursionCount r);
};


class OrOper : public SequenceNode
{
public:
  OrOper();
  OrOper(Node *p, RecursionCount r);

  ExprValue exprValue();

#ifdef GENERATOR_FUNCTIONS
  int assignValue(ExprValue, ExprValue);
#endif
};


class XorExpr : public ChoiceNode
{
public:
  XorExpr();
  XorExpr(Node *p, RecursionCount r);
};


class XorOper : public SequenceNode
{
public:
  XorOper();
  XorOper(Node *p, RecursionCount r);

  ExprValue exprValue();

#ifdef GENERATOR_FUNCTIONS
  int assignValue(ExprValue, ExprValue);
#endif
};


class AndExpr : public ChoiceNode
{
public:
  AndExpr();
  AndExpr(Node *p, RecursionCount r);
};


class AndOper : public SequenceNode
{
public:
  AndOper();
  AndOper(Node *p, RecursionCount r);

  ExprValue exprValue();

#ifdef GENERATOR_FUNCTIONS
  int assignValue(ExprValue, ExprValue);
#endif
};


class ShiftExpr : public ChoiceNode
{
public:
  ShiftExpr();
  ShiftExpr(Node *p, RecursionCount r);
};


class ShiftRightOper : public SequenceNode
{
public:
  ShiftRightOper();
  ShiftRightOper(Node *p, RecursionCount r);

  ExprValue exprValue();

#ifdef GENERATOR_FUNCTIONS
  int assignValue(ExprValue, ExprValue);
#endif
};


class ShiftLeftOper : public SequenceNode
{
public:
  ShiftLeftOper();
  ShiftLeftOper(Node *p, RecursionCount r);

  ExprValue exprValue();

#ifdef GENERATOR_FUNCTIONS
  int assignValue(ExprValue, ExprValue);
#endif
};


class AddExpr : public ChoiceNode
{
public:
  AddExpr();
  AddExpr(Node *p, RecursionCount r);
};


class AddOper : public SequenceNode
{
public:
  AddOper();
  AddOper(Node *p, RecursionCount r);

  ExprValue exprValue();

#ifdef GENERATOR_FUNCTIONS
  int assignValue(ExprValue, ExprValue);
#endif
};


class SubtractOper : public SequenceNode
{
public:
  SubtractOper();
  SubtractOper(Node *p, RecursionCount r);

  ExprValue exprValue();

#ifdef GENERATOR_FUNCTIONS
  int assignValue(ExprValue, ExprValue);
#endif
};


class MultExpr : public ChoiceNode
{
public:
  MultExpr();
  MultExpr(Node *p, RecursionCount r);
};


class MultOper : public SequenceNode
{
public:
  MultOper();
  MultOper(Node *p, RecursionCount r);

  ExprValue exprValue();

#ifdef GENERATOR_FUNCTIONS
  int assignValue(ExprValue, ExprValue);
#endif
};


class DivOper : public SequenceNode
{
public:
  DivOper();
  DivOper(Node *p, RecursionCount r);

  ExprValue exprValue();

#ifdef GENERATOR_FUNCTIONS
  int assignValue(ExprValue, ExprValue);
#endif
};


class RemainderOper : public SequenceNode
{
public:
  RemainderOper();
  RemainderOper(Node *p, RecursionCount r);

  ExprValue exprValue();

#ifdef GENERATOR_FUNCTIONS
  int assignValue(ExprValue, ExprValue);
#endif
};


class UnaryExpr : public ChoiceNode
{
public:
  UnaryExpr();
  UnaryExpr(Node *p, RecursionCount r);
};


class UnaryMinusOper : public ChoiceNode
{
public:
  UnaryMinusOper();
  UnaryMinusOper(Node *p, RecursionCount r);

  ExprValue exprValue();

#ifdef GENERATOR_FUNCTIONS
  int assignValue(ExprValue, ExprValue);
#endif
};


class UnaryPlusOper : public ChoiceNode
{
public:
  UnaryPlusOper();
  UnaryPlusOper(Node *p, RecursionCount r);
};


class UnaryNotOper : public ChoiceNode
{
public:
  UnaryNotOper();
  UnaryNotOper(Node *p, RecursionCount r);

  ExprValue exprValue();

#ifdef GENERATOR_FUNCTIONS
  int assignValue(ExprValue, ExprValue);
#endif
};


class PrimaryExpr : public ChoiceNode
{
public:
  PrimaryExpr();
  PrimaryExpr(Node *p, RecursionCount r);
};


#endif

