//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/utils/nodes/include/outputidl.hh
//
// Modifications:
// $Log: outputidl.hh,v $
// Revision 1.1.1.1  2000/02/09 17:07:13  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.3  1998/05/11 10:33:44  stephen
// Added stream operator for Node& type.
//
// Revision 1.2  1997/10/14 10:23:58  james
// Extended types removed
//
// Revision 1.1  1997/10/06 11:35:49  james
// Initial Sources
//

#ifndef _OUTPUTIDL_HH
#define _OUTPUTIDL_HH

ostream &operator<<(ostream &output, Node *node);

ostream &operator<<(ostream &output, Node &node);

ostream &operator<<(ostream &output, ChoiceNode &node);

ostream &operator<<(ostream &output, ListNode &node);

ostream &operator<<(ostream &output, SequenceNode &node);

ostream &operator<<(ostream &output, Specification &node);

ostream &operator<<(ostream &output, Definition &node);

ostream &operator<<(ostream &output, Module &node);

ostream &operator<<(ostream &output, Definitions &node);

ostream &operator<<(ostream &output, Interface &node);

ostream &operator<<(ostream &output, InterfaceDcl &node);

ostream &operator<<(ostream &output, ForwardDcl &node);

ostream &operator<<(ostream &output, InterfaceBody &node);

ostream &operator<<(ostream &output, Export &node);

ostream &operator<<(ostream &output, InheritanceSpec &node);

ostream &operator<<(ostream &output, _ScopedName &node);

ostream &operator<<(ostream &output, ScopedNameA &node);

ostream &operator<<(ostream &output, ScopedNameB &node);

ostream &operator<<(ostream &output, ConstDcl &node);

ostream &operator<<(ostream &output, ConstType &node);

ostream &operator<<(ostream &output, ConstExp &node);

ostream &operator<<(ostream &output, OrExpr &node);

ostream &operator<<(ostream &output, OrOper &node);

ostream &operator<<(ostream &output, XorExpr &node);

ostream &operator<<(ostream &output, XorOper &node);

ostream &operator<<(ostream &output, AndExpr &node);

ostream &operator<<(ostream &output, AndOper &node);

ostream &operator<<(ostream &output, ShiftExpr &node);

ostream &operator<<(ostream &output, ShiftRightOper &node);

ostream &operator<<(ostream &output, ShiftLeftOper &node);

ostream &operator<<(ostream &output, AddExpr &node);

ostream &operator<<(ostream &output, AddOper &node);

ostream &operator<<(ostream &output, SubtractOper &node);

ostream &operator<<(ostream &output, MultExpr &node);

ostream &operator<<(ostream &output, MultOper &node);

ostream &operator<<(ostream &output, DivOper &node);

ostream &operator<<(ostream &output, RemainderOper &node);

ostream &operator<<(ostream &output, UnaryExpr &node);

ostream &operator<<(ostream &output, UnaryMinusOper &node);

ostream &operator<<(ostream &output, UnaryPlusOper &node);

ostream &operator<<(ostream &output, UnaryNotOper &node);

ostream &operator<<(ostream &output, PrimaryExpr &node);

ostream &operator<<(ostream &output, Literal &node);

ostream &operator<<(ostream &output, BooleanLiteral &node);

ostream &operator<<(ostream &output, PositiveIntConst &node);

ostream &operator<<(ostream &output, TypeDcl &node);

ostream &operator<<(ostream &output, TypeDeclarator &node);

ostream &operator<<(ostream &output, TypeSpec &node);

ostream &operator<<(ostream &output, SimpleTypeSpec &node);

ostream &operator<<(ostream &output, BaseTypeSpec &node);

ostream &operator<<(ostream &output, ObjectType &node);

ostream &operator<<(ostream &output, TemplateTypeSpec &node);

ostream &operator<<(ostream &output, ConstrTypeSpec &node);

ostream &operator<<(ostream &output, Declarators &node);

ostream &operator<<(ostream &output, Declarator &node);

ostream &operator<<(ostream &output, SimpleDeclarator &node);

ostream &operator<<(ostream &output, ComplexDeclarator &node);

ostream &operator<<(ostream &output, FloatingPtType &node);

ostream &operator<<(ostream &output, FloatType &node);

ostream &operator<<(ostream &output, DoubleType &node);

ostream &operator<<(ostream &output, IntegerType &node);

ostream &operator<<(ostream &output, SignedInt &node);

ostream &operator<<(ostream &output, SignedLongInt &node);

ostream &operator<<(ostream &output, SignedShortInt &node);

ostream &operator<<(ostream &output, UnsignedInt &node);

ostream &operator<<(ostream &output, UnsignedLongInt &node);

ostream &operator<<(ostream &output, UnsignedShortInt &node);

ostream &operator<<(ostream &output, CharType &node);

ostream &operator<<(ostream &output, BooleanType &node);

ostream &operator<<(ostream &output, OctetType &node);

ostream &operator<<(ostream &output, AnyType &node);

ostream &operator<<(ostream &output, StructType &node);

ostream &operator<<(ostream &output, MemberList &node);

ostream &operator<<(ostream &output, Member &node);

ostream &operator<<(ostream &output, UnionType &node);

ostream &operator<<(ostream &output, UnionSwitch &node);

ostream &operator<<(ostream &output, SwitchTypeSpec &node);

ostream &operator<<(ostream &output, SwitchBody &node);

ostream &operator<<(ostream &output, Case &node);

ostream &operator<<(ostream &output, CaseLabel &node);

ostream &operator<<(ostream &output, DefaultLabel &node);

ostream &operator<<(ostream &output, CaseLabelList &node);

ostream &operator<<(ostream &output, ElementSpec &node);

ostream &operator<<(ostream &output, EnumType &node);

ostream &operator<<(ostream &output, Enumerator &node);

ostream &operator<<(ostream &output, EnumeratorList &node);

ostream &operator<<(ostream &output, SequenceType &node);

ostream &operator<<(ostream &output, StringType &node);

ostream &operator<<(ostream &output, ArrayDeclarator &node);

ostream &operator<<(ostream &output, FixedArraySizeList &node);

ostream &operator<<(ostream &output, FixedArraySize &node);

ostream &operator<<(ostream &output, AttrDcl &node);

ostream &operator<<(ostream &output, Readonly &node);

ostream &operator<<(ostream &output, SimpleDeclaratorList &node);

ostream &operator<<(ostream &output, ExceptDcl &node);

ostream &operator<<(ostream &output, OpDcl &node);

ostream &operator<<(ostream &output, OpTypeSpec &node);

ostream &operator<<(ostream &output, OpTypeSpecA &node);

ostream &operator<<(ostream &output, OpTypeSpecB &node);

ostream &operator<<(ostream &output, OpAttribute &node);

ostream &operator<<(ostream &output, ParameterDcls &node);

ostream &operator<<(ostream &output, ParameterDclsA &node);

ostream &operator<<(ostream &output, ParamDcl &node);

ostream &operator<<(ostream &output, ParamAttribute &node);

ostream &operator<<(ostream &output, RaisesExpr &node);

ostream &operator<<(ostream &output, ContextExpr &node);

ostream &operator<<(ostream &output, ParamTypeSpec &node);

ostream &operator<<(ostream &output, _Identifier &node);

ostream &operator<<(ostream &output, IntegerLiteral &node);

ostream &operator<<(ostream &output, CharacterLiteral &node);

ostream &operator<<(ostream &output, StringLiteral &node);

ostream &operator<<(ostream &output, FloatingPtLiteral &node);

#endif

