//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/utils/nodes/include/types.hh
//
// Modifications:
// $Log: types.hh,v $
// Revision 1.1.1.1  2000/02/09 17:07:13  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1997/10/16 14:23:39  james
// Reduced memory usage
//
// Revision 1.4  1997/10/14 10:24:00  james
// Extended types removed
//
// Revision 1.3  1997/10/08 13:22:55  tet
// Added WIN32 guard.
//
// Revision 1.2  1997/10/08 10:52:47  james
// Minor typo
//
// Revision 1.1  1997/10/06 11:35:50  james
// Initial Sources
//
//

#ifndef _TYPES_HH
#define _TYPES_HH

#include <iostream.h>
#include <fstream.h>

#define MAX_LABELS 100

typedef enum TypeSpecifier {
  tsUndefined,
  tsShort,
  tsUShort,
  tsLong,
  tsULong,
  tsFloat,
  tsDouble,
  tsBoolean,
  tsChar,
  tsString,
  tsAny,
  tsOctet,
  tsEnum,
  tsMAX};

fstream &operator<<(fstream &output, const TypeSpecifier ts);
ostream &operator<<(ostream &output, const TypeSpecifier ts);

typedef enum EvalType {
  etUndefined,
  etLong,
  etULong,
  etDouble,
  etBoolean,
  etChar,
  etString,
  etEnum,
  etMAX};


fstream &operator<<(fstream &output, const EvalType et);
ostream &operator<<(ostream &output, const EvalType et);

typedef enum{
  IdNotInitialised,
  IdSpecification,
  IdDefinition,
  IdModule,
  IdDefinitions,
  IdInterface,
  IdInterfaceDcl,
  IdForwardDcl,
  IdInterfaceBody,
  IdExport,
  IdInheritanceSpec,
  IdScopedName,
  IdScopedNameA,
  IdScopedNameB,
  IdConstDcl,
  IdConstType,
  IdConstExp,
  IdOrExpr,
  IdOrOper,
  IdXorExpr,
  IdXorOper,
  IdAndExpr,
  IdAndOper,
  IdShiftExpr,
  IdShiftRightOper,
  IdShiftLeftOper,
  IdAddExpr,
  IdAddOper,
  IdSubtractOper,
  IdMultExpr,
  IdMultOper,
  IdDivOper,
  IdRemainderOper,
  IdUnaryExpr,
  IdUnaryMinusOper,
  IdUnaryPlusOper,
  IdUnaryNotOper,
  IdPrimaryExpr,
  IdLiteral,
  IdBooleanLiteral,
  IdPositiveIntConst,
  IdTypeDcl,
  IdTypeDeclarator,
  IdTypeSpec,
  IdSimpleTypeSpec,
  IdBaseTypeSpec,
  IdObjectType,
  IdTemplateTypeSpec,
  IdConstrTypeSpec,
  IdDeclarators,
  IdDeclarator,
  IdSimpleDeclarator,
  IdComplexDeclarator,
  IdFloatingPtType,
  IdFloatType,
  IdDoubleType,
  IdIntegerType,
  IdSignedInt,
  IdSignedLongInt,
  IdSignedShortInt,
  IdUnsignedInt,
  IdUnsignedLongInt,
  IdUnsignedShortInt,
  IdCharType,
  IdBooleanType,
  IdOctetType,
  IdAnyType,
  IdStructType,
  IdMemberList,
  IdMember,
  IdUnionType,
  IdUnionSwitch,
  IdSwitchTypeSpec,
  IdSwitchBody,
  IdCase,
  IdCaseLabel,
  IdDefaultLabel,
  IdCaseLabelList,
  IdElementSpec,
  IdEnumType,
  IdEnumerator,
  IdEnumeratorList,
  IdSequenceType,
  IdStringType,
  IdArrayDeclarator,
  IdFixedArraySizeList,
  IdFixedArraySize,
  IdAttrDcl,
  IdReadonly,
  IdSimpleDeclaratorList,
  IdExceptDcl,
  IdOpDcl,
  IdOpTypeSpec,
  IdOpTypeSpecA,
  IdOpTypeSpecB,
  IdOpAttribute,
  IdParameterDcls,
  IdParameterDclsA,
  IdParamDcl,
  IdParamAttribute,
  IdRaisesExpr,
  IdContextExpr,
  IdParamTypeSpec,
  IdIdentifier,
  IdIntegerLiteral,
  IdCharacterLiteral,
  IdStringLiteral,
  IdFloatingPtLiteral,
  IdScopedNameBList,
  MAX_NODE_ID
}NodeId;

fstream &operator<<(fstream &output, const NodeId id);
ostream &operator<<(ostream &output, const NodeId id);

#endif

