//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/utils/nodes/include/utilities.hh
//
// Modifications:
// $Log: utilities.hh,v $
// Revision 1.1.1.1  2000/02/09 17:07:13  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1998/05/11 10:40:31  stephen
// Node* changes to Node& for support functions.
//
// Revision 1.6  1997/12/01 10:55:08  james
// CountMembers added
//
// Revision 1.5  1997/11/24 12:18:31  james
// TypeCode support added
//
// Revision 1.4  1997/11/17 11:08:52  james
// CountTypes function added
//
// Revision 1.3  1997/10/20 17:29:37  stephen
// Added case label counting functions.
//
// Revision 1.2  1997/10/16 14:23:40  james
// Reduced memory usage
//
// Revision 1.1  1997/10/06 11:35:51  james
// Initial Sources
//

#ifndef _UTILTITES_HH
#define _UTILTITES_HH

TypeSpecifier GetType(Node &);

EvalType GetEvalType(Node &);

Node *FindDefinition(Node &start, const class _ScopedName  name,int flag = 1);

TypeSpecifier FindTypeSpecifier(Node &ptr);

int CountCaseLabels(Node &ptr,int countDefault);

int CountPreceedingCaseLabels(Node &start);

int CountTypes(Node &ptr);

int CountMembers(Node &ptr);

int IsATypeCode(Node *node);

#endif

