
//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/utils/nodes/src/parser.y
//
// Modifications:
// $Log: parser.cpp,v $
// Revision 1.2  2000/02/11 16:06:38  mli
// export->exp (export is a keyword).
//
// Revision 1.7  1997/12/09 11:01:36  james
// String Concatination
//
// Revision 1.3  1997/12/09 10:54:31  james
// String Concatination
//
// Revision 1.2  1997/10/14 10:24:17  james
// Extended types removed
//
// Revision 1.1  1997/10/06 11:36:05  james
// Initial Sources
//
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <grammar.hh>
#include <constexpr.hh>
#include <literals.hh>


extern Specification specification;


typedef union
#ifdef __cplusplus
	YYSTYPE
#endif

{
    char *string;

    AddExpr *addExpr;
    AddOper *addOper;
    AndExpr *andExpr;
    AndOper *andOper;
    AnyType *anyType;
    ArrayDeclarator *arrayDeclarator;
    AttrDcl *attrDcl;
    BaseTypeSpec *baseTypeSpec;
    BooleanLiteral *booleanLiteral;
    BooleanType *booleanType;
    Case *_case;
    CaseLabel *caseLabel;
    CaseLabelList *caseLabelList;
    CharType *charType;
    CharacterLiteral *characterLiteral;
    ComplexDeclarator *complexDeclarator;
    ConstDcl *constDcl;
    ConstExp *constExp;
    ConstType *constType;
    ConstrTypeSpec *constrTypeSpec;
    ContextExpr *contextExpr;
    Declarator *declarator;
    Declarators *declarators;
    Definition *definition;
    Definitions *definitions;
    DivOper *divOper;
    ElementSpec *elementSpec;
    EnumType *enumType;
    Enumerator *enumerator;
    EnumeratorList *enumeratorList;
    ExceptDcl *exceptDcl;
    Export *exp;
    FixedArraySize *fixedArraySize;
    FixedArraySizeList *fixedArraySizeList;
    FloatingPtLiteral *floatingPtLiteral;
    FloatingPtType *floatingPtType;
    FloatType *floatType;
    DoubleType *doubleType;
    ForwardDcl *forwardDcl;
    _Identifier *identifier;
    InheritanceSpec *inheritanceSpec;
    IntegerLiteral *integerLiteral;
    IntegerType *integerType;
    Interface *interface;
    InterfaceBody *interfaceBody;
    InterfaceDcl *interfaceDcl;
    Literal *literal;
    Member *member;
    MemberList *memberList;
    Module *module;
    MultExpr *multExpr;
    MultOper *multOper;
    ObjectType *objectType;
    OctetType *octetType;
    OpAttribute *opAttribute;
    OpDcl *opDcl;
    OpTypeSpec *opTypeSpec;
    OpTypeSpecA *opTypeSpecA;
    OpTypeSpecB *opTypeSpecB;
    OrExpr *orExpr;
    OrOper *orOper;
    ParamAttribute *paramAttribute;
    ParamDcl *paramDcl;
    ParamTypeSpec *paramTypeSpec;
    ParameterDcls *parameterDcls;
    ParameterDclsA *parameterDclsA;
    PositiveIntConst *positiveIntConst;
    PrimaryExpr *primaryExpr;
    RaisesExpr *raisesExpr;
    Readonly *readonly;
    RemainderOper *remainderOper;
    _ScopedName *scopedName;
    ScopedNameA *scopedNameA;
    ScopedNameB *scopedNameB;
    SequenceType *sequenceType;
    ShiftExpr *shiftExpr;
    ShiftLeftOper *shiftLeftOper;
    ShiftRightOper *shiftRightOper;
    SignedInt *signedInt;
    SignedLongInt *signedLongInt;
    SignedShortInt *signedShortInt;
    SimpleDeclarator *simpleDeclarator;
    SimpleDeclaratorList *simpleDeclaratorList;
    SimpleTypeSpec *simpleTypeSpec;
    Specification *specification;
    StringLiteral *stringLiteral;
    char *stringLiteralList;
    StringType *stringType;
    StructType *structType;
    SubtractOper *subtractOper;
    SwitchBody *switchBody;
    SwitchTypeSpec *switchTypeSpec;
    TemplateTypeSpec *templateTypeSpec;
    TypeDcl *typeDcl;
    TypeDeclarator *typeDeclarator;
    TypeSpec *typeSpec;
    UnaryExpr *unaryExpr;
    UnaryMinusOper *unaryMinusOper;
    UnaryNotOper *unaryNotOper;
    UnaryPlusOper *unaryPlusOper;
    UnionType *unionType;
    UnionSwitch *unionSwitch;
    UnsignedInt *unsignedInt;
    UnsignedLongInt *unsignedLongInt;
    UnsignedShortInt *unsignedShortInt;
    XorExpr *xorExpr;
    XorOper *xorOper;
} YYSTYPE;
# define ANY 257
# define ATTRIBUTE 258
# define BOOLEAN 259
# define CASE 260
# define CHAR 261
# define CONST 262
# define CONTEXT 263
# define DEFAULT 264
# define DOUBLE 265
# define ENUM 266
# define EXCEPTION 267
# define FLOAT 268
# define IN 269
# define INOUT 270
# define INTERFACE 271
# define LONG 272
# define MODULE 273
# define OBJECT 274
# define OCTET 275
# define ONEWAY 276
# define OUT 277
# define RAISES 278
# define READONLY 279
# define SEQUENCE 280
# define SHORT 281
# define STRING 282
# define STRUCT 283
# define SWITCH 284
# define TYPEDEF 285
# define UNSIGNED 286
# define UNION 287
# define VOID 288
# define SEMI_COLON 289
# define LEFT_CURLY_BRACKET 290
# define RIGHT_CURLY_BRACKET 291
# define COLON 292
# define COMMA 293
# define EQUALS_SIGN 294
# define PLUS_SIGN 295
# define MINUS_SIGN 296
# define LEFT_PARENTHESIS 297
# define RIGHT_PARENTHESIS 298
# define LESS_THAN_SIGN 299
# define GREATER_THAN_SIGN 300
# define LEFT_SQUARE_BRACKET 301
# define RIGHT_SQUARE_BRACKET 302
# define APOSTROPHE 303
# define DOUBLE_QUOTE 304
# define REVERSE_SOLIDUS 305
# define VERTICAL_LINE 306
# define CIRCUMFLEX 307
# define AMPERSAND 308
# define ASTERISK 309
# define SOLIDUS 310
# define PERCENT_SIGN 311
# define TILDA 312
# define SHIFT_LEFT 313
# define SHIFT_RIGHT 314
# define SCOPE_DELIMITOR 315
# define IDENTIFIER 316
# define INTEGER_LITERAL 317
# define STRING_LITERAL 318
# define CHARACTER_LITERAL 319
# define FLOATING_PT_LITERAL 320
# define BOOLEAN_LITERAL 321

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif


#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif

#ifndef yylex
#ifdef __EXTERN_C__
	extern "C" { int yylex(void); }
#else
	int yylex(void);
#endif
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256
yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 78,
	290, 20,
	-2, 18,
-1, 96,
	316, 33,
	-2, 172,
-1, 153,
	316, 33,
	-2, 171,
-1, 158,
	288, 175,
	291, 17,
	316, 33,
	-2, 167,
-1, 195,
	288, 175,
	291, 16,
	316, 33,
	-2, 167,
	};
# define YYNPROD 211
# define YYLAST 511
yytabelem yyact[]={

    53,   150,    51,   187,    50,    11,    76,    64,    59,    22,
    12,    58,   177,   176,   175,    65,   109,    54,    52,   212,
   174,   173,   204,   141,    66,    56,    20,   223,     9,    67,
    21,    53,   108,    51,   273,    50,   224,   172,   274,    59,
    22,    92,    58,   180,   181,   182,    65,   304,    54,    52,
    90,   280,   303,   250,    55,    66,    56,    20,    64,   236,
    67,    21,    53,   302,    51,   291,    50,   151,   301,   279,
    59,    22,   254,    58,   178,   179,   281,    65,   162,    54,
    52,   138,   137,   136,   275,    55,    66,    56,    20,    64,
   237,    67,    21,   221,   105,   222,   214,   213,   139,   171,
   105,    64,   298,   145,   150,   147,   148,   149,    53,   273,
    51,   289,    50,   274,   100,   255,    59,    22,   238,    58,
    64,   136,   189,    65,   158,    54,    52,   104,   101,    97,
    96,    55,    66,    56,    20,   296,   244,    67,    21,    64,
   283,   145,   150,   147,   148,   149,    53,   243,    51,   242,
    50,   241,   240,    28,    59,   134,    27,    58,    26,    25,
    24,    65,   248,    54,    52,    35,    64,    74,    83,    55,
    66,    56,    53,    93,    51,    67,    50,    84,   103,   264,
    59,   261,    94,    58,   270,   272,    51,    65,    50,    54,
    52,   278,    59,    10,   112,    58,    66,    56,    51,    65,
    50,    67,   155,    32,    64,    22,    44,   245,    66,    56,
    11,    65,    30,    67,    22,    12,   266,   268,    73,    19,
    66,    15,   273,    33,   267,    67,   274,    86,   164,   205,
    64,    20,     4,     9,   126,    21,     6,     5,   196,   192,
    75,   111,    64,    77,   123,   116,    35,    78,    79,    80,
    81,   114,    35,   118,    64,    11,   160,    35,    82,    22,
    12,   120,   153,    37,    19,     3,    15,   130,    23,   107,
    31,     1,    36,    89,   166,    69,    20,    38,     9,    39,
    21,   117,   154,    18,    72,    63,    62,    49,   102,    70,
    32,    71,    17,   132,   133,    32,    95,   131,    29,    34,
   215,   269,   125,    16,   146,     2,   256,    61,    60,    35,
    48,   121,   122,   170,   209,   300,    43,    35,   220,    88,
    45,    57,   129,   202,   292,   259,   260,    91,   306,   262,
   263,   183,   165,   253,   265,   115,   113,   169,   247,   206,
   203,   201,   210,   211,    40,    42,   188,    32,   127,     8,
   168,   209,   152,   135,    13,    32,   194,   195,     7,   140,
   159,   110,    98,   157,   161,   208,    99,    14,    47,   249,
    46,   143,   106,   163,   285,   128,   167,   156,   299,   276,
   277,    68,   207,    85,   142,   271,   144,   200,    87,    41,
   119,   197,   124,     0,     0,   199,   198,     0,     0,     0,
     0,   209,   208,     0,     0,   184,   185,   186,     0,     0,
     0,     0,     0,   225,   191,   233,   234,   235,     0,   207,
   227,   209,   193,   231,   232,   226,   216,    35,   197,   228,
   257,   246,   199,   198,   239,   293,   190,     0,   229,   230,
   217,     0,   218,     0,   190,     0,   219,     0,     0,     0,
   165,   251,   208,   290,   284,     0,   297,   286,   305,     0,
   295,   294,     0,     0,     0,    32,     0,     0,   288,   207,
     0,     0,   208,     0,   287,   252,     0,     0,     0,     0,
   258,     0,     0,     0,     0,     0,     0,     0,     0,   207,
     0,     0,     0,     0,     0,   282,     0,     0,     0,     0,
     0,     0,     0,   258,     0,     0,     0,     0,     0,     0,
   258 };
yytabelem yypact[]={

    -7,-10000000,    -7,-10000000,  -129,  -130,  -131,  -133,  -136,  -149,
-10000000,   -73,  -310,-10000000,-10000000,  -310,-10000000,-10000000,-10000000,  -310,
  -310,  -310,  -310,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
  -310,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,  -310,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,  -249,  -258,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,   -99,  -310,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,  -160,-10000000,  -161,  -178,  -162,
  -106,  -163,  -193,-10000000,-10000000,-10000000,  -269,-10000000,  -299,-10000000,
  -111,-10000000,  -214,-10000000,-10000000,  -227,  -149,    -7,  -166,-10000000,
  -308,  -149,-10000000,  -219,  -310,  -310,  -269,-10000000,  -214,  -310,
  -194,  -263,-10000000,  -285,  -287,-10000000,  -294,-10000000,  -301,-10000000,
  -221,-10000000,-10000000,  -266,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -214,  -176,  -176,  -176,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -315,-10000000,-10000000,-10000000,
-10000000,  -214,  -169,  -149,-10000000,  -310,   -52,-10000000,  -257,  -196,
-10000000,  -195,   -61,  -198,-10000000,-10000000,-10000000,-10000000,  -275,-10000000,
  -264,  -214,-10000000,  -214,  -214,  -214,  -214,  -214,  -214,  -214,
  -214,  -214,  -214,  -239,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,  -199,-10000000,-10000000,  -173,  -257,-10000000,  -137,  -138,  -140,
  -142,  -153,   -51,  -310,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
  -126,-10000000,-10000000,  -308,-10000000,  -245,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,  -310,-10000000,-10000000,-10000000,  -287,  -294,  -301,  -221,
  -221,  -266,  -266,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,   -85,  -225,-10000000,-10000000,-10000000,
  -175,-10000000,  -310,   -97,   -53,   -38,  -209,-10000000,-10000000,   -72,
-10000000,  -228,  -247,  -217,-10000000,   -85,-10000000,-10000000,-10000000,  -151,
-10000000,  -226,-10000000,  -214,  -181,  -310,-10000000,-10000000,  -232,  -308,
-10000000,   -53,  -310,-10000000,-10000000,  -154,-10000000,  -310,  -190,-10000000,
-10000000,  -317,  -230,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,  -246,
-10000000,-10000000,  -308,-10000000,  -317,-10000000,-10000000 };
yytabelem yypgo[]={

     0,   261,   392,   245,   390,   389,   388,   387,   223,   386,
   279,   184,   185,   385,   277,   384,   383,   237,   194,   381,
   193,   380,   379,   378,   168,   258,   265,   377,   375,   374,
   283,   228,   373,   236,   238,   269,   372,   371,   272,   370,
   368,   367,   227,   366,   362,   360,   359,   263,   358,   357,
   356,   354,   353,   282,   262,   352,   349,   244,   348,   345,
   344,   343,   342,   341,   340,   339,   338,   336,   335,   334,
   179,   229,   333,   330,   329,   241,   327,   267,   326,   325,
   324,   323,   322,   155,   321,   320,   319,   316,   313,   253,
   312,   311,   310,   308,   307,   177,   306,   270,   305,    23,
   304,   206,   303,   302,   301,   300,   299,   232,   298,   202,
   234,   297,   294,   293,   292,   288,   287,   286,   285,   251,
   281,   271 };
yytabelem yyr1[]={

     0,   121,   121,    98,    98,    26,    26,    26,    26,    26,
    56,    27,    27,    48,    48,    51,    50,    50,    41,    44,
    44,    49,    49,    34,    34,    34,    34,    34,    43,    45,
    45,    83,    85,    85,    84,    86,    86,    17,    19,    19,
    19,    19,    19,    19,    18,    67,    67,    68,   119,   119,
   120,     3,     3,     4,    89,    89,    89,    91,    90,     1,
     1,     1,     2,   103,    57,    57,    57,    57,    58,    28,
    82,   110,   110,   110,   110,   111,   113,   112,    77,    77,
    77,    52,    52,    52,    52,    52,    75,   107,   107,   108,
   109,   109,    97,    97,    97,     8,     8,     8,     8,     8,
     8,     8,    59,   106,   106,    20,    20,    20,    25,    25,
    24,    24,    95,    16,    38,    38,    39,    40,    47,    47,
    92,    92,    93,    94,   116,   116,   117,   118,    14,    10,
    60,     5,   102,    54,    54,    53,   114,   115,   105,   105,
   105,   105,   105,   104,   104,    11,    13,    13,    12,    12,
    29,    30,    32,    32,    31,    87,    88,    88,   101,    76,
    76,     6,    36,    36,    35,     7,    81,    81,    96,    96,
    33,    55,    55,    63,    62,    62,    79,    79,    22,    22,
    61,    64,    64,    65,    66,    72,    74,    74,    73,    73,
    70,    69,    69,    69,    78,    80,    80,    21,    23,    23,
    71,    71,    71,    15,    37,    46,    99,   100,   100,    42,
     9 };
yytabelem yyr2[]={

     0,     2,     0,     3,     5,     5,     5,     5,     5,     5,
    11,     3,     5,     3,     3,    13,     3,     1,     5,     3,
     1,     3,     5,     5,     5,     5,     5,     5,     5,     3,
     7,     5,     3,     1,     3,     3,     7,    11,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     7,     3,     3,
     7,     3,     3,     7,     3,     3,     3,     7,     7,     3,
     3,     3,     7,     7,     3,     3,     3,     3,     7,     7,
     7,     3,     3,     3,     3,     5,     5,     5,     3,     3,
     7,     3,     3,     3,     3,     3,     3,     5,     3,     5,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     7,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     5,     5,     3,     3,
     3,     3,    11,     3,     5,     7,     7,    15,     3,     3,
     3,     3,     3,     3,     5,     7,     3,     5,     7,     5,
     5,    11,     3,     7,     3,    11,     5,     1,     5,     7,
     1,     5,     3,     5,     7,     9,     3,     1,     3,     7,
    11,     3,     1,    11,     3,     1,     3,     1,     3,     1,
     3,     3,     3,     5,     3,     7,     3,     1,     3,     7,
     7,     3,     3,     3,     9,     3,     7,     9,     3,     7,
     3,     3,     3,     3,     3,     3,     3,     3,     5,     3,
     3 };
yytabelem yychk[]={

-10000000,  -121,   -98,   -26,  -107,   -17,   -33,   -48,   -56,   285,
   -20,   262,   267,   -51,   -41,   273,  -102,  -114,   -30,   271,
   283,   287,   266,   -26,   289,   289,   289,   289,   289,  -108,
  -109,   -97,   -20,    -8,  -106,   -83,   -38,   -47,   -14,   -10,
   -60,    -5,   -59,   -87,  -101,   -85,   -39,   -40,   -92,  -116,
   261,   259,   275,   257,   274,   280,   282,   -84,   268,   265,
   -93,   -94,  -117,  -118,   315,   272,   281,   286,   -19,   -47,
   -14,   -10,   -38,  -101,   -83,   -42,   316,   -42,   -42,   -42,
   -42,   -42,   -25,   -24,   -95,   -16,   -42,    -6,   -86,   -42,
   299,   -76,   299,   272,   281,   -42,   290,   290,   -44,   -43,
   292,   290,  -115,   284,   290,   293,   -36,   -35,   301,   315,
   -97,   -75,   -18,   -67,  -119,   -68,    -3,  -120,   -89,    -4,
    -1,   -91,   -90,   -57,    -2,  -103,  -110,   -58,   -28,   -82,
   -77,  -111,  -113,  -112,   -83,   -52,   297,   296,   295,   312,
   -46,   -99,   -15,   -37,    -9,   317,  -100,   319,   320,   321,
   318,   294,   -55,   -54,   -53,  -109,   -27,   -26,   290,   -45,
   -83,   -54,   297,   -32,   -31,   -42,   -24,   -35,   -75,   -42,
   -88,   293,   300,   306,   307,   308,   314,   313,   295,   296,
   309,   310,   311,   -18,   -77,   -77,   -77,   318,   -18,   291,
   -53,   -25,   291,   -26,   -50,   -49,   -34,  -107,   -17,   -33,
    -7,   -63,   -81,   -64,   279,   -71,   -65,    -8,  -101,   -83,
   -62,   -61,   276,   293,   291,  -105,   -47,   -14,   -10,   -30,
   -83,   291,   293,   302,   300,   -75,  -119,    -3,   -89,    -1,
    -1,   -57,   -57,  -110,  -110,  -110,   298,   289,   291,   -34,
   289,   289,   289,   289,   289,   258,   -42,   -66,   288,   -83,
   298,   -31,   -71,   -72,   297,   290,   -96,   -95,   -42,   -79,
   -78,   278,   -74,   -73,   -70,   -69,   269,   277,   270,  -104,
   -11,   -13,   -12,   260,   264,   293,   -22,   -21,   263,   297,
   298,   293,   -71,   291,   -11,   -29,   -12,  -109,   -18,   292,
   -95,   297,   -80,   -83,   -70,   -95,   289,   -24,   292,   -23,
   -99,   298,   293,   298,   293,   -83,   -99 };
yytabelem yydef[]={

     2,    -2,     1,     3,     0,     0,     0,     0,     0,    33,
    88,    33,     0,    13,    14,     0,   105,   106,   107,     0,
     0,     0,     0,     4,     5,     6,     7,     8,     9,    87,
     0,    90,    91,    92,    93,    94,    95,    96,    97,    98,
    99,   100,   101,   103,   104,     0,   114,   115,   118,   119,
   128,   129,   130,   131,   102,     0,   160,    32,   116,   117,
   120,   121,   124,   125,    34,   122,   123,     0,     0,    38,
    39,    40,    41,    42,    43,     0,   209,     0,    -2,     0,
     0,     0,    89,   108,   110,   111,   112,   113,    31,    35,
    33,   158,    33,   126,   127,     0,    -2,     0,     0,    19,
    33,    33,   136,     0,     0,     0,   161,   162,    33,     0,
   157,     0,    86,    44,    45,    46,    48,    49,    51,    52,
    54,    55,    56,    59,    60,    61,    64,    65,    66,    67,
    71,    72,    73,    74,    78,    79,    33,    33,    33,    33,
    81,    82,    83,    84,    85,   205,   206,   203,   204,   210,
   207,    33,     0,    -2,   133,     0,     0,    11,    -2,    28,
    29,    33,    33,     0,   152,   154,   109,   163,     0,    36,
     0,    33,   159,    33,    33,    33,    33,    33,    33,    33,
    33,    33,    33,     0,    75,    76,    77,   208,    37,   170,
   134,     0,    10,    12,     0,    -2,    21,     0,     0,     0,
     0,     0,     0,     0,   166,   181,   182,   200,   201,   202,
     0,   174,   180,    33,   132,     0,   138,   139,   140,   141,
   142,   151,     0,   164,   155,   156,    47,    50,    53,    57,
    58,    62,    63,    68,    69,    70,    80,   135,    15,    22,
    23,    24,    25,    26,    27,    33,     0,   183,   184,    30,
     0,   153,     0,   177,   187,     0,   165,   168,   112,   179,
   176,     0,     0,   186,   188,    33,   191,   192,   193,     0,
   143,    33,   146,    33,     0,     0,   173,   178,     0,    33,
   185,     0,     0,   137,   144,     0,   147,     0,     0,   149,
   169,     0,     0,   195,   189,   190,   145,   150,   148,     0,
   198,   194,    33,   197,     0,   196,   199 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"ANY",	257,
	"ATTRIBUTE",	258,
	"BOOLEAN",	259,
	"CASE",	260,
	"CHAR",	261,
	"CONST",	262,
	"CONTEXT",	263,
	"DEFAULT",	264,
	"DOUBLE",	265,
	"ENUM",	266,
	"EXCEPTION",	267,
	"FLOAT",	268,
	"IN",	269,
	"INOUT",	270,
	"INTERFACE",	271,
	"LONG",	272,
	"MODULE",	273,
	"OBJECT",	274,
	"OCTET",	275,
	"ONEWAY",	276,
	"OUT",	277,
	"RAISES",	278,
	"READONLY",	279,
	"SEQUENCE",	280,
	"SHORT",	281,
	"STRING",	282,
	"STRUCT",	283,
	"SWITCH",	284,
	"TYPEDEF",	285,
	"UNSIGNED",	286,
	"UNION",	287,
	"VOID",	288,
	"SEMI_COLON",	289,
	"LEFT_CURLY_BRACKET",	290,
	"RIGHT_CURLY_BRACKET",	291,
	"COLON",	292,
	"COMMA",	293,
	"EQUALS_SIGN",	294,
	"PLUS_SIGN",	295,
	"MINUS_SIGN",	296,
	"LEFT_PARENTHESIS",	297,
	"RIGHT_PARENTHESIS",	298,
	"LESS_THAN_SIGN",	299,
	"GREATER_THAN_SIGN",	300,
	"LEFT_SQUARE_BRACKET",	301,
	"RIGHT_SQUARE_BRACKET",	302,
	"APOSTROPHE",	303,
	"DOUBLE_QUOTE",	304,
	"REVERSE_SOLIDUS",	305,
	"VERTICAL_LINE",	306,
	"CIRCUMFLEX",	307,
	"AMPERSAND",	308,
	"ASTERISK",	309,
	"SOLIDUS",	310,
	"PERCENT_SIGN",	311,
	"TILDA",	312,
	"SHIFT_LEFT",	313,
	"SHIFT_RIGHT",	314,
	"SCOPE_DELIMITOR",	315,
	"IDENTIFIER",	316,
	"INTEGER_LITERAL",	317,
	"STRING_LITERAL",	318,
	"CHARACTER_LITERAL",	319,
	"FLOATING_PT_LITERAL",	320,
	"BOOLEAN_LITERAL",	321,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"start : Specification",
	"start : /* empty */",
	"Specification : Definition",
	"Specification : Specification Definition",
	"Definition : TypeDcl SEMI_COLON",
	"Definition : ConstDcl SEMI_COLON",
	"Definition : ExceptDcl SEMI_COLON",
	"Definition : Interface SEMI_COLON",
	"Definition : Module SEMI_COLON",
	"Module : MODULE Identifier LEFT_CURLY_BRACKET Definitions RIGHT_CURLY_BRACKET",
	"Definitions : Definition",
	"Definitions : Definitions Definition",
	"Interface : InterfaceDcl",
	"Interface : ForwardDcl",
	"InterfaceDcl : INTERFACE Identifier InheritanceSpecOpt LEFT_CURLY_BRACKET InterfaceBodyOpt RIGHT_CURLY_BRACKET",
	"InterfaceBodyOpt : InterfaceBody",
	"InterfaceBodyOpt : /* empty */",
	"ForwardDcl : INTERFACE Identifier",
	"InheritanceSpecOpt : InheritanceSpec",
	"InheritanceSpecOpt : /* empty */",
	"InterfaceBody : Export",
	"InterfaceBody : InterfaceBody Export",
	"Export : TypeDcl SEMI_COLON",
	"Export : ConstDcl SEMI_COLON",
	"Export : ExceptDcl SEMI_COLON",
	"Export : AttrDcl SEMI_COLON",
	"Export : OpDcl SEMI_COLON",
	"InheritanceSpec : COLON InheritanceSpecList",
	"InheritanceSpecList : ScopedName",
	"InheritanceSpecList : InheritanceSpecList COMMA ScopedName",
	"ScopedName : ScopedNameAOpt ScopedNameB",
	"ScopedNameAOpt : ScopedNameA",
	"ScopedNameAOpt : /* empty */",
	"ScopedNameA : SCOPE_DELIMITOR",
	"ScopedNameB : Identifier",
	"ScopedNameB : ScopedNameB SCOPE_DELIMITOR Identifier",
	"ConstDcl : CONST ConstType Identifier EQUALS_SIGN ConstExp",
	"ConstType : IntegerType",
	"ConstType : CharType",
	"ConstType : BooleanType",
	"ConstType : FloatingPtType",
	"ConstType : StringType",
	"ConstType : ScopedName",
	"ConstExp : OrExpr",
	"OrExpr : XorExpr",
	"OrExpr : OrOper",
	"OrOper : OrExpr VERTICAL_LINE XorExpr",
	"XorExpr : AndExpr",
	"XorExpr : XorOper",
	"XorOper : XorExpr CIRCUMFLEX AndExpr",
	"AndExpr : ShiftExpr",
	"AndExpr : AndOper",
	"AndOper : AndExpr AMPERSAND ShiftExpr",
	"ShiftExpr : AddExpr",
	"ShiftExpr : ShiftRightOper",
	"ShiftExpr : ShiftLeftOper",
	"ShiftRightOper : ShiftExpr SHIFT_RIGHT AddExpr",
	"ShiftLeftOper : ShiftExpr SHIFT_LEFT AddExpr",
	"AddExpr : MultExpr",
	"AddExpr : AddOper",
	"AddExpr : SubtractOper",
	"AddOper : AddExpr PLUS_SIGN MultExpr",
	"SubtractOper : AddExpr MINUS_SIGN MultExpr",
	"MultExpr : UnaryExpr",
	"MultExpr : MultOper",
	"MultExpr : DivOper",
	"MultExpr : RemainderOper",
	"MultOper : MultExpr ASTERISK UnaryExpr",
	"DivOper : MultExpr SOLIDUS UnaryExpr",
	"RemainderOper : MultExpr PERCENT_SIGN UnaryExpr",
	"UnaryExpr : PrimaryExpr",
	"UnaryExpr : UnaryMinusOper",
	"UnaryExpr : UnaryPlusOper",
	"UnaryExpr : UnaryNotOper",
	"UnaryMinusOper : MINUS_SIGN PrimaryExpr",
	"UnaryPlusOper : PLUS_SIGN PrimaryExpr",
	"UnaryNotOper : TILDA PrimaryExpr",
	"PrimaryExpr : ScopedName",
	"PrimaryExpr : Literal",
	"PrimaryExpr : LEFT_PARENTHESIS ConstExp RIGHT_PARENTHESIS",
	"Literal : IntegerLiteral",
	"Literal : StringLiteral",
	"Literal : CharacterLiteral",
	"Literal : FloatingPtLiteral",
	"Literal : BooleanLiteral",
	"PositiveIntConst : ConstExp",
	"TypeDcl : TYPEDEF TypeDeclarator",
	"TypeDcl : ConstrTypeSpec",
	"TypeDeclarator : TypeSpec Declarators",
	"TypeSpec : SimpleTypeSpec",
	"TypeSpec : ConstrTypeSpec",
	"SimpleTypeSpec : BaseTypeSpec",
	"SimpleTypeSpec : TemplateTypeSpec",
	"SimpleTypeSpec : ScopedName",
	"BaseTypeSpec : FloatingPtType",
	"BaseTypeSpec : IntegerType",
	"BaseTypeSpec : CharType",
	"BaseTypeSpec : BooleanType",
	"BaseTypeSpec : OctetType",
	"BaseTypeSpec : AnyType",
	"BaseTypeSpec : ObjectType",
	"ObjectType : OBJECT",
	"TemplateTypeSpec : SequenceType",
	"TemplateTypeSpec : StringType",
	"ConstrTypeSpec : StructType",
	"ConstrTypeSpec : UnionType",
	"ConstrTypeSpec : EnumType",
	"Declarators : Declarator",
	"Declarators : Declarators COMMA Declarator",
	"Declarator : SimpleDeclarator",
	"Declarator : ComplexDeclarator",
	"SimpleDeclarator : Identifier",
	"ComplexDeclarator : ArrayDeclarator",
	"FloatingPtType : FloatType",
	"FloatingPtType : DoubleType",
	"FloatType : FLOAT",
	"DoubleType : DOUBLE",
	"IntegerType : SignedInt",
	"IntegerType : UnsignedInt",
	"SignedInt : SignedLongInt",
	"SignedInt : SignedShortInt",
	"SignedLongInt : LONG",
	"SignedShortInt : SHORT",
	"UnsignedInt : UnsignedLongInt",
	"UnsignedInt : UnsignedShortInt",
	"UnsignedLongInt : UNSIGNED LONG",
	"UnsignedShortInt : UNSIGNED SHORT",
	"CharType : CHAR",
	"BooleanType : BOOLEAN",
	"OctetType : OCTET",
	"AnyType : ANY",
	"StructType : STRUCT Identifier LEFT_CURLY_BRACKET MemberList RIGHT_CURLY_BRACKET",
	"MemberList : Member",
	"MemberList : MemberList Member",
	"Member : TypeSpec Declarators SEMI_COLON",
	"UnionType : UNION Identifier UnionSwitch",
	"UnionSwitch : SWITCH LEFT_PARENTHESIS SwitchTypeSpec RIGHT_PARENTHESIS LEFT_CURLY_BRACKET SwitchBody RIGHT_CURLY_BRACKET",
	"SwitchTypeSpec : IntegerType",
	"SwitchTypeSpec : CharType",
	"SwitchTypeSpec : BooleanType",
	"SwitchTypeSpec : EnumType",
	"SwitchTypeSpec : ScopedName",
	"SwitchBody : Case",
	"SwitchBody : SwitchBody Case",
	"Case : CaseLabelList ElementSpec SEMI_COLON",
	"CaseLabelList : CaseLabel",
	"CaseLabelList : CaseLabelList CaseLabel",
	"CaseLabel : CASE ConstExp COLON",
	"CaseLabel : DEFAULT COLON",
	"ElementSpec : TypeSpec Declarator",
	"EnumType : ENUM Identifier LEFT_CURLY_BRACKET EnumeratorList RIGHT_CURLY_BRACKET",
	"EnumeratorList : Enumerator",
	"EnumeratorList : EnumeratorList COMMA Enumerator",
	"Enumerator : Identifier",
	"SequenceType : SEQUENCE LESS_THAN_SIGN SimpleTypeSpec COMMAPositiveIntConstOpt GREATER_THAN_SIGN",
	"COMMAPositiveIntConstOpt : COMMA PositiveIntConst",
	"COMMAPositiveIntConstOpt : /* empty */",
	"StringType : STRING StringSizeOpt",
	"StringSizeOpt : LESS_THAN_SIGN PositiveIntConst GREATER_THAN_SIGN",
	"StringSizeOpt : /* empty */",
	"ArrayDeclarator : Identifier FixedArraySizeList",
	"FixedArraySizeList : FixedArraySize",
	"FixedArraySizeList : FixedArraySizeList FixedArraySize",
	"FixedArraySize : LEFT_SQUARE_BRACKET PositiveIntConst RIGHT_SQUARE_BRACKET",
	"AttrDcl : ReadonlyOpt ATTRIBUTE ParamTypeSpec SimpleDeclaratorList",
	"ReadonlyOpt : READONLY",
	"ReadonlyOpt : /* empty */",
	"SimpleDeclaratorList : SimpleDeclarator",
	"SimpleDeclaratorList : SimpleDeclaratorList COMMA SimpleDeclarator",
	"ExceptDcl : EXCEPTION Identifier LEFT_CURLY_BRACKET MemberListOpt RIGHT_CURLY_BRACKET",
	"MemberListOpt : MemberList",
	"MemberListOpt : /* empty */",
	"OpDcl : OpTypeSpec Identifier ParameterDcls RaisesExprOpt ContextExprOpt",
	"OpAttributeOpt : OpAttribute",
	"OpAttributeOpt : /* empty */",
	"RaisesExprOpt : RaisesExpr",
	"RaisesExprOpt : /* empty */",
	"ContextExprOpt : ContextExpr",
	"ContextExprOpt : /* empty */",
	"OpAttribute : ONEWAY",
	"OpTypeSpec : ParamTypeSpec",
	"OpTypeSpec : OpTypeSpecA",
	"OpTypeSpecA : OpAttributeOpt OpTypeSpecB",
	"OpTypeSpecB : VOID",
	"ParameterDcls : LEFT_PARENTHESIS ParameterDclsAOpt RIGHT_PARENTHESIS",
	"ParameterDclsAOpt : ParameterDclsA",
	"ParameterDclsAOpt : /* empty */",
	"ParameterDclsA : ParamDcl",
	"ParameterDclsA : ParameterDclsA COMMA ParamDcl",
	"ParamDcl : ParamAttribute ParamTypeSpec SimpleDeclarator",
	"ParamAttribute : IN",
	"ParamAttribute : OUT",
	"ParamAttribute : INOUT",
	"RaisesExpr : RAISES LEFT_PARENTHESIS RaisesExprList RIGHT_PARENTHESIS",
	"RaisesExprList : ScopedName",
	"RaisesExprList : RaisesExprList COMMA ScopedName",
	"ContextExpr : CONTEXT LEFT_PARENTHESIS ContextExprList RIGHT_PARENTHESIS",
	"ContextExprList : StringLiteral",
	"ContextExprList : ContextExprList COMMA StringLiteral",
	"ParamTypeSpec : BaseTypeSpec",
	"ParamTypeSpec : StringType",
	"ParamTypeSpec : ScopedName",
	"CharacterLiteral : CHARACTER_LITERAL",
	"FloatingPtLiteral : FLOATING_PT_LITERAL",
	"IntegerLiteral : INTEGER_LITERAL",
	"StringLiteral : StringLiteralList",
	"StringLiteralList : STRING_LITERAL",
	"StringLiteralList : StringLiteralList STRING_LITERAL",
	"Identifier : IDENTIFIER",
	"BooleanLiteral : BOOLEAN_LITERAL",
};
#endif /* YYDEBUG */
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */


/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yynewmax * sizeof(type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside switch should never be
	executed; yypvt is set to 0 to avoid "used before set" warning.
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
	yypvt = 0;
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 3:
{
                  specification << yypvt[-0].definition;
               } break;
case 4:
{
                  specification << yypvt[-0].definition;
               } break;
case 5:
{
                  yyval.definition = new Definition;
                  *yyval.definition << yypvt[-1].typeDcl;
               } break;
case 6:
{
                  yyval.definition = new Definition;
                  *yyval.definition << yypvt[-1].constDcl;
               } break;
case 7:
{
                  yyval.definition = new Definition;
                  *yyval.definition << yypvt[-1].exceptDcl;
               } break;
case 8:
{
                  yyval.definition = new Definition;
                  *yyval.definition << yypvt[-1].interface;
               } break;
case 9:
{
                  yyval.definition = new Definition;
                  *yyval.definition << yypvt[-1].module;
               } break;
case 10:
{
                  yyval.module = new Module;
                  *yyval.module << yypvt[-3].identifier << yypvt[-1].definitions;
               } break;
case 11:
{
                  yyval.definitions = new Definitions;
                  *yyval.definitions << yypvt[-0].definition;
               } break;
case 12:
{
                  yyval.definitions = yypvt[-1].definitions;
                  *yyval.definitions << yypvt[-0].definition;
               } break;
case 13:
{
                  yyval.interface = new Interface;
                  *yyval.interface << yypvt[-0].interfaceDcl;
               } break;
case 14:
{
                  yyval.interface = new Interface;
                  *yyval.interface << yypvt[-0].forwardDcl;
               } break;
case 15:
{
                  yyval.interfaceDcl = new InterfaceDcl;
                  *yyval.interfaceDcl << yypvt[-4].identifier << yypvt[-3].inheritanceSpec << yypvt[-1].interfaceBody;
               } break;
case 16:
{
                 yyval.interfaceBody = yypvt[-0].interfaceBody;
               } break;
case 17:
{
                 yyval.interfaceBody = 0;
               } break;
case 18:
{
                  yyval.forwardDcl = new ForwardDcl;
                  *yyval.forwardDcl << yypvt[-0].identifier;
               } break;
case 19:
{
                  yyval.inheritanceSpec = yypvt[-0].inheritanceSpec;
               } break;
case 20:
{
                  yyval.inheritanceSpec = 0;
               } break;
case 21:
{
                  yyval.interfaceBody = new InterfaceBody;
                  *yyval.interfaceBody << yypvt[-0].exp;
               } break;
case 22:
{
                  yyval.interfaceBody = yypvt[-1].interfaceBody;
                  *yyval.interfaceBody << yypvt[-0].exp;
               } break;
case 23:
{
                  yyval.exp = new Export;
                  *yyval.exp << yypvt[-1].typeDcl;
               } break;
case 24:
{
                  yyval.exp = new Export;
                  *yyval.exp << yypvt[-1].constDcl;
               } break;
case 25:
{
                  yyval.exp = new Export;
                  *yyval.exp << yypvt[-1].exceptDcl;
               } break;
case 26:
{
                  yyval.exp = new Export;
                  *yyval.exp << yypvt[-1].attrDcl;
               } break;
case 27:
{
                  yyval.exp = new Export;
                  *yyval.exp << yypvt[-1].opDcl;
               } break;
case 28:
{
                  yyval.inheritanceSpec = yypvt[-0].inheritanceSpec;
               } break;
case 29:
{
                  yyval.inheritanceSpec = new InheritanceSpec;
                  *yyval.inheritanceSpec << yypvt[-0].scopedName;
               } break;
case 30:
{
                  yyval.inheritanceSpec = yypvt[-2].inheritanceSpec;
                  *yyval.inheritanceSpec << yypvt[-0].scopedName;
               } break;
case 31:
{
                  yyval.scopedName = new _ScopedName;
                  *yyval.scopedName << yypvt[-1].scopedNameA << yypvt[-0].scopedNameB;
               } break;
case 32:
{
                  yyval.scopedNameA = yypvt[-0].scopedNameA;
               } break;
case 33:
{
                  yyval.scopedNameA = 0;
               } break;
case 34:
{
                  yyval.scopedNameA = new ScopedNameA;
               } break;
case 35:
{
                  yyval.scopedNameB = new ScopedNameB;
                  *yyval.scopedNameB << yypvt[-0].identifier;
               } break;
case 36:
{
                  yyval.scopedNameB = yypvt[-2].scopedNameB;
                  *yyval.scopedNameB << yypvt[-0].identifier;
               } break;
case 37:
{
                  yyval.constDcl = new ConstDcl;
                  *yyval.constDcl << yypvt[-3].constType << yypvt[-2].identifier << yypvt[-0].constExp;
               } break;
case 38:
{
                  yyval.constType = new ConstType;
                  *yyval.constType << yypvt[-0].integerType;
               } break;
case 39:
{
                  yyval.constType = new ConstType;
                  *yyval.constType << yypvt[-0].charType;
               } break;
case 40:
{
                  yyval.constType = new ConstType;
                  *yyval.constType << yypvt[-0].booleanType;
               } break;
case 41:
{
                  yyval.constType = new ConstType;
                  *yyval.constType << yypvt[-0].floatingPtType;
               } break;
case 42:
{
                  yyval.constType = new ConstType;
                  *yyval.constType << yypvt[-0].stringType;
               } break;
case 43:
{
                  yyval.constType = new ConstType;
                  *yyval.constType << yypvt[-0].scopedName;
               } break;
case 44:
{
                  yyval.constExp = new ConstExp;
                  *yyval.constExp << yypvt[-0].orExpr;
               } break;
case 45:
{
                  yyval.orExpr = new OrExpr;
                  *yyval.orExpr << yypvt[-0].xorExpr;
               } break;
case 46:
{
                  yyval.orExpr = new OrExpr;
                  *yyval.orExpr << yypvt[-0].orOper;
               } break;
case 47:
{
                  yyval.orOper = new OrOper;
                  *yyval.orOper << yypvt[-2].orExpr << yypvt[-0].xorExpr;
               } break;
case 48:
{
                  yyval.xorExpr = new XorExpr;
                  *yyval.xorExpr << yypvt[-0].andExpr;
               } break;
case 49:
{
                  yyval.xorExpr = new XorExpr;
                  *yyval.xorExpr << yypvt[-0].xorOper;
               } break;
case 50:
{
                  yyval.xorOper = new XorOper;
                  *yyval.xorOper << yypvt[-2].xorExpr << yypvt[-0].andExpr;
               } break;
case 51:
{
                  yyval.andExpr = new AndExpr;
                  *yyval.andExpr << yypvt[-0].shiftExpr;
               } break;
case 52:
{
                  yyval.andExpr = new AndExpr;
                  *yyval.andExpr << yypvt[-0].andOper;
               } break;
case 53:
{
                  yyval.andOper = new AndOper;
                  *yyval.andOper << yypvt[-2].andExpr << yypvt[-0].shiftExpr;
               } break;
case 54:
{
                  yyval.shiftExpr = new ShiftExpr;
                  *yyval.shiftExpr << yypvt[-0].addExpr;
               } break;
case 55:
{
                  yyval.shiftExpr = new ShiftExpr;
                  *yyval.shiftExpr << yypvt[-0].shiftRightOper;
               } break;
case 56:
{
                  yyval.shiftExpr = new ShiftExpr;
                  *yyval.shiftExpr << yypvt[-0].shiftLeftOper;
               } break;
case 57:
{
                  yyval.shiftRightOper = new ShiftRightOper;
                  *yyval.shiftRightOper << yypvt[-2].shiftExpr << yypvt[-0].addExpr;
               } break;
case 58:
{
                  yyval.shiftLeftOper = new ShiftLeftOper;
                  *yyval.shiftLeftOper << yypvt[-2].shiftExpr << yypvt[-0].addExpr;
               } break;
case 59:
{
                  yyval.addExpr = new AddExpr;
                  *yyval.addExpr << yypvt[-0].multExpr;
               } break;
case 60:
{
                  yyval.addExpr = new AddExpr;
                  *yyval.addExpr << yypvt[-0].addOper;
               } break;
case 61:
{
                  yyval.addExpr = new AddExpr;
                  *yyval.addExpr << yypvt[-0].subtractOper;
               } break;
case 62:
{
                  yyval.addOper = new AddOper;
                  *yyval.addOper << yypvt[-2].addExpr << yypvt[-0].multExpr;
               } break;
case 63:
{
                  yyval.subtractOper = new SubtractOper;
                  *yyval.subtractOper << yypvt[-2].addExpr << yypvt[-0].multExpr;
               } break;
case 64:
{
                  yyval.multExpr = new MultExpr;
                  *yyval.multExpr << yypvt[-0].unaryExpr;
               } break;
case 65:
{
                  yyval.multExpr = new MultExpr;
                  *yyval.multExpr << yypvt[-0].multOper;
               } break;
case 66:
{
                  yyval.multExpr = new MultExpr;
                  *yyval.multExpr << yypvt[-0].divOper;
               } break;
case 67:
{
                  yyval.multExpr = new MultExpr;
                  *yyval.multExpr << yypvt[-0].remainderOper;
               } break;
case 68:
{
                  yyval.multOper = new MultOper;
                  *yyval.multOper << yypvt[-2].multExpr << yypvt[-0].unaryExpr;
               } break;
case 69:
{
                  yyval.divOper = new DivOper;
                  *yyval.divOper << yypvt[-2].multExpr << yypvt[-0].unaryExpr;
               } break;
case 70:
{
                  yyval.remainderOper = new RemainderOper;
                  *yyval.remainderOper << yypvt[-2].multExpr << yypvt[-0].unaryExpr;
               } break;
case 71:
{
                  yyval.unaryExpr = new UnaryExpr;
                  *yyval.unaryExpr << yypvt[-0].primaryExpr;
               } break;
case 72:
{
                  yyval.unaryExpr = new UnaryExpr;
                  *yyval.unaryExpr << yypvt[-0].unaryMinusOper;
               } break;
case 73:
{
                  yyval.unaryExpr = new UnaryExpr;
                  *yyval.unaryExpr << yypvt[-0].unaryPlusOper;
               } break;
case 74:
{
                  yyval.unaryExpr = new UnaryExpr;
                  *yyval.unaryExpr << yypvt[-0].unaryNotOper;
               } break;
case 75:
{
                  yyval.unaryMinusOper = new UnaryMinusOper;
                  *yyval.unaryMinusOper << yypvt[-0].primaryExpr;
               } break;
case 76:
{
                  yyval.unaryPlusOper = new UnaryPlusOper;
                  *yyval.unaryPlusOper << yypvt[-0].primaryExpr;
               } break;
case 77:
{
                  yyval.unaryNotOper = new UnaryNotOper;
                  *yyval.unaryNotOper << yypvt[-0].primaryExpr;
               } break;
case 78:
{
                  yyval.primaryExpr = new PrimaryExpr;
                  *yyval.primaryExpr << yypvt[-0].scopedName;
               } break;
case 79:
{
                  yyval.primaryExpr = new PrimaryExpr;
                  *yyval.primaryExpr << yypvt[-0].literal;
               } break;
case 80:
{
                  yyval.primaryExpr = new PrimaryExpr;
                  *yyval.primaryExpr << yypvt[-1].constExp;
               } break;
case 81:
{
                  yyval.literal = new Literal;
                  *yyval.literal << yypvt[-0].integerLiteral;
               } break;
case 82:
{
                  yyval.literal = new Literal;
                  *yyval.literal << yypvt[-0].stringLiteral;
               } break;
case 83:
{
                  yyval.literal = new Literal;
                  *yyval.literal << yypvt[-0].characterLiteral;
               } break;
case 84:
{
                  yyval.literal = new Literal;
                  *yyval.literal << yypvt[-0].floatingPtLiteral;
               } break;
case 85:
{
                  yyval.literal = new Literal;
                  *yyval.literal << yypvt[-0].booleanLiteral;
               } break;
case 86:
{
                  yyval.positiveIntConst = new PositiveIntConst;
                  *yyval.positiveIntConst << yypvt[-0].constExp;
               } break;
case 87:
{
                  yyval.typeDcl = new TypeDcl;
                  *yyval.typeDcl << yypvt[-0].typeDeclarator;
               } break;
case 88:
{
                  yyval.typeDcl = new TypeDcl;
                  *yyval.typeDcl << yypvt[-0].constrTypeSpec;
               } break;
case 89:
{
                  yyval.typeDeclarator = new TypeDeclarator;
                  *yyval.typeDeclarator << yypvt[-1].typeSpec << yypvt[-0].declarators;
               } break;
case 90:
{
                  yyval.typeSpec = new TypeSpec;
                  *yyval.typeSpec << yypvt[-0].simpleTypeSpec;
               } break;
case 91:
{
                  yyval.typeSpec = new TypeSpec;
                  *yyval.typeSpec << yypvt[-0].constrTypeSpec;
               } break;
case 92:
{
                  yyval.simpleTypeSpec = new SimpleTypeSpec;
                  *yyval.simpleTypeSpec << yypvt[-0].baseTypeSpec;
               } break;
case 93:
{
                  yyval.simpleTypeSpec = new SimpleTypeSpec;
                  *yyval.simpleTypeSpec << yypvt[-0].templateTypeSpec;
               } break;
case 94:
{
                  yyval.simpleTypeSpec = new SimpleTypeSpec;
                  *yyval.simpleTypeSpec << yypvt[-0].scopedName;
               } break;
case 95:
{
                  yyval.baseTypeSpec = new BaseTypeSpec;
                  *yyval.baseTypeSpec << yypvt[-0].floatingPtType;
               } break;
case 96:
{
                  yyval.baseTypeSpec = new BaseTypeSpec;
                  *yyval.baseTypeSpec << yypvt[-0].integerType;
               } break;
case 97:
{
                  yyval.baseTypeSpec = new BaseTypeSpec;
                  *yyval.baseTypeSpec << yypvt[-0].charType;
               } break;
case 98:
{
                  yyval.baseTypeSpec = new BaseTypeSpec;
                  *yyval.baseTypeSpec << yypvt[-0].booleanType;
               } break;
case 99:
{
                  yyval.baseTypeSpec = new BaseTypeSpec;
                  *yyval.baseTypeSpec << yypvt[-0].octetType;
               } break;
case 100:
{
                  yyval.baseTypeSpec = new BaseTypeSpec;
                  *yyval.baseTypeSpec << yypvt[-0].anyType;
               } break;
case 101:
{
                  yyval.baseTypeSpec = new BaseTypeSpec;
                  *yyval.baseTypeSpec << yypvt[-0].objectType;
               } break;
case 102:
{
                  yyval.objectType = new ObjectType;
               } break;
case 103:
{
                  yyval.templateTypeSpec = new TemplateTypeSpec;
                  *yyval.templateTypeSpec << yypvt[-0].sequenceType;
               } break;
case 104:
{
                  yyval.templateTypeSpec = new TemplateTypeSpec;
                  *yyval.templateTypeSpec << yypvt[-0].stringType;
               } break;
case 105:
{
                  yyval.constrTypeSpec = new ConstrTypeSpec;
                  *yyval.constrTypeSpec << yypvt[-0].structType;
               } break;
case 106:
{
                  yyval.constrTypeSpec = new ConstrTypeSpec;
                  *yyval.constrTypeSpec << yypvt[-0].unionType;
               } break;
case 107:
{
                  yyval.constrTypeSpec = new ConstrTypeSpec;
                  *yyval.constrTypeSpec << yypvt[-0].enumType;
               } break;
case 108:
{
                  yyval.declarators = new Declarators;
                  *yyval.declarators << yypvt[-0].declarator;
               } break;
case 109:
{
                  yyval.declarators = yypvt[-2].declarators;
                  *yyval.declarators << yypvt[-0].declarator;
               } break;
case 110:
{
                  yyval.declarator = new Declarator;
                  *yyval.declarator << yypvt[-0].simpleDeclarator;
               } break;
case 111:
{
                  yyval.declarator = new Declarator;
                  *yyval.declarator << yypvt[-0].complexDeclarator;
               } break;
case 112:
{
                  yyval.simpleDeclarator = new SimpleDeclarator;
                  *yyval.simpleDeclarator << yypvt[-0].identifier;
               } break;
case 113:
{
                  yyval.complexDeclarator = new ComplexDeclarator;
                  *yyval.complexDeclarator << yypvt[-0].arrayDeclarator;
               } break;
case 114:
{
                  yyval.floatingPtType = new FloatingPtType;
                  *yyval.floatingPtType << yypvt[-0].floatType;
               } break;
case 115:
{
                 yyval.floatingPtType = new FloatingPtType;
                 *yyval.floatingPtType << yypvt[-0].doubleType;
               } break;
case 116:
{
                 yyval.floatType = new FloatType;
               } break;
case 117:
{
                 yyval.doubleType = new DoubleType;
               } break;
case 118:
{
                  yyval.integerType = new IntegerType;
                  *yyval.integerType << yypvt[-0].signedInt;
               } break;
case 119:
{
                  yyval.integerType = new IntegerType;
                  *yyval.integerType << yypvt[-0].unsignedInt;
               } break;
case 120:
{
                  yyval.signedInt = new SignedInt;
                  *yyval.signedInt << yypvt[-0].signedLongInt;
               } break;
case 121:
{
                  yyval.signedInt = new SignedInt;
                  *yyval.signedInt << yypvt[-0].signedShortInt;
               } break;
case 122:
{
                  yyval.signedLongInt = new SignedLongInt;
               } break;
case 123:
{
                  yyval.signedShortInt = new SignedShortInt;
               } break;
case 124:
{
                  yyval.unsignedInt = new UnsignedInt;
                  *yyval.unsignedInt << yypvt[-0].unsignedLongInt;
               } break;
case 125:
{
                  yyval.unsignedInt = new UnsignedInt;
                  *yyval.unsignedInt << yypvt[-0].unsignedShortInt;
               } break;
case 126:
{
                  yyval.unsignedLongInt = new UnsignedLongInt;
               } break;
case 127:
{
                  yyval.unsignedShortInt = new UnsignedShortInt;
               } break;
case 128:
{
                  yyval.charType = new CharType;
               } break;
case 129:
{
                  yyval.booleanType = new BooleanType;
               } break;
case 130:
{
                  yyval.octetType = new OctetType;
               } break;
case 131:
{
                  yyval.anyType = new AnyType;
               } break;
case 132:
{
                  yyval.structType = new StructType;
                  *yyval.structType << yypvt[-3].identifier << yypvt[-1].memberList;
               } break;
case 133:
{
                  yyval.memberList = new MemberList;
                  *yyval.memberList << yypvt[-0].member;
               } break;
case 134:
{
                  yyval.memberList = yypvt[-1].memberList;
                  *yyval.memberList << yypvt[-0].member;
               } break;
case 135:
{
                  yyval.member = new Member;
                  *yyval.member << yypvt[-2].typeSpec << yypvt[-1].declarators;
               } break;
case 136:
{
                  yyval.unionType = new UnionType;
                  *yyval.unionType << yypvt[-1].identifier << yypvt[-0].unionSwitch;
               } break;
case 137:
{
                  yyval.unionSwitch = new UnionSwitch;
                  *yyval.unionSwitch << yypvt[-4].switchTypeSpec << yypvt[-1].switchBody;
               } break;
case 138:
{
                  yyval.switchTypeSpec = new SwitchTypeSpec;
                  *yyval.switchTypeSpec << yypvt[-0].integerType;
               } break;
case 139:
{
                  yyval.switchTypeSpec = new SwitchTypeSpec;
                  *yyval.switchTypeSpec << yypvt[-0].charType;
               } break;
case 140:
{
                  yyval.switchTypeSpec = new SwitchTypeSpec;
                  *yyval.switchTypeSpec << yypvt[-0].booleanType;
               } break;
case 141:
{
                  yyval.switchTypeSpec = new SwitchTypeSpec;
                  *yyval.switchTypeSpec << yypvt[-0].enumType;
               } break;
case 142:
{
                  yyval.switchTypeSpec = new SwitchTypeSpec;
                  *yyval.switchTypeSpec << yypvt[-0].scopedName;
               } break;
case 143:
{
                  yyval.switchBody = new SwitchBody;
                  *yyval.switchBody << yypvt[-0]._case;
               } break;
case 144:
{
                  yyval.switchBody = yypvt[-1].switchBody;
                  *yyval.switchBody << yypvt[-0]._case;
               } break;
case 145:
{
                  yyval._case = new Case;
                  *yyval._case << yypvt[-2].caseLabelList << yypvt[-1].elementSpec;
               } break;
case 146:
{
                  yyval.caseLabelList = new CaseLabelList;
                  *yyval.caseLabelList << yypvt[-0].caseLabel;
               } break;
case 147:
{
                  yyval.caseLabelList = yypvt[-1].caseLabelList;
                  *yyval.caseLabelList << yypvt[-0].caseLabel;
               } break;
case 148:
{
                  yyval.caseLabel = new CaseLabel;
                  *yyval.caseLabel << yypvt[-1].constExp;
               } break;
case 149:
{
                  yyval.caseLabel = new CaseLabel;
                  *yyval.caseLabel << new DefaultLabel;
               } break;
case 150:
{
                  yyval.elementSpec = new ElementSpec;
                  *yyval.elementSpec << yypvt[-1].typeSpec << yypvt[-0].declarator;
               } break;
case 151:
{
                  yyval.enumType = new EnumType;
                  *yyval.enumType << yypvt[-3].identifier << yypvt[-1].enumeratorList;
               } break;
case 152:
{
                  yyval.enumeratorList = new EnumeratorList;
                  *yyval.enumeratorList << yypvt[-0].enumerator;
               } break;
case 153:
{
                  yyval.enumeratorList = yypvt[-2].enumeratorList;
                  *yyval.enumeratorList << yypvt[-0].enumerator;
               } break;
case 154:
{
                  yyval.enumerator = new Enumerator;
                  *yyval.enumerator << yypvt[-0].identifier;
               } break;
case 155:
{
                  yyval.sequenceType = new SequenceType;
                  *yyval.sequenceType << yypvt[-2].simpleTypeSpec << yypvt[-1].positiveIntConst;
               } break;
case 156:
{
                 yyval.positiveIntConst = yypvt[-0].positiveIntConst;
               } break;
case 157:
{
                 yyval.positiveIntConst = 0;
               } break;
case 158:
{
                  yyval.stringType = new StringType;
                  *yyval.stringType << yypvt[-0].positiveIntConst;
               } break;
case 159:
{
                 yyval.positiveIntConst = yypvt[-1].positiveIntConst;
               } break;
case 160:
{
                 yyval.positiveIntConst = 0;
               } break;
case 161:
{
                  yyval.arrayDeclarator = new ArrayDeclarator;
                  *yyval.arrayDeclarator << yypvt[-1].identifier << yypvt[-0].fixedArraySizeList;
               } break;
case 162:
{
                  yyval.fixedArraySizeList = new FixedArraySizeList;
                  *yyval.fixedArraySizeList << yypvt[-0].fixedArraySize;
               } break;
case 163:
{
                  yyval.fixedArraySizeList = yypvt[-1].fixedArraySizeList;
                  *yyval.fixedArraySizeList << yypvt[-0].fixedArraySize;
               } break;
case 164:
{
                  yyval.fixedArraySize = new FixedArraySize;
                  *yyval.fixedArraySize << yypvt[-1].positiveIntConst;
               } break;
case 165:
{
                  yyval.attrDcl = new AttrDcl;
                  *yyval.attrDcl << yypvt[-3].readonly << yypvt[-1].paramTypeSpec << yypvt[-0].simpleDeclaratorList;
               } break;
case 166:
{
                  yyval.readonly = new Readonly;
               } break;
case 167:
{
                  yyval.readonly = 0;
               } break;
case 168:
{
                  yyval.simpleDeclaratorList = new SimpleDeclaratorList;
                  *yyval.simpleDeclaratorList << yypvt[-0].simpleDeclarator;
               } break;
case 169:
{
                  yyval.simpleDeclaratorList = yypvt[-2].simpleDeclaratorList;
                  *yyval.simpleDeclaratorList << yypvt[-0].simpleDeclarator;
               } break;
case 170:
{
                  yyval.exceptDcl = new ExceptDcl;
                  *yyval.exceptDcl << yypvt[-3].identifier << yypvt[-1].memberList;
               } break;
case 171:
{
                 yyval.memberList = yypvt[-0].memberList;
               } break;
case 172:
{
                yyval.memberList = 0;
               } break;
case 173:
{
                  yyval.opDcl = new OpDcl;
                  *yyval.opDcl << yypvt[-4].opTypeSpec << yypvt[-3].identifier << yypvt[-2].parameterDcls << yypvt[-1].raisesExpr << yypvt[-0].contextExpr;
               } break;
case 174:
{
                  yyval.opAttribute = yypvt[-0].opAttribute;
               } break;
case 175:
{
                  yyval.opAttribute = 0;
               } break;
case 176:
{
                  yyval.raisesExpr = yypvt[-0].raisesExpr;
               } break;
case 177:
{
                  yyval.raisesExpr = 0;
               } break;
case 178:
{
                  yyval.contextExpr = yypvt[-0].contextExpr;
               } break;
case 179:
{
                  yyval.contextExpr = 0;
               } break;
case 180:
{
                  yyval.opAttribute = new OpAttribute;
               } break;
case 181:
{
                  yyval.opTypeSpec = new OpTypeSpec;
                  *yyval.opTypeSpec << yypvt[-0].paramTypeSpec;
               } break;
case 182:
{
                  yyval.opTypeSpec = new OpTypeSpec;
                  *yyval.opTypeSpec << yypvt[-0].opTypeSpecA;
               } break;
case 183:
{
                  yyval.opTypeSpecA = new OpTypeSpecA;
                *yyval.opTypeSpecA << yypvt[-1].opAttribute << yypvt[-0].opTypeSpecB;
               } break;
case 184:
{
                  yyval.opTypeSpecB = new OpTypeSpecB;
               } break;
case 185:
{
                  yyval.parameterDcls = new ParameterDcls;
                  *yyval.parameterDcls << yypvt[-1].parameterDclsA;
               } break;
case 186:
{
                 yyval.parameterDclsA = yypvt[-0].parameterDclsA;
               } break;
case 187:
{
                 yyval.parameterDclsA = 0;
               } break;
case 188:
{
                  yyval.parameterDclsA = new ParameterDclsA;
                  *yyval.parameterDclsA << yypvt[-0].paramDcl;
               } break;
case 189:
{
                  yyval.parameterDclsA = yypvt[-2].parameterDclsA;
                  *yyval.parameterDclsA << yypvt[-0].paramDcl;
               } break;
case 190:
{
                  yyval.paramDcl = new ParamDcl;
                  *yyval.paramDcl << yypvt[-2].paramAttribute << yypvt[-1].paramTypeSpec << yypvt[-0].simpleDeclarator;
               } break;
case 191:
{
                  yyval.paramAttribute = new ParamAttribute;
                *((SimpleChoiceNode*)yyval.paramAttribute) = 0;
               } break;
case 192:
{
                  yyval.paramAttribute = new ParamAttribute;
                *((SimpleChoiceNode*)yyval.paramAttribute) = 1;
               } break;
case 193:
{
                  yyval.paramAttribute = new ParamAttribute;
                *((SimpleChoiceNode*)yyval.paramAttribute) = 2;
               } break;
case 194:
{
                  yyval.raisesExpr = yypvt[-1].raisesExpr;
               } break;
case 195:
{
                  yyval.raisesExpr = new RaisesExpr;
                  *yyval.raisesExpr << yypvt[-0].scopedName;
               } break;
case 196:
{
                  yyval.raisesExpr = yypvt[-2].raisesExpr;
                  *yyval.raisesExpr << yypvt[-0].scopedName;
               } break;
case 197:
{
                  yyval.contextExpr = yypvt[-1].contextExpr;
               } break;
case 198:
{
                  yyval.contextExpr = new ContextExpr;
                  *yyval.contextExpr << yypvt[-0].stringLiteral;
               } break;
case 199:
{
                  yyval.contextExpr = yypvt[-2].contextExpr;
                  *yyval.contextExpr << yypvt[-0].stringLiteral;
               } break;
case 200:
{
                  yyval.paramTypeSpec = new ParamTypeSpec;
                  *yyval.paramTypeSpec << yypvt[-0].baseTypeSpec;
               } break;
case 201:
{
                  yyval.paramTypeSpec = new ParamTypeSpec;
                  *yyval.paramTypeSpec << yypvt[-0].stringType;
               } break;
case 202:
{
                  yyval.paramTypeSpec = new ParamTypeSpec;
                  *yyval.paramTypeSpec << yypvt[-0].scopedName;
               } break;
case 203:
{
                 yyval.characterLiteral = new CharacterLiteral;
                 *yyval.characterLiteral = yypvt[-0].string;
                 free(yypvt[-0].string);
               } break;
case 204:
{
                 yyval.floatingPtLiteral = new FloatingPtLiteral;
                 *yyval.floatingPtLiteral = yypvt[-0].string;
                 free(yypvt[-0].string);
               } break;
case 205:
{
                 yyval.integerLiteral = new IntegerLiteral;
                 *yyval.integerLiteral = yypvt[-0].string;
                 free(yypvt[-0].string);
               } break;
case 206:
{
                 yyval.stringLiteral = new StringLiteral;
                 *yyval.stringLiteral = yypvt[-0].stringLiteralList;
                 free(yypvt[-0].stringLiteralList);
               } break;
case 207:
{
                  yyval.stringLiteralList = yypvt[-0].string;
               } break;
case 208:
{
									yyval.stringLiteralList = (char *)calloc (strlen(yypvt[-1].stringLiteralList) + strlen(yypvt[-0].string) + 1,sizeof(char));
									strcpy(yyval.stringLiteralList,yypvt[-1].stringLiteralList);
									strcat((yyval.stringLiteralList),yypvt[-0].string);
									free(yypvt[-1].stringLiteralList);
									free(yypvt[-0].string);
               } break;
case 209:
{
                 yyval.identifier = new _Identifier;
                 *yyval.identifier = yypvt[-0].string;
                 free(yypvt[-0].string);
               } break;
case 210:
{
                 yyval.booleanLiteral = new BooleanLiteral;
                 *yyval.booleanLiteral = yypvt[-0].string;
                 free(yypvt[-0].string);
               } break;
	}
	goto yystack;		/* reset registers in driver code */
}

