//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/utils/nodes/src/types.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:07:14  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.2  1997/10/14 10:24:18  james
// Extended types removed
//
// Revision 1.1  1997/10/06 11:36:06  james
// Initial Sources
//
//

#include "types.hh"

char  *NodeNames[MAX_NODE_ID+1] = {
  "NotInitialised",
  "Specification",
  "Definition",
  "Module",
  "Definitions",
  "Interface",
  "InterfaceDcl",
  "ForwardDcl",
  "InterfaceBody",
  "Export",
  "InheritanceSpec",
  "ScopedName",
  "ScopedNameA",
  "ScopedNameB",
  "ConstDcl",
  "ConstType",
  "ConstExp",
  "OrExpr",
  "OrOper",
  "XorExpr",
  "XorOper",
  "AndExpr",
  "AndOper",
  "ShiftExpr",
  "ShiftRightOper",
  "ShiftLeftOper",
  "AddExpr",
  "AddOper",
  "SubtractOper",
  "MultExpr",
  "MultOper",
  "DivOper",
  "RemainderOper",
  "UnaryExpr",
  "UnaryMinusOper",
  "UnaryPlusOper",
  "UnaryNotOper",
  "PrimaryExpr",
  "Literal",
  "BooleanLiteral",
  "PositiveIntConst",
  "TypeDcl",
  "TypeDeclarator",
  "TypeSpec",
  "SimpleTypeSpec",
  "BaseTypeSpec",
  "ObjectType",
  "TemplateTypeSpec",
  "ConstrTypeSpec",
  "Declarators",
  "Declarator",
  "SimpleDeclarator",
  "ComplexDeclarator",
  "FloatingPtType",
  "FloatType",
  "DoubleType",
  "IntegerType",
  "SignedInt",
  "SignedLongInt",
  "SignedShortInt",
  "UnsignedInt",
  "UnsignedLongInt",
  "UnsignedShortInt",
  "CharType",
  "BooleanType",
  "OctetType",
  "AnyType",
  "StructType",
  "MemberList",
  "Member",
  "UnionType",
  "UnionSwitch",
  "SwitchTypeSpec",
  "SwitchBody",
  "Case",
  "CaseLabel",
  "DefaultLabel",
  "CaseLabelList",
  "ElementSpec",
  "EnumType",
  "Enumerator",
  "EnumeratorList",
  "SequenceType",
  "StringType",
  "ArrayDeclarator",
  "FixedArraySizeList",
  "FixedArraySize",
  "AttrDcl",
  "Readonly",
  "SimpleDeclaratorList",
  "ExceptDcl",
  "OpDcl",
  "OpTypeSpec",
  "OpTypeSpecA",
  "OpTypeSpecB",
  "OpAttribute",
  "ParameterDcls",
  "ParameterDclsA",
  "ParamDcl",
  "ParamAttribute",
  "RaisesExpr",
  "ContextExpr",
  "ParamTypeSpec",
  "Identifier",
  "IntegerLiteral",
  "CharacterLiteral",
  "StringLiteral",
  "FloatingPtLiteral",
  "ScopedNameBList",
  "MAX_NODE_ID"
  };

char  *TypeSpecifierStrings[tsMAX+1] = {
  "Undefined",
  "Short",
  "UShort",
  "Long",
  "ULong",
  "Float",
  "Double",
  "Boolean",
  "Char",
  "String",
  "Any",
  "Octet",
  "Enum",
  "MAX"
  };

char  *EvalTypeStrings[etMAX+1] = {
  "Undefined",
  "Long",
  "ULong",
  "Double",
  "Boolean",
  "Char",
  "String",
  "MAX"
  };


ostream &operator<<(ostream &output, const NodeId id)
{
  if (id < 0 || id >= MAX_NODE_ID)
    output << "NodeId(" << (int)id << ")";
  else
    output << NodeNames[id];
  return output;
}

fstream &operator<<(fstream &output, const NodeId id)
{
  if (id < 0 || id >= MAX_NODE_ID)
    output << "NodeId(" << (int)id << ")";
  else
    output << NodeNames[id];
  return output;
}

fstream &operator<<(fstream &output, const TypeSpecifier ts)
{
  if (ts < 0 || ts >= tsMAX)
    output << "TypeSpecifier(" << (int)ts << ")";
  else
    output << TypeSpecifierStrings[ts];
  return output;
}

ostream &operator<<(ostream &output, const TypeSpecifier ts)
{
  if (ts < 0 || ts >= tsMAX)
    output << "TypeSpecifier(" << (int)ts << ")";
  else
    output << TypeSpecifierStrings[ts];
  return output;
}

fstream &operator<<(fstream &output, const EvalType et)
{
  if (et < 0 || et >= etMAX)
    output << "EvalType(" << (int)et << ")";
  else
    output << EvalTypeStrings[et];
  return output;
}

ostream &operator<<(ostream &output, const EvalType et)
{
  if (et < 0 || et >= etMAX)
    output << "EvalType(" << (int)et << ")";
  else
    output << EvalTypeStrings[et];
  return output;
}


