/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/***************************************************/
/* Interface DynAny                                */
/***************************************************/

#include <corba_supp.hh>
#include <tserver.hh>
#include <DAny.h>
#include <DAny_impl.h>

extern "C" {
#include <t1_aux.h>

//-----------------------------------------------------------

int is_valid_type(VSBoolean p_boo)
{   
    CORBA::Boolean boo = (CORBA::Boolean) p_boo;
    
    if (boo == 1)
	return TRUE;
    else
	return FALSE;
}


int is_correct_tc(VSDynAny_ptr *p_da, VSString str)
{
    DynamicAny::DynAny_ptr *da = (DynamicAny::DynAny_ptr *) p_da;
    
    CORBA::TypeCode_var da_tc;
     try {
	da_tc = (*da)->type();	
    }
    catch (...) {
	return FALSE; 
    }

     switch (da_tc->kind()) {
       case CORBA::tk_boolean:
       {
	   if(strcmp(str,"Boolean") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }
       break;	     
       case CORBA::tk_long:
       {
	   if(strcmp(str,"Long") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_struct:
       {
	   if(strcmp(str,"Struct") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_short:
       {
	   if(strcmp(str,"Short") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_ushort:
       {
	   if(strcmp(str,"UShort") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_longlong:
       {
	   if(strcmp(str,"LLong") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_ulonglong:
       {
	   if(strcmp(str,"ULLong") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_ulong:
       {
	   if(strcmp(str,"ULong") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_double:
       {
	   if(strcmp(str,"Double") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_longdouble:
       {
	   if(strcmp(str,"LDouble") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_float:
       {
	   if(strcmp(str,"Float") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_char:
       {
	   if(strcmp(str,"Char") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_wchar:
       {
	   if(strcmp(str,"WChar") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
        case CORBA::tk_string:
       {
	   if(strcmp(str,"String") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_wstring:
       {
	   if(strcmp(str,"WString") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
        case CORBA::tk_objref:
       {
	   if(strcmp(str,"Reference") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_value:
       {
	   if(strcmp(str,"ValueType") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_any:
       {
	   if(strcmp(str,"Any") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_octet:
       {
	   if(strcmp(str,"Octet") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       case CORBA::tk_TypeCode:
       {
	   if(strcmp(str,"TypeCode") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;
       default:
       {
	   if(strcmp(str,"DynAny") == 0)
	       return TRUE;
	   else
	       return FALSE;
       }  	    
       break;       
     }
}


}

