/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/***************************************************/
/* Interface DynAny                                */
/***************************************************/

#include <corba_supp.hh>
#include <tserver.hh>
#include <DAny.h>
#include <DAny_impl.h>

extern "C" {
#include <t1i_tdi.h>
#include <corba_defs.h>

    DynamicAny::DynAny_ptr DAny;    
    void get_DAny(CORBA::TypeCode_ptr p_tc)
    {   
	CORBA::ORB_ptr orb = glob_TS.m_corb->orb(); 
	CORBA::Object_ptr obj = orb->resolve_initial_references("DynAnyFactory");
	DynamicAny::DynAnyFactory_ptr DAF = DynamicAny::DynAnyFactory::_narrow(obj);
	DAny =  DAF->create_dyn_any_from_type_code(p_tc);
    }

    CORBA::TypeCode_ptr struct_tc;
    void provide_struct_tc()
    {
	CORBA::ORB_ptr orb = glob_TS.m_corb->orb();

	CORBA::StructMemberSeq mems(2);
	mems.length(2);

	mems[0].name = CORBA::string_dup("x");
	mems[0].type = CORBA::TypeCode::_duplicate(CORBA::_tc_short);
	mems[1].name = CORBA::string_dup("y");
	mems[1].type = CORBA::TypeCode::_duplicate(CORBA::_tc_long);
	
	struct_tc = orb->create_struct_tc(
	    "IDL:DAnyTest::TestStruct:1.0",
	    "TestStruct",
	    mems );
    }

/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * daTCDA(anonymous prop) */

int provide_daTCDA (VSDynAny_ptr **testvar, enum prop_daTCDA_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;
    CORBA::TypeCode_ptr a;
    
    a = CORBA::_tc_short;    

    switch(prop_1) {
      case PdaTCDA_prop_1_tTC:
      {
	  try {
	      a = CORBA::_tc_TypeCode;
	      get_DAny(a);    
	      tvar = new DynamicAny::DynAny_ptr(DAny);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }	      
      break;
      case PdaTCDA_prop_1_tDAny:
      {
	  try {
	      CORBA::Any tmp;
	      tmp <<= (CORBA::Short) 2;

	      CORBA::ORB_ptr orb = glob_TS.m_corb->orb(); 
	      CORBA::Object_ptr obj = orb->resolve_initial_references("DynAnyFactory");
	      DynamicAny::DynAnyFactory_ptr daf = DynamicAny::DynAnyFactory::_narrow(obj);
	      DynamicAny::DynAny_var dany = daf->create_dyn_any( tmp);

	      tvar = new DynamicAny::DynAny_ptr(dany);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break; 
      case PdaTCDA_prop_1_tComp:
      {
	  try {
	      provide_struct_tc();
	      a = struct_tc;
	      get_DAny(a);    
	      tvar = new DynamicAny::DynAny_ptr(DAny);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }

    try {

    }
    catch(...) {
	return FALSE;
    }

    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}



int relinquish_daTCDA (VSDynAny_ptr **testvar, enum prop_daTCDA_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch(prop_1) {
      case PdaTCDA_prop_1_tTC:
      case PdaTCDA_prop_1_tDAny:
      case PdaTCDA_prop_1_tComp: 
	    (*tvar)->destroy();
	    break;
    }
    return TRUE;
}

/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * daBooL(anonymous prop) */

int provide_daBooL (VSDynAny_ptr **testvar, enum prop_daBooL_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;
    CORBA::TypeCode_ptr a;
    
    a = CORBA::_tc_short;    

    switch(prop_1) {
      case PdaBooL_prop_1_tBoolean:
	    a = CORBA::_tc_boolean;
	    break;
      case PdaBooL_prop_1_tLong:
	    a = CORBA::_tc_long;
	    break; 
      case PdaBooL_prop_1_tComp:
      {
	  try {
	      provide_struct_tc();
	      a = struct_tc;
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }

    try {
	get_DAny(a);    
	tvar = new DynamicAny::DynAny_ptr(DAny);
    }
    catch(...) {
	return FALSE;
    }

    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}

int relinquish_daBooL (VSDynAny_ptr **testvar, enum prop_daBooL_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch(prop_1) {
      case PdaBooL_prop_1_tBoolean:
      case PdaBooL_prop_1_tLong:
      case Pdashort_prop_1_tComp: 
	    (*tvar)->destroy();
	    break;
    }

    return TRUE;
}


/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * dashort(anonymous prop) */

int provide_dashort (VSDynAny_ptr **testvar, enum prop_dashort_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;
    CORBA::TypeCode_ptr a;
    
    a = CORBA::_tc_short;    

    switch(prop_1) {
      case Pdashort_prop_1_tShort:
	    a = CORBA::_tc_short;
	    break;
      case Pdashort_prop_1_tUShort:
	    a = CORBA::_tc_ushort;
	    break; 
      case Pdashort_prop_1_tComp:
      {
	  try {
	      provide_struct_tc();
	      a = struct_tc;
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }

    try {
	get_DAny(a);    
	tvar = new DynamicAny::DynAny_ptr(DAny);
    }
    catch(...) {
	return FALSE;
    }

    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}

int relinquish_dashort (VSDynAny_ptr **testvar, enum prop_dashort_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch(prop_1) {
      case Pdashort_prop_1_tShort:
      case Pdashort_prop_1_tUShort:
      case Pdashort_prop_1_tComp: 
	    (*tvar)->destroy();
	    break;
    }

    return TRUE;
}


/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * daLLong(anonymous prop) */

int provide_daLLong (VSDynAny_ptr **testvar, enum prop_daLLong_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;
    CORBA::TypeCode_ptr a;
    
    a = CORBA::_tc_short;    

    switch(prop_1) {
      case PdaLLong_prop_1_tLLong:
	    a = CORBA::_tc_longlong;
	    break;
      case PdaLLong_prop_1_tULLong:
	    a = CORBA::_tc_ulonglong;
	    break; 
      case PdaLLong_prop_1_tComp:
      {
	  try {
	      provide_struct_tc();
	      a = struct_tc;
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }

    try {
	get_DAny(a);    
	tvar = new DynamicAny::DynAny_ptr(DAny);
    }
    catch(...) {
	return FALSE;
    }

    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}

int relinquish_daLLong (VSDynAny_ptr **testvar, enum prop_daLLong_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch(prop_1) {
      case PdaLLong_prop_1_tLLong:
      case PdaLLong_prop_1_tULLong:
      case PdaLLong_prop_1_tComp: 
	    (*tvar)->destroy();
	    break;
    }

    return TRUE;
}

/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * daULD(anonymous prop) */

int provide_daULD (VSDynAny_ptr **testvar, enum prop_daULD_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;
    CORBA::TypeCode_ptr a;
    
    a = CORBA::_tc_short;    

    switch(prop_1) {
      case PdaULD_prop_1_tULong:
	    a = CORBA::_tc_ulong;
	    break;
      case PdaULD_prop_1_tDouble:
	    a = CORBA::_tc_double;
	    break; 
      case PdaULD_prop_1_tComp:
      {
	  try {
	      provide_struct_tc();
	      a = struct_tc;
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }

    try {
	get_DAny(a);    
	tvar = new DynamicAny::DynAny_ptr(DAny);
    }
    catch(...) {
	return FALSE;
    }

    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}

int relinquish_daULD (VSDynAny_ptr **testvar, enum prop_daULD_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch(prop_1) {
      case PdaULD_prop_1_tULong:
      case PdaULD_prop_1_tDouble:
      case PdaULD_prop_1_tComp: 
	    (*tvar)->destroy();
	    break;
    }

    return TRUE;
}

/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * daLDF(anonymous prop) */

int provide_daLDF (VSDynAny_ptr **testvar, enum prop_daLDF_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;
    CORBA::TypeCode_ptr a;
    
    a = CORBA::_tc_short;    

    switch(prop_1) {
      case PdaLDF_prop_1_tFloat:
	    a = CORBA::_tc_float;
	    break;
      case PdaLDF_prop_1_tLDouble:
	    a = CORBA::_tc_longdouble;
	    break; 
      case PdaLDF_prop_1_tComp:
      {
	  try {
	      provide_struct_tc();
	      a = struct_tc;
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }

    try {
	get_DAny(a);    
	tvar = new DynamicAny::DynAny_ptr(DAny);
    }
    catch(...) {
	return FALSE;
    }

    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}

int relinquish_daLDF (VSDynAny_ptr **testvar, enum prop_daLDF_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch(prop_1) {
      case PdaLDF_prop_1_tFloat:
      case PdaLDF_prop_1_tLDouble:
      case PdaLDF_prop_1_tComp: 
	    (*tvar)->destroy();
	    break;
    }

    return TRUE;
}

/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * daChar(anonymous prop) */

int provide_daChar (VSDynAny_ptr **testvar, enum prop_daChar_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;
    CORBA::TypeCode_ptr a;
    
    a = CORBA::_tc_short;    

    switch(prop_1) {
      case PdaChar_prop_1_tChar:
	    a = CORBA::_tc_char;
	    break;
      case PdaChar_prop_1_tWChar:
	    a = CORBA::_tc_wchar;
	    break; 
      case PdaChar_prop_1_tComp:
      {
	  try {
	      provide_struct_tc();
	      a = struct_tc;
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }

    try {
	get_DAny(a);    
	tvar = new DynamicAny::DynAny_ptr(DAny);
    }
    catch(...) {
	return FALSE;
    }

    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}

int relinquish_daChar (VSDynAny_ptr **testvar, enum prop_daChar_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch(prop_1) {
      case PdaChar_prop_1_tChar:
      case PdaChar_prop_1_tWChar:
      case PdaChar_prop_1_tComp: 
	    (*tvar)->destroy();
	    break;
    }
    return TRUE;
}

/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * daString(anonymous prop) */

int provide_daString (VSDynAny_ptr **testvar, enum prop_daString_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;
    CORBA::TypeCode_ptr a;
    
    a = CORBA::_tc_short;    

    switch(prop_1) {
      case PdaString_prop_1_tStr:
	    a = CORBA::_tc_string;
	    break;
      case PdaString_prop_1_tWStr:
	    a = CORBA::_tc_wstring;
	    break; 
      case PdaString_prop_1_tComp:
      {
	  try {
	      provide_struct_tc();
	      a = struct_tc;
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }

    try {
	get_DAny(a);    
	tvar = new DynamicAny::DynAny_ptr(DAny);
    }
    catch(...) {
	return FALSE;
    }

    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}

int relinquish_daString (VSDynAny_ptr **testvar, enum prop_daString_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch(prop_1) {
      case PdaString_prop_1_tStr:
      case PdaString_prop_1_tWStr:
      case PdaString_prop_1_tComp: 
	    (*tvar)->destroy();
	    break;
    }
    return TRUE;
}

/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * daRefVal(anonymous prop) */

int provide_daRefVal (VSDynAny_ptr **testvar, enum prop_daRefVal_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;
    CORBA::TypeCode_ptr a;
    
    a = CORBA::_tc_short;    

    switch(prop_1) {
      case PdaRefVal_prop_1_tRef:
	    a = CORBA::_tc_Object;
	    break;
      case PdaRefVal_prop_1_tVal:
      {
	  CORBA::ORB_ptr orb = glob_TS.m_corb->orb();
	  CORBA::ValueMemberSeq mems(0);
	  mems.length(0);  

	  CORBA::TypeCode_ptr a = orb->create_value_tc(
	      "IDL:DAnyTest::TestValue:1.0",
	      "TestValue",
	      CORBA::VM_NONE,
	      CORBA::TypeCode::_nil(),
	      mems);
      }
      break; 
      case PdaRefVal_prop_1_tComp:
      {
	  try {
	      provide_struct_tc();
	      a = struct_tc;
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }

    try {
	get_DAny(a);    
	tvar = new DynamicAny::DynAny_ptr(DAny);
    }
    catch(...) {
	return FALSE;
    }

    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}

int relinquish_daRefVal (VSDynAny_ptr **testvar, enum prop_daRefVal_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch(prop_1) {
      case PdaRefVal_prop_1_tRef:
      case PdaRefVal_prop_1_tVal:
      case PdaRefVal_prop_1_tComp: 
	    (*tvar)->destroy();
	    break;
    }
    return TRUE;
}

/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * daAnyO(anonymous prop) */

int provide_daAnyO (VSDynAny_ptr **testvar, enum prop_daAnyO_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;
    CORBA::TypeCode_ptr a;
    
    a = CORBA::_tc_short;    

    switch(prop_1) {
      case PdaAnyO_prop_1_tAny:
	    a = CORBA::_tc_any;
	    break;
      case PdaAnyO_prop_1_tOctet:
	    a = CORBA::_tc_octet;
	    break; 
      case PdaAnyO_prop_1_tComp:
      {
	  try {
	      provide_struct_tc();
	      a = struct_tc;
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }

    try {
	get_DAny(a);    
	tvar = new DynamicAny::DynAny_ptr(DAny);
    }
    catch(...) {
	return FALSE;
    }

    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}

int relinquish_daAnyO (VSDynAny_ptr **testvar, enum prop_daAnyO_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch(prop_1) {
      case PdaAnyO_prop_1_tAny:
      case PdaAnyO_prop_1_tOctet:
      case PdaAnyO_prop_1_tComp: 
	    (*tvar)->destroy();
	    break;
    }
    return TRUE;
}

}
