/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/***************************************************/
/* Interface DynAny                                */
/***************************************************/

#include <corba_supp.hh>
#include <tserver.hh>
#include <DAny.h>
#include <DAny_impl.h>

extern "C" {
#include <t1i_tdi.h>
#include <corba_defs.h>

    DynamicAny::DynAny_ptr DAfromAny;

    void get_DAny(CORBA::Any p_any)
    {   
	CORBA::ORB_ptr orb = glob_TS.m_corb->orb(); 
	CORBA::Object_ptr obj = orb->resolve_initial_references("DynAnyFactory");
	DynamicAny::DynAnyFactory_ptr daf = DynamicAny::DynAnyFactory::_narrow(obj);
	DAfromAny = daf->create_dyn_any(p_any);
    }

    DynamicAny::DynAnyFactory_ptr DAF;
    void get_DAF()
    {   
	CORBA::ORB_ptr orb = glob_TS.m_corb->orb(); 
	CORBA::Object_ptr obj = orb->resolve_initial_references("DynAnyFactory");
	DAF = DynamicAny::DynAnyFactory::_narrow(obj);
    }

/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * daCompCount(anonymous prop) */
int provide_daCompCount (VSDynAny_ptr **testvar, enum prop_daCompCount_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;
    CORBA::Any tmp;

    switch(prop_1) {
      case PdaCompCount_prop_1_short0:
      {
	  try {
	      tmp <<= (CORBA::Short) 2;
	      get_DAny(tmp);
	  
	      tvar = new DynamicAny::DynAny_ptr(DAfromAny);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
      case PdaCompCount_prop_1_struct3:
      {
	  try {
	      DAnyTest::TestStruct tstruct;
	      tstruct.x = 1;
	      tstruct.y = 2;
	      
	      tmp <<=  tstruct;
	      get_DAny(tmp);
	      tvar = new DynamicAny::DynAny_ptr(DAfromAny);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    /*  case  PdaCompCount_prop_1_array3:
      {
	  try {
	      DAnyTest::TestArray tarray;
	      tarray[0] = 1;
	      tarray[1] = 2;
	      
	      tmp <<= tarray_forany(tarray);
	      get_DAny(tmp);
	      tvar = new DynamicAny::DynAny_ptr(DAfromAny);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break; */     
    }

    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}

int relinquish_daCompCount (VSDynAny_ptr **testvar, enum prop_daCompCount_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch(prop_1) {
      case PdaCompCount_prop_1_short0:
      case PdaCompCount_prop_1_struct3:
	    (*tvar)->destroy();
	    break;
    }

    return TRUE;
}


/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * da(anonymous prop) */

int provide_da (void*** testvar, enum prop_da_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;
    CORBA::Any tmp;
    
    switch(prop_1) {
      case Pda_prop_1_struct3:
      {
	  try {
	       DAnyTest::TestStruct tstruct;
	      tstruct.x = 1;
	      tstruct.y = 2;
	     
	      tmp <<=  tstruct;
	      get_DAny(tmp);
	      tvar = new DynamicAny::DynAny_ptr(DAfromAny);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;     
    }
    
    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}


int relinquish_da (void*** testvar, enum prop_da_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch(prop_1) {
      case Pda_prop_1_struct3:
	    (*tvar)->destroy();
	    break;
    }
    return TRUE;
}   


/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * daCurComp(anonymous prop) */
int provide_daComp (VSDynAny_ptr **testvar, enum prop_daComp_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;

    CORBA::Any tmp;
    switch(prop_1) {
      case PdaComp_prop_1_tshort:
      {
	  try {
	      tmp <<= (CORBA::Short) 2;
	      get_DAny(tmp);
	  
	      tvar = new DynamicAny::DynAny_ptr(DAfromAny);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
      case PdaComp_prop_1_tstruct:
      {
	  try {
	      DAnyTest::TestStruct tstruct;
	      tstruct.x = 1;
	      tstruct.y = 2; 
	      
	      tmp <<=  tstruct;
	      get_DAny(tmp);
	      tvar = new DynamicAny::DynAny_ptr(DAfromAny);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }
    
    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}

int relinquish_daComp (void*** testvar, enum prop_daComp_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;

    switch (prop_1)
    {
      case PdaComp_prop_1_tstruct:
      case PdaComp_prop_1_tshort:
	    (*tvar)->destroy();
	    break;
    }   
    return TRUE;
}


/*------------------------------------------------------------------*/
/* test variable VSAny_ptr * astr(anonymous prop) */

int provide_astr(VSAny_ptr *testvar, enum prop_astr_prop_1 prop_1)
{
    CORBA::Any *tvar = new CORBA::Any;

    switch (prop_1)
    {
      case Pastr_prop_1_strNull:
      {
	  char *str = NULL;
	  *tvar <<= str;
      }
      break;
      case Pastr_prop_1_tshort:
      {
	  *tvar <<= (CORBA::Short) 2;
      }
      break;
      case Pastr_prop_1_tstring:
      {
	  *tvar <<= "Hello";
      }
      break;
    }

    *testvar = (VSAny) tvar;
    return TRUE;
}

int relinquish_astr (VSAny_ptr *testvar, enum prop_astr_prop_1 prop_1)
{
    CORBA::Any *tvar = (CORBA::Any *) *testvar;
    switch (prop_1)
    {
      case Pastr_prop_1_tstring:
	    break;     
    } 
    return TRUE;
}

/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * dastr(anonymous prop) */

int provide_dastr ( VSDynAny_ptr **testvar, enum prop_dastr_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;

    switch (prop_1)
    {
      case Pdastr_prop_1_tstring:
      {
	  try {
	      get_DAF();
	      DynamicAny::DynAny_ptr tmp = DAF->create_dyn_any_from_type_code(CORBA::_tc_string);
	      tvar = new DynamicAny::DynAny_ptr(tmp);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }
    
    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}

int relinquish_dastr (void*** testvar, enum prop_dastr_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch (prop_1)
    {
      case Pdastr_prop_1_tstring:
	    (*tvar)->destroy();
	    break;
    }
    return TRUE;
}

/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * danytc(anonymous prop) */
int provide_danytc (VSDynAny_ptr **testvar, enum prop_danytc_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;    
    
    switch (prop_1)
    {
      case Pdanytc_prop_1_tshort:
      {
	  try {
	      get_DAF();
	      DynamicAny::DynAny_ptr tmp = DAF->create_dyn_any_from_type_code(CORBA::_tc_short);
	      // without -> without result
	      tvar = new DynamicAny::DynAny_ptr(tmp);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }

    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}

int relinquish_danytc (VSDynAny_ptr **testvar, enum prop_danytc_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch (prop_1)
    {
      case Pdanytc_prop_1_tshort:  
	    (*tvar)->destroy();
	    break;
    }
    return TRUE;
}


/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * dany(anonymous prop) */
int provide_dany (void*** testvar, enum prop_dany_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;
    CORBA::Any tmp;
    
    switch (prop_1)
    {
      case Pdany_prop_1_tshort: 
      {
	  try {
	      tmp <<= (CORBA::Short) 1;
	      get_DAny(tmp);
	  
	      tvar = new DynamicAny::DynAny_ptr(DAfromAny);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }

    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE;
}

int relinquish_dany (VSDynAny_ptr **testvar, enum prop_dany_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch (prop_1)
    {
      case Pdany_prop_1_tshort:
	    (*tvar)->destroy();
	    break;   
    }
    return TRUE;
}


/*------------------------------------------------------------------*/
/* test variable VSDynAny_ptr * daparam(anonymous prop) */
int provide_daparam (void*** testvar, enum prop_daparam_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar;
    CORBA::Any tmp;
	      
    switch (prop_1)
    {
      case Pdaparam_prop_1_tshort1:
      {
	  try {
	      tmp <<= (CORBA::Short) 3;
	      get_DAny(tmp);
	  
	      tvar = new DynamicAny::DynAny_ptr(DAfromAny);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
      case Pdaparam_prop_1_tlong:
      {
	  try {
	      tmp <<= (CORBA::Long) 1;
	      get_DAny(tmp);
	  
	      tvar = new DynamicAny::DynAny_ptr(DAfromAny);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
      case Pdaparam_prop_1_tshort2:
      {
	  try {
	      tmp <<= (CORBA::Long) 1;
	      get_DAny(tmp);
	  
	      tvar = new DynamicAny::DynAny_ptr(DAfromAny);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }	
      break;
    }
    *testvar = (VSDynAny_ptr *) tvar;
    return TRUE; 
}


int relinquish_daparam (VSDynAny_ptr **testvar, enum prop_daparam_prop_1 prop_1)
{
    DynamicAny::DynAny_ptr *tvar = (DynamicAny::DynAny_ptr *) *testvar;
    switch (prop_1)
    {
      case Pdaparam_prop_1_tshort1: 
      case Pdaparam_prop_1_tlong:
      case Pdaparam_prop_1_tshort2:
	    (*tvar)->destroy();
	    break;
    }
    return TRUE;
}


}
