/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/***************************************************/
/* interface DynEnum                               */
/***************************************************/

#include <corba_supp.hh>
#include <tserver.hh>
#include <DAny.h>
#include <DAny_impl.h>

extern "C" {
#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* set_as_string */

VSBoolean VSset_as_string(VSDynEnum_ptr *p_de, VSString p_str, VSEnvironment* ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    DynamicAny::DynEnum_ptr *de = (DynamicAny::DynEnum_ptr *) p_de;
    char *str = (char *) p_str;

    try {
	(*de)->set_as_string(str);
    }
    catch(CORBA::Exception &ex) {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
	    env->exception(t);
	(VSBoolean) FALSE;
    }
    catch (...) {
	(VSBoolean) FALSE;
    }

    return (VSBoolean) TRUE;
}

/*------------------------------------------------------*/
/* get_as_string */

VSString VSget_as_string(VSDynEnum_ptr *p_de, VSEnvironment* ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    DynamicAny::DynEnum_ptr *de = (DynamicAny::DynEnum_ptr *) p_de;

     try {
	(*de)->set_as_string("red");
     }
     catch (...) {
	 return (VSString) NULL;
     }
     
     char *E_Str;
     try {
	 E_Str = (*de)->get_as_string();
     }
     catch(CORBA::Exception &ex) {
	 CORBA::Exception *t = exception_convert(&ex);
	 if(env)
	     env->exception(t);
	 (VSString) NULL;
     }
     catch (...) {
	 (VSString) NULL;
     }

     return (VSString) E_Str;
}


/*------------------------------------------------------*/
/* set_as_ulong */

VSBoolean VSset_as_ulong(VSDynEnum_ptr *p_de, VSULong p_num, VSEnvironment* ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    DynamicAny::DynEnum_ptr *de = (DynamicAny::DynEnum_ptr *) p_de;
    CORBA::ULong num = (CORBA::ULong) p_num;    

    try {
	(*de)->set_as_ulong(num);
    }
    catch(CORBA::Exception &ex) {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
	    env->exception(t);
	(VSBoolean) FALSE;
    }
    catch (...) {
	(VSBoolean) FALSE;
    }

    return (VSBoolean) TRUE;
}


/*------------------------------------------------------*/
/* get_as_ulong */

VSULong VSget_as_ulong(VSDynEnum_ptr *p_de, VSEnvironment* ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    DynamicAny::DynEnum_ptr *de = (DynamicAny::DynEnum_ptr *) p_de;
   
    try {
	(*de)->set_as_ulong(0);
    }  
    catch (...) {
	(VSULong) 3;
    }

    CORBA::ULong E_num;
    try {
	E_num = (*de)->get_as_ulong();
    }
    catch(CORBA::Exception &ex) {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
	    env->exception(t);
	(VSULong) 3;
    }
    catch (...) {
	(VSULong) 3;
    }


    return (VSULong) E_num;
}


} // end
