/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/***************************************************/
/* Interface DynEnum                               */
/***************************************************/

#include <corba_supp.hh>
#include <tserver.hh>
#include <DAny.h>
#include <DAny_impl.h>

extern "C" {
#include <t1i_tdi.h>
#include <corba_defs.h>

    DynamicAny::DynAny_ptr DAny;    
    void get_DAny(CORBA::TypeCode_ptr p_tc)
    {   
	CORBA::ORB_ptr orb = glob_TS.m_corb->orb(); 
	CORBA::Object_ptr obj = orb->resolve_initial_references("DynAnyFactory");
	DynamicAny::DynAnyFactory_ptr DAF = DynamicAny::DynAnyFactory::_narrow(obj);
	DAny =  DAF->create_dyn_any_from_type_code(p_tc);
    }
    
    CORBA::TypeCode_ptr enum_tc;
    void provide_enum_tc()
    {
	CORBA::ORB_ptr orb = glob_TS.m_corb->orb();

	CORBA::EnumMemberSeq mems(3);
	mems.length(3);

	mems[0] = CORBA::string_dup("red");
	mems[1] = CORBA::string_dup("green");
	mems[2] = CORBA::string_dup("blue");

	
	enum_tc = orb->create_enum_tc(
	    "IDL:DAnyTest::TestEnum:1.0",
	    "TestEnum",
	    mems );
    }   


/*------------------------------------------------------------------*/
/* test variable VSDynEnum_ptr DEnum(anonymous prop) */

int provide_DEnum (VSDynEnum_ptr **testvar, enum prop_DEnum_prop_1 prop_1)
{
    DynamicAny::DynEnum_ptr *tvar;

    switch(prop_1) {
      case PDEnum_prop_1_tenum:
      {
	  try {
	      provide_enum_tc();
	      get_DAny(enum_tc);

	      DynamicAny::DynEnum_var de = DynamicAny::DynEnum::_narrow(DAny);
	       tvar = new DynamicAny::DynEnum_ptr(de);
	  }
	  catch (...) {
	      return FALSE;
	  }	      
      }
      break;
    }
    
    *testvar = (VSDynEnum_ptr *) tvar;
    return TRUE;
}


int relinquish_DEnum (VSDynEnum_ptr **testvar, enum prop_DEnum_prop_1 prop_1)
{
     DynamicAny::DynEnum_ptr *tvar = (DynamicAny::DynEnum_ptr *) *testvar;

    switch(prop_1) {
      case PDEnum_prop_1_tenum:
	    (*tvar)->destroy();
	    break;
    }
    return TRUE;
}

/*------------------------------------------------------------------*/
/* test variable VSString str(anonymous prop) */

int provide_str (VSString *testvar, enum prop_str_prop_1 prop_1)
{
    char **tvar = (char **) testvar; 

    switch(prop_1) {
      case Pstr_prop_1_valid:
	    *tvar = CORBA::string_dup("red");
	    break;
      case Pstr_prop_1_invalid:
	    *tvar = CORBA::string_dup("rot");
	    break;
    }

    return TRUE;
}

int relinquish_str (VSString *testvar, enum prop_str_prop_1 prop_1)
{
     char **tvar = (char **) testvar; 

     switch(prop_1) {
      case Pstr_prop_1_valid:
      case Pstr_prop_1_invalid:
	    CORBA::string_free(*tvar);
	    break;
     }

     return TRUE;
}

} // end
