/* ADL test driver from t1.tdr
 *
 * test VSset_elements(dSeq, aSeq, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop prop_1 */
static struct ADL__propertyValue ADL__prop_values_325[] = {
    {"valid", PdSeq_prop_1_valid, 0},
    {0, 0, 0}
};

/* values for prop prop_1 */
static struct ADL__propertyValue ADL__prop_values_326[] = {
    {"valid", PaSeq_prop_1_valid, 0},
    {"typeinvalid", PaSeq_prop_1_typeinvalid, 0},
    {"valinvalid", PaSeq_prop_1_valinvalid, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_327[] = {
    {"prop_1", "prop", ADL__prop_values_325, 1},
    {"prop_1", "prop", ADL__prop_values_326, 3},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_331[4] = {
    {"dSeq", "VSDynSequence_ptr *", ADL__prop_info_327, 0, 1},
    {"aSeq", "VSAnySeq_ptr", ADL__prop_info_327, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_327, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSset_elements_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSDYNSEQUENCE_PTR_P
#define ADL__PRINT_VSDYNSEQUENCE_PTR_P
void (*ADL__print_VSDynSequence_ptr_P)(VSDynSequence_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSDYNSEQUENCE_PTR_P */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSANYSEQ_PTR
#define ADL__PRINT_VSANYSEQ_PTR
void (*ADL__print_VSAnySeq_ptr)(VSAnySeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSANYSEQ_PTR */
#ifndef ADL__PRINT_VSDYNANYSEQ_PTR
#define ADL__PRINT_VSDYNANYSEQ_PTR
void (*ADL__print_VSDynAnySeq_ptr)(VSDynAnySeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSDYNANYSEQ_PTR */

void ADL__emit_VSDynSequence_ptr_P (void* val, emitter_t emitter)
{
  VSDynSequence_ptr *tmp;

  if (ADL__print_VSDynSequence_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSDynSequence_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSAnySeq_ptr (void* val, emitter_t emitter)
{
  VSAnySeq_ptr tmp;

  if (ADL__print_VSAnySeq_ptr != 0) {
    tmp = *(VSAnySeq_ptr*) val;
    ADL__print_VSAnySeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSDynAnySeq_ptr (void* val, emitter_t emitter)
{
  VSDynAnySeq_ptr tmp;

  if (ADL__print_VSDynAnySeq_ptr != 0) {
    tmp = *(VSDynAnySeq_ptr*) val;
    ADL__print_VSDynAnySeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {1, 3};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSDynSequence_ptr *dSeq_328;
    VSAnySeq_ptr aSeq_329;
    VSEnvironment *env_330;
    VSBoolean fut_return_324;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSset_elements_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSset_elements_InfoArrayIdx,
        ADL__VSset_elements_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_dSeq(&dSeq_328, ADL__prop_values_325[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSDynSequence_ptr_P(&dSeq_328, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_aSeq(&aSeq_329, ADL__prop_values_326[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSAnySeq_ptr(&aSeq_329, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_330)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_330, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSset_elements_assertionReport = rf->assertionReport;
       fut_return_324 = ADL__ACF_VSset_elements(dSeq_328, aSeq_329, env_330);
       test_value = ADL__VSset_elements_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_330);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_aSeq(&aSeq_329, ADL__prop_values_326[tvec[1]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_dSeq(&dSeq_328, ADL__prop_values_325[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_331,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSset_elements_head);

    return 0;
}


struct ADL__Directive_info VSset_elements1_info = {
    N_VARS,
    ADL__var_info_331
};

struct ADL__TDD_info ADL__test_info = {
    3,
    &ADL__VSset_elements_InfoArrayIdx,
    ADL__VSset_elements_InfoArray,
    ADL__test_driver,
    "VSset_elements",
    "VSset_elements1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSset_elements1",
    "t1_tr.rif",
    &VSset_elements1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

