/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/***************************************************/
/* Interface DynStruct                             */
/***************************************************/


#include <corba_supp.hh>
#include <tserver.hh>
#include <DAny.h>
#include <DAny_impl.h>

extern "C" {
#include <t1i_tdi.h>
#include <corba_defs.h>

    DynamicAny::DynAny_ptr DAny;    
    void get_DAny(CORBA::TypeCode_ptr p_tc)
    {   
	CORBA::ORB_ptr orb = glob_TS.m_corb->orb(); 
	CORBA::Object_ptr obj = orb->resolve_initial_references("DynAnyFactory");
	DynamicAny::DynAnyFactory_ptr DAF = DynamicAny::DynAnyFactory::_narrow(obj);
	DAny =  DAF->create_dyn_any_from_type_code(p_tc);
    }

    CORBA::TypeCode_ptr struct_tc;
    void provide_struct_tc()
    {
	CORBA::ORB_ptr orb = glob_TS.m_corb->orb();

	CORBA::StructMemberSeq mems(2);
	mems.length(2);

	mems[0].name = CORBA::string_dup("x");
	mems[0].type = CORBA::TypeCode::_duplicate(CORBA::_tc_short);
	mems[1].name = CORBA::string_dup("y");
	mems[1].type = CORBA::TypeCode::_duplicate(CORBA::_tc_long);
	
	struct_tc = orb->create_struct_tc(
	    "IDL:DAnyTest::TestStruct:1.0",
	    "TestStruct",
	    mems );
    }   

    DynamicAny::NameValuePairSeq AnyMems;
    void create_struct_AnyMems()
    {
	AnyMems.length(2);

	CORBA::Any x;
	x <<= (CORBA::Short) 0;

	CORBA::Any y;
	y <<= (CORBA::Long) 1;

	AnyMems[0].id = CORBA::string_dup("x");
	AnyMems[0].value = x;
	AnyMems[1].id = CORBA::string_dup("y");
	AnyMems[1].value = y;
    }

    DynamicAny::NameDynAnyPairSeq DAnyMems;
    void create_struct_DAnyMems()
    {
	DAnyMems.length(2);

	get_DAny(CORBA::_tc_short);	
	DAny->insert_short(0);
	DAnyMems[0].id = CORBA::string_dup("x");
	DAnyMems[0].value = DAny;
	DAny->destroy();

	get_DAny(CORBA::_tc_long);       
	DAny->insert_long(1);
	DAnyMems[1].id = CORBA::string_dup("y");
	DAnyMems[1].value = DAny;
	DAny->destroy();
    }    

/*------------------------------------------------------------------*/
/* test variable VSDynStruct_ptr * DStruct(anonymous prop) */

int provide_DStruct (VSDynStruct_ptr **testvar, enum prop_DStruct_prop_1 prop_1)
{
    DynamicAny::DynStruct_ptr *tvar;
    CORBA::ORB_ptr orb = glob_TS.m_corb->orb();

    switch(prop_1) {
      case PDStruct_prop_1_tStruct:
      {
	  try {
	      provide_struct_tc();
	      get_DAny(struct_tc);
	      DynamicAny::DynStruct_var ds = DynamicAny::DynStruct::_narrow(DAny);

	      create_struct_AnyMems();	      
	      ds->set_members(AnyMems);

	      tvar = new DynamicAny::DynStruct_ptr(ds);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
      case PDStruct_prop_1_tException:
      {
	  try {
	      CORBA::StructMemberSeq mems(0);
	      mems.length(0);
	  
	      struct_tc = orb->create_struct_tc(
		  "IDL:DAnyTest::BAD_PARAM:1.0",
		  "BAD_PARAM",
		  mems );

	      get_DAny(struct_tc);
	      DynamicAny::DynStruct_var ds = DynamicAny::DynStruct::_narrow(DAny);	
	      tvar = new DynamicAny::DynStruct_ptr(ds);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;  
    }
    *testvar = (VSDynStruct_ptr *) tvar;
    return TRUE;
}

int relinquish_DStruct (VSDynStruct_ptr **testvar, enum prop_DStruct_prop_1 prop_1)
{
    DynamicAny::DynStruct_ptr *tvar = (DynamicAny::DynStruct_ptr *) *testvar;
    
    switch(prop_1) {
      case PDStruct_prop_1_tStruct:
      case PDStruct_prop_1_tException:
	    (*tvar)->destroy();
	    break;
    }
    
    return TRUE;
}


/*------------------------------------------------------------------*/
/* test variable VSNameValuePairSeq_ptr * NVPseq(anonymous prop) */
int provide_NVPseq (VSNameValuePairSeq_ptr *testvar, enum prop_NVPseq_prop_1 prop_1)
{
    DynamicAny::NameValuePairSeq *tvar;

    switch(prop_1) {
      case PNVPseq_prop_1_valid:
      {
	  try {
	      create_struct_AnyMems();	  
	      tvar = new  DynamicAny::NameValuePairSeq(AnyMems);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
      case PNVPseq_prop_1_invalid:
      {
	  try {
	      DynamicAny::NameValuePairSeq Mems;
	      Mems.length(2);

	      CORBA::Any x;
	      x <<= (CORBA::Long) 0;

	      CORBA::Any y;
	      y <<= (CORBA::Long) 1;

	      Mems[0].id = CORBA::string_dup("x");
	      Mems[0].value = x;
	      Mems[1].id = CORBA::string_dup("y");
	      Mems[1].value = y;
	      tvar = new  DynamicAny::NameValuePairSeq(Mems);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }

    *testvar = (VSNameValuePairSeq_ptr) tvar;
    return TRUE;
}

int relinquish_NVPseq (VSNameValuePairSeq_ptr *testvar, enum prop_NVPseq_prop_1 prop_1)
{
    DynamicAny::NameValuePairSeq *tvar = (DynamicAny::NameValuePairSeq *) *testvar;

    switch(prop_1) {
      case PNVPseq_prop_1_valid:
      case PNVPseq_prop_1_invalid:
	    delete tvar;
	    break;
    }

    return TRUE;
}

/*------------------------------------------------------------------*/
/* test variable VSNameDynAnyPairSeq_ptr * NDAPseq(anonymous prop) */
int provide_NDAPseq (VSNameDynAnyPairSeq_ptr *testvar, enum prop_NDAPseq_prop_1 prop_1)
{
    DynamicAny::NameDynAnyPairSeq *tvar;

    switch(prop_1) {
      case PNDAPseq_prop_1_valid:
      {
	  try {
	      create_struct_DAnyMems();	  
	      tvar = new  DynamicAny::NameDynAnyPairSeq(DAnyMems);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
      case PNDAPseq_prop_1_invalid:
      {
	  try {
	      DynamicAny::NameDynAnyPairSeq Mems;
	      Mems.length(2);

	      get_DAny(CORBA::_tc_long);	
	      DAny->insert_long(0);
	      Mems[0].id = CORBA::string_dup("x");
	      Mems[0].value = DAny;
	      DAny->destroy();

	      get_DAny(CORBA::_tc_long);       
	      DAny->insert_long(1);
	      Mems[1].id = CORBA::string_dup("y");
	      Mems[1].value = DAny;
	      DAny->destroy();
	      tvar = new  DynamicAny::NameDynAnyPairSeq(Mems);
	  }
	  catch (...) {
	      return FALSE;
	  }
	  
      }
      break;
    }	

    *testvar = (VSNameDynAnyPairSeq_ptr) tvar;
    return TRUE;
}

int relinquish_NDAPseq (VSNameDynAnyPairSeq_ptr *testvar, enum prop_NDAPseq_prop_1 prop_1)
{
    DynamicAny::NameDynAnyPairSeq *tvar = (DynamicAny::NameDynAnyPairSeq *) *testvar;

    switch(prop_1) {
      case PNDAPseq_prop_1_valid:
      case PNDAPseq_prop_1_invalid:
	    delete tvar;
	    break;
    }

    return TRUE;
}


}
