/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/***************************************************/
/* Interface DynUnion                               */
/***************************************************/

#include <corba_supp.hh>
#include <tserver.hh>
#include <DAny.h>
#include <DAny_impl.h>

extern "C" {
#include <t1_aux.h>

//-----------------------------------------------------------

int valid_discriminator(VSDynUnion_ptr *p_du, VSDynAny_ptr *p_da)
{
    DynamicAny::DynUnion_ptr *du = (DynamicAny::DynUnion_ptr *) p_du;
    DynamicAny::DynAny_ptr *da = (DynamicAny::DynAny_ptr *) p_da;

    if(!du) 
	return FALSE; 

    CORBA::TypeCode_var tcDA, tcDisc;
    try {
	tcDA = (*da)->type();

	DynamicAny::DynAny_ptr disc = (*du)->get_discriminator();
	tcDisc = disc->type();
    }
    catch (...) {
	return FALSE;
    } 
    return (tcDA->kind() == tcDisc->kind());
}



int discriminator_consistent_Umember(VSDynAny_ptr *p_da)
{
    DynamicAny::DynAny_ptr *da = (DynamicAny::DynAny_ptr *) p_da;
    
    CORBA::TypeCode_var tc = (*da)->type();

    if (tc->kind() == CORBA::tk_long) {
	CORBA::Long L = (*da)->get_long();
	if ((L == 1) || (L == 1))
	    return TRUE;
	else
	    return FALSE;
    }

    if (tc->kind() == CORBA::tk_enum) {
	DynamicAny::DynEnum_var de = DynamicAny::DynEnum::_narrow(*da);
	char * E = de->get_as_string();
	
	if ((strcmp(E, "red") == 0) || (strcmp(E, "red") == 0) || (strcmp(E, "red") == 0))
	    return TRUE;
	else
	    return FALSE;	
    }

    return FALSE;
}

int no_active_member(VSDynUnion_ptr *p_du)
{
    DynamicAny::DynUnion_ptr *du = (DynamicAny::DynUnion_ptr *) p_du;

    if(!du) 
	return FALSE;

    CORBA::Boolean boo = (*du)->has_no_active_member();
    
    return boo;
}


int comp_count(VSDynUnion_ptr *p_du)
{
    DynamicAny::DynUnion_ptr *du = (DynamicAny::DynUnion_ptr *) p_du; 
    
    CORBA::ULong count = (*du)->component_count();

    return count;
}

int return_correct_discriminator(VSDynAny_ptr *p_da)
{
    DynamicAny::DynAny_ptr *da = (DynamicAny::DynAny_ptr *) p_da;

    if (da == 0)
	return FALSE;
    else
	return TRUE;
}

int union_has_default_member(VSDynUnion_ptr *p_du)
{
    DynamicAny::DynUnion_ptr *du = (DynamicAny::DynUnion_ptr *) p_du; 
    
    CORBA::TCKind tk = (*du)->discriminator_kind();

    if (tk == CORBA::tk_long)
	return TRUE;	
    else
	return FALSE;
}

int return_correct_disTCKind(VSTCKind p_tk)
{
    CORBA::TCKind tk = (CORBA::TCKind) p_tk;
   
    if (tk == 0)
	return FALSE;
    else
	return TRUE; 
    
}

int return_correct_memTCKind(VSTCKind p_tk)
{  
    CORBA::TCKind tk = (CORBA::TCKind) p_tk;  
 
    return (tk == CORBA::tk_float);  
}
		
int valid_DynAny(VSDynAny_ptr *p_da)
{
    DynamicAny::DynAny_ptr *da = (DynamicAny::DynAny_ptr *) p_da;
   
    if (da == 0)
	return FALSE;
    else
	return TRUE;
}

int valid_return_string(VSString p_str)
{
    char *str = (char *) p_str;  
    
    if (strcmp(str, "f") == 0)
	return TRUE;
    else
	return FALSE;  
}

} //end
