/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/***************************************************/
/* Interface DynValue                              */
/***************************************************/


#include <corba_supp.hh>
#include <tserver.hh>
#include <DAny.h>
#include <DAny_impl.h>

extern "C" {
#include <t1i_tdi.h>
#include <corba_defs.h>

        
    DynamicAny::DynAny_ptr get_DAny(CORBA::TypeCode_ptr p_tc)
    {   
	CORBA::ORB_ptr orb = glob_TS.m_corb->orb(); 
	CORBA::Object_ptr obj = orb->resolve_initial_references("DynAnyFactory");
	DynamicAny::DynAnyFactory_ptr DAF = DynamicAny::DynAnyFactory::_narrow(obj);
	DynamicAny::DynAny_ptr dany =  DAF->create_dyn_any_from_type_code(p_tc);
	return dany;
    }

    
    CORBA::TypeCode_ptr provide_value_tc()
    {
	CORBA::ORB_ptr orb = glob_TS.m_corb->orb();
	CORBA::ValueMemberSeq mems(2);
	mems.length(2);

	mems[0].id = CORBA::string_dup("IDL:DAnyTest::TestValueA:1.0");
	mems[0].name = CORBA::string_dup("x");
	mems[0].type = CORBA::TypeCode::_duplicate(CORBA::_tc_short);
	mems[0].access = CORBA::PUBLIC_MEMBER;

	mems[1].id = CORBA::string_dup("IDL:DAnyTest::TestValueA:1.0");
	mems[1].name = CORBA::string_dup("y");
	mems[1].type = CORBA::TypeCode::_duplicate(CORBA::_tc_long);
	mems[1].access = CORBA::PUBLIC_MEMBER;

	CORBA::TypeCode_ptr value_tc = orb->create_value_tc(
	      "IDL:DAnyTest::TestValueA:1.0",
	      "TestValue",
	      CORBA::VM_NONE,
	      CORBA::TypeCode::_nil(),
	      mems);

	return value_tc; 
    }   

    
    DynamicAny::NameValuePairSeq create_value_AnyMems()
    {
	DynamicAny::NameValuePairSeq anyMems;

	anyMems.length(2);

	CORBA::Any x;
	x <<= (CORBA::Short) 0;

	CORBA::Any y;
	y <<= (CORBA::Long) 1;

	anyMems[0].id = CORBA::string_dup("x");
	anyMems[0].value = x;
	anyMems[1].id = CORBA::string_dup("y");
	anyMems[1].value = y;
	
	return anyMems;
    }

    
    DynamicAny::NameDynAnyPairSeq create_value_DAnyMems()
    {
	DynamicAny::NameDynAnyPairSeq dAnyMems;
	dAnyMems.length(2);

	 DynamicAny::DynAny_ptr dAnyx = get_DAny(CORBA::_tc_short);	
	dAnyx->insert_short(0);
	dAnyMems[0].id = CORBA::string_dup("x");
	dAnyMems[0].value = dAnyx;
	dAnyx->destroy();

	DynamicAny::DynAny_ptr dAnyy = get_DAny(CORBA::_tc_long);
	dAnyy->insert_long(1);
	dAnyMems[1].id = CORBA::string_dup("y");
	dAnyMems[1].value = dAnyy;
	dAnyx->destroy();
	
	return dAnyMems;
    }    

/*------------------------------------------------------------------*/
/* test variable VSDynValue_ptr * dVal(anonymous prop) */

int provide_dVal (VSDynValue_ptr **testvar, enum prop_dVal_prop_1 prop_1)
{
    DynamicAny::DynValue_ptr *tvar;
    CORBA::ORB_ptr orb = glob_TS.m_corb->orb();

    switch(prop_1) {
      case PdVal_prop_1_tVal:
      {
	  try {
	      CORBA::TypeCode_ptr value_tc = provide_value_tc();
	      DynamicAny::DynAny_ptr dany = get_DAny(value_tc);
	      DynamicAny::DynValue_var dVal = DynamicAny::DynValue::_narrow(dany);

	     DynamicAny::NameValuePairSeq  anyMems =create_value_AnyMems();    

	     tvar = new DynamicAny::DynValue_ptr(dVal);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
      case PdVal_prop_1_tValempty:
      {
	  try {
	      CORBA::ORB_ptr orb = glob_TS.m_corb->orb();
	      CORBA::ValueMemberSeq value_mems;
	      value_mems.length(0);     
	  
	      CORBA::TypeCode_ptr value_tc = orb->create_value_tc(
		  "IDL:DAnyTest::TestValue:1.0",
		  "TestValue",
		  CORBA::VM_NONE,
		  CORBA::TypeCode::_nil(),
		  value_mems);
	      DynamicAny::DynAny_ptr dany = get_DAny(value_tc);
	      DynamicAny::DynValue_var dVal = DynamicAny::DynValue::_narrow(dany);	
	      tvar = new DynamicAny::DynValue_ptr(dVal);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;  
    }
    *testvar = (VSDynValue_ptr *) tvar;
    return TRUE;
}

int relinquish_dVal (VSDynValue_ptr **testvar, enum prop_dVal_prop_1 prop_1)
{
    DynamicAny::DynValue_ptr *tvar = (DynamicAny::DynValue_ptr *) *testvar;
    
    switch(prop_1) {
      case PdVal_prop_1_tVal:
      case PdVal_prop_1_tValempty:
	    (*tvar)->destroy();
	    break;
    }
    
    return TRUE;
}


/*------------------------------------------------------------------*/
/* test variable VSNameValuePairSeq_ptr * NVPseq(anonymous prop) */
int provide_NVPseq (VSNameValuePairSeq_ptr *testvar, enum prop_NVPseq_prop_1 prop_1)
{
    DynamicAny::NameValuePairSeq *tvar;

    switch(prop_1) {
      case PNVPseq_prop_1_valid:
      {
	  try {
	      DynamicAny::NameValuePairSeq anyMems = create_value_AnyMems();	  
	      tvar = new  DynamicAny::NameValuePairSeq(anyMems);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
      case PNVPseq_prop_1_invalid:
      {
	  try {
	      DynamicAny::NameValuePairSeq Mems;
	      Mems.length(2);

	      CORBA::Any x;
	      x <<= (CORBA::Long) 0;

	      CORBA::Any y;
	      y <<= (CORBA::Long) 1;

	      Mems[0].id = CORBA::string_dup("x");
	      Mems[0].value = x;
	      Mems[1].id = CORBA::string_dup("y");
	      Mems[1].value = y;
	      tvar = new  DynamicAny::NameValuePairSeq(Mems);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
    }

    *testvar = (VSNameValuePairSeq_ptr) tvar;
    return TRUE;
}

int relinquish_NVPseq (VSNameValuePairSeq_ptr *testvar, enum prop_NVPseq_prop_1 prop_1)
{
    DynamicAny::NameValuePairSeq *tvar = (DynamicAny::NameValuePairSeq *) *testvar;

    switch(prop_1) {
      case PNVPseq_prop_1_valid:
      case PNVPseq_prop_1_invalid:
	    delete tvar;
	    break;
    }

    return TRUE;
}

/*------------------------------------------------------------------*/
/* test variable VSNameDynAnyPairSeq_ptr * NDAPseq(anonymous prop) */
int provide_NDAPseq (VSNameDynAnyPairSeq_ptr *testvar, enum prop_NDAPseq_prop_1 prop_1)
{
    DynamicAny::NameDynAnyPairSeq *tvar;

    switch(prop_1) {
      case PNDAPseq_prop_1_valid:
      {
	  try {
	      DynamicAny::NameDynAnyPairSeq dAnyMems = create_value_DAnyMems();	  
	      tvar = new DynamicAny::NameDynAnyPairSeq(dAnyMems);
	  }
	  catch (...) {
	      return FALSE;
	  }
      }
      break;
      case PNDAPseq_prop_1_invalid:
      {
	  try {
	      DynamicAny::NameDynAnyPairSeq Mems;
	      Mems.length(2);

	      DynamicAny::DynAny_ptr dax = get_DAny(CORBA::_tc_long);	
	      dax->insert_long(0);
	      Mems[0].id = CORBA::string_dup("x");
	      Mems[0].value = dax;
	      dax->destroy();

	      DynamicAny::DynAny_ptr day = get_DAny(CORBA::_tc_long);       
	      day->insert_long(1);
	      Mems[1].id = CORBA::string_dup("y");
	      Mems[1].value = day;
	      day->destroy();
	      tvar = new  DynamicAny::NameDynAnyPairSeq(Mems);
	  }
	  catch (...) {
	      return FALSE;
	  }
	  
      }
      break;
    }	

    *testvar = (VSNameDynAnyPairSeq_ptr) tvar;
    return TRUE;
}

int relinquish_NDAPseq (VSNameDynAnyPairSeq_ptr *testvar, enum prop_NDAPseq_prop_1 prop_1)
{
    DynamicAny::NameDynAnyPairSeq *tvar = (DynamicAny::NameDynAnyPairSeq *) *testvar;

    switch(prop_1) {
      case PNDAPseq_prop_1_valid:
      case PNDAPseq_prop_1_invalid:
	    delete tvar;
	    break;
    }

    return TRUE;
}


}
