/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/***************************************************/
/* interface DynAnyFactory                         */
/***************************************************/

#include <corba_supp.hh>
#include <tserver.hh>
#include <DAny.h>
#include <DAny_impl.h>

extern "C" {

#include <t1_aux.h>

//-----------------------------------------------------------

int is_DynAnyFactory(VSDynAnyFactory_ptr *daf)
{
    DynamicAny::DynAnyFactory_ptr *factory = (DynamicAny::DynAnyFactory_ptr *) daf;
    
    int ret = (factory ? TRUE : FALSE);    
    return ret;
}

int is_valid_input(VSAny p_a)
{
    CORBA::Any *a = (CORBA::Any *) p_a;

    CORBA::TypeCode_var a_tc;
    try {
	a_tc = a->type();	
    }
    catch (...) {
	return FALSE; 
    }

    if (a_tc->kind() == CORBA::tk_short)
	return TRUE;
    else
	return FALSE;
}


int equal_Any(VSDynAny_ptr *p_da, VSAny p_a)
{
    DynamicAny::DynAny_ptr *da = (DynamicAny::DynAny_ptr *) p_da;
    CORBA::Any *a = (CORBA::Any *) p_a;

    CORBA::TypeCode_var da_tc, a_tc;
    

    try {
	da_tc = (*da)->type();
	a_tc = a->type();	
    }
    catch (...) {
	return FALSE; 
    }

    if (da_tc->kind() == a_tc->kind())
    {
	switch (da_tc->kind()) {
	  case CORBA::tk_short:
	  {
	      CORBA::Short a_short, da_short;
	      *a >>= a_short;
	      da_short = (*da)->get_short();
	      
	      return (a_short == da_short);
	  }
	  break;
	  default:
		return FALSE;
		break;
	}
    }
    else
	return FALSE; 
}


int is_short_tc(VSTypeCode_ptr *p_tc)
{
    CORBA::TypeCode_ptr *tc = (CORBA::TypeCode_ptr *) p_tc;
    
    if ((*tc)->kind() == CORBA::tk_short)
	return TRUE;
    else
	return FALSE;
}


int is_DynAny(VSDynAny_ptr *p_da)
{
    DynamicAny::DynAny_ptr *da = (DynamicAny::DynAny_ptr *) p_da;
   
    return (da ? TRUE : FALSE);
}


int is_seq_tc(VSTypeCode_ptr *p_tc)
{
    CORBA::TypeCode_ptr *tc = (CORBA::TypeCode_ptr *) p_tc;

    if ((*tc)->kind() == CORBA::tk_sequence)
	return TRUE;
    else
	return FALSE;
}

int is_DynSeq(VSDynAny_ptr *p_da)
{
    DynamicAny::DynAny_ptr *da = (DynamicAny::DynAny_ptr *) p_da;

    try {
	DynamicAny::DynSequence_ptr dyn_struct = DynamicAny::DynSequence::_narrow(*da);
    }
    catch (...) {
	return FALSE;
    }
    
    return TRUE;
}

}

