/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/
     
#include <corba_supp.hh>
#include <DAny_inc.h> 

class TestInterfaceA_impl;

class TestInterface_impl;

class TestValue_impl;

//
// TestInterfaceA_impl
//

class TestInterfaceA_impl : public virtual POA_DAnyTest::TestInterfaceA
{
  public:
    TestInterfaceA_impl();
    ~TestInterfaceA_impl();
  
    virtual void display(DAnyTest::TestAbstrInterface_ptr obj)
	throw(CORBA::SystemException);
};

//
// TestInterface_impl
//

class TestInterface_impl : public virtual POA_DAnyTest::TestInterface
{
  public:
    TestInterface_impl();
    ~TestInterface_impl();
  
    virtual char* get_description()
	throw(CORBA::SystemException);
};


//
// TestValue_impl
//

class TestValue_impl: public virtual DAnyTest::TestValue,
                       public virtual CORBA::DefaultValueRefCountBase
{
  public:
  TestValue_impl(); 
  ~TestValue_impl();
  
  virtual CORBA::ValueBase* _copy_value();

  virtual char* get_description()
	throw(CORBA::SystemException);
};

//
// ValueFactory
//
class TestValueFactory_impl : virtual public CORBA::ValueFactoryBase
{
    virtual CORBA::ValueBase* create_for_unmarshal();

  public:

     TestValueFactory_impl();
    ~TestValueFactory_impl();

    virtual DAnyTest::TestValue* create();    
};
