//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//


#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/

VSContext_ptr *VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Context_ptr ttc;

		try {
				ttc = CORBA::Context::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSContext_ptr *) 0;
		}
		catch (...) {
				return (VSContext_ptr *) 0;
		}

		CORBA::Context_ptr *rtc = new CORBA::Context_ptr(ttc);
		return (VSContext_ptr *) rtc;
}

VSContext_ptr *VSduplicate(VSContext_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Context_ptr *tc = (CORBA::Context_ptr *) o1;
		CORBA::Context_ptr ttc;

		try {
				ttc = CORBA::Context::_duplicate(tc ? *tc : (CORBA::Context_ptr) 0);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSContext_ptr *) 0;
		}
		catch (...) {
				return (VSContext_ptr *) 0;
		}

		CORBA::Context_ptr *rtc = new CORBA::Context_ptr(ttc);
		return (VSContext_ptr *) rtc;
}

VSStatus VSset_one_value(VSContext_ptr *ctx, VSIdentifier s, VSAny *any, VSEnvironment *ev)
{
	CORBA::Environment *env = (CORBA::Environment *)ev;
	CORBA::Context_ptr *pCtx = (CORBA::Context_ptr *)ctx;
	const char *ps = (const char *)s;
	CORBA::Any *pAny = (CORBA::Any *)any;

	if (!pCtx || !*pCtx ||
			is_invalid_context_ptr(ctx) || is_nil_context_ptr(ctx))
		 return 1;

	try {
		(*pCtx)->set_one_value(ps, *pAny);
	}
	catch (CORBA::Exception &ex) {
		CORBA::Exception *t = exception_convert(&ex);

		if(env)
			env->exception(t);

		return 0;
	}
	catch (...) {
		return 0;
	}

	return 1;
}

}

