//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/DII/Context/t1i_tdi.cpp
//
// Purpose:
//
// Modifications:
// $Log: t1i_tdi.cpp,v $
// Revision 1.2  2001/01/10 15:53:21  mli
// Remove value nil for variable name.
//
// Revision 1.1.1.1  2000/02/09 17:13:09  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1997/12/05 16:28:00  cwatson
// Now uses .hh for c++ include files.
//
// Revision 1.5  1997/10/04 16:42:02  stephen
// Changed include to corba_supp.hh.
//
// Revision 1.4  1997/10/03 12:20:43  ian
// Added set_one value.
//
// Revision 1.2  1997/09/12 13:00:40  cwatson
// Moved all _ptr provide and relinquish functions to corba/common/ptr_prov.cpp.
//
// Revision 1.1  1997/08/19 14:57:05  cwatson
// *** empty log message ***
//
//
/*
 * ./t1_tdi.c
 */

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

/* ---- global property declarations ---- */
/* ---- test variables and local properties ---- */


int provide_any_string (void*** testvar, enum prop_any_string_v v)
{
	CORBA::Any *pAny = 0;

	try {
		pAny = new CORBA::Any;
		switch (v)
		{
			case Pany_string_v_valid:
				*pAny <<= (const char*) "ApTest Ltd.";
				break;
			case Pany_string_v_nil:
				*pAny <<= (const char*)"";
				break;
			case Pany_string_v_null:
				*pAny <<= (const char*) "";
				break;
			case Pany_string_v_invalid:
				*pAny <<= (CORBA::Long)1;
				break;
		}	
	}
	catch (CORBA::Exception& e) {
		return 0;
	}

	*testvar = (void **)pAny;

	return 1;
}

int relinquish_any_string (void*** testvar, enum prop_any_string_v v)
{
	(void *)&v;

	//delete (CORBA::Any *)*testvar;

	return 1;
}

}

