/* ADL test driver from t1.tdr
 *
 * test VScount(ctxlist_ptr, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_427[] = {
    {"valid", Pctxlist_ptr_v_valid, 0},
    {"valid1", Pctxlist_ptr_v_valid1, 0},
    {"nil", Pctxlist_ptr_v_nil, 0},
    {"null", Pctxlist_ptr_v_null, 0},
    {"invalid", Pctxlist_ptr_v_invalid, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_428[] = {
    {"v", "prop", ADL__prop_values_427, 5},
    {0, 0, 0}
};
#define TVEC_SIZE 1

static struct ADL__variableInfo ADL__var_info_431[3] = {
    {"ctxlist_ptr", "VSContextList_ptr *", ADL__prop_info_428, 0, 1},
    {"env", "VSEnvironment *", ADL__prop_info_428, 1, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 2


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VScount_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSCONTEXTLIST_PTR_P
#define ADL__PRINT_VSCONTEXTLIST_PTR_P
void (*ADL__print_VSContextList_ptr_P)(VSContextList_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTEXTLIST_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */
#ifndef ADL__PRINT_VSSTRING
#define ADL__PRINT_VSSTRING
void (*ADL__print_VSString)(VSString, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTRING */
#ifndef ADL__PRINT_VSSTATUS
#define ADL__PRINT_VSSTATUS
void (*ADL__print_VSStatus)(VSStatus, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTATUS */

void ADL__emit_VSContextList_ptr_P (void* val, emitter_t emitter)
{
  VSContextList_ptr *tmp;

  if (ADL__print_VSContextList_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSContextList_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSString (void* val, emitter_t emitter)
{
  VSString tmp;

  if (ADL__print_VSString != 0) {
    tmp = *(VSString*) val;
    ADL__print_VSString(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSStatus (void* val, emitter_t emitter)
{
  VSStatus tmp;

  if (ADL__print_VSStatus != 0) {
    tmp = *(VSStatus*) val;
    ADL__print_VSStatus(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {5};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSContextList_ptr *ctxlist_ptr_429;
    VSEnvironment *env_430;
    VSULong fut_return_426;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VScount_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VScount_InfoArrayIdx,
        ADL__VScount_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_ctxlist_ptr(&ctxlist_ptr_429, ADL__prop_values_427[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSContextList_ptr_P(&ctxlist_ptr_429, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_env(&env_430)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
       ADL__emit_VSEnvironment_P(&env_430, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VScount_assertionReport = rf->assertionReport;
       fut_return_426 = ADL__ACF_VScount(ctxlist_ptr_429, env_430);
       test_value = ADL__VScount_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_env(&env_430);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_ctxlist_ptr(&ctxlist_ptr_429, ADL__prop_values_427[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_431,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VScount_head);

    return 0;
}


struct ADL__Directive_info VScount1_info = {
    N_VARS,
    ADL__var_info_431
};

struct ADL__TDD_info ADL__test_info = {
    5,
    &ADL__VScount_InfoArrayIdx,
    ADL__VScount_InfoArray,
    ADL__test_driver,
    "VScount",
    "VScount1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VScount1",
    "t1_tr.rif",
    &VScount1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

