/* ADL test driver from t1.tdr
 *
 * test VSremove(nvlist_ptr, index, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_525[] = {
    {"valid", Pnvlist_ptr_v_valid, 0},
    {"valid1", Pnvlist_ptr_v_valid1, 0},
    {"nil", Pnvlist_ptr_v_nil, 0},
    {"null", Pnvlist_ptr_v_null, 0},
    {"invalid", Pnvlist_ptr_v_invalid, 0},
    {0, 0, 0}
};

/* values for literal variable index */
static VSULong ADL__litvar_val_518[] = {
    0,
    1,
    2,
    99,
};

static struct ADL__propertyValue ADL__litvar_info_517[] = {
    {"0", 0, ADL__litvar_val_518},
    {"1", 1, ADL__litvar_val_518},
    {"2", 2, ADL__litvar_val_518},
    {"99", 3, ADL__litvar_val_518},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_526[] = {
    {"v", "prop", ADL__prop_values_525, 5},
    {"index", "litvar", ADL__litvar_info_517, 4},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_530[4] = {
    {"nvlist_ptr", "VSNVList_ptr *", ADL__prop_info_526, 0, 1},
    {"index", "VSULong", ADL__prop_info_526, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_526, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSremove_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSNVLIST_PTR_P
#define ADL__PRINT_VSNVLIST_PTR_P
void (*ADL__print_VSNVList_ptr_P)(VSNVList_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSNVLIST_PTR_P */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */
#ifndef ADL__PRINT_VSFLAGS_P
#define ADL__PRINT_VSFLAGS_P
void (*ADL__print_VSFlags_P)(VSFlags*, emitter_t) = 0;

#endif /* ADL__PRINT_VSFLAGS_P */
#ifndef ADL__PRINT_VSNAMEDVALUE_PTR_P
#define ADL__PRINT_VSNAMEDVALUE_PTR_P
void (*ADL__print_VSNamedValue_ptr_P)(VSNamedValue_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSNAMEDVALUE_PTR_P */
#ifndef ADL__PRINT_VSSTRING
#define ADL__PRINT_VSSTRING
void (*ADL__print_VSString)(VSString, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTRING */
#ifndef ADL__PRINT_VSSTATUS
#define ADL__PRINT_VSSTATUS
void (*ADL__print_VSStatus)(VSStatus, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTATUS */

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSNVList_ptr_P (void* val, emitter_t emitter)
{
  VSNVList_ptr *tmp;

  if (ADL__print_VSNVList_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSNVList_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSFlags_P (void* val, emitter_t emitter)
{
  VSFlags *tmp;

  if (ADL__print_VSFlags_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSFlags_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSNamedValue_ptr_P (void* val, emitter_t emitter)
{
  VSNamedValue_ptr *tmp;

  if (ADL__print_VSNamedValue_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSNamedValue_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSString (void* val, emitter_t emitter)
{
  VSString tmp;

  if (ADL__print_VSString != 0) {
    tmp = *(VSString*) val;
    ADL__print_VSString(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSStatus (void* val, emitter_t emitter)
{
  VSStatus tmp;

  if (ADL__print_VSStatus != 0) {
    tmp = *(VSStatus*) val;
    ADL__print_VSStatus(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {5, 4};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSNVList_ptr *nvlist_ptr_527;
    VSULong index_528;
    VSEnvironment *env_529;
    VSStatus fut_return_524;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSremove_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSremove_InfoArrayIdx,
        ADL__VSremove_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_nvlist_ptr(&nvlist_ptr_527, ADL__prop_values_525[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSNVList_ptr_P(&nvlist_ptr_527, rf->variableReport->emitVariable);

       index_528 = ADL__litvar_val_518[tvec[1]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 1, tvec + 1, 1);
       ADL__emit_VSULong(&index_528, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_529)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_529, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSremove_assertionReport = rf->assertionReport;
       fut_return_524 = ADL__ACF_VSremove(nvlist_ptr_527, index_528, env_529);
       test_value = ADL__VSremove_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_529);
SKIP_2:
       relvec[1] = 1;	/* relinquish succeeds for index_528 */
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_nvlist_ptr(&nvlist_ptr_527, ADL__prop_values_525[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_530,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSremove_head);

    return 0;
}


struct ADL__Directive_info VSremove1_info = {
    N_VARS,
    ADL__var_info_530
};

struct ADL__TDD_info ADL__test_info = {
    20,
    &ADL__VSremove_InfoArrayIdx,
    ADL__VSremove_InfoArray,
    ADL__test_driver,
    "VSremove",
    "VSremove1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSremove1",
    "t1_tr.rif",
    &VSremove1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

