//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/DII/NVList/t1i_tdi.cpp
//
// Purpose:
//
// Modifications:
// $Log: t1i_tdi.cpp,v $
// Revision 1.2  2001/01/11 13:25:26  mli
// Remove value nul from variable lname.
//
// Revision 1.1.1.1  2000/02/09 17:13:21  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/26 14:48:42  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/05 16:28:04  cwatson
// Now uses .hh for c++ include files.
//
// Revision 1.4  1997/10/04 16:42:10  stephen
// Changed include to corba_supp.hh.
//
// Revision 1.3  1997/10/01 16:01:03  cwatson
// Added count(), item(), remove(), add(), add_item() and add_item_consume() tests.
// Makefile changes.
//
// Revision 1.2  1997/09/12 13:01:19  cwatson
// Moved all _ptr provide and relinquish functions to corba/common/ptr_prov.cpp.
//
// Revision 1.1  1997/08/19 14:53:56  cwatson
// *** empty log message ***
//
//
/*
 * ./t1_tdi.c
 */

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

/* ---- global property declarations ---- */
/* ---- test variables and local properties ---- */

int provide_lname(VSString *testvar, enum prop_lname_v v)
{
		char *tvar;

		switch(v){
				case Plname_v_valid:
						tvar = CORBA::string_dup("ApTest");
						break;
				case Plname_v_nil:
						tvar = CORBA::string_dup("");
						break;
		}

		glob_TS.testcase(VSPROVIDE_NVLNAME) = v;
		*testvar = (VSString) tvar;
		return TRUE;
}

int relinquish_lname(VSString *testvar, enum prop_lname_v v)
{
		char *tvar = (char *) *testvar;

		switch(v){
				case Plname_v_valid:
				case Plname_v_nil:
						break;
		}

		return TRUE;
}

int provide_flags_ptr(VSFlags **testvar, enum prop_flags_ptr_v v)
{
		CORBA::Flags  *tvar;
		 
		switch(v){
				case Pflags_ptr_v_in:
						tvar = new CORBA::Flags(CORBA::ARG_IN);
						break;
				case Pflags_ptr_v_out:
						tvar = new CORBA::Flags(CORBA::ARG_OUT);
						break;
				case Pflags_ptr_v_inout:
						tvar = new CORBA::Flags(CORBA::ARG_INOUT);
						break;
		}

		glob_TS.testcase(VSPROVIDE_NVLFLAGS) = v;
		*testvar = (VSFlags *) tvar;
		return TRUE;
}

int relinquish_flags_ptr(VSFlags **testvar, enum prop_flags_ptr_v v)
{
		return TRUE;
}

}

