//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/DII/NamedValue/t1.cpp
//
// Purpose:
//
// Modifications:
// $Log: t1.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:13:25  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1997/12/05 16:28:05  cwatson
// Now uses .hh for c++ include files.
//
// Revision 1.6  1997/11/11 13:13:55  cwatson
// Changed the exception handling by removing VSExceptionWrap.
//
// Revision 1.5  1997/10/04 16:42:11  stephen
// Changed include to corba_supp.hh.
//
// Revision 1.4  1997/10/01 16:02:56  cwatson
// Makefile changes.
//
// Revision 1.3  1997/09/15 10:57:28  cwatson
// Added the VSNOT_IMPLEMENTED macro and we now check for the NOT_IMPLEMENTED
// User Exception.
//
// Revision 1.2  1997/08/22 10:30:32  stephen
// Removed debugging printf calls.
//
// Revision 1.1  1997/08/19 14:57:27  cwatson
// *** empty log message ***
//
//

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/

VSNamedValue_ptr *VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
#ifndef VSORB_NO_NAMEDVALUE_NIL
		CORBA::NamedValue_ptr ttc;

		try {
				ttc = CORBA::NamedValue::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSNamedValue_ptr *) 0;
		}
		catch (...) {
				return (VSNamedValue_ptr *) 0;
		}

		CORBA::NamedValue_ptr *rtc = new CORBA::NamedValue_ptr(ttc);
		return (VSNamedValue_ptr *) rtc;
#else
		VSNOT_IMPLEMENTED;
		return (VSNamedValue_ptr *) 0;
#endif
}

VSNamedValue_ptr *VSduplicate(VSNamedValue_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
#ifndef VSORB_NO_NAMEDVALUE_DUPLICATE
		CORBA::NamedValue_ptr *tc = (CORBA::NamedValue_ptr *) o1;
		CORBA::NamedValue_ptr ttc;

		try {
				ttc = CORBA::NamedValue::_duplicate(tc ? *tc : (CORBA::NamedValue_ptr) 0);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSNamedValue_ptr *) 0;
		}
		catch (...) {
				return (VSNamedValue_ptr *) 0;
		}

		CORBA::NamedValue_ptr *rtc = new CORBA::NamedValue_ptr(ttc);
		return (VSNamedValue_ptr *) rtc;
#else
		VSNOT_IMPLEMENTED;
		return (VSNamedValue_ptr *) 0;
#endif
}

}

