//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/DII/Object/t1.cpp
//
// Purpose:
//
// Modifications:
// $Log: t1.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:13:32  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.8  1999/05/06 16:32:34  cwatson
// SR# 115 Added invalid and nil checks for calling method.
//
// Revision 1.7  1999/05/06 16:08:24  cwatson
// SR# 115 Added invalid and nil checks for calling method.
//
// Revision 1.6  1999/04/26 14:48:45  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/05 16:28:09  cwatson
// Now uses .hh for c++ include files.
//
// Revision 1.4  1997/11/11 13:13:56  cwatson
// Changed the exception handling by removing VSExceptionWrap.
//
// Revision 1.3  1997/10/09 14:26:23  cwatson
// Added CORBA scoping.
//
// Revision 1.2  1997/10/04 16:42:15  stephen
// Changed include to corba_supp.hh.
//
// Revision 1.1  1997/10/03 16:05:51  cwatson
// Initial version.
//
//

#include	<corba_supp.hh>
#include	<tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/

VSStatus VScreate_request(VSObject_ptr *po, VSContext_ptr *pc,
															VSChar *pop, VSNVList_ptr *pnl,
															VSNamedValue_ptr *pr, VSRequest_ptr *preq,
															VSFlags *pf, VSEnvironment *ev)
{
		VSStatus ret = 0;
		CORBA::Environment *env = (CORBA::Environment *) ev;
#ifndef VSORB_NO_OBJECT_CREATE_REQUEST
		CORBA::Object_ptr *o = (CORBA::Object_ptr *) po;
		CORBA::Context_ptr *c = (CORBA::Context_ptr *) pc;
		char *op = (char *) pop;
		CORBA::NVList_ptr *nl = (CORBA::NVList_ptr *) pnl;
		CORBA::NamedValue_ptr *r = (CORBA::NamedValue_ptr *) pr;
		CORBA::Request_ptr *req = (CORBA::Request_ptr *) preq;
		CORBA::Flags *f = (CORBA::Flags *) pf;

		CORBA::Object_ptr ro = o ? *o : 0;
		CORBA::Context_ptr rc = c ? *c : 0;
		CORBA::NVList_ptr rnl = nl ? *nl : 0;
		CORBA::NamedValue_ptr rr = r ? *r : CORBA::NamedValue_ptr(0);
		CORBA::Request_ptr rreq = req ? *req : 0;
		CORBA::Flags rf = f ? *f : CORBA::ARG_IN;

		if(!o || is_invalid_object_ptr(po) || is_nil_object_ptr(po))
			return (VSStatus) 0;

		try {
				(*o)->_create_request(rc,op,rnl,rr,rreq,rf);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSBoolean) 0;
		}
		catch (...) {
				return (VSBoolean) 0;
		}

		*preq = (VSRequest_ptr) rreq;
#else
		VSNOT_IMPLEMENTED;
#endif
		return (VSStatus) 0;
}

/*------------------------------------------------------*/

}

