//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/DII/Object/t1i_tdi.cpp
//
// Purpose:
//
// Modifications:
// $Log: t1i_tdi.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:13:33  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.4  1997/12/05 16:28:10  cwatson
// Now uses .hh for c++ include files.
//
// Revision 1.3  1997/10/09 14:26:23  cwatson
// Added CORBA scoping.
//
// Revision 1.2  1997/10/04 16:42:16  stephen
// Changed include to corba_supp.hh.
//
// Revision 1.1  1997/10/03 16:05:58  cwatson
// Initial version.
//
//

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

/* ---- global property declarations ---- */
/* ---- test variables and local properties ---- */

/* ------------------------------------------------------------ */
/* test variable object_ptr() */

int provide_object_ptr(VSObject_ptr **testvar, enum prop_object_ptr_v v)
{
		CORBA::Object_ptr  *tvar;

		switch(v){
				case Pobject_ptr_v_valid:
						{
						tvar = new CORBA::Object_ptr(glob_TS.m_tobj);
						}
						break;
				case Pobject_ptr_v_nil:
						{
						 CORBA::Object *ao = CORBA::Object::_nil();
						 tvar = new CORBA::Object_ptr(ao);
						}
						break;
				case Pobject_ptr_v_invalid:
						tvar = glob_TS.invalid_object_ptr();
						break;
		}

		*testvar = (VSObject_ptr *) tvar;
		return TRUE;
}

int relinquish_object_ptr(VSObject_ptr **testvar,
							enum prop_object_ptr_v v)
{
		CORBA::Object_ptr  *tvar = (CORBA::Object_ptr *) *testvar;

		switch(v){
				case Pobject_ptr_v_valid:
						break;
				case Pobject_ptr_v_invalid:
						break;
				case Pobject_ptr_v_nil:
						delete tvar;
						break;
		}
		return TRUE;
}

int provide_req_ptr(VSRequest_ptr **testvar)
{
		CORBA::Request_var r;
		CORBA::Request_ptr *rp = new CORBA::Request_ptr(r);
		*testvar = (VSRequest_ptr *) rp;

		return TRUE;
}

int relinquish_req_ptr(VSRequest_ptr **testvar)
{
		return TRUE;
}


int provide_flags(VSFlags **testvar)
{
		CORBA::Flags *fp = new CORBA::Flags(CORBA::ARG_IN);
		*testvar = (VSFlags *) fp;

		return TRUE;
}

int relinquish_flags(VSFlags **testvar)
{
		return TRUE;
}

}

