/* ADL test driver from t1.tdr
 *
 * test VSduplicate(request_ptr, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_483[] = {
    {"valid", Prequest_ptr_v_valid, 0},
    {"nil", Prequest_ptr_v_nil, 0},
    {"null", Prequest_ptr_v_null, 0},
    {"invalid", Prequest_ptr_v_invalid, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_484[] = {
    {"v", "prop", ADL__prop_values_483, 4},
    {0, 0, 0}
};
#define TVEC_SIZE 1

static struct ADL__variableInfo ADL__var_info_487[3] = {
    {"request_ptr", "VSRequest_ptr *", ADL__prop_info_484, 0, 1},
    {"env", "VSEnvironment *", ADL__prop_info_484, 1, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 2


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSduplicate_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSREQUEST_PTR_P
#define ADL__PRINT_VSREQUEST_PTR_P
void (*ADL__print_VSRequest_ptr_P)(VSRequest_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSREQUEST_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSREQUESTSEQ_P
#define ADL__PRINT_VSREQUESTSEQ_P
void (*ADL__print_VSRequestSeq_P)(VSRequestSeq*, emitter_t) = 0;

#endif /* ADL__PRINT_VSREQUESTSEQ_P */

void ADL__emit_VSRequest_ptr_P (void* val, emitter_t emitter)
{
  VSRequest_ptr *tmp;

  if (ADL__print_VSRequest_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSRequest_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSRequestSeq_P (void* val, emitter_t emitter)
{
  VSRequestSeq *tmp;

  if (ADL__print_VSRequestSeq_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSRequestSeq_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {4};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSRequest_ptr *request_ptr_485;
    VSEnvironment *env_486;
    VSRequest_ptr *fut_return_482;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSduplicate_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSduplicate_InfoArrayIdx,
        ADL__VSduplicate_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_request_ptr(&request_ptr_485, ADL__prop_values_483[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSRequest_ptr_P(&request_ptr_485, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_env(&env_486)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
       ADL__emit_VSEnvironment_P(&env_486, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSduplicate_assertionReport = rf->assertionReport;
       fut_return_482 = ADL__ACF_VSduplicate(request_ptr_485, env_486);
       test_value = ADL__VSduplicate_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_env(&env_486);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_request_ptr(&request_ptr_485, ADL__prop_values_483[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_487,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSduplicate_head);

    return 0;
}


struct ADL__Directive_info VSduplicate1_info = {
    N_VARS,
    ADL__var_info_487
};

struct ADL__TDD_info ADL__test_info = {
    4,
    &ADL__VSduplicate_InfoArrayIdx,
    ADL__VSduplicate_InfoArray,
    ADL__test_driver,
    "VSduplicate",
    "VSduplicate1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSduplicate1",
    "t1_tr.rif",
    &VSduplicate1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

