//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/DII/Request/t1i_tdi.cpp
//
// Purpose:
//
// Modifications:
// $Log: t1i_tdi.cpp,v $
// Revision 1.3  2001/01/25 17:22:31  mli
// Update semantics def. and test variable impl. for add_arg,
// send_oneway and send_multiple_oneway.
//
// Revision 1.2  2001/01/05 16:55:13  mli
// Use create_named_value to init. result in provide_ts_req_ptr.
//
// Revision 1.1.1.1  2000/02/09 17:13:36  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.16  1999/04/29 14:48:14  cwatson
// SR100 Removed extra release(), fixed string bounds, set return type.
//
// Revision 1.15  1998/04/24 14:59:47  stephen
// Line wrapped & left syntax errors.
//
// Revision 1.14  1998/04/22 13:40:50  stephen
// Incorrect names used in add_arg calls.
//
// Revision 1.13  1997/12/05 16:28:12  cwatson
// Now uses .hh for c++ include files.
//
// Revision 1.12  1997/11/28 13:27:56  cwatson
// Removed old exception_convert().
//
// Revision 1.11  1997/11/14 12:20:02  cwatson
// create_list now creates a list of 3 items - not 0.
//
// Revision 1.10  1997/10/22 14:25:59  ian
// Added tests for send_oneway, send_deferred, get_response,
// poll_response,send_multiple_oneway and add_arg.
//
// Revision 1.1  1997/08/19 14:57:42  cwatson
// *** empty log message ***
//
//
/*
* ./t1_tdi.c
*/
#include <corba_supp.hh>
#include <tserver.hh>
extern "C" {
#include <t1i_tdi.h>
#include <corba_defs.h>
    /* ---- global property declarations ---- */
    /* ---- test variables and local properties ---- */
    /* ------------------------------------------------------------ */
    int provide_flags(VSFlags **testvar)
    {
	CORBA::Flags *fp = new CORBA::Flags;
	*testvar = (VSFlags *) fp;
	return TRUE;
    }
    int relinquish_flags(VSFlags **testvar)
    {
	return TRUE;
    }
    CORBA::Boolean g_fInvalidRequest = FALSE;
    prop_ops g_OpType;
    CORBA::Any g_Any;
    CORBA::NVList_ptr argList;
    CORBA::NamedValue_ptr result;
    /* test variable VSRequest_ptr * ts_req_ptr(prop p) */
    int provide_ts_req_ptr(VSRequest_ptr **testvar, enum prop_ops p,
			   enum prop_flags flags, enum prop_action action)
    {
	int nRet = TRUE;
	CORBA::ORB_ptr orb = glob_TS.m_corb->orb();
	orb->create_named_value(result);

	CORBA::Request_ptr req;
	CORBA::Flags f;
	switch (flags)
	{
	case Pflags_NoOutListMemory:
	    f = (CORBA::Flags)0;
	    break;
	case Pflags_OutListMemory:
	    f = (CORBA::Flags)0;//CORBA::OUT_LIST_MEMORY;
	    break;
	}
	g_fInvalidRequest = FALSE;
	g_OpType = p;
	try
	{
	    orb->create_list(0, argList);
	    CORBA::NVList_ptr empty_nvl; 
	    orb->create_list(0, empty_nvl);
	    switch (p)
	    {
	    case Pops_Invalid:
	    {
		g_fInvalidRequest = TRUE;
		CORBA::Any::from_char s1('1');
		CORBA::Any::from_char s2('2');
		*(argList->add_item("ONE", CORBA::ARG_IN)->value()) <<= s1;
		*(argList->add_item("TWO", CORBA::ARG_INOUT)->value()) <<= s2;
		argList->add_item("THREE", CORBA::ARG_OUT);

		glob_TS.m_tobj->_create_request(CORBA::Context::_nil(),
						"*completely_bogus_operation_name*",
						(action == Paction_NoNVList) ? empty_nvl : argList, result, req, f);
		req->set_return_type(CORBA::_tc_char);
		break;
	    }
	case Pops_CharOp:
	{
	    CORBA::Any::from_char s1('1');
	    CORBA::Any::from_char s2('2');
	    g_Any <<= s1;
	    *(argList->add_item("c1", CORBA::ARG_IN)->value()) <<= s1;
	    *(argList->add_item("c2", CORBA::ARG_INOUT)->value()) <<= s2;
	    *(argList->add_item("c3", CORBA::ARG_OUT)->value()) <<= s1;

	    glob_TS.m_tobj->_create_request(CORBA::Context::_nil(),
					    "charOp", 
					    (action == Paction_NoNVList) ? empty_nvl: argList,
					    result, req, f);
	    
	    req->set_return_type(CORBA::_tc_char);
	    break;
	}
	case Pops_OctetOp:
	{
	    CORBA::Any::from_octet o1(1);
	    CORBA::Any::from_octet o2(2);
	    g_Any <<= o1;
	    *(argList->add_item("o1", CORBA::ARG_IN)->value()) <<= o1;
	    *(argList->add_item("o2", CORBA::ARG_INOUT)->value()) <<= o2;
	    *(argList->add_item("o3", CORBA::ARG_OUT)->value()) <<= o1;

	    glob_TS.m_tobj->_create_request(CORBA::Context::_nil(),
					    "octetOp", (action == Paction_NoNVList) ? empty_nvl : argList,
					    result, req, f);
		req->set_return_type(CORBA::_tc_octet);
	    break;
	}
	case Pops_BooleanOp:
	{
	    CORBA::Any::from_boolean o1(0);
	    CORBA::Any::from_boolean o2(1);
	    g_Any <<= o1;
	    *(argList->add_item("b1", CORBA::ARG_IN)->value()) <<= o1;
	    *(argList->add_item("b2", CORBA::ARG_INOUT)->value()) <<= o2;
	    *(argList->add_item("b3", CORBA::ARG_OUT)->value()) <<= o1;

	    glob_TS.m_tobj->_create_request(CORBA::Context::_nil(),
					    "booleanOp", (action == Paction_NoNVList) ? empty_nvl : argList,
					    result, req, f);
	    req->set_return_type(CORBA::_tc_boolean);
	    break;
	}
	case Pops_ShortOp:
	    g_Any <<= (CORBA::Short)1;
	    *(argList->add_item("s1", CORBA::ARG_IN)->value())
		<<= (CORBA::Short)1;
	    *(argList->add_item("s2", CORBA::ARG_INOUT)->value())
		<<= (CORBA::Short)2;
	    *(argList->add_item("s3", CORBA::ARG_OUT)->value()) <<= (CORBA::Short)0;

	    glob_TS.m_tobj->_create_request(CORBA::Context::_nil(),
					    "shortOp", (action == Paction_NoNVList) ? empty_nvl : argList,
					    result, req, f);
	    req->set_return_type(CORBA::_tc_short);
	    break;
	case Pops_LongOp:
	    g_Any <<= (CORBA::Long)1;
	    *(argList->add_item("l1", CORBA::ARG_IN)->value())
		<<= (CORBA::Long)1;
	    *(argList->add_item("l2", CORBA::ARG_INOUT)->value())
		<<= (CORBA::Long)2;
	    *(argList->add_item("l3", CORBA::ARG_OUT)->value()) <<= (CORBA::Long)0;

	    glob_TS.m_tobj->_create_request(CORBA::Context::_nil(),
					    "longOp", (action == Paction_NoNVList) ? empty_nvl : argList,
					    result, req, f);
	    req->set_return_type(CORBA::_tc_long);
	    break;
	case Pops_FloatOp:
	    g_Any <<= (CORBA::Float)1.0;
	    *(argList->add_item("f1", CORBA::ARG_IN)->value())
		<<= (CORBA::Float)1.0;
	    *(argList->add_item("f2", CORBA::ARG_INOUT)->value())
		<<= (CORBA::Float)2.0;
	    *(argList->add_item("f3", CORBA::ARG_OUT)->value()) <<=
		(CORBA::Float)0.0;

	    glob_TS.m_tobj->_create_request(CORBA::Context::_nil(),
					    "floatOp", (action == Paction_NoNVList) ? empty_nvl : argList,
					    result, req, f);
	    req->set_return_type(CORBA::_tc_float);
	    break;
	case Pops_DoubleOp:
	    g_Any <<= (CORBA::Double)1.0;
	    *(argList->add_item("d1", CORBA::ARG_IN)->value())
		<<= (CORBA::Double)1.0;
	    *(argList->add_item("d2", CORBA::ARG_INOUT)->value())
		<<= (CORBA::Double)2.0;
	    *(argList->add_item("d3", CORBA::ARG_OUT)->value()) <<=
		(CORBA::Double)0.0;

	    glob_TS.m_tobj->_create_request(CORBA::Context::_nil(),
					    "doubleOp", (action == Paction_NoNVList) ? empty_nvl : argList,
					    result, req, f);
	    req->set_return_type(CORBA::_tc_double);
	    break;
	case Pops_StringOp:
	{
	    CORBA::Any::from_string s1("1", 0, FALSE);
	    CORBA::Any::from_string s2("2", 0, FALSE);
	    g_Any <<= s1;
	    *(argList->add_item("s1", CORBA::ARG_IN)->value()) <<= s1;
	    *(argList->add_item("s2", CORBA::ARG_INOUT)->value()) <<= s2;
	    *(argList->add_item("s3", CORBA::ARG_OUT)->value()) <<= s1;

	    glob_TS.m_tobj->_create_request(CORBA::Context::_nil(),
					    "stringOp", (action == Paction_NoNVList) ? empty_nvl : argList,
					    result, req, f);
	    req->set_return_type(CORBA::_tc_string);
	    break;
	}
	case Pops_UShortOp:
	    g_Any <<= (CORBA::UShort)1;
	    *(argList->add_item("us1", CORBA::ARG_IN)->value())
		<<= (CORBA::UShort)1;
	    *(argList->add_item("us2", CORBA::ARG_INOUT)->value())
		<<= (CORBA::UShort)2;
	    *(argList->add_item("us3", CORBA::ARG_OUT)->value()) <<=
		(CORBA::UShort)0;

	    glob_TS.m_tobj->_create_request(CORBA::Context::_nil(),
					    "ushortOp", (action == Paction_NoNVList) ? empty_nvl : argList,
					    result, req, f);
	    req->set_return_type(CORBA::_tc_ushort);
	    break;
	case Pops_ULongOp:
	    g_Any <<= (CORBA::ULong)1;
	    *(argList->add_item("ul1", CORBA::ARG_IN)->value())
		<<= (CORBA::ULong)1;
	    *(argList->add_item("ul2", CORBA::ARG_INOUT)->value())
		<<= (CORBA::ULong)2;
	    *(argList->add_item("ul3", CORBA::ARG_OUT)->value()) <<=
		(CORBA::ULong)0;

	    glob_TS.m_tobj->_create_request(CORBA::Context::_nil(),
					    "ulongOp", (action == Paction_NoNVList) ? empty_nvl : argList,
					    result, req, f);
	    req->set_return_type(CORBA::_tc_ulong);
	    break;
	}
	    if (CORBA::is_nil(req))
		nRet =  FALSE;
	    else
	    {
		switch (action)
		{
		case Paction_SendDeferred:
		    req->send_deferred();
		    break;
		case Paction_Invoke:
		    req->invoke();
		    break;
		}
		CORBA::Request_ptr *tvar = new CORBA::Request_ptr(req);
		*testvar = (VSRequest_ptr *)tvar;
	    }
	}
	catch (CORBA::Exception &ex)
	{
	    nRet = FALSE;
	}
	return nRet;
    }
    int relinquish_ts_req_ptr(VSRequest_ptr **testvar, enum prop_ops p,
			      enum prop_flags flags, enum prop_action action)
    {
	switch (flags)
	{
	case Pflags_NoOutListMemory:
	    // TO DO: Release NVlist
	    break;
	case Pflags_OutListMemory:
	    break;
	}
	switch (p)
	{
	case Pops_Invalid:
	    delete (CORBA::Request_ptr *)*testvar;
	    CORBA::release(argList);
	    break;
	default:
	    delete (CORBA::Request_ptr *)*testvar;
	    CORBA::release(argList);
	    break;
	}
	return TRUE;
    }
    // test variable VSRequestSeq * ts_oneway_reqseq_ptr(anonymous prop)
    int provide_ts_oneway_reqseq_ptr(VSRequestSeq **testvar, enum prop_req_list
				     p)
    {
	int nRet = TRUE;
	CORBA::ORB::RequestSeq seq;
	try {
	    switch (p)
	    {
	    case Preq_list_OneReq:
	    {
		VSRequest_ptr *p;
		provide_ts_req_ptr(&p, Pops_CharOp,
				   Pflags_OutListMemory, Paction_None);
		seq.length(1);
		seq[0] = (CORBA::Request_ptr)*p;
		break;
	    }
	case Preq_list_TwoReq:
	{
	    VSRequest_ptr *p1, *p2;

	    provide_ts_req_ptr(&p1, Pops_CharOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p2, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);

	    seq.length(2);
	    seq[0] = (CORBA::Request_ptr)*p1;
	    seq[1] = (CORBA::Request_ptr)*p2;
	    break;
	}
	case Preq_list_ThreeReq:
	{
	    VSRequest_ptr *p1, *p2, *p3;

	    provide_ts_req_ptr(&p1, Pops_CharOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p2, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p3, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    seq.length(3);
	    seq[0] = (CORBA::Request_ptr)*p1;
	    seq[1] = (CORBA::Request_ptr)*p2;
	    seq[2] = (CORBA::Request_ptr)*p3;
	    break;
	}
	case Preq_list_FourReq:
	{
	    VSRequest_ptr *p1, *p2, *p3, *p4;

	    provide_ts_req_ptr(&p1, Pops_CharOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p2, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p3, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p4, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    seq.length(4);
	    seq[0] = (CORBA::Request_ptr)*p1;
	    seq[1] = (CORBA::Request_ptr)*p2;
	    seq[2] = (CORBA::Request_ptr)*p3;
	    seq[3] = (CORBA::Request_ptr)*p4;
	    break;
	}
	case Preq_list_FiveReq:
	{
	    VSRequest_ptr *p1, *p2, *p3, *p4, *p5;

	    provide_ts_req_ptr(&p1, Pops_CharOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p2, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p3, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p4, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p5, Pops_BooleanOp,
			       Pflags_OutListMemory, Paction_None);
	    seq.length(5);
	    seq[0] = (CORBA::Request_ptr)*p1;
	    seq[1] = (CORBA::Request_ptr)*p2;
	    seq[2] = (CORBA::Request_ptr)*p3;
	    seq[3] = (CORBA::Request_ptr)*p4;
	    seq[4] = (CORBA::Request_ptr)*p4;
	    break;
	}
	case Preq_list_SixReq:
	{
	    VSRequest_ptr *p1, *p2, *p3, *p4, *p5, *p6;

	    provide_ts_req_ptr(&p1, Pops_CharOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p2, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p3, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p4, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p5, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p6, Pops_DoubleOp,
			       Pflags_OutListMemory, Paction_None);
	    seq.length(6);
	    seq[0] = (CORBA::Request_ptr)*p1;
	    seq[1] = (CORBA::Request_ptr)*p2;
	    seq[2] = (CORBA::Request_ptr)*p3;
	    seq[3] = (CORBA::Request_ptr)*p4;
	    seq[4] = (CORBA::Request_ptr)*p5;
	    seq[5] = (CORBA::Request_ptr)*p6;
	    break;
	}
	case Preq_list_SevenReq:
	{
	    VSRequest_ptr *p1, *p2, *p3, *p4, *p5, *p6, *p7;

	    provide_ts_req_ptr(&p1, Pops_CharOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p2, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p3, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p4, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p5, Pops_ULongOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p6, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p7, Pops_StringOp,
			       Pflags_OutListMemory, Paction_None);
	    seq.length(7);
	    seq[0] = (CORBA::Request_ptr)*p1;
	    seq[1] = (CORBA::Request_ptr)*p2;
	    seq[2] = (CORBA::Request_ptr)*p3;
	    seq[3] = (CORBA::Request_ptr)*p4;
	    seq[4] = (CORBA::Request_ptr)*p5;
	    seq[5] = (CORBA::Request_ptr)*p6;
	    seq[6] = (CORBA::Request_ptr)*p7;
	    break;
	}
	case Preq_list_EightReq:
	{
	    VSRequest_ptr *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8;

	    provide_ts_req_ptr(&p1, Pops_CharOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p2, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p3, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p4, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p5, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p6, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p7, Pops_UShortOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p8, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    seq.length(8);
	    seq[0] = (CORBA::Request_ptr)*p1;
	    seq[1] = (CORBA::Request_ptr)*p2;
	    seq[2] = (CORBA::Request_ptr)*p3;
	    seq[3] = (CORBA::Request_ptr)*p4;
	    seq[4] = (CORBA::Request_ptr)*p5;
	    seq[5] = (CORBA::Request_ptr)*p6;
	    seq[6] = (CORBA::Request_ptr)*p7;
	    seq[7] = (CORBA::Request_ptr)*p8;
	    break;
	}
	case Preq_list_NineReq:
	{
	    VSRequest_ptr *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9;

	    provide_ts_req_ptr(&p1, Pops_CharOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p2, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p3, Pops_Invalid,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p4, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p5, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p6, Pops_BooleanOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p7, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p8, Pops_StringOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p9, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    seq.length(9);
	    seq[0] = (CORBA::Request_ptr)*p1;
	    seq[1] = (CORBA::Request_ptr)*p2;
	    seq[2] = (CORBA::Request_ptr)*p3;
	    seq[3] = (CORBA::Request_ptr)*p4;
	    seq[4] = (CORBA::Request_ptr)*p5;
	    seq[5] = (CORBA::Request_ptr)*p6;
	    seq[6] = (CORBA::Request_ptr)*p7;
	    seq[7] = (CORBA::Request_ptr)*p8;
	    seq[8] = (CORBA::Request_ptr)*p9;
	    break;
	}
	case Preq_list_TenReq:
	{
	    VSRequest_ptr *p1, *p2, *p3, *p4, *p5, *p6, *p7, *p8, *p9, *p10;

	    provide_ts_req_ptr(&p1, Pops_CharOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p2, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p3, Pops_OctetOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p4, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p5, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p6, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p7, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p8, Pops_StringOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p9, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    provide_ts_req_ptr(&p10, Pops_FloatOp,
			       Pflags_OutListMemory, Paction_None);
	    seq.length(10);
	    seq[0] = (CORBA::Request_ptr)*p1;
	    seq[1] = (CORBA::Request_ptr)*p2;
	    seq[2] = (CORBA::Request_ptr)*p3;
	    seq[3] = (CORBA::Request_ptr)*p4;
	    seq[4] = (CORBA::Request_ptr)*p5;
	    seq[5] = (CORBA::Request_ptr)*p6;
	    seq[6] = (CORBA::Request_ptr)*p7;
	    seq[7] = (CORBA::Request_ptr)*p8;
	    seq[8] = (CORBA::Request_ptr)*p9;
	    seq[9] = (CORBA::Request_ptr)*p10;
	    break;
	}
	}
	}
	catch (...)
	{
	    nRet = FALSE;
	}

	if (nRet)
	{
	    CORBA::ORB::RequestSeq *ret = new CORBA::ORB::RequestSeq(seq);
	    *testvar = (VSRequestSeq *)ret;
	}
	return nRet;
    }
    int relinquish_ts_oneway_reqseq_ptr(VSRequestSeq **testvar,
					enum prop_req_list)
    {
	delete (CORBA::ORB::RequestSeq *)*testvar;
	return TRUE;
    }
    /* ------------------------------------------------------------ */
}
