/* ADL test driver from t1.tdr
 *
 * test VSSystemEx_completed(sysex_ptr, completed, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop all_sysex */
static struct ADL__propertyValue ADL__prop_values_900[] = {
    {"unknown", Pall_sysex_unknown, 0},
    {"bad_param", Pall_sysex_bad_param, 0},
    {"no_memory", Pall_sysex_no_memory, 0},
    {"imp_limit", Pall_sysex_imp_limit, 0},
    {"comm_failure", Pall_sysex_comm_failure, 0},
    {"inv_objref", Pall_sysex_inv_objref, 0},
    {"no_permission", Pall_sysex_no_permission, 0},
    {"internal", Pall_sysex_internal, 0},
    {"marshal", Pall_sysex_marshal, 0},
    {"initialize", Pall_sysex_initialize, 0},
    {"no_implement", Pall_sysex_no_implement, 0},
    {"bad_typecode", Pall_sysex_bad_typecode, 0},
    {"bad_operation", Pall_sysex_bad_operation, 0},
    {"no_resources", Pall_sysex_no_resources, 0},
    {"no_response", Pall_sysex_no_response, 0},
    {"persist_store", Pall_sysex_persist_store, 0},
    {"bad_inv_order", Pall_sysex_bad_inv_order, 0},
    {"transient", Pall_sysex_transient, 0},
    {"free_mem", Pall_sysex_free_mem, 0},
    {"inv_ident", Pall_sysex_inv_ident, 0},
    {"inv_flag", Pall_sysex_inv_flag, 0},
    {"intf_repos", Pall_sysex_intf_repos, 0},
    {"bad_context", Pall_sysex_bad_context, 0},
    {"obj_adapter", Pall_sysex_obj_adapter, 0},
    {"data_conversion", Pall_sysex_data_conversion, 0},
    {"object_not_exist", Pall_sysex_object_not_exist, 0},
    {"valid", Pall_sysex_valid, 0},
    {0, 0, 0}
};

/* values for prop prop_1 */
static struct ADL__propertyValue ADL__prop_values_901[] = {
    {"yes", Pcompleted_prop_1_yes, 0},
    {"no", Pcompleted_prop_1_no, 0},
    {"maybe", Pcompleted_prop_1_maybe, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_902[] = {
    {"=all_sysex", "prop", ADL__prop_values_900, 27},
    {"prop_1", "prop", ADL__prop_values_901, 3},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_906[4] = {
    {"sysex_ptr", "VSSystemException *", ADL__prop_info_902, 0, 1},
    {"completed", "VSCompleted", ADL__prop_info_902, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_902, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSSystemEx_completed_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSEXCEPTION_P
#define ADL__PRINT_VSEXCEPTION_P
void (*ADL__print_VSException_P)(VSException*, emitter_t) = 0;

#endif /* ADL__PRINT_VSEXCEPTION_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSSYSTEMEXCEPTION_P
#define ADL__PRINT_VSSYSTEMEXCEPTION_P
void (*ADL__print_VSSystemException_P)(VSSystemException*, emitter_t) = 0;

#endif /* ADL__PRINT_VSSYSTEMEXCEPTION_P */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */
#ifndef ADL__PRINT_VSCOMPLETED
#define ADL__PRINT_VSCOMPLETED
void (*ADL__print_VSCompleted)(VSCompleted, emitter_t) = 0;

#endif /* ADL__PRINT_VSCOMPLETED */
#ifndef ADL__PRINT_VSUSEREXCEPTION_P
#define ADL__PRINT_VSUSEREXCEPTION_P
void (*ADL__print_VSUserException_P)(VSUserException*, emitter_t) = 0;

#endif /* ADL__PRINT_VSUSEREXCEPTION_P */

void ADL__emit_VSException_P (void* val, emitter_t emitter)
{
  VSException *tmp;

  if (ADL__print_VSException_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSException_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSSystemException_P (void* val, emitter_t emitter)
{
  VSSystemException *tmp;

  if (ADL__print_VSSystemException_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSSystemException_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSCompleted (void* val, emitter_t emitter)
{
  VSCompleted tmp;

  if (ADL__print_VSCompleted != 0) {
    tmp = *(VSCompleted*) val;
    ADL__print_VSCompleted(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSUserException_P (void* val, emitter_t emitter)
{
  VSUserException *tmp;

  if (ADL__print_VSUserException_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSUserException_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {27, 3};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSSystemException *sysex_ptr_903;
    VSCompleted completed_904;
    VSEnvironment *env_905;
    VSCompleted fut_return_899;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSSystemEx_completed_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSSystemEx_completed_InfoArrayIdx,
        ADL__VSSystemEx_completed_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_sysex_ptr(&sysex_ptr_903, ADL__prop_values_900[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSSystemException_P(&sysex_ptr_903, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_completed(&completed_904, ADL__prop_values_901[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSCompleted(&completed_904, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_905)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_905, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSSystemEx_completed_assertionReport = rf->assertionReport;
       fut_return_899 = ADL__ACF_VSSystemEx_completed(sysex_ptr_903, completed_904, env_905);
       test_value = ADL__VSSystemEx_completed_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_905);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_completed(&completed_904, ADL__prop_values_901[tvec[1]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_sysex_ptr(&sysex_ptr_903, ADL__prop_values_900[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_906,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSSystemEx_completed_head);

    return 0;
}


struct ADL__Directive_info VSSystemEx_completed1_info = {
    N_VARS,
    ADL__var_info_906
};

struct ADL__TDD_info ADL__test_info = {
    81,
    &ADL__VSSystemEx_completed_InfoArrayIdx,
    ADL__VSSystemEx_completed_InfoArray,
    ADL__test_driver,
    "VSSystemEx_completed",
    "VSSystemEx_completed1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSSystemEx_completed1",
    "t1_tr.rif",
    &VSSystemEx_completed1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

