//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/Exceptions/sysex/t1_aux.cpp
//
// Purpose:
//
// Modifications:
// $Log: t1_aux.cpp,v $
// Revision 1.4  2001/01/26 08:31:35  mli
// Update sysex_completed_equal.
//
// Revision 1.3  2001/01/25 11:48:21  mli
// Update for VSSystemEx_completed.
//
// Revision 1.2  2000/02/18 11:02:55  mli
// Corrected an error in method 'sysex_completed_equal'.
//
// Revision 1.1.1.1  2000/02/09 17:13:40  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.10  1999/04/30 10:09:27  cwatson
// SR100 Changed exception equality functions.
//
// Revision 1.9  1999/04/28 14:26:31  cwatson
// SR100 text revision change.
//
// Revision 1.8  1999/04/27 14:07:39  cwatson
// SR100 Unrequired redirection removed.
//
// Revision 1.7  1997/12/05 16:28:13  cwatson
// Now uses .hh for c++ include files.
//
// Revision 1.6  1997/11/11 13:13:58  cwatson
// Changed the exception handling by removing VSExceptionWrap.
//
// Revision 1.5  1997/10/09 10:52:51  tet
// Removed undeeded #define.
//
// Revision 1.4  1997/10/04 16:42:20  stephen
// Changed include to corba_supp.hh.
//
// Revision 1.3  1997/10/01 16:03:59  cwatson
// Makefile changes.
//
// Revision 1.2  1997/09/19 15:44:25  ian
// Windows NT version.
//
// Revision 1.1  1997/08/19 15:03:21  cwatson
// *** empty log message ***
//
//
/*
 *
 * t1_aux.c -- 
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

//-----------------------------------------------------------
// General SystemException.

int sysex_equal(VSSystemException *e1, VSSystemException *e2)
{
	CORBA::SystemException *ex1 = (CORBA::SystemException *) e1;
	CORBA::SystemException *ex2 = (CORBA::SystemException *) e2;

	if (!ex1 && !ex2)
        return TRUE;
	if (!ex1 || !ex2)
        return FALSE;
	return ex1->minor() == ex2->minor() &&
        ex1->completed() == ex2->completed();
}

int sysex_minor_equal(VSSystemException *e1, VSULong m)
{
		CORBA::SystemException *ex1 = (CORBA::SystemException *) e1;
		CORBA::ULong	mn = (CORBA::ULong) m;

		return (ex1 && (ex1->minor() == mn)) ? TRUE : FALSE;
}

int sysex_completed_equal(VSSystemException *e1, VSCompleted m)
{
		CORBA::SystemException *ex1 = (CORBA::SystemException *) e1;
		CORBA::CompletionStatus* mn = (CORBA::CompletionStatus*) m;

		return (ex1 && (ex1->completed() == *mn)) ? TRUE : FALSE;
}

//-----------------------------------------------------------
// General UserException.

int userex_equal(VSUserException *e1, VSUserException *e2)
{
	CORBA::UserException *ex1 = (CORBA::UserException *) e1;
	CORBA::UserException *ex2 = (CORBA::UserException *) e2;

	return !ex1 == !ex2;
}

}
