
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/

VSIDLType_ptr
VSoriginal_type_def_read(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Object_ptr     obj_ptr;
		CORBA::Repository_ptr 	IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::AliasDef_ptr 		aliasDef_ptr;
		CORBA::IDLType_ptr    	IDLT_ptr;
		IRSupport *irs = glob_TS.repository();
 
		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_AliasDef::A1");
				aliasDef_ptr = CORBA::AliasDef::_narrow(ctnD_ptr);
				IDLT_ptr = aliasDef_ptr->original_type_def();
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		return (VSIDLType_ptr) IDLT_ptr;
}
/*------------------------------------------------------*/
VSAliasDef_ptr*
VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::AliasDef_ptr ttc;
				 
		try {
				ttc = CORBA::AliasDef::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		catch (...) {
				return (VSAliasDef_ptr *) 0;
		}
		CORBA::AliasDef_ptr *rtc = new CORBA::AliasDef_ptr(ttc);
		return (VSAliasDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSAliasDef_ptr*
VSduplicate(VSAliasDef_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::AliasDef_ptr *tc = (CORBA::AliasDef_ptr *) o1;
		CORBA::AliasDef_ptr ttc;
						 
		try {
       ttc = CORBA::AliasDef::_duplicate(tc ? *tc : (CORBA::AliasDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSAliasDef_ptr *) 0;
    }
		 
		CORBA::AliasDef_ptr *rtc = new CORBA::AliasDef_ptr(ttc);
		return (VSAliasDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSAliasDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
		CORBA::AliasDef_ptr ttc;
						 
		try {
        ttc = CORBA::AliasDef::_narrow(tc ? *tc : (CORBA::AliasDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSAliasDef_ptr *) 0;
    }
		 
		CORBA::AliasDef_ptr *rtc = new CORBA::AliasDef_ptr(ttc);
		return (VSAliasDef_ptr *) rtc;
}

/*------------------------------------------------------*/
/* WRITE INTERFACE */
/*------------------------------------------------------*/

void
VSoriginal_type_def_write(const VSIDLType_ptr vs_idltype_ptr, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::IDLType_ptr IDLT_ptr = (CORBA::IDLType_ptr) vs_idltype_ptr;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::AliasDef_ptr alDef_ptr;
		IRSupport *irs = glob_TS.repository();
		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_AliasDef::A2");
				alDef_ptr = CORBA::AliasDef::_narrow(ctnD_ptr);
				alDef_ptr->original_type_def(IDLT_ptr);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
}


/*------------------------------------------------------*/
/* redefined functions */
/*------------------------------------------------------*/
VSDefinitionKind VSdef_kind(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::DefinitionKind dk;
		CORBA::AliasDef_ptr 	aliasDef_ptr;
		IRSupport *irs = glob_TS.repository();
    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_AliasDef::A1");
				if (!ctnD_ptr)
						return (VSDefinitionKind) 0;
				aliasDef_ptr = CORBA::AliasDef::_narrow(ctnD_ptr);
				dk = aliasDef_ptr->def_kind();
			}
    catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
    return (VSDefinitionKind) dk;
}

/*------------------------------------------------------*/
VSTypeCode_ptr*
VStype(VSEnvironment *ev) 
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr retType_ptr;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::AliasDef_ptr 	aliasDef_ptr;
		IRSupport *irs = glob_TS.repository();

    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_AliasDef::A1");
				aliasDef_ptr = CORBA::AliasDef::_narrow(ctnD_ptr);
				retType_ptr = aliasDef_ptr->type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (retType_ptr);
		return (VSTypeCode_ptr *) rptr;
}
/*------------------------------------------------------*/
}

