//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/

VSTypeCode_ptr* 
VSelement_type(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr	IR_ptr;
		CORBA::Contained_ptr		ctnD_ptr;
		CORBA::ArrayDef_ptr 	arDef_ptr;
		CORBA::TypeCode_ptr		tc_ptr;
		IRSupport *irs = glob_TS.repository();

		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_ArrayDef::I1::Ar");
				CORBA::AliasDef_ptr alDef_ptr = CORBA::AliasDef::_narrow(ctnD_ptr);
				CORBA::IDLType_ptr idlobj_ptr = alDef_ptr->original_type_def();
				arDef_ptr = CORBA::ArrayDef::_narrow(idlobj_ptr);
				tc_ptr = arDef_ptr->element_type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSTypeCode_ptr *) 0;
		}
		CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (tc_ptr);
		return (VSTypeCode_ptr *) rptr;
}

/*------------------------------------------------------*/
/* type_def_read() */

VSIDLType_ptr
VSelement_type_def_read(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr	IR_ptr;
  	CORBA::Contained_ptr  ctnD_ptr;
		CORBA::ArrayDef_ptr 	arDef_ptr;
		CORBA::IDLType_ptr    IDLT_ptr;
		IRSupport *irs = glob_TS.repository();
		
		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_ArrayDef::I1::Ar");
				CORBA::AliasDef_ptr alDef_ptr = CORBA::AliasDef::_narrow(ctnD_ptr);
				CORBA::IDLType_ptr idlobj_ptr = alDef_ptr->original_type_def();
				arDef_ptr = CORBA::ArrayDef::_narrow(idlobj_ptr);
				IDLT_ptr = arDef_ptr->element_type_def();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		return (VSIDLType_ptr) IDLT_ptr;
}

/*------------------------------------------------------*/
VSULong
VSlength_read(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::ArrayDef_ptr arDef_ptr;
		CORBA::ULong arDef_length;
		IRSupport *irs = glob_TS.repository();
		
		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_ArrayDef::I1::Ar");
				CORBA::AliasDef_ptr alDef_ptr = CORBA::AliasDef::_narrow(ctnD_ptr);
				CORBA::IDLType_ptr idlobj_ptr = alDef_ptr->original_type_def();
				arDef_ptr = CORBA::ArrayDef::_narrow(idlobj_ptr);
				if(arDef_ptr == NULL) throw 0;
				arDef_length = arDef_ptr->length();
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
           env->exception(t);
    }
		catch (...) {
        return (VSULong) 0;
    }
		return (VSULong) arDef_length;
}

/*------------------------------------------------------*/
VSArrayDef_ptr*
VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::ArrayDef_ptr ttc;
				 
		try {
				ttc = CORBA::ArrayDef::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				}
				catch (...) {
						return (VSArrayDef_ptr *) 0;
		}
		CORBA::ArrayDef_ptr *rtc = new CORBA::ArrayDef_ptr(ttc);
		return (VSArrayDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSArrayDef_ptr*
VSduplicate(VSArrayDef_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::ArrayDef_ptr *tc = (CORBA::ArrayDef_ptr *) o1;
		CORBA::ArrayDef_ptr ttc;
						 
		try {
       ttc = CORBA::ArrayDef::_duplicate(tc ? *tc : (CORBA::ArrayDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSArrayDef_ptr *) 0;
    }
		 
		CORBA::ArrayDef_ptr *rtc = new CORBA::ArrayDef_ptr(ttc);
		return (VSArrayDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSArrayDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
		CORBA::ArrayDef_ptr ttc;
						 
		try {
        ttc = CORBA::ArrayDef::_narrow(tc ? *tc : (CORBA::ArrayDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSArrayDef_ptr *) 0;
    }
		CORBA::ArrayDef_ptr *rtc = new CORBA::ArrayDef_ptr(ttc);
		return (VSArrayDef_ptr *) rtc;
}

/*------------------------------------------------------*/
/* WRITE INTERFACE */
/*------------------------------------------------------*/

void
VSlength_write(VSULong vs_new_length, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::ULong new_length = (CORBA::ULong) vs_new_length;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::ArrayDef_ptr arDef_ptr;
		IRSupport *irs = glob_TS.repository();

		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_ArrayDef::I1::Ar");
				CORBA::AliasDef_ptr alDef_ptr = CORBA::AliasDef::_narrow(ctnD_ptr);
				CORBA::IDLType_ptr idlobj_ptr = alDef_ptr->original_type_def();
				arDef_ptr = CORBA::ArrayDef::_narrow(idlobj_ptr);
				arDef_ptr->length(new_length);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
}

/*------------------------------------------------------*/
void
VSelement_type_def_write(const VSIDLType_ptr vs_idltype_ptr, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::IDLType_ptr IDLT_ptr = (CORBA::IDLType_ptr) vs_idltype_ptr;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::ArrayDef_ptr arDef_ptr;
		IRSupport *irs = glob_TS.repository();
		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_ArrayDef::I1::Ar2");
				CORBA::AliasDef_ptr alDef_ptr = CORBA::AliasDef::_narrow(ctnD_ptr);
				CORBA::IDLType_ptr idlobj_ptr = alDef_ptr->original_type_def();
				arDef_ptr = CORBA::ArrayDef::_narrow(idlobj_ptr);
				arDef_ptr->element_type_def(IDLT_ptr);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
}
		 
/*------------------------------------------------------*/
/* redefined functions */
/*------------------------------------------------------*/
VSDefinitionKind VSdef_kind(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::DefinitionKind dk;
		CORBA::ArrayDef_ptr 	arrayDef_ptr;
		IRSupport *irs = glob_TS.repository();

    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_ArrayDef::I1::Ar");
				CORBA::AliasDef_ptr alDef_ptr = CORBA::AliasDef::_narrow(ctnD_ptr);
				CORBA::IDLType_ptr idlobj_ptr = alDef_ptr->original_type_def();
				arrayDef_ptr = CORBA::ArrayDef::_narrow(idlobj_ptr);
				dk = arrayDef_ptr->def_kind();
		}
    catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
    return (VSDefinitionKind) dk;
}
/*------------------------------------------------------*/
VSTypeCode_ptr*
VStype(VSEnvironment *ev) 
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr retType_ptr;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::ArrayDef_ptr 	arrDef_ptr;
		IRSupport *irs = glob_TS.repository();

    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_ArrayDef::I1::Ar");
				CORBA::AliasDef_ptr alDef_ptr = CORBA::AliasDef::_narrow(ctnD_ptr);
				CORBA::IDLType_ptr idlobj_ptr = alDef_ptr->original_type_def();
				arrDef_ptr = CORBA::ArrayDef::_narrow(idlobj_ptr);
				retType_ptr = arrDef_ptr->type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (retType_ptr);
		return (VSTypeCode_ptr *) rptr;
}
/*------------------------------------------------------*/

}

