//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//
/*
 *
 * t1_aux.c -- 
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>


/*------------------------------------------------------*/
int
is_correct_length(VSULong vs_l)
{
		CORBA::Long l = (CORBA::Long) vs_l;

		if (l == 10)
				return TRUE;
								
		return FALSE;
}

/*------------------------------------------------------*/
int
is_correct_element_type(VSTypeCode_ptr* vs_tc_ptr)
{
	CORBA::TypeCode_ptr* tc_ptr = (CORBA::TypeCode_ptr *) vs_tc_ptr;

  return((*tc_ptr)->kind() == CORBA::tk_short);
}

/*------------------------------------------------------*/
int
is_correct_element_type_def(VSIDLType_ptr vs_idltype_ptr)
{
	CORBA::IDLType_ptr idltype_ptr = (CORBA::IDLType_ptr) vs_idltype_ptr;
	 
	return(idltype_ptr->type()->kind() == CORBA::tk_short);
}
/*------------------------------------------------------*/
int is_nil_object(VSObject_ptr o1)
{
		CORBA::Object_ptr obj1 = (CORBA::Object_ptr) o1;
		 
		if(!obj1)
			return TRUE;
		return CORBA::is_nil(obj1);
}

int
is_nil_arraydef_ptr(VSArrayDef_ptr *o1)
{
		CORBA::ArrayDef_ptr *tc = (CORBA::ArrayDef_ptr *) o1;
		if(!tc)
				return TRUE;
								 
		return CORBA::is_nil(*tc);
}
											 
int 
cleanup_arraydef_ptr(VSArrayDef_ptr *o1)
{
		CORBA::ArrayDef_ptr *tc = (CORBA::ArrayDef_ptr *) o1;
		if(!tc)
				return TRUE;
		delete tc;
		return TRUE;
}
/*------------------------------------------------------*/
/* aux functions for the write functionality */
/*------------------------------------------------------*/
int
is_correct_new_length(VSULong vs_l1, VSULong vs_l2)
{
		CORBA::ULong l1 = (CORBA::ULong) vs_l1;
		CORBA::ULong l2 = (CORBA::ULong) vs_l2;
		return (l1 == l2);
}
						 
/*------------------------------------------------------*/
int
is_same_type_def(VSIDLType_ptr vs_idl1_ptr, VSIDLType_ptr vs_idl2_ptr)
{
		CORBA::IDLType_ptr idl1_ptr = (CORBA::IDLType_ptr) vs_idl1_ptr;
		CORBA::IDLType_ptr idl2_ptr = (CORBA::IDLType_ptr) vs_idl2_ptr;
		CORBA::TypeCode_ptr t1 = idl1_ptr->type();
		CORBA::TypeCode_ptr t2 = idl2_ptr->type();

		return t1->equal(t2);
}
													
/*------------------------------------------------------*/
/* aux funcs for redefined functionality */
/*------------------------------------------------------*/
int
is_correct_def_kind(VSDefinitionKind vs_dk)
{
		CORBA::DefinitionKind dk = (CORBA::DefinitionKind) vs_dk;
		return (dk == CORBA::dk_Array);
}
													 
/*------------------------------------------------------*/
int
is_correct_typecode(VSTypeCode_ptr* vs_tc_ptr)
{
		CORBA::TypeCode_ptr* tc_ptr = (CORBA::TypeCode_ptr *) vs_tc_ptr;
		return ((*tc_ptr)->kind() == CORBA::tk_array);
}
/*------------------------------------------------------*/
}
