//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

/* ------------------------------------------------------------ */
/* object_ptr is provided for the VSnarrow() test */
int
provide_object_ptr (VSObject_ptr **testvar,
											enum prop_object_ptr_objValue objValue)
{
	CORBA::Object_ptr tvar;
	CORBA::Object_ptr *rptr;
	CORBA::Repository_ptr IR_ptr;
	CORBA::AliasDef_ptr alDef_ptr;
	CORBA::IDLType_ptr idlobj_ptr;
	CORBA::Contained_ptr ctnD_ptr;

	IRSupport *irs = glob_TS.repository();

    switch (objValue)  {
        case Pobject_ptr_objValue_valid:
        		IR_ptr = irs->get_repository();
        		ctnD_ptr = irs->get_contained(IR_ptr,"M_ArrayDef::I1::Ar");
						alDef_ptr = CORBA::AliasDef::_narrow(ctnD_ptr);
						idlobj_ptr = alDef_ptr->original_type_def();
						tvar = idlobj_ptr;
						break;
       case Pobject_ptr_objValue_null:
            tvar = NULL;
						break;
    }
		rptr = new CORBA::Object_ptr(tvar);
		*testvar = (VSObject_ptr *) rptr;
		return TRUE;
}

int
relinquish_object_ptr (VSObject_ptr **testvar,
													enum prop_object_ptr_objValue objValue)
{
	CORBA::Object_ptr* tvar = (CORBA::Object_ptr *) *testvar;
	
    switch (objValue)  {
        case Pobject_ptr_objValue_valid:
						delete tvar;
						break;
				case Pobject_ptr_objValue_null:
        		break;
    }
		return TRUE;
}

/* ------------------------------------------------------------ */
/* arraydef_ptr is provided for the VSduplicate() test */
int
provide_arraydef_ptr (VSArrayDef_ptr **testvar,
											enum prop_arraydef_ptr_arrayValue arrayValue)
{
    CORBA::ArrayDef_ptr tvar;
    CORBA::ArrayDef_ptr *rptr;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr ctnD_ptr;
    CORBA::AliasDef_ptr alDef_ptr;
		CORBA::IDLType_ptr idlobj_ptr;
		IRSupport *irs = glob_TS.repository();

    switch (arrayValue)  {
        case Parraydef_ptr_arrayValue_valid:
        		IR_ptr = irs->get_repository();
        		ctnD_ptr = irs->get_contained(IR_ptr,"M_ArrayDef::I1::Ar");
						alDef_ptr = CORBA::AliasDef::_narrow(ctnD_ptr);
						idlobj_ptr = alDef_ptr->original_type_def();
	    			tvar = CORBA::ArrayDef::_narrow(idlobj_ptr);
	    			break;
	    	case Parraydef_ptr_arrayValue_null:
						tvar = NULL;
	   			 	break;
    }
		rptr = new CORBA::ArrayDef_ptr(tvar);
		*testvar = (VSArrayDef_ptr *) rptr;
		return TRUE;
}

int
relinquish_arraydef_ptr (VSArrayDef_ptr **testvar,
													enum prop_arraydef_ptr_arrayValue arrayValue)
{
	CORBA::ArrayDef_ptr* tvar = (CORBA::ArrayDef_ptr *) *testvar;

		switch (arrayValue)  {
        case Parraydef_ptr_arrayValue_valid:
						delete tvar;
						break;
				case Parraydef_ptr_arrayValue_null:
						break;
    }
		return TRUE;
}
/* ------------------------------------------------------------ */
/* type is provided for the VSelement_type_def_write() test */
int
provide_type (VSIDLType_ptr *testvar)
{
    CORBA::IDLType_ptr *tvar = (CORBA::IDLType_ptr *) testvar;
		CORBA::Repository_ptr  IR_ptr;
		IRSupport *irs = glob_TS.repository();
		IR_ptr = irs->get_repository();
		try {
				*tvar = IR_ptr->get_primitive(CORBA::pk_short);
		}
		catch (...) {
				return FALSE;
		}
		return TRUE;
}

int
relinquish_type (VSIDLType_ptr *testvar)
{
		return TRUE;
}
				 
/* ------------------------------------------------------------ */

}
