//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */

/*------------------------------------------------------*/
/* type() */

VSTypeCode_ptr* 
VStype(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr	IR_ptr;
		CORBA::Contained_ptr		ctnD_ptr;
		CORBA::AttributeDef_ptr attDef_ptr;
		CORBA::TypeCode_ptr		tc_ptr;
		IRSupport *irs = glob_TS.repository();

		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_AttributeDef::I1::Att_ro");
				attDef_ptr = CORBA::AttributeDef::_narrow(ctnD_ptr);
				tc_ptr = attDef_ptr->type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
        return (VSTypeCode_ptr *) 0;
		}
		CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (tc_ptr);
		return (VSTypeCode_ptr *) rptr;
}

/*------------------------------------------------------*/
/* type_def_read() */

VSIDLType_ptr
VStype_def_read(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr	IR_ptr;
  	CORBA::Contained_ptr   ctnD_ptr;
		CORBA::AttributeDef_ptr attDef_ptr;
		CORBA::IDLType_ptr    IDLT_ptr;
		IRSupport *irs = glob_TS.repository();
		
		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_AttributeDef::I1::Att_ro");
				attDef_ptr = CORBA::AttributeDef::_narrow(ctnD_ptr);
				IDLT_ptr = attDef_ptr->type_def();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		return (VSIDLType_ptr) IDLT_ptr;
}

/*------------------------------------------------------*/
/* mode_read() */

VSAttributeMode 
VSmode_read(VSEnvironment *ev, VSAttributeDef_ptr vs_calling_att_ptr)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::AttributeDef_ptr attDef_ptr = (CORBA::AttributeDef_ptr) vs_calling_att_ptr;
		CORBA::AttributeMode		attMode;

		try {
				attMode = attDef_ptr->mode();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		return (VSAttributeMode) attMode;
}

/*------------------------------------------------------*/
VSAttributeDef_ptr*
VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::AttributeDef_ptr ttc;
				 
		try {
  		     ttc = CORBA::AttributeDef::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				}
				catch (...) {
						return (VSAttributeDef_ptr *) 0;
				}
				CORBA::AttributeDef_ptr *rtc = new CORBA::AttributeDef_ptr(ttc);
				return (VSAttributeDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSAttributeDef_ptr*
VSduplicate(VSAttributeDef_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::AttributeDef_ptr *tc = (CORBA::AttributeDef_ptr *) o1;
		CORBA::AttributeDef_ptr ttc;
						 
		try {
       ttc = CORBA::AttributeDef::_duplicate(tc ? *tc : (CORBA::AttributeDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSAttributeDef_ptr *) 0;
    }
		 
		CORBA::AttributeDef_ptr *rtc = new CORBA::AttributeDef_ptr(ttc);
		return (VSAttributeDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSAttributeDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
		CORBA::AttributeDef_ptr ttc;
						 
		try {
        ttc = CORBA::AttributeDef::_narrow(tc ? *tc : (CORBA::AttributeDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSAttributeDef_ptr *) 0;
    }
		 
		CORBA::AttributeDef_ptr *rtc = new CORBA::AttributeDef_ptr(ttc);
		return (VSAttributeDef_ptr *) rtc;
}

/*------------------------------------------------------*/
/* WRITE INTERFACE */
/*------------------------------------------------------*/

void
VStype_def_write(const VSIDLType_ptr vs_idltype_ptr, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::IDLType_ptr IDLT_ptr = (CORBA::IDLType_ptr) vs_idltype_ptr;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::AttributeDef_ptr attDef_ptr;
		IRSupport *irs = glob_TS.repository();

		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_AttributeDef::I1::Att_ro");
				attDef_ptr = CORBA::AttributeDef::_narrow(ctnD_ptr);
				attDef_ptr->type_def(IDLT_ptr);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		return;
}

/*------------------------------------------------------*/
void
VSmode_write(VSAttributeMode vs_att_mode, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::AttributeMode att_mode = (CORBA::AttributeMode) vs_att_mode;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::AttributeDef_ptr attDef_ptr;
		IRSupport *irs = glob_TS.repository();

		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_AttributeDef::I1::Att_ro");
				attDef_ptr = CORBA::AttributeDef::_narrow(ctnD_ptr);
				attDef_ptr->mode(att_mode);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		return;
}

/*------------------------------------------------------*/
/* redefined functions */
/*------------------------------------------------------*/
VSDefinitionKind VSdef_kind(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::DefinitionKind dk;
		CORBA::AttributeDef_ptr 	attDef_ptr;
		IRSupport *irs = glob_TS.repository();
    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_AttributeDef::I1::Att_rw");
				if (!ctnD_ptr)
						return (VSDefinitionKind) 0;
				attDef_ptr = CORBA::AttributeDef::_narrow(ctnD_ptr);
				dk = attDef_ptr->def_kind();
			}
    catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
    return (VSDefinitionKind) dk;
}

/*------------------------------------------------------*/
VSDescription_ptr 
VSdescribe(VSEnvironment *ev) 
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr	IR_ptr;
    CORBA::Contained_ptr		cPtr;
		CORBA::AttributeDef_ptr		attDef_ptr;
		IRSupport *irs = glob_TS.repository();
    CORBA::Contained::Description* desc_ptr;
    
    try {
        IR_ptr = irs->get_repository();
        cPtr = irs->get_contained(IR_ptr,"M_AttributeDef::I1::Att_rw");
				if(!cPtr)
						return (VSDescription_ptr) 0;
				attDef_ptr = CORBA::AttributeDef::_narrow(cPtr);
				desc_ptr = attDef_ptr->describe();
    }
    catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
	    			env->exception(t);
    }
    catch (...) {
				return (VSDescription_ptr) 0;
    }

    return (VSDescription_ptr) desc_ptr;
}
/*------------------------------------------------------*/

}

