//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/
/* type() */

VSTypeCode_ptr* 
VStype(VSEnvironment *ev)
{
  CORBA::Environment *env = (CORBA::Environment *) ev;
  CORBA::Object_ptr			obj_ptr;
  CORBA::Repository_ptr	IR_ptr;
  CORBA::Contained_ptr		ctnD_ptr;
  CORBA::ConstantDef_ptr cDef_ptr;
  CORBA::TypeCode_ptr		tc_ptr;
  IRSupport *irs = glob_TS.repository();
  
  try {
    IR_ptr = irs->get_repository();
    ctnD_ptr = irs->get_contained(IR_ptr,"M_ConstantDef::C1");
    cDef_ptr = CORBA::ConstantDef::_narrow(ctnD_ptr);
    tc_ptr = cDef_ptr->type();
  }
  catch (CORBA::Exception &ex) {
    CORBA::Exception *t = exception_convert(&ex);
    if(env)
      env->exception(t);
    return (VSTypeCode_ptr *) 0;
  }
  CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (tc_ptr);
  return (VSTypeCode_ptr *) rptr;
}
  
  /*------------------------------------------------------*/
  /* type_def_read() */
  
  VSIDLType_ptr
  VStype_def_read(VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Object_ptr			obj_ptr;
    CORBA::Repository_ptr	IR_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    CORBA::ConstantDef_ptr cDef_ptr;
    CORBA::IDLType_ptr    IDLT_ptr;
    IRSupport *irs = glob_TS.repository();
    
    try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_ConstantDef::C1");
      cDef_ptr = CORBA::ConstantDef::_narrow(ctnD_ptr);
      IDLT_ptr = cDef_ptr->type_def();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSIDLType_ptr) IDLT_ptr;
  }
  
  /*------------------------------------------------------*/
  /* value_read() */
  
  VSAny_ptr 
  VSvalue_read(VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Object_ptr			obj_ptr;
    CORBA::Repository_ptr	IR_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    CORBA::ConstantDef_ptr cDef_ptr;
    CORBA::Any*						value_ptr    ;
    IRSupport *irs = glob_TS.repository();
    
    try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_ConstantDef::C1");
      cDef_ptr = CORBA::ConstantDef::_narrow(ctnD_ptr);
      value_ptr = cDef_ptr->value();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSAny_ptr) value_ptr;
  }
  
  /*------------------------------------------------------*/
  VSConstantDef_ptr*
  VSnil(VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ConstantDef_ptr ttc;
    
    try {
      ttc = CORBA::ConstantDef::_nil();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSConstantDef_ptr *) 0;
    }
    CORBA::ConstantDef_ptr *rtc = new CORBA::ConstantDef_ptr(ttc);
    return (VSConstantDef_ptr *) rtc;
  }
  
  /*------------------------------------------------------*/
  VSConstantDef_ptr*
  VSduplicate(VSConstantDef_ptr *o1, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ConstantDef_ptr *tc = (CORBA::ConstantDef_ptr *) o1;
    CORBA::ConstantDef_ptr ttc;
    
    try {
      ttc = CORBA::ConstantDef::_duplicate(tc ? *tc : (CORBA::ConstantDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSConstantDef_ptr *) 0;
    }
    CORBA::ConstantDef_ptr *rtc = new CORBA::ConstantDef_ptr(ttc);
    return (VSConstantDef_ptr *) rtc;
  }
  
  /*------------------------------------------------------*/
  VSConstantDef_ptr*
  VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
    CORBA::ConstantDef_ptr ttc;
    
    try {
      ttc = CORBA::ConstantDef::_narrow(tc ? *tc : (CORBA::ConstantDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSConstantDef_ptr *) 0;
    }
    
    CORBA::ConstantDef_ptr *rtc = new CORBA::ConstantDef_ptr(ttc);
    return (VSConstantDef_ptr *) rtc;
  }
  /*------------------------------------------------------*/
  /* WRITE INTERFACE */
  /*------------------------------------------------------*/
  
  void
  VStype_def_write(const VSIDLType_ptr vs_idltype_ptr, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::IDLType_ptr IDLT_ptr = (CORBA::IDLType_ptr) vs_idltype_ptr;
    
    CORBA::Repository_ptr IR_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    CORBA::ConstantDef_ptr cDef_ptr;
    IRSupport *irs = glob_TS.repository();
    
    try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_ConstantDef::C1");
      cDef_ptr = CORBA::ConstantDef::_narrow(ctnD_ptr);
      cDef_ptr->type_def(IDLT_ptr);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return;
  }
  
  /*------------------------------------------------------*/
  void
  VSvalue_write(VSConstantDef_ptr *o1, const VSAny_ptr vs_value, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ConstantDef_ptr *tc = (CORBA::ConstantDef_ptr *) o1;
    CORBA::Any* value = (CORBA::Any *) vs_value;
    try{
      (*tc)->value(*value);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return;
  }
  
  /*------------------------------------------------------*/
  /* redefined functions */
  /*------------------------------------------------------*/
  VSDefinitionKind VSdef_kind(VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Repository_ptr IR_ptr;
    CORBA::Contained_ptr    ctnD_ptr;
    CORBA::DefinitionKind dk;
    CORBA::ConstantDef_ptr 	constDef_ptr;
    IRSupport *irs = glob_TS.repository();
    try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_ConstantDef::C1");
      if (!ctnD_ptr)
	return (VSDefinitionKind) 0;
      constDef_ptr = CORBA::ConstantDef::_narrow(ctnD_ptr);
      dk = constDef_ptr->def_kind();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSDefinitionKind) dk;
  }
  /*------------------------------------------------------*/
  VSDescription_ptr 
  VSdescribe(VSEnvironment *ev) 
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Repository_ptr	IR_ptr;
    CORBA::Contained_ptr		cPtr;
    CORBA::ConstantDef_ptr		constDef_ptr;
    IRSupport *irs = glob_TS.repository();
    CORBA::Contained::Description* desc_ptr;
    
    try {
      IR_ptr = irs->get_repository();
      cPtr = irs->get_contained(IR_ptr,"M_ConstantDef::C1");
      if(!cPtr)
	return (VSDescription_ptr) 0;
      constDef_ptr = CORBA::ConstantDef::_narrow(cPtr);
      desc_ptr = constDef_ptr->describe();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSDescription_ptr) 0;
    }
    
    return (VSDescription_ptr) desc_ptr;
  } 
  /*------------------------------------------------------*/
  
}

