/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/IR/Contained/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:14:00  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.4  1997/11/26 14:56:15  kevin
   Added write tests and update CORBA scoping.

   Revision 1.3  1997/09/18 17:22:58  kevin
   Sample Repository for testing Contained functionlity.

   Revision 1.2  1997/09/18 12:22:14  kevin
   Checked in before starting on C-mapping.

   Revision 1.1  1997/08/21 14:37:03  kevin
   Tests for the Contained class in the IR.

*/

#include <corba_defs.h>

/* id() */
VSRepositoryId 
VSid_read(VSEnvironment *ev);

void 
VSid_write(const VSRepositoryId repId, VSEnvironment *ev);

/* name() */
VSIdentifier 
VSname_read(VSEnvironment *ev, VSString);

void 
VSname_write(const VSIdentifier new_name, VSEnvironment *ev, VSString);

/* version() */
VSVersionSpec 
VSversion_read(VSEnvironment *ev);

void 
VSversion_write(const VSVersionSpec vspec, VSEnvironment *ev);

/* defined_in() */
VSContainer_ptr 
VSdefined_in(VSEnvironment *ev);

/* absolute_name() */
VSScopedName 
VSabsolute_name(VSEnvironment *ev);

/* containing_repository() */
VSRepository_ptr 
VScontaining_repository(VSEnvironment *ev);

/* describe() */
VSDescription_ptr 
VSdescribe(VSEnvironment *ev); 

/* move() */
void 
VSmove(const VSContainer_ptr new_container, 
				const VSIdentifier new_name, 
				const VSVersionSpec new_version,
				VSEnvironment *ev,
				VSString moveObj);

/* _narrow */
VSContained_ptr*
VSnarrow(VSObject_ptr *o1,  VSEnvironment *ev);

/* _duplicate */
VSContained_ptr*
VSduplicate(VSContained_ptr *o1, VSEnvironment *ev);

/* _nil */
VSContained_ptr*
VSnil(VSEnvironment *ev);


