/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_empty_string(VSString);

extern int is_invalid_string(VSString);

extern int is_nil_contained_ptr(VSContained_ptr);

extern int contents_contain(VSContainedSeq_ptr, VSString);

extern int type_limited(VSString, VSDefinitionKind);

extern int is_same_string(VSString, VSString);

extern int level_limited(VSString, long);

extern int numOccurrences(VSString in, VSString of);

extern int is_nil_container_ptr(VSContainer_ptr *);

extern int is_nil_object(VSObject_ptr);

extern int cleanup_container_ptr(VSContainer_ptr *);

extern int exists_definition(VSRepositoryId);

extern int id_exists(VSRepositoryId);

extern int container_is_interface(VSContainer_ptr);

extern int descriptionSeqExceedsSize(VSDescriptionSeq_ptr, VSLong);

extern int descriptionSeqContains(VSDescriptionSeq_ptr, VSString);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSScopedName)(VSScopedName, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSContained_ptr)(VSContained_ptr, emitter_t);
extern void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t);
extern void (*ADL__print_VSBoolean)(VSBoolean, emitter_t);
extern void (*ADL__print_VSContainedSeq_ptr)(VSContainedSeq_ptr, emitter_t);
extern void (*ADL__print_VSLong)(VSLong, emitter_t);
extern void (*ADL__print_VSDescriptionSeq_ptr)(VSDescriptionSeq_ptr, emitter_t);
extern void (*ADL__print_VSIdentifier)(VSIdentifier, emitter_t);
extern void (*ADL__print_VSContainer_ptr_P)(VSContainer_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t);
extern void (*ADL__print_VSRepositoryId)(VSRepositoryId, emitter_t);
extern void (*ADL__print_VSVersionSpec)(VSVersionSpec, emitter_t);
extern void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t);
extern void (*ADL__print_VSAny_ptr)(VSAny_ptr, emitter_t);
extern void (*ADL__print_VSContainer_ptr)(VSContainer_ptr, emitter_t);
extern void (*ADL__print_VSStructMemberSeq_ptr)(VSStructMemberSeq_ptr, emitter_t);
extern void (*ADL__print_VSUnionMemberSeq_ptr)(VSUnionMemberSeq_ptr, emitter_t);
extern void (*ADL__print_VSEnumMemberSeq_ptr)(VSEnumMemberSeq_ptr, emitter_t);
extern void (*ADL__print_VSInterfaceDefSeq_ptr)(VSInterfaceDefSeq_ptr, emitter_t);
extern void (*ADL__print_VSValueDef_ptr)(VSValueDef_ptr, emitter_t);
extern void (*ADL__print_VSValueDefSeq_ptr)(VSValueDefSeq_ptr, emitter_t);
extern void (*ADL__print_VSInitializerSeq_ptr)(VSInitializerSeq_ptr, emitter_t);

/* Declarations of wrapper of FUT */
extern VSContained_ptr (*ADL__VSlookup_wrapper)(VSScopedName const, VSEnvironment*);
extern VSContainedSeq_ptr (*ADL__VScontents_wrapper)(VSDefinitionKind, VSBoolean, VSEnvironment*);
extern VSDescriptionSeq_ptr (*ADL__VSdescribe_contents_wrapper)(VSDefinitionKind, VSBoolean, VSLong, VSEnvironment*);
extern VSContainedSeq_ptr (*ADL__VSlookup_name_wrapper)(VSIdentifier const, VSLong, VSDefinitionKind, VSBoolean, VSEnvironment*);
extern VSContainer_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSContainer_ptr *(*ADL__VSduplicate_wrapper)(VSContainer_ptr*, VSEnvironment*);
extern VSContainer_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*);
extern VSModuleDef_ptr (*ADL__VScreate_module_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSEnvironment*);
extern VSConstantDef_ptr (*ADL__VScreate_constant_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSIDLType_ptr const, VSAny_ptr const, VSEnvironment*, VSContainer_ptr);
extern VSStructDef_ptr (*ADL__VScreate_struct_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSStructMemberSeq_ptr const, VSEnvironment*, VSContainer_ptr);
extern VSUnionDef_ptr (*ADL__VScreate_union_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSIDLType_ptr const, VSUnionMemberSeq_ptr const, VSEnvironment*, VSContainer_ptr);
extern VSEnumDef_ptr (*ADL__VScreate_enum_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSEnumMemberSeq_ptr const, VSEnvironment*, VSContainer_ptr);
extern VSAliasDef_ptr (*ADL__VScreate_alias_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSIDLType_ptr const, VSEnvironment*, VSContainer_ptr);
extern VSInterfaceDef_ptr (*ADL__VScreate_interface_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSInterfaceDefSeq_ptr const, VSEnvironment*, VSContainer_ptr);
extern VSExceptionDef_ptr (*ADL__VScreate_exception_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSStructMemberSeq_ptr const, VSEnvironment*, VSContainer_ptr);
extern VSValueDef_ptr (*ADL__VScreate_value_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, const VSBoolean, const VSBoolean, VSValueDef_ptr const, const VSBoolean, VSValueDefSeq_ptr const, VSInterfaceDefSeq_ptr const, VSInitializerSeq_ptr const, VSEnvironment*, VSContainer_ptr);
extern VSValueBoxDef_ptr (*ADL__VScreate_value_box_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSIDLType_ptr const, VSEnvironment*, VSContainer_ptr);
extern VSNativeDef_ptr (*ADL__VScreate_native_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSEnvironment*, VSContainer_ptr);

#endif
