//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/
/* members_read() */

VSEnumMemberSeq_ptr
VSmembers_read(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr			obj_ptr;
		CORBA::Repository_ptr	IR_ptr;
  	CORBA::Contained_ptr   ctnD_ptr;
		CORBA::EnumDef_ptr enumDef_ptr;
		CORBA::EnumMemberSeq* 	memberSeq_ptr;
		IRSupport *irs = glob_TS.repository();

		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_EnumDef::E1");
				if(CORBA::is_nil(ctnD_ptr))
						throw 0;
				enumDef_ptr = CORBA::EnumDef::_narrow(ctnD_ptr);
				memberSeq_ptr = enumDef_ptr->members();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		catch (...) {
				return (VSEnumMemberSeq_ptr) 0;
		}
		return (VSEnumMemberSeq_ptr) memberSeq_ptr;
}

/*------------------------------------------------------*/
VSEnumDef_ptr*
VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::EnumDef_ptr ttc;
				 
		try {
				ttc = CORBA::EnumDef::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		catch (...) {
						return (VSEnumDef_ptr *) 0;
		}
		CORBA::EnumDef_ptr *rtc = new CORBA::EnumDef_ptr(ttc);
		return (VSEnumDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSEnumDef_ptr*
VSduplicate(VSEnumDef_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::EnumDef_ptr *tc = (CORBA::EnumDef_ptr *) o1;
		CORBA::EnumDef_ptr ttc;
						 
		try {
       ttc = CORBA::EnumDef::_duplicate(tc ? *tc : (CORBA::EnumDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSEnumDef_ptr *) 0;
    }
		 
		CORBA::EnumDef_ptr *rtc = new CORBA::EnumDef_ptr(ttc);
		return (VSEnumDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSEnumDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
		CORBA::EnumDef_ptr ttc;
						 
		try {
        ttc = CORBA::EnumDef::_narrow(tc ? *tc : (CORBA::EnumDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSEnumDef_ptr *) 0;
    }
		 
		CORBA::EnumDef_ptr *rtc = new CORBA::EnumDef_ptr(ttc);
		return (VSEnumDef_ptr *) rtc;
}
/*------------------------------------------------------*/
/* WRITE INTERFACE */
/*------------------------------------------------------*/

void
VSmembers_write(const VSEnumMemberSeq_ptr vs_members, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::EnumMemberSeq* new_members = (CORBA::EnumMemberSeq *) vs_members;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::EnumDef_ptr eDef_ptr;
		IRSupport *irs = glob_TS.repository();
		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_EnumDef::E1");
				eDef_ptr = CORBA::EnumDef::_narrow(ctnD_ptr);
				eDef_ptr->members(*new_members);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
}

/*------------------------------------------------------*/
/* redefined functions */
/*------------------------------------------------------*/
VSDefinitionKind VSdef_kind(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::DefinitionKind dk;
		CORBA::EnumDef_ptr 	enumDef_ptr;
		IRSupport *irs = glob_TS.repository();
    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_EnumDef::E1");
				if (!ctnD_ptr)
						return (VSDefinitionKind) 0;
				enumDef_ptr = CORBA::EnumDef::_narrow(ctnD_ptr);
				dk = enumDef_ptr->def_kind();
			}
    catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
    return (VSDefinitionKind) dk;
}
/*------------------------------------------------------*/
VSTypeCode_ptr*
VStype(VSEnvironment *ev) 
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr retType_ptr;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::EnumDef_ptr 	enumDef_ptr;
		IRSupport *irs = glob_TS.repository();

    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_EnumDef::E1");
				enumDef_ptr = CORBA::EnumDef::_narrow(ctnD_ptr);
				retType_ptr = enumDef_ptr->type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (retType_ptr);
		return (VSTypeCode_ptr *) rptr;
}
/*------------------------------------------------------*/
}

