//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//
/*
 *
 * t1_aux.c -- 
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>


/*------------------------------------------------------*/
int
is_correct_members(VSEnumMemberSeq_ptr vs_members_seq)
{
 	CORBA::EnumMemberSeq* memberSeq_ptr = (CORBA::EnumMemberSeq *) vs_members_seq;

	if(!memberSeq_ptr)
		return FALSE;

	return((memberSeq_ptr->length() == 3) &&
					(strcmp("a", (char *) (*memberSeq_ptr)[0]) == 0) &&
					(strcmp("b", (char *) (*memberSeq_ptr)[1]) == 0) &&
					(strcmp("c", (char *) (*memberSeq_ptr)[2]) == 0));
		return FALSE;
}


/*------------------------------------------------------*/
int is_nil_object(VSObject_ptr o1)
{
		CORBA::Object_ptr obj1 = (CORBA::Object_ptr) o1;
		 
		if(!obj1)
			return TRUE;
		return CORBA::is_nil(obj1);
}

int
is_nil_enumdef_ptr(VSEnumDef_ptr *o1)
{
		CORBA::EnumDef_ptr *tc = (CORBA::EnumDef_ptr *) o1;
		if(!tc)
				return TRUE;
		return CORBA::is_nil(*tc);
}
											 
int 
cleanup_enumdef_ptr(VSEnumDef_ptr *o1)
{
		CORBA::EnumDef_ptr *tc = (CORBA::EnumDef_ptr *) o1;
		if(!tc)
				return TRUE;
		delete tc;
		return TRUE;
}

/*------------------------------------------------------*/
/* aux functions for write tests */
/*------------------------------------------------------*/
int
is_same_members(VSEnumMemberSeq_ptr vs_m1, VSEnumMemberSeq_ptr vs_m2)
{
		CORBA::EnumMemberSeq* m1Seq_ptr = (CORBA::EnumMemberSeq *) vs_m1;
		CORBA::EnumMemberSeq* m2Seq_ptr = (CORBA::EnumMemberSeq *) vs_m2;
		if (m1Seq_ptr->length() != m2Seq_ptr->length())
				return FALSE;
		CORBA::ULong i = 0;
		while (i < m1Seq_ptr->length()) {
				if (strcmp( (char *)(*m1Seq_ptr)[i], (char *)(*m2Seq_ptr)[i]) != 0)
						return FALSE;
				i++;
		}
		return TRUE;
}

/*------------------------------------------------------*/
/* aux funcs for redefined functionality */
/*------------------------------------------------------*/
int
is_correct_def_kind(VSDefinitionKind vs_dk)
{
		CORBA::DefinitionKind dk = (CORBA::DefinitionKind) vs_dk;
		return (dk == CORBA::dk_Enum);
}

/*------------------------------------------------------*/
int
is_correct_typecode(VSTypeCode_ptr* vs_tc_ptr)
{
		CORBA::TypeCode_ptr* tc_ptr = (CORBA::TypeCode_ptr *) vs_tc_ptr;
		return ((*tc_ptr)->kind() == CORBA::tk_enum);
}
/*------------------------------------------------------*/
}
