//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

/* ------------------------------------------------------------ */
/* object_ptr is provided for the VSnarrow() test */
int
provide_object_ptr (VSObject_ptr **testvar,
											enum prop_object_ptr_objValue objValue)
{
	CORBA::Object_ptr tvar;
	CORBA::Object_ptr* rptr;
	CORBA::Object_ptr obj_ptr;
	CORBA::Repository_ptr IR_ptr;
	IRSupport *irs = glob_TS.repository();

    switch (objValue)  {
        case Pobject_ptr_objValue_valid:
        		IR_ptr = irs->get_repository();
        		tvar = irs->get_contained(IR_ptr,"M_EnumDef::E1");
						break;
       case Pobject_ptr_objValue_null:
            tvar = NULL;
						break;
    }
		rptr = new CORBA::Object_ptr(tvar);
		*testvar = (VSObject_ptr *) rptr;
		return TRUE;
}

int
relinquish_object_ptr (VSObject_ptr **testvar,
													enum prop_object_ptr_objValue objValue)
{
	CORBA::Object_ptr* tvar = (CORBA::Object_ptr *) *testvar;

    switch (objValue)  {
        case Pobject_ptr_objValue_valid:
						delete tvar;
						break;
				case Pobject_ptr_objValue_null:
        		break;
    }
		return TRUE;
}

/* ------------------------------------------------------------ */
/* enumdef_ptr is provided for the VSduplicate() test */
int
provide_enumdef_ptr (VSEnumDef_ptr **testvar,
											enum prop_enumdef_ptr_enumValue enumValue)
{
	CORBA::EnumDef_ptr tvar;
	CORBA::EnumDef_ptr* rptr; 
	
	CORBA::Object_ptr obj_ptr;
  CORBA::Repository_ptr  IR_ptr;
	CORBA::Contained_ptr ctnD_ptr;
	IRSupport *irs = glob_TS.repository();

		switch (enumValue)  {
        case Penumdef_ptr_enumValue_valid:
        		IR_ptr = irs->get_repository();
        		ctnD_ptr = irs->get_contained(IR_ptr,"M_EnumDef::E1");
						tvar = CORBA::EnumDef::_narrow(ctnD_ptr);
						break;
       case Penumdef_ptr_enumValue_null:
            tvar = NULL;
						break;
    }
		rptr = new CORBA::EnumDef_ptr(tvar);
		*testvar = (VSEnumDef_ptr *) rptr;
		return TRUE;
}

int
relinquish_enumdef_ptr (VSEnumDef_ptr **testvar,
													enum prop_enumdef_ptr_enumValue enumValue)
{
		CORBA::EnumDef_ptr* tvar = (CORBA::EnumDef_ptr *) *testvar;

		switch (enumValue)  {
        case Penumdef_ptr_enumValue_valid:
						delete tvar;
						break;
				case Penumdef_ptr_enumValue_null:
						break;
    }
		return TRUE;
}

/* ------------------------------------------------------------ */
/* new_members is provided for the VSmembers_write() test by
	 reading the members of an existing EnumDef */
int 
provide_new_members (VSEnumMemberSeq_ptr *testvar)
{
    CORBA::Repository_ptr  IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::EnumMemberSeq* tvar;
		CORBA::EnumMemberSeq* rptr;
								 
		IRSupport *irs = glob_TS.repository();
		IR_ptr = irs->get_repository();
		ctnD_ptr = irs->get_contained(IR_ptr,"M_EnumDef::ECopy");
		if (!ctnD_ptr)
				return FALSE;
		CORBA::EnumDef_ptr eDef_ptr = CORBA::EnumDef::_narrow(ctnD_ptr);
		tvar = eDef_ptr->members();
		rptr = new CORBA::EnumMemberSeq(*tvar);
		*testvar = (VSEnumMemberSeq_ptr) rptr;
		return TRUE;
}

int 
relinquish_new_members (VSEnumMemberSeq_ptr *testvar)
{
    CORBA::EnumMemberSeq* tvar = (CORBA::EnumMemberSeq *) *testvar;
		delete tvar;
		return TRUE;
}

/* ------------------------------------------------------------ */

}
