//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/
/* type() */

VSTypeCode_ptr* 
VStype(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr			obj_ptr;
		CORBA::Repository_ptr	IR_ptr;
		CORBA::Contained_ptr		ctnD_ptr;
		CORBA::ExceptionDef_ptr exceptDef_ptr;
		CORBA::TypeCode_ptr		tc_ptr;
		IRSupport *irs = glob_TS.repository();

		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_ExceptionDef::E1");
				exceptDef_ptr = CORBA::ExceptionDef::_narrow(ctnD_ptr);
				tc_ptr = exceptDef_ptr->type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
       return (VSTypeCode_ptr *) 0;
		}
		CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (tc_ptr);
		return (VSTypeCode_ptr *) rptr;
}

/*------------------------------------------------------*/
/* members_read() */

VSStructMemberSeq_ptr
VSmembers_read(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr			obj_ptr;
		CORBA::Repository_ptr	IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::ExceptionDef_ptr exceptDef_ptr;
		CORBA::StructMemberSeq* memberSeq_ptr;
		IRSupport *irs = glob_TS.repository();
		
		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_ExceptionDef::E1");
				exceptDef_ptr = CORBA::ExceptionDef::_narrow(ctnD_ptr);
				memberSeq_ptr = exceptDef_ptr->members();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		return (VSStructMemberSeq_ptr) memberSeq_ptr;
}

/*------------------------------------------------------*/
VSExceptionDef_ptr*
VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::ExceptionDef_ptr ttc;
				 
		try {
				ttc = CORBA::ExceptionDef::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		catch (...) {
				return (VSExceptionDef_ptr *) 0;
		}
		CORBA::ExceptionDef_ptr *rtc = new CORBA::ExceptionDef_ptr(ttc);
		return (VSExceptionDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSExceptionDef_ptr*
VSduplicate(VSExceptionDef_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::ExceptionDef_ptr *tc = (CORBA::ExceptionDef_ptr *) o1;
		CORBA::ExceptionDef_ptr ttc;
						 
		try {
       ttc = CORBA::ExceptionDef::_duplicate(tc ? *tc : (CORBA::ExceptionDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSExceptionDef_ptr *) 0;
    }
		 
		CORBA::ExceptionDef_ptr *rtc = new CORBA::ExceptionDef_ptr(ttc);
		return (VSExceptionDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSExceptionDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
		CORBA::ExceptionDef_ptr ttc;
						 
		try {
        ttc = CORBA::ExceptionDef::_narrow(tc ? *tc : (CORBA::ExceptionDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSExceptionDef_ptr *) 0;
    }
		 
		CORBA::ExceptionDef_ptr *rtc = new CORBA::ExceptionDef_ptr(ttc);
		return (VSExceptionDef_ptr *) rtc;
}
/*------------------------------------------------------*/
/* WRITE INTERFACE */
/*------------------------------------------------------*/

void
VSmembers_write(const VSStructMemberSeq_ptr vs_members, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::StructMemberSeq* new_members = (CORBA::StructMemberSeq *) vs_members;
		 
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::ExceptionDef_ptr exDef_ptr;
		IRSupport *irs = glob_TS.repository();
		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_ExceptionDef::E1");
				exDef_ptr = CORBA::ExceptionDef::_narrow(ctnD_ptr);
				exDef_ptr->members(*new_members);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
}

/*------------------------------------------------------*/
/* redefined functions */
/*------------------------------------------------------*/
VSDefinitionKind VSdef_kind(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::DefinitionKind dk;
		CORBA::ExceptionDef_ptr 	exceptDef_ptr;
		IRSupport *irs = glob_TS.repository();
    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_ExceptionDef::E1");
				if (!ctnD_ptr)
						return (VSDefinitionKind) 0;
				exceptDef_ptr = CORBA::ExceptionDef::_narrow(ctnD_ptr);
				dk = exceptDef_ptr->def_kind();
			}
    catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
    return (VSDefinitionKind) dk;
}

/*------------------------------------------------------*/
VSDescription_ptr 
VSdescribe(VSEnvironment *ev) 
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr	IR_ptr;
    CORBA::Contained_ptr		cPtr;
		CORBA::ExceptionDef_ptr		exceptDef_ptr;
		IRSupport *irs = glob_TS.repository();
    CORBA::Contained::Description* desc_ptr;
    
    try {
        IR_ptr = irs->get_repository();
        cPtr = irs->get_contained(IR_ptr,"M_ExceptionDef::E1");
				if(!cPtr)
						return (VSDescription_ptr) 0;
				exceptDef_ptr = CORBA::ExceptionDef::_narrow(cPtr);
				desc_ptr = exceptDef_ptr->describe();
    }
    catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
	    			env->exception(t);
    }
    catch (...) {
				return (VSDescription_ptr) 0;
    }

    return (VSDescription_ptr) desc_ptr;
} 
/*------------------------------------------------------*/

}

