//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

				 
/* ------------------------------------------------------------ */
/* object_ptr is provided for the VSnarrow() test. */
int
provide_object_ptr (VSObject_ptr **testvar,
											enum prop_object_ptr_objValue objValue)
{
	CORBA::Object_ptr tvar;
	CORBA::Object_ptr* rptr;
	CORBA::Object_ptr obj_ptr;
	CORBA::Repository_ptr IR_ptr;
	CORBA::ORB_ptr orb;
	IRSupport *irs = glob_TS.repository();

    switch (objValue)  {
        case Pobject_ptr_objValue_valid:
        		IR_ptr = irs->get_repository();
        		tvar = irs->get_contained(IR_ptr,"M_ExceptionDef::E1");
						break;
       case Pobject_ptr_objValue_null:
            tvar = NULL;
						break;
    }
		rptr = new CORBA::Object_ptr(tvar);
		*testvar = (VSObject_ptr *) rptr;
		return TRUE;
}

int
relinquish_object_ptr (VSObject_ptr **testvar,
													enum prop_object_ptr_objValue objValue)
{
		CORBA::Object_ptr* tvar = (CORBA::Object_ptr *) *testvar;

    switch (objValue)  {
        case Pobject_ptr_objValue_valid:
						delete tvar;
						break;
				case Pobject_ptr_objValue_null:
        		break;
    }
		return TRUE;
}

/* ------------------------------------------------------------ */
/* exceptiondef_ptr is provided for the VSduplicate() test. */
int
provide_exceptiondef_ptr (VSExceptionDef_ptr **testvar,
											enum prop_exceptiondef_ptr_exdefValue exdefValue)
{
	CORBA::ExceptionDef_ptr tvar;
	CORBA::ExceptionDef_ptr* rptr;
	 
	CORBA::ORB_ptr orb;
	CORBA::Object_ptr obj_ptr;
  CORBA::Repository_ptr  IR_ptr;
	CORBA::Contained_ptr ctnD_ptr;
	IRSupport *irs = glob_TS.repository();

		switch (exdefValue)  {
        case Pexceptiondef_ptr_exdefValue_valid:
        		IR_ptr = irs->get_repository();
        		ctnD_ptr = irs->get_contained(IR_ptr,"M_ExceptionDef::E1");
						tvar = CORBA::ExceptionDef::_narrow(ctnD_ptr);
						break;
       case Pexceptiondef_ptr_exdefValue_null:
            tvar = NULL;
						break;
    }
		rptr = new CORBA::ExceptionDef_ptr(tvar);
		*testvar = (VSExceptionDef_ptr *) rptr;
		return TRUE;
}

int
relinquish_exceptiondef_ptr (VSExceptionDef_ptr **testvar,
											enum prop_exceptiondef_ptr_exdefValue exdefValue)
{
		CORBA::ExceptionDef_ptr* tvar = (CORBA::ExceptionDef_ptr *) *testvar;

		switch (exdefValue)  {
        case Pexceptiondef_ptr_exdefValue_valid:
						delete tvar;
						break;
				case Pexceptiondef_ptr_exdefValue_null:
						break;
    }
		return TRUE;
}

/* ------------------------------------------------------------ */
/* new_members is provided for the VSmembers_write() test. */
int 
provide_new_members (VSStructMemberSeq_ptr *testvar)
{
    CORBA::Repository_ptr  IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::StructMemberSeq* tvar;
		CORBA::StructMemberSeq* rptr;
								 
		IRSupport *irs = glob_TS.repository();
		IR_ptr = irs->get_repository();
		ctnD_ptr = irs->get_contained(IR_ptr,"M_ExceptionDef::ExCopy");
		if (!ctnD_ptr)
				return FALSE;
		CORBA::ExceptionDef_ptr uDef_ptr = CORBA::ExceptionDef::_narrow(ctnD_ptr);
		tvar = uDef_ptr->members();
		rptr = new CORBA::StructMemberSeq(*tvar);
		*testvar = (VSStructMemberSeq_ptr) rptr;
		return TRUE;
}

int 
relinquish_new_members (VSStructMemberSeq_ptr *testvar)
{
    CORBA::StructMemberSeq* tvar = (CORBA::StructMemberSeq *) *testvar;
		delete tvar;
		return TRUE;
}

/* ------------------------------------------------------------ */

}
