//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/
/* We test the type() operation on IDLType using the concrete
	 sub-class InterfaceDef */

VSTypeCode_ptr*
VStype(VSEnvironment *ev) //, VSTypeCode_ptr calling_IDLType)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr retType_ptr;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::IRObject_ptr 	IRObj_ptr;
		CORBA::IDLType_ptr 		IDLT_ptr;
		IRSupport *irs = glob_TS.repository();

    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_IDLType::I1");
				IRObj_ptr = ctnD_ptr;
				IDLT_ptr = CORBA::IDLType::_narrow(IRObj_ptr);
				retType_ptr = IDLT_ptr->type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (retType_ptr);
		return (VSTypeCode_ptr *) rptr;
}

/*------------------------------------------------------*/
VSIDLType_ptr*
VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::IDLType_ptr ttc;
				 
		try {
				ttc = CORBA::IDLType::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				}
				catch (...) {
						return (VSIDLType_ptr *) 0;
				}
				CORBA::IDLType_ptr *rtc = new CORBA::IDLType_ptr(ttc);
				return (VSIDLType_ptr *) rtc;
}

/*------------------------------------------------------*/
VSIDLType_ptr*
VSduplicate(VSIDLType_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::IDLType_ptr *tc = (CORBA::IDLType_ptr *) o1;
		CORBA::IDLType_ptr ttc;
						 
		try {
       ttc = CORBA::IDLType::_duplicate(tc ? *tc : (CORBA::IDLType_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSIDLType_ptr *) 0;
    }
		 
		CORBA::IDLType_ptr *rtc = new CORBA::IDLType_ptr(ttc);
		return (VSIDLType_ptr *) rtc;
}

/*------------------------------------------------------*/
VSIDLType_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
    CORBA::IDLType_ptr ttc;
    
    try {
	ttc = CORBA::IDLType::_narrow(tc ? *tc : (CORBA::IDLType_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
            env->exception(t);
    }
    catch (...) {
        return (VSIDLType_ptr *) 0;
    }
		 
    CORBA::IDLType_ptr *rtc = new CORBA::IDLType_ptr(ttc);
    return (VSIDLType_ptr *) rtc;
}

/*------------------------------------------------------*/

}

