//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

 
/* ------------------------------------------------------------ */
/* object_ptr is provided for the VSnarrow() test */
int
provide_object_ptr (VSObject_ptr **testvar,
		    enum prop_object_ptr_objValue objValue)
{
  CORBA::Object_ptr tvar;   
  CORBA::Object_ptr obj_ptr;
  CORBA:: Repository_ptr IR_ptr;
  CORBA::Object_ptr *rptr;
	IRSupport *irs = glob_TS.repository();

    switch(objValue){
        case Pobject_ptr_objValue_valid:
        		IR_ptr = irs->get_repository();
        		tvar = irs->get_contained(IR_ptr,"M_IDLType::I1");
	    			break;
	 	   	case Pobject_ptr_objValue_null:
						tvar = NULL;
	    			break;
		}
		
		rptr = new CORBA::Object_ptr(tvar);
		*testvar = (VSObject_ptr *) rptr;
		return TRUE;
}

int
relinquish_object_ptr (VSObject_ptr **testvar,
		       enum prop_object_ptr_objValue objValue)
{
  CORBA::Object_ptr* tvar = (CORBA::Object_ptr *) *testvar;

  	switch (objValue){
  		case Pobject_ptr_objValue_valid:
    			delete tvar;
  		case Pobject_ptr_objValue_null:
        	break;
    }
		return TRUE;
}

/* ------------------------------------------------------------ */
/* idltype_ptr is provided for the VSduplicate test */
int
provide_idltype_ptr (VSIDLType_ptr **testvar,
		     enum prop_idltype_ptr_idltValue idltValue)
{
  CORBA::IDLType_ptr tvar; 
    CORBA::IDLType_ptr *rptr;
    CORBA::Object_ptr obj_ptr;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr ctnD_ptr;
		IRSupport *irs = glob_TS.repository();
    
    switch (idltValue)  {
        case Pidltype_ptr_idltValue_valid:
        		IR_ptr = irs->get_repository();
        		ctnD_ptr = irs->get_contained(IR_ptr,"M_IDLType::I1");
	    			//the InterfaceDef I1 is of type IDLType so we can narrow... 
	    			tvar = CORBA::IDLType::_narrow(ctnD_ptr);
						break;
	    	case Pidltype_ptr_idltValue_null:
						tvar = NULL;
	    			break;
		}

		rptr = new CORBA::IDLType_ptr(tvar);
		*testvar = (VSIDLType_ptr *) rptr;
		return TRUE;
}

int
relinquish_idltype_ptr (VSIDLType_ptr **testvar,
			enum prop_idltype_ptr_idltValue idltValue)
{
	CORBA::IDLType_ptr* tvar = (CORBA::IDLType_ptr *) *testvar;

		switch (idltValue)  {
        case Pidltype_ptr_idltValue_valid:
						delete tvar;
				case Pidltype_ptr_idltValue_null:
						break;
    }
		return TRUE;
}

/* ------------------------------------------------------------ */

}

