/* ADL test driver from t1.tdr
 *
 * test VSdestroy(env, irObj)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop irObj_value */
static struct ADL__propertyValue ADL__prop_values_253[] = {
    {"valid", PirObj_irObj_value_valid, 0},
    {"Repository", PirObj_irObj_value_Repository, 0},
    {"PrimitiveDef", PirObj_irObj_value_PrimitiveDef, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_254[] = {
    {"irObj_value", "prop", ADL__prop_values_253, 3},
    {0, 0, 0}
};
#define TVEC_SIZE 1

static struct ADL__variableInfo ADL__var_info_257[3] = {
    {"env", "VSEnvironment *", ADL__prop_info_254, 0, 0},
    {"irObj", "VSIRObject_ptr", ADL__prop_info_254, 0, 1},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 2


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSdestroy_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSIROBJECT_PTR
#define ADL__PRINT_VSIROBJECT_PTR
void (*ADL__print_VSIRObject_ptr)(VSIRObject_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSIROBJECT_PTR */
#ifndef ADL__PRINT_VSDEFINITIONKIND
#define ADL__PRINT_VSDEFINITIONKIND
void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t) = 0;

#endif /* ADL__PRINT_VSDEFINITIONKIND */
#ifndef ADL__PRINT_VSIROBJECT_PTR_P
#define ADL__PRINT_VSIROBJECT_PTR_P
void (*ADL__print_VSIRObject_ptr_P)(VSIRObject_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSIROBJECT_PTR_P */
#ifndef ADL__PRINT_VSOBJECT_PTR_P
#define ADL__PRINT_VSOBJECT_PTR_P
void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR_P */
#ifndef ADL__PRINT_VSOBJECT_PTR
#define ADL__PRINT_VSOBJECT_PTR
void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR */

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIRObject_ptr (void* val, emitter_t emitter)
{
  VSIRObject_ptr tmp;

  if (ADL__print_VSIRObject_ptr != 0) {
    tmp = *(VSIRObject_ptr*) val;
    ADL__print_VSIRObject_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSDefinitionKind (void* val, emitter_t emitter)
{
  VSDefinitionKind tmp;

  if (ADL__print_VSDefinitionKind != 0) {
    tmp = *(VSDefinitionKind*) val;
    ADL__print_VSDefinitionKind(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSIRObject_ptr_P (void* val, emitter_t emitter)
{
  VSIRObject_ptr *tmp;

  if (ADL__print_VSIRObject_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSIRObject_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter)
{
  VSObject_ptr *tmp;

  if (ADL__print_VSObject_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObject_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr (void* val, emitter_t emitter)
{
  VSObject_ptr tmp;

  if (ADL__print_VSObject_ptr != 0) {
    tmp = *(VSObject_ptr*) val;
    ADL__print_VSObject_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {3};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSEnvironment *env_255;
    VSIRObject_ptr irObj_256;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSdestroy_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSdestroy_InfoArrayIdx,
        ADL__VSdestroy_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_env(&env_255)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
       ADL__emit_VSEnvironment_P(&env_255, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(0);
       if (!provide_irObj(&irObj_256, ADL__prop_values_253[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 0, 1);
       ADL__emit_VSIRObject_ptr(&irObj_256, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSdestroy_assertionReport = rf->assertionReport;
       ADL__ACF_VSdestroy(env_255, irObj_256);
       test_value = ADL__VSdestroy_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(0);
       relvec[1] = relinquish_irObj(&irObj_256, ADL__prop_values_253[tvec[0]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_env(&env_255);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_257,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSdestroy_head);

    return 0;
}


struct ADL__Directive_info VSdestroy1_info = {
    N_VARS,
    ADL__var_info_257
};

struct ADL__TDD_info ADL__test_info = {
    3,
    &ADL__VSdestroy_InfoArrayIdx,
    ADL__VSdestroy_InfoArray,
    ADL__test_driver,
    "VSdestroy",
    "VSdestroy1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSdestroy1",
    "t1_tr.rif",
    &VSdestroy1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

