//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//
/*
 *
 * t1_aux.c -- 
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

//-----------------------------------------------------------
int existsTestInterface() //does the test interface exist in the IFR?
{
	CORBA:: Repository_ptr IR_ptr;
	CORBA:: Contained_ptr ctnD_ptr;
	IRSupport *irs = glob_TS.repository();
	  try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_IRObject::I");
				if (!ctnD_ptr)
						return FALSE;
				//if(is_nil_object(ctnD_ptr))
				if(CORBA::is_nil(ctnD_ptr))
						return FALSE;
		}
		catch(...)
		{
			return FALSE; //an error has occurred ...return FALSE
		}
		return TRUE;
}

//-----------------------------------------------------------
// General Object.

int is_nil_object(VSObject_ptr o1)
{
		CORBA::Object_ptr obj1 = (CORBA::Object_ptr) o1;
		if(!obj1)
				return TRUE;
		return CORBA::is_nil(obj1);
}

int
is_correct_def_kind(VSDefinitionKind vs_dk)
{
		CORBA::DefinitionKind dk = (CORBA::DefinitionKind) vs_dk;
		return (dk == CORBA::dk_Interface);
}


//-----------------------------------------------------------
// General ORB.

int is_nil_irobject_ptr(VSIRObject_ptr *o1)
{
		CORBA::IRObject_ptr *tc = (CORBA::IRObject_ptr *) o1;
		if (!tc)
			return TRUE;
		return CORBA::is_nil(*tc);
}

int is_same_irobject_ptr(VSIRObject_ptr *o1, VSIRObject_ptr *o2)
{
		CORBA::Object_ptr *optr1 = (CORBA::Object_ptr *) o1;
		CORBA::Object_ptr *optr2 = (CORBA::Object_ptr *) o2;
		
		if(is_nil_irobject_ptr(o1) && is_nil_irobject_ptr(o2))
				return TRUE;
		
		//return (*optr1)->is_equivalent(*optr2);
		return (*optr1 == *optr2);
}

int cleanup_irobject_ptr(VSIRObject_ptr *o1)
{
		CORBA::IRObject_ptr *tc = (CORBA::IRObject_ptr *) o1;
		if(!tc)
				return TRUE;

		delete tc;
		return TRUE;
}

//need to sort this out!!!
int is_invalid_irobject_ptr(VSIRObject_ptr *o1)
{
		//IRObject_ptr *tc1 = (IRObject_ptr *) o1;

		/* Special pointer comparison. There is only one invalid	*/
		/* ORB and it is maintained in TS. */
		//IRObject_ptr *tc2 = glob_TS.invalid_orb_ptr();	//bad comparison
		//return (tc1 == tc2);
		return FALSE;
}


/*----------------------*/
}
