/*
 Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
 Copyright (c) 2001 Object Oriented Concepts GmbH.

 All rights reserved. No part of this source code may be reproduced,
 stored in a retrieval system, or transmitted, in any form or by any
 means, electronic, mechanical, photocopying, recording or otherwise,
 except as stated in the end-user licence agreement, without the prior
 permission of the copyright owners.

 Developed for X/Open by ApTest Ireland Limited.

 Project: VSORB

 * Copyright (c) 2001                                               
 * GMD FOKUS                                                        
 * Project: CORVAL2

*/


#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/

/* base_interfaces_read() */

VSInterfaceDefSeq_ptr 
VSbase_interfaces_read(VSEnvironment *ev, 
		       VSInterfaceDef_ptr calling_interface_ptr)
{
  CORBA::Environment *env = (CORBA::Environment *) ev;
  CORBA::InterfaceDef_ptr IFace_ptr = (CORBA::InterfaceDef_ptr) calling_interface_ptr;
  CORBA::InterfaceDefSeq* IntFaceSeq_ptr;
  
  CORBA::ORB_ptr orb = glob_TS.m_corb->orb();
  
  try {
    IntFaceSeq_ptr = IFace_ptr->base_interfaces();
  }
  catch (CORBA::Exception &ex) {
    CORBA::Exception *t = exception_convert(&ex);
    if(env)
      env->exception(t);
  }
  return (VSInterfaceDefSeq_ptr) IntFaceSeq_ptr;
}
  
  /*------------------------------------------------------*/
  /* is_a() */
  
  VSBoolean
  VSis_a(const VSRepositoryId interface_id, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::RepositoryId interfaceId = (CORBA::RepositoryId) interface_id;
    CORBA::Object_ptr			obj_ptr;
    CORBA::InterfaceDef_ptr	IFace_ptr;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    VSBoolean isA;
    IRSupport *irs = glob_TS.repository();
    
    try {
      IR_ptr = irs->get_repository();
				//get our interface over which we are running the test:
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::is_a::I3");
      if (!ctnD_ptr)
	return (VSBoolean) 0;
      IFace_ptr = CORBA::InterfaceDef::_narrow(ctnD_ptr);
      isA = IFace_ptr->is_a(interfaceId);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSBoolean) isA;
  }
  
  /*------------------------------------------------------*/
  /* describe_interface() */
  
  VSFullInterfaceDescription_ptr 
  VSdescribe_interface(VSEnvironment *ev, VSInterfaceDef_ptr calling_intface_ptr)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::InterfaceDef_ptr IFace_ptr = (CORBA::InterfaceDef_ptr) calling_intface_ptr;
    CORBA::InterfaceDef::FullInterfaceDescription* fid_ptr;
    
    CORBA::ORB_ptr orb = glob_TS.m_corb->orb();
    CORBA::Identifier objName;	
    
    try {
      fid_ptr = IFace_ptr->describe_interface();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSFullInterfaceDescription_ptr) fid_ptr;
  }
  
  /*------------------------------------------------------*/
  VSInterfaceDef_ptr*
  VSnil(VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::InterfaceDef_ptr ttc;
    
    try {
      ttc = CORBA::InterfaceDef::_nil();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSInterfaceDef_ptr *) 0;
    }
    CORBA::InterfaceDef_ptr *rtc = new CORBA::InterfaceDef_ptr(ttc);
    return (VSInterfaceDef_ptr *) rtc;
  }
  
  /*------------------------------------------------------*/
  VSInterfaceDef_ptr*
  VSduplicate(VSInterfaceDef_ptr *o1, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::InterfaceDef_ptr *tc = (CORBA::InterfaceDef_ptr *) o1;
    CORBA::InterfaceDef_ptr ttc;
    
    try {
      ttc = CORBA::InterfaceDef::_duplicate(tc ? *tc : (CORBA::InterfaceDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSInterfaceDef_ptr *) 0;
    }
    
    CORBA::InterfaceDef_ptr *rtc = new CORBA::InterfaceDef_ptr(ttc);
    return (VSInterfaceDef_ptr *) rtc;
  }
  
  /*------------------------------------------------------*/
  VSInterfaceDef_ptr*
  VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
    CORBA::InterfaceDef_ptr ttc;
    
    try {
      ttc = CORBA::InterfaceDef::_narrow(*tc ? *tc : (CORBA::InterfaceDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSInterfaceDef_ptr *) 0;
    }
    
    CORBA::InterfaceDef_ptr *rtc = new CORBA::InterfaceDef_ptr(ttc);
    return (VSInterfaceDef_ptr *) rtc;
  }
  
  /*------------------------------------------------------*/
  /* WRITE INTERFACE */
  /*------------------------------------------------------*/
  
  void
  VSbase_interfaces_write(const VSInterfaceDefSeq_ptr vs_intDefSeq,
			  VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::InterfaceDefSeq* intDefSeq = (CORBA::InterfaceDefSeq *) vs_intDefSeq;
    CORBA::InterfaceDef_ptr IFace_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    CORBA::Repository_ptr  IR_ptr;
    
    IRSupport *irs = glob_TS.repository();
    
    try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::I_write");
      if (!ctnD_ptr)
	return;
      IFace_ptr = CORBA::InterfaceDef::_narrow(ctnD_ptr);
      IFace_ptr->base_interfaces(*intDefSeq);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
  }
  
  /*------------------------------------------------------*/
  VSAttributeDef_ptr
  VScreate_attribute(const VSRepositoryId vs_id,
		     const VSIdentifier vs_name,
		     const VSVersionSpec vs_version,
		     const VSIDLType_ptr vs_type,
		     VSAttributeMode vs_mode,
		     VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::RepositoryId id = (CORBA::RepositoryId) vs_id;
    CORBA::Identifier name = (CORBA::Identifier) vs_name;
    CORBA::VersionSpec version = (CORBA::VersionSpec) vs_version;
    CORBA::IDLType_ptr type = (CORBA::IDLType_ptr) vs_type;
    CORBA::AttributeMode mode = (CORBA::AttributeMode) vs_mode;
    CORBA::AttributeDef_ptr attDef_ptr;
    
    CORBA::Repository_ptr  IR_ptr;
    CORBA::InterfaceDef_ptr IFace_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    
    IRSupport *irs = glob_TS.repository();
    
    try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::I_write");
      if (!ctnD_ptr)
	return (VSAttributeDef_ptr) 0;
      IFace_ptr = CORBA::InterfaceDef::_narrow(ctnD_ptr);
      attDef_ptr = IFace_ptr->create_attribute(id, name, version, type, mode);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSAttributeDef_ptr) attDef_ptr;
  }
  
  /*------------------------------------------------------*/
  VSOperationDef_ptr
  VScreate_operation(const VSRepositoryId vs_id,
		     const VSIdentifier vs_name,
		     const VSVersionSpec vs_version,
		     const VSIDLType_ptr vs_result,
		     VSOperationMode vs_mode,
		     const VSParDescriptionSeq_ptr vs_params,
		     const VSExceptionDefSeq_ptr vs_exceptions,
		     const VSContextIdSeq_ptr vs_contexts,
		     VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::RepositoryId id = (CORBA::RepositoryId) vs_id;
    CORBA::Identifier name = (CORBA::Identifier) vs_name;
    CORBA::VersionSpec version = (CORBA::VersionSpec) vs_version;
    CORBA::IDLType_ptr result = (CORBA::IDLType_ptr) vs_result;
    CORBA::OperationMode mode = (CORBA::OperationMode) vs_mode;
    CORBA::ParDescriptionSeq* params = (CORBA::ParDescriptionSeq *) vs_params;
    CORBA::ExceptionDefSeq* exceptions = (CORBA::ExceptionDefSeq *) vs_exceptions;
    CORBA::ContextIdSeq* contexts = (CORBA::ContextIdSeq *) vs_contexts;
    CORBA::OperationDef_ptr opDef_ptr;
    
    CORBA::Repository_ptr  IR_ptr;
    CORBA::InterfaceDef_ptr IFace_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    static int i = 0;
    
    IRSupport *irs = glob_TS.repository();
    
    try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::I_write");
      if (!ctnD_ptr)
	return (VSOperationDef_ptr) 0;
      IFace_ptr = CORBA::InterfaceDef::_narrow(ctnD_ptr);
      char opname[50];
      strcpy(opname, (char *) name);
      opname[strlen(opname) - 1] += i++;
      opDef_ptr = IFace_ptr->create_operation(id, opname, version, result, 
					      mode,
					      *params, *exceptions, *contexts);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSOperationDef_ptr) opDef_ptr;
  }
  
  /*------------------------------------------------------*/
  VSDescription_ptr 
  VSdescribe(VSEnvironment *ev) 
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Repository_ptr	IR_ptr;
    CORBA::Contained_ptr		cPtr;
    CORBA::InterfaceDef_ptr		ifaceDef_ptr;
    IRSupport *irs = glob_TS.repository();
    CORBA::Contained::Description* desc_ptr;
    
    try {
      IR_ptr = irs->get_repository();
      cPtr = irs->get_contained(IR_ptr,"M_InterfaceDef::I_write");
      if(!cPtr)
	return (VSDescription_ptr) 0;
      ifaceDef_ptr = CORBA::InterfaceDef::_narrow(cPtr);
      desc_ptr = ifaceDef_ptr->describe();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSDescription_ptr) 0;
    }
    
    return (VSDescription_ptr) desc_ptr;
  } 
  
  /*------------------------------------------------------*/
  /*  
VSBoolean 
VSis_abstract_read(VSEnvironment *ev, 
		   VSInterfaceDef_ptr calling_interface_ptr)
{
  CORBA::Environment *env = (CORBA::Environment *) ev;
  CORBA::InterfaceDef_ptr IFace_ptr = 
    (CORBA::InterfaceDef_ptr) calling_interface_ptr;
  CORBA::Boolean res;
  
  try {
    res = IFace_ptr->is_abstract();
  }
  catch (CORBA::Exception &ex) {
    CORBA::Exception *t = exception_convert(&ex);
    if(env)
      env->exception(t);
  }
  return (VSBoolean) res;
}
*/
 /*------------------------------------------------------*/
/*
void
VSis_abstract_write(VSEnvironment *ev, 
		    VSInterfaceDef_ptr calling_interface_ptr,
		    VSBoolean abs)
{
  CORBA::Environment *env = (CORBA::Environment *) ev;
  CORBA::InterfaceDef_ptr IFace_ptr = 
    (CORBA::InterfaceDef_ptr) calling_interface_ptr;
  
  try {
    IFace_ptr->is_abstract(abs);
  }
  catch (CORBA::Exception &ex) {
    CORBA::Exception *t = exception_convert(&ex);
    if(env)
      env->exception(t);
  }
  return;
}
*/
 /*------------------------------------------------------*/
  

}

