/*
  Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  Copyright (c) 2001 Object Oriented Concepts GmbH.

  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
  
  Developed for X/Open by ApTest Ireland Limited.
  
  Project: VSORB
  
 * Copyright (c) 2001                                               
 * GMD FOKUS                                                        
 * Project: CORVAL2

*/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>
 
/* ------------------------------------------------------------ */
/* fulldesc_calling_interface provides an interface pointer for the
	 VSdescribe_interface() test. */
int 
provide_fulldesc_calling_interface (VSInterfaceDef_ptr *testvar, 
				    enum prop_fulldesc_calling_interface_ciValue ciValue)
{
  CORBA::Object_ptr      obj_ptr;
  CORBA::Repository_ptr  IR_ptr;
  CORBA::Contained_ptr   ctnD_ptr;
  
  CORBA::InterfaceDef_ptr* tvar = (CORBA::InterfaceDef_ptr *) testvar;
  
  IRSupport *irs = glob_TS.repository();
  IR_ptr = irs->get_repository();
  
  switch (ciValue) {
  case Pfulldesc_calling_interface_ciValue_base:
    ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::Ibase");
    if (!ctnD_ptr)
      return FALSE;
    break;
  }
  *tvar = CORBA::InterfaceDef::_narrow(ctnD_ptr);
  return TRUE;
}
  
  int 
  relinquish_fulldesc_calling_interface (VSInterfaceDef_ptr *testvar, 
					 enum prop_fulldesc_calling_interface_ciValue ciValue)
  {
    switch (ciValue) {
    case Pfulldesc_calling_interface_ciValue_base:
      break;
    }
    return TRUE;
  }
  
  /* ------------------------------------------------------------ */
  /* calling_interface provides an interface pointer for the 
     VSbase_interfaces_read() test. */
  int 
  provide_calling_interface (VSInterfaceDef_ptr *testvar, 
			     enum prop_calling_interface_ciValue ciValue)
  {
    CORBA::Object_ptr      obj_ptr;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    
    CORBA::InterfaceDef_ptr* tvar = (CORBA::InterfaceDef_ptr *) testvar;
    
    IRSupport *irs = glob_TS.repository();
    IR_ptr = irs->get_repository();
    
    switch (ciValue) {
    case Pcalling_interface_ciValue_base:
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::Ibase");
      break;
    case  Pcalling_interface_ciValue_derived_single:
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::M_base_interfaces::Isingle");
      break;
    case Pcalling_interface_ciValue_derived_multiple:
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::M_base_interfaces::Imultiple");
      break;
    }
    if (!ctnD_ptr)
      return FALSE;
    *tvar = CORBA::InterfaceDef::_narrow(ctnD_ptr);
    return TRUE;
  }
  
  int 
  relinquish_calling_interface (VSInterfaceDef_ptr *testvar, 
				enum prop_calling_interface_ciValue ciValue)
  {
    switch (ciValue) {
    case Pcalling_interface_ciValue_base:
    case Pcalling_interface_ciValue_derived_single:
    case Pcalling_interface_ciValue_derived_multiple:
      break;
    }
    return TRUE;
  }
  
  
  /* ------------------------------------------------------------ */
  /* interface_id is provided for the VSis_a() test. */
  int 
  provide_interface_id (VSRepositoryId *testvar, 
			enum prop_interface_id_idValue idValue)
  {
    CORBA::Object_ptr      obj_ptr;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    
    CORBA::RepositoryId* tvar = (CORBA::RepositoryId *) testvar;
    
    IRSupport *irs = glob_TS.repository();
    IR_ptr = irs->get_repository();
    
    switch (idValue) {
    case Pinterface_id_idValue_same:
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::is_a::I3");
      break;
    case Pinterface_id_idValue_direct:
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::is_a::I2");
      break;
    case Pinterface_id_idValue_indirect:
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::is_a::I1");
      break;
    case Pinterface_id_idValue_derived:
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::is_a::I4");
      break;
    case Pinterface_id_idValue_unrelated:
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::is_a::Iunrelated");
      break;
    case Pinterface_id_idValue_non_interface:
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::is_a::C1");
      break;
    }
    if (!ctnD_ptr)
      return FALSE;
    *tvar = ctnD_ptr->id();
    return TRUE;
  }
  
  int 
  relinquish_interface_id (VSRepositoryId *testvar, 
			   enum prop_interface_id_idValue idValue)
  {
    switch (idValue) {
    case Pinterface_id_idValue_same:
    case Pinterface_id_idValue_direct:
    case Pinterface_id_idValue_indirect:
    case Pinterface_id_idValue_derived:
    case Pinterface_id_idValue_unrelated:
    case Pinterface_id_idValue_non_interface:
      break;
    }
    return TRUE;
  }
  
  /* ------------------------------------------------------------ */
  /* object_ptr is provided for the VSnarrow() test */
  int
  provide_object_ptr (VSObject_ptr **testvar,
		      enum prop_object_ptr_objValue objValue)
  {
    CORBA::Object_ptr tvar;
    CORBA::Object_ptr *rptr;
    CORBA::Repository_ptr IR_ptr;
    IRSupport *irs = glob_TS.repository();
    
    switch (objValue)  {
    case Pobject_ptr_objValue_valid:
      IR_ptr = irs->get_repository();
      tvar = irs->get_contained(IR_ptr,"M_InterfaceDef::Ibase");
      if(!tvar)
	return FALSE;
      break;
    case Pobject_ptr_objValue_null:
      tvar = NULL;
      break;
    }
    rptr = new CORBA::Object_ptr(tvar);
    *testvar = (VSObject_ptr *) rptr;
    return TRUE;
  }
  
  int
  relinquish_object_ptr (VSObject_ptr **testvar,
			 enum prop_object_ptr_objValue objValue)
  {
    CORBA::Object_ptr* tvar = (CORBA::Object_ptr *) *testvar;
    switch (objValue)  {
    case Pobject_ptr_objValue_valid:
      delete tvar;
    case Pobject_ptr_objValue_null:
      break;
    }
    return TRUE;
  }
  
  /* ------------------------------------------------------------ */
  /* interfacedef_ptr is provided for the VSduplicate() test */
  int
  provide_interfacedef_ptr (VSInterfaceDef_ptr **testvar,
			    enum prop_interfacedef_ptr_intdefValue intdefValue)
  {
    CORBA::InterfaceDef_ptr tvar;
    CORBA::InterfaceDef_ptr *rptr;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr ctnD_ptr;
    IRSupport *irs = glob_TS.repository();
    
    
    switch (intdefValue)  {
    case Pinterfacedef_ptr_intdefValue_valid:
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef");
      if (!ctnD_ptr)
	return FALSE;
      tvar = CORBA::InterfaceDef::_narrow(ctnD_ptr);
      break;
    case Pinterfacedef_ptr_intdefValue_null:
            tvar = NULL;
	    break;
    }
    rptr = new CORBA::InterfaceDef_ptr(tvar);
    *testvar = (VSInterfaceDef_ptr *) rptr;
    return TRUE;
  }
  
  int
  relinquish_interfacedef_ptr (VSInterfaceDef_ptr **testvar,
			       enum prop_interfacedef_ptr_intdefValue intdefValue)
  {
    CORBA::InterfaceDef_ptr* tvar = (CORBA::InterfaceDef_ptr *) *testvar;
    switch (intdefValue)  {
    case Pinterfacedef_ptr_intdefValue_valid:
      delete tvar;
    case Pinterfacedef_ptr_intdefValue_null:
      break;
    }
    return TRUE;
  }
  
  
  /* ------------------------------------------------------------ */
  /* provide functions for testing the write functionality */
  /* ------------------------------------------------------------ */
  /* intDefSeq is provided for the base_interfaces_write() test.
     To provide this we simply look up the base_interfaces of 
     another InterfaceDef */
  int
  provide_intDefSeq (VSInterfaceDefSeq_ptr *testvar, 
		     enum prop_intDefSeq_iDefSeqVal iDefSeqVal)
  {
    CORBA::InterfaceDefSeq* tvar;
    CORBA::InterfaceDefSeq* rptr;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    CORBA::InterfaceDef_ptr	ifDef_ptr;
    
    IRSupport *irs = glob_TS.repository();
    IR_ptr = irs->get_repository();
    
    switch (iDefSeqVal) {
    case PintDefSeq_iDefSeqVal_name_conflict:
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::M_base_interfaces::Isingle");
      break;
    case PintDefSeq_iDefSeqVal_no_conflict:
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::M_base_interfaces::Imultiple");
      break;
    }
    if (!ctnD_ptr)
      return FALSE;
    ifDef_ptr = CORBA::InterfaceDef::_narrow(ctnD_ptr);
    tvar = ifDef_ptr->base_interfaces();
    rptr = new CORBA::InterfaceDefSeq(*tvar);
    *testvar = (VSInterfaceDefSeq_ptr) rptr;
    return TRUE;
  }
  
  int
  relinquish_intDefSeq (VSInterfaceDefSeq_ptr *testvar, 
			enum prop_intDefSeq_iDefSeqVal iDefSeqVal)
  {
    CORBA::InterfaceDefSeq* tvar = (CORBA::InterfaceDefSeq *) *testvar;
    switch (iDefSeqVal) {
    case PintDefSeq_iDefSeqVal_name_conflict:
    case PintDefSeq_iDefSeqVal_no_conflict:
      delete tvar;
      break;
    }
    return TRUE;
  }
  /* ------------------------------------------------------------ */
  /* Providing an id for the new attribute we're creating. We try this
     with a unique and an already existing id. For the latter we simply 
     get the id of an object already in the repository (doesn't have to be
     an attribute) */
  int
  provide_att_id (VSRepositoryId *testvar, 
		  enum prop_att_id_atIdVal atIdVal)
  {
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    
    CORBA::RepositoryId* tvar = (CORBA::RepositoryId *) testvar;
    IRSupport *irs = glob_TS.repository();
    
    switch (atIdVal) {
    case Patt_id_atIdVal_exists:
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::Ibase::A1");
      if (!ctnD_ptr)
	return FALSE;
      *tvar = ctnD_ptr->id();
      break;
    case Patt_id_atIdVal_not_exists:
      *tvar = (CORBA::RepositoryId) "new_att_id";
      break;
    }
    return TRUE;
  }
  
  int
  relinquish_att_id (VSRepositoryId *testvar, 
		     enum prop_att_id_atIdVal atIdVal)
  {
    switch (atIdVal) {
    case Patt_id_atIdVal_exists:
    case Patt_id_atIdVal_not_exists:
      break;
    }
    return TRUE;
  }
  /* ------------------------------------------------------------ */
  /* type is provided for the VScreate_attribute() and 
     VScreate_operation() tests. */
  int
  provide_type (VSIDLType_ptr *testvar)
  {
    CORBA::IDLType_ptr *tvar = (CORBA::IDLType_ptr *) testvar;
    CORBA::Repository_ptr  IR_ptr;
    
    IRSupport *irs = glob_TS.repository();
    IR_ptr = irs->get_repository();
    try {
      *tvar = IR_ptr->get_primitive(CORBA::pk_short);
    }
    catch (...) {
      return FALSE;
    }
    return TRUE;
  }
  
  int
  relinquish_type (VSIDLType_ptr *testvar)
  {
    return TRUE;
  }
  /* ------------------------------------------------------------ */
  /* att_mode is provided for the VScreate_attribute() test */
  int
  provide_att_mode (VSAttributeMode *testvar)
  {
    CORBA::AttributeMode* tvar = (CORBA::AttributeMode *) testvar;
    *tvar = CORBA::ATTR_NORMAL;
    return TRUE;
  }
  
  int
  relinquish_att_mode (VSAttributeMode *testvar)
  {
    return TRUE;
  }
  /* ------------------------------------------------------------ */
  /* op_id is provided for the VScreate_operation() test.
     Same criteria applies here as with providing an attribute id */
  int
  provide_op_id (VSRepositoryId *testvar, 
		 enum prop_op_id_opIdVal opIdVal)
  {
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    CORBA::RepositoryId* tvar = (CORBA::RepositoryId *) testvar;
    IRSupport *irs = glob_TS.repository();
    
    switch(opIdVal) {
    case Pop_id_opIdVal_exists:
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::Ibase::Op1");
      if (!ctnD_ptr)
	return FALSE;
      *tvar = ctnD_ptr->id();
      break;
    case Pop_id_opIdVal_not_exists:
      *tvar = (CORBA::RepositoryId) "new_op_id";
      break;
    }
    return TRUE;
  }
  
  int
  relinquish_op_id (VSRepositoryId *testvar, 
		    enum prop_op_id_opIdVal opIdVal)
  {
    switch(opIdVal) {
    case Pop_id_opIdVal_exists:
    case Pop_id_opIdVal_not_exists:
      break;
    }
    return TRUE;
  }
  /* ------------------------------------------------------------ */
  /* op_name is provided for the VScreate_operation() test */
  /*
    int
    provide_op_name (VSIdentifier *testvar, 
    enum prop_op_name_opNameVal opNameVal)
    {
    CORBA::Identifier *tvar = (CORBA::Identifier *) testvar;
    
    switch (opNameVal) {
    case Pop_name_opNameVal_exists:
    *tvar = CORBA::string_dup("OpOld");
    break;
    case Pop_name_opNameVal_not_exists:
    *tvar = CORBA::string_dup("OpNew");
    break;
    }
    return TRUE;
    }
    
    int
    relinquish_op_name (VSIdentifier *testvar, 
    enum prop_op_name_opNameVal opNameVal)
    {
    switch (opNameVal) {
    case Pop_name_opNameVal_exists:
    case Pop_name_opNameVal_not_exists:
    break;
    }
    return TRUE;
    }
  */
  /* ------------------------------------------------------------ */
  /* op_mode is provided for the VScreate_operation() test */
  int
  provide_op_mode (VSOperationMode *testvar,
		   enum prop_op_mode_opModeVal opModeVal)
  {
    CORBA::OperationMode* tvar = (CORBA::OperationMode *) testvar;	
    switch(opModeVal) {
    case Pop_mode_opModeVal_normal:
      *tvar = CORBA::OP_NORMAL; 
      break;
    case Pop_mode_opModeVal_oneway:
      *tvar = CORBA::OP_ONEWAY;
      break;
    }
    return TRUE;
  }
  
  int
  relinquish_op_mode (VSOperationMode *testvar,
		      enum prop_op_mode_opModeVal opModeVal) 
  {
    switch(opModeVal) {
    case Pop_mode_opModeVal_normal:
    case Pop_mode_opModeVal_oneway:
      break;
    }
    return TRUE;
  }
  /* ------------------------------------------------------------ */
  /* rather than constructing a parameter sequence from scratch we 
     can look up an existing operation in the IR */
  int
  provide_params (VSParDescriptionSeq_ptr *testvar)
  {
    CORBA::ParDescriptionSeq* tvar; //= (ParDescriptionSeq *) *testvar;
    CORBA::ParDescriptionSeq* rptr;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    CORBA::OperationDef_ptr opDef_ptr;
    
    IRSupport *irs = glob_TS.repository();
    IR_ptr = irs->get_repository();
    
    ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::Ibase::Op1");
    if (!ctnD_ptr)
      return FALSE;
    opDef_ptr = CORBA::OperationDef::_narrow(ctnD_ptr);
    tvar = opDef_ptr->params();
    rptr = new CORBA::ParDescriptionSeq(*tvar);
    *testvar = (VSParDescriptionSeq_ptr) rptr;
    return TRUE;
  }
  
  int
  relinquish_params (VSParDescriptionSeq_ptr *testvar)
  {
    CORBA::ParDescriptionSeq* tvar = (CORBA::ParDescriptionSeq *) *testvar;
    delete tvar;
    return TRUE;
  }
  /* ------------------------------------------------------------ */
  /* we provide exceptions in a similar way to how we provide 
     parameters above */
  int
  provide_exceptions (VSExceptionDefSeq_ptr *testvar)
  {
    CORBA::ExceptionDefSeq* tvar;
    CORBA::ExceptionDefSeq* rptr;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    CORBA::OperationDef_ptr opDef_ptr;
    
    IRSupport *irs = glob_TS.repository();
    IR_ptr = irs->get_repository();
    
    ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::Ibase::Op1");
    if (!ctnD_ptr)
      return FALSE;
    opDef_ptr = CORBA::OperationDef::_narrow(ctnD_ptr);
    tvar = opDef_ptr->exceptions();
    rptr = new CORBA::ExceptionDefSeq(*tvar);
    *testvar = (VSExceptionDefSeq_ptr) rptr;
    return TRUE;
  }
  
  int
  relinquish_exceptions (VSExceptionDefSeq_ptr *testvar)
  {
    CORBA::ExceptionDefSeq* tvar = (CORBA::ExceptionDefSeq *) *testvar;
    delete tvar;
    return TRUE;
  }
  /* ------------------------------------------------------------ */
  /* we provide contexts in a similar way to how we provide 
     parameters above */
  int
  provide_contexts (VSContextIdSeq_ptr *testvar)
  {
    CORBA::ContextIdSeq* tvar;
    CORBA::ContextIdSeq* rptr;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    CORBA::OperationDef_ptr opDef_ptr;
    
    IRSupport *irs = glob_TS.repository();
    IR_ptr = irs->get_repository();
    
    ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::Ibase::Op1");
    if (!ctnD_ptr)
      return FALSE;
    opDef_ptr = CORBA::OperationDef::_narrow(ctnD_ptr);
    tvar = opDef_ptr->contexts();
    rptr = new CORBA::ContextIdSeq(*tvar);
    *testvar = (VSContextIdSeq_ptr) rptr;
    return TRUE;
  }
  
  int
  relinquish_contexts (VSContextIdSeq_ptr *testvar)
  {
    CORBA::ContextIdSeq* tvar = (CORBA::ContextIdSeq *) *testvar;
    delete tvar;
    return TRUE;
  }

  /* ------------------------------------------------------------ */
  /*
  int 
  provide_abs_intf (VSInterfaceDef_ptr *testvar, 
			     enum prop_abs_intf_ciValue ciValue)
  {
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr   ctnD_ptr;
    CORBA::InterfaceDef_ptr* tvar = (CORBA::InterfaceDef_ptr *) testvar;
    
    IRSupport *irs = glob_TS.repository();
    IR_ptr = irs->get_repository();
    
    switch (ciValue) {
    case Pabs_intf_abstract:
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::TestAbstrInterfaceA");
      break;
    case  Pabs_intf_not_abstract:
      ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::Ibase");
      break;
    }
    if (!ctnD_ptr)
      return FALSE;
    *tvar = CORBA::InterfaceDef::_narrow(ctnD_ptr);
    return TRUE;
  }
  
  int 
  relinquish_abs_intf (VSInterfaceDef_ptr *testvar, 
		       enum prop_abs_intf_ciValue ciValue)
  {
    CORBA::Repository_var  IR_ptr;
    CORBA::Contained_var   ctnD_ptr;
    CORBA::InterfaceDef_var tvar;
    
    IRSupport *irs = glob_TS.repository();
    IR_ptr = irs->get_repository();
    ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::TestAbstrInterfaceA");
    tvar = CORBA::InterfaceDef::_narrow(ctnD_ptr);
    tvar ->is_abstract(true);

    ctnD_ptr = irs->get_contained(IR_ptr,"M_InterfaceDef::Ibase");
    tvar = CORBA::InterfaceDef::_narrow(ctnD_ptr);
    tvar ->is_abstract(false);

    return TRUE;
  }
*/  
  /* ------------------------------------------------------------ */    
}
