//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/
VSModuleDef_ptr*
VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::ModuleDef_ptr ttc;
				 
		try {
				ttc = CORBA::ModuleDef::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				}
				catch (...) {
						return (VSModuleDef_ptr *) 0;
				}
				CORBA::ModuleDef_ptr *rtc = new CORBA::ModuleDef_ptr(ttc);
				return (VSModuleDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSModuleDef_ptr*
VSduplicate(VSModuleDef_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::ModuleDef_ptr *tc = (CORBA::ModuleDef_ptr *) o1;
		CORBA::ModuleDef_ptr ttc;
						 
		try {
       ttc = CORBA::ModuleDef::_duplicate(tc ? *tc : (CORBA::ModuleDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSModuleDef_ptr *) 0;
    }
		 
		CORBA::ModuleDef_ptr *rtc = new CORBA::ModuleDef_ptr(ttc);
		return (VSModuleDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSModuleDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
    CORBA::ModuleDef_ptr ttc;
    
    try {
        ttc = CORBA::ModuleDef::_narrow(tc ? *tc : (CORBA::ModuleDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
	if(env)
            env->exception(t);
    }
    catch (...) {
        return (VSModuleDef_ptr *) 0;
    }
    
    CORBA::ModuleDef_ptr *rtc = new CORBA::ModuleDef_ptr(ttc);
    return (VSModuleDef_ptr *) rtc;
}

/*------------------------------------------------------*/
/* redefined functions */
/*------------------------------------------------------*/
/* test that def_kind() which is declared initially in IRObject
	 returns the correct DefinitionKind for ModuleDef. */

VSDefinitionKind VSdef_kind(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::DefinitionKind dk;
		CORBA::ModuleDef_ptr 	moduleDef_ptr;
		IRSupport *irs = glob_TS.repository();
    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_Module");
				if (!ctnD_ptr)
						return (VSDefinitionKind) 0;
				moduleDef_ptr = CORBA::ModuleDef::_narrow(ctnD_ptr);
				dk = moduleDef_ptr->def_kind();
			}
    catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
    return (VSDefinitionKind) dk;
}
/*------------------------------------------------------*/

}

