//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//
/*
 *
 * t1_aux.c -- 
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

int
is_nil_moduledef_ptr(VSModuleDef_ptr *o1)
{
		CORBA::ModuleDef_ptr *tc = (CORBA::ModuleDef_ptr *) o1;
		if(!tc)
				return TRUE;
								 
		return CORBA::is_nil(*tc);
}

int
is_nil_object(VSObject_ptr o1)
{
    CORBA::Object_ptr obj1 = (CORBA::Object_ptr) o1;
    
    if(!obj1)
	return TRUE;
    return CORBA::is_nil(obj1);
}
											 
int 
cleanup_moduledef_ptr(VSModuleDef_ptr *o1)
{
		CORBA::ModuleDef_ptr *tc = (CORBA::ModuleDef_ptr *) o1;
		if(!tc)
				return TRUE;
		delete tc;
		return TRUE;
}

/*------------------------------------------------------*/
/* aux funcs for redefined functionality */
/*------------------------------------------------------*/
int
is_correct_def_kind(VSDefinitionKind vs_dk)
{
		CORBA::DefinitionKind dk = (CORBA::DefinitionKind) vs_dk;
		return (dk == CORBA::dk_Module);
}
/*------------------------------------------------------*/
}
