/*
  Copyright (c) 2001                                               
  GMD FOKUS                                                        
  Project: CORVAL2
  
  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
   
  File: tset/c++/api/IR/NativeDef/t1.cpp
  
  Purpose:
  
  Modifications:
  $Log: t1.cpp,v $
  Revision 1.1  2001/01/29 11:03:50  mli
  Initial files.

*/

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

  /*------------------------------------------------------*/
  VSNativeDef_ptr*
  VSnil(VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::NativeDef_ptr ttc;
    
    try {
      ttc = CORBA::NativeDef::_nil();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSNativeDef_ptr *) 0;
    }
    CORBA::NativeDef_ptr *rtc = new CORBA::NativeDef_ptr(ttc);
    return (VSNativeDef_ptr *) rtc;
  }
  
  /*------------------------------------------------------*/
  VSNativeDef_ptr*
  VSduplicate(VSNativeDef_ptr *o1, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::NativeDef_ptr *tc = (CORBA::NativeDef_ptr *) o1;
    CORBA::NativeDef_ptr ttc;
    
    try {
      ttc = CORBA::NativeDef::_duplicate(tc ? *tc : (CORBA::NativeDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSNativeDef_ptr *) 0;
    }
    
    CORBA::NativeDef_ptr *rtc = new CORBA::NativeDef_ptr(ttc);
    return (VSNativeDef_ptr *) rtc;
  }
  
  /*------------------------------------------------------*/
  VSNativeDef_ptr*
  VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
    CORBA::NativeDef_ptr ttc;
    try {
      ttc = CORBA::NativeDef::_narrow(tc ? *tc : (CORBA::NativeDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSNativeDef_ptr *) 0;
    }
    
    
    CORBA::NativeDef_ptr *rtc = new CORBA::NativeDef_ptr(ttc);
    return (VSNativeDef_ptr *) rtc;
  }


  VSDefinitionKind VSdef_kind(VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Repository_ptr IR_ptr;
    CORBA::Contained_ptr    ctnD_ptr;
    CORBA::DefinitionKind dk;
    CORBA::NativeDef_ptr  nt;
    IRSupport *irs = glob_TS.repository();
    
    try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestNative");
      nt = CORBA::NativeDef::_narrow(ctnD_ptr);
      dk = nt->def_kind();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSDefinitionKind) dk;
  }
  /*------------------------------------------------------*/
  VSTypeCode_ptr*
  VStype(VSEnvironment *ev) 
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::TypeCode_ptr retType_ptr;
    CORBA::Repository_ptr IR_ptr;
    CORBA::Contained_ptr    ctnD_ptr;
    CORBA::NativeDef_ptr    nt;
    IRSupport *irs = glob_TS.repository();
    
    try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestNative");
      nt = CORBA::NativeDef::_narrow(ctnD_ptr);
      retType_ptr = nt->type();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (retType_ptr);
    return (VSTypeCode_ptr *) rptr;
  }
  /*------------------------------------------------------*/
  
}



