/*
  Copyright (c) 2001                                               
  GMD FOKUS                                                        
  Project: CORVAL2
  
  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
   
  File: tset/c++/api/IR/NativeDef/t1_aux.cpp
  
  Purpose:
  
  Modifications:
  $Log: t1_aux.cpp,v $
  Revision 1.1  2001/01/29 11:03:51  mli
  Initial files.

*/


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>


  /*------------------------------------------------------*/
  int is_nil_object(VSObject_ptr o1)
  {
    CORBA::Object_ptr obj1 = (CORBA::Object_ptr) o1;
    
    if(!obj1)
      return TRUE;
    return CORBA::is_nil(obj1);
  }
  
  int
  is_nil_nativedef_ptr(VSNativeDef_ptr *o1)
  {
    CORBA::NativeDef_ptr *tc = (CORBA::NativeDef_ptr *) o1;
    if(!tc)
      return TRUE;
    
    return CORBA::is_nil(*tc);
  }
											 
  int 
  cleanup_nativedef_ptr(VSNativeDef_ptr *o1)
  {
    CORBA::NativeDef_ptr *tc = (CORBA::NativeDef_ptr *) o1;
    if(!tc)
      return TRUE;
    delete tc;
    return TRUE;
  }
  
  /*------------------------------------------------------*/
  int
  is_correct_def_kind(VSDefinitionKind vs_dk)
  {
    CORBA::DefinitionKind dk = (CORBA::DefinitionKind) vs_dk;
    return (dk == CORBA::dk_Native);
  }
  /*------------------------------------------------------*/
  int
  is_correct_typecode(VSTypeCode_ptr* vs_tc_ptr)
  {
    CORBA::TypeCode_ptr* tc_ptr = (CORBA::TypeCode_ptr *) vs_tc_ptr;
    return ((*tc_ptr)->kind() == CORBA::tk_native);
  }
  /*------------------------------------------------------*/
}

