/*
  Copyright (c) 2001                                               
  GMD FOKUS                                                        
  Project: CORVAL2
  
  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
   
  File: tset/c++/api/IR/NativeDef/t1i_tdi.cpp
  
  Purpose:
  
  Modifications:
  $Log: t1i_tdi.cpp,v $
  Revision 1.1  2001/01/29 11:03:51  mli
  Initial files.

*/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>


int
provide_object_ptr (VSObject_ptr **testvar,
		    enum prop_object_ptr_objValue objValue)
{
  CORBA::Object_ptr tvar;
  CORBA::Repository_ptr IR_ptr;
  CORBA::Contained_ptr ctnD_ptr;
  IRSupport *irs = glob_TS.repository();
  
  switch (objValue)  {
  case Pobject_ptr_objValue_valid:
    IR_ptr = irs->get_repository();
    ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestNative");
    tvar = CORBA::Contained::_duplicate(ctnD_ptr);
    break;
  case Pobject_ptr_objValue_null:
    tvar = CORBA::Object::_nil();
    break;
  }
  CORBA::Object_ptr *rp = new CORBA::Object_ptr(tvar); 
  *testvar = (VSObject_ptr *) rp ;
  return TRUE;
}
  
  int
  relinquish_object_ptr (VSObject_ptr **testvar,
			 enum prop_object_ptr_objValue objValue)
  {
    CORBA::Object_ptr* tvar = (CORBA::Object_ptr *) *testvar;
    
    switch (objValue)  {
    case Pobject_ptr_objValue_valid:
    case Pobject_ptr_objValue_null:
      break;
    }
    return TRUE;
  }
  
  /* ------------------------------------------------------------ */
  /* nativedef_ptr is provided for the VSduplicate() test */
  int
  provide_nativedef_ptr (VSNativeDef_ptr **testvar,
			 enum prop_nativedef_ptr_nativeValue nativeValue)
  {
    CORBA::NativeDef_ptr tvar;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr ctnD_ptr;
    IRSupport *irs = glob_TS.repository();
    
    switch (nativeValue)  {
    case Pnativedef_ptr_nativeValue_valid:
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestNative");
      tvar = CORBA::NativeDef::_narrow(ctnD_ptr);
      break;
    case Pnativedef_ptr_nativeValue_null:
      tvar = NULL;
      break;
    }
    *testvar = (VSNativeDef_ptr *) &tvar;
    return TRUE;
  }
  
  int
  relinquish_nativedef_ptr (VSNativeDef_ptr **testvar,
			    enum prop_nativedef_ptr_nativeValue nativeValue)
  {
    CORBA::NativeDef_ptr* tvar = (CORBA::NativeDef_ptr *) *testvar;
    switch (nativeValue)  {
    case Pnativedef_ptr_nativeValue_valid:
    case Pnativedef_ptr_nativeValue_null:
      break;
    }
    return TRUE;
  }
  
  
  /* ------------------------------------------------------------ */
  
}
