//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/
/* result() */

VSTypeCode_ptr* 
VSresult(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr			obj_ptr;
		CORBA::Repository_ptr	IR_ptr;
		CORBA::Contained_ptr		ctnD_ptr;
		CORBA::OperationDef_ptr opDef_ptr;
		CORBA::TypeCode_ptr		tc_ptr;
		IRSupport *irs = glob_TS.repository();

		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_OperationDef::I1::op_float");
				opDef_ptr = CORBA::OperationDef::_narrow(ctnD_ptr);
				tc_ptr = opDef_ptr->result();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
        return (VSTypeCode_ptr *) 0;
		}
		CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (tc_ptr);
		return (VSTypeCode_ptr *) rptr;
}

/*------------------------------------------------------*/
/* result_def_read() */

VSIDLType_ptr
VSresult_def_read(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr			obj_ptr;
		CORBA::Repository_ptr	IR_ptr;
  	CORBA::Contained_ptr   ctnD_ptr;
		CORBA::OperationDef_ptr opDef_ptr;
		CORBA::IDLType_ptr    IDLT_ptr;
		IRSupport *irs = glob_TS.repository();
		
		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_OperationDef::I1::op_float");
				opDef_ptr = CORBA::OperationDef::_narrow(ctnD_ptr);
				IDLT_ptr = opDef_ptr->result_def();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		return (VSIDLType_ptr) IDLT_ptr;
}

/*------------------------------------------------------*/
/* params_read() */
VSParDescriptionSeq_ptr
VSparams_read(VSEnvironment *ev)
{
	CORBA::Environment *env = (CORBA::Environment *) ev;
	CORBA::Object_ptr      obj_ptr;
	CORBA::Repository_ptr  IR_ptr;
	CORBA::Contained_ptr   ctnD_ptr;
	CORBA::OperationDef_ptr opDef_ptr;
	CORBA::ParDescriptionSeq* paramsDesc_ptr;
	IRSupport *irs = glob_TS.repository();
											 
	try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_OperationDef::I1::op_params");
			opDef_ptr = CORBA::OperationDef::_narrow(ctnD_ptr);
			paramsDesc_ptr = opDef_ptr->params();
	}

	catch (CORBA::Exception &ex) {
			CORBA::Exception *t = exception_convert(&ex);
			if(env)
					env->exception(t);
	}
	return (VSParDescriptionSeq_ptr) paramsDesc_ptr;
}

/*------------------------------------------------------*/
/* mode_read() */
VSOperationMode
VSmode_read(VSEnvironment *ev, VSOperationDef_ptr vs_calling_op_ptr)
{
	CORBA::Environment *env = (CORBA::Environment *) ev;
	CORBA::OperationDef_ptr opDef_ptr = (CORBA::OperationDef_ptr) vs_calling_op_ptr;
	CORBA::OperationMode		opMode;
						 
	try {
			opMode = opDef_ptr->mode();
	}
																			 
	catch (CORBA::Exception &ex) {
			CORBA::Exception *t = exception_convert(&ex);
			if(env)
					env->exception(t);
	}
	return (VSOperationMode) opMode;
}

/*------------------------------------------------------*/
/* contexts_read() */
VSContextIdSeq_ptr
VScontexts_read(VSEnvironment *ev)
{
	CORBA::Environment *env = (CORBA::Environment *) ev;
	CORBA::Object_ptr      obj_ptr;
	CORBA::Repository_ptr  IR_ptr;
	CORBA::Contained_ptr   ctnD_ptr;
	CORBA::OperationDef_ptr opDef_ptr;
	CORBA::ContextIdSeq*   ctxtSeq_ptr;
	IRSupport *irs = glob_TS.repository();

	try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_OperationDef::I1::op_context");
			opDef_ptr = CORBA::OperationDef::_narrow(ctnD_ptr);
			ctxtSeq_ptr = opDef_ptr->contexts();
  }
	 
	catch (CORBA::Exception &ex) {
			CORBA::Exception *t = exception_convert(&ex);
			if(env)
          env->exception(t);
  }
	return (VSContextIdSeq_ptr) ctxtSeq_ptr;
}

/*------------------------------------------------------*/
/* exceptions_read() */

VSExceptionDefSeq_ptr
VSexceptions_read(VSEnvironment *ev)
{
	CORBA::Environment *env = (CORBA::Environment *) ev;
	CORBA::Object_ptr      obj_ptr;
	CORBA::Repository_ptr  IR_ptr;
	CORBA::Contained_ptr   ctnD_ptr;
	CORBA::OperationDef_ptr opDef_ptr;
	CORBA::ExceptionDefSeq*   exceptSeq_ptr;
	IRSupport *irs = glob_TS.repository();
								 
	try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_OperationDef::I1::op_exception");
			opDef_ptr = CORBA::OperationDef::_narrow(ctnD_ptr);
			exceptSeq_ptr = opDef_ptr->exceptions();
  }
	 
	catch (CORBA::Exception &ex) {
			CORBA::Exception *t = exception_convert(&ex);
			if(env)
          env->exception(t);
  }
	return (VSExceptionDefSeq_ptr) exceptSeq_ptr;
}

/*------------------------------------------------------*/
VSOperationDef_ptr*
VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::OperationDef_ptr ttc;
				 
		try {
				ttc = CORBA::OperationDef::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		catch (...) {
				return (VSOperationDef_ptr *) 0;
		}
		CORBA::OperationDef_ptr *rtc = new CORBA::OperationDef_ptr(ttc);
		return (VSOperationDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSOperationDef_ptr*
VSduplicate(VSOperationDef_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::OperationDef_ptr *tc = (CORBA::OperationDef_ptr *) o1;
		CORBA::OperationDef_ptr ttc;
						 
		try {
       ttc = CORBA::OperationDef::_duplicate(tc ? *tc : (CORBA::OperationDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSOperationDef_ptr *) 0;
    }
		 
		CORBA::OperationDef_ptr *rtc = new CORBA::OperationDef_ptr(ttc);
		return (VSOperationDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSOperationDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
		CORBA::OperationDef_ptr ttc;
						 
		try {
        ttc = CORBA::OperationDef::_narrow(tc ? *tc : (CORBA::OperationDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSOperationDef_ptr *) 0;
    }
		 
		CORBA::OperationDef_ptr *rtc = new CORBA::OperationDef_ptr(ttc);
		return (VSOperationDef_ptr *) rtc;
}
/*------------------------------------------------------*/
/* WRITE INTERFACE */
/*------------------------------------------------------*/

void
VSresult_def_write(const VSIDLType_ptr vs_idltype_ptr, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::IDLType_ptr IDLT_ptr = (CORBA::IDLType_ptr) vs_idltype_ptr;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::OperationDef_ptr opDef_ptr;
		IRSupport *irs = glob_TS.repository();
		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_OperationDef::I1::op_float");
				opDef_ptr = CORBA::OperationDef::_narrow(ctnD_ptr);
				opDef_ptr->result_def(IDLT_ptr);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
}

/*------------------------------------------------------*/

void
VSparams_write(const VSParDescriptionSeq_ptr vs_params, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::ParDescriptionSeq* new_params = (CORBA::ParDescriptionSeq *) vs_params;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::OperationDef_ptr opDef_ptr;
		IRSupport *irs = glob_TS.repository();
		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_OperationDef::I1::op_write");
				opDef_ptr = CORBA::OperationDef::_narrow(ctnD_ptr);
				opDef_ptr->params(*new_params);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
}

/*------------------------------------------------------*/

void
VSmode_write(VSOperationMode vs_opmode, VSEnvironment *ev, VSOperationDef_ptr vs_calling_op)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::OperationMode new_opmode = (CORBA::OperationMode) vs_opmode;
		CORBA::OperationDef_ptr opDef_ptr = (CORBA::OperationDef_ptr) vs_calling_op;

		try {
				opDef_ptr->mode(new_opmode);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
}

/*------------------------------------------------------*/

void
VScontexts_write(const VSContextIdSeq_ptr vs_contexts, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::ContextIdSeq* new_contexts = (CORBA::ContextIdSeq *) vs_contexts;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::OperationDef_ptr opDef_ptr;
		IRSupport *irs = glob_TS.repository();
		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_OperationDef::I1::op_write");
				opDef_ptr = CORBA::OperationDef::_narrow(ctnD_ptr);
				opDef_ptr->contexts(*new_contexts);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
}

/*------------------------------------------------------*/

void
VSexceptions_write(const VSExceptionDefSeq_ptr vs_exceptions, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::ExceptionDefSeq* new_exceptions = (CORBA::ExceptionDefSeq *) vs_exceptions;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::OperationDef_ptr opDef_ptr;
		IRSupport *irs = glob_TS.repository();
		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_OperationDef::I1::op_write");
				opDef_ptr = CORBA::OperationDef::_narrow(ctnD_ptr);
				opDef_ptr->exceptions(*new_exceptions);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
}

/*------------------------------------------------------*/
/* redefined functions */
/*------------------------------------------------------*/
VSDefinitionKind VSdef_kind(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::DefinitionKind dk;
		CORBA::OperationDef_ptr 	opDef_ptr;
		IRSupport *irs = glob_TS.repository();
    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_OperationDef::I1::op_oneway");
				if (!ctnD_ptr)
						return (VSDefinitionKind) 0;
				opDef_ptr = CORBA::OperationDef::_narrow(ctnD_ptr);
				dk = opDef_ptr->def_kind();
			}
    catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
    return (VSDefinitionKind) dk;
}
/*------------------------------------------------------*/
VSDescription_ptr 
VSdescribe(VSEnvironment *ev) 
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr	IR_ptr;
    CORBA::Contained_ptr		cPtr;
		CORBA::OperationDef_ptr		opDef_ptr;
		IRSupport *irs = glob_TS.repository();
    CORBA::Contained::Description* desc_ptr;
    
    try {
        IR_ptr = irs->get_repository();
        cPtr = irs->get_contained(IR_ptr,"M_OperationDef::I1::op_oneway");
				if(!cPtr)
						return (VSDescription_ptr) 0;
				opDef_ptr = CORBA::OperationDef::_narrow(cPtr);
				desc_ptr = opDef_ptr->describe();
    }
    catch (CORBA::Exception &ex) {
			CORBA::Exception *t = exception_convert(&ex);
			if(env)
	    		env->exception(t);
    }
    catch (...) {
				return (VSDescription_ptr) 0;
    }

    return (VSDescription_ptr) desc_ptr;
} 
/*------------------------------------------------------*/

}

