/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/IR/OperationDef/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:14:18  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.3  1997/11/26 14:57:35  kevin
   Added write tests and update CORBA scoping.

   Revision 1.2  1997/10/03 12:05:35  kevin
   *** empty log message ***

   Revision 1.1  1997/09/18 17:00:38  kevin
   Tested on everything bar contexts under ORBIX - moving to test under DAIS

   Revision 1.1  1997/08/21 14:37:03  kevin
   Tests for the Contained class in the IR.


*/

#include <corba_defs.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/
/* result() */
 
 VSTypeCode_ptr*
 VSresult(VSEnvironment *ev);


/*------------------------------------------------------*/
/* result_def_read() */
 
 VSIDLType_ptr
 VSresult_def_read(VSEnvironment *ev);

/*------------------------------------------------------*/
/* params_read() */
VSParDescriptionSeq_ptr
VSparams_read(VSEnvironment *ev);

/*------------------------------------------------------*/
/* mode_read() */
VSOperationMode
VSmode_read(VSEnvironment *ev, VSOperationDef_ptr vs_calling_op_ptr);

/*------------------------------------------------------*/
/* contexts_read() */
VSContextIdSeq_ptr
VScontexts_read(VSEnvironment *ev);

/*------------------------------------------------------*/
/* exceptions_read() */
 
 VSExceptionDefSeq_ptr
 VSexceptions_read(VSEnvironment *ev);

/*------------------------------------------------------*/
VSOperationDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev);

/*------------------------------------------------------*/
VSOperationDef_ptr*
VSduplicate(VSOperationDef_ptr *o1, VSEnvironment *ev);

/*------------------------------------------------------*/
VSOperationDef_ptr*
VSnil(VSEnvironment *ev);

/*------------------------------------------------------*/
/* WRITE INTERFACE */
/*------------------------------------------------------*/

void
VSresult_def_write(const VSIDLType_ptr vs_idltype_ptr, 
									VSEnvironment *ev);

/*------------------------------------------------------*/
void
VSparams_write(const VSParDescriptionSeq_ptr vs_params, 
								VSEnvironment *ev);

/*------------------------------------------------------*/
void
VSmode_write(VSOperationMode vs_opmode, 
							VSEnvironment *ev, 
							VSOperationDef_ptr vs_calling_op);

/*------------------------------------------------------*/
void
VScontexts_write(const VSContextIdSeq_ptr vs_contexts, 
									VSEnvironment *ev);

/*------------------------------------------------------*/
void
VSexceptions_write(const VSExceptionDefSeq_ptr vs_exceptions, 
										VSEnvironment *ev);

/*------------------------------------------------------*/
/* REDEFINED INTERFACE */
/*------------------------------------------------------*/

VSDefinitionKind 
VSdef_kind(VSEnvironment *ev);

/*------------------------------------------------------*/
VSDescription_ptr
VSdescribe(VSEnvironment *ev);

