//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */

/*------------------------------------------------------*/
/* kind() */

VSPrimitiveKind 
VSkind(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr					obj_ptr;
		CORBA::Repository_ptr			IR_ptr;
		CORBA::PrimitiveDef_ptr		primDef_ptr;
		CORBA::PrimitiveKind			p_kind;
		IRSupport *irs = glob_TS.repository();

		try {
        IR_ptr = irs->get_repository();
				primDef_ptr = IR_ptr->get_primitive(CORBA::pk_short);
				p_kind = primDef_ptr->kind();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		return (VSPrimitiveKind) p_kind;
}

/*------------------------------------------------------*/
VSPrimitiveDef_ptr*
VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::PrimitiveDef_ptr ttc;
				 
		try {
				ttc = CORBA::PrimitiveDef::_nil();
    
		}
    catch (CORBA::Exception &ex) {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
						env->exception(t);
    }
    catch (...) {
			return (VSPrimitiveDef_ptr *) 0;
    }
		CORBA::PrimitiveDef_ptr *rtc = new CORBA::PrimitiveDef_ptr(ttc);
		return (VSPrimitiveDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSPrimitiveDef_ptr*
VSduplicate(VSPrimitiveDef_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::PrimitiveDef_ptr *tc = (CORBA::PrimitiveDef_ptr *) o1;
		CORBA::PrimitiveDef_ptr ttc;
						 
		try {
       ttc = CORBA::PrimitiveDef::_duplicate(tc ? *tc : (CORBA::PrimitiveDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSPrimitiveDef_ptr *) 0;
    }
		 
		CORBA::PrimitiveDef_ptr *rtc = new CORBA::PrimitiveDef_ptr(ttc);
		return (VSPrimitiveDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSPrimitiveDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
		CORBA::PrimitiveDef_ptr ttc;
						 
		try {
        ttc = CORBA::PrimitiveDef::_narrow(tc ? *tc : (CORBA::PrimitiveDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
            env->exception(t);
    }
    catch (...) {
        return (VSPrimitiveDef_ptr *) 0;
    }
		 
		CORBA::PrimitiveDef_ptr *rtc = new CORBA::PrimitiveDef_ptr(ttc);
		return (VSPrimitiveDef_ptr *) rtc;
}

/*------------------------------------------------------*/
/* redefined functions */
/*------------------------------------------------------*/
VSDefinitionKind VSdef_kind(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr IR_ptr;
		CORBA::PrimitiveDef_ptr   primDef_ptr;
		CORBA::DefinitionKind dk;
		IRSupport *irs = glob_TS.repository();
    try {
				IR_ptr = irs->get_repository();
				primDef_ptr = IR_ptr->get_primitive(CORBA::pk_short);
				dk = primDef_ptr->def_kind();
		}
    catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
    return (VSDefinitionKind) dk;
}
/*------------------------------------------------------*/
VSTypeCode_ptr*
VStype(VSEnvironment *ev) 
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr retType_ptr;
    CORBA::PrimitiveDef_ptr   primDef_ptr;
		CORBA::Repository_ptr IR_ptr;
		IRSupport *irs = glob_TS.repository();

    try {
				IR_ptr = irs->get_repository();
				primDef_ptr = IR_ptr->get_primitive(CORBA::pk_short);
				retType_ptr = primDef_ptr->type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (retType_ptr);
		return (VSTypeCode_ptr *) rptr;
}
/*------------------------------------------------------*/
  		
}


