//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

/* ------------------------------------------------------------ */
/* object_ptr is provided for the VSnarrow() test */
int
provide_object_ptr (VSObject_ptr **testvar,
		    enum prop_object_ptr_objValue objValue)
{
	CORBA::Object_ptr tvar;
	CORBA::Object_ptr *rptr;
	CORBA::Object_ptr obj_ptr;
	CORBA::Repository_ptr IR_ptr;
	IRSupport *irs = glob_TS.repository();

	switch (objValue)  {
        case Pobject_ptr_objValue_valid:
        		IR_ptr = irs->get_repository();
						try {
								tvar = IR_ptr->get_primitive(CORBA::pk_short);
						}
						catch(...){
								return FALSE;
						}
						break;
       case Pobject_ptr_objValue_null:
            tvar = NULL;
						break;
    }
		rptr = new CORBA::Object_ptr(tvar);
		*testvar = (VSObject_ptr *) rptr;
		return TRUE;
}

int
relinquish_object_ptr (VSObject_ptr **testvar,
		       enum prop_object_ptr_objValue objValue)
{
	CORBA::Object_ptr* tvar = (CORBA::Object_ptr *) *testvar;

    switch (objValue)  {
        case Pobject_ptr_objValue_valid:
						delete tvar;
				case Pobject_ptr_objValue_null:
        		break;
    }
		return TRUE;
}

/* ------------------------------------------------------------ */
/* primtivedef_ptr is provided for VSduplicate() test */
int
provide_primtivedef_ptr (VSPrimitiveDef_ptr **testvar,
			 enum prop_primtivedef_ptr_primtiveValue primtiveValue)
{
	CORBA::PrimitiveDef_ptr tvar;
	CORBA::PrimitiveDef_ptr* rptr;
	 
	CORBA::Object_ptr obj_ptr;
  CORBA::Repository_ptr  IR_ptr;
	CORBA::Contained_ptr ctnD_ptr;
	IRSupport *irs = glob_TS.repository();

		switch (primtiveValue)  {
        case Pprimtivedef_ptr_primtiveValue_valid:
        		IR_ptr = irs->get_repository();
						try {
								tvar = IR_ptr->get_primitive(CORBA::pk_short);
						}
						catch(...){
								return FALSE;
						}
						break;
       case Pprimtivedef_ptr_primtiveValue_null:
            tvar = NULL;
						break;
    }
		rptr = new CORBA::PrimitiveDef_ptr(tvar);
		*testvar = (VSPrimitiveDef_ptr *) rptr;
		return TRUE;
}

int
relinquish_primtivedef_ptr (VSPrimitiveDef_ptr **testvar,
			    enum prop_primtivedef_ptr_primtiveValue primtiveValue)
{
		CORBA::PrimitiveDef_ptr* tvar = (CORBA::PrimitiveDef_ptr *) *testvar;

		switch (primtiveValue)  {
        case Pprimtivedef_ptr_primtiveValue_valid:
						delete tvar;
				case Pprimtivedef_ptr_primtiveValue_null:
						break;
    }
		return TRUE;
}

				 
/* ------------------------------------------------------------ */

}
