//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
/*

 * Copyright (c) 2001                                               
 * GMD FOKUS                                                        
 * Project: CORVAL2
 *
 * t1_aux.c -- 
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

/*------------------------------------------------------*/
int
is_correct_primitive(VSPrimitiveDef_ptr vs_prim)
{
		CORBA::PrimitiveDef_ptr prim_ptr = (CORBA::PrimitiveDef_ptr) vs_prim;

		return (prim_ptr->kind() == CORBA::pk_string);
}

/*------------------------------------------------------*/
int is_invalid_id(VSString s)
{
		 if(s == NULL) return FALSE;
				 return (strcmp(s,"invalid") == 0) ? TRUE : FALSE;
}
									
//-----------------------------------------------------------
int is_nil_object(VSObject_ptr o1)
{
		CORBA::Object_ptr obj1 = (CORBA::Object_ptr) o1;
	 
	 	if(!obj1)
			 return TRUE;
		return CORBA::is_nil(obj1);
}
										 
/*------------------------------------------------------*/
int cleanup_repository_ptr(VSRepository_ptr *o1)
{
		CORBA::Repository_ptr *tc = (CORBA::Repository_ptr *) o1;
		if(!tc)
			return TRUE;
							 
		delete tc;
		return TRUE;
}

int
is_nil_contained_ptr(VSContained_ptr o1)
{
	CORBA::Contained_ptr tc = (CORBA::Contained_ptr) o1;
	if(!tc)
			return TRUE;

	return CORBA::is_nil(tc);
}

int
is_nil_repository_ptr(VSRepository_ptr *o1)
{

	CORBA::Repository_ptr *tc = (CORBA::Repository_ptr *) o1;
	if(!tc)
			return TRUE;

	return CORBA::is_nil(*tc);
}

/*------------------------------------------------------*/
/* aux funcs for the write interface tests */
/*------------------------------------------------------*/
int
exists_sequence(VSSequenceDef_ptr vs_def_ptr)
{
		CORBA::SequenceDef_ptr def_ptr = (CORBA::SequenceDef_ptr) vs_def_ptr;
		if(!def_ptr)
				return TRUE;
		return !CORBA::is_nil(def_ptr);
}

int
exists_array(VSArrayDef_ptr vs_def_ptr)
{
		CORBA::ArrayDef_ptr def_ptr = (CORBA::ArrayDef_ptr) vs_def_ptr;
		if(!def_ptr)
				return TRUE;
		return !CORBA::is_nil(def_ptr);
}

int
exists_string(VSStringDef_ptr vs_def_ptr)
{
		CORBA::StringDef_ptr def_ptr = (CORBA::StringDef_ptr) vs_def_ptr;
		if(!def_ptr)
				return TRUE;
		return !CORBA::is_nil(def_ptr);
}

int
zero_val(VSULong vs_val)
{
		CORBA::Long l = (CORBA::Long) vs_val;

		if(l == 0)
				return TRUE;
		return FALSE;
}

/*------------------------------------------------------*/
/* aux funcs for redefined functionality */
/*------------------------------------------------------*/
int
is_correct_def_kind(VSDefinitionKind vs_dk)
{
		CORBA::DefinitionKind dk = (CORBA::DefinitionKind) vs_dk;
		return (dk == CORBA::dk_Repository);
}
/*------------------------------------------------------*/

int is_correct_typecode(VSTypeCode_ptr vo_tc, VSTypeCode_ptr vr_tc)
{
  CORBA::TypeCode_ptr o_tc = (CORBA::TypeCode_ptr) vo_tc;
  CORBA::TypeCode_ptr r_tc = (CORBA::TypeCode_ptr) vr_tc;
  return (o_tc->equal(r_tc));
}

/*------------------------------------------------------*/

int exists_wstring(VSWstringDef_ptr vs_def_ptr)
{
  CORBA::WstringDef_ptr def_ptr = (CORBA::WstringDef_ptr) vs_def_ptr;
  if(!def_ptr)
    return TRUE;
  return !CORBA::is_nil(def_ptr);
}

}
