/*
 Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
 Copyright (c) 2001 Object Oriented Concepts GmbH.

 All rights reserved. No part of this source code may be reproduced,
 stored in a retrieval system, or transmitted, in any form or by any
 means, electronic, mechanical, photocopying, recording or otherwise,
 except as stated in the end-user licence agreement, without the prior
 permission of the copyright owners.

 Developed for X/Open by ApTest Ireland Limited.

 Project: VSORB

 * Copyright (c) 2001                                               
 * GMD FOKUS                                                        
 * Project: CORVAL2

*/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

 
/* ------------------------------------------------------------ */
/* search_id is provided for the VSlookup_id() test which looks for 
	 an object given its RepositoryId. */
int 
provide_search_id (VSRepositoryId *testvar, enum prop_search_id_sidValue sidValue)
{
 	CORBA::Object_ptr      obj_ptr;
	CORBA::Repository_ptr  IR_ptr;
 	CORBA::Contained_ptr   ctnD_ptr;

	CORBA::RepositoryId* tvar = (CORBA::RepositoryId *) testvar;
	IRSupport *irs = glob_TS.repository();
  IR_ptr = irs->get_repository();

		switch(sidValue) {
				case Psearch_id_sidValue_exists:
        	ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_contents");
					if (!ctnD_ptr)
							return FALSE;
					*tvar = ctnD_ptr->id();
					break;
				case Psearch_id_sidValue_not_exists:
					*tvar = (CORBA::RepositoryId) "invalid";
					break;
		}
		return TRUE;
}

int 
relinquish_search_id (VSRepositoryId *testvar, enum prop_search_id_sidValue sidValue)
{
		switch(sidValue) {
				case Psearch_id_sidValue_exists:
				case Psearch_id_sidValue_not_exists:
						break;
		}
		return TRUE;
}
	
		
/* ------------------------------------------------------------ */
/* kind is provided for the VSget_primitive() test which returns a 
	 reference to a PrimitiveDef with the specified kind attribute. */
int 
provide_kind (VSPrimitiveKind *testvar/*, enum prop_kind_pkValue pkValue*/)
{
	CORBA::PrimitiveKind* tvar = (CORBA::PrimitiveKind *) testvar;

//		switch(pkValue) {
//				case Pkind_pkValue_pkString:
					*tvar = CORBA::pk_string;
/*					break;
				case Pkind_pkValue_pkObjref:
					*tvar = CORBA::pk_objref;
					break;
				case Pkind_pkValue_pkNull:
					*tvar = CORBA::pk_null;
					break;
				case Pkind_pkValue_pkShort:
					*tvar = CORBA::pk_short;
						break;
		}*/
		return TRUE;
}

int 
relinquish_kind (VSPrimitiveKind *testvar /*, enum prop_kind_pkValue pkValue*/)
{
		/*switch(pkValue) {
				case Pkind_pkValue_pkString:
				case Pkind_pkValue_pkObjref:
				case Pkind_pkValue_pkNull:
				case Pkind_pkValue_pkShort:
						break;
		}*/
		return TRUE;
}



/* ------------------------------------------------------------ */
/* object_ptr is provided for the VSnarrow test */
int
provide_object_ptr (VSObject_ptr **testvar,
										enum prop_object_ptr_objValue objValue)
{
	CORBA::Object_ptr tvar;
	CORBA::Object_ptr *rptr;
	CORBA::Object_ptr obj_ptr;
	IRSupport *irs = glob_TS.repository();

   switch (objValue)  {
	      case Pobject_ptr_objValue_valid:
  			tvar = irs->get_repository();
				break;
 
		case Pobject_ptr_objValue_null:
        tvar = NULL;
				break;
    }
		rptr = new CORBA::Object_ptr(tvar);
		*testvar = (VSObject_ptr *) rptr;
		return TRUE;
}
 
int
relinquish_object_ptr (VSObject_ptr **testvar,
											enum prop_object_ptr_objValue objValue)
{
	CORBA::Object_ptr* tvar = (CORBA::Object_ptr *) *testvar;

    switch (objValue)  {
        case Pobject_ptr_objValue_valid:
						delete tvar;
				case Pobject_ptr_objValue_null:
        break;
    }
		return TRUE;
}

/* ------------------------------------------------------------ */
/* repository_ptr is provided for the VSduplicate() test */
int
provide_repository_ptr (VSRepository_ptr **testvar,
											enum prop_repository_ptr_repValue repValue)
{
	CORBA::Repository_ptr tvar;
	CORBA::Repository_ptr* rptr;
	CORBA::Object_ptr obj_ptr;
	IRSupport *irs = glob_TS.repository();

		switch (repValue)  {
        case Prepository_ptr_repValue_valid:
  					tvar = irs->get_repository();
						break;
       case Prepository_ptr_repValue_null:
            tvar = NULL;
						break;
    }
		rptr = new CORBA::Repository_ptr(tvar);
		*testvar = (VSRepository_ptr *) rptr;
		return TRUE;
}

int
relinquish_repository_ptr (VSRepository_ptr **testvar,
											enum prop_repository_ptr_repValue repValue)
{
	 CORBA::Repository_ptr* tvar = (CORBA::Repository_ptr *) *testvar;

		switch (repValue)  {
        case Prepository_ptr_repValue_valid:
						delete tvar;
				case Prepository_ptr_repValue_null:
						break;
    }
		return TRUE;
}

/* ------------------------------------------------------------ */
/* el_type is provided for the VScreate_sequence() and VScreate_array()
	 tests. */
int 
provide_el_type (VSIDLType_ptr *testvar)
{
		CORBA::IDLType_ptr *tvar = (CORBA::IDLType_ptr *) testvar;
		CORBA::Repository_ptr  IR_ptr;

		IRSupport *irs = glob_TS.repository();
		try {
				IR_ptr = irs->get_repository();
				*tvar = IR_ptr->get_primitive(CORBA::pk_short);
		}
		catch (...) {
				return FALSE;
		}
		return TRUE;
}

int
relinquish_el_type (VSIDLType_ptr *testvar)
{
		return TRUE;
}


/* ------------------------------------------------------------ */
int 
provide_c_type (VSTypeCode_ptr *testvar,
		enum prop_c_type_ct ct)
{
  CORBA::TypeCode_ptr *tvar = (CORBA::TypeCode_ptr *) testvar;
  CORBA::ORB_ptr orb = glob_TS.m_corb->orb();
  switch (ct)  {
  case Pc_type_ct_simple:
    {
      CORBA::StructMemberSeq seq;
      seq.length(2);
      seq[0].name = CORBA::string_dup("str");
      seq[0].type = CORBA::_tc_string;
      seq[0].type_def= CORBA::IDLType::_nil();
      seq[1].name = CORBA::string_dup("sh");
      seq[1].type = CORBA::_tc_short;
      seq[1].type_def= CORBA::IDLType::_nil();
      *tvar = orb->create_struct_tc("IDL:M_Container/I_copy/S1:1.0",
				    "S1", seq);
    }
    break;
  case Pc_type_ct_recursive:
    *tvar = orb->create_sequence_tc(3, CORBA::_tc_long);
    break;
  }
  return TRUE;
}

int
relinquish_c_type (VSIDLType_ptr *testvar, enum prop_c_type_ct ct)
{
  return TRUE;
}
/* ------------------------------------------------------------ */

}
