/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
   Copyright (c) 2001 Object Oriented Concepts GmbH.

   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: CORVAL2
*/


#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/

VSTypeCode_ptr* 
VSelement_type(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr	IR_ptr;
		CORBA::Contained_ptr		ctnD_ptr;
		CORBA::SequenceDef_ptr 	seqDef_ptr;
		CORBA::TypeCode_ptr		tc_ptr;
		IRSupport *irs = glob_TS.repository();

		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_SequenceDef::S1");
				CORBA::StructDef_ptr structDef_ptr = CORBA::StructDef::_narrow(ctnD_ptr);
				CORBA::StructMemberSeq* memberSeq_ptr = structDef_ptr->members();
				CORBA::IDLType_ptr idlobj_ptr = (*memberSeq_ptr)[0].type_def;
				seqDef_ptr = CORBA::SequenceDef::_narrow(idlobj_ptr);
				tc_ptr = seqDef_ptr->element_type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
        return (VSTypeCode_ptr *) 0;
		}

		CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (tc_ptr);
		return (VSTypeCode_ptr *) rptr;
}

/*------------------------------------------------------*/
/* element_type_def_read() */

VSIDLType_ptr
VSelement_type_def_read(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr	IR_ptr;
  	CORBA::Contained_ptr  ctnD_ptr;
		CORBA::SequenceDef_ptr 	seqDef_ptr;
		CORBA::IDLType_ptr    IDLT_ptr;
		IRSupport *irs = glob_TS.repository();

		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_SequenceDef::S1");
				CORBA::StructDef_ptr structDef_ptr = CORBA::StructDef::_narrow(ctnD_ptr);
				CORBA::StructMemberSeq* memberSeq_ptr = structDef_ptr->members();
				CORBA::IDLType_ptr idlobj_ptr = (*memberSeq_ptr)[0].type_def;
				seqDef_ptr = CORBA::SequenceDef::_narrow(idlobj_ptr);
				IDLT_ptr = seqDef_ptr->element_type_def();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		return (VSIDLType_ptr) IDLT_ptr;
}

/*------------------------------------------------------*/
VSULong
VSbound_read(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::SequenceDef_ptr seqDef_ptr;
		CORBA::ULong seqDef_bound;
		IRSupport *irs = glob_TS.repository();
												 
		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_SequenceDef::S1");
				CORBA::StructDef_ptr structDef_ptr = CORBA::StructDef::_narrow(ctnD_ptr);
				CORBA::StructMemberSeq* memberSeq_ptr = structDef_ptr->members();
				CORBA::IDLType_ptr idlobj_ptr = (*memberSeq_ptr)[0].type_def;
				seqDef_ptr = CORBA::SequenceDef::_narrow(idlobj_ptr);
				seqDef_bound = seqDef_ptr->bound();
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
         		  env->exception(t);
    }
		catch (...) {
        return (VSULong) 0;
    }
		return (VSULong) seqDef_bound;
}


/*------------------------------------------------------*/
VSSequenceDef_ptr*
VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::SequenceDef_ptr ttc;
				 
		try {
				ttc = CORBA::SequenceDef::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				}
				catch (...) {
						return (VSSequenceDef_ptr *) 0;
				}
				CORBA::SequenceDef_ptr *rtc = new CORBA::SequenceDef_ptr(ttc);
				return (VSSequenceDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSSequenceDef_ptr*
VSduplicate(VSSequenceDef_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::SequenceDef_ptr *tc = (CORBA::SequenceDef_ptr *) o1;
		CORBA::SequenceDef_ptr ttc;
						 
		try {
       ttc = CORBA::SequenceDef::_duplicate(tc ? *tc : (CORBA::SequenceDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSSequenceDef_ptr *) 0;
    }
		 
		CORBA::SequenceDef_ptr *rtc = new CORBA::SequenceDef_ptr(ttc);
		return (VSSequenceDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSSequenceDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
		CORBA::SequenceDef_ptr ttc;
						 
		try {
        ttc = CORBA::SequenceDef::_narrow(tc ? *tc : (CORBA::SequenceDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSSequenceDef_ptr *) 0;
    }
		 
		CORBA::SequenceDef_ptr *rtc = new CORBA::SequenceDef_ptr(ttc);
		return (VSSequenceDef_ptr *) rtc;
}

/*------------------------------------------------------*/
/* WRITE INTERFACE */
/*------------------------------------------------------*/

void
VSbound_write(VSULong vs_new_bound, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::ULong new_bound = (CORBA::ULong) vs_new_bound;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::SequenceDef_ptr seqDef_ptr;
		IRSupport *irs = glob_TS.repository();

		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_SequenceDef::S1");
				CORBA::StructDef_ptr structDef_ptr = CORBA::StructDef::_narrow(ctnD_ptr);
				CORBA::StructMemberSeq* memberSeq_ptr = structDef_ptr->members();
				CORBA::IDLType_ptr idlobj_ptr = (*memberSeq_ptr)[0].type_def;
				seqDef_ptr = CORBA::SequenceDef::_narrow(idlobj_ptr);
				seqDef_ptr->bound(new_bound);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		catch (...) {
			return;

		}
}

/*------------------------------------------------------*/
void
VSelement_type_def_write(const VSIDLType_ptr vs_idltype_ptr, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::IDLType_ptr IDLT_ptr = (CORBA::IDLType_ptr) vs_idltype_ptr;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::SequenceDef_ptr seqDef_ptr;
		IRSupport *irs = glob_TS.repository();

		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_SequenceDef::S1");
				CORBA::StructDef_ptr structDef_ptr = CORBA::StructDef::_narrow(ctnD_ptr);
				CORBA::StructMemberSeq* memberSeq_ptr = structDef_ptr->members();
				CORBA::IDLType_ptr idlobj_ptr = (*memberSeq_ptr)[0].type_def;
				seqDef_ptr = CORBA::SequenceDef::_narrow(idlobj_ptr);
				seqDef_ptr->element_type_def(IDLT_ptr);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		return;
}


/*------------------------------------------------------*/
/* redefined functions */
/*------------------------------------------------------*/
VSDefinitionKind VSdef_kind(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::DefinitionKind dk;
		CORBA::SequenceDef_ptr 	seqDef_ptr;
		IRSupport *irs = glob_TS.repository();

    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_SequenceDef::S1");
				if (!ctnD_ptr)
						return (VSDefinitionKind) 0;
				CORBA::StructDef_ptr structDef_ptr = CORBA::StructDef::_narrow(ctnD_ptr);
				CORBA::StructMemberSeq* memberSeq_ptr = structDef_ptr->members();
				CORBA::IDLType_ptr idlobj_ptr = (*memberSeq_ptr)[0].type_def;
				seqDef_ptr = CORBA::SequenceDef::_narrow(idlobj_ptr);
				dk = seqDef_ptr->def_kind();
			}
    catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
    return (VSDefinitionKind) dk;
}
/*------------------------------------------------------*/
VSTypeCode_ptr*
VStype(VSEnvironment *ev) 
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr retType_ptr;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::SequenceDef_ptr 	seqDef_ptr;
		IRSupport *irs = glob_TS.repository();

    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_SequenceDef::S1");
				CORBA::StructDef_ptr structDef_ptr = CORBA::StructDef::_narrow(ctnD_ptr);
				CORBA::StructMemberSeq* memberSeq_ptr = structDef_ptr->members();
				CORBA::IDLType_ptr idlobj_ptr = (*memberSeq_ptr)[0].type_def;
				seqDef_ptr = CORBA::SequenceDef::_narrow(idlobj_ptr);
				retType_ptr = seqDef_ptr->type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (retType_ptr);
		return (VSTypeCode_ptr *) rptr;
}
/*------------------------------------------------------*/

}

