/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: CORVAL2
*/


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>


/*------------------------------------------------------*/
int
is_correct_bound(VSULong vs_l)
{
		CORBA::ULong l = (CORBA::ULong) vs_l;

    if (l == 10)
				return TRUE;
						 
		return FALSE;
}

/*------------------------------------------------------*/
int is_nil_object(VSObject_ptr o1)
{
		CORBA::Object_ptr obj1 = (CORBA::Object_ptr) o1;
		 
		if(!obj1)
			return TRUE;
		return CORBA::is_nil(obj1);
}

int
is_nil_stringdef_ptr(VSStringDef_ptr *o1)
{
		CORBA::StringDef_ptr *tc = (CORBA::StringDef_ptr *) o1;
		if(!tc)
				return TRUE;
								 
		return CORBA::is_nil(*tc);
}
											 
int 
cleanup_stringdef_ptr(VSStringDef_ptr *o1)
{
		CORBA::StringDef_ptr *tc = (CORBA::StringDef_ptr *) o1;
		if(!tc)
				return TRUE;
		delete tc;
		return TRUE;
}
/*------------------------------------------------------*/
/* aux functions for the write functionality */
/*------------------------------------------------------*/

int
is_zero_bound(VSULong val)
{
		CORBA::ULong ul = (CORBA::ULong) val;
		return (ul == 0);
}

int
is_correct_new_bound(VSULong vs_b1, VSULong vs_b2)
{
		CORBA::ULong b1 = (CORBA::ULong) vs_b1;
		CORBA::ULong b2 = (CORBA::ULong) vs_b2;
		return (b1 == b2);
}

/*------------------------------------------------------*/
/* aux funcs for redefined functionality */
/*------------------------------------------------------*/
int
is_correct_def_kind(VSDefinitionKind vs_dk)
{
		CORBA::DefinitionKind dk = (CORBA::DefinitionKind) vs_dk;
		return (dk == CORBA::dk_String);
}
/*------------------------------------------------------*/
int
is_correct_typecode(VSTypeCode_ptr* vs_tc_ptr)
{
		CORBA::TypeCode_ptr* tc_ptr = (CORBA::TypeCode_ptr *) vs_tc_ptr;
		return ((*tc_ptr)->kind() == CORBA::tk_string);
}
/*------------------------------------------------------*/
}
