/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
   Copyright (c) 2001 Object Oriented Concepts GmbH.

   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: CORVAL2
*/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

/* ------------------------------------------------------------ */
/* object_ptr is provided for the VSnarrow() test */
int
provide_object_ptr (VSObject_ptr **testvar,
		    enum prop_object_ptr_objValue objValue)
{
	CORBA::Object_ptr tvar;
	CORBA::Object_ptr* rptr;
	CORBA::Repository_ptr IR_ptr;
	CORBA::AttributeDef_ptr attDef_ptr;
	CORBA::IDLType_ptr idlobj_ptr;
	CORBA::Contained_ptr ctnD_ptr;
	IRSupport *irs = glob_TS.repository();

    switch (objValue)  {
        case Pobject_ptr_objValue_valid:
        		IR_ptr = irs->get_repository();
        		ctnD_ptr = irs->get_contained(IR_ptr,"M_StringDef::I1::S1");
						attDef_ptr = CORBA::AttributeDef::_narrow(ctnD_ptr);
						idlobj_ptr = attDef_ptr->type_def();
						tvar = idlobj_ptr;
	    			break;
	    case Pobject_ptr_objValue_null:
						tvar = NULL;
	    			break;
		}
		rptr = new CORBA::Object_ptr(tvar);
		*testvar = (VSObject_ptr *) rptr;
    return TRUE;
}

int
relinquish_object_ptr (VSObject_ptr **testvar,
		       enum prop_object_ptr_objValue objValue)
{
	CORBA::Object_ptr* tvar = (CORBA::Object_ptr *) *testvar;

    switch (objValue)  {
        case Pobject_ptr_objValue_valid:
	  delete tvar;
	  break;
    case Pobject_ptr_objValue_null:
      break;
    }
    return TRUE;
}

/* ------------------------------------------------------------ */
/* stringdef_ptr is provided for the VSduplicate() test */
int
provide_stringdef_ptr (VSStringDef_ptr **testvar,
		       enum prop_stringdef_ptr_stringValue stringValue)
{
  CORBA::StringDef_ptr tvar;
  CORBA::StringDef_ptr* rptr;
  CORBA::Repository_ptr  IR_ptr;
  CORBA::Contained_ptr ctnD_ptr;
	CORBA::AttributeDef_ptr attDef_ptr;
	CORBA::IDLType_ptr idlobj_ptr;
	IRSupport *irs = glob_TS.repository();
    
    switch (stringValue)  {
        case Pstringdef_ptr_stringValue_valid:
        		IR_ptr = irs->get_repository();
        		ctnD_ptr = irs->get_contained(IR_ptr,"M_StringDef::I1::S1");
						attDef_ptr = CORBA::AttributeDef::_narrow(ctnD_ptr);
						idlobj_ptr = attDef_ptr->type_def();
						tvar = CORBA::StringDef::_narrow(idlobj_ptr);
	    			break;
    		case Pstringdef_ptr_stringValue_null:
            tvar = NULL;
	    			break;
    }
    rptr = new CORBA::StringDef_ptr(tvar);
    *testvar = (VSStringDef_ptr *) rptr;
    return TRUE;
}

int
relinquish_stringdef_ptr (VSStringDef_ptr **testvar,
			  enum prop_stringdef_ptr_stringValue stringValue)
{
  CORBA::StringDef_ptr* tvar = (CORBA::StringDef_ptr *) *testvar;
    switch (stringValue)  {
          case Pstringdef_ptr_stringValue_valid:
	    delete tvar;
    case Pstringdef_ptr_stringValue_null:
      break;
    }
    return TRUE;
}

				 
/* ------------------------------------------------------------ */

}
