/*
 Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
 Copyright (c) 2001 Object Oriented Concepts GmbH.

 All rights reserved. No part of this source code may be reproduced,
 stored in a retrieval system, or transmitted, in any form or by any
 means, electronic, mechanical, photocopying, recording or otherwise,
 except as stated in the end-user licence agreement, without the prior
 permission of the copyright owners.

 Developed for X/Open by ApTest Ireland Limited.

 Project: CORVAL2
*/


#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/
/* members_read() */
 
 VSStructMemberSeq_ptr
 VSmembers_read(VSEnvironment *ev)
 {
		CORBA::Environment *env = (CORBA::Environment *) ev;
	 	CORBA::Object_ptr      obj_ptr;
	 	CORBA::Repository_ptr  IR_ptr;
	 	CORBA::Contained_ptr   ctnD_ptr;
	 	CORBA::StructDef_ptr		structDef_ptr;
	 	CORBA::StructMemberSeq* memberSeq_ptr;
		IRSupport *irs = glob_TS.repository();
					
		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_StructDef::S1");
				if (CORBA::is_nil(ctnD_ptr))
						throw 0;
				structDef_ptr = CORBA::StructDef::_narrow(ctnD_ptr);
				memberSeq_ptr = structDef_ptr->members();
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
				return (VSStructMemberSeq_ptr) 0;
		}
		return (VSStructMemberSeq_ptr) memberSeq_ptr;
}

/*------------------------------------------------------*/
VSStructDef_ptr*
VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::StructDef_ptr ttc;
				 
		try {
				ttc = CORBA::StructDef::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				}
		catch (...) {
				return (VSStructDef_ptr *) 0;
		}
		CORBA::StructDef_ptr *rtc = new CORBA::StructDef_ptr(ttc);
		return (VSStructDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSStructDef_ptr*
VSduplicate(VSStructDef_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::StructDef_ptr *tc = (CORBA::StructDef_ptr *) o1;
		CORBA::StructDef_ptr ttc;
						 
		try {
       ttc = CORBA::StructDef::_duplicate(tc ? *tc : (CORBA::StructDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSStructDef_ptr *) 0;
    }
		 
		CORBA::StructDef_ptr *rtc = new CORBA::StructDef_ptr(ttc);
		return (VSStructDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSStructDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
		CORBA::StructDef_ptr ttc;
						 
		try {
        ttc = CORBA::StructDef::_narrow(tc ? *tc : (CORBA::StructDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSStructDef_ptr *) 0;
    }
		 
		CORBA::StructDef_ptr *rtc = new CORBA::StructDef_ptr(ttc);
		return (VSStructDef_ptr *) rtc;
}

/*------------------------------------------------------*/
/* WRITE INTERFACE */
/*------------------------------------------------------*/
void
VSmembers_write(const VSStructMemberSeq_ptr vs_members, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::StructMemberSeq* new_members = (CORBA::StructMemberSeq *) vs_members;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::StructDef_ptr  sDef_ptr;
		IRSupport *irs = glob_TS.repository();
		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_StructDef::S1");
				sDef_ptr = CORBA::StructDef::_narrow(ctnD_ptr);
				sDef_ptr->members(*new_members);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
}

/*------------------------------------------------------*/
/* redefined functions */
/*------------------------------------------------------*/
VSDefinitionKind VSdef_kind(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::DefinitionKind dk;
		CORBA::StructDef_ptr 	structDef_ptr;
		IRSupport *irs = glob_TS.repository();
    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_StructDef::S1");
				if (!ctnD_ptr)
						return (VSDefinitionKind) 0;
				structDef_ptr = CORBA::StructDef::_narrow(ctnD_ptr);
				dk = structDef_ptr->def_kind();
			}
    catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
    return (VSDefinitionKind) dk;
}
/*------------------------------------------------------*/
VSTypeCode_ptr*
VStype(VSEnvironment *ev) 
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr retType_ptr;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::StructDef_ptr 	structDef_ptr;
		IRSupport *irs = glob_TS.repository();

    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_StructDef::S1");
				structDef_ptr = CORBA::StructDef::_narrow(ctnD_ptr);
				retType_ptr = structDef_ptr->type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (retType_ptr);
		return (VSTypeCode_ptr *) rptr;
}
/*------------------------------------------------------*/
}

