/*
 Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.

 All rights reserved. No part of this source code may be reproduced,
 stored in a retrieval system, or transmitted, in any form or by any
 means, electronic, mechanical, photocopying, recording or otherwise,
 except as stated in the end-user licence agreement, without the prior
 permission of the copyright owners.

 Developed for X/Open by ApTest Ireland Limited.

 Project: CORVAL2
*/


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>


/*------------------------------------------------------*/
int
is_correct_members(VSStructMemberSeq_ptr vs_members_seq)
{
 CORBA::StructMemberSeq* memberSeq_ptr = (CORBA::StructMemberSeq *) vs_members_seq;
	if(!memberSeq_ptr)
			return FALSE;
	
	return((memberSeq_ptr->length() == 2) &&
				(strcmp("str", (char *) (*memberSeq_ptr)[0].name) == 0) &&
				(strcmp("sh", (char *) (*memberSeq_ptr)[1].name) == 0));
		return FALSE;
}


/*------------------------------------------------------*/
int is_nil_object(VSObject_ptr o1)
{
		CORBA::Object_ptr obj1 = (CORBA::Object_ptr) o1;
		 
		if(!obj1)
			return TRUE;
		return CORBA::is_nil(obj1);
}

int
is_nil_structdef_ptr(VSStructDef_ptr *o1)
{
		CORBA::StructDef_ptr *tc = (CORBA::StructDef_ptr *) o1;
		if(!tc)
				return TRUE;
								 
		return CORBA::is_nil(*tc);
}
											 
int 
cleanup_structdef_ptr(VSStructDef_ptr *o1)
{
		CORBA::StructDef_ptr *tc = (CORBA::StructDef_ptr *) o1;
		if(!tc)
				return TRUE;
		delete tc;
		return TRUE;
}

/*------------------------------------------------------*/
/* aux functions for write tests */
/*------------------------------------------------------*/

int
is_same_members(VSStructMemberSeq_ptr vs_m1, VSStructMemberSeq_ptr vs_m2)
{
		CORBA::StructMemberSeq* m1Seq_ptr = (CORBA::StructMemberSeq *) vs_m1;
		CORBA::StructMemberSeq* m2Seq_ptr = (CORBA::StructMemberSeq *) vs_m2;
		if(!m1Seq_ptr || !m2Seq_ptr)
				return FALSE;

		if (m1Seq_ptr->length() != m2Seq_ptr->length())
				return FALSE;
		CORBA::ULong i = 0;
		while (i < m1Seq_ptr->length()) {
				if (strcmp( (char *)(*m1Seq_ptr)[i].name, (char *)(*m2Seq_ptr)[i].name) != 0)
						return FALSE;
				i++;
		}
		return TRUE;
}

/*------------------------------------------------------*/
/* aux funcs for redefined functionality */
/*------------------------------------------------------*/
int
is_correct_def_kind(VSDefinitionKind vs_dk)
{
		CORBA::DefinitionKind dk = (CORBA::DefinitionKind) vs_dk;
		return (dk == CORBA::dk_Struct);
}
/*------------------------------------------------------*/
int
is_correct_typecode(VSTypeCode_ptr* vs_tc_ptr)
{
		CORBA::TypeCode_ptr* tc_ptr = (CORBA::TypeCode_ptr *) vs_tc_ptr;
		if(!tc_ptr || !*tc_ptr)
				return FALSE;

		return ((*tc_ptr)->kind() == CORBA::tk_struct);
}
/*------------------------------------------------------*/
}
