/*
 Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
 Copyright (c) 2001 Object Oriented Concepts GmbH.

 All rights reserved. No part of this source code may be reproduced,
 stored in a retrieval system, or transmitted, in any form or by any
 means, electronic, mechanical, photocopying, recording or otherwise,
 except as stated in the end-user licence agreement, without the prior
 permission of the copyright owners.

 Developed for X/Open by ApTest Ireland Limited.

 Project: CORVAL2
*/

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/
VSTypedefDef_ptr*
VSnil(VSEnvironment *ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::TypedefDef_ptr ttc;
    
    try {
	ttc = CORBA::TypedefDef::_nil();
    }
    catch (CORBA::Exception &ex) {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
	    env->exception(t);
    }
    catch (...) {
	return (VSTypedefDef_ptr *) 0;
				}
    CORBA::TypedefDef_ptr *rtc = new CORBA::TypedefDef_ptr(ttc);
    return (VSTypedefDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSTypedefDef_ptr*
VSduplicate(VSTypedefDef_ptr *o1, VSEnvironment *ev)
{
    
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::TypedefDef_ptr *tc = (CORBA::TypedefDef_ptr *) o1;
    CORBA::TypedefDef_ptr ttc;
    
    try {
	ttc = CORBA::TypedefDef::_duplicate(tc ? *tc : (CORBA::TypedefDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
            env->exception(t);
    }
    catch (...) {
        return (VSTypedefDef_ptr *) 0;
    }
    
    CORBA::TypedefDef_ptr *rtc = new CORBA::TypedefDef_ptr(ttc);
    return (VSTypedefDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSTypedefDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
    CORBA::TypedefDef_ptr ttc;
    
    try {
        ttc = CORBA::TypedefDef::_narrow(tc ? *tc : (CORBA::TypedefDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
            env->exception(t);
    }
    catch (...) {
        return (VSTypedefDef_ptr *) 0;
    }
		 
    CORBA::TypedefDef_ptr *rtc = new CORBA::TypedefDef_ptr(ttc);
    return (VSTypedefDef_ptr *) rtc;
}

/*------------------------------------------------------*/
/* The inherited describe() operation returns a TypeDescription
	 for each interface derived from TypedefDef (Struct, Union,
	 Enum, Alias). Here we test for this TypeDescription on the
	 subtype StructDef. */

VSDescription_ptr 
VSdescribe(VSEnvironment *ev) 
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr	IR_ptr;
    CORBA::Contained_ptr		cPtr;
		CORBA::StructDef_ptr		structDef_ptr;
		IRSupport *irs = glob_TS.repository();
    CORBA::Contained::Description* desc_ptr;
    
    try {
        IR_ptr = irs->get_repository();
        cPtr = irs->get_contained(IR_ptr,"M_StructDef::S1");
				if(!cPtr)
						return (VSDescription_ptr) 0;
				structDef_ptr = CORBA::StructDef::_narrow(cPtr);
				desc_ptr = structDef_ptr->describe();
    }
    catch (CORBA::Exception &ex) {
			CORBA::Exception *t = exception_convert(&ex);
			if(env)
	   		 env->exception(t);
    }
    catch (...) {
			return (VSDescription_ptr) 0;
    }

    return (VSDescription_ptr) desc_ptr;
} 
/*------------------------------------------------------*/

}

