//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//
/*
 *
 * t1_aux.c -- 
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

int
is_nil_typedef_ptr(VSTypedefDef_ptr *o1)
{
		CORBA::TypedefDef_ptr *tc = (CORBA::TypedefDef_ptr *) o1;
		if(!tc)
				return TRUE;
								 
		return CORBA::is_nil(*tc);
}
											 
int 
cleanup_typedef_ptr(VSTypedefDef_ptr *o1)
{
		CORBA::TypedefDef_ptr *tc = (CORBA::TypedefDef_ptr *) o1;
		if(!tc)
				return TRUE;
		delete tc;
		return TRUE;
}

int
is_nil_object(VSObject_ptr o1)
{
		CORBA::Object_ptr obj1 = (CORBA::Object_ptr) o1;
		 
		if(!obj1)
			return TRUE;
		return CORBA::is_nil(obj1);
}

/*------------------------------------------------------*/
/* aux funcs for redefined functionality */
/*------------------------------------------------------*/

int
is_correct_description(VSDescription_ptr vs_desc_ptr)
{
		CORBA::Contained::Description* desc_ptr = 
				(CORBA::Contained::Description *) vs_desc_ptr;
		if (!desc_ptr)
				return FALSE;

		if (desc_ptr->kind != CORBA::dk_Struct)
				return FALSE;

		const CORBA::TypeDescription* typeDesc_ptr;
		if (desc_ptr->value >>= typeDesc_ptr) {
				if(!typeDesc_ptr)
						return FALSE;
				if(!typeDesc_ptr->name)
						return FALSE;
				return (strcmp( (char*)typeDesc_ptr->name, "S1") == 0);
		}
		return FALSE;
}
/*------------------------------------------------------*/
}
