/*
 Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
 Copyright (c) 2001 Object Oriented Concepts GmbH.

 All rights reserved. No part of this source code may be reproduced,
 stored in a retrieval system, or transmitted, in any form or by any
 means, electronic, mechanical, photocopying, recording or otherwise,
 except as stated in the end-user licence agreement, without the prior
 permission of the copyright owners.

 Developed for X/Open by ApTest Ireland Limited.

 Project: CORVAL2
*/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

 
/* ------------------------------------------------------------ */
/* object_ptr is provided for the VSnarrow() test. */
int
provide_object_ptr (VSObject_ptr **testvar,
		    enum prop_object_ptr_objValue objValue)
{
    CORBA::Object_ptr tvar;
		CORBA::Object_ptr *rptr;
    CORBA::Repository_ptr IR_ptr;
		IRSupport *irs = glob_TS.repository();
 
    switch (objValue)  {
        case Pobject_ptr_objValue_valid:
        		IR_ptr = irs->get_repository();
        		tvar = irs->get_contained(IR_ptr,"M_TypedefDef::TD1");
	    			break;
	    case Pobject_ptr_objValue_null:
						tvar = NULL;
	    break;
		}
		rptr = new CORBA::Object_ptr(tvar);
		*testvar = (VSObject_ptr *) rptr;
    return TRUE;
}

int
relinquish_object_ptr (VSObject_ptr **testvar,
													enum prop_object_ptr_objValue objValue)
{
	CORBA::Object_ptr* tvar = (CORBA::Object_ptr *) *testvar;

    switch (objValue)  {
        case Pobject_ptr_objValue_valid:
						delete tvar;
				case Pobject_ptr_objValue_null:
        		break;
    }
		return TRUE;
}

/* ------------------------------------------------------------ */
/* typedef_ptr is provided for the VSduplicate() test. */
int
provide_typedef_ptr (VSTypedefDef_ptr **testvar,
		     enum prop_typedef_ptr_tdefValue tdefValue)
{
    CORBA::TypedefDef_ptr tvar;
		CORBA::TypedefDef_ptr *rptr;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr ctnD_ptr;
		IRSupport *irs = glob_TS.repository();

    switch (tdefValue)  {
        case Ptypedef_ptr_tdefValue_valid:
        		IR_ptr = irs->get_repository();
        		ctnD_ptr = irs->get_contained(IR_ptr,"M_TypedefDef::TD1");
	    			tvar = CORBA::TypedefDef::_narrow(ctnD_ptr);
	    			break;
	    case Ptypedef_ptr_tdefValue_null:
						tvar = NULL;
	    			break;
		}
		rptr = new CORBA::TypedefDef_ptr(tvar);
		*testvar = (VSTypedefDef_ptr *) rptr;
    return TRUE;
}

int
relinquish_typedef_ptr (VSTypedefDef_ptr **testvar,
											enum prop_typedef_ptr_tdefValue tdefValue)
{
		CORBA::TypedefDef_ptr* tvar = (CORBA::TypedefDef_ptr *) *testvar;

		switch (tdefValue)  {
        case Ptypedef_ptr_tdefValue_valid:
						delete tvar;
				case Ptypedef_ptr_tdefValue_null:
						break;
    }
		return TRUE;
}


/* ------------------------------------------------------------ */

}
