/* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
   Copyright (c) 2001 Object Oriented Concepts GmbH.

 All rights reserved. No part of this source code may be reproduced,
 stored in a retrieval system, or transmitted, in any form or by any
 means, electronic, mechanical, photocopying, recording or otherwise,
 except as stated in the end-user licence agreement, without the prior
 permission of the copyright owners.

 Developed for X/Open by ApTest Ireland Limited.

 Project: CORVAL2
*/


#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/

VSTypeCode_ptr* 
VSdiscriminator_type(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr			obj_ptr;
		CORBA::Repository_ptr	IR_ptr;
		CORBA::Contained_ptr		ctnD_ptr;
		CORBA::UnionDef_ptr 	unionDef_ptr;
		CORBA::TypeCode_ptr		tc_ptr;
		IRSupport *irs = glob_TS.repository();
 
		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_UnionDef::U1");
				unionDef_ptr = CORBA::UnionDef::_narrow(ctnD_ptr);
				tc_ptr = unionDef_ptr->discriminator_type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
        return (VSTypeCode_ptr *) 0;
		}
		CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (tc_ptr);
		return (VSTypeCode_ptr *) rptr;
}

/*------------------------------------------------------*/
/* type_def_read() */

VSIDLType_ptr
VSdiscriminator_type_def_read(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr			obj_ptr;
		CORBA::Repository_ptr	IR_ptr;
  	CORBA::Contained_ptr  ctnD_ptr;
		CORBA::UnionDef_ptr 	unionDef_ptr;
		CORBA::IDLType_ptr    IDLT_ptr;
		IRSupport *irs = glob_TS.repository();
		
		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_UnionDef::U1");
				unionDef_ptr = CORBA::UnionDef::_narrow(ctnD_ptr);
				IDLT_ptr = unionDef_ptr->discriminator_type_def();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		return (VSIDLType_ptr) IDLT_ptr;
}

/*------------------------------------------------------*/
/* members_read() */

VSUnionMemberSeq_ptr
VSmembers_read(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr			obj_ptr;
		CORBA::Repository_ptr	IR_ptr;
  	CORBA::Contained_ptr   ctnD_ptr;
		CORBA::UnionDef_ptr		unionDef_ptr;
		CORBA::UnionMemberSeq* memberSeq_ptr;
		IRSupport *irs = glob_TS.repository();
		
		try {
        IR_ptr = irs->get_repository();
        ctnD_ptr = irs->get_contained(IR_ptr,"M_UnionDef::U1");
				unionDef_ptr = CORBA::UnionDef::_narrow(ctnD_ptr);
				memberSeq_ptr = unionDef_ptr->members();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		return (VSUnionMemberSeq_ptr) memberSeq_ptr;
}


/*------------------------------------------------------*/
VSUnionDef_ptr*
VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::UnionDef_ptr ttc;
				 
		try {
				ttc = CORBA::UnionDef::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		catch (...) {
				return (VSUnionDef_ptr *) 0;
		}
		CORBA::UnionDef_ptr *rtc = new CORBA::UnionDef_ptr(ttc);
		return (VSUnionDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSUnionDef_ptr*
VSduplicate(VSUnionDef_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::UnionDef_ptr *tc = (CORBA::UnionDef_ptr *) o1;
		CORBA::UnionDef_ptr ttc;
						 
		try {
       ttc = CORBA::UnionDef::_duplicate(tc ? *tc : (CORBA::UnionDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSUnionDef_ptr *) 0;
    }
		 
		CORBA::UnionDef_ptr *rtc = new CORBA::UnionDef_ptr(ttc);
		return (VSUnionDef_ptr *) rtc;
}

/*------------------------------------------------------*/
VSUnionDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
		CORBA::UnionDef_ptr ttc;
						 
		try {
        ttc = CORBA::UnionDef::_narrow(tc ? *tc : (CORBA::UnionDef_ptr) 0);
    }
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
            env->exception(t);
    }
		catch (...) {
        return (VSUnionDef_ptr *) 0;
    }
		 
		CORBA::UnionDef_ptr *rtc = new CORBA::UnionDef_ptr(ttc);
		return (VSUnionDef_ptr *) rtc;
}
/*------------------------------------------------------*/
/* WRITE INTERFACE */
/*------------------------------------------------------*/

void
VSdiscriminator_type_def_write(const VSIDLType_ptr vs_idltype_ptr, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::IDLType_ptr IDLT_ptr = (CORBA::IDLType_ptr) vs_idltype_ptr;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::UnionDef_ptr uDef_ptr;
		IRSupport *irs = glob_TS.repository();
		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_UnionDef::U1");
				uDef_ptr = CORBA::UnionDef::_narrow(ctnD_ptr);
				uDef_ptr->discriminator_type_def(IDLT_ptr);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
}

/*------------------------------------------------------*/

void
VSmembers_write(const VSUnionMemberSeq_ptr vs_members, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::UnionMemberSeq* members = (CORBA::UnionMemberSeq *) vs_members;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr   ctnD_ptr;
		CORBA::UnionDef_ptr uDef_ptr;
		IRSupport *irs = glob_TS.repository();
		try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_UnionDef::U1");
				uDef_ptr = CORBA::UnionDef::_narrow(ctnD_ptr);
				uDef_ptr->members(*members);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
}

/*------------------------------------------------------*/
/* redefined functions */
/*------------------------------------------------------*/
VSDefinitionKind VSdef_kind(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::DefinitionKind dk;
		CORBA::UnionDef_ptr 	unionDef_ptr;
		IRSupport *irs = glob_TS.repository();
    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_UnionDef::U1");
				if (!ctnD_ptr)
						return (VSDefinitionKind) 0;
				unionDef_ptr = CORBA::UnionDef::_narrow(ctnD_ptr);
				dk = unionDef_ptr->def_kind();
			}
    catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
    return (VSDefinitionKind) dk;
}
/*------------------------------------------------------*/
VSTypeCode_ptr*
VStype(VSEnvironment *ev) 
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr retType_ptr;

		CORBA::Repository_ptr IR_ptr;
		CORBA::Contained_ptr    ctnD_ptr;
		CORBA::UnionDef_ptr 	unionDef_ptr;
		IRSupport *irs = glob_TS.repository();

    try {
				IR_ptr = irs->get_repository();
				ctnD_ptr = irs->get_contained(IR_ptr,"M_UnionDef::U1");
				unionDef_ptr = CORBA::UnionDef::_narrow(ctnD_ptr);
				retType_ptr = unionDef_ptr->type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
		}
		CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (retType_ptr);
		return (VSTypeCode_ptr *) rptr;
}
/*------------------------------------------------------*/

}

