/*
 Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.

 All rights reserved. No part of this source code may be reproduced,
 stored in a retrieval system, or transmitted, in any form or by any
 means, electronic, mechanical, photocopying, recording or otherwise,
 except as stated in the end-user licence agreement, without the prior
 permission of the copyright owners.

 Developed for X/Open by ApTest Ireland Limited.

 Project: CORVAL2
*/


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

/*------------------------------------------------------*/
int
is_correct_discriminator_type(VSTypeCode_ptr* vs_tc_ptr)
{
	CORBA::TypeCode_ptr* tc_ptr = (CORBA::TypeCode_ptr *) vs_tc_ptr;

  return((*tc_ptr)->kind() == CORBA::tk_long);
}

/*------------------------------------------------------*/
int
is_correct_discriminator_type_def(VSIDLType_ptr vs_idltype_ptr)
{
	CORBA::IDLType_ptr idltype_ptr = (CORBA::IDLType_ptr) vs_idltype_ptr;
	 
	return(idltype_ptr->type()->kind() == CORBA::tk_long);
}

/*------------------------------------------------------*/
int
is_correct_members(VSUnionMemberSeq_ptr vs_members_seq)
{
 CORBA::UnionMemberSeq* memberSeq_ptr = (CORBA::UnionMemberSeq *) vs_members_seq;
	
	return((memberSeq_ptr->length() == 3) &&
					(strcmp("l", (char *) (*memberSeq_ptr)[0].name) == 0) &&
					(strcmp("f", (char *) (*memberSeq_ptr)[1].name) == 0) &&
					(strcmp("str", (char *) (*memberSeq_ptr)[2].name) == 0));
		return FALSE;
}

/*------------------------------------------------------*/
int is_nil_object(VSObject_ptr o1)
{
		CORBA::Object_ptr obj1 = (CORBA::Object_ptr) o1;
		 
		if(!obj1)
			return TRUE;
		return CORBA::is_nil(obj1);
}

int
is_nil_uniondef_ptr(VSUnionDef_ptr *o1)
{
		CORBA::UnionDef_ptr *tc = (CORBA::UnionDef_ptr *) o1;
		if(!tc)
				return TRUE;
								 
		return CORBA::is_nil(*tc);
}
											 
int 
cleanup_uniondef_ptr(VSUnionDef_ptr *o1)
{
		CORBA::UnionDef_ptr *tc = (CORBA::UnionDef_ptr *) o1;
		if(!tc)
				return TRUE;
		delete tc;
		return TRUE;
}
/*------------------------------------------------------*/
/* aux functions for write tests */
/*------------------------------------------------------*/

int
is_same_members(VSUnionMemberSeq_ptr vs_m1, VSUnionMemberSeq_ptr vs_m2)
{
		CORBA::UnionMemberSeq* m1Seq_ptr = (CORBA::UnionMemberSeq *) vs_m1;
		CORBA::UnionMemberSeq* m2Seq_ptr = (CORBA::UnionMemberSeq *) vs_m2;
		if (m1Seq_ptr->length() != m2Seq_ptr->length())
				return FALSE;
		CORBA::ULong i = 0;
		while (i < m1Seq_ptr->length()) {
				if (strcmp( (char *)(*m1Seq_ptr)[i].name, (char *)(*m2Seq_ptr)[i].name) != 0)
						return FALSE;
				i++;
		}
		return TRUE;
}

/*------------------------------------------------------*/
int
is_same_type_def(VSIDLType_ptr vs_idl1_ptr, VSIDLType_ptr vs_idl2_ptr)
{
    CORBA::IDLType_ptr idl1_ptr = (CORBA::IDLType_ptr) vs_idl1_ptr;
		CORBA::IDLType_ptr idl2_ptr = (CORBA::IDLType_ptr) vs_idl2_ptr;
		CORBA::TypeCode_ptr t1 = idl1_ptr->type();
		CORBA::TypeCode_ptr t2 = idl2_ptr->type();

		return t1->equal(t2);
}

/*------------------------------------------------------*/
/* aux funcs for redefined functionality */
/*------------------------------------------------------*/
int
is_correct_def_kind(VSDefinitionKind vs_dk)
{
		CORBA::DefinitionKind dk = (CORBA::DefinitionKind) vs_dk;
		return (dk == CORBA::dk_Union);
}
/*------------------------------------------------------*/
int
is_correct_typecode(VSTypeCode_ptr* vs_tc_ptr)
{
		CORBA::TypeCode_ptr* tc_ptr = (CORBA::TypeCode_ptr *) vs_tc_ptr;
		CORBA::TCKind tk = (*tc_ptr)->kind();
		return (tk == CORBA::tk_union);
}
/*------------------------------------------------------*/
}
