/*
  Copyright (c) 2001                                               
  GMD FOKUS                                                        
  Project: CORVAL2
  
  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
   
  File: tset/c++/api/IR/ValueBoxDef/t1.cpp
  
  Purpose:
  
  Modifications:
  $Log: t1.cpp,v $
  Revision 1.1  2001/01/29 11:44:41  mli
  Initial files.

*/

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

  /*------------------------------------------------------*/
  VSValueBoxDef_ptr*
  VSnil(VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueBoxDef_ptr ttc;
    
    try {
      ttc = CORBA::ValueBoxDef::_nil();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSValueBoxDef_ptr *) 0;
    }
    CORBA::ValueBoxDef_ptr *rtc = new CORBA::ValueBoxDef_ptr(ttc);
    return (VSValueBoxDef_ptr *) rtc;
  }
  
  /*------------------------------------------------------*/
  VSValueBoxDef_ptr*
  VSduplicate(VSValueBoxDef_ptr *o1, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueBoxDef_ptr *tc = (CORBA::ValueBoxDef_ptr *) o1;
    CORBA::ValueBoxDef_ptr ttc;
    
    try {
      ttc = CORBA::ValueBoxDef::_duplicate(tc ? *tc : (CORBA::ValueBoxDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSValueBoxDef_ptr *) 0;
    }
    
    CORBA::ValueBoxDef_ptr *rtc = new CORBA::ValueBoxDef_ptr(ttc);
    return (VSValueBoxDef_ptr *) rtc;
  }
  
  /*------------------------------------------------------*/
  VSValueBoxDef_ptr*
  VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
    CORBA::ValueBoxDef_ptr ttc;
    try {
      ttc = CORBA::ValueBoxDef::_narrow(tc ? *tc : (CORBA::ValueBoxDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSValueBoxDef_ptr *) 0;
    }
    
    
    CORBA::ValueBoxDef_ptr *rtc = new CORBA::ValueBoxDef_ptr(ttc);
    return (VSValueBoxDef_ptr *) rtc;
  }


  VSDefinitionKind VSdef_kind(VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Repository_ptr IR_ptr;
    CORBA::Contained_ptr    ctnD_ptr;
    CORBA::DefinitionKind dk;
    CORBA::ValueBoxDef_ptr  nt;
    IRSupport *irs = glob_TS.repository();
    
    try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestShortBox");
      nt = CORBA::ValueBoxDef::_narrow(ctnD_ptr);
      dk = nt->def_kind();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSDefinitionKind) dk;
  }
  /*------------------------------------------------------*/
  VSTypeCode_ptr*
  VStype(VSEnvironment *ev) 
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::TypeCode_ptr retType_ptr;
    CORBA::Repository_ptr IR_ptr;
    CORBA::Contained_ptr    ctnD_ptr;
    CORBA::ValueBoxDef_ptr    nt;
    IRSupport *irs = glob_TS.repository();
    
    try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestShortBox");
      nt = CORBA::ValueBoxDef::_narrow(ctnD_ptr);
      retType_ptr = nt->type();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (retType_ptr);
    return (VSTypeCode_ptr *) rptr;
  }
  /*------------------------------------------------------*/

  VSIDLType_ptr VSoriginal_type_def_read(VSValueBoxDef_ptr *o,
					 VSEnvironment *ev) 
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueBoxDef_ptr *tmp = (CORBA::ValueBoxDef_ptr *) o;
    CORBA::ValueBoxDef_ptr vb = *tmp;
    CORBA::IDLType_ptr rs;
    try {
      rs = vb->original_type_def();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSIDLType_ptr) rs;
  }
  /*------------------------------------------------------*/

  void VSoriginal_type_def_write(VSIDLType_ptr vs_tc, VSValueBoxDef_ptr *o,
				 VSEnvironment *ev) 
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueBoxDef_ptr *tmp = (CORBA::ValueBoxDef_ptr *) o;
    CORBA::ValueBoxDef_ptr vb = *tmp;
    CORBA::IDLType_ptr itc = (CORBA::IDLType_ptr) vs_tc;
    try {
      vb->original_type_def(itc);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return;
  }
}



