/*
  Copyright (c) 2001                                               
  GMD FOKUS                                                        
  Project: CORVAL2
  
  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
   
  File: tset/c++/api/IR/ValueBoxDef/t1_aux.cpp
  
  Purpose:
  
  Modifications:
  $Log: t1_aux.cpp,v $
  Revision 1.1  2001/01/29 11:44:42  mli
  Initial files.

*/


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>


  /*------------------------------------------------------*/
  int is_nil_object(VSObject_ptr o1)
  {
    CORBA::Object_ptr obj1 = (CORBA::Object_ptr) o1;
    
    if(!obj1)
      return TRUE;
    return CORBA::is_nil(obj1);
  }
  
  int
  is_nil_valueboxdef_ptr(VSValueBoxDef_ptr *o1)
  {
    CORBA::ValueBoxDef_ptr *tc = (CORBA::ValueBoxDef_ptr *) o1;
    if(!tc)
      return TRUE;
    
    return CORBA::is_nil(*tc);
  }
											 
  int 
  cleanup_valueboxdef_ptr(VSValueBoxDef_ptr *o1)
  {
    CORBA::ValueBoxDef_ptr *tc = (CORBA::ValueBoxDef_ptr *) o1;
    if(!tc)
      return TRUE;
    delete tc;
    return TRUE;
  }
  
  /*------------------------------------------------------*/
  int
  is_correct_def_kind(VSDefinitionKind vs_dk)
  {
    CORBA::DefinitionKind dk = (CORBA::DefinitionKind) vs_dk;
    return (dk == CORBA::dk_ValueBox);
  }
  /*------------------------------------------------------*/
  int
  is_correct_typecode(VSTypeCode_ptr* vs_tc_ptr)
  {
    CORBA::TypeCode_ptr* tc_ptr = (CORBA::TypeCode_ptr *) vs_tc_ptr;
    return ((*tc_ptr)->kind() == CORBA::tk_value_box);
  }
  /*------------------------------------------------------*/

  int
  is_correct_orig_typecode(VSIDLType_ptr o)
  {
    CORBA::IDLType_ptr itc = (CORBA::IDLType_ptr) o;
    return (itc->type()->kind() == CORBA::tk_short);
  }

  /*------------------------------------------------------*/
  int
  equal_typecode(VSIDLType_ptr o1, VSValueBoxDef_ptr *o2)
  {
    CORBA::IDLType_ptr itc = (CORBA::IDLType_ptr) o1;
    CORBA::ValueBoxDef_ptr *tmp = (CORBA::ValueBoxDef_ptr *) o2;
    CORBA::ValueBoxDef_ptr vtc = *tmp;
    return (itc->type()->kind() == vtc->type()->kind());
  }

  /*------------------------------------------------------*/
}

