/*
  Copyright (c) 2001                                               
  GMD FOKUS                                                        
  Project: CORVAL2
  
  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
   
  File: tset/c++/api/IR/ValueBoxDef/t1i_tdi.cpp
  
  Purpose:
  
  Modifications:
  $Log: t1i_tdi.cpp,v $
  Revision 1.1  2001/01/29 11:44:42  mli
  Initial files.

*/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>


int
provide_object_ptr (VSObject_ptr **testvar,
		    enum prop_object_ptr_objValue objValue)
{
  CORBA::Object_ptr tvar;
  CORBA::Repository_ptr IR_ptr;
  CORBA::Contained_ptr ctnD_ptr;
  IRSupport *irs = glob_TS.repository();
  
  switch (objValue)  {
  case Pobject_ptr_objValue_valid:
    IR_ptr = irs->get_repository();
    ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestShortBox");
    tvar = CORBA::Contained::_duplicate(ctnD_ptr);
    break;
  case Pobject_ptr_objValue_null:
    tvar = CORBA::Object::_nil();
    break;
  }
  CORBA::Object_ptr *rp = new CORBA::Object_ptr(tvar); 
  *testvar = (VSObject_ptr *) rp ;
  return TRUE;
}
  
  int
  relinquish_object_ptr (VSObject_ptr **testvar,
			 enum prop_object_ptr_objValue objValue)
  {
    CORBA::Object_ptr* tvar = (CORBA::Object_ptr *) *testvar;
    
    switch (objValue)  {
    case Pobject_ptr_objValue_valid:
    case Pobject_ptr_objValue_null:
      break;
    }
    return TRUE;
  }
  
  /* ------------------------------------------------------------ */
  /* valueboxdef_ptr is provided for the VSduplicate() test */
  int
  provide_valueboxdef_ptr (VSValueBoxDef_ptr **testvar,
			 enum prop_valueboxdef_ptr_valueboxValue valueboxValue)
  {
    CORBA::ValueBoxDef_ptr tvar;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr ctnD_ptr;
    IRSupport *irs = glob_TS.repository();
    
    switch (valueboxValue)  {
    case Pvalueboxdef_ptr_valueboxValue_valid:
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestShortBox");
      tvar = CORBA::ValueBoxDef::_narrow(ctnD_ptr);
      break;
    case Pvalueboxdef_ptr_valueboxValue_null:
      tvar = NULL;
      break;
    }
    *testvar = (VSValueBoxDef_ptr *) &tvar;
    return TRUE;
  }
  
  int
  relinquish_valueboxdef_ptr (VSValueBoxDef_ptr **testvar,
			    enum prop_valueboxdef_ptr_valueboxValue valueboxValue)
  {
    CORBA::ValueBoxDef_ptr* tvar = (CORBA::ValueBoxDef_ptr *) *testvar;
    switch (valueboxValue)  {
    case Pvalueboxdef_ptr_valueboxValue_valid:
    case Pvalueboxdef_ptr_valueboxValue_null:
      break;
    }
    return TRUE;
  }
  
  
  /* ------------------------------------------------------------ */
  
  int
  provide_o_tc (VSIDLType_ptr *testvar,
			 enum prop_o_tc_tc tc)
  {
    CORBA::IDLType_ptr tvar;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr ctnD_ptr;
    IRSupport *irs = glob_TS.repository();
    IR_ptr = irs->get_repository();
    
    switch (tc)  {
    case Po_tc_tc_same:
      ctnD_ptr = irs->get_contained(IR_ptr,
				    "M_Container::M_write::TestShortBox");
      tvar = CORBA::IDLType::_narrow(ctnD_ptr);
      break;
    case Po_tc_tc_diff:
      ctnD_ptr = irs->get_contained(IR_ptr,
				    "M_Container::I_copy::E1");
      tvar = CORBA::IDLType::_narrow(ctnD_ptr);
      break;
    }
    *testvar = (VSIDLType_ptr) tvar;
    return TRUE;
  }
  
  int
  relinquish_o_tc (VSIDLType_ptr *testvar,
			    enum prop_o_tc_tc tc)
  {
    return TRUE;
  }
  
  
  /* ------------------------------------------------------------ */
  
}
