/*
  Copyright (c) 2001                                               
  GMD FOKUS                                                        
  Project: CORVAL2
  
  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
   
  File: tset/c++/api/IR/ValueDef/t1.cpp
  
  Purpose:
  
  Modifications:
  $Log: t1.cpp,v $
  Revision 1.2  2001/01/31 08:14:58  mli
  Update.

  Revision 1.1  2001/01/30 14:01:43  mli
  Initial files.


*/

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

  /*------------------------------------------------------*/
  VSValueDef_ptr
  VSnil(VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueDef_ptr ttc;
    
    try {
      ttc = CORBA::ValueDef::_nil();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSValueDef_ptr) 0;
    }
    return (VSValueDef_ptr) ttc;
  }
  
  /*------------------------------------------------------*/
  VSValueDef_ptr
  VSduplicate(VSValueDef_ptr o1, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueDef_ptr tc = (CORBA::ValueDef_ptr) o1;
    CORBA::ValueDef_ptr ttc;
    
    try {
      ttc = CORBA::ValueDef::_duplicate(tc ? tc : (CORBA::ValueDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSValueDef_ptr) 0;
    }
    return (VSValueDef_ptr) ttc;
  }
  
  /*------------------------------------------------------*/
  VSValueDef_ptr
  VSnarrow(VSObject_ptr o1, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Object_ptr tc = (CORBA::Object_ptr) o1;
    CORBA::ValueDef_ptr ttc;
    try {
      ttc = CORBA::ValueDef::_narrow(tc ? tc : (CORBA::ValueDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSValueDef_ptr) 0;
    }
    return (VSValueDef_ptr) ttc;
  }

  /*------------------------------------------------------*/

  VSInterfaceDefSeq_ptr 
  VSsupported_interfaces_read(VSEnvironment *ev, VSValueDef_ptr c_vdef)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::InterfaceDefSeq *rptr;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	rptr = vdef->supported_interfaces();
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSInterfaceDefSeq_ptr) rptr;
  }

  /*------------------------------------------------------*/

  void 
   VSsupported_interfaces_write(VSEnvironment *ev, VSValueDef_ptr c_vdef,
				VSInterfaceDefSeq_ptr s_itp)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::InterfaceDefSeq *itp = (CORBA::InterfaceDefSeq *) s_itp;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	vdef->supported_interfaces(*itp);
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return;
  }

  /*------------------------------------------------------*/

  VSInitializerSeq_ptr 
  VSinitializers_read(VSEnvironment *ev, VSValueDef_ptr c_vdef)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::InitializerSeq *rptr;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	rptr = vdef->initializers();
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSInitializerSeq_ptr) rptr;
  }

  /*------------------------------------------------------*/

  void 
  VSinitializers_write(VSEnvironment *ev, VSValueDef_ptr c_vdef,
		       VSInitializerSeq_ptr s_iseq)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::InitializerSeq *iseq = (CORBA::InitializerSeq *) s_iseq;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	vdef->initializers(*iseq);
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return;
  }

  /*------------------------------------------------------*/

  VSValueDef_ptr 
  VSbase_value_read(VSEnvironment *ev, VSValueDef_ptr c_vdef)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueDef_ptr rptr;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	rptr = vdef->base_value();
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSValueDef_ptr) rptr;
  }

  /*------------------------------------------------------*/

  void 
  VSbase_value_write(VSEnvironment *ev, VSValueDef_ptr c_vdef,
		     VSValueDef_ptr s_vdef)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueDef_ptr as = (CORBA::ValueDef_ptr) s_vdef;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	vdef->base_value(as);
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return;
  }

  /*------------------------------------------------------*/

  VSValueDefSeq_ptr 
  VSabstract_base_values_read(VSEnvironment *ev, VSValueDef_ptr c_vdef)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueDefSeq *rptr;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	rptr = vdef->abstract_base_values();
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSValueDefSeq_ptr) rptr;
  }

  /*------------------------------------------------------*/

  void 
  VSabstract_base_values_write(VSEnvironment *ev, VSValueDef_ptr c_vdef,
			       VSValueDefSeq_ptr s_vdseq)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueDefSeq *as = (CORBA::ValueDefSeq *) s_vdseq;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	vdef->abstract_base_values(*as);
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return;
  }

  /*------------------------------------------------------*/

  VSBoolean 
  VSis_abstract_read(VSEnvironment *ev, VSValueDef_ptr c_vdef)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Boolean rptr;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	rptr = vdef->is_abstract();
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSBoolean) rptr;
  }

  /*----------------------------------------------------------------*/

  void 
    VSis_abstract_write(VSEnvironment *ev, VSValueDef_ptr c_vdef,
			VSBoolean s_ab)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Boolean as = (CORBA::Boolean) s_ab;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	vdef->is_abstract(as);
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return;
  }

 /*----------------------------------------------------------------*/

  VSBoolean 
    VSis_custom_read(VSEnvironment *ev, VSValueDef_ptr c_vdef)

  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Boolean rptr;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	rptr = vdef->is_custom();
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSBoolean) rptr;
  }

  /*----------------------------------------------------------------*/

  void 
    VSis_custom_write(VSEnvironment *ev, VSValueDef_ptr c_vdef,
		       VSBoolean s_ct)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Boolean as = (CORBA::Boolean) s_ct;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	vdef->is_custom(as);
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return;
  }

 /*----------------------------------------------------------------*/

  VSBoolean 
    VSis_truncatable_read(VSEnvironment *ev, VSValueDef_ptr c_vdef)

  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Boolean rptr;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	rptr = vdef->is_truncatable();
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSBoolean) rptr;
  }

  /*----------------------------------------------------------------*/

  void 
    VSis_truncatable_write(VSEnvironment *ev, VSValueDef_ptr c_vdef,
			   VSBoolean s_tr)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Boolean as = (CORBA::Boolean) s_tr;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	vdef->is_truncatable(as);
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return;
  }

 /*------------------------------------------------------*/

  VSBoolean
  VSis_a(const VSRepositoryId c_id, VSValueDef_ptr c_vdef, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Boolean rptr;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;
    CORBA::RepositoryId id = (CORBA::RepositoryId) c_id;

    try
      {
	rptr = vdef->is_a(id);
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSBoolean) rptr;
  }

  /*----------------------------------------------------------------*/
  
  VSFullValueDescription_ptr
  VSdescribe_value(VSEnvironment *ev, VSValueDef_ptr c_vdef)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueDef::FullValueDescription *rptr;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;

    try
      {
	rptr = vdef->describe_value();
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSFullValueDescription_ptr) rptr;
  }

  /*----------------------------------------------------------------*/
  VSValueMemberDef_ptr
  VScreate_value_member(const VSRepositoryId vs_id,
			const VSIdentifier vs_name,
			const VSVersionSpec vs_version,
			const VSIDLType_ptr vs_type,
			const VSVisibility access,
			VSValueDef_ptr c_vdef, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueMemberDef_ptr rptr;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;
    CORBA::RepositoryId id = (CORBA::RepositoryId) vs_id;
    CORBA::Identifier name = (CORBA::Identifier) vs_name;
    CORBA::VersionSpec version = (CORBA::VersionSpec) vs_version;
    CORBA::IDLType_ptr type = (CORBA::IDLType_ptr) vs_type;
    CORBA::Visibility as = (CORBA::Visibility) access;

    try
      {
	rptr = vdef->create_value_member(id, name, version, type, as);
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSValueMemberDef_ptr) rptr;
  }

  /*------------------------------------------------------*/
  
  VSAttributeDef_ptr
  VScreate_attribute(const VSRepositoryId vs_id,
		     const VSIdentifier vs_name,
		     const VSVersionSpec vs_version,
		     const VSIDLType_ptr vs_type,
		     const VSAttributeMode vs_mode,
		     VSValueDef_ptr c_vdef, VSEnvironment *ev)

  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::AttributeDef_ptr rptr;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;
    CORBA::RepositoryId id = (CORBA::RepositoryId) vs_id;
    CORBA::Identifier name = (CORBA::Identifier) vs_name;
    CORBA::VersionSpec version = (CORBA::VersionSpec) vs_version;
    CORBA::IDLType_ptr type = (CORBA::IDLType_ptr) vs_type;
    CORBA::AttributeMode mode = (CORBA::AttributeMode) vs_mode;
    try
      {
	rptr = vdef->create_attribute(id, name, version, type, mode);
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSAttributeDef_ptr) rptr;
  }

  /*------------------------------------------------------*/

  VSOperationDef_ptr
  VScreate_operation(const VSRepositoryId vs_id,
		     const VSIdentifier vs_name,
		     const VSVersionSpec vs_version,
		     const VSIDLType_ptr vs_result,
		     const VSOperationMode vs_mode,
		     const VSParDescriptionSeq_ptr vs_params,
		     const VSExceptionDefSeq_ptr vs_exceptions,
		     const VSContextIdSeq_ptr vs_contexts,
		     VSValueDef_ptr c_vdef, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::OperationDef_ptr rptr;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;
    CORBA::RepositoryId id = (CORBA::RepositoryId) vs_id;
    CORBA::Identifier name = (CORBA::Identifier) vs_name;
    CORBA::VersionSpec version = (CORBA::VersionSpec) vs_version;
    CORBA::IDLType_ptr result = (CORBA::IDLType_ptr) vs_result;
    CORBA::OperationMode mode = (CORBA::OperationMode) vs_mode;
    CORBA::ParDescriptionSeq *par = (CORBA::ParDescriptionSeq *) vs_params;
    CORBA::ExceptionDefSeq *exp  = (CORBA::ExceptionDefSeq *) vs_exceptions;
    CORBA::ContextIdSeq *cxt = (CORBA::ContextIdSeq *) vs_contexts;
    try
      {
	rptr = vdef->create_operation(id, name, version, result, mode,
				       *par, *exp, *cxt);
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSOperationDef_ptr) rptr;
  }

  /*------------------------------------------------------*/

  VSDefinitionKind VSdef_kind(VSEnvironment *ev, VSValueDef_ptr c_vdef)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;
    CORBA::DefinitionKind dk;
    try {
      dk = vdef->def_kind();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSDefinitionKind) dk;
  }

  /*------------------------------------------------------*/

}



