/*
  Copyright (c) 2001                                               
  GMD FOKUS                                                        
  Project: CORVAL2
  
  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
   
  File: tset/c++/api/IR/ValueDef/t1_aux.cpp
  
  Purpose:
  
  Modifications:
  $Log: t1_aux.cpp,v $
  Revision 1.1  2001/01/30 14:01:43  mli
  Initial files.

*/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

  
  /*------------------------------------------------------*/
  int is_nil_object(VSObject_ptr o1)
  {
    CORBA::Object_ptr obj1 = (CORBA::Object_ptr) o1;
    
    if(!obj1)
      return TRUE;
    return CORBA::is_nil(obj1);
  }
  
  /*------------------------------------------------------*/
  
  int
  is_nil_valuedef_ptr(VSValueDef_ptr o1)
  {
    CORBA::ValueDef_ptr tc = (CORBA::ValueDef_ptr) o1;
    if(!tc)
      return TRUE;
    
    return CORBA::is_nil(tc);
  }


  /*------------------------------------------------------*/
  int 
  cleanup_valuedef_ptr(VSValueDef_ptr o1)
  {
    CORBA::ValueDef_ptr tc = (CORBA::ValueDef_ptr) o1;
    if(!CORBA::is_nil(tc))
      return TRUE;
    CORBA::release(tc);
    return TRUE;
  }

  /*------------------------------------------------------*/
  int correct_supported_interfaces(VSInterfaceDefSeq_ptr vs_idef)
  {
    CORBA::InterfaceDefSeq *idef = (CORBA::InterfaceDefSeq *) vs_idef;
    return TRUE;
  }

  /*------------------------------------------------------*/
  int correct_supported_interfaces_set(VSInterfaceDefSeq_ptr vs_idef, VSValueDef_ptr c_vdef)
  {
    CORBA::InterfaceDefSeq *idef = (CORBA::InterfaceDefSeq *) vs_idef;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;
    return TRUE;
  }

  /*------------------------------------------------------*/
  int correct_initializers(VSInitializerSeq_ptr vs_iseq)
  {
    CORBA::InitializerSeq *iseq = (CORBA::InitializerSeq *) vs_iseq;
    return TRUE;
  }
  
  /*------------------------------------------------------*/
  int correct_initializers_set(VSInitializerSeq_ptr vs_iseq, VSValueDef_ptr c_vdef)   
  {
    CORBA::InitializerSeq *iseq = (CORBA::InitializerSeq *) vs_iseq;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;
    return TRUE;
  }

  /*------------------------------------------------------*/

  int correct_base_value(VSValueDef_ptr vs_vdef)
  {
    CORBA::ValueDef_ptr svdef = (CORBA::ValueDef_ptr) vs_vdef;
    return TRUE;
  }
  
  /*------------------------------------------------------*/
  int correct_base_value_set(VSValueDef_ptr vs_vdef, VSValueDef_ptr c_vdef)   
  {
    CORBA::ValueDef_ptr svdef = (CORBA::ValueDef_ptr) vs_vdef;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;
    return TRUE;
  }

  /*------------------------------------------------------*/
    
  int correct_abstract_base_values(VSValueDefSeq_ptr vs_vseq)
  {
    CORBA::ValueDefSeq *vseq = (CORBA::ValueDefSeq *) vs_vseq;
    return TRUE;
  }
  
  /*------------------------------------------------------*/
  int correct_abstract_base_values_set(VSValueDefSeq_ptr vs_vseq, VSValueDef_ptr c_vdef)   
  {
    CORBA::ValueDefSeq *vseq = (CORBA::ValueDefSeq *) vs_vseq;
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;
    return TRUE;
  }

  /*------------------------------------------------------*/

  int is_abstract(VSValueDef_ptr c_vdef)
  {
    return FALSE;
  }

  /*------------------------------------------------------*/
  
  int
  is_abstract_set(VSBoolean abs, VSValueDef_ptr c_vdef)
  {
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;
    bool res = vdef->is_abstract();
    return (res == (bool) abs);
  }

  /*------------------------------------------------------*/

  int is_custom(VSValueDef_ptr c_vdef)
  {
    return FALSE;
  }

  /*------------------------------------------------------*/
  
  int
  is_custom_set(VSBoolean abs, VSValueDef_ptr c_vdef)
  {
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;
    bool res = vdef->is_custom();
    return (res == (bool) abs);
  }
  /*------------------------------------------------------*/

  int is_truncatable(VSValueDef_ptr c_vdef)
  {
    return FALSE;
  }

  /*------------------------------------------------------*/
  
  int
  is_truncatable_set(VSBoolean abs, VSValueDef_ptr c_vdef)
  {
    CORBA::ValueDef_ptr vdef = (CORBA::ValueDef_ptr) c_vdef;
    bool res = vdef->is_truncatable();
    return (res == (bool) abs);
  }
  /*------------------------------------------------------*/

  int is_derived_from(VSRepositoryId vs_id)
  {
    CORBA::RepositoryId id = (CORBA::RepositoryId) vs_id;
    if(strcmp(id, "IDL:M_Container/M_write/TestValueB:1.0")==0)
      return TRUE;
    else
      return FALSE;
  }

  /*------------------------------------------------------*/
    int correct_full_description(VSFullValueDescription_ptr vs_des)
    {
      CORBA::ValueDef::FullValueDescription *des = 
	(CORBA::ValueDef::FullValueDescription *) vs_des;
      if(strcmp(des->id, "IDL:M_Container/M_write/TestValueB:1.0")==0)
	return TRUE;
    }

  /*------------------------------------------------------*/

  int id_exists(VSRepositoryId vs_id)
  {
    CORBA::RepositoryId id = (CORBA::RepositoryId) vs_id;
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();
    CORBA::Contained_var ctnD_ptr = irs->get_contained(IR_ptr, id);
    if (!CORBA::is_nil(ctnD_ptr))
      return TRUE;
    return FALSE;
  }

  /*------------------------------------------------------*/
  int name_exists(VSIdentifier vs_name)
  {
    CORBA::Identifier nm = (CORBA::Identifier) vs_name;
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();
    CORBA::Contained_var ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestValueB");
    CORBA::ValueDef_ptr vdef = CORBA::ValueDef::_narrow(ctnD_ptr);
    assert(!CORBA::is_nil(vdef));
    CORBA::Contained_var ct = vdef->lookup(nm);
    if(!CORBA::is_nil(ct))
      return TRUE;
    return FALSE;
  }

  /*------------------------------------------------------*/
  int correct_vmem_defined_in(VSValueMemberDef_ptr)
  {
    return TRUE;
  }

  /*------------------------------------------------------*/

  int correct_att_defined_in(VSAttributeDef_ptr)
  {
    return TRUE;
  }

  /*------------------------------------------------------*/

  int correct_op_defined_in(VSOperationDef_ptr)
  {
    return TRUE;
  }

}

