/*
  Copyright (c) 2001                                               
  GMD FOKUS                                                        
  Project: CORVAL2
  
  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
   
  File: tset/c++/api/IR/ValueDef/t1i_tdi.cpp
  
  Purpose:
  
  Modifications:
  $Log: t1i_tdi.cpp,v $
  Revision 1.2  2001/01/31 08:14:59  mli
  Update.

  Revision 1.1  2001/01/30 14:01:43  mli
  Initial files.


*/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>


  int
  provide_object_ptr (VSObject_ptr *testvar,
		      enum prop_object_ptr_objValue objValue)
  {
    CORBA::Object_ptr tvar;
    CORBA::Repository_ptr IR_ptr;
    CORBA::Contained_ptr ctnD_ptr;
    
    IRSupport *irs = glob_TS.repository();
    
    switch (objValue)  {
    case Pobject_ptr_objValue_valid:
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestValueB");
      tvar = CORBA::Contained::_duplicate(ctnD_ptr);
      break;
    case Pobject_ptr_objValue_null:
      tvar = CORBA::Object::_nil();
      break;
    }
    *testvar = (VSObject_ptr) tvar;
    return TRUE;
  }
  
  int
  relinquish_object_ptr (VSObject_ptr *testvar,
			 enum prop_object_ptr_objValue objValue)
  {
    return TRUE;
  }
  
  
  /* ------------------------------------------------------------ */
  
  int
  provide_c_vdef (VSValueDef_ptr *testvar)
  {
    CORBA::ValueDef_ptr tvar;
    CORBA::Object_ptr* rptr;
    CORBA::Repository_ptr IR_ptr;
    CORBA::ValueDef_var vdef;
    CORBA::Contained_ptr ctnD_ptr;
    
    IRSupport *irs = glob_TS.repository();
    
    IR_ptr = irs->get_repository();
    ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestValueB");
    vdef = CORBA::ValueDef::_narrow(ctnD_ptr);
    tvar = CORBA::ValueDef::_duplicate(vdef);
    
    *testvar = (VSObject_ptr) tvar;
    return TRUE;
  }
  
  int
  relinquish_c_vdef (VSValueDef_ptr *testvar)
  {
    return TRUE;
  }
  
 /* ------------------------------------------------------------ */
 
  int
  provide_c_id (VSRepositoryId *testvar,
		enum prop_c_id_a a)
  {
    CORBA::RepositoryId tvar;
    switch (a)  {
    case Pc_id_a_derived:
      tvar = CORBA::string_dup("IDL:M_Container/M_write/TestValueB:1.0");
      break;
    case Pc_id_a_not_derived:
      tvar = CORBA::string_dup("IDL:M_Container/M_write/TestValueC:1.0");
      break;
    }
    *testvar = (VSRepositoryId) tvar;
    return TRUE;
  }

  int
  relinquish_c_id (VSRepositoryId *testvar,
		   enum prop_c_id_a a)
  {
    return TRUE;
  }

  /* ------------------------------------------------------------ */

  int
  provide_s_vdef (VSValueDef_ptr *testvar)
  {
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();
    CORBA::Contained_var ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestValueC");
    CORBA::ValueDef_ptr vdef = CORBA::ValueDef::_narrow(ctnD_ptr);
    *testvar = (VSValueDef_ptr) vdef;
    return TRUE;
  }
  
  int
  relinquish_s_vdef (VSIDLType_ptr *testvar)
  {
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();

    CORBA::Contained_var ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestValueB");
    CORBA::ValueDef_var vdef = CORBA::ValueDef::_narrow(ctnD_ptr);
    vdef->base_value(CORBA::ValueDef::_nil());
    return TRUE;
  }
  
 /* ------------------------------------------------------------ */

  int
  provide_s_vdef_seq (VSValueDefSeq_ptr *testvar)
  {
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();
    CORBA::Contained_var ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestValueD");
    CORBA::ValueDef_ptr vdef = CORBA::ValueDef::_narrow(ctnD_ptr);
    CORBA::ValueDefSeq t;
    t.length(1);
    t[0] = vdef;
    CORBA::ValueDefSeq *tvar = new CORBA::ValueDefSeq(t);
    *testvar = (VSValueDefSeq_ptr) tvar;
    return TRUE;
  }
  
  int
  relinquish_s_vdef_seq (VSValueDefSeq_ptr *testvar)
  {
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();

    CORBA::Contained_var ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestValueB");
    CORBA::ValueDef_var vdef = CORBA::ValueDef::_narrow(ctnD_ptr);
    ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestValueA");
    CORBA::ValueDef_ptr m = CORBA::ValueDef::_narrow(ctnD_ptr);
    CORBA::ValueDefSeq t;
    t.length(1);
    t[0] = m;
    vdef->abstract_base_values(t);
    return TRUE;
  }
  
 /* ------------------------------------------------------------ */

  int
  provide_s_intf_def_seq (VSInterfaceDefSeq_ptr *testvar)
  {
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();
    CORBA::Contained_var ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_contents::I2");
    CORBA::InterfaceDef_ptr vdef = CORBA::InterfaceDef::_narrow(ctnD_ptr);
    CORBA::InterfaceDefSeq t;
    t.length(1);
    t[0] = vdef;
    CORBA::InterfaceDefSeq *tvar = new CORBA::InterfaceDefSeq(t);
    *testvar = (VSInterfaceDefSeq_ptr) tvar;
    return TRUE;
  }
  
  int
  relinquish_s_intf_def_seq (VSInterfaceDefSeq_ptr *testvar)
  {
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();

    CORBA::Contained_var ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestValueB");
    CORBA::ValueDef_var vdef = CORBA::ValueDef::_narrow(ctnD_ptr);
    ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::I_copy");
    CORBA::InterfaceDef_ptr m = CORBA::InterfaceDef::_narrow(ctnD_ptr);
    CORBA::InterfaceDefSeq t;
    t.length(1);
    t[0] = m;
    vdef->supported_interfaces(t);
    return TRUE;
  }
  
 /* ------------------------------------------------------------ */

  int
  provide_s_initializer_seq (VSInitializerSeq_ptr *testvar)
  {
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();
    CORBA::Contained_var ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestValueB");
    CORBA::ValueDef_ptr vdef = CORBA::ValueDef::_narrow(ctnD_ptr);
    CORBA::InitializerSeq *iseq = vdef->initializers();
    (*iseq)[0].name = CORBA::string_dup("generate");
    *testvar = (VSInitializerSeq_ptr) iseq;
    return TRUE;
  }
  
  int
  relinquish_s_initializer_seq (VSInitializerSeq_ptr *testvar)
  {
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();
    CORBA::Contained_var ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestValueB");
    CORBA::ValueDef_ptr vdef = CORBA::ValueDef::_narrow(ctnD_ptr);
    CORBA::InitializerSeq_var iseq = vdef->initializers();
    iseq[0].name = CORBA::string_dup("create");
    return TRUE;
  }
  
 /* ------------------------------------------------------------ */

  int
  provide_vl_id (VSRepositoryId *testvar,
		 enum prop_vl_id_a a)
  {
    CORBA::RepositoryId tvar;
    switch (a)  {
    case Pvl_id_a_exist:
      tvar = CORBA::string_dup("IDL:M_Container/M_write/TestValueB/age:1.0");
      break;
    case Pvl_id_a_non_exist:
      tvar = CORBA::string_dup("IDL:M_Container/M_write/TestValueB/age2:1.0");
      break;
    }
    *testvar = (VSRepositoryId) tvar;
    return TRUE;
  }

  int
  relinquish_vl_id (VSRepositoryId *testvar,
		 enum prop_vl_id_a a)
  {
    return TRUE;
  }

  /* ------------------------------------------------------------ */

  int
  provide_vl_name (VSIdentifier *testvar,
		   enum prop_vl_name_b b)
  {
    CORBA::Identifier tvar;
    switch (b)  {
    case Pvl_name_b_exist:
      tvar = CORBA::string_dup("age");
      break;
    case Pvl_name_b_non_exist:
      tvar = CORBA::string_dup("age2");
      break;
    }
    *testvar = (VSIdentifier) tvar;
    return TRUE;
  }

  int
  relinquish_vl_name (VSIdentifier *testvar,
		      enum prop_vl_name_b b)
  {
    return TRUE;
  }

  /* ------------------------------------------------------------ */

  int
  provide_vl_type (VSIDLType_ptr *testvar)
  {
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();
    CORBA::PrimitiveDef_ptr tvar = IR_ptr->get_primitive(CORBA::pk_ulong);
    CORBA::IDLType_ptr tmp = CORBA::PrimitiveDef::_duplicate(tvar);
    *testvar = (VSIDLType_ptr) tmp;
    return TRUE;
  }
  
  int
  relinquish_vl_type (VSIDLType_ptr *testvar)
  {
    return TRUE;
  }

  /* ------------------------------------------------------------ */

  int
  provide_at_id (VSRepositoryId *testvar,
		 enum prop_at_id_a a)
  {
    CORBA::RepositoryId tvar;
    switch (a)  {
    case Pat_id_a_exist:
      tvar = CORBA::string_dup("IDL:M_Container/M_write/TestValueB/name:1.0");
      break;
    case Pat_id_a_non_exist:
      tvar = CORBA::string_dup("IDL:M_Container/M_write/TestValueB/name1:1.0");
      break;
    }
    *testvar = (VSRepositoryId) tvar;
    return TRUE;
  }

  int
  relinquish_at_id (VSRepositoryId *testvar,
		 enum prop_at_id_a a)
  {
    return TRUE;
  }

  /* ------------------------------------------------------------ */

  int
  provide_at_name (VSIdentifier *testvar,
		   enum prop_at_name_b b)
  {
    CORBA::Identifier tvar;
    switch (b)  {
    case Pat_name_b_exist:
      tvar = CORBA::string_dup("name");
      break;
    case Pat_name_b_non_exist:
      tvar = CORBA::string_dup("name1");
      break;
    }
    *testvar = (VSIdentifier) tvar;
    return TRUE;
  }

  int
  relinquish_at_name (VSIdentifier *testvar,
		      enum prop_at_name_b b)
  {
    return TRUE;
  }

  /* ------------------------------------------------------------ */
  int
  provide_at_type (VSIDLType_ptr *testvar)
  {
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();
    CORBA::PrimitiveDef_ptr tvar = IR_ptr->get_primitive(CORBA::pk_octet);
    CORBA::IDLType_ptr tmp = CORBA::PrimitiveDef::_duplicate(tvar);
    *testvar = (VSIDLType_ptr) tmp;
    return TRUE;
  }
  
  int
  relinquish_at_type (VSIDLType_ptr *testvar)
  {
    return TRUE;
  }

  /* ------------------------------------------------------------ */

  int
  provide_at_mode (VSAttributeMode *testvar,
		   enum prop_at_mode_c c)
  {
    CORBA::AttributeMode tvar;
    switch (c)  {
    case Pat_mode_c_normal:
      tvar = CORBA::ATTR_NORMAL;
      break;
    case Pat_mode_c_readonly:
      tvar = CORBA::ATTR_READONLY;
      break;
    }
    CORBA::AttributeMode *tmp = new CORBA::AttributeMode(tvar);
    *testvar = (VSAttributeMode) tmp;
    return TRUE;
  }

  int
  relinquish_at_mode (VSAttributeMode *testvar,
		      enum prop_at_mode_c c)
  {
    return TRUE;
  }

  /* ------------------------------------------------------------ */

  int
  provide_op_mode (VSOperationMode *testvar,
		   enum prop_op_mode_c c)
  {
    CORBA::OperationMode tvar;
    switch (c)  {
    case Pop_mode_c_normal:
      tvar = CORBA::OP_NORMAL;
      break;
    case Pop_mode_c_oneway:
      tvar = CORBA::OP_ONEWAY;
      break;
    }
    CORBA::OperationMode *tmp = new CORBA::OperationMode(tvar);
    *testvar = (VSOperationMode) tmp;
    return TRUE;
  }

  int
  relinquish_op_mode (VSOperationMode *testvar,
		      enum prop_op_mode_c c)
  {
    return TRUE;
  }

  /* ------------------------------------------------------------ */
  int
  provide_op_id (VSRepositoryId *testvar,
		 enum prop_op_id_a a)
  {
    CORBA::RepositoryId tvar;
    switch (a)  {
    case Pop_id_a_exist:
      tvar = CORBA::string_dup("IDL:M_Container/M_write/TestValueB/print:1.0");
      break;
    case Pop_id_a_non_exist:
      tvar = CORBA::string_dup("IDL:M_Container/M_write/TestValueB/print1:1.0");
      break;
    }
    *testvar = (VSRepositoryId) tvar;
    return TRUE;
  }

  int
  relinquish_op_id (VSRepositoryId *testvar,
		 enum prop_op_id_a a)
  {
    return TRUE;
  }

  /* ------------------------------------------------------------ */

  int
  provide_op_name (VSIdentifier *testvar,
		   enum prop_op_name_b b)
  {
    CORBA::Identifier tvar;
    switch (b)  {
    case Pop_name_b_exist:
      tvar = CORBA::string_dup("print");
      break;
    case Pop_name_b_non_exist:
      tvar = CORBA::string_dup("print1");
      break;
    }
    *testvar = (VSIdentifier) tvar;
    return TRUE;
  }

  int
  relinquish_op_name (VSIdentifier *testvar,
		      enum prop_op_name_b b)
  {
    return TRUE;
  }

  /* ------------------------------------------------------------ */
  int
  provide_op_result (VSIDLType_ptr *testvar)
  {
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();
    CORBA::PrimitiveDef_ptr tvar = IR_ptr->get_primitive(CORBA::pk_string);
    CORBA::IDLType_ptr tmp = CORBA::PrimitiveDef::_duplicate(tvar);
    *testvar = (VSIDLType_ptr) tmp;
    return TRUE;
  }
  
  int
  relinquish_op_result (VSIDLType_ptr *testvar)
  {
    return TRUE;
  }

  /* ------------------------------------------------------------ */

  int
  provide_op_params(VSParDescriptionSeq_ptr *testvar)
  {
    CORBA::ParDescriptionSeq s(0);
    CORBA::ParDescriptionSeq *tvar = new CORBA::ParDescriptionSeq(s);
    *testvar = (VSParDescriptionSeq_ptr) tvar;
    return TRUE;
  }

  int
  relinquish_op_params(VSParDescriptionSeq_ptr *testvar)
  {
    return TRUE;
  }
  /* ------------------------------------------------------------ */

  int
  provide_op_exceptions(VSExceptionDefSeq_ptr *testvar)
  {
    CORBA::ExceptionDefSeq s(0);
    CORBA::ExceptionDefSeq *tvar = new CORBA::ExceptionDefSeq(s);
    *testvar = (VSExceptionDefSeq_ptr) tvar;
    return TRUE;
  }

  int
  relinquish_op_exceptions(VSExceptionDefSeq_ptr *testvar)
  {
    return TRUE;
  }
  /* ------------------------------------------------------------ */
  int
  provide_op_contexts(VSContextIdSeq_ptr *testvar)
  {
    CORBA::ContextIdSeq s(0);
    CORBA::ContextIdSeq *tvar = new CORBA::ContextIdSeq(s);
    *testvar = (VSContextIdSeq_ptr) tvar;
    return TRUE;
  }

  int
  relinquish_op_contexts(VSContextIdSeq_ptr *testvar)
  {
    return TRUE;
  }
  /* ------------------------------------------------------------ */

}

