/*
  Copyright (c) 2001                                               
  GMD FOKUS                                                        
  Project: CORVAL2
  
  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
   
  File: tset/c++/api/IR/ValueMemberDef/t1.cpp
  
  Purpose:
  
  Modifications:
  $Log: t1.cpp,v $
  Revision 1.1  2001/01/30 14:02:10  mli
  Initial files.


*/

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

  /*------------------------------------------------------*/
  VSValueMemberDef_ptr
  VSnil(VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueMemberDef_ptr ttc;
    
    try {
      ttc = CORBA::ValueMemberDef::_nil();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSValueMemberDef_ptr) 0;
    }
    return (VSValueMemberDef_ptr) ttc;
  }
  
  /*------------------------------------------------------*/
  VSValueMemberDef_ptr
  VSduplicate(VSValueMemberDef_ptr o1, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueMemberDef_ptr tc = (CORBA::ValueMemberDef_ptr) o1;
    CORBA::ValueMemberDef_ptr ttc;
    
    try {
      ttc = CORBA::ValueMemberDef::_duplicate(tc ? tc : (CORBA::ValueMemberDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSValueMemberDef_ptr) 0;
    }
    return (VSValueMemberDef_ptr) ttc;
  }
  
  /*------------------------------------------------------*/
  VSValueMemberDef_ptr
  VSnarrow(VSObject_ptr o1, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Object_ptr tc = (CORBA::Object_ptr) o1;
    CORBA::ValueMemberDef_ptr ttc;
    try {
      ttc = CORBA::ValueMemberDef::_narrow(tc ? tc : (CORBA::ValueMemberDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSValueMemberDef_ptr) 0;
    }
    return (VSValueMemberDef_ptr) ttc;
  }

  /*------------------------------------------------------*/

  VSTypeCode_ptr
  VStype(VSEnvironment *ev, VSValueMemberDef_ptr c_vmdef) 
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::TypeCode_ptr rptr;
    CORBA::ValueMemberDef_ptr vmdef = (CORBA::ValueMemberDef_ptr) c_vmdef;

    try
      {
	rptr = vmdef->type();
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSTypeCode_ptr) rptr;
  }
  
  /*------------------------------------------------------*/

  VSIDLType_ptr 
  VStype_def_read(VSEnvironment *ev, VSValueMemberDef_ptr c_vmdef)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::IDLType_ptr rptr;
    CORBA::ValueMemberDef_ptr vmdef = (CORBA::ValueMemberDef_ptr) c_vmdef;

    try
      {
	rptr = vmdef->type_def();
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSIDLType_ptr) rptr;
  }

  /*------------------------------------------------------*/

  void 
  VStype_def_write(VSEnvironment *ev, VSValueMemberDef_ptr c_vmdef,
		   VSIDLType_ptr s_itp)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::IDLType_ptr itp = (CORBA::IDLType_ptr) s_itp;
    CORBA::ValueMemberDef_ptr vmdef = (CORBA::ValueMemberDef_ptr) c_vmdef;

    try
      {
	vmdef->type_def(itp);
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return;
  }

  /*------------------------------------------------------*/

  VSVisibility 
  VSaccess_read(VSEnvironment *ev, VSValueMemberDef_ptr c_vmdef)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Visibility rptr;
    CORBA::ValueMemberDef_ptr vmdef = (CORBA::ValueMemberDef_ptr) c_vmdef;

    try
      {
	rptr = vmdef->access();
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSVisibility) rptr;
  }

  /*------------------------------------------------------*/

  void 
  VSaccess_write(VSEnvironment *ev, VSValueMemberDef_ptr c_vmdef,
		 VSVisibility s_as)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Visibility as = (CORBA::Visibility) s_as;
    CORBA::ValueMemberDef_ptr vmdef = (CORBA::ValueMemberDef_ptr) c_vmdef;

    try
      {
	vmdef->access(as);
      }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return;
  }

  /*------------------------------------------------------*/

  VSDefinitionKind VSdef_kind(VSEnvironment *ev, VSValueMemberDef_ptr c_vmdef)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ValueMemberDef_ptr vmdef = (CORBA::ValueMemberDef_ptr) c_vmdef;
    CORBA::DefinitionKind dk;
    try {
      dk = vmdef->def_kind();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSDefinitionKind) dk;
  }

  /*------------------------------------------------------*/

}



