/*
  Copyright (c) 2001                                               
  GMD FOKUS                                                        
  Project: CORVAL2
  
  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
   
  File: tset/c++/api/IR/ValueMemberDef/t1_aux.cpp
  
  Purpose:
  
  Modifications:
  $Log: t1_aux.cpp,v $
  Revision 1.1  2001/01/30 14:02:11  mli
  Initial files.

*/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

  
  /*------------------------------------------------------*/
  int is_nil_object(VSObject_ptr o1)
  {
    CORBA::Object_ptr obj1 = (CORBA::Object_ptr) o1;
    
    if(!obj1)
      return TRUE;
    return CORBA::is_nil(obj1);
  }
  
  /*------------------------------------------------------*/
  
  int
  is_nil_valuememdef_ptr(VSValueMemberDef_ptr o1)
  {
    CORBA::ValueMemberDef_ptr tc = (CORBA::ValueMemberDef_ptr) o1;
    if(!tc)
      return TRUE;
    
    return CORBA::is_nil(tc);
  }


  /*------------------------------------------------------*/
  											 
  int 
  cleanup_valuememdef_ptr(VSValueMemberDef_ptr o1)
  {
    CORBA::ValueMemberDef_ptr tc = (CORBA::ValueMemberDef_ptr) o1;
    if(!CORBA::is_nil(tc))
      return TRUE;
    CORBA::release(tc);
    return TRUE;
  }

  /*------------------------------------------------------*/
  
  int correct_type_def(VSIDLType_ptr vs_itp)
  {
    CORBA::IDLType_ptr itp = (CORBA::IDLType_ptr) vs_itp;
    return (itp->type()->kind() == CORBA::tk_long);    
  }

  /*------------------------------------------------------*/
  
  int correct_type_def_set(VSIDLType_ptr vs_itp, VSValueMemberDef_ptr c_vmdef)
  {
    CORBA::IDLType_ptr itp = (CORBA::IDLType_ptr) vs_itp;
    CORBA::ValueMemberDef_ptr vmdef = (CORBA::ValueMemberDef_ptr) c_vmdef;
    return (itp->type()->kind() == vmdef->type_def()->type()->kind());
  }

  /*------------------------------------------------------*/
  
  int correct_access(VSVisibility vs_as)
  {
    CORBA::Visibility as = (CORBA::Visibility) vs_as;
    return (as == 1); 
  }
  
  /*------------------------------------------------------*/
   
  int correct_access_set(VSVisibility vs_as, VSValueMemberDef_ptr c_vmdef)
  {
    CORBA::ValueMemberDef_ptr vmdef = (CORBA::ValueMemberDef_ptr) c_vmdef;
    CORBA::Visibility as = (CORBA::Visibility) vs_as;
    return (as == vmdef->access());
  }

  /*------------------------------------------------------*/
  
  int
  correct_type(VSTypeCode_ptr vs_tc)
  {
    CORBA::TypeCode_ptr tc = (CORBA::TypeCode_ptr) vs_tc;
    return (tc->kind() == CORBA::tk_long);
  }

  /*------------------------------------------------------*/
  
  int
  is_correct_def_kind(VSDefinitionKind vs_dk)
  {
    CORBA::DefinitionKind dk = (CORBA::DefinitionKind) vs_dk;
    return (dk == CORBA::dk_ValueMember);
  }


  /*------------------------------------------------------*/
}

