/*
  Copyright (c) 2001                                               
  GMD FOKUS                                                        
  Project: CORVAL2
  
  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
   
  File: tset/c++/api/IR/ValueMemberDef/t1i_tdi.cpp
  
  Purpose:
  
  Modifications:
  $Log: t1i_tdi.cpp,v $
  Revision 1.1  2001/01/30 14:02:11  mli
  Initial files.


*/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>


  int
  provide_object_ptr (VSObject_ptr *testvar,
		      enum prop_object_ptr_objValue objValue)
  {
    CORBA::Object_ptr tvar;
    CORBA::Repository_ptr IR_ptr;
    CORBA::Contained_ptr ctnD_ptr;
    
    IRSupport *irs = glob_TS.repository();
    
    switch (objValue)  {
    case Pobject_ptr_objValue_valid:
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestValueB::age");
      tvar = CORBA::Contained::_duplicate(ctnD_ptr);
      break;
    case Pobject_ptr_objValue_null:
      tvar = CORBA::Object::_nil();
      break;
    }
    *testvar = (VSObject_ptr) tvar;
    return TRUE;
  }
  
  int
  relinquish_object_ptr (VSObject_ptr *testvar,
			 enum prop_object_ptr_objValue objValue)
  {
    return TRUE;
  }
  
  
  /* ------------------------------------------------------------ */
  
  int
  provide_c_vmdef (VSValueMemberDef_ptr *testvar)
  {
    CORBA::ValueMemberDef_ptr tvar;
    CORBA::Object_ptr* rptr;
    CORBA::Repository_ptr IR_ptr;
    CORBA::ValueMemberDef_var vmdef;
    CORBA::Contained_ptr ctnD_ptr;
    
    IRSupport *irs = glob_TS.repository();
    
    IR_ptr = irs->get_repository();
    ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestValueB::age");
    vmdef = CORBA::ValueMemberDef::_narrow(ctnD_ptr);
    tvar = CORBA::ValueMemberDef::_duplicate(vmdef);
    
    *testvar = (VSObject_ptr) tvar;
    return TRUE;
  }
  
  int
  relinquish_c_vmdef (VSValueMemberDef_ptr *testvar)
  {
    return TRUE;
  }
  
 /* ------------------------------------------------------------ */
 
  int
  provide_s_type_def (VSIDLType_ptr *testvar)
  {
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();
    CORBA::IDLType_ptr tvar = IR_ptr->get_primitive(CORBA::pk_octet);
    *testvar = (VSObject_ptr) tvar;
    return TRUE;
  }
  
  int
  relinquish_s_type_def (VSIDLType_ptr *testvar)
  {
    IRSupport *irs = glob_TS.repository();
    CORBA::Repository_ptr IR_ptr = irs->get_repository();

    CORBA::Contained_var ctnD_ptr = irs->get_contained(IR_ptr,"M_Container::M_write::TestValueB::age");
    CORBA::ValueMemberDef_var vmdef = CORBA::ValueMemberDef::_narrow(ctnD_ptr);
    CORBA::IDLType_var itp = IR_ptr->get_primitive(CORBA::pk_long);
    vmdef->type_def(itp);
    vmdef->access(1);
    return TRUE;
  }
  
 /* ------------------------------------------------------------ */
 
}
