/*
  Copyright (c) 2001                                               
  GMD FOKUS                                                        
  Project: CORVAL2
  
  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
   
  File: tset/c++/api/IR/WstringDef/t1.cpp
  
  Purpose:
  
  Modifications:
  $Log: t1.cpp,v $
  Revision 1.1  2001/01/29 11:00:54  mli
  Initial files.

*/

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/

VSULong
VSbound_read(VSEnvironment *ev)
{
  CORBA::Environment *env = (CORBA::Environment *) ev;
  CORBA::Repository_ptr IR_ptr;
  CORBA::Contained_ptr    ctnD_ptr;
  CORBA::WstringDef_ptr strDef_ptr;
  CORBA::ULong strDef_bound;
  IRSupport *irs = glob_TS.repository();
  
  try {
    IR_ptr = irs->get_repository();
    ctnD_ptr = irs->get_contained(IR_ptr,"M_WstringDef::I1::WS1");
    CORBA::AttributeDef_ptr attDef_ptr = CORBA::AttributeDef::_narrow(ctnD_ptr);
    CORBA::IDLType_ptr idlobj_ptr = attDef_ptr->type_def();
    strDef_ptr = CORBA::WstringDef::_narrow(idlobj_ptr);
    if(strDef_ptr == NULL) throw 0;
    strDef_bound = strDef_ptr->bound();
  }
  catch (CORBA::Exception &ex) {
    CORBA::Exception *t = exception_convert(&ex);
    if(env)
      env->exception(t);
  }
  catch (...) {
    return (VSULong) 0;
  }
  return (VSULong) strDef_bound;
}
  
  /*------------------------------------------------------*/
  VSWstringDef_ptr*
  VSnil(VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::WstringDef_ptr ttc;
    
    try {
      ttc = CORBA::WstringDef::_nil();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSWstringDef_ptr *) 0;
    }
    CORBA::WstringDef_ptr *rtc = new CORBA::WstringDef_ptr(ttc);
    return (VSWstringDef_ptr *) rtc;
  }
  
  /*------------------------------------------------------*/
  VSWstringDef_ptr*
  VSduplicate(VSWstringDef_ptr *o1, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::WstringDef_ptr *tc = (CORBA::WstringDef_ptr *) o1;
    CORBA::WstringDef_ptr ttc;
    
    try {
      ttc = CORBA::WstringDef::_duplicate(tc ? *tc : (CORBA::WstringDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSWstringDef_ptr *) 0;
    }
    
    CORBA::WstringDef_ptr *rtc = new CORBA::WstringDef_ptr(ttc);
    return (VSWstringDef_ptr *) rtc;
  }
  
  /*------------------------------------------------------*/
  VSWstringDef_ptr*
  VSnarrow(VSObject_ptr *o1, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;
    CORBA::WstringDef_ptr ttc;
    try {
      ttc = CORBA::WstringDef::_narrow(tc ? *tc : (CORBA::WstringDef_ptr) 0);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return (VSWstringDef_ptr *) 0;
    }
    
    
    CORBA::WstringDef_ptr *rtc = new CORBA::WstringDef_ptr(ttc);
    return (VSWstringDef_ptr *) rtc;
  }
  /*------------------------------------------------------*/
  /* WRITE INTERFACE */
  /*------------------------------------------------------*/
  
  void
  VSbound_write(VSULong vs_new_bound, VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ULong new_bound = (CORBA::ULong) vs_new_bound;
    CORBA::Repository_ptr IR_ptr;
    CORBA::Contained_ptr    ctnD_ptr;
    CORBA::WstringDef_ptr strDef_ptr;
    IRSupport *irs = glob_TS.repository();
    
    try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_WstringDef::I1::WS1");
      CORBA::AttributeDef_ptr attDef_ptr = CORBA::AttributeDef::_narrow(ctnD_ptr);
      CORBA::IDLType_ptr idlobj_ptr = attDef_ptr->type_def();
      strDef_ptr = CORBA::WstringDef::_narrow(idlobj_ptr);
      if(strDef_ptr == NULL) throw 0;
      strDef_ptr->bound(new_bound);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    catch (...) {
      return;
    }
  }
  
  /*------------------------------------------------------*/
  /* redefined functions */
  /*------------------------------------------------------*/
  VSDefinitionKind VSdef_kind(VSEnvironment *ev)
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Repository_ptr IR_ptr;
    CORBA::Contained_ptr    ctnD_ptr;
    CORBA::DefinitionKind dk;
    CORBA::WstringDef_ptr 	stringDef_ptr;
    IRSupport *irs = glob_TS.repository();
    
    try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_WstringDef::I1::WS1");
      CORBA::AttributeDef_ptr attDef_ptr = CORBA::AttributeDef::_narrow(ctnD_ptr);
      CORBA::IDLType_ptr idlobj_ptr = attDef_ptr->type_def();
      stringDef_ptr = CORBA::WstringDef::_narrow(idlobj_ptr);
      dk = stringDef_ptr->def_kind();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    return (VSDefinitionKind) dk;
  }
  /*------------------------------------------------------*/
  VSTypeCode_ptr*
  VStype(VSEnvironment *ev) 
  {
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::TypeCode_ptr retType_ptr;
    
    CORBA::Repository_ptr IR_ptr;
    CORBA::Contained_ptr    ctnD_ptr;
    CORBA::WstringDef_ptr 	strDef_ptr;
    IRSupport *irs = glob_TS.repository();
    
    try {
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_WstringDef::I1::WS1");
      CORBA::AttributeDef_ptr attDef_ptr = CORBA::AttributeDef::_narrow(ctnD_ptr);
      CORBA::IDLType_ptr idlobj_ptr = attDef_ptr->type_def();
      strDef_ptr = CORBA::WstringDef::_narrow(idlobj_ptr);
      retType_ptr = strDef_ptr->type();
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
    }
    CORBA::TypeCode_ptr* rptr = new CORBA::TypeCode_ptr (retType_ptr);
    return (VSTypeCode_ptr *) rptr;
  }
  /*------------------------------------------------------*/
  
}



