/*
  Copyright (c) 2001                                               
  GMD FOKUS                                                        
  Project: CORVAL2
  
  All rights reserved. No part of this source code may be reproduced,
  stored in a retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording or otherwise,
  except as stated in the end-user licence agreement, without the prior
  permission of the copyright owners.
   
  File: tset/c++/api/IR/WstringDef/t1i_tdi.cpp
  
  Purpose:
  
  Modifications:
  $Log: t1i_tdi.cpp,v $
  Revision 1.1  2001/01/29 11:00:55  mli
  Initial files.

*/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>


int
provide_object_ptr (VSObject_ptr **testvar,
		    enum prop_object_ptr_objValue objValue)
{
  CORBA::Object_ptr tvar;
  CORBA::Object_ptr* rptr;
  CORBA::Repository_ptr IR_ptr;
  CORBA::AttributeDef_ptr attDef_ptr;
  CORBA::IDLType_ptr idlobj_ptr;
  CORBA::Contained_ptr ctnD_ptr;
  IRSupport *irs = glob_TS.repository();
  
  switch (objValue)  {
  case Pobject_ptr_objValue_valid:
    IR_ptr = irs->get_repository();
    ctnD_ptr = irs->get_contained(IR_ptr,"M_WstringDef::I1::WS1");
    attDef_ptr = CORBA::AttributeDef::_narrow(ctnD_ptr);
    idlobj_ptr = attDef_ptr->type_def();
    tvar = idlobj_ptr;
    break;
  case Pobject_ptr_objValue_null:
    tvar = NULL;
    break;
  }
  rptr = new CORBA::Object_ptr(tvar);
  *testvar = (VSObject_ptr *) rptr;
  return TRUE;
}
  
  int
  relinquish_object_ptr (VSObject_ptr **testvar,
			 enum prop_object_ptr_objValue objValue)
  {
    CORBA::Object_ptr* tvar = (CORBA::Object_ptr *) *testvar;
    
    switch (objValue)  {
    case Pobject_ptr_objValue_valid:
      delete tvar;
      break;
    case Pobject_ptr_objValue_null:
      break;
    }
    return TRUE;
  }
  
  /* ------------------------------------------------------------ */
  /* wstringdef_ptr is provided for the VSduplicate() test */
  int
  provide_wstringdef_ptr (VSWstringDef_ptr **testvar,
			 enum prop_wstringdef_ptr_wstringValue wstringValue)
  {
    CORBA::WstringDef_ptr tvar;
    CORBA::WstringDef_ptr* rptr;
    CORBA::Repository_ptr  IR_ptr;
    CORBA::Contained_ptr ctnD_ptr;
    CORBA::AttributeDef_ptr attDef_ptr;
    CORBA::IDLType_ptr idlobj_ptr;
    IRSupport *irs = glob_TS.repository();
    
    switch (wstringValue)  {
    case Pwstringdef_ptr_wstringValue_valid:
      IR_ptr = irs->get_repository();
      ctnD_ptr = irs->get_contained(IR_ptr,"M_WstringDef::I1::WS1");
      attDef_ptr = CORBA::AttributeDef::_narrow(ctnD_ptr);
      idlobj_ptr = attDef_ptr->type_def();
      tvar = CORBA::WstringDef::_narrow(idlobj_ptr);
      break;
    case Pwstringdef_ptr_wstringValue_null:
      tvar = NULL;
      break;
    }
    rptr = new CORBA::WstringDef_ptr(tvar);
    *testvar = (VSWstringDef_ptr *) rptr;
    return TRUE;
  }
  
  int
  relinquish_wstringdef_ptr (VSWstringDef_ptr **testvar,
			    enum prop_wstringdef_ptr_wstringValue wstringValue)
  {
    CORBA::WstringDef_ptr* tvar = (CORBA::WstringDef_ptr *) *testvar;
    switch (wstringValue)  {
    case Pwstringdef_ptr_wstringValue_valid:
      delete tvar;
    case Pwstringdef_ptr_wstringValue_null:
      break;
    }
    return TRUE;
  }
  
  
  /* ------------------------------------------------------------ */
  
}
