/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/***************************************************/
/* POA attributes                                  */
/***************************************************/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

//-----------------------------------------------------------
// ......

  int is_return_POAName(VSString str)
  {    
    if (strcmp(str, "testPOA") == 0)
      return TRUE;
    else
      return FALSE;
  }
  
  int is_return_theParentPOA(VSPOA_ptr *p_poa)
  {
    PortableServer::POA_ptr *poa = (PortableServer::POA_ptr *) p_poa;
  
    if (poa == 0)
      return FALSE;
    else
      return TRUE;   
  }

  int is_return_POAMgr(VSPOAManager_ptr *p_poaMgr)
  {
    PortableServer::POAManager_ptr *poaMgr = (PortableServer::POAManager_ptr *) p_poaMgr;

    if(poaMgr == 0)
      return FALSE;
    else
      return TRUE;
  }

  int is_return_childrenPOAs(VSPOAList* p_POAList)
  {
    PortableServer::POAList* children_POAlist = (PortableServer::POAList *) p_POAList;

    if(children_POAlist)
      {    
	int poa_count;
	char* childPOA_name;
	for (poa_count=0; poa_count<children_POAlist->length(); poa_count++) {
	  PortableServer::POA_ptr theChild_POA;
	
	  try {
	    theChild_POA = (*children_POAlist)[poa_count];
	    childPOA_name = (theChild_POA)->the_name();	
	  }
	  catch (CORBA::Exception &ex) {
	    return FALSE;
	  }
	  if(strcmp(childPOA_name, "childPOA") == 0) 
	    return TRUE;	 
	} 
  
	return FALSE; 
      }
  } 
  

  int is_correct_activator_write(VSPOA_ptr *p_poa)
  {
    PortableServer::POA_ptr *poa = (PortableServer::POA_ptr *) p_poa;
    PortableServer::AdapterActivator_ptr activator = (*poa)->the_activator(); 
    
    if (activator)
      return TRUE;
    else
      return FALSE;
  }

  int is_return_activator(VSAdapterActivator_ptr *p_activator)
  {
    PortableServer::AdapterActivator_ptr *activator = (PortableServer::AdapterActivator_ptr *) p_activator; 

    if (activator)
      return TRUE;
    else
      return FALSE;
  }  
 
}
