/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/***************************************************/
/* POA attributes                                  */
/***************************************************/


#include <corba_supp.hh>
#include <tserver.hh>
#include <POAtest_impl.h>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

/*-----------------------------------------------------------*/
/* test variable VSPOA_ptr * testPOA(prop value) */

  int provide_testPOA (void*** testvar, enum prop_testPOA_value value)
  {
    PortableServer::POA_ptr *tvar;

    PortableServer::POA_ptr rootPOA;
    PortableServer::POAManager_ptr poa_mgr;
    try {
      CORBA::ORB_ptr orb = glob_TS.m_corb->orb();
      CORBA::Object_ptr o = orb->resolve_initial_references("RootPOA");
      rootPOA = PortableServer::POA::_narrow(o);
      poa_mgr = rootPOA->the_POAManager();
    }
    catch (...) {
      return FALSE;
    }

    switch (value) {
    case PtestPOA_value_valid:
      {
	try {
	  CORBA::PolicyList polList;	  
	  PortableServer::POA_ptr test_POA = rootPOA->create_POA("testPOA", poa_mgr, polList); 
	  tvar = new PortableServer::POA_ptr(test_POA);
	}
	catch (...) {
	  return FALSE;
	}      
	break;
      }
    }
    
    *testvar = (VSPOA_ptr *) tvar;  
    return TRUE;
  }

  int relinquish_testPOA (void*** testvar, enum prop_testPOA_value value)
  {
    PortableServer::POA_ptr *tvar = (PortableServer::POA_ptr *) *testvar;
    switch (value) {
    case PtestPOA_value_valid:
      (*tvar)->destroy(TRUE, TRUE);
      break;
    }
    return TRUE;
  }


  /*-----------------------------------------------------------*/
  /* test variable VSPOA_ptr * readActPOA(prop value) */
  int provide_readActPOA (VSPOA_ptr **testvar, enum prop_readActPOA_value value)
  {
    PortableServer::POA_ptr *tvar;
    
    PortableServer::POA_ptr rootPOA;
    PortableServer::POAManager_ptr poa_mgr;
  
    try {
      CORBA::ORB_ptr orb = glob_TS.m_corb->orb();
      CORBA::Object_ptr o = orb->resolve_initial_references("RootPOA");
      rootPOA = PortableServer::POA::_narrow(o);
      poa_mgr = rootPOA->the_POAManager();
    }
    catch (...) {
      return FALSE;
    }  

    switch (value) {
    case PreadActPOA_value_valid:
      {
	try {
	  CORBA::PolicyList polList;
	  PortableServer::POA_ptr adpActPOA = rootPOA->create_POA("actPOA", poa_mgr, polList);  
	   
	  adpActivator* adapter_actSvt = new adpActivator;
	  PortableServer::AdapterActivator_ptr adapter_act = adapter_actSvt->_this();
	  
	  adpActPOA->the_activator(adapter_act);
	  tvar = new PortableServer::POA_ptr(adpActPOA);
	}
	catch (...) {
	  return FALSE;
	}
      }   
    }
    
    *testvar = (VSPOA_ptr *) tvar;  
    return TRUE;
  }

  int relinquish_readActPOA (VSPOA_ptr **testvar, enum prop_readActPOA_value value)
  {
    PortableServer::POA_ptr *tvar = (PortableServer::POA_ptr *) *testvar;
    switch (value) {
    case PreadActPOA_value_valid:
      (*tvar)->destroy(TRUE, TRUE);
      break;
    }
  }

}


