/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/


/********************************************************/
/* Operations for the USE_DEFAULT_SERVANT policy        */
/********************************************************/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {
#include <t1.h>
#include <t1_aux.h>
#include <t1i_tdi.h>

  /*------------------------------------------------------------------*/
  /* set_servan(..) */

  void *VSset_servant(VSServant *p_svt, VSPOA_ptr *p_poa, VSEnvironment *ev)
  {
    PortableServer::Servant *svt = (PortableServer::Servant *) p_svt;
    PortableServer::POA_ptr *poa = (PortableServer::POA_ptr *) p_poa;    
    CORBA::Environment *env = (CORBA::Environment *) ev;

    try {
      (*poa)->set_servant(*svt);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);      
    }

  }


  /*------------------------------------------------------------------*/
  /* get_servan(..) */

  VSServant *VSget_servant(VSPOA_ptr *p_poa, VSEnvironment *ev) 
  {
    PortableServer::POA_ptr *poa = (PortableServer::POA_ptr *) p_poa;    
    CORBA::Environment *env = (CORBA::Environment *) ev;

    PortableServer::Servant svt;
    try {
      svt = (*poa)->get_servant();
    }     
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
      return (VSServant *) 0;
    }

    PortableServer::Servant *rsvt = new PortableServer::Servant(svt);
    return (VSServant *) rsvt;
  }
}

     
    
