/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/


/********************************************************/
/* Operations for the USE_DEFAULT_SERVANT policy        */
/********************************************************/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

  //-----------------------------------------------------------
  // ......

  int poa_with_pol(VSPOA_ptr *p_poa, VSString str)
  {
    PortableServer::POA_ptr *poa = (PortableServer::POA_ptr *) p_poa;

    if (poa == 0)
      return FALSE;
    
    char *poa_name = (*poa)->the_name();
  
    if(strcmp(poa_name, str) == 0)
      return TRUE;
    else
      return FALSE;
  }

  int poa_with_defaultSvt(VSPOA_ptr *p_poa)
  {
    PortableServer::POA_ptr *poa = (PortableServer::POA_ptr *) p_poa;

    PortableServer::Servant svt;
    try {
      svt = (*poa)->get_servant();
    }     
    catch (...) {     
      return FALSE;
    }

    return (svt ? TRUE : FALSE);
  }


  int is_return_defaultSvt(VSServant *p_svt)
  {
    PortableServer::Servant *svt = ( PortableServer::Servant *) p_svt;
    
    if (svt)
      return TRUE;
    else
      return FALSE;
  }
}
