/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/**************************************************/
/* Identity mapping operations                    */
/**************************************************/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

//-----------------------------------------------------------
// ......

int is_return_oid(VSObjectId_var *oid)
{
  PortableServer::ObjectId_var *objId = (PortableServer::ObjectId_var *) oid;
      
  if (objId)
    return TRUE;
  else
    return FALSE;
}

int is_return_object(VSObject_ptr *p_obj)
{
  CORBA::Object_ptr *obj = (CORBA::Object_ptr *) p_obj;

  if (obj)
    return TRUE;
  else
    return FALSE;
}


int is_oid_str(VSObjectId_var *oid, VSString str)
{
  PortableServer::ObjectId_var *objId = (PortableServer::ObjectId_var *) oid;

  char *oid_str = PortableServer::ObjectId_to_string(*objId);

  if (strcmp(oid_str, str) == 0)
    return TRUE;
  else
    return FALSE;
}

int poa_with_policy(VSPOA_ptr *p_poa, VSString str)
{
  PortableServer::POA_ptr *poa = (PortableServer::POA_ptr *) p_poa;

  char *poa_name = (*poa)->the_name();

  if(strcmp(poa_name, str) == 0)
    return TRUE;
  else
    return FALSE;
}

int objRef_created_bythePOA(VSString obj_str, VSString str)
{
  if (strcmp(obj_str, str) == 0)
    return TRUE;
  else 
    return FALSE;
}

}
