/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/**************************************************/
/* Identity mapping operations                    */
/**************************************************/

#include <corba_supp.hh>
#include <tserver.hh>
#include <POAtest_impl.h>

extern "C" {
#include <t1.h>
#include <t1_aux.h>
#include <t1i_tdi.h>

  /*------------------------------------------------------------------*/
  /* reference_to_servant(..) */

  VSServant *VSreference_to_servant(VSString p_objStr, VSPOA_ptr *thePOA, VSEnvironment *ev)
  {    
    char *objStr = (char *) p_objStr;
    PortableServer::POA_ptr *test_poa = (PortableServer::POA_ptr *) thePOA; 
    CORBA::Environment *env = (CORBA::Environment *) ev;
    
    PortableServer::POA_ptr rootPOA;
    try {
      CORBA::ORB_ptr orb = glob_TS.m_corb->orb();
      CORBA::Object_ptr o = orb->resolve_initial_references("RootPOA");
      rootPOA = PortableServer::POA::_narrow(o);     
    }
    catch (...) {
      return (VSServant *) 0;
    }  
   
    char *poa_name;   
    try {
      poa_name = (*test_poa)->the_name();
    }
    catch (...) {
      return (VSServant *) 0;
    } 

    CORBA::Object_ptr obj;
    PortableServer::Servant svt; 
    PortableServer::Servant test_svt = new I_impl::I_impl(1);

    if(strcmp(poa_name, "poaRetain") == 0)
      {	
	if (strcmp(objStr, "inAOM") == 0)
	  {
	    try {
	     PortableServer::ObjectId_var oid = (*test_poa)->activate_object(test_svt);
	     obj = (*test_poa)->id_to_reference(oid);
	    }
	    catch (...) {
	      return (VSServant *) 0;	
	    }
	  }
	if (strcmp(objStr, "notinAOM") == 0)
	  {	    
	    try {
	      obj = (*test_poa)->create_reference("M_POAtest::I");
	    }
	    catch (...) {
	      return (VSServant*) 0;	
	    }
	  }
	if (strcmp(objStr, "inotherPOA") == 0)
	  {
	    try {
	      obj = rootPOA->create_reference("M_POAtest::I");
	    }
	    catch (...) {
	      return (VSServant *) 0;	
	    }
	  }
      } 

    if (strcmp(poa_name, "poaDefaultSvt") == 0)	
      {	
	(*test_poa)->set_servant(test_svt);
	test_svt->_remove_ref();

	if (strcmp(objStr, "inOtherPOA") == 0)
	  {
	    try {	  
	      obj = rootPOA->create_reference("M_POAtest::I");
	    }
	    catch (...) {
	      return (VSServant *) 0;	
	    }
	  }
	else {
	  try {	   
	    obj = (*test_poa)->create_reference("M_POAtest::I");	    
	  }
	  catch (...) {
	    return (VSServant*) 0;	
	  }
	}
      }

    if(strcmp(poa_name, "poaSvtMgr") == 0)
      {
	if (strcmp(objStr, "inOtherPOA") == 0)
	  {
	    try {
	      obj = rootPOA->create_reference("M_POAtest::I");
	    }
	    catch (...) {
	      return (VSServant *) 0;	
	    }
	  }
	else {
	 try {
	   obj = (*test_poa)->create_reference("M_POAtest::I");
	 }
	 catch (...) {
	   return (VSServant *) 0;	
	 }
	}
      }
         
    try {
      svt = (*test_poa)->reference_to_servant(obj);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
      return (VSServant *) 0;
    }
    
    // return (VSServant) svt;
    PortableServer::Servant *rsvt = new PortableServer::Servant(svt);
    return (VSServant *) rsvt;
  }  


  /*------------------------------------------------------------------*/
  /* servant_to_reference(..) */

  VSObject_ptr* VSservant_to_reference(VSULong p_svt, VSPOA_ptr *thePOA, VSEnvironment *ev)
  {
    CORBA::ULong svt = p_svt;
    PortableServer::POA_ptr *test_poa = (PortableServer::POA_ptr *) thePOA; 
    CORBA::Environment *env = (CORBA::Environment *) ev;

    char *poa_name;   
    try {
      poa_name = (*test_poa)->the_name();
    }
    catch (...) {
      return (VSObject_ptr *) 0;
    }

   
    PortableServer::Servant test_svt = new I_impl::I_impl(1);
    
    if (svt==1)
      {    
	if (strcmp(poa_name, "poaUniqueId") == 0) 
	  {
	    try {	     
	      PortableServer::ObjectId_var oid = (*test_poa)->activate_object(test_svt); 	    }
	    catch (...) {
	      return (VSObject_ptr *) 0;
	    }	 	
	  }	
	if (strcmp(poa_name, "poaMultId") == 0)
	  { 
	    try {	      
	     PortableServer::ObjectId_var oid = (*test_poa)->activate_object(test_svt); 
	    }
	    catch (...) {
	      return (VSObject_ptr *) 0;
	    }
	  }
	if (strcmp(poa_name, "poaImplicit") == 0)
	  { 
	    try {	      
	      PortableServer::ObjectId_var oid = (*test_poa)->activate_object(test_svt); 
	    }
	    catch (...) {
	      return (VSObject_ptr *) 0;
	    }
	  }
      }

    if (strcmp(poa_name, "poaDefaultSvt") == 0)	
      {	
	
	try {
	  (*test_poa)->set_servant(test_svt);	 
	  test_svt->_remove_ref();
	}
	catch (...) {
	  return (VSObject_ptr *) 0;	
	}
      }

    CORBA::Object_ptr obj;
    try {
      obj = (*test_poa)->servant_to_reference(test_svt);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
      return (VSObject_ptr *) 0;
    }

    CORBA::Object_ptr *robj = new CORBA::Object_ptr(obj);
    return (VSObject_ptr *) robj;
  }
}
