/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/**************************************************/
/* Identity mapping operations                    */
/**************************************************/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

//-----------------------------------------------------------
// ......


int is_return_obj(VSObject_ptr *p_obj)
{
  PortableServer::ObjectId_var *obj = (PortableServer::ObjectId_var *) p_obj;
      
   if (obj)
     return TRUE;
   else
     return FALSE;
}

int is_return_servant(VSServant *p_svt)
{
 PortableServer::Servant *svt = ( PortableServer::Servant *) p_svt;

  if (svt)
    return TRUE;
  else
    return FALSE;
}

int poa_with_pol(VSPOA_ptr *p_poa, VSString str)
{
  PortableServer::POA_ptr *poa = (PortableServer::POA_ptr *) p_poa;

  if (poa == 0)
    return FALSE;

  char *poa_name = (*poa)->the_name();

  if(strcmp(poa_name, str) == 0)
    return TRUE;
  else
    return FALSE;
}

int objRef_created_bythePOA(VSString objStr, VSString str)
{
  if (strcmp(objStr, str) == 0)
    return TRUE;
  else
    return FALSE;
} 

int is_svt_inAOM(VSULong p_svt)
{
  CORBA::ULong svt = (CORBA::ULong) p_svt;
  if(svt == 1)
    return TRUE;
  else
    return FALSE;
}

}
