/* ADL test driver from t1.tdr
 *
 * test VSid_to_servant(oid, idTosvt_POA, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop value */
static struct ADL__propertyValue ADL__prop_values_202[] = {
    {"inAOM", Poid_value_inAOM, 0},
    {"notinAOM", Poid_value_notinAOM, 0},
    {0, 0, 0}
};

/* values for prop value */
static struct ADL__propertyValue ADL__prop_values_203[] = {
    {"poaRetain", PidTosvt_POA_value_poaRetain, 0},
    {"poaDefaultSvt", PidTosvt_POA_value_poaDefaultSvt, 0},
    {"poaSvtMgr", PidTosvt_POA_value_poaSvtMgr, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_204[] = {
    {"value", "prop", ADL__prop_values_202, 2},
    {"value", "prop", ADL__prop_values_203, 3},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_208[4] = {
    {"oid", "VSObjectId_var *", ADL__prop_info_204, 0, 1},
    {"idTosvt_POA", "VSPOA_ptr *", ADL__prop_info_204, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_204, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSid_to_servant_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSOBJECTID_VAR_P
#define ADL__PRINT_VSOBJECTID_VAR_P
void (*ADL__print_VSObjectId_var_P)(VSObjectId_var*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECTID_VAR_P */
#ifndef ADL__PRINT_VSPOA_PTR_P
#define ADL__PRINT_VSPOA_PTR_P
void (*ADL__print_VSPOA_ptr_P)(VSPOA_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOA_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSSERVANT_P
#define ADL__PRINT_VSSERVANT_P
void (*ADL__print_VSServant_P)(VSServant*, emitter_t) = 0;

#endif /* ADL__PRINT_VSSERVANT_P */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */

void ADL__emit_VSObjectId_var_P (void* val, emitter_t emitter)
{
  VSObjectId_var *tmp;

  if (ADL__print_VSObjectId_var_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObjectId_var_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSPOA_ptr_P (void* val, emitter_t emitter)
{
  VSPOA_ptr *tmp;

  if (ADL__print_VSPOA_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPOA_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSServant_P (void* val, emitter_t emitter)
{
  VSServant *tmp;

  if (ADL__print_VSServant_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSServant_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2, 3};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSObjectId_var *oid_205;
    VSPOA_ptr *idTosvt_POA_206;
    VSEnvironment *env_207;
    VSServant *fut_return_201;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSid_to_servant_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSid_to_servant_InfoArrayIdx,
        ADL__VSid_to_servant_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_oid(&oid_205, ADL__prop_values_202[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSObjectId_var_P(&oid_205, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_idTosvt_POA(&idTosvt_POA_206, ADL__prop_values_203[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSPOA_ptr_P(&idTosvt_POA_206, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_207)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_207, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSid_to_servant_assertionReport = rf->assertionReport;
       fut_return_201 = ADL__ACF_VSid_to_servant(oid_205, idTosvt_POA_206, env_207);
       test_value = ADL__VSid_to_servant_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_207);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_idTosvt_POA(&idTosvt_POA_206, ADL__prop_values_203[tvec[1]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_oid(&oid_205, ADL__prop_values_202[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_208,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSid_to_servant_head);

    return 0;
}


struct ADL__Directive_info VSid_to_servant1_info = {
    N_VARS,
    ADL__var_info_208
};

struct ADL__TDD_info ADL__test_info = {
    6,
    &ADL__VSid_to_servant_InfoArrayIdx,
    ADL__VSid_to_servant_InfoArray,
    ADL__test_driver,
    "VSid_to_servant",
    "VSid_to_servant1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSid_to_servant1",
    "t1_tr.rif",
    &VSid_to_servant1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

