/* ADL test driver from t1.tdr
 *
 * test VSservant_to_id(svt, svtToid_POA, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop value */
static struct ADL__propertyValue ADL__prop_values_210[] = {
    {"poaUniqueId", PsvtToid_POA_value_poaUniqueId, 0},
    {"poaMultId", PsvtToid_POA_value_poaMultId, 0},
    {"poaImplicit", PsvtToid_POA_value_poaImplicit, 0},
    {"poaDefaultSvt", PsvtToid_POA_value_poaDefaultSvt, 0},
    {"poaOther", PsvtToid_POA_value_poaOther, 0},
    {0, 0, 0}
};

/* values for literal variable svt */
static VSULong ADL__litvar_val_212[] = {
    1,
    0,
};

static struct ADL__propertyValue ADL__litvar_info_211[] = {
    {"1", 0, ADL__litvar_val_212},
    {"0", 1, ADL__litvar_val_212},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_213[] = {
    {"svt", "litvar", ADL__litvar_info_211, 2},
    {"value", "prop", ADL__prop_values_210, 5},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_217[4] = {
    {"svt", "VSULong", ADL__prop_info_213, 0, 1},
    {"svtToid_POA", "VSPOA_ptr *", ADL__prop_info_213, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_213, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSservant_to_id_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSOBJECTID_VAR_P
#define ADL__PRINT_VSOBJECTID_VAR_P
void (*ADL__print_VSObjectId_var_P)(VSObjectId_var*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECTID_VAR_P */
#ifndef ADL__PRINT_VSPOA_PTR_P
#define ADL__PRINT_VSPOA_PTR_P
void (*ADL__print_VSPOA_ptr_P)(VSPOA_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOA_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSSERVANT_P
#define ADL__PRINT_VSSERVANT_P
void (*ADL__print_VSServant_P)(VSServant*, emitter_t) = 0;

#endif /* ADL__PRINT_VSSERVANT_P */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */

void ADL__emit_VSObjectId_var_P (void* val, emitter_t emitter)
{
  VSObjectId_var *tmp;

  if (ADL__print_VSObjectId_var_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObjectId_var_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSPOA_ptr_P (void* val, emitter_t emitter)
{
  VSPOA_ptr *tmp;

  if (ADL__print_VSPOA_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPOA_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSServant_P (void* val, emitter_t emitter)
{
  VSServant *tmp;

  if (ADL__print_VSServant_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSServant_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2, 5};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSULong svt_214;
    VSPOA_ptr *svtToid_POA_215;
    VSEnvironment *env_216;
    VSObjectId_var *fut_return_209;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSservant_to_id_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSservant_to_id_InfoArrayIdx,
        ADL__VSservant_to_id_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       svt_214 = ADL__litvar_val_212[tvec[0]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 0, tvec + 0, 1);
       ADL__emit_VSULong(&svt_214, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_svtToid_POA(&svtToid_POA_215, ADL__prop_values_210[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSPOA_ptr_P(&svtToid_POA_215, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_216)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_216, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSservant_to_id_assertionReport = rf->assertionReport;
       fut_return_209 = ADL__ACF_VSservant_to_id(svt_214, svtToid_POA_215, env_216);
       test_value = ADL__VSservant_to_id_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_216);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_svtToid_POA(&svtToid_POA_215, ADL__prop_values_210[tvec[1]].propValCode);
SKIP_1:
       relvec[0] = 1;	/* relinquish succeeds for svt_214 */
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_217,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSservant_to_id_head);

    return 0;
}


struct ADL__Directive_info VSservant_to_id1_info = {
    N_VARS,
    ADL__var_info_217
};

struct ADL__TDD_info ADL__test_info = {
    10,
    &ADL__VSservant_to_id_InfoArrayIdx,
    ADL__VSservant_to_id_InfoArray,
    ADL__test_driver,
    "VSservant_to_id",
    "VSservant_to_id1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSservant_to_id1",
    "t1_tr.rif",
    &VSservant_to_id1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

