/* ADL test driver from t1.tdr
 *
 * test VSactivate_object_with_id(p_svt, oid, testpoa_id, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop value */
static struct ADL__propertyValue ADL__prop_values_269[] = {
    {"valid", Pp_svt_value_valid, 0},
    {0, 0, 0}
};

/* values for prop value */
static struct ADL__propertyValue ADL__prop_values_270[] = {
    {"new", Poid_value_new, 0},
    {"active", Poid_value_active, 0},
    {0, 0, 0}
};

/* values for prop value */
static struct ADL__propertyValue ADL__prop_values_271[] = {
    {"poa_Retain", Ptestpoa_id_value_poa_Retain, 0},
    {"poa_nonRetain", Ptestpoa_id_value_poa_nonRetain, 0},
    {"poa_SysId", Ptestpoa_id_value_poa_SysId, 0},
    {"poa_UniqueId", Ptestpoa_id_value_poa_UniqueId, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_272[] = {
    {"value", "prop", ADL__prop_values_269, 1},
    {"value", "prop", ADL__prop_values_270, 2},
    {"value", "prop", ADL__prop_values_271, 4},
    {0, 0, 0}
};
#define TVEC_SIZE 3

static struct ADL__variableInfo ADL__var_info_277[5] = {
    {"p_svt", "VSServant *", ADL__prop_info_272, 0, 1},
    {"oid", "VSObjectId_var *", ADL__prop_info_272, 1, 1},
    {"testpoa_id", "VSPOA_ptr *", ADL__prop_info_272, 2, 1},
    {"env", "VSEnvironment *", ADL__prop_info_272, 3, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 4


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSactivate_object_with_id_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSSERVANT_P
#define ADL__PRINT_VSSERVANT_P
void (*ADL__print_VSServant_P)(VSServant*, emitter_t) = 0;

#endif /* ADL__PRINT_VSSERVANT_P */
#ifndef ADL__PRINT_VSPOA_PTR_P
#define ADL__PRINT_VSPOA_PTR_P
void (*ADL__print_VSPOA_ptr_P)(VSPOA_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOA_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSOBJECTID_VAR_P
#define ADL__PRINT_VSOBJECTID_VAR_P
void (*ADL__print_VSObjectId_var_P)(VSObjectId_var*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECTID_VAR_P */

void ADL__emit_VSServant_P (void* val, emitter_t emitter)
{
  VSServant *tmp;

  if (ADL__print_VSServant_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSServant_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSPOA_ptr_P (void* val, emitter_t emitter)
{
  VSPOA_ptr *tmp;

  if (ADL__print_VSPOA_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPOA_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObjectId_var_P (void* val, emitter_t emitter)
{
  VSObjectId_var *tmp;

  if (ADL__print_VSObjectId_var_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObjectId_var_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {1, 2, 4};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSServant *p_svt_273;
    VSObjectId_var *oid_274;
    VSPOA_ptr *testpoa_id_275;
    VSEnvironment *env_276;
    VSBoolean fut_return_268;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSactivate_object_with_id_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSactivate_object_with_id_InfoArrayIdx,
        ADL__VSactivate_object_with_id_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_p_svt(&p_svt_273, ADL__prop_values_269[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSServant_P(&p_svt_273, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_oid(&oid_274, ADL__prop_values_270[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSObjectId_var_P(&oid_274, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_testpoa_id(&testpoa_id_275, ADL__prop_values_271[tvec[2]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 1);
       ADL__emit_VSPOA_ptr_P(&testpoa_id_275, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(3);
       if (!provide_env(&env_276)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_3;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
       ADL__emit_VSEnvironment_P(&env_276, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSactivate_object_with_id_assertionReport = rf->assertionReport;
       fut_return_268 = ADL__ACF_VSactivate_object_with_id(p_svt_273, oid_274, testpoa_id_275, env_276);
       test_value = ADL__VSactivate_object_with_id_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(3);
       relvec[3] = relinquish_env(&env_276);
SKIP_3:
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_testpoa_id(&testpoa_id_275, ADL__prop_values_271[tvec[2]].propValCode);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_oid(&oid_274, ADL__prop_values_270[tvec[1]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_p_svt(&p_svt_273, ADL__prop_values_269[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_277,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSactivate_object_with_id_head);

    return 0;
}


struct ADL__Directive_info VSactivate_object_with_id1_info = {
    N_VARS,
    ADL__var_info_277
};

struct ADL__TDD_info ADL__test_info = {
    8,
    &ADL__VSactivate_object_with_id_InfoArrayIdx,
    ADL__VSactivate_object_with_id_InfoArray,
    ADL__test_driver,
    "VSactivate_object_with_id",
    "VSactivate_object_with_id1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSactivate_object_with_id1",
    "t1_tr.rif",
    &VSactivate_object_with_id1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

