/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/*************************************************/
/* Object activation and deactivation            */
/*************************************************/

#include <corba_supp.hh>
#include <tserver.hh>
#include <POAtest_impl.h>

extern "C" {

#include <t1_aux.h>

//-----------------------------------------------------------
// ......

int is_return_oid(VSObjectId_var *oid)
{
  PortableServer::ObjectId_var *objId = (PortableServer::ObjectId_var *) oid;
      
  if (objId)
    return TRUE;
  else
    return FALSE;
}

int poa_with_Pol(VSPOA_ptr *testPOA, VSString str)
{
  PortableServer::POA_ptr *tPOA = (PortableServer::POA_ptr *) testPOA;
 
  char* poa_name = (*tPOA)->the_name();
 
  if (strcmp(poa_name, str) == 0)
    return TRUE;   
  else
     return FALSE;
}

int is_obj_active(VSObjectId_var *oid, VSPOA_ptr *testPOA)
{  
  PortableServer::ObjectId_var *objid = (PortableServer::ObjectId_var *) oid;
  PortableServer::POA_ptr *tPOA = (PortableServer::POA_ptr *) testPOA;

  if(!objid)
    return FALSE;
 
  try {
    PortableServer::Servant svt = (*tPOA)->id_to_servant(*objid);
  }
  catch (...) {
    return FALSE;
  }    
  
  return TRUE;   
}

int  oidStr_equal_active(VSObjectId_var *oid)
{
  PortableServer::ObjectId_var *obj_id = (PortableServer::ObjectId_var *) oid;

  char *oid_str = PortableServer::ObjectId_to_string(*obj_id);
  
  if (strcmp(oid_str, "active") == 0)
    return TRUE;
  else
    return FALSE;
}

int is_oid_deactive(VSObjectId_var *oid, VSPOA_ptr *testPOA)
{  
  PortableServer::ObjectId_var *objid = (PortableServer::ObjectId_var *) oid;
  PortableServer::POA_ptr *tPOA = (PortableServer::POA_ptr *) testPOA;

  if(!objid)
    return FALSE;
 
  try {
    PortableServer::Servant svt = (*tPOA)->id_to_servant(*objid);
  }
  catch(PortableServer::POA::ObjectNotActive) {
    return TRUE;
  }
  catch (...) {
    return FALSE;
  }  
  return FALSE;   
}

int oid_reactive(VSObjectId_var *oid, VSPOA_ptr *testPOA)
{  
  PortableServer::ObjectId_var *objid = (PortableServer::ObjectId_var *) oid;
  PortableServer::POA_ptr *tpoa = (PortableServer::POA_ptr *) testPOA;

  if(!objid)
    return FALSE;

  char *poa_name, *oid_str;
  try {
    poa_name = (*tpoa)->the_name();
    oid_str = PortableServer::ObjectId_to_string(*objid);
  }
  catch (...) {
    return FALSE;
  }   
 
  PortableServer::Servant svt = new I_impl::I_impl(1);
  if (strcmp(poa_name, "poaAOM") == 0) 
    {
      if (strcmp(oid_str, "active") == 0) 
	{      
	  try {
	    (*tpoa)->activate_object_with_id(*objid, svt);
	  }
	  catch (...){
	    return FALSE;
	  }
	  return TRUE;	  
	}   
    }  
  return FALSE;
}

}
