/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/**************************************************/
/* POA creation und destruction                   */
/**************************************************/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>


 
  //-----------------------------------------------------------
  // ......

  int is_valid_policy(VSULong pol)
  {
    CORBA::ULong policy = (CORBA::ULong) pol;
    if(policy == 1) 
      return TRUE;
    else
      return FALSE;
  }


  int is_nil_poamanager(VSPOAManager_ptr *mgr)
  {  
    PortableServer::POAManager_ptr *POAmgr = (PortableServer::POAManager_ptr *) mgr;
    
    if(!CORBA::is_nil(*POAmgr))
      return TRUE;
    else
      return FALSE;
  }

  int childPOA_with_newPOAmgr(VSPOA_ptr *poa)
  {
    PortableServer::POA_ptr *childPOA = (PortableServer::POA_ptr *) poa;

    if (childPOA == 0)
      return FALSE; 

    PortableServer::POAManager_ptr childPOAmgr = (*childPOA)->the_POAManager();

    return (childPOAmgr ? TRUE : FALSE);
  }

  int is_exist_adapter(VSAdapter str)
  {
    char *adapter = (char *) str;
    
    if(strcmp(adapter, "existPOA") == 0)
      return TRUE;
    else
      return FALSE;
  }

  PortableServer::POA_ptr rootPOA;  
  void get_rootpoa() {    
    CORBA::ORB_ptr orb = glob_TS.m_corb->orb();
    CORBA::Object_ptr o = orb->resolve_initial_references("RootPOA");
    rootPOA = PortableServer::POA::_narrow(o);    
  }         
  

  int is_the_childpoa(VSPOA_ptr *childPOA)
  {  
    PortableServer::POA_ptr *child_POA = (PortableServer::POA_ptr *) childPOA;
  
    char* childPOA_name;
    PortableServer::POAList* children_POAlist;
  
    // False: *child_POA == 0
    if (child_POA == 0)
      return FALSE;

    get_rootpoa();
    try {
      childPOA_name = (*child_POA)->the_name();
      children_POAlist = rootPOA->the_children();
    }
    catch (CORBA::Exception &ex) {
      return FALSE;
    }

    if(children_POAlist) { 
      int poa_count;
      for (poa_count=0; poa_count<children_POAlist->length(); poa_count++) {
	PortableServer::POA_ptr theChild_POA;
	char* theChildPOA_name;
	try {
	  theChild_POA = (*children_POAlist)[poa_count];      
	  theChildPOA_name = theChild_POA->the_name();	
	}
	catch (CORBA::Exception &ex) {
	  return FALSE;
	}

	if(strcmp(theChildPOA_name, childPOA_name) == 0)
	  return TRUE; 
      }    
    }
    
    return FALSE;
  }
  
  int is_return_poa(VSPOA_ptr *poa)
  {
    PortableServer::POA_ptr *childPOA = (PortableServer::POA_ptr *) poa;
  
    int ret = (childPOA ? TRUE : FALSE);
  
    if (childPOA)
      (*childPOA)->destroy(TRUE, TRUE);
 
    return ret;
  } 

  int is_destroy_poa(VSPOA_ptr *p_poa)
  {
    PortableServer::POA_ptr *poa = (PortableServer::POA_ptr *) p_poa;
    int ret = (poa ? TRUE : FALSE);

    return ret;
  }


  int poa_with_pol(VSPOA_ptr *p_parent, VSString str)
  {
    PortableServer::POA_ptr *poa = (PortableServer::POA_ptr *) p_parent;

    if (poa == 0)
      return FALSE;

    char *poa_name = (*poa)->the_name();
    if(strcmp(poa_name, str) == 0)
      return TRUE;
    else
      return FALSE;
  }

  int is_childPOA_name(VSString childadapter, VSString p_str)
  {
    char *adapter = (char *) childadapter;
    char *str = (char *) p_str;
    
    if (strcmp(adapter, str) == 0)
      return TRUE;
    else
      return FALSE;
  }

  int is_actParameter_true(VSBoolean p_act)
  {
    CORBA::ULong act = (CORBA::ULong) p_act;
    if(act == 1) 
      return TRUE;
    else
      return FALSE;
  }

  int is_return_findPOA(VSPOA_ptr *poa)
  {
    PortableServer::POA_ptr *childPOA = (PortableServer::POA_ptr *) poa;
  
    int ret = (childPOA ? TRUE : FALSE);   
    return ret;
  }

}


