/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/**********************************************************/
/* Policy interfaces and factories for the policy objects */
/**********************************************************/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

//-----------------------------------------------------------
// ......
 
  int correct_Thread_policy(VSThreadPolicy_var *p_pol, VSThreadPolicyValue p_polVal)
  {
    PortableServer::ThreadPolicy_var *pol = (PortableServer::ThreadPolicy_var *) p_pol;    
     PortableServer::ThreadPolicyValue polVal = (PortableServer::ThreadPolicyValue) p_polVal;

     PortableServer::ThreadPolicyValue tpolVal = (*pol)->value();

     return (tpolVal==polVal);
  }

  
  int destroy_Thread_policy(VSThreadPolicy_var *p_pol)
  {
    PortableServer::ThreadPolicy_var *pol = (PortableServer::ThreadPolicy_var *) p_pol;

    try {
      (*pol)->destroy();
    }
    catch (...) {
      return FALSE;
    }
    
    return TRUE;
  }

  int correct_Thread_value(VSThreadPolicyValue p_polVal)
  {
    PortableServer::ThreadPolicyValue polVal = (PortableServer::ThreadPolicyValue) p_polVal;

    return (polVal == PortableServer::ORB_CTRL_MODEL);
  }


//-----------------------------------------------------------
// ......
  int correct_Lifespan_policy(VSLifespanPolicy_var *p_pol, VSLifespanPolicyValue p_polVal)
  {
    PortableServer::LifespanPolicy_var *pol = (PortableServer::LifespanPolicy_var *) p_pol;    
     PortableServer::LifespanPolicyValue polVal = (PortableServer::LifespanPolicyValue) p_polVal;

     PortableServer::LifespanPolicyValue tpolVal = (*pol)->value();

     return (tpolVal==polVal);
  }

  
  int destroy_Lifespan_policy(VSLifespanPolicy_var *p_pol)
  {
    PortableServer::LifespanPolicy_var *pol = (PortableServer::LifespanPolicy_var *) p_pol;

    try {
      (*pol)->destroy();
    }
    catch (...) {
      return FALSE;
    }
    
    return TRUE;
  }

  int correct_Lifespan_value(VSLifespanPolicyValue p_polVal)
  {
    PortableServer::LifespanPolicyValue polVal = (PortableServer::LifespanPolicyValue) p_polVal;

    return (polVal == PortableServer::PERSISTENT);
  }

  //-----------------------------------------------------------
// ......
  int correct_IdUniqueness_policy(VSIdUniquenessPolicy_var *p_pol, VSIdUniquenessPolicyValue p_polVal)
  {
    PortableServer::IdUniquenessPolicy_var *pol = (PortableServer::IdUniquenessPolicy_var *) p_pol;    
     PortableServer::IdUniquenessPolicyValue polVal = (PortableServer::IdUniquenessPolicyValue) p_polVal;

     PortableServer::IdUniquenessPolicyValue tpolVal = (*pol)->value();

     return (tpolVal==polVal);
  }

  
  int destroy_IdUniqueness_policy(VSIdUniquenessPolicy_var *p_pol)
  {
    PortableServer::IdUniquenessPolicy_var *pol = (PortableServer::IdUniquenessPolicy_var *) p_pol;

    try {
      (*pol)->destroy();
    }
    catch (...) {
      return FALSE;
    }
    
    return TRUE;
  }

  int correct_IdUniqueness_value(VSIdUniquenessPolicyValue p_polVal)
  {
    PortableServer::IdUniquenessPolicyValue polVal = (PortableServer::IdUniquenessPolicyValue) p_polVal;

    return (polVal == PortableServer::UNIQUE_ID);
  }

  //-----------------------------------------------------------
  // ......
  int correct_IdAssignment_policy(VSIdAssignmentPolicy_var *p_pol, VSIdAssignmentPolicyValue p_polVal)
  {
    PortableServer::IdAssignmentPolicy_var *pol = (PortableServer::IdAssignmentPolicy_var *) p_pol;    
     PortableServer::IdAssignmentPolicyValue polVal = (PortableServer::IdAssignmentPolicyValue) p_polVal;

     PortableServer::IdAssignmentPolicyValue tpolVal = (*pol)->value();

     return (tpolVal==polVal);
  }

  
  int destroy_IdAssignment_policy(VSIdAssignmentPolicy_var *p_pol)
  {
    PortableServer::IdAssignmentPolicy_var *pol = (PortableServer::IdAssignmentPolicy_var *) p_pol;

    try {
      (*pol)->destroy();
    }
    catch (...) {
      return FALSE;
    }
    
    return TRUE;
  }

  int correct_IdAssignment_value(VSIdAssignmentPolicyValue p_polVal)
  {
    PortableServer::IdAssignmentPolicyValue polVal = (PortableServer::IdAssignmentPolicyValue) p_polVal;

    return (polVal == PortableServer::USER_ID);
  }

 //-----------------------------------------------------------
// ......
  int correct_ImplicitActivation_policy(VSImplicitActivationPolicy_var *p_pol, VSImplicitActivationPolicyValue p_polVal)
  {
    PortableServer::ImplicitActivationPolicy_var *pol = (PortableServer::ImplicitActivationPolicy_var *) p_pol;    
     PortableServer::ImplicitActivationPolicyValue polVal = (PortableServer::ImplicitActivationPolicyValue) p_polVal;

     PortableServer::ImplicitActivationPolicyValue tpolVal = (*pol)->value();

     return (tpolVal==polVal);
  }

  
  int destroy_ImplicitActivation_policy(VSImplicitActivationPolicy_var *p_pol)
  {
    PortableServer::ImplicitActivationPolicy_var *pol = (PortableServer::ImplicitActivationPolicy_var *) p_pol;

    try {
      (*pol)->destroy();
    }
    catch (...) {
      return FALSE;
    }
    
    return TRUE;
  }

  int correct_ImplicitActivation_value(VSImplicitActivationPolicyValue p_polVal)
  {
    PortableServer::ImplicitActivationPolicyValue polVal = (PortableServer::ImplicitActivationPolicyValue) p_polVal;

    return (polVal == PortableServer::IMPLICIT_ACTIVATION);
  }


  //-----------------------------------------------------------
// ......
  int correct_ServantRetention_policy(VSServantRetentionPolicy_var *p_pol, VSServantRetentionPolicyValue p_polVal)
  {
    PortableServer::ServantRetentionPolicy_var *pol = (PortableServer::ServantRetentionPolicy_var *) p_pol;    
     PortableServer::ServantRetentionPolicyValue polVal = (PortableServer::ServantRetentionPolicyValue) p_polVal;

     PortableServer::ServantRetentionPolicyValue tpolVal = (*pol)->value();

     return (tpolVal==polVal);
  }

  
  int destroy_ServantRetention_policy(VSServantRetentionPolicy_var *p_pol)
  {
    PortableServer::ServantRetentionPolicy_var *pol = (PortableServer::ServantRetentionPolicy_var *) p_pol;

    try {
      (*pol)->destroy();
    }
    catch (...) {
      return FALSE;
    }
    
    return TRUE;
  }

  int correct_ServantRetention_value(VSServantRetentionPolicyValue p_polVal)
  {
    PortableServer::ServantRetentionPolicyValue polVal = (PortableServer::ServantRetentionPolicyValue) p_polVal;

    return (polVal == PortableServer::RETAIN);
  }

  //-----------------------------------------------------------
// ......
  int correct_RequestProcessing_policy(VSRequestProcessingPolicy_var *p_pol, VSRequestProcessingPolicyValue p_polVal)
  {
    PortableServer::RequestProcessingPolicy_var *pol = (PortableServer::RequestProcessingPolicy_var *) p_pol;    
     PortableServer::RequestProcessingPolicyValue polVal = (PortableServer::RequestProcessingPolicyValue) p_polVal;

     PortableServer::RequestProcessingPolicyValue tpolVal = (*pol)->value();

     return (tpolVal==polVal);
  }

  
  int destroy_RequestProcessing_policy(VSRequestProcessingPolicy_var *p_pol)
  {
    PortableServer::RequestProcessingPolicy_var *pol = (PortableServer::RequestProcessingPolicy_var *) p_pol;

    try {
      (*pol)->destroy();
    }
    catch (...) {
      return FALSE;
    }
    
    return TRUE;
  }

  int correct_RequestProcessing_value(VSRequestProcessingPolicyValue p_polVal)
  {
    PortableServer::RequestProcessingPolicyValue polVal = (PortableServer::RequestProcessingPolicyValue) p_polVal;

    return (polVal == PortableServer::USE_ACTIVE_OBJECT_MAP_ONLY);
  }
  
}
