/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/**********************************************************/
/* Policy interfaces and factories for the policy objects */
/**********************************************************/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

  /*-----------------------------------------------------------*/
  /* test variable VSThreadPolicyValue thread() */
  int provide_thread (VSThreadPolicyValue *testvar)
  {
    PortableServer::ThreadPolicyValue *tvar = (PortableServer::ThreadPolicyValue *) testvar;

    *tvar = PortableServer::ORB_CTRL_MODEL;
    return TRUE;
  }

  int relinquish_thread (VSThreadPolicyValue *testvar)
  {
    return TRUE;
  }


  /*-----------------------------------------------------------*/
  /* test variable VSLifespanPolicyValue lifespan() */
  int provide_lifespan (VSLifespanPolicyValue *testvar)
  {
    PortableServer::LifespanPolicyValue *tvar = (PortableServer::LifespanPolicyValue *) testvar;
    *tvar = PortableServer::PERSISTENT;
    
    return TRUE;
  }
  
  int relinquish_lifespan (VSLifespanPolicyValue *testvar)
  {
    return TRUE;    
  }


  /*-----------------------------------------------------------*/
  /* test variable VSIdUniquenessPolicyValue idUniqueness() */
  int provide_idUniqueness (VSIdUniquenessPolicyValue *testvar)
  {
    PortableServer::IdUniquenessPolicyValue *tvar = (PortableServer::IdUniquenessPolicyValue *) testvar;

    *tvar = PortableServer::UNIQUE_ID;    
  }

  int relinquish_idUniqueness (VSIdUniquenessPolicyValue *testvar)
  {
    return TRUE;
  }

  /*-----------------------------------------------------------*/
  /* test variable VSIdAssignmentPolicyValue idAssignment() */
  int provide_idAssignment (VSIdAssignmentPolicyValue *testvar)
  {
    PortableServer::IdAssignmentPolicyValue *tvar = (PortableServer::IdAssignmentPolicyValue *) testvar;

    *tvar = PortableServer::USER_ID;
    return TRUE;
  }

  int relinquish_idAssignment (VSIdAssignmentPolicyValue *testvar)
  {
    return FALSE;
  }

  /*-----------------------------------------------------------*/
  /* test variable VSImplicitActivationPolicyValue implicitAct() */
  int provide_implicitAct (VSImplicitActivationPolicyValue *testvar)
  {
    PortableServer::ImplicitActivationPolicyValue *tvar = (PortableServer::ImplicitActivationPolicyValue *) testvar;

    *tvar = PortableServer::IMPLICIT_ACTIVATION;
    return TRUE;
  }

  int relinquish_implicitAct (VSImplicitActivationPolicyValue *testvar)
  {
    return FALSE;
  }


  /*-----------------------------------------------------------*/
  /* test variable VSServantRetentionPolicyValue svtRetention() */
  int provide_svtRetention (VSServantRetentionPolicyValue *testvar)
  {
    PortableServer::ServantRetentionPolicyValue *tvar = (PortableServer::ServantRetentionPolicyValue *) testvar;

    *tvar = PortableServer::RETAIN;
    return TRUE;
  }

  int relinquish_svtRetention (VSServantRetentionPolicyValue *testvar)
  {
    return FALSE;
  }

  /*-----------------------------------------------------------*/
  /* test variable VSRequestProcessingPolicyValue requestProcess() */
  int provide_requestProcess (VSRequestProcessingPolicyValue *testvar)
  {
    PortableServer::RequestProcessingPolicyValue *tvar = (PortableServer::RequestProcessingPolicyValue *) testvar;

    *tvar = PortableServer::USE_ACTIVE_OBJECT_MAP_ONLY;
    return TRUE;
  }

  int relinquish_requestProcess (VSRequestProcessingPolicyValue *testvar)
  {
    return FALSE;
  }

}
