/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/


/****************************************************/
/* Reference creation operations                    */
/****************************************************/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {
#include <t1.h>
#include <t1_aux.h>
#include <t1i_tdi.h>


  /*------------------------------------------------------------------*/
  /* Test the function create_reference()                                   */ 

   VSObject_ptr *VScreate_reference(VSRepositoryId *p_rep, VSObjectId_var *p_oid,  VSPOA_ptr *thePOA, VSEnvironment *ev)
  {
    CORBA::RepositoryId *rep = (CORBA::RepositoryId *) p_rep;
    PortableServer::ObjectId_var *oid = (PortableServer::ObjectId_var *) p_oid;
    PortableServer::POA_ptr *test_poa = (PortableServer::POA_ptr *) thePOA;  
    CORBA::Environment *env = (CORBA::Environment *) ev;

    CORBA::Object_ptr objref;
  
    try {      
      objref = (*test_poa)->create_reference(*rep);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
    
      if(env){
	env->exception(t);
      }
      return (VSObject_ptr *) 0;
    }
    catch (...) {
      return (VSObject_ptr *) 0;
    }
 
    CORBA::Object_ptr *robj = new CORBA::Object_ptr(objref);      
    
    return (VSObject_ptr *) robj ;    
  }


  /*------------------------------------------------------------------*/
  /* Test the function create_reference_with_id()                     */ 
 
  VSObject_ptr *VScreate_reference_with_id(VSRepositoryId *p_rep, VSObjectId_var *p_oid, VSPOA_ptr *thePOA, VSEnvironment *ev)
  {
    CORBA::RepositoryId *rep = (CORBA::RepositoryId *) p_rep;
    PortableServer::ObjectId_var *oid = (PortableServer::ObjectId_var *) p_oid;
    PortableServer::POA_ptr *test_poa = (PortableServer::POA_ptr *) thePOA;  
    CORBA::Environment *env = (CORBA::Environment *) ev;

    CORBA::Object_ptr objref;
  
    try {      
      objref = (*test_poa)->create_reference_with_id(*oid, *rep);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
    
      if(env){
	env->exception(t);
      }
      return (VSObject_ptr *) 0;
    }
    catch (...) {
      return (VSObject_ptr *) 0;
    }
 
    CORBA::Object_ptr *robj = new CORBA::Object_ptr(objref);      
    
    return (VSObject_ptr *) robj ;    
  }

}

