/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/


/****************************************************/
/* Reference creation operations                    */
/****************************************************/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>


 
//-----------------------------------------------------------
// ......

int is_return_object(VSObject_ptr *obj)
{
  CORBA::Object_ptr *robj= (CORBA::Object_ptr *) obj;
  
  int ret = (robj ? TRUE : FALSE); 

  CORBA::release(*robj);

  return ret;

}


int poa_with_Pol(VSPOA_ptr *testPOA, VSString str)
{
  PortableServer::POA_ptr *tPOA = (PortableServer::POA_ptr *) testPOA; 

  char* poa_name = (*tPOA)->the_name();

  if (strcmp(poa_name, str) == 0)
    return TRUE;
  else
     return FALSE;
}        


int obj_no_active(VSObject_ptr *p_obj, VSPOA_ptr *testPOA)
{
  CORBA::Object_ptr *obj = (CORBA::Object_ptr *) p_obj;
  PortableServer::POA_ptr *tPOA = (PortableServer::POA_ptr *) testPOA;

  if(!obj)
    return FALSE;

  try {
    PortableServer::Servant svt = (*tPOA)->reference_to_servant(*obj);
  }
  catch (...) {
    return TRUE;
  }

  return FALSE;
}    

}
