/* ADL test driver from t1.tdr
 *
 * test VSresolve_initial_references(oid, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop value */
static struct ADL__propertyValue ADL__prop_values_86[] = {
    {"valid", Poid_value_valid, 0},
    {"nil", Poid_value_nil, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_87[] = {
    {"value", "prop", ADL__prop_values_86, 2},
    {0, 0, 0}
};
#define TVEC_SIZE 1

static struct ADL__variableInfo ADL__var_info_90[3] = {
    {"oid", "VSObjectId *", ADL__prop_info_87, 0, 1},
    {"env", "VSEnvironment *", ADL__prop_info_87, 1, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 2


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSresolve_initial_references_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSOBJECTID_P
#define ADL__PRINT_VSOBJECTID_P
void (*ADL__print_VSObjectId_P)(VSObjectId*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECTID_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSOBJECT_PTR_P
#define ADL__PRINT_VSOBJECT_PTR_P
void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR_P */
#ifndef ADL__PRINT_VSPOA_PTR_P
#define ADL__PRINT_VSPOA_PTR_P
void (*ADL__print_VSPOA_ptr_P)(VSPOA_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOA_PTR_P */

void ADL__emit_VSObjectId_P (void* val, emitter_t emitter)
{
  VSObjectId *tmp;

  if (ADL__print_VSObjectId_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObjectId_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter)
{
  VSObject_ptr *tmp;

  if (ADL__print_VSObject_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObject_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSPOA_ptr_P (void* val, emitter_t emitter)
{
  VSPOA_ptr *tmp;

  if (ADL__print_VSPOA_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPOA_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSObjectId *oid_88;
    VSEnvironment *env_89;
    VSObject_ptr *fut_return_85;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSresolve_initial_references_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSresolve_initial_references_InfoArrayIdx,
        ADL__VSresolve_initial_references_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_oid(&oid_88, ADL__prop_values_86[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSObjectId_P(&oid_88, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_env(&env_89)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
       ADL__emit_VSEnvironment_P(&env_89, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSresolve_initial_references_assertionReport = rf->assertionReport;
       fut_return_85 = ADL__ACF_VSresolve_initial_references(oid_88, env_89);
       test_value = ADL__VSresolve_initial_references_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_env(&env_89);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_oid(&oid_88, ADL__prop_values_86[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_90,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSresolve_initial_references_head);

    return 0;
}


struct ADL__Directive_info VSresolve_initial_references1_info = {
    N_VARS,
    ADL__var_info_90
};

struct ADL__TDD_info ADL__test_info = {
    2,
    &ADL__VSresolve_initial_references_InfoArrayIdx,
    ADL__VSresolve_initial_references_InfoArray,
    ADL__test_driver,
    "VSresolve_initial_references",
    "VSresolve_initial_references1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSresolve_initial_references1",
    "t1_tr.rif",
    &VSresolve_initial_references1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

