/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/*******************************************/
/* Getting the root POA                    */
/*******************************************/


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {
#include <t1.h>
#include <t1_aux.h>
#include <t1i_tdi.h>


/*------------------------------------------------------*/

VSObject_ptr *VSresolve_initial_references(VSObjectId *id,VSEnvironment *ev)
{
  CORBA::Environment *env = (CORBA::Environment *) ev;
  CORBA::ORB::ObjectId *oid = (CORBA::ORB::ObjectId *) id;
  
  CORBA::ORB_ptr orb = glob_TS.m_corb->orb();
  CORBA::Object_ptr obj;

  try {
    obj = orb->resolve_initial_references(*oid);
  }
  catch (CORBA::Exception &ex) {
    CORBA::Exception *t = exception_convert(&ex);
    if(env)
      env->exception(t);
    
    return (VSObject_ptr *) 0;
  }
  catch (...) {
    return (VSObject_ptr *) 0;				
  }

  CORBA::Object_ptr *robj = new CORBA::Object_ptr(obj);
  return (VSObject_ptr *) robj;
}


/*------------------------------------------------------*/
 
VSPOA_ptr* VSnarrow(VSObject_ptr *obj, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;

		CORBA::Object_ptr *object = (CORBA::Object_ptr *) obj;
		PortableServer::POA_ptr poa;

		try {
		  poa = PortableServer::POA::_narrow(*object);
		}
		catch (CORBA::Exception &ex) {
		  CORBA::Exception *t = exception_convert(&ex);
		  if(env)
		    env->exception(t);
		  return (VSPOA_ptr *) 0;
		}
		catch (...) {
		  return (VSPOA_ptr *) 0;
		}

		PortableServer::POA_ptr *rPOA = new PortableServer::POA_ptr(poa);
		return (VSPOA_ptr *) rPOA;
}

}
