/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/*******************************************/
/* Getting the root POA                    */
/*******************************************/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

 
int is_nil_oid(VSObjectId *id)
{
		CORBA::ORB::ObjectId *oid = (CORBA::ORB::ObjectId *) id;
		if(!oid || !*oid)
				return FALSE;

		if(strcmp(*oid,"") == 0)
				return TRUE;
		return FALSE;
}

int is_rootPOA_oid(VSObjectId *id)
{
  CORBA::ORB::ObjectId *oid = (CORBA::ORB::ObjectId *) id;
  if(!oid || !*oid)
    return FALSE;
  
  if(strcmp(*oid, "RootPOA") == 0)
    return TRUE;
  return FALSE;

}


int is_valid_obj(VSObject_ptr *o)
{
		CORBA::Object_ptr *obj = (CORBA::Object_ptr *) o;

		int ret = (obj ? TRUE : FALSE);
		if(obj)
				delete obj;

		return ret;
}


int is_return_rootPOA(VSPOA_ptr *poa)
{
  PortableServer::POA_ptr *root_poa = (PortableServer::POA_ptr *) poa;

  if(root_poa)  
    return TRUE;
  else
    return FALSE;
}

 
}
