/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/*******************************************/
/* Getting the root POA                    */
/*******************************************/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>


/* ------------------------------------------------------------ */
/* test variable objectid() */

int provide_oid (VSObjectId **testvar, enum prop_oid_value value)
{
  CORBA::ORB::ObjectId tvar;
  switch(value){
  case Poid_value_valid:
    tvar = CORBA::string_dup("RootPOA");
    break;
    
  case Poid_value_nil:
    tvar = CORBA::string_dup("");
    break;           
  }
		
  CORBA::ORB::ObjectId *tmp = new CORBA::ORB::ObjectId();
  *tmp = tvar;
  *testvar = (VSObjectId *) tmp;
  return TRUE;
}

int relinquish_oid (VSObjectId **testvar, enum prop_oid_value value)
{
  CORBA::ORB::ObjectId *tvar = (CORBA::ORB::ObjectId *) *testvar;
  switch(value){
  case Poid_value_valid:
  case Poid_value_nil:				
    CORBA::string_free(*tvar);
    break;
  }
  return TRUE;
}


int provide_obj(VSObject_ptr **testvar,	enum prop_obj_value value)
{
  CORBA::Object_ptr  *tvar;
  switch(value){
  case Pobj_value_valid:
    {
      CORBA::ORB_ptr orb = glob_TS.m_corb->orb();
      CORBA::Object_ptr obj = glob_TS.m_tobj->_duplicate(glob_TS.m_tobj);
      // CORBA::Object_ptr obj = orb->resolve_initial_references("RootPOA");
      tvar = new CORBA::Object_ptr(obj);
    }
    break;      		
  }

  *testvar = (VSObject_ptr *) tvar;
  return TRUE;
}


int relinquish_obj(VSObject_ptr **testvar, enum prop_obj_value value)
{
		CORBA::Object_ptr  *tvar = (CORBA::Object_ptr *) *testvar;
		switch(value){
		case Pobj_value_valid:			
		  CORBA::release(*tvar);
		  break;
		}
		return TRUE;
}

}
