/* ADL test driver from t1.tdr
 *
 * test VSset_servant_manager(svtMgr, setSvtMgrPOA, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop value */
static struct ADL__propertyValue ADL__prop_values_128[] = {
    {"valid", PsvtMgr_value_valid, 0},
    {0, 0, 0}
};

/* values for prop value */
static struct ADL__propertyValue ADL__prop_values_129[] = {
    {"noSvtMgrPol", PsetSvtMgrPOA_value_noSvtMgrPol, 0},
    {"svtMgrPol", PsetSvtMgrPOA_value_svtMgrPol, 0},
    {"svtMgrset", PsetSvtMgrPOA_value_svtMgrset, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_130[] = {
    {"value", "prop", ADL__prop_values_128, 1},
    {"value", "prop", ADL__prop_values_129, 3},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_134[4] = {
    {"svtMgr", "VSServantManager_ptr *", ADL__prop_info_130, 0, 1},
    {"setSvtMgrPOA", "VSPOA_ptr *", ADL__prop_info_130, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_130, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSset_servant_manager_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSSERVANTMANAGER_PTR_P
#define ADL__PRINT_VSSERVANTMANAGER_PTR_P
void (*ADL__print_VSServantManager_ptr_P)(VSServantManager_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSSERVANTMANAGER_PTR_P */
#ifndef ADL__PRINT_VSPOA_PTR_P
#define ADL__PRINT_VSPOA_PTR_P
void (*ADL__print_VSPOA_ptr_P)(VSPOA_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOA_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */

void ADL__emit_VSServantManager_ptr_P (void* val, emitter_t emitter)
{
  VSServantManager_ptr *tmp;

  if (ADL__print_VSServantManager_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSServantManager_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSPOA_ptr_P (void* val, emitter_t emitter)
{
  VSPOA_ptr *tmp;

  if (ADL__print_VSPOA_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPOA_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {1, 3};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSServantManager_ptr *svtMgr_131;
    VSPOA_ptr *setSvtMgrPOA_132;
    VSEnvironment *env_133;
    VSBoolean fut_return_127;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSset_servant_manager_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSset_servant_manager_InfoArrayIdx,
        ADL__VSset_servant_manager_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_svtMgr(&svtMgr_131, ADL__prop_values_128[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSServantManager_ptr_P(&svtMgr_131, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_setSvtMgrPOA(&setSvtMgrPOA_132, ADL__prop_values_129[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSPOA_ptr_P(&setSvtMgrPOA_132, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_133)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_133, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSset_servant_manager_assertionReport = rf->assertionReport;
       fut_return_127 = ADL__ACF_VSset_servant_manager(svtMgr_131, setSvtMgrPOA_132, env_133);
       test_value = ADL__VSset_servant_manager_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_133);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_setSvtMgrPOA(&setSvtMgrPOA_132, ADL__prop_values_129[tvec[1]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_svtMgr(&svtMgr_131, ADL__prop_values_128[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_134,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSset_servant_manager_head);

    return 0;
}


struct ADL__Directive_info VSset_servant_manager1_info = {
    N_VARS,
    ADL__var_info_134
};

struct ADL__TDD_info ADL__test_info = {
    3,
    &ADL__VSset_servant_manager_InfoArrayIdx,
    ADL__VSset_servant_manager_InfoArray,
    ADL__test_driver,
    "VSset_servant_manager",
    "VSset_servant_manager1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSset_servant_manager1",
    "t1_tr.rif",
    &VSset_servant_manager1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

