/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/**********************************************/
/* Servant manager registration               */
/**********************************************/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {
#include <t1.h>
#include <t1_aux.h>
#include <t1i_tdi.h>

  /*------------------------------------------------------------------*/ 
  /* set_servant_manager(..) */
  VSBoolean VSset_servant_manager(VSServantManager_ptr *p_svtMgr, VSPOA_ptr *p_poa, VSEnvironment *ev)
  {
    PortableServer::ServantManager_ptr *svtMgr = (PortableServer::ServantManager_ptr *) p_svtMgr;
    PortableServer::POA_ptr *poa = (PortableServer::POA_ptr *) p_poa;    
    CORBA::Environment *env = (CORBA::Environment *) ev;

    char *poa_name;   
    try {
      poa_name = (*poa)->the_name();
    }
    catch (...) {
      return FALSE;
    }
 
    if(strcmp(poa_name, "svtMgrset") == 0)
      {
	try {
	  (*poa)->set_servant_manager(*svtMgr);	
	}
	catch (...) {
	  return FALSE;
	}
      }

    try {
      (*poa)->set_servant_manager(*svtMgr);
    }
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
      return FALSE;
    }

    return TRUE;
  }

  /*------------------------------------------------------------------*/ 
  /* get_servant_manager(..) */

  VSServantManager_ptr *VSget_servant_manager(VSPOA_ptr *p_poa, VSEnvironment *ev)
  {
    PortableServer::POA_ptr *poa = (PortableServer::POA_ptr *) p_poa;    
    CORBA::Environment *env = (CORBA::Environment *) ev;

    PortableServer::ServantManager_ptr svtMgr;

    try {
      svtMgr = (*poa)->get_servant_manager();
    }     
    catch (CORBA::Exception &ex) {
      CORBA::Exception *t = exception_convert(&ex);
      if(env)
	env->exception(t);
      return (VSServantManager_ptr *) 0;
    }

    PortableServer::ServantManager_ptr *rsvtMgr = new PortableServer::ServantManager_ptr(svtMgr);
    return (VSServantManager_ptr *) rsvtMgr;
  }
}
