/* ADL test driver from t1.tdr
 *
 * test VSget_state(env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


static struct ADL__propertyInfo ADL__prop_info_303[] = {
    {0, 0, 0}
};
#define TVEC_SIZE 0

static struct ADL__variableInfo ADL__var_info_305[2] = {
    {"env", "VSEnvironment *", ADL__prop_info_303, 0, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 1


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSget_state_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSPOAMANAGER_PTR_P
#define ADL__PRINT_VSPOAMANAGER_PTR_P
void (*ADL__print_VSPOAManager_ptr_P)(VSPOAManager_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOAMANAGER_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSSTATE
#define ADL__PRINT_VSSTATE
void (*ADL__print_VSState)(VSState, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTATE */

void ADL__emit_VSPOAManager_ptr_P (void* val, emitter_t emitter)
{
  VSPOAManager_ptr *tmp;

  if (ADL__print_VSPOAManager_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPOAManager_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSState (void* val, emitter_t emitter)
{
  VSState tmp;

  if (ADL__print_VSState != 0) {
    tmp = *(VSState*) val;
    ADL__print_VSState(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[1];
    enum ADL__ACF_result test_value;
    VSEnvironment *env_304;
    VSState fut_return_302;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    tvec[0] = 0;
    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSget_state_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSget_state_InfoArrayIdx,
        ADL__VSget_state_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_env(&env_304)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
       ADL__emit_VSEnvironment_P(&env_304, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSget_state_assertionReport = rf->assertionReport;
       fut_return_302 = ADL__ACF_VSget_state(env_304);
       test_value = ADL__VSget_state_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_env(&env_304);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSget_state_head);

    return 0;
}


struct ADL__Directive_info VSget_state1_info = {
    N_VARS,
    ADL__var_info_305
};

struct ADL__TDD_info ADL__test_info = {
    1,
    &ADL__VSget_state_InfoArrayIdx,
    ADL__VSget_state_InfoArray,
    ADL__test_driver,
    "VSget_state",
    "VSget_state1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSget_state1",
    "t1_tr.rif",
    &VSget_state1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

