/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/*********************************************/
/*  POAManger interface                      */
/*********************************************/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>   
  

int is_active_state(VSPOAManager_ptr *mgr)
{
  PortableServer::POAManager_ptr *mgr_act = (PortableServer::POAManager_ptr *) mgr;
  
  if (!mgr_act)
    return FALSE;

  PortableServer::POAManager::State mgr_state;

  try {
    mgr_state = (*mgr_act)->get_state();
  }
  catch (...) {
    return FALSE;
  }
 
  return(mgr_state == PortableServer::POAManager::ACTIVE);
}

int is_inactive_state(VSPOAManager_ptr *mgr)
{
  PortableServer::POAManager_ptr *mgr_inact = (PortableServer::POAManager_ptr *) mgr;
  
  if (!mgr_inact)
    return FALSE;
  
  PortableServer::POAManager::State mgr_state;

  try {
    mgr_state = (*mgr_inact)->get_state();
    CORBA::release(*mgr_inact);
     }
  
  catch (...) {
    return FALSE;
  }

  return(mgr_state == PortableServer::POAManager::INACTIVE);
}

int is_hold_state(VSPOAManager_ptr *mgr)
{
  PortableServer::POAManager_ptr *mgr_hold = (PortableServer::POAManager_ptr *) mgr;

  if (!mgr_hold)
    return FALSE;

  PortableServer::POAManager::State mgr_state;

  try {
    mgr_state= (*mgr_hold)->get_state();
  }
  
  catch (...) {
    return FALSE;
  }

  return(mgr_state == PortableServer::POAManager::HOLDING);
}


int is_discard_state(VSPOAManager_ptr *mgr)
{
  PortableServer::POAManager_ptr *mgr_discard = (PortableServer::POAManager_ptr *) mgr;

  if (!mgr_discard)
    return FALSE;
  
  PortableServer::POAManager::State mgr_state;

  try {
    mgr_state = (*mgr_discard)->get_state();
  }
  
  catch (...) {
    return FALSE;
  }

  return(mgr_state == PortableServer::POAManager::DISCARDING);
}

int correct_poaMgr_state(VSState p_mgrState)
{
  PortableServer::POAManager::State mgrState = (PortableServer::POAManager::State) p_mgrState; 

  return (mgrState == PortableServer::POAManager::ACTIVE);
}

}   
