/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

#include "POAtest_impl.h" 

/***************************************************************/
/* Interface I                                         */
/***************************************************************/
I_impl::I_impl(CORBA::Long init_m = 0)
{
  n = init_m;
}


I_impl::~I_impl()
{

}

CORBA::Long I_impl::op(CORBA::Long m)
    throw(CORBA::SystemException)
{
  m = m+n;  
  return m;
}


/******************************************************************/
/* A ServantActivator                                             */
/******************************************************************/

PortableServer::Servant 
SvtActivator::incarnate( const PortableServer::ObjectId& oid,
			 PortableServer::POA_ptr poa)
  throw( CORBA::SystemException, 
	 PortableServer::ForwardRequest)
{
  CORBA::String_var str = PortableServer::ObjectId_to_string(oid);
  if (strcmp(str, "I_Svt") == 0) 
    return new I_impl(1); 
  else
    throw CORBA::OBJECT_NOT_EXIST();
}

void  SvtActivator::etherealize( const PortableServer::ObjectId& oid,
				   PortableServer::POA_ptr poa,
				   PortableServer::Servant svt,
				   CORBA::Boolean cleanup_in_progress,
				   CORBA::Boolean remaining_activations )
    throw(CORBA::SystemException)
 
{
  if (remaining_activations == 0)
    delete svt;
  else
    svt->_remove_ref();
}  



/*************************************************************/
/* A ServantLocator                                          */
/*************************************************************/

PortableServer::Servant 
SvtLocator::preinvoke( const PortableServer::ObjectId& oid,
		       PortableServer::POA_ptr poa,
		       const char * operation,
		       void * & cookie )
  throw( CORBA::SystemException, 
	 PortableServer::ForwardRequest)
{
  CORBA::String_var str = PortableServer::ObjectId_to_string(oid);
  if (strcmp(str, "I_Svt") == 0) 
    return new I_impl(1); 
  else
    throw CORBA::OBJECT_NOT_EXIST(); 
}

void SvtLocator::postinvoke( const PortableServer::ObjectId& oid,
			     PortableServer::POA_ptr poa,
			     const char * operation,
			     void * cookie,
			     PortableServer::Servant svt )
  throw(CORBA::SystemException)
{
  svt->_remove_ref();
}


/*************************************************************/
/* A AdapterActivator for API test                           */
/*************************************************************/ 

CORBA::Boolean
adpActivator::unknown_adapter( PortableServer::POA_ptr parent,
			       const char * name)
    throw(CORBA::SystemException)
{
  CORBA::Boolean return_val =0;

  if(strcmp(name, "childPOA") == 0) 
    {
      CORBA::PolicyList polList;
      PortableServer::POAManager_ptr poa_mgr = parent->the_POAManager();

      try {    
	PortableServer::POA_ptr test_POA = parent->create_POA("childPOA", poa_mgr, polList);
	return_val = 1;
      }
      catch (...) {
	return return_val;
      }

      return return_val;
    }
}
