/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/
#include <corba_supp.hh>
#include <POAtest_inc.h> 

// Interface I
class I_impl : public virtual POA_M_POAtest::I, 
  public PortableServer::RefCountServantBase
{
 public:
  I_impl(CORBA::Long init_m);
  virtual ~I_impl();

  virtual CORBA::Long op(CORBA::Long m)
    throw( CORBA::SystemException);
  
 private:
  CORBA::Long n; 
};
                           
// A ServantActivator
class SvtActivator : public POA_PortableServer::ServantActivator
{
 public: 
  SvtActivator() {};
  ~SvtActivator() {};

  virtual PortableServer::Servant 
    incarnate( const PortableServer::ObjectId& oid, 
	       PortableServer::POA_ptr poa )
    throw( CORBA::SystemException,
	   PortableServer::ForwardRequest);
    
  virtual void
    etherealize( const PortableServer::ObjectId& oid,
		  PortableServer::POA_ptr poa,
		  PortableServer::Servant svt,
		  CORBA::Boolean cleanup_in_progress,
		  CORBA::Boolean remaining_activations )
    throw(CORBA::SystemException);
}; 

// A ServantLocator
class SvtLocator : public POA_PortableServer::ServantLocator
{
 public:
  SvtLocator() {};
  ~SvtLocator() {};

  virtual PortableServer::Servant
    preinvoke( const PortableServer::ObjectId& oid,
	       PortableServer::POA_ptr poa,
	       const char * operation,
	       void * & cookie )
    throw( CORBA::SystemException, 
	   PortableServer::ForwardRequest);
  
  virtual void 
    postinvoke( const PortableServer::ObjectId& oid,
		PortableServer::POA_ptr poa,
		const char * operation,
		void * cookie,
		PortableServer::Servant svt )
    throw(CORBA::SystemException);
    
};

// A AdapterActivator
class adpActivator : public POA_PortableServer::AdapterActivator
{
 public:
  adpActivator() {};
  ~adpActivator() {};

  virtual CORBA::Boolean 
    unknown_adapter( PortableServer::POA_ptr parent,
		     const char * name)
    throw(CORBA::SystemException);

};

