/*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
*
* All rights reserved. No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Developed for X/Open by ApTest Ireland Limited.
*
* Project: VSORB
*
* File: tset/c++/api/basicTypes/Any/t1.cpp
*
* Modifications:
* $Log: t1.cpp,v $
* Revision 1.1.1.1  2000/02/09 17:14:36  mli
* Imported TOG's VSOrb 1.1.1
*
* Revision 1.4  1997/12/05 16:28:15  cwatson
* Now uses .hh for c++ include files.
*
* Revision 1.3  1997/11/11 13:13:59  cwatson
* Changed the exception handling by removing VSExceptionWrap.
*
* Revision 1.2  1997/10/09 11:09:16  ian
* Changed corba_defs to corba_supp.
*
* Revision 1.1  1997/10/04 10:34:24  ian
* Initial version.
*
*/

#include  <corba_supp.hh>
#include  <tserver.hh>

extern "C" {

#include <t1.h>
#include <t1_aux.h>

#define IMPLEMENT_WRAPPER_FUNCTION(WRAPPER_FUNCTION, TYPE, CORBA_TYPE) \
	VSAny *WRAPPER_FUNCTION(TYPE s, VSEnvironment *ev)  \
	{ \
		CORBA::Environment *env = (CORBA::Environment *)ev; \
			CORBA::Any *pAny = NULL; \
			\
			try { \
					pAny = new CORBA::Any; \
					*pAny <<= (CORBA_TYPE)s; \
			} \
			catch (CORBA::Exception &ex) { \
										 \
				CORBA::Exception *t = exception_convert(&ex);   \
							 \
				if(env) \
					env->exception(t); \
		 \
				delete pAny; \
				pAny = NULL; \
			} \
			catch (...) { \
				delete pAny; \
				pAny = NULL; \
			} \
		 \
			return (VSAny *)pAny; \
		}; 

	IMPLEMENT_WRAPPER_FUNCTION(VSShortToAny, VSShort, CORBA::Short);
	IMPLEMENT_WRAPPER_FUNCTION(VSUShortToAny, VSUShort, CORBA::UShort);
	IMPLEMENT_WRAPPER_FUNCTION(VSLongToAny, VSLong, CORBA::Long);
	IMPLEMENT_WRAPPER_FUNCTION(VSULongToAny, VSULong, CORBA::ULong);
	IMPLEMENT_WRAPPER_FUNCTION(VSFloatToAny, VSFloat, CORBA::Float);
	IMPLEMENT_WRAPPER_FUNCTION(VSDoubleToAny, VSDouble, CORBA::Double);
	IMPLEMENT_WRAPPER_FUNCTION(VSUnboundStringToAny, VSString, char *);

	#define IMPLEMENT_AMBIGUOUS_WRAPPER_FUNCTION(WRAPPER_FUNCTION, TYPE, CORBA_TYPE, ANY_STRUCT) \
		VSAny *WRAPPER_FUNCTION(TYPE s, VSEnvironment *ev) \
		{ \
			CORBA::Environment *env = (CORBA::Environment *)ev; \
			CORBA::Any *pAny = NULL; \
				\
			try { \
					pAny = new CORBA::Any; \
					CORBA::Any::ANY_STRUCT fb((CORBA_TYPE)s); \
       \
					*pAny <<= fb; \
			} \
			catch (CORBA::Exception &ex) { \
										 \
				CORBA::Exception *t = exception_convert(&ex);   \
							 \
				if(env) \
					env->exception(t); \
		    \
				delete pAny; \
				pAny = NULL; \
			} \
			catch (...) { \
				delete pAny; \
				pAny = NULL; \
			} \
		 \
			return (VSAny *)pAny; \
		} 

	IMPLEMENT_AMBIGUOUS_WRAPPER_FUNCTION(VSBooleanToAny, VSBoolean, CORBA::Boolean, from_boolean);
	IMPLEMENT_AMBIGUOUS_WRAPPER_FUNCTION(VSCharToAny, VSChar, CORBA::Char, from_char);
	IMPLEMENT_AMBIGUOUS_WRAPPER_FUNCTION(VSOctetToAny, VSOctet, CORBA::Octet, from_octet);
} // extern "C"
