/*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
*
* All rights reserved. No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Developed for X/Open by ApTest Ireland Limited.
*
* Project: VSORB
*
* File: tset/c++/api/basicTypes/Any/t1_aux.cpp
*
* Modifications:
* $Log: t1_aux.cpp,v $
* Revision 1.1.1.1  2000/02/09 17:14:36  mli
* Imported TOG's VSOrb 1.1.1
*
* Revision 1.5  1999/04/28 14:20:23  cwatson
* SR100 text revision change.
*
* SR100 Revision 1.4  1999/04/28 10:38:18  cwatson
* Missing & added.
*
* Revision 1.3  1997/12/05 16:28:15  cwatson
* Now uses .hh for c++ include files.
*
* Revision 1.2  1997/10/09 11:09:17  ian
* Changed corba_defs to corba_supp.
*
* Revision 1.1  1997/10/04 10:34:25  ian
* Initial version.
*
*/


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

int ReleaseAny(VSAny *pAny)
{
	delete (CORBA::Any *)pAny;

	return TRUE;
}

#define IS_EQUAL_FUNCTION(EQUAL_FUNCTION, TYPE) \
	int EQUAL_FUNCTION(VSAny *pAny1, TYPE s1) \
	{ \
			CORBA::Any *pAny2 = (CORBA::Any *)pAny1; \
			TYPE s2; \
	 \
			if (*pAny2 >>= s2) \
				return (s1 == s2); \
	\
			return FALSE; \
	} 

	IS_EQUAL_FUNCTION(IsAnyToShortEqual, VSShort);
	IS_EQUAL_FUNCTION(IsAnyToUShortEqual, VSUShort);
	IS_EQUAL_FUNCTION(IsAnyToLongEqual, VSLong);
	IS_EQUAL_FUNCTION(IsAnyToULongEqual, VSULong);
	IS_EQUAL_FUNCTION(IsAnyToFloatEqual, VSFloat);
	IS_EQUAL_FUNCTION(IsAnyToDoubleEqual, VSDouble);

	int IsAnyToUnboundStringEqual(VSAny *pAny1, VSString s1) 
	{ 
			CORBA::Any *pAny2 = (CORBA::Any *)pAny1; 
			VSString s2; 
	 
			if (*pAny2 >>= s2)
	 			return (!::strcmp(s1, s2)); 

			return FALSE;
	} 

#define AMBIGUOUS_IS_EQUAL_FUNCTION(EQUAL_FUNCTION, TYPE, CORBA_TYPE, ANY_STRUCT) \
	int EQUAL_FUNCTION(VSAny *pAny1, TYPE b1) \
	{ \
		CORBA::Any *pAny2 = (CORBA::Any *)pAny1; \
	\
		CORBA_TYPE b2; \
		CORBA::Any::ANY_STRUCT tb((CORBA_TYPE &)b2); \
	 \
		if (*pAny2 >>= tb) \
	 		return (b1 == b2); \
	\
		return FALSE; \
	} 

	AMBIGUOUS_IS_EQUAL_FUNCTION(IsAnyToBooleanEqual, VSBoolean, CORBA::Boolean, to_boolean);
	AMBIGUOUS_IS_EQUAL_FUNCTION(IsAnyToOctetEqual, VSOctet, CORBA::Octet, to_octet);
	AMBIGUOUS_IS_EQUAL_FUNCTION(IsAnyToCharEqual, VSChar, CORBA::Char, to_char);

} // extern "C"
