
//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <corba_defs_aux.h>

//-----------------------------------------------------------
// General.

int no_exception(VSEnvironment *ev)
{
		CORBA::Environment	*env = (CORBA::Environment *) ev;
		if(!env)
				return TRUE;

		CORBA::Exception *ex = env->exception();
		if(ex)
				return FALSE;
		return TRUE;
}


//-----------------------------------------------------------
// Functions to operate on Exceptions directly.

int ex_user_exception(VSException *ev)
{
    CORBA::Exception *ex = (CORBA::Exception *) ev;
 
    CORBA::UserException *se;
    if((se = CORBA::UserException::_downcast(ex)))
        return TRUE;
 
    return FALSE;
}
 
int ex_system_exception(VSException *ev)
{
    CORBA::Exception *ex = (CORBA::Exception *) ev;
    CORBA::SystemException *se;
    if((se = CORBA::SystemException::_downcast(ex)))
        return TRUE;
 
    return FALSE;
}

int ex_system_exception_is(VSString str,VSException *pex)
{
		CORBA::Exception *ex = (CORBA::Exception *) pex;
    CORBA::SystemException *se;

		if(!pex)
				return FALSE;

    if(se = CORBA::SystemException::_downcast(ex)){
        if(strcmp(str,"UNKNOWN") == 0)
            return (CORBA::UNKNOWN::_downcast(se)) ? TRUE : FALSE;
        if(strcmp(str,"BAD_PARAM") == 0)
            return (CORBA::BAD_PARAM::_downcast(se)) ? TRUE : FALSE;
        if(strcmp(str,"NO_MEMORY") == 0)
            return (CORBA::NO_MEMORY::_downcast(se)) ? TRUE : FALSE;
        if(strcmp(str,"IMP_LIMIT") == 0)
            return (CORBA::IMP_LIMIT::_downcast(se)) ? TRUE : FALSE;
        if(strcmp(str,"COMM_FAILURE") == 0)
            return (CORBA::COMM_FAILURE::_downcast(se)) ? TRUE : FALSE;
        if(strcmp(str,"INV_OBJREF") == 0)
            return (CORBA::INV_OBJREF::_downcast(se)) ? TRUE : FALSE;
				if(strcmp(str,"NO_PERMISSION") == 0)
            return (CORBA::NO_PERMISSION::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"INTERNAL") == 0)
            return (CORBA::INTERNAL::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"MARSHAL") == 0)
            return (CORBA::MARSHAL::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"INITIALIZE") == 0)
            return (CORBA::INITIALIZE::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"NO_IMPLEMENT") == 0)
            return (CORBA::NO_IMPLEMENT::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"BAD_TYPECODE") == 0)
            return (CORBA::BAD_TYPECODE::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"BAD_OPERATION") == 0)
            return (CORBA::BAD_OPERATION::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"NO_RESOURCES") == 0)
            return (CORBA::NO_RESOURCES::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"NO_RESPONSE") == 0)
            return (CORBA::NO_RESPONSE::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"PERSIST_STORE") == 0)
            return (CORBA::PERSIST_STORE::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"BAD_INV_ORDER") == 0)
            return (CORBA::BAD_INV_ORDER::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"TRANSIENT") == 0)
            return (CORBA::TRANSIENT::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"FREE_MEM") == 0)
            return (CORBA::FREE_MEM::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"INV_IDENT") == 0)
            return (CORBA::INV_IDENT::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"INV_FLAG") == 0)
            return (CORBA::INV_FLAG::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"INTF_REPOS") == 0)
            return (CORBA::INTF_REPOS::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"BAD_CONTEXT") == 0)
            return (CORBA::BAD_CONTEXT::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"OBJ_ADAPTER") == 0)
            return (CORBA::OBJ_ADAPTER::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"DATA_CONVERSION") == 0)
            return (CORBA::DATA_CONVERSION::_downcast(se)) ? TRUE : FALSE;;
        if(strcmp(str,"OBJECT_NOT_EXIST") == 0)
            return (CORBA::OBJECT_NOT_EXIST::_downcast(se)) ? TRUE : FALSE;
    }
    return FALSE;
}

VSString exception_to_string(VSException *exparam)
{
		CORBA::Exception *ex = (CORBA::Exception *) exparam;
		CORBA::SystemException *se;
		CORBA::UserException *ue;

		if(ue = CORBA::UserException::_downcast(ex)){
				
				if(CORBA::ORB::InvalidName::_downcast(se))
						return CORBA::string_dup("ORB::InvalidName");
                                if(CORBA::Bounds::_downcast(se))
						return CORBA::string_dup("CORBA::Bounds");

				if(CORBA::TypeCode::BadKind::_downcast(se))
						return CORBA::string_dup("TypeCode::BadKind");
				if(CORBA::TypeCode::Bounds::_downcast(se))
						return CORBA::string_dup("TypeCode::Bounds");
				if(CORBA::PolicyError::_downcast(se))
						return CORBA::string_dup("PolicyError");

				return 0;
		}

		if(se = CORBA::SystemException::_downcast(ex)){

				if(CORBA::UNKNOWN::_downcast(se))
						return CORBA::string_dup("UNKNOWN");
				if(CORBA::BAD_PARAM::_downcast(se))
						return CORBA::string_dup("BAD_PARAM");
				if(CORBA::NO_MEMORY::_downcast(se))
						return CORBA::string_dup("NO_MEMORY");
				if(CORBA::IMP_LIMIT::_downcast(se))
						return CORBA::string_dup("IMP_LIMIT");
				if(CORBA::COMM_FAILURE::_downcast(se))
						return CORBA::string_dup("COMM_FAILURE");
				if(CORBA::INV_OBJREF::_downcast(se))
						return CORBA::string_dup("INV_OBJREF");

				if(CORBA::NO_PERMISSION::_downcast(se))
						return CORBA::string_dup("NO_PERMISSION");
				if(CORBA::INTERNAL::_downcast(se))
						return CORBA::string_dup("INTERNAL");
				if(CORBA::MARSHAL::_downcast(se))
						return CORBA::string_dup("MARSHAL");
				if(CORBA::INITIALIZE::_downcast(se))
						return CORBA::string_dup("INITIALIZE");
				if(CORBA::NO_IMPLEMENT::_downcast(se))
						return CORBA::string_dup("NO_IMPLEMENT");
				if(CORBA::BAD_TYPECODE::_downcast(se))
						return CORBA::string_dup("BAD_TYPECODE");
				if(CORBA::BAD_OPERATION::_downcast(se))
						return CORBA::string_dup("BAD_OPERATION");
				if(CORBA::NO_RESOURCES::_downcast(se))
						return CORBA::string_dup("NO_RESOURCES");
				if(CORBA::NO_RESPONSE::_downcast(se))
						return CORBA::string_dup("NO_RESPONSE");
				if(CORBA::PERSIST_STORE::_downcast(se))
						return CORBA::string_dup("PERSIST_STORE");
				if(CORBA::BAD_INV_ORDER::_downcast(se))
						return CORBA::string_dup("BAD_INV_ORDER");
				if(CORBA::TRANSIENT::_downcast(se))
						return CORBA::string_dup("TRANSIENT");
				if(CORBA::FREE_MEM::_downcast(se))
						return CORBA::string_dup("FREE_MEM");
				if(CORBA::INV_IDENT::_downcast(se))
						return CORBA::string_dup("INV_IDENT");
				if(CORBA::INV_FLAG::_downcast(se))
						return CORBA::string_dup("INV_FLAG");
				if(CORBA::INTF_REPOS::_downcast(se))
						return CORBA::string_dup("INTF_REPOS");
				if(CORBA::BAD_CONTEXT::_downcast(se))
						return CORBA::string_dup("BAD_CONTEXT");
				if(CORBA::OBJ_ADAPTER::_downcast(se))
						return CORBA::string_dup("OBJ_ADAPTER");
				if(CORBA::DATA_CONVERSION::_downcast(se))
						return CORBA::string_dup("DATA_CONVERSION");
				if(CORBA::OBJECT_NOT_EXIST::_downcast(se))
						return CORBA::string_dup("OBJECT_NOT_EXIST");
		}
		return 0;
}

//-----------------------------------------------------------
// Functions that operate on Exceptions via the Environment.

int user_exception(VSEnvironment *ev)
{
		CORBA::Environment	*env = (CORBA::Environment *) ev;
		CORBA::Exception *ex;
    CORBA::UserException *se;

		if(!env || !(ex = env->exception()))
				return FALSE;
		
    if((se = CORBA::UserException::_downcast(ex)))
        return TRUE;
 
    return FALSE;
}

int system_exception(VSEnvironment *ev)
{
		CORBA::Environment	*env = (CORBA::Environment *) ev;
		CORBA::Exception *ex;
    CORBA::SystemException *se;

		if(!env || !(ex = env->exception()))
				return FALSE;

    if((se = CORBA::SystemException::_downcast(ex)))
        return TRUE;
 
    return FALSE;
}

//-----------------------------------------------------------

int system_exception_is(VSString str,VSEnvironment *ev)
{
		CORBA::Environment	*env = (CORBA::Environment *) ev;
		CORBA::Exception *ex;

		if(!env || !(ex = env->exception()))
				return FALSE;

		return ex_system_exception_is(str,(VSException *) ex);
}

int user_exception_is(VSString str,VSEnvironment *ev)
{
		CORBA::Environment	*env = (CORBA::Environment *) ev;
		if(!env)
				return FALSE;

		CORBA::Exception *ex;
		CORBA::UserException *se;

		if((ex = env->exception()) && (se = CORBA::UserException::_downcast(ex))){
				if(strcmp(str,"NOT_IMPLEMENTED") == 0)
						return (not_implemented::_downcast(ex)) ? TRUE : FALSE;
				if(strcmp(str,"ORB::InvalidName") == 0)
						return (CORBA::ORB::InvalidName::_downcast(se)) ? TRUE : FALSE;

                                if(strcmp(str,"CORBA::Bounds") == 0)
						return (CORBA::Bounds::_downcast(se)) ? TRUE : FALSE;

				if(strcmp(str,"TypeCode::BadKind") == 0)
						return (CORBA::TypeCode::BadKind::_downcast(se)) ? TRUE : FALSE;
				if(strcmp(str,"TypeCode::Bounds") == 0)
						return (CORBA::TypeCode::Bounds::_downcast(se)) ? TRUE : FALSE;
				if(strcmp(str,"PolicyError") == 0)
				    return (CORBA::PolicyError::_downcast(se)) ? TRUE : FALSE;
				
		}
		
		return FALSE;
}


//-----------------------------------------------------------

CORBA::Exception *exception_convert(CORBA::Exception *exparam)
{
		CORBA::Exception *rex = 0;
		CORBA::Exception *ex = (CORBA::Exception *) exparam;
		CORBA::SystemException *se;
		CORBA::UserException *ue;

		if(ue = CORBA::UserException::_downcast(ex)){
				if(rex = CORBA::ORB::InvalidName::_downcast(ue))
						return new CORBA::ORB::InvalidName();
                                if(rex = CORBA::Bounds::_downcast(ue))
						return new CORBA::Bounds();

				if(rex = CORBA::TypeCode::BadKind::_downcast(ue))
						return new CORBA::TypeCode::BadKind();
				if(rex = CORBA::TypeCode::Bounds::_downcast(ue))
						return new CORBA::TypeCode::Bounds();

				/* Policy Exception */
				if(rex = CORBA::PolicyError::_downcast(ue))
						return new CORBA::PolicyError();

				/* POA Exception */
				if(PortableServer::POAManager::AdapterInactive::_downcast(ue))
				  return new PortableServer::POAManager::AdapterInactive();
				
				if(PortableServer::Current::NoContext::_downcast(ue))
				  return new PortableServer::Current::NoContext();

				if(PortableServer::POA::WrongPolicy::_downcast(ue))
				  return new PortableServer::POA::WrongPolicy();
 
				if(PortableServer::POA::AdapterAlreadyExists::_downcast(ue))
				  return new PortableServer::POA::AdapterAlreadyExists();

				if(PortableServer::POA::AdapterNonExistent::_downcast(ue))
				  return new PortableServer::POA::AdapterNonExistent();

				if(PortableServer::POA::InvalidPolicy::_downcast(ue))     
				  return new PortableServer::POA::InvalidPolicy();

				if(PortableServer::POA::NoServant::_downcast(ue))     
				  return new PortableServer::POA::NoServant();

				if(PortableServer::POA::ObjectAlreadyActive::_downcast(ue))     
				  return new PortableServer::POA::ObjectAlreadyActive();

				if(PortableServer::POA::ObjectNotActive::_downcast(ue))     
				  return new PortableServer::POA::ObjectNotActive();

				if(PortableServer::POA::ServantAlreadyActive::_downcast(ue))     
				  return new PortableServer::POA::ServantAlreadyActive();

				if(PortableServer::POA::ServantNotActive::_downcast(ue))     
				  return new PortableServer::POA::ServantNotActive();

				if(PortableServer::POA::WrongAdapter::_downcast(ue))     
				  return new PortableServer::POA::WrongAdapter();
				/* DAny Exception */	
				if(DynamicAny::DynAny::InvalidValue::_downcast(ue))
				    return new DynamicAny::DynAny::InvalidValue();

				if(DynamicAny::DynAny::TypeMismatch::_downcast(ue))
				    return new DynamicAny::DynAny::TypeMismatch;

				if(rex = DynamicAny::DynAnyFactory::InconsistentTypeCode::_downcast(ue))
				    return new DynamicAny::DynAnyFactory::InconsistentTypeCode;


				return 0;
		}

		if(se = CORBA::SystemException::_downcast(ex)){

				if(rex = CORBA::UNKNOWN::_downcast(se))
						return new CORBA::UNKNOWN();
				if(rex = CORBA::BAD_PARAM::_downcast(se))
						return new CORBA::BAD_PARAM();
				if(rex = CORBA::NO_MEMORY::_downcast(se))
						return new CORBA::NO_MEMORY();
				if(rex = CORBA::IMP_LIMIT::_downcast(se))
						return new CORBA::IMP_LIMIT();
				if(rex = CORBA::COMM_FAILURE::_downcast(se))
						return new CORBA::COMM_FAILURE();
				if(rex = CORBA::INV_OBJREF::_downcast(se))
						return new CORBA::INV_OBJREF();
				if(rex = CORBA::NO_PERMISSION::_downcast(se))
						return new CORBA::NO_PERMISSION();
				if(rex = CORBA::INTERNAL::_downcast(se))
						return new CORBA::INTERNAL();
				if(rex = CORBA::MARSHAL::_downcast(se))
						return new CORBA::MARSHAL();
				if(rex = CORBA::INITIALIZE::_downcast(se))
						return new CORBA::INITIALIZE();
				if(rex = CORBA::NO_IMPLEMENT::_downcast(se))
						return new CORBA::NO_IMPLEMENT();
				if(rex = CORBA::BAD_TYPECODE::_downcast(se))
						return new CORBA::BAD_TYPECODE();
				if(rex = CORBA::BAD_OPERATION::_downcast(se))
						return new CORBA::BAD_OPERATION();
				if(rex = CORBA::NO_RESOURCES::_downcast(se))
						return new CORBA::NO_RESOURCES();
				if(rex = CORBA::NO_RESPONSE::_downcast(se))
						return new CORBA::NO_RESPONSE();
				if(rex = CORBA::PERSIST_STORE::_downcast(se))
						return new CORBA::PERSIST_STORE();
				if(rex = CORBA::BAD_INV_ORDER::_downcast(se))
						return new CORBA::BAD_INV_ORDER();
				if(rex = CORBA::TRANSIENT::_downcast(se))
						return new CORBA::TRANSIENT();
				if(rex = CORBA::FREE_MEM::_downcast(se))
						return new CORBA::FREE_MEM();
				if(rex = CORBA::INV_IDENT::_downcast(se))
						return new CORBA::INV_IDENT();
				if(rex = CORBA::INV_FLAG::_downcast(se))
						return new CORBA::INV_FLAG();
				if(rex = CORBA::INTF_REPOS::_downcast(se))
						return new CORBA::INTF_REPOS();
				if(rex = CORBA::BAD_CONTEXT::_downcast(se))
						return new CORBA::BAD_CONTEXT();
				if(rex = CORBA::OBJ_ADAPTER::_downcast(se))
						return new CORBA::OBJ_ADAPTER();
				if(rex = CORBA::DATA_CONVERSION::_downcast(se))
						return new CORBA::DATA_CONVERSION();
				if(rex = CORBA::OBJECT_NOT_EXIST::_downcast(se))
						return new CORBA::OBJECT_NOT_EXIST();
		}
		return 0;
}


//--------------------------------------------------------------
// POA Defs
int POA_user_exception_is(VSString str, VSEnvironment *ev)
{
  CORBA::Environment *env = (CORBA::Environment *) ev;
 
  if(!env)
    return FALSE;

  CORBA::Exception *ex;
  CORBA::UserException *ue;

  if((ex = env->exception()) && (ue = CORBA::UserException::_downcast(ex))){
    
    if(strcmp(str, "AdapterInactive") == 0)
      return (PortableServer::POAManager::AdapterInactive::_downcast(ue)) ? TRUE : FALSE;

    if(strcmp(str, "NoContext") == 0)
      return (PortableServer::Current::NoContext::_downcast(ue)) ? TRUE : FALSE;
     
    if(strcmp(str, "WrongPolicy") == 0)
      return (PortableServer::POA::WrongPolicy::_downcast(ue)) ? TRUE : FALSE;

    if(strcmp(str, "AdapterAlreadyExists") == 0)
      return (PortableServer::POA::AdapterAlreadyExists::_downcast(ue)) ? TRUE : FALSE;

    if(strcmp(str, "InvalidPolicy") == 0)
      return (PortableServer::POA::InvalidPolicy::_downcast(ue)) ? TRUE : FALSE;

    if(strcmp(str, "AdapterNonExistent") == 0)
      return (PortableServer::POA::AdapterNonExistent::_downcast(ue)) ? TRUE : FALSE;

    if(strcmp(str, "NoServant") == 0)
      return (PortableServer::POA::NoServant::_downcast(ue)) ? TRUE : FALSE;

    if(strcmp(str, "ObjectAlreadyActive") == 0)
      return (PortableServer::POA::ObjectAlreadyActive::_downcast(ue)) ? TRUE : FALSE;

    if(strcmp(str, "ObjectNotActive") == 0)
      return (PortableServer::POA::ObjectNotActive::_downcast(ue)) ? TRUE : FALSE;

    if(strcmp(str, "ServantAlreadyActive") == 0)
      return (PortableServer::POA::ServantAlreadyActive::_downcast(ue)) ? TRUE : FALSE;

    if(strcmp(str, "ServantNotActive") == 0)
      return (PortableServer::POA::ServantNotActive::_downcast(ue)) ? TRUE : FALSE;

    if(strcmp(str, "WrongAdapter") == 0)
      return (PortableServer::POA::WrongAdapter::_downcast(ue)) ? TRUE : FALSE;   
    
  }

  return FALSE;
}

//--------------------------------------------------------------
// DAny Defs
int DAny_user_exception_is(VSString str, VSEnvironment *ev)
{
  CORBA::Environment *env = (CORBA::Environment *) ev;
 
  if(!env)
    return FALSE;

  CORBA::Exception *ex;
  CORBA::UserException *ue;

  if((ex = env->exception()) && (ue = CORBA::UserException::_downcast(ex))){
    
    if(strcmp(str, "InvalidValue") == 0)
	return (DynamicAny::DynAny::InvalidValue::_downcast(ue)) ? TRUE :FALSE;

    if(strcmp(str, "TypeMismatch") == 0)
      return (DynamicAny::DynAny::TypeMismatch::_downcast(ue)) ? TRUE : FALSE;
     
    if(strcmp(str, "InconsistentTypeCode") == 0)
      return (DynamicAny::DynAnyFactory::InconsistentTypeCode::_downcast(ue)) ? TRUE : FALSE;    
  }

  return FALSE;
}


//----------------------------------------------------------------
// POA Defs

CORBA::Exception *POA_exception_convert(CORBA::Exception *exparam)
{
  CORBA::Exception *rex = 0;
  CORBA::Exception *ex = (CORBA::Exception *) exparam;
  CORBA::SystemException *se;
  CORBA::UserException *ue;

  if(ue = CORBA::UserException::_downcast(ex)){
    if(PortableServer::POAManager::AdapterInactive::_downcast(ue))
      return new PortableServer::POAManager::AdapterInactive();

    if(PortableServer::Current::NoContext::_downcast(ue))
      return new PortableServer::Current::NoContext();

    if(PortableServer::POA::WrongPolicy::_downcast(ue))
      return new PortableServer::POA::WrongPolicy();
 
    if(PortableServer::POA::AdapterAlreadyExists::_downcast(ue))
      return new PortableServer::POA::AdapterAlreadyExists();

    if(PortableServer::POA::AdapterNonExistent::_downcast(ue))
      return new PortableServer::POA::AdapterNonExistent();

    if(PortableServer::POA::InvalidPolicy::_downcast(ue))     
      return new PortableServer::POA::InvalidPolicy();

    if(PortableServer::POA::NoServant::_downcast(ue))     
      return new PortableServer::POA::NoServant();

    if(PortableServer::POA::ObjectAlreadyActive::_downcast(ue))     
      return new PortableServer::POA::ObjectAlreadyActive();

    if(PortableServer::POA::ObjectNotActive::_downcast(ue))     
      return new PortableServer::POA::ObjectNotActive();

    if(PortableServer::POA::ServantAlreadyActive::_downcast(ue))     
      return new PortableServer::POA::ServantAlreadyActive();

    if(PortableServer::POA::ServantNotActive::_downcast(ue))     
      return new PortableServer::POA::ServantNotActive();

    if(PortableServer::POA::WrongAdapter::_downcast(ue))     
      return new PortableServer::POA::WrongAdapter();
}

  return 0;
}


//----------------------------------------------------------------
// DAny Defs
CORBA::Exception *DAny_exception_convert(CORBA::Exception *exparam)
{
  CORBA::Exception *rex = 0;
  CORBA::Exception *ex = (CORBA::Exception *) exparam;
  CORBA::SystemException *se;
  CORBA::UserException *ue;
  
  if(ue = CORBA::UserException::_downcast(ex)) {
      if(DynamicAny::DynAny::InvalidValue::_downcast(ue))
	  return new DynamicAny::DynAny::InvalidValue();

      if(DynamicAny::DynAny::TypeMismatch::_downcast(ue))
	  return new DynamicAny::DynAny::TypeMismatch;

      if(rex = DynamicAny::DynAnyFactory::InconsistentTypeCode::_downcast(ue))
	  return new DynamicAny::DynAnyFactory::InconsistentTypeCode;
  }
  return 0;
}	

}

