//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <corba_defs_aux.h>

//-----------------------------------------------------------
// General Object.

int is_nil_object_ptr(VSObject_ptr *o1)
{
		CORBA::Object_ptr *optr1 = (CORBA::Object_ptr *) o1;
		if(!optr1)
				return TRUE;

		return CORBA::is_nil(*optr1);
}

int is_invalid_object_ptr(VSObject_ptr *o1)
{
		CORBA::Object_ptr *optr1 = (CORBA::Object_ptr *) o1;

		/* Special pointer comparison. There is only one invalid	*/
		/* Object and it is maintained in TS. */
		CORBA::Object_ptr *optr2 = glob_TS.invalid_object_ptr();
		return (optr1 == optr2);
}

//-----------------------------------------------------------
// General NamedValue_ptr.

int is_nil_nvalue_ptr(VSNamedValue_ptr *o1)
{
		CORBA::NamedValue_ptr *optr1 = (CORBA::NamedValue_ptr *) o1;
		
		if(!optr1)
				return TRUE;

		return CORBA::is_nil(*optr1);
}

int is_invalid_nvalue_ptr(VSNamedValue_ptr *o1)
{
		CORBA::NamedValue_ptr *optr1 = (CORBA::NamedValue_ptr *) o1;

		/* Special pointer comparison. There is only one invalid	*/
		/* NamedValue and it is maintained in TS. */
		CORBA::NamedValue_ptr *optr2 = glob_TS.invalid_nvalue_ptr();
		return (optr1 == optr2);
}

//-----------------------------------------------------------
// General TypeCode_ptr.

int is_nil_typecode_ptr(VSTypeCode_ptr *o1)
{
		CORBA::TypeCode_ptr *optr1 = (CORBA::TypeCode_ptr *) o1;
		if(!optr1)
				return TRUE;

		return CORBA::is_nil(*optr1);
}

int is_invalid_typecode_ptr(VSTypeCode_ptr *o1)
{
		CORBA::TypeCode_ptr *optr1 = (CORBA::TypeCode_ptr *) o1;

		/* Special pointer comparison. There is only one invalid	*/
		/* TypeCode and it is maintained in TS. */
		CORBA::TypeCode_ptr *optr2 = glob_TS.invalid_typecode_ptr();
		return (optr1 == optr2);
}

//-----------------------------------------------------------
// General Environment_ptr.

int is_nil_env_ptr(VSEnvironment_ptr *o1)
{
		CORBA::Environment_ptr *optr1 = (CORBA::Environment_ptr *) o1;
		if(!optr1)
				return TRUE;

		return CORBA::is_nil(*optr1);
}

int is_invalid_env_ptr(VSEnvironment_ptr *o1)
{
		CORBA::Environment_ptr *optr1 = (CORBA::Environment_ptr *) o1;

		/* Special pointer comparison. There is only one invalid	*/
		/* Environment and it is maintained in TS. */
		CORBA::Environment_ptr *optr2 = glob_TS.invalid_env_ptr();
		return (optr1 == optr2);
}

//-----------------------------------------------------------
// General NVList_ptr.

int is_nil_nvlist_ptr(VSNVList_ptr *o1)
{
		CORBA::NVList_ptr *optr1 = (CORBA::NVList_ptr *) o1;
		if(!optr1)
				return TRUE;

		return CORBA::is_nil(*optr1);
}

int is_invalid_nvlist_ptr(VSNVList_ptr *o1)
{
		CORBA::NVList_ptr *optr1 = (CORBA::NVList_ptr *) o1;

		/* Special pointer comparison. There is only one invalid	*/
		/* NVList and it is maintained in TS. */
		CORBA::NVList_ptr *optr2 = glob_TS.invalid_nvlist_ptr();
		return (optr1 == optr2);
}

//-----------------------------------------------------------
// General Context_ptr.

int is_nil_context_ptr(VSContext_ptr *o1)
{
		CORBA::Context_ptr *optr1 = (CORBA::Context_ptr *) o1;
		if(!optr1)
				return TRUE;

		return CORBA::is_nil(*optr1);
}

int is_invalid_context_ptr(VSContext_ptr *o1)
{
		CORBA::Context_ptr *optr1 = (CORBA::Context_ptr *) o1;

		/* Special pointer comparison. There is only one invalid	*/
		/* Context and it is maintained in TS. */
		CORBA::Context_ptr *optr2 = glob_TS.invalid_context_ptr();
		return (optr1 == optr2);
}

//-----------------------------------------------------------
// General Request_ptr.

int is_nil_request_ptr(VSRequest_ptr *o1)
{
		CORBA::Request_ptr *optr1 = (CORBA::Request_ptr *) o1;
		if(!optr1)
				return TRUE;

		return CORBA::is_nil(*optr1);
}

int is_invalid_request_ptr(VSRequest_ptr *o1)
{
		CORBA::Request_ptr *optr1 = (CORBA::Request_ptr *) o1;

		/* Special pointer comparison. There is only one invalid	*/
		/* Request and it is maintained in TS. */
		CORBA::Request_ptr *optr2 = glob_TS.invalid_request_ptr();
		return (optr1 == optr2);
}

//-----------------------------------------------------------
// General ORB_ptr.

int is_nil_orb_ptr(VSORB_ptr *o1)
{
    CORBA::ORB_ptr *optr1 = (CORBA::ORB_ptr *) o1;
    if(!optr1)
	return TRUE;
    
    return CORBA::is_nil(*optr1);
}

int is_invalid_orb_ptr(VSORB_ptr *o1)
{
		CORBA::ORB_ptr *optr1 = (CORBA::ORB_ptr *) o1;

		/* Special pointer comparison. There is only one invalid	*/
		/* ORB and it is maintained in TS. */
		CORBA::ORB_ptr *optr2 = glob_TS.invalid_orb_ptr();
		return (optr1 == optr2);
}

//-----------------------------------------------------------
// General ContextList_ptr.

int is_nil_ctxlist_ptr(VSContextList_ptr *o1)
{
		CORBA::ContextList_ptr *optr1 = (CORBA::ContextList_ptr *) o1;
		if(!optr1)
				return TRUE;

		return CORBA::is_nil(*optr1);
}

int is_invalid_ctxlist_ptr(VSContextList_ptr *o1)
{
		CORBA::ContextList_ptr *optr1 = (CORBA::ContextList_ptr *) o1;

		/* Special pointer comparison. There is only one invalid	*/
		/* ContextList and it is maintained in TS. */
		CORBA::ContextList_ptr *optr2 = glob_TS.invalid_ctxlist_ptr();
		return (optr1 == optr2);
}

//-----------------------------------------------------------
// General ExceptionList_ptr.

int is_nil_exlist_ptr(VSExceptionList_ptr *o1)
{
		CORBA::ExceptionList_ptr *optr1 = (CORBA::ExceptionList_ptr *) o1;
		if(!optr1)
				return TRUE;

		return CORBA::is_nil(*optr1);
}

int is_invalid_exlist_ptr(VSExceptionList_ptr *o1)
{
		CORBA::ExceptionList_ptr *optr1 = (CORBA::ExceptionList_ptr *) o1;

		/* Special pointer comparison. There is only one invalid	*/
		/* ExceptionList and it is maintained in TS. */
		CORBA::ExceptionList_ptr *optr2 = glob_TS.invalid_exlist_ptr();
		return (optr1 == optr2);
}

}
