//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/corba/corba/corba_defs_tdd.cpp
//
// Purpose:
//
// Modifications:
// $Log: corba_defs_tdd.cpp,v $
// Revision 1.2  2000/05/23 16:53:32  mli
//   o   changed provide_env and relinquish_env for CORBA::Environment
//
// Revision 1.1.1.1  2000/02/09 17:14:39  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.3  1997/10/04 16:43:04  stephen
// Changed include to corba_supp.hh.
//
// Revision 1.2  1997/10/01 15:34:19  cwatson
// Makefile changes.
// corba_defs.hpp moved to c++/include/corba_supp.hh.
//
// Revision 1.1  1997/08/06 14:39:02  cwatson
// *** empty log message ***
//
//

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <corba_defs_tdd.h>
#include <corba_defs.h>

/* ---- global property declarations ---- */
/* ---- test variables and local properties ---- */

/* ------------------------------------------------------------ */
/* test variable CORBA_Environment * env() */

int provide_env (VSEnvironment ** testvar)
{
		CORBA::Environment *tvar;
                CORBA::ORB_ptr orb = glob_TS.m_corb->orb();
                if(!CORBA::is_nil(orb))
                  orb->create_environment(tvar);

		// tvar = new CORBA::Environment();
		if(tvar){
				*testvar = (VSEnvironment *) tvar;
				return TRUE;
		}

		return FALSE;
}

int relinquish_env (VSEnvironment ** testvar)
{
		CORBA::Environment ** tvar = (CORBA::Environment **) testvar;
		// delete *tvar;
                if (!CORBA::is_nil(*tvar))
                    CORBA::release(*tvar);
                                               
		return TRUE;
}


/* ------------------------------------------------------------ */
/* test variable  int * argc() */

int provide_argc (int** testvar)
{
		static int tmp = 1;
		*testvar = &tmp;
		return TRUE;
}

int relinquish_argc (int** testvar)
{
		return TRUE;
}

/* ------------------------------------------------------------ */
/* test variable  char * * argv() */

static char *targv[2] = {
		"VSORB_init1",
		NULL
};

int provide_argv (char*** testvar)
{
		*testvar = targv;
		return TRUE;
}

int relinquish_argv (char*** testvar)
{
		return TRUE;
}

}
