/*
 * ./corba_defs_tdd.h
 * generated from corba_defs.tdd by ADLT
 */
#ifndef CORBA_DEFS_TDD_H
#define CORBA_DEFS_TDD_H 1

#include <adl_reporting.h>
#include "corba_defs_aux.h"

/* ---- global property declarations ---- */
enum prop_str_val {Pstr_val_good, Pstr_val_null, Pstr_val_empty};
#define PROP_STR_VAL_SZ 3

/* ---- test variables and local properties ---- */
/* test variable VSEnvironment * env() */
int provide_env (void*** testvar);
int relinquish_env (void*** testvar);

/* test variable  int * argc() */
int provide_argc (int** testvar);
int relinquish_argc (int** testvar);

/* test variable  char * * argv() */
int provide_argv (char*** testvar);
int relinquish_argv (char*** testvar);

enum prop_target_object_ptr_v {Ptarget_object_ptr_v_valid, Ptarget_object_ptr_v_nil, Ptarget_object_ptr_v_invalid};
#define PROP_TARGET_OBJECT_PTR_V_SZ 3

/* test variable VSObject_ptr * target_object_ptr(prop v) */
int provide_target_object_ptr (void*** testvar, enum prop_target_object_ptr_v v);
int relinquish_target_object_ptr (void*** testvar, enum prop_target_object_ptr_v v);

enum prop_nvalue_ptr_v {Pnvalue_ptr_v_valid, Pnvalue_ptr_v_nil, Pnvalue_ptr_v_invalid};
#define PROP_NVALUE_PTR_V_SZ 3

/* test variable VSNamedValue_ptr * nvalue_ptr(prop v) */
int provide_nvalue_ptr (void*** testvar, enum prop_nvalue_ptr_v v);
int relinquish_nvalue_ptr (void*** testvar, enum prop_nvalue_ptr_v v);

enum prop_typecode_ptr_v {Ptypecode_ptr_v_valid, Ptypecode_ptr_v_nil, Ptypecode_ptr_v_invalid};
#define PROP_TYPECODE_PTR_V_SZ 3

/* test variable VSTypeCode_ptr * typecode_ptr(prop v) */
int provide_typecode_ptr (void*** testvar, enum prop_typecode_ptr_v v);
int relinquish_typecode_ptr (void*** testvar, enum prop_typecode_ptr_v v);

enum prop_env_ptr_v {Penv_ptr_v_valid, Penv_ptr_v_nil, Penv_ptr_v_null, Penv_ptr_v_invalid};
#define PROP_ENV_PTR_V_SZ 4

/* test variable VSEnvironment_ptr * env_ptr(prop v) */
int provide_env_ptr (void*** testvar, enum prop_env_ptr_v v);
int relinquish_env_ptr (void*** testvar, enum prop_env_ptr_v v);

enum prop_nvlist_ptr_v {Pnvlist_ptr_v_valid, Pnvlist_ptr_v_valid1, Pnvlist_ptr_v_nil, Pnvlist_ptr_v_null, Pnvlist_ptr_v_invalid};
#define PROP_NVLIST_PTR_V_SZ 5

/* test variable VSNVList_ptr * nvlist_ptr(prop v) */
int provide_nvlist_ptr (void*** testvar, enum prop_nvlist_ptr_v v);
int relinquish_nvlist_ptr (void*** testvar, enum prop_nvlist_ptr_v v);

enum prop_request_ptr_v {Prequest_ptr_v_valid, Prequest_ptr_v_nil, Prequest_ptr_v_null, Prequest_ptr_v_invalid};
#define PROP_REQUEST_PTR_V_SZ 4

/* test variable VSRequest_ptr * request_ptr(prop v) */
int provide_request_ptr (void*** testvar, enum prop_request_ptr_v v);
int relinquish_request_ptr (void*** testvar, enum prop_request_ptr_v v);

enum prop_context_ptr_v {Pcontext_ptr_v_valid, Pcontext_ptr_v_nil, Pcontext_ptr_v_null, Pcontext_ptr_v_invalid};
#define PROP_CONTEXT_PTR_V_SZ 4

/* test variable VSContext_ptr * context_ptr(prop v) */
int provide_context_ptr (void*** testvar, enum prop_context_ptr_v v);
int relinquish_context_ptr (void*** testvar, enum prop_context_ptr_v v);

enum prop_ctxlist_ptr_v {Pctxlist_ptr_v_valid, Pctxlist_ptr_v_valid1, Pctxlist_ptr_v_nil, Pctxlist_ptr_v_null, Pctxlist_ptr_v_invalid};
#define PROP_CTXLIST_PTR_V_SZ 5

/* test variable VSContextList_ptr * ctxlist_ptr(prop v) */
int provide_ctxlist_ptr (void*** testvar, enum prop_ctxlist_ptr_v v);
int relinquish_ctxlist_ptr (void*** testvar, enum prop_ctxlist_ptr_v v);

enum prop_exlist_ptr_v {Pexlist_ptr_v_valid, Pexlist_ptr_v_valid1, Pexlist_ptr_v_nil, Pexlist_ptr_v_null, Pexlist_ptr_v_invalid};
#define PROP_EXLIST_PTR_V_SZ 5

/* test variable VSExceptionList_ptr * exlist_ptr(prop v) */
int provide_exlist_ptr (void*** testvar, enum prop_exlist_ptr_v v);
int relinquish_exlist_ptr (void*** testvar, enum prop_exlist_ptr_v v);

enum prop_orb_ptr_v {Porb_ptr_v_valid, Porb_ptr_v_nil, Porb_ptr_v_null, Porb_ptr_v_invalid};
#define PROP_ORB_PTR_V_SZ 4

/* test variable VSORB_ptr * orb_ptr(prop v) */
int provide_orb_ptr (void*** testvar, enum prop_orb_ptr_v v);
int relinquish_orb_ptr (void*** testvar, enum prop_orb_ptr_v v);

enum prop_repid_v {Prepid_v_empty};
#define PROP_REPID_V_SZ 1

/* test variable VSRepositoryId repid(prop v) */
int provide_repid (VSRepositoryId *testvar, enum prop_repid_v v);
int relinquish_repid (VSRepositoryId *testvar, enum prop_repid_v v);

enum prop_name_v {Pname_v_good, Pname_v_empty};
#define PROP_NAME_V_SZ 2

/* test variable VSIdentifier name(prop v) */
int provide_name (VSIdentifier *testvar, enum prop_name_v v);
int relinquish_name (VSIdentifier *testvar, enum prop_name_v v);

enum prop_struct_mseq_v {Pstruct_mseq_v_empty, Pstruct_mseq_v_good};
#define PROP_STRUCT_MSEQ_V_SZ 2

/* test variable VSStructMemberSeq * struct_mseq(prop v) */
int provide_struct_mseq (void*** testvar, enum prop_struct_mseq_v v);
int relinquish_struct_mseq (void*** testvar, enum prop_struct_mseq_v v);

enum prop_discriminator_type_v {Pdiscriminator_type_v_dshort, Pdiscriminator_type_v_dlong, Pdiscriminator_type_v_dushort, Pdiscriminator_type_v_dulong, Pdiscriminator_type_v_dchar, Pdiscriminator_type_v_dboolean};
#define PROP_DISCRIMINATOR_TYPE_V_SZ 6

/* test variable VSTypeCode_ptr * discriminator_type(prop v) */
int provide_discriminator_type (void*** testvar, enum prop_discriminator_type_v v);
int relinquish_discriminator_type (void*** testvar, enum prop_discriminator_type_v v);

enum prop_union_mseq_v {Punion_mseq_v_empty, Punion_mseq_v_good};
#define PROP_UNION_MSEQ_V_SZ 2

/* test variable VSUnionMemberSeq * union_mseq(prop v) */
int provide_union_mseq (void*** testvar, enum prop_union_mseq_v v);
int relinquish_union_mseq (void*** testvar, enum prop_union_mseq_v v);

enum prop_enum_mseq_v {Penum_mseq_v_empty, Penum_mseq_v_good};
#define PROP_ENUM_MSEQ_V_SZ 2

/* test variable VSEnumMemberSeq * enum_mseq(prop v) */
int provide_enum_mseq (void*** testvar, enum prop_enum_mseq_v v);
int relinquish_enum_mseq (void*** testvar, enum prop_enum_mseq_v v);

enum prop_typecode_v {Ptypecode_v_tvoid, Ptypecode_v_tshort, Ptypecode_v_tlong, Ptypecode_v_tushort, Ptypecode_v_tulong, Ptypecode_v_tfloat, Ptypecode_v_tdouble, Ptypecode_v_tboolean, Ptypecode_v_tchar, Ptypecode_v_toctet, Ptypecode_v_tany, Ptypecode_v_tTypeCode, Ptypecode_v_tPrincipal, Ptypecode_v_tobjref, Ptypecode_v_tstruct, Ptypecode_v_tunion, Ptypecode_v_tenum, Ptypecode_v_tstring, Ptypecode_v_tsequence, Ptypecode_v_tarray, Ptypecode_v_talias, Ptypecode_v_texcept};
#define PROP_TYPECODE_V_SZ 22

/* test variable VSTypeCode_ptr * typecode(prop v) */
int provide_typecode (void*** testvar, enum prop_typecode_v v);
int relinquish_typecode (void*** testvar, enum prop_typecode_v v);

#endif
