//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//
//

#include	<corba_supp.hh>
#include	<tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/

VSBoolean VSobj_is_nil(VSObject_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Boolean ret = FALSE;
		CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;

		try {
				ret = CORBA::is_nil(tc ? *tc : (CORBA::Object_ptr) 0);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return ret;
		}
		catch (...) {
				return ret;
		}

		return ret;
}

/*------------------------------------------------------*/

VSBoolean VSnvalue_is_nil(VSNamedValue_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Boolean ret = FALSE;
		CORBA::NamedValue_ptr *tc = (CORBA::NamedValue_ptr *) o1;

		try {
				ret = CORBA::is_nil(tc ? *tc : (CORBA::NamedValue_ptr) 0);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return ret;
		}
		catch (...) {
				return ret;
		}

		return ret;
}

/*------------------------------------------------------*/

VSBoolean VStypecode_is_nil(VSTypeCode_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Boolean ret = FALSE;
		CORBA::TypeCode_ptr *tc = (CORBA::TypeCode_ptr *) o1;

		try {
				ret = CORBA::is_nil(tc ? *tc : (CORBA::TypeCode_ptr) 0);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return ret;
		}
		catch (...) {
				return ret;
		}

		return ret;
}

/*------------------------------------------------------*/

VSBoolean VSenv_is_nil(VSEnvironment_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Boolean ret = FALSE;
		CORBA::Environment_ptr *tc = (CORBA::Environment_ptr *) o1;

		try {
				ret = CORBA::is_nil(tc ? *tc : (CORBA::Environment_ptr) 0);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return ret;
		}
		catch (...) {
				return ret;
		}

		return ret;
}

/*------------------------------------------------------*/

VSBoolean VSnvlist_is_nil(VSNVList_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Boolean ret = FALSE;
		CORBA::NVList_ptr *tc = (CORBA::NVList_ptr *) o1;

		try {
				ret = CORBA::is_nil(tc ? *tc : (CORBA::NVList_ptr) 0);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return ret;
		}
		catch (...) {
				return ret;
		}

		return ret;
}

/*------------------------------------------------------*/

VSBoolean VSrequest_is_nil(VSRequest_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Boolean ret = FALSE;
		CORBA::Request_ptr *tc = (CORBA::Request_ptr *) o1;

		try {
				ret = CORBA::is_nil(tc ? *tc : (CORBA::Request_ptr) 0);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return ret;
		}
		catch (...) {
				return ret;
		}

		return ret;
}

/*------------------------------------------------------*/

VSBoolean VScontext_is_nil(VSContext_ptr *o1, VSEnvironment *ev)
{
		CORBA::Boolean ret = FALSE;
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Context_ptr *tc = (CORBA::Context_ptr *) o1;

		try {
				ret = CORBA::is_nil(tc ? *tc : (CORBA::Context_ptr) 0);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return ret;
		}
		catch (...) {
				return ret;
		}

		return ret;
}

/*------------------------------------------------------*/

VSBoolean VSorb_is_nil(VSORB_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Boolean ret = FALSE;
		CORBA::ORB_ptr *tc = (CORBA::ORB_ptr *) o1;

		try {
				ret = CORBA::is_nil(tc ? *tc : (CORBA::ORB_ptr) 0);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return ret;
		}
		catch (...) {
				return ret;
		}

		return ret;
}

}

