//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/corba/isnil/t1_aux.cpp
//
// Purpose:
//
// Modifications:
// $Log: t1_aux.cpp,v $
// Revision 1.2  2001/01/17 11:17:27  corval2
// Update due to changes of variables.
//
// Revision 1.1.1.1  2000/02/09 17:14:40  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.4  1997/12/05 16:28:23  cwatson
// Now uses .hh for c++ include files.
//
// Revision 1.3  1997/10/09 10:53:21  tet
// Removed undeeded #define.
//
// Revision 1.2  1997/10/04 16:43:06  stephen
// Changed include to corba_supp.hh.
//
// Revision 1.1  1997/10/01 15:55:24  cwatson
// Initial is_nil() versions.
//
//


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <corba_defs_tdd.h>
#include <t1_aux.h>

//-----------------------------------------------------------

int obj_is_nil_ptr()
{
		unsigned long t = glob_TS.testcase(VSPROVIDE_OBJPTR);
		if(t == Ptarget_object_ptr_v_nil)
				return TRUE;

		return FALSE;
}

int nval_is_nil_ptr()
{
		unsigned long t = glob_TS.testcase(VSPROVIDE_NVALPTR);
		if(t == Pnvalue_ptr_v_nil)
				return TRUE;

		return FALSE;
}

int nvlist_is_nil_ptr()
{
		unsigned long t = glob_TS.testcase(VSPROVIDE_NVLISTPTR);
		if(t == Pnvlist_ptr_v_nil)
				return TRUE;
		if(t == Pnvlist_ptr_v_null)
				return TRUE;

		return FALSE;
}

int req_is_nil_ptr()
{
		unsigned long t = glob_TS.testcase(VSPROVIDE_REQPTR);
		if(t == Prequest_ptr_v_nil)
				return TRUE;
		if(t == Prequest_ptr_v_null)
				return TRUE;

		return FALSE;
}

int orb_is_nil_ptr()
{
		unsigned long t = glob_TS.testcase(VSPROVIDE_ORBPTR);
		if(t == Porb_ptr_v_nil)
				return TRUE;
		if(t == Porb_ptr_v_null)
				return TRUE;

		return FALSE;
}

int ctx_is_nil_ptr()
{
		unsigned long t = glob_TS.testcase(VSPROVIDE_CTXPTR);
		if(t == Pcontext_ptr_v_nil)
				return TRUE;
		if(t == Pcontext_ptr_v_null)
				return TRUE;

		return FALSE;
}

int tcode_is_nil_ptr()
{
		unsigned long t = glob_TS.testcase(VSPROVIDE_TCODEPTR);
		if(t == Ptypecode_ptr_v_nil)
				return TRUE;
		return FALSE;
}

int env_is_nil_ptr()
{
		unsigned long t = glob_TS.testcase(VSPROVIDE_ENVPTR);
		if(t == Penv_ptr_v_nil)
				return TRUE;
		if(t == Penv_ptr_v_null)
				return TRUE;

		return FALSE;
}

}
