//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include	<corba_supp.hh>
#include	<tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/

void VSobj_release(VSObject_ptr *o1, VSEnvironment *ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Object_ptr *tc = (CORBA::Object_ptr *) o1;

    try
    {
	if(tc)
	    CORBA::release(*tc);
    }
    catch (CORBA::Exception &ex)
    {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
	    env->exception(t);
	return;
    }
    catch (...)
    {
	return;
    }
    
    return;
}

/*------------------------------------------------------*/

void VSnvalue_release(VSNamedValue_ptr *o1, VSEnvironment *ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::NamedValue_ptr *tc = (CORBA::NamedValue_ptr *) o1;

    try
    {
	if(tc)
	    CORBA::release(*tc);
    }
    catch (CORBA::Exception &ex)
    {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
	    env->exception(t);
	return;
    }
    catch (...)
    {
	return;
    }

    return;
}

/*------------------------------------------------------*/

void VStypecode_release(VSTypeCode_ptr *o1, VSEnvironment *ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::TypeCode_ptr *tc = (CORBA::TypeCode_ptr *) o1;

    try
    {
	if(tc)
	    CORBA::release(*tc);
    }
    catch (CORBA::Exception &ex)
    {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
	    env->exception(t);
	return;
    }
    catch (...)
    {
	return;
    }

    return;
}

/*------------------------------------------------------*/

void VSenv_release(VSEnvironment_ptr *o1, VSEnvironment *ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Environment_ptr *tc = (CORBA::Environment_ptr *) o1;

    try
    {
	if(tc)
	    CORBA::release(*tc);
    }
    catch (CORBA::Exception &ex)
    {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
	    env->exception(t);
	return;
    }
    catch (...)
    {
	return;
    }

    return;
}

/*------------------------------------------------------*/

void VSnvlist_release(VSNVList_ptr *o1, VSEnvironment *ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::NVList_ptr *tc = (CORBA::NVList_ptr *) o1;

    try
    {
	if(tc)
	    CORBA::release(*tc);
    }
    catch (CORBA::Exception &ex)
    {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
	    env->exception(t);
	return;
    }
    catch (...)
    {
	return;
    }

    return;
}

/*------------------------------------------------------*/

void VSrequest_release(VSRequest_ptr *o1, VSEnvironment *ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Request_ptr *tc = (CORBA::Request_ptr *) o1;

    try
    {
	if(tc)
	    CORBA::release(*tc);
    }
    catch (CORBA::Exception &ex)
    {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
	    env->exception(t);
	return;
    }
    catch (...)
    {
	return;
    }

    return;
}

/*------------------------------------------------------*/

void VScontext_release(VSContext_ptr *o1, VSEnvironment *ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::Context_ptr *tc = (CORBA::Context_ptr *) o1;

    try
    {
	if(tc)
	    CORBA::release(*tc);
    }
    catch (CORBA::Exception &ex)
    {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
	    env->exception(t);
	return;
    }
    catch (...)
    {
	return;
    }

    return;
}

/*------------------------------------------------------*/

void VSorb_release(VSORB_ptr *o1, VSEnvironment *ev)
{
    CORBA::Environment *env = (CORBA::Environment *) ev;
    CORBA::ORB_ptr *tc = (CORBA::ORB_ptr *) o1;

    try
    {
	if(tc)
	    CORBA::release(*tc);
    }
    catch (CORBA::Exception &ex)
    {
	CORBA::Exception *t = exception_convert(&ex);
	if(env)
	    env->exception(t);
	return;
    }
    catch (...)
    {
	return;
    }

    return;
}

}

