/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: CORVAL2
*/

#include <orb_supp.hh>
#include <ir_support.hh>
#include <tin.hh>
#include <exwrap.hh>

/*--------------------------------------------------------------------------*/
/* A provide property value can be passed to a function using the m_tcases  */
/* array. eg. provide_typecode() will use testcases(VSPROVIDE_TC) to set		*/
/* the current property being tested. */

#define TSMAX_TESTCASES	16
#define VSPROVIDE_TC				0
#define VSPROVIDE_OBJPTR		1
#define VSPROVIDE_TCODEPTR	2
#define VSPROVIDE_NVALPTR		3
#define VSPROVIDE_NVLISTPTR	4
#define VSPROVIDE_ENVPTR		5
#define VSPROVIDE_REQPTR		6
#define VSPROVIDE_CTXPTR		7
#define VSPROVIDE_ORBPTR		8
#define VSPROVIDE_CTXLISTPTR	9
#define VSPROVIDE_EXLISTPTR	10
#define VSPROVIDE_NVLNAME		11
#define VSPROVIDE_NVLFLAGS	12
#define VSPROVIDE_NAME	13

class TS {
		CORBA::ULong							*m_tcases;
		char *										m_nullIOR;
		CORBA::ORB_ptr						*m_invalid_orb_ptr;
		CORBA::TypeCode_ptr				*m_invalid_typecode_ptr;
		CORBA::Environment_ptr		*m_invalid_env_ptr;
		CORBA::Object_ptr					*m_invalid_object_ptr;
		CORBA::Context_ptr				*m_invalid_context_ptr;
		CORBA::Request_ptr				*m_invalid_request_ptr;
		CORBA::NamedValue_ptr			*m_invalid_nvalue_ptr;
		CORBA::NVList_ptr					*m_invalid_nvlist_ptr;
		CORBA::ContextList_ptr		*m_invalid_ctxlist_ptr;
		CORBA::ExceptionList_ptr	*m_invalid_exlist_ptr;
		IRSupport									*m_rep;
public:
    TS();
    ~TS();
		void initialise();

    OrbSupport *m_corb;
		apiServer_ptr m_tobj;
		CORBA::ULong	&testcase(CORBA::ULong i) { return *(m_tcases+i); }
		char *nullIOR_string();
		
		CORBA::ORB_ptr	*invalid_orb_ptr();
		CORBA::TypeCode_ptr	*invalid_typecode_ptr()
									{ return m_invalid_typecode_ptr; }
		CORBA::Environment_ptr	*invalid_env_ptr()
									{ return m_invalid_env_ptr; }
		CORBA::Object_ptr	*invalid_object_ptr()
									{ return m_invalid_object_ptr; }
		CORBA::Context_ptr	*invalid_context_ptr()
									{ return m_invalid_context_ptr; }
		CORBA::Request_ptr	*invalid_request_ptr()
									{ return m_invalid_request_ptr; }
		CORBA::NamedValue_ptr	*invalid_nvalue_ptr()
									{ return m_invalid_nvalue_ptr; }
		CORBA::NVList_ptr	*invalid_nvlist_ptr()
									{ return m_invalid_nvlist_ptr; }
		CORBA::ContextList_ptr	*invalid_ctxlist_ptr()
									{ return m_invalid_ctxlist_ptr; }
		CORBA::ExceptionList_ptr	*invalid_exlist_ptr()
									{ return m_invalid_exlist_ptr; }
		IRSupport			*repository()
									{ return m_rep; }
};
extern TS glob_TS;

