//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/

VSEnvironment_ptr *VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Environment_ptr ttc;

		try {
				ttc = CORBA::Environment::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSEnvironment_ptr *) 0;
		}
		catch (...) {
				return (VSEnvironment_ptr *) 0;
		}

		CORBA::Environment_ptr *rtc = new CORBA::Environment_ptr(ttc);
		return (VSEnvironment_ptr *) rtc;
}

VSEnvironment_ptr *VSduplicate(VSEnvironment_ptr *e1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Environment_ptr *tc = (CORBA::Environment_ptr *) e1;
		CORBA::Environment_ptr ttc;

		try {
				ttc = CORBA::Environment::_duplicate(tc ? *tc : (CORBA::Environment_ptr) 0);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSEnvironment_ptr *) 0;
		}
		catch (...) {
				return (VSEnvironment_ptr *) 0;
		}

		CORBA::Environment_ptr *rtc = new CORBA::Environment_ptr(ttc);
		return (VSEnvironment_ptr *) rtc;
}

void VSclear(VSEnvironment_ptr *e1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::Environment_ptr *eptr = (CORBA::Environment_ptr *) e1;

		// Ignore the NULL case.
		if(!eptr || !*eptr || is_invalid_env_ptr(e1) || is_nil_env_ptr(e1))
				return;

		try {
				(*eptr)->clear();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return;
		}
		catch (...) {
				return;
		}

		return;
}

}

