//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/pObjects/Environment/t1_aux.cpp
//
// Purpose:
//
// Modifications:
// $Log: t1_aux.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:14:45  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.8  1999/05/10 13:22:31  cwatson
// Added invalid and nil ptr checks().
//
// Revision 1.7  1997/12/05 16:28:28  cwatson
// Now uses .hh for c++ include files.
//
// Revision 1.6  1997/10/09 10:53:23  tet
// Removed undeeded #define.
//
// Revision 1.5  1997/10/04 16:43:12  stephen
// Changed include to corba_supp.hh.
//
// Revision 1.4  1997/10/01 15:56:38  cwatson
// Makefile changes.
//
// Revision 1.3  1997/09/12 13:04:39  cwatson
// Moved all the _ptr provide and relinquish functions to corba/common/ptr_prov.cpp.
//
// Revision 1.2  1997/09/08 11:38:22  cwatson
// Added the VSclear() test.
//
// Revision 1.1  1997/08/20 11:34:48  cwatson
// *** empty log message ***
//
// Revision 1.1  1997/08/06 14:40:00  cwatson
// *** empty log message ***
//
//
/*
 *
 * t1_aux.c -- 
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

//-----------------------------------------------------------
// General Environment.

int is_same_env_ptr(VSEnvironment_ptr *o1, VSEnvironment_ptr *o2)
{
		if(is_nil_env_ptr(o1) && is_nil_env_ptr(o2))
				return TRUE;
		
		return TRUE;
}

int cleanup_env_ptr(VSEnvironment_ptr *o1)
{
		CORBA::Environment_ptr *tc = (CORBA::Environment_ptr *) o1;
		if(!tc)
				return TRUE;

		delete tc;
		return TRUE;
}

int ex_is_cleared(VSEnvironment_ptr *e1)
{
		CORBA::Environment_ptr *eptr = (CORBA::Environment_ptr *) e1;
		if(!eptr || is_nil_env_ptr(e1) || is_invalid_env_ptr(e1))
				return TRUE;

		return (*eptr)->exception() ? FALSE : TRUE;
}

}
