/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_same_object(VSObject_ptr *, VSObject_ptr *);

extern VSObject_ptr *get_obj_from_str(VSString);

extern int is_same_string(VSString, VSString);

extern VSString get_str_from_obj(VSObject_ptr *);

extern int is_empty_string(VSString);

extern int is_bad_string(VSString);

extern int is_nullIOR_string(VSString);

extern int is_same_orb_ptr(VSORB_ptr *, VSORB_ptr *);

extern int cleanup_orb_ptr(VSORB_ptr *);

extern int is_oidlist_valid(VSObjectIdList *);

extern int is_empty_objectid(VSObjectId *id);

extern int is_bad_objectid(VSObjectId *id);

extern int is_nil_objectid(VSObjectId *id);

extern int is_valid_objectptr(VSObject_ptr *o);

extern int is_valid_struct_tc(VSTypeCode_ptr *t);

extern int struct_tc_empty(VSTypeCode_ptr *t);

extern int struct_tc_good(VSTypeCode_ptr *t);

extern int is_empty_sseq(VSStructMemberSeq *);

extern int is_good_sseq(VSStructMemberSeq *);

extern int are_good_params(VSUnionMemberSeq *, VSTypeCode_ptr *d, VSRepositoryId id, VSIdentifier name);

extern int is_valid_union_tc(VSTypeCode_ptr *d, VSTypeCode_ptr *t);

extern int union_tc_empty(VSTypeCode_ptr *t);

extern int union_tc_good(VSTypeCode_ptr *t);

extern int is_empty_useq(VSUnionMemberSeq *);

extern int is_good_useq(VSUnionMemberSeq *);

extern int is_valid_enum_tc(VSTypeCode_ptr *t);

extern int enum_tc_empty(VSTypeCode_ptr *t);

extern int enum_tc_good(VSTypeCode_ptr *t);

extern int is_empty_eseq(VSEnumMemberSeq *);

extern int is_good_eseq(VSEnumMemberSeq *);

extern int is_valid_alias_tc(VSTypeCode_ptr *t);

extern int content_is_same(VSTypeCode_ptr *t1, VSTypeCode_ptr *t2);

extern int is_valid_exception_tc(VSTypeCode_ptr *t);

extern int is_valid_interface_tc(VSTypeCode_ptr *t);

extern int is_valid_string_tc(VSTypeCode_ptr *t);

extern int is_same_length(VSULong b, VSTypeCode_ptr *t);

extern int is_valid_sequence_tc(VSTypeCode_ptr *t);

extern int is_valid_array_tc(VSTypeCode_ptr *t);

extern int valuefactory_registered(VSRepositoryId);

extern int is_return_ValueFactory(VSValueFactory);

extern int return_correct_tc(VSTypeCode_ptr *, VSString);

extern int is_orb_workpending(VSBoolean);

extern int is_orb_performwork(VSBoolean);

extern int is_orb_schutdown(VSBoolean);

extern int is_orb_run(VSBoolean);

extern int is_orb_destroy(VSBoolean);

extern int is_return_policy(VSPolicy_ptr *);

extern int valid_policy_parameter(VSPolicyType, VSAny);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSString)(VSString, emitter_t);
extern void (*ADL__print_VSORB_ptr_P)(VSORB_ptr*, emitter_t);
extern void (*ADL__print_VSObjectIdList_P)(VSObjectIdList*, emitter_t);
extern void (*ADL__print_VSObjectId_P)(VSObjectId*, emitter_t);
extern void (*ADL__print_VSRepositoryId)(VSRepositoryId, emitter_t);
extern void (*ADL__print_VSIdentifier)(VSIdentifier, emitter_t);
extern void (*ADL__print_VSStructMemberSeq_P)(VSStructMemberSeq*, emitter_t);
extern void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t);
extern void (*ADL__print_VSUnionMemberSeq_P)(VSUnionMemberSeq*, emitter_t);
extern void (*ADL__print_VSEnumMemberSeq_P)(VSEnumMemberSeq*, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);
extern void (*ADL__print_VSValueFactory)(VSValueFactory, emitter_t);
extern void (*ADL__print_VSBoolean)(VSBoolean, emitter_t);
extern void (*ADL__print_VSPolicyType)(VSPolicyType, emitter_t);
extern void (*ADL__print_VSAny)(VSAny, emitter_t);
extern void (*ADL__print_VSPolicy_ptr_P)(VSPolicy_ptr*, emitter_t);

/* Declarations of wrapper of FUT */
extern VSString (*ADL__VSobject_to_string_wrapper)(VSObject_ptr*, VSEnvironment*);
extern VSObject_ptr *(*ADL__VSstring_to_object_wrapper)(VSString, VSEnvironment*);
extern VSORB_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSORB_ptr *(*ADL__VSduplicate_wrapper)(VSORB_ptr*, VSEnvironment*);
extern VSObjectIdList *(*ADL__VSlist_initial_services_wrapper)(VSEnvironment*);
extern VSObject_ptr *(*ADL__VSresolve_initial_references_wrapper)(VSObjectId*, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScreate_struct_tc_wrapper)(VSRepositoryId, VSIdentifier, VSStructMemberSeq*, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScreate_union_tc_wrapper)(VSRepositoryId, VSIdentifier, VSTypeCode_ptr*, VSUnionMemberSeq*, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScreate_enum_tc_wrapper)(VSRepositoryId, VSIdentifier, VSEnumMemberSeq*, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScreate_alias_tc_wrapper)(VSRepositoryId, VSIdentifier, VSTypeCode_ptr*, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScreate_exception_tc_wrapper)(VSRepositoryId, VSIdentifier, VSStructMemberSeq*, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScreate_interface_tc_wrapper)(VSRepositoryId, VSIdentifier, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScreate_string_tc_wrapper)(VSULong, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScreate_sequence_tc_wrapper)(VSULong, VSTypeCode_ptr*, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScreate_array_tc_wrapper)(VSULong, VSTypeCode_ptr*, VSEnvironment*);
extern VSValueFactory (*ADL__VSregister_value_factory_wrapper)(VSRepositoryId, VSValueFactory, VSEnvironment*);
extern VSBoolean (*ADL__VSunregister_value_factory_wrapper)(VSRepositoryId, VSEnvironment*);
extern VSValueFactory (*ADL__VSlookup_value_factory_wrapper)(VSValueFactory, VSRepositoryId, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScreate_wstring_tc_wrapper)(VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScreate_value_tc_wrapper)(VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScreate_value_box_tc_wrapper)(VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScreate_native_tc_wrapper)(VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScreate_abstract_interface_tc_wrapper)(VSEnvironment*);
extern VSBoolean (*ADL__VSwork_pending_wrapper)(VSORB_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSperform_work_wrapper)(VSORB_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSrun_wrapper)(VSORB_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSshutdown_wrapper)(VSORB_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSdestroy_wrapper)(VSORB_ptr*, VSEnvironment*);
extern VSPolicy_ptr *(*ADL__VScreate_policy_wrapper)(VSPolicyType, VSAny, VSEnvironment*);

#endif
