/* ADL test driver from t1.tdr
 *
 * test VShash(object_ptr, hashnum, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_463[] = {
    {"valid", Pobject_ptr_v_valid, 0},
    {"invalid", Pobject_ptr_v_invalid, 0},
    {0, 0, 0}
};

/* values for literal variable hashnum */
static VSULong ADL__litvar_val_465[] = {
    999,
    100,
    1,
    0,
};

static struct ADL__propertyValue ADL__litvar_info_464[] = {
    {"999", 0, ADL__litvar_val_465},
    {"100", 1, ADL__litvar_val_465},
    {"1", 2, ADL__litvar_val_465},
    {"0", 3, ADL__litvar_val_465},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_466[] = {
    {"v", "prop", ADL__prop_values_463, 2},
    {"hashnum", "litvar", ADL__litvar_info_464, 4},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_470[4] = {
    {"object_ptr", "VSObject_ptr *", ADL__prop_info_466, 0, 1},
    {"hashnum", "VSULong", ADL__prop_info_466, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_466, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VShash_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSOBJECT_PTR_P
#define ADL__PRINT_VSOBJECT_PTR_P
void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR_P */
#ifndef ADL__PRINT_VSINTERFACEDEF_PTR_P
#define ADL__PRINT_VSINTERFACEDEF_PTR_P
void (*ADL__print_VSInterfaceDef_ptr_P)(VSInterfaceDef_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSINTERFACEDEF_PTR_P */
#ifndef ADL__PRINT_VSCHAR_P
#define ADL__PRINT_VSCHAR_P
void (*ADL__print_VSChar_P)(VSChar*, emitter_t) = 0;

#endif /* ADL__PRINT_VSCHAR_P */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter)
{
  VSObject_ptr *tmp;

  if (ADL__print_VSObject_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObject_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSInterfaceDef_ptr_P (void* val, emitter_t emitter)
{
  VSInterfaceDef_ptr *tmp;

  if (ADL__print_VSInterfaceDef_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSInterfaceDef_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSChar_P (void* val, emitter_t emitter)
{
  VSChar *tmp;

  if (ADL__print_VSChar_P != 0) {
    tmp = *(VSChar**) val;
    ADL__print_VSChar_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2, 4};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSObject_ptr *object_ptr_467;
    VSULong hashnum_468;
    VSEnvironment *env_469;
    VSULong fut_return_462;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VShash_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VShash_InfoArrayIdx,
        ADL__VShash_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_object_ptr(&object_ptr_467, ADL__prop_values_463[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSObject_ptr_P(&object_ptr_467, rf->variableReport->emitVariable);

       hashnum_468 = ADL__litvar_val_465[tvec[1]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 1, tvec + 1, 1);
       ADL__emit_VSULong(&hashnum_468, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_469)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_469, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VShash_assertionReport = rf->assertionReport;
       fut_return_462 = ADL__ACF_VShash(object_ptr_467, hashnum_468, env_469);
       test_value = ADL__VShash_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_469);
SKIP_2:
       relvec[1] = 1;	/* relinquish succeeds for hashnum_468 */
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_object_ptr(&object_ptr_467, ADL__prop_values_463[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_470,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VShash_head);

    return 0;
}


struct ADL__Directive_info VShash1_info = {
    N_VARS,
    ADL__var_info_470
};

struct ADL__TDD_info ADL__test_info = {
    8,
    &ADL__VShash_InfoArrayIdx,
    ADL__VShash_InfoArray,
    ADL__test_driver,
    "VShash",
    "VShash1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VShash1",
    "t1_tr.rif",
    &VShash1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

