//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

//-----------------------------------------------------------
// General Object.

int is_valid_object_ptr(VSObject_ptr *o1)
{
		if(!o1)
			return FALSE;

		CORBA::Object_ptr *optr1 = (CORBA::Object_ptr *) o1;

		CORBA::Object_ptr optr2 = glob_TS.m_tobj;
		return (*optr1 == optr2);
}

int is_same_object_ptr(VSObject_ptr *o1, VSObject_ptr *o2)
{
		CORBA::Object_ptr *optr1 = (CORBA::Object_ptr *) o1;
		CORBA::Object_ptr *optr2 = (CORBA::Object_ptr *) o2;

		if(is_nil_object_ptr(o1) && is_nil_object_ptr(o2))
				return TRUE;

		return (*optr1)->_is_equivalent(*optr2);
}

int cleanup_object_ptr(VSObject_ptr *o1)
{
		CORBA::Object_ptr *optr1 = (CORBA::Object_ptr *) o1;
		if(!optr1)
				return TRUE;

		CORBA::release(*optr1);
		delete optr1;
		return TRUE;
}

int hash_value_is_good(VSULong ph,VSULong mx)
{
		CORBA::ULong h = (CORBA::ULong) ph;
		CORBA::ULong maxim = (CORBA::ULong) mx;

		return (h <= maxim) ? TRUE : FALSE;
}

int is_valid_intdef(VSInterfaceDef_ptr *i)
{
		CORBA::InterfaceDef_ptr *idef = (CORBA::InterfaceDef_ptr *) i;
		if(!idef || !*idef)
				return FALSE;

		CORBA::InterfaceDef::FullInterfaceDescription *fd = 0;
		try {
				fd = (*idef)->describe_interface();
		}
		catch(...) {
				return FALSE;
		}

		char *n = fd->name;
		if(n && (strcmp(n,"apiServer") == 0))
				return TRUE;

		return TRUE;
}

}
