//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/pObjects/Object/t1i_tdi.cpp
//
// Purpose:
//
// Modifications:
// $Log: t1i_tdi.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:14:50  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.9  1998/04/29 11:57:03  stephen
// Removed nil object value.
//
// Revision 1.8  1997/12/05 16:28:34  cwatson
// Now uses .hh for c++ include files.
//
// Revision 1.7  1997/10/04 16:43:17  stephen
// Changed include to corba_supp.hh.
//
// Revision 1.6  1997/10/01 15:56:57  cwatson
// Makefile changes.
//
// Revision 1.5  1997/09/22 09:52:33  ian
// Changed CORBA::OBJECT_NIL to CORBA::Object_nil().
//
// Revision 1.4  1997/09/19 15:58:40  ian
// Windows NT version.
//
// Revision 1.3  1997/09/12 13:06:06  cwatson
// Use a VSObject_ptr * instead of a VSObject_ptr in VSobject_to_string, just in
// case this is implemented as a class.
// Moved all the _ptr provide and relinquish functions to corba/common/ptr_prov.cpp.
//
// Revision 1.2  1997/09/08 11:40:34  cwatson
// Added _get_interface(), is_a(), is_equivalent(), non_existent() and hash() tests.
//
// Revision 1.1  1997/08/20 11:43:44  cwatson
// *** empty log message ***
//
// Revision 1.1  1997/08/06 14:40:02  cwatson
// *** empty log message ***
//
//
/*
 * ./t1_tdi.c
 */

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

/* ---- global property declarations ---- */
/* ---- test variables and local properties ---- */

/* ------------------------------------------------------------ */
/* test variable object_ptr() */

int provide_object_ptr(VSObject_ptr **testvar, enum prop_object_ptr_v v)
{
		CORBA::Object_ptr  *tvar;

		switch(v){
				case Pobject_ptr_v_valid:
						{
						CORBA::Object_ptr o = glob_TS.m_tobj->_duplicate(glob_TS.m_tobj);
						tvar = new CORBA::Object_ptr(o);
						}
						break;
				case Pobject_ptr_v_invalid:
						tvar = glob_TS.invalid_object_ptr();
						break;
		}

		*testvar = (VSObject_ptr *) tvar;
		return TRUE;
}

int relinquish_object_ptr(VSObject_ptr **testvar,
							enum prop_object_ptr_v v)
{
		CORBA::Object_ptr  *tvar = (CORBA::Object_ptr *) *testvar;

		switch(v){
				case Pobject_ptr_v_valid:
						break;
				case Pobject_ptr_v_invalid:
						break;
		}
		return TRUE;
}

}

