//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include	<corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

/*------------------------------------------------------*/

VSTCKind VSkind(VSTypeCode_ptr *t, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TCKind k = CORBA::tk_void;
		CORBA::TypeCode_ptr *tptr = (CORBA::TypeCode_ptr *) t;

		try {
				k = (*tptr)->kind();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSTCKind) 0;
		}
		catch (...) {
				return 0;
		}

		return (VSTCKind) k;
}

/*------------------------------------------------------*/

VSBoolean VSequal(VSTypeCode_ptr *t1,VSTypeCode_ptr *t2, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		VSBoolean ret = 0;
		CORBA::TypeCode_ptr *tptr1 = (CORBA::TypeCode_ptr *) t1;
		CORBA::TypeCode_ptr *tptr2 = (CORBA::TypeCode_ptr *) t2;

		try {
				ret = (VSBoolean) (*tptr1)->equal(*tptr2);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSBoolean) 0;
		}
		catch (...) {
				return (VSBoolean) 0;
		}

		return ret;
}

/*------------------------------------------------------*/

VSChar *VSid(VSTypeCode_ptr *t, VSEnvironment *ev)
{
		VSChar *ret = 0;
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr *tptr = (CORBA::TypeCode_ptr *) t;

		try {
				ret = (VSChar *) (*tptr)->id();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSChar *) 0;
		}
		catch (...) {
				return (VSChar *) 0;
		}

		return ret;
}

/*------------------------------------------------------*/

VSChar *VSname(VSTypeCode_ptr *t, VSEnvironment *ev)
{
		VSChar *ret = 0;
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr *tptr = (CORBA::TypeCode_ptr *) t;

		try {
				ret = (VSChar *) (*tptr)->name();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSChar *) 0;
		}
		catch (...) {
				return (VSChar *) 0;
		}

		return ret;
}

/*------------------------------------------------------*/

VSULong VSmember_count(VSTypeCode_ptr *t, VSEnvironment *ev)
{
		VSULong ret = 0;
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr *tptr = (CORBA::TypeCode_ptr *) t;

		try {
				ret = (VSULong) (*tptr)->member_count();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSULong) 0;
		}
		catch (...) {
				return (VSULong) 0;
		}

		return ret;
}

/*------------------------------------------------------*/

VSChar *VSmember_name(VSULong i, VSTypeCode_ptr *t, VSEnvironment *ev)
{
		VSChar *ret = 0;
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr *tptr = (CORBA::TypeCode_ptr *) t;
		CORBA::ULong index = (CORBA::ULong) i;

		try {
				ret = (VSChar *) (*tptr)->member_name(index);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSChar *) 0;
		}
		catch (...) {
				return (VSChar *) 0;
		}

		return ret;
}

/*------------------------------------------------------*/

VSTypeCode_ptr *VSmember_type(VSULong i, VSTypeCode_ptr *t, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr *tptr = (CORBA::TypeCode_ptr *) t;
		CORBA::TypeCode_ptr ret;
		CORBA::ULong index = (CORBA::ULong) i;

		try {
				ret = (*tptr)->member_type(index);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSTypeCode_ptr *) 0;
		}
		catch (...) {
				return (VSTypeCode_ptr *) 0;
		}

		CORBA::TypeCode_ptr *rtc = new CORBA::TypeCode_ptr(ret);
		return (VSTypeCode_ptr *) rtc;
}

/*------------------------------------------------------*/

VSAny *VSmember_label(VSULong i, VSTypeCode_ptr *t, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr *tptr = (CORBA::TypeCode_ptr *) t;
		CORBA::Any *ret;
		CORBA::ULong index = (CORBA::ULong) i;

		try {
		    ret = (*tptr)->member_label(index);
		}
		catch (CORBA::Exception &ex) {
		    CORBA::Exception *t = exception_convert(&ex);
		    if(env)
			env->exception(t);
		    return (VSAny *) 0;
		}
		catch (...) {
		    return (VSAny *) 0;
		}
		
		return (VSAny *) ret;
}

/*------------------------------------------------------*/

VSTypeCode_ptr *VSdiscriminator_type(VSTypeCode_ptr *t, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr *tptr = (CORBA::TypeCode_ptr *) t;
		CORBA::TypeCode_ptr ret;

		try {
				ret = (*tptr)->discriminator_type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSTypeCode_ptr *) 0;
		}
		catch (...) {
				return (VSTypeCode_ptr *) 0;
		}

		CORBA::TypeCode_ptr *rtc = new CORBA::TypeCode_ptr(ret);
		return (VSTypeCode_ptr *) rtc;
}

/*------------------------------------------------------*/

VSLong VSdefault_index(VSTypeCode_ptr *t, VSEnvironment *ev)
{
		VSLong ret = 0;
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr *tptr = (CORBA::TypeCode_ptr *) t;

		try {
				ret = (VSLong) (*tptr)->default_index();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSLong) 0;
		}
		catch (...) {
				return (VSLong) 0;
		}

		return ret;
}

/*------------------------------------------------------*/

VSULong VSlength(VSTypeCode_ptr *t, VSEnvironment *ev)
{
		VSULong ret = 0;
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr *tptr = (CORBA::TypeCode_ptr *) t;

		try {
				ret = (VSULong) (*tptr)->length();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSULong) 0;
		}
		catch (...) {
				return (VSULong) 0;
		}

		return ret;
}

/*------------------------------------------------------*/

VSTypeCode_ptr *VScontent_type(VSTypeCode_ptr *t, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr *tptr = (CORBA::TypeCode_ptr *) t;
		CORBA::TypeCode_ptr ret;

		try {
				ret = (*tptr)->content_type();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSTypeCode_ptr *) 0;
		}
		catch (...) {
				return (VSTypeCode_ptr *) 0;
		}

		CORBA::TypeCode_ptr *rtc = new CORBA::TypeCode_ptr(ret);
		return (VSTypeCode_ptr *) rtc;
}

/*------------------------------------------------------*/

VSTypeCode_ptr *VSnil(VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr ttc;

		try {
				ttc = CORBA::TypeCode::_nil();
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSTypeCode_ptr *) 0;
		}
		catch (...) {
				return (VSTypeCode_ptr *) 0;
		}

		CORBA::TypeCode_ptr *rtc = new CORBA::TypeCode_ptr(ttc);
		return (VSTypeCode_ptr *) rtc;
}

VSTypeCode_ptr *VSduplicate(VSTypeCode_ptr *o1, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::TypeCode_ptr *tc = (CORBA::TypeCode_ptr *) o1;
		CORBA::TypeCode_ptr ttc;

		try {
				ttc = CORBA::TypeCode::_duplicate(tc ? *tc : (CORBA::TypeCode_ptr) 0);
		}
		catch (CORBA::Exception &ex) {
				CORBA::Exception *t = exception_convert(&ex);
				if(env)
						env->exception(t);
				return (VSTypeCode_ptr *) 0;
		}
		catch (...) {
				return (VSTypeCode_ptr *) 0;
		}

		CORBA::TypeCode_ptr *rtc = new CORBA::TypeCode_ptr(ttc);
		return (VSTypeCode_ptr *) rtc;
}

}

