/* ADL test driver from t1.tdr
 *
 * test VSORB_init(argc, argv, oid, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop oid_value */
static struct ADL__propertyValue ADL__prop_values_49[] = {
    {"valid", Poid_oid_value_valid, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_50[] = {
    {"oid_value", "prop", ADL__prop_values_49, 1},
    {0, 0, 0}
};
#define TVEC_SIZE 1

static struct ADL__variableInfo ADL__var_info_55[5] = {
    {"argc", " int *", ADL__prop_info_50, 0, 0},
    {"argv", " char * *", ADL__prop_info_50, 0, 0},
    {"oid", "VSORBid", ADL__prop_info_50, 0, 1},
    {"env", "VSEnvironment *", ADL__prop_info_50, 1, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 4


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSORB_init_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_INT_P
#define ADL__PRINT_INT_P
void (*ADL__print_int_P)(int*, emitter_t) = 0;

#endif /* ADL__PRINT_INT_P */
#ifndef ADL__PRINT_CHAR_P_P
#define ADL__PRINT_CHAR_P_P
void (*ADL__print_char_P_P)(char**, emitter_t) = 0;

#endif /* ADL__PRINT_CHAR_P_P */
#ifndef ADL__PRINT_VSORBID
#define ADL__PRINT_VSORBID
void (*ADL__print_VSORBid)(VSORBid, emitter_t) = 0;

#endif /* ADL__PRINT_VSORBID */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSORB_PTR
#define ADL__PRINT_VSORB_PTR
void (*ADL__print_VSORB_ptr)(VSORB_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSORB_PTR */

void ADL__emit_int_P (void* val, emitter_t emitter)
{
  int* tmp;

  if (ADL__print_int_P != 0) {
    tmp = *(int**) val;
    ADL__print_int_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_char_P_P (void* val, emitter_t emitter)
{
  char** tmp;

  if (ADL__print_char_P_P != 0) {
    tmp = *(char***) val;
    ADL__print_char_P_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSORBid (void* val, emitter_t emitter)
{
  VSORBid tmp;

  if (ADL__print_VSORBid != 0) {
    tmp = *(VSORBid*) val;
    ADL__print_VSORBid(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSORB_ptr (void* val, emitter_t emitter)
{
  VSORB_ptr tmp;

  if (ADL__print_VSORB_ptr != 0) {
    tmp = *(VSORB_ptr*) val;
    ADL__print_VSORB_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {1};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    int* argc_51;
    char** argv_52;
    VSORBid oid_53;
    VSEnvironment *env_54;
    VSORB_ptr fut_return_48;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSORB_init_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSORB_init_InfoArrayIdx,
        ADL__VSORB_init_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_argc(&argc_51)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
       ADL__emit_int_P(&argc_51, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(0);
       if (!provide_argv(&argv_52)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 0, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 0, 0);
       ADL__emit_char_P_P(&argv_52, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(0);
       if (!provide_oid(&oid_53, ADL__prop_values_49[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 0, 1);
       ADL__emit_VSORBid(&oid_53, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_env(&env_54)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 1, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_3;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 1, 0);
       ADL__emit_VSEnvironment_P(&env_54, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSORB_init_assertionReport = rf->assertionReport;
       fut_return_48 = ADL__ACF_VSORB_init(argc_51, argv_52, oid_53, env_54);
       test_value = ADL__VSORB_init_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(1);
       relvec[3] = relinquish_env(&env_54);
SKIP_3:
      ADL__set_TDDVarNum(0);
       relvec[2] = relinquish_oid(&oid_53, ADL__prop_values_49[tvec[0]].propValCode);
SKIP_2:
      ADL__set_TDDVarNum(0);
       relvec[1] = relinquish_argv(&argv_52);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_argc(&argc_51);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_55,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSORB_init_head);

    return 0;
}


struct ADL__Directive_info VSORB_init1_info = {
    N_VARS,
    ADL__var_info_55
};

struct ADL__TDD_info ADL__test_info = {
    1,
    &ADL__VSORB_init_InfoArrayIdx,
    ADL__VSORB_init_InfoArray,
    ADL__test_driver,
    "VSORB_init",
    "VSORB_init1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSORB_init1",
    "t1_tr.rif",
    &VSORB_init1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

