//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/pObjects/oinit/t1_aux.cpp
//
// Purpose:
//
// Modifications:
// $Log: t1_aux.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:14:55  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.8  1999/05/06 16:29:52  ian
// SR#132 Changed CORBA::OBJECT_NIL to CORBA::Object::_nil()
//
// Revision 1.7  1998/04/29 15:19:34  stephen
// CORBA::OBJECT_NIL used instead of CORBA::Object.
//
// Revision 1.6  1997/12/05 16:28:37  cwatson
// Now uses .hh for c++ include files.
//
// Revision 1.5  1997/11/27 12:07:39  cwatson
// Removed Orbix specific code.
//
// Revision 1.4  1997/10/09 10:53:27  tet
// Removed undeeded #define.
//
// Revision 1.3  1997/10/04 16:43:21  stephen
// Changed include to corba_supp.hh.
//
// Revision 1.2  1997/10/01 15:57:10  cwatson
// Makefile changes.
//
// Revision 1.1  1997/08/06 14:41:02  cwatson
// *** empty log message ***
//
//
/*
*
* t1_aux.c -- 
*
* This file contains declarations of auxiliary functions
* in module "t1"
*
*/

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

    //-----------------------------------------------------------
    // General.

    //-----------------------------------------------------------
    // ORB_init().

    int test_orb_ptr(VSORB_ptr optr)
    {
	char *str;
	CORBA::ORB_ptr roptr = (CORBA::ORB_ptr) optr;

	if(!roptr)
	    return FALSE;

	try {
	    str = roptr->object_to_string(CORBA::Object::_nil());
	}
	catch (CORBA::Exception &sysEx) {
	    return FALSE;
	}
	
	return TRUE;
    }

    int release_orb(VSORB_ptr optr)
    {
	CORBA::ORB_ptr roptr = (CORBA::ORB_ptr) optr;
	if(!roptr)
	    return FALSE;

	try {
	    CORBA::release(roptr);
	}
	catch (CORBA::Exception &sysEx) {
	    return FALSE;
	}
	
	return TRUE;
    }

}
