//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/pObjects/oinit/t1i_tdi.cpp
//
// Purpose:
//
// Modifications:
// $Log: t1i_tdi.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:14:55  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1997/12/05 16:28:37  cwatson
// Now uses .hh for c++ include files.
//
// Revision 1.4  1997/10/04 16:43:21  stephen
// Changed include to corba_supp.hh.
//
// Revision 1.3  1997/10/01 15:57:11  cwatson
// Makefile changes.
//
// Revision 1.2  1997/09/29 12:03:36  stephen
// Make system updated to reflect configuration changes.
//
// Revision 1.1  1997/08/06 14:41:04  cwatson
// *** empty log message ***
//
//
/*
 * ./t1_tdi.c
 */

#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

/* ---- global property declarations ---- */
/* ---- test variables and local properties ---- */

/* ------------------------------------------------------------ */
/* test variable CORBA_ORBid oid() */

int provide_oid (VSORBid *testvar, enum prop_oid_oid_value oid_value)
{
		CORBA::ORBid *tvar = (CORBA::ORBid *) testvar;
		switch(oid_value){
				case Poid_oid_value_valid:
						*tvar = CORBA::string_dup(ORB_ID);
						break;
		}
		return TRUE;
}

int relinquish_oid (VSORBid *testvar, enum prop_oid_oid_value oid_value)
{
		CORBA::ORBid *tvar = (CORBA::ORBid *) testvar;
		switch(oid_value){
				case Poid_oid_value_valid:
						CORBA::string_free(*tvar);
						break;
		}
		return TRUE;
}

}
