//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2000 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <orb_supp.hh>
#include <tin.hh>
#include <server.hh>

/*
****************************************************************
*    The following section describes the implementation for
*    the TestServer interface. Each of the operations coded
*    here matches the specification in the IDL
****************************************************************
*/

CORBA::Char 
apiServer_imp::charOp(CORBA::Char c1,
                     CORBA::Char& c2,
                     CORBA::Char_out c3)
    throw(CORBA::SystemException)
{
    c3 = c2;
    c2 = c1;
    return c1;
}

CORBA::Octet 
apiServer_imp::octetOp(CORBA::Octet o1,
                       CORBA::Octet& o2,
                       CORBA::Octet_out o3)
    throw(CORBA::SystemException)
{
    o3 = o2;
    o2 = o1;
    return o1;
}
    
CORBA::Boolean 
apiServer_imp::booleanOp(CORBA::Boolean b1,
                           CORBA::Boolean& b2,
                           CORBA::Boolean_out b3)
    throw(CORBA::SystemException)
{
    b3 = b2;
    b2 = b1;
    return b1;
}

CORBA::Short 
apiServer_imp::shortOp(CORBA::Short s1,
                       CORBA::Short& s2,
                       CORBA::Short_out s3)
    throw(CORBA::SystemException)
{
    s3 = s2;
    s2 = s1;
    return s1;
}

CORBA::Long 
apiServer_imp::longOp(CORBA::Long l1,
                     CORBA::Long& l2,
                     CORBA::Long_out l3)
    throw(CORBA::SystemException)
{
    l3 = l2;
    l2 = l1;
    return l1;
}

CORBA::Float 
apiServer_imp::floatOp(CORBA::Float f1,
                       CORBA::Float& f2,
                       CORBA::Float_out f3)
    throw(CORBA::SystemException)
{
    f3 = f2;
    f2 = f1;
    return f1;
}

CORBA::Double 
apiServer_imp::doubleOp(CORBA::Double d1,
                         CORBA::Double& d2,
                         CORBA::Double_out d3)
    throw(CORBA::SystemException)
{
    d3 = d2;
    d2 = d1;
    return d1;
}

char* 
apiServer_imp::stringOp(const char* s1,char*& s2,
                        CORBA::String_out s3)
    throw(CORBA::SystemException)
{
    CORBA::ULong len = strlen(s2);
    
    s3 = CORBA::string_alloc(len);
    strcpy(s3, s2);
    CORBA::string_free(s2);

    len = strlen(s1);
    s2 = CORBA::string_alloc(len);
    strcpy(s2, s1);
    
    return CORBA::string_dup(s1);
}

CORBA::UShort 
apiServer_imp::ushortOp(CORBA::UShort us1,
                         CORBA::UShort& us2,
                         CORBA::UShort_out us3)
    throw(CORBA::SystemException)
{
    us3 = us2;
    us2 = us1;
    return us1;
}

CORBA::ULong 
apiServer_imp::ulongOp(CORBA::ULong ul1,
                       CORBA::ULong& ul2,
                       CORBA::ULong_out ul3)
    throw(CORBA::SystemException)
{
    ul3 = ul2;
    ul2 = ul1;
    return ul1;
}

CORBA::Long
apiServer_imp::increment(CORBA::Long num)
    throw(CORBA::SystemException)
{
    return(num + 1);
}

