//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/hdr/DII/NamedValue/NamedValue.cpp
//
// Purpose: Header file test for the interface CORBA::NamedValue
//
// Modifications:
// $Log: NamedValue.cpp,v $
// Revision 1.2  2000/05/24 16:22:25  mli
//   o   void (*tet_startup)(void) -> void (*tet_startup)()
//   o   void (*tet_cleanup)(void) -> void (*tet_cleanup)()
//
// Revision 1.1.1.1  2000/02/09 17:15:01  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1997/11/20 14:43:37  ian
// Removed function ptr assignment.
//
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

static void test1A()
{
	::tet_infoline("The class CORBA::NamedValue shall be defined ");
	::tet_infoline("to be a class that inherits from");
	::tet_infoline(".");


	::tet_infoline("TEST: Assignment");
	if (always_ret_0())
	{
		CORBA::NamedValue_var myNamedValue_var1;
		CORBA::NamedValue_var myNamedValue_var2;

		myNamedValue_var1 = myNamedValue_var2;

		(void *)&myNamedValue_var1;
	}

	::tet_result(TET_PASS);
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

