//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The type CORBA::ORB::RequestSeq shall be defined ");
	::tet_infoline("to be a class with all the member functions required");
	::tet_infoline("of a sequence of Request_ptr.");

	// Test the constructors 

	// Test the constructor CORBA::ORB::RequestSeq::RequestSeq() 
	if (always_ret_0())
	{
		CORBA::ORB::RequestSeq myRequestSeq;

		(void *)&myRequestSeq;
	}

	// Test the constructor CORBA::ORB::RequestSeq::RequestSeq(ULong max) 
	if (always_ret_0())
	{
		CORBA::ORB::RequestSeq myRequestSeq((CORBA::ULong)1);

		(void *)&myRequestSeq;
	}

	// Test the constructor 
	// CORBA::ORB::RequestSeq::RequestSeq(ULong max,ULong length, 
	// Request_ptr *data, Boolean release = FALSE) 
	if (always_ret_0())
	{
		CORBA::Request_ptr *myBuffer;
		CORBA::ORB::RequestSeq myRequestSeq(
								 (CORBA::ULong)1,
								 (CORBA::ULong)1,
								 myBuffer,
								 (CORBA::Boolean)0);

		(void *)&myRequestSeq;
	}

	// Test the constructor 
	// CORBA::ORB::RequestSeq::RequestSeq(const CORBA::ORB::RequestSeq&) 
	if (always_ret_0())
	{
		CORBA::ORB::RequestSeq	myRequestSeq1;
		CORBA::ORB::RequestSeq myRequestSeq(myRequestSeq1);

		(void *)&myRequestSeq;
	}

	// Test the member functions 

	// Test the function ULong maximum() const 
	if (always_ret_0())
	{
		CORBA::ORB::RequestSeq  myRequestSeq;
		CORBA::ULong ul = myRequestSeq.maximum();

		(void *)&ul;
	}			

	// Test the function void length(ULong)
	if (always_ret_0())
	{
		CORBA::ORB::RequestSeq myRequestSeq;
		   
		CORBA::ULong ul = 0;
				
		myRequestSeq.length(ul);
	}
					   
	// Test the function ULong length() const
	if (always_ret_0())
	{
		CORBA::ORB::RequestSeq myRequestSeq;
								  
		CORBA::ULong ul = myRequestSeq.length();
									   
		(void *)&ul;
	}
											  
	// Test the operators

	// Test the operator Request_ptr &operator=(const Request_ptr&)
	if (always_ret_0())
	{
 		CORBA::ORB::RequestSeq myRequestSeq1, myRequestSeq2;
		   
		myRequestSeq1 = myRequestSeq2;
				
		(void *)&myRequestSeq1;
	}
					   
	// Test the operator Request_ptr &operator[](ULong index)
	if (always_ret_0())
	{
		CORBA::ULong index = 0;
		CORBA::ORB::RequestSeq myRequestSeq;
		CORBA::Request_ptr myRequest_ptr;
										  
		myRequestSeq[index] = myRequest_ptr;
											   
		(void *)&myRequestSeq;
	 }
													  
	// Test the operator const Request_ptr &operator[](ULong index) const
	if (always_ret_0())
	{
		CORBA::ULong index = 0;
		CORBA::ORB::RequestSeq myRequestSeq;
		const CORBA::Request_ptr& myRequest_ptr = myRequestSeq[index];

		(void *)&myRequest_ptr;
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

