//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/hdr/DII/Object/_create_request.cpp
//
// Purpose: Header file test for the operation CORBA::Object::_create_request
//
// Modifications:
// $Log: _create_request.cpp,v $
// Revision 1.2  2000/05/24 16:22:36  mli
//   o   void (*tet_startup)(void) -> void (*tet_startup)()
//   o   void (*tet_cleanup)(void) -> void (*tet_cleanup)()
//
// Revision 1.1.1.1  2000/02/09 17:15:02  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.4  1997/11/20 14:43:43  ian
// Removed function ptr assignment.
//
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

static void test1A()
{
	CORBA::Object_var myObjRef;

#if VSORB_CORBA_STATUS
	// declare an instance of the return type 
	CORBA::Status ret;
#endif /* VSORB_CORBA_STATUS */

	// declare an instance of each parameter 
	CORBA::Context_ptr ctx = (CORBA::Context_ptr)0; // in 
	CORBA::Identifier operation = (CORBA::Identifier)0; // in 
	CORBA::NVList_ptr arg_list = (CORBA::NVList_ptr)0; // in 
	CORBA::NamedValue_ptr result = (CORBA::NamedValue_ptr)0; // in 
	CORBA::Request_ptr request = (CORBA::Request_ptr)0; // out 
	CORBA::Flags req_flags = (CORBA::Flags)0; // in 

	::tet_infoline("The function CORBA::Object::_create_request");
	::tet_infoline("shall be defined to be of type");
	::tet_infoline("CORBA::Status CORBA::Object::_create_request(");
	::tet_infoline("CORBA::Context_ptr,");
	::tet_infoline("CORBA::Identifier,");
	::tet_infoline("CORBA::NVList_ptr,");
	::tet_infoline("CORBA::NamedValue_ptr,");
	::tet_infoline("CORBA::Request_ptr&,");
	::tet_infoline("CORBA::Flags");
	::tet_infoline(");");

	// Include a call to the function to make sure it is present in the library 
	if (always_ret_0())
#if VSORB_CORBA_STATUS
		ret = 
#endif /* VSORB_CORBA_STATUS */

			myObjRef->_create_request(ctx, operation, arg_list, result, request, req_flags );

	::tet_result(TET_PASS);
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

