//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The type CORBA::PolicyList shall be defined ");
	::tet_infoline("to be a class with all the member functions required");
	::tet_infoline("of a sequence of Policy.");

	// Test the constructors 

	// Test the constructor CORBA::PolicyList::PolicyList() 
	if (always_ret_0())
	{
		CORBA::PolicyList myPolicyList;

		(void *)&myPolicyList;
	}

	// Test the constructor CORBA::PolicyList::PolicyList(ULong max) 
	if (always_ret_0())
	{
		CORBA::PolicyList myPolicyList((CORBA::ULong)1);

		(void *)&myPolicyList;
	}

	// Test the constructor 
	// CORBA::PolicyList::PolicyList(ULong max,ULong length, 
	// Policy *data, Boolean release = FALSE) 
	if (always_ret_0())
	{
		CORBA::Policy_ptr myBuffer;
		CORBA::PolicyList myPolicyList(
								 (CORBA::ULong)1,
								 (CORBA::ULong)1,
								 &myBuffer,
								 (CORBA::Boolean)0);

		(void *)&myPolicyList;
	}

	// Test the constructor 
	// CORBA::PolicyList::PolicyList(const CORBA::PolicyList&) 
	if (always_ret_0())
	{
		CORBA::PolicyList	myPolicyList1;
		CORBA::PolicyList myPolicyList(myPolicyList1);

		(void *)&myPolicyList;
	}

	// Test the member functions 

	// Test the function ULong maximum() const 
	if (always_ret_0())
	{
		CORBA::PolicyList  myPolicyList;
		CORBA::ULong ul = myPolicyList.maximum();

		(void *)&ul;
	}			

	// Test the function void length(ULong)
	if (always_ret_0())
	{
		CORBA::PolicyList myPolicyList;
		   
		CORBA::ULong ul = 0;
				
		myPolicyList.length(ul);
	}
					   
	// Test the function ULong length() const
	if (always_ret_0())
	{
		CORBA::PolicyList myPolicyList;
								  
		CORBA::ULong ul = myPolicyList.length();
									   
		(void *)&ul;
	}
											  
	// Test the operators

	// Test the operator Policy &operator=(const Policy&)
	if (always_ret_0())
	{
 		CORBA::PolicyList myPolicyList1, myPolicyList2;
		   
		myPolicyList1 = myPolicyList2;
				
		(void *)&myPolicyList1;
	}
					   
	// Test the operator Policy &operator[](ULong index)
	if (always_ret_0())
	{
		CORBA::ULong index = 0;
		CORBA::PolicyList myPolicyList;
		CORBA::Policy_ptr myPolicy;
										  
		myPolicyList[index] = myPolicy;
											   
		(void *)&myPolicyList;
	 }
													  
	// Test the operator const Policy &operator[](ULong index) const
	if (always_ret_0())
	{
		CORBA::ULong index = 0;
		CORBA::PolicyList myPolicyList;
		const CORBA::Policy_ptr myPolicy = myPolicyList[index];

		(void *)&myPolicy;
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

