//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

extern "C" {
static void test1A()
{
	CORBA::PolicyType myPolicyType;
	CORBA::ULong BaseType;
	CORBA::ULong *pBaseType;

	::tet_infoline("The type CORBA::PolicyType shall be defined ");
	::tet_infoline("to be of type CORBA::ULong.");

	myPolicyType = (CORBA::PolicyType)0;
	BaseType = (CORBA::ULong)0;

	::tet_infoline("TEST: size");
	if (sizeof(CORBA::PolicyType) != sizeof(CORBA::ULong)) 
	{
		::tet_printf("ERROR: Expected size of CORBA::PolicyType to be %d, is %d.", sizeof(CORBA::ULong), sizeof(CORBA::PolicyType));

		::tet_result(TET_FAIL);
		return;
	}

	if (myPolicyType == BaseType)
		pBaseType = &myPolicyType;

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

