//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A(void)
{

  ::tet_infoline("The class DynamicAny::DynValue shall be defined ");
  ::tet_infoline("to be a class that inherits from");
  ::tet_infoline("DynamicAny::DynAny .");

  ::tet_infoline("TEST: Widening of object reference to DynamicAny::DynValue");
  if (always_ret_0())
  {
    DynamicAny::DynValue_ptr  myInterface_ptr = (DynamicAny::DynValue_ptr)0;
    DynamicAny::DynValue_var  myInterface_var;

    DynamicAny::DynAny_ptr myParent_ptr1 = myInterface_ptr;
    DynamicAny::DynAny_ptr myParent_ptr2 = myInterface_var;
    DynamicAny::DynAny_var myParent_var = DynamicAny::DynValue::_duplicate(myInterface_var);

    (void *)&myParent_var;
  }


  ::tet_infoline("TEST: Assignment");
  if (always_ret_0())
  {
    DynamicAny::DynValue_var  myInterface_var1;
    DynamicAny::DynValue_var  myInterface_var2;

    myInterface_var1 = myInterface_var2;

    (void *)&myInterface_var1;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    DynamicAny::DynValue_ptr  myInterface_ptr = (DynamicAny::DynValue_ptr)0;

    any <<= myInterface_ptr;
    any <<= &myInterface_ptr;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    DynamicAny::DynValue_ptr  myInterface_ptr;

    b = any >>= myInterface_ptr;

    (void*)&b;
    (void*)&myInterface_ptr;
  }


  ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}

