//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  DynamicAny::NameValuePair  myStructure;

  // Declare pointers for each of the member fields 
  DynamicAny::FieldName_var myField1;
  CORBA::Any myField2;

  ::tet_infoline("The struct DynamicAny::NameValuePair");
  ::tet_infoline("shall be defined and shall have the members");
  ::tet_infoline("{ DynamicAny::FieldName_var id, CORBA::Any value}.");

  // Force the compiler to complain if the a member type is incorrect

  // Test the field name 
  myField1 = myStructure.id;

  // Test the field type 
  myField2 = myStructure.value;



  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    DynamicAny::NameValuePair   myStructure;
    DynamicAny::NameValuePair  *myStructure_ptr;
    CORBA::Any any;

    any <<= &myStructure;
    any <<= myStructure_ptr;
  }



  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    const DynamicAny::NameValuePair  *myStructure_ptr;
    CORBA::Any any;
    CORBA::Boolean b;

    b = any >>= myStructure_ptr;

    (void*)&b;
    (void*)&myStructure_ptr;
  }



  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

