//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type DynamicAny::NameValuePairSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of DynamicAny::NameValuePair Def.");

  // Test the constructors 

  // Test the constructor DynamicAny::NameValuePairSeq::NameValuePairSeq() 
  if (always_ret_0())
  {
    DynamicAny::NameValuePairSeq mySeq;

    (void *)&mySeq;
  }

  // Test the constructor DynamicAny::NameValuePairSeq::NameValuePairSeq(ULong max) 
  if (always_ret_0())
  {
    DynamicAny::NameValuePairSeq mySeq((CORBA::ULong)1);

    (void *)&mySeq;
  }

  // Test the constructor 
  // DynamicAny::NameValuePairSeq::NameValuePairSeq(ULong max,ULong length, 
  //           DynamicAny::NameValuePair *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    DynamicAny::NameValuePair myElement;
    DynamicAny::NameValuePairSeq mySeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myElement,
                 (CORBA::Boolean)0);

    (void *)&mySeq;
  }

  // Test the constructor 
  // DynamicAny::NameValuePairSeq::NameValuePairSeq(const DynamicAny::NameValuePairSeq&) 
  if (always_ret_0())
  {
    DynamicAny::NameValuePairSeq mySeq1;
    DynamicAny::NameValuePairSeq mySeq(mySeq1);

    (void *)&mySeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    DynamicAny::NameValuePairSeq  mySeq;
    CORBA::ULong ul = mySeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    DynamicAny::NameValuePairSeq mySeq;

    CORBA::ULong ul = 0;

    mySeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    DynamicAny::NameValuePairSeq mySeq;

    CORBA::ULong ul = mySeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator) 
  if (always_ret_0())
  {
    DynamicAny::NameValuePairSeq mySeq1, mySeq2;

    mySeq1 = mySeq2;

    (void *)&mySeq1;
  }
  
  // Test the operator: DynamicAny::NameValuePairSeq &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    DynamicAny::NameValuePairSeq mySeq;
    DynamicAny::NameValuePair myElement;

    mySeq[index] = myElement;

    (void *)&mySeq;
  }
  
  // Test the operator: const DynamicAny::NameValuePair &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    DynamicAny::NameValuePairSeq mySeq;
    const DynamicAny::NameValuePair& myElement = mySeq[index];

    (void *)&myElement;
  }


  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    DynamicAny::NameValuePairSeq mySeq;
    DynamicAny::NameValuePairSeq *mySeq_ptr;

    any <<= &mySeq;
    any <<= mySeq_ptr;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    const DynamicAny::NameValuePairSeq *mySeq_ptr;
    CORBA::Any any;
    CORBA::Boolean b;

    b = any >>= mySeq_ptr;

    (void*)&b;
    (void*)&mySeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

