//
// Copyright (c) 2000 The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for The Open Group by Object Oriented Concepts GmbH.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The exception CORBA::BAD_QOS shall be defined.");

	// Test the constructors

	::tet_infoline("TEST: The constructor CORBA::BAD_QOS::BAD_QOS()");
	if (always_ret_0())
	{
		CORBA::BAD_QOS myBAD_QOS;

		(void *)&myBAD_QOS;
	}

	::tet_infoline("TEST: The constructor CORBA::BAD_QOS::BAD_QOS(const BAD_QOS &)");
	if (always_ret_0())
	{
		CORBA::BAD_QOS myBAD_QOS1;

		CORBA::BAD_QOS myBAD_QOS2(myBAD_QOS1);

		(void *)&myBAD_QOS2;
	}

	::tet_infoline("TEST: The constructor CORBA::BAD_QOS::BAD_QOS(");
	::tet_infoline("CORBA::ULong minor,");
	::tet_infoline("CORBA::CompletionStatus completed)");
	if (always_ret_0())
	{
		CORBA::ULong *pminor = (CORBA::ULong *)0;
		CORBA::CompletionStatus *pcompleted = (CORBA::CompletionStatus *)0;

		CORBA::BAD_QOS myBAD_QOS2(*pminor,*pcompleted);
	}

	::tet_infoline("TEST: The assignment operator");
	if (always_ret_0())
	{
		CORBA::BAD_QOS myBAD_QOS1;
		CORBA::BAD_QOS myBAD_QOS2;

		myBAD_QOS1 = myBAD_QOS2;

		(void *)&myBAD_QOS1;
	}

	::tet_infoline("TEST: Test the _downcast method");
	if (always_ret_0())
	{
		CORBA::Exception *pException = 0;;
		CORBA::BAD_QOS*pBAD_QOS;

		pBAD_QOS = CORBA::BAD_QOS::_downcast(pException);
	}
	if (always_ret_0())
	{
		const CORBA::Exception *pException = 0;;
		const CORBA::BAD_QOS*pBAD_QOS;

		pBAD_QOS = CORBA::BAD_QOS::_downcast(pException);
	}

	::tet_infoline("TEST: Test the _raise method");
	if (always_ret_0())
	{
		CORBA::BAD_QOS myBAD_QOS;

		myBAD_QOS._raise();
	}

	::tet_infoline("TEST: Test the read access function for minor");
	if (always_ret_0())
	{
		CORBA::BAD_QOS myBAD_QOS;

		CORBA::ULong minor = myBAD_QOS.minor();
	}

	::tet_infoline("TEST: Test the write access function for minor");
	if (always_ret_0())
	{
		CORBA::BAD_QOS myBAD_QOS;
		CORBA::ULong *pminor = 0;

		myBAD_QOS.minor(*pminor);
	}

	::tet_infoline("TEST: Test the read access function for completed");
	if (always_ret_0())
	{
		CORBA::BAD_QOS myBAD_QOS;

		CORBA::CompletionStatus completed = myBAD_QOS.completed();
	}

	::tet_infoline("TEST: Test the write access function for completed");
	if (always_ret_0())
	{
		CORBA::BAD_QOS myBAD_QOS;
		CORBA::CompletionStatus *pcompleted = 0;

		myBAD_QOS.completed(*pcompleted);
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

