//
// Copyright (c) 2000 The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for The Open Group by Object Oriented Concepts GmbH.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The exception CORBA::CODESET_INCOMPATIBLE shall be defined.");

	// Test the constructors

	::tet_infoline("TEST: The constructor CORBA::CODESET_INCOMPATIBLE::CODESET_INCOMPATIBLE()");
	if (always_ret_0())
	{
		CORBA::CODESET_INCOMPATIBLE myCODESET_INCOMPATIBLE;

		(void *)&myCODESET_INCOMPATIBLE;
	}

	::tet_infoline("TEST: The constructor CORBA::CODESET_INCOMPATIBLE::CODESET_INCOMPATIBLE(const CODESET_INCOMPATIBLE &)");
	if (always_ret_0())
	{
		CORBA::CODESET_INCOMPATIBLE myCODESET_INCOMPATIBLE1;

		CORBA::CODESET_INCOMPATIBLE myCODESET_INCOMPATIBLE2(myCODESET_INCOMPATIBLE1);

		(void *)&myCODESET_INCOMPATIBLE2;
	}

	::tet_infoline("TEST: The constructor CORBA::CODESET_INCOMPATIBLE::CODESET_INCOMPATIBLE(");
	::tet_infoline("CORBA::ULong minor,");
	::tet_infoline("CORBA::CompletionStatus completed)");
	if (always_ret_0())
	{
		CORBA::ULong *pminor = (CORBA::ULong *)0;
		CORBA::CompletionStatus *pcompleted = (CORBA::CompletionStatus *)0;

		CORBA::CODESET_INCOMPATIBLE myCODESET_INCOMPATIBLE2(*pminor,*pcompleted);
	}

	::tet_infoline("TEST: The assignment operator");
	if (always_ret_0())
	{
		CORBA::CODESET_INCOMPATIBLE myCODESET_INCOMPATIBLE1;
		CORBA::CODESET_INCOMPATIBLE myCODESET_INCOMPATIBLE2;

		myCODESET_INCOMPATIBLE1 = myCODESET_INCOMPATIBLE2;

		(void *)&myCODESET_INCOMPATIBLE1;
	}

	::tet_infoline("TEST: Test the _downcast method");
	if (always_ret_0())
	{
		CORBA::Exception *pException = 0;;
		CORBA::CODESET_INCOMPATIBLE*pCODESET_INCOMPATIBLE;

		pCODESET_INCOMPATIBLE = CORBA::CODESET_INCOMPATIBLE::_downcast(pException);
	}
	if (always_ret_0())
	{
		const CORBA::Exception *pException = 0;;
		const CORBA::CODESET_INCOMPATIBLE*pCODESET_INCOMPATIBLE;

		pCODESET_INCOMPATIBLE = CORBA::CODESET_INCOMPATIBLE::_downcast(pException);
	}

	::tet_infoline("TEST: Test the _raise method");
	if (always_ret_0())
	{
		CORBA::CODESET_INCOMPATIBLE myCODESET_INCOMPATIBLE;

		myCODESET_INCOMPATIBLE._raise();
	}

	::tet_infoline("TEST: Test the read access function for minor");
	if (always_ret_0())
	{
		CORBA::CODESET_INCOMPATIBLE myCODESET_INCOMPATIBLE;

		CORBA::ULong minor = myCODESET_INCOMPATIBLE.minor();
	}

	::tet_infoline("TEST: Test the write access function for minor");
	if (always_ret_0())
	{
		CORBA::CODESET_INCOMPATIBLE myCODESET_INCOMPATIBLE;
		CORBA::ULong *pminor = 0;

		myCODESET_INCOMPATIBLE.minor(*pminor);
	}

	::tet_infoline("TEST: Test the read access function for completed");
	if (always_ret_0())
	{
		CORBA::CODESET_INCOMPATIBLE myCODESET_INCOMPATIBLE;

		CORBA::CompletionStatus completed = myCODESET_INCOMPATIBLE.completed();
	}

	::tet_infoline("TEST: Test the write access function for completed");
	if (always_ret_0())
	{
		CORBA::CODESET_INCOMPATIBLE myCODESET_INCOMPATIBLE;
		CORBA::CompletionStatus *pcompleted = 0;

		myCODESET_INCOMPATIBLE.completed(*pcompleted);
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

