//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

extern "C" {
static void test1A()
{
	CORBA::CompletionStatus myCompletionStatus1;
	CORBA::CompletionStatus myCompletionStatus2;

	::tet_infoline("The type CORBA::CompletionStatus");
	::tet_infoline("shall be defined to be an enum.");
	::tet_infoline("Each enumerator shall be defined in the correct order.");

	::tet_infoline("TEST: size");

	if (sizeof(CORBA::CompletionStatus) != 4) 
	{
		::tet_printf("ERROR: Expected size of CORBA::CompletionStatus to be 4, is %d", sizeof(CORBA::CompletionStatus));

		::tet_result(TET_FAIL);

		return;
	}

	::tet_infoline("TEST: enumerators");

	myCompletionStatus1 = CORBA::COMPLETED_YES;
	myCompletionStatus2 = CORBA::COMPLETED_NO;

	if (myCompletionStatus1 >= myCompletionStatus2)
	{
		::tet_printf("ERROR: Expected enumerator CORBA::COMPLETED_YES to be less than enumerator CORBA::COMPLETED_NO");

		::tet_result(TET_FAIL);
	}

	myCompletionStatus1 = CORBA::COMPLETED_NO;
	myCompletionStatus2 = CORBA::COMPLETED_MAYBE;

	if (myCompletionStatus1 >= myCompletionStatus2)
	{
		::tet_printf("ERROR: Expected enumerator CORBA::COMPLETED_NO to be less than enumerator CORBA::COMPLETED_MAYBE");

		::tet_result(TET_FAIL);
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

