//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The exception CORBA::IMP_LIMIT shall be defined.");

	// Test the constructors

	::tet_infoline("TEST: The constructor CORBA::IMP_LIMIT::IMP_LIMIT()");
	if (always_ret_0())
	{
		CORBA::IMP_LIMIT myIMP_LIMIT;

		(void *)&myIMP_LIMIT;
	}

	::tet_infoline("TEST: The constructor CORBA::IMP_LIMIT::IMP_LIMIT(const IMP_LIMIT &)");
	if (always_ret_0())
	{
		CORBA::IMP_LIMIT myIMP_LIMIT1;

		CORBA::IMP_LIMIT myIMP_LIMIT2(myIMP_LIMIT1);

		(void *)&myIMP_LIMIT2;
	}

	::tet_infoline("TEST: The constructor CORBA::IMP_LIMIT::IMP_LIMIT(");
	::tet_infoline("CORBA::ULong minor,");
	::tet_infoline("CORBA::CompletionStatus completed)");
	if (always_ret_0())
	{
		CORBA::ULong *pminor = (CORBA::ULong *)0;
		CORBA::CompletionStatus *pcompleted = (CORBA::CompletionStatus *)0;

		CORBA::IMP_LIMIT myIMP_LIMIT2(*pminor,*pcompleted);
	}

	::tet_infoline("TEST: The assignment operator");
	if (always_ret_0())
	{
		CORBA::IMP_LIMIT myIMP_LIMIT1;
		CORBA::IMP_LIMIT myIMP_LIMIT2;

		myIMP_LIMIT1 = myIMP_LIMIT2;

		(void *)&myIMP_LIMIT1;
	}

	::tet_infoline("TEST: Test the _downcast method");
	if (always_ret_0())
	{
		CORBA::Exception *pException = 0;;
		CORBA::IMP_LIMIT*pIMP_LIMIT;

		pIMP_LIMIT = CORBA::IMP_LIMIT::_downcast(pException);
	}
	if (always_ret_0())
	{
	        const CORBA::Exception *pException = 0;;
		const CORBA::IMP_LIMIT*pIMP_LIMIT;

		pIMP_LIMIT = CORBA::IMP_LIMIT::_downcast(pException);
	}

	::tet_infoline("TEST: Test the _raise method");
	if (always_ret_0())
	{
		CORBA::IMP_LIMIT myIMP_LIMIT;

		myIMP_LIMIT._raise();
	}

	::tet_infoline("TEST: Test the read access function for minor");
	if (always_ret_0())
	{
		CORBA::IMP_LIMIT myIMP_LIMIT;

		CORBA::ULong minor = myIMP_LIMIT.minor();
	}

	::tet_infoline("TEST: Test the write access function for minor");
	if (always_ret_0())
	{
		CORBA::IMP_LIMIT myIMP_LIMIT;
		CORBA::ULong *pminor = 0;

		myIMP_LIMIT.minor(*pminor);
	}

	::tet_infoline("TEST: Test the read access function for completed");
	if (always_ret_0())
	{
		CORBA::IMP_LIMIT myIMP_LIMIT;

		CORBA::CompletionStatus completed = myIMP_LIMIT.completed();
	}

	::tet_infoline("TEST: Test the write access function for completed");
	if (always_ret_0())
	{
		CORBA::IMP_LIMIT myIMP_LIMIT;
		CORBA::CompletionStatus *pcompleted = 0;

		myIMP_LIMIT.completed(*pcompleted);
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

