//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The exception CORBA::INTF_REPOS shall be defined.");

	// Test the constructors

	::tet_infoline("TEST: The constructor CORBA::INTF_REPOS::INTF_REPOS()");
	if (always_ret_0())
	{
		CORBA::INTF_REPOS myINTF_REPOS;

		(void *)&myINTF_REPOS;
	}

	::tet_infoline("TEST: The constructor CORBA::INTF_REPOS::INTF_REPOS(const INTF_REPOS &)");
	if (always_ret_0())
	{
		CORBA::INTF_REPOS myINTF_REPOS1;

		CORBA::INTF_REPOS myINTF_REPOS2(myINTF_REPOS1);

		(void *)&myINTF_REPOS2;
	}

	::tet_infoline("TEST: The constructor CORBA::INTF_REPOS::INTF_REPOS(");
	::tet_infoline("CORBA::ULong minor,");
	::tet_infoline("CORBA::CompletionStatus completed)");
	if (always_ret_0())
	{
		CORBA::ULong *pminor = (CORBA::ULong *)0;
		CORBA::CompletionStatus *pcompleted = (CORBA::CompletionStatus *)0;

		CORBA::INTF_REPOS myINTF_REPOS2(*pminor,*pcompleted);
	}

	::tet_infoline("TEST: The assignment operator");
	if (always_ret_0())
	{
		CORBA::INTF_REPOS myINTF_REPOS1;
		CORBA::INTF_REPOS myINTF_REPOS2;

		myINTF_REPOS1 = myINTF_REPOS2;

		(void *)&myINTF_REPOS1;
	}

	::tet_infoline("TEST: Test the _downcast method");
	if (always_ret_0())
	{
		CORBA::Exception *pException = 0;;
		CORBA::INTF_REPOS*pINTF_REPOS;

		pINTF_REPOS = CORBA::INTF_REPOS::_downcast(pException);
	}
	if (always_ret_0())
	{
		const CORBA::Exception *pException = 0;;
		const CORBA::INTF_REPOS*pINTF_REPOS;

		pINTF_REPOS = CORBA::INTF_REPOS::_downcast(pException);
	}

	::tet_infoline("TEST: Test the _raise method");
	if (always_ret_0())
	{
		CORBA::INTF_REPOS myINTF_REPOS;

		myINTF_REPOS._raise();
	}

	::tet_infoline("TEST: Test the read access function for minor");
	if (always_ret_0())
	{
		CORBA::INTF_REPOS myINTF_REPOS;

		CORBA::ULong minor = myINTF_REPOS.minor();
	}

	::tet_infoline("TEST: Test the write access function for minor");
	if (always_ret_0())
	{
		CORBA::INTF_REPOS myINTF_REPOS;
		CORBA::ULong *pminor = 0;

		myINTF_REPOS.minor(*pminor);
	}

	::tet_infoline("TEST: Test the read access function for completed");
	if (always_ret_0())
	{
		CORBA::INTF_REPOS myINTF_REPOS;

		CORBA::CompletionStatus completed = myINTF_REPOS.completed();
	}

	::tet_infoline("TEST: Test the write access function for completed");
	if (always_ret_0())
	{
		CORBA::INTF_REPOS myINTF_REPOS;
		CORBA::CompletionStatus *pcompleted = 0;

		myINTF_REPOS.completed(*pcompleted);
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

