//
// Copyright (c) 2000 The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for The Open Group by Object Oriented Concepts GmbH.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The exception CORBA::INV_POLICY shall be defined.");

	// Test the constructors

	::tet_infoline("TEST: The constructor CORBA::INV_POLICY::INV_POLICY()");
	if (always_ret_0())
	{
		CORBA::INV_POLICY myINV_POLICY;

		(void *)&myINV_POLICY;
	}

	::tet_infoline("TEST: The constructor CORBA::INV_POLICY::INV_POLICY(const INV_POLICY &)");
	if (always_ret_0())
	{
		CORBA::INV_POLICY myINV_POLICY1;

		CORBA::INV_POLICY myINV_POLICY2(myINV_POLICY1);

		(void *)&myINV_POLICY2;
	}

	::tet_infoline("TEST: The constructor CORBA::INV_POLICY::INV_POLICY(");
	::tet_infoline("CORBA::ULong minor,");
	::tet_infoline("CORBA::CompletionStatus completed)");
	if (always_ret_0())
	{
		CORBA::ULong *pminor = (CORBA::ULong *)0;
		CORBA::CompletionStatus *pcompleted = (CORBA::CompletionStatus *)0;

		CORBA::INV_POLICY myINV_POLICY2(*pminor,*pcompleted);
	}

	::tet_infoline("TEST: The assignment operator");
	if (always_ret_0())
	{
		CORBA::INV_POLICY myINV_POLICY1;
		CORBA::INV_POLICY myINV_POLICY2;

		myINV_POLICY1 = myINV_POLICY2;

		(void *)&myINV_POLICY1;
	}

	::tet_infoline("TEST: Test the _downcast method");
	if (always_ret_0())
	{
		CORBA::Exception *pException = 0;;
		CORBA::INV_POLICY*pINV_POLICY;

		pINV_POLICY = CORBA::INV_POLICY::_downcast(pException);
	}
	if (always_ret_0())
	{
		const CORBA::Exception *pException = 0;;
		const CORBA::INV_POLICY*pINV_POLICY;

		pINV_POLICY = CORBA::INV_POLICY::_downcast(pException);
	}

	::tet_infoline("TEST: Test the _raise method");
	if (always_ret_0())
	{
		CORBA::INV_POLICY myINV_POLICY;

		myINV_POLICY._raise();
	}

	::tet_infoline("TEST: Test the read access function for minor");
	if (always_ret_0())
	{
		CORBA::INV_POLICY myINV_POLICY;

		CORBA::ULong minor = myINV_POLICY.minor();
	}

	::tet_infoline("TEST: Test the write access function for minor");
	if (always_ret_0())
	{
		CORBA::INV_POLICY myINV_POLICY;
		CORBA::ULong *pminor = 0;

		myINV_POLICY.minor(*pminor);
	}

	::tet_infoline("TEST: Test the read access function for completed");
	if (always_ret_0())
	{
		CORBA::INV_POLICY myINV_POLICY;

		CORBA::CompletionStatus completed = myINV_POLICY.completed();
	}

	::tet_infoline("TEST: Test the write access function for completed");
	if (always_ret_0())
	{
		CORBA::INV_POLICY myINV_POLICY;
		CORBA::CompletionStatus *pcompleted = 0;

		myINV_POLICY.completed(*pcompleted);
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

