//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The exception CORBA::NO_RESPONSE shall be defined.");

	// Test the constructors

	::tet_infoline("TEST: The constructor CORBA::NO_RESPONSE::NO_RESPONSE()");
	if (always_ret_0())
	{
		CORBA::NO_RESPONSE myNO_RESPONSE;

		(void *)&myNO_RESPONSE;
	}

	::tet_infoline("TEST: The constructor CORBA::NO_RESPONSE::NO_RESPONSE(const NO_RESPONSE &)");
	if (always_ret_0())
	{
		CORBA::NO_RESPONSE myNO_RESPONSE1;

		CORBA::NO_RESPONSE myNO_RESPONSE2(myNO_RESPONSE1);

		(void *)&myNO_RESPONSE2;
	}

	::tet_infoline("TEST: The constructor CORBA::NO_RESPONSE::NO_RESPONSE(");
	::tet_infoline("CORBA::ULong minor,");
	::tet_infoline("CORBA::CompletionStatus completed)");
	if (always_ret_0())
	{
		CORBA::ULong *pminor = (CORBA::ULong *)0;
		CORBA::CompletionStatus *pcompleted = (CORBA::CompletionStatus *)0;

		CORBA::NO_RESPONSE myNO_RESPONSE2(*pminor,*pcompleted);
	}

	::tet_infoline("TEST: The assignment operator");
	if (always_ret_0())
	{
		CORBA::NO_RESPONSE myNO_RESPONSE1;
		CORBA::NO_RESPONSE myNO_RESPONSE2;

		myNO_RESPONSE1 = myNO_RESPONSE2;

		(void *)&myNO_RESPONSE1;
	}

	::tet_infoline("TEST: Test the _downcast method");
	if (always_ret_0())
	{
		CORBA::Exception *pException = 0;;
		CORBA::NO_RESPONSE*pNO_RESPONSE;

		pNO_RESPONSE = CORBA::NO_RESPONSE::_downcast(pException);
	}
	if (always_ret_0())
	{
		const CORBA::Exception *pException = 0;;
		const CORBA::NO_RESPONSE*pNO_RESPONSE;

		pNO_RESPONSE = CORBA::NO_RESPONSE::_downcast(pException);
	}

	::tet_infoline("TEST: Test the _raise method");
	if (always_ret_0())
	{
		CORBA::NO_RESPONSE myNO_RESPONSE;

		myNO_RESPONSE._raise();
	}

	::tet_infoline("TEST: Test the read access function for minor");
	if (always_ret_0())
	{
		CORBA::NO_RESPONSE myNO_RESPONSE;

		CORBA::ULong minor = myNO_RESPONSE.minor();
	}

	::tet_infoline("TEST: Test the write access function for minor");
	if (always_ret_0())
	{
		CORBA::NO_RESPONSE myNO_RESPONSE;
		CORBA::ULong *pminor = 0;

		myNO_RESPONSE.minor(*pminor);
	}

	::tet_infoline("TEST: Test the read access function for completed");
	if (always_ret_0())
	{
		CORBA::NO_RESPONSE myNO_RESPONSE;

		CORBA::CompletionStatus completed = myNO_RESPONSE.completed();
	}

	::tet_infoline("TEST: Test the write access function for completed");
	if (always_ret_0())
	{
		CORBA::NO_RESPONSE myNO_RESPONSE;
		CORBA::CompletionStatus *pcompleted = 0;

		myNO_RESPONSE.completed(*pcompleted);
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

