//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The exception CORBA::OBJECT_NOT_EXIST shall be defined.");

	// Test the constructors

	::tet_infoline("TEST: The constructor CORBA::OBJECT_NOT_EXIST::OBJECT_NOT_EXIST()");
	if (always_ret_0())
	{
		CORBA::OBJECT_NOT_EXIST myOBJECT_NOT_EXIST;

		(void *)&myOBJECT_NOT_EXIST;
	}

	::tet_infoline("TEST: The constructor CORBA::OBJECT_NOT_EXIST::OBJECT_NOT_EXIST(const OBJECT_NOT_EXIST &)");
	if (always_ret_0())
	{
		CORBA::OBJECT_NOT_EXIST myOBJECT_NOT_EXIST1;

		CORBA::OBJECT_NOT_EXIST myOBJECT_NOT_EXIST2(myOBJECT_NOT_EXIST1);

		(void *)&myOBJECT_NOT_EXIST2;
	}

	::tet_infoline("TEST: The constructor CORBA::OBJECT_NOT_EXIST::OBJECT_NOT_EXIST(");
	::tet_infoline("CORBA::ULong minor,");
	::tet_infoline("CORBA::CompletionStatus completed)");
	if (always_ret_0())
	{
		CORBA::ULong *pminor = (CORBA::ULong *)0;
		CORBA::CompletionStatus *pcompleted = (CORBA::CompletionStatus *)0;

		CORBA::OBJECT_NOT_EXIST myOBJECT_NOT_EXIST2(*pminor,*pcompleted);
	}

	::tet_infoline("TEST: The assignment operator");
	if (always_ret_0())
	{
		CORBA::OBJECT_NOT_EXIST myOBJECT_NOT_EXIST1;
		CORBA::OBJECT_NOT_EXIST myOBJECT_NOT_EXIST2;

		myOBJECT_NOT_EXIST1 = myOBJECT_NOT_EXIST2;

		(void *)&myOBJECT_NOT_EXIST1;
	}

	::tet_infoline("TEST: Test the _downcast method");
	if (always_ret_0())
	{
		CORBA::Exception *pException = 0;;
		CORBA::OBJECT_NOT_EXIST*pOBJECT_NOT_EXIST;

		pOBJECT_NOT_EXIST = CORBA::OBJECT_NOT_EXIST::_downcast(pException);
	}
	if (always_ret_0())
	{
		const CORBA::Exception *pException = 0;;
		const CORBA::OBJECT_NOT_EXIST*pOBJECT_NOT_EXIST;

		pOBJECT_NOT_EXIST = CORBA::OBJECT_NOT_EXIST::_downcast(pException);
	}

	::tet_infoline("TEST: Test the _raise method");
	if (always_ret_0())
	{
		CORBA::OBJECT_NOT_EXIST myOBJECT_NOT_EXIST;

		myOBJECT_NOT_EXIST._raise();
	}

	::tet_infoline("TEST: Test the read access function for minor");
	if (always_ret_0())
	{
		CORBA::OBJECT_NOT_EXIST myOBJECT_NOT_EXIST;

		CORBA::ULong minor = myOBJECT_NOT_EXIST.minor();
	}

	::tet_infoline("TEST: Test the write access function for minor");
	if (always_ret_0())
	{
		CORBA::OBJECT_NOT_EXIST myOBJECT_NOT_EXIST;
		CORBA::ULong *pminor = 0;

		myOBJECT_NOT_EXIST.minor(*pminor);
	}

	::tet_infoline("TEST: Test the read access function for completed");
	if (always_ret_0())
	{
		CORBA::OBJECT_NOT_EXIST myOBJECT_NOT_EXIST;

		CORBA::CompletionStatus completed = myOBJECT_NOT_EXIST.completed();
	}

	::tet_infoline("TEST: Test the write access function for completed");
	if (always_ret_0())
	{
		CORBA::OBJECT_NOT_EXIST myOBJECT_NOT_EXIST;
		CORBA::CompletionStatus *pcompleted = 0;

		myOBJECT_NOT_EXIST.completed(*pcompleted);
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

