//
// Copyright (c) 2000 The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for The Open Group by Object Oriented Concepts GmbH.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The exception CORBA::REBIND shall be defined.");

	// Test the constructors

	::tet_infoline("TEST: The constructor CORBA::REBIND::REBIND()");
	if (always_ret_0())
	{
		CORBA::REBIND myREBIND;

		(void *)&myREBIND;
	}

	::tet_infoline("TEST: The constructor CORBA::REBIND::REBIND(const REBIND &)");
	if (always_ret_0())
	{
		CORBA::REBIND myREBIND1;

		CORBA::REBIND myREBIND2(myREBIND1);

		(void *)&myREBIND2;
	}

	::tet_infoline("TEST: The constructor CORBA::REBIND::REBIND(");
	::tet_infoline("CORBA::ULong minor,");
	::tet_infoline("CORBA::CompletionStatus completed)");
	if (always_ret_0())
	{
		CORBA::ULong *pminor = (CORBA::ULong *)0;
		CORBA::CompletionStatus *pcompleted = (CORBA::CompletionStatus *)0;

		CORBA::REBIND myREBIND2(*pminor,*pcompleted);
	}

	::tet_infoline("TEST: The assignment operator");
	if (always_ret_0())
	{
		CORBA::REBIND myREBIND1;
		CORBA::REBIND myREBIND2;

		myREBIND1 = myREBIND2;

		(void *)&myREBIND1;
	}

	::tet_infoline("TEST: Test the _downcast method");
	if (always_ret_0())
	{
		CORBA::Exception *pException = 0;;
		CORBA::REBIND*pREBIND;

		pREBIND = CORBA::REBIND::_downcast(pException);
	}
	if (always_ret_0())
	{
		const CORBA::Exception *pException = 0;;
		const CORBA::REBIND*pREBIND;

		pREBIND = CORBA::REBIND::_downcast(pException);
	}

	::tet_infoline("TEST: Test the _raise method");
	if (always_ret_0())
	{
		CORBA::REBIND myREBIND;

		myREBIND._raise();
	}

	::tet_infoline("TEST: Test the read access function for minor");
	if (always_ret_0())
	{
		CORBA::REBIND myREBIND;

		CORBA::ULong minor = myREBIND.minor();
	}

	::tet_infoline("TEST: Test the write access function for minor");
	if (always_ret_0())
	{
		CORBA::REBIND myREBIND;
		CORBA::ULong *pminor = 0;

		myREBIND.minor(*pminor);
	}

	::tet_infoline("TEST: Test the read access function for completed");
	if (always_ret_0())
	{
		CORBA::REBIND myREBIND;

		CORBA::CompletionStatus completed = myREBIND.completed();
	}

	::tet_infoline("TEST: Test the write access function for completed");
	if (always_ret_0())
	{
		CORBA::REBIND myREBIND;
		CORBA::CompletionStatus *pcompleted = 0;

		myREBIND.completed(*pcompleted);
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

