//
// Copyright (c) 2000 The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for The Open Group by Object Oriented Concepts GmbH.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The exception CORBA::TRANSACTION_MODE shall be defined.");

	// Test the constructors

	::tet_infoline("TEST: The constructor CORBA::TRANSACTION_MODE::TRANSACTION_MODE()");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_MODE myTRANSACTION_MODE;

		(void *)&myTRANSACTION_MODE;
	}

	::tet_infoline("TEST: The constructor CORBA::TRANSACTION_MODE::TRANSACTION_MODE(const TRANSACTION_MODE &)");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_MODE myTRANSACTION_MODE1;

		CORBA::TRANSACTION_MODE myTRANSACTION_MODE2(myTRANSACTION_MODE1);

		(void *)&myTRANSACTION_MODE2;
	}

	::tet_infoline("TEST: The constructor CORBA::TRANSACTION_MODE::TRANSACTION_MODE(");
	::tet_infoline("CORBA::ULong minor,");
	::tet_infoline("CORBA::CompletionStatus completed)");
	if (always_ret_0())
	{
		CORBA::ULong *pminor = (CORBA::ULong *)0;
		CORBA::CompletionStatus *pcompleted = (CORBA::CompletionStatus *)0;

		CORBA::TRANSACTION_MODE myTRANSACTION_MODE2(*pminor,*pcompleted);
	}

	::tet_infoline("TEST: The assignment operator");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_MODE myTRANSACTION_MODE1;
		CORBA::TRANSACTION_MODE myTRANSACTION_MODE2;

		myTRANSACTION_MODE1 = myTRANSACTION_MODE2;

		(void *)&myTRANSACTION_MODE1;
	}

	::tet_infoline("TEST: Test the _downcast method");
	if (always_ret_0())
	{
		CORBA::Exception *pException = 0;;
		CORBA::TRANSACTION_MODE*pTRANSACTION_MODE;

		pTRANSACTION_MODE = CORBA::TRANSACTION_MODE::_downcast(pException);
	}
	if (always_ret_0())
	{
		const CORBA::Exception *pException = 0;;
		const CORBA::TRANSACTION_MODE*pTRANSACTION_MODE;

		pTRANSACTION_MODE = CORBA::TRANSACTION_MODE::_downcast(pException);
	}

	::tet_infoline("TEST: Test the _raise method");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_MODE myTRANSACTION_MODE;

		myTRANSACTION_MODE._raise();
	}

	::tet_infoline("TEST: Test the read access function for minor");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_MODE myTRANSACTION_MODE;

		CORBA::ULong minor = myTRANSACTION_MODE.minor();
	}

	::tet_infoline("TEST: Test the write access function for minor");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_MODE myTRANSACTION_MODE;
		CORBA::ULong *pminor = 0;

		myTRANSACTION_MODE.minor(*pminor);
	}

	::tet_infoline("TEST: Test the read access function for completed");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_MODE myTRANSACTION_MODE;

		CORBA::CompletionStatus completed = myTRANSACTION_MODE.completed();
	}

	::tet_infoline("TEST: Test the write access function for completed");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_MODE myTRANSACTION_MODE;
		CORBA::CompletionStatus *pcompleted = 0;

		myTRANSACTION_MODE.completed(*pcompleted);
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

