//
// Copyright (c) 2000 The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for The Open Group by Object Oriented Concepts GmbH.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The exception CORBA::TRANSACTION_UNAVAILABLE shall be defined.");

	// Test the constructors

	::tet_infoline("TEST: The constructor CORBA::TRANSACTION_UNAVAILABLE::TRANSACTION_UNAVAILABLE()");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_UNAVAILABLE myTRANSACTION_UNAVAILABLE;

		(void *)&myTRANSACTION_UNAVAILABLE;
	}

	::tet_infoline("TEST: The constructor CORBA::TRANSACTION_UNAVAILABLE::TRANSACTION_UNAVAILABLE(const TRANSACTION_UNAVAILABLE &)");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_UNAVAILABLE myTRANSACTION_UNAVAILABLE1;

		CORBA::TRANSACTION_UNAVAILABLE myTRANSACTION_UNAVAILABLE2(myTRANSACTION_UNAVAILABLE1);

		(void *)&myTRANSACTION_UNAVAILABLE2;
	}

	::tet_infoline("TEST: The constructor CORBA::TRANSACTION_UNAVAILABLE::TRANSACTION_UNAVAILABLE(");
	::tet_infoline("CORBA::ULong minor,");
	::tet_infoline("CORBA::CompletionStatus completed)");
	if (always_ret_0())
	{
		CORBA::ULong *pminor = (CORBA::ULong *)0;
		CORBA::CompletionStatus *pcompleted = (CORBA::CompletionStatus *)0;

		CORBA::TRANSACTION_UNAVAILABLE myTRANSACTION_UNAVAILABLE2(*pminor,*pcompleted);
	}

	::tet_infoline("TEST: The assignment operator");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_UNAVAILABLE myTRANSACTION_UNAVAILABLE1;
		CORBA::TRANSACTION_UNAVAILABLE myTRANSACTION_UNAVAILABLE2;

		myTRANSACTION_UNAVAILABLE1 = myTRANSACTION_UNAVAILABLE2;

		(void *)&myTRANSACTION_UNAVAILABLE1;
	}

	::tet_infoline("TEST: Test the _downcast method");
	if (always_ret_0())
	{
		CORBA::Exception *pException = 0;;
		CORBA::TRANSACTION_UNAVAILABLE*pTRANSACTION_UNAVAILABLE;

		pTRANSACTION_UNAVAILABLE = CORBA::TRANSACTION_UNAVAILABLE::_downcast(pException);
	}
	if (always_ret_0())
	{
		const CORBA::Exception *pException = 0;;
		const CORBA::TRANSACTION_UNAVAILABLE*pTRANSACTION_UNAVAILABLE;

		pTRANSACTION_UNAVAILABLE = CORBA::TRANSACTION_UNAVAILABLE::_downcast(pException);
	}

	::tet_infoline("TEST: Test the _raise method");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_UNAVAILABLE myTRANSACTION_UNAVAILABLE;

		myTRANSACTION_UNAVAILABLE._raise();
	}

	::tet_infoline("TEST: Test the read access function for minor");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_UNAVAILABLE myTRANSACTION_UNAVAILABLE;

		CORBA::ULong minor = myTRANSACTION_UNAVAILABLE.minor();
	}

	::tet_infoline("TEST: Test the write access function for minor");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_UNAVAILABLE myTRANSACTION_UNAVAILABLE;
		CORBA::ULong *pminor = 0;

		myTRANSACTION_UNAVAILABLE.minor(*pminor);
	}

	::tet_infoline("TEST: Test the read access function for completed");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_UNAVAILABLE myTRANSACTION_UNAVAILABLE;

		CORBA::CompletionStatus completed = myTRANSACTION_UNAVAILABLE.completed();
	}

	::tet_infoline("TEST: Test the write access function for completed");
	if (always_ret_0())
	{
		CORBA::TRANSACTION_UNAVAILABLE myTRANSACTION_UNAVAILABLE;
		CORBA::CompletionStatus *pcompleted = 0;

		myTRANSACTION_UNAVAILABLE.completed(*pcompleted);
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

