//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <stdio.h>
#include <tet_api.h>

char ebuf[4096];

extern "C" {
static void test1A(void)
{
/*enum*/ CORBA::completion_status mycompletion_status1;
/*enum*/ CORBA::completion_status mycompletion_status2;

  ::tet_infoline("The type CORBA::completion_status");
  ::tet_infoline("shall be defined to be an enum.");
  ::tet_infoline("Each enumerator shall be defined in the correct order");

  ::tet_infoline("TEST: size");
  if (sizeof(CORBA::completion_status) != 4) {
    ::sprintf((char *)&ebuf[0],
              "ERROR: Expected size of CORBA::completion_status to be 4, is %d", 
              sizeof(CORBA::completion_status));
    ::tet_infoline(ebuf);
    ::tet_result(TET_FAIL);
    return;
  }

  ::tet_infoline("TEST: enumerators");

  mycompletion_status1 = CORBA::COMPLETED_YES;;
  mycompletion_status2 = CORBA::COMPLETED_NO;;
  if (mycompletion_status1 >= mycompletion_status2)
  {
    ::sprintf((char *)&ebuf[0], "ERROR: Expected enumerator CORBA::COMPLETED_YES to be "
      "less than enumerator CORBA::COMPLETED_NO");
    ::tet_infoline(ebuf);
    ::tet_result(TET_FAIL);
  }

  mycompletion_status1 = CORBA::COMPLETED_NO;;
  mycompletion_status2 = CORBA::COMPLETED_MAYBE;;
  if (mycompletion_status1 >= mycompletion_status2)
  {
    ::sprintf((char *)&ebuf[0], "ERROR: Expected enumerator CORBA::COMPLETED_NO to be "
      "less than enumerator CORBA::COMPLETED_MAYBE");
    ::tet_infoline(ebuf);
    ::tet_result(TET_FAIL);
  }


  ::tet_result(TET_PASS);
}
}

void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };


