//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::AttrDescriptionSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of AttributeDescription.");

  // Test the constructors 

  // Test the constructor CORBA::AttrDescriptionSeq::AttrDescriptionSeq() 
  if (always_ret_0())
  {
    CORBA::AttrDescriptionSeq myAttrDescriptionSeq;

    (void *)&myAttrDescriptionSeq;
  }

  // Test the constructor CORBA::AttrDescriptionSeq::AttrDescriptionSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::AttrDescriptionSeq myAttrDescriptionSeq((CORBA::ULong)1);

    (void *)&myAttrDescriptionSeq;
  }

  // Test the constructor 
  // CORBA::AttrDescriptionSeq::AttrDescriptionSeq(ULong max,ULong length, 
  //           AttributeDescription *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::AttributeDescription  *myBuffer;
    CORBA::AttrDescriptionSeq myAttrDescriptionSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myAttrDescriptionSeq;
  }

  // Test the constructor 
  // CORBA::AttrDescriptionSeq::AttrDescriptionSeq(const CORBA::AttrDescriptionSeq&) 
  if (always_ret_0())
  {
    CORBA::AttrDescriptionSeq  myAttrDescriptionSeq1;
    CORBA::AttrDescriptionSeq myAttrDescriptionSeq(myAttrDescriptionSeq1);

    (void *)&myAttrDescriptionSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::AttrDescriptionSeq  myAttrDescriptionSeq;
    CORBA::ULong ul = myAttrDescriptionSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::AttrDescriptionSeq myAttrDescriptionSeq;

    CORBA::ULong ul = 0;

    myAttrDescriptionSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::AttrDescriptionSeq myAttrDescriptionSeq;

    CORBA::ULong ul = myAttrDescriptionSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the operator AttributeDescription &operator=(const AttributeDescription&) 
  if (always_ret_0())
  {
    CORBA::AttrDescriptionSeq myAttrDescriptionSeq1, myAttrDescriptionSeq2;

    myAttrDescriptionSeq1 = myAttrDescriptionSeq2;

    (void *)&myAttrDescriptionSeq1;
  }
  
  // Test the operator AttributeDescription &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::AttrDescriptionSeq myAttrDescriptionSeq;
    CORBA::AttributeDescription myAttributeDescription;

    myAttrDescriptionSeq[index] = myAttributeDescription;

    (void *)&myAttrDescriptionSeq;
  }
  
  // Test the operator const AttributeDescription &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::AttrDescriptionSeq myAttrDescriptionSeq;
    const CORBA::AttributeDescription& myAttributeDescription = myAttrDescriptionSeq[index];

    (void *)&myAttributeDescription;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::AttrDescriptionSeq myAttrDescriptionSeq;

    any <<= myAttrDescriptionSeq;
    any <<= &myAttrDescriptionSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::AttrDescriptionSeq *myConstAttrDescriptionSeq_ptr;

    b = any >>= myConstAttrDescriptionSeq_ptr;

    (void*)&b;
    (void*)&myConstAttrDescriptionSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

