//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::ContainedSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of Contained.");

  // Test the constructors 

  // Test the constructor CORBA::ContainedSeq::ContainedSeq() 
  if (always_ret_0())
  {
    CORBA::ContainedSeq myContainedSeq;

    (void *)&myContainedSeq;
  }

  // Test the constructor CORBA::ContainedSeq::ContainedSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::ContainedSeq myContainedSeq((CORBA::ULong)1);

    (void *)&myContainedSeq;
  }

  // Test the constructor 
  // CORBA::ContainedSeq::ContainedSeq(ULong max,ULong length, 
  //           Contained *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::Contained_ptr myBuffer;
    CORBA::ContainedSeq myContainedSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myContainedSeq;
  }

  // Test the constructor 
  // CORBA::ContainedSeq::ContainedSeq(const CORBA::ContainedSeq&) 
  if (always_ret_0())
  {
    CORBA::ContainedSeq  myContainedSeq1;
    CORBA::ContainedSeq myContainedSeq(myContainedSeq1);

    (void *)&myContainedSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::ContainedSeq  myContainedSeq;
    CORBA::ULong ul = myContainedSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::ContainedSeq myContainedSeq;

    CORBA::ULong ul = 0;

    myContainedSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::ContainedSeq myContainedSeq;

    CORBA::ULong ul = myContainedSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the operator Contained &operator=(const Contained&) 
  if (always_ret_0())
  {
    CORBA::ContainedSeq myContainedSeq1, myContainedSeq2;

    myContainedSeq1 = myContainedSeq2;

    (void *)&myContainedSeq1;
  }
  
  // Test the operator Contained &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ContainedSeq myContainedSeq;
    CORBA::Contained_var myContained;

    myContainedSeq[index] = myContained;

    (void *)&myContainedSeq;
  }
  
  // Test the operator const Contained &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ContainedSeq myContainedSeq;
    const CORBA::Contained_var& myContained = myContainedSeq[index];

    (void *)&myContained;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::ContainedSeq myContainedSeq;

    any <<= myContainedSeq;
    any <<= &myContainedSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::ContainedSeq *myContainedSeq_ptr = 0;

    b = any >>= myContainedSeq_ptr;

    (void*)&b;
    (void*)&myContainedSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

