//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The class CORBA::Container shall be defined ");
  ::tet_infoline("to be a class that inherits from");
  ::tet_infoline("IRObject Object .");

  ::tet_infoline("TEST: Widening of object reference to IRObject");
  if (always_ret_0())
  {
    CORBA::Container_ptr  myContainer_ptr = (CORBA::Container_ptr)0;
    CORBA::Container_var  myContainer_var;

    CORBA::IRObject_ptr myIRObject_ptr1 = myContainer_ptr;
    CORBA::IRObject_ptr myIRObject_ptr2 = myContainer_var;
    CORBA::IRObject_var myIRObject_var = CORBA::Container::_duplicate(myContainer_var);

    (void *)&myIRObject_var;
  }

  ::tet_infoline("TEST: Widening of object reference to Object");
  if (always_ret_0())
  {
    CORBA::IRObject_ptr  myIRObject_ptr = (CORBA::IRObject_ptr)0;
    CORBA::IRObject_var  myIRObject_var;

    CORBA::Object_ptr myObject_ptr1 = myIRObject_ptr;
    CORBA::Object_ptr myObject_ptr2 = myIRObject_var;
    CORBA::Object_var myObject_var = CORBA::IRObject::_duplicate(myIRObject_var);

    (void *)&myObject_var;
  }


  ::tet_infoline("TEST: Assignment");
  if (always_ret_0())
  {
    CORBA::Container_var  myContainer_var1;
    CORBA::Container_var  myContainer_var2;

    myContainer_var1 = myContainer_var2;

    (void *)&myContainer_var1;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Container_ptr  myContainer_ptr = (CORBA::Container_ptr)0;

    any <<= myContainer_ptr;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    CORBA::Container_ptr  myContainer_ptr=(CORBA::Container_ptr)0;

    b = any >>= myContainer_ptr;

    (void*)&b;
    (void*)&myContainer_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

