//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	CORBA::Container_var myObjRef;

	// declare an instance of the return type 
	CORBA::InterfaceDef_ptr ret;

	// declare an instance of each parameter 
	const char * id = (const char *)0; // in 
	const char * name = (const char *)0; // in 
	const char * version = (const char *)0; // in 
	const CORBA::InterfaceDefSeq base_interfaces;//  = (const CORBA::InterfaceDefSeq)0; // in 

	::tet_infoline("The function CORBA::Container::create_interface");
	::tet_infoline("shall be defined to be of type");
	::tet_infoline("CORBA::InterfaceDef_ptr CORBA::Container::create_interface(");
	::tet_infoline("const char *,");
	::tet_infoline("const char *,");
	::tet_infoline("const char *,");
	::tet_infoline("const CORBA::InterfaceDefSeq&");
	::tet_infoline(");");

	// Include a call to the function to make sure it is present in the library 
	if (always_ret_0())
		ret = 

			myObjRef->create_interface(id, name, version, base_interfaces );

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

