//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::ContextIdSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of ContextIdentifier.");

  // Test the constructors 

  // Test the constructor CORBA::ContextIdSeq::ContextIdSeq() 
  if (always_ret_0())
  {
    CORBA::ContextIdSeq myContextIdSeq;

    (void *)&myContextIdSeq;
  }

  // Test the constructor CORBA::ContextIdSeq::ContextIdSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::ContextIdSeq myContextIdSeq((CORBA::ULong)1);

    (void *)&myContextIdSeq;
  }

  // Test the constructor 
  // CORBA::ContextIdSeq::ContextIdSeq(ULong max,ULong length, 
  //           ContextIdentifier *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::ContextIdentifier  *myBuffer;
    CORBA::ContextIdSeq myContextIdSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myContextIdSeq;
  }

  // Test the constructor 
  // CORBA::ContextIdSeq::ContextIdSeq(const CORBA::ContextIdSeq&) 
  if (always_ret_0())
  {
    CORBA::ContextIdSeq  myContextIdSeq1;
    CORBA::ContextIdSeq myContextIdSeq(myContextIdSeq1);

    (void *)&myContextIdSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::ContextIdSeq  myContextIdSeq;
    CORBA::ULong ul = myContextIdSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::ContextIdSeq myContextIdSeq;

    CORBA::ULong ul = 0;

    myContextIdSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::ContextIdSeq myContextIdSeq;

    CORBA::ULong ul = myContextIdSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the operator ContextIdentifier &operator=(const ContextIdentifier&) 
  if (always_ret_0())
  {
    CORBA::ContextIdSeq myContextIdSeq1, myContextIdSeq2;

    myContextIdSeq1 = myContextIdSeq2;

    (void *)&myContextIdSeq1;
  }
  
  // Test the operator ContextIdentifier &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ContextIdSeq myContextIdSeq;
    CORBA::ContextIdentifier myContextIdentifier;

    myContextIdSeq[index] = myContextIdentifier;

    (void *)&myContextIdSeq;
  }
  
  // Test the operator const ContextIdentifier &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ContextIdSeq myContextIdSeq;
    const CORBA::ContextIdentifier& myContextIdentifier = myContextIdSeq[index];

    (void *)&myContextIdentifier;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::ContextIdSeq myContextIdSeq;

    any <<= myContextIdSeq;
    any <<= &myContextIdSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::ContextIdSeq *myConstContextIdSeq_ptr;

    b = any >>= myConstContextIdSeq_ptr;

    (void*)&b;
    (void*)&myConstContextIdSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

