//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  CORBA::ContextIdentifier  myContextIdentifier;
  CORBA::Identifier BaseType;
  CORBA::Identifier *pBaseType;

  ::tet_infoline("The type CORBA::ContextIdentifier shall be defined ");
  ::tet_infoline("to be of type Identifier.");

  myContextIdentifier = (CORBA::ContextIdentifier)0;
  BaseType = (CORBA::Identifier)0;

  ::tet_infoline("TEST: size");
  if (sizeof(CORBA::ContextIdentifier) != sizeof(CORBA::Identifier))
  {
    ::tet_printf("ERROR: Expected size of CORBA::ContextIdentifier to be %d, is %d.", sizeof(CORBA::Identifier), sizeof(CORBA::ContextIdentifier));

    ::tet_result(TET_FAIL);
    return;
  }

  if (myContextIdentifier == BaseType)
    pBaseType = &myContextIdentifier;
 
  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;

    any <<= myContextIdentifier;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

