//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;
static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  CORBA::DefinitionKind myDefinitionKind1;
  CORBA::DefinitionKind myDefinitionKind2;

  ::tet_infoline("The type CORBA::DefinitionKind");
  ::tet_infoline("shall be defined to be an enum.");
  ::tet_infoline("Each enumerator shall be defined in the correct order.");

  ::tet_infoline("TEST: size");

  if (sizeof(CORBA::DefinitionKind) != 4)
  {
    ::tet_printf("ERROR: Expected size of CORBA::DefinitionKind to be 4, is %d", sizeof(CORBA::DefinitionKind));

    ::tet_result(TET_FAIL);

    return;
  }

  ::tet_infoline("TEST: enumerators");

  myDefinitionKind1 = CORBA::dk_none;
  myDefinitionKind2 = CORBA::dk_all;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_none to be less than enumerator CORBA::dk_all");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_all;
  myDefinitionKind2 = CORBA::dk_Attribute;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_all to be less than enumerator CORBA::dk_Attribute");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_Attribute;
  myDefinitionKind2 = CORBA::dk_Constant;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_Attribute to be less than enumerator CORBA::dk_Constant");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_Constant;
  myDefinitionKind2 = CORBA::dk_Exception;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_Constant to be less than enumerator CORBA::dk_Exception");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_Exception;
  myDefinitionKind2 = CORBA::dk_Interface;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_Exception to be less than enumerator CORBA::dk_Interface");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_Interface;
  myDefinitionKind2 = CORBA::dk_Module;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_Interface to be less than enumerator CORBA::dk_Module");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_Module;
  myDefinitionKind2 = CORBA::dk_Operation;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_Module to be less than enumerator CORBA::dk_Operation");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_Operation;
  myDefinitionKind2 = CORBA::dk_Typedef;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_Operation to be less than enumerator CORBA::dk_Typedef");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_Typedef;
  myDefinitionKind2 = CORBA::dk_Alias;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_Typedef to be less than enumerator CORBA::dk_Alias");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_Alias;
  myDefinitionKind2 = CORBA::dk_Struct;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_Alias to be less than enumerator CORBA::dk_Struct");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_Struct;
  myDefinitionKind2 = CORBA::dk_Union;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_Struct to be less than enumerator CORBA::dk_Union");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_Union;
  myDefinitionKind2 = CORBA::dk_Enum;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_Union to be less than enumerator CORBA::dk_Enum");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_Enum;
  myDefinitionKind2 = CORBA::dk_Primitive;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_Enum to be less than enumerator CORBA::dk_Primitive");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_Primitive;
  myDefinitionKind2 = CORBA::dk_String;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_Primitive to be less than enumerator CORBA::dk_String");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_String;
  myDefinitionKind2 = CORBA::dk_Sequence;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_String to be less than enumerator CORBA::dk_Sequence");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_Sequence;
  myDefinitionKind2 = CORBA::dk_Array;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_Sequence to be less than enumerator CORBA::dk_Array");

    ::tet_result(TET_FAIL);
  }

  myDefinitionKind1 = CORBA::dk_Array;
  myDefinitionKind2 = CORBA::dk_Repository;

  if (myDefinitionKind1 >= myDefinitionKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::dk_Array to be less than enumerator CORBA::dk_Repository");

    ::tet_result(TET_FAIL);
  }


  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any  any;

    any <<= myDefinitionKind1;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any  any;
    CORBA::Boolean b;
    b = any >>= myDefinitionKind1;

    (void*)&b;
    (void*)&myDefinitionKind1;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

