//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::EnumMemberSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of Identifier.");

  // Test the constructors 

  // Test the constructor CORBA::EnumMemberSeq::EnumMemberSeq() 
  if (always_ret_0())
  {
    CORBA::EnumMemberSeq myEnumMemberSeq;

    (void *)&myEnumMemberSeq;
  }

  // Test the constructor CORBA::EnumMemberSeq::EnumMemberSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::EnumMemberSeq myEnumMemberSeq((CORBA::ULong)1);

    (void *)&myEnumMemberSeq;
  }

  // Test the constructor 
  // CORBA::EnumMemberSeq::EnumMemberSeq(ULong max,ULong length, 
  //           Identifier *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::Identifier  *myBuffer;
    CORBA::EnumMemberSeq myEnumMemberSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myEnumMemberSeq;
  }

  // Test the constructor 
  // CORBA::EnumMemberSeq::EnumMemberSeq(const CORBA::EnumMemberSeq&) 
  if (always_ret_0())
  {
    CORBA::EnumMemberSeq  myEnumMemberSeq1;
    CORBA::EnumMemberSeq myEnumMemberSeq(myEnumMemberSeq1);

    (void *)&myEnumMemberSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::EnumMemberSeq  myEnumMemberSeq;
    CORBA::ULong ul = myEnumMemberSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::EnumMemberSeq myEnumMemberSeq;

    CORBA::ULong ul = 0;

    myEnumMemberSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::EnumMemberSeq myEnumMemberSeq;

    CORBA::ULong ul = myEnumMemberSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the operator Identifier &operator=(const Identifier&) 
  if (always_ret_0())
  {
    CORBA::EnumMemberSeq myEnumMemberSeq1, myEnumMemberSeq2;

    myEnumMemberSeq1 = myEnumMemberSeq2;

    (void *)&myEnumMemberSeq1;
  }
  
  // Test the operator Identifier &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::EnumMemberSeq myEnumMemberSeq;
    CORBA::Identifier myIdentifier;

    myEnumMemberSeq[index] = myIdentifier;

    (void *)&myEnumMemberSeq;
  }
  
  // Test the operator const Identifier &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::EnumMemberSeq myEnumMemberSeq;
    const CORBA::Identifier& myIdentifier = myEnumMemberSeq[index];

    (void *)&myIdentifier;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::EnumMemberSeq myEnumMemberSeq;

    any <<= myEnumMemberSeq;
    any <<= &myEnumMemberSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::EnumMemberSeq *myEnumMemberSeq_ptr;

    b = any >>= myEnumMemberSeq_ptr;

    (void*)&b;
    (void*)&myEnumMemberSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

