//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::ExcDescriptionSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of ExceptionDescription.");

  // Test the constructors 

  // Test the constructor CORBA::ExcDescriptionSeq::ExcDescriptionSeq() 
  if (always_ret_0())
  {
    CORBA::ExcDescriptionSeq myExcDescriptionSeq;

    (void *)&myExcDescriptionSeq;
  }

  // Test the constructor CORBA::ExcDescriptionSeq::ExcDescriptionSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::ExcDescriptionSeq myExcDescriptionSeq((CORBA::ULong)1);

    (void *)&myExcDescriptionSeq;
  }

  // Test the constructor 
  // CORBA::ExcDescriptionSeq::ExcDescriptionSeq(ULong max,ULong length, 
  //           ExceptionDescription *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::ExceptionDescription  *myBuffer;
    CORBA::ExcDescriptionSeq myExcDescriptionSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myExcDescriptionSeq;
  }

  // Test the constructor 
  // CORBA::ExcDescriptionSeq::ExcDescriptionSeq(const CORBA::ExcDescriptionSeq&) 
  if (always_ret_0())
  {
    CORBA::ExcDescriptionSeq  myExcDescriptionSeq1;
    CORBA::ExcDescriptionSeq myExcDescriptionSeq(myExcDescriptionSeq1);

    (void *)&myExcDescriptionSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::ExcDescriptionSeq  myExcDescriptionSeq;
    CORBA::ULong ul = myExcDescriptionSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::ExcDescriptionSeq myExcDescriptionSeq;

    CORBA::ULong ul = 0;

    myExcDescriptionSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::ExcDescriptionSeq myExcDescriptionSeq;

    CORBA::ULong ul = myExcDescriptionSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the operator ExceptionDescription &operator=(const ExceptionDescription&) 
  if (always_ret_0())
  {
    CORBA::ExcDescriptionSeq myExcDescriptionSeq1, myExcDescriptionSeq2;

    myExcDescriptionSeq1 = myExcDescriptionSeq2;

    (void *)&myExcDescriptionSeq1;
  }
  
  // Test the operator ExceptionDescription &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ExcDescriptionSeq myExcDescriptionSeq;
    CORBA::ExceptionDescription myExceptionDescription;

    myExcDescriptionSeq[index] = myExceptionDescription;

    (void *)&myExcDescriptionSeq;
  }
  
  // Test the operator const ExceptionDescription &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ExcDescriptionSeq myExcDescriptionSeq;
    const CORBA::ExceptionDescription& myExceptionDescription = myExcDescriptionSeq[index];

    (void *)&myExceptionDescription;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::ExcDescriptionSeq myExcDescriptionSeq;

    any <<= myExcDescriptionSeq;
    any <<= &myExcDescriptionSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::ExcDescriptionSeq *myConstExcDescriptionSeq_ptr;

    b = any >>= myConstExcDescriptionSeq_ptr;

    (void*)&b;
    (void*)&myConstExcDescriptionSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

