//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::ExceptionDefSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of ExceptionDef.");

  // Test the constructors 

  // Test the constructor CORBA::ExceptionDefSeq::ExceptionDefSeq() 
  if (always_ret_0())
  {
    CORBA::ExceptionDefSeq myExceptionDefSeq;

    (void *)&myExceptionDefSeq;
  }

  // Test the constructor CORBA::ExceptionDefSeq::ExceptionDefSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::ExceptionDefSeq myExceptionDefSeq((CORBA::ULong)1);

    (void *)&myExceptionDefSeq;
  }

  // Test the constructor 
  // CORBA::ExceptionDefSeq::ExceptionDefSeq(ULong max,ULong length, 
  //           ExceptionDef *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::ExceptionDef_ptr myBuffer;
    CORBA::ExceptionDefSeq myExceptionDefSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myExceptionDefSeq;
  }

  // Test the constructor 
  // CORBA::ExceptionDefSeq::ExceptionDefSeq(const CORBA::ExceptionDefSeq&) 
  if (always_ret_0())
  {
    CORBA::ExceptionDefSeq  myExceptionDefSeq1;
    CORBA::ExceptionDefSeq myExceptionDefSeq(myExceptionDefSeq1);

    (void *)&myExceptionDefSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::ExceptionDefSeq  myExceptionDefSeq;
    CORBA::ULong ul = myExceptionDefSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::ExceptionDefSeq myExceptionDefSeq;

    CORBA::ULong ul = 0;

    myExceptionDefSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::ExceptionDefSeq myExceptionDefSeq;

    CORBA::ULong ul = myExceptionDefSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the operator ExceptionDef &operator=(const ExceptionDef&) 
  if (always_ret_0())
  {
    CORBA::ExceptionDefSeq myExceptionDefSeq1, myExceptionDefSeq2;

    myExceptionDefSeq1 = myExceptionDefSeq2;

    (void *)&myExceptionDefSeq1;
  }
  
  // Test the operator ExceptionDef &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ExceptionDefSeq myExceptionDefSeq;
    CORBA::ExceptionDef_var myExceptionDef;

    myExceptionDefSeq[index] = myExceptionDef;

    (void *)&myExceptionDefSeq;
  }
  
  // Test the operator const ExceptionDef &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ExceptionDefSeq myExceptionDefSeq;
    const CORBA::ExceptionDef_var& myExceptionDef = myExceptionDefSeq[index];

    (void *)&myExceptionDef;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::ExceptionDefSeq myExceptionDefSeq;

    any <<= myExceptionDefSeq;
    any <<= &myExceptionDefSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::ExceptionDefSeq *myConstExceptionDefSeq_ptr = 0;

    b = any >>= myConstExceptionDefSeq_ptr;

    (void*)&b;
    (void*)&myConstExceptionDefSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

