//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  CORBA::Initializer  myStructure;

  // Declare pointers for each of the member fields 
  CORBA::StructMemberSeq myField1;
  CORBA::Identifier_var myField2;

  ::tet_infoline("The struct CORBA::Initializer");
  ::tet_infoline("shall be defined and shall have the members");
  ::tet_infoline("{CORBA::StructMemberSeq members, CORBA::Identifier name}.");

  // Force the compiler to complain if the a member type is incorrect

  // Test the field name 
  myField1 = myStructure.members;

  // Test the field type 
  myField2 = myStructure.name;


  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Initializer  myStructure;
    CORBA::Initializer  *myStructure_ptr;

    any <<= &myStructure;
    any <<= myStructure_ptr;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    const CORBA::Initializer  *myStructure_ptr;
    CORBA::Any any;
    CORBA::Boolean b;

    b = any >>= myStructure_ptr;

    (void*)&b;
    (void*)&myStructure_ptr;
  }


  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

