//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  CORBA::InterfaceDef::FullInterfaceDescription  myFullInterfaceDescription;
  CORBA::InterfaceDef::FullInterfaceDescription  *myFullInterfaceDescription_ptr;

  // Declare pointers for each of the member fields 
  CORBA::Identifier_var myname;
  CORBA::RepositoryId_var myid;
  CORBA::RepositoryId_var mydefined_in;
  CORBA::VersionSpec_var myversion;
  CORBA::OpDescriptionSeq *poperations;
  CORBA::AttrDescriptionSeq *pattributes;
  CORBA::RepositoryIdSeq *pbase_interfaces;
  CORBA::TypeCode_var mytype;

  ::tet_infoline("The struct CORBA::InterfaceDef::FullInterfaceDescription");
  ::tet_infoline("shall be defined and shall have the members");
  ::tet_infoline("{ Identifier name, RepositoryId id, RepositoryId defined_in, VersionSpec version, OpDescriptionSeq operations, AttrDescriptionSeq attributes, RepositoryIdSeq base_interfaces, TypeCode type}.");

  // Force the compiler to complain if the a member type is incorrect

  // Test the field name 
  myname = myFullInterfaceDescription.name;

  // Test the field id 
  myid = myFullInterfaceDescription.id;

  // Test the field defined_in 
  mydefined_in = myFullInterfaceDescription.defined_in;

  // Test the field version 
  myversion = myFullInterfaceDescription.version;

  // Test the field operations 
  poperations = &myFullInterfaceDescription.operations;

  // Test the field attributes 
  pattributes = &myFullInterfaceDescription.attributes;

  // Test the field base_interfaces 
  pbase_interfaces = &myFullInterfaceDescription.base_interfaces;

  // Test the field type 
  mytype = myFullInterfaceDescription.type;


  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;

    any <<= myFullInterfaceDescription;
    any <<= &myFullInterfaceDescription;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::InterfaceDef::FullInterfaceDescription *myConstFullInterfaceDescription_ptr = 0;

    b = any >>= myConstFullInterfaceDescription_ptr;

    (void*)&b;
    (void*)&myConstFullInterfaceDescription_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

