//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::InterfaceDefSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of InterfaceDef.");

  // Test the constructors 

  // Test the constructor CORBA::InterfaceDefSeq::InterfaceDefSeq() 
  if (always_ret_0())
  {
    CORBA::InterfaceDefSeq myInterfaceDefSeq;

    (void *)&myInterfaceDefSeq;
  }

  // Test the constructor CORBA::InterfaceDefSeq::InterfaceDefSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::InterfaceDefSeq myInterfaceDefSeq((CORBA::ULong)1);

    (void *)&myInterfaceDefSeq;
  }

  // Test the constructor 
  // CORBA::InterfaceDefSeq::InterfaceDefSeq(ULong max,ULong length, 
  //           InterfaceDef *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::InterfaceDef_ptr  myBuffer;
    CORBA::InterfaceDefSeq myInterfaceDefSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myInterfaceDefSeq;
  }

  // Test the constructor 
  // CORBA::InterfaceDefSeq::InterfaceDefSeq(const CORBA::InterfaceDefSeq&) 
  if (always_ret_0())
  {
    CORBA::InterfaceDefSeq  myInterfaceDefSeq1;
    CORBA::InterfaceDefSeq myInterfaceDefSeq(myInterfaceDefSeq1);

    (void *)&myInterfaceDefSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::InterfaceDefSeq  myInterfaceDefSeq;
    CORBA::ULong ul = myInterfaceDefSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::InterfaceDefSeq myInterfaceDefSeq;

    CORBA::ULong ul = 0;

    myInterfaceDefSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::InterfaceDefSeq myInterfaceDefSeq;

    CORBA::ULong ul = myInterfaceDefSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the operator InterfaceDef &operator=(const InterfaceDef&) 
  if (always_ret_0())
  {
    CORBA::InterfaceDefSeq myInterfaceDefSeq1, myInterfaceDefSeq2;

    myInterfaceDefSeq1 = myInterfaceDefSeq2;

    (void *)&myInterfaceDefSeq1;
  }
  
  // Test the operator InterfaceDef &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::InterfaceDefSeq myInterfaceDefSeq;
    CORBA::InterfaceDef_var myInterfaceDef;

    myInterfaceDefSeq[index] = myInterfaceDef;

    (void *)&myInterfaceDefSeq;
  }
  
  // Test the operator const InterfaceDef &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::InterfaceDefSeq myInterfaceDefSeq;
    const CORBA::InterfaceDef_var& myInterfaceDef = myInterfaceDefSeq[index];

    (void *)&myInterfaceDef;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::InterfaceDefSeq myInterfaceDefSeq;

    any <<= myInterfaceDefSeq;
    any <<= &myInterfaceDefSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::InterfaceDefSeq *myInterfaceDefSeq_ptr = 0;

    b = any >>= myInterfaceDefSeq_ptr;

    (void*)&b;
    (void*)&myInterfaceDefSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

