//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	CORBA::ModuleDef_var myObjRef;

	// declare an instance of the return type 
	CORBA::ValueBoxDef_ptr ret;

	// declare an instance of each parameter 

	const char * myp1 = (const char *)0; // in CORBA::RepositoryId
	const char * myp2 = (const char *)0; // in CORBA::Identifier_var
	const char * myp3 = (const char *)0; // in CORBA::VersionSpec
	CORBA::IDLType* myp4 = 0; // in CORBA::IDLType

	::tet_infoline("The function CORBA::ModuleDef::create_value_box");
	::tet_infoline("shall be defined to be of type");
	::tet_infoline("CORBA::ValueBoxDef_ptr create_value_box(");
	::tet_infoline("CORBA::RepositoryId,");
	::tet_infoline("CORBA::Identifier_var,");
	::tet_infoline("CORBA::VersionSpec");
	::tet_infoline("CORBA::IDLType");
	::tet_infoline(");");

	// Include a call to the function to make sure it is present in the library 
	if (always_ret_0())
		ret = myObjRef->create_value_box(myp1,myp2,myp3,myp4);

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

