//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; 

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A(void)
{
	CORBA::ORB_var  myObjRef;

	// declare an instance of the return type 
	CORBA::TypeCode_ptr ret;

	// declare an instance of each parameter 
	const char *id = 0;
	const char *name = 0;
	CORBA::EnumMemberSeq members;

  ::tet_infoline("The function CORBA::ORB::create_enum_tc");
  ::tet_infoline("shall be defined to be of type");
  ::tet_infoline("CORBA::TypeCode_ptr CORBA::ORB::create_enum_tc(");
  ::tet_infoline("    const char *,");
  ::tet_infoline("    const char *,");
  ::tet_infoline("    const CORBA::EnumMemberSeq&");
  ::tet_infoline("    );");

  // Include a call to the function to make sure it is present in the library 
  if (always_ret_0())
    ret = 
      myObjRef->create_enum_tc(id, name, members );

  ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}

