//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::OpDescriptionSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of OperationDescription.");

  // Test the constructors 

  // Test the constructor CORBA::OpDescriptionSeq::OpDescriptionSeq() 
  if (always_ret_0())
  {
    CORBA::OpDescriptionSeq myOpDescriptionSeq;

    (void *)&myOpDescriptionSeq;
  }

  // Test the constructor CORBA::OpDescriptionSeq::OpDescriptionSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::OpDescriptionSeq myOpDescriptionSeq((CORBA::ULong)1);

    (void *)&myOpDescriptionSeq;
  }

  // Test the constructor 
  // CORBA::OpDescriptionSeq::OpDescriptionSeq(ULong max,ULong length, 
  //           OperationDescription *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::OperationDescription  *myBuffer;
    CORBA::OpDescriptionSeq myOpDescriptionSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myOpDescriptionSeq;
  }

  // Test the constructor 
  // CORBA::OpDescriptionSeq::OpDescriptionSeq(const CORBA::OpDescriptionSeq&) 
  if (always_ret_0())
  {
    CORBA::OpDescriptionSeq  myOpDescriptionSeq1;
    CORBA::OpDescriptionSeq myOpDescriptionSeq(myOpDescriptionSeq1);

    (void *)&myOpDescriptionSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::OpDescriptionSeq  myOpDescriptionSeq;
    CORBA::ULong ul = myOpDescriptionSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::OpDescriptionSeq myOpDescriptionSeq;

    CORBA::ULong ul = 0;

    myOpDescriptionSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::OpDescriptionSeq myOpDescriptionSeq;

    CORBA::ULong ul = myOpDescriptionSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the operator OperationDescription &operator=(const OperationDescription&) 
  if (always_ret_0())
  {
    CORBA::OpDescriptionSeq myOpDescriptionSeq1, myOpDescriptionSeq2;

    myOpDescriptionSeq1 = myOpDescriptionSeq2;

    (void *)&myOpDescriptionSeq1;
  }
  
  // Test the operator OperationDescription &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::OpDescriptionSeq myOpDescriptionSeq;
    CORBA::OperationDescription myOperationDescription;

    myOpDescriptionSeq[index] = myOperationDescription;

    (void *)&myOpDescriptionSeq;
  }
  
  // Test the operator const OperationDescription &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::OpDescriptionSeq myOpDescriptionSeq;
    const CORBA::OperationDescription& myOperationDescription = myOpDescriptionSeq[index];

    (void *)&myOperationDescription;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::OpDescriptionSeq myOpDescriptionSeq;

    any <<= myOpDescriptionSeq;
    any <<= &myOpDescriptionSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::OpDescriptionSeq *myOpDescriptionSeq_ptr = 0;

    b = any >>= myOpDescriptionSeq_ptr;

    (void*)&b;
    (void*)&myOpDescriptionSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

