//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  CORBA::OperationDescription  myOperationDescription;
  CORBA::OperationDescription  *myOperationDescription_ptr;

  // Declare pointers for each of the member fields 
  CORBA::Identifier_var myname;
  CORBA::RepositoryId_var myid;
  CORBA::RepositoryId_var mydefined_in;
  CORBA::VersionSpec_var myversion;
  CORBA::TypeCode_var myresult;
  CORBA::OperationMode *pmode;
  CORBA::ContextIdSeq *pcontexts;
  CORBA::ParDescriptionSeq *pparameters;
  CORBA::ExcDescriptionSeq *pexceptions;

  ::tet_infoline("The struct CORBA::OperationDescription");
  ::tet_infoline("shall be defined and shall have the members");
  ::tet_infoline("{ Identifier name, RepositoryId id, RepositoryId defined_in, VersionSpec version, TypeCode result, OperationMode mode, ContextIdSeq contexts, ParDescriptionSeq parameters, ExcDescriptionSeq exceptions}.");

  // Force the compiler to complain if the a member type is incorrect

  // Test the field name 
  myname = myOperationDescription.name;

  // Test the field id 
  myid = myOperationDescription.id;

  // Test the field defined_in 
  mydefined_in = myOperationDescription.defined_in;

  // Test the field version 
  myversion = myOperationDescription.version;

  // Test the field result 
  myresult = myOperationDescription.result;

  // Test the field mode 
  pmode = &myOperationDescription.mode;

  // Test the field contexts 
  pcontexts = &myOperationDescription.contexts;

  // Test the field parameters 
  pparameters = &myOperationDescription.parameters;

  // Test the field exceptions 
  pexceptions = &myOperationDescription.exceptions;


  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;

    any <<= myOperationDescription;
    any <<= &myOperationDescription;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::OperationDescription *myConstOperationDescription_ptr = 0;

    b = any >>= myConstOperationDescription_ptr;

    (void*)&b;
    (void*)&myConstOperationDescription_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

