//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;
static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  CORBA::OperationMode myOperationMode1;
  CORBA::OperationMode myOperationMode2;

  ::tet_infoline("The type CORBA::OperationMode");
  ::tet_infoline("shall be defined to be an enum.");
  ::tet_infoline("Each enumerator shall be defined in the correct order.");

  ::tet_infoline("TEST: size");

  if (sizeof(CORBA::OperationMode) != 4)
  {
    ::tet_printf("ERROR: Expected size of CORBA::OperationMode to be 4, is %d", sizeof(CORBA::OperationMode));

    ::tet_result(TET_FAIL);

    return;
  }

  ::tet_infoline("TEST: enumerators");

  myOperationMode1 = CORBA::OP_NORMAL;
  myOperationMode2 = CORBA::OP_ONEWAY;

  if (myOperationMode1 >= myOperationMode2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::OP_NORMAL to be less than enumerator CORBA::OP_ONEWAY");

    ::tet_result(TET_FAIL);
  }


  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any  any;

    any <<= myOperationMode1;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any  any;
    CORBA::Boolean b;
    b = any >>= myOperationMode1;

    (void*)&b;
    (void*)&myOperationMode1;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

