//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::ParDescriptionSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of ParameterDescription.");

  // Test the constructors 

  // Test the constructor CORBA::ParDescriptionSeq::ParDescriptionSeq() 
  if (always_ret_0())
  {
    CORBA::ParDescriptionSeq myParDescriptionSeq;

    (void *)&myParDescriptionSeq;
  }

  // Test the constructor CORBA::ParDescriptionSeq::ParDescriptionSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::ParDescriptionSeq myParDescriptionSeq((CORBA::ULong)1);

    (void *)&myParDescriptionSeq;
  }

  // Test the constructor 
  // CORBA::ParDescriptionSeq::ParDescriptionSeq(ULong max,ULong length, 
  //           ParameterDescription *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::ParameterDescription  *myBuffer;
    CORBA::ParDescriptionSeq myParDescriptionSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myParDescriptionSeq;
  }

  // Test the constructor 
  // CORBA::ParDescriptionSeq::ParDescriptionSeq(const CORBA::ParDescriptionSeq&) 
  if (always_ret_0())
  {
    CORBA::ParDescriptionSeq  myParDescriptionSeq1;
    CORBA::ParDescriptionSeq myParDescriptionSeq(myParDescriptionSeq1);

    (void *)&myParDescriptionSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::ParDescriptionSeq  myParDescriptionSeq;
    CORBA::ULong ul = myParDescriptionSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::ParDescriptionSeq myParDescriptionSeq;

    CORBA::ULong ul = 0;

    myParDescriptionSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::ParDescriptionSeq myParDescriptionSeq;

    CORBA::ULong ul = myParDescriptionSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the operator ParameterDescription &operator=(const ParameterDescription&) 
  if (always_ret_0())
  {
    CORBA::ParDescriptionSeq myParDescriptionSeq1, myParDescriptionSeq2;

    myParDescriptionSeq1 = myParDescriptionSeq2;

    (void *)&myParDescriptionSeq1;
  }
  
  // Test the operator ParameterDescription &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ParDescriptionSeq myParDescriptionSeq;
    CORBA::ParameterDescription myParameterDescription;

    myParDescriptionSeq[index] = myParameterDescription;

    (void *)&myParDescriptionSeq;
  }
  
  // Test the operator const ParameterDescription &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ParDescriptionSeq myParDescriptionSeq;
    const CORBA::ParameterDescription& myParameterDescription = myParDescriptionSeq[index];

    (void *)&myParameterDescription;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::ParDescriptionSeq myParDescriptionSeq;

    any <<= myParDescriptionSeq;
    any <<= &myParDescriptionSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::ParDescriptionSeq *myConstParDescriptionSeq_ptr;

    b = any >>= myConstParDescriptionSeq_ptr;

    (void*)&b;
    (void*)&myConstParDescriptionSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

