//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;
static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  CORBA::ParameterMode myParameterMode1;
  CORBA::ParameterMode myParameterMode2;

  ::tet_infoline("The type CORBA::ParameterMode");
  ::tet_infoline("shall be defined to be an enum.");
  ::tet_infoline("Each enumerator shall be defined in the correct order.");

  ::tet_infoline("TEST: size");

  if (sizeof(CORBA::ParameterMode) != 4)
  {
    ::tet_printf("ERROR: Expected size of CORBA::ParameterMode to be 4, is %d", sizeof(CORBA::ParameterMode));

    ::tet_result(TET_FAIL);

    return;
  }

  ::tet_infoline("TEST: enumerators");

  myParameterMode1 = CORBA::PARAM_IN;
  myParameterMode2 = CORBA::PARAM_OUT;

  if (myParameterMode1 >= myParameterMode2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::PARAM_IN to be less than enumerator CORBA::PARAM_OUT");

    ::tet_result(TET_FAIL);
  }

  myParameterMode1 = CORBA::PARAM_OUT;
  myParameterMode2 = CORBA::PARAM_INOUT;

  if (myParameterMode1 >= myParameterMode2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::PARAM_OUT to be less than enumerator CORBA::PARAM_INOUT");

    ::tet_result(TET_FAIL);
  }


  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any  any;

    any <<= myParameterMode1;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any  any;
    CORBA::Boolean b;
    b = any >>= myParameterMode1;

    (void*)&b;
    (void*)&myParameterMode1;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

