//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;
static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  CORBA::PrimitiveKind myPrimitiveKind1;
  CORBA::PrimitiveKind myPrimitiveKind2;

  ::tet_infoline("The type CORBA::PrimitiveKind");
  ::tet_infoline("shall be defined to be an enum.");
  ::tet_infoline("Each enumerator shall be defined in the correct order.");

  ::tet_infoline("TEST: size");

  if (sizeof(CORBA::PrimitiveKind) != 4)
  {
    ::tet_printf("ERROR: Expected size of CORBA::PrimitiveKind to be 4, is %d", sizeof(CORBA::PrimitiveKind));

    ::tet_result(TET_FAIL);

    return;
  }

  ::tet_infoline("TEST: enumerators");

  myPrimitiveKind1 = CORBA::pk_null;
  myPrimitiveKind2 = CORBA::pk_void;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_null to be less than enumerator CORBA::pk_void");

    ::tet_result(TET_FAIL);
  }

  myPrimitiveKind1 = CORBA::pk_void;
  myPrimitiveKind2 = CORBA::pk_short;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_void to be less than enumerator CORBA::pk_short");

    ::tet_result(TET_FAIL);
  }

  myPrimitiveKind1 = CORBA::pk_short;
  myPrimitiveKind2 = CORBA::pk_long;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_short to be less than enumerator CORBA::pk_long");

    ::tet_result(TET_FAIL);
  }

  myPrimitiveKind1 = CORBA::pk_long;
  myPrimitiveKind2 = CORBA::pk_ushort;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_long to be less than enumerator CORBA::pk_ushort");

    ::tet_result(TET_FAIL);
  }

  myPrimitiveKind1 = CORBA::pk_ushort;
  myPrimitiveKind2 = CORBA::pk_ulong;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_ushort to be less than enumerator CORBA::pk_ulong");

    ::tet_result(TET_FAIL);
  }

  myPrimitiveKind1 = CORBA::pk_ulong;
  myPrimitiveKind2 = CORBA::pk_float;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_ulong to be less than enumerator CORBA::pk_float");

    ::tet_result(TET_FAIL);
  }

  myPrimitiveKind1 = CORBA::pk_float;
  myPrimitiveKind2 = CORBA::pk_double;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_float to be less than enumerator CORBA::pk_double");

    ::tet_result(TET_FAIL);
  }

  myPrimitiveKind1 = CORBA::pk_double;
  myPrimitiveKind2 = CORBA::pk_boolean;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_double to be less than enumerator CORBA::pk_boolean");

    ::tet_result(TET_FAIL);
  }

  myPrimitiveKind1 = CORBA::pk_boolean;
  myPrimitiveKind2 = CORBA::pk_char;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_boolean to be less than enumerator CORBA::pk_char");

    ::tet_result(TET_FAIL);
  }

  myPrimitiveKind1 = CORBA::pk_char;
  myPrimitiveKind2 = CORBA::pk_octet;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_char to be less than enumerator CORBA::pk_octet");

    ::tet_result(TET_FAIL);
  }

  myPrimitiveKind1 = CORBA::pk_octet;
  myPrimitiveKind2 = CORBA::pk_any;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_octet to be less than enumerator CORBA::pk_any");

    ::tet_result(TET_FAIL);
  }

  myPrimitiveKind1 = CORBA::pk_any;
  myPrimitiveKind2 = CORBA::pk_TypeCode;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_any to be less than enumerator CORBA::pk_TypeCode");

    ::tet_result(TET_FAIL);
  }

  myPrimitiveKind1 = CORBA::pk_TypeCode;
  myPrimitiveKind2 = CORBA::pk_Principal;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_TypeCode to be less than enumerator CORBA::pk_Principal");

    ::tet_result(TET_FAIL);
  }

  myPrimitiveKind1 = CORBA::pk_Principal;
  myPrimitiveKind2 = CORBA::pk_string;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_Principal to be less than enumerator CORBA::pk_string");

    ::tet_result(TET_FAIL);
  }

  myPrimitiveKind1 = CORBA::pk_string;
  myPrimitiveKind2 = CORBA::pk_objref;

  if (myPrimitiveKind1 >= myPrimitiveKind2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::pk_string to be less than enumerator CORBA::pk_objref");

    ::tet_result(TET_FAIL);
  }


  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any  any;

    any <<= myPrimitiveKind1;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any  any;
    CORBA::Boolean b;
    b = any >>= myPrimitiveKind1;

    (void*)&b;
    (void*)&myPrimitiveKind1;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

