//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::Repository::DescriptionSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of Description.");

  // Test the constructors 

  // Test the constructor CORBA::Repository::DescriptionSeq::DescriptionSeq() 
  if (always_ret_0())
  {
    CORBA::Repository::DescriptionSeq myDescriptionSeq;

    (void *)&myDescriptionSeq;
  }

  // Test the constructor CORBA::Repository::DescriptionSeq::DescriptionSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::Repository::DescriptionSeq myDescriptionSeq((CORBA::ULong)1);

    (void *)&myDescriptionSeq;
  }

  // Test the constructor 
  // CORBA::Repository::DescriptionSeq::DescriptionSeq(ULong max,ULong length, 
  //           Description *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::Repository::Description  *myBuffer;
    CORBA::Repository::DescriptionSeq myDescriptionSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myDescriptionSeq;
  }

  // Test the constructor 
  // CORBA::Repository::DescriptionSeq::DescriptionSeq(const CORBA::Repository::DescriptionSeq&) 
  if (always_ret_0())
  {
    CORBA::Repository::DescriptionSeq  myDescriptionSeq1;
    CORBA::Repository::DescriptionSeq myDescriptionSeq(myDescriptionSeq1);

    (void *)&myDescriptionSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::Repository::DescriptionSeq  myDescriptionSeq;
    CORBA::ULong ul = myDescriptionSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::Repository::DescriptionSeq myDescriptionSeq;

    CORBA::ULong ul = 0;

    myDescriptionSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::Repository::DescriptionSeq myDescriptionSeq;

    CORBA::ULong ul = myDescriptionSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the operator Description &operator=(const Description&) 
  if (always_ret_0())
  {
    CORBA::Repository::DescriptionSeq myDescriptionSeq1, myDescriptionSeq2;

    myDescriptionSeq1 = myDescriptionSeq2;

    (void *)&myDescriptionSeq1;
  }
  
  // Test the operator Description &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::Repository::DescriptionSeq myDescriptionSeq;
    CORBA::Repository::Description myDescription;

    myDescriptionSeq[index] = myDescription;

    (void *)&myDescriptionSeq;
  }
  
  // Test the operator const Description &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::Repository::DescriptionSeq myDescriptionSeq;
    const CORBA::Repository::Description& myDescription = myDescriptionSeq[index];

    (void *)&myDescription;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Repository::DescriptionSeq myDescriptionSeq;

    any <<= myDescriptionSeq;
    any <<= &myDescriptionSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::Repository::DescriptionSeq *myConstDescriptionSeq_ptr = 0;

    b = any >>= myConstDescriptionSeq_ptr;

    (void*)&b;
    (void*)&myConstDescriptionSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

