//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

static void test1A()
{
	CORBA::Repository_var myObjRef;

	// declare an instance of the return type 
	CORBA::ConstantDef_ptr ret;

	// declare an instance of each parameter 
	const char * id = (const char *)0; // in 
	const char * name = (const char *)0; // in 
	const char * version = (const char *)0; // in 
	CORBA::IDLType_ptr type = (CORBA::IDLType_ptr)0; // in 
	const CORBA::Any value;//  = (const CORBA::Any)0; // in 

	::tet_infoline("The function CORBA::Repository::create_constant");
	::tet_infoline("shall be defined to be of type");
	::tet_infoline("CORBA::ConstantDef_ptr CORBA::Repository::create_constant(");
	::tet_infoline("const char *,");
	::tet_infoline("const char *,");
	::tet_infoline("const char *,");
	::tet_infoline("CORBA::IDLType_ptr,");
	::tet_infoline("const CORBA::Any&");
	::tet_infoline(");");

	// Include a call to the function to make sure it is present in the library 
	if (always_ret_0())
		ret = 

			myObjRef->create_constant(id, name, version, type, value );

	::tet_result(TET_PASS);
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

