//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::RepositoryIdSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of RepositoryId.");

  // Test the constructors 

  // Test the constructor CORBA::RepositoryIdSeq::RepositoryIdSeq() 
  if (always_ret_0())
  {
    CORBA::RepositoryIdSeq myRepositoryIdSeq;

    (void *)&myRepositoryIdSeq;
  }

  // Test the constructor CORBA::RepositoryIdSeq::RepositoryIdSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::RepositoryIdSeq myRepositoryIdSeq((CORBA::ULong)1);

    (void *)&myRepositoryIdSeq;
  }

  // Test the constructor 
  // CORBA::RepositoryIdSeq::RepositoryIdSeq(ULong max,ULong length, 
  //           RepositoryId *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::RepositoryId  *myBuffer;
    CORBA::RepositoryIdSeq myRepositoryIdSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myRepositoryIdSeq;
  }

  // Test the constructor 
  // CORBA::RepositoryIdSeq::RepositoryIdSeq(const CORBA::RepositoryIdSeq&) 
  if (always_ret_0())
  {
    CORBA::RepositoryIdSeq  myRepositoryIdSeq1;
    CORBA::RepositoryIdSeq myRepositoryIdSeq(myRepositoryIdSeq1);

    (void *)&myRepositoryIdSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::RepositoryIdSeq  myRepositoryIdSeq;
    CORBA::ULong ul = myRepositoryIdSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::RepositoryIdSeq myRepositoryIdSeq;

    CORBA::ULong ul = 0;

    myRepositoryIdSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::RepositoryIdSeq myRepositoryIdSeq;

    CORBA::ULong ul = myRepositoryIdSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the operator RepositoryId &operator=(const RepositoryId&) 
  if (always_ret_0())
  {
    CORBA::RepositoryIdSeq myRepositoryIdSeq1, myRepositoryIdSeq2;

    myRepositoryIdSeq1 = myRepositoryIdSeq2;

    (void *)&myRepositoryIdSeq1;
  }
  
  // Test the operator RepositoryId &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::RepositoryIdSeq myRepositoryIdSeq;
    CORBA::RepositoryId myRepositoryId;

    myRepositoryIdSeq[index] = myRepositoryId;

    (void *)&myRepositoryIdSeq;
  }
  
  // Test the operator const RepositoryId &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::RepositoryIdSeq myRepositoryIdSeq;
    const CORBA::RepositoryId& myRepositoryId = myRepositoryIdSeq[index];

    (void *)&myRepositoryId;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::RepositoryIdSeq myRepositoryIdSeq;

    any <<= myRepositoryIdSeq;
    any <<= &myRepositoryIdSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::RepositoryIdSeq *myConstRepositoryIdSeq_ptr = 0;

    b = any >>= myConstRepositoryIdSeq_ptr;

    (void*)&b;
    (void*)&myConstRepositoryIdSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

