//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The class CORBA::SequenceDef shall be defined ");
  ::tet_infoline("to be a class that inherits from");
  ::tet_infoline("IDLType IRObject Object .");

  ::tet_infoline("TEST: Widening of object reference to IDLType");
  if (always_ret_0())
  {
    CORBA::SequenceDef_ptr  mySequenceDef_ptr = (CORBA::SequenceDef_ptr)0;
    CORBA::SequenceDef_var  mySequenceDef_var;

    CORBA::IDLType_ptr myIDLType_ptr1 = mySequenceDef_ptr;
    CORBA::IDLType_ptr myIDLType_ptr2 = mySequenceDef_var;
    CORBA::IDLType_var myIDLType_var = CORBA::SequenceDef::_duplicate(mySequenceDef_var);

    (void *)&myIDLType_var;
  }

  ::tet_infoline("TEST: Widening of object reference to IRObject");
  if (always_ret_0())
  {
    CORBA::IDLType_ptr  myIDLType_ptr = (CORBA::IDLType_ptr)0;
    CORBA::IDLType_var  myIDLType_var;

    CORBA::IRObject_ptr myIRObject_ptr1 = myIDLType_ptr;
    CORBA::IRObject_ptr myIRObject_ptr2 = myIDLType_var;
    CORBA::IRObject_var myIRObject_var = CORBA::IDLType::_duplicate(myIDLType_var);

    (void *)&myIRObject_var;
  }

  ::tet_infoline("TEST: Widening of object reference to Object");
  if (always_ret_0())
  {
    CORBA::IRObject_ptr  myIRObject_ptr = (CORBA::IRObject_ptr)0;
    CORBA::IRObject_var  myIRObject_var;

    CORBA::Object_ptr myObject_ptr1 = myIRObject_ptr;
    CORBA::Object_ptr myObject_ptr2 = myIRObject_var;
    CORBA::Object_var myObject_var = CORBA::IRObject::_duplicate(myIRObject_var);

    (void *)&myObject_var;
  }


  ::tet_infoline("TEST: Assignment");
  if (always_ret_0())
  {
    CORBA::SequenceDef_var  mySequenceDef_var1;
    CORBA::SequenceDef_var  mySequenceDef_var2;

    mySequenceDef_var1 = mySequenceDef_var2;

    (void *)&mySequenceDef_var1;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::SequenceDef_ptr  mySequenceDef_ptr = (CORBA::SequenceDef_ptr)0;

    any <<= mySequenceDef_ptr;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    CORBA::SequenceDef_ptr  mySequenceDef_ptr=(CORBA::SequenceDef_ptr)0;

    b = any >>= mySequenceDef_ptr;

    (void*)&b;
    (void*)&mySequenceDef_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

