//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  CORBA::StructMember  myStructMember;
  CORBA::StructMember  *myStructMember_ptr;

  // Declare pointers for each of the member fields 
  CORBA::Identifier_var myname;
  CORBA::TypeCode_var mytype;
  CORBA::IDLType_var mytype_def;

  ::tet_infoline("The struct CORBA::StructMember");
  ::tet_infoline("shall be defined and shall have the members");
  ::tet_infoline("{ Identifier name, TypeCode type, IDLType type_def}.");

  // Force the compiler to complain if the a member type is incorrect

  // Test the field name 
  myname = myStructMember.name;

  // Test the field type 
  mytype = myStructMember.type;

  // Test the field type_def 
  mytype_def = myStructMember.type_def;


  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;

    any <<= myStructMember;
    any <<= &myStructMember;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    const CORBA::StructMember *myConstStructMember_ptr = 0;
    CORBA::Any any;
    CORBA::Boolean b;

    b = any >>= myConstStructMember_ptr;

    (void*)&b;
    (void*)&myConstStructMember_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

