//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::StructMemberSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of StructMember.");

  // Test the constructors 

  // Test the constructor CORBA::StructMemberSeq::StructMemberSeq() 
  if (always_ret_0())
  {
    CORBA::StructMemberSeq myStructMemberSeq;

    (void *)&myStructMemberSeq;
  }

  // Test the constructor CORBA::StructMemberSeq::StructMemberSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::StructMemberSeq myStructMemberSeq((CORBA::ULong)1);

    (void *)&myStructMemberSeq;
  }

  // Test the constructor 
  // CORBA::StructMemberSeq::StructMemberSeq(ULong max,ULong length, 
  //           StructMember *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::StructMember  *myBuffer;
    CORBA::StructMemberSeq myStructMemberSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myStructMemberSeq;
  }

  // Test the constructor 
  // CORBA::StructMemberSeq::StructMemberSeq(const CORBA::StructMemberSeq&) 
  if (always_ret_0())
  {
    CORBA::StructMemberSeq  myStructMemberSeq1;
    CORBA::StructMemberSeq myStructMemberSeq(myStructMemberSeq1);

    (void *)&myStructMemberSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::StructMemberSeq  myStructMemberSeq;
    CORBA::ULong ul = myStructMemberSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::StructMemberSeq myStructMemberSeq;

    CORBA::ULong ul = 0;

    myStructMemberSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::StructMemberSeq myStructMemberSeq;

    CORBA::ULong ul = myStructMemberSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the operator StructMember &operator=(const StructMember&) 
  if (always_ret_0())
  {
    CORBA::StructMemberSeq myStructMemberSeq1, myStructMemberSeq2;

    myStructMemberSeq1 = myStructMemberSeq2;

    (void *)&myStructMemberSeq1;
  }
  
  // Test the operator StructMember &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::StructMemberSeq myStructMemberSeq;
    CORBA::StructMember myStructMember;

    myStructMemberSeq[index] = myStructMember;

    (void *)&myStructMemberSeq;
  }
  
  // Test the operator const StructMember &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::StructMemberSeq myStructMemberSeq;
    const CORBA::StructMember& myStructMember = myStructMemberSeq[index];

    (void *)&myStructMember;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::StructMemberSeq myStructMemberSeq;

    any <<= myStructMemberSeq;
    any <<= &myStructMemberSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::StructMemberSeq *myStructMemberSeq_ptr = 0;

    b = any >>= myStructMemberSeq_ptr;

    (void*)&b;
    (void*)&myStructMemberSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

