//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  CORBA::TypeDescription  myTypeDescription;
  CORBA::TypeDescription  *myTypeDescription_ptr;

  // Declare pointers for each of the member fields 
  CORBA::Identifier_var myname;
  CORBA::RepositoryId_var myid;
  CORBA::RepositoryId_var mydefined_in;
  CORBA::VersionSpec_var myversion;
  CORBA::TypeCode_var mytype;

  ::tet_infoline("The struct CORBA::TypeDescription");
  ::tet_infoline("shall be defined and shall have the members");
  ::tet_infoline("{ Identifier name, RepositoryId id, RepositoryId defined_in, VersionSpec version, TypeCode type}.");

  // Force the compiler to complain if the a member type is incorrect

  // Test the field name 
  myname = myTypeDescription.name;

  // Test the field id 
  myid = myTypeDescription.id;

  // Test the field defined_in 
  mydefined_in = myTypeDescription.defined_in;

  // Test the field version 
  myversion = myTypeDescription.version;

  // Test the field type 
  mytype = myTypeDescription.type;


  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;

    any <<= myTypeDescription;
    any <<= &myTypeDescription;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::TypeDescription *myConstTypeDescription_ptr = 0;

    b = any >>= myConstTypeDescription_ptr;

    (void*)&b;
    (void*)&myConstTypeDescription_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

