//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The class CORBA::UnionDef shall be defined ");
  ::tet_infoline("to be a class that inherits from");
  ::tet_infoline("TypedefDef Contained IRObject Object IDLType .");

  ::tet_infoline("TEST: Widening of object reference to TypedefDef");
  if (always_ret_0())
  {
    CORBA::UnionDef_ptr  myUnionDef_ptr = (CORBA::UnionDef_ptr)0;
    CORBA::UnionDef_var  myUnionDef_var;

    CORBA::TypedefDef_ptr myTypedefDef_ptr1 = myUnionDef_ptr;
    CORBA::TypedefDef_ptr myTypedefDef_ptr2 = myUnionDef_var;
    CORBA::TypedefDef_var myTypedefDef_var = CORBA::UnionDef::_duplicate(myUnionDef_var);

    (void *)&myTypedefDef_var;
  }

  ::tet_infoline("TEST: Widening of object reference to Contained");
  if (always_ret_0())
  {
    CORBA::TypedefDef_ptr  myTypedefDef_ptr = (CORBA::TypedefDef_ptr)0;
    CORBA::TypedefDef_var  myTypedefDef_var;

    CORBA::Contained_ptr myContained_ptr1 = myTypedefDef_ptr;
    CORBA::Contained_ptr myContained_ptr2 = myTypedefDef_var;
    CORBA::Contained_var myContained_var = CORBA::TypedefDef::_duplicate(myTypedefDef_var);

    (void *)&myContained_var;
  }

  ::tet_infoline("TEST: Widening of object reference to IRObject");
  if (always_ret_0())
  {
    CORBA::Contained_ptr  myContained_ptr = (CORBA::Contained_ptr)0;
    CORBA::Contained_var  myContained_var;

    CORBA::IRObject_ptr myIRObject_ptr1 = myContained_ptr;
    CORBA::IRObject_ptr myIRObject_ptr2 = myContained_var;
    CORBA::IRObject_var myIRObject_var = CORBA::Contained::_duplicate(myContained_var);

    (void *)&myIRObject_var;
  }

  ::tet_infoline("TEST: Widening of object reference to Object");
  if (always_ret_0())
  {
    CORBA::IRObject_ptr  myIRObject_ptr = (CORBA::IRObject_ptr)0;
    CORBA::IRObject_var  myIRObject_var;

    CORBA::Object_ptr myObject_ptr1 = myIRObject_ptr;
    CORBA::Object_ptr myObject_ptr2 = myIRObject_var;
    CORBA::Object_var myObject_var = CORBA::IRObject::_duplicate(myIRObject_var);

    (void *)&myObject_var;
  }

  ::tet_infoline("TEST: Widening of object reference to IDLType");
  if (always_ret_0())
  {
    CORBA::TypedefDef_ptr  myTypedefDef_ptr = (CORBA::TypedefDef_ptr)0;
    CORBA::TypedefDef_var  myTypedefDef_var;

    CORBA::IDLType_ptr myIDLType_ptr1 = myTypedefDef_ptr;
    CORBA::IDLType_ptr myIDLType_ptr2 = myTypedefDef_var;
    CORBA::IDLType_var myIDLType_var = CORBA::TypedefDef::_duplicate(myTypedefDef_var);

    (void *)&myIDLType_var;
  }


  ::tet_infoline("TEST: Assignment");
  if (always_ret_0())
  {
    CORBA::UnionDef_var  myUnionDef_var1;
    CORBA::UnionDef_var  myUnionDef_var2;

    myUnionDef_var1 = myUnionDef_var2;

    (void *)&myUnionDef_var1;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::UnionDef_ptr  myUnionDef_ptr = (CORBA::UnionDef_ptr)0;

    any <<= myUnionDef_ptr;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    CORBA::UnionDef_ptr  myUnionDef_ptr=(CORBA::UnionDef_ptr)0;

    b = any >>= myUnionDef_ptr;

    (void*)&b;
    (void*)&myUnionDef_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

