//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::UnionMemberSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of UnionMember.");

  // Test the constructors 

  // Test the constructor CORBA::UnionMemberSeq::UnionMemberSeq() 
  if (always_ret_0())
  {
    CORBA::UnionMemberSeq myUnionMemberSeq;

    (void *)&myUnionMemberSeq;
  }

  // Test the constructor CORBA::UnionMemberSeq::UnionMemberSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::UnionMemberSeq myUnionMemberSeq((CORBA::ULong)1);

    (void *)&myUnionMemberSeq;
  }

  // Test the constructor 
  // CORBA::UnionMemberSeq::UnionMemberSeq(ULong max,ULong length, 
  //           UnionMember *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::UnionMember  *myBuffer;
    CORBA::UnionMemberSeq myUnionMemberSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myUnionMemberSeq;
  }

  // Test the constructor 
  // CORBA::UnionMemberSeq::UnionMemberSeq(const CORBA::UnionMemberSeq&) 
  if (always_ret_0())
  {
    CORBA::UnionMemberSeq  myUnionMemberSeq1;
    CORBA::UnionMemberSeq myUnionMemberSeq(myUnionMemberSeq1);

    (void *)&myUnionMemberSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::UnionMemberSeq  myUnionMemberSeq;
    CORBA::ULong ul = myUnionMemberSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::UnionMemberSeq myUnionMemberSeq;

    CORBA::ULong ul = 0;

    myUnionMemberSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::UnionMemberSeq myUnionMemberSeq;

    CORBA::ULong ul = myUnionMemberSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the operator UnionMember &operator=(const UnionMember&) 
  if (always_ret_0())
  {
    CORBA::UnionMemberSeq myUnionMemberSeq1, myUnionMemberSeq2;

    myUnionMemberSeq1 = myUnionMemberSeq2;

    (void *)&myUnionMemberSeq1;
  }
  
  // Test the operator UnionMember &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::UnionMemberSeq myUnionMemberSeq;
    CORBA::UnionMember myUnionMember;

    myUnionMemberSeq[index] = myUnionMember;

    (void *)&myUnionMemberSeq;
  }
  
  // Test the operator const UnionMember &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::UnionMemberSeq myUnionMemberSeq;
    const CORBA::UnionMember& myUnionMember = myUnionMemberSeq[index];

    (void *)&myUnionMember;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::UnionMemberSeq myUnionMemberSeq;

    any <<= myUnionMemberSeq;
    any <<= &myUnionMemberSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::UnionMemberSeq *myUnionMemberSeq_ptr = 0;

    b = any >>= myUnionMemberSeq_ptr;

    (void*)&b;
    (void*)&myUnionMemberSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

