//
// Copyright (c) 2000 The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for The Open Group by GMD Fokus, Berlin.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  CORBA::ValueDef::FullValueDescription  myFullValueDescription;
  CORBA::ValueDef::FullValueDescription  *myFullValueDescription_ptr;

  // Declare pointers for each of the member fields 
  CORBA::Identifier_var myname;
  CORBA::RepositoryId_var myid;
  CORBA::Boolean myis_abstract;
  CORBA::Boolean myis_custom;
  CORBA::RepositoryId_var mydefined_in;
  CORBA::VersionSpec_var myversion;
  CORBA::OpDescriptionSeq *poperations;
  CORBA::AttrDescriptionSeq *pattributes;
  CORBA::ValueMemberSeq *pmembers;
  CORBA::InitializerSeq *pinitializers;
  CORBA::RepositoryIdSeq *psupported_interfaces;
  CORBA::RepositoryIdSeq *pabstract_base_values;
  CORBA::Boolean myis_truncatable;
  CORBA::RepositoryId_var mybase_value;
  CORBA::TypeCode_var mytype;

  ::tet_infoline("The struct CORBA::ValueDef::FullValueDescription");
  ::tet_infoline("shall be defined and shall have the members: {");
  ::tet_infoline("Identifier name, ");
  ::tet_infoline("RepositoryId id, ");
  ::tet_infoline("Boolean is_abstract, ");
  ::tet_infoline("Boolean is_custom, ");
  ::tet_infoline("RepositoryId defined_in, ");
  ::tet_infoline("VersionSpec version, ");
  ::tet_infoline("OpDescriptionSeq operations, ");
  ::tet_infoline("AttrDescriptionSeq attributes, ");
  ::tet_infoline("ValueMemberSeq members, ");
  ::tet_infoline("InitializerSeq initializers, ");
  ::tet_infoline("RepositoryIdSeq supported_interfaces, ");
  ::tet_infoline("RepositoryIdSeq abstract_base_values, ");
  ::tet_infoline("Boolean is_truncatable, ");
  ::tet_infoline("RepositoryId base_value, ");
  ::tet_infoline("TypeCode type}.");

  // Force the compiler to complain if the a member type is incorrect

  // Test the field name 
  myname = myFullValueDescription.name;

  // Test the field id 
  myid = myFullValueDescription.id;

  // Test the field is_abstract 
  myis_abstract = myFullValueDescription.is_abstract;

  // Test the field is_custom 
  myis_custom = myFullValueDescription.is_custom;

  // Test the field defined_in 
  mydefined_in = myFullValueDescription.defined_in;

  // Test the field version 
  myversion = myFullValueDescription.version;

  // Test the field operations 
  poperations = &myFullValueDescription.operations;

  // Test the field attributes 
  pattributes = &myFullValueDescription.attributes;

  // Test the field members 
  pmembers = &myFullValueDescription.members;

  // Test the field initializers 
  pinitializers = &myFullValueDescription.initializers;

  // Test the field supported_interfaces 
  psupported_interfaces = &myFullValueDescription.supported_interfaces;

  // Test the field abstract_base_values 
  pabstract_base_values = &myFullValueDescription.abstract_base_values;

  // Test the field is_truncatable 
  myis_truncatable = myFullValueDescription.is_truncatable;

  // Test the field base_value 
  mybase_value = myFullValueDescription.base_value;

  // Test the field type 
  mytype = myFullValueDescription.type;


  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;

    any <<= myFullValueDescription;
    any <<= &myFullValueDescription;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::ValueDef::FullValueDescription *myConstFullValueDescription_ptr = 0;

    b = any >>= myConstFullValueDescription_ptr;

    (void*)&b;
    (void*)&myConstFullValueDescription_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

