//
// Copyright (c) 2000 The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for The Open Group by GMD Fokus, Berlin.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The class CORBA::ValueDef shall be defined ");
  ::tet_infoline("to be a class that inherits from");
  ::tet_infoline("Container IRObject Object Contained IDLType .");

  ::tet_infoline("TEST: Widening of object reference to Container");
  if (always_ret_0())
  {
    CORBA::ValueDef_ptr  myValueDef_ptr = (CORBA::ValueDef_ptr)0;
    CORBA::ValueDef_var  myValueDef_var;

    CORBA::Container_ptr myContainer_ptr1 = myValueDef_ptr;
    CORBA::Container_ptr myContainer_ptr2 = myValueDef_var;
    CORBA::Container_var myContainer_var = CORBA::ValueDef::_duplicate(myValueDef_var);

    (void *)&myContainer_var;
  }

  ::tet_infoline("TEST: Widening of object reference to IRObject");
  if (always_ret_0())
  {
    CORBA::Container_ptr  myContainer_ptr = (CORBA::Container_ptr)0;
    CORBA::Container_var  myContainer_var;

    CORBA::IRObject_ptr myIRObject_ptr1 = myContainer_ptr;
    CORBA::IRObject_ptr myIRObject_ptr2 = myContainer_var;
    CORBA::IRObject_var myIRObject_var = CORBA::Container::_duplicate(myContainer_var);

    (void *)&myIRObject_var;
  }

  ::tet_infoline("TEST: Widening of object reference to Object");
  if (always_ret_0())
  {
    CORBA::IRObject_ptr  myIRObject_ptr = (CORBA::IRObject_ptr)0;
    CORBA::IRObject_var  myIRObject_var;

    CORBA::Object_ptr myObject_ptr1 = myIRObject_ptr;
    CORBA::Object_ptr myObject_ptr2 = myIRObject_var;
    CORBA::Object_var myObject_var = CORBA::IRObject::_duplicate(myIRObject_var);

    (void *)&myObject_var;
  }

  ::tet_infoline("TEST: Widening of object reference to Contained");
  if (always_ret_0())
  {
    CORBA::ValueDef_ptr  myValueDef_ptr = (CORBA::ValueDef_ptr)0;
    CORBA::ValueDef_var  myValueDef_var;

    CORBA::Contained_ptr myContained_ptr1 = myValueDef_ptr;
    CORBA::Contained_ptr myContained_ptr2 = myValueDef_var;
    CORBA::Contained_var myContained_var = CORBA::ValueDef::_duplicate(myValueDef_var);

    (void *)&myContained_var;
  }

  ::tet_infoline("TEST: Widening of object reference to IDLType");
  if (always_ret_0())
  {
    CORBA::ValueDef_ptr  myValueDef_ptr = (CORBA::ValueDef_ptr)0;
    CORBA::ValueDef_var  myValueDef_var;

    CORBA::IDLType_ptr myIDLType_ptr1 = myValueDef_ptr;
    CORBA::IDLType_ptr myIDLType_ptr2 = myValueDef_var;
    CORBA::IDLType_var myIDLType_var = CORBA::ValueDef::_duplicate(myValueDef_var);

    (void *)&myIDLType_var;
  }


  ::tet_infoline("TEST: Assignment");
  if (always_ret_0())
  {
    CORBA::ValueDef_var  myValueDef_var1;
    CORBA::ValueDef_var  myValueDef_var2;

    myValueDef_var1 = myValueDef_var2;

    (void *)&myValueDef_var1;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::ValueDef_ptr  myValueDef_ptr = (CORBA::ValueDef_ptr)0;

    any <<= myValueDef_ptr;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    CORBA::ValueDef_ptr  myValueDef_ptr=(CORBA::ValueDef_ptr)0;

    b = any >>= myValueDef_ptr;

    (void*)&b;
    (void*)&myValueDef_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

