//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::ValueDefSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of ValueDef Def.");

  // Test the constructors 

  // Test the constructor CORBA::ValueDefSeq::ValueDefSeq() 
  if (always_ret_0())
  {
    CORBA::ValueDefSeq myValueDefSeq;

    (void *)&myValueDefSeq;
  }

  // Test the constructor CORBA::ValueDefSeq::ValueDefSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::ValueDefSeq myValueDefSeq((CORBA::ULong)1);

    (void *)&myValueDefSeq;
  }

  // Test the constructor 
  // CORBA::ValueDefSeq::ValueDefSeq(ULong max,ULong length, 
  //           ValueDef *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::ValueDef_ptr  myBuffer;
    CORBA::ValueDefSeq myValueDefSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myValueDefSeq;
  }

  // Test the constructor 
  // CORBA::ValueDefSeq::ValueDefSeq(const CORBA::ValueDefSeq&) 
  if (always_ret_0())
  {
    CORBA::ValueDefSeq  myValueDefSeq1;
    CORBA::ValueDefSeq myValueDefSeq(myValueDefSeq1);

    (void *)&myValueDefSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::ValueDefSeq  myValueDefSeq;
    CORBA::ULong ul = myValueDefSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::ValueDefSeq myValueDefSeq;

    CORBA::ULong ul = 0;

    myValueDefSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::ValueDefSeq myValueDefSeq;

    CORBA::ULong ul = myValueDefSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator) 
  if (always_ret_0())
  {
    CORBA::ValueDefSeq myValueDefSeq1, myValueDefSeq2;

    myValueDefSeq1 = myValueDefSeq2;

    (void *)&myValueDefSeq1;
  }
  
  // Test the operator ValueDef &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ValueDefSeq myValueDefSeq;
    CORBA::ValueDef_ptr myValueDef;

    myValueDefSeq[index] = myValueDef;

    (void *)&myValueDefSeq;
  }
  
  // Test the operator const ValueDef &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ValueDefSeq myValueDefSeq;
    const CORBA::ValueDef_var myValueDef = myValueDefSeq[index];

    (void *)&myValueDef;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::ValueDefSeq myValueDefSeq;

    any <<= myValueDefSeq;
    any <<= &myValueDefSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::ValueDefSeq *myValueDefSeq_ptr = 0;

    b = any >>= myValueDefSeq_ptr;

    (void*)&b;
    (void*)&myValueDefSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

