//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  CORBA::ValueMember  myStructure;

  // Declare pointers for each of the member fields 
  CORBA::Identifier_var myField1;
  CORBA::RepositoryId myField2;
  CORBA::RepositoryId myField3;
  CORBA::VersionSpec myField4;
  CORBA::TypeCode_var myField5;
  CORBA::IDLType_var myField6;
  CORBA::Visibility myField7;

  ::tet_infoline("The struct CORBA::ValueMember");
  ::tet_infoline("shall be defined and shall have the members");
  ::tet_infoline("{");
  ::tet_infoline("CORBA::Identifier,");
  ::tet_infoline("CORBA::RepositoryId,");
  ::tet_infoline("CORBA::RepositoryId,");
  ::tet_infoline("CORBA::VersionSpec,");
  ::tet_infoline("CORBA::TypeCode,");
  ::tet_infoline("CORBA::IDLType,");
  ::tet_infoline("CORBA::Visibility");
  ::tet_infoline("}.");

  // Force the compiler to complain if the a member type is incorrect

  // Test the field name 
  myField1 = myStructure.name;

  // Test the field type 
  myField2 = myStructure.id;

  // Test the field type 
  myField3 = myStructure.defined_in;

  // Test the field type 
  myField4 = myStructure.version;

  // Test the field type 
  myField5 = myStructure.type;

  // Test the field type 
  myField6 = myStructure.type_def;

  // Test the field type 
  myField7 = myStructure.access;


  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::ValueMember  myStructure;
    CORBA::ValueMember  *myStructure_ptr;

    any <<= &myStructure;
    any <<= myStructure_ptr;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    const CORBA::ValueMember  *myStructure_ptr;
    CORBA::Any any;
    CORBA::Boolean b;

    b = any >>= myStructure_ptr;

    (void*)&b;
    (void*)&myStructure_ptr;
  }


  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

