//
// Copyright (c) 2000 The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for The Open Group by GMD Fokus, Berlin.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The class CORBA::ValueMemberDef shall be defined ");
  ::tet_infoline("to be a class that inherits from");
  ::tet_infoline("Contained IRObject Object.");


  ::tet_infoline("TEST: Widening of object reference to Contained");
  if (always_ret_0())
  {
    CORBA::ValueMemberDef_ptr  myValueMemberDef_ptr = (CORBA::ValueMemberDef_ptr)0;
    CORBA::ValueMemberDef_var  myValueMemberDef_var;

    CORBA::Contained_ptr myContained_ptr1 = myValueMemberDef_ptr;
    CORBA::Contained_ptr myContained_ptr2 = myValueMemberDef_var;
    CORBA::Contained_var myContained_var = CORBA::ValueMemberDef::_duplicate(myValueMemberDef_var);

    (void *)&myContained_var;
  }

  ::tet_infoline("TEST: Widening of object reference to IRObject");
  if (always_ret_0())
  {
    CORBA::Contained_ptr  myContained_ptr = (CORBA::Contained_ptr)0;
    CORBA::Contained_var  myContained_var;

    CORBA::IRObject_ptr myIRObject_ptr1 = myContained_ptr;
    CORBA::IRObject_ptr myIRObject_ptr2 = myContained_var;
    CORBA::IRObject_var myIRObject_var = CORBA::Contained::_duplicate(myContained_var);

    (void *)&myIRObject_var;
  }

  ::tet_infoline("TEST: Widening of object reference to Object");
  if (always_ret_0())
  {
    CORBA::IRObject_ptr  myIRObject_ptr = (CORBA::IRObject_ptr)0;
    CORBA::IRObject_var  myIRObject_var;

    CORBA::Object_ptr myObject_ptr1 = myIRObject_ptr;
    CORBA::Object_ptr myObject_ptr2 = myIRObject_var;
    CORBA::Object_var myObject_var = CORBA::IRObject::_duplicate(myIRObject_var);

    (void *)&myObject_var;
  }



  ::tet_infoline("TEST: Assignment");
  if (always_ret_0())
  {
    CORBA::ValueMemberDef_var  myValueMemberDef_var1;
    CORBA::ValueMemberDef_var  myValueMemberDef_var2;

    myValueMemberDef_var1 = myValueMemberDef_var2;

    (void *)&myValueMemberDef_var1;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::ValueMemberDef_ptr  myValueMemberDef_ptr = (CORBA::ValueMemberDef_ptr)0;

    any <<= myValueMemberDef_ptr;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    CORBA::ValueMemberDef_ptr  myValueMemberDef_ptr=(CORBA::ValueMemberDef_ptr)0;

    b = any >>= myValueMemberDef_ptr;

    (void*)&b;
    (void*)&myValueMemberDef_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

