//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>


volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}


extern "C" {
static void test1A()
{
  CORBA::Visibility  myType;
  CORBA::Visibility *pmyType;
  CORBA::Short myBaseType;
  CORBA::Short *pmyBaseType;


	::tet_infoline("The type CORBA::Visibility");
	::tet_infoline("shall be defined to be of type: CORBA::Short.");


	myBaseType = (CORBA::Visibility)0;
	myType = myBaseType;

	if (myType == myBaseType)
	  pmyBaseType = &myType;


  ::tet_infoline("TEST: size");
  if (sizeof(CORBA::Visibility) != sizeof(CORBA::Short))
  {
    ::tet_printf("ERROR: Expected size of CORBA::Visibility to be %d, is %d.", sizeof(CORBA::Short), sizeof(CORBA::Visibility));

    ::tet_result(TET_FAIL);
    return;
  }



  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;

    any <<= myType;
    any <<= &myType;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;

    b = any >>= myType;

    (void*)&b;
    (void*)&pmyType;
  }

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

