//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
    return vol;
}

extern "C" {
static void test1A(void)
{


  ::tet_infoline("The class PortableServer::ServantBase has been defined");
  ::tet_infoline("ServantBase().");

  if (always_ret_0())
	{
		PortableServer::ServantBase& myClass();

		(void *)&myClass;
	}



  ::tet_infoline("The class PortableServer::ServantBase shall have a member ");
  ::tet_infoline("PortableServer::POA_ptr _default_POA() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	PortableServer::POA_ptr (PortableServer::ServantBase::*pf2)() = NULL;
	pf2 = &PortableServer::ServantBase::_default_POA;

	if (always_ret_0())
	{
		PortableServer::ServantBase_var myClass2=NULL;
		PortableServer::POA_ptr p_out2 = (myClass2->*pf2)();
	}
 
  ::tet_infoline("The class PortableServer::ServantBase shall have a member ");
  ::tet_infoline("CORBA::InterfaceDef_ptr _get_interface() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::InterfaceDef_ptr (PortableServer::ServantBase::*pf3)() = NULL;
	pf3 = &PortableServer::ServantBase::_get_interface;

	if (always_ret_0())
	{
		PortableServer::ServantBase_var myClass3=NULL;
		CORBA::InterfaceDef_ptr p_out3 = (myClass3->*pf3)();
	}
 
  ::tet_infoline("The class PortableServer::ServantBase shall have a member ");
  ::tet_infoline("CORBA::Boolean _is_a(const char*) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::Boolean (PortableServer::ServantBase::*pf4)(const char*) = NULL;
	pf4 = &PortableServer::ServantBase::_is_a;

	if (always_ret_0())
	{
		PortableServer::ServantBase_var myClass4=NULL;
		const char* p_in4;
		CORBA::Boolean p_out4 = (myClass4->*pf4)(p_in4);
	}
 
 
  ::tet_infoline("The class PortableServer::ServantBase shall have a member ");
  ::tet_infoline("CORBA::Boolean _non_existent() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::Boolean (PortableServer::ServantBase::*pf5)() = NULL;
	pf5 = &PortableServer::ServantBase::_non_existent;

	if (always_ret_0())
	{
		PortableServer::ServantBase_var myClass5=NULL;
		CORBA::Boolean p_out5 = (myClass5->*pf5)();
	}
  
  ::tet_infoline("The class PortableServer::ServantBase shall have a member ");
  ::tet_infoline("void _add_ref() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (PortableServer::ServantBase::*pf6)() = NULL;
	pf6 = &PortableServer::ServantBase::_add_ref;

	if (always_ret_0())
	{
		PortableServer::ServantBase_var myClass6=NULL;
		(void) (myClass6->*pf6)();
	}
   
  ::tet_infoline("The class PortableServer::ServantBase shall have a member ");
  ::tet_infoline("void _remove_ref() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (PortableServer::ServantBase::*pf7)() = NULL;
	pf7 = &PortableServer::ServantBase::_remove_ref;

	if (always_ret_0())
	{
		PortableServer::ServantBase_var myClass7=NULL;
		(void) (myClass7->*pf7)();
	}



    ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
