//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

extern "C" {
static void test1A()
{
	PortableServer::POAManager::State myState1;
	PortableServer::POAManager::State myState2;

	::tet_infoline("The type PortableServer::POAManager::State");
	::tet_infoline("shall be defined to be an enum.");
	::tet_infoline("Each enumerator shall be defined in the correct order.");

	::tet_infoline("TEST: size");

	if (sizeof(PortableServer::POAManager::State) != 4) 
	{
		::tet_printf("ERROR: Expected size of PortableServer::POAManager::State to be 4, is %d", sizeof(PortableServer::POAManager::State));

		::tet_result(TET_FAIL);

		return;
	}

	::tet_infoline("TEST: enumerators");

	myState1 = PortableServer::POAManager::HOLDING;
	myState2 = PortableServer::POAManager::ACTIVE;

	if (myState1 >= myState2)
	{
		::tet_printf("ERROR: Expected enumerator PortableServer::POAManager::HOLDING to be less than enumerator PortableServer::POAManager::ACTIVE");

		::tet_result(TET_FAIL);
	}

	myState1 = PortableServer::POAManager::DISCARDING;
	myState2 = PortableServer::POAManager::INACTIVE;

	if (myState1 >= myState2)
	{
		::tet_printf("ERROR: Expected enumerator PortableServer::POAManager::DISCARDING to be less than enumerator PortableServer::POAManager::INACTIVE");

		::tet_result(TET_FAIL);
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

