//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A(void)
{

  ::tet_infoline("The class PortableServer::ServantActivator shall be defined ");
  ::tet_infoline("to be a class that inherits from");
  ::tet_infoline("PortableServer::ServantManager .");

  ::tet_infoline("TEST: Widening of object reference to PortableServer::ServantManager");
  if (always_ret_0())
  {
    PortableServer::ServantActivator_ptr  myServantActivator_ptr = (PortableServer::ServantActivator_ptr)0;
    PortableServer::ServantActivator_var  myServantActivator_var;

    PortableServer::ServantManager_ptr myServantManager_ptr1 = myServantActivator_ptr;
    PortableServer::ServantManager_ptr myServantManager_ptr2 = myServantActivator_var;
    PortableServer::ServantManager_var myServantManager_var = PortableServer::ServantActivator::_duplicate(myServantActivator_var);

    (void *)&myServantManager_var;
  }


  ::tet_infoline("TEST: Assignment");
  if (always_ret_0())
  {
    PortableServer::ServantActivator_var  myServantActivator_var1;
    PortableServer::ServantActivator_var  myServantActivator_var2;

    myServantActivator_var1 = myServantActivator_var2;

    (void *)&myServantActivator_var1;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    PortableServer::ServantActivator_ptr  myServantActivator_ptr = (PortableServer::ServantActivator_ptr)0;

    any <<= myServantActivator_ptr;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    PortableServer::ServantActivator_ptr  myServantActivator_ptr=(PortableServer::ServantActivator_ptr)0;

    b = any >>= myServantActivator_ptr;

    (void*)&b;
    (void*)&myServantActivator_ptr;
  }


  ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}

