//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

static void test1A()
{
	PortableServer::ServantLocator_var myObjRef;

#if VSORB_CORBA_STATUS
	// declare an instance of the return type 
	CORBA::Status ret;
#endif /* VSORB_CORBA_STATUS */

	// declare an instance of each parameter 
	const PortableServer::ObjectId& myoid=0; // in 
	PortableServer::POA_ptr mypoa; // in 
	CORBA::Identifier myid; // in 
	PortableServer::ServantLocator::Cookie mycookie; // in 
	PortableServer::Servant myserv;

	::tet_infoline("The function PortableServer::ServantLocator::postinvoke");
	::tet_infoline("shall be defined to be of type");
	::tet_infoline("void PortableServer::ServantLocator::postinvoke(");
	::tet_infoline("PortableServer::ObjectId_ptr,");
	::tet_infoline("PortableServer::POA_ptr,");
	::tet_infoline("CORBA::Identifier,");
	::tet_infoline("PortableServer::ServantLocator::Cookie,");
	::tet_infoline("PortableServer::Servant");
	::tet_infoline(");");

	// Include a call to the function to make sure it is present in the library 
	if (always_ret_0())
#if VSORB_CORBA_STATUS
		ret = 
#endif /* VSORB_CORBA_STATUS */

			myObjRef->postinvoke(myoid,mypoa,myid,mycookie,myserv);

	::tet_result(TET_PASS);
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

