//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;
static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
	PortableServer::LifespanPolicyValue myElement1;
	PortableServer::LifespanPolicyValue myElement2;

	::tet_infoline("The type PortableServer::LifespanPolicyValue");
	::tet_infoline("shall be defined to be an enum.");
	::tet_infoline("Each enumerator shall be defined in the correct order.");

	::tet_infoline("TEST: size");

	if (sizeof(PortableServer::LifespanPolicyValue) != 4) 
	{
		::tet_printf("ERROR: Expected size of PortableServer::LifespanPolicyValue to be 4 bytes, is %d", sizeof(PortableServer::LifespanPolicyValue));

		::tet_result(TET_FAIL);

		return;
	}

	::tet_infoline("TEST: enumerators");

	myElement1 = PortableServer::TRANSIENT;
	myElement2 = PortableServer::PERSISTENT;

	if (myElement1 >= myElement2)
	{
		::tet_printf("ERROR: Expected enumerator PortableServer::TRANSIENT to be less than enumerator PortableServer::PERSISTENT");

		::tet_result(TET_FAIL);
	}



	// Any Exchange:
	myElement1 = PortableServer::TRANSIENT;
	myElement2 = PortableServer::PERSISTENT;

	::tet_infoline("TEST: Insertion into CORBA::Any");
	if (always_ret_0())
	  {
	    CORBA::Any  any;

	    any <<= myElement1;
	  }

	::tet_infoline("TEST: Extraction from CORBA::Any");
	if (always_ret_0())
	  {
	    CORBA::Any  any;
	    CORBA::Boolean b;
	    b = any >>= myElement1;
	    
	    (void*)&b;
	    (void*)&myElement1;
	  }



	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

