//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type PortableServer::ObjectId shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of CORBA::Octet Def.");

  // Test the constructors 

  // Test the constructor PortableServer::ObjectId::ObjectId() 
  if (always_ret_0())
  {
    PortableServer::ObjectId mySeq;

    (void *)&mySeq;
  }

  // Test the constructor PortableServer::ObjectId::ObjectId(ULong max) 
  if (always_ret_0())
  {
    PortableServer::ObjectId mySeq((CORBA::ULong)1);

    (void *)&mySeq;
  }

  // Test the constructor 
  // PortableServer::ObjectId::ObjectId(ULong max,ULong length, 
  //           CORBA::Octet *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::Octet myElement;
    PortableServer::ObjectId mySeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myElement,
                 (CORBA::Boolean)0);

    (void *)&mySeq;
  }

  // Test the constructor 
  // PortableServer::ObjectId::ObjectId(const PortableServer::ObjectId&) 
  if (always_ret_0())
  {
    PortableServer::ObjectId mySeq1;
    PortableServer::ObjectId mySeq(mySeq1);

    (void *)&mySeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    PortableServer::ObjectId  mySeq;
    CORBA::ULong ul = mySeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    PortableServer::ObjectId mySeq;

    CORBA::ULong ul = 0;

    mySeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    PortableServer::ObjectId mySeq;

    CORBA::ULong ul = mySeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator) 
  if (always_ret_0())
  {
    PortableServer::ObjectId mySeq1, mySeq2;

    mySeq1 = mySeq2;

    (void *)&mySeq1;
  }
  
  // Test the operator: PortableServer::POA &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    PortableServer::ObjectId mySeq;
    CORBA::Octet myElement;

    mySeq[index] = myElement;

    (void *)&mySeq;
  }
  
  // Test the operator: const PortableServer::POA &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    PortableServer::ObjectId mySeq;
    const CORBA::Octet& myElement = mySeq[index];

    (void *)&myElement;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    PortableServer::ObjectId mySeq;

    any <<= mySeq;
    any <<= &mySeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const PortableServer::ObjectId *mySeq_ptr = 0;

    b = any >>= mySeq_ptr;

    (void*)&b;
    (void*)&mySeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

