//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	CORBA::ServiceDetail  myServiceDetail;

	// Declare pointers for each of the member fields 
	CORBA::ServiceDetailType *pservice_detail_type;
	CORBA::Octet service_detail_elem;

	::tet_infoline("The struct CORBA::ServiceDetail");
	::tet_infoline("shall be defined and shall have the members");
	::tet_infoline("{ ServiceDetailType service_detail_type, sequence<Octet> service_detail}.");

	// Force the compiler to complain if the a member type is incorrect

	// Test the field service_detail_type 
	pservice_detail_type = &myServiceDetail.service_detail_type;

	// Test the field service_detail 
	if (always_ret_0())
		service_detail_elem = myServiceDetail.service_detail[(CORBA::ULong)0];

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

