//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	CORBA::ServiceInformation  myServiceInformation;

	CORBA::ServiceOption service_options_elem;
	CORBA::ServiceDetail service_details_elem;

	::tet_infoline("The struct CORBA::ServiceInformation");
	::tet_infoline("shall be defined and shall have the members");
	::tet_infoline("{ sequence<ServiceOption> service_options, sequence<ServiceDetail> service_details}.");

	// Force the compiler to complain if the a member type is incorrect

	// Test the field service_options 
	if (always_ret_0())
		service_options_elem = myServiceInformation.service_options[(CORBA::ULong)0];

	// Test the field service_details 
	if (always_ret_0())
		service_details_elem = myServiceInformation.service_details[(CORBA::ULong)0];

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

