//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	CORBA::ORB_var myObjRef;

	// declare an instance of the return type 
	CORBA::Boolean ret;

	// declare an instance of each parameter 
	CORBA::ServiceType service_type = (CORBA::ServiceType)0; // in 
	CORBA::ServiceInformation *service_information = (CORBA::ServiceInformation *)0; // out 

	::tet_infoline("The function CORBA::ORB::get_service_information");
	::tet_infoline("shall be defined to be of type");
	::tet_infoline("CORBA::Boolean CORBA::ORB::get_service_information(");
	::tet_infoline("CORBA::ServiceType,");
	::tet_infoline("CORBA::ServiceInformation *&");
	::tet_infoline(");");

	// Include a call to the function to make sure it is present in the library 
	if (always_ret_0())
		ret = 
			myObjRef->get_service_information(service_type, service_information);

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

