//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
    return vol;
}

extern "C" {
static void test1A(void)
{


  ::tet_infoline("The class CORBA::ValueBase has a constructor of the form");
  ::tet_infoline("ValueBase_var().");

  if (always_ret_0())
	{
		CORBA::ValueBase_var myValueBase_var();

		(void *)&myValueBase_var;
	}


  ::tet_infoline("The class CORBA::ValueBase shall have a copy constructor defined.");

  if (always_ret_0())
	{
		CORBA::ValueBase_var myValueBase_var2;
		CORBA::ValueBase_var myValueBase_var3(myValueBase_var2);

		(void *)&myValueBase_var3;
	}


  ::tet_infoline("The class CORBA::ValueBase has a constructor of the form");
  ::tet_infoline("ValueBase_var(const CORBA::ValueBase&).");

  if (always_ret_0())
	{
		CORBA::ValueBase_var myValueBase4_var(const CORBA::ValueBase& val);

		(void *)&myValueBase4_var;
	}


  ::tet_infoline("The class CORBA::ValueBase shall have a member ");
  ::tet_infoline("CORBA::ValueBase* _add_ref() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::ValueBase* (CORBA::ValueBase::*pf5)() = NULL;
	pf5 = &CORBA::ValueBase::_add_ref;

	if (always_ret_0())
	{
		CORBA::ValueBase_var myValueBase5=NULL;
		CORBA::ValueBase_var p5 = (myValueBase5->*pf5)();
	}
 

  ::tet_infoline("The class CORBA::ValueBase shall have a member ");
  ::tet_infoline("void _remove_ref() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::ValueBase::*pf6)() = NULL;
	pf6 = &CORBA::ValueBase::_remove_ref;

	if (always_ret_0())
	{
		CORBA::ValueBase_var myValueBase6=NULL;
		(void) (myValueBase6->*pf6)();
	}
 

  ::tet_infoline("The class CORBA::ValueBase shall have a member ");
  ::tet_infoline("CORBA::ValueBase* _copy_value() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::ValueBase* (CORBA::ValueBase::*pf7)() = NULL;
	pf7 = &CORBA::ValueBase::_copy_value;

	if (always_ret_0())
	{
		CORBA::ValueBase_var myValueBase7=NULL;
		CORBA::ValueBase_var p7 = (myValueBase7->*pf7)();
	}
 
  ::tet_infoline("The class CORBA::ValueBase shall have a member ");
  ::tet_infoline("CORBA::ULong* _refcount_value() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::ULong (CORBA::ValueBase::*pf8)() = NULL;
	pf8 = &CORBA::ValueBase::_refcount_value;

	if (always_ret_0())
	{
		CORBA::ValueBase_var myValueBase8=NULL;
		CORBA::ULong p8 = (myValueBase8->*pf8)();
	}
 

  ::tet_infoline("The class CORBA::ValueBase shall have a member ");
  ::tet_infoline("static ValueBase* _downcast(ValueBase*) defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::ValueBase_var myValueBase9;
		CORBA::ValueBase* p9;
		CORBA::ValueBase* ret9;
		ret9 = (myValueBase9->_downcast)(p9);
	}
  



    ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
