//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::AnySeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of AnyDef.");

  // Test the constructors 

  // Test the constructor CORBA::AnySeq::AnySeq() 
  if (always_ret_0())
  {
    CORBA::AnySeq myAnySeq;

    (void *)&myAnySeq;
  }

  // Test the constructor CORBA::AnySeq::AnySeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::AnySeq myAnySeq((CORBA::ULong)1);

    (void *)&myAnySeq;
  }

  // Test the constructor 
  // CORBA::AnySeq::AnySeq(ULong max,ULong length, 
  //           Any *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::Any  myBuffer;
    CORBA::AnySeq myAnySeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myAnySeq;
  }

  // Test the constructor 
  // CORBA::AnySeq::AnySeq(const CORBA::AnySeq&) 
  if (always_ret_0())
  {
    CORBA::AnySeq  myAnySeq1;
    CORBA::AnySeq myAnySeq(myAnySeq1);

    (void *)&myAnySeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::AnySeq  myAnySeq;
    CORBA::ULong ul = myAnySeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::AnySeq myAnySeq;

    CORBA::ULong ul = 0;

    myAnySeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::AnySeq myAnySeq;

    CORBA::ULong ul = myAnySeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the operator Any &operator=(const Any&) 
  if (always_ret_0())
  {
    CORBA::AnySeq myAnySeq1, myAnySeq2;

    myAnySeq1 = myAnySeq2;

    (void *)&myAnySeq1;
  }
  
  // Test the operator Any &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::AnySeq myAnySeq;
    CORBA::Any_var myAny;

    myAnySeq[index] = myAny;

    (void *)&myAnySeq;
  }
  
  // Test the operator const Any &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::AnySeq myAnySeq;
    const CORBA::Any& myAny = myAnySeq[index];

    (void *)&myAny;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::AnySeq myAnySeq;

    any <<= myAnySeq;
    any <<= &myAnySeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::AnySeq *myAnySeq_ptr = 0;

    b = any >>= myAnySeq_ptr;

    (void*)&b;
    (void*)&myAnySeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

