//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::BooleanSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of Boolean Def.");

  // Test the constructors 

  // Test the constructor CORBA::BooleanSeq::BooleanSeq() 
  if (always_ret_0())
  {
    CORBA::BooleanSeq myBooleanSeq;

    (void *)&myBooleanSeq;
  }

  // Test the constructor CORBA::BooleanSeq::BooleanSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::BooleanSeq myBooleanSeq((CORBA::ULong)1);

    (void *)&myBooleanSeq;
  }

  // Test the constructor 
  // CORBA::BooleanSeq::BooleanSeq(ULong max,ULong length, 
  //           Boolean *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::Boolean  myBuffer;
    CORBA::BooleanSeq myBooleanSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myBooleanSeq;
  }

  // Test the constructor 
  // CORBA::BooleanSeq::BooleanSeq(const CORBA::BooleanSeq&) 
  if (always_ret_0())
  {
    CORBA::BooleanSeq  myBooleanSeq1;
    CORBA::BooleanSeq myBooleanSeq(myBooleanSeq1);

    (void *)&myBooleanSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::BooleanSeq  myBooleanSeq;
    CORBA::ULong ul = myBooleanSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::BooleanSeq myBooleanSeq;

    CORBA::ULong ul = 0;

    myBooleanSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::BooleanSeq myBooleanSeq;

    CORBA::ULong ul = myBooleanSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator. 
  if (always_ret_0())
  {
    CORBA::BooleanSeq myBooleanSeq1, myBooleanSeq2;

    myBooleanSeq1 = myBooleanSeq2;

    (void *)&myBooleanSeq1;
  }
  
  // Test the operator Boolean &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::BooleanSeq myBooleanSeq;
    CORBA::Any_var myAny;

    myBooleanSeq[index] = myAny;

    (void *)&myBooleanSeq;
  }
  
  // Test the operator const Boolean &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::BooleanSeq myBooleanSeq;
    const CORBA::Boolean& myBoolean = myBooleanSeq[index];

    (void *)&myBoolean;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::BooleanSeq myBooleanSeq;

    any <<= myBooleanSeq;
    any <<= &myBooleanSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::BooleanSeq *myBooleanSeq_ptr = 0;

    b = any >>= myBooleanSeq_ptr;

    (void*)&b;
    (void*)&myBooleanSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

