//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::CharSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of Char Def.");

  // Test the constructors 

  // Test the constructor CORBA::CharSeq::CharSeq() 
  if (always_ret_0())
  {
    CORBA::CharSeq myCharSeq;

    (void *)&myCharSeq;
  }

  // Test the constructor CORBA::CharSeq::CharSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::CharSeq myCharSeq((CORBA::ULong)1);

    (void *)&myCharSeq;
  }

  // Test the constructor 
  // CORBA::CharSeq::CharSeq(ULong max,ULong length, 
  //           Char *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::Char  myBuffer;
    CORBA::CharSeq myCharSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myCharSeq;
  }

  // Test the constructor 
  // CORBA::CharSeq::CharSeq(const CORBA::CharSeq&) 
  if (always_ret_0())
  {
    CORBA::CharSeq  myCharSeq1;
    CORBA::CharSeq myCharSeq(myCharSeq1);

    (void *)&myCharSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::CharSeq  myCharSeq;
    CORBA::ULong ul = myCharSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::CharSeq myCharSeq;

    CORBA::ULong ul = 0;

    myCharSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::CharSeq myCharSeq;

    CORBA::ULong ul = myCharSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator) 
  if (always_ret_0())
  {
    CORBA::CharSeq myCharSeq1, myCharSeq2;

    myCharSeq1 = myCharSeq2;

    (void *)&myCharSeq1;
  }
  
  // Test the operator Char &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::CharSeq myCharSeq;
    CORBA::Char myChar;

    myCharSeq[index] = myChar;

    (void *)&myCharSeq;
  }
  
  // Test the operator const Char &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::CharSeq myCharSeq;
    const CORBA::Char& myChar = myCharSeq[index];

    (void *)&myChar;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::CharSeq myCharSeq;

    any <<= myCharSeq;
    any <<= &myCharSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::CharSeq *myCharSeq_ptr = 0;

    b = any >>= myCharSeq_ptr;

    (void*)&b;
    (void*)&myCharSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

