//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::DoubleSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of Double Def.");

  // Test the constructors 

  // Test the constructor CORBA::DoubleSeq::DoubleSeq() 
  if (always_ret_0())
  {
    CORBA::DoubleSeq myDoubleSeq;

    (void *)&myDoubleSeq;
  }

  // Test the constructor CORBA::DoubleSeq::DoubleSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::DoubleSeq myDoubleSeq((CORBA::ULong)1);

    (void *)&myDoubleSeq;
  }

  // Test the constructor 
  // CORBA::DoubleSeq::DoubleSeq(ULong max,ULong length, 
  //           Double *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::Double  myBuffer;
    CORBA::DoubleSeq myDoubleSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myDoubleSeq;
  }

  // Test the constructor 
  // CORBA::DoubleSeq::DoubleSeq(const CORBA::DoubleSeq&) 
  if (always_ret_0())
  {
    CORBA::DoubleSeq  myDoubleSeq1;
    CORBA::DoubleSeq myDoubleSeq(myDoubleSeq1);

    (void *)&myDoubleSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::DoubleSeq  myDoubleSeq;
    CORBA::ULong ul = myDoubleSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::DoubleSeq myDoubleSeq;

    CORBA::ULong ul = 0;

    myDoubleSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::DoubleSeq myDoubleSeq;

    CORBA::ULong ul = myDoubleSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator) 
  if (always_ret_0())
  {
    CORBA::DoubleSeq myDoubleSeq1, myDoubleSeq2;

    myDoubleSeq1 = myDoubleSeq2;

    (void *)&myDoubleSeq1;
  }
  
  // Test the operator Double &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::DoubleSeq myDoubleSeq;
    CORBA::Double myDouble;

    myDoubleSeq[index] = myDouble;

    (void *)&myDoubleSeq;
  }
  
  // Test the operator const Double &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::DoubleSeq myDoubleSeq;
    const CORBA::Double& myDouble = myDoubleSeq[index];

    (void *)&myDouble;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::DoubleSeq myDoubleSeq;

    any <<= myDoubleSeq;
    any <<= &myDoubleSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::DoubleSeq *myDoubleSeq_ptr = 0;

    b = any >>= myDoubleSeq_ptr;

    (void*)&b;
    (void*)&myDoubleSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

