//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::FloatSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of Float Def.");

  // Test the constructors 

  // Test the constructor CORBA::FloatSeq::FloatSeq() 
  if (always_ret_0())
  {
    CORBA::FloatSeq myFloatSeq;

    (void *)&myFloatSeq;
  }

  // Test the constructor CORBA::FloatSeq::FloatSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::FloatSeq myFloatSeq((CORBA::ULong)1);

    (void *)&myFloatSeq;
  }

  // Test the constructor 
  // CORBA::FloatSeq::FloatSeq(ULong max,ULong length, 
  //           Float *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::Float  myBuffer;
    CORBA::FloatSeq myFloatSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myFloatSeq;
  }

  // Test the constructor 
  // CORBA::FloatSeq::FloatSeq(const CORBA::FloatSeq&) 
  if (always_ret_0())
  {
    CORBA::FloatSeq  myFloatSeq1;
    CORBA::FloatSeq myFloatSeq(myFloatSeq1);

    (void *)&myFloatSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::FloatSeq  myFloatSeq;
    CORBA::ULong ul = myFloatSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::FloatSeq myFloatSeq;

    CORBA::ULong ul = 0;

    myFloatSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::FloatSeq myFloatSeq;

    CORBA::ULong ul = myFloatSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator) 
  if (always_ret_0())
  {
    CORBA::FloatSeq myFloatSeq1, myFloatSeq2;

    myFloatSeq1 = myFloatSeq2;

    (void *)&myFloatSeq1;
  }
  
  // Test the operator Float &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::FloatSeq myFloatSeq;
    CORBA::Float myFloat;

    myFloatSeq[index] = myFloat;

    (void *)&myFloatSeq;
  }
  
  // Test the operator const Short &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::FloatSeq myFloatSeq;
    const CORBA::Float& myFloat = myFloatSeq[index];

    (void *)&myFloat;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::FloatSeq myFloatSeq;

    any <<= myFloatSeq;
    any <<= &myFloatSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::FloatSeq *myFloatSeq_ptr = 0;

    b = any >>= myFloatSeq_ptr;

    (void*)&b;
    (void*)&myFloatSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

