//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::LongLongSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of LongLong Def.");

  // Test the constructors 

  // Test the constructor CORBA::LongLongSeq::LongLongSeq() 
  if (always_ret_0())
  {
    CORBA::LongLongSeq myLongLongSeq;

    (void *)&myLongLongSeq;
  }

  // Test the constructor CORBA::LongLongSeq::LongLongSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::LongLongSeq myLongLongSeq((CORBA::ULong)1);

    (void *)&myLongLongSeq;
  }

  // Test the constructor 
  // CORBA::LongLongSeq::LongLongSeq(ULong max,ULong length, 
  //           LongLong *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::LongLong  myBuffer;
    CORBA::LongLongSeq myLongLongSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myLongLongSeq;
  }

  // Test the constructor 
  // CORBA::LongLongSeq::LongLongSeq(const CORBA::LongLongSeq&) 
  if (always_ret_0())
  {
    CORBA::LongLongSeq  myLongLongSeq1;
    CORBA::LongLongSeq myLongLongSeq(myLongLongSeq1);

    (void *)&myLongLongSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::LongLongSeq  myLongLongSeq;
    CORBA::LongLong ul = myLongLongSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::LongLongSeq myLongLongSeq;

    CORBA::ULong ul = 0;

    myLongLongSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::LongLongSeq myLongLongSeq;

    CORBA::ULong ul = myLongLongSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator) 
  if (always_ret_0())
  {
    CORBA::LongLongSeq myLongLongSeq1, myLongLongSeq2;

    myLongLongSeq1 = myLongLongSeq2;

    (void *)&myLongLongSeq1;
  }
  
  // Test the operator Short &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::LongLongSeq myLongLongSeq;
    CORBA::LongLong myLongLong;

    myLongLongSeq[index] = myLongLong;

    (void *)&myLongLongSeq;
  }
  
  // Test the operator const Short &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::LongLongSeq myLongLongSeq;
    const CORBA::LongLong& myLongLong = myLongLongSeq[index];

    (void *)&myLongLong;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::LongLongSeq myLongLongSeq;

    any <<= myLongLongSeq;
    any <<= &myLongLongSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::LongLongSeq *myLongLongSeq_ptr = 0;

    b = any >>= myLongLongSeq_ptr;

    (void*)&b;
    (void*)&myLongLongSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

