//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::LongSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of Long Def.");

  // Test the constructors 

  // Test the constructor CORBA::LongSeq::LongSeq() 
  if (always_ret_0())
  {
    CORBA::LongSeq myLongSeq;

    (void *)&myLongSeq;
  }

  // Test the constructor CORBA::LongSeq::LongSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::LongSeq myLongSeq((CORBA::ULong)1);

    (void *)&myLongSeq;
  }

  // Test the constructor 
  // CORBA::LongSeq::LongSeq(ULong max,ULong length, 
  //           UShort *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::Long  myBuffer;
    CORBA::LongSeq myLongSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myLongSeq;
  }

  // Test the constructor 
  // CORBA::LongSeq::LongSeq(const CORBA::LongSeq&) 
  if (always_ret_0())
  {
    CORBA::LongSeq  myLongSeq1;
    CORBA::LongSeq myLongSeq(myLongSeq1);

    (void *)&myLongSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::LongSeq  myLongSeq;
    CORBA::Long ul = myLongSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::LongSeq myLongSeq;

    CORBA::ULong ul = 0;

    myLongSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::LongSeq myLongSeq;

    CORBA::ULong ul = myLongSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator) 
  if (always_ret_0())
  {
    CORBA::LongSeq myLongSeq1, myLongSeq2;

    myLongSeq1 = myLongSeq2;

    (void *)&myLongSeq1;
  }
  
  // Test the operator UShort &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::LongSeq myLongSeq;
    CORBA::Long myLong;

    myLongSeq[index] = myLong;

    (void *)&myLongSeq;
  }
  
  // Test the operator const UShort &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::LongSeq myLongSeq;
    const CORBA::Long& myLong = myLongSeq[index];

    (void *)&myLong;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::LongSeq myLongSeq;

    any <<= myLongSeq;
    any <<= &myLongSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::LongSeq *myLongSeq_ptr = 0;

    b = any >>= myLongSeq_ptr;

    (void*)&b;
    (void*)&myLongSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

