//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::OctetSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of Octet Def.");

  // Test the constructors 

  // Test the constructor CORBA::OctetSeq::OctetSeq() 
  if (always_ret_0())
  {
    CORBA::OctetSeq myOctetSeq;

    (void *)&myOctetSeq;
  }

  // Test the constructor CORBA::OctetSeq::OctetSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::OctetSeq myOctetSeq((CORBA::ULong)1);

    (void *)&myOctetSeq;
  }

  // Test the constructor 
  // CORBA::OctetSeq::OctetSeq(ULong max,ULong length, 
  //           Octet *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::Octet  myBuffer;
    CORBA::OctetSeq myOctetSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myOctetSeq;
  }

  // Test the constructor 
  // CORBA::OctetSeq::OctetSeq(const CORBA::OctetSeq&) 
  if (always_ret_0())
  {
    CORBA::OctetSeq  myOctetSeq1;
    CORBA::OctetSeq myOctetSeq(myOctetSeq1);

    (void *)&myOctetSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::OctetSeq  myOctetSeq;
    CORBA::ULong ul = myOctetSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::OctetSeq myOctetSeq;

    CORBA::ULong ul = 0;

    myOctetSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::OctetSeq myOctetSeq;

    CORBA::ULong ul = myOctetSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator) 
  if (always_ret_0())
  {
    CORBA::OctetSeq myOctetSeq1, myOctetSeq2;

    myOctetSeq1 = myOctetSeq2;

    (void *)&myOctetSeq1;
  }
  
  // Test the operator Char &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::OctetSeq myOctetSeq;
    CORBA::Octet myOctet;

    myOctetSeq[index] = myOctet;

    (void *)&myOctetSeq;
  }
  
  // Test the operator const Char &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::OctetSeq myOctetSeq;
    const CORBA::Octet& myOctet = myOctetSeq[index];

    (void *)&myOctet;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::OctetSeq myOctetSeq;

    any <<= myOctetSeq;
    any <<= &myOctetSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::OctetSeq *myOctetSeq_ptr = 0;

    b = any >>= myOctetSeq_ptr;

    (void*)&b;
    (void*)&myOctetSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

