//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::ShortSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of Short Def.");

  // Test the constructors 

  // Test the constructor CORBA::ShortSeq::ShortSeq() 
  if (always_ret_0())
  {
    CORBA::ShortSeq myShortSeq;

    (void *)&myShortSeq;
  }

  // Test the constructor CORBA::ShortSeq::ShortSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::ShortSeq myShortSeq((CORBA::ULong)1);

    (void *)&myShortSeq;
  }

  // Test the constructor 
  // CORBA::ShortSeq::ShortSeq(ULong max,ULong length, 
  //           Short *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::Short  myBuffer;
    CORBA::ShortSeq myShortSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myShortSeq;
  }

  // Test the constructor 
  // CORBA::ShortSeq::ShortSeq(const CORBA::ShortSeq&) 
  if (always_ret_0())
  {
    CORBA::ShortSeq  myShortSeq1;
    CORBA::ShortSeq myShortSeq(myShortSeq1);

    (void *)&myShortSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::ShortSeq  myShortSeq;
    CORBA::ULong ul = myShortSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::ShortSeq myShortSeq;

    CORBA::ULong ul = 0;

    myShortSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::ShortSeq myShortSeq;

    CORBA::ULong ul = myShortSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator) 
  if (always_ret_0())
  {
    CORBA::ShortSeq myShortSeq1, myShortSeq2;

    myShortSeq1 = myShortSeq2;

    (void *)&myShortSeq1;
  }
  
  // Test the operator Short &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ShortSeq myShortSeq;
    CORBA::Short myShort;

    myShortSeq[index] = myShort;

    (void *)&myShortSeq;
  }
  
  // Test the operator const Short &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ShortSeq myShortSeq;
    const CORBA::Short& myShort = myShortSeq[index];

    (void *)&myShort;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::ShortSeq myShortSeq;

    any <<= myShortSeq;
    any <<= &myShortSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::ShortSeq *myShortSeq_ptr = 0;

    b = any >>= myShortSeq_ptr;

    (void*)&b;
    (void*)&myShortSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

