//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::ULongLongSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of ULongLong Def.");

  // Test the constructors 

  // Test the constructor CORBA::ULongLongSeq::LongLongSeq() 
  if (always_ret_0())
  {
    CORBA::ULongLongSeq myULongLongSeq;

    (void *)&myULongLongSeq;
  }

  // Test the constructor CORBA::ULongLongSeq::ULongLongSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::ULongLongSeq myULongLongSeq((CORBA::ULong)1);

    (void *)&myULongLongSeq;
  }

  // Test the constructor 
  // CORBA::ULongLongSeq::ULongLongSeq(ULong max,ULong length, 
  //           ULongLong *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::ULongLong  myBuffer;
    CORBA::ULongLongSeq myULongLongSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myULongLongSeq;
  }

  // Test the constructor 
  // CORBA::ULongLongSeq::ULongLongSeq(const CORBA::ULongLongSeq&) 
  if (always_ret_0())
  {
    CORBA::ULongLongSeq  myULongLongSeq1;
    CORBA::ULongLongSeq myULongLongSeq(myULongLongSeq1);

    (void *)&myULongLongSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::ULongLongSeq  myULongLongSeq;
    CORBA::ULongLong ul = myULongLongSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::ULongLongSeq myULongLongSeq;

    CORBA::ULong ul = 0;

    myULongLongSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::ULongLongSeq myULongLongSeq;

    CORBA::ULong ul = myULongLongSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator) 
  if (always_ret_0())
  {
    CORBA::ULongLongSeq myULongLongSeq1, myULongLongSeq2;

    myULongLongSeq1 = myULongLongSeq2;

    (void *)&myULongLongSeq1;
  }
  
  // Test the operator Short &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ULongLongSeq myULongLongSeq;
    CORBA::ULongLong myULongLong;

    myULongLongSeq[index] = myULongLong;

    (void *)&myULongLongSeq;
  }
  
  // Test the operator const Short &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ULongLongSeq myULongLongSeq;
    const CORBA::ULongLong& myULongLong = myULongLongSeq[index];

    (void *)&myULongLong;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::ULongLongSeq myULongLongSeq;

    any <<= myULongLongSeq;
    any <<= &myULongLongSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::ULongLongSeq *myULongLongSeq_ptr = 0;

    b = any >>= myULongLongSeq_ptr;

    (void*)&b;
    (void*)&myULongLongSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

