//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::ULongSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of ULong Def.");

  // Test the constructors 

  // Test the constructor CORBA::ULongSeq::ULongSeq() 
  if (always_ret_0())
  {
    CORBA::ULongSeq myULongSeq;

    (void *)&myULongSeq;
  }

  // Test the constructor CORBA::ULongSeq::ULongSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::ULongSeq myULongSeq((CORBA::ULong)1);

    (void *)&myULongSeq;
  }

  // Test the constructor 
  // CORBA::ULongSeq::ULongSeq(ULong max,ULong length, 
  //           ULong *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::ULong  myBuffer;
    CORBA::ULongSeq myULongSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myULongSeq;
  }

  // Test the constructor 
  // CORBA::ULongSeq::ULongSeq(const CORBA::ULongSeq&) 
  if (always_ret_0())
  {
    CORBA::ULongSeq  myULongSeq1;
    CORBA::ULongSeq myULongSeq(myULongSeq1);

    (void *)&myULongSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::ULongSeq  myULongSeq;
    CORBA::ULong ul = myULongSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::ULongSeq myULongSeq;

    CORBA::ULong ul = 0;

    myULongSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::ULongSeq myULongSeq;

    CORBA::ULong ul = myULongSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator) 
  if (always_ret_0())
  {
    CORBA::ULongSeq myULongSeq1, myULongSeq2;

    myULongSeq1 = myULongSeq2;

    (void *)&myULongSeq1;
  }
  
  // Test the operator ULong &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ULongSeq myULongSeq;
    CORBA::ULong myULong;

    myULongSeq[index] = myULong;

    (void *)&myULongSeq;
  }
  
  // Test the operator const ULong &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::ULongSeq myULongSeq;
    const CORBA::ULong& myULong = myULongSeq[index];

    (void *)&myULong;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::ULongSeq myULongSeq;

    any <<= myULongSeq;
    any <<= &myULongSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::ULongSeq *myULongSeq_ptr = 0;

    b = any >>= myULongSeq_ptr;

    (void*)&b;
    (void*)&myULongSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

