//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::UShortSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of UShort Def.");

  // Test the constructors 

  // Test the constructor CORBA::UShortSeq::UShortSeq() 
  if (always_ret_0())
  {
    CORBA::UShortSeq myUShortSeq;

    (void *)&myUShortSeq;
  }

  // Test the constructor CORBA::UShortSeq::UShortSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::UShortSeq myUShortSeq((CORBA::ULong)1);

    (void *)&myUShortSeq;
  }

  // Test the constructor 
  // CORBA::UShortSeq::UShortSeq(ULong max,ULong length, 
  //           UShort *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::UShort  myBuffer;
    CORBA::UShortSeq myUShortSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myUShortSeq;
  }

  // Test the constructor 
  // CORBA::UShortSeq::UShortSeq(const CORBA::UShortSeq&) 
  if (always_ret_0())
  {
    CORBA::UShortSeq  myUShortSeq1;
    CORBA::UShortSeq myUShortSeq(myUShortSeq1);

    (void *)&myUShortSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::UShortSeq  myUShortSeq;
    CORBA::ULong ul = myUShortSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::UShortSeq myUShortSeq;

    CORBA::ULong ul = 0;

    myUShortSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::UShortSeq myUShortSeq;

    CORBA::ULong ul = myUShortSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator) 
  if (always_ret_0())
  {
    CORBA::UShortSeq myUShortSeq1, myUShortSeq2;

    myUShortSeq1 = myUShortSeq2;

    (void *)&myUShortSeq1;
  }
  
  // Test the operator UShort &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::UShortSeq myUShortSeq;
    CORBA::UShort myUShort;

    myUShortSeq[index] = myUShort;

    (void *)&myUShortSeq;
  }
  
  // Test the operator const UShort &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::UShortSeq myUShortSeq;
    const CORBA::UShort& myUShort = myUShortSeq[index];

    (void *)&myUShort;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::UShortSeq myUShortSeq;

    any <<= myUShortSeq;
    any <<= &myUShortSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::UShortSeq *myUShortSeq_ptr = 0;

    b = any >>= myUShortSeq_ptr;

    (void*)&b;
    (void*)&myUShortSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

