//
// Copyright (c) 2000 GMD FOKUS, Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  ::tet_infoline("The type CORBA::WCharSeq shall be defined ");
  ::tet_infoline("to be a class with all the member functions required");
  ::tet_infoline("of a sequence of WChar Def.");

  // Test the constructors 

  // Test the constructor CORBA::WCharSeq::WCharSeq() 
  if (always_ret_0())
  {
    CORBA::WCharSeq myWCharSeq;

    (void *)&myWCharSeq;
  }

  // Test the constructor CORBA::WCharSeq::WCharSeq(ULong max) 
  if (always_ret_0())
  {
    CORBA::WCharSeq myWCharSeq((CORBA::ULong)1);

    (void *)&myWCharSeq;
  }

  // Test the constructor 
  // CORBA::WCharSeq::WCharSeq(ULong max,ULong length, 
  //           WChar *data, Boolean release = FALSE) 
  if (always_ret_0())
  {
    CORBA::WChar  myBuffer;
    CORBA::WCharSeq myWCharSeq(
                 (CORBA::ULong)1,
                 (CORBA::ULong)1,
                 &myBuffer,
                 (CORBA::Boolean)0);

    (void *)&myWCharSeq;
  }

  // Test the constructor 
  // CORBA::WCharSeq::WCharSeq(const CORBA::WCharSeq&) 
  if (always_ret_0())
  {
    CORBA::WCharSeq  myWCharSeq1;
    CORBA::WCharSeq myWCharSeq(myWCharSeq1);

    (void *)&myWCharSeq;
  }

  // Test the member functions 

  // Test the function ULong maximum() const 
  if (always_ret_0())
  {
    CORBA::WCharSeq  myWCharSeq;
    CORBA::ULong ul = myWCharSeq.maximum();

    (void *)&ul;
  }
  
  // Test the function void length(ULong) 
  if (always_ret_0())
  {
    CORBA::WCharSeq myWCharSeq;

    CORBA::ULong ul = 0;

    myWCharSeq.length(ul);
  }
  
  // Test the function ULong length() const
  if (always_ret_0())
  {
    CORBA::WCharSeq myWCharSeq;

    CORBA::ULong ul = myWCharSeq.length();

    (void *)&ul;
  }

  // Test the operators

  // Test the assignment operator) 
  if (always_ret_0())
  {
    CORBA::WCharSeq myWCharSeq1, myWCharSeq2;

    myWCharSeq1 = myWCharSeq2;

    (void *)&myWCharSeq1;
  }
  
  // Test the operator Char &operator[](ULong index)
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::WCharSeq myWCharSeq;
    CORBA::WChar myWChar;

    myWCharSeq[index] = myWChar;

    (void *)&myWCharSeq;
  }
  
  // Test the operator const Char &operator[](ULong index) const 
  if (always_ret_0())
  {
    CORBA::ULong index = 0;
    CORBA::WCharSeq myWCharSeq;
    const CORBA::WChar& myWChar = myWCharSeq[index];

    (void *)&myWChar;
  }

  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::WCharSeq myWCharSeq;

    any <<= myWCharSeq;
    any <<= &myWCharSeq;
  }
 
  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any any;
    CORBA::Boolean b;
    const CORBA::WCharSeq *myWCharSeq_ptr = 0;

    b = any >>= myWCharSeq_ptr;

    (void*)&b;
    (void*)&myWCharSeq_ptr;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

