//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
    return vol;
}

extern "C" {
static void test1A(void)
{


  ::tet_infoline("The class CORBA::StringValue has a constructor of the form");
  ::tet_infoline("StringValue_var().");

  if (always_ret_0())
	{
		CORBA::StringValue_var myStringValue_var();

		(void *)&myStringValue_var;
	}



  ::tet_infoline("The class CORBA::StringValue_var has a constructor of the form");
  ::tet_infoline("StringValue_var(const CORBA::StringValue& val).");

  if (always_ret_0())
	{
		CORBA::StringValue_var myStringValue1_var(const CORBA::StringValue& val);

		(void *)&myStringValue1_var;
	}



  ::tet_infoline("The class CORBA::StringValue_var has a constructor of the form");
  ::tet_infoline("StringValue_var(const char* str).");

  if (always_ret_0())
	{
		CORBA::StringValue_var myStringValue2_var(const char* str);

		(void *)&myStringValue2_var;
	}

  
  ::tet_infoline("The class CORBA::StringValue_var has a constructor of the form");
  ::tet_infoline("StringValue_var(char *p).");

  if (always_ret_0())
	{
		CORBA::StringValue_var myStringValue3_var(char* p);

		(void *)&myStringValue3_var;
	}


  ::tet_infoline("The class CORBA::StringValue_var has a constructor of the form");
  ::tet_infoline("StringValue_var(const String_var& var).");

  if (always_ret_0())
	{
		CORBA::StringValue_var myStringValue4_var(const CORBA::String_var& var);

		(void *)&myStringValue4_var;
	}




  ::tet_infoline("The class CORBA::StringValue has an assignment operator of the form");
  ::tet_infoline(" StringValue &operator=( char *str).");

	CORBA::StringValue& (CORBA::StringValue::*pf)(char *) = NULL;

	pf = &CORBA::StringValue::operator=;

  if (always_ret_0())
	{
		char *p = "StringValue &operator=(char *p)";
		CORBA::StringValue *myStringValue;

		(void)(myStringValue->*pf)(p);
	}



  ::tet_infoline("The class CORBA::StringValue has an assignment operator of the form");
  ::tet_infoline(" StringValue &operator=(const char *str).");

	CORBA::StringValue& (CORBA::StringValue::*pf2)(const char *) = NULL;
	pf2 = &CORBA::StringValue::operator=;

  if (always_ret_0())
	{
		const char *p = "StringValue &operator=(const char *p)";
		CORBA::StringValue *myStringValue;

		(void)(myStringValue->*pf2)(p);
	}



  ::tet_infoline("The class CORBA::StringValue has an assignment operator of the form");
  ::tet_infoline(" StringValue &operator=(const CORBA::String_var& var).");

	CORBA::StringValue& (CORBA::StringValue::*pf3)(const CORBA::String_var&) = NULL;
	pf3 = &CORBA::StringValue::operator=;

  if (always_ret_0())
	{
		const CORBA::String_var& p = "StringValue &operator=(const CORBA::String_var&)";
		CORBA::StringValue *myStringValue;

		(void)(myStringValue->*pf3)(p);
	}



  ::tet_infoline("The class CORBA::StringValue shall have a member ");
  ::tet_infoline("const char* _value() const defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::StringValue_var myStringValue6;
		const char* ret6;
		ret6 = (myStringValue6->_value)();
	}
  


  ::tet_infoline("The class CORBA::StringValue shall have a member ");
  ::tet_infoline("void _value(char* str) defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::StringValue_var myStringValue7;
		char* p7;
		(void)(myStringValue7->_value)(p7);
	}


  ::tet_infoline("The class CORBA::StringValue shall have a member ");
  ::tet_infoline("void _value(const char* str) defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::StringValue_var myStringValue8;
		const char* p8;
		(void)(myStringValue8->_value)(p8);
	}


  ::tet_infoline("The class CORBA::StringValue shall have a member ");
  ::tet_infoline("void _value(const String_var& var) defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::StringValue_var myStringValue9;
		const CORBA::String_var& p9 = "DUMMY";
		(void)(myStringValue9->_value)(p9);
	}


  ::tet_infoline("The class CORBA::StringValue shall have a member ");
  ::tet_infoline("const char* _boxed_in() const defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::StringValue_var myStringValue10;
		const char* ret10;
		ret10 = (myStringValue10->_boxed_in)();
	}
  

  ::tet_infoline("The class CORBA::StringValue shall have a member ");
  ::tet_infoline("const char* _boxed_inout() defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::StringValue_var myStringValue11;
		char*& ret11 = (myStringValue11->_boxed_inout)();
	}
  

  ::tet_infoline("The class CORBA::StringValue shall have a member ");
  ::tet_infoline("const char* _boxed_out() defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::StringValue_var myStringValue12;
		char*& ret12 = (myStringValue12->_boxed_out)();
	}
  

  ::tet_infoline("The class CORBA::StringValue shall have a member ");
  ::tet_infoline("static StringValue* _downcast(ValueBase* base) defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::StringValue_var myStringValue13;
		CORBA::ValueBase* p13;
		CORBA::StringValue* ret13;
		ret13 = (myStringValue13->_downcast)(p13);
	}
  


    ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
