//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
    return vol;
}

extern "C" {
static void test1A(void)
{


  ::tet_infoline("The class CORBA::WStringValue has a constructor of the form");
  ::tet_infoline("WStringValue_var().");

  if (always_ret_0())
	{
		CORBA::WStringValue_var myWStringValue_var();

		(void *)&myWStringValue_var;
	}



  ::tet_infoline("The class CORBA::WStringValue_var has a constructor of the form");
  ::tet_infoline("WStringValue_var(const CORBA::WStringValue& val).");

  if (always_ret_0())
	{
		CORBA::WStringValue_var myWStringValue1_var(const CORBA::WStringValue& val);

		(void *)&myWStringValue1_var;
	}



  ::tet_infoline("The class CORBA::WStringValue_var has a constructor of the form");
  ::tet_infoline("WStringValue_var(const char* str).");

  if (always_ret_0())
	{
		CORBA::WStringValue_var myWStringValue2_var(const char* str);

		(void *)&myWStringValue2_var;
	}

  
  ::tet_infoline("The class CORBA::WStringValue_var has a constructor of the form");
  ::tet_infoline("WStringValue_var(char *p).");

  if (always_ret_0())
	{
		CORBA::WStringValue_var myWStringValue3_var(char* p);

		(void *)&myWStringValue3_var;
	}


  ::tet_infoline("The class CORBA::WStringValue_var has a constructor of the form");
  ::tet_infoline("WStringValue_var(const WString_var& var).");

  if (always_ret_0())
	{
		CORBA::WStringValue_var myWStringValue4_var(const CORBA::WString_var& var);

		(void *)&myWStringValue4_var;
	}




  ::tet_infoline("The class CORBA::WStringValue has an assignment operator of the form");
  ::tet_infoline(" WStringValue &operator=( WChar *str).");

	CORBA::WStringValue& (CORBA::WStringValue::*pf)(CORBA::WChar *) = NULL;

	pf = &CORBA::WStringValue::operator=;

  if (always_ret_0())
	{
		CORBA::WChar *p = L"WStringValue &operator=(CORBA::WChar *p)";
		CORBA::WStringValue *myWStringValue;

		(void)(myWStringValue->*pf)(p);
	}



  ::tet_infoline("The class CORBA::WStringValue has an assignment operator of the form");
  ::tet_infoline(" WStringValue &operator=(const WChar *str).");

	CORBA::WStringValue& (CORBA::WStringValue::*pf2)(const CORBA::WChar *) = NULL;
	pf2 = &CORBA::WStringValue::operator=;

  if (always_ret_0())
	{
		const CORBA::WChar *p = L"WStringValue &operator=(const CORBA::WChar *p)";
		CORBA::WStringValue *myWStringValue;

		(void)(myWStringValue->*pf2)(p);
	}



  ::tet_infoline("The class CORBA::WStringValue has an assignment operator of the form");
  ::tet_infoline(" WStringValue &operator=(const CORBA::String_var& var).");

	CORBA::WStringValue& (CORBA::WStringValue::*pf3)(const CORBA::WString_var&) = NULL;
	pf3 = &CORBA::WStringValue::operator=;

  if (always_ret_0())
	{
		const CORBA::WString_var& p = L"WStringValue &operator=(const CORBA::WString_var&)";
		CORBA::WStringValue *myWStringValue;

		(void)(myWStringValue->*pf3)(p);
	}



  ::tet_infoline("The class CORBA::WStringValue shall have a member ");
  ::tet_infoline("const CORBA::WChar* _value() const defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::WStringValue_var myWStringValue6;
		const CORBA::WChar* ret6;
		ret6 = (myWStringValue6->_value)();
	}
  


  ::tet_infoline("The class CORBA::WStringValue shall have a member ");
  ::tet_infoline("void _value(CORBA::WChar* str) defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::WStringValue_var myWStringValue7;
		CORBA::WChar* p7;
		(void)(myWStringValue7->_value)(p7);
	}


  ::tet_infoline("The class CORBA::WStringValue shall have a member ");
  ::tet_infoline("void _value(const CORBA::WChar* str) defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::WStringValue_var myWStringValue8;
		const CORBA::WChar* p8;
		(void)(myWStringValue8->_value)(p8);
	}


  ::tet_infoline("The class CORBA::WStringValue shall have a member ");
  ::tet_infoline("void _value(const WString_var& var) defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::WStringValue_var myWStringValue9;
		const CORBA::WString_var& p9 = L"DUMMY";
		(void)(myWStringValue9->_value)(p9);
	}


  ::tet_infoline("The class CORBA::WStringValue shall have a member ");
  ::tet_infoline("const CORBA::WChar* _boxed_in() const defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::WStringValue_var myWStringValue10;
		const CORBA::WChar* ret10;
		ret10 = (myWStringValue10->_boxed_in)();
	}
  

  ::tet_infoline("The class CORBA::WStringValue shall have a member ");
  ::tet_infoline("const char* _boxed_inout() defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::WStringValue_var myWStringValue11;
		CORBA::WChar*& ret11 = (myWStringValue11->_boxed_inout)();
	}
  

  ::tet_infoline("The class CORBA::WStringValue shall have a member ");
  ::tet_infoline("const char* _boxed_out() defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::WStringValue_var myWStringValue12;
		CORBA::WChar*& ret12 = (myWStringValue12->_boxed_out)();
	}
  

  ::tet_infoline("The class CORBA::WStringValue shall have a member ");
  ::tet_infoline("static WStringValue* _downcast(ValueBase* base) defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::WStringValue_var myWStringValue13;
		CORBA::ValueBase* p13;
		CORBA::WStringValue* ret13;
		ret13 = (myWStringValue13->_downcast)(p13);
	}
  


    ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
