/*
* Copyright (c) 2000 Object Oriented Concepts GmbH
*
* All rights reserved. No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Project: CORVAL2
*
*/

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A(void)
{
	CORBA::Boolean (CORBA::Any::*pf)(CORBA::Any::to_abstract_base) const = NULL;

  ::tet_infoline("The class CORBA::Any shall have a Boolean operator>>=(to_abstract_base) member.");

  // Force the compiler to generate warnings/errors if member does not exist

	pf = &CORBA::Any::operator>>=;
  
	if (always_ret_0())
	{
		CORBA::Any myAny;
		CORBA::AbstractBase_ptr p = NULL;
		CORBA::Any::to_abstract_base s(p);

		(void)(myAny.*pf)(s);
	}
  
  ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
