//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//
// Purpose: Header file test for the type CORBA::Double
//

#include <corba_supp.hh>
#include <stdio.h>
#include <tet_api.h>

/*error messages formatted here*/
char ebuf[4096];

extern "C" {
static void test1A(void)
{
    CORBA::Double mydouble;
    double       dummy;
    double       *pdummy;

    tet_infoline("The type CORBA::Double shall be defined to be of type double.");

    tet_infoline("TEST: Size");
    if ((sizeof(CORBA::Double)) != sizeof(double)) 
    {
	sprintf((char *)&ebuf[0], 
		"ERROR: Expected size of CORBA::Double to be %d bytes, is %d bytes", 
		sizeof(double),sizeof(CORBA::Double));
	tet_infoline(ebuf);
	tet_result(TET_FAIL);
	return;
    }

    tet_infoline("TEST: Signed");
    mydouble = 0;
    mydouble -= 1;
    dummy = 0;
    if (mydouble == dummy)
    {
	tet_infoline("ERROR: Expected CORBA::Double to be signed, is unsigned.");
	tet_result(TET_FAIL);
	return;
    }

    tet_infoline("TEST: Integral");
    mydouble = 4.32;
    if (mydouble == 4)
    {
	tet_infoline("ERROR: Expected CORBA::Double to be a double, is integral.");
	tet_result(TET_FAIL);
	return;
    }

    /* Force the compiler to generate warnings/errors if CORBA::Double */
    /* is not defined to be double */

    mydouble = 1;
    if (mydouble == dummy)
	mydouble = 0;

    pdummy = &mydouble;


    tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}
