//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//
// Purpose: Header file test for the type CORBA::Float
//

#include <corba_supp.hh>
#include <stdio.h>
#include <tet_api.h>

/*error messages formatted here*/
char ebuf[4096];

extern "C" {
static void test1A(void)
{
    CORBA::Float myfloat;
    float       dummy;
    float       *pdummy;

    tet_infoline("The type CORBA::Float shall be defined to be of type float.");

    tet_infoline("TEST: Size");
    if ((sizeof(CORBA::Float)) != sizeof(float)) 
    {
	sprintf((char *)&ebuf[0], 
		"ERROR: Expected size of CORBA::Float to be %d bytes, is %d bytes", 
		sizeof(float),sizeof(CORBA::Float));
	tet_infoline(ebuf);
	tet_result(TET_FAIL);
	return;
    }

    tet_infoline("TEST: Signed");
    myfloat = 0;
    myfloat -= 1;
    dummy = 0;
    if (myfloat == dummy)
    {
	tet_infoline("ERROR: Expected CORBA::Float to be signed, is unsigned.");
	tet_result(TET_FAIL);
	return;
    }

    tet_infoline("TEST: Integral");
    myfloat = CORBA::Float(4.32);
    if (myfloat == 4)
    {
	tet_infoline("ERROR: Expected CORBA::Float to be a float, is integral.");
	tet_result(TET_FAIL);
	return;
    }

    /* Force the compiler to generate warnings/errors if */
    /* CORBA::Float is not defined to be float */

    myfloat = 1;
    if (myfloat == dummy)
	myfloat = 0;

    pdummy = &myfloat;


    tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}
