//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//
// Purpose: Header file test for the type CORBA::Long
//

#include <corba_supp.hh>
#include <stdio.h>
#include <tet_api.h>

/*error messages formatted here*/
char ebuf[4096];

extern "C" {
static void test1A(void)
{
    CORBA::Long mylong;
    long       dummy;

    tet_infoline("The type CORBA::Long shall be defined with a size ");
    tet_infoline("of exactly 4 bytes, signed and integral.");

    tet_infoline("TEST: Size");
    if ((sizeof(CORBA::Long)) != 4) 
    {
	sprintf((char *)&ebuf[0], 
		"ERROR: Expected size of CORBA::Long to be 4 bytes, is %d bytes", 
		sizeof(CORBA::Long));
	tet_infoline(ebuf);
	tet_result(TET_FAIL);
	return;
    }

    tet_infoline("TEST: Signed");
    mylong = 0;
    mylong -= 1;
    dummy = 0;
    if (mylong >= dummy)
    {
	tet_infoline("ERROR: Expected CORBA::Long to be signed, is unsigned.");
	tet_result(TET_FAIL);
	return;
    }

    tet_infoline("TEST: Integral");
    mylong = CORBA::Long(4.32);
    if (mylong != 4)
    {
	tet_infoline("ERROR: Expected CORBA::Long to be integral.");
	tet_result(TET_FAIL);
	return;
    }

    tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}
