//
// Copyright (c) 2000 Object Oriented Concepts GmbH
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//
// Purpose: Header file test for the type CORBA::LongLong
//

#include <corba_supp.hh>
#include <stdio.h>
#include <tet_api.h>

/*error messages formatted here*/
char ebuf[4096];

extern "C" {
static void test1A(void)
{
    CORBA::Long mylonglong;
    long long       dummy;

    tet_infoline("The type CORBA::LongLong shall be defined with a size ");
    tet_infoline("of exactly 8 bytes, signed and integral.");

    tet_infoline("TEST: Size");
    if ((sizeof(CORBA::LongLong)) != 8) 
    {
	sprintf((char *)&ebuf[0], 
		"ERROR: Expected size of CORBA::LongLong to be 8 bytes, is %d bytes", 
		sizeof(CORBA::LongLong));
	tet_infoline(ebuf);
	tet_result(TET_FAIL);
	return;
    }

    tet_infoline("TEST: Signed");
    mylonglong = 0;
    mylonglong -= 1;
    dummy = 0;
    if (mylonglong >= dummy)
    {
	tet_infoline("ERROR: Expected CORBA::LongLong to be signed, is unsigned.");
	tet_result(TET_FAIL);
	return;
    }

    tet_infoline("TEST: Integral");
    mylonglong = CORBA::LongLong(4.32);
    if (mylonglong != 4)
    {
	tet_infoline("ERROR: Expected CORBA::LongLong to be integral.");
	tet_result(TET_FAIL);
	return;
    }

    tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}
