//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//
// Purpose: Header file test for the type CORBA::Octet
//

#include <corba_supp.hh>
#include <stdio.h>
#include <tet_api.h>

/*error messages formatted here*/
char ebuf[4096];

int bits_per_octet = 0;

extern "C" {
static void test1A(void)
{
    CORBA::Octet myoctet;

    tet_infoline("The type CORBA::Octet shall be defined with a size ");
    tet_infoline("size of exactly 8 bits.");

    myoctet = 1;

    while (myoctet != 0) {
	myoctet = myoctet << 1;
	bits_per_octet++;
    }

    tet_infoline("TEST: Size");
    if ((sizeof(CORBA::Octet) * bits_per_octet) != 8) 
    {
	sprintf((char *)&ebuf[0], 
		"ERROR: Expected size of CORBA::Octet to be 8 bits, is %d bits", 
		sizeof(CORBA::Octet)*bits_per_octet);
	tet_infoline(ebuf);
	tet_result(TET_FAIL);
	return;
    }

    tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}
