//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//
// Purpose: Header file test for the type CORBA::Short
//

#include <corba_supp.hh>
#include <stdio.h>
#include <tet_api.h>

/*error messages formatted here*/
char ebuf[4096];

extern "C" {
static void test1A(void)
{
    CORBA::Short myshort;
    short       dummy;

    tet_infoline("The type CORBA::Short shall be defined with a size ");
    tet_infoline("of exactly 2 bytes, signed and integral.");

    tet_infoline("TEST: Size");
    if ((sizeof(CORBA::Short)) != 2) 
    {
	sprintf((char *)&ebuf[0], 
		"ERROR: Expected size of CORBA::Short to be 2 bytes, is %d bytes", sizeof(CORBA::Short));
	tet_infoline(ebuf);
	tet_result(TET_FAIL);
	return;
    }

    tet_infoline("TEST: Signed");
    myshort = 0;
    myshort -= 1;
    dummy = 0;
    if (myshort >= dummy)
    {
	tet_infoline("ERROR: Expected CORBA::Short to be signed, is unsigned.");
	tet_result(TET_FAIL);
	return;
    }

    tet_infoline("TEST: Integral");
    myshort = CORBA::Short(4.32);
    if (myshort != 4)
    {
	tet_infoline("ERROR: Expected CORBA::Short to be integral.");
	tet_result(TET_FAIL);
	return;
    }

    tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}
