//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//
// Purpose: Header file test for the type CORBA::ULong
//

#include <corba_supp.hh>
#include <stdio.h>
#include <tet_api.h>

/*error messages formatted here*/
char ebuf[4096];

extern "C" {
static void test1A(void)
{
    CORBA::ULong myulong;
    unsigned long       dummy;

    tet_infoline("The type CORBA::ULong shall be defined with a size ");
    tet_infoline("of exactly 4 bytes, unsigned and integral.");

    tet_infoline("TEST: Size");
    if ((sizeof(CORBA::ULong)) != 4) 
    {
	sprintf((char *)&ebuf[0], 
		"ERROR: Expected size of CORBA::ULong to be 4 bytes, is %d bytes",
		sizeof(CORBA::ULong));
	tet_infoline(ebuf);
	tet_result(TET_FAIL);
	return;
    }

    tet_infoline("TEST: Unsigned");
    myulong = 0;
    myulong -= 1;
    dummy = 0;
    if (myulong < dummy)
    {
	tet_infoline("ERROR: Expected CORBA::ULong to be unsigned, is signed.");
	tet_result(TET_FAIL);
	return;
    }

    tet_infoline("TEST: Integral");
    myulong = CORBA::ULong(4.32);
    if (myulong != 4)
    {
	tet_infoline("ERROR: Expected CORBA::ULong to be integral.");
	tet_result(TET_FAIL);
	return;
    }

    tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}
