//
// Copyright (c) 2000 Object Oriented Concepts GmbH
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//
// Purpose: Header file test for the type CORBA::ULongLong
//

#include <corba_supp.hh>
#include <stdio.h>
#include <tet_api.h>

/*error messages formatted here*/
char ebuf[4096];

extern "C" {
static void test1A(void)
{
    CORBA::ULongLong myulonglong;
    unsigned long long       dummy;

    tet_infoline("The type CORBA::ULongLong shall be defined with a size ");
    tet_infoline("of exactly 8 bytes, unsigned and integral.");

    tet_infoline("TEST: Size");
    if ((sizeof(CORBA::ULongLong)) != 8) 
    {
	sprintf((char *)&ebuf[0], 
		"ERROR: Expected size of CORBA::ULongLong to be 8 bytes, is %d bytes",
		sizeof(CORBA::ULongLong));
	tet_infoline(ebuf);
	tet_result(TET_FAIL);
	return;
    }

    tet_infoline("TEST: Unsigned");
    myulonglong = 0;
    myulonglong -= 1;
    dummy = 0;
    if (myulonglong < dummy)
    {
	tet_infoline("ERROR: Expected CORBA::ULongLong to be unsigned, is signed.");
	tet_result(TET_FAIL);
	return;
    }

    tet_infoline("TEST: Integral");
    myulonglong = CORBA::ULongLong(4.32);
    if (myulonglong != 4)
    {
	tet_infoline("ERROR: Expected CORBA::ULongLong to be integral.");
	tet_result(TET_FAIL);
	return;
    }

    tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}
