//
// Copyright (c) 2000 Object Oriented Concepts GmbH
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//
// Purpose: Header file test for the type CORBA::WChar
//

#include <corba_supp.hh>
#include <stdio.h>
#include <tet_api.h>

/*error messages formatted here*/
char ebuf[4096];

extern "C" {
static void test1A(void)
{
    tet_infoline("The type CORBA::WChar shall be defined with a size ");
    tet_infoline("size of sizeof(wchar_t) bytes.");

    tet_infoline("TEST: Size");
    if (sizeof(CORBA::WChar) != sizeof(wchar_t)) 
    {
	sprintf((char *)&ebuf[0], 
		"ERROR: Expected size of CORBA::WChar to be %d, is %d bytes", 
		sizeof(wchar_t), sizeof(CORBA::WChar));
	tet_infoline(ebuf);
	tet_result(TET_FAIL);
	return;
    }
    
    tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}
