//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; 

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A(void)
{
	::tet_infoline("The type CORBA::ORB::ObjectIdList shall be defined ");
	::tet_infoline("to be a class with all the member functions required");
	::tet_infoline("of a sequence of ObjectId.");

	// Test the constructors 

	// Test the constructor CORBA::ORB::ObjectIdList::ObjectIdList() 
	if (always_ret_0())
	{
		CORBA::ORB::ObjectIdList myObjectIdList;

		(void *)&myObjectIdList;
	}

	// Test the constructor CORBA::ORB::ObjectIdList::ObjectIdList(ULong max) 
	if (always_ret_0())
	{
		CORBA::ORB::ObjectIdList myObjectIdList((CORBA::ULong)1);

		(void *)&myObjectIdList;
	}

	// Test the constructor 
	// CORBA::ORB::ObjectIdList::ObjectIdList(ULong max,ULong length, 
	//					 ObjectId *data, Boolean release = FALSE) 
	if (always_ret_0())
	{
		CORBA::ORB::ObjectId	myBuffer;
		CORBA::ORB::ObjectIdList myObjectIdList(
								 (CORBA::ULong)1,
								 (CORBA::ULong)1,
								 &myBuffer,
								 (CORBA::Boolean)0);

		(void *)&myObjectIdList;
	}

	// Test the constructor 
	// CORBA::ORB::ObjectIdList::ObjectIdList(const CORBA::ORB::ObjectIdList&) 
	if (always_ret_0())
	{
		CORBA::ORB::ObjectIdList	myObjectIdList1;
		CORBA::ORB::ObjectIdList myObjectIdList(myObjectIdList1);

		(void *)&myObjectIdList;
	}

	// Test the member functions 

	if (always_ret_0())
	{
		CORBA::ORB::ObjectIdList myObjectIdList;
		CORBA::ULong ul = myObjectIdList.maximum();

		(void *)&ul;
	}

	if (always_ret_0())
	{
		CORBA::ORB::ObjectIdList myObjectIdList;
		CORBA::ULong ul = 0;

		myObjectIdList.length(ul);
	}

	if (always_ret_0())
	{
		CORBA::ORB::ObjectIdList myObjectIdList;
		CORBA::ULong ul = myObjectIdList.length();

		(void *)&ul;
	}

	// Test the operators

	// Test the operator ObjectId &operator=(const ObjectId&) 
	if (always_ret_0())
	{
		CORBA::ORB::ObjectIdList objectIdList1;
		CORBA::ORB::ObjectIdList objectIdList2;
		objectIdList2 = objectIdList1;

		(void *)&objectIdList2;
	}	

	// Test the operator ObjectId &operator[](ULong index)
	if (always_ret_0())
	{
		CORBA::ULong index = (CORBA::ULong)0;
		CORBA::ORB::ObjectIdList objectIdList;

		CORBA::ORB::ObjectId objectId;
 		objectIdList[index] = objectId;
	}
	
	// Test the operator const ObjectId &operator[](ULong index) const 
	if (always_ret_0())
	{
		CORBA::ULong index = (CORBA::ULong)0;
		CORBA::ORB::ObjectIdList objectIdList;

		const CORBA::ORB::ObjectId objectId = objectIdList[index];
	}
	
	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}


