//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The exception CORBA::PolicyError shall be defined.");

	// Test the constructors

	::tet_infoline("TEST: The constructor CORBA::PolicyError::PolicyError()");
	if (always_ret_0())
	{
		CORBA::PolicyError myException;

		(void *)&myException;
	}

	::tet_infoline("TEST: The constructor CORBA::PolicyError::PolicyError(const PolicyError &)");
	if (always_ret_0())
	{
		CORBA::PolicyError myException1;

		CORBA::PolicyError myException2(myException1);

		(void *)&myException2;
	}



	::tet_infoline("TEST: The assignment operator");
	if (always_ret_0())
	{
		CORBA::PolicyError myException1;
		CORBA::PolicyError myException2;

		myException1 = myException2;

		(void *)&myException1;
	}

	::tet_infoline("TEST: Test the _downcast method");
	if (always_ret_0())
	{
		CORBA::Exception *pException = 0;;
		CORBA::PolicyError *pmyException;

		pmyException = CORBA::PolicyError::_downcast(pException);
	}
	if (always_ret_0())
	{
		const CORBA::Exception *pException = 0;;
		const CORBA::PolicyError*pmyException;

		pmyException = CORBA::PolicyError::_downcast(pException);
	}

	::tet_infoline("TEST: Test the _raise method");
	if (always_ret_0())
	{
		CORBA::PolicyError myException;

		myException._raise();
	}


	::tet_infoline("TEST: Test the read access function for reason");
	if (always_ret_0())
	{
		CORBA::PolicyError myException;
		CORBA::PolicyErrorCode index = myException.reason;
	}

	::tet_infoline("TEST: Test the constructor PolicyError(CORBA::PolicyErrorCode)");
	if (always_ret_0())
	{
		CORBA::PolicyError myException;
		CORBA::PolicyErrorCode myobject;
		CORBA::PolicyError myException2(myobject);
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

