//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;
static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A()
{
  CORBA::SetOverrideType myEnumeration1;
  CORBA::SetOverrideType myEnumeration2;

  ::tet_infoline("The type CORBA::SetOverrideType");
  ::tet_infoline("shall be defined to be an enum.");
  ::tet_infoline("Each enumerator shall be defined in the correct order.");

  ::tet_infoline("TEST: size");

  if (sizeof(CORBA::SetOverrideType) != 4)
  {
    ::tet_printf("ERROR: Expected size of CORBA::SetOverrideType to be 4, is %d", sizeof(CORBA::SetOverrideType));

    ::tet_result(TET_FAIL);

    return;
  }


  ::tet_infoline("TEST: enumerators");

  myEnumeration1 = CORBA::SET_OVERRIDE;
  myEnumeration2 = CORBA::ADD_OVERRIDE;

  if (myEnumeration1 >= myEnumeration2)
  {
    ::tet_printf("ERROR: Expected enumerator CORBA::SET_OVERRIDE to be less than enumerator CORBA::ADD_OVERRIDE");
    ::tet_result(TET_FAIL);
  }



  ::tet_infoline("TEST: Insertion into CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any  any;
    any <<= (CORBA::Short)myEnumeration1;
  }

  ::tet_infoline("TEST: Extraction from CORBA::Any");
  if (always_ret_0())
  {
    CORBA::Any  any;
    CORBA::Boolean b;
    b = any >>= (CORBA::Short)myEnumeration1;

    (void*)&b;
    (void*)&myEnumeration1;
  }

  ::tet_result(TET_PASS);
}
}

extern "C" {
  void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
  struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

