//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

static void test1A()
{
	CORBA::Object_var myInterface;

#if VSORB_CORBA_STATUS
	// declare an instance of the return type 
	CORBA::Status ret;
#endif /* VSORB_CORBA_STATUS */

	// declare an instance of each parameter 
	CORBA::Context_ptr myp1;
	CORBA::Identifier myp2;
	CORBA::NVList_ptr myp3;
	CORBA::NamedValue_ptr myp4;
	CORBA::Request_ptr myp5;
	CORBA::Flags myp6;

	::tet_infoline("The function CORBA::Object::_create_request");
	::tet_infoline("shall be defined to be of type");
	::tet_infoline("void _create_request(CORBA::Context,CORBA::Identifier,CORBA::NVList,CORBA::NamedValue,CORBA::Request,CORBA::Flags)");


	// Include a call to the function to make sure it is present in the library 
	if (always_ret_0())
#if VSORB_CORBA_STATUS
		ret = 
#endif /* VSORB_CORBA_STATUS */

	// due to CORBA 1.34.2 this operation must have a leading underscore. 
			myInterface->_create_request(myp1,myp2,myp3,myp4,myp5,myp6);

	::tet_result(TET_PASS);
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

