//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The exception CORBA::TypeCode::BadKind shall be defined.");

	// Test the constructors

	::tet_infoline("TEST: The constructor CORBA::TypeCode::BadKind::BadKind()");
	if (always_ret_0())
	{
		CORBA::TypeCode::BadKind myBadKind;

		(void *)&myBadKind;
	}

	::tet_infoline("TEST: The constructor CORBA::TypeCode::BadKind::BadKind(const BadKind &)");
	if (always_ret_0())
	{
		CORBA::TypeCode::BadKind myBadKind1;

		CORBA::TypeCode::BadKind myBadKind2(myBadKind1);

		(void *)&myBadKind2;
	}

	::tet_infoline("TEST: The assignment operator");
	if (always_ret_0())
	{
		CORBA::TypeCode::BadKind myBadKind1;
		CORBA::TypeCode::BadKind myBadKind2;

		myBadKind1 = myBadKind2;

		(void *)&myBadKind1;
	}

	::tet_infoline("TEST: Test the _downcast method");
	if (always_ret_0())
	{
		CORBA::Exception *pException = 0;;
		CORBA::TypeCode::BadKind*pBadKind;

		pBadKind = CORBA::TypeCode::BadKind::_downcast(pException);
	}

	::tet_infoline("TEST: Test the _raise method");
	if (always_ret_0())
	{
                CORBA::TypeCode::BadKind myBadKind;

                myBadKind._raise();
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

