//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The exception CORBA::TypeCode::Bounds shall be defined.");

	// Test the constructors

	::tet_infoline("TEST: The constructor CORBA::TypeCode::Bounds::Bounds()");
	if (always_ret_0())
	{
		CORBA::TypeCode::Bounds myBounds;

		(void *)&myBounds;
	}

	::tet_infoline("TEST: The constructor CORBA::TypeCode::Bounds::Bounds(const Bounds &)");
	if (always_ret_0())
	{
		CORBA::TypeCode::Bounds myBounds1;

		CORBA::TypeCode::Bounds myBounds2(myBounds1);

		(void *)&myBounds2;
	}

	::tet_infoline("TEST: The assignment operator");
	if (always_ret_0())
	{
		CORBA::TypeCode::Bounds myBounds1;
		CORBA::TypeCode::Bounds myBounds2;

		myBounds1 = myBounds2;

		(void *)&myBounds1;
	}

	::tet_infoline("TEST: Test the _downcast method");
	if (always_ret_0())
	{
		CORBA::Exception *pException = 0;;
		CORBA::TypeCode::Bounds*pBounds;

		pBounds = CORBA::TypeCode::Bounds::_downcast(pException);
	}

	::tet_infoline("TEST: Test the _raise method");
	if (always_ret_0())
	{
                CORBA::TypeCode::Bounds myBounds;

                myBounds._raise();
	}

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

