# include <stdio.h>
# include <stdlib.h>
# include <tet_api.h>
# include <cstdlib>
# include <unistd.h>
# include <fcntl.h>
# include <tp.hh>

# define STRMAXLENGTH 200
# define BUFSIZE 1024

int testpurp::compile(){
    char* cmdstr;
    int fd1,fd2,fd3,fd4;
    const char* ERROR_FILENAME = "tmp_comp.err";
    const char* OUT_FILENAME = "tmp_comp.out";
    int n;

    // Allocate memory !
 
    cmdstr=(char *) malloc(STRMAXLENGTH);
    
    // Output-redirection
    close(1);
    if ((fd1=open(OUT_FILENAME,O_WRONLY|O_CREAT|O_TRUNC,0666)==-1))
      tet_printf("could not create output file\n");

    // Error-redirection
    close(2);
    if ((fd2=open(ERROR_FILENAME,O_WRONLY|O_CREAT|O_TRUNC,0666)==-1)){
      tet_printf("could not create error file\n");
    }

    strcpy(cmdstr,"make -sf $VS_ROOT/bin/vsorb_vars -f tcg_ctrl.mk ");
    strcat(cmdstr,name);
    strcat(cmdstr,".o");
    // Compile piece of code 
    if ((system(cmdstr))!=0)                 //Compilation not OK ?
      {
	::tet_infoline("Error while compiling the C++ source code for this feature");
	if((fd3=open(OUT_FILENAME,O_RDONLY))==-1)
	  ::tet_printf("could not open compiler output file");
	else {
	char buf[BUFSIZE];
	while ((n=(read(fd3,buf,BUFSIZE)))>0)
	  {
	    // Making sure we don't send any rubbish to output...
	    if(n<BUFSIZE)
	      buf[n]='\0'; 
	    ::tet_printf(buf);
	  }
	}

	if((fd4=open(ERROR_FILENAME,O_RDONLY))==-1)
	  ::tet_printf("could not open compiler Error file");
	else {
	  char buf[BUFSIZE];
	  while ((n=(read(fd4,buf,BUFSIZE)))>0)
	    {	      
	      if(n<BUFSIZE)
		buf[n]='\0'; 
	      ::tet_printf(buf);
	    }
	}
	// free memory
	free(cmdstr);
	close(fd3);
	close(fd4);
	return(0);
      }
    else
      {
	// free memory
	free(cmdstr);
	return(1);
    }
}

void testpurp::run(int inv_para)
{
  testpurp::result=TET_UNTESTED;
  print_pp();

  if(testpurp::compile()) // if Compile OK...
    {
      if (inv_para==1){      // and inverting option is on
	::tet_result(TET_FAIL); // then FAIL
	result=TET_FAIL;
      }
      else {
	::tet_result(TET_PASS);  // else PASS
	testpurp::result=TET_PASS;
      }
    }
  else  // if Compiling failed...
    {     
      if (inv_para==1){      // and inverting option is on
	::tet_result(TET_PASS); // then PASS
	result=TET_PASS;
      }
      else {
	::tet_result(TET_FAIL);  // else FAIL
	testpurp::result=TET_FAIL;
      }
    }
}


void testpurp::print_pp()
 {
   char* cstring;
   cstring=(char *) malloc(STRMAXLENGTH);  
   strcpy(cstring,descrptn);
   tet_printf(cstring);
   free(cstring);
 } 
    
void testpurp::skip()
 {  
    testpurp::print_pp();
  ::tet_result(TET_UNTESTED);
  return;
 }
