//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.3  2000/04/18 14:08:48  dow
// False and true are keywords in CORBA IDL 2.3
//
// Revision 1.2  2000/04/17 13:23:47  dow
// IDL names which are C++ keywords should be translated
// to names which begin with _cxx_.
// Private and public are IDL keywords in CORBA 2.3
//
// Revision 1.1.1.1  2000/02/09 17:15:45  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/26 13:49:46  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/15 10:51:34  james
// #ifdefs removed
//
// Revision 1.4  1997/12/09 11:24:56  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetAvocado(::Avocado &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAvocado");
#endif

  GetFloat(v._cxx_and);
  GetDouble(v._cxx_and_eq);
  GetULong(v._cxx_auto);
  GetShort(v._cxx_bitand);
  GetUShort(v._cxx_bitor);
  GetChar(v._cxx_bool);
  GetBoolean(v._cxx_break);
  GetOctet(v._cxx_catch);
  GetFloat(v._cxx_class);
  GetDouble(v._cxx_compl);
  GetLong(v._cxx_const_cast);
  GetULong(v._cxx_continue);
  GetShort(v._cxx_delete);
  GetUShort(v._cxx_do);
  GetChar(v._cxx_dynamic_cast);
  GetBoolean(v._cxx_else);
  GetOctet(v._cxx_explicit);
  GetFloat(v._cxx_extern);
  GetLong(v._cxx_for);
  GetULong(v._cxx_friend);
  GetShort(v._cxx_goto);
  GetUShort(v._cxx_if);
  GetOctet(v._cxx_int);
  GetBoolean(v._cxx_mutable);
  GetFloat(v._cxx_namespace);
  GetDouble(v._cxx_new);
  GetLong(v._cxx_not);
  GetULong(v._cxx_not_eq);
  GetShort(v._cxx_operator);
  GetUShort(v._cxx_or);
  GetChar(v._cxx_or_eq);
  GetBoolean(v._cxx_protected);
  GetDouble(v._cxx_register);
  GetLong(v._cxx_reinterpret_cast);
  GetULong(v._cxx_return);
  GetShort(v._cxx_signed);
  GetUShort(v._cxx_sizeof);
  GetChar(v._cxx_static);
  GetOctet(v._cxx_static_cast);
  GetBoolean(v._cxx_template);
  GetFloat(v._cxx_this);
  GetDouble(v._cxx_throw);
  GetShort(v._cxx_typeid);
  GetUShort(v._cxx_typename);
  GetChar(v._cxx_using);
  GetOctet(v._cxx_virtual);
  GetBoolean(v._cxx_volatile);
  GetFloat(v._cxx_wchar_t);
  GetDouble(v._cxx_while);
  GetLong(v._cxx_xor);
  GetULong(v._cxx_xor_eq);
}

int CheckAvocado(const ::Avocado &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAvocado");
#endif

  AddName("and");
  if (!CheckFloat(v._cxx_and))
    iRetCode = 0;
  RemoveName();
  AddName("and_eq");
  if (!CheckDouble(v._cxx_and_eq))
    iRetCode = 0;
  RemoveName();
  AddName("auto");
  if (!CheckULong(v._cxx_auto))
    iRetCode = 0;
  RemoveName();
  AddName("bitand");
  if (!CheckShort(v._cxx_bitand))
    iRetCode = 0;
  RemoveName();
  AddName("bitor");
  if (!CheckUShort(v._cxx_bitor))
    iRetCode = 0;
  RemoveName();
  AddName("bool");
  if (!CheckChar(v._cxx_bool))
    iRetCode = 0;
  RemoveName();
  AddName("break");
  if (!CheckBoolean(v._cxx_break))
    iRetCode = 0;
  RemoveName();
  AddName("catch");
  if (!CheckOctet(v._cxx_catch))
    iRetCode = 0;
  RemoveName();
  AddName("class");
  if (!CheckFloat(v._cxx_class))
    iRetCode = 0;
  RemoveName();
  AddName("compl");
  if (!CheckDouble(v._cxx_compl))
    iRetCode = 0;
  RemoveName();
  AddName("const_cast");
  if (!CheckLong(v._cxx_const_cast))
    iRetCode = 0;
  RemoveName();
  AddName("continue");
  if (!CheckULong(v._cxx_continue))
    iRetCode = 0;
  RemoveName();
  AddName("delete");
  if (!CheckShort(v._cxx_delete))
    iRetCode = 0;
  RemoveName();
  AddName("do");
  if (!CheckUShort(v._cxx_do))
    iRetCode = 0;
  RemoveName();
  AddName("dynamic_cast");
  if (!CheckChar(v._cxx_dynamic_cast))
    iRetCode = 0;
  RemoveName();
  AddName("else");
  if (!CheckBoolean(v._cxx_else))
    iRetCode = 0;
  RemoveName();
  AddName("explicit");
  if (!CheckOctet(v._cxx_explicit))
    iRetCode = 0;
  RemoveName();
  AddName("extern");
  if (!CheckFloat(v._cxx_extern))
    iRetCode = 0;
  RemoveName();
  AddName("for");
  if (!CheckLong(v._cxx_for))
    iRetCode = 0;
  RemoveName();
  AddName("friend");
  if (!CheckULong(v._cxx_friend))
    iRetCode = 0;
  RemoveName();
  AddName("goto");
  if (!CheckShort(v._cxx_goto))
    iRetCode = 0;
  RemoveName();
  AddName("if");
  if (!CheckUShort(v._cxx_if))
    iRetCode = 0;
  RemoveName();
  AddName("int");
  if (!CheckOctet(v._cxx_int))
    iRetCode = 0;
  RemoveName();
  AddName("mutable");
  if (!CheckBoolean(v._cxx_mutable))
    iRetCode = 0;
  RemoveName();
  AddName("namespace");
  if (!CheckFloat(v._cxx_namespace))
    iRetCode = 0;
  RemoveName();
  AddName("new");
  if (!CheckDouble(v._cxx_new))
    iRetCode = 0;
  RemoveName();
  AddName("not");
  if (!CheckLong(v._cxx_not))
    iRetCode = 0;
  RemoveName();
  AddName("not_eq");
  if (!CheckULong(v._cxx_not_eq))
    iRetCode = 0;
  RemoveName();
  AddName("operator");
  if (!CheckShort(v._cxx_operator))
    iRetCode = 0;
  RemoveName();
  AddName("or");
  if (!CheckUShort(v._cxx_or))
    iRetCode = 0;
  RemoveName();
  AddName("or_eq");
  if (!CheckChar(v._cxx_or_eq))
    iRetCode = 0;
  RemoveName();
  AddName("protected");
  if (!CheckBoolean(v._cxx_protected))
    iRetCode = 0;
  RemoveName();
  AddName("register");
  if (!CheckDouble(v._cxx_register))
    iRetCode = 0;
  RemoveName();
  AddName("reinterpret_cast");
  if (!CheckLong(v._cxx_reinterpret_cast))
    iRetCode = 0;
  RemoveName();
  AddName("return");
  if (!CheckULong(v._cxx_return))
    iRetCode = 0;
  RemoveName();
  AddName("signed");
  if (!CheckShort(v._cxx_signed))
    iRetCode = 0;
  RemoveName();
  AddName("sizeof");
  if (!CheckUShort(v._cxx_sizeof))
    iRetCode = 0;
  RemoveName();
  AddName("static");
  if (!CheckChar(v._cxx_static))
    iRetCode = 0;
  RemoveName();
  AddName("static_cast");
  if (!CheckOctet(v._cxx_static_cast))
    iRetCode = 0;
  RemoveName();
  AddName("template");
  if (!CheckBoolean(v._cxx_template))
    iRetCode = 0;
  RemoveName();
  AddName("this");
  if (!CheckFloat(v._cxx_this))
    iRetCode = 0;
  RemoveName();
  AddName("throw");
  if (!CheckDouble(v._cxx_throw))
    iRetCode = 0;
  RemoveName();
  AddName("typeid");
  if (!CheckShort(v._cxx_typeid))
    iRetCode = 0;
  RemoveName();
  AddName("typename");
  if (!CheckUShort(v._cxx_typename))
    iRetCode = 0;
  RemoveName();
  AddName("using");
  if (!CheckChar(v._cxx_using))
    iRetCode = 0;
  RemoveName();
  AddName("virtual");
  if (!CheckOctet(v._cxx_virtual))
    iRetCode = 0;
  RemoveName();
  AddName("volatile");
  if (!CheckBoolean(v._cxx_volatile))
    iRetCode = 0;
  RemoveName();
  AddName("wchar_t");
  if (!CheckFloat(v._cxx_wchar_t))
    iRetCode = 0;
  RemoveName();
  AddName("while");
  if (!CheckDouble(v._cxx_while))
    iRetCode = 0;
  RemoveName();
  AddName("xor");
  if (!CheckLong(v._cxx_xor))
    iRetCode = 0;
  RemoveName();
  AddName("xor_eq");
  if (!CheckULong(v._cxx_xor_eq))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerAvocadoExcpt(::idlServer::AvocadoExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerAvocadoExcpt");
#endif

  GetAvocado(v.ex1);
}

int CheckidlServerAvocadoExcpt(const ::idlServer::AvocadoExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerAvocadoExcpt");
#endif

  AddName("ex1");
  if (!CheckAvocado(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



