//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/client.cpp
//
// Modifications:
// $Log: client.cpp,v $
// Revision 1.2  2000/03/28 18:40:35  mli
//   o   remove 'CORBA::Environment ev;'
//   o   int initialise
//
// Revision 1.1.1.1  2000/02/09 17:15:47  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.4  1997/12/09 11:25:03  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern OrbSupport *orb;
extern char *stringifiedIOR;

static int initialised = 0;
CORBA::Object_ptr obj;
idlServer_ptr  tobj;

void
initialise()
{
    if (!initialised)
    {


#ifdef DEBUG
	  ::tet_infoline("client: connecting to proxy");
	  ::tet_printf("client: using %s", stringifiedIOR);
#endif
	  
	  try {
	      obj = orb->getObject(stringifiedIOR);
	  }
	  catch (CORBA::SystemException &ex) {
	      ::tet_infoline("client: getObj failed");
	      ::tet_printf("client: minor code %d", ex.minor());
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  if (obj == 0)
	  {
	      ::tet_infoline("client: failed connecting to proxy");
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  try {
	      tobj = idlServer::_narrow(obj);
	  }
	  catch (CORBA::Exception &ex) {
	      ::tet_infoline("client: failed to narrow object reference.");
	  }
	  initialised = 1;

	  char * tout = 0;
	  tout = getenv("VSORB_EVENT_TIMEOUT");

	  unsigned long timeout = (tout) ? atoi(tout) : 15;
	  orb->setTimeout(tobj, timeout);
      }
    
}

#ifdef VSORB_IDL_TESTS

void testIDL()
{
  char buf1[1024];

  if (::Apple != (CORBA::Char)97)
  {
    ::tet_infoline("The constant ::Apple has incorrect value");
    strcpy(buf1,CharToString((unsigned char)97));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Apple));
    ::tet_result(TET_FAIL);
  }
  if (::Lemon != (CORBA::Char)98)
  {
    ::tet_infoline("The constant ::Lemon has incorrect value");
    strcpy(buf1,CharToString((unsigned char)98));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Lemon));
    ::tet_result(TET_FAIL);
  }
  if (::BlackCherry != (CORBA::Char)99)
  {
    ::tet_infoline("The constant ::BlackCherry has incorrect value");
    strcpy(buf1,CharToString((unsigned char)99));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::BlackCherry));
    ::tet_result(TET_FAIL);
  }
  if (::Lychees != (CORBA::Char)100)
  {
    ::tet_infoline("The constant ::Lychees has incorrect value");
    strcpy(buf1,CharToString((unsigned char)100));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Lychees));
    ::tet_result(TET_FAIL);
  }
  if (::LoganBerry != (CORBA::Char)101)
  {
    ::tet_infoline("The constant ::LoganBerry has incorrect value");
    strcpy(buf1,CharToString((unsigned char)101));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::LoganBerry));
    ::tet_result(TET_FAIL);
  }
  if (::Parsnip != (CORBA::Char)102)
  {
    ::tet_infoline("The constant ::Parsnip has incorrect value");
    strcpy(buf1,CharToString((unsigned char)102));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Parsnip));
    ::tet_result(TET_FAIL);
  }
  if (::Celery != (CORBA::Char)103)
  {
    ::tet_infoline("The constant ::Celery has incorrect value");
    strcpy(buf1,CharToString((unsigned char)103));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Celery));
    ::tet_result(TET_FAIL);
  }
  if (::WhiteCabbage != (CORBA::Char)104)
  {
    ::tet_infoline("The constant ::WhiteCabbage has incorrect value");
    strcpy(buf1,CharToString((unsigned char)104));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::WhiteCabbage));
    ::tet_result(TET_FAIL);
  }
  if (::Aniseed != (CORBA::Char)105)
  {
    ::tet_infoline("The constant ::Aniseed has incorrect value");
    strcpy(buf1,CharToString((unsigned char)105));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Aniseed));
    ::tet_result(TET_FAIL);
  }
  if (::Bayleaf != (CORBA::Char)106)
  {
    ::tet_infoline("The constant ::Bayleaf has incorrect value");
    strcpy(buf1,CharToString((unsigned char)106));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Bayleaf));
    ::tet_result(TET_FAIL);
  }
  if (::Dill != (CORBA::Char)107)
  {
    ::tet_infoline("The constant ::Dill has incorrect value");
    strcpy(buf1,CharToString((unsigned char)107));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Dill));
    ::tet_result(TET_FAIL);
  }
  if (::Oregano != (CORBA::Char)108)
  {
    ::tet_infoline("The constant ::Oregano has incorrect value");
    strcpy(buf1,CharToString((unsigned char)108));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Oregano));
    ::tet_result(TET_FAIL);
  }
  if (::Beansprout != (CORBA::Char)109)
  {
    ::tet_infoline("The constant ::Beansprout has incorrect value");
    strcpy(buf1,CharToString((unsigned char)109));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Beansprout));
    ::tet_result(TET_FAIL);
  }
  if (::Almonds != (CORBA::Char)110)
  {
    ::tet_infoline("The constant ::Almonds has incorrect value");
    strcpy(buf1,CharToString((unsigned char)110));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Almonds));
    ::tet_result(TET_FAIL);
  }
  if (::Guava != (CORBA::Char)111)
  {
    ::tet_infoline("The constant ::Guava has incorrect value");
    strcpy(buf1,CharToString((unsigned char)111));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Guava));
    ::tet_result(TET_FAIL);
  }
  if (::Mushroom != (CORBA::Char)112)
  {
    ::tet_infoline("The constant ::Mushroom has incorrect value");
    strcpy(buf1,CharToString((unsigned char)112));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Mushroom));
    ::tet_result(TET_FAIL);
  }
  if (::Runnerbean != (CORBA::Char)113)
  {
    ::tet_infoline("The constant ::Runnerbean has incorrect value");
    strcpy(buf1,CharToString((unsigned char)113));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Runnerbean));
    ::tet_result(TET_FAIL);
  }
  if (::Tofu != (CORBA::Char)114)
  {
    ::tet_infoline("The constant ::Tofu has incorrect value");
    strcpy(buf1,CharToString((unsigned char)114));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Tofu));
    ::tet_result(TET_FAIL);
  }
  if (::Prunes != (CORBA::Char)115)
  {
    ::tet_infoline("The constant ::Prunes has incorrect value");
    strcpy(buf1,CharToString((unsigned char)115));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Prunes));
    ::tet_result(TET_FAIL);
  }
  if (::Brocoli != (CORBA::Char)116)
  {
    ::tet_infoline("The constant ::Brocoli has incorrect value");
    strcpy(buf1,CharToString((unsigned char)116));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Brocoli));
    ::tet_result(TET_FAIL);
  }
  if (::GrannySmith != (CORBA::Char)117)
  {
    ::tet_infoline("The constant ::GrannySmith has incorrect value");
    strcpy(buf1,CharToString((unsigned char)117));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::GrannySmith));
    ::tet_result(TET_FAIL);
  }
  if (::BrazilNut != (CORBA::Char)118)
  {
    ::tet_infoline("The constant ::BrazilNut has incorrect value");
    strcpy(buf1,CharToString((unsigned char)118));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::BrazilNut));
    ::tet_result(TET_FAIL);
  }
  if (::SweetPotato != (CORBA::Char)119)
  {
    ::tet_infoline("The constant ::SweetPotato has incorrect value");
    strcpy(buf1,CharToString((unsigned char)119));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::SweetPotato));
    ::tet_result(TET_FAIL);
  }
  if (::Tangarine != (CORBA::Char)120)
  {
    ::tet_infoline("The constant ::Tangarine has incorrect value");
    strcpy(buf1,CharToString((unsigned char)120));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Tangarine));
    ::tet_result(TET_FAIL);
  }
  if (::Billberries != (CORBA::Char)121)
  {
    ::tet_infoline("The constant ::Billberries has incorrect value");
    strcpy(buf1,CharToString((unsigned char)121));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Billberries));
    ::tet_result(TET_FAIL);
  }
  if (::CantelopeMelon != (CORBA::Char)122)
  {
    ::tet_infoline("The constant ::CantelopeMelon has incorrect value");
    strcpy(buf1,CharToString((unsigned char)122));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::CantelopeMelon));
    ::tet_result(TET_FAIL);
  }
  if (::LolloRossa != (CORBA::Char)65)
  {
    ::tet_infoline("The constant ::LolloRossa has incorrect value");
    strcpy(buf1,CharToString((unsigned char)65));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::LolloRossa));
    ::tet_result(TET_FAIL);
  }
  if (::RowanBerry != (CORBA::Char)66)
  {
    ::tet_infoline("The constant ::RowanBerry has incorrect value");
    strcpy(buf1,CharToString((unsigned char)66));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::RowanBerry));
    ::tet_result(TET_FAIL);
  }
  if (::Sweetcorn != (CORBA::Char)67)
  {
    ::tet_infoline("The constant ::Sweetcorn has incorrect value");
    strcpy(buf1,CharToString((unsigned char)67));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Sweetcorn));
    ::tet_result(TET_FAIL);
  }
  if (::Onion != (CORBA::Char)68)
  {
    ::tet_infoline("The constant ::Onion has incorrect value");
    strcpy(buf1,CharToString((unsigned char)68));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Onion));
    ::tet_result(TET_FAIL);
  }
  if (::Shallots != (CORBA::Char)69)
  {
    ::tet_infoline("The constant ::Shallots has incorrect value");
    strcpy(buf1,CharToString((unsigned char)69));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Shallots));
    ::tet_result(TET_FAIL);
  }
  if (::Plum != (CORBA::Char)70)
  {
    ::tet_infoline("The constant ::Plum has incorrect value");
    strcpy(buf1,CharToString((unsigned char)70));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Plum));
    ::tet_result(TET_FAIL);
  }
  if (::KidneyBean != (CORBA::Char)71)
  {
    ::tet_infoline("The constant ::KidneyBean has incorrect value");
    strcpy(buf1,CharToString((unsigned char)71));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::KidneyBean));
    ::tet_result(TET_FAIL);
  }
  if (::Zucchini != (CORBA::Char)72)
  {
    ::tet_infoline("The constant ::Zucchini has incorrect value");
    strcpy(buf1,CharToString((unsigned char)72));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Zucchini));
    ::tet_result(TET_FAIL);
  }
  if (::ButterBean != (CORBA::Char)73)
  {
    ::tet_infoline("The constant ::ButterBean has incorrect value");
    strcpy(buf1,CharToString((unsigned char)73));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::ButterBean));
    ::tet_result(TET_FAIL);
  }
  if (::Avocado != (CORBA::Char)74)
  {
    ::tet_infoline("The constant ::Avocado has incorrect value");
    strcpy(buf1,CharToString((unsigned char)74));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Avocado));
    ::tet_result(TET_FAIL);
  }
  if (::GoldenDelicous != (CORBA::Char)75)
  {
    ::tet_infoline("The constant ::GoldenDelicous has incorrect value");
    strcpy(buf1,CharToString((unsigned char)75));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::GoldenDelicous));
    ::tet_result(TET_FAIL);
  }
  if (::Lentil != (CORBA::Char)76)
  {
    ::tet_infoline("The constant ::Lentil has incorrect value");
    strcpy(buf1,CharToString((unsigned char)76));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Lentil));
    ::tet_result(TET_FAIL);
  }
  if (::Fig != (CORBA::Char)77)
  {
    ::tet_infoline("The constant ::Fig has incorrect value");
    strcpy(buf1,CharToString((unsigned char)77));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Fig));
    ::tet_result(TET_FAIL);
  }
  if (::CrabApple != (CORBA::Char)78)
  {
    ::tet_infoline("The constant ::CrabApple has incorrect value");
    strcpy(buf1,CharToString((unsigned char)78));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::CrabApple));
    ::tet_result(TET_FAIL);
  }
  if (::RedOnion != (CORBA::Char)79)
  {
    ::tet_infoline("The constant ::RedOnion has incorrect value");
    strcpy(buf1,CharToString((unsigned char)79));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::RedOnion));
    ::tet_result(TET_FAIL);
  }
  if (::HazelNut != (CORBA::Char)80)
  {
    ::tet_infoline("The constant ::HazelNut has incorrect value");
    strcpy(buf1,CharToString((unsigned char)80));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::HazelNut));
    ::tet_result(TET_FAIL);
  }
  if (::Cinnamon != (CORBA::Char)81)
  {
    ::tet_infoline("The constant ::Cinnamon has incorrect value");
    strcpy(buf1,CharToString((unsigned char)81));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Cinnamon));
    ::tet_result(TET_FAIL);
  }
  if (::GooseBerry != (CORBA::Char)82)
  {
    ::tet_infoline("The constant ::GooseBerry has incorrect value");
    strcpy(buf1,CharToString((unsigned char)82));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::GooseBerry));
    ::tet_result(TET_FAIL);
  }
  if (::EggPlant != (CORBA::Char)83)
  {
    ::tet_infoline("The constant ::EggPlant has incorrect value");
    strcpy(buf1,CharToString((unsigned char)83));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::EggPlant));
    ::tet_result(TET_FAIL);
  }
  if (::JuniperBerries != (CORBA::Char)84)
  {
    ::tet_infoline("The constant ::JuniperBerries has incorrect value");
    strcpy(buf1,CharToString((unsigned char)84));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::JuniperBerries));
    ::tet_result(TET_FAIL);
  }
  if (::Cloves != (CORBA::Char)85)
  {
    ::tet_infoline("The constant ::Cloves has incorrect value");
    strcpy(buf1,CharToString((unsigned char)85));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Cloves));
    ::tet_result(TET_FAIL);
  }
  if (::Daikan != (CORBA::Char)86)
  {
    ::tet_infoline("The constant ::Daikan has incorrect value");
    strcpy(buf1,CharToString((unsigned char)86));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Daikan));
    ::tet_result(TET_FAIL);
  }
  if (::Mustard != (CORBA::Char)87)
  {
    ::tet_infoline("The constant ::Mustard has incorrect value");
    strcpy(buf1,CharToString((unsigned char)87));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Mustard));
    ::tet_result(TET_FAIL);
  }
  if (::Strawberry != (CORBA::Char)88)
  {
    ::tet_infoline("The constant ::Strawberry has incorrect value");
    strcpy(buf1,CharToString((unsigned char)88));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Strawberry));
    ::tet_result(TET_FAIL);
  }
  if (::BreadFruit != (CORBA::Char)89)
  {
    ::tet_infoline("The constant ::BreadFruit has incorrect value");
    strcpy(buf1,CharToString((unsigned char)89));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::BreadFruit));
    ::tet_result(TET_FAIL);
  }
  if (::Thyme != (CORBA::Char)90)
  {
    ::tet_infoline("The constant ::Thyme has incorrect value");
    strcpy(buf1,CharToString((unsigned char)90));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Thyme));
    ::tet_result(TET_FAIL);
  }
  if (::Sweedes != (CORBA::Char)48)
  {
    ::tet_infoline("The constant ::Sweedes has incorrect value");
    strcpy(buf1,CharToString((unsigned char)48));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Sweedes));
    ::tet_result(TET_FAIL);
  }
  if (::Pomegranate != (CORBA::Char)49)
  {
    ::tet_infoline("The constant ::Pomegranate has incorrect value");
    strcpy(buf1,CharToString((unsigned char)49));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Pomegranate));
    ::tet_result(TET_FAIL);
  }
  if (::Tarragon != (CORBA::Char)50)
  {
    ::tet_infoline("The constant ::Tarragon has incorrect value");
    strcpy(buf1,CharToString((unsigned char)50));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Tarragon));
    ::tet_result(TET_FAIL);
  }
  if (::Lettuce != (CORBA::Char)51)
  {
    ::tet_infoline("The constant ::Lettuce has incorrect value");
    strcpy(buf1,CharToString((unsigned char)51));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Lettuce));
    ::tet_result(TET_FAIL);
  }
  if (::Mangetout != (CORBA::Char)52)
  {
    ::tet_infoline("The constant ::Mangetout has incorrect value");
    strcpy(buf1,CharToString((unsigned char)52));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Mangetout));
    ::tet_result(TET_FAIL);
  }
  if (::Cress != (CORBA::Char)53)
  {
    ::tet_infoline("The constant ::Cress has incorrect value");
    strcpy(buf1,CharToString((unsigned char)53));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Cress));
    ::tet_result(TET_FAIL);
  }
  if (::BambooShoot != (CORBA::Char)54)
  {
    ::tet_infoline("The constant ::BambooShoot has incorrect value");
    strcpy(buf1,CharToString((unsigned char)54));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::BambooShoot));
    ::tet_result(TET_FAIL);
  }
  if (::Cassava != (CORBA::Char)55)
  {
    ::tet_infoline("The constant ::Cassava has incorrect value");
    strcpy(buf1,CharToString((unsigned char)55));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Cassava));
    ::tet_result(TET_FAIL);
  }
  if (::Melon != (CORBA::Char)56)
  {
    ::tet_infoline("The constant ::Melon has incorrect value");
    strcpy(buf1,CharToString((unsigned char)56));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Melon));
    ::tet_result(TET_FAIL);
  }
  if (::RedGrapes != (CORBA::Char)57)
  {
    ::tet_infoline("The constant ::RedGrapes has incorrect value");
    strcpy(buf1,CharToString((unsigned char)57));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::RedGrapes));
    ::tet_result(TET_FAIL);
  }
  if (::BeechNut != (CORBA::Char)32)
  {
    ::tet_infoline("The constant ::BeechNut has incorrect value");
    strcpy(buf1,CharToString((unsigned char)32));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::BeechNut));
    ::tet_result(TET_FAIL);
  }
  if (::Elderberry != (CORBA::Char)33)
  {
    ::tet_infoline("The constant ::Elderberry has incorrect value");
    strcpy(buf1,CharToString((unsigned char)33));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Elderberry));
    ::tet_result(TET_FAIL);
  }
  if (::Kumquats != (CORBA::Char)35)
  {
    ::tet_infoline("The constant ::Kumquats has incorrect value");
    strcpy(buf1,CharToString((unsigned char)35));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Kumquats));
    ::tet_result(TET_FAIL);
  }
  if (::Walnuts != (CORBA::Char)36)
  {
    ::tet_infoline("The constant ::Walnuts has incorrect value");
    strcpy(buf1,CharToString((unsigned char)36));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Walnuts));
    ::tet_result(TET_FAIL);
  }
  if (::Fennell != (CORBA::Char)37)
  {
    ::tet_infoline("The constant ::Fennell has incorrect value");
    strcpy(buf1,CharToString((unsigned char)37));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Fennell));
    ::tet_result(TET_FAIL);
  }
  if (::Uglifruit != (CORBA::Char)38)
  {
    ::tet_infoline("The constant ::Uglifruit has incorrect value");
    strcpy(buf1,CharToString((unsigned char)38));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Uglifruit));
    ::tet_result(TET_FAIL);
  }
  if (::Waterchestnut != (CORBA::Char)40)
  {
    ::tet_infoline("The constant ::Waterchestnut has incorrect value");
    strcpy(buf1,CharToString((unsigned char)40));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Waterchestnut));
    ::tet_result(TET_FAIL);
  }
  if (::Chickpea != (CORBA::Char)41)
  {
    ::tet_infoline("The constant ::Chickpea has incorrect value");
    strcpy(buf1,CharToString((unsigned char)41));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Chickpea));
    ::tet_result(TET_FAIL);
  }
  if (::Beetroot != (CORBA::Char)42)
  {
    ::tet_infoline("The constant ::Beetroot has incorrect value");
    strcpy(buf1,CharToString((unsigned char)42));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Beetroot));
    ::tet_result(TET_FAIL);
  }
  if (::Okra != (CORBA::Char)43)
  {
    ::tet_infoline("The constant ::Okra has incorrect value");
    strcpy(buf1,CharToString((unsigned char)43));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Okra));
    ::tet_result(TET_FAIL);
  }
  if (::Plantain != (CORBA::Char)44)
  {
    ::tet_infoline("The constant ::Plantain has incorrect value");
    strcpy(buf1,CharToString((unsigned char)44));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Plantain));
    ::tet_result(TET_FAIL);
  }
  if (::Blackcurrant != (CORBA::Char)45)
  {
    ::tet_infoline("The constant ::Blackcurrant has incorrect value");
    strcpy(buf1,CharToString((unsigned char)45));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Blackcurrant));
    ::tet_result(TET_FAIL);
  }
  if (::Pineapple != (CORBA::Char)46)
  {
    ::tet_infoline("The constant ::Pineapple has incorrect value");
    strcpy(buf1,CharToString((unsigned char)46));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Pineapple));
    ::tet_result(TET_FAIL);
  }
  if (::LimaBean != (CORBA::Char)47)
  {
    ::tet_infoline("The constant ::LimaBean has incorrect value");
    strcpy(buf1,CharToString((unsigned char)47));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::LimaBean));
    ::tet_result(TET_FAIL);
  }
  if (::Mangosteen != (CORBA::Char)58)
  {
    ::tet_infoline("The constant ::Mangosteen has incorrect value");
    strcpy(buf1,CharToString((unsigned char)58));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Mangosteen));
    ::tet_result(TET_FAIL);
  }
  if (::Pear != (CORBA::Char)59)
  {
    ::tet_infoline("The constant ::Pear has incorrect value");
    strcpy(buf1,CharToString((unsigned char)59));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Pear));
    ::tet_result(TET_FAIL);
  }
  if (::RedPepper != (CORBA::Char)60)
  {
    ::tet_infoline("The constant ::RedPepper has incorrect value");
    strcpy(buf1,CharToString((unsigned char)60));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::RedPepper));
    ::tet_result(TET_FAIL);
  }
  if (::BeefTomatoes != (CORBA::Char)61)
  {
    ::tet_infoline("The constant ::BeefTomatoes has incorrect value");
    strcpy(buf1,CharToString((unsigned char)61));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::BeefTomatoes));
    ::tet_result(TET_FAIL);
  }
  if (::FrenchBeans != (CORBA::Char)62)
  {
    ::tet_infoline("The constant ::FrenchBeans has incorrect value");
    strcpy(buf1,CharToString((unsigned char)62));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::FrenchBeans));
    ::tet_result(TET_FAIL);
  }
  if (::Sharanfruit != (CORBA::Char)64)
  {
    ::tet_infoline("The constant ::Sharanfruit has incorrect value");
    strcpy(buf1,CharToString((unsigned char)64));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Sharanfruit));
    ::tet_result(TET_FAIL);
  }
  if (::Radish != (CORBA::Char)91)
  {
    ::tet_infoline("The constant ::Radish has incorrect value");
    strcpy(buf1,CharToString((unsigned char)91));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Radish));
    ::tet_result(TET_FAIL);
  }
  if (::Cherry != (CORBA::Char)93)
  {
    ::tet_infoline("The constant ::Cherry has incorrect value");
    strcpy(buf1,CharToString((unsigned char)93));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Cherry));
    ::tet_result(TET_FAIL);
  }
  if (::Papaya != (CORBA::Char)94)
  {
    ::tet_infoline("The constant ::Papaya has incorrect value");
    strcpy(buf1,CharToString((unsigned char)94));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Papaya));
    ::tet_result(TET_FAIL);
  }
  if (::Peppercorn != (CORBA::Char)95)
  {
    ::tet_infoline("The constant ::Peppercorn has incorrect value");
    strcpy(buf1,CharToString((unsigned char)95));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Peppercorn));
    ::tet_result(TET_FAIL);
  }
  if (::Susander != (CORBA::Char)96)
  {
    ::tet_infoline("The constant ::Susander has incorrect value");
    strcpy(buf1,CharToString((unsigned char)96));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Susander));
    ::tet_result(TET_FAIL);
  }
  if (::Raspberry != (CORBA::Char)123)
  {
    ::tet_infoline("The constant ::Raspberry has incorrect value");
    strcpy(buf1,CharToString((unsigned char)123));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Raspberry));
    ::tet_result(TET_FAIL);
  }
  if (::Grapefruit != (CORBA::Char)124)
  {
    ::tet_infoline("The constant ::Grapefruit has incorrect value");
    strcpy(buf1,CharToString((unsigned char)124));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Grapefruit));
    ::tet_result(TET_FAIL);
  }
  if (::PepinoMelon != (CORBA::Char)125)
  {
    ::tet_infoline("The constant ::PepinoMelon has incorrect value");
    strcpy(buf1,CharToString((unsigned char)125));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::PepinoMelon));
    ::tet_result(TET_FAIL);
  }
  if (::Damsons != (CORBA::Char)126)
  {
    ::tet_infoline("The constant ::Damsons has incorrect value");
    strcpy(buf1,CharToString((unsigned char)126));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Damsons));
    ::tet_result(TET_FAIL);
  }
  if (::Peanutsquash != (CORBA::Char)10)
  {
    ::tet_infoline("The constant ::Peanutsquash has incorrect value");
    strcpy(buf1,CharToString((unsigned char)10));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Peanutsquash));
    ::tet_result(TET_FAIL);
  }
  if (::CherryTomatoes != (CORBA::Char)9)
  {
    ::tet_infoline("The constant ::CherryTomatoes has incorrect value");
    strcpy(buf1,CharToString((unsigned char)9));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::CherryTomatoes));
    ::tet_result(TET_FAIL);
  }
  if (::Artichokes != (CORBA::Char)11)
  {
    ::tet_infoline("The constant ::Artichokes has incorrect value");
    strcpy(buf1,CharToString((unsigned char)11));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Artichokes));
    ::tet_result(TET_FAIL);
  }
  if (::GreenGrapes != (CORBA::Char)8)
  {
    ::tet_infoline("The constant ::GreenGrapes has incorrect value");
    strcpy(buf1,CharToString((unsigned char)8));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::GreenGrapes));
    ::tet_result(TET_FAIL);
  }
  if (::Rasin != (CORBA::Char)13)
  {
    ::tet_infoline("The constant ::Rasin has incorrect value");
    strcpy(buf1,CharToString((unsigned char)13));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Rasin));
    ::tet_result(TET_FAIL);
  }
  if (::CookingApple != (CORBA::Char)12)
  {
    ::tet_infoline("The constant ::CookingApple has incorrect value");
    strcpy(buf1,CharToString((unsigned char)12));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::CookingApple));
    ::tet_result(TET_FAIL);
  }
  if (::Chives != (CORBA::Char)7)
  {
    ::tet_infoline("The constant ::Chives has incorrect value");
    strcpy(buf1,CharToString((unsigned char)7));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Chives));
    ::tet_result(TET_FAIL);
  }
  if (::Mullberry != (CORBA::Char)92)
  {
    ::tet_infoline("The constant ::Mullberry has incorrect value");
    strcpy(buf1,CharToString((unsigned char)92));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Mullberry));
    ::tet_result(TET_FAIL);
  }
  if (::Eddo != (CORBA::Char)63)
  {
    ::tet_infoline("The constant ::Eddo has incorrect value");
    strcpy(buf1,CharToString((unsigned char)63));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Eddo));
    ::tet_result(TET_FAIL);
  }
  if (::Yam != (CORBA::Char)39)
  {
    ::tet_infoline("The constant ::Yam has incorrect value");
    strcpy(buf1,CharToString((unsigned char)39));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Yam));
    ::tet_result(TET_FAIL);
  }
  if (::GreenChilly != (CORBA::Char)34)
  {
    ::tet_infoline("The constant ::GreenChilly has incorrect value");
    strcpy(buf1,CharToString((unsigned char)34));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::GreenChilly));
    ::tet_result(TET_FAIL);
  }
  if (::Corn != (CORBA::Char)0)
  {
    ::tet_infoline("The constant ::Corn has incorrect value");
    strcpy(buf1,CharToString((unsigned char)0));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Corn));
    ::tet_result(TET_FAIL);
  }
  if (::Peach != (CORBA::Char)7)
  {
    ::tet_infoline("The constant ::Peach has incorrect value");
    strcpy(buf1,CharToString((unsigned char)7));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Peach));
    ::tet_result(TET_FAIL);
  }
  if (::Squash != (CORBA::Char)52)
  {
    ::tet_infoline("The constant ::Squash has incorrect value");
    strcpy(buf1,CharToString((unsigned char)52));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Squash));
    ::tet_result(TET_FAIL);
  }
  if (::Parsley != (CORBA::Char)209)
  {
    ::tet_infoline("The constant ::Parsley has incorrect value");
    strcpy(buf1,CharToString((unsigned char)209));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Parsley));
    ::tet_result(TET_FAIL);
  }
  if (::YellowPepper != (CORBA::Char)255)
  {
    ::tet_infoline("The constant ::YellowPepper has incorrect value");
    strcpy(buf1,CharToString((unsigned char)255));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::YellowPepper));
    ::tet_result(TET_FAIL);
  }
  if (::Satsuma != (CORBA::Char)0)
  {
    ::tet_infoline("The constant ::Satsuma has incorrect value");
    strcpy(buf1,CharToString((unsigned char)0));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Satsuma));
    ::tet_result(TET_FAIL);
  }
  if (::Peanuts != (CORBA::Char)10)
  {
    ::tet_infoline("The constant ::Peanuts has incorrect value");
    strcpy(buf1,CharToString((unsigned char)10));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Peanuts));
    ::tet_result(TET_FAIL);
  }
  if (::Basil != (CORBA::Char)14)
  {
    ::tet_infoline("The constant ::Basil has incorrect value");
    strcpy(buf1,CharToString((unsigned char)14));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Basil));
    ::tet_result(TET_FAIL);
  }
  if (::CoxPippin != (CORBA::Char)50)
  {
    ::tet_infoline("The constant ::CoxPippin has incorrect value");
    strcpy(buf1,CharToString((unsigned char)50));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::CoxPippin));
    ::tet_result(TET_FAIL);
  }
  if (::Blueberry != (CORBA::Char)175)
  {
    ::tet_infoline("The constant ::Blueberry has incorrect value");
    strcpy(buf1,CharToString((unsigned char)175));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Blueberry));
    ::tet_result(TET_FAIL);
  }
  if (::Blackberry != (CORBA::Char)255)
  {
    ::tet_infoline("The constant ::Blackberry has incorrect value");
    strcpy(buf1,CharToString((unsigned char)255));
    ::tet_printf("Expected %s, but found %s", buf1,CharToString(::Blackberry));
    ::tet_result(TET_FAIL);
  }
::tet_result(TET_PASS);
}
 
#endif



 
void testidlServerChervil(void)
{
  
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Chervil()");
#endif
  
  ernie.seed("ChervilCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("ChervilReturn");
  try {
     tobj->Chervil();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Chervil");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


