//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/client.cpp
//
// Modifications:
// $Log: client.cpp,v $
// Revision 1.2  2000/03/29 16:53:28  mli
//   o   remove 'CORBA::Environment ev;'
//   o   int initialise
//
// Revision 1.1.1.1  2000/02/09 17:15:48  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.4  1997/12/09 11:25:08  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern OrbSupport *orb;
extern char *stringifiedIOR;

static int initialised = 0;
CORBA::Object_ptr obj;
idlServer_ptr  tobj;

void
initialise()
{
    if (!initialised)
    {

#ifdef DEBUG
	  ::tet_infoline("client: connecting to proxy");
	  ::tet_printf("client: using %s", stringifiedIOR);
#endif
	  
	  try {
	      obj = orb->getObject(stringifiedIOR);
	  }
	  catch (CORBA::SystemException &ex) {
	      ::tet_infoline("client: getObj failed");
	      ::tet_printf("client: minor code %d", ex.minor());
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  if (obj == 0)
	  {
	      ::tet_infoline("client: failed connecting to proxy");
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  try {
	      tobj = idlServer::_narrow(obj);
	  }
	  catch (CORBA::Exception &ex) {
	      ::tet_infoline("client: failed to narrow object reference.");
	  }
	  initialised = 1;

	  char * tout = 0;
	  tout = getenv("VSORB_EVENT_TIMEOUT");

	  unsigned long timeout = (tout) ? atoi(tout) : 15;
	  orb->setTimeout(tobj, timeout);
      }
    
}

#ifdef VSORB_IDL_TESTS

void testIDL()
{
  char buf1[1024];

  if (!CompareFloats(::Apple,0.2))
  {
    ::tet_infoline("The constant ::Apple has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)0.2,(float)::Apple);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Banana,200))
  {
    ::tet_infoline("The constant ::Banana has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)200,(float)::Banana);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Carrots,200))
  {
    ::tet_infoline("The constant ::Carrots has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)200,(float)::Carrots);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Lemon,200))
  {
    ::tet_infoline("The constant ::Lemon has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)200,(float)::Lemon);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::BlackCherry,200))
  {
    ::tet_infoline("The constant ::BlackCherry has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)200,(float)::BlackCherry);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Starfruit,0.0002))
  {
    ::tet_infoline("The constant ::Starfruit has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)0.0002,(float)::Starfruit);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Rhubarb,0.0002))
  {
    ::tet_infoline("The constant ::Rhubarb has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)0.0002,(float)::Rhubarb);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::PassionFruit,1000))
  {
    ::tet_infoline("The constant ::PassionFruit has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)1000,(float)::PassionFruit);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Pumpkin,1000))
  {
    ::tet_infoline("The constant ::Pumpkin has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)1000,(float)::Pumpkin);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Mango,1000))
  {
    ::tet_infoline("The constant ::Mango has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)1000,(float)::Mango);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::WaterMelon,1000))
  {
    ::tet_infoline("The constant ::WaterMelon has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)1000,(float)::WaterMelon);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Lime,0.001))
  {
    ::tet_infoline("The constant ::Lime has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)0.001,(float)::Lime);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Dates,0.001))
  {
    ::tet_infoline("The constant ::Dates has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)0.001,(float)::Dates);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Coconut,1))
  {
    ::tet_infoline("The constant ::Coconut has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)1,(float)::Coconut);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Lychees,1000))
  {
    ::tet_infoline("The constant ::Lychees has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)1000,(float)::Lychees);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Cabbage,1000))
  {
    ::tet_infoline("The constant ::Cabbage has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)1000,(float)::Cabbage);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Cucumber,1000))
  {
    ::tet_infoline("The constant ::Cucumber has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)1000,(float)::Cucumber);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Ginger,1000))
  {
    ::tet_infoline("The constant ::Ginger has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)1000,(float)::Ginger);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Apricots,0.001))
  {
    ::tet_infoline("The constant ::Apricots has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)0.001,(float)::Apricots);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::BlackEyedBeans,0.001))
  {
    ::tet_infoline("The constant ::BlackEyedBeans has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)0.001,(float)::BlackEyedBeans);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Leek,1.2))
  {
    ::tet_infoline("The constant ::Leek has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)1.2,(float)::Leek);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Mint,1200))
  {
    ::tet_infoline("The constant ::Mint has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)1200,(float)::Mint);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::GardenPeas,1200))
  {
    ::tet_infoline("The constant ::GardenPeas has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)1200,(float)::GardenPeas);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Asparagus,1200))
  {
    ::tet_infoline("The constant ::Asparagus has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)1200,(float)::Asparagus);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::GaliaMelon,1200))
  {
    ::tet_infoline("The constant ::GaliaMelon has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)1200,(float)::GaliaMelon);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Sultana,0.0012))
  {
    ::tet_infoline("The constant ::Sultana has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)0.0012,(float)::Sultana);
    ::tet_result(TET_FAIL);
  }
  if (!CompareFloats(::Turnip,0.0012))
  {
    ::tet_infoline("The constant ::Turnip has incorrect value");
    ::tet_printf("Expected %g, but found %g",(float)0.0012,(float)::Turnip);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Orange,0.2))
  {
    ::tet_infoline("The constant ::Orange has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)0.2,(double)::Orange);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::LoganBerry,200))
  {
    ::tet_infoline("The constant ::LoganBerry has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)200,(double)::LoganBerry);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Parsnip,200))
  {
    ::tet_infoline("The constant ::Parsnip has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)200,(double)::Parsnip);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Celery,200))
  {
    ::tet_infoline("The constant ::Celery has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)200,(double)::Celery);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::WhiteCabbage,200))
  {
    ::tet_infoline("The constant ::WhiteCabbage has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)200,(double)::WhiteCabbage);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Aniseed,0.0002))
  {
    ::tet_infoline("The constant ::Aniseed has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)0.0002,(double)::Aniseed);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Bayleaf,0.0002))
  {
    ::tet_infoline("The constant ::Bayleaf has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)0.0002,(double)::Bayleaf);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Dill,1000))
  {
    ::tet_infoline("The constant ::Dill has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)1000,(double)::Dill);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Oregano,1000))
  {
    ::tet_infoline("The constant ::Oregano has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)1000,(double)::Oregano);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Beansprout,1000))
  {
    ::tet_infoline("The constant ::Beansprout has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)1000,(double)::Beansprout);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Almonds,1000))
  {
    ::tet_infoline("The constant ::Almonds has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)1000,(double)::Almonds);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Guava,0.001))
  {
    ::tet_infoline("The constant ::Guava has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)0.001,(double)::Guava);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Mushroom,0.001))
  {
    ::tet_infoline("The constant ::Mushroom has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)0.001,(double)::Mushroom);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Runnerbean,1))
  {
    ::tet_infoline("The constant ::Runnerbean has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)1,(double)::Runnerbean);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Tofu,1000))
  {
    ::tet_infoline("The constant ::Tofu has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)1000,(double)::Tofu);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Prunes,1000))
  {
    ::tet_infoline("The constant ::Prunes has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)1000,(double)::Prunes);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Brocoli,1000))
  {
    ::tet_infoline("The constant ::Brocoli has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)1000,(double)::Brocoli);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::GrannySmith,1000))
  {
    ::tet_infoline("The constant ::GrannySmith has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)1000,(double)::GrannySmith);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::BrazilNut,0.001))
  {
    ::tet_infoline("The constant ::BrazilNut has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)0.001,(double)::BrazilNut);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::SweetPotato,0.001))
  {
    ::tet_infoline("The constant ::SweetPotato has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)0.001,(double)::SweetPotato);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Onion,1.2))
  {
    ::tet_infoline("The constant ::Onion has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)1.2,(double)::Onion);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Tangarine,1200))
  {
    ::tet_infoline("The constant ::Tangarine has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)1200,(double)::Tangarine);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Billberries,1200))
  {
    ::tet_infoline("The constant ::Billberries has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)1200,(double)::Billberries);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::CantelopeMelon,1200))
  {
    ::tet_infoline("The constant ::CantelopeMelon has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)1200,(double)::CantelopeMelon);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::LolloRossa,1200))
  {
    ::tet_infoline("The constant ::LolloRossa has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)1200,(double)::LolloRossa);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::RowanBerry,0.0012))
  {
    ::tet_infoline("The constant ::RowanBerry has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)0.0012,(double)::RowanBerry);
    ::tet_result(TET_FAIL);
  }
  if (!CompareDoubles(::Sweetcorn,0.0012))
  {
    ::tet_infoline("The constant ::Sweetcorn has incorrect value");
    ::tet_printf("Expected %lg, but found %lg",(double)0.0012,(double)::Sweetcorn);
    ::tet_result(TET_FAIL);
  }
::tet_result(TET_PASS);
}
 
#endif



 
void testidlServerPlum(void)
{
  
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Plum()");
#endif
  
  ernie.seed("PlumCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("PlumReturn");
  try {
     tobj->Plum();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Plum");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


