//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/checkany.cpp
//
// Modifications:
// $Log: checkany.cpp,v $
// Revision 1.5  2000/05/09 15:54:28  dow
// *** empty log message ***
//
// Revision 1.4  2000/05/09 12:34:05  dow
// CORBA Any operator>>= should have the second parameter const
//
// Revision 1.3  2000/05/09 12:27:28  dow
// CORBA Any operator>>= should have the second parameter const Any*&
// instead of Any&;
// CORBA Any operator>>= should have the second parameter const T*&
// for more complex types
//
// Revision 1.2  2000/05/09 11:34:08  dow
// CORBA Any operator>>= should have the second parameter const Any*&
// instead of Any&
//
// Revision 1.1.1.1  2000/02/09 17:15:51  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1999/04/26 13:50:00  james
// Changed CORBA::Char* to char*
//
// Revision 1.6  1999/04/21 14:13:55  stephen
// SR# 97: Removed unneeded TypeCode file dependency.
//
// Revision 1.5  1998/08/24 11:45:39  james
// ENV updates
//
// Revision 1.4  1997/12/09 11:25:18  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern char name[];

 
int CheckAny(const CORBA::Any &any)
{
  switch(ernie.getULong()%(12+6))
  {
    case   0: {
                CORBA::ULong  v;
#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::ULong");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::ULong as expected", name);
                  return 0;
                }
                if (!ernie.checkULong(v))
                {
                  tet_printf("Expected %s to contain CORBA::ULong with value %u, but found %u instead.",
                    name,ernie.getULongAgain(),v);
                  return 0;
                }
              }
              break;
    case   1: {
                CORBA::Long  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Long");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Long as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkLong(v))
                {
                  tet_printf("Expected %s to contain CORBA::Long with value %d, but found %d instead.",
                    name,ernie.getLongAgain(),v);
                  return 0;
                }
              }
              break;
    case   2: {
                CORBA::UShort  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::UShort");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::UShort as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkUShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::UShort with value %u, but found %u instead.",
                    name,ernie.getUShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   3: {
                CORBA::Short  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Short");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Short as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::Short with value %d, but found %d instead.",
                    name,ernie.getShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   4: {
                CORBA::Boolean  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Boolean");
#endif
                if (!(any >>= CORBA::Any::to_boolean(v)))
                {
                  tet_printf("%s did not contain a CORBA::Boolean as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkBoolean(v))
                {
                  tet_printf("Expected %s to contain CORBA::Boolean with value %s, but found %s instead.",
                    name,
                    BooleanToString(ernie.getBooleanAgain()),
                    BooleanToString(v));
                  return 0;
                }
              }
              break;
    case   5: {
                CORBA::Octet  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Octet");
#endif
                if (!(any >>= CORBA::Any::to_octet(v)))
                {
                  tet_printf("%s did not contain a CORBA::Octet as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkOctet(v))
                {
                  ::tet_printf("Expected %s to contain CORBA::Octet with value %s, but found %s instead.",
                    name,
                    OctetToString(ernie.getOctetAgain()),
                    OctetToString(v));
                  return 0;
                }
              }
              break;
    case   6: {
                CORBA::Char  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Char");
#endif
                if (!(any >>= CORBA::Any::to_char(v)))
                {
                  tet_printf("%s did not contain a CORBA::Char as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkChar(v))
                {
                  tet_printf("Expected %s to contain CORBA::Char with value %s, but found %s instead.",
                    name,
                    CharToString(ernie.getCharAgain()),
                    CharToString(v));
                  return 0;
                }
              }
              break;
    case   7: {
                CORBA::Float  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Float");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Float as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkFloat(v))
                {
                  tet_printf("Expected %s to contain CORBA::Float with value %g, but found %g instead.",
                    name,
                    ernie.getFloatAgain(),
                    v);
                  return 0;
                }
              }
               break;
    case   8: {
                CORBA::Double  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Double");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Double as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkDouble(v))
                {
                  tet_printf("Expected %s to contain CORBA::Double with value %g, but found %g instead.",
                    name,
                    ernie.getDoubleAgain(),
                    v);
                  return 0;
                }
              }
              break;
    case   9: {
                char *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting char*");
#endif
                if (!(any >>= CORBA::Any::to_string(v,0)))
                {
                  tet_printf("%s did not contain a char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v))
                {
                  tet_printf("Expected %s to contain char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case  10: {
                CORBA::ULong  b;
                char   *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting bounded char*");
#endif
                b = ernie.getULong()%30+1;

                if (!(any >>= CORBA::Any::to_string(v,b)))
                {
                  tet_printf("%s did not contain a bounded char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v,b))
                {
                  tet_printf("Expected %s to contain a bounded char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case   12: {
                CORBA::Any  v;
		const CORBA::Any *ptr = &v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Any");
#endif
                if (!(any >>= ptr))
                {
                  tet_printf("%s did not contain a CORBA::Any as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAny(*ptr))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  13: {
                const ::Apple::BlackCherry *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Apple::BlackCherry\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Apple::BlackCherry as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAppleBlackCherry(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  14: {
                ::Apple::Starfruit v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Apple::Starfruit\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Apple::Starfruit as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAppleStarfruit(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  15: {
                const ::Apple::WaterMelon *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Apple::WaterMelon\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Apple::WaterMelon as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAppleWaterMelon(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  16: {
                ::BlackEyedBeans v;
		const ::BlackEyedBeans *ptr = &v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BlackEyedBeans\n");
#endif
                if (!(any  >>= ptr))
                {
                  tet_printf("%s did not contain a ::BlackEyedBeans as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlackEyedBeans(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  17: {
                ::Dates v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Dates\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Dates as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckDates(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  18: {
                const ::Cabbage *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cabbage\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cabbage as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCabbage(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;

  }
  return 1;
}




