//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/getany.cpp
//
// Modifications:
// $Log: getany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:15:51  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/21 14:13:56  stephen
// SR# 97: Removed unneeded TypeCode file dependency.
//
// Revision 1.5  1998/08/24 11:45:40  james
// ENV updates
//
// Revision 1.4  1997/12/09 11:25:19  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"

//Header files generated by idl compiler
#include "tin.hh"

#include "types.hh"
extern Ernie ernie;


void GetAny(CORBA::Any &any)
{
  switch(ernie.getULong()%(12+6))
  {
    case   0: any <<= ernie.getULong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating ULong");
#endif
              break;
    case   1: any <<= ernie.getLong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Long");
#endif
              break;
    case   2: any <<= ernie.getUShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating UShort");
#endif
              break;
    case   3: any <<= ernie.getShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Short");
#endif
              break;
    case   4: any <<= CORBA::Any::from_boolean(ernie.getBoolean());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Boolean");
#endif
              break;
    case   5: any <<= CORBA::Any::from_octet(ernie.getOctet());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Octet");
#endif
              break;
    case   6: any <<= CORBA::Any::from_char(ernie.getChar());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Char");
#endif
              break;
    case   7: any <<= ernie.getFloat();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Float");
#endif
               break;
    case   8: any <<= ernie.getDouble();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Double");
#endif
              break;
    case   9: any <<= ernie.getString();
#ifdef DEBUG
              ::tet_infoline("GetAny creating String");
#endif
              break;
    case  10: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating BoundedString");
#endif
                CORBA::ULong  b;
                b = ernie.getULong()%30+1;
                any <<= CORBA::Any::from_string(ernie.getString(b),b);
              }
              break;
    case   12: {
                CORBA::Any  _any;  
#ifdef DEBUG
                ::tet_infoline("GetAny creating Any");
#endif
                GetAny(_any);
                any <<= _any;
               }
                break;

    case  13: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Apple::BlackCherry");
#endif
                ::Apple::BlackCherry   v;

                GetAppleBlackCherry(v);

                any  <<= v;
              }
              break;

    case  14: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Apple::Starfruit");
#endif
                ::Apple::Starfruit   v;

                GetAppleStarfruit(v);

                any  <<= v;
              }
              break;

    case  15: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Apple::WaterMelon");
#endif
                ::Apple::WaterMelon   v;

                GetAppleWaterMelon(v);

                any  <<= v;
              }
              break;

    case  16: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BlackEyedBeans");
#endif
                ::BlackEyedBeans   v;

                GetBlackEyedBeans(v);

                any  <<= v;
              }
              break;

    case  17: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Dates");
#endif
                ::Dates   v;

                GetDates(v);

                any  <<= v;
              }
              break;

    case  18: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cabbage");
#endif
                ::Cabbage   v;

                GetCabbage(v);

                any  <<= v;
              }
              break;

  }
}


