//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.3  2001/01/29 16:40:55  arnop
// Some minor fixes.
//
// Revision 1.2  2001/01/25 17:44:51  tet
// const parameter in CheckObject
//
// Revision 1.1.1.1  2000/02/09 17:15:51  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1999/04/26 13:50:01  james
// Changed CORBA::Char* to char*
//
// Revision 1.6  1998/03/27 14:58:07  stephen
// Spurious enum removed.
//
// Revision 1.5  1997/12/15 10:51:36  james
// #ifdefs removed
//
// Revision 1.4  1997/12/09 11:25:19  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(const CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetAppleBlackCherry(::Apple::BlackCherry &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAppleBlackCherry");
#endif

  GetOctet(v.Carrots);
  v.Lemon = Getobject();
}

int CheckAppleBlackCherry(const ::Apple::BlackCherry &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAppleBlackCherry");
#endif

  AddName("Carrots");
  if (!CheckOctet(v.Carrots))
    iRetCode = 0;
  RemoveName();
  AddName("Lemon");
  if (!Checkobject(v.Lemon.in()))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetAppleStarfruit(::Apple::Starfruit &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAppleStarfruit");
#endif

  ::Apple::Starfruit StarfruitArray[4] = {::Apple::Rhubarb,::Apple::PassionFruit,::Apple::Pumpkin,::Apple::Mango};
  v = StarfruitArray[ernie.getULong()%4];
}

int CheckAppleStarfruit(const ::Apple::Starfruit &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAppleStarfruit");
#endif

  ::Apple::Starfruit StarfruitArray[4] = {::Apple::Rhubarb,::Apple::PassionFruit,::Apple::Pumpkin,::Apple::Mango};
  if (v != StarfruitArray[ernie.getULong()%4])
  {
    ::tet_printf("ERROR: %s has incorrect value",name);
    ::tet_printf("Expected %d, but found %d instead", StarfruitArray[ernie.getULongAgain()%4],v);
    iRetCode = 0;
  }
  return iRetCode;
}

 
void GetAppleWaterMelon(::Apple::WaterMelon &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAppleWaterMelon");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetShort(v[i1]);
      RemoveIndex();
    }
  }
}

int CheckAppleWaterMelon(const ::Apple::WaterMelon &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAppleWaterMelon");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckShort(v[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetBlackEyedBeans(::BlackEyedBeans &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBlackEyedBeans");
#endif

  GetAny(v);
}

int CheckBlackEyedBeans(const ::BlackEyedBeans &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBlackEyedBeans");
#endif

  if (!CheckAny(v))
    iRetCode = 0;
  return iRetCode;
}

 
void GetDates(::Dates &v)
{
#ifdef DEBUG
  ::tet_infoline("GetDates");
#endif

  GetULong(v);
}

int CheckDates(const ::Dates &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckDates");
#endif

  if (!CheckULong(v))
    iRetCode = 0;
  return iRetCode;
}

 
void GetCabbage(::Cabbage &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCabbage");
#endif

  {
    int vSelection;
    CORBA::Char vArray[1] = {'a'};
    
    vSelection = ernie.getULong() % 2;
    switch (vSelection) {
      case 0 :
              {
                CORBA::Double _value2;
                
                GetDouble(_value2);
                v. Coconut(_value2);
              }
              break;
      default:
              {
                CORBA::Float _value2;
                
                GetFloat(_value2);
                v. Lychees(_value2);
              }
              break;
    }
    if (vSelection < 1)
      v._d(vArray[vSelection]);
  }
}

int CheckCabbage(const ::Cabbage &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCabbage");
#endif

  {
    int vSelection;
    CORBA::Char vArray[1] = {'a'};
    
    vSelection = ernie.getULong() % 2;
    
    if (vSelection < 1 && v._d() != vArray[vSelection])
    {
      ::tet_printf("ERROR: %s has an incorrect discriminator",name);
      iRetCode = 0;
    }
    switch (vSelection) {
      case 0 :
              AddName("Coconut()");
              if (!CheckDouble(v.Coconut()))
                iRetCode = 0;
              RemoveName();
              break;
      default:
              AddName("Lychees()");
              if (!CheckFloat(v.Lychees()))
                iRetCode = 0;
              RemoveName();
              break;
    }
  }
  return iRetCode;
}

 
void GetidlServerAsparagus(::idlServer::Asparagus &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerAsparagus");
#endif

  GetDates(v.Leek);
}

int CheckidlServerAsparagus(const ::idlServer::Asparagus &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerAsparagus");
#endif

  AddName("Leek");
  if (!CheckDates(v.Leek))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



