//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;
 

char *
idlServer_imp::Mint( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Mint\n");
#endif
  
  ernie.seed("MintCall");
  
  ernie.seed("MintReturn"); 
  
  ReturnValue = GetString();
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Mint\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::GardenPeas(::BlackEyedBeans_out p1,::BlackEyedBeans &p2 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GardenPeas\n");
#endif
  
  ernie.seed("GardenPeasCall");
  AddName("p2");
  if (!CheckBlackEyedBeans(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GardenPeasReturn"); 
  {
    ::idlServer::Asparagus ex;
    GetidlServerAsparagus(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  p1  = new ::BlackEyedBeans;
  GetBlackEyedBeans(*(p1.ptr()));
  GetBlackEyedBeans(p2);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GardenPeas\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
idlServer_imp::Banana(const ::BlackEyedBeans &p1,CORBA::Context_ptr ctx VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  CORBA::NVList_ptr ctxNVList;
  CORBA::NamedValue_ptr ctxNamedValue;
  CORBA::Any *ctxAny;
  const char *ctxString;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Banana\n");
#endif
  
  ernie.seed("BananaCall");
  AddName("p1");
  if (!CheckBlackEyedBeans(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ctx->get_values(0,CORBA::CTX_RESTRICT_SCOPE,"Orange",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Orange");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Orange");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  
  ernie.seed("BananaReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Banana\n");
#endif
  ::tet_result(TET_PASS);
  
  
}



