//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;
 


::Apple
idlServer_imp::GardenPeas(::Apple p1,::BlackCherry &p2,::idlServer::Dates &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Apple ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GardenPeas\n");
#endif
  
  ernie.seed("GardenPeasCall");
  AddName("p1");
  if (!CheckApple(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckidlServerDates(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GardenPeasReturn"); 
  
  GetApple(ReturnValue);
  GetBlackCherry(p2);
  GetidlServerDates(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GardenPeas\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



