//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


void
idlServer_imp::PassionFruit(::Apple p1,::Banana p2,::Carrots p3,::Lemon p4,::BlackCherry p5,::Starfruit p6,::Rhubarb p7 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PassionFruit\n");
#endif
  
  ernie.seed("PassionFruitCall");
  AddName("p1");
  if (!CheckApple(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckBanana(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCarrots(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p4");
  if (!CheckLemon(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p5");
  if (!CheckBlackCherry(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p6");
  if (!CheckStarfruit(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p7");
  if (!CheckRhubarb(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PassionFruitReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PassionFruit\n");
#endif
  ::tet_result(TET_PASS);
  
  
}



