//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;
 


void
idlServer_imp::Rhubarb(::Apple::Carrots p1,::Apple::BlackCherry::Carrots &p2,::Apple::BlackCherry::Starfruit &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Rhubarb\n");
#endif
  
  ernie.seed("RhubarbCall");
  AddName("p1");
  if (!CheckAppleCarrots(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAppleBlackCherryStarfruit(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RhubarbReturn"); 
  
  GetAppleBlackCherryCarrots(p2);
  GetAppleBlackCherryStarfruit(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Rhubarb\n");
#endif
  ::tet_result(TET_PASS);
  
  
}



