//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;
 


::Banana_ptr
idlServer_imp::Peanuts( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Banana_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::Apple::Peanuts\n");
#endif
  
  ernie.seed("PeanutsCall");
  
  ernie.seed("PeanutsReturn"); 
  
  ReturnValue = Banana::_narrow(Getobject());
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::Apple::Peanuts\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Peanuts(::Banana_ptr _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::Apple::Peanuts\n");
#endif
  
  ernie.seed("PeanutsCall");
  AddName("_attr");
  if (!Checkobject(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PeanutsReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::Apple::Peanuts\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
idlServer_imp::Orange(::Banana_ptr p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::Banana::Orange\n");
#endif
  
  ernie.seed("OrangeCall");
  AddName("p1");
  if (!Checkobject(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("OrangeReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::Banana::Orange\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
idlServer_imp::Basil(::Banana_out p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::Banana::Basil\n");
#endif
  
  ernie.seed("BasilCall");
  
  ernie.seed("BasilReturn"); 
  
  p1 = Banana::_narrow(Getobject());
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::Banana::Basil\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
idlServer_imp::VineTomatoes(::Banana_ptr &p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::Banana::VineTomatoes\n");
#endif
  
  ernie.seed("VineTomatoesCall");
  AddName("p1");
  if (!Checkobject(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("VineTomatoesReturn"); 
  
  p1 = Banana::_narrow(Getobject());
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::Banana::VineTomatoes\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::idlServer_ptr
idlServer_imp::Lemon(const ::Corn &p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::idlServer_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lemon\n");
#endif
  
  ernie.seed("LemonCall");
  AddName("p1");
  if (!CheckCorn(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LemonReturn"); 
  
  ReturnValue = idlServer::_narrow(Getobject());
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lemon\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



