//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;
 


void
idlServer_imp::Lemon(const ::idlServer::Dates &p1,::Banana::Dates &p2 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lemon\n");
#endif
  
  ernie.seed("LemonCall");
  AddName("p1");
  if (!CheckidlServerDates(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckBananaDates(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LemonReturn"); 
  {
    ::idlServer::Orange ex;
    GetidlServerOrange(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetBananaDates(p2);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lemon\n");
#endif
  ::tet_result(TET_PASS);
  
  
}



