//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;
 


void
idlServer_imp::Lemon(const ::idlServer::Melon p1,::Apple::Pumpkin &p2,::Banana::Pumpkin &p3,::Carrots::Pumpkin &p4,::Dates::Pumpkin &p5 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lemon\n");
#endif
  
  ernie.seed("LemonCall");
  AddName("p1");
  if (!CheckidlServerMelon(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckApplePumpkin(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBananaPumpkin(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p4");
  if (!CheckCarrotsPumpkin(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p5");
  if (!CheckDatesPumpkin(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LemonReturn"); 
  {
    ::Carrots::Oregano ex;
    GetCarrotsOregano(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetApplePumpkin(p2);
  GetBananaPumpkin(p3);
  GetCarrotsPumpkin(p4);
  GetDatesPumpkin(p5);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lemon\n");
#endif
  ::tet_result(TET_PASS);
  
  
}



