//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;
 


void
idlServer_imp::Bayleaf( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Bayleaf\n");
#endif
  
  ernie.seed("BayleafCall");
  
  ernie.seed("BayleafReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Bayleaf\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Float
idlServer_imp::BlackCherry(CORBA::Float p1,CORBA::Float_out p2,CORBA::Float &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  CORBA::Float ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BlackCherry\n");
#endif
  
  ernie.seed("BlackCherryCall");
  AddName("p1");
  if (!CheckFloat(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckFloat(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlackCherryReturn"); 
  
  GetFloat(ReturnValue);
  GetFloat(p2);
  GetFloat(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BlackCherry\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Double
idlServer_imp::Starfruit(CORBA::Double p1,CORBA::Double_out p2,CORBA::Double &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  CORBA::Double ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Starfruit\n");
#endif
  
  ernie.seed("StarfruitCall");
  AddName("p1");
  if (!CheckDouble(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckDouble(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("StarfruitReturn"); 
  
  GetDouble(ReturnValue);
  GetDouble(p2);
  GetDouble(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Starfruit\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Long
idlServer_imp::Rhubarb(CORBA::Long p1,CORBA::Long_out p2,CORBA::Long &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  CORBA::Long ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Rhubarb\n");
#endif
  
  ernie.seed("RhubarbCall");
  AddName("p1");
  if (!CheckLong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckLong(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RhubarbReturn"); 
  
  GetLong(ReturnValue);
  GetLong(p2);
  GetLong(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Rhubarb\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Short
idlServer_imp::PassionFruit(CORBA::Short p1,CORBA::Short_out p2,CORBA::Short &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  CORBA::Short ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PassionFruit\n");
#endif
  
  ernie.seed("PassionFruitCall");
  AddName("p1");
  if (!CheckShort(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckShort(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PassionFruitReturn"); 
  
  GetShort(ReturnValue);
  GetShort(p2);
  GetShort(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PassionFruit\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::ULong
idlServer_imp::Pumpkin(CORBA::ULong p1,CORBA::ULong_out p2,CORBA::ULong &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  CORBA::ULong ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Pumpkin\n");
#endif
  
  ernie.seed("PumpkinCall");
  AddName("p1");
  if (!CheckULong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckULong(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PumpkinReturn"); 
  
  GetULong(ReturnValue);
  GetULong(p2);
  GetULong(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Pumpkin\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::UShort
idlServer_imp::Mango(CORBA::UShort p1,CORBA::UShort_out p2,CORBA::UShort &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  CORBA::UShort ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Mango\n");
#endif
  
  ernie.seed("MangoCall");
  AddName("p1");
  if (!CheckUShort(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckUShort(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MangoReturn"); 
  
  GetUShort(ReturnValue);
  GetUShort(p2);
  GetUShort(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Mango\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Char
idlServer_imp::WaterMelon(CORBA::Char p1,CORBA::Char_out p2,CORBA::Char &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  CORBA::Char ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::WaterMelon\n");
#endif
  
  ernie.seed("WaterMelonCall");
  AddName("p1");
  if (!CheckChar(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckChar(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("WaterMelonReturn"); 
  
  GetChar(ReturnValue);
  GetChar(p2);
  GetChar(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::WaterMelon\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Boolean
idlServer_imp::Lime(CORBA::Boolean p1,CORBA::Boolean_out p2,CORBA::Boolean &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  CORBA::Boolean ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lime\n");
#endif
  
  ernie.seed("LimeCall");
  AddName("p1");
  if (!CheckBoolean(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBoolean(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LimeReturn"); 
  
  GetBoolean(ReturnValue);
  GetBoolean(p2);
  GetBoolean(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lime\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Octet
idlServer_imp::Dates(CORBA::Octet p1,CORBA::Octet_out p2,CORBA::Octet &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  CORBA::Octet ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Dates\n");
#endif
  
  ernie.seed("DatesCall");
  AddName("p1");
  if (!CheckOctet(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckOctet(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("DatesReturn"); 
  
  GetOctet(ReturnValue);
  GetOctet(p2);
  GetOctet(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Dates\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Object_ptr
idlServer_imp::Coconut(CORBA::Object_ptr p1,CORBA::Object_out p2,CORBA::Object_ptr &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  CORBA::Object_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Coconut\n");
#endif
  
  ernie.seed("CoconutCall");
  AddName("p1");
  if (!Checkobject(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!Checkobject(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CoconutReturn"); 
  
  ReturnValue = Getobject();
  p2 = Getobject();
  p3 = Getobject();
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Coconut\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
idlServer_imp::Lychees(const char * p1,CORBA::String_out p2,char * &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lychees\n");
#endif
  
  ernie.seed("LycheesCall");
  AddName("p1");
  if (!CheckString(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckString(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LycheesReturn"); 
  
  ReturnValue = GetString();
  p2 = GetString();
  p3 = GetString();
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lychees\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
idlServer_imp::Cabbage(const char * p1,CORBA::String_out p2,char * &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Cabbage\n");
#endif
  
  ernie.seed("CabbageCall");
  AddName("p1");
  if (!CheckString(p1,23))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckString(p3,44))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CabbageReturn"); 
  
  ReturnValue = GetString(20);
  p2 = GetString(38);
  p3 = GetString(44);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Cabbage\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



