//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/checktypecode.cpp
//
// Modifications:
// $Log: checktypecode.cpp,v $
// Revision 1.3  2000/05/24 14:47:27  dow
// introduced scope: CORBA::tc_string
//
// Revision 1.2  2000/05/24 14:29:38  dow
// changed the typecode for bounded strings to tc_string
//
// Revision 1.1.1.1  2000/02/09 17:16:03  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.3  1997/12/09 11:26:06  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"


extern Ernie ernie;
extern char name[];
extern OrbSupport * orb;

 
int CheckCORBATypeCode_ptr(const CORBA::TypeCode_ptr &tc)
{
  switch(ernie.getULong()%(12+9))
  {
    case   0: 
              if (!tc->equal(CORBA::_tc_ulong))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_ulong, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   1: 
              if (!tc->equal(CORBA::_tc_long))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_long, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   2: 
              if (!tc->equal(CORBA::_tc_ushort))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_ushort, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   3: 
              if (!tc->equal(CORBA::_tc_short))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_short, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   4: 
              if (!tc->equal(CORBA::_tc_boolean))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_boolean, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   5: 
              if (!tc->equal(CORBA::_tc_octet))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_octet, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   6: 
              if (!tc->equal(CORBA::_tc_char))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_char, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   7: 
              if (!tc->equal(CORBA::_tc_float))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_float, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
               break;
    case   8: 
              if (!tc->equal(CORBA::_tc_double))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_double, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   9: 
              if (!tc->equal(CORBA::_tc_string))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_string, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  10: 
              if (!tc->equal(orb->orb()->create_string_tc(ernie.getULong()%30+1)))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_string, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   11: 
              if (!tc->equal(CORBA::_tc_TypeCode))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_TypeCode, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   12: 
              if (!tc->equal(CORBA::_tc_any))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_any, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  13: 
              if (!tc->equal(::_tc_Apple))
              {
                 tet_printf("Expected %s to contain ::_tc_Apple, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  14: 
              if (!tc->equal(::_tc_PassionFruit))
              {
                 tet_printf("Expected %s to contain ::_tc_PassionFruit, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  15: 
              if (!tc->equal(::_tc_Banana))
              {
                 tet_printf("Expected %s to contain ::_tc_Banana, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  16: 
              if (!tc->equal(::idlServer::_tc_TypeCode))
              {
                 tet_printf("Expected %s to contain ::idlServer::_tc_TypeCode, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  17: 
              if (!tc->equal(CORBA::_tc_string))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_string, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  18: 
              if (!tc->equal(CORBA::_tc_string))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_string, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  19: 
              if (!tc->equal(CORBA::_tc_string))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_string, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  20: 
              if (!tc->equal(CORBA::_tc_string))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_string, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  21: 
              if (!tc->equal(CORBA::_tc_string))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_string, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;

  }
  return 1;
}




