//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/gettypecode.cpp
//
// Modifications:
// $Log: gettypecode.cpp,v $
// Revision 1.3  2000/05/24 14:49:25  dow
// introduced scope: CORBA::tc_string
//
// Revision 1.2  2000/05/24 14:30:54  dow
// changed the typecode for bounded strings to tc_string
//
// Revision 1.1.1.1  2000/02/09 17:16:04  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.3  1997/12/09 11:26:07  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern OrbSupport * orb;

void GetCORBATypeCode_ptr(CORBA::TypeCode_ptr &tc)
{
  switch(ernie.getULong()%(12+9))
  {
    case   0: tc = CORBA::_tc_ulong;
#ifdef DEBUG
	      ::tet_infoline("GetTypeCode creating ULong\n");
#endif
              break;
    case   1: tc = CORBA::_tc_long;
#ifdef DEBUG
::tet_infoline("GetTypeCode creating Long\n");
#endif
              break;
    case   2: tc = CORBA::_tc_ushort;
#ifdef DEBUG
::tet_infoline("GetTypeCode creating UShort\n");
#endif
              break;
    case   3: tc = CORBA::_tc_short;
#ifdef DEBUG
::tet_infoline("GetTypeCode creating Short\n");
#endif
              break;
    case   4: tc = CORBA::_tc_boolean;
#ifdef DEBUG
::tet_infoline("GetTypeCode creating Boolean\n");
#endif
              break;
    case   5: tc = CORBA::_tc_octet;
#ifdef DEBUG
::tet_infoline("GetTypeCode creating Octet\n");
#endif
              break;
    case   6: tc = CORBA::_tc_char;
#ifdef DEBUG
::tet_infoline("GetTypeCode creating Char\n");
#endif
              break;
    case   7: tc = CORBA::_tc_float;
#ifdef DEBUG
::tet_infoline("GetTypeCode creating Float\n");
#endif
               break;
    case   8: tc = CORBA::_tc_double;
#ifdef DEBUG
::tet_infoline("GetTypeCode creating Double\n");
#endif
              break;
    case   9: tc = CORBA::_tc_string;
#ifdef DEBUG
::tet_infoline("GetTypeCode creating String\n");
#endif
              break;
    case  10: {
#ifdef DEBUG
::tet_infoline("GetTypeCode creating BoundedString\n");
#endif
                tc = orb->orb()->create_string_tc(ernie.getULong()%30+1);
              }
              break;
    case   11: tc = CORBA::_tc_TypeCode;
#ifdef DEBUG
::tet_infoline("GetTypeCode creating TypeCode\n");
#endif
              break;
    case   12: tc = CORBA::_tc_any;
#ifdef DEBUG
::tet_infoline("GetTypeCode creating Any\n");
#endif
              break;

    case  13: tc = ::_tc_Apple;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Apple\n");
#endif
              break;

    case  14: tc = ::_tc_PassionFruit;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_PassionFruit\n");
#endif
              break;

    case  15: tc = ::_tc_Banana;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Banana\n");
#endif
              break;

    case  16: tc = ::idlServer::_tc_TypeCode;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::idlServer::_tc_TypeCode\n");
#endif
              break;

    case  17: tc = CORBA::_tc_string;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating _tc_string\n");
#endif
              break;

    case  18: tc = CORBA::_tc_string;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating _tc_string\n");
#endif
              break;

    case  19: tc = CORBA::_tc_string;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating _tc_string\n");
#endif
              break;

    case  20: tc = CORBA::_tc_string;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating _tc_string\n");
#endif
              break;

    case  21: tc = CORBA::_tc_string;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating _tc_string\n");
#endif
              break;

  }
}


