//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;
 


::idlServer::TypeCode
idlServer_imp::Lime(const ::idlServer::TypeCode &p1,::idlServer::TypeCode_out p2,::idlServer::TypeCode &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::idlServer::TypeCode ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lime\n");
#endif
  
  ernie.seed("LimeCall");
  AddName("p1");
  if (!CheckidlServerTypeCode(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckidlServerTypeCode(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LimeReturn"); 
  
  GetidlServerTypeCode(ReturnValue);
  GetidlServerTypeCode(p2);
  GetidlServerTypeCode(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lime\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
idlServer_imp::BlueBerry(CORBA::TypeCode_ptr p1,CORBA::TypeCode_out p2,CORBA::TypeCode_ptr &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BlueBerry\n");
#endif
  
  ernie.seed("BlueBerryCall");
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlueBerryReturn"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
  GetCORBATypeCode_ptr(p2);
  GetCORBATypeCode_ptr(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BlueBerry\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
idlServer_imp::Lemon( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lemon\n");
#endif
  
  ernie.seed("LemonCall");
  
  ernie.seed("LemonReturn"); 
  
  ReturnValue = GetString(15);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lemon\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Lemon(const char * _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lemon\n");
#endif
  
  ernie.seed("LemonCall");
  AddName("_attr");
  if (!CheckString(_attr,15))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LemonReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lemon\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

char *
idlServer_imp::BlackCherry(const char * p1,CORBA::String_out p2,char * &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BlackCherry\n");
#endif
  
  ernie.seed("BlackCherryCall");
  AddName("p1");
  if (!CheckString(p1,3))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckString(p3,482))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlackCherryReturn"); 
  
  ReturnValue = GetString(3);
  p2 = GetString(513);
  p3 = GetString(482);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BlackCherry\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



