//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;
 


CORBA::Any*
idlServer_imp::Lime(const CORBA::Any &p1,CORBA::Any_out p2,CORBA::Any &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lime\n");
#endif
  
  ernie.seed("LimeCall");
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LimeReturn"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p2 = new CORBA::Any;
  GetAny(*(p2.ptr()));
  GetAny(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lime\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
idlServer_imp::Lemon( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lemon\n");
#endif
  
  ernie.seed("LemonCall");
  
  ernie.seed("LemonReturn"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lemon\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Lemon(const CORBA::Any &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lemon\n");
#endif
  
  ernie.seed("LemonCall");
  AddName("_attr");
  if (!CheckAny(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LemonReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lemon\n");
#endif
  ::tet_result(TET_PASS);
  
  
}



