//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.2  2001/01/29 16:40:55  arnop
// Some minor fixes.
//
// Revision 1.1.1.1  2000/02/09 17:16:09  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.9  1999/04/26 13:50:41  james
// Changed CORBA::Char* to char*
//
// Revision 1.8  1998/08/24 11:46:06  james
// ENV updates
//
// Revision 1.7  1997/12/15 10:51:44  james
// #ifdefs removed
//
// Revision 1.6  1997/12/11 16:26:39  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetSweetcorn(::Sweetcorn &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSweetcorn");
#endif

  ::Sweetcorn SweetcornArray[6] = {::Banana,::Carrots,::Lemon,::BlackCherry,::Starfruit,::Rhubarb};
  v = SweetcornArray[ernie.getULong()%6];
}

int CheckSweetcorn(const ::Sweetcorn &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSweetcorn");
#endif

  ::Sweetcorn SweetcornArray[6] = {::Banana,::Carrots,::Lemon,::BlackCherry,::Starfruit,::Rhubarb};
  if (v != SweetcornArray[ernie.getULong()%6])
  {
    ::tet_printf("ERROR: %s has incorrect value",name);
    ::tet_printf("Expected %d, but found %d instead", SweetcornArray[ernie.getULongAgain()%6],v);
    iRetCode = 0;
  }
  return iRetCode;
}

 
void GetMangetout(::Mangetout &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMangetout");
#endif

}

int CheckMangetout(const ::Mangetout &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMangetout");
#endif

  return iRetCode;
}

 
void GetCress(::Cress &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCress");
#endif

  GetULong(v.Plum);
}

int CheckCress(const ::Cress &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCress");
#endif

  AddName("Plum");
  if (!CheckULong(v.Plum))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetBambooShoot(::BambooShoot &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBambooShoot");
#endif

  GetFloat(v.Plum);
  GetDouble(v.KidneyBean);
  GetLong(v.Zucchini);
  GetULong(v.ButterBean);
  GetShort(v.Avocado);
  GetUShort(v.GoldenDelicous);
  GetChar(v.Lentil);
  GetBoolean(v.Fig);
  GetOctet(v.CrabApple);
  v.RedOnion = GetString();
  v.HazelNut = GetString(23);
  v.Cinnamon = Getobject();
  GetAny(v.GooseBerry);
}

int CheckBambooShoot(const ::BambooShoot &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBambooShoot");
#endif

  AddName("Plum");
  if (!CheckFloat(v.Plum))
    iRetCode = 0;
  RemoveName();
  AddName("KidneyBean");
  if (!CheckDouble(v.KidneyBean))
    iRetCode = 0;
  RemoveName();
  AddName("Zucchini");
  if (!CheckLong(v.Zucchini))
    iRetCode = 0;
  RemoveName();
  AddName("ButterBean");
  if (!CheckULong(v.ButterBean))
    iRetCode = 0;
  RemoveName();
  AddName("Avocado");
  if (!CheckShort(v.Avocado))
    iRetCode = 0;
  RemoveName();
  AddName("GoldenDelicous");
  if (!CheckUShort(v.GoldenDelicous))
    iRetCode = 0;
  RemoveName();
  AddName("Lentil");
  if (!CheckChar(v.Lentil))
    iRetCode = 0;
  RemoveName();
  AddName("Fig");
  if (!CheckBoolean(v.Fig))
    iRetCode = 0;
  RemoveName();
  AddName("CrabApple");
  if (!CheckOctet(v.CrabApple))
    iRetCode = 0;
  RemoveName();
  AddName("RedOnion");
  if (!CheckString((const char *)v.RedOnion))
    iRetCode = 0;
  RemoveName();
  AddName("HazelNut");
  if (!CheckString((const char *)v.HazelNut,23))
    iRetCode = 0;
  RemoveName();
  AddName("Cinnamon");
  if (!Checkobject(v.Cinnamon.in()))
    iRetCode = 0;
  RemoveName();
  AddName("GooseBerry");
  if (!CheckAny(v.GooseBerry))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetRunnerbean(::Runnerbean &v)
{
#ifdef DEBUG
  ::tet_infoline("GetRunnerbean");
#endif

  GetFloat(v.Sultana);
}

int CheckRunnerbean(const ::Runnerbean &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRunnerbean");
#endif

  AddName("Sultana");
  if (!CheckFloat(v.Sultana))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetGuava(::Guava &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGuava");
#endif

  GetFloat(v.Sultana);
}

int CheckGuava(const ::Guava &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGuava");
#endif

  AddName("Sultana");
  if (!CheckFloat(v.Sultana))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetBrazilNut(::BrazilNut &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBrazilNut");
#endif

  {
    int vSelection;
    CORBA::Long vArray[2] = {23,-25};
    
    vSelection = ernie.getULong() % 3;
    switch (vSelection) {
      case 0 :
              {
                ::Runnerbean _value2;
                
                GetRunnerbean(_value2);
                v. Parsnip(_value2);
              }
              break;
      case 1 :
              {
                CORBA::Long _value2;
                
                GetLong(_value2);
                v. Celery(_value2);
              }
              break;
      default:
              {
                CORBA::Short _value2;
                
                GetShort(_value2);
                v. WhiteCabbage(_value2);
              }
              break;
    }
    if (vSelection < 2)
      v._d(vArray[vSelection]);
  }
}

int CheckBrazilNut(const ::BrazilNut &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBrazilNut");
#endif

  {
    int vSelection;
    CORBA::Long vArray[2] = {23,-25};
    
    vSelection = ernie.getULong() % 3;
    
    if (vSelection < 2 && v._d() != vArray[vSelection])
    {
      ::tet_printf("ERROR: %s has an incorrect discriminator",name);
      iRetCode = 0;
    }
    switch (vSelection) {
      case 0 :
              AddName("Parsnip()");
              if (!CheckRunnerbean(v.Parsnip()))
                iRetCode = 0;
              RemoveName();
              break;
      case 1 :
              AddName("Celery()");
              if (!CheckLong(v.Celery()))
                iRetCode = 0;
              RemoveName();
              break;
      default:
              AddName("WhiteCabbage()");
              if (!CheckShort(v.WhiteCabbage()))
                iRetCode = 0;
              RemoveName();
              break;
    }
  }
  return iRetCode;
}

 
void GetCassava(::Cassava &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCassava");
#endif

  GetGuava(v.Oregano);
  GetRunnerbean(v.Almonds);
  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      GetGuava(v.Mushroom[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 1; ++i1)
    {
      AddIndex(i1);
      GetRunnerbean(v.Tofu[i1]);
      RemoveIndex();
    }
  }
}

int CheckCassava(const ::Cassava &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCassava");
#endif

  AddName("Oregano");
  if (!CheckGuava(v.Oregano))
    iRetCode = 0;
  RemoveName();
  AddName("Almonds");
  if (!CheckRunnerbean(v.Almonds))
    iRetCode = 0;
  RemoveName();
  AddName("Mushroom");
  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      if (!CheckGuava(v.Mushroom[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Tofu");
  {
    int	i1;
    for(i1=0; i1 < 1; ++i1)
    {
      AddIndex(i1);
      if (!CheckRunnerbean(v.Tofu[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetMelon(::Melon &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMelon");
#endif

  GetBrazilNut(v.SweetPotato);
  {
    int	i1;
    for(i1=0; i1 < 2; ++i1)
    {
      AddIndex(i1);
      GetBrazilNut(v.Orange[i1]);
      RemoveIndex();
    }
  }
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Tangarine.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetOctet(v.Tangarine[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.GardenPeas[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetFloat(v.GardenPeas[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.CantelopeMelon.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetOctet(v.CantelopeMelon[i1]);
      RemoveIndex();
    }
  }
  GetSweetcorn(v.Apple);
  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      GetSweetcorn(v.Onion[i1]);
      RemoveIndex();
    }
  }
}

int CheckMelon(const ::Melon &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMelon");
#endif

  AddName("SweetPotato");
  if (!CheckBrazilNut(v.SweetPotato))
    iRetCode = 0;
  RemoveName();
  AddName("Orange");
  {
    int	i1;
    for(i1=0; i1 < 2; ++i1)
    {
      AddIndex(i1);
      if (!CheckBrazilNut(v.Orange[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Tangarine");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Tangarine.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Tangarine.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckOctet(v.Tangarine[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("GardenPeas");
  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.GardenPeas[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GardenPeas[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckFloat(v.GardenPeas[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("CantelopeMelon");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.CantelopeMelon.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.CantelopeMelon.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckOctet(v.CantelopeMelon[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Apple");
  if (!CheckSweetcorn(v.Apple))
    iRetCode = 0;
  RemoveName();
  AddName("Onion");
  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      if (!CheckSweetcorn(v.Onion[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetidlServerRedGrapes(::idlServer::RedGrapes &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerRedGrapes");
#endif

  {
    int	i1;
    for(i1=0; i1 < 34; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Plum[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 12; ++i1)
    {
      AddIndex(i1);
      GetDouble(v.KidneyBean[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      GetLong(v.Zucchini[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      GetULong(v.ButterBean[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 1; ++i1)
    {
      AddIndex(i1);
      GetShort(v.Avocado[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 32; ++i1)
    {
      AddIndex(i1);
      GetUShort(v.GoldenDelicous[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      GetChar(v.Lentil[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 2; ++i1)
    {
      AddIndex(i1);
      GetBoolean(v.Fig[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      GetOctet(v.CrabApple[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 2; ++i1)
    {
      AddIndex(i1);
      v.RedOnion[i1] = GetString();
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 1; ++i1)
    {
      AddIndex(i1);
      v.HazelNut[i1] = GetString(15);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      v.Cinnamon[i1] = Getobject();
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 2; ++i1)
    {
      AddIndex(i1);
      GetAny(v.GooseBerry[i1]);
      RemoveIndex();
    }
  }
}

int CheckidlServerRedGrapes(const ::idlServer::RedGrapes &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerRedGrapes");
#endif

  AddName("Plum");
  {
    int	i1;
    for(i1=0; i1 < 34; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Plum[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("KidneyBean");
  {
    int	i1;
    for(i1=0; i1 < 12; ++i1)
    {
      AddIndex(i1);
      if (!CheckDouble(v.KidneyBean[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Zucchini");
  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      if (!CheckLong(v.Zucchini[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("ButterBean");
  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      if (!CheckULong(v.ButterBean[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Avocado");
  {
    int	i1;
    for(i1=0; i1 < 1; ++i1)
    {
      AddIndex(i1);
      if (!CheckShort(v.Avocado[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("GoldenDelicous");
  {
    int	i1;
    for(i1=0; i1 < 32; ++i1)
    {
      AddIndex(i1);
      if (!CheckUShort(v.GoldenDelicous[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Lentil");
  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      if (!CheckChar(v.Lentil[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Fig");
  {
    int	i1;
    for(i1=0; i1 < 2; ++i1)
    {
      AddIndex(i1);
      if (!CheckBoolean(v.Fig[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("CrabApple");
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      if (!CheckOctet(v.CrabApple[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("RedOnion");
  {
    int	i1;
    for(i1=0; i1 < 2; ++i1)
    {
      AddIndex(i1);
      if (!CheckString((const char *)v.RedOnion[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("HazelNut");
  {
    int	i1;
    for(i1=0; i1 < 1; ++i1)
    {
      AddIndex(i1);
      if (!CheckString((const char *)v.HazelNut[i1],15))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Cinnamon");
  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      if (!Checkobject(v.Cinnamon[i1].in()))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("GooseBerry");
  {
    int	i1;
    for(i1=0; i1 < 2; ++i1)
    {
      AddIndex(i1);
      if (!CheckAny(v.GooseBerry[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}



