//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;
 


void
idlServer_imp::JuniperBerries(CORBA::Long p1,::Sweetcorn_out p2,CORBA::Octet &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::JuniperBerries\n");
#endif
  
  ernie.seed("JuniperBerriesCall");
  AddName("p1");
  if (!CheckLong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckOctet(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("JuniperBerriesReturn"); 
  {
    ::Mangetout ex;
    GetMangetout(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetSweetcorn(p2);
  GetOctet(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::JuniperBerries\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
idlServer_imp::Daikan( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Daikan\n");
#endif
  
  ernie.seed("DaikanCall");
  
  ernie.seed("DaikanReturn"); 
  switch (ernie.getULong() % 2)
  {
    case 0:
          {
            ::Cress ex;
            GetCress(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 1:
          {
            ::idlServer::RedGrapes ex;
            GetidlServerRedGrapes(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
  }
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Daikan\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
idlServer_imp::Thyme( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Thyme\n");
#endif
  
  ernie.seed("ThymeCall");
  
  ernie.seed("ThymeReturn"); 
  switch (ernie.getULong() % 2)
  {
    case 0:
          {
            ::Cress ex;
            GetCress(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 1:
          {
            ::idlServer::RedGrapes ex;
            GetidlServerRedGrapes(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
  }
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Thyme\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
idlServer_imp::Lettuce( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lettuce\n");
#endif
  
  ernie.seed("LettuceCall");
  
  ernie.seed("LettuceReturn"); 
  switch (ernie.getULong() % 6)
  {
    case 0:
          {
            ::Mangetout ex;
            GetMangetout(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 1:
          {
            ::Cress ex;
            GetCress(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 2:
          {
            ::BambooShoot ex;
            GetBambooShoot(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 3:
          {
            ::Cassava ex;
            GetCassava(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 4:
          {
            ::Melon ex;
            GetMelon(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 5:
          {
            ::idlServer::RedGrapes ex;
            GetidlServerRedGrapes(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
  }
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lettuce\n");
#endif
  ::tet_result(TET_PASS);
  
  
}



