//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:11  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.8  1999/04/26 13:50:46  james
// Changed CORBA::Char* to char*
//
// Revision 1.7  1998/08/24 11:46:11  james
// ENV updates
//
// Revision 1.6  1997/12/15 10:51:44  james
// #ifdefs removed
//
// Revision 1.5  1997/12/11 17:17:36  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetEggPlant(::EggPlant &v)
{
#ifdef DEBUG
  ::tet_infoline("GetEggPlant");
#endif

  ::EggPlant EggPlantArray[6] = {::Banana,::Carrots,::Lemon,::BlackCherry,::Starfruit,::Rhubarb};
  v = EggPlantArray[ernie.getULong()%6];
}

int CheckEggPlant(const ::EggPlant &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckEggPlant");
#endif

  ::EggPlant EggPlantArray[6] = {::Banana,::Carrots,::Lemon,::BlackCherry,::Starfruit,::Rhubarb};
  if (v != EggPlantArray[ernie.getULong()%6])
  {
    ::tet_printf("ERROR: %s has incorrect value",name);
    ::tet_printf("Expected %d, but found %d instead", EggPlantArray[ernie.getULongAgain()%6],v);
    iRetCode = 0;
  }
  return iRetCode;
}

 
void GetPlum(::Plum v)
{
#ifdef DEBUG
  ::tet_infoline("GetPlum");
#endif

  {
    int	i1;
    for(i1=0; i1 < 18; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetFloat(v[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckPlum(const ::Plum v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPlum");
#endif

  {
    int	i1;
    for(i1=0; i1 < 18; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckFloat(v[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetAvocado(::Avocado &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAvocado");
#endif

  GetShort(v.Pumpkin);
}

int CheckAvocado(const ::Avocado &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAvocado");
#endif

  AddName("Pumpkin");
  if (!CheckShort(v.Pumpkin))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetZucchini(::Zucchini &v)
{
#ifdef DEBUG
  ::tet_infoline("GetZucchini");
#endif

  GetShort(v.Pumpkin);
}

int CheckZucchini(const ::Zucchini &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckZucchini");
#endif

  AddName("Pumpkin");
  if (!CheckShort(v.Pumpkin))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetLentil(::Lentil &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLentil");
#endif

  {
    int vSelection;
    CORBA::Long vArray[2] = {23,-25};
    
    vSelection = ernie.getULong() % 3;
    switch (vSelection) {
      case 0 :
              {
                CORBA::Octet _value2;
                
                GetOctet(_value2);
                v. Lime(_value2);
              }
              break;
      case 1 :
              {
                ::Avocado _value2;
                
                GetAvocado(_value2);
                v. Coconut(_value2);
              }
              break;
      default:
              {
                CORBA::Short _value2;
                
                GetShort(_value2);
                v. Lychees(_value2);
              }
              break;
    }
    if (vSelection < 2)
      v._d(vArray[vSelection]);
  }
}

int CheckLentil(const ::Lentil &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLentil");
#endif

  {
    int vSelection;
    CORBA::Long vArray[2] = {23,-25};
    
    vSelection = ernie.getULong() % 3;
    
    if (vSelection < 2 && v._d() != vArray[vSelection])
    {
      ::tet_printf("ERROR: %s has an incorrect discriminator",name);
      iRetCode = 0;
    }
    switch (vSelection) {
      case 0 :
              AddName("Lime()");
              if (!CheckOctet(v.Lime()))
                iRetCode = 0;
              RemoveName();
              break;
      case 1 :
              AddName("Coconut()");
              if (!CheckAvocado(v.Coconut()))
                iRetCode = 0;
              RemoveName();
              break;
      default:
              AddName("Lychees()");
              if (!CheckShort(v.Lychees()))
                iRetCode = 0;
              RemoveName();
              break;
    }
  }
  return iRetCode;
}

 
void Getstring_23(char* &v)
{
#ifdef DEBUG
  ::tet_infoline("Getstring_23");
#endif

  v = GetString(23);
}

int Checkstring_23(const char* &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("Checkstring_23");
#endif

  if (!CheckString((const char *)v,23))
    iRetCode = 0;
  return iRetCode;
}

 
void Getstring_25(char* &v)
{
#ifdef DEBUG
  ::tet_infoline("Getstring_25");
#endif

  v = GetString(25);
}

int Checkstring_25(const char* &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("Checkstring_25");
#endif

  if (!CheckString((const char *)v,25))
    iRetCode = 0;
  return iRetCode;
}



