//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


CORBA::Float
siiServer_imp::Cucumber( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Float ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Cucumber\n");
#endif
  
  ernie.seed("CucumberCall");
  
  ernie.seed("CucumberReturn"); 
  
  GetFloat(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Cucumber\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Cucumber(CORBA::Float _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Cucumber\n");
#endif
  
  ernie.seed("CucumberCall");
  AddName("_attr");
  if (!CheckFloat(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CucumberReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Cucumber\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Double
siiServer_imp::Ginger( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Double ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Ginger\n");
#endif
  
  ernie.seed("GingerCall");
  
  ernie.seed("GingerReturn"); 
  
  GetDouble(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Ginger\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Ginger(CORBA::Double _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Ginger\n");
#endif
  
  ernie.seed("GingerCall");
  AddName("_attr");
  if (!CheckDouble(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GingerReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Ginger\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Long
siiServer_imp::Apricots( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Long ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Apricots\n");
#endif
  
  ernie.seed("ApricotsCall");
  
  ernie.seed("ApricotsReturn"); 
  
  GetLong(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Apricots\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Apricots(CORBA::Long _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Apricots\n");
#endif
  
  ernie.seed("ApricotsCall");
  AddName("_attr");
  if (!CheckLong(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ApricotsReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Apricots\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::ULong
siiServer_imp::BlackEyedBeans( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::ULong ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::BlackEyedBeans\n");
#endif
  
  ernie.seed("BlackEyedBeansCall");
  
  ernie.seed("BlackEyedBeansReturn"); 
  
  GetULong(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::BlackEyedBeans\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::BlackEyedBeans(CORBA::ULong _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::BlackEyedBeans\n");
#endif
  
  ernie.seed("BlackEyedBeansCall");
  AddName("_attr");
  if (!CheckULong(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlackEyedBeansReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::BlackEyedBeans\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Short
siiServer_imp::Leek( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Short ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Leek\n");
#endif
  
  ernie.seed("LeekCall");
  
  ernie.seed("LeekReturn"); 
  
  GetShort(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Leek\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Leek(CORBA::Short _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Leek\n");
#endif
  
  ernie.seed("LeekCall");
  AddName("_attr");
  if (!CheckShort(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LeekReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Leek\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::UShort
siiServer_imp::Mint( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::UShort ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Mint\n");
#endif
  
  ernie.seed("MintCall");
  
  ernie.seed("MintReturn"); 
  
  GetUShort(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Mint\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Mint(CORBA::UShort _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Mint\n");
#endif
  
  ernie.seed("MintCall");
  AddName("_attr");
  if (!CheckUShort(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MintReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Mint\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Char
siiServer_imp::GardenPeas( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Char ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::GardenPeas\n");
#endif
  
  ernie.seed("GardenPeasCall");
  
  ernie.seed("GardenPeasReturn"); 
  
  GetChar(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::GardenPeas\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::GardenPeas(CORBA::Char _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::GardenPeas\n");
#endif
  
  ernie.seed("GardenPeasCall");
  AddName("_attr");
  if (!CheckChar(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GardenPeasReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::GardenPeas\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Boolean
siiServer_imp::Fig( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Boolean ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Fig\n");
#endif
  
  ernie.seed("FigCall");
  
  ernie.seed("FigReturn"); 
  
  GetBoolean(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Fig\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Fig(CORBA::Boolean _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Fig\n");
#endif
  
  ernie.seed("FigCall");
  AddName("_attr");
  if (!CheckBoolean(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("FigReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Fig\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Octet
siiServer_imp::Asparagus( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Octet ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Asparagus\n");
#endif
  
  ernie.seed("AsparagusCall");
  
  ernie.seed("AsparagusReturn"); 
  
  GetOctet(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Asparagus\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Asparagus(CORBA::Octet _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Asparagus\n");
#endif
  
  ernie.seed("AsparagusCall");
  AddName("_attr");
  if (!CheckOctet(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AsparagusReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Asparagus\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

char *
siiServer_imp::GaliaMelon( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::GaliaMelon\n");
#endif
  
  ernie.seed("GaliaMelonCall");
  
  ernie.seed("GaliaMelonReturn"); 
  
  ReturnValue = GetString();
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::GaliaMelon\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::GaliaMelon(const char * _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::GaliaMelon\n");
#endif
  
  ernie.seed("GaliaMelonCall");
  AddName("_attr");
  if (!CheckString(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GaliaMelonReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::GaliaMelon\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

char *
siiServer_imp::Sultana( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Sultana\n");
#endif
  
  ernie.seed("SultanaCall");
  
  ernie.seed("SultanaReturn"); 
  
  ReturnValue = GetString(23);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Sultana\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Sultana(const char * _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Sultana\n");
#endif
  
  ernie.seed("SultanaCall");
  AddName("_attr");
  if (!CheckString(_attr,23))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SultanaReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Sultana\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Object_ptr
siiServer_imp::Turnip( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Object_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Turnip\n");
#endif
  
  ernie.seed("TurnipCall");
  
  ernie.seed("TurnipReturn"); 
  
  ReturnValue = Getobject();
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Turnip\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Turnip(CORBA::Object_ptr _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Turnip\n");
#endif
  
  ernie.seed("TurnipCall");
  AddName("_attr");
  if (!Checkobject(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("TurnipReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Turnip\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Any*
siiServer_imp::Orange( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Orange\n");
#endif
  
  ernie.seed("OrangeCall");
  
  ernie.seed("OrangeReturn"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Orange\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Orange(const CORBA::Any &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Orange\n");
#endif
  
  ernie.seed("OrangeCall");
  AddName("_attr");
  if (!CheckAny(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("OrangeReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Orange\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::TypeCode_ptr
siiServer_imp::LoganBerry( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::LoganBerry\n");
#endif
  
  ernie.seed("LoganBerryCall");
  
  ernie.seed("LoganBerryReturn"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::LoganBerry\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::LoganBerry(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::LoganBerry\n");
#endif
  
  ernie.seed("LoganBerryCall");
  AddName("_attr");
  if (!CheckCORBATypeCode_ptr(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LoganBerryReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::LoganBerry\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Float
siiServer_imp::Parsnip( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Float ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Parsnip\n");
#endif
  
  ernie.seed("ParsnipCall");
  
  ernie.seed("ParsnipReturn"); 
  
  GetFloat(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Parsnip\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Double
siiServer_imp::Celery( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Double ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Celery\n");
#endif
  
  ernie.seed("CeleryCall");
  
  ernie.seed("CeleryReturn"); 
  
  GetDouble(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Celery\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Long
siiServer_imp::WhiteCabbage( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Long ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::WhiteCabbage\n");
#endif
  
  ernie.seed("WhiteCabbageCall");
  
  ernie.seed("WhiteCabbageReturn"); 
  
  GetLong(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::WhiteCabbage\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::ULong
siiServer_imp::Aniseed( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::ULong ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Aniseed\n");
#endif
  
  ernie.seed("AniseedCall");
  
  ernie.seed("AniseedReturn"); 
  
  GetULong(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Aniseed\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Short
siiServer_imp::Bayleaf( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Short ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Bayleaf\n");
#endif
  
  ernie.seed("BayleafCall");
  
  ernie.seed("BayleafReturn"); 
  
  GetShort(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Bayleaf\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::UShort
siiServer_imp::Dill( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::UShort ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Dill\n");
#endif
  
  ernie.seed("DillCall");
  
  ernie.seed("DillReturn"); 
  
  GetUShort(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Dill\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Char
siiServer_imp::Oregano( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Char ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Oregano\n");
#endif
  
  ernie.seed("OreganoCall");
  
  ernie.seed("OreganoReturn"); 
  
  GetChar(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Oregano\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Boolean
siiServer_imp::Beansprout( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Boolean ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Beansprout\n");
#endif
  
  ernie.seed("BeansproutCall");
  
  ernie.seed("BeansproutReturn"); 
  
  GetBoolean(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Beansprout\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Octet
siiServer_imp::Almonds( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Octet ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Almonds\n");
#endif
  
  ernie.seed("AlmondsCall");
  
  ernie.seed("AlmondsReturn"); 
  
  GetOctet(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Almonds\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
siiServer_imp::Guava( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Guava\n");
#endif
  
  ernie.seed("GuavaCall");
  
  ernie.seed("GuavaReturn"); 
  
  ReturnValue = GetString();
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Guava\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
siiServer_imp::Mushroom( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Mushroom\n");
#endif
  
  ernie.seed("MushroomCall");
  
  ernie.seed("MushroomReturn"); 
  
  ReturnValue = GetString(25);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Mushroom\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Object_ptr
siiServer_imp::Runnerbean( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Object_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Runnerbean\n");
#endif
  
  ernie.seed("RunnerbeanCall");
  
  ernie.seed("RunnerbeanReturn"); 
  
  ReturnValue = Getobject();
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Runnerbean\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Tofu( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Tofu\n");
#endif
  
  ernie.seed("TofuCall");
  
  ernie.seed("TofuReturn"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Tofu\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Prunes( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Prunes\n");
#endif
  
  ernie.seed("PrunesCall");
  
  ernie.seed("PrunesReturn"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Prunes\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::EggPlant
siiServer_imp::GrannySmith( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  
  ::EggPlant ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::GrannySmith\n");
#endif
  
  ernie.seed("GrannySmithCall");
  
  ernie.seed("GrannySmithReturn"); 
  
  GetEggPlant(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::GrannySmith\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::GrannySmith(::EggPlant _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::GrannySmith\n");
#endif
  
  ernie.seed("GrannySmithCall");
  AddName("_attr");
  if (!CheckEggPlant(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GrannySmithReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::GrannySmith\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Plum_slice *
siiServer_imp::SweetPotato( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Plum_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::SweetPotato\n");
#endif
  
  ernie.seed("SweetPotatoCall");
  
  ernie.seed("SweetPotatoReturn"); 
  
  ReturnValue = new ::Plum;
  GetPlum(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::SweetPotato\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::SweetPotato(const ::Plum _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::SweetPotato\n");
#endif
  
  ernie.seed("SweetPotatoCall");
  AddName("_attr");
  if (!CheckPlum(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SweetPotatoReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::SweetPotato\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Zucchini
siiServer_imp::Billberries( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Zucchini ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Billberries\n");
#endif
  
  ernie.seed("BillberriesCall");
  
  ernie.seed("BillberriesReturn"); 
  
  GetZucchini(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Billberries\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Billberries(const ::Zucchini &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Billberries\n");
#endif
  
  ernie.seed("BillberriesCall");
  AddName("_attr");
  if (!CheckZucchini(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BillberriesReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Billberries\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Avocado
siiServer_imp::LolloRossa( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::LolloRossa\n");
#endif
  
  ernie.seed("LolloRossaCall");
  
  ernie.seed("LolloRossaReturn"); 
  
  GetAvocado(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::LolloRossa\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::LolloRossa(const ::Avocado &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::LolloRossa\n");
#endif
  
  ernie.seed("LolloRossaCall");
  AddName("_attr");
  if (!CheckAvocado(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LolloRossaReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::LolloRossa\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Lentil
siiServer_imp::Sweetcorn( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  
  ::Lentil ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Sweetcorn\n");
#endif
  
  ernie.seed("SweetcornCall");
  
  ernie.seed("SweetcornReturn"); 
  
  GetLentil(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Sweetcorn\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Sweetcorn(const ::Lentil &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Sweetcorn\n");
#endif
  
  ernie.seed("SweetcornCall");
  AddName("_attr");
  if (!CheckLentil(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SweetcornReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Sweetcorn\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::EggPlant
siiServer_imp::Shallots( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  
  ::EggPlant ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Shallots\n");
#endif
  
  ernie.seed("ShallotsCall");
  
  ernie.seed("ShallotsReturn"); 
  
  GetEggPlant(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Shallots\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Plum_slice *
siiServer_imp::KidneyBean( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Plum_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::KidneyBean\n");
#endif
  
  ernie.seed("KidneyBeanCall");
  
  ernie.seed("KidneyBeanReturn"); 
  
  ReturnValue = new ::Plum;
  GetPlum(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::KidneyBean\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Zucchini
siiServer_imp::ButterBean( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Zucchini ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::ButterBean\n");
#endif
  
  ernie.seed("ButterBeanCall");
  
  ernie.seed("ButterBeanReturn"); 
  
  GetZucchini(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::ButterBean\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Avocado
siiServer_imp::GoldenDelicous( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::GoldenDelicous\n");
#endif
  
  ernie.seed("GoldenDelicousCall");
  
  ernie.seed("GoldenDelicousReturn"); 
  
  GetAvocado(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::GoldenDelicous\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Lentil
siiServer_imp::CrabApple( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  
  ::Lentil ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::CrabApple\n");
#endif
  
  ernie.seed("CrabAppleCall");
  
  ernie.seed("CrabAppleReturn"); 
  
  GetLentil(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::CrabApple\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Long
siiServer_imp::RedOnion( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Long ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::RedOnion\n");
#endif
  
  ernie.seed("RedOnionCall");
  
  ernie.seed("RedOnionReturn"); 
  
  GetLong(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::RedOnion\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::RedOnion(CORBA::Long _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::RedOnion\n");
#endif
  
  ernie.seed("RedOnionCall");
  AddName("_attr");
  if (!CheckLong(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedOnionReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::RedOnion\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Long
siiServer_imp::HazelNut( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Long ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::HazelNut\n");
#endif
  
  ernie.seed("HazelNutCall");
  
  ernie.seed("HazelNutReturn"); 
  
  GetLong(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::HazelNut\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::HazelNut(CORBA::Long _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::HazelNut\n");
#endif
  
  ernie.seed("HazelNutCall");
  AddName("_attr");
  if (!CheckLong(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("HazelNutReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::HazelNut\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Long
siiServer_imp::Cinnamon( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Long ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Cinnamon\n");
#endif
  
  ernie.seed("CinnamonCall");
  
  ernie.seed("CinnamonReturn"); 
  
  GetLong(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Cinnamon\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Cinnamon(CORBA::Long _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Cinnamon\n");
#endif
  
  ernie.seed("CinnamonCall");
  AddName("_attr");
  if (!CheckLong(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CinnamonReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Cinnamon\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Long
siiServer_imp::GooseBerry( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Long ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::GooseBerry\n");
#endif
  
  ernie.seed("GooseBerryCall");
  
  ernie.seed("GooseBerryReturn"); 
  
  GetLong(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::GooseBerry\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::GooseBerry(CORBA::Long _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::GooseBerry\n");
#endif
  
  ernie.seed("GooseBerryCall");
  AddName("_attr");
  if (!CheckLong(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GooseBerryReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::GooseBerry\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::EggPlant
siiServer_imp::JuniperBerries( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  
  ::EggPlant ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::JuniperBerries\n");
#endif
  
  ernie.seed("JuniperBerriesCall");
  
  ernie.seed("JuniperBerriesReturn"); 
  
  GetEggPlant(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::JuniperBerries\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::JuniperBerries(::EggPlant _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::JuniperBerries\n");
#endif
  
  ernie.seed("JuniperBerriesCall");
  AddName("_attr");
  if (!CheckEggPlant(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("JuniperBerriesReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::JuniperBerries\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::EggPlant
siiServer_imp::Cloves( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  
  ::EggPlant ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Cloves\n");
#endif
  
  ernie.seed("ClovesCall");
  
  ernie.seed("ClovesReturn"); 
  
  GetEggPlant(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Cloves\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Cloves(::EggPlant _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Cloves\n");
#endif
  
  ernie.seed("ClovesCall");
  AddName("_attr");
  if (!CheckEggPlant(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ClovesReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Cloves\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::EggPlant
siiServer_imp::Daikan( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  
  ::EggPlant ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Daikan\n");
#endif
  
  ernie.seed("DaikanCall");
  
  ernie.seed("DaikanReturn"); 
  
  GetEggPlant(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Daikan\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Daikan(::EggPlant _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Daikan\n");
#endif
  
  ernie.seed("DaikanCall");
  AddName("_attr");
  if (!CheckEggPlant(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("DaikanReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Daikan\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::EggPlant
siiServer_imp::Mustard( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  
  ::EggPlant ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Mustard\n");
#endif
  
  ernie.seed("MustardCall");
  
  ernie.seed("MustardReturn"); 
  
  GetEggPlant(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Mustard\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Mustard(::EggPlant _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::siiServer::Mustard\n");
#endif
  
  ernie.seed("MustardCall");
  AddName("_attr");
  if (!CheckEggPlant(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MustardReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::siiServer::Mustard\n");
#endif
  ::tet_result(TET_PASS);
  
  
}



