//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;
 

void
idlServer_imp::Sultana( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::LoganBerry::Banana::Sultana\n");
#endif
  
  ernie.seed("SultanaCall");
  
  ernie.seed("SultanaReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::LoganBerry::Banana::Sultana\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::LoganBerry::Parsnip::Celery::WhiteCabbage
idlServer_imp::Aniseed( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::LoganBerry::Parsnip::Celery::WhiteCabbage ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Aniseed\n");
#endif
  
  ernie.seed("AniseedCall");
  
  ernie.seed("AniseedReturn"); 
  
  GetLoganBerryParsnipCeleryWhiteCabbage(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Aniseed\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Aniseed(const ::LoganBerry::Parsnip::Celery::WhiteCabbage &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Aniseed\n");
#endif
  
  ernie.seed("AniseedCall");
  AddName("_attr");
  if (!CheckLoganBerryParsnipCeleryWhiteCabbage(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AniseedReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Aniseed\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
idlServer_imp::Bayleaf(::LoganBerry::Banana::GaliaMelon p1,CORBA::Long &Aniseed VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Bayleaf\n");
#endif
  
  ernie.seed("BayleafCall");
  AddName("p1");
  if (!CheckLoganBerryBananaGaliaMelon(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BayleafReturn"); 
  
  GetLong(Aniseed);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Bayleaf\n");
#endif
  ::tet_result(TET_PASS);
  
  
}



