//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::LoganBerry*
idlServer_imp::LoganBerryAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::LoganBerry* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LoganBerryAttr\n");
#endif
  
  ernie.seed("LoganBerryAttrCall");
  
  ernie.seed("LoganBerryAttrReturn"); 
  ReturnValue = new ::LoganBerry;
  GetLoganBerry(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LoganBerryAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::LoganBerryAttr(const ::LoganBerry &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LoganBerryAttr\n");
#endif
  
  ernie.seed("LoganBerryAttrCall");
  AddName("_attr");
  if (!CheckLoganBerry(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LoganBerryAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LoganBerryAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::LoganBerry*
idlServer_imp::LoganBerryOp(const ::LoganBerry &p1,::LoganBerry_out p2,::LoganBerry &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::LoganBerry* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LoganBerryOp\n");
#endif
  
  ernie.seed("LoganBerryOpCall");
  AddName("p1");
  if (!CheckLoganBerry(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckLoganBerry(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LoganBerryOpReturn"); 
  {
    ::idlServer::LoganBerryExcpt ex;
    GetidlServerLoganBerryExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::LoganBerry;
  GetLoganBerry(*ReturnValue);
  p2 = new ::LoganBerry;
  GetLoganBerry(p2);
  GetLoganBerry(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LoganBerryOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Parsnip_slice *
idlServer_imp::ParsnipAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Parsnip_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ParsnipAttr\n");
#endif
  
  ernie.seed("ParsnipAttrCall");
  
  ernie.seed("ParsnipAttrReturn"); 
  
  ReturnValue = new ::Parsnip;
  GetParsnip(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ParsnipAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::ParsnipAttr(const ::Parsnip _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ParsnipAttr\n");
#endif
  
  ernie.seed("ParsnipAttrCall");
  AddName("_attr");
  if (!CheckParsnip(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ParsnipAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ParsnipAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Parsnip_slice *
idlServer_imp::ParsnipOp(const ::Parsnip p1,::Parsnip_out p2,::Parsnip p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Parsnip_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ParsnipOp\n");
#endif
  
  ernie.seed("ParsnipOpCall");
  AddName("p1");
  if (!CheckParsnip(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckParsnip(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ParsnipOpReturn"); 
  {
    ::idlServer::ParsnipExcpt ex;
    GetidlServerParsnipExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Parsnip;
  GetParsnip(ReturnValue);
  p2 = new ::Parsnip;
  GetParsnip(p2);
  GetParsnip(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ParsnipOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Celery*
idlServer_imp::CeleryAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Celery* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CeleryAttr\n");
#endif
  
  ernie.seed("CeleryAttrCall");
  
  ernie.seed("CeleryAttrReturn"); 
  ReturnValue = new ::Celery;
  GetCelery(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CeleryAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::CeleryAttr(const ::Celery &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CeleryAttr\n");
#endif
  
  ernie.seed("CeleryAttrCall");
  AddName("_attr");
  if (!CheckCelery(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CeleryAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CeleryAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Celery*
idlServer_imp::CeleryOp(const ::Celery &p1,::Celery_out p2,::Celery &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Celery* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CeleryOp\n");
#endif
  
  ernie.seed("CeleryOpCall");
  AddName("p1");
  if (!CheckCelery(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCelery(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CeleryOpReturn"); 
  {
    ::idlServer::CeleryExcpt ex;
    GetidlServerCeleryExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Celery;
  GetCelery(*ReturnValue);
  p2 = new ::Celery;
  GetCelery(p2);
  GetCelery(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CeleryOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::WhiteCabbage_slice *
idlServer_imp::WhiteCabbageAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::WhiteCabbage_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::WhiteCabbageAttr\n");
#endif
  
  ernie.seed("WhiteCabbageAttrCall");
  
  ernie.seed("WhiteCabbageAttrReturn"); 
  
  ReturnValue = new ::WhiteCabbage;
  GetWhiteCabbage(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::WhiteCabbageAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::WhiteCabbageAttr(const ::WhiteCabbage _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::WhiteCabbageAttr\n");
#endif
  
  ernie.seed("WhiteCabbageAttrCall");
  AddName("_attr");
  if (!CheckWhiteCabbage(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("WhiteCabbageAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::WhiteCabbageAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::WhiteCabbage_slice *
idlServer_imp::WhiteCabbageOp(const ::WhiteCabbage p1,::WhiteCabbage_out p2,::WhiteCabbage p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::WhiteCabbage_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::WhiteCabbageOp\n");
#endif
  
  ernie.seed("WhiteCabbageOpCall");
  AddName("p1");
  if (!CheckWhiteCabbage(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckWhiteCabbage(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("WhiteCabbageOpReturn"); 
  {
    ::idlServer::WhiteCabbageExcpt ex;
    GetidlServerWhiteCabbageExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::WhiteCabbage;
  GetWhiteCabbage(ReturnValue);
  p2 = new ::WhiteCabbage;
  GetWhiteCabbage(p2);
  GetWhiteCabbage(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::WhiteCabbageOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Aniseed*
idlServer_imp::AniseedAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Aniseed* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AniseedAttr\n");
#endif
  
  ernie.seed("AniseedAttrCall");
  
  ernie.seed("AniseedAttrReturn"); 
  ReturnValue = new ::Aniseed;
  GetAniseed(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AniseedAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::AniseedAttr(const ::Aniseed &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AniseedAttr\n");
#endif
  
  ernie.seed("AniseedAttrCall");
  AddName("_attr");
  if (!CheckAniseed(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AniseedAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AniseedAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Aniseed*
idlServer_imp::AniseedOp(const ::Aniseed &p1,::Aniseed_out p2,::Aniseed &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Aniseed* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AniseedOp\n");
#endif
  
  ernie.seed("AniseedOpCall");
  AddName("p1");
  if (!CheckAniseed(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAniseed(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AniseedOpReturn"); 
  {
    ::idlServer::AniseedExcpt ex;
    GetidlServerAniseedExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Aniseed;
  GetAniseed(*ReturnValue);
  p2 = new ::Aniseed;
  GetAniseed(p2);
  GetAniseed(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AniseedOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Bayleaf_slice *
idlServer_imp::BayleafAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Bayleaf_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BayleafAttr\n");
#endif
  
  ernie.seed("BayleafAttrCall");
  
  ernie.seed("BayleafAttrReturn"); 
  
  ReturnValue = new ::Bayleaf;
  GetBayleaf(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BayleafAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BayleafAttr(const ::Bayleaf _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BayleafAttr\n");
#endif
  
  ernie.seed("BayleafAttrCall");
  AddName("_attr");
  if (!CheckBayleaf(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BayleafAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BayleafAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Bayleaf_slice *
idlServer_imp::BayleafOp(const ::Bayleaf p1,::Bayleaf_out p2,::Bayleaf p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Bayleaf_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BayleafOp\n");
#endif
  
  ernie.seed("BayleafOpCall");
  AddName("p1");
  if (!CheckBayleaf(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBayleaf(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BayleafOpReturn"); 
  {
    ::idlServer::BayleafExcpt ex;
    GetidlServerBayleafExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Bayleaf;
  GetBayleaf(ReturnValue);
  p2 = new ::Bayleaf;
  GetBayleaf(p2);
  GetBayleaf(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BayleafOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Dill*
idlServer_imp::DillAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Dill* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::DillAttr\n");
#endif
  
  ernie.seed("DillAttrCall");
  
  ernie.seed("DillAttrReturn"); 
  ReturnValue = new ::Dill;
  GetDill(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::DillAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::DillAttr(const ::Dill &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::DillAttr\n");
#endif
  
  ernie.seed("DillAttrCall");
  AddName("_attr");
  if (!CheckDill(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("DillAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::DillAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Dill*
idlServer_imp::DillOp(const ::Dill &p1,::Dill_out p2,::Dill &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Dill* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::DillOp\n");
#endif
  
  ernie.seed("DillOpCall");
  AddName("p1");
  if (!CheckDill(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckDill(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("DillOpReturn"); 
  {
    ::idlServer::DillExcpt ex;
    GetidlServerDillExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Dill;
  GetDill(*ReturnValue);
  p2 = new ::Dill;
  GetDill(p2);
  GetDill(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::DillOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Oregano_slice *
idlServer_imp::OreganoAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Oregano_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::OreganoAttr\n");
#endif
  
  ernie.seed("OreganoAttrCall");
  
  ernie.seed("OreganoAttrReturn"); 
  
  ReturnValue = new ::Oregano;
  GetOregano(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::OreganoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::OreganoAttr(const ::Oregano _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::OreganoAttr\n");
#endif
  
  ernie.seed("OreganoAttrCall");
  AddName("_attr");
  if (!CheckOregano(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("OreganoAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::OreganoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Oregano_slice *
idlServer_imp::OreganoOp(const ::Oregano p1,::Oregano_out p2,::Oregano p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Oregano_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::OreganoOp\n");
#endif
  
  ernie.seed("OreganoOpCall");
  AddName("p1");
  if (!CheckOregano(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckOregano(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("OreganoOpReturn"); 
  {
    ::idlServer::OreganoExcpt ex;
    GetidlServerOreganoExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Oregano;
  GetOregano(ReturnValue);
  p2 = new ::Oregano;
  GetOregano(p2);
  GetOregano(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::OreganoOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



