//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Beansprout*
idlServer_imp::BeansproutAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Beansprout* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BeansproutAttr\n");
#endif
  
  ernie.seed("BeansproutAttrCall");
  
  ernie.seed("BeansproutAttrReturn"); 
  ReturnValue = new ::Beansprout;
  GetBeansprout(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BeansproutAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BeansproutAttr(const ::Beansprout &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BeansproutAttr\n");
#endif
  
  ernie.seed("BeansproutAttrCall");
  AddName("_attr");
  if (!CheckBeansprout(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BeansproutAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BeansproutAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Beansprout*
idlServer_imp::BeansproutOp(const ::Beansprout &p1,::Beansprout_out p2,::Beansprout &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Beansprout* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BeansproutOp\n");
#endif
  
  ernie.seed("BeansproutOpCall");
  AddName("p1");
  if (!CheckBeansprout(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBeansprout(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BeansproutOpReturn"); 
  {
    ::idlServer::BeansproutExcpt ex;
    GetidlServerBeansproutExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Beansprout;
  GetBeansprout(*ReturnValue);
  p2 = new ::Beansprout;
  GetBeansprout(*(p2.ptr()));
  GetBeansprout(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BeansproutOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Almonds_slice *
idlServer_imp::AlmondsAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Almonds_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AlmondsAttr\n");
#endif
  
  ernie.seed("AlmondsAttrCall");
  
  ernie.seed("AlmondsAttrReturn"); 
  
  ReturnValue = new ::Almonds;
  GetAlmonds(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AlmondsAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::AlmondsAttr(const ::Almonds _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AlmondsAttr\n");
#endif
  
  ernie.seed("AlmondsAttrCall");
  AddName("_attr");
  if (!CheckAlmonds(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AlmondsAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AlmondsAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Almonds_slice *
idlServer_imp::AlmondsOp(const ::Almonds p1,::Almonds_out p2,::Almonds p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Almonds_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AlmondsOp\n");
#endif
  
  ernie.seed("AlmondsOpCall");
  AddName("p1");
  if (!CheckAlmonds(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAlmonds(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AlmondsOpReturn"); 
  {
    ::idlServer::AlmondsExcpt ex;
    GetidlServerAlmondsExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Almonds;
  GetAlmonds(ReturnValue);
  p2 = new ::Almonds;
  GetAlmonds(p2);
  GetAlmonds(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AlmondsOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Guava*
idlServer_imp::GuavaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Guava* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GuavaAttr\n");
#endif
  
  ernie.seed("GuavaAttrCall");
  
  ernie.seed("GuavaAttrReturn"); 
  ReturnValue = new ::Guava;
  GetGuava(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GuavaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::GuavaAttr(const ::Guava &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GuavaAttr\n");
#endif
  
  ernie.seed("GuavaAttrCall");
  AddName("_attr");
  if (!CheckGuava(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GuavaAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GuavaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Guava*
idlServer_imp::GuavaOp(const ::Guava &p1,::Guava_out p2,::Guava &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Guava* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GuavaOp\n");
#endif
  
  ernie.seed("GuavaOpCall");
  AddName("p1");
  if (!CheckGuava(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGuava(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GuavaOpReturn"); 
  {
    ::idlServer::GuavaExcpt ex;
    GetidlServerGuavaExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Guava;
  GetGuava(*ReturnValue);
  p2 = new ::Guava;
  GetGuava(*(p2.ptr()));
  GetGuava(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GuavaOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Mushroom_slice *
idlServer_imp::MushroomAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Mushroom_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MushroomAttr\n");
#endif
  
  ernie.seed("MushroomAttrCall");
  
  ernie.seed("MushroomAttrReturn"); 
  
  ReturnValue = new ::Mushroom;
  GetMushroom(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MushroomAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::MushroomAttr(const ::Mushroom _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MushroomAttr\n");
#endif
  
  ernie.seed("MushroomAttrCall");
  AddName("_attr");
  if (!CheckMushroom(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MushroomAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MushroomAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Mushroom_slice *
idlServer_imp::MushroomOp(const ::Mushroom p1,::Mushroom_out p2,::Mushroom p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Mushroom_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MushroomOp\n");
#endif
  
  ernie.seed("MushroomOpCall");
  AddName("p1");
  if (!CheckMushroom(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckMushroom(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MushroomOpReturn"); 
  {
    ::idlServer::MushroomExcpt ex;
    GetidlServerMushroomExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Mushroom;
  GetMushroom(ReturnValue);
  p2 = new ::Mushroom;
  GetMushroom(p2);
  GetMushroom(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MushroomOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Runnerbean*
idlServer_imp::RunnerbeanAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Runnerbean* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RunnerbeanAttr\n");
#endif
  
  ernie.seed("RunnerbeanAttrCall");
  
  ernie.seed("RunnerbeanAttrReturn"); 
  ReturnValue = new ::Runnerbean;
  GetRunnerbean(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RunnerbeanAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::RunnerbeanAttr(const ::Runnerbean &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RunnerbeanAttr\n");
#endif
  
  ernie.seed("RunnerbeanAttrCall");
  AddName("_attr");
  if (!CheckRunnerbean(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RunnerbeanAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RunnerbeanAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Runnerbean*
idlServer_imp::RunnerbeanOp(const ::Runnerbean &p1,::Runnerbean_out p2,::Runnerbean &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Runnerbean* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RunnerbeanOp\n");
#endif
  
  ernie.seed("RunnerbeanOpCall");
  AddName("p1");
  if (!CheckRunnerbean(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckRunnerbean(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RunnerbeanOpReturn"); 
  {
    ::idlServer::RunnerbeanExcpt ex;
    GetidlServerRunnerbeanExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Runnerbean;
  GetRunnerbean(*ReturnValue);
  p2 = new ::Runnerbean;
  GetRunnerbean(*(p2.ptr()));
  GetRunnerbean(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RunnerbeanOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Tofu_slice *
idlServer_imp::TofuAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Tofu_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::TofuAttr\n");
#endif
  
  ernie.seed("TofuAttrCall");
  
  ernie.seed("TofuAttrReturn"); 
  
  ReturnValue = new ::Tofu;
  GetTofu(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::TofuAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::TofuAttr(const ::Tofu _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::TofuAttr\n");
#endif
  
  ernie.seed("TofuAttrCall");
  AddName("_attr");
  if (!CheckTofu(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("TofuAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::TofuAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Tofu_slice *
idlServer_imp::TofuOp(const ::Tofu p1,::Tofu_out p2,::Tofu p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Tofu_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::TofuOp\n");
#endif
  
  ernie.seed("TofuOpCall");
  AddName("p1");
  if (!CheckTofu(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckTofu(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("TofuOpReturn"); 
  {
    ::idlServer::TofuExcpt ex;
    GetidlServerTofuExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Tofu;
  GetTofu(ReturnValue);
  p2 = new ::Tofu;
  GetTofu(p2);
  GetTofu(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::TofuOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Prunes*
idlServer_imp::PrunesAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Prunes* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PrunesAttr\n");
#endif
  
  ernie.seed("PrunesAttrCall");
  
  ernie.seed("PrunesAttrReturn"); 
  ReturnValue = new ::Prunes;
  GetPrunes(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PrunesAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::PrunesAttr(const ::Prunes &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PrunesAttr\n");
#endif
  
  ernie.seed("PrunesAttrCall");
  AddName("_attr");
  if (!CheckPrunes(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PrunesAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PrunesAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Prunes*
idlServer_imp::PrunesOp(const ::Prunes &p1,::Prunes_out p2,::Prunes &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Prunes* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PrunesOp\n");
#endif
  
  ernie.seed("PrunesOpCall");
  AddName("p1");
  if (!CheckPrunes(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPrunes(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PrunesOpReturn"); 
  {
    ::idlServer::PrunesExcpt ex;
    GetidlServerPrunesExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Prunes;
  GetPrunes(*ReturnValue);
  p2 = new ::Prunes;
  GetPrunes(*(p2.ptr()));
  GetPrunes(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PrunesOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Brocoli_slice *
idlServer_imp::BrocoliAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Brocoli_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BrocoliAttr\n");
#endif
  
  ernie.seed("BrocoliAttrCall");
  
  ernie.seed("BrocoliAttrReturn"); 
  
  ReturnValue = new ::Brocoli;
  GetBrocoli(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BrocoliAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BrocoliAttr(const ::Brocoli _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BrocoliAttr\n");
#endif
  
  ernie.seed("BrocoliAttrCall");
  AddName("_attr");
  if (!CheckBrocoli(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BrocoliAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BrocoliAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Brocoli_slice *
idlServer_imp::BrocoliOp(const ::Brocoli p1,::Brocoli_out p2,::Brocoli p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Brocoli_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BrocoliOp\n");
#endif
  
  ernie.seed("BrocoliOpCall");
  AddName("p1");
  if (!CheckBrocoli(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBrocoli(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BrocoliOpReturn"); 
  {
    ::idlServer::BrocoliExcpt ex;
    GetidlServerBrocoliExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Brocoli;
  GetBrocoli(ReturnValue);
  p2 = new ::Brocoli;
  GetBrocoli(p2);
  GetBrocoli(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BrocoliOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



