//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:17  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/26 13:50:58  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/15 10:51:46  james
// #ifdefs removed
//
// Revision 1.4  1997/12/09 11:26:43  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetGrannySmith(::GrannySmith &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGrannySmith");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%18;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetChar(v[i1]);
      RemoveIndex();
    }
  }
}

int CheckGrannySmith(const ::GrannySmith &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGrannySmith");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%18;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckChar(v[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetBrazilNut(::BrazilNut v)
{
#ifdef DEBUG
  ::tet_infoline("GetBrazilNut");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%18;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetChar(v[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBrazilNut(const ::BrazilNut v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBrazilNut");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%18;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckChar(v[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetSweetPotato(::SweetPotato &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSweetPotato");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetBoolean(v[i1]);
      RemoveIndex();
    }
  }
}

int CheckSweetPotato(const ::SweetPotato &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSweetPotato");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckBoolean(v[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetTangarine(::Tangarine v)
{
#ifdef DEBUG
  ::tet_infoline("GetTangarine");
#endif

  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetBoolean(v[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckTangarine(const ::Tangarine v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTangarine");
#endif

  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckBoolean(v[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetBillberries(::Billberries &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBillberries");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%11;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetBoolean(v[i1]);
      RemoveIndex();
    }
  }
}

int CheckBillberries(const ::Billberries &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBillberries");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%11;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckBoolean(v[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetCantelopeMelon(::CantelopeMelon v)
{
#ifdef DEBUG
  ::tet_infoline("GetCantelopeMelon");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetBoolean(v[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCantelopeMelon(const ::CantelopeMelon v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCantelopeMelon");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckBoolean(v[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetLolloRossa(::LolloRossa &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLolloRossa");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetOctet(v[i1]);
      RemoveIndex();
    }
  }
}

int CheckLolloRossa(const ::LolloRossa &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLolloRossa");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckOctet(v[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetRowanBerry(::RowanBerry v)
{
#ifdef DEBUG
  ::tet_infoline("GetRowanBerry");
#endif

  {
    int	i1;
    for(i1=0; i1 < 19; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetOctet(v[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckRowanBerry(const ::RowanBerry v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRowanBerry");
#endif

  {
    int	i1;
    for(i1=0; i1 < 19; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckOctet(v[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetidlServerGrannySmithExcpt(::idlServer::GrannySmithExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerGrannySmithExcpt");
#endif

  GetGrannySmith(v.ex1);
}

int CheckidlServerGrannySmithExcpt(const ::idlServer::GrannySmithExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerGrannySmithExcpt");
#endif

  AddName("ex1");
  if (!CheckGrannySmith(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerBrazilNutExcpt(::idlServer::BrazilNutExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerBrazilNutExcpt");
#endif

  GetBrazilNut(v.ex1);
}

int CheckidlServerBrazilNutExcpt(const ::idlServer::BrazilNutExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerBrazilNutExcpt");
#endif

  AddName("ex1");
  if (!CheckBrazilNut(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerSweetPotatoExcpt(::idlServer::SweetPotatoExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerSweetPotatoExcpt");
#endif

  GetSweetPotato(v.ex1);
}

int CheckidlServerSweetPotatoExcpt(const ::idlServer::SweetPotatoExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerSweetPotatoExcpt");
#endif

  AddName("ex1");
  if (!CheckSweetPotato(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerTangarineExcpt(::idlServer::TangarineExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerTangarineExcpt");
#endif

  GetTangarine(v.ex1);
}

int CheckidlServerTangarineExcpt(const ::idlServer::TangarineExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerTangarineExcpt");
#endif

  AddName("ex1");
  if (!CheckTangarine(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerBillberriesExcpt(::idlServer::BillberriesExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerBillberriesExcpt");
#endif

  GetBillberries(v.ex1);
}

int CheckidlServerBillberriesExcpt(const ::idlServer::BillberriesExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerBillberriesExcpt");
#endif

  AddName("ex1");
  if (!CheckBillberries(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerCantelopeMelonExcpt(::idlServer::CantelopeMelonExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerCantelopeMelonExcpt");
#endif

  GetCantelopeMelon(v.ex1);
}

int CheckidlServerCantelopeMelonExcpt(const ::idlServer::CantelopeMelonExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerCantelopeMelonExcpt");
#endif

  AddName("ex1");
  if (!CheckCantelopeMelon(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerLolloRossaExcpt(::idlServer::LolloRossaExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerLolloRossaExcpt");
#endif

  GetLolloRossa(v.ex1);
}

int CheckidlServerLolloRossaExcpt(const ::idlServer::LolloRossaExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerLolloRossaExcpt");
#endif

  AddName("ex1");
  if (!CheckLolloRossa(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerRowanBerryExcpt(::idlServer::RowanBerryExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerRowanBerryExcpt");
#endif

  GetRowanBerry(v.ex1);
}

int CheckidlServerRowanBerryExcpt(const ::idlServer::RowanBerryExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerRowanBerryExcpt");
#endif

  AddName("ex1");
  if (!CheckRowanBerry(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



