//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::GrannySmith*
idlServer_imp::GrannySmithAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::GrannySmith* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GrannySmithAttr\n");
#endif
  
  ernie.seed("GrannySmithAttrCall");
  
  ernie.seed("GrannySmithAttrReturn"); 
  ReturnValue = new ::GrannySmith;
  GetGrannySmith(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GrannySmithAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::GrannySmithAttr(const ::GrannySmith &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GrannySmithAttr\n");
#endif
  
  ernie.seed("GrannySmithAttrCall");
  AddName("_attr");
  if (!CheckGrannySmith(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GrannySmithAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GrannySmithAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::GrannySmith*
idlServer_imp::GrannySmithOp(const ::GrannySmith &p1,::GrannySmith_out p2,::GrannySmith &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::GrannySmith* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GrannySmithOp\n");
#endif
  
  ernie.seed("GrannySmithOpCall");
  AddName("p1");
  if (!CheckGrannySmith(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGrannySmith(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GrannySmithOpReturn"); 
  {
    ::idlServer::GrannySmithExcpt ex;
    GetidlServerGrannySmithExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::GrannySmith;
  GetGrannySmith(*ReturnValue);
  p2 = new ::GrannySmith;
  GetGrannySmith(*(p2.ptr()));
  GetGrannySmith(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GrannySmithOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::BrazilNut_slice *
idlServer_imp::BrazilNutAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::BrazilNut_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BrazilNutAttr\n");
#endif
  
  ernie.seed("BrazilNutAttrCall");
  
  ernie.seed("BrazilNutAttrReturn"); 
  
  ReturnValue = new ::BrazilNut;
  GetBrazilNut(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BrazilNutAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BrazilNutAttr(const ::BrazilNut _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BrazilNutAttr\n");
#endif
  
  ernie.seed("BrazilNutAttrCall");
  AddName("_attr");
  if (!CheckBrazilNut(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BrazilNutAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BrazilNutAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::BrazilNut_slice *
idlServer_imp::BrazilNutOp(const ::BrazilNut p1,::BrazilNut_out p2,::BrazilNut p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::BrazilNut_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BrazilNutOp\n");
#endif
  
  ernie.seed("BrazilNutOpCall");
  AddName("p1");
  if (!CheckBrazilNut(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBrazilNut(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BrazilNutOpReturn"); 
  {
    ::idlServer::BrazilNutExcpt ex;
    GetidlServerBrazilNutExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::BrazilNut;
  GetBrazilNut(ReturnValue);
  p2 = new ::BrazilNut;
  GetBrazilNut(p2);
  GetBrazilNut(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BrazilNutOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::SweetPotato*
idlServer_imp::SweetPotatoAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::SweetPotato* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SweetPotatoAttr\n");
#endif
  
  ernie.seed("SweetPotatoAttrCall");
  
  ernie.seed("SweetPotatoAttrReturn"); 
  ReturnValue = new ::SweetPotato;
  GetSweetPotato(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SweetPotatoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::SweetPotatoAttr(const ::SweetPotato &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SweetPotatoAttr\n");
#endif
  
  ernie.seed("SweetPotatoAttrCall");
  AddName("_attr");
  if (!CheckSweetPotato(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SweetPotatoAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SweetPotatoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::SweetPotato*
idlServer_imp::SweetPotatoOp(const ::SweetPotato &p1,::SweetPotato_out p2,::SweetPotato &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::SweetPotato* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SweetPotatoOp\n");
#endif
  
  ernie.seed("SweetPotatoOpCall");
  AddName("p1");
  if (!CheckSweetPotato(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckSweetPotato(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SweetPotatoOpReturn"); 
  {
    ::idlServer::SweetPotatoExcpt ex;
    GetidlServerSweetPotatoExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::SweetPotato;
  GetSweetPotato(*ReturnValue);
  p2 = new ::SweetPotato;
  GetSweetPotato(*(p2.ptr()));
  GetSweetPotato(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SweetPotatoOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Tangarine_slice *
idlServer_imp::TangarineAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Tangarine_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::TangarineAttr\n");
#endif
  
  ernie.seed("TangarineAttrCall");
  
  ernie.seed("TangarineAttrReturn"); 
  
  ReturnValue = new ::Tangarine;
  GetTangarine(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::TangarineAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::TangarineAttr(const ::Tangarine _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::TangarineAttr\n");
#endif
  
  ernie.seed("TangarineAttrCall");
  AddName("_attr");
  if (!CheckTangarine(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("TangarineAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::TangarineAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Tangarine_slice *
idlServer_imp::TangarineOp(const ::Tangarine p1,::Tangarine_out p2,::Tangarine p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Tangarine_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::TangarineOp\n");
#endif
  
  ernie.seed("TangarineOpCall");
  AddName("p1");
  if (!CheckTangarine(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckTangarine(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("TangarineOpReturn"); 
  {
    ::idlServer::TangarineExcpt ex;
    GetidlServerTangarineExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Tangarine;
  GetTangarine(ReturnValue);
  p2 = new ::Tangarine;
  GetTangarine(p2);
  GetTangarine(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::TangarineOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Billberries*
idlServer_imp::BillberriesAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Billberries* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BillberriesAttr\n");
#endif
  
  ernie.seed("BillberriesAttrCall");
  
  ernie.seed("BillberriesAttrReturn"); 
  ReturnValue = new ::Billberries;
  GetBillberries(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BillberriesAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BillberriesAttr(const ::Billberries &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BillberriesAttr\n");
#endif
  
  ernie.seed("BillberriesAttrCall");
  AddName("_attr");
  if (!CheckBillberries(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BillberriesAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BillberriesAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Billberries*
idlServer_imp::BillberriesOp(const ::Billberries &p1,::Billberries_out p2,::Billberries &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Billberries* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BillberriesOp\n");
#endif
  
  ernie.seed("BillberriesOpCall");
  AddName("p1");
  if (!CheckBillberries(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBillberries(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BillberriesOpReturn"); 
  {
    ::idlServer::BillberriesExcpt ex;
    GetidlServerBillberriesExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Billberries;
  GetBillberries(*ReturnValue);
  p2 = new ::Billberries;
  GetBillberries(*(p2.ptr()));
  GetBillberries(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BillberriesOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::CantelopeMelon_slice *
idlServer_imp::CantelopeMelonAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::CantelopeMelon_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CantelopeMelonAttr\n");
#endif
  
  ernie.seed("CantelopeMelonAttrCall");
  
  ernie.seed("CantelopeMelonAttrReturn"); 
  
  ReturnValue = new ::CantelopeMelon;
  GetCantelopeMelon(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CantelopeMelonAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::CantelopeMelonAttr(const ::CantelopeMelon _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CantelopeMelonAttr\n");
#endif
  
  ernie.seed("CantelopeMelonAttrCall");
  AddName("_attr");
  if (!CheckCantelopeMelon(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CantelopeMelonAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CantelopeMelonAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::CantelopeMelon_slice *
idlServer_imp::CantelopeMelonOp(const ::CantelopeMelon p1,::CantelopeMelon_out p2,::CantelopeMelon p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::CantelopeMelon_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CantelopeMelonOp\n");
#endif
  
  ernie.seed("CantelopeMelonOpCall");
  AddName("p1");
  if (!CheckCantelopeMelon(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCantelopeMelon(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CantelopeMelonOpReturn"); 
  {
    ::idlServer::CantelopeMelonExcpt ex;
    GetidlServerCantelopeMelonExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::CantelopeMelon;
  GetCantelopeMelon(ReturnValue);
  p2 = new ::CantelopeMelon;
  GetCantelopeMelon(p2);
  GetCantelopeMelon(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CantelopeMelonOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::LolloRossa*
idlServer_imp::LolloRossaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::LolloRossa* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LolloRossaAttr\n");
#endif
  
  ernie.seed("LolloRossaAttrCall");
  
  ernie.seed("LolloRossaAttrReturn"); 
  ReturnValue = new ::LolloRossa;
  GetLolloRossa(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LolloRossaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::LolloRossaAttr(const ::LolloRossa &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LolloRossaAttr\n");
#endif
  
  ernie.seed("LolloRossaAttrCall");
  AddName("_attr");
  if (!CheckLolloRossa(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LolloRossaAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LolloRossaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::LolloRossa*
idlServer_imp::LolloRossaOp(const ::LolloRossa &p1,::LolloRossa_out p2,::LolloRossa &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::LolloRossa* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LolloRossaOp\n");
#endif
  
  ernie.seed("LolloRossaOpCall");
  AddName("p1");
  if (!CheckLolloRossa(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckLolloRossa(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LolloRossaOpReturn"); 
  {
    ::idlServer::LolloRossaExcpt ex;
    GetidlServerLolloRossaExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::LolloRossa;
  GetLolloRossa(*ReturnValue);
  p2 = new ::LolloRossa;
  GetLolloRossa(*(p2.ptr()));
  GetLolloRossa(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LolloRossaOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::RowanBerry_slice *
idlServer_imp::RowanBerryAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::RowanBerry_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RowanBerryAttr\n");
#endif
  
  ernie.seed("RowanBerryAttrCall");
  
  ernie.seed("RowanBerryAttrReturn"); 
  
  ReturnValue = new ::RowanBerry;
  GetRowanBerry(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RowanBerryAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::RowanBerryAttr(const ::RowanBerry _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RowanBerryAttr\n");
#endif
  
  ernie.seed("RowanBerryAttrCall");
  AddName("_attr");
  if (!CheckRowanBerry(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RowanBerryAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RowanBerryAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::RowanBerry_slice *
idlServer_imp::RowanBerryOp(const ::RowanBerry p1,::RowanBerry_out p2,::RowanBerry p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::RowanBerry_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RowanBerryOp\n");
#endif
  
  ernie.seed("RowanBerryOpCall");
  AddName("p1");
  if (!CheckRowanBerry(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckRowanBerry(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RowanBerryOpReturn"); 
  {
    ::idlServer::RowanBerryExcpt ex;
    GetidlServerRowanBerryExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::RowanBerry;
  GetRowanBerry(ReturnValue);
  p2 = new ::RowanBerry;
  GetRowanBerry(p2);
  GetRowanBerry(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RowanBerryOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



