//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Sweetcorn*
idlServer_imp::SweetcornAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Sweetcorn* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SweetcornAttr\n");
#endif
  
  ernie.seed("SweetcornAttrCall");
  
  ernie.seed("SweetcornAttrReturn"); 
  ReturnValue = new ::Sweetcorn;
  GetSweetcorn(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SweetcornAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::SweetcornAttr(const ::Sweetcorn &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SweetcornAttr\n");
#endif
  
  ernie.seed("SweetcornAttrCall");
  AddName("_attr");
  if (!CheckSweetcorn(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SweetcornAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SweetcornAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Sweetcorn*
idlServer_imp::SweetcornOp(const ::Sweetcorn &p1,::Sweetcorn_out p2,::Sweetcorn &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Sweetcorn* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SweetcornOp\n");
#endif
  
  ernie.seed("SweetcornOpCall");
  AddName("p1");
  if (!CheckSweetcorn(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckSweetcorn(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SweetcornOpReturn"); 
  {
    ::idlServer::SweetcornExcpt ex;
    GetidlServerSweetcornExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Sweetcorn;
  GetSweetcorn(*ReturnValue);
  p2 = new ::Sweetcorn;
  GetSweetcorn(*(p2.ptr()));
  GetSweetcorn(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SweetcornOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Onion_slice *
idlServer_imp::OnionAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Onion_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::OnionAttr\n");
#endif
  
  ernie.seed("OnionAttrCall");
  
  ernie.seed("OnionAttrReturn"); 
  
  ReturnValue = new ::Onion;
  GetOnion(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::OnionAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::OnionAttr(const ::Onion _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::OnionAttr\n");
#endif
  
  ernie.seed("OnionAttrCall");
  AddName("_attr");
  if (!CheckOnion(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("OnionAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::OnionAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Onion_slice *
idlServer_imp::OnionOp(const ::Onion p1,::Onion_out p2,::Onion p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Onion_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::OnionOp\n");
#endif
  
  ernie.seed("OnionOpCall");
  AddName("p1");
  if (!CheckOnion(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckOnion(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("OnionOpReturn"); 
  {
    ::idlServer::OnionExcpt ex;
    GetidlServerOnionExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Onion;
  GetOnion(ReturnValue);
  p2 = new ::Onion;
  GetOnion(p2);
  GetOnion(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::OnionOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Shallots*
idlServer_imp::ShallotsAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Shallots* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ShallotsAttr\n");
#endif
  
  ernie.seed("ShallotsAttrCall");
  
  ernie.seed("ShallotsAttrReturn"); 
  ReturnValue = new ::Shallots;
  GetShallots(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ShallotsAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::ShallotsAttr(const ::Shallots &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ShallotsAttr\n");
#endif
  
  ernie.seed("ShallotsAttrCall");
  AddName("_attr");
  if (!CheckShallots(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ShallotsAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ShallotsAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Shallots*
idlServer_imp::ShallotsOp(const ::Shallots &p1,::Shallots_out p2,::Shallots &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Shallots* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ShallotsOp\n");
#endif
  
  ernie.seed("ShallotsOpCall");
  AddName("p1");
  if (!CheckShallots(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckShallots(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ShallotsOpReturn"); 
  {
    ::idlServer::ShallotsExcpt ex;
    GetidlServerShallotsExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Shallots;
  GetShallots(*ReturnValue);
  p2 = new ::Shallots;
  GetShallots(*(p2.ptr()));
  GetShallots(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ShallotsOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Plum_slice *
idlServer_imp::PlumAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Plum_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PlumAttr\n");
#endif
  
  ernie.seed("PlumAttrCall");
  
  ernie.seed("PlumAttrReturn"); 
  
  ReturnValue = new ::Plum;
  GetPlum(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PlumAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::PlumAttr(const ::Plum _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PlumAttr\n");
#endif
  
  ernie.seed("PlumAttrCall");
  AddName("_attr");
  if (!CheckPlum(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PlumAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PlumAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Plum_slice *
idlServer_imp::PlumOp(const ::Plum p1,::Plum_out p2,::Plum p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Plum_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PlumOp\n");
#endif
  
  ernie.seed("PlumOpCall");
  AddName("p1");
  if (!CheckPlum(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPlum(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PlumOpReturn"); 
  {
    ::idlServer::PlumExcpt ex;
    GetidlServerPlumExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Plum;
  GetPlum(ReturnValue);
  p2 = new ::Plum;
  GetPlum(p2);
  GetPlum(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PlumOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::KidneyBean*
idlServer_imp::KidneyBeanAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::KidneyBean* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KidneyBeanAttr\n");
#endif
  
  ernie.seed("KidneyBeanAttrCall");
  
  ernie.seed("KidneyBeanAttrReturn"); 
  ReturnValue = new ::KidneyBean;
  GetKidneyBean(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KidneyBeanAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::KidneyBeanAttr(const ::KidneyBean &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KidneyBeanAttr\n");
#endif
  
  ernie.seed("KidneyBeanAttrCall");
  AddName("_attr");
  if (!CheckKidneyBean(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KidneyBeanAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KidneyBeanAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::KidneyBean*
idlServer_imp::KidneyBeanOp(const ::KidneyBean &p1,::KidneyBean_out p2,::KidneyBean &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::KidneyBean* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KidneyBeanOp\n");
#endif
  
  ernie.seed("KidneyBeanOpCall");
  AddName("p1");
  if (!CheckKidneyBean(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckKidneyBean(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KidneyBeanOpReturn"); 
  {
    ::idlServer::KidneyBeanExcpt ex;
    GetidlServerKidneyBeanExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::KidneyBean;
  GetKidneyBean(*ReturnValue);
  p2 = new ::KidneyBean;
  GetKidneyBean(*(p2.ptr()));
  GetKidneyBean(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KidneyBeanOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Zucchini_slice *
idlServer_imp::ZucchiniAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Zucchini_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ZucchiniAttr\n");
#endif
  
  ernie.seed("ZucchiniAttrCall");
  
  ernie.seed("ZucchiniAttrReturn"); 
  
  ReturnValue = new ::Zucchini;
  GetZucchini(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ZucchiniAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::ZucchiniAttr(const ::Zucchini _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ZucchiniAttr\n");
#endif
  
  ernie.seed("ZucchiniAttrCall");
  AddName("_attr");
  if (!CheckZucchini(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ZucchiniAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ZucchiniAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Zucchini_slice *
idlServer_imp::ZucchiniOp(const ::Zucchini p1,::Zucchini_out p2,::Zucchini p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Zucchini_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ZucchiniOp\n");
#endif
  
  ernie.seed("ZucchiniOpCall");
  AddName("p1");
  if (!CheckZucchini(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckZucchini(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ZucchiniOpReturn"); 
  {
    ::idlServer::ZucchiniExcpt ex;
    GetidlServerZucchiniExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Zucchini;
  GetZucchini(ReturnValue);
  p2 = new ::Zucchini;
  GetZucchini(p2);
  GetZucchini(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ZucchiniOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::ButterBean*
idlServer_imp::ButterBeanAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::ButterBean* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ButterBeanAttr\n");
#endif
  
  ernie.seed("ButterBeanAttrCall");
  
  ernie.seed("ButterBeanAttrReturn"); 
  ReturnValue = new ::ButterBean;
  GetButterBean(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ButterBeanAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::ButterBeanAttr(const ::ButterBean &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ButterBeanAttr\n");
#endif
  
  ernie.seed("ButterBeanAttrCall");
  AddName("_attr");
  if (!CheckButterBean(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ButterBeanAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ButterBeanAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::ButterBean*
idlServer_imp::ButterBeanOp(const ::ButterBean &p1,::ButterBean_out p2,::ButterBean &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::ButterBean* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ButterBeanOp\n");
#endif
  
  ernie.seed("ButterBeanOpCall");
  AddName("p1");
  if (!CheckButterBean(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckButterBean(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ButterBeanOpReturn"); 
  {
    ::idlServer::ButterBeanExcpt ex;
    GetidlServerButterBeanExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::ButterBean;
  GetButterBean(*ReturnValue);
  p2 = new ::ButterBean;
  GetButterBean(*(p2.ptr()));
  GetButterBean(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ButterBeanOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Avocado_slice *
idlServer_imp::AvocadoAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoAttr\n");
#endif
  
  ernie.seed("AvocadoAttrCall");
  
  ernie.seed("AvocadoAttrReturn"); 
  
  ReturnValue = new ::Avocado;
  GetAvocado(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::AvocadoAttr(const ::Avocado _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoAttr\n");
#endif
  
  ernie.seed("AvocadoAttrCall");
  AddName("_attr");
  if (!CheckAvocado(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AvocadoAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Avocado_slice *
idlServer_imp::AvocadoOp(const ::Avocado p1,::Avocado_out p2,::Avocado p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Avocado_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoOp\n");
#endif
  
  ernie.seed("AvocadoOpCall");
  AddName("p1");
  if (!CheckAvocado(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAvocado(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AvocadoOpReturn"); 
  {
    ::idlServer::AvocadoExcpt ex;
    GetidlServerAvocadoExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Avocado;
  GetAvocado(ReturnValue);
  p2 = new ::Avocado;
  GetAvocado(p2);
  GetAvocado(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



