//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:20  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/26 13:51:05  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/15 10:51:47  james
// #ifdefs removed
//
// Revision 1.4  1997/12/09 11:26:53  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetGoldenDelicous(::GoldenDelicous &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGoldenDelicous");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%18;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%18;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetFloat(v[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckGoldenDelicous(const ::GoldenDelicous &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGoldenDelicous");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%18;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%18;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckFloat(v[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetCrabApple(::CrabApple v)
{
#ifdef DEBUG
  ::tet_infoline("GetCrabApple");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetDouble(v[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCrabApple(const ::CrabApple v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCrabApple");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckDouble(v[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetCinnamon(::Cinnamon &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCinnamon");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%15;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetDouble(v[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCinnamon(const ::Cinnamon &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCinnamon");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%15;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckDouble(v[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetJuniperBerries(::JuniperBerries v)
{
#ifdef DEBUG
  ::tet_infoline("GetJuniperBerries");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%11;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetDouble(v[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckJuniperBerries(const ::JuniperBerries v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckJuniperBerries");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%11;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckDouble(v[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetMustard(::Mustard &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMustard");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%19;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetLong(v[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMustard(const ::Mustard &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMustard");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%19;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckLong(v[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetThyme(::Thyme v)
{
#ifdef DEBUG
  ::tet_infoline("GetThyme");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%12;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetLong(v[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckThyme(const ::Thyme v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckThyme");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%12;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckLong(v[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetTarragon(::Tarragon &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTarragon");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetShort(v[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckTarragon(const ::Tarragon &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTarragon");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckShort(v[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetCress(::Cress v)
{
#ifdef DEBUG
  ::tet_infoline("GetCress");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%9;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetShort(v[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCress(const ::Cress v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCress");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%9;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckShort(v[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetidlServerGoldenDelicousExcpt(::idlServer::GoldenDelicousExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerGoldenDelicousExcpt");
#endif

  GetGoldenDelicous(v.ex1);
}

int CheckidlServerGoldenDelicousExcpt(const ::idlServer::GoldenDelicousExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerGoldenDelicousExcpt");
#endif

  AddName("ex1");
  if (!CheckGoldenDelicous(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerCrabAppleExcpt(::idlServer::CrabAppleExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerCrabAppleExcpt");
#endif

  GetCrabApple(v.ex1);
}

int CheckidlServerCrabAppleExcpt(const ::idlServer::CrabAppleExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerCrabAppleExcpt");
#endif

  AddName("ex1");
  if (!CheckCrabApple(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerCinnamonExcpt(::idlServer::CinnamonExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerCinnamonExcpt");
#endif

  GetCinnamon(v.ex1);
}

int CheckidlServerCinnamonExcpt(const ::idlServer::CinnamonExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerCinnamonExcpt");
#endif

  AddName("ex1");
  if (!CheckCinnamon(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerJuniperBerriesExcpt(::idlServer::JuniperBerriesExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerJuniperBerriesExcpt");
#endif

  GetJuniperBerries(v.ex1);
}

int CheckidlServerJuniperBerriesExcpt(const ::idlServer::JuniperBerriesExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerJuniperBerriesExcpt");
#endif

  AddName("ex1");
  if (!CheckJuniperBerries(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerMustardExcpt(::idlServer::MustardExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerMustardExcpt");
#endif

  GetMustard(v.ex1);
}

int CheckidlServerMustardExcpt(const ::idlServer::MustardExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerMustardExcpt");
#endif

  AddName("ex1");
  if (!CheckMustard(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerThymeExcpt(::idlServer::ThymeExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerThymeExcpt");
#endif

  GetThyme(v.ex1);
}

int CheckidlServerThymeExcpt(const ::idlServer::ThymeExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerThymeExcpt");
#endif

  AddName("ex1");
  if (!CheckThyme(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerTarragonExcpt(::idlServer::TarragonExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerTarragonExcpt");
#endif

  GetTarragon(v.ex1);
}

int CheckidlServerTarragonExcpt(const ::idlServer::TarragonExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerTarragonExcpt");
#endif

  AddName("ex1");
  if (!CheckTarragon(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerCressExcpt(::idlServer::CressExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerCressExcpt");
#endif

  GetCress(v.ex1);
}

int CheckidlServerCressExcpt(const ::idlServer::CressExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerCressExcpt");
#endif

  AddName("ex1");
  if (!CheckCress(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



