//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::GoldenDelicous*
idlServer_imp::GoldenDelicousAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::GoldenDelicous* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GoldenDelicousAttr\n");
#endif
  
  ernie.seed("GoldenDelicousAttrCall");
  
  ernie.seed("GoldenDelicousAttrReturn"); 
  ReturnValue = new ::GoldenDelicous;
  GetGoldenDelicous(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GoldenDelicousAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::GoldenDelicousAttr(const ::GoldenDelicous &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GoldenDelicousAttr\n");
#endif
  
  ernie.seed("GoldenDelicousAttrCall");
  AddName("_attr");
  if (!CheckGoldenDelicous(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GoldenDelicousAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GoldenDelicousAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::GoldenDelicous*
idlServer_imp::GoldenDelicousOp(const ::GoldenDelicous &p1,::GoldenDelicous_out p2,::GoldenDelicous &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::GoldenDelicous* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GoldenDelicousOp\n");
#endif
  
  ernie.seed("GoldenDelicousOpCall");
  AddName("p1");
  if (!CheckGoldenDelicous(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGoldenDelicous(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GoldenDelicousOpReturn"); 
  {
    ::idlServer::GoldenDelicousExcpt ex;
    GetidlServerGoldenDelicousExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::GoldenDelicous;
  GetGoldenDelicous(*ReturnValue);
  p2 = new ::GoldenDelicous;
  GetGoldenDelicous(*(p2.ptr()));
  GetGoldenDelicous(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GoldenDelicousOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::CrabApple_slice *
idlServer_imp::CrabAppleAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::CrabApple_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CrabAppleAttr\n");
#endif
  
  ernie.seed("CrabAppleAttrCall");
  
  ernie.seed("CrabAppleAttrReturn"); 
  
  ReturnValue = new ::CrabApple;
  GetCrabApple(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CrabAppleAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::CrabAppleAttr(const ::CrabApple _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CrabAppleAttr\n");
#endif
  
  ernie.seed("CrabAppleAttrCall");
  AddName("_attr");
  if (!CheckCrabApple(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CrabAppleAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CrabAppleAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::CrabApple_slice *
idlServer_imp::CrabAppleOp(const ::CrabApple p1,::CrabApple_out p2,::CrabApple p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::CrabApple_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CrabAppleOp\n");
#endif
  
  ernie.seed("CrabAppleOpCall");
  AddName("p1");
  if (!CheckCrabApple(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCrabApple(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CrabAppleOpReturn"); 
  {
    ::idlServer::CrabAppleExcpt ex;
    GetidlServerCrabAppleExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::CrabApple;
  GetCrabApple(ReturnValue);
  p2 = new ::CrabApple;
  GetCrabApple(p2);
  GetCrabApple(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CrabAppleOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Cinnamon*
idlServer_imp::CinnamonAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Cinnamon* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CinnamonAttr\n");
#endif
  
  ernie.seed("CinnamonAttrCall");
  
  ernie.seed("CinnamonAttrReturn"); 
  ReturnValue = new ::Cinnamon;
  GetCinnamon(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CinnamonAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::CinnamonAttr(const ::Cinnamon &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CinnamonAttr\n");
#endif
  
  ernie.seed("CinnamonAttrCall");
  AddName("_attr");
  if (!CheckCinnamon(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CinnamonAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CinnamonAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Cinnamon*
idlServer_imp::CinnamonOp(const ::Cinnamon &p1,::Cinnamon_out p2,::Cinnamon &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Cinnamon* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CinnamonOp\n");
#endif
  
  ernie.seed("CinnamonOpCall");
  AddName("p1");
  if (!CheckCinnamon(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCinnamon(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CinnamonOpReturn"); 
  {
    ::idlServer::CinnamonExcpt ex;
    GetidlServerCinnamonExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Cinnamon;
  GetCinnamon(*ReturnValue);
  p2 = new ::Cinnamon;
  GetCinnamon(*(p2.ptr()));
  GetCinnamon(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CinnamonOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::JuniperBerries_slice *
idlServer_imp::JuniperBerriesAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::JuniperBerries_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::JuniperBerriesAttr\n");
#endif
  
  ernie.seed("JuniperBerriesAttrCall");
  
  ernie.seed("JuniperBerriesAttrReturn"); 
  
  ReturnValue = new ::JuniperBerries;
  GetJuniperBerries(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::JuniperBerriesAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::JuniperBerriesAttr(const ::JuniperBerries _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::JuniperBerriesAttr\n");
#endif
  
  ernie.seed("JuniperBerriesAttrCall");
  AddName("_attr");
  if (!CheckJuniperBerries(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("JuniperBerriesAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::JuniperBerriesAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::JuniperBerries_slice *
idlServer_imp::JuniperBerriesOp(const ::JuniperBerries p1,::JuniperBerries_out p2,::JuniperBerries p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::JuniperBerries_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::JuniperBerriesOp\n");
#endif
  
  ernie.seed("JuniperBerriesOpCall");
  AddName("p1");
  if (!CheckJuniperBerries(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckJuniperBerries(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("JuniperBerriesOpReturn"); 
  {
    ::idlServer::JuniperBerriesExcpt ex;
    GetidlServerJuniperBerriesExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::JuniperBerries;
  GetJuniperBerries(ReturnValue);
  p2 = new ::JuniperBerries;
  GetJuniperBerries(p2);
  GetJuniperBerries(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::JuniperBerriesOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Mustard*
idlServer_imp::MustardAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Mustard* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MustardAttr\n");
#endif
  
  ernie.seed("MustardAttrCall");
  
  ernie.seed("MustardAttrReturn"); 
  ReturnValue = new ::Mustard;
  GetMustard(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MustardAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::MustardAttr(const ::Mustard &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MustardAttr\n");
#endif
  
  ernie.seed("MustardAttrCall");
  AddName("_attr");
  if (!CheckMustard(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MustardAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MustardAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Mustard*
idlServer_imp::MustardOp(const ::Mustard &p1,::Mustard_out p2,::Mustard &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Mustard* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MustardOp\n");
#endif
  
  ernie.seed("MustardOpCall");
  AddName("p1");
  if (!CheckMustard(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckMustard(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MustardOpReturn"); 
  {
    ::idlServer::MustardExcpt ex;
    GetidlServerMustardExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Mustard;
  GetMustard(*ReturnValue);
  p2 = new ::Mustard;
  GetMustard(*(p2.ptr()));
  GetMustard(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MustardOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Thyme_slice *
idlServer_imp::ThymeAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Thyme_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ThymeAttr\n");
#endif
  
  ernie.seed("ThymeAttrCall");
  
  ernie.seed("ThymeAttrReturn"); 
  
  ReturnValue = new ::Thyme;
  GetThyme(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ThymeAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::ThymeAttr(const ::Thyme _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ThymeAttr\n");
#endif
  
  ernie.seed("ThymeAttrCall");
  AddName("_attr");
  if (!CheckThyme(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ThymeAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ThymeAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Thyme_slice *
idlServer_imp::ThymeOp(const ::Thyme p1,::Thyme_out p2,::Thyme p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Thyme_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ThymeOp\n");
#endif
  
  ernie.seed("ThymeOpCall");
  AddName("p1");
  if (!CheckThyme(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckThyme(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ThymeOpReturn"); 
  {
    ::idlServer::ThymeExcpt ex;
    GetidlServerThymeExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Thyme;
  GetThyme(ReturnValue);
  p2 = new ::Thyme;
  GetThyme(p2);
  GetThyme(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ThymeOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Tarragon*
idlServer_imp::TarragonAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Tarragon* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::TarragonAttr\n");
#endif
  
  ernie.seed("TarragonAttrCall");
  
  ernie.seed("TarragonAttrReturn"); 
  ReturnValue = new ::Tarragon;
  GetTarragon(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::TarragonAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::TarragonAttr(const ::Tarragon &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::TarragonAttr\n");
#endif
  
  ernie.seed("TarragonAttrCall");
  AddName("_attr");
  if (!CheckTarragon(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("TarragonAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::TarragonAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Tarragon*
idlServer_imp::TarragonOp(const ::Tarragon &p1,::Tarragon_out p2,::Tarragon &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Tarragon* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::TarragonOp\n");
#endif
  
  ernie.seed("TarragonOpCall");
  AddName("p1");
  if (!CheckTarragon(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckTarragon(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("TarragonOpReturn"); 
  {
    ::idlServer::TarragonExcpt ex;
    GetidlServerTarragonExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Tarragon;
  GetTarragon(*ReturnValue);
  p2 = new ::Tarragon;
  GetTarragon(*(p2.ptr()));
  GetTarragon(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::TarragonOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Cress_slice *
idlServer_imp::CressAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Cress_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CressAttr\n");
#endif
  
  ernie.seed("CressAttrCall");
  
  ernie.seed("CressAttrReturn"); 
  
  ReturnValue = new ::Cress;
  GetCress(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CressAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::CressAttr(const ::Cress _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CressAttr\n");
#endif
  
  ernie.seed("CressAttrCall");
  AddName("_attr");
  if (!CheckCress(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CressAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CressAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Cress_slice *
idlServer_imp::CressOp(const ::Cress p1,::Cress_out p2,::Cress p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Cress_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CressOp\n");
#endif
  
  ernie.seed("CressOpCall");
  AddName("p1");
  if (!CheckCress(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCress(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CressOpReturn"); 
  {
    ::idlServer::CressExcpt ex;
    GetidlServerCressExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Cress;
  GetCress(ReturnValue);
  p2 = new ::Cress;
  GetCress(p2);
  GetCress(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CressOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



