//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Melon*
idlServer_imp::MelonAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Melon* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MelonAttr\n");
#endif
  
  ernie.seed("MelonAttrCall");
  
  ernie.seed("MelonAttrReturn"); 
  ReturnValue = new ::Melon;
  GetMelon(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MelonAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::MelonAttr(const ::Melon &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MelonAttr\n");
#endif
  
  ernie.seed("MelonAttrCall");
  AddName("_attr");
  if (!CheckMelon(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MelonAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MelonAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Melon*
idlServer_imp::MelonOp(const ::Melon &p1,::Melon_out p2,::Melon &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Melon* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MelonOp\n");
#endif
  
  ernie.seed("MelonOpCall");
  AddName("p1");
  if (!CheckMelon(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckMelon(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MelonOpReturn"); 
  {
    ::idlServer::MelonExcpt ex;
    GetidlServerMelonExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Melon;
  GetMelon(*ReturnValue);
  p2 = new ::Melon;
  GetMelon(*(p2.ptr()));
  GetMelon(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MelonOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Elderberry_slice *
idlServer_imp::ElderberryAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Elderberry_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ElderberryAttr\n");
#endif
  
  ernie.seed("ElderberryAttrCall");
  
  ernie.seed("ElderberryAttrReturn"); 
  
  ReturnValue = new ::Elderberry;
  GetElderberry(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ElderberryAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::ElderberryAttr(const ::Elderberry _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ElderberryAttr\n");
#endif
  
  ernie.seed("ElderberryAttrCall");
  AddName("_attr");
  if (!CheckElderberry(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ElderberryAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ElderberryAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Elderberry_slice *
idlServer_imp::ElderberryOp(const ::Elderberry p1,::Elderberry_out p2,::Elderberry p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Elderberry_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ElderberryOp\n");
#endif
  
  ernie.seed("ElderberryOpCall");
  AddName("p1");
  if (!CheckElderberry(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckElderberry(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ElderberryOpReturn"); 
  {
    ::idlServer::ElderberryExcpt ex;
    GetidlServerElderberryExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Elderberry;
  GetElderberry(ReturnValue);
  p2 = new ::Elderberry;
  GetElderberry(p2);
  GetElderberry(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ElderberryOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Fennell*
idlServer_imp::FennellAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Fennell* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::FennellAttr\n");
#endif
  
  ernie.seed("FennellAttrCall");
  
  ernie.seed("FennellAttrReturn"); 
  ReturnValue = new ::Fennell;
  GetFennell(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::FennellAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::FennellAttr(const ::Fennell &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::FennellAttr\n");
#endif
  
  ernie.seed("FennellAttrCall");
  AddName("_attr");
  if (!CheckFennell(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("FennellAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::FennellAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Fennell*
idlServer_imp::FennellOp(const ::Fennell &p1,::Fennell_out p2,::Fennell &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Fennell* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::FennellOp\n");
#endif
  
  ernie.seed("FennellOpCall");
  AddName("p1");
  if (!CheckFennell(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckFennell(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("FennellOpReturn"); 
  {
    ::idlServer::FennellExcpt ex;
    GetidlServerFennellExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Fennell;
  GetFennell(*ReturnValue);
  p2 = new ::Fennell;
  GetFennell(*(p2.ptr()));
  GetFennell(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::FennellOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Chickpea_slice *
idlServer_imp::ChickpeaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Chickpea_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ChickpeaAttr\n");
#endif
  
  ernie.seed("ChickpeaAttrCall");
  
  ernie.seed("ChickpeaAttrReturn"); 
  
  ReturnValue = new ::Chickpea;
  GetChickpea(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ChickpeaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::ChickpeaAttr(const ::Chickpea _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ChickpeaAttr\n");
#endif
  
  ernie.seed("ChickpeaAttrCall");
  AddName("_attr");
  if (!CheckChickpea(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ChickpeaAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ChickpeaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Chickpea_slice *
idlServer_imp::ChickpeaOp(const ::Chickpea p1,::Chickpea_out p2,::Chickpea p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Chickpea_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ChickpeaOp\n");
#endif
  
  ernie.seed("ChickpeaOpCall");
  AddName("p1");
  if (!CheckChickpea(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckChickpea(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ChickpeaOpReturn"); 
  {
    ::idlServer::ChickpeaExcpt ex;
    GetidlServerChickpeaExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Chickpea;
  GetChickpea(ReturnValue);
  p2 = new ::Chickpea;
  GetChickpea(p2);
  GetChickpea(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ChickpeaOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Plantain*
idlServer_imp::PlantainAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Plantain* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PlantainAttr\n");
#endif
  
  ernie.seed("PlantainAttrCall");
  
  ernie.seed("PlantainAttrReturn"); 
  ReturnValue = new ::Plantain;
  GetPlantain(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PlantainAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::PlantainAttr(const ::Plantain &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PlantainAttr\n");
#endif
  
  ernie.seed("PlantainAttrCall");
  AddName("_attr");
  if (!CheckPlantain(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PlantainAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PlantainAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Plantain*
idlServer_imp::PlantainOp(const ::Plantain &p1,::Plantain_out p2,::Plantain &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Plantain* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PlantainOp\n");
#endif
  
  ernie.seed("PlantainOpCall");
  AddName("p1");
  if (!CheckPlantain(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPlantain(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PlantainOpReturn"); 
  {
    ::idlServer::PlantainExcpt ex;
    GetidlServerPlantainExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Plantain;
  GetPlantain(*ReturnValue);
  p2 = new ::Plantain;
  GetPlantain(*(p2.ptr()));
  GetPlantain(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PlantainOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::LimaBean_slice *
idlServer_imp::LimaBeanAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::LimaBean_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LimaBeanAttr\n");
#endif
  
  ernie.seed("LimaBeanAttrCall");
  
  ernie.seed("LimaBeanAttrReturn"); 
  
  ReturnValue = new ::LimaBean;
  GetLimaBean(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LimaBeanAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::LimaBeanAttr(const ::LimaBean _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LimaBeanAttr\n");
#endif
  
  ernie.seed("LimaBeanAttrCall");
  AddName("_attr");
  if (!CheckLimaBean(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LimaBeanAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LimaBeanAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::LimaBean_slice *
idlServer_imp::LimaBeanOp(const ::LimaBean p1,::LimaBean_out p2,::LimaBean p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::LimaBean_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LimaBeanOp\n");
#endif
  
  ernie.seed("LimaBeanOpCall");
  AddName("p1");
  if (!CheckLimaBean(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckLimaBean(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LimaBeanOpReturn"); 
  {
    ::idlServer::LimaBeanExcpt ex;
    GetidlServerLimaBeanExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::LimaBean;
  GetLimaBean(ReturnValue);
  p2 = new ::LimaBean;
  GetLimaBean(p2);
  GetLimaBean(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LimaBeanOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::RedPepper*
idlServer_imp::RedPepperAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::RedPepper* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedPepperAttr\n");
#endif
  
  ernie.seed("RedPepperAttrCall");
  
  ernie.seed("RedPepperAttrReturn"); 
  ReturnValue = new ::RedPepper;
  GetRedPepper(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedPepperAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::RedPepperAttr(const ::RedPepper &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedPepperAttr\n");
#endif
  
  ernie.seed("RedPepperAttrCall");
  AddName("_attr");
  if (!CheckRedPepper(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedPepperAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedPepperAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::RedPepper*
idlServer_imp::RedPepperOp(const ::RedPepper &p1,::RedPepper_out p2,::RedPepper &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::RedPepper* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedPepperOp\n");
#endif
  
  ernie.seed("RedPepperOpCall");
  AddName("p1");
  if (!CheckRedPepper(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckRedPepper(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedPepperOpReturn"); 
  {
    ::idlServer::RedPepperExcpt ex;
    GetidlServerRedPepperExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::RedPepper;
  GetRedPepper(*ReturnValue);
  p2 = new ::RedPepper;
  GetRedPepper(*(p2.ptr()));
  GetRedPepper(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedPepperOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Sharanfruit_slice *
idlServer_imp::SharanfruitAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Sharanfruit_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SharanfruitAttr\n");
#endif
  
  ernie.seed("SharanfruitAttrCall");
  
  ernie.seed("SharanfruitAttrReturn"); 
  
  ReturnValue = new ::Sharanfruit;
  GetSharanfruit(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SharanfruitAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::SharanfruitAttr(const ::Sharanfruit _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SharanfruitAttr\n");
#endif
  
  ernie.seed("SharanfruitAttrCall");
  AddName("_attr");
  if (!CheckSharanfruit(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SharanfruitAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SharanfruitAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Sharanfruit_slice *
idlServer_imp::SharanfruitOp(const ::Sharanfruit p1,::Sharanfruit_out p2,::Sharanfruit p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Sharanfruit_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SharanfruitOp\n");
#endif
  
  ernie.seed("SharanfruitOpCall");
  AddName("p1");
  if (!CheckSharanfruit(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckSharanfruit(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SharanfruitOpReturn"); 
  {
    ::idlServer::SharanfruitExcpt ex;
    GetidlServerSharanfruitExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Sharanfruit;
  GetSharanfruit(ReturnValue);
  p2 = new ::Sharanfruit;
  GetSharanfruit(p2);
  GetSharanfruit(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SharanfruitOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



