//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Papaya*
idlServer_imp::PapayaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Papaya* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PapayaAttr\n");
#endif
  
  ernie.seed("PapayaAttrCall");
  
  ernie.seed("PapayaAttrReturn"); 
  ReturnValue = new ::Papaya;
  GetPapaya(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PapayaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::PapayaAttr(const ::Papaya &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PapayaAttr\n");
#endif
  
  ernie.seed("PapayaAttrCall");
  AddName("_attr");
  if (!CheckPapaya(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PapayaAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PapayaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Papaya*
idlServer_imp::PapayaOp(const ::Papaya &p1,::Papaya_out p2,::Papaya &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Papaya* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PapayaOp\n");
#endif
  
  ernie.seed("PapayaOpCall");
  AddName("p1");
  if (!CheckPapaya(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPapaya(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PapayaOpReturn"); 
  {
    ::idlServer::PapayaExcpt ex;
    GetidlServerPapayaExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Papaya;
  GetPapaya(*ReturnValue);
  p2 = new ::Papaya;
  GetPapaya(*(p2.ptr()));
  GetPapaya(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PapayaOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Raspberry_slice *
idlServer_imp::RaspberryAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Raspberry_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RaspberryAttr\n");
#endif
  
  ernie.seed("RaspberryAttrCall");
  
  ernie.seed("RaspberryAttrReturn"); 
  
  ReturnValue = new ::Raspberry;
  GetRaspberry(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RaspberryAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::RaspberryAttr(const ::Raspberry _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RaspberryAttr\n");
#endif
  
  ernie.seed("RaspberryAttrCall");
  AddName("_attr");
  if (!CheckRaspberry(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RaspberryAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RaspberryAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Raspberry_slice *
idlServer_imp::RaspberryOp(const ::Raspberry p1,::Raspberry_out p2,::Raspberry p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Raspberry_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RaspberryOp\n");
#endif
  
  ernie.seed("RaspberryOpCall");
  AddName("p1");
  if (!CheckRaspberry(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckRaspberry(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RaspberryOpReturn"); 
  {
    ::idlServer::RaspberryExcpt ex;
    GetidlServerRaspberryExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Raspberry;
  GetRaspberry(ReturnValue);
  p2 = new ::Raspberry;
  GetRaspberry(p2);
  GetRaspberry(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RaspberryOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Damsons*
idlServer_imp::DamsonsAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Damsons* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::DamsonsAttr\n");
#endif
  
  ernie.seed("DamsonsAttrCall");
  
  ernie.seed("DamsonsAttrReturn"); 
  ReturnValue = new ::Damsons;
  GetDamsons(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::DamsonsAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::DamsonsAttr(const ::Damsons &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::DamsonsAttr\n");
#endif
  
  ernie.seed("DamsonsAttrCall");
  AddName("_attr");
  if (!CheckDamsons(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("DamsonsAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::DamsonsAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Damsons*
idlServer_imp::DamsonsOp(const ::Damsons &p1,::Damsons_out p2,::Damsons &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Damsons* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::DamsonsOp\n");
#endif
  
  ernie.seed("DamsonsOpCall");
  AddName("p1");
  if (!CheckDamsons(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckDamsons(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("DamsonsOpReturn"); 
  {
    ::idlServer::DamsonsExcpt ex;
    GetidlServerDamsonsExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Damsons;
  GetDamsons(*ReturnValue);
  p2 = new ::Damsons;
  GetDamsons(*(p2.ptr()));
  GetDamsons(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::DamsonsOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Artichokes_slice *
idlServer_imp::ArtichokesAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Artichokes_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ArtichokesAttr\n");
#endif
  
  ernie.seed("ArtichokesAttrCall");
  
  ernie.seed("ArtichokesAttrReturn"); 
  
  ReturnValue = new ::Artichokes;
  GetArtichokes(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ArtichokesAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::ArtichokesAttr(const ::Artichokes _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ArtichokesAttr\n");
#endif
  
  ernie.seed("ArtichokesAttrCall");
  AddName("_attr");
  if (!CheckArtichokes(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ArtichokesAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ArtichokesAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Artichokes_slice *
idlServer_imp::ArtichokesOp(const ::Artichokes p1,::Artichokes_out p2,::Artichokes p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Artichokes_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ArtichokesOp\n");
#endif
  
  ernie.seed("ArtichokesOpCall");
  AddName("p1");
  if (!CheckArtichokes(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckArtichokes(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ArtichokesOpReturn"); 
  {
    ::idlServer::ArtichokesExcpt ex;
    GetidlServerArtichokesExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Artichokes;
  GetArtichokes(ReturnValue);
  p2 = new ::Artichokes;
  GetArtichokes(p2);
  GetArtichokes(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ArtichokesOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::CookingApple*
idlServer_imp::CookingAppleAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::CookingApple* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CookingAppleAttr\n");
#endif
  
  ernie.seed("CookingAppleAttrCall");
  
  ernie.seed("CookingAppleAttrReturn"); 
  ReturnValue = new ::CookingApple;
  GetCookingApple(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CookingAppleAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::CookingAppleAttr(const ::CookingApple &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CookingAppleAttr\n");
#endif
  
  ernie.seed("CookingAppleAttrCall");
  AddName("_attr");
  if (!CheckCookingApple(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CookingAppleAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CookingAppleAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::CookingApple*
idlServer_imp::CookingAppleOp(const ::CookingApple &p1,::CookingApple_out p2,::CookingApple &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::CookingApple* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CookingAppleOp\n");
#endif
  
  ernie.seed("CookingAppleOpCall");
  AddName("p1");
  if (!CheckCookingApple(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCookingApple(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CookingAppleOpReturn"); 
  {
    ::idlServer::CookingAppleExcpt ex;
    GetidlServerCookingAppleExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::CookingApple;
  GetCookingApple(*ReturnValue);
  p2 = new ::CookingApple;
  GetCookingApple(*(p2.ptr()));
  GetCookingApple(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CookingAppleOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GreenChilly_slice *
idlServer_imp::GreenChillyAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::GreenChilly_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GreenChillyAttr\n");
#endif
  
  ernie.seed("GreenChillyAttrCall");
  
  ernie.seed("GreenChillyAttrReturn"); 
  
  ReturnValue = new ::GreenChilly;
  GetGreenChilly(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GreenChillyAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::GreenChillyAttr(const ::GreenChilly _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GreenChillyAttr\n");
#endif
  
  ernie.seed("GreenChillyAttrCall");
  AddName("_attr");
  if (!CheckGreenChilly(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GreenChillyAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GreenChillyAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::GreenChilly_slice *
idlServer_imp::GreenChillyOp(const ::GreenChilly p1,::GreenChilly_out p2,::GreenChilly p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::GreenChilly_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GreenChillyOp\n");
#endif
  
  ernie.seed("GreenChillyOpCall");
  AddName("p1");
  if (!CheckGreenChilly(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGreenChilly(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GreenChillyOpReturn"); 
  {
    ::idlServer::GreenChillyExcpt ex;
    GetidlServerGreenChillyExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::GreenChilly;
  GetGreenChilly(ReturnValue);
  p2 = new ::GreenChilly;
  GetGreenChilly(p2);
  GetGreenChilly(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GreenChillyOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::YellowPepper*
idlServer_imp::YellowPepperAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::YellowPepper* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::YellowPepperAttr\n");
#endif
  
  ernie.seed("YellowPepperAttrCall");
  
  ernie.seed("YellowPepperAttrReturn"); 
  ReturnValue = new ::YellowPepper;
  GetYellowPepper(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::YellowPepperAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::YellowPepperAttr(const ::YellowPepper &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::YellowPepperAttr\n");
#endif
  
  ernie.seed("YellowPepperAttrCall");
  AddName("_attr");
  if (!CheckYellowPepper(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("YellowPepperAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::YellowPepperAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::YellowPepper*
idlServer_imp::YellowPepperOp(const ::YellowPepper &p1,::YellowPepper_out p2,::YellowPepper &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::YellowPepper* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::YellowPepperOp\n");
#endif
  
  ernie.seed("YellowPepperOpCall");
  AddName("p1");
  if (!CheckYellowPepper(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckYellowPepper(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("YellowPepperOpReturn"); 
  {
    ::idlServer::YellowPepperExcpt ex;
    GetidlServerYellowPepperExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::YellowPepper;
  GetYellowPepper(*ReturnValue);
  p2 = new ::YellowPepper;
  GetYellowPepper(*(p2.ptr()));
  GetYellowPepper(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::YellowPepperOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Blueberry_slice *
idlServer_imp::BlueberryAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Blueberry_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BlueberryAttr\n");
#endif
  
  ernie.seed("BlueberryAttrCall");
  
  ernie.seed("BlueberryAttrReturn"); 
  
  ReturnValue = new ::Blueberry;
  GetBlueberry(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BlueberryAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BlueberryAttr(const ::Blueberry _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BlueberryAttr\n");
#endif
  
  ernie.seed("BlueberryAttrCall");
  AddName("_attr");
  if (!CheckBlueberry(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlueberryAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BlueberryAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Blueberry_slice *
idlServer_imp::BlueberryOp(const ::Blueberry p1,::Blueberry_out p2,::Blueberry p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Blueberry_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BlueberryOp\n");
#endif
  
  ernie.seed("BlueberryOpCall");
  AddName("p1");
  if (!CheckBlueberry(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBlueberry(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlueberryOpReturn"); 
  {
    ::idlServer::BlueberryExcpt ex;
    GetidlServerBlueberryExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Blueberry;
  GetBlueberry(ReturnValue);
  p2 = new ::Blueberry;
  GetBlueberry(p2);
  GetBlueberry(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BlueberryOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



