//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Scallion*
idlServer_imp::ScallionAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Scallion* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ScallionAttr\n");
#endif
  
  ernie.seed("ScallionAttrCall");
  
  ernie.seed("ScallionAttrReturn"); 
  ReturnValue = new ::Scallion;
  GetScallion(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ScallionAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::ScallionAttr(const ::Scallion &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ScallionAttr\n");
#endif
  
  ernie.seed("ScallionAttrCall");
  AddName("_attr");
  if (!CheckScallion(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ScallionAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ScallionAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Scallion*
idlServer_imp::ScallionOp(const ::Scallion &p1,::Scallion_out p2,::Scallion &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Scallion* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ScallionOp\n");
#endif
  
  ernie.seed("ScallionOpCall");
  AddName("p1");
  if (!CheckScallion(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckScallion(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ScallionOpReturn"); 
  {
    ::idlServer::ScallionExcpt ex;
    GetidlServerScallionExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Scallion;
  GetScallion(*ReturnValue);
  p2 = new ::Scallion;
  GetScallion(*(p2.ptr()));
  GetScallion(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ScallionOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::KiwanoMelon_slice *
idlServer_imp::KiwanoMelonAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::KiwanoMelon_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KiwanoMelonAttr\n");
#endif
  
  ernie.seed("KiwanoMelonAttrCall");
  
  ernie.seed("KiwanoMelonAttrReturn"); 
  
  ReturnValue = new ::KiwanoMelon;
  GetKiwanoMelon(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KiwanoMelonAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::KiwanoMelonAttr(const ::KiwanoMelon _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KiwanoMelonAttr\n");
#endif
  
  ernie.seed("KiwanoMelonAttrCall");
  AddName("_attr");
  if (!CheckKiwanoMelon(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KiwanoMelonAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KiwanoMelonAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::KiwanoMelon_slice *
idlServer_imp::KiwanoMelonOp(const ::KiwanoMelon p1,::KiwanoMelon_out p2,::KiwanoMelon p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::KiwanoMelon_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KiwanoMelonOp\n");
#endif
  
  ernie.seed("KiwanoMelonOpCall");
  AddName("p1");
  if (!CheckKiwanoMelon(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckKiwanoMelon(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KiwanoMelonOpReturn"); 
  {
    ::idlServer::KiwanoMelonExcpt ex;
    GetidlServerKiwanoMelonExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::KiwanoMelon;
  GetKiwanoMelon(ReturnValue);
  p2 = new ::KiwanoMelon;
  GetKiwanoMelon(p2);
  GetKiwanoMelon(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KiwanoMelonOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Celeriac*
idlServer_imp::CeleriacAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Celeriac* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CeleriacAttr\n");
#endif
  
  ernie.seed("CeleriacAttrCall");
  
  ernie.seed("CeleriacAttrReturn"); 
  ReturnValue = new ::Celeriac;
  GetCeleriac(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CeleriacAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::CeleriacAttr(const ::Celeriac &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CeleriacAttr\n");
#endif
  
  ernie.seed("CeleriacAttrCall");
  AddName("_attr");
  if (!CheckCeleriac(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CeleriacAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CeleriacAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Celeriac*
idlServer_imp::CeleriacOp(const ::Celeriac &p1,::Celeriac_out p2,::Celeriac &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Celeriac* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CeleriacOp\n");
#endif
  
  ernie.seed("CeleriacOpCall");
  AddName("p1");
  if (!CheckCeleriac(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCeleriac(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CeleriacOpReturn"); 
  {
    ::idlServer::CeleriacExcpt ex;
    GetidlServerCeleriacExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Celeriac;
  GetCeleriac(*ReturnValue);
  p2 = new ::Celeriac;
  GetCeleriac(*(p2.ptr()));
  GetCeleriac(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CeleriacOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Clementine_slice *
idlServer_imp::ClementineAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Clementine_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ClementineAttr\n");
#endif
  
  ernie.seed("ClementineAttrCall");
  
  ernie.seed("ClementineAttrReturn"); 
  
  ReturnValue = new ::Clementine;
  GetClementine(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ClementineAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::ClementineAttr(const ::Clementine _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ClementineAttr\n");
#endif
  
  ernie.seed("ClementineAttrCall");
  AddName("_attr");
  if (!CheckClementine(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ClementineAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ClementineAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Clementine_slice *
idlServer_imp::ClementineOp(const ::Clementine p1,::Clementine_out p2,::Clementine p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Clementine_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ClementineOp\n");
#endif
  
  ernie.seed("ClementineOpCall");
  AddName("p1");
  if (!CheckClementine(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckClementine(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ClementineOpReturn"); 
  {
    ::idlServer::ClementineExcpt ex;
    GetidlServerClementineExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Clementine;
  GetClementine(ReturnValue);
  p2 = new ::Clementine;
  GetClementine(p2);
  GetClementine(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ClementineOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Record*
idlServer_imp::RecordAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Record* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RecordAttr\n");
#endif
  
  ernie.seed("RecordAttrCall");
  
  ernie.seed("RecordAttrReturn"); 
  ReturnValue = new ::Record;
  GetRecord(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RecordAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::RecordAttr(const ::Record &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RecordAttr\n");
#endif
  
  ernie.seed("RecordAttrCall");
  AddName("_attr");
  if (!CheckRecord(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RecordAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RecordAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Record*
idlServer_imp::RecordOp(const ::Record &p1,::Record_out p2,::Record &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Record* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RecordOp\n");
#endif
  
  ernie.seed("RecordOpCall");
  AddName("p1");
  if (!CheckRecord(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckRecord(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RecordOpReturn"); 
  {
    ::idlServer::RecordExcpt ex;
    GetidlServerRecordExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Record;
  GetRecord(*ReturnValue);
  p2 = new ::Record;
  GetRecord(*(p2.ptr()));
  GetRecord(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RecordOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::KerrsPinks_slice *
idlServer_imp::KerrsPinksAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::KerrsPinks_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KerrsPinksAttr\n");
#endif
  
  ernie.seed("KerrsPinksAttrCall");
  
  ernie.seed("KerrsPinksAttrReturn"); 
  
  ReturnValue = new ::KerrsPinks;
  GetKerrsPinks(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KerrsPinksAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::KerrsPinksAttr(const ::KerrsPinks _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KerrsPinksAttr\n");
#endif
  
  ernie.seed("KerrsPinksAttrCall");
  AddName("_attr");
  if (!CheckKerrsPinks(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KerrsPinksAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KerrsPinksAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::KerrsPinks_slice *
idlServer_imp::KerrsPinksOp(const ::KerrsPinks p1,::KerrsPinks_out p2,::KerrsPinks p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::KerrsPinks_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KerrsPinksOp\n");
#endif
  
  ernie.seed("KerrsPinksOpCall");
  AddName("p1");
  if (!CheckKerrsPinks(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckKerrsPinks(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KerrsPinksOpReturn"); 
  {
    ::idlServer::KerrsPinksExcpt ex;
    GetidlServerKerrsPinksExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::KerrsPinks;
  GetKerrsPinks(ReturnValue);
  p2 = new ::KerrsPinks;
  GetKerrsPinks(p2);
  GetKerrsPinks(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KerrsPinksOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::MarisPiper*
idlServer_imp::MarisPiperAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::MarisPiper* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MarisPiperAttr\n");
#endif
  
  ernie.seed("MarisPiperAttrCall");
  
  ernie.seed("MarisPiperAttrReturn"); 
  ReturnValue = new ::MarisPiper;
  GetMarisPiper(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MarisPiperAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::MarisPiperAttr(const ::MarisPiper &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MarisPiperAttr\n");
#endif
  
  ernie.seed("MarisPiperAttrCall");
  AddName("_attr");
  if (!CheckMarisPiper(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MarisPiperAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MarisPiperAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::MarisPiper*
idlServer_imp::MarisPiperOp(const ::MarisPiper &p1,::MarisPiper_out p2,::MarisPiper &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::MarisPiper* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MarisPiperOp\n");
#endif
  
  ernie.seed("MarisPiperOpCall");
  AddName("p1");
  if (!CheckMarisPiper(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckMarisPiper(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MarisPiperOpReturn"); 
  {
    ::idlServer::MarisPiperExcpt ex;
    GetidlServerMarisPiperExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::MarisPiper;
  GetMarisPiper(*ReturnValue);
  p2 = new ::MarisPiper;
  GetMarisPiper(*(p2.ptr()));
  GetMarisPiper(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MarisPiperOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Banana1_slice *
idlServer_imp::Banana1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Banana1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Banana1Attr\n");
#endif
  
  ernie.seed("Banana1AttrCall");
  
  ernie.seed("Banana1AttrReturn"); 
  
  ReturnValue = new ::Banana1;
  GetBanana1(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Banana1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Banana1Attr(const ::Banana1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Banana1Attr\n");
#endif
  
  ernie.seed("Banana1AttrCall");
  AddName("_attr");
  if (!CheckBanana1(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Banana1AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Banana1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Banana1_slice *
idlServer_imp::Banana1Op(const ::Banana1 p1,::Banana1_out p2,::Banana1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Banana1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Banana1Op\n");
#endif
  
  ernie.seed("Banana1OpCall");
  AddName("p1");
  if (!CheckBanana1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBanana1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Banana1OpReturn"); 
  {
    ::idlServer::Banana1Excpt ex;
    GetidlServerBanana1Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Banana1;
  GetBanana1(ReturnValue);
  p2 = new ::Banana1;
  GetBanana1(p2);
  GetBanana1(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Banana1Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



