//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/client.cpp
//
// Modifications:
// $Log: client.cpp,v $
// Revision 1.2  2000/03/29 17:08:22  mli
//   o   remove 'CORBA::Environment ev;'
//   o   int initialise
//
// Revision 1.1.1.1  2000/02/09 17:16:26  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.4  1997/12/09 11:27:12  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern OrbSupport *orb;
extern char *stringifiedIOR;

static int initialised = 0;
CORBA::Object_ptr obj;
idlServer_ptr  tobj;

void
initialise()
{
    if (!initialised)
    {

#ifdef DEBUG
	  ::tet_infoline("client: connecting to proxy");
	  ::tet_printf("client: using %s", stringifiedIOR);
#endif
	  
	  try {
	      obj = orb->getObject(stringifiedIOR);
	  }
	  catch (CORBA::SystemException &ex) {
	      ::tet_infoline("client: getObj failed");
	      ::tet_printf("client: minor code %d", ex.minor());
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  if (obj == 0)
	  {
	      ::tet_infoline("client: failed connecting to proxy");
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  try {
	      tobj = idlServer::_narrow(obj);
	  }
	  catch (CORBA::Exception &ex) {
	      ::tet_infoline("client: failed to narrow object reference.");
	  }
	  initialised = 1;

	  char * tout = 0;
	  tout = getenv("VSORB_EVENT_TIMEOUT");

	  unsigned long timeout = (tout) ? atoi(tout) : 15;
	  orb->setTimeout(tobj, timeout);
      }
    
}

#ifdef VSORB_IDL_TESTS

void testIDL()
{
  char buf1[1024];

::tet_result(TET_PASS);
}
 
#endif



 
void testidlServerZucchini1Attr(void)
{
  
  ::Zucchini1_slice * ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Zucchini1_slice * ::idlServer::Zucchini1Attr()");
#endif
  
  ernie.seed("Zucchini1AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Zucchini1AttrReturn");
  try {
    ReturnValue = tobj->Zucchini1Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Zucchini1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckZucchini1(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerZucchini1AttrW(void)
{
  
  ::Zucchini1 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Zucchini1Attr(const ::Zucchini1 _attr)");
#endif
  
  ernie.seed("Zucchini1AttrCall");
  GetZucchini1(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Zucchini1AttrReturn");
  try {
     tobj->Zucchini1Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Zucchini1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerZucchini1Op(void)
{
  
  ::Zucchini1_slice * ReturnValue;
  ::Zucchini1 p1;
  ::Zucchini1_slice * p2;
  ::Zucchini1 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Zucchini1_slice * ::idlServer::Zucchini1Op(const ::Zucchini1 p1,::Zucchini1_slice *&p2,::Zucchini1 p3)");
#endif
  
  ernie.seed("Zucchini1OpCall");
  GetZucchini1(p1);
  GetZucchini1(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Zucchini1OpReturn");
  try {
    ReturnValue = tobj->Zucchini1Op(p1,p2,p3);
  }
  catch (::idlServer::Zucchini1Excpt &ex){
    if (!CheckidlServerZucchini1Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Zucchini1Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckZucchini1(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckZucchini1(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckZucchini1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerRedOnion1Attr(void)
{
  
  ::RedOnion1* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::RedOnion1* ::idlServer::RedOnion1Attr()");
#endif
  
  ernie.seed("RedOnion1AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("RedOnion1AttrReturn");
  try {
    ReturnValue = tobj->RedOnion1Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::RedOnion1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckRedOnion1(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerRedOnion1AttrW(void)
{
  
  ::RedOnion1 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::RedOnion1Attr(const ::RedOnion1 &_attr)");
#endif
  
  ernie.seed("RedOnion1AttrCall");
  GetRedOnion1(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("RedOnion1AttrReturn");
  try {
     tobj->RedOnion1Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::RedOnion1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerRedOnion1Op(void)
{
  
  ::RedOnion1* ReturnValue;
  ::RedOnion1 p1;
  ::RedOnion1* p2;
  ::RedOnion1 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::RedOnion1* ::idlServer::RedOnion1Op(const ::RedOnion1 &p1,::RedOnion1 *&p2,::RedOnion1 &p3)");
#endif
  
  ernie.seed("RedOnion1OpCall");
  GetRedOnion1(p1);
  GetRedOnion1(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("RedOnion1OpReturn");
  try {
    ReturnValue = tobj->RedOnion1Op(p1,p2,p3);
  }
  catch (::idlServer::RedOnion1Excpt &ex){
    if (!CheckidlServerRedOnion1Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::RedOnion1Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckRedOnion1(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckRedOnion1(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckRedOnion1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerJuniperBerries1Attr(void)
{
  
  ::JuniperBerries1_slice * ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::JuniperBerries1_slice * ::idlServer::JuniperBerries1Attr()");
#endif
  
  ernie.seed("JuniperBerries1AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("JuniperBerries1AttrReturn");
  try {
    ReturnValue = tobj->JuniperBerries1Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::JuniperBerries1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckJuniperBerries1(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerJuniperBerries1AttrW(void)
{
  
  ::JuniperBerries1 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::JuniperBerries1Attr(const ::JuniperBerries1 _attr)");
#endif
  
  ernie.seed("JuniperBerries1AttrCall");
  GetJuniperBerries1(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("JuniperBerries1AttrReturn");
  try {
     tobj->JuniperBerries1Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::JuniperBerries1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerJuniperBerries1Op(void)
{
  
  ::JuniperBerries1_slice * ReturnValue;
  ::JuniperBerries1 p1;
  ::JuniperBerries1_slice * p2;
  ::JuniperBerries1 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::JuniperBerries1_slice * ::idlServer::JuniperBerries1Op(const ::JuniperBerries1 p1,::JuniperBerries1_slice *&p2,::JuniperBerries1 p3)");
#endif
  
  ernie.seed("JuniperBerries1OpCall");
  GetJuniperBerries1(p1);
  GetJuniperBerries1(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("JuniperBerries1OpReturn");
  try {
    ReturnValue = tobj->JuniperBerries1Op(p1,p2,p3);
  }
  catch (::idlServer::JuniperBerries1Excpt &ex){
    if (!CheckidlServerJuniperBerries1Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::JuniperBerries1Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckJuniperBerries1(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckJuniperBerries1(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckJuniperBerries1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerTarragon1Attr(void)
{
  
  ::Tarragon1* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Tarragon1* ::idlServer::Tarragon1Attr()");
#endif
  
  ernie.seed("Tarragon1AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Tarragon1AttrReturn");
  try {
    ReturnValue = tobj->Tarragon1Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Tarragon1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckTarragon1(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerTarragon1AttrW(void)
{
  
  ::Tarragon1 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Tarragon1Attr(const ::Tarragon1 &_attr)");
#endif
  
  ernie.seed("Tarragon1AttrCall");
  GetTarragon1(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Tarragon1AttrReturn");
  try {
     tobj->Tarragon1Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Tarragon1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerTarragon1Op(void)
{
  
  ::Tarragon1* ReturnValue;
  ::Tarragon1 p1;
  ::Tarragon1* p2;
  ::Tarragon1 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Tarragon1* ::idlServer::Tarragon1Op(const ::Tarragon1 &p1,::Tarragon1 *&p2,::Tarragon1 &p3)");
#endif
  
  ernie.seed("Tarragon1OpCall");
  GetTarragon1(p1);
  GetTarragon1(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Tarragon1OpReturn");
  try {
    ReturnValue = tobj->Tarragon1Op(p1,p2,p3);
  }
  catch (::idlServer::Tarragon1Excpt &ex){
    if (!CheckidlServerTarragon1Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Tarragon1Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckTarragon1(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckTarragon1(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckTarragon1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerElderberry1Attr(void)
{
  
  ::Elderberry1_slice * ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Elderberry1_slice * ::idlServer::Elderberry1Attr()");
#endif
  
  ernie.seed("Elderberry1AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Elderberry1AttrReturn");
  try {
    ReturnValue = tobj->Elderberry1Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Elderberry1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckElderberry1(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerElderberry1AttrW(void)
{
  
  ::Elderberry1 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Elderberry1Attr(const ::Elderberry1 _attr)");
#endif
  
  ernie.seed("Elderberry1AttrCall");
  GetElderberry1(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Elderberry1AttrReturn");
  try {
     tobj->Elderberry1Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Elderberry1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerElderberry1Op(void)
{
  
  ::Elderberry1_slice * ReturnValue;
  ::Elderberry1 p1;
  ::Elderberry1_slice * p2;
  ::Elderberry1 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Elderberry1_slice * ::idlServer::Elderberry1Op(const ::Elderberry1 p1,::Elderberry1_slice *&p2,::Elderberry1 p3)");
#endif
  
  ernie.seed("Elderberry1OpCall");
  GetElderberry1(p1);
  GetElderberry1(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Elderberry1OpReturn");
  try {
    ReturnValue = tobj->Elderberry1Op(p1,p2,p3);
  }
  catch (::idlServer::Elderberry1Excpt &ex){
    if (!CheckidlServerElderberry1Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Elderberry1Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckElderberry1(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckElderberry1(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckElderberry1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPlantain1Attr(void)
{
  
  ::Plantain1* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Plantain1* ::idlServer::Plantain1Attr()");
#endif
  
  ernie.seed("Plantain1AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Plantain1AttrReturn");
  try {
    ReturnValue = tobj->Plantain1Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Plantain1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPlantain1(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPlantain1AttrW(void)
{
  
  ::Plantain1 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Plantain1Attr(const ::Plantain1 &_attr)");
#endif
  
  ernie.seed("Plantain1AttrCall");
  GetPlantain1(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Plantain1AttrReturn");
  try {
     tobj->Plantain1Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Plantain1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPlantain1Op(void)
{
  
  ::Plantain1* ReturnValue;
  ::Plantain1 p1;
  ::Plantain1* p2;
  ::Plantain1 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Plantain1* ::idlServer::Plantain1Op(const ::Plantain1 &p1,::Plantain1 *&p2,::Plantain1 &p3)");
#endif
  
  ernie.seed("Plantain1OpCall");
  GetPlantain1(p1);
  GetPlantain1(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Plantain1OpReturn");
  try {
    ReturnValue = tobj->Plantain1Op(p1,p2,p3);
  }
  catch (::idlServer::Plantain1Excpt &ex){
    if (!CheckidlServerPlantain1Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Plantain1Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPlantain1(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckPlantain1(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPlantain1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSharanfruit1Attr(void)
{
  
  ::Sharanfruit1_slice * ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Sharanfruit1_slice * ::idlServer::Sharanfruit1Attr()");
#endif
  
  ernie.seed("Sharanfruit1AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sharanfruit1AttrReturn");
  try {
    ReturnValue = tobj->Sharanfruit1Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sharanfruit1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckSharanfruit1(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSharanfruit1AttrW(void)
{
  
  ::Sharanfruit1 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Sharanfruit1Attr(const ::Sharanfruit1 _attr)");
#endif
  
  ernie.seed("Sharanfruit1AttrCall");
  GetSharanfruit1(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sharanfruit1AttrReturn");
  try {
     tobj->Sharanfruit1Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sharanfruit1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSharanfruit1Op(void)
{
  
  ::Sharanfruit1_slice * ReturnValue;
  ::Sharanfruit1 p1;
  ::Sharanfruit1_slice * p2;
  ::Sharanfruit1 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Sharanfruit1_slice * ::idlServer::Sharanfruit1Op(const ::Sharanfruit1 p1,::Sharanfruit1_slice *&p2,::Sharanfruit1 p3)");
#endif
  
  ernie.seed("Sharanfruit1OpCall");
  GetSharanfruit1(p1);
  GetSharanfruit1(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sharanfruit1OpReturn");
  try {
    ReturnValue = tobj->Sharanfruit1Op(p1,p2,p3);
  }
  catch (::idlServer::Sharanfruit1Excpt &ex){
    if (!CheckidlServerSharanfruit1Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sharanfruit1Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckSharanfruit1(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckSharanfruit1(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckSharanfruit1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerDamsons1Attr(void)
{
  
  ::Damsons1* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Damsons1* ::idlServer::Damsons1Attr()");
#endif
  
  ernie.seed("Damsons1AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Damsons1AttrReturn");
  try {
    ReturnValue = tobj->Damsons1Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Damsons1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckDamsons1(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerDamsons1AttrW(void)
{
  
  ::Damsons1 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Damsons1Attr(const ::Damsons1 &_attr)");
#endif
  
  ernie.seed("Damsons1AttrCall");
  GetDamsons1(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Damsons1AttrReturn");
  try {
     tobj->Damsons1Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Damsons1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerDamsons1Op(void)
{
  
  ::Damsons1* ReturnValue;
  ::Damsons1 p1;
  ::Damsons1* p2;
  ::Damsons1 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Damsons1* ::idlServer::Damsons1Op(const ::Damsons1 &p1,::Damsons1 *&p2,::Damsons1 &p3)");
#endif
  
  ernie.seed("Damsons1OpCall");
  GetDamsons1(p1);
  GetDamsons1(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Damsons1OpReturn");
  try {
    ReturnValue = tobj->Damsons1Op(p1,p2,p3);
  }
  catch (::idlServer::Damsons1Excpt &ex){
    if (!CheckidlServerDamsons1Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Damsons1Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckDamsons1(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckDamsons1(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckDamsons1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerEddo1Attr(void)
{
  
  ::Eddo1_slice * ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Eddo1_slice * ::idlServer::Eddo1Attr()");
#endif
  
  ernie.seed("Eddo1AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Eddo1AttrReturn");
  try {
    ReturnValue = tobj->Eddo1Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Eddo1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckEddo1(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerEddo1AttrW(void)
{
  
  ::Eddo1 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Eddo1Attr(const ::Eddo1 _attr)");
#endif
  
  ernie.seed("Eddo1AttrCall");
  GetEddo1(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Eddo1AttrReturn");
  try {
     tobj->Eddo1Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Eddo1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerEddo1Op(void)
{
  
  ::Eddo1_slice * ReturnValue;
  ::Eddo1 p1;
  ::Eddo1_slice * p2;
  ::Eddo1 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Eddo1_slice * ::idlServer::Eddo1Op(const ::Eddo1 p1,::Eddo1_slice *&p2,::Eddo1 p3)");
#endif
  
  ernie.seed("Eddo1OpCall");
  GetEddo1(p1);
  GetEddo1(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Eddo1OpReturn");
  try {
    ReturnValue = tobj->Eddo1Op(p1,p2,p3);
  }
  catch (::idlServer::Eddo1Excpt &ex){
    if (!CheckidlServerEddo1Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Eddo1Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckEddo1(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckEddo1(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckEddo1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCoxPippin1Attr(void)
{
  
  ::CoxPippin1* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::CoxPippin1* ::idlServer::CoxPippin1Attr()");
#endif
  
  ernie.seed("CoxPippin1AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("CoxPippin1AttrReturn");
  try {
    ReturnValue = tobj->CoxPippin1Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::CoxPippin1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckCoxPippin1(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCoxPippin1AttrW(void)
{
  
  ::CoxPippin1 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::CoxPippin1Attr(const ::CoxPippin1 &_attr)");
#endif
  
  ernie.seed("CoxPippin1AttrCall");
  GetCoxPippin1(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("CoxPippin1AttrReturn");
  try {
     tobj->CoxPippin1Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::CoxPippin1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCoxPippin1Op(void)
{
  
  ::CoxPippin1* ReturnValue;
  ::CoxPippin1 p1;
  ::CoxPippin1* p2;
  ::CoxPippin1 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::CoxPippin1* ::idlServer::CoxPippin1Op(const ::CoxPippin1 &p1,::CoxPippin1 *&p2,::CoxPippin1 &p3)");
#endif
  
  ernie.seed("CoxPippin1OpCall");
  GetCoxPippin1(p1);
  GetCoxPippin1(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("CoxPippin1OpReturn");
  try {
    ReturnValue = tobj->CoxPippin1Op(p1,p2,p3);
  }
  catch (::idlServer::CoxPippin1Excpt &ex){
    if (!CheckidlServerCoxPippin1Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::CoxPippin1Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckCoxPippin1(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckCoxPippin1(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCoxPippin1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerKiwanoMelon1Attr(void)
{
  
  ::KiwanoMelon1_slice * ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::KiwanoMelon1_slice * ::idlServer::KiwanoMelon1Attr()");
#endif
  
  ernie.seed("KiwanoMelon1AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("KiwanoMelon1AttrReturn");
  try {
    ReturnValue = tobj->KiwanoMelon1Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::KiwanoMelon1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckKiwanoMelon1(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerKiwanoMelon1AttrW(void)
{
  
  ::KiwanoMelon1 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::KiwanoMelon1Attr(const ::KiwanoMelon1 _attr)");
#endif
  
  ernie.seed("KiwanoMelon1AttrCall");
  GetKiwanoMelon1(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("KiwanoMelon1AttrReturn");
  try {
     tobj->KiwanoMelon1Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::KiwanoMelon1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerKiwanoMelon1Op(void)
{
  
  ::KiwanoMelon1_slice * ReturnValue;
  ::KiwanoMelon1 p1;
  ::KiwanoMelon1_slice * p2;
  ::KiwanoMelon1 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::KiwanoMelon1_slice * ::idlServer::KiwanoMelon1Op(const ::KiwanoMelon1 p1,::KiwanoMelon1_slice *&p2,::KiwanoMelon1 p3)");
#endif
  
  ernie.seed("KiwanoMelon1OpCall");
  GetKiwanoMelon1(p1);
  GetKiwanoMelon1(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("KiwanoMelon1OpReturn");
  try {
    ReturnValue = tobj->KiwanoMelon1Op(p1,p2,p3);
  }
  catch (::idlServer::KiwanoMelon1Excpt &ex){
    if (!CheckidlServerKiwanoMelon1Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::KiwanoMelon1Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckKiwanoMelon1(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckKiwanoMelon1(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckKiwanoMelon1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerRedCabbage1Attr(void)
{
  
  ::RedCabbage1* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::RedCabbage1* ::idlServer::RedCabbage1Attr()");
#endif
  
  ernie.seed("RedCabbage1AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("RedCabbage1AttrReturn");
  try {
    ReturnValue = tobj->RedCabbage1Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::RedCabbage1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckRedCabbage1(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerRedCabbage1AttrW(void)
{
  
  ::RedCabbage1 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::RedCabbage1Attr(const ::RedCabbage1 &_attr)");
#endif
  
  ernie.seed("RedCabbage1AttrCall");
  GetRedCabbage1(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("RedCabbage1AttrReturn");
  try {
     tobj->RedCabbage1Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::RedCabbage1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerRedCabbage1Op(void)
{
  
  ::RedCabbage1* ReturnValue;
  ::RedCabbage1 p1;
  ::RedCabbage1* p2;
  ::RedCabbage1 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::RedCabbage1* ::idlServer::RedCabbage1Op(const ::RedCabbage1 &p1,::RedCabbage1 *&p2,::RedCabbage1 &p3)");
#endif
  
  ernie.seed("RedCabbage1OpCall");
  GetRedCabbage1(p1);
  GetRedCabbage1(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("RedCabbage1OpReturn");
  try {
    ReturnValue = tobj->RedCabbage1Op(p1,p2,p3);
  }
  catch (::idlServer::RedCabbage1Excpt &ex){
    if (!CheckidlServerRedCabbage1Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::RedCabbage1Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckRedCabbage1(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckRedCabbage1(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckRedCabbage1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPimpernel1Attr(void)
{
  
  ::Pimpernel1_slice * ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Pimpernel1_slice * ::idlServer::Pimpernel1Attr()");
#endif
  
  ernie.seed("Pimpernel1AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Pimpernel1AttrReturn");
  try {
    ReturnValue = tobj->Pimpernel1Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Pimpernel1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPimpernel1(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPimpernel1AttrW(void)
{
  
  ::Pimpernel1 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Pimpernel1Attr(const ::Pimpernel1 _attr)");
#endif
  
  ernie.seed("Pimpernel1AttrCall");
  GetPimpernel1(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Pimpernel1AttrReturn");
  try {
     tobj->Pimpernel1Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Pimpernel1Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPimpernel1Op(void)
{
  
  ::Pimpernel1_slice * ReturnValue;
  ::Pimpernel1 p1;
  ::Pimpernel1_slice * p2;
  ::Pimpernel1 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Pimpernel1_slice * ::idlServer::Pimpernel1Op(const ::Pimpernel1 p1,::Pimpernel1_slice *&p2,::Pimpernel1 p3)");
#endif
  
  ernie.seed("Pimpernel1OpCall");
  GetPimpernel1(p1);
  GetPimpernel1(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Pimpernel1OpReturn");
  try {
    ReturnValue = tobj->Pimpernel1Op(p1,p2,p3);
  }
  catch (::idlServer::Pimpernel1Excpt &ex){
    if (!CheckidlServerPimpernel1Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Pimpernel1Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPimpernel1(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckPimpernel1(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPimpernel1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerBlackCherry2Attr(void)
{
  
  ::BlackCherry2* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::BlackCherry2* ::idlServer::BlackCherry2Attr()");
#endif
  
  ernie.seed("BlackCherry2AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("BlackCherry2AttrReturn");
  try {
    ReturnValue = tobj->BlackCherry2Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::BlackCherry2Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckBlackCherry2(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerBlackCherry2AttrW(void)
{
  
  ::BlackCherry2 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::BlackCherry2Attr(const ::BlackCherry2 &_attr)");
#endif
  
  ernie.seed("BlackCherry2AttrCall");
  GetBlackCherry2(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("BlackCherry2AttrReturn");
  try {
     tobj->BlackCherry2Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::BlackCherry2Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerBlackCherry2Op(void)
{
  
  ::BlackCherry2* ReturnValue;
  ::BlackCherry2 p1;
  ::BlackCherry2* p2;
  ::BlackCherry2 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::BlackCherry2* ::idlServer::BlackCherry2Op(const ::BlackCherry2 &p1,::BlackCherry2 *&p2,::BlackCherry2 &p3)");
#endif
  
  ernie.seed("BlackCherry2OpCall");
  GetBlackCherry2(p1);
  GetBlackCherry2(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("BlackCherry2OpReturn");
  try {
    ReturnValue = tobj->BlackCherry2Op(p1,p2,p3);
  }
  catch (::idlServer::BlackCherry2Excpt &ex){
    if (!CheckidlServerBlackCherry2Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::BlackCherry2Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckBlackCherry2(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckBlackCherry2(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBlackCherry2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCucumber2Attr(void)
{
  
  ::Cucumber2* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Cucumber2* ::idlServer::Cucumber2Attr()");
#endif
  
  ernie.seed("Cucumber2AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Cucumber2AttrReturn");
  try {
    ReturnValue = tobj->Cucumber2Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Cucumber2Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckCucumber2(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCucumber2AttrW(void)
{
  
  ::Cucumber2 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Cucumber2Attr(const ::Cucumber2 &_attr)");
#endif
  
  ernie.seed("Cucumber2AttrCall");
  GetCucumber2(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Cucumber2AttrReturn");
  try {
     tobj->Cucumber2Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Cucumber2Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCucumber2Op(void)
{
  
  ::Cucumber2* ReturnValue;
  ::Cucumber2 p1;
  ::Cucumber2* p2;
  ::Cucumber2 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Cucumber2* ::idlServer::Cucumber2Op(const ::Cucumber2 &p1,::Cucumber2 *&p2,::Cucumber2 &p3)");
#endif
  
  ernie.seed("Cucumber2OpCall");
  GetCucumber2(p1);
  GetCucumber2(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Cucumber2OpReturn");
  try {
    ReturnValue = tobj->Cucumber2Op(p1,p2,p3);
  }
  catch (::idlServer::Cucumber2Excpt &ex){
    if (!CheckidlServerCucumber2Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Cucumber2Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckCucumber2(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckCucumber2(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCucumber2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


