//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/getany.cpp
//
// Modifications:
// $Log: getany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:26  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.4  1997/12/09 11:27:15  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"

//Header files generated by idl compiler
#include "tin.hh"

#include "types.hh"
extern Ernie ernie;


void GetAny(CORBA::Any &any)
{
  switch(ernie.getULong()%(12+15))
  {
    case   0: any <<= ernie.getULong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating ULong");
#endif
              break;
    case   1: any <<= ernie.getLong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Long");
#endif
              break;
    case   2: any <<= ernie.getUShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating UShort");
#endif
              break;
    case   3: any <<= ernie.getShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Short");
#endif
              break;
    case   4: any <<= CORBA::Any::from_boolean(ernie.getBoolean());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Boolean");
#endif
              break;
    case   5: any <<= CORBA::Any::from_octet(ernie.getOctet());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Octet");
#endif
              break;
    case   6: any <<= CORBA::Any::from_char(ernie.getChar());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Char");
#endif
              break;
    case   7: any <<= ernie.getFloat();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Float");
#endif
               break;
    case   8: any <<= ernie.getDouble();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Double");
#endif
              break;
    case   9: any <<= ernie.getString();
#ifdef DEBUG
              ::tet_infoline("GetAny creating String");
#endif
              break;
    case  10: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating BoundedString");
#endif
                CORBA::ULong  b;
                b = ernie.getULong()%30+1;
                any <<= CORBA::Any::from_string(ernie.getString(b),b);
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr _typecode;
#ifdef DEBUG
                ::tet_infoline("GetAny creating TypeCode");
#endif
                GetCORBATypeCode_ptr(_typecode);
                any <<= _typecode;
               }
                break;
    case   12: {
                CORBA::Any  _any;  
#ifdef DEBUG
                ::tet_infoline("GetAny creating Any");
#endif
                GetAny(_any);
                any <<= _any;
               }
                break;

    case  13: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Zucchini1");
#endif
                ::Zucchini1_forany   v(::Zucchini1_alloc());

                GetZucchini1(v);

                any  <<= v;
              }
              break;

    case  14: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::RedOnion1");
#endif
                ::RedOnion1   v;

                GetRedOnion1(v);

                any  <<= v;
              }
              break;

    case  15: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::JuniperBerries1");
#endif
                ::JuniperBerries1_forany   v(::JuniperBerries1_alloc());

                GetJuniperBerries1(v);

                any  <<= v;
              }
              break;

    case  16: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Tarragon1");
#endif
                ::Tarragon1   v;

                GetTarragon1(v);

                any  <<= v;
              }
              break;

    case  17: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Elderberry1");
#endif
                ::Elderberry1_forany   v(::Elderberry1_alloc());

                GetElderberry1(v);

                any  <<= v;
              }
              break;

    case  18: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Plantain1");
#endif
                ::Plantain1   v;

                GetPlantain1(v);

                any  <<= v;
              }
              break;

    case  19: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sharanfruit1");
#endif
                ::Sharanfruit1_forany   v(::Sharanfruit1_alloc());

                GetSharanfruit1(v);

                any  <<= v;
              }
              break;

    case  20: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Damsons1");
#endif
                ::Damsons1   v;

                GetDamsons1(v);

                any  <<= v;
              }
              break;

    case  21: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Eddo1");
#endif
                ::Eddo1_forany   v(::Eddo1_alloc());

                GetEddo1(v);

                any  <<= v;
              }
              break;

    case  22: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CoxPippin1");
#endif
                ::CoxPippin1   v;

                GetCoxPippin1(v);

                any  <<= v;
              }
              break;

    case  23: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::KiwanoMelon1");
#endif
                ::KiwanoMelon1_forany   v(::KiwanoMelon1_alloc());

                GetKiwanoMelon1(v);

                any  <<= v;
              }
              break;

    case  24: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::RedCabbage1");
#endif
                ::RedCabbage1   v;

                GetRedCabbage1(v);

                any  <<= v;
              }
              break;

    case  25: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pimpernel1");
#endif
                ::Pimpernel1_forany   v(::Pimpernel1_alloc());

                GetPimpernel1(v);

                any  <<= v;
              }
              break;

    case  26: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BlackCherry2");
#endif
                ::BlackCherry2   v;

                GetBlackCherry2(v);

                any  <<= v;
              }
              break;

    case  27: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cucumber2");
#endif
                ::Cucumber2   v;

                GetCucumber2(v);

                any  <<= v;
              }
              break;

  }
}


