//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:26  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/26 13:51:16  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/15 10:51:49  james
// #ifdefs removed
//
// Revision 1.4  1997/12/09 11:27:15  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetZucchini1(::Zucchini1 v)
{
#ifdef DEBUG
  ::tet_infoline("GetZucchini1");
#endif

  {
    int	i1;
    for(i1=0; i1 < 18; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                v[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetChar(v[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckZucchini1(const ::Zucchini1 v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckZucchini1");
#endif

  {
    int	i1;
    for(i1=0; i1 < 18; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                if (l7 != v[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckChar(v[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetRedOnion1(::RedOnion1 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetRedOnion1");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetBoolean(v[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckRedOnion1(const ::RedOnion1 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRedOnion1");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckBoolean(v[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetJuniperBerries1(::JuniperBerries1 v)
{
#ifdef DEBUG
  ::tet_infoline("GetJuniperBerries1");
#endif

  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%13;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetBoolean(v[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckJuniperBerries1(const ::JuniperBerries1 v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckJuniperBerries1");
#endif

  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%13;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckBoolean(v[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetTarragon1(::Tarragon1 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTarragon1");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%10;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%11;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetBoolean(v[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckTarragon1(const ::Tarragon1 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTarragon1");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%10;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%11;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckBoolean(v[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetElderberry1(::Elderberry1 v)
{
#ifdef DEBUG
  ::tet_infoline("GetElderberry1");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%12;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%19;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetOctet(v[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckElderberry1(const ::Elderberry1 v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckElderberry1");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%12;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%19;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckOctet(v[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetPlantain1(::Plantain1 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetPlantain1");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckPlantain1(const ::Plantain1 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPlantain1");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetSharanfruit1(::Sharanfruit1 v)
{
#ifdef DEBUG
  ::tet_infoline("GetSharanfruit1");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                v[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckSharanfruit1(const ::Sharanfruit1 v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSharanfruit1");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                if (l7 != v[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetDamsons1(::Damsons1 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetDamsons1");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%2;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%4;
                v[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckDamsons1(const ::Damsons1 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckDamsons1");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%2;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%4;
                if (l7 != v[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetEddo1(::Eddo1 v)
{
#ifdef DEBUG
  ::tet_infoline("GetEddo1");
#endif

  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%9;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%5;
                    v[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckEddo1(const ::Eddo1 v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckEddo1");
#endif

  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%9;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%5;
                    if (l9 != v[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetCoxPippin1(::CoxPippin1 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCoxPippin1");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%6;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%17;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetDouble(v[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCoxPippin1(const ::CoxPippin1 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCoxPippin1");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%6;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%17;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckDouble(v[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetKiwanoMelon1(::KiwanoMelon1 v)
{
#ifdef DEBUG
  ::tet_infoline("GetKiwanoMelon1");
#endif

  {
    int	i1;
    for(i1=0; i1 < 18; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%6;
                    v[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetDouble(v[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckKiwanoMelon1(const ::KiwanoMelon1 v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckKiwanoMelon1");
#endif

  {
    int	i1;
    for(i1=0; i1 < 18; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%6;
                    if (l9 != v[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckDouble(v[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetRedCabbage1(::RedCabbage1 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetRedCabbage1");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%11;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%15;
                v[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetDouble(v[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckRedCabbage1(const ::RedCabbage1 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRedCabbage1");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%11;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%15;
                if (l7 != v[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckDouble(v[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetPimpernel1(::Pimpernel1 v)
{
#ifdef DEBUG
  ::tet_infoline("GetPimpernel1");
#endif

  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%11;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%14;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetLong(v[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckPimpernel1(const ::Pimpernel1 v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPimpernel1");
#endif

  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%11;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%14;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckLong(v[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetBlackCherry2(::BlackCherry2 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBlackCherry2");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%16;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                v[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetLong(v[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBlackCherry2(const ::BlackCherry2 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBlackCherry2");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%16;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                if (l7 != v[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckLong(v[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetCucumber2(::Cucumber2 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCucumber2");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%2;
    v.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%14;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%5;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%4;
                v[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetLong(v[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCucumber2(const ::Cucumber2 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCucumber2");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%2;
    if (l1 != v.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%14;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%5;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%4;
                if (l7 != v[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckLong(v[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetidlServerZucchini1Excpt(::idlServer::Zucchini1Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerZucchini1Excpt");
#endif

  GetZucchini1(v.ex1);
}

int CheckidlServerZucchini1Excpt(const ::idlServer::Zucchini1Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerZucchini1Excpt");
#endif

  AddName("ex1");
  if (!CheckZucchini1(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerRedOnion1Excpt(::idlServer::RedOnion1Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerRedOnion1Excpt");
#endif

  GetRedOnion1(v.ex1);
}

int CheckidlServerRedOnion1Excpt(const ::idlServer::RedOnion1Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerRedOnion1Excpt");
#endif

  AddName("ex1");
  if (!CheckRedOnion1(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerJuniperBerries1Excpt(::idlServer::JuniperBerries1Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerJuniperBerries1Excpt");
#endif

  GetJuniperBerries1(v.ex1);
}

int CheckidlServerJuniperBerries1Excpt(const ::idlServer::JuniperBerries1Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerJuniperBerries1Excpt");
#endif

  AddName("ex1");
  if (!CheckJuniperBerries1(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerTarragon1Excpt(::idlServer::Tarragon1Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerTarragon1Excpt");
#endif

  GetTarragon1(v.ex1);
}

int CheckidlServerTarragon1Excpt(const ::idlServer::Tarragon1Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerTarragon1Excpt");
#endif

  AddName("ex1");
  if (!CheckTarragon1(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerElderberry1Excpt(::idlServer::Elderberry1Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerElderberry1Excpt");
#endif

  GetElderberry1(v.ex1);
}

int CheckidlServerElderberry1Excpt(const ::idlServer::Elderberry1Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerElderberry1Excpt");
#endif

  AddName("ex1");
  if (!CheckElderberry1(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerPlantain1Excpt(::idlServer::Plantain1Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerPlantain1Excpt");
#endif

  GetPlantain1(v.ex1);
}

int CheckidlServerPlantain1Excpt(const ::idlServer::Plantain1Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerPlantain1Excpt");
#endif

  AddName("ex1");
  if (!CheckPlantain1(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerSharanfruit1Excpt(::idlServer::Sharanfruit1Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerSharanfruit1Excpt");
#endif

  GetSharanfruit1(v.ex1);
}

int CheckidlServerSharanfruit1Excpt(const ::idlServer::Sharanfruit1Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerSharanfruit1Excpt");
#endif

  AddName("ex1");
  if (!CheckSharanfruit1(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerDamsons1Excpt(::idlServer::Damsons1Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerDamsons1Excpt");
#endif

  GetDamsons1(v.ex1);
}

int CheckidlServerDamsons1Excpt(const ::idlServer::Damsons1Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerDamsons1Excpt");
#endif

  AddName("ex1");
  if (!CheckDamsons1(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerEddo1Excpt(::idlServer::Eddo1Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerEddo1Excpt");
#endif

  GetEddo1(v.ex1);
}

int CheckidlServerEddo1Excpt(const ::idlServer::Eddo1Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerEddo1Excpt");
#endif

  AddName("ex1");
  if (!CheckEddo1(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerCoxPippin1Excpt(::idlServer::CoxPippin1Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerCoxPippin1Excpt");
#endif

  GetCoxPippin1(v.ex1);
}

int CheckidlServerCoxPippin1Excpt(const ::idlServer::CoxPippin1Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerCoxPippin1Excpt");
#endif

  AddName("ex1");
  if (!CheckCoxPippin1(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerKiwanoMelon1Excpt(::idlServer::KiwanoMelon1Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerKiwanoMelon1Excpt");
#endif

  GetKiwanoMelon1(v.ex1);
}

int CheckidlServerKiwanoMelon1Excpt(const ::idlServer::KiwanoMelon1Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerKiwanoMelon1Excpt");
#endif

  AddName("ex1");
  if (!CheckKiwanoMelon1(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerRedCabbage1Excpt(::idlServer::RedCabbage1Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerRedCabbage1Excpt");
#endif

  GetRedCabbage1(v.ex1);
}

int CheckidlServerRedCabbage1Excpt(const ::idlServer::RedCabbage1Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerRedCabbage1Excpt");
#endif

  AddName("ex1");
  if (!CheckRedCabbage1(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerPimpernel1Excpt(::idlServer::Pimpernel1Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerPimpernel1Excpt");
#endif

  GetPimpernel1(v.ex1);
}

int CheckidlServerPimpernel1Excpt(const ::idlServer::Pimpernel1Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerPimpernel1Excpt");
#endif

  AddName("ex1");
  if (!CheckPimpernel1(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerBlackCherry2Excpt(::idlServer::BlackCherry2Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerBlackCherry2Excpt");
#endif

  GetBlackCherry2(v.ex1);
}

int CheckidlServerBlackCherry2Excpt(const ::idlServer::BlackCherry2Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerBlackCherry2Excpt");
#endif

  AddName("ex1");
  if (!CheckBlackCherry2(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerCucumber2Excpt(::idlServer::Cucumber2Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerCucumber2Excpt");
#endif

  GetCucumber2(v.ex1);
}

int CheckidlServerCucumber2Excpt(const ::idlServer::Cucumber2Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerCucumber2Excpt");
#endif

  AddName("ex1");
  if (!CheckCucumber2(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



