//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Zucchini1_slice *
idlServer_imp::Zucchini1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Zucchini1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Zucchini1Attr\n");
#endif
  
  ernie.seed("Zucchini1AttrCall");
  
  ernie.seed("Zucchini1AttrReturn"); 
  
  ReturnValue = new ::Zucchini1;
  GetZucchini1(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Zucchini1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Zucchini1Attr(const ::Zucchini1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Zucchini1Attr\n");
#endif
  
  ernie.seed("Zucchini1AttrCall");
  AddName("_attr");
  if (!CheckZucchini1(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Zucchini1AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Zucchini1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Zucchini1_slice *
idlServer_imp::Zucchini1Op(const ::Zucchini1 p1,::Zucchini1_out p2,::Zucchini1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Zucchini1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Zucchini1Op\n");
#endif
  
  ernie.seed("Zucchini1OpCall");
  AddName("p1");
  if (!CheckZucchini1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckZucchini1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Zucchini1OpReturn"); 
  {
    ::idlServer::Zucchini1Excpt ex;
    GetidlServerZucchini1Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Zucchini1;
  GetZucchini1(ReturnValue);
  p2 = new ::Zucchini1;
  GetZucchini1(p2);
  GetZucchini1(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Zucchini1Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::RedOnion1*
idlServer_imp::RedOnion1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::RedOnion1* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedOnion1Attr\n");
#endif
  
  ernie.seed("RedOnion1AttrCall");
  
  ernie.seed("RedOnion1AttrReturn"); 
  ReturnValue = new ::RedOnion1;
  GetRedOnion1(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedOnion1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::RedOnion1Attr(const ::RedOnion1 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedOnion1Attr\n");
#endif
  
  ernie.seed("RedOnion1AttrCall");
  AddName("_attr");
  if (!CheckRedOnion1(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedOnion1AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedOnion1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::RedOnion1*
idlServer_imp::RedOnion1Op(const ::RedOnion1 &p1,::RedOnion1_out p2,::RedOnion1 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::RedOnion1* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedOnion1Op\n");
#endif
  
  ernie.seed("RedOnion1OpCall");
  AddName("p1");
  if (!CheckRedOnion1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckRedOnion1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedOnion1OpReturn"); 
  {
    ::idlServer::RedOnion1Excpt ex;
    GetidlServerRedOnion1Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::RedOnion1;
  GetRedOnion1(*ReturnValue);
  p2 = new ::RedOnion1;
  GetRedOnion1(*(p2.ptr()));
  GetRedOnion1(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedOnion1Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::JuniperBerries1_slice *
idlServer_imp::JuniperBerries1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::JuniperBerries1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::JuniperBerries1Attr\n");
#endif
  
  ernie.seed("JuniperBerries1AttrCall");
  
  ernie.seed("JuniperBerries1AttrReturn"); 
  
  ReturnValue = new ::JuniperBerries1;
  GetJuniperBerries1(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::JuniperBerries1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::JuniperBerries1Attr(const ::JuniperBerries1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::JuniperBerries1Attr\n");
#endif
  
  ernie.seed("JuniperBerries1AttrCall");
  AddName("_attr");
  if (!CheckJuniperBerries1(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("JuniperBerries1AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::JuniperBerries1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::JuniperBerries1_slice *
idlServer_imp::JuniperBerries1Op(const ::JuniperBerries1 p1,::JuniperBerries1_out p2,::JuniperBerries1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::JuniperBerries1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::JuniperBerries1Op\n");
#endif
  
  ernie.seed("JuniperBerries1OpCall");
  AddName("p1");
  if (!CheckJuniperBerries1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckJuniperBerries1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("JuniperBerries1OpReturn"); 
  {
    ::idlServer::JuniperBerries1Excpt ex;
    GetidlServerJuniperBerries1Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::JuniperBerries1;
  GetJuniperBerries1(ReturnValue);
  p2 = new ::JuniperBerries1;
  GetJuniperBerries1(p2);
  GetJuniperBerries1(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::JuniperBerries1Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Tarragon1*
idlServer_imp::Tarragon1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Tarragon1* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Tarragon1Attr\n");
#endif
  
  ernie.seed("Tarragon1AttrCall");
  
  ernie.seed("Tarragon1AttrReturn"); 
  ReturnValue = new ::Tarragon1;
  GetTarragon1(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Tarragon1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Tarragon1Attr(const ::Tarragon1 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Tarragon1Attr\n");
#endif
  
  ernie.seed("Tarragon1AttrCall");
  AddName("_attr");
  if (!CheckTarragon1(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Tarragon1AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Tarragon1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Tarragon1*
idlServer_imp::Tarragon1Op(const ::Tarragon1 &p1,::Tarragon1_out p2,::Tarragon1 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Tarragon1* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Tarragon1Op\n");
#endif
  
  ernie.seed("Tarragon1OpCall");
  AddName("p1");
  if (!CheckTarragon1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckTarragon1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Tarragon1OpReturn"); 
  {
    ::idlServer::Tarragon1Excpt ex;
    GetidlServerTarragon1Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Tarragon1;
  GetTarragon1(*ReturnValue);
  p2 = new ::Tarragon1;
  GetTarragon1(*(p2.ptr()));
  GetTarragon1(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Tarragon1Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Elderberry1_slice *
idlServer_imp::Elderberry1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Elderberry1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Elderberry1Attr\n");
#endif
  
  ernie.seed("Elderberry1AttrCall");
  
  ernie.seed("Elderberry1AttrReturn"); 
  
  ReturnValue = new ::Elderberry1;
  GetElderberry1(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Elderberry1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Elderberry1Attr(const ::Elderberry1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Elderberry1Attr\n");
#endif
  
  ernie.seed("Elderberry1AttrCall");
  AddName("_attr");
  if (!CheckElderberry1(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Elderberry1AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Elderberry1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Elderberry1_slice *
idlServer_imp::Elderberry1Op(const ::Elderberry1 p1,::Elderberry1_out p2,::Elderberry1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Elderberry1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Elderberry1Op\n");
#endif
  
  ernie.seed("Elderberry1OpCall");
  AddName("p1");
  if (!CheckElderberry1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckElderberry1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Elderberry1OpReturn"); 
  {
    ::idlServer::Elderberry1Excpt ex;
    GetidlServerElderberry1Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Elderberry1;
  GetElderberry1(ReturnValue);
  p2 = new ::Elderberry1;
  GetElderberry1(p2);
  GetElderberry1(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Elderberry1Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Plantain1*
idlServer_imp::Plantain1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Plantain1* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Plantain1Attr\n");
#endif
  
  ernie.seed("Plantain1AttrCall");
  
  ernie.seed("Plantain1AttrReturn"); 
  ReturnValue = new ::Plantain1;
  GetPlantain1(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Plantain1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Plantain1Attr(const ::Plantain1 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Plantain1Attr\n");
#endif
  
  ernie.seed("Plantain1AttrCall");
  AddName("_attr");
  if (!CheckPlantain1(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Plantain1AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Plantain1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Plantain1*
idlServer_imp::Plantain1Op(const ::Plantain1 &p1,::Plantain1_out p2,::Plantain1 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Plantain1* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Plantain1Op\n");
#endif
  
  ernie.seed("Plantain1OpCall");
  AddName("p1");
  if (!CheckPlantain1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPlantain1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Plantain1OpReturn"); 
  {
    ::idlServer::Plantain1Excpt ex;
    GetidlServerPlantain1Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Plantain1;
  GetPlantain1(*ReturnValue);
  p2 = new ::Plantain1;
  GetPlantain1(*(p2.ptr()));
  GetPlantain1(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Plantain1Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Sharanfruit1_slice *
idlServer_imp::Sharanfruit1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Sharanfruit1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sharanfruit1Attr\n");
#endif
  
  ernie.seed("Sharanfruit1AttrCall");
  
  ernie.seed("Sharanfruit1AttrReturn"); 
  
  ReturnValue = new ::Sharanfruit1;
  GetSharanfruit1(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sharanfruit1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Sharanfruit1Attr(const ::Sharanfruit1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sharanfruit1Attr\n");
#endif
  
  ernie.seed("Sharanfruit1AttrCall");
  AddName("_attr");
  if (!CheckSharanfruit1(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sharanfruit1AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sharanfruit1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Sharanfruit1_slice *
idlServer_imp::Sharanfruit1Op(const ::Sharanfruit1 p1,::Sharanfruit1_out p2,::Sharanfruit1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Sharanfruit1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sharanfruit1Op\n");
#endif
  
  ernie.seed("Sharanfruit1OpCall");
  AddName("p1");
  if (!CheckSharanfruit1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckSharanfruit1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sharanfruit1OpReturn"); 
  {
    ::idlServer::Sharanfruit1Excpt ex;
    GetidlServerSharanfruit1Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Sharanfruit1;
  GetSharanfruit1(ReturnValue);
  p2 = new ::Sharanfruit1;
  GetSharanfruit1(p2);
  GetSharanfruit1(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sharanfruit1Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Damsons1*
idlServer_imp::Damsons1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Damsons1* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Damsons1Attr\n");
#endif
  
  ernie.seed("Damsons1AttrCall");
  
  ernie.seed("Damsons1AttrReturn"); 
  ReturnValue = new ::Damsons1;
  GetDamsons1(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Damsons1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Damsons1Attr(const ::Damsons1 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Damsons1Attr\n");
#endif
  
  ernie.seed("Damsons1AttrCall");
  AddName("_attr");
  if (!CheckDamsons1(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Damsons1AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Damsons1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Damsons1*
idlServer_imp::Damsons1Op(const ::Damsons1 &p1,::Damsons1_out p2,::Damsons1 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Damsons1* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Damsons1Op\n");
#endif
  
  ernie.seed("Damsons1OpCall");
  AddName("p1");
  if (!CheckDamsons1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckDamsons1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Damsons1OpReturn"); 
  {
    ::idlServer::Damsons1Excpt ex;
    GetidlServerDamsons1Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Damsons1;
  GetDamsons1(*ReturnValue);
  p2 = new ::Damsons1;
  GetDamsons1(*(p2.ptr()));
  GetDamsons1(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Damsons1Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Eddo1_slice *
idlServer_imp::Eddo1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Eddo1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Eddo1Attr\n");
#endif
  
  ernie.seed("Eddo1AttrCall");
  
  ernie.seed("Eddo1AttrReturn"); 
  
  ReturnValue = new ::Eddo1;
  GetEddo1(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Eddo1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Eddo1Attr(const ::Eddo1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Eddo1Attr\n");
#endif
  
  ernie.seed("Eddo1AttrCall");
  AddName("_attr");
  if (!CheckEddo1(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Eddo1AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Eddo1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Eddo1_slice *
idlServer_imp::Eddo1Op(const ::Eddo1 p1,::Eddo1_out p2,::Eddo1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Eddo1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Eddo1Op\n");
#endif
  
  ernie.seed("Eddo1OpCall");
  AddName("p1");
  if (!CheckEddo1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckEddo1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Eddo1OpReturn"); 
  {
    ::idlServer::Eddo1Excpt ex;
    GetidlServerEddo1Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Eddo1;
  GetEddo1(ReturnValue);
  p2 = new ::Eddo1;
  GetEddo1(p2);
  GetEddo1(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Eddo1Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::CoxPippin1*
idlServer_imp::CoxPippin1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::CoxPippin1* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CoxPippin1Attr\n");
#endif
  
  ernie.seed("CoxPippin1AttrCall");
  
  ernie.seed("CoxPippin1AttrReturn"); 
  ReturnValue = new ::CoxPippin1;
  GetCoxPippin1(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CoxPippin1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::CoxPippin1Attr(const ::CoxPippin1 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CoxPippin1Attr\n");
#endif
  
  ernie.seed("CoxPippin1AttrCall");
  AddName("_attr");
  if (!CheckCoxPippin1(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CoxPippin1AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CoxPippin1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::CoxPippin1*
idlServer_imp::CoxPippin1Op(const ::CoxPippin1 &p1,::CoxPippin1_out p2,::CoxPippin1 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::CoxPippin1* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CoxPippin1Op\n");
#endif
  
  ernie.seed("CoxPippin1OpCall");
  AddName("p1");
  if (!CheckCoxPippin1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCoxPippin1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CoxPippin1OpReturn"); 
  {
    ::idlServer::CoxPippin1Excpt ex;
    GetidlServerCoxPippin1Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::CoxPippin1;
  GetCoxPippin1(*ReturnValue);
  p2 = new ::CoxPippin1;
  GetCoxPippin1(*(p2.ptr()));
  GetCoxPippin1(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CoxPippin1Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::KiwanoMelon1_slice *
idlServer_imp::KiwanoMelon1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::KiwanoMelon1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KiwanoMelon1Attr\n");
#endif
  
  ernie.seed("KiwanoMelon1AttrCall");
  
  ernie.seed("KiwanoMelon1AttrReturn"); 
  
  ReturnValue = new ::KiwanoMelon1;
  GetKiwanoMelon1(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KiwanoMelon1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::KiwanoMelon1Attr(const ::KiwanoMelon1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KiwanoMelon1Attr\n");
#endif
  
  ernie.seed("KiwanoMelon1AttrCall");
  AddName("_attr");
  if (!CheckKiwanoMelon1(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KiwanoMelon1AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KiwanoMelon1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::KiwanoMelon1_slice *
idlServer_imp::KiwanoMelon1Op(const ::KiwanoMelon1 p1,::KiwanoMelon1_out p2,::KiwanoMelon1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::KiwanoMelon1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KiwanoMelon1Op\n");
#endif
  
  ernie.seed("KiwanoMelon1OpCall");
  AddName("p1");
  if (!CheckKiwanoMelon1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckKiwanoMelon1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KiwanoMelon1OpReturn"); 
  {
    ::idlServer::KiwanoMelon1Excpt ex;
    GetidlServerKiwanoMelon1Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::KiwanoMelon1;
  GetKiwanoMelon1(ReturnValue);
  p2 = new ::KiwanoMelon1;
  GetKiwanoMelon1(p2);
  GetKiwanoMelon1(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KiwanoMelon1Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::RedCabbage1*
idlServer_imp::RedCabbage1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::RedCabbage1* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedCabbage1Attr\n");
#endif
  
  ernie.seed("RedCabbage1AttrCall");
  
  ernie.seed("RedCabbage1AttrReturn"); 
  ReturnValue = new ::RedCabbage1;
  GetRedCabbage1(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedCabbage1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::RedCabbage1Attr(const ::RedCabbage1 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedCabbage1Attr\n");
#endif
  
  ernie.seed("RedCabbage1AttrCall");
  AddName("_attr");
  if (!CheckRedCabbage1(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedCabbage1AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedCabbage1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::RedCabbage1*
idlServer_imp::RedCabbage1Op(const ::RedCabbage1 &p1,::RedCabbage1_out p2,::RedCabbage1 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::RedCabbage1* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedCabbage1Op\n");
#endif
  
  ernie.seed("RedCabbage1OpCall");
  AddName("p1");
  if (!CheckRedCabbage1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckRedCabbage1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedCabbage1OpReturn"); 
  {
    ::idlServer::RedCabbage1Excpt ex;
    GetidlServerRedCabbage1Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::RedCabbage1;
  GetRedCabbage1(*ReturnValue);
  p2 = new ::RedCabbage1;
  GetRedCabbage1(*(p2.ptr()));
  GetRedCabbage1(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedCabbage1Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Pimpernel1_slice *
idlServer_imp::Pimpernel1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Pimpernel1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Pimpernel1Attr\n");
#endif
  
  ernie.seed("Pimpernel1AttrCall");
  
  ernie.seed("Pimpernel1AttrReturn"); 
  
  ReturnValue = new ::Pimpernel1;
  GetPimpernel1(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Pimpernel1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Pimpernel1Attr(const ::Pimpernel1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Pimpernel1Attr\n");
#endif
  
  ernie.seed("Pimpernel1AttrCall");
  AddName("_attr");
  if (!CheckPimpernel1(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Pimpernel1AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Pimpernel1Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Pimpernel1_slice *
idlServer_imp::Pimpernel1Op(const ::Pimpernel1 p1,::Pimpernel1_out p2,::Pimpernel1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Pimpernel1_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Pimpernel1Op\n");
#endif
  
  ernie.seed("Pimpernel1OpCall");
  AddName("p1");
  if (!CheckPimpernel1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPimpernel1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Pimpernel1OpReturn"); 
  {
    ::idlServer::Pimpernel1Excpt ex;
    GetidlServerPimpernel1Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Pimpernel1;
  GetPimpernel1(ReturnValue);
  p2 = new ::Pimpernel1;
  GetPimpernel1(p2);
  GetPimpernel1(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Pimpernel1Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::BlackCherry2*
idlServer_imp::BlackCherry2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::BlackCherry2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BlackCherry2Attr\n");
#endif
  
  ernie.seed("BlackCherry2AttrCall");
  
  ernie.seed("BlackCherry2AttrReturn"); 
  ReturnValue = new ::BlackCherry2;
  GetBlackCherry2(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BlackCherry2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BlackCherry2Attr(const ::BlackCherry2 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BlackCherry2Attr\n");
#endif
  
  ernie.seed("BlackCherry2AttrCall");
  AddName("_attr");
  if (!CheckBlackCherry2(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlackCherry2AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BlackCherry2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::BlackCherry2*
idlServer_imp::BlackCherry2Op(const ::BlackCherry2 &p1,::BlackCherry2_out p2,::BlackCherry2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::BlackCherry2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BlackCherry2Op\n");
#endif
  
  ernie.seed("BlackCherry2OpCall");
  AddName("p1");
  if (!CheckBlackCherry2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBlackCherry2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlackCherry2OpReturn"); 
  {
    ::idlServer::BlackCherry2Excpt ex;
    GetidlServerBlackCherry2Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::BlackCherry2;
  GetBlackCherry2(*ReturnValue);
  p2 = new ::BlackCherry2;
  GetBlackCherry2(*(p2.ptr()));
  GetBlackCherry2(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BlackCherry2Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Cucumber2*
idlServer_imp::Cucumber2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Cucumber2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Cucumber2Attr\n");
#endif
  
  ernie.seed("Cucumber2AttrCall");
  
  ernie.seed("Cucumber2AttrReturn"); 
  ReturnValue = new ::Cucumber2;
  GetCucumber2(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Cucumber2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Cucumber2Attr(const ::Cucumber2 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Cucumber2Attr\n");
#endif
  
  ernie.seed("Cucumber2AttrCall");
  AddName("_attr");
  if (!CheckCucumber2(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cucumber2AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Cucumber2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Cucumber2*
idlServer_imp::Cucumber2Op(const ::Cucumber2 &p1,::Cucumber2_out p2,::Cucumber2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Cucumber2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Cucumber2Op\n");
#endif
  
  ernie.seed("Cucumber2OpCall");
  AddName("p1");
  if (!CheckCucumber2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCucumber2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cucumber2OpReturn"); 
  {
    ::idlServer::Cucumber2Excpt ex;
    GetidlServerCucumber2Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Cucumber2;
  GetCucumber2(*ReturnValue);
  p2 = new ::Cucumber2;
  GetCucumber2(*(p2.ptr()));
  GetCucumber2(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Cucumber2Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



