//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/checkany.cpp
//
// Modifications:
// $Log: checkany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:28  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1999/04/26 13:51:18  james
// Changed CORBA::Char* to char*
//
// Revision 1.4  1997/12/09 11:27:20  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern char name[];

 
int CheckAny(const CORBA::Any &any)
{
  switch(ernie.getULong()%(12+15))
  {
    case   0: {
                CORBA::ULong  v;
#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::ULong");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::ULong as expected", name);
                  return 0;
                }
                if (!ernie.checkULong(v))
                {
                  tet_printf("Expected %s to contain CORBA::ULong with value %u, but found %u instead.",
                    name,ernie.getULongAgain(),v);
                  return 0;
                }
              }
              break;
    case   1: {
                CORBA::Long  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Long");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Long as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkLong(v))
                {
                  tet_printf("Expected %s to contain CORBA::Long with value %d, but found %d instead.",
                    name,ernie.getLongAgain(),v);
                  return 0;
                }
              }
              break;
    case   2: {
                CORBA::UShort  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::UShort");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::UShort as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkUShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::UShort with value %u, but found %u instead.",
                    name,ernie.getUShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   3: {
                CORBA::Short  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Short");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Short as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::Short with value %d, but found %d instead.",
                    name,ernie.getShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   4: {
                CORBA::Boolean  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Boolean");
#endif
                if (!(any >>= CORBA::Any::to_boolean(v)))
                {
                  tet_printf("%s did not contain a CORBA::Boolean as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkBoolean(v))
                {
                  tet_printf("Expected %s to contain CORBA::Boolean with value %s, but found %s instead.",
                    name,
                    BooleanToString(ernie.getBooleanAgain()),
                    BooleanToString(v));
                  return 0;
                }
              }
              break;
    case   5: {
                CORBA::Octet  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Octet");
#endif
                if (!(any >>= CORBA::Any::to_octet(v)))
                {
                  tet_printf("%s did not contain a CORBA::Octet as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkOctet(v))
                {
                  ::tet_printf("Expected %s to contain CORBA::Octet with value %s, but found %s instead.",
                    name,
                    OctetToString(ernie.getOctetAgain()),
                    OctetToString(v));
                  return 0;
                }
              }
              break;
    case   6: {
                CORBA::Char  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Char");
#endif
                if (!(any >>= CORBA::Any::to_char(v)))
                {
                  tet_printf("%s did not contain a CORBA::Char as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkChar(v))
                {
                  tet_printf("Expected %s to contain CORBA::Char with value %s, but found %s instead.",
                    name,
                    CharToString(ernie.getCharAgain()),
                    CharToString(v));
                  return 0;
                }
              }
              break;
    case   7: {
                CORBA::Float  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Float");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Float as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkFloat(v))
                {
                  tet_printf("Expected %s to contain CORBA::Float with value %g, but found %g instead.",
                    name,
                    ernie.getFloatAgain(),
                    v);
                  return 0;
                }
              }
               break;
    case   8: {
                CORBA::Double  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Double");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Double as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkDouble(v))
                {
                  tet_printf("Expected %s to contain CORBA::Double with value %g, but found %g instead.",
                    name,
                    ernie.getDoubleAgain(),
                    v);
                  return 0;
                }
              }
              break;
    case   9: {
                char *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting char*");
#endif
                if (!(any >>= CORBA::Any::to_string(v,0)))
                {
                  tet_printf("%s did not contain a char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v))
                {
                  tet_printf("Expected %s to contain char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case  10: {
                CORBA::ULong  b;
                char   *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting bounded char*");
#endif
                b = ernie.getULong()%30+1;

                if (!(any >>= CORBA::Any::to_string(v,b)))
                {
                  tet_printf("%s did not contain a bounded char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v,b))
                {
                  tet_printf("Expected %s to contain a bounded char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::TypeCode");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::TypeCode as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCORBATypeCode_ptr(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case   12: {
                CORBA::Any  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Any");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Any as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAny(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  13: {
                ::Parsnip2_forany v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Parsnip2\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Parsnip2 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckParsnip2(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  14: {
                ::Prunes2 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Prunes2\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Prunes2 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPrunes2(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  15: {
                ::Plum2_forany v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Plum2\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Plum2 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPlum2(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  16: {
                ::EggPlant2 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::EggPlant2\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::EggPlant2 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckEggPlant2(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  17: {
                ::Mustard2 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mustard2\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mustard2 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMustard2(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  18: {
                ::Elderberry2_forany v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Elderberry2\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Elderberry2 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckElderberry2(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  19: {
                ::RedPepper2 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::RedPepper2\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::RedPepper2 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRedPepper2(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  20: {
                ::Artichokes2_forany v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Artichokes2\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Artichokes2 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckArtichokes2(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  21: {
                ::KiwanoMelon2_forany v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::KiwanoMelon2\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::KiwanoMelon2 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckKiwanoMelon2(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  22: {
                ::BritishQueens2 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BritishQueens2\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BritishQueens2 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBritishQueens2(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  23: {
                ::Starfruit3_forany v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Starfruit3\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Starfruit3 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckStarfruit3(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  24: {
                ::Parsnip3_forany v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Parsnip3\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Parsnip3 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckParsnip3(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  25: {
                ::Billberries3 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Billberries3\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Billberries3 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBillberries3(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  26: {
                ::GooseBerry3_forany v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GooseBerry3\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GooseBerry3 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGooseBerry3(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  27: {
                ::Elderberry3_forany v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Elderberry3\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Elderberry3 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckElderberry3(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;

  }
  return 1;
}




