//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Parsnip2_slice *
idlServer_imp::Parsnip2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Parsnip2_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Parsnip2Attr\n");
#endif
  
  ernie.seed("Parsnip2AttrCall");
  
  ernie.seed("Parsnip2AttrReturn"); 
  
  ReturnValue = new ::Parsnip2;
  GetParsnip2(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Parsnip2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Parsnip2Attr(const ::Parsnip2 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Parsnip2Attr\n");
#endif
  
  ernie.seed("Parsnip2AttrCall");
  AddName("_attr");
  if (!CheckParsnip2(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Parsnip2AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Parsnip2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Parsnip2_slice *
idlServer_imp::Parsnip2Op(const ::Parsnip2 p1,::Parsnip2_out p2,::Parsnip2 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Parsnip2_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Parsnip2Op\n");
#endif
  
  ernie.seed("Parsnip2OpCall");
  AddName("p1");
  if (!CheckParsnip2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckParsnip2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Parsnip2OpReturn"); 
  {
    ::idlServer::Parsnip2Excpt ex;
    GetidlServerParsnip2Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Parsnip2;
  GetParsnip2(ReturnValue);
  p2 = new ::Parsnip2;
  GetParsnip2(p2);
  GetParsnip2(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Parsnip2Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Prunes2*
idlServer_imp::Prunes2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Prunes2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Prunes2Attr\n");
#endif
  
  ernie.seed("Prunes2AttrCall");
  
  ernie.seed("Prunes2AttrReturn"); 
  ReturnValue = new ::Prunes2;
  GetPrunes2(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Prunes2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Prunes2Attr(const ::Prunes2 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Prunes2Attr\n");
#endif
  
  ernie.seed("Prunes2AttrCall");
  AddName("_attr");
  if (!CheckPrunes2(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Prunes2AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Prunes2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Prunes2*
idlServer_imp::Prunes2Op(const ::Prunes2 &p1,::Prunes2_out p2,::Prunes2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Prunes2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Prunes2Op\n");
#endif
  
  ernie.seed("Prunes2OpCall");
  AddName("p1");
  if (!CheckPrunes2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPrunes2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Prunes2OpReturn"); 
  {
    ::idlServer::Prunes2Excpt ex;
    GetidlServerPrunes2Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Prunes2;
  GetPrunes2(*ReturnValue);
  p2 = new ::Prunes2;
  GetPrunes2(*(p2.ptr()));
  GetPrunes2(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Prunes2Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Plum2_slice *
idlServer_imp::Plum2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Plum2_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Plum2Attr\n");
#endif
  
  ernie.seed("Plum2AttrCall");
  
  ernie.seed("Plum2AttrReturn"); 
  
  ReturnValue = new ::Plum2;
  GetPlum2(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Plum2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Plum2Attr(const ::Plum2 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Plum2Attr\n");
#endif
  
  ernie.seed("Plum2AttrCall");
  AddName("_attr");
  if (!CheckPlum2(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Plum2AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Plum2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Plum2_slice *
idlServer_imp::Plum2Op(const ::Plum2 p1,::Plum2_out p2,::Plum2 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Plum2_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Plum2Op\n");
#endif
  
  ernie.seed("Plum2OpCall");
  AddName("p1");
  if (!CheckPlum2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPlum2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Plum2OpReturn"); 
  {
    ::idlServer::Plum2Excpt ex;
    GetidlServerPlum2Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Plum2;
  GetPlum2(ReturnValue);
  p2 = new ::Plum2;
  GetPlum2(p2);
  GetPlum2(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Plum2Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::EggPlant2*
idlServer_imp::EggPlant2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::EggPlant2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::EggPlant2Attr\n");
#endif
  
  ernie.seed("EggPlant2AttrCall");
  
  ernie.seed("EggPlant2AttrReturn"); 
  ReturnValue = new ::EggPlant2;
  GetEggPlant2(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::EggPlant2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::EggPlant2Attr(const ::EggPlant2 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::EggPlant2Attr\n");
#endif
  
  ernie.seed("EggPlant2AttrCall");
  AddName("_attr");
  if (!CheckEggPlant2(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("EggPlant2AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::EggPlant2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::EggPlant2*
idlServer_imp::EggPlant2Op(const ::EggPlant2 &p1,::EggPlant2_out p2,::EggPlant2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::EggPlant2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::EggPlant2Op\n");
#endif
  
  ernie.seed("EggPlant2OpCall");
  AddName("p1");
  if (!CheckEggPlant2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckEggPlant2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("EggPlant2OpReturn"); 
  {
    ::idlServer::EggPlant2Excpt ex;
    GetidlServerEggPlant2Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::EggPlant2;
  GetEggPlant2(*ReturnValue);
  p2 = new ::EggPlant2;
  GetEggPlant2(*(p2.ptr()));
  GetEggPlant2(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::EggPlant2Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Mustard2*
idlServer_imp::Mustard2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Mustard2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Mustard2Attr\n");
#endif
  
  ernie.seed("Mustard2AttrCall");
  
  ernie.seed("Mustard2AttrReturn"); 
  ReturnValue = new ::Mustard2;
  GetMustard2(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Mustard2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Mustard2Attr(const ::Mustard2 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Mustard2Attr\n");
#endif
  
  ernie.seed("Mustard2AttrCall");
  AddName("_attr");
  if (!CheckMustard2(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Mustard2AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Mustard2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Mustard2*
idlServer_imp::Mustard2Op(const ::Mustard2 &p1,::Mustard2_out p2,::Mustard2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Mustard2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Mustard2Op\n");
#endif
  
  ernie.seed("Mustard2OpCall");
  AddName("p1");
  if (!CheckMustard2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckMustard2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Mustard2OpReturn"); 
  {
    ::idlServer::Mustard2Excpt ex;
    GetidlServerMustard2Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Mustard2;
  GetMustard2(*ReturnValue);
  p2 = new ::Mustard2;
  GetMustard2(*(p2.ptr()));
  GetMustard2(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Mustard2Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Elderberry2_slice *
idlServer_imp::Elderberry2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Elderberry2_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Elderberry2Attr\n");
#endif
  
  ernie.seed("Elderberry2AttrCall");
  
  ernie.seed("Elderberry2AttrReturn"); 
  
  ReturnValue = new ::Elderberry2;
  GetElderberry2(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Elderberry2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Elderberry2Attr(const ::Elderberry2 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Elderberry2Attr\n");
#endif
  
  ernie.seed("Elderberry2AttrCall");
  AddName("_attr");
  if (!CheckElderberry2(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Elderberry2AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Elderberry2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Elderberry2_slice *
idlServer_imp::Elderberry2Op(const ::Elderberry2 p1,::Elderberry2_out p2,::Elderberry2 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Elderberry2_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Elderberry2Op\n");
#endif
  
  ernie.seed("Elderberry2OpCall");
  AddName("p1");
  if (!CheckElderberry2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckElderberry2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Elderberry2OpReturn"); 
  {
    ::idlServer::Elderberry2Excpt ex;
    GetidlServerElderberry2Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Elderberry2;
  GetElderberry2(ReturnValue);
  p2 = new ::Elderberry2;
  GetElderberry2(p2);
  GetElderberry2(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Elderberry2Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::RedPepper2*
idlServer_imp::RedPepper2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::RedPepper2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedPepper2Attr\n");
#endif
  
  ernie.seed("RedPepper2AttrCall");
  
  ernie.seed("RedPepper2AttrReturn"); 
  ReturnValue = new ::RedPepper2;
  GetRedPepper2(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedPepper2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::RedPepper2Attr(const ::RedPepper2 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedPepper2Attr\n");
#endif
  
  ernie.seed("RedPepper2AttrCall");
  AddName("_attr");
  if (!CheckRedPepper2(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedPepper2AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedPepper2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::RedPepper2*
idlServer_imp::RedPepper2Op(const ::RedPepper2 &p1,::RedPepper2_out p2,::RedPepper2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::RedPepper2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedPepper2Op\n");
#endif
  
  ernie.seed("RedPepper2OpCall");
  AddName("p1");
  if (!CheckRedPepper2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckRedPepper2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedPepper2OpReturn"); 
  {
    ::idlServer::RedPepper2Excpt ex;
    GetidlServerRedPepper2Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::RedPepper2;
  GetRedPepper2(*ReturnValue);
  p2 = new ::RedPepper2;
  GetRedPepper2(*(p2.ptr()));
  GetRedPepper2(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedPepper2Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Artichokes2_slice *
idlServer_imp::Artichokes2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Artichokes2_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Artichokes2Attr\n");
#endif
  
  ernie.seed("Artichokes2AttrCall");
  
  ernie.seed("Artichokes2AttrReturn"); 
  
  ReturnValue = new ::Artichokes2;
  GetArtichokes2(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Artichokes2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Artichokes2Attr(const ::Artichokes2 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Artichokes2Attr\n");
#endif
  
  ernie.seed("Artichokes2AttrCall");
  AddName("_attr");
  if (!CheckArtichokes2(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Artichokes2AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Artichokes2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Artichokes2_slice *
idlServer_imp::Artichokes2Op(const ::Artichokes2 p1,::Artichokes2_out p2,::Artichokes2 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Artichokes2_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Artichokes2Op\n");
#endif
  
  ernie.seed("Artichokes2OpCall");
  AddName("p1");
  if (!CheckArtichokes2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckArtichokes2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Artichokes2OpReturn"); 
  {
    ::idlServer::Artichokes2Excpt ex;
    GetidlServerArtichokes2Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Artichokes2;
  GetArtichokes2(ReturnValue);
  p2 = new ::Artichokes2;
  GetArtichokes2(p2);
  GetArtichokes2(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Artichokes2Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::KiwanoMelon2_slice *
idlServer_imp::KiwanoMelon2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::KiwanoMelon2_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KiwanoMelon2Attr\n");
#endif
  
  ernie.seed("KiwanoMelon2AttrCall");
  
  ernie.seed("KiwanoMelon2AttrReturn"); 
  
  ReturnValue = new ::KiwanoMelon2;
  GetKiwanoMelon2(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KiwanoMelon2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::KiwanoMelon2Attr(const ::KiwanoMelon2 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KiwanoMelon2Attr\n");
#endif
  
  ernie.seed("KiwanoMelon2AttrCall");
  AddName("_attr");
  if (!CheckKiwanoMelon2(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KiwanoMelon2AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KiwanoMelon2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::KiwanoMelon2_slice *
idlServer_imp::KiwanoMelon2Op(const ::KiwanoMelon2 p1,::KiwanoMelon2_out p2,::KiwanoMelon2 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::KiwanoMelon2_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KiwanoMelon2Op\n");
#endif
  
  ernie.seed("KiwanoMelon2OpCall");
  AddName("p1");
  if (!CheckKiwanoMelon2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckKiwanoMelon2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KiwanoMelon2OpReturn"); 
  {
    ::idlServer::KiwanoMelon2Excpt ex;
    GetidlServerKiwanoMelon2Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::KiwanoMelon2;
  GetKiwanoMelon2(ReturnValue);
  p2 = new ::KiwanoMelon2;
  GetKiwanoMelon2(p2);
  GetKiwanoMelon2(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KiwanoMelon2Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::BritishQueens2*
idlServer_imp::BritishQueens2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::BritishQueens2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BritishQueens2Attr\n");
#endif
  
  ernie.seed("BritishQueens2AttrCall");
  
  ernie.seed("BritishQueens2AttrReturn"); 
  ReturnValue = new ::BritishQueens2;
  GetBritishQueens2(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BritishQueens2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BritishQueens2Attr(const ::BritishQueens2 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BritishQueens2Attr\n");
#endif
  
  ernie.seed("BritishQueens2AttrCall");
  AddName("_attr");
  if (!CheckBritishQueens2(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BritishQueens2AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BritishQueens2Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::BritishQueens2*
idlServer_imp::BritishQueens2Op(const ::BritishQueens2 &p1,::BritishQueens2_out p2,::BritishQueens2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::BritishQueens2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BritishQueens2Op\n");
#endif
  
  ernie.seed("BritishQueens2OpCall");
  AddName("p1");
  if (!CheckBritishQueens2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBritishQueens2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BritishQueens2OpReturn"); 
  {
    ::idlServer::BritishQueens2Excpt ex;
    GetidlServerBritishQueens2Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::BritishQueens2;
  GetBritishQueens2(*ReturnValue);
  p2 = new ::BritishQueens2;
  GetBritishQueens2(*(p2.ptr()));
  GetBritishQueens2(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BritishQueens2Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Starfruit3_slice *
idlServer_imp::Starfruit3Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Starfruit3_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Starfruit3Attr\n");
#endif
  
  ernie.seed("Starfruit3AttrCall");
  
  ernie.seed("Starfruit3AttrReturn"); 
  
  ReturnValue = new ::Starfruit3;
  GetStarfruit3(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Starfruit3Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Starfruit3Attr(const ::Starfruit3 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Starfruit3Attr\n");
#endif
  
  ernie.seed("Starfruit3AttrCall");
  AddName("_attr");
  if (!CheckStarfruit3(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Starfruit3AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Starfruit3Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Starfruit3_slice *
idlServer_imp::Starfruit3Op(const ::Starfruit3 p1,::Starfruit3_out p2,::Starfruit3 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Starfruit3_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Starfruit3Op\n");
#endif
  
  ernie.seed("Starfruit3OpCall");
  AddName("p1");
  if (!CheckStarfruit3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckStarfruit3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Starfruit3OpReturn"); 
  {
    ::idlServer::Starfruit3Excpt ex;
    GetidlServerStarfruit3Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Starfruit3;
  GetStarfruit3(ReturnValue);
  p2 = new ::Starfruit3;
  GetStarfruit3(p2);
  GetStarfruit3(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Starfruit3Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Parsnip3_slice *
idlServer_imp::Parsnip3Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Parsnip3_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Parsnip3Attr\n");
#endif
  
  ernie.seed("Parsnip3AttrCall");
  
  ernie.seed("Parsnip3AttrReturn"); 
  
  ReturnValue = new ::Parsnip3;
  GetParsnip3(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Parsnip3Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Parsnip3Attr(const ::Parsnip3 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Parsnip3Attr\n");
#endif
  
  ernie.seed("Parsnip3AttrCall");
  AddName("_attr");
  if (!CheckParsnip3(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Parsnip3AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Parsnip3Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Parsnip3_slice *
idlServer_imp::Parsnip3Op(const ::Parsnip3 p1,::Parsnip3_out p2,::Parsnip3 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Parsnip3_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Parsnip3Op\n");
#endif
  
  ernie.seed("Parsnip3OpCall");
  AddName("p1");
  if (!CheckParsnip3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckParsnip3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Parsnip3OpReturn"); 
  {
    ::idlServer::Parsnip3Excpt ex;
    GetidlServerParsnip3Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Parsnip3;
  GetParsnip3(ReturnValue);
  p2 = new ::Parsnip3;
  GetParsnip3(p2);
  GetParsnip3(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Parsnip3Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Billberries3*
idlServer_imp::Billberries3Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Billberries3* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Billberries3Attr\n");
#endif
  
  ernie.seed("Billberries3AttrCall");
  
  ernie.seed("Billberries3AttrReturn"); 
  ReturnValue = new ::Billberries3;
  GetBillberries3(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Billberries3Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Billberries3Attr(const ::Billberries3 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Billberries3Attr\n");
#endif
  
  ernie.seed("Billberries3AttrCall");
  AddName("_attr");
  if (!CheckBillberries3(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Billberries3AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Billberries3Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Billberries3*
idlServer_imp::Billberries3Op(const ::Billberries3 &p1,::Billberries3_out p2,::Billberries3 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Billberries3* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Billberries3Op\n");
#endif
  
  ernie.seed("Billberries3OpCall");
  AddName("p1");
  if (!CheckBillberries3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBillberries3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Billberries3OpReturn"); 
  {
    ::idlServer::Billberries3Excpt ex;
    GetidlServerBillberries3Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Billberries3;
  GetBillberries3(*ReturnValue);
  p2 = new ::Billberries3;
  GetBillberries3(*(p2.ptr()));
  GetBillberries3(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Billberries3Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GooseBerry3_slice *
idlServer_imp::GooseBerry3Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry3_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GooseBerry3Attr\n");
#endif
  
  ernie.seed("GooseBerry3AttrCall");
  
  ernie.seed("GooseBerry3AttrReturn"); 
  
  ReturnValue = new ::GooseBerry3;
  GetGooseBerry3(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GooseBerry3Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::GooseBerry3Attr(const ::GooseBerry3 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GooseBerry3Attr\n");
#endif
  
  ernie.seed("GooseBerry3AttrCall");
  AddName("_attr");
  if (!CheckGooseBerry3(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GooseBerry3AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GooseBerry3Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::GooseBerry3_slice *
idlServer_imp::GooseBerry3Op(const ::GooseBerry3 p1,::GooseBerry3_out p2,::GooseBerry3 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry3_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GooseBerry3Op\n");
#endif
  
  ernie.seed("GooseBerry3OpCall");
  AddName("p1");
  if (!CheckGooseBerry3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GooseBerry3OpReturn"); 
  {
    ::idlServer::GooseBerry3Excpt ex;
    GetidlServerGooseBerry3Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::GooseBerry3;
  GetGooseBerry3(ReturnValue);
  p2 = new ::GooseBerry3;
  GetGooseBerry3(p2);
  GetGooseBerry3(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GooseBerry3Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Elderberry3_slice *
idlServer_imp::Elderberry3Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Elderberry3_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Elderberry3Attr\n");
#endif
  
  ernie.seed("Elderberry3AttrCall");
  
  ernie.seed("Elderberry3AttrReturn"); 
  
  ReturnValue = new ::Elderberry3;
  GetElderberry3(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Elderberry3Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Elderberry3Attr(const ::Elderberry3 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Elderberry3Attr\n");
#endif
  
  ernie.seed("Elderberry3AttrCall");
  AddName("_attr");
  if (!CheckElderberry3(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Elderberry3AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Elderberry3Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Elderberry3_slice *
idlServer_imp::Elderberry3Op(const ::Elderberry3 p1,::Elderberry3_out p2,::Elderberry3 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Elderberry3_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Elderberry3Op\n");
#endif
  
  ernie.seed("Elderberry3OpCall");
  AddName("p1");
  if (!CheckElderberry3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckElderberry3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Elderberry3OpReturn"); 
  {
    ::idlServer::Elderberry3Excpt ex;
    GetidlServerElderberry3Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Elderberry3;
  GetElderberry3(ReturnValue);
  p2 = new ::Elderberry3;
  GetElderberry3(p2);
  GetElderberry3(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Elderberry3Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



