//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/getany.cpp
//
// Modifications:
// $Log: getany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:31  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1997/12/12 08:51:02  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"

//Header files generated by idl compiler
#include "tin.hh"

#include "types.hh"
extern Ernie ernie;


void GetAny(CORBA::Any &any)
{
  switch(ernie.getULong()%(12+14))
  {
    case   0: any <<= ernie.getULong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating ULong");
#endif
              break;
    case   1: any <<= ernie.getLong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Long");
#endif
              break;
    case   2: any <<= ernie.getUShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating UShort");
#endif
              break;
    case   3: any <<= ernie.getShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Short");
#endif
              break;
    case   4: any <<= CORBA::Any::from_boolean(ernie.getBoolean());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Boolean");
#endif
              break;
    case   5: any <<= CORBA::Any::from_octet(ernie.getOctet());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Octet");
#endif
              break;
    case   6: any <<= CORBA::Any::from_char(ernie.getChar());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Char");
#endif
              break;
    case   7: any <<= ernie.getFloat();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Float");
#endif
               break;
    case   8: any <<= ernie.getDouble();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Double");
#endif
              break;
    case   9: any <<= ernie.getString();
#ifdef DEBUG
              ::tet_infoline("GetAny creating String");
#endif
              break;
    case  10: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating BoundedString");
#endif
                CORBA::ULong  b;
                b = ernie.getULong()%30+1;
                any <<= CORBA::Any::from_string(ernie.getString(b),b);
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr _typecode;
#ifdef DEBUG
                ::tet_infoline("GetAny creating TypeCode");
#endif
                GetCORBATypeCode_ptr(_typecode);
                any <<= _typecode;
               }
                break;
    case   12: {
                CORBA::Any  _any;  
#ifdef DEBUG
                ::tet_infoline("GetAny creating Any");
#endif
                GetAny(_any);
                any <<= _any;
               }
                break;

    case  13: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::LoganBerry19");
#endif
                ::LoganBerry19   v;

                GetLoganBerry19(v);

                any  <<= v;
              }
              break;

    case  14: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Orange19");
#endif
                ::Orange19   v;

                GetOrange19(v);

                any  <<= v;
              }
              break;

    case  15: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BlackCherry20");
#endif
                ::BlackCherry20   v;

                GetBlackCherry20(v);

                any  <<= v;
              }
              break;

    case  16: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lemon20");
#endif
                ::Lemon20   v;

                GetLemon20(v);

                any  <<= v;
              }
              break;

    case  17: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Coconut6");
#endif
                ::Coconut6_forany   v(::Coconut6_alloc());

                GetCoconut6(v);

                any  <<= v;
              }
              break;

    case  18: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lime6");
#endif
                ::Lime6   v;

                GetLime6(v);

                any  <<= v;
              }
              break;

    case  19: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mint6");
#endif
                ::Mint6_forany   v(::Mint6_alloc());

                GetMint6(v);

                any  <<= v;
              }
              break;

    case  20: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BlackEyedBeans6");
#endif
                ::BlackEyedBeans6   v;

                GetBlackEyedBeans6(v);

                any  <<= v;
              }
              break;

    case  21: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mangetout6");
#endif
                ::Mangetout6   v;

                GetMangetout6(v);

                any  <<= v;
              }
              break;

    case  22: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lettuce6");
#endif
                ::Lettuce6   v;

                GetLettuce6(v);

                any  <<= v;
              }
              break;

    case  23: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Chervil6");
#endif
                ::Chervil6_forany   v(::Chervil6_alloc());

                GetChervil6(v);

                any  <<= v;
              }
              break;

    case  24: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Blueberry6");
#endif
                ::Blueberry6   v;

                GetBlueberry6(v);

                any  <<= v;
              }
              break;

    case  25: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Turnip7");
#endif
                ::Turnip7   v;

                GetTurnip7(v);

                any  <<= v;
              }
              break;

    case  26: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sultana7");
#endif
                ::Sultana7   v;

                GetSultana7(v);

                any  <<= v;
              }
              break;

  }
}


