//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:31  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1999/04/26 13:51:22  james
// Changed CORBA::Char* to char*
//
// Revision 1.6  1997/12/15 10:51:50  james
// #ifdefs removed
//
// Revision 1.5  1997/12/12 08:51:03  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetLoganBerry19(::LoganBerry19 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLoganBerry19");
#endif

  GetLong(v.Sultana19);
  GetFloat(v.GaliaMelon19);
  GetBoolean(v.Turnip19);
}

int CheckLoganBerry19(const ::LoganBerry19 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLoganBerry19");
#endif

  AddName("Sultana19");
  if (!CheckLong(v.Sultana19))
    iRetCode = 0;
  RemoveName();
  AddName("GaliaMelon19");
  if (!CheckFloat(v.GaliaMelon19))
    iRetCode = 0;
  RemoveName();
  AddName("Turnip19");
  if (!CheckBoolean(v.Turnip19))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetOrange19(::Orange19 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetOrange19");
#endif

  GetLong(v.Sultana19);
  GetFloat(v.GaliaMelon19);
  GetBoolean(v.Turnip19);
}

int CheckOrange19(const ::Orange19 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckOrange19");
#endif

  AddName("Sultana19");
  if (!CheckLong(v.Sultana19))
    iRetCode = 0;
  RemoveName();
  AddName("GaliaMelon19");
  if (!CheckFloat(v.GaliaMelon19))
    iRetCode = 0;
  RemoveName();
  AddName("Turnip19");
  if (!CheckBoolean(v.Turnip19))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetBlackCherry20(::BlackCherry20 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBlackCherry20");
#endif

  GetOctet(v.Banana20);
  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      GetUShort(v.Apple20[i1]);
      RemoveIndex();
    }
  }
  GetChar(v.Carrots20);
}

int CheckBlackCherry20(const ::BlackCherry20 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBlackCherry20");
#endif

  AddName("Banana20");
  if (!CheckOctet(v.Banana20))
    iRetCode = 0;
  RemoveName();
  AddName("Apple20");
  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      if (!CheckUShort(v.Apple20[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Carrots20");
  if (!CheckChar(v.Carrots20))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetLemon20(::Lemon20 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLemon20");
#endif

  GetOctet(v.Banana20);
  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      GetUShort(v.Apple20[i1]);
      RemoveIndex();
    }
  }
  GetChar(v.Carrots20);
}

int CheckLemon20(const ::Lemon20 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLemon20");
#endif

  AddName("Banana20");
  if (!CheckOctet(v.Banana20))
    iRetCode = 0;
  RemoveName();
  AddName("Apple20");
  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      if (!CheckUShort(v.Apple20[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Carrots20");
  if (!CheckChar(v.Carrots20))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetCoconut6(::Coconut6 v)
{
#ifdef DEBUG
  ::tet_infoline("GetCoconut6");
#endif

  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 13; ++i3)
        {
          AddIndex(i3);
          GetChar(v[i1].WaterMelon6[i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCoconut6(const ::Coconut6 v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCoconut6");
#endif

  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      AddName("WaterMelon6");
      {
        int	i3;
        for(i3=0; i3 < 13; ++i3)
        {
          AddIndex(i3);
          if (!CheckChar(v[i1].WaterMelon6[i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetLime6(::Lime6 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLime6");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      GetChar(v.WaterMelon6[i1]);
      RemoveIndex();
    }
  }
}

int CheckLime6(const ::Lime6 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLime6");
#endif

  AddName("WaterMelon6");
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      if (!CheckChar(v.WaterMelon6[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetMint6(::Mint6 v)
{
#ifdef DEBUG
  ::tet_infoline("GetMint6");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 11; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v[i1].Apricots6[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v[i1].Apricots6[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetOrange19(v[i1].Apricots6[i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMint6(const ::Mint6 v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMint6");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      AddName("Apricots6");
      {
        int	i3;
        for(i3=0; i3 < 11; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v[i1].Apricots6[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1].Apricots6[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v[i1].Apricots6[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1].Apricots6[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckOrange19(v[i1].Apricots6[i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetBlackEyedBeans6(::BlackEyedBeans6 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBlackEyedBeans6");
#endif

  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Apricots6[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Apricots6[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetOrange19(v.Apricots6[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBlackEyedBeans6(const ::BlackEyedBeans6 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBlackEyedBeans6");
#endif

  AddName("Apricots6");
  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Apricots6[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Apricots6[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Apricots6[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Apricots6[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckOrange19(v.Apricots6[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetMangetout6(::Mangetout6 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMangetout6");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Tarragon6.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Tarragon6[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Tarragon6[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetBlackCherry20(v.Tarragon6[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMangetout6(const ::Mangetout6 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMangetout6");
#endif

  AddName("Tarragon6");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Tarragon6.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Tarragon6.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Tarragon6[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Tarragon6[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Tarragon6[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Tarragon6[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckBlackCherry20(v.Tarragon6[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetLettuce6(::Lettuce6 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLettuce6");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Tarragon6.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Tarragon6[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Tarragon6[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetBlackCherry20(v.Tarragon6[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLettuce6(const ::Lettuce6 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLettuce6");
#endif

  AddName("Tarragon6");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Tarragon6.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Tarragon6.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Tarragon6[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Tarragon6[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Tarragon6[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Tarragon6[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckBlackCherry20(v.Tarragon6[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetChervil6(::Chervil6 v)
{
#ifdef DEBUG
  ::tet_infoline("GetChervil6");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%12;
        v[i1].CoxPippin6.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%19;
            v[i1].CoxPippin6[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%10;
                v[i1].CoxPippin6[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v[i1].CoxPippin6[i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckChervil6(const ::Chervil6 v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckChervil6");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      AddName("CoxPippin6");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%12;
        if (l3 != v[i1].CoxPippin6.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].CoxPippin6.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%19;
            if (l5 != v[i1].CoxPippin6[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1].CoxPippin6[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%10;
                if (l7 != v[i1].CoxPippin6[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v[i1].CoxPippin6[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v[i1].CoxPippin6[i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetBlueberry6(::Blueberry6 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBlueberry6");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%12;
    v.CoxPippin6.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%19;
        v.CoxPippin6[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%10;
            v.CoxPippin6[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetFloat(v.CoxPippin6[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBlueberry6(const ::Blueberry6 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBlueberry6");
#endif

  AddName("CoxPippin6");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%12;
    if (l1 != v.CoxPippin6.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.CoxPippin6.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%19;
        if (l3 != v.CoxPippin6[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.CoxPippin6[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%10;
            if (l5 != v.CoxPippin6[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.CoxPippin6[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckFloat(v.CoxPippin6[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetTurnip7(::Turnip7 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTurnip7");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%4;
    v.GaliaMelon7.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.GaliaMelon7[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%9;
            v.GaliaMelon7[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetLime6(v.GaliaMelon7[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckTurnip7(const ::Turnip7 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTurnip7");
#endif

  AddName("GaliaMelon7");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%4;
    if (l1 != v.GaliaMelon7.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.GaliaMelon7.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.GaliaMelon7[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GaliaMelon7[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%9;
            if (l5 != v.GaliaMelon7[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GaliaMelon7[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckLime6(v.GaliaMelon7[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetSultana7(::Sultana7 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSultana7");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%4;
    v.GaliaMelon7.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.GaliaMelon7[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%9;
            v.GaliaMelon7[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetLime6(v.GaliaMelon7[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckSultana7(const ::Sultana7 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSultana7");
#endif

  AddName("GaliaMelon7");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%4;
    if (l1 != v.GaliaMelon7.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.GaliaMelon7.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.GaliaMelon7[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GaliaMelon7[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%9;
            if (l5 != v.GaliaMelon7[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GaliaMelon7[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckLime6(v.GaliaMelon7[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetTestServerLoganBerry19Excpt(::TestServer::LoganBerry19Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTestServerLoganBerry19Excpt");
#endif

  GetLoganBerry19(v.ex1);
}

int CheckTestServerLoganBerry19Excpt(const ::TestServer::LoganBerry19Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTestServerLoganBerry19Excpt");
#endif

  AddName("ex1");
  if (!CheckLoganBerry19(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetTestServerOrange19Excpt(::TestServer::Orange19Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTestServerOrange19Excpt");
#endif

  GetOrange19(v.ex1);
}

int CheckTestServerOrange19Excpt(const ::TestServer::Orange19Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTestServerOrange19Excpt");
#endif

  AddName("ex1");
  if (!CheckOrange19(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetTestServerBlackCherry20Excpt(::TestServer::BlackCherry20Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTestServerBlackCherry20Excpt");
#endif

  GetBlackCherry20(v.ex1);
}

int CheckTestServerBlackCherry20Excpt(const ::TestServer::BlackCherry20Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTestServerBlackCherry20Excpt");
#endif

  AddName("ex1");
  if (!CheckBlackCherry20(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetTestServerLemon20Excpt(::TestServer::Lemon20Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTestServerLemon20Excpt");
#endif

  GetLemon20(v.ex1);
}

int CheckTestServerLemon20Excpt(const ::TestServer::Lemon20Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTestServerLemon20Excpt");
#endif

  AddName("ex1");
  if (!CheckLemon20(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetTestServerCoconut6Excpt(::TestServer::Coconut6Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTestServerCoconut6Excpt");
#endif

  GetCoconut6(v.ex1);
}

int CheckTestServerCoconut6Excpt(const ::TestServer::Coconut6Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTestServerCoconut6Excpt");
#endif

  AddName("ex1");
  if (!CheckCoconut6(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetTestServerLime6Excpt(::TestServer::Lime6Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTestServerLime6Excpt");
#endif

  GetLime6(v.ex1);
}

int CheckTestServerLime6Excpt(const ::TestServer::Lime6Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTestServerLime6Excpt");
#endif

  AddName("ex1");
  if (!CheckLime6(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetTestServerMint6Excpt(::TestServer::Mint6Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTestServerMint6Excpt");
#endif

  GetMint6(v.ex1);
}

int CheckTestServerMint6Excpt(const ::TestServer::Mint6Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTestServerMint6Excpt");
#endif

  AddName("ex1");
  if (!CheckMint6(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetTestServerBlackEyedBeans6Excpt(::TestServer::BlackEyedBeans6Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTestServerBlackEyedBeans6Excpt");
#endif

  GetBlackEyedBeans6(v.ex1);
}

int CheckTestServerBlackEyedBeans6Excpt(const ::TestServer::BlackEyedBeans6Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTestServerBlackEyedBeans6Excpt");
#endif

  AddName("ex1");
  if (!CheckBlackEyedBeans6(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetTestServerMangetout6Excpt(::TestServer::Mangetout6Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTestServerMangetout6Excpt");
#endif

  GetMangetout6(v.ex1);
}

int CheckTestServerMangetout6Excpt(const ::TestServer::Mangetout6Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTestServerMangetout6Excpt");
#endif

  AddName("ex1");
  if (!CheckMangetout6(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetTestServerLettuce6Excpt(::TestServer::Lettuce6Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTestServerLettuce6Excpt");
#endif

  GetLettuce6(v.ex1);
}

int CheckTestServerLettuce6Excpt(const ::TestServer::Lettuce6Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTestServerLettuce6Excpt");
#endif

  AddName("ex1");
  if (!CheckLettuce6(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetTestServerChervil6Excpt(::TestServer::Chervil6Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTestServerChervil6Excpt");
#endif

  GetChervil6(v.ex1);
}

int CheckTestServerChervil6Excpt(const ::TestServer::Chervil6Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTestServerChervil6Excpt");
#endif

  AddName("ex1");
  if (!CheckChervil6(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetTestServerBlueberry6Excpt(::TestServer::Blueberry6Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTestServerBlueberry6Excpt");
#endif

  GetBlueberry6(v.ex1);
}

int CheckTestServerBlueberry6Excpt(const ::TestServer::Blueberry6Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTestServerBlueberry6Excpt");
#endif

  AddName("ex1");
  if (!CheckBlueberry6(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetTestServerTurnip7Excpt(::TestServer::Turnip7Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTestServerTurnip7Excpt");
#endif

  GetTurnip7(v.ex1);
}

int CheckTestServerTurnip7Excpt(const ::TestServer::Turnip7Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTestServerTurnip7Excpt");
#endif

  AddName("ex1");
  if (!CheckTurnip7(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetTestServerSultana7Excpt(::TestServer::Sultana7Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTestServerSultana7Excpt");
#endif

  GetSultana7(v.ex1);
}

int CheckTestServerSultana7Excpt(const ::TestServer::Sultana7Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTestServerSultana7Excpt");
#endif

  AddName("ex1");
  if (!CheckSultana7(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



