//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::LoganBerry19
TestServer_imp::LoganBerry19Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::LoganBerry19 ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::LoganBerry19Attr\n");
#endif
  
  ernie.seed("LoganBerry19AttrCall");
  
  ernie.seed("LoganBerry19AttrReturn"); 
  
  GetLoganBerry19(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::LoganBerry19Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
TestServer_imp::LoganBerry19Attr(const ::LoganBerry19 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::LoganBerry19Attr\n");
#endif
  
  ernie.seed("LoganBerry19AttrCall");
  AddName("_attr");
  if (!CheckLoganBerry19(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LoganBerry19AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::LoganBerry19Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::LoganBerry19
TestServer_imp::LoganBerry19Op(const ::LoganBerry19 &p1,::LoganBerry19_out p2,::LoganBerry19 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::LoganBerry19 ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::LoganBerry19Op\n");
#endif
  
  ernie.seed("LoganBerry19OpCall");
  AddName("p1");
  if (!CheckLoganBerry19(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckLoganBerry19(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LoganBerry19OpReturn"); 
  {
    ::TestServer::LoganBerry19Excpt ex;
    GetTestServerLoganBerry19Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetLoganBerry19(ReturnValue);
  GetLoganBerry19(p2);
  GetLoganBerry19(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::LoganBerry19Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Orange19
TestServer_imp::Orange19Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Orange19 ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Orange19Attr\n");
#endif
  
  ernie.seed("Orange19AttrCall");
  
  ernie.seed("Orange19AttrReturn"); 
  
  GetOrange19(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Orange19Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
TestServer_imp::Orange19Attr(const ::Orange19 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Orange19Attr\n");
#endif
  
  ernie.seed("Orange19AttrCall");
  AddName("_attr");
  if (!CheckOrange19(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Orange19AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Orange19Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Orange19
TestServer_imp::Orange19Op(const ::Orange19 &p1,::Orange19_out p2,::Orange19 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Orange19 ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Orange19Op\n");
#endif
  
  ernie.seed("Orange19OpCall");
  AddName("p1");
  if (!CheckOrange19(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckOrange19(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Orange19OpReturn"); 
  {
    ::TestServer::Orange19Excpt ex;
    GetTestServerOrange19Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetOrange19(ReturnValue);
  GetOrange19(p2);
  GetOrange19(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Orange19Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::BlackCherry20
TestServer_imp::BlackCherry20Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::BlackCherry20 ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::BlackCherry20Attr\n");
#endif
  
  ernie.seed("BlackCherry20AttrCall");
  
  ernie.seed("BlackCherry20AttrReturn"); 
  
  GetBlackCherry20(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::BlackCherry20Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
TestServer_imp::BlackCherry20Attr(const ::BlackCherry20 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::BlackCherry20Attr\n");
#endif
  
  ernie.seed("BlackCherry20AttrCall");
  AddName("_attr");
  if (!CheckBlackCherry20(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlackCherry20AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::BlackCherry20Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::BlackCherry20
TestServer_imp::BlackCherry20Op(const ::BlackCherry20 &p1,::BlackCherry20_out p2,::BlackCherry20 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::BlackCherry20 ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::BlackCherry20Op\n");
#endif
  
  ernie.seed("BlackCherry20OpCall");
  AddName("p1");
  if (!CheckBlackCherry20(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBlackCherry20(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlackCherry20OpReturn"); 
  {
    ::TestServer::BlackCherry20Excpt ex;
    GetTestServerBlackCherry20Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetBlackCherry20(ReturnValue);
  GetBlackCherry20(p2);
  GetBlackCherry20(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::BlackCherry20Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Lemon20
TestServer_imp::Lemon20Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Lemon20 ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Lemon20Attr\n");
#endif
  
  ernie.seed("Lemon20AttrCall");
  
  ernie.seed("Lemon20AttrReturn"); 
  
  GetLemon20(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Lemon20Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
TestServer_imp::Lemon20Attr(const ::Lemon20 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Lemon20Attr\n");
#endif
  
  ernie.seed("Lemon20AttrCall");
  AddName("_attr");
  if (!CheckLemon20(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lemon20AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Lemon20Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Lemon20
TestServer_imp::Lemon20Op(const ::Lemon20 &p1,::Lemon20_out p2,::Lemon20 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Lemon20 ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Lemon20Op\n");
#endif
  
  ernie.seed("Lemon20OpCall");
  AddName("p1");
  if (!CheckLemon20(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckLemon20(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lemon20OpReturn"); 
  {
    ::TestServer::Lemon20Excpt ex;
    GetTestServerLemon20Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetLemon20(ReturnValue);
  GetLemon20(p2);
  GetLemon20(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Lemon20Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Coconut6_slice *
TestServer_imp::Coconut6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Coconut6_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Coconut6Attr\n");
#endif
  
  ernie.seed("Coconut6AttrCall");
  
  ernie.seed("Coconut6AttrReturn"); 
  
  ReturnValue = new ::Coconut6;
  GetCoconut6(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Coconut6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
TestServer_imp::Coconut6Attr(const ::Coconut6 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Coconut6Attr\n");
#endif
  
  ernie.seed("Coconut6AttrCall");
  AddName("_attr");
  if (!CheckCoconut6(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Coconut6AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Coconut6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Coconut6_slice *
TestServer_imp::Coconut6Op(const ::Coconut6 p1,::Coconut6_out  p2,::Coconut6 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Coconut6_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Coconut6Op\n");
#endif
  
  ernie.seed("Coconut6OpCall");
  AddName("p1");
  if (!CheckCoconut6(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCoconut6(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Coconut6OpReturn"); 
  {
    ::TestServer::Coconut6Excpt ex;
    GetTestServerCoconut6Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Coconut6;
  GetCoconut6(ReturnValue);
  GetCoconut6(p2);
  GetCoconut6(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Coconut6Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Lime6
TestServer_imp::Lime6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Lime6 ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Lime6Attr\n");
#endif
  
  ernie.seed("Lime6AttrCall");
  
  ernie.seed("Lime6AttrReturn"); 
  
  GetLime6(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Lime6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
TestServer_imp::Lime6Attr(const ::Lime6 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Lime6Attr\n");
#endif
  
  ernie.seed("Lime6AttrCall");
  AddName("_attr");
  if (!CheckLime6(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lime6AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Lime6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Lime6
TestServer_imp::Lime6Op(const ::Lime6 &p1,::Lime6_out p2,::Lime6 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Lime6 ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Lime6Op\n");
#endif
  
  ernie.seed("Lime6OpCall");
  AddName("p1");
  if (!CheckLime6(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckLime6(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lime6OpReturn"); 
  {
    ::TestServer::Lime6Excpt ex;
    GetTestServerLime6Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetLime6(ReturnValue);
  GetLime6(p2);
  GetLime6(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Lime6Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Mint6_slice *
TestServer_imp::Mint6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Mint6_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Mint6Attr\n");
#endif
  
  ernie.seed("Mint6AttrCall");
  
  ernie.seed("Mint6AttrReturn"); 
  
  ReturnValue = new ::Mint6;
  GetMint6(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Mint6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
TestServer_imp::Mint6Attr(const ::Mint6 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Mint6Attr\n");
#endif
  
  ernie.seed("Mint6AttrCall");
  AddName("_attr");
  if (!CheckMint6(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Mint6AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Mint6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Mint6_slice *
TestServer_imp::Mint6Op(const ::Mint6 p1,::Mint6_out p2,::Mint6 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Mint6_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Mint6Op\n");
#endif
  
  ernie.seed("Mint6OpCall");
  AddName("p1");
  if (!CheckMint6(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckMint6(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Mint6OpReturn"); 
  {
    ::TestServer::Mint6Excpt ex;
    GetTestServerMint6Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Mint6;
  GetMint6(ReturnValue);
  p2 = new ::Mint6;
  GetMint6(p2);
  GetMint6(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Mint6Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::BlackEyedBeans6*
TestServer_imp::BlackEyedBeans6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::BlackEyedBeans6* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::BlackEyedBeans6Attr\n");
#endif
  
  ernie.seed("BlackEyedBeans6AttrCall");
  
  ernie.seed("BlackEyedBeans6AttrReturn"); 
  ReturnValue = new ::BlackEyedBeans6;
  GetBlackEyedBeans6(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::BlackEyedBeans6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
TestServer_imp::BlackEyedBeans6Attr(const ::BlackEyedBeans6 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::BlackEyedBeans6Attr\n");
#endif
  
  ernie.seed("BlackEyedBeans6AttrCall");
  AddName("_attr");
  if (!CheckBlackEyedBeans6(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlackEyedBeans6AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::BlackEyedBeans6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::BlackEyedBeans6*
TestServer_imp::BlackEyedBeans6Op(const ::BlackEyedBeans6 &p1,::BlackEyedBeans6_out p2,::BlackEyedBeans6 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::BlackEyedBeans6* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::BlackEyedBeans6Op\n");
#endif
  
  ernie.seed("BlackEyedBeans6OpCall");
  AddName("p1");
  if (!CheckBlackEyedBeans6(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBlackEyedBeans6(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlackEyedBeans6OpReturn"); 
  {
    ::TestServer::BlackEyedBeans6Excpt ex;
    GetTestServerBlackEyedBeans6Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::BlackEyedBeans6;
  GetBlackEyedBeans6(*ReturnValue);
  p2 = new ::BlackEyedBeans6;
  GetBlackEyedBeans6(*p2);
  GetBlackEyedBeans6(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::BlackEyedBeans6Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Mangetout6*
TestServer_imp::Mangetout6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Mangetout6* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Mangetout6Attr\n");
#endif
  
  ernie.seed("Mangetout6AttrCall");
  
  ernie.seed("Mangetout6AttrReturn"); 
  ReturnValue = new ::Mangetout6;
  GetMangetout6(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Mangetout6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
TestServer_imp::Mangetout6Attr(const ::Mangetout6 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Mangetout6Attr\n");
#endif
  
  ernie.seed("Mangetout6AttrCall");
  AddName("_attr");
  if (!CheckMangetout6(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Mangetout6AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Mangetout6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Mangetout6*
TestServer_imp::Mangetout6Op(const ::Mangetout6 &p1,::Mangetout6_out p2,::Mangetout6 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Mangetout6* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Mangetout6Op\n");
#endif
  
  ernie.seed("Mangetout6OpCall");
  AddName("p1");
  if (!CheckMangetout6(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckMangetout6(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Mangetout6OpReturn"); 
  {
    ::TestServer::Mangetout6Excpt ex;
    GetTestServerMangetout6Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Mangetout6;
  GetMangetout6(*ReturnValue);
  p2 = new ::Mangetout6;
  GetMangetout6(*p2);
  GetMangetout6(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Mangetout6Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Lettuce6*
TestServer_imp::Lettuce6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Lettuce6* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Lettuce6Attr\n");
#endif
  
  ernie.seed("Lettuce6AttrCall");
  
  ernie.seed("Lettuce6AttrReturn"); 
  ReturnValue = new ::Lettuce6;
  GetLettuce6(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Lettuce6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
TestServer_imp::Lettuce6Attr(const ::Lettuce6 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Lettuce6Attr\n");
#endif
  
  ernie.seed("Lettuce6AttrCall");
  AddName("_attr");
  if (!CheckLettuce6(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lettuce6AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Lettuce6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Lettuce6*
TestServer_imp::Lettuce6Op(const ::Lettuce6 &p1,::Lettuce6_out p2,::Lettuce6 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Lettuce6* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Lettuce6Op\n");
#endif
  
  ernie.seed("Lettuce6OpCall");
  AddName("p1");
  if (!CheckLettuce6(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckLettuce6(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lettuce6OpReturn"); 
  {
    ::TestServer::Lettuce6Excpt ex;
    GetTestServerLettuce6Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Lettuce6;
  GetLettuce6(*ReturnValue);
  p2 = new ::Lettuce6;
  GetLettuce6(*p2);
  GetLettuce6(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Lettuce6Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Chervil6_slice *
TestServer_imp::Chervil6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Chervil6_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Chervil6Attr\n");
#endif
  
  ernie.seed("Chervil6AttrCall");
  
  ernie.seed("Chervil6AttrReturn"); 
  
  ReturnValue = new ::Chervil6;
  GetChervil6(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Chervil6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
TestServer_imp::Chervil6Attr(const ::Chervil6 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Chervil6Attr\n");
#endif
  
  ernie.seed("Chervil6AttrCall");
  AddName("_attr");
  if (!CheckChervil6(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Chervil6AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Chervil6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Chervil6_slice *
TestServer_imp::Chervil6Op(const ::Chervil6 p1,::Chervil6_out p2,::Chervil6 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Chervil6_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Chervil6Op\n");
#endif
  
  ernie.seed("Chervil6OpCall");
  AddName("p1");
  if (!CheckChervil6(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckChervil6(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Chervil6OpReturn"); 
  {
    ::TestServer::Chervil6Excpt ex;
    GetTestServerChervil6Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Chervil6;
  GetChervil6(ReturnValue);
  p2 = new ::Chervil6;
  GetChervil6(p2);
  GetChervil6(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Chervil6Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Blueberry6*
TestServer_imp::Blueberry6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Blueberry6* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Blueberry6Attr\n");
#endif
  
  ernie.seed("Blueberry6AttrCall");
  
  ernie.seed("Blueberry6AttrReturn"); 
  ReturnValue = new ::Blueberry6;
  GetBlueberry6(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Blueberry6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
TestServer_imp::Blueberry6Attr(const ::Blueberry6 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Blueberry6Attr\n");
#endif
  
  ernie.seed("Blueberry6AttrCall");
  AddName("_attr");
  if (!CheckBlueberry6(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Blueberry6AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Blueberry6Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Blueberry6*
TestServer_imp::Blueberry6Op(const ::Blueberry6 &p1,::Blueberry6_out p2,::Blueberry6 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Blueberry6* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Blueberry6Op\n");
#endif
  
  ernie.seed("Blueberry6OpCall");
  AddName("p1");
  if (!CheckBlueberry6(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBlueberry6(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Blueberry6OpReturn"); 
  {
    ::TestServer::Blueberry6Excpt ex;
    GetTestServerBlueberry6Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Blueberry6;
  GetBlueberry6(*ReturnValue);
  p2 = new ::Blueberry6;
  GetBlueberry6(*p2);
  GetBlueberry6(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Blueberry6Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Turnip7*
TestServer_imp::Turnip7Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Turnip7* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Turnip7Attr\n");
#endif
  
  ernie.seed("Turnip7AttrCall");
  
  ernie.seed("Turnip7AttrReturn"); 
  ReturnValue = new ::Turnip7;
  GetTurnip7(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Turnip7Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
TestServer_imp::Turnip7Attr(const ::Turnip7 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Turnip7Attr\n");
#endif
  
  ernie.seed("Turnip7AttrCall");
  AddName("_attr");
  if (!CheckTurnip7(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Turnip7AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Turnip7Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Turnip7*
TestServer_imp::Turnip7Op(const ::Turnip7 &p1,::Turnip7_out p2,::Turnip7 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Turnip7* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Turnip7Op\n");
#endif
  
  ernie.seed("Turnip7OpCall");
  AddName("p1");
  if (!CheckTurnip7(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckTurnip7(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Turnip7OpReturn"); 
  {
    ::TestServer::Turnip7Excpt ex;
    GetTestServerTurnip7Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Turnip7;
  GetTurnip7(*ReturnValue);
  p2 = new ::Turnip7;
  GetTurnip7(*p2);
  GetTurnip7(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Turnip7Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Sultana7*
TestServer_imp::Sultana7Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Sultana7* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Sultana7Attr\n");
#endif
  
  ernie.seed("Sultana7AttrCall");
  
  ernie.seed("Sultana7AttrReturn"); 
  ReturnValue = new ::Sultana7;
  GetSultana7(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Sultana7Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
TestServer_imp::Sultana7Attr(const ::Sultana7 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Sultana7Attr\n");
#endif
  
  ernie.seed("Sultana7AttrCall");
  AddName("_attr");
  if (!CheckSultana7(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sultana7AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Sultana7Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Sultana7*
TestServer_imp::Sultana7Op(const ::Sultana7 &p1,::Sultana7_out p2,::Sultana7 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Sultana7* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TestServer::Sultana7Op\n");
#endif
  
  ernie.seed("Sultana7OpCall");
  AddName("p1");
  if (!CheckSultana7(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckSultana7(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sultana7OpReturn"); 
  {
    ::TestServer::Sultana7Excpt ex;
    GetTestServerSultana7Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Sultana7;
  GetSultana7(*ReturnValue);
  p2 = new ::Sultana7;
  GetSultana7(*p2);
  GetSultana7(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::TestServer::Sultana7Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



