//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/client.cpp
//
// Modifications:
// $Log: client.cpp,v $
// Revision 1.2  2000/03/29 17:09:23  mli
//   o   remove 'CORBA::Environment ev;'
//   o   int initialise
//
// Revision 1.1.1.1  2000/02/09 17:16:32  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1998/08/24 11:46:37  james
// ENV updates
//
// Revision 1.5  1997/12/12 08:57:57  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern OrbSupport *orb;
extern char *stringifiedIOR;

static int initialised = 0;
CORBA::Object_ptr obj;
idlServer_ptr  tobj;

void
initialise()
{
    if (!initialised)
    {

#ifdef DEBUG
	  ::tet_infoline("client: connecting to proxy");
	  ::tet_printf("client: using %s", stringifiedIOR);
#endif
	  
	  try {
	      obj = orb->getObject(stringifiedIOR);
	  }
	  catch (CORBA::SystemException &ex) {
	      ::tet_infoline("client: getObj failed");
	      ::tet_printf("client: minor code %d", ex.minor());
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  if (obj == 0)
	  {
	      ::tet_infoline("client: failed connecting to proxy");
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  try {
	      tobj = idlServer::_narrow(obj);
	  }
	  catch (CORBA::Exception &ex) {
	      ::tet_infoline("client: failed to narrow object reference.");
	  }
	  initialised = 1;

	  char * tout = 0;
	  tout = getenv("VSORB_EVENT_TIMEOUT");

	  unsigned long timeout = (tout) ? atoi(tout) : 15;
	  orb->setTimeout(tobj, timeout);
      }
    
}

#ifdef VSORB_IDL_TESTS

void testIDL()
{
  char buf1[1024];

::tet_result(TET_PASS);
}
 
#endif



 
void testidlServerRadish22Attr(void)
{
  
  
  ::Radish22 ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Radish22 ::idlServer::Radish22Attr()");
#endif
  
  ernie.seed("Radish22AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Radish22AttrReturn");
  try {
    ReturnValue = tobj->Radish22Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Radish22Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckRadish22(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerRadish22AttrW(void)
{
  
  
  ::Radish22 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Radish22Attr(::Radish22 _attr)");
#endif
  
  ernie.seed("Radish22AttrCall");
  GetRadish22(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Radish22AttrReturn");
  try {
     tobj->Radish22Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Radish22Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerRadish22Op(void)
{
  
  
  ::Radish22 ReturnValue;
  
  ::Radish22 p1;
  
  ::Radish22 p2;
  
  ::Radish22 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Radish22 ::idlServer::Radish22Op(::Radish22 p1,::Radish22 &p2,::Radish22 &p3)");
#endif
  
  ernie.seed("Radish22OpCall");
  GetRadish22(p1);
  GetRadish22(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Radish22OpReturn");
  try {
    ReturnValue = tobj->Radish22Op(p1,p2,p3);
  }
  catch (::idlServer::Radish22Excpt &ex){
    if (!CheckidlServerRadish22Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Radish22Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckRadish22(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckRadish22(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckRadish22(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSharanfruit22Attr(void)
{
  
  
  ::Sharanfruit22 ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Sharanfruit22 ::idlServer::Sharanfruit22Attr()");
#endif
  
  ernie.seed("Sharanfruit22AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sharanfruit22AttrReturn");
  try {
    ReturnValue = tobj->Sharanfruit22Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sharanfruit22Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckSharanfruit22(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSharanfruit22AttrW(void)
{
  
  
  ::Sharanfruit22 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Sharanfruit22Attr(::Sharanfruit22 _attr)");
#endif
  
  ernie.seed("Sharanfruit22AttrCall");
  GetSharanfruit22(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sharanfruit22AttrReturn");
  try {
     tobj->Sharanfruit22Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sharanfruit22Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSharanfruit22Op(void)
{
  
  
  ::Sharanfruit22 ReturnValue;
  
  ::Sharanfruit22 p1;
  
  ::Sharanfruit22 p2;
  
  ::Sharanfruit22 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Sharanfruit22 ::idlServer::Sharanfruit22Op(::Sharanfruit22 p1,::Sharanfruit22 &p2,::Sharanfruit22 &p3)");
#endif
  
  ernie.seed("Sharanfruit22OpCall");
  GetSharanfruit22(p1);
  GetSharanfruit22(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sharanfruit22OpReturn");
  try {
    ReturnValue = tobj->Sharanfruit22Op(p1,p2,p3);
  }
  catch (::idlServer::Sharanfruit22Excpt &ex){
    if (!CheckidlServerSharanfruit22Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sharanfruit22Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckSharanfruit22(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckSharanfruit22(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckSharanfruit22(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerTarragon23Attr(void)
{
  
  ::Tarragon23_slice * ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Tarragon23_slice * ::idlServer::Tarragon23Attr()");
#endif
  
  ernie.seed("Tarragon23AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Tarragon23AttrReturn");
  try {
    ReturnValue = tobj->Tarragon23Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Tarragon23Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckTarragon23(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerTarragon23AttrW(void)
{
  
  ::Tarragon23 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Tarragon23Attr(const ::Tarragon23 _attr)");
#endif
  
  ernie.seed("Tarragon23AttrCall");
  GetTarragon23(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Tarragon23AttrReturn");
  try {
     tobj->Tarragon23Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Tarragon23Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerTarragon23Op(void)
{
  
  ::Tarragon23_slice * ReturnValue;
  ::Tarragon23 p1;
  ::Tarragon23_slice * p2;
  ::Tarragon23 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Tarragon23_slice * ::idlServer::Tarragon23Op(const ::Tarragon23 p1,::Tarragon23_slice *&p2,::Tarragon23 p3)");
#endif
  
  ernie.seed("Tarragon23OpCall");
  GetTarragon23(p1);
  GetTarragon23(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Tarragon23OpReturn");
  try {
    ReturnValue = tobj->Tarragon23Op(p1,p2,p3);
  }
  catch (::idlServer::Tarragon23Excpt &ex){
    if (!CheckidlServerTarragon23Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Tarragon23Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckTarragon23(ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckTarragon23(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckTarragon23(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerButterBean24Attr(void)
{
  
  ::ButterBean24* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::ButterBean24* ::idlServer::ButterBean24Attr()");
#endif
  
  ernie.seed("ButterBean24AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("ButterBean24AttrReturn");
  try {
    ReturnValue = tobj->ButterBean24Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::ButterBean24Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckButterBean24(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerButterBean24AttrW(void)
{
  
  ::ButterBean24 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::ButterBean24Attr(const ::ButterBean24 &_attr)");
#endif
  
  ernie.seed("ButterBean24AttrCall");
  GetButterBean24(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("ButterBean24AttrReturn");
  try {
     tobj->ButterBean24Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::ButterBean24Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerButterBean24Op(void)
{
  
  ::ButterBean24* ReturnValue;
  ::ButterBean24 p1;
  ::ButterBean24* p2;
  ::ButterBean24 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::ButterBean24* ::idlServer::ButterBean24Op(const ::ButterBean24 &p1,::ButterBean24 *&p2,::ButterBean24 &p3)");
#endif
  
  ernie.seed("ButterBean24OpCall");
  GetButterBean24(p1);
  GetButterBean24(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("ButterBean24OpReturn");
  try {
    ReturnValue = tobj->ButterBean24Op(p1,p2,p3);
  }
  catch (::idlServer::ButterBean24Excpt &ex){
    if (!CheckidlServerButterBean24Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::ButterBean24Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckButterBean24(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckButterBean24(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckButterBean24(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerZucchini24Attr(void)
{
  
  ::Zucchini24* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Zucchini24* ::idlServer::Zucchini24Attr()");
#endif
  
  ernie.seed("Zucchini24AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Zucchini24AttrReturn");
  try {
    ReturnValue = tobj->Zucchini24Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Zucchini24Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckZucchini24(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerZucchini24AttrW(void)
{
  
  ::Zucchini24 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Zucchini24Attr(const ::Zucchini24 &_attr)");
#endif
  
  ernie.seed("Zucchini24AttrCall");
  GetZucchini24(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Zucchini24AttrReturn");
  try {
     tobj->Zucchini24Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Zucchini24Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerZucchini24Op(void)
{
  
  ::Zucchini24* ReturnValue;
  ::Zucchini24 p1;
  ::Zucchini24* p2;
  ::Zucchini24 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Zucchini24* ::idlServer::Zucchini24Op(const ::Zucchini24 &p1,::Zucchini24 *&p2,::Zucchini24 &p3)");
#endif
  
  ernie.seed("Zucchini24OpCall");
  GetZucchini24(p1);
  GetZucchini24(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Zucchini24OpReturn");
  try {
    ReturnValue = tobj->Zucchini24Op(p1,p2,p3);
  }
  catch (::idlServer::Zucchini24Excpt &ex){
    if (!CheckidlServerZucchini24Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Zucchini24Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckZucchini24(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckZucchini24(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckZucchini24(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPlum24Attr(void)
{
  
  ::Zucchini24::Plum24* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Zucchini24::Plum24* ::idlServer::Plum24Attr()");
#endif
  
  ernie.seed("Plum24AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Plum24AttrReturn");
  try {
    ReturnValue = tobj->Plum24Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Plum24Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckZucchini24Plum24(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPlum24AttrW(void)
{
  
  ::Zucchini24::Plum24 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Plum24Attr(const ::Zucchini24::Plum24 &_attr)");
#endif
  
  ernie.seed("Plum24AttrCall");
  GetZucchini24Plum24(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Plum24AttrReturn");
  try {
     tobj->Plum24Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Plum24Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPlum24Op(void)
{
  
  ::Zucchini24::Plum24* ReturnValue;
  ::Zucchini24::Plum24 p1;
  ::Zucchini24::Plum24* p2;
  ::Zucchini24::Plum24 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Zucchini24::Plum24* ::idlServer::Plum24Op(const ::Zucchini24::Plum24 &p1,::Zucchini24::Plum24 *&p2,::Zucchini24::Plum24 &p3)");
#endif
  
  ernie.seed("Plum24OpCall");
  GetZucchini24Plum24(p1);
  GetZucchini24Plum24(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Plum24OpReturn");
  try {
    ReturnValue = tobj->Plum24Op(p1,p2,p3);
  }
  catch (::idlServer::Plum24Excpt &ex){
    if (!CheckidlServerPlum24Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Plum24Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckZucchini24Plum24(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckZucchini24Plum24(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckZucchini24Plum24(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerDill25Attr(void)
{
  
  ::Dill25* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Dill25* ::idlServer::Dill25Attr()");
#endif
  
  ernie.seed("Dill25AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Dill25AttrReturn");
  try {
    ReturnValue = tobj->Dill25Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Dill25Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckDill25(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerDill25AttrW(void)
{
  
  ::Dill25 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Dill25Attr(const ::Dill25 &_attr)");
#endif
  
  ernie.seed("Dill25AttrCall");
  GetDill25(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Dill25AttrReturn");
  try {
     tobj->Dill25Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Dill25Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerDill25Op(void)
{
  
  ::Dill25* ReturnValue;
  ::Dill25 p1;
  ::Dill25* p2;
  ::Dill25 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Dill25* ::idlServer::Dill25Op(const ::Dill25 &p1,::Dill25 *&p2,::Dill25 &p3)");
#endif
  
  ernie.seed("Dill25OpCall");
  GetDill25(p1);
  GetDill25(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Dill25OpReturn");
  try {
    ReturnValue = tobj->Dill25Op(p1,p2,p3);
  }
  catch (::idlServer::Dill25Excpt &ex){
    if (!CheckidlServerDill25Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Dill25Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckDill25(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckDill25(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckDill25(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerBayleaf25Attr(void)
{
  
  ::Bayleaf25* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Bayleaf25* ::idlServer::Bayleaf25Attr()");
#endif
  
  ernie.seed("Bayleaf25AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Bayleaf25AttrReturn");
  try {
    ReturnValue = tobj->Bayleaf25Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Bayleaf25Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckBayleaf25(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerBayleaf25AttrW(void)
{
  
  ::Bayleaf25 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Bayleaf25Attr(const ::Bayleaf25 &_attr)");
#endif
  
  ernie.seed("Bayleaf25AttrCall");
  GetBayleaf25(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Bayleaf25AttrReturn");
  try {
     tobj->Bayleaf25Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Bayleaf25Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerBayleaf25Op(void)
{
  
  ::Bayleaf25* ReturnValue;
  ::Bayleaf25 p1;
  ::Bayleaf25* p2;
  ::Bayleaf25 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Bayleaf25* ::idlServer::Bayleaf25Op(const ::Bayleaf25 &p1,::Bayleaf25 *&p2,::Bayleaf25 &p3)");
#endif
  
  ernie.seed("Bayleaf25OpCall");
  GetBayleaf25(p1);
  GetBayleaf25(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Bayleaf25OpReturn");
  try {
    ReturnValue = tobj->Bayleaf25Op(p1,p2,p3);
  }
  catch (::idlServer::Bayleaf25Excpt &ex){
    if (!CheckidlServerBayleaf25Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Bayleaf25Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckBayleaf25(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckBayleaf25(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBayleaf25(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerWhiteCabbage25Attr(void)
{
  
  ::Bayleaf25::WhiteCabbage25* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Bayleaf25::WhiteCabbage25* ::idlServer::WhiteCabbage25Attr()");
#endif
  
  ernie.seed("WhiteCabbage25AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("WhiteCabbage25AttrReturn");
  try {
    ReturnValue = tobj->WhiteCabbage25Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::WhiteCabbage25Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckBayleaf25WhiteCabbage25(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerWhiteCabbage25AttrW(void)
{
  
  ::Bayleaf25::WhiteCabbage25 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::WhiteCabbage25Attr(const ::Bayleaf25::WhiteCabbage25 &_attr)");
#endif
  
  ernie.seed("WhiteCabbage25AttrCall");
  GetBayleaf25WhiteCabbage25(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("WhiteCabbage25AttrReturn");
  try {
     tobj->WhiteCabbage25Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::WhiteCabbage25Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerWhiteCabbage25Op(void)
{
  
  ::Bayleaf25::WhiteCabbage25* ReturnValue;
  ::Bayleaf25::WhiteCabbage25 p1;
  ::Bayleaf25::WhiteCabbage25* p2;
  ::Bayleaf25::WhiteCabbage25 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Bayleaf25::WhiteCabbage25* ::idlServer::WhiteCabbage25Op(const ::Bayleaf25::WhiteCabbage25 &p1,::Bayleaf25::WhiteCabbage25 *&p2,::Bayleaf25::WhiteCabbage25 &p3)");
#endif
  
  ernie.seed("WhiteCabbage25OpCall");
  GetBayleaf25WhiteCabbage25(p1);
  GetBayleaf25WhiteCabbage25(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("WhiteCabbage25OpReturn");
  try {
    ReturnValue = tobj->WhiteCabbage25Op(p1,p2,p3);
  }
  catch (::idlServer::WhiteCabbage25Excpt &ex){
    if (!CheckidlServerWhiteCabbage25Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::WhiteCabbage25Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckBayleaf25WhiteCabbage25(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckBayleaf25WhiteCabbage25(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBayleaf25WhiteCabbage25(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


