//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/checkany.cpp
//
// Modifications:
// $Log: checkany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:32  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1999/04/26 13:51:25  james
// Changed CORBA::Char* to char*
//
// Revision 1.6  1998/08/24 11:46:38  james
// ENV updates
//
// Revision 1.5  1997/12/12 08:57:59  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern char name[];

 
int CheckAny(const CORBA::Any &any)
{
  switch(ernie.getULong()%(12+72))
  {
    case   0: {
                CORBA::ULong  v;
#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::ULong");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::ULong as expected", name);
                  return 0;
                }
                if (!ernie.checkULong(v))
                {
                  tet_printf("Expected %s to contain CORBA::ULong with value %u, but found %u instead.",
                    name,ernie.getULongAgain(),v);
                  return 0;
                }
              }
              break;
    case   1: {
                CORBA::Long  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Long");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Long as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkLong(v))
                {
                  tet_printf("Expected %s to contain CORBA::Long with value %d, but found %d instead.",
                    name,ernie.getLongAgain(),v);
                  return 0;
                }
              }
              break;
    case   2: {
                CORBA::UShort  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::UShort");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::UShort as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkUShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::UShort with value %u, but found %u instead.",
                    name,ernie.getUShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   3: {
                CORBA::Short  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Short");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Short as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::Short with value %d, but found %d instead.",
                    name,ernie.getShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   4: {
                CORBA::Boolean  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Boolean");
#endif
                if (!(any >>= CORBA::Any::to_boolean(v)))
                {
                  tet_printf("%s did not contain a CORBA::Boolean as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkBoolean(v))
                {
                  tet_printf("Expected %s to contain CORBA::Boolean with value %s, but found %s instead.",
                    name,
                    BooleanToString(ernie.getBooleanAgain()),
                    BooleanToString(v));
                  return 0;
                }
              }
              break;
    case   5: {
                CORBA::Octet  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Octet");
#endif
                if (!(any >>= CORBA::Any::to_octet(v)))
                {
                  tet_printf("%s did not contain a CORBA::Octet as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkOctet(v))
                {
                  ::tet_printf("Expected %s to contain CORBA::Octet with value %s, but found %s instead.",
                    name,
                    OctetToString(ernie.getOctetAgain()),
                    OctetToString(v));
                  return 0;
                }
              }
              break;
    case   6: {
                CORBA::Char  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Char");
#endif
                if (!(any >>= CORBA::Any::to_char(v)))
                {
                  tet_printf("%s did not contain a CORBA::Char as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkChar(v))
                {
                  tet_printf("Expected %s to contain CORBA::Char with value %s, but found %s instead.",
                    name,
                    CharToString(ernie.getCharAgain()),
                    CharToString(v));
                  return 0;
                }
              }
              break;
    case   7: {
                CORBA::Float  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Float");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Float as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkFloat(v))
                {
                  tet_printf("Expected %s to contain CORBA::Float with value %g, but found %g instead.",
                    name,
                    ernie.getFloatAgain(),
                    v);
                  return 0;
                }
              }
               break;
    case   8: {
                CORBA::Double  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Double");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Double as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkDouble(v))
                {
                  tet_printf("Expected %s to contain CORBA::Double with value %g, but found %g instead.",
                    name,
                    ernie.getDoubleAgain(),
                    v);
                  return 0;
                }
              }
              break;
    case   9: {
                char *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting char*");
#endif
                if (!(any >>= CORBA::Any::to_string(v,0)))
                {
                  tet_printf("%s did not contain a char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v))
                {
                  tet_printf("Expected %s to contain char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case  10: {
                CORBA::ULong  b;
                char   *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting bounded char*");
#endif
                b = ernie.getULong()%30+1;

                if (!(any >>= CORBA::Any::to_string(v,b)))
                {
                  tet_printf("%s did not contain a bounded char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v,b))
                {
                  tet_printf("Expected %s to contain a bounded char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::TypeCode");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::TypeCode as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCORBATypeCode_ptr(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case   12: {
                CORBA::Any  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Any");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Any as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAny(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  13: {
                ::Radish22 v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Radish22\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Radish22 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRadish22(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  14: {
                ::Sharanfruit22 v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Sharanfruit22\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Sharanfruit22 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSharanfruit22(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  15: {
                ::Tarragon23_forany v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Tarragon23\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Tarragon23 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckTarragon23(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  16: {
                ::ButterBean24 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::ButterBean24\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::ButterBean24 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckButterBean24(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  17: {
                ::Zucchini24 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Zucchini24\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Zucchini24 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckZucchini24(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  18: {
                ::Zucchini24::Plum24 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Zucchini24::Plum24\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Zucchini24::Plum24 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckZucchini24Plum24(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  19: {
                ::Dill25 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Dill25\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Dill25 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckDill25(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  20: {
                ::Bayleaf25 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Bayleaf25\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Bayleaf25 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBayleaf25(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  21: {
                ::Bayleaf25::WhiteCabbage25 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Bayleaf25::WhiteCabbage25\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Bayleaf25::WhiteCabbage25 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBayleaf25WhiteCabbage25(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  22: {
                ::WaterMelon26 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::WaterMelon26\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::WaterMelon26 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckWaterMelon26(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  23: {
                ::Mango26 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mango26\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mango26 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMango26(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  24: {
                ::Mango26::PassionFruit26 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mango26::PassionFruit26\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mango26::PassionFruit26 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMango26PassionFruit26(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  25: {
                ::Record26 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Record26\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Record26 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRecord26(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  26: {
                ::Potato26 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Potato26\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Potato26 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPotato26(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  27: {
                ::Potato26::ChineseLeaves26 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Potato26::ChineseLeaves26\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Potato26::ChineseLeaves26 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPotato26ChineseLeaves26(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  28: {
                ::Blackberry27 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Blackberry27\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Blackberry27 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlackberry27(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  29: {
                ::Blueberry27 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Blueberry27\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Blueberry27 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlueberry27(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  30: {
                ::Blueberry27::Basil27 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Blueberry27::Basil27\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Blueberry27::Basil27 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlueberry27Basil27(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  31: {
                ::Grapefruit28 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Grapefruit28\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Grapefruit28 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGrapefruit28(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  32: {
                ::Raspberry28 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Raspberry28\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Raspberry28 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRaspberry28(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  33: {
                ::Raspberry28::Peppercorn28 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Raspberry28::Peppercorn28\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Raspberry28::Peppercorn28 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRaspberry28Peppercorn28(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  34: {
                ::Kumquats29 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Kumquats29\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Kumquats29 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckKumquats29(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  35: {
                ::Elderberry29 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Elderberry29\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Elderberry29 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckElderberry29(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  36: {
                ::Elderberry29::RedGrapes29 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Elderberry29::RedGrapes29\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Elderberry29::RedGrapes29 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckElderberry29RedGrapes29(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  37: {
                ::RedOnion30 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::RedOnion30\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::RedOnion30 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRedOnion30(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  38: {
                ::CrabApple30 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CrabApple30\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CrabApple30 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCrabApple30(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  39: {
                ::CrabApple30::Lentil30 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CrabApple30::Lentil30\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CrabApple30::Lentil30 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCrabApple30Lentil30(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  40: {
                ::Runnerbean31 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Runnerbean31\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Runnerbean31 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRunnerbean31(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  41: {
                ::Mushroom31 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mushroom31\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mushroom31 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMushroom31(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  42: {
                ::Mushroom31::Almonds31 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mushroom31::Almonds31\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mushroom31::Almonds31 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMushroom31Almonds31(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  43: {
                ::Cucumber32 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cucumber32\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cucumber32 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCucumber32(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  44: {
                ::Cabbage32 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cabbage32\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cabbage32 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCabbage32(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  45: {
                ::Cabbage32::Coconut32 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cabbage32::Coconut32\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cabbage32::Coconut32 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCabbage32Coconut32(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  46: {
                ::GoldenWonder32 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GoldenWonder32\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GoldenWonder32 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGoldenWonder32(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  47: {
                ::KerrsPinks32 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::KerrsPinks32\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::KerrsPinks32 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckKerrsPinks32(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  48: {
                ::KerrsPinks32::Wilja32 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::KerrsPinks32::Wilja32\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::KerrsPinks32::Wilja32 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckKerrsPinks32Wilja32(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  49: {
                ::Currant33 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Currant33\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Currant33 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCurrant33(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  50: {
                ::PricklyPear33 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::PricklyPear33\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::PricklyPear33 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPricklyPear33(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  51: {
                ::PricklyPear33::VineTomatoes33 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::PricklyPear33::VineTomatoes33\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::PricklyPear33::VineTomatoes33 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPricklyPear33VineTomatoes33(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  52: {
                ::GreenGrapes34 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GreenGrapes34\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GreenGrapes34 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGreenGrapes34(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  53: {
                ::Artichokes34 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Artichokes34\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Artichokes34 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckArtichokes34(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  54: {
                ::Artichokes34::Peanutsquash34 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Artichokes34::Peanutsquash34\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Artichokes34::Peanutsquash34 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckArtichokes34Peanutsquash34(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  55: {
                ::Beetroot35 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Beetroot35\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Beetroot35 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBeetroot35(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  56: {
                ::Chickpea35 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Chickpea35\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Chickpea35 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckChickpea35(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  57: {
                ::Chickpea35::Uglifruit35 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Chickpea35::Uglifruit35\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Chickpea35::Uglifruit35 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckChickpea35Uglifruit35(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  58: {
                ::Cloves36 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cloves36\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cloves36 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCloves36(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  59: {
                ::JuniperBerries36 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::JuniperBerries36\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::JuniperBerries36 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckJuniperBerries36(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  60: {
                ::JuniperBerries36::GooseBerry36 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::JuniperBerries36::GooseBerry36\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::JuniperBerries36::GooseBerry36 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckJuniperBerries36GooseBerry36(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  61: {
                ::SweetPotato37 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::SweetPotato37\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::SweetPotato37 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSweetPotato37(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  62: {
                ::BrazilNut37 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BrazilNut37\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BrazilNut37 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBrazilNut37(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  63: {
                ::BrazilNut37::Brocoli37 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BrazilNut37::Brocoli37\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BrazilNut37::Brocoli37 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBrazilNut37Brocoli37(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  64: {
                ::GardenPeas38 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GardenPeas38\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GardenPeas38 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGardenPeas38(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  65: {
                ::Mint38 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mint38\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mint38 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMint38(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  66: {
                ::Mint38::BlackEyedBeans38 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mint38::BlackEyedBeans38\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mint38::BlackEyedBeans38 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMint38BlackEyedBeans38(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  67: {
                ::KingEdward38 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::KingEdward38\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::KingEdward38 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckKingEdward38(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  68: {
                ::Cara38 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cara38\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cara38 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCara38(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  69: {
                ::Cara38::Rooster38 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cara38::Rooster38\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cara38::Rooster38 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCara38Rooster38(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  70: {
                ::PippinApple39 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::PippinApple39\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::PippinApple39 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPippinApple39(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  71: {
                ::Chayato39 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Chayato39\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Chayato39 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckChayato39(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  72: {
                ::Chayato39::KiwanoMelon39 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Chayato39::KiwanoMelon39\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Chayato39::KiwanoMelon39 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckChayato39KiwanoMelon39(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  73: {
                ::Yam40 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Yam40\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Yam40 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckYam40(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  74: {
                ::Eddo40 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Eddo40\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Eddo40 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckEddo40(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  75: {
                ::Eddo40::Chives40 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Eddo40::Chives40\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Eddo40::Chives40 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckEddo40Chives40(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  76: {
                ::Mangosteen41 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mangosteen41\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mangosteen41 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMangosteen41(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  77: {
                ::LimaBean41 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::LimaBean41\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::LimaBean41 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLimaBean41(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  78: {
                ::LimaBean41::Blackcurrant41 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::LimaBean41::Blackcurrant41\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::LimaBean41::Blackcurrant41 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLimaBean41Blackcurrant41(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  79: {
                ::Sweedes42 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Sweedes42\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Sweedes42 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSweedes42(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  80: {
                ::Thyme42 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Thyme42\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Thyme42 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckThyme42(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  81: {
                ::Thyme42::Strawberry42 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Thyme42::Strawberry42\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Thyme42::Strawberry42 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckThyme42Strawberry42(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  82: {
                ::Sweetcorn43 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Sweetcorn43\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Sweetcorn43 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSweetcorn43(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  83: {
                ::RowanBerry43 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::RowanBerry43\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::RowanBerry43 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRowanBerry43(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  84: {
                ::RowanBerry43::CantelopeMelon43 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::RowanBerry43::CantelopeMelon43\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::RowanBerry43::CantelopeMelon43 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRowanBerry43CantelopeMelon43(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;

  }
  return 1;
}




