//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/getany.cpp
//
// Modifications:
// $Log: getany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:32  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1998/08/24 11:46:39  james
// ENV updates
//
// Revision 1.5  1997/12/12 08:58:00  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"

//Header files generated by idl compiler
#include "tin.hh"

#include "types.hh"
extern Ernie ernie;


void GetAny(CORBA::Any &any)
{
  switch(ernie.getULong()%(12+72))
  {
    case   0: any <<= ernie.getULong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating ULong");
#endif
              break;
    case   1: any <<= ernie.getLong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Long");
#endif
              break;
    case   2: any <<= ernie.getUShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating UShort");
#endif
              break;
    case   3: any <<= ernie.getShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Short");
#endif
              break;
    case   4: any <<= CORBA::Any::from_boolean(ernie.getBoolean());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Boolean");
#endif
              break;
    case   5: any <<= CORBA::Any::from_octet(ernie.getOctet());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Octet");
#endif
              break;
    case   6: any <<= CORBA::Any::from_char(ernie.getChar());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Char");
#endif
              break;
    case   7: any <<= ernie.getFloat();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Float");
#endif
               break;
    case   8: any <<= ernie.getDouble();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Double");
#endif
              break;
    case   9: any <<= ernie.getString();
#ifdef DEBUG
              ::tet_infoline("GetAny creating String");
#endif
              break;
    case  10: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating BoundedString");
#endif
                CORBA::ULong  b;
                b = ernie.getULong()%30+1;
                any <<= CORBA::Any::from_string(ernie.getString(b),b);
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr _typecode;
#ifdef DEBUG
                ::tet_infoline("GetAny creating TypeCode");
#endif
                GetCORBATypeCode_ptr(_typecode);
                any <<= _typecode;
               }
                break;
    case   12: {
                CORBA::Any  _any;  
#ifdef DEBUG
                ::tet_infoline("GetAny creating Any");
#endif
                GetAny(_any);
                any <<= _any;
               }
                break;

    case  13: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Radish22");
#endif
                ::Radish22   v;

                GetRadish22(v);

                any  <<= v;
              }
              break;

    case  14: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sharanfruit22");
#endif
                ::Sharanfruit22   v;

                GetSharanfruit22(v);

                any  <<= v;
              }
              break;

    case  15: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Tarragon23");
#endif
                ::Tarragon23_forany   v(::Tarragon23_alloc());

                GetTarragon23(v);

                any  <<= v;
              }
              break;

    case  16: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::ButterBean24");
#endif
                ::ButterBean24   v;

                GetButterBean24(v);

                any  <<= v;
              }
              break;

    case  17: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Zucchini24");
#endif
                ::Zucchini24   v;

                GetZucchini24(v);

                any  <<= v;
              }
              break;

    case  18: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Zucchini24::Plum24");
#endif
                ::Zucchini24::Plum24   v;

                GetZucchini24Plum24(v);

                any  <<= v;
              }
              break;

    case  19: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Dill25");
#endif
                ::Dill25   v;

                GetDill25(v);

                any  <<= v;
              }
              break;

    case  20: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Bayleaf25");
#endif
                ::Bayleaf25   v;

                GetBayleaf25(v);

                any  <<= v;
              }
              break;

    case  21: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Bayleaf25::WhiteCabbage25");
#endif
                ::Bayleaf25::WhiteCabbage25   v;

                GetBayleaf25WhiteCabbage25(v);

                any  <<= v;
              }
              break;

    case  22: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::WaterMelon26");
#endif
                ::WaterMelon26   v;

                GetWaterMelon26(v);

                any  <<= v;
              }
              break;

    case  23: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mango26");
#endif
                ::Mango26   v;

                GetMango26(v);

                any  <<= v;
              }
              break;

    case  24: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mango26::PassionFruit26");
#endif
                ::Mango26::PassionFruit26   v;

                GetMango26PassionFruit26(v);

                any  <<= v;
              }
              break;

    case  25: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Record26");
#endif
                ::Record26   v;

                GetRecord26(v);

                any  <<= v;
              }
              break;

    case  26: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Potato26");
#endif
                ::Potato26   v;

                GetPotato26(v);

                any  <<= v;
              }
              break;

    case  27: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Potato26::ChineseLeaves26");
#endif
                ::Potato26::ChineseLeaves26   v;

                GetPotato26ChineseLeaves26(v);

                any  <<= v;
              }
              break;

    case  28: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Blackberry27");
#endif
                ::Blackberry27   v;

                GetBlackberry27(v);

                any  <<= v;
              }
              break;

    case  29: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Blueberry27");
#endif
                ::Blueberry27   v;

                GetBlueberry27(v);

                any  <<= v;
              }
              break;

    case  30: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Blueberry27::Basil27");
#endif
                ::Blueberry27::Basil27   v;

                GetBlueberry27Basil27(v);

                any  <<= v;
              }
              break;

    case  31: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Grapefruit28");
#endif
                ::Grapefruit28   v;

                GetGrapefruit28(v);

                any  <<= v;
              }
              break;

    case  32: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Raspberry28");
#endif
                ::Raspberry28   v;

                GetRaspberry28(v);

                any  <<= v;
              }
              break;

    case  33: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Raspberry28::Peppercorn28");
#endif
                ::Raspberry28::Peppercorn28   v;

                GetRaspberry28Peppercorn28(v);

                any  <<= v;
              }
              break;

    case  34: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Kumquats29");
#endif
                ::Kumquats29   v;

                GetKumquats29(v);

                any  <<= v;
              }
              break;

    case  35: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Elderberry29");
#endif
                ::Elderberry29   v;

                GetElderberry29(v);

                any  <<= v;
              }
              break;

    case  36: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Elderberry29::RedGrapes29");
#endif
                ::Elderberry29::RedGrapes29   v;

                GetElderberry29RedGrapes29(v);

                any  <<= v;
              }
              break;

    case  37: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::RedOnion30");
#endif
                ::RedOnion30   v;

                GetRedOnion30(v);

                any  <<= v;
              }
              break;

    case  38: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CrabApple30");
#endif
                ::CrabApple30   v;

                GetCrabApple30(v);

                any  <<= v;
              }
              break;

    case  39: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CrabApple30::Lentil30");
#endif
                ::CrabApple30::Lentil30   v;

                GetCrabApple30Lentil30(v);

                any  <<= v;
              }
              break;

    case  40: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Runnerbean31");
#endif
                ::Runnerbean31   v;

                GetRunnerbean31(v);

                any  <<= v;
              }
              break;

    case  41: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mushroom31");
#endif
                ::Mushroom31   v;

                GetMushroom31(v);

                any  <<= v;
              }
              break;

    case  42: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mushroom31::Almonds31");
#endif
                ::Mushroom31::Almonds31   v;

                GetMushroom31Almonds31(v);

                any  <<= v;
              }
              break;

    case  43: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cucumber32");
#endif
                ::Cucumber32   v;

                GetCucumber32(v);

                any  <<= v;
              }
              break;

    case  44: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cabbage32");
#endif
                ::Cabbage32   v;

                GetCabbage32(v);

                any  <<= v;
              }
              break;

    case  45: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cabbage32::Coconut32");
#endif
                ::Cabbage32::Coconut32   v;

                GetCabbage32Coconut32(v);

                any  <<= v;
              }
              break;

    case  46: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GoldenWonder32");
#endif
                ::GoldenWonder32   v;

                GetGoldenWonder32(v);

                any  <<= v;
              }
              break;

    case  47: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::KerrsPinks32");
#endif
                ::KerrsPinks32   v;

                GetKerrsPinks32(v);

                any  <<= v;
              }
              break;

    case  48: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::KerrsPinks32::Wilja32");
#endif
                ::KerrsPinks32::Wilja32   v;

                GetKerrsPinks32Wilja32(v);

                any  <<= v;
              }
              break;

    case  49: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Currant33");
#endif
                ::Currant33   v;

                GetCurrant33(v);

                any  <<= v;
              }
              break;

    case  50: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::PricklyPear33");
#endif
                ::PricklyPear33   v;

                GetPricklyPear33(v);

                any  <<= v;
              }
              break;

    case  51: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::PricklyPear33::VineTomatoes33");
#endif
                ::PricklyPear33::VineTomatoes33   v;

                GetPricklyPear33VineTomatoes33(v);

                any  <<= v;
              }
              break;

    case  52: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GreenGrapes34");
#endif
                ::GreenGrapes34   v;

                GetGreenGrapes34(v);

                any  <<= v;
              }
              break;

    case  53: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Artichokes34");
#endif
                ::Artichokes34   v;

                GetArtichokes34(v);

                any  <<= v;
              }
              break;

    case  54: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Artichokes34::Peanutsquash34");
#endif
                ::Artichokes34::Peanutsquash34   v;

                GetArtichokes34Peanutsquash34(v);

                any  <<= v;
              }
              break;

    case  55: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Beetroot35");
#endif
                ::Beetroot35   v;

                GetBeetroot35(v);

                any  <<= v;
              }
              break;

    case  56: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Chickpea35");
#endif
                ::Chickpea35   v;

                GetChickpea35(v);

                any  <<= v;
              }
              break;

    case  57: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Chickpea35::Uglifruit35");
#endif
                ::Chickpea35::Uglifruit35   v;

                GetChickpea35Uglifruit35(v);

                any  <<= v;
              }
              break;

    case  58: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cloves36");
#endif
                ::Cloves36   v;

                GetCloves36(v);

                any  <<= v;
              }
              break;

    case  59: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::JuniperBerries36");
#endif
                ::JuniperBerries36   v;

                GetJuniperBerries36(v);

                any  <<= v;
              }
              break;

    case  60: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::JuniperBerries36::GooseBerry36");
#endif
                ::JuniperBerries36::GooseBerry36   v;

                GetJuniperBerries36GooseBerry36(v);

                any  <<= v;
              }
              break;

    case  61: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::SweetPotato37");
#endif
                ::SweetPotato37   v;

                GetSweetPotato37(v);

                any  <<= v;
              }
              break;

    case  62: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BrazilNut37");
#endif
                ::BrazilNut37   v;

                GetBrazilNut37(v);

                any  <<= v;
              }
              break;

    case  63: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BrazilNut37::Brocoli37");
#endif
                ::BrazilNut37::Brocoli37   v;

                GetBrazilNut37Brocoli37(v);

                any  <<= v;
              }
              break;

    case  64: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GardenPeas38");
#endif
                ::GardenPeas38   v;

                GetGardenPeas38(v);

                any  <<= v;
              }
              break;

    case  65: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mint38");
#endif
                ::Mint38   v;

                GetMint38(v);

                any  <<= v;
              }
              break;

    case  66: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mint38::BlackEyedBeans38");
#endif
                ::Mint38::BlackEyedBeans38   v;

                GetMint38BlackEyedBeans38(v);

                any  <<= v;
              }
              break;

    case  67: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::KingEdward38");
#endif
                ::KingEdward38   v;

                GetKingEdward38(v);

                any  <<= v;
              }
              break;

    case  68: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cara38");
#endif
                ::Cara38   v;

                GetCara38(v);

                any  <<= v;
              }
              break;

    case  69: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cara38::Rooster38");
#endif
                ::Cara38::Rooster38   v;

                GetCara38Rooster38(v);

                any  <<= v;
              }
              break;

    case  70: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::PippinApple39");
#endif
                ::PippinApple39   v;

                GetPippinApple39(v);

                any  <<= v;
              }
              break;

    case  71: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Chayato39");
#endif
                ::Chayato39   v;

                GetChayato39(v);

                any  <<= v;
              }
              break;

    case  72: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Chayato39::KiwanoMelon39");
#endif
                ::Chayato39::KiwanoMelon39   v;

                GetChayato39KiwanoMelon39(v);

                any  <<= v;
              }
              break;

    case  73: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Yam40");
#endif
                ::Yam40   v;

                GetYam40(v);

                any  <<= v;
              }
              break;

    case  74: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Eddo40");
#endif
                ::Eddo40   v;

                GetEddo40(v);

                any  <<= v;
              }
              break;

    case  75: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Eddo40::Chives40");
#endif
                ::Eddo40::Chives40   v;

                GetEddo40Chives40(v);

                any  <<= v;
              }
              break;

    case  76: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mangosteen41");
#endif
                ::Mangosteen41   v;

                GetMangosteen41(v);

                any  <<= v;
              }
              break;

    case  77: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::LimaBean41");
#endif
                ::LimaBean41   v;

                GetLimaBean41(v);

                any  <<= v;
              }
              break;

    case  78: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::LimaBean41::Blackcurrant41");
#endif
                ::LimaBean41::Blackcurrant41   v;

                GetLimaBean41Blackcurrant41(v);

                any  <<= v;
              }
              break;

    case  79: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sweedes42");
#endif
                ::Sweedes42   v;

                GetSweedes42(v);

                any  <<= v;
              }
              break;

    case  80: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Thyme42");
#endif
                ::Thyme42   v;

                GetThyme42(v);

                any  <<= v;
              }
              break;

    case  81: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Thyme42::Strawberry42");
#endif
                ::Thyme42::Strawberry42   v;

                GetThyme42Strawberry42(v);

                any  <<= v;
              }
              break;

    case  82: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sweetcorn43");
#endif
                ::Sweetcorn43   v;

                GetSweetcorn43(v);

                any  <<= v;
              }
              break;

    case  83: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::RowanBerry43");
#endif
                ::RowanBerry43   v;

                GetRowanBerry43(v);

                any  <<= v;
              }
              break;

    case  84: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::RowanBerry43::CantelopeMelon43");
#endif
                ::RowanBerry43::CantelopeMelon43   v;

                GetRowanBerry43CantelopeMelon43(v);

                any  <<= v;
              }
              break;

  }
}


