//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Radish22
idlServer_imp::Radish22Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  
  ::Radish22 ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Radish22Attr\n");
#endif
  
  ernie.seed("Radish22AttrCall");
  
  ernie.seed("Radish22AttrReturn"); 
  
  GetRadish22(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Radish22Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Radish22Attr(::Radish22 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Radish22Attr\n");
#endif
  
  ernie.seed("Radish22AttrCall");
  AddName("_attr");
  if (!CheckRadish22(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Radish22AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Radish22Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Radish22
idlServer_imp::Radish22Op(::Radish22 p1,::Radish22_out p2,::Radish22 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  
  ::Radish22 ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Radish22Op\n");
#endif
  
  ernie.seed("Radish22OpCall");
  AddName("p1");
  if (!CheckRadish22(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckRadish22(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Radish22OpReturn"); 
  {
    ::idlServer::Radish22Excpt ex;
    GetidlServerRadish22Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetRadish22(ReturnValue);
  GetRadish22(p2);
  GetRadish22(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Radish22Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Sharanfruit22
idlServer_imp::Sharanfruit22Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  
  ::Sharanfruit22 ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sharanfruit22Attr\n");
#endif
  
  ernie.seed("Sharanfruit22AttrCall");
  
  ernie.seed("Sharanfruit22AttrReturn"); 
  
  GetSharanfruit22(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sharanfruit22Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Sharanfruit22Attr(::Sharanfruit22 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sharanfruit22Attr\n");
#endif
  
  ernie.seed("Sharanfruit22AttrCall");
  AddName("_attr");
  if (!CheckSharanfruit22(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sharanfruit22AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sharanfruit22Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Sharanfruit22
idlServer_imp::Sharanfruit22Op(::Sharanfruit22 p1,::Sharanfruit22_out p2,::Sharanfruit22 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  
  ::Sharanfruit22 ReturnValue;
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sharanfruit22Op\n");
#endif
  
  ernie.seed("Sharanfruit22OpCall");
  AddName("p1");
  if (!CheckSharanfruit22(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckSharanfruit22(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sharanfruit22OpReturn"); 
  {
    ::idlServer::Sharanfruit22Excpt ex;
    GetidlServerSharanfruit22Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetSharanfruit22(ReturnValue);
  GetSharanfruit22(p2);
  GetSharanfruit22(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sharanfruit22Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Tarragon23_slice *
idlServer_imp::Tarragon23Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Tarragon23_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Tarragon23Attr\n");
#endif
  
  ernie.seed("Tarragon23AttrCall");
  
  ernie.seed("Tarragon23AttrReturn"); 
  
  ReturnValue = new ::Tarragon23;
  GetTarragon23(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Tarragon23Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Tarragon23Attr(const ::Tarragon23 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Tarragon23Attr\n");
#endif
  
  ernie.seed("Tarragon23AttrCall");
  AddName("_attr");
  if (!CheckTarragon23(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Tarragon23AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Tarragon23Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Tarragon23_slice *
idlServer_imp::Tarragon23Op(const ::Tarragon23 p1,::Tarragon23_out p2,::Tarragon23 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Tarragon23_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Tarragon23Op\n");
#endif
  
  ernie.seed("Tarragon23OpCall");
  AddName("p1");
  if (!CheckTarragon23(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckTarragon23(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Tarragon23OpReturn"); 
  {
    ::idlServer::Tarragon23Excpt ex;
    GetidlServerTarragon23Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Tarragon23;
  GetTarragon23(ReturnValue);
  p2 = new ::Tarragon23;
  GetTarragon23(p2);
  GetTarragon23(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Tarragon23Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::ButterBean24*
idlServer_imp::ButterBean24Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::ButterBean24* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ButterBean24Attr\n");
#endif
  
  ernie.seed("ButterBean24AttrCall");
  
  ernie.seed("ButterBean24AttrReturn"); 
  ReturnValue = new ::ButterBean24;
  GetButterBean24(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ButterBean24Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::ButterBean24Attr(const ::ButterBean24 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ButterBean24Attr\n");
#endif
  
  ernie.seed("ButterBean24AttrCall");
  AddName("_attr");
  if (!CheckButterBean24(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ButterBean24AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ButterBean24Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::ButterBean24*
idlServer_imp::ButterBean24Op(const ::ButterBean24 &p1,::ButterBean24_out p2,::ButterBean24 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::ButterBean24* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::ButterBean24Op\n");
#endif
  
  ernie.seed("ButterBean24OpCall");
  AddName("p1");
  if (!CheckButterBean24(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckButterBean24(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ButterBean24OpReturn"); 
  {
    ::idlServer::ButterBean24Excpt ex;
    GetidlServerButterBean24Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::ButterBean24;
  GetButterBean24(*ReturnValue);
  p2 = new ::ButterBean24;
  GetButterBean24(*(p2.ptr()));
  GetButterBean24(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::ButterBean24Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Zucchini24*
idlServer_imp::Zucchini24Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Zucchini24* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Zucchini24Attr\n");
#endif
  
  ernie.seed("Zucchini24AttrCall");
  
  ernie.seed("Zucchini24AttrReturn"); 
  ReturnValue = new ::Zucchini24;
  GetZucchini24(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Zucchini24Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Zucchini24Attr(const ::Zucchini24 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Zucchini24Attr\n");
#endif
  
  ernie.seed("Zucchini24AttrCall");
  AddName("_attr");
  if (!CheckZucchini24(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Zucchini24AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Zucchini24Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Zucchini24*
idlServer_imp::Zucchini24Op(const ::Zucchini24 &p1,::Zucchini24_out p2,::Zucchini24 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Zucchini24* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Zucchini24Op\n");
#endif
  
  ernie.seed("Zucchini24OpCall");
  AddName("p1");
  if (!CheckZucchini24(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckZucchini24(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Zucchini24OpReturn"); 
  {
    ::idlServer::Zucchini24Excpt ex;
    GetidlServerZucchini24Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Zucchini24;
  GetZucchini24(*ReturnValue);
  p2 = new ::Zucchini24;
  GetZucchini24(*(p2.ptr()));
  GetZucchini24(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Zucchini24Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Zucchini24::Plum24*
idlServer_imp::Plum24Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Zucchini24::Plum24* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Plum24Attr\n");
#endif
  
  ernie.seed("Plum24AttrCall");
  
  ernie.seed("Plum24AttrReturn"); 
  ReturnValue = new ::Zucchini24::Plum24;
  GetZucchini24Plum24(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Plum24Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Plum24Attr(const ::Zucchini24::Plum24 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Plum24Attr\n");
#endif
  
  ernie.seed("Plum24AttrCall");
  AddName("_attr");
  if (!CheckZucchini24Plum24(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Plum24AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Plum24Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Zucchini24::Plum24*
idlServer_imp::Plum24Op(const ::Zucchini24::Plum24 &p1,::Zucchini24::Plum24_out p2,::Zucchini24::Plum24 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Zucchini24::Plum24* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Plum24Op\n");
#endif
  
  ernie.seed("Plum24OpCall");
  AddName("p1");
  if (!CheckZucchini24Plum24(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckZucchini24Plum24(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Plum24OpReturn"); 
  {
    ::idlServer::Plum24Excpt ex;
    GetidlServerPlum24Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Zucchini24::Plum24;
  GetZucchini24Plum24(*ReturnValue);
  p2 = new ::Zucchini24::Plum24;
  GetZucchini24Plum24(*(p2.ptr()));
  GetZucchini24Plum24(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Plum24Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Dill25*
idlServer_imp::Dill25Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Dill25* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Dill25Attr\n");
#endif
  
  ernie.seed("Dill25AttrCall");
  
  ernie.seed("Dill25AttrReturn"); 
  ReturnValue = new ::Dill25;
  GetDill25(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Dill25Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Dill25Attr(const ::Dill25 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Dill25Attr\n");
#endif
  
  ernie.seed("Dill25AttrCall");
  AddName("_attr");
  if (!CheckDill25(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Dill25AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Dill25Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Dill25*
idlServer_imp::Dill25Op(const ::Dill25 &p1,::Dill25_out p2,::Dill25 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Dill25* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Dill25Op\n");
#endif
  
  ernie.seed("Dill25OpCall");
  AddName("p1");
  if (!CheckDill25(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckDill25(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Dill25OpReturn"); 
  {
    ::idlServer::Dill25Excpt ex;
    GetidlServerDill25Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Dill25;
  GetDill25(*ReturnValue);
  p2 = new ::Dill25;
  GetDill25(*(p2.ptr()));
  GetDill25(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Dill25Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Bayleaf25*
idlServer_imp::Bayleaf25Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Bayleaf25* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Bayleaf25Attr\n");
#endif
  
  ernie.seed("Bayleaf25AttrCall");
  
  ernie.seed("Bayleaf25AttrReturn"); 
  ReturnValue = new ::Bayleaf25;
  GetBayleaf25(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Bayleaf25Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Bayleaf25Attr(const ::Bayleaf25 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Bayleaf25Attr\n");
#endif
  
  ernie.seed("Bayleaf25AttrCall");
  AddName("_attr");
  if (!CheckBayleaf25(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Bayleaf25AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Bayleaf25Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Bayleaf25*
idlServer_imp::Bayleaf25Op(const ::Bayleaf25 &p1,::Bayleaf25_out p2,::Bayleaf25 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Bayleaf25* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Bayleaf25Op\n");
#endif
  
  ernie.seed("Bayleaf25OpCall");
  AddName("p1");
  if (!CheckBayleaf25(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBayleaf25(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Bayleaf25OpReturn"); 
  {
    ::idlServer::Bayleaf25Excpt ex;
    GetidlServerBayleaf25Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Bayleaf25;
  GetBayleaf25(*ReturnValue);
  p2 = new ::Bayleaf25;
  GetBayleaf25(*(p2.ptr()));
  GetBayleaf25(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Bayleaf25Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Bayleaf25::WhiteCabbage25*
idlServer_imp::WhiteCabbage25Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Bayleaf25::WhiteCabbage25* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::WhiteCabbage25Attr\n");
#endif
  
  ernie.seed("WhiteCabbage25AttrCall");
  
  ernie.seed("WhiteCabbage25AttrReturn"); 
  ReturnValue = new ::Bayleaf25::WhiteCabbage25;
  GetBayleaf25WhiteCabbage25(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::WhiteCabbage25Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::WhiteCabbage25Attr(const ::Bayleaf25::WhiteCabbage25 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::WhiteCabbage25Attr\n");
#endif
  
  ernie.seed("WhiteCabbage25AttrCall");
  AddName("_attr");
  if (!CheckBayleaf25WhiteCabbage25(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("WhiteCabbage25AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::WhiteCabbage25Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Bayleaf25::WhiteCabbage25*
idlServer_imp::WhiteCabbage25Op(const ::Bayleaf25::WhiteCabbage25 &p1,::Bayleaf25::WhiteCabbage25_out p2,::Bayleaf25::WhiteCabbage25 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Bayleaf25::WhiteCabbage25* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::WhiteCabbage25Op\n");
#endif
  
  ernie.seed("WhiteCabbage25OpCall");
  AddName("p1");
  if (!CheckBayleaf25WhiteCabbage25(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBayleaf25WhiteCabbage25(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("WhiteCabbage25OpReturn"); 
  {
    ::idlServer::WhiteCabbage25Excpt ex;
    GetidlServerWhiteCabbage25Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Bayleaf25::WhiteCabbage25;
  GetBayleaf25WhiteCabbage25(*ReturnValue);
  p2 = new ::Bayleaf25::WhiteCabbage25;
  GetBayleaf25WhiteCabbage25(*(p2.ptr()));
  GetBayleaf25WhiteCabbage25(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::WhiteCabbage25Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



