//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/checkany.cpp
//
// Modifications:
// $Log: checkany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:34  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/26 13:51:30  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/12 08:59:35  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern char name[];

 
int CheckAny(const CORBA::Any &any)
{
  switch(ernie.getULong()%(12+89))
  {
    case   0: {
                CORBA::ULong  v;
#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::ULong");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::ULong as expected", name);
                  return 0;
                }
                if (!ernie.checkULong(v))
                {
                  tet_printf("Expected %s to contain CORBA::ULong with value %u, but found %u instead.",
                    name,ernie.getULongAgain(),v);
                  return 0;
                }
              }
              break;
    case   1: {
                CORBA::Long  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Long");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Long as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkLong(v))
                {
                  tet_printf("Expected %s to contain CORBA::Long with value %d, but found %d instead.",
                    name,ernie.getLongAgain(),v);
                  return 0;
                }
              }
              break;
    case   2: {
                CORBA::UShort  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::UShort");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::UShort as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkUShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::UShort with value %u, but found %u instead.",
                    name,ernie.getUShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   3: {
                CORBA::Short  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Short");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Short as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::Short with value %d, but found %d instead.",
                    name,ernie.getShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   4: {
                CORBA::Boolean  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Boolean");
#endif
                if (!(any >>= CORBA::Any::to_boolean(v)))
                {
                  tet_printf("%s did not contain a CORBA::Boolean as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkBoolean(v))
                {
                  tet_printf("Expected %s to contain CORBA::Boolean with value %s, but found %s instead.",
                    name,
                    BooleanToString(ernie.getBooleanAgain()),
                    BooleanToString(v));
                  return 0;
                }
              }
              break;
    case   5: {
                CORBA::Octet  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Octet");
#endif
                if (!(any >>= CORBA::Any::to_octet(v)))
                {
                  tet_printf("%s did not contain a CORBA::Octet as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkOctet(v))
                {
                  ::tet_printf("Expected %s to contain CORBA::Octet with value %s, but found %s instead.",
                    name,
                    OctetToString(ernie.getOctetAgain()),
                    OctetToString(v));
                  return 0;
                }
              }
              break;
    case   6: {
                CORBA::Char  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Char");
#endif
                if (!(any >>= CORBA::Any::to_char(v)))
                {
                  tet_printf("%s did not contain a CORBA::Char as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkChar(v))
                {
                  tet_printf("Expected %s to contain CORBA::Char with value %s, but found %s instead.",
                    name,
                    CharToString(ernie.getCharAgain()),
                    CharToString(v));
                  return 0;
                }
              }
              break;
    case   7: {
                CORBA::Float  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Float");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Float as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkFloat(v))
                {
                  tet_printf("Expected %s to contain CORBA::Float with value %g, but found %g instead.",
                    name,
                    ernie.getFloatAgain(),
                    v);
                  return 0;
                }
              }
               break;
    case   8: {
                CORBA::Double  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Double");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Double as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkDouble(v))
                {
                  tet_printf("Expected %s to contain CORBA::Double with value %g, but found %g instead.",
                    name,
                    ernie.getDoubleAgain(),
                    v);
                  return 0;
                }
              }
              break;
    case   9: {
                char *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting char*");
#endif
                if (!(any >>= CORBA::Any::to_string(v,0)))
                {
                  tet_printf("%s did not contain a char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v))
                {
                  tet_printf("Expected %s to contain char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case  10: {
                CORBA::ULong  b;
                char   *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting bounded char*");
#endif
                b = ernie.getULong()%30+1;

                if (!(any >>= CORBA::Any::to_string(v,b)))
                {
                  tet_printf("%s did not contain a bounded char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v,b))
                {
                  tet_printf("Expected %s to contain a bounded char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::TypeCode");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::TypeCode as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCORBATypeCode_ptr(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case   12: {
                CORBA::Any  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Any");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Any as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAny(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  13: {
                ::LoganBerry44 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::LoganBerry44\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::LoganBerry44 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLoganBerry44(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  14: {
                ::Orange44 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Orange44\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Orange44 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOrange44(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  15: {
                ::Orange44::Sultana44 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Orange44::Sultana44\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Orange44::Sultana44 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOrange44Sultana44(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  16: {
                ::BlackCherry45 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BlackCherry45\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BlackCherry45 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlackCherry45(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  17: {
                ::Lemon45 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lemon45\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lemon45 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLemon45(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  18: {
                ::Lemon45::Banana45 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lemon45::Banana45\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lemon45::Banana45 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLemon45Banana45(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  19: {
                ::Corriander45 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Corriander45\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Corriander45 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCorriander45(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  20: {
                ::Kiwi45 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Kiwi45\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Kiwi45 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckKiwi45(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  21: {
                ::Kiwi45::GalaApple45 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Kiwi45::GalaApple45\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Kiwi45::GalaApple45 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckKiwi45GalaApple45(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  22: {
                ::YellowPepper46 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::YellowPepper46\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::YellowPepper46 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckYellowPepper46(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  23: {
                ::Parsley46 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Parsley46\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Parsley46 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckParsley46(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  24: {
                ::Parsley46::Peach46 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Parsley46::Peach46\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Parsley46::Peach46 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckParsley46Peach46(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  25: {
                ::Radish47 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Radish47\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Radish47 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRadish47(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  26: {
                ::Sharanfruit47 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Sharanfruit47\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Sharanfruit47 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSharanfruit47(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  27: {
                ::Sharanfruit47::BeefTomatoes47 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Sharanfruit47::BeefTomatoes47\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Sharanfruit47::BeefTomatoes47 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSharanfruit47BeefTomatoes47(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  28: {
                ::BambooShoot48 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BambooShoot48\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BambooShoot48 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBambooShoot48(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  29: {
                ::Cress48 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cress48\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cress48 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCress48(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  30: {
                ::Cress48::Lettuce48 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cress48::Lettuce48\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cress48::Lettuce48 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCress48Lettuce48(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  31: {
                ::ButterBean49 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::ButterBean49\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::ButterBean49 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckButterBean49(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  32: {
                ::Zucchini49 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Zucchini49\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Zucchini49 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckZucchini49(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  33: {
                ::Zucchini49::Plum49 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Zucchini49::Plum49\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Zucchini49::Plum49 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckZucchini49Plum49(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  34: {
                ::Dill50 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Dill50\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Dill50 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckDill50(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  35: {
                ::Bayleaf50 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Bayleaf50\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Bayleaf50 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBayleaf50(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  36: {
                ::Bayleaf50::WhiteCabbage50 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Bayleaf50::WhiteCabbage50\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Bayleaf50::WhiteCabbage50 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBayleaf50WhiteCabbage50(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  37: {
                ::WaterMelon51 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::WaterMelon51\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::WaterMelon51 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckWaterMelon51(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  38: {
                ::Mango51 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mango51\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mango51 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMango51(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  39: {
                ::Mango51::PassionFruit51 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mango51::PassionFruit51\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mango51::PassionFruit51 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMango51PassionFruit51(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  40: {
                ::Record51 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Record51\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Record51 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRecord51(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  41: {
                ::Potato51 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Potato51\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Potato51 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPotato51(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  42: {
                ::Potato51::ChineseLeaves51 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Potato51::ChineseLeaves51\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Potato51::ChineseLeaves51 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPotato51ChineseLeaves51(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  43: {
                ::Blackberry52 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Blackberry52\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Blackberry52 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlackberry52(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  44: {
                ::Blueberry52 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Blueberry52\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Blueberry52 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlueberry52(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  45: {
                ::Blueberry52::Basil52 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Blueberry52::Basil52\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Blueberry52::Basil52 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlueberry52Basil52(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  46: {
                ::CookingApple53 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CookingApple53\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CookingApple53 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCookingApple53(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  47: {
                ::Rasin53 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Rasin53\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Rasin53 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRasin53(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  48: {
                ::Rasin53::Artichokes53 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Rasin53::Artichokes53\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Rasin53::Artichokes53 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRasin53Artichokes53(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  49: {
                ::Rasin53::Artichokes53::Peanutsquash53 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Rasin53::Artichokes53::Peanutsquash53\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Rasin53::Artichokes53::Peanutsquash53 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRasin53Artichokes53Peanutsquash53(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  50: {
                ::Susander54 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Susander54\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Susander54 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSusander54(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  51: {
                ::Peppercorn54 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Peppercorn54\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Peppercorn54 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPeppercorn54(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  52: {
                ::Peppercorn54::Cherry54 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Peppercorn54::Cherry54\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Peppercorn54::Cherry54 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPeppercorn54Cherry54(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  53: {
                ::Peppercorn54::Cherry54::Okra54 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Peppercorn54::Cherry54::Okra54\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Peppercorn54::Cherry54::Okra54 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPeppercorn54Cherry54Okra54(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  54: {
                ::RedPepper55 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::RedPepper55\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::RedPepper55 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRedPepper55(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  55: {
                ::Pear55 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Pear55\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Pear55 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPear55(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  56: {
                ::Pear55::LimaBean55 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Pear55::LimaBean55\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Pear55::LimaBean55 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPear55LimaBean55(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  57: {
                ::Pear55::LimaBean55::Blackcurrant55 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Pear55::LimaBean55::Blackcurrant55\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Pear55::LimaBean55::Blackcurrant55 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPear55LimaBean55Blackcurrant55(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  58: {
                ::Waterchestnut56 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Waterchestnut56\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Waterchestnut56 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckWaterchestnut56(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  59: {
                ::Uglifruit56 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Uglifruit56\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Uglifruit56 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckUglifruit56(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  60: {
                ::Uglifruit56::Walnuts56 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Uglifruit56::Walnuts56\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Uglifruit56::Walnuts56 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckUglifruit56Walnuts56(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  61: {
                ::Uglifruit56::Walnuts56::Pomegranate56 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Uglifruit56::Walnuts56::Pomegranate56\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Uglifruit56::Walnuts56::Pomegranate56 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckUglifruit56Walnuts56Pomegranate56(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  62: {
                ::Melon57 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Melon57\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Melon57 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMelon57(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  63: {
                ::Cassava57 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cassava57\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cassava57 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCassava57(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  64: {
                ::Cassava57::Cress57 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cassava57::Cress57\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cassava57::Cress57 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCassava57Cress57(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  65: {
                ::Cassava57::Cress57::Lettuce57 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cassava57::Cress57::Lettuce57\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cassava57::Cress57::Lettuce57 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCassava57Cress57Lettuce57(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  66: {
                ::BreadFruit58 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BreadFruit58\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BreadFruit58 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBreadFruit58(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  67: {
                ::Strawberry58 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Strawberry58\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Strawberry58 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckStrawberry58(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  68: {
                ::Strawberry58::Daikan58 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Strawberry58::Daikan58\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Strawberry58::Daikan58 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckStrawberry58Daikan58(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  69: {
                ::Strawberry58::Daikan58::Avocado58 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Strawberry58::Daikan58::Avocado58\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Strawberry58::Daikan58::Avocado58 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckStrawberry58Daikan58Avocado58(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  70: {
                ::Cinnamon59 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cinnamon59\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cinnamon59 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCinnamon59(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  71: {
                ::HazelNut59 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::HazelNut59\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::HazelNut59 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckHazelNut59(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  72: {
                ::HazelNut59::CrabApple59 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::HazelNut59::CrabApple59\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::HazelNut59::CrabApple59 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckHazelNut59CrabApple59(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  73: {
                ::HazelNut59::CrabApple59::Lentil59 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::HazelNut59::CrabApple59::Lentil59\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::HazelNut59::CrabApple59::Lentil59 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckHazelNut59CrabApple59Lentil59(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  74: {
                ::KidneyBean60 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::KidneyBean60\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::KidneyBean60 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckKidneyBean60(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  75: {
                ::Plum60 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Plum60\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Plum60 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPlum60(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  76: {
                ::Plum60::Onion60 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Plum60::Onion60\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Plum60::Onion60 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPlum60Onion60(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  77: {
                ::Plum60::Onion60::Tofu60 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Plum60::Onion60::Tofu60\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Plum60::Onion60::Tofu60 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPlum60Onion60Tofu60(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  78: {
                ::Billberries61 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Billberries61\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Billberries61 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBillberries61(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  79: {
                ::Tangarine61 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Tangarine61\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Tangarine61 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckTangarine61(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  80: {
                ::Tangarine61::BrazilNut61 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Tangarine61::BrazilNut61\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Tangarine61::BrazilNut61 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckTangarine61BrazilNut61(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  81: {
                ::Tangarine61::BrazilNut61::Brocoli61 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Tangarine61::BrazilNut61::Brocoli61\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Tangarine61::BrazilNut61::Brocoli61 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckTangarine61BrazilNut61Brocoli61(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  82: {
                ::Guava62 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Guava62\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Guava62 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGuava62(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  83: {
                ::Almonds62 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Almonds62\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Almonds62 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAlmonds62(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  84: {
                ::Almonds62::Oregano62 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Almonds62::Oregano62\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Almonds62::Oregano62 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAlmonds62Oregano62(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  85: {
                ::Almonds62::Oregano62::Asparagus62 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Almonds62::Oregano62::Asparagus62\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Almonds62::Oregano62::Asparagus62 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAlmonds62Oregano62Asparagus62(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  86: {
                ::Celery63 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Celery63\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Celery63 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCelery63(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  87: {
                ::Parsnip63 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Parsnip63\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Parsnip63 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckParsnip63(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  88: {
                ::Parsnip63::Orange63 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Parsnip63::Orange63\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Parsnip63::Orange63 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckParsnip63Orange63(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  89: {
                ::Parsnip63::Orange63::Sultana63 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Parsnip63::Orange63::Sultana63\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Parsnip63::Orange63::Sultana63 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckParsnip63Orange63Sultana63(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  90: {
                ::Leek64 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Leek64\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Leek64 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLeek64(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  91: {
                ::BlackEyedBeans64 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BlackEyedBeans64\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BlackEyedBeans64 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlackEyedBeans64(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  92: {
                ::BlackEyedBeans64::Ginger64 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BlackEyedBeans64::Ginger64\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BlackEyedBeans64::Ginger64 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlackEyedBeans64Ginger64(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  93: {
                ::BlackEyedBeans64::Ginger64::Starfruit64 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BlackEyedBeans64::Ginger64::Starfruit64\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BlackEyedBeans64::Ginger64::Starfruit64 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlackEyedBeans64Ginger64Starfruit64(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  94: {
                ::Dates65 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Dates65\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Dates65 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckDates65(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  95: {
                ::Lime65 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lime65\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lime65 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLime65(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  96: {
                ::Lime65::Mango65 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lime65::Mango65\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lime65::Mango65 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLime65Mango65(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  97: {
                ::Lime65::Mango65::PassionFruit65 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lime65::Mango65::PassionFruit65\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lime65::Mango65::PassionFruit65 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLime65Mango65PassionFruit65(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  98: {
                ::Carrots66 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Carrots66\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Carrots66 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCarrots66(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  99: {
                ::Banana66 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Banana66\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Banana66 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBanana66(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  100: {
                ::Banana66::PentlandDell65 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Banana66::PentlandDell65\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Banana66::PentlandDell65 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBanana66PentlandDell65(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  101: {
                ::Banana66::PentlandDell65::Homeguard65 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Banana66::PentlandDell65::Homeguard65\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Banana66::PentlandDell65::Homeguard65 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBanana66PentlandDell65Homeguard65(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;

  }
  return 1;
}




