//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/getany.cpp
//
// Modifications:
// $Log: getany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:34  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1997/12/12 08:59:35  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"

//Header files generated by idl compiler
#include "tin.hh"

#include "types.hh"
extern Ernie ernie;


void GetAny(CORBA::Any &any)
{
  switch(ernie.getULong()%(12+89))
  {
    case   0: any <<= ernie.getULong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating ULong");
#endif
              break;
    case   1: any <<= ernie.getLong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Long");
#endif
              break;
    case   2: any <<= ernie.getUShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating UShort");
#endif
              break;
    case   3: any <<= ernie.getShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Short");
#endif
              break;
    case   4: any <<= CORBA::Any::from_boolean(ernie.getBoolean());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Boolean");
#endif
              break;
    case   5: any <<= CORBA::Any::from_octet(ernie.getOctet());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Octet");
#endif
              break;
    case   6: any <<= CORBA::Any::from_char(ernie.getChar());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Char");
#endif
              break;
    case   7: any <<= ernie.getFloat();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Float");
#endif
               break;
    case   8: any <<= ernie.getDouble();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Double");
#endif
              break;
    case   9: any <<= ernie.getString();
#ifdef DEBUG
              ::tet_infoline("GetAny creating String");
#endif
              break;
    case  10: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating BoundedString");
#endif
                CORBA::ULong  b;
                b = ernie.getULong()%30+1;
                any <<= CORBA::Any::from_string(ernie.getString(b),b);
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr _typecode;
#ifdef DEBUG
                ::tet_infoline("GetAny creating TypeCode");
#endif
                GetCORBATypeCode_ptr(_typecode);
                any <<= _typecode;
               }
                break;
    case   12: {
                CORBA::Any  _any;  
#ifdef DEBUG
                ::tet_infoline("GetAny creating Any");
#endif
                GetAny(_any);
                any <<= _any;
               }
                break;

    case  13: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::LoganBerry44");
#endif
                ::LoganBerry44   v;

                GetLoganBerry44(v);

                any  <<= v;
              }
              break;

    case  14: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Orange44");
#endif
                ::Orange44   v;

                GetOrange44(v);

                any  <<= v;
              }
              break;

    case  15: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Orange44::Sultana44");
#endif
                ::Orange44::Sultana44   v;

                GetOrange44Sultana44(v);

                any  <<= v;
              }
              break;

    case  16: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BlackCherry45");
#endif
                ::BlackCherry45   v;

                GetBlackCherry45(v);

                any  <<= v;
              }
              break;

    case  17: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lemon45");
#endif
                ::Lemon45   v;

                GetLemon45(v);

                any  <<= v;
              }
              break;

    case  18: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lemon45::Banana45");
#endif
                ::Lemon45::Banana45   v;

                GetLemon45Banana45(v);

                any  <<= v;
              }
              break;

    case  19: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Corriander45");
#endif
                ::Corriander45   v;

                GetCorriander45(v);

                any  <<= v;
              }
              break;

    case  20: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Kiwi45");
#endif
                ::Kiwi45   v;

                GetKiwi45(v);

                any  <<= v;
              }
              break;

    case  21: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Kiwi45::GalaApple45");
#endif
                ::Kiwi45::GalaApple45   v;

                GetKiwi45GalaApple45(v);

                any  <<= v;
              }
              break;

    case  22: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::YellowPepper46");
#endif
                ::YellowPepper46   v;

                GetYellowPepper46(v);

                any  <<= v;
              }
              break;

    case  23: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Parsley46");
#endif
                ::Parsley46   v;

                GetParsley46(v);

                any  <<= v;
              }
              break;

    case  24: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Parsley46::Peach46");
#endif
                ::Parsley46::Peach46   v;

                GetParsley46Peach46(v);

                any  <<= v;
              }
              break;

    case  25: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Radish47");
#endif
                ::Radish47   v;

                GetRadish47(v);

                any  <<= v;
              }
              break;

    case  26: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sharanfruit47");
#endif
                ::Sharanfruit47   v;

                GetSharanfruit47(v);

                any  <<= v;
              }
              break;

    case  27: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sharanfruit47::BeefTomatoes47");
#endif
                ::Sharanfruit47::BeefTomatoes47   v;

                GetSharanfruit47BeefTomatoes47(v);

                any  <<= v;
              }
              break;

    case  28: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BambooShoot48");
#endif
                ::BambooShoot48   v;

                GetBambooShoot48(v);

                any  <<= v;
              }
              break;

    case  29: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cress48");
#endif
                ::Cress48   v;

                GetCress48(v);

                any  <<= v;
              }
              break;

    case  30: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cress48::Lettuce48");
#endif
                ::Cress48::Lettuce48   v;

                GetCress48Lettuce48(v);

                any  <<= v;
              }
              break;

    case  31: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::ButterBean49");
#endif
                ::ButterBean49   v;

                GetButterBean49(v);

                any  <<= v;
              }
              break;

    case  32: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Zucchini49");
#endif
                ::Zucchini49   v;

                GetZucchini49(v);

                any  <<= v;
              }
              break;

    case  33: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Zucchini49::Plum49");
#endif
                ::Zucchini49::Plum49   v;

                GetZucchini49Plum49(v);

                any  <<= v;
              }
              break;

    case  34: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Dill50");
#endif
                ::Dill50   v;

                GetDill50(v);

                any  <<= v;
              }
              break;

    case  35: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Bayleaf50");
#endif
                ::Bayleaf50   v;

                GetBayleaf50(v);

                any  <<= v;
              }
              break;

    case  36: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Bayleaf50::WhiteCabbage50");
#endif
                ::Bayleaf50::WhiteCabbage50   v;

                GetBayleaf50WhiteCabbage50(v);

                any  <<= v;
              }
              break;

    case  37: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::WaterMelon51");
#endif
                ::WaterMelon51   v;

                GetWaterMelon51(v);

                any  <<= v;
              }
              break;

    case  38: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mango51");
#endif
                ::Mango51   v;

                GetMango51(v);

                any  <<= v;
              }
              break;

    case  39: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mango51::PassionFruit51");
#endif
                ::Mango51::PassionFruit51   v;

                GetMango51PassionFruit51(v);

                any  <<= v;
              }
              break;

    case  40: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Record51");
#endif
                ::Record51   v;

                GetRecord51(v);

                any  <<= v;
              }
              break;

    case  41: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Potato51");
#endif
                ::Potato51   v;

                GetPotato51(v);

                any  <<= v;
              }
              break;

    case  42: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Potato51::ChineseLeaves51");
#endif
                ::Potato51::ChineseLeaves51   v;

                GetPotato51ChineseLeaves51(v);

                any  <<= v;
              }
              break;

    case  43: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Blackberry52");
#endif
                ::Blackberry52   v;

                GetBlackberry52(v);

                any  <<= v;
              }
              break;

    case  44: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Blueberry52");
#endif
                ::Blueberry52   v;

                GetBlueberry52(v);

                any  <<= v;
              }
              break;

    case  45: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Blueberry52::Basil52");
#endif
                ::Blueberry52::Basil52   v;

                GetBlueberry52Basil52(v);

                any  <<= v;
              }
              break;

    case  46: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CookingApple53");
#endif
                ::CookingApple53   v;

                GetCookingApple53(v);

                any  <<= v;
              }
              break;

    case  47: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Rasin53");
#endif
                ::Rasin53   v;

                GetRasin53(v);

                any  <<= v;
              }
              break;

    case  48: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Rasin53::Artichokes53");
#endif
                ::Rasin53::Artichokes53   v;

                GetRasin53Artichokes53(v);

                any  <<= v;
              }
              break;

    case  49: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Rasin53::Artichokes53::Peanutsquash53");
#endif
                ::Rasin53::Artichokes53::Peanutsquash53   v;

                GetRasin53Artichokes53Peanutsquash53(v);

                any  <<= v;
              }
              break;

    case  50: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Susander54");
#endif
                ::Susander54   v;

                GetSusander54(v);

                any  <<= v;
              }
              break;

    case  51: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Peppercorn54");
#endif
                ::Peppercorn54   v;

                GetPeppercorn54(v);

                any  <<= v;
              }
              break;

    case  52: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Peppercorn54::Cherry54");
#endif
                ::Peppercorn54::Cherry54   v;

                GetPeppercorn54Cherry54(v);

                any  <<= v;
              }
              break;

    case  53: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Peppercorn54::Cherry54::Okra54");
#endif
                ::Peppercorn54::Cherry54::Okra54   v;

                GetPeppercorn54Cherry54Okra54(v);

                any  <<= v;
              }
              break;

    case  54: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::RedPepper55");
#endif
                ::RedPepper55   v;

                GetRedPepper55(v);

                any  <<= v;
              }
              break;

    case  55: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pear55");
#endif
                ::Pear55   v;

                GetPear55(v);

                any  <<= v;
              }
              break;

    case  56: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pear55::LimaBean55");
#endif
                ::Pear55::LimaBean55   v;

                GetPear55LimaBean55(v);

                any  <<= v;
              }
              break;

    case  57: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pear55::LimaBean55::Blackcurrant55");
#endif
                ::Pear55::LimaBean55::Blackcurrant55   v;

                GetPear55LimaBean55Blackcurrant55(v);

                any  <<= v;
              }
              break;

    case  58: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Waterchestnut56");
#endif
                ::Waterchestnut56   v;

                GetWaterchestnut56(v);

                any  <<= v;
              }
              break;

    case  59: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Uglifruit56");
#endif
                ::Uglifruit56   v;

                GetUglifruit56(v);

                any  <<= v;
              }
              break;

    case  60: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Uglifruit56::Walnuts56");
#endif
                ::Uglifruit56::Walnuts56   v;

                GetUglifruit56Walnuts56(v);

                any  <<= v;
              }
              break;

    case  61: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Uglifruit56::Walnuts56::Pomegranate56");
#endif
                ::Uglifruit56::Walnuts56::Pomegranate56   v;

                GetUglifruit56Walnuts56Pomegranate56(v);

                any  <<= v;
              }
              break;

    case  62: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Melon57");
#endif
                ::Melon57   v;

                GetMelon57(v);

                any  <<= v;
              }
              break;

    case  63: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cassava57");
#endif
                ::Cassava57   v;

                GetCassava57(v);

                any  <<= v;
              }
              break;

    case  64: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cassava57::Cress57");
#endif
                ::Cassava57::Cress57   v;

                GetCassava57Cress57(v);

                any  <<= v;
              }
              break;

    case  65: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cassava57::Cress57::Lettuce57");
#endif
                ::Cassava57::Cress57::Lettuce57   v;

                GetCassava57Cress57Lettuce57(v);

                any  <<= v;
              }
              break;

    case  66: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BreadFruit58");
#endif
                ::BreadFruit58   v;

                GetBreadFruit58(v);

                any  <<= v;
              }
              break;

    case  67: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Strawberry58");
#endif
                ::Strawberry58   v;

                GetStrawberry58(v);

                any  <<= v;
              }
              break;

    case  68: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Strawberry58::Daikan58");
#endif
                ::Strawberry58::Daikan58   v;

                GetStrawberry58Daikan58(v);

                any  <<= v;
              }
              break;

    case  69: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Strawberry58::Daikan58::Avocado58");
#endif
                ::Strawberry58::Daikan58::Avocado58   v;

                GetStrawberry58Daikan58Avocado58(v);

                any  <<= v;
              }
              break;

    case  70: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cinnamon59");
#endif
                ::Cinnamon59   v;

                GetCinnamon59(v);

                any  <<= v;
              }
              break;

    case  71: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::HazelNut59");
#endif
                ::HazelNut59   v;

                GetHazelNut59(v);

                any  <<= v;
              }
              break;

    case  72: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::HazelNut59::CrabApple59");
#endif
                ::HazelNut59::CrabApple59   v;

                GetHazelNut59CrabApple59(v);

                any  <<= v;
              }
              break;

    case  73: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::HazelNut59::CrabApple59::Lentil59");
#endif
                ::HazelNut59::CrabApple59::Lentil59   v;

                GetHazelNut59CrabApple59Lentil59(v);

                any  <<= v;
              }
              break;

    case  74: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::KidneyBean60");
#endif
                ::KidneyBean60   v;

                GetKidneyBean60(v);

                any  <<= v;
              }
              break;

    case  75: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Plum60");
#endif
                ::Plum60   v;

                GetPlum60(v);

                any  <<= v;
              }
              break;

    case  76: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Plum60::Onion60");
#endif
                ::Plum60::Onion60   v;

                GetPlum60Onion60(v);

                any  <<= v;
              }
              break;

    case  77: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Plum60::Onion60::Tofu60");
#endif
                ::Plum60::Onion60::Tofu60   v;

                GetPlum60Onion60Tofu60(v);

                any  <<= v;
              }
              break;

    case  78: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Billberries61");
#endif
                ::Billberries61   v;

                GetBillberries61(v);

                any  <<= v;
              }
              break;

    case  79: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Tangarine61");
#endif
                ::Tangarine61   v;

                GetTangarine61(v);

                any  <<= v;
              }
              break;

    case  80: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Tangarine61::BrazilNut61");
#endif
                ::Tangarine61::BrazilNut61   v;

                GetTangarine61BrazilNut61(v);

                any  <<= v;
              }
              break;

    case  81: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Tangarine61::BrazilNut61::Brocoli61");
#endif
                ::Tangarine61::BrazilNut61::Brocoli61   v;

                GetTangarine61BrazilNut61Brocoli61(v);

                any  <<= v;
              }
              break;

    case  82: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Guava62");
#endif
                ::Guava62   v;

                GetGuava62(v);

                any  <<= v;
              }
              break;

    case  83: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Almonds62");
#endif
                ::Almonds62   v;

                GetAlmonds62(v);

                any  <<= v;
              }
              break;

    case  84: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Almonds62::Oregano62");
#endif
                ::Almonds62::Oregano62   v;

                GetAlmonds62Oregano62(v);

                any  <<= v;
              }
              break;

    case  85: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Almonds62::Oregano62::Asparagus62");
#endif
                ::Almonds62::Oregano62::Asparagus62   v;

                GetAlmonds62Oregano62Asparagus62(v);

                any  <<= v;
              }
              break;

    case  86: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Celery63");
#endif
                ::Celery63   v;

                GetCelery63(v);

                any  <<= v;
              }
              break;

    case  87: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Parsnip63");
#endif
                ::Parsnip63   v;

                GetParsnip63(v);

                any  <<= v;
              }
              break;

    case  88: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Parsnip63::Orange63");
#endif
                ::Parsnip63::Orange63   v;

                GetParsnip63Orange63(v);

                any  <<= v;
              }
              break;

    case  89: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Parsnip63::Orange63::Sultana63");
#endif
                ::Parsnip63::Orange63::Sultana63   v;

                GetParsnip63Orange63Sultana63(v);

                any  <<= v;
              }
              break;

    case  90: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Leek64");
#endif
                ::Leek64   v;

                GetLeek64(v);

                any  <<= v;
              }
              break;

    case  91: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BlackEyedBeans64");
#endif
                ::BlackEyedBeans64   v;

                GetBlackEyedBeans64(v);

                any  <<= v;
              }
              break;

    case  92: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BlackEyedBeans64::Ginger64");
#endif
                ::BlackEyedBeans64::Ginger64   v;

                GetBlackEyedBeans64Ginger64(v);

                any  <<= v;
              }
              break;

    case  93: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BlackEyedBeans64::Ginger64::Starfruit64");
#endif
                ::BlackEyedBeans64::Ginger64::Starfruit64   v;

                GetBlackEyedBeans64Ginger64Starfruit64(v);

                any  <<= v;
              }
              break;

    case  94: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Dates65");
#endif
                ::Dates65   v;

                GetDates65(v);

                any  <<= v;
              }
              break;

    case  95: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lime65");
#endif
                ::Lime65   v;

                GetLime65(v);

                any  <<= v;
              }
              break;

    case  96: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lime65::Mango65");
#endif
                ::Lime65::Mango65   v;

                GetLime65Mango65(v);

                any  <<= v;
              }
              break;

    case  97: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lime65::Mango65::PassionFruit65");
#endif
                ::Lime65::Mango65::PassionFruit65   v;

                GetLime65Mango65PassionFruit65(v);

                any  <<= v;
              }
              break;

    case  98: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Carrots66");
#endif
                ::Carrots66   v;

                GetCarrots66(v);

                any  <<= v;
              }
              break;

    case  99: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Banana66");
#endif
                ::Banana66   v;

                GetBanana66(v);

                any  <<= v;
              }
              break;

    case  100: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Banana66::PentlandDell65");
#endif
                ::Banana66::PentlandDell65   v;

                GetBanana66PentlandDell65(v);

                any  <<= v;
              }
              break;

    case  101: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Banana66::PentlandDell65::Homeguard65");
#endif
                ::Banana66::PentlandDell65::Homeguard65   v;

                GetBanana66PentlandDell65Homeguard65(v);

                any  <<= v;
              }
              break;

  }
}


