//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::LoganBerry44*
idlServer_imp::LoganBerry44Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::LoganBerry44* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LoganBerry44Attr\n");
#endif
  
  ernie.seed("LoganBerry44AttrCall");
  
  ernie.seed("LoganBerry44AttrReturn"); 
  ReturnValue = new ::LoganBerry44;
  GetLoganBerry44(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LoganBerry44Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::LoganBerry44Attr(const ::LoganBerry44 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LoganBerry44Attr\n");
#endif
  
  ernie.seed("LoganBerry44AttrCall");
  AddName("_attr");
  if (!CheckLoganBerry44(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LoganBerry44AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LoganBerry44Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::LoganBerry44*
idlServer_imp::LoganBerry44Op(const ::LoganBerry44 &p1,::LoganBerry44_out p2,::LoganBerry44 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::LoganBerry44* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LoganBerry44Op\n");
#endif
  
  ernie.seed("LoganBerry44OpCall");
  AddName("p1");
  if (!CheckLoganBerry44(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckLoganBerry44(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LoganBerry44OpReturn"); 
  {
    ::idlServer::LoganBerry44Excpt ex;
    GetidlServerLoganBerry44Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::LoganBerry44;
  GetLoganBerry44(*ReturnValue);
  p2 = new ::LoganBerry44;
  GetLoganBerry44(*(p2.ptr()));
  GetLoganBerry44(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LoganBerry44Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Orange44*
idlServer_imp::Orange44Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Orange44* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Orange44Attr\n");
#endif
  
  ernie.seed("Orange44AttrCall");
  
  ernie.seed("Orange44AttrReturn"); 
  ReturnValue = new ::Orange44;
  GetOrange44(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Orange44Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Orange44Attr(const ::Orange44 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Orange44Attr\n");
#endif
  
  ernie.seed("Orange44AttrCall");
  AddName("_attr");
  if (!CheckOrange44(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Orange44AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Orange44Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Orange44*
idlServer_imp::Orange44Op(const ::Orange44 &p1,::Orange44_out p2,::Orange44 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Orange44* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Orange44Op\n");
#endif
  
  ernie.seed("Orange44OpCall");
  AddName("p1");
  if (!CheckOrange44(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckOrange44(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Orange44OpReturn"); 
  {
    ::idlServer::Orange44Excpt ex;
    GetidlServerOrange44Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Orange44;
  GetOrange44(*ReturnValue);
  p2 = new ::Orange44;
  GetOrange44(*(p2.ptr()));
  GetOrange44(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Orange44Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Orange44::Sultana44*
idlServer_imp::Sultana44Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Orange44::Sultana44* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sultana44Attr\n");
#endif
  
  ernie.seed("Sultana44AttrCall");
  
  ernie.seed("Sultana44AttrReturn"); 
  ReturnValue = new ::Orange44::Sultana44;
  GetOrange44Sultana44(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sultana44Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Sultana44Attr(const ::Orange44::Sultana44 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sultana44Attr\n");
#endif
  
  ernie.seed("Sultana44AttrCall");
  AddName("_attr");
  if (!CheckOrange44Sultana44(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sultana44AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sultana44Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Orange44::Sultana44*
idlServer_imp::Sultana44Op(const ::Orange44::Sultana44 &p1,::Orange44::Sultana44_out p2,::Orange44::Sultana44 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Orange44::Sultana44* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sultana44Op\n");
#endif
  
  ernie.seed("Sultana44OpCall");
  AddName("p1");
  if (!CheckOrange44Sultana44(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckOrange44Sultana44(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sultana44OpReturn"); 
  {
    ::idlServer::Sultana44Excpt ex;
    GetidlServerSultana44Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Orange44::Sultana44;
  GetOrange44Sultana44(*ReturnValue);
  p2 = new ::Orange44::Sultana44;
  GetOrange44Sultana44(*(p2.ptr()));
  GetOrange44Sultana44(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sultana44Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::BlackCherry45*
idlServer_imp::BlackCherry45Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::BlackCherry45* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BlackCherry45Attr\n");
#endif
  
  ernie.seed("BlackCherry45AttrCall");
  
  ernie.seed("BlackCherry45AttrReturn"); 
  ReturnValue = new ::BlackCherry45;
  GetBlackCherry45(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BlackCherry45Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BlackCherry45Attr(const ::BlackCherry45 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BlackCherry45Attr\n");
#endif
  
  ernie.seed("BlackCherry45AttrCall");
  AddName("_attr");
  if (!CheckBlackCherry45(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlackCherry45AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BlackCherry45Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::BlackCherry45*
idlServer_imp::BlackCherry45Op(const ::BlackCherry45 &p1,::BlackCherry45_out p2,::BlackCherry45 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::BlackCherry45* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BlackCherry45Op\n");
#endif
  
  ernie.seed("BlackCherry45OpCall");
  AddName("p1");
  if (!CheckBlackCherry45(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBlackCherry45(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlackCherry45OpReturn"); 
  {
    ::idlServer::BlackCherry45Excpt ex;
    GetidlServerBlackCherry45Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::BlackCherry45;
  GetBlackCherry45(*ReturnValue);
  p2 = new ::BlackCherry45;
  GetBlackCherry45(*(p2.ptr()));
  GetBlackCherry45(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BlackCherry45Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Lemon45*
idlServer_imp::Lemon45Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Lemon45* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lemon45Attr\n");
#endif
  
  ernie.seed("Lemon45AttrCall");
  
  ernie.seed("Lemon45AttrReturn"); 
  ReturnValue = new ::Lemon45;
  GetLemon45(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lemon45Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Lemon45Attr(const ::Lemon45 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lemon45Attr\n");
#endif
  
  ernie.seed("Lemon45AttrCall");
  AddName("_attr");
  if (!CheckLemon45(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lemon45AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lemon45Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Lemon45*
idlServer_imp::Lemon45Op(const ::Lemon45 &p1,::Lemon45_out p2,::Lemon45 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Lemon45* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lemon45Op\n");
#endif
  
  ernie.seed("Lemon45OpCall");
  AddName("p1");
  if (!CheckLemon45(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckLemon45(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lemon45OpReturn"); 
  {
    ::idlServer::Lemon45Excpt ex;
    GetidlServerLemon45Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Lemon45;
  GetLemon45(*ReturnValue);
  p2 = new ::Lemon45;
  GetLemon45(*(p2.ptr()));
  GetLemon45(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lemon45Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Lemon45::Banana45*
idlServer_imp::Banana45Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Lemon45::Banana45* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Banana45Attr\n");
#endif
  
  ernie.seed("Banana45AttrCall");
  
  ernie.seed("Banana45AttrReturn"); 
  ReturnValue = new ::Lemon45::Banana45;
  GetLemon45Banana45(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Banana45Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Banana45Attr(const ::Lemon45::Banana45 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Banana45Attr\n");
#endif
  
  ernie.seed("Banana45AttrCall");
  AddName("_attr");
  if (!CheckLemon45Banana45(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Banana45AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Banana45Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Lemon45::Banana45*
idlServer_imp::Banana45Op(const ::Lemon45::Banana45 &p1,::Lemon45::Banana45_out p2,::Lemon45::Banana45 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Lemon45::Banana45* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Banana45Op\n");
#endif
  
  ernie.seed("Banana45OpCall");
  AddName("p1");
  if (!CheckLemon45Banana45(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckLemon45Banana45(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Banana45OpReturn"); 
  {
    ::idlServer::Banana45Excpt ex;
    GetidlServerBanana45Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Lemon45::Banana45;
  GetLemon45Banana45(*ReturnValue);
  p2 = new ::Lemon45::Banana45;
  GetLemon45Banana45(*(p2.ptr()));
  GetLemon45Banana45(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Banana45Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Corriander45*
idlServer_imp::Corriander45Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Corriander45* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Corriander45Attr\n");
#endif
  
  ernie.seed("Corriander45AttrCall");
  
  ernie.seed("Corriander45AttrReturn"); 
  ReturnValue = new ::Corriander45;
  GetCorriander45(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Corriander45Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Corriander45Attr(const ::Corriander45 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Corriander45Attr\n");
#endif
  
  ernie.seed("Corriander45AttrCall");
  AddName("_attr");
  if (!CheckCorriander45(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Corriander45AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Corriander45Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Corriander45*
idlServer_imp::Corriander45Op(const ::Corriander45 &p1,::Corriander45_out p2,::Corriander45 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Corriander45* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Corriander45Op\n");
#endif
  
  ernie.seed("Corriander45OpCall");
  AddName("p1");
  if (!CheckCorriander45(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCorriander45(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Corriander45OpReturn"); 
  {
    ::idlServer::Corriander45Excpt ex;
    GetidlServerCorriander45Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Corriander45;
  GetCorriander45(*ReturnValue);
  p2 = new ::Corriander45;
  GetCorriander45(*(p2.ptr()));
  GetCorriander45(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Corriander45Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Kiwi45*
idlServer_imp::Kiwi45Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Kiwi45* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Kiwi45Attr\n");
#endif
  
  ernie.seed("Kiwi45AttrCall");
  
  ernie.seed("Kiwi45AttrReturn"); 
  ReturnValue = new ::Kiwi45;
  GetKiwi45(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Kiwi45Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Kiwi45Attr(const ::Kiwi45 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Kiwi45Attr\n");
#endif
  
  ernie.seed("Kiwi45AttrCall");
  AddName("_attr");
  if (!CheckKiwi45(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Kiwi45AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Kiwi45Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Kiwi45*
idlServer_imp::Kiwi45Op(const ::Kiwi45 &p1,::Kiwi45_out p2,::Kiwi45 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Kiwi45* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Kiwi45Op\n");
#endif
  
  ernie.seed("Kiwi45OpCall");
  AddName("p1");
  if (!CheckKiwi45(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckKiwi45(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Kiwi45OpReturn"); 
  {
    ::idlServer::Kiwi45Excpt ex;
    GetidlServerKiwi45Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Kiwi45;
  GetKiwi45(*ReturnValue);
  p2 = new ::Kiwi45;
  GetKiwi45(*(p2.ptr()));
  GetKiwi45(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Kiwi45Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Kiwi45::GalaApple45*
idlServer_imp::GalaApple45Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Kiwi45::GalaApple45* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GalaApple45Attr\n");
#endif
  
  ernie.seed("GalaApple45AttrCall");
  
  ernie.seed("GalaApple45AttrReturn"); 
  ReturnValue = new ::Kiwi45::GalaApple45;
  GetKiwi45GalaApple45(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GalaApple45Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::GalaApple45Attr(const ::Kiwi45::GalaApple45 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GalaApple45Attr\n");
#endif
  
  ernie.seed("GalaApple45AttrCall");
  AddName("_attr");
  if (!CheckKiwi45GalaApple45(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GalaApple45AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GalaApple45Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Kiwi45::GalaApple45*
idlServer_imp::GalaApple45Op(const ::Kiwi45::GalaApple45 &p1,::Kiwi45::GalaApple45_out p2,::Kiwi45::GalaApple45 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Kiwi45::GalaApple45* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GalaApple45Op\n");
#endif
  
  ernie.seed("GalaApple45OpCall");
  AddName("p1");
  if (!CheckKiwi45GalaApple45(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckKiwi45GalaApple45(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GalaApple45OpReturn"); 
  {
    ::idlServer::GalaApple45Excpt ex;
    GetidlServerGalaApple45Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Kiwi45::GalaApple45;
  GetKiwi45GalaApple45(*ReturnValue);
  p2 = new ::Kiwi45::GalaApple45;
  GetKiwi45GalaApple45(*(p2.ptr()));
  GetKiwi45GalaApple45(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GalaApple45Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::YellowPepper46*
idlServer_imp::YellowPepper46Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::YellowPepper46* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::YellowPepper46Attr\n");
#endif
  
  ernie.seed("YellowPepper46AttrCall");
  
  ernie.seed("YellowPepper46AttrReturn"); 
  ReturnValue = new ::YellowPepper46;
  GetYellowPepper46(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::YellowPepper46Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::YellowPepper46Attr(const ::YellowPepper46 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::YellowPepper46Attr\n");
#endif
  
  ernie.seed("YellowPepper46AttrCall");
  AddName("_attr");
  if (!CheckYellowPepper46(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("YellowPepper46AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::YellowPepper46Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::YellowPepper46*
idlServer_imp::YellowPepper46Op(const ::YellowPepper46 &p1,::YellowPepper46_out p2,::YellowPepper46 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::YellowPepper46* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::YellowPepper46Op\n");
#endif
  
  ernie.seed("YellowPepper46OpCall");
  AddName("p1");
  if (!CheckYellowPepper46(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckYellowPepper46(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("YellowPepper46OpReturn"); 
  {
    ::idlServer::YellowPepper46Excpt ex;
    GetidlServerYellowPepper46Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::YellowPepper46;
  GetYellowPepper46(*ReturnValue);
  p2 = new ::YellowPepper46;
  GetYellowPepper46(*(p2.ptr()));
  GetYellowPepper46(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::YellowPepper46Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Parsley46*
idlServer_imp::Parsley46Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Parsley46* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Parsley46Attr\n");
#endif
  
  ernie.seed("Parsley46AttrCall");
  
  ernie.seed("Parsley46AttrReturn"); 
  ReturnValue = new ::Parsley46;
  GetParsley46(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Parsley46Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Parsley46Attr(const ::Parsley46 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Parsley46Attr\n");
#endif
  
  ernie.seed("Parsley46AttrCall");
  AddName("_attr");
  if (!CheckParsley46(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Parsley46AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Parsley46Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Parsley46*
idlServer_imp::Parsley46Op(const ::Parsley46 &p1,::Parsley46_out p2,::Parsley46 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Parsley46* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Parsley46Op\n");
#endif
  
  ernie.seed("Parsley46OpCall");
  AddName("p1");
  if (!CheckParsley46(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckParsley46(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Parsley46OpReturn"); 
  {
    ::idlServer::Parsley46Excpt ex;
    GetidlServerParsley46Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Parsley46;
  GetParsley46(*ReturnValue);
  p2 = new ::Parsley46;
  GetParsley46(*(p2.ptr()));
  GetParsley46(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Parsley46Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Parsley46::Peach46*
idlServer_imp::Peach46Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Parsley46::Peach46* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Peach46Attr\n");
#endif
  
  ernie.seed("Peach46AttrCall");
  
  ernie.seed("Peach46AttrReturn"); 
  ReturnValue = new ::Parsley46::Peach46;
  GetParsley46Peach46(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Peach46Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Peach46Attr(const ::Parsley46::Peach46 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Peach46Attr\n");
#endif
  
  ernie.seed("Peach46AttrCall");
  AddName("_attr");
  if (!CheckParsley46Peach46(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Peach46AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Peach46Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Parsley46::Peach46*
idlServer_imp::Peach46Op(const ::Parsley46::Peach46 &p1,::Parsley46::Peach46_out p2,::Parsley46::Peach46 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Parsley46::Peach46* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Peach46Op\n");
#endif
  
  ernie.seed("Peach46OpCall");
  AddName("p1");
  if (!CheckParsley46Peach46(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckParsley46Peach46(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Peach46OpReturn"); 
  {
    ::idlServer::Peach46Excpt ex;
    GetidlServerPeach46Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Parsley46::Peach46;
  GetParsley46Peach46(*ReturnValue);
  p2 = new ::Parsley46::Peach46;
  GetParsley46Peach46(*(p2.ptr()));
  GetParsley46Peach46(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Peach46Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Radish47*
idlServer_imp::Radish47Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Radish47* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Radish47Attr\n");
#endif
  
  ernie.seed("Radish47AttrCall");
  
  ernie.seed("Radish47AttrReturn"); 
  ReturnValue = new ::Radish47;
  GetRadish47(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Radish47Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Radish47Attr(const ::Radish47 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Radish47Attr\n");
#endif
  
  ernie.seed("Radish47AttrCall");
  AddName("_attr");
  if (!CheckRadish47(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Radish47AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Radish47Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Radish47*
idlServer_imp::Radish47Op(const ::Radish47 &p1,::Radish47_out p2,::Radish47 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Radish47* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Radish47Op\n");
#endif
  
  ernie.seed("Radish47OpCall");
  AddName("p1");
  if (!CheckRadish47(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckRadish47(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Radish47OpReturn"); 
  {
    ::idlServer::Radish47Excpt ex;
    GetidlServerRadish47Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Radish47;
  GetRadish47(*ReturnValue);
  p2 = new ::Radish47;
  GetRadish47(*(p2.ptr()));
  GetRadish47(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Radish47Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Sharanfruit47*
idlServer_imp::Sharanfruit47Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Sharanfruit47* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sharanfruit47Attr\n");
#endif
  
  ernie.seed("Sharanfruit47AttrCall");
  
  ernie.seed("Sharanfruit47AttrReturn"); 
  ReturnValue = new ::Sharanfruit47;
  GetSharanfruit47(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sharanfruit47Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Sharanfruit47Attr(const ::Sharanfruit47 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sharanfruit47Attr\n");
#endif
  
  ernie.seed("Sharanfruit47AttrCall");
  AddName("_attr");
  if (!CheckSharanfruit47(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sharanfruit47AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sharanfruit47Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Sharanfruit47*
idlServer_imp::Sharanfruit47Op(const ::Sharanfruit47 &p1,::Sharanfruit47_out p2,::Sharanfruit47 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Sharanfruit47* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sharanfruit47Op\n");
#endif
  
  ernie.seed("Sharanfruit47OpCall");
  AddName("p1");
  if (!CheckSharanfruit47(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckSharanfruit47(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sharanfruit47OpReturn"); 
  {
    ::idlServer::Sharanfruit47Excpt ex;
    GetidlServerSharanfruit47Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Sharanfruit47;
  GetSharanfruit47(*ReturnValue);
  p2 = new ::Sharanfruit47;
  GetSharanfruit47(*(p2.ptr()));
  GetSharanfruit47(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sharanfruit47Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Sharanfruit47::BeefTomatoes47*
idlServer_imp::BeefTomatoes47Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Sharanfruit47::BeefTomatoes47* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BeefTomatoes47Attr\n");
#endif
  
  ernie.seed("BeefTomatoes47AttrCall");
  
  ernie.seed("BeefTomatoes47AttrReturn"); 
  ReturnValue = new ::Sharanfruit47::BeefTomatoes47;
  GetSharanfruit47BeefTomatoes47(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BeefTomatoes47Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BeefTomatoes47Attr(const ::Sharanfruit47::BeefTomatoes47 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BeefTomatoes47Attr\n");
#endif
  
  ernie.seed("BeefTomatoes47AttrCall");
  AddName("_attr");
  if (!CheckSharanfruit47BeefTomatoes47(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BeefTomatoes47AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BeefTomatoes47Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Sharanfruit47::BeefTomatoes47*
idlServer_imp::BeefTomatoes47Op(const ::Sharanfruit47::BeefTomatoes47 &p1,::Sharanfruit47::BeefTomatoes47_out p2,::Sharanfruit47::BeefTomatoes47 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Sharanfruit47::BeefTomatoes47* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BeefTomatoes47Op\n");
#endif
  
  ernie.seed("BeefTomatoes47OpCall");
  AddName("p1");
  if (!CheckSharanfruit47BeefTomatoes47(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckSharanfruit47BeefTomatoes47(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BeefTomatoes47OpReturn"); 
  {
    ::idlServer::BeefTomatoes47Excpt ex;
    GetidlServerBeefTomatoes47Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Sharanfruit47::BeefTomatoes47;
  GetSharanfruit47BeefTomatoes47(*ReturnValue);
  p2 = new ::Sharanfruit47::BeefTomatoes47;
  GetSharanfruit47BeefTomatoes47(*(p2.ptr()));
  GetSharanfruit47BeefTomatoes47(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BeefTomatoes47Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::BambooShoot48*
idlServer_imp::BambooShoot48Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::BambooShoot48* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BambooShoot48Attr\n");
#endif
  
  ernie.seed("BambooShoot48AttrCall");
  
  ernie.seed("BambooShoot48AttrReturn"); 
  ReturnValue = new ::BambooShoot48;
  GetBambooShoot48(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BambooShoot48Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BambooShoot48Attr(const ::BambooShoot48 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BambooShoot48Attr\n");
#endif
  
  ernie.seed("BambooShoot48AttrCall");
  AddName("_attr");
  if (!CheckBambooShoot48(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BambooShoot48AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BambooShoot48Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::BambooShoot48*
idlServer_imp::BambooShoot48Op(const ::BambooShoot48 &p1,::BambooShoot48_out p2,::BambooShoot48 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::BambooShoot48* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BambooShoot48Op\n");
#endif
  
  ernie.seed("BambooShoot48OpCall");
  AddName("p1");
  if (!CheckBambooShoot48(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBambooShoot48(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BambooShoot48OpReturn"); 
  {
    ::idlServer::BambooShoot48Excpt ex;
    GetidlServerBambooShoot48Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::BambooShoot48;
  GetBambooShoot48(*ReturnValue);
  p2 = new ::BambooShoot48;
  GetBambooShoot48(*(p2.ptr()));
  GetBambooShoot48(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BambooShoot48Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



