//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/checkany.cpp
//
// Modifications:
// $Log: checkany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:36  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/26 13:51:36  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/12 09:00:25  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern char name[];

 
int CheckAny(const CORBA::Any &any)
{
  switch(ernie.getULong()%(12+100))
  {
    case   0: {
                CORBA::ULong  v;
#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::ULong");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::ULong as expected", name);
                  return 0;
                }
                if (!ernie.checkULong(v))
                {
                  tet_printf("Expected %s to contain CORBA::ULong with value %u, but found %u instead.",
                    name,ernie.getULongAgain(),v);
                  return 0;
                }
              }
              break;
    case   1: {
                CORBA::Long  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Long");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Long as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkLong(v))
                {
                  tet_printf("Expected %s to contain CORBA::Long with value %d, but found %d instead.",
                    name,ernie.getLongAgain(),v);
                  return 0;
                }
              }
              break;
    case   2: {
                CORBA::UShort  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::UShort");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::UShort as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkUShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::UShort with value %u, but found %u instead.",
                    name,ernie.getUShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   3: {
                CORBA::Short  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Short");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Short as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::Short with value %d, but found %d instead.",
                    name,ernie.getShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   4: {
                CORBA::Boolean  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Boolean");
#endif
                if (!(any >>= CORBA::Any::to_boolean(v)))
                {
                  tet_printf("%s did not contain a CORBA::Boolean as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkBoolean(v))
                {
                  tet_printf("Expected %s to contain CORBA::Boolean with value %s, but found %s instead.",
                    name,
                    BooleanToString(ernie.getBooleanAgain()),
                    BooleanToString(v));
                  return 0;
                }
              }
              break;
    case   5: {
                CORBA::Octet  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Octet");
#endif
                if (!(any >>= CORBA::Any::to_octet(v)))
                {
                  tet_printf("%s did not contain a CORBA::Octet as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkOctet(v))
                {
                  ::tet_printf("Expected %s to contain CORBA::Octet with value %s, but found %s instead.",
                    name,
                    OctetToString(ernie.getOctetAgain()),
                    OctetToString(v));
                  return 0;
                }
              }
              break;
    case   6: {
                CORBA::Char  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Char");
#endif
                if (!(any >>= CORBA::Any::to_char(v)))
                {
                  tet_printf("%s did not contain a CORBA::Char as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkChar(v))
                {
                  tet_printf("Expected %s to contain CORBA::Char with value %s, but found %s instead.",
                    name,
                    CharToString(ernie.getCharAgain()),
                    CharToString(v));
                  return 0;
                }
              }
              break;
    case   7: {
                CORBA::Float  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Float");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Float as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkFloat(v))
                {
                  tet_printf("Expected %s to contain CORBA::Float with value %g, but found %g instead.",
                    name,
                    ernie.getFloatAgain(),
                    v);
                  return 0;
                }
              }
               break;
    case   8: {
                CORBA::Double  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Double");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Double as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkDouble(v))
                {
                  tet_printf("Expected %s to contain CORBA::Double with value %g, but found %g instead.",
                    name,
                    ernie.getDoubleAgain(),
                    v);
                  return 0;
                }
              }
              break;
    case   9: {
                char *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting char*");
#endif
                if (!(any >>= CORBA::Any::to_string(v,0)))
                {
                  tet_printf("%s did not contain a char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v))
                {
                  tet_printf("Expected %s to contain char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case  10: {
                CORBA::ULong  b;
                char   *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting bounded char*");
#endif
                b = ernie.getULong()%30+1;

                if (!(any >>= CORBA::Any::to_string(v,b)))
                {
                  tet_printf("%s did not contain a bounded char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v,b))
                {
                  tet_printf("Expected %s to contain a bounded char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::TypeCode");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::TypeCode as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCORBATypeCode_ptr(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case   12: {
                CORBA::Any  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Any");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Any as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAny(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  13: {
                ::Cultra66 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cultra66\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cultra66 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCultra66(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  14: {
                ::Pimpernel66 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Pimpernel66\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Pimpernel66 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPimpernel66(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  15: {
                ::Pimpernel66::KerrsPinks66 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Pimpernel66::KerrsPinks66\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Pimpernel66::KerrsPinks66 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPimpernel66KerrsPinks66(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  16: {
                ::Pimpernel66::KerrsPinks66::Wilja66 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Pimpernel66::KerrsPinks66::Wilja66\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Pimpernel66::KerrsPinks66::Wilja66 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPimpernel66KerrsPinks66Wilja66(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  17: {
                ::Broadbeans67 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Broadbeans67\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Broadbeans67 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBroadbeans67(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  18: {
                ::ChineseLeaves67 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::ChineseLeaves67\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::ChineseLeaves67 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckChineseLeaves67(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  19: {
                ::ChineseLeaves67::Clementine67 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::ChineseLeaves67::Clementine67\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::ChineseLeaves67::Clementine67 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckChineseLeaves67Clementine67(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  20: {
                ::ChineseLeaves67::Clementine67::Chestnut67 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::ChineseLeaves67::Clementine67::Chestnut67\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::ChineseLeaves67::Clementine67::Chestnut67 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckChineseLeaves67Clementine67Chestnut67(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  21: {
                ::Celeriac68 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Celeriac68\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Celeriac68 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCeleriac68(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  22: {
                ::RedChilly68 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::RedChilly68\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::RedChilly68 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRedChilly68(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  23: {
                ::RedChilly68::Chayato68 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::RedChilly68::Chayato68\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::RedChilly68::Chayato68 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRedChilly68Chayato68(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  24: {
                ::RedChilly68::Chayato68::KiwanoMelon68 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::RedChilly68::Chayato68::KiwanoMelon68\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::RedChilly68::Chayato68::KiwanoMelon68 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRedChilly68Chayato68KiwanoMelon68(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  25: {
                ::Scallion69 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Scallion69\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Scallion69 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckScallion69(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  26: {
                ::VineTomatoes69 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::VineTomatoes69\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::VineTomatoes69 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckVineTomatoes69(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  27: {
                ::VineTomatoes69::Chervil69 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::VineTomatoes69::Chervil69\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::VineTomatoes69::Chervil69 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckVineTomatoes69Chervil69(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  28: {
                ::VineTomatoes69::Chervil69::GreenChilly69 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::VineTomatoes69::Chervil69::GreenChilly69\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::VineTomatoes69::Chervil69::GreenChilly69 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckVineTomatoes69Chervil69GreenChilly69(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  29: {
                ::Peanuts70 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Peanuts70\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Peanuts70 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPeanuts70(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  30: {
                ::Satsuma70 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Satsuma70\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Satsuma70 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSatsuma70(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  31: {
                ::Satsuma70::Parsley70 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Satsuma70::Parsley70\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Satsuma70::Parsley70 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSatsuma70Parsley70(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  32: {
                ::Satsuma70::Parsley70::Peach70 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Satsuma70::Parsley70::Peach70\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Satsuma70::Parsley70::Peach70 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSatsuma70Parsley70Peach70(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  33: {
                ::Mullberry71 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mullberry71\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mullberry71 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMullberry71(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  34: {
                ::Chives71 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Chives71\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Chives71 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckChives71(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  35: {
                ::Chives71::Rasin71 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Chives71::Rasin71\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Chives71::Rasin71 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckChives71Rasin71(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  36: {
                ::Chives71::Rasin71::Cherry71 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Chives71::Rasin71::Cherry71\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Chives71::Rasin71::Cherry71 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckChives71Rasin71Cherry71(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  37: {
                ::Damsons72 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Damsons72\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Damsons72 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckDamsons72(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  38: {
                ::PepinoMelon72 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::PepinoMelon72\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::PepinoMelon72 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPepinoMelon72(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  39: {
                ::PepinoMelon72::Raspberry72 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::PepinoMelon72::Raspberry72\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::PepinoMelon72::Raspberry72 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPepinoMelon72Raspberry72(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  40: {
                ::PepinoMelon72::Raspberry72::Peppercorn72 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::PepinoMelon72::Raspberry72::Peppercorn72\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::PepinoMelon72::Raspberry72::Peppercorn72 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPepinoMelon72Raspberry72Peppercorn72(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  41: {
                ::FrenchBeans73 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::FrenchBeans73\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::FrenchBeans73 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckFrenchBeans73(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  42: {
                ::BeefTomatoes73 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BeefTomatoes73\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BeefTomatoes73 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBeefTomatoes73(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  43: {
                ::BeefTomatoes73::Pear73 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BeefTomatoes73::Pear73\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BeefTomatoes73::Pear73 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBeefTomatoes73Pear73(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  44: {
                ::BeefTomatoes73::Pear73::Walnuts73 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BeefTomatoes73::Pear73::Walnuts73\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BeefTomatoes73::Pear73::Walnuts73 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBeefTomatoes73Pear73Walnuts73(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  45: {
                ::Plantain74 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Plantain74\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Plantain74 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPlantain74(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  46: {
                ::Okra74 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Okra74\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Okra74 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOkra74(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  47: {
                ::Okra74::Chickpea74 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Okra74::Chickpea74\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Okra74::Chickpea74 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOkra74Chickpea74(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  48: {
                ::Okra74::Chickpea74::Uglifruit74 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Okra74::Chickpea74::Uglifruit74\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Okra74::Chickpea74::Uglifruit74 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOkra74Chickpea74Uglifruit74(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  49: {
                ::BeechNut75 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BeechNut75\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BeechNut75 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBeechNut75(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  50: {
                ::RedGrapes75 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::RedGrapes75\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::RedGrapes75 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRedGrapes75(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  51: {
                ::RedGrapes75::Cassava75 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::RedGrapes75::Cassava75\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::RedGrapes75::Cassava75 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRedGrapes75Cassava75(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  52: {
                ::RedGrapes75::Cassava75::Daikan75 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::RedGrapes75::Cassava75::Daikan75\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::RedGrapes75::Cassava75::Daikan75 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRedGrapes75Cassava75Daikan75(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  53: {
                ::Tarragon76 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Tarragon76\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Tarragon76 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckTarragon76(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  54: {
                ::Pomegranate76 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Pomegranate76\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Pomegranate76 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPomegranate76(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  55: {
                ::Pomegranate76::Thyme76 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Pomegranate76::Thyme76\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Pomegranate76::Thyme76 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPomegranate76Thyme76(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  56: {
                ::Pomegranate76::Thyme76::Strawberry76 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Pomegranate76::Thyme76::Strawberry76\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Pomegranate76::Thyme76::Strawberry76 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPomegranate76Thyme76Strawberry76(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  57: {
                ::EggPlant77 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::EggPlant77\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::EggPlant77 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckEggPlant77(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  58: {
                ::GooseBerry77 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GooseBerry77\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GooseBerry77 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGooseBerry77(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  59: {
                ::GooseBerry77::HazelNut77 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GooseBerry77::HazelNut77\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GooseBerry77::HazelNut77 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGooseBerry77HazelNut77(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  60: {
                ::GooseBerry77::HazelNut77::Onion77 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GooseBerry77::HazelNut77::Onion77\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GooseBerry77::HazelNut77::Onion77 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGooseBerry77HazelNut77Onion77(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  61: {
                ::GoldenDelicous78 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GoldenDelicous78\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GoldenDelicous78 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGoldenDelicous78(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  62: {
                ::Avocado78 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Avocado78\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Avocado78 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAvocado78(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  63: {
                ::Avocado78::Zucchini78 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Avocado78::Zucchini78\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Avocado78::Zucchini78 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAvocado78Zucchini78(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  64: {
                ::Avocado78::Zucchini78::Plum78 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Avocado78::Zucchini78::Plum78\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Avocado78::Zucchini78::Plum78 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAvocado78Zucchini78Plum78(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  65: {
                ::LolloRossa79 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::LolloRossa79\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::LolloRossa79 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLolloRossa79(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  66: {
                ::CantelopeMelon79 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CantelopeMelon79\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CantelopeMelon79 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCantelopeMelon79(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  67: {
                ::CantelopeMelon79::Tangarine79 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CantelopeMelon79::Tangarine79\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CantelopeMelon79::Tangarine79 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCantelopeMelon79Tangarine79(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  68: {
                ::CantelopeMelon79::Tangarine79::Oregano79 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CantelopeMelon79::Tangarine79::Oregano79\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CantelopeMelon79::Tangarine79::Oregano79 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCantelopeMelon79Tangarine79Oregano79(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  69: {
                ::Prunes80 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Prunes80\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Prunes80 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPrunes80(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  70: {
                ::Tofu80 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Tofu80\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Tofu80 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckTofu80(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  71: {
                ::Tofu80::Mushroom80 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Tofu80::Mushroom80\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Tofu80::Mushroom80 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckTofu80Mushroom80(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  72: {
                ::Tofu80::Mushroom80::Almonds80 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Tofu80::Mushroom80::Almonds80\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Tofu80::Mushroom80::Almonds80 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckTofu80Mushroom80Almonds80(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  73: {
                ::Aniseed81 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Aniseed81\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Aniseed81 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAniseed81(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  74: {
                ::WhiteCabbage81 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::WhiteCabbage81\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::WhiteCabbage81 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckWhiteCabbage81(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  75: {
                ::WhiteCabbage81::Parsnip81 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::WhiteCabbage81::Parsnip81\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::WhiteCabbage81::Parsnip81 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckWhiteCabbage81Parsnip81(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  76: {
                ::WhiteCabbage81::Parsnip81::Ginger81 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::WhiteCabbage81::Parsnip81::Ginger81\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::WhiteCabbage81::Parsnip81::Ginger81 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckWhiteCabbage81Parsnip81Ginger81(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  77: {
                ::GaliaMelon82 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GaliaMelon82\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GaliaMelon82 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGaliaMelon82(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  78: {
                ::Asparagus82 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Asparagus82\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Asparagus82 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAsparagus82(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  79: {
                ::Asparagus82::Mint82 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Asparagus82::Mint82\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Asparagus82::Mint82 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAsparagus82Mint82(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  80: {
                ::Asparagus82::Mint82::BlackEyedBeans82 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Asparagus82::Mint82::BlackEyedBeans82\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Asparagus82::Mint82::BlackEyedBeans82 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAsparagus82Mint82BlackEyedBeans82(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  81: {
                ::Lychees83 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lychees83\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lychees83 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLychees83(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  82: {
                ::Coconut83 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Coconut83\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Coconut83 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCoconut83(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  83: {
                ::Coconut83::Lime83 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Coconut83::Lime83\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Coconut83::Lime83 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCoconut83Lime83(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  84: {
                ::Coconut83::Lime83::PentlandDell82 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Coconut83::Lime83::PentlandDell82\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Coconut83::Lime83::PentlandDell82 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCoconut83Lime83PentlandDell82(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  85: {
                ::Rhubarb84 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Rhubarb84\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Rhubarb84 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRhubarb84(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  86: {
                ::Starfruit84 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Starfruit84\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Starfruit84 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckStarfruit84(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  87: {
                ::Starfruit84::Lemon84 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Starfruit84::Lemon84\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Starfruit84::Lemon84 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckStarfruit84Lemon84(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  88: {
                ::Starfruit84::Lemon84::Banana84 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Starfruit84::Lemon84::Banana84\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Starfruit84::Lemon84::Banana84 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckStarfruit84Lemon84Banana84(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  89: {
                ::MarisPiper84 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::MarisPiper84\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::MarisPiper84 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMarisPiper84(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  90: {
                ::Rooster84 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Rooster84\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Rooster84 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRooster84(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  91: {
                ::Rooster84::Pimpernel84 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Rooster84::Pimpernel84\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Rooster84::Pimpernel84 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRooster84Pimpernel84(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  92: {
                ::Rooster84::Pimpernel84::Clementine84 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Rooster84::Pimpernel84::Clementine84\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Rooster84::Pimpernel84::Clementine84 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRooster84Pimpernel84Clementine84(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  93: {
                ::BritishQueens85 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BritishQueens85\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BritishQueens85 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBritishQueens85(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  94: {
                ::Homeguard85 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Homeguard85\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Homeguard85 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckHomeguard85(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  95: {
                ::Homeguard85::Potato85 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Homeguard85::Potato85\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Homeguard85::Potato85 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckHomeguard85Potato85(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  96: {
                ::Homeguard85::Potato85::ChineseLeaves85 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Homeguard85::Potato85::ChineseLeaves85\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Homeguard85::Potato85::ChineseLeaves85 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckHomeguard85Potato85ChineseLeaves85(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  97: {
                ::Cauliflower86 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cauliflower86\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cauliflower86 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCauliflower86(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  98: {
                ::GalaApple86 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GalaApple86\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GalaApple86 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGalaApple86(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  99: {
                ::GalaApple86::RedChilly86 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GalaApple86::RedChilly86\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GalaApple86::RedChilly86 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGalaApple86RedChilly86(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  100: {
                ::GalaApple86::RedChilly86::Chervil86 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GalaApple86::RedChilly86::Chervil86\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GalaApple86::RedChilly86::Chervil86 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGalaApple86RedChilly86Chervil86(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  101: {
                ::IcebergLettuce87 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::IcebergLettuce87\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::IcebergLettuce87 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckIcebergLettuce87(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  102: {
                ::Chestnut87 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Chestnut87\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Chestnut87 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckChestnut87(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  103: {
                ::Chestnut87::PricklyPear87 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Chestnut87::PricklyPear87\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Chestnut87::PricklyPear87 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckChestnut87PricklyPear87(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  104: {
                ::Chestnut87::PricklyPear87::VineTomatoes87 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Chestnut87::PricklyPear87::VineTomatoes87\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Chestnut87::PricklyPear87::VineTomatoes87 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckChestnut87PricklyPear87VineTomatoes87(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  105: {
                ::CoxPippin88 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CoxPippin88\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CoxPippin88 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCoxPippin88(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  106: {
                ::Basil88 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Basil88\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Basil88 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBasil88(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  107: {
                ::Basil88::Satsuma88 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Basil88::Satsuma88\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Basil88::Satsuma88 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBasil88Satsuma88(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  108: {
                ::Basil88::Satsuma88::Rasin88 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Basil88::Satsuma88::Rasin88\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Basil88::Satsuma88::Rasin88 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBasil88Satsuma88Rasin88(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  109: {
                ::Corn89 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Corn89\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Corn89 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCorn89(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  110: {
                ::GreenChilly89 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GreenChilly89\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GreenChilly89 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGreenChilly89(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  111: {
                ::GreenChilly89::Eddo89 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GreenChilly89::Eddo89\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GreenChilly89::Eddo89 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGreenChilly89Eddo89(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  112: {
                ::GreenChilly89::Eddo89::Chives89 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GreenChilly89::Eddo89::Chives89\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GreenChilly89::Eddo89::Chives89 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGreenChilly89Eddo89Chives89(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;

  }
  return 1;
}




