//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/getany.cpp
//
// Modifications:
// $Log: getany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:36  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1997/12/12 09:00:26  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"

//Header files generated by idl compiler
#include "tin.hh"

#include "types.hh"
extern Ernie ernie;


void GetAny(CORBA::Any &any)
{
  switch(ernie.getULong()%(12+100))
  {
    case   0: any <<= ernie.getULong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating ULong");
#endif
              break;
    case   1: any <<= ernie.getLong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Long");
#endif
              break;
    case   2: any <<= ernie.getUShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating UShort");
#endif
              break;
    case   3: any <<= ernie.getShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Short");
#endif
              break;
    case   4: any <<= CORBA::Any::from_boolean(ernie.getBoolean());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Boolean");
#endif
              break;
    case   5: any <<= CORBA::Any::from_octet(ernie.getOctet());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Octet");
#endif
              break;
    case   6: any <<= CORBA::Any::from_char(ernie.getChar());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Char");
#endif
              break;
    case   7: any <<= ernie.getFloat();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Float");
#endif
               break;
    case   8: any <<= ernie.getDouble();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Double");
#endif
              break;
    case   9: any <<= ernie.getString();
#ifdef DEBUG
              ::tet_infoline("GetAny creating String");
#endif
              break;
    case  10: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating BoundedString");
#endif
                CORBA::ULong  b;
                b = ernie.getULong()%30+1;
                any <<= CORBA::Any::from_string(ernie.getString(b),b);
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr _typecode;
#ifdef DEBUG
                ::tet_infoline("GetAny creating TypeCode");
#endif
                GetCORBATypeCode_ptr(_typecode);
                any <<= _typecode;
               }
                break;
    case   12: {
                CORBA::Any  _any;  
#ifdef DEBUG
                ::tet_infoline("GetAny creating Any");
#endif
                GetAny(_any);
                any <<= _any;
               }
                break;

    case  13: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cultra66");
#endif
                ::Cultra66   v;

                GetCultra66(v);

                any  <<= v;
              }
              break;

    case  14: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pimpernel66");
#endif
                ::Pimpernel66   v;

                GetPimpernel66(v);

                any  <<= v;
              }
              break;

    case  15: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pimpernel66::KerrsPinks66");
#endif
                ::Pimpernel66::KerrsPinks66   v;

                GetPimpernel66KerrsPinks66(v);

                any  <<= v;
              }
              break;

    case  16: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pimpernel66::KerrsPinks66::Wilja66");
#endif
                ::Pimpernel66::KerrsPinks66::Wilja66   v;

                GetPimpernel66KerrsPinks66Wilja66(v);

                any  <<= v;
              }
              break;

    case  17: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Broadbeans67");
#endif
                ::Broadbeans67   v;

                GetBroadbeans67(v);

                any  <<= v;
              }
              break;

    case  18: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::ChineseLeaves67");
#endif
                ::ChineseLeaves67   v;

                GetChineseLeaves67(v);

                any  <<= v;
              }
              break;

    case  19: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::ChineseLeaves67::Clementine67");
#endif
                ::ChineseLeaves67::Clementine67   v;

                GetChineseLeaves67Clementine67(v);

                any  <<= v;
              }
              break;

    case  20: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::ChineseLeaves67::Clementine67::Chestnut67");
#endif
                ::ChineseLeaves67::Clementine67::Chestnut67   v;

                GetChineseLeaves67Clementine67Chestnut67(v);

                any  <<= v;
              }
              break;

    case  21: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Celeriac68");
#endif
                ::Celeriac68   v;

                GetCeleriac68(v);

                any  <<= v;
              }
              break;

    case  22: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::RedChilly68");
#endif
                ::RedChilly68   v;

                GetRedChilly68(v);

                any  <<= v;
              }
              break;

    case  23: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::RedChilly68::Chayato68");
#endif
                ::RedChilly68::Chayato68   v;

                GetRedChilly68Chayato68(v);

                any  <<= v;
              }
              break;

    case  24: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::RedChilly68::Chayato68::KiwanoMelon68");
#endif
                ::RedChilly68::Chayato68::KiwanoMelon68   v;

                GetRedChilly68Chayato68KiwanoMelon68(v);

                any  <<= v;
              }
              break;

    case  25: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Scallion69");
#endif
                ::Scallion69   v;

                GetScallion69(v);

                any  <<= v;
              }
              break;

    case  26: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::VineTomatoes69");
#endif
                ::VineTomatoes69   v;

                GetVineTomatoes69(v);

                any  <<= v;
              }
              break;

    case  27: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::VineTomatoes69::Chervil69");
#endif
                ::VineTomatoes69::Chervil69   v;

                GetVineTomatoes69Chervil69(v);

                any  <<= v;
              }
              break;

    case  28: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::VineTomatoes69::Chervil69::GreenChilly69");
#endif
                ::VineTomatoes69::Chervil69::GreenChilly69   v;

                GetVineTomatoes69Chervil69GreenChilly69(v);

                any  <<= v;
              }
              break;

    case  29: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Peanuts70");
#endif
                ::Peanuts70   v;

                GetPeanuts70(v);

                any  <<= v;
              }
              break;

    case  30: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Satsuma70");
#endif
                ::Satsuma70   v;

                GetSatsuma70(v);

                any  <<= v;
              }
              break;

    case  31: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Satsuma70::Parsley70");
#endif
                ::Satsuma70::Parsley70   v;

                GetSatsuma70Parsley70(v);

                any  <<= v;
              }
              break;

    case  32: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Satsuma70::Parsley70::Peach70");
#endif
                ::Satsuma70::Parsley70::Peach70   v;

                GetSatsuma70Parsley70Peach70(v);

                any  <<= v;
              }
              break;

    case  33: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mullberry71");
#endif
                ::Mullberry71   v;

                GetMullberry71(v);

                any  <<= v;
              }
              break;

    case  34: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Chives71");
#endif
                ::Chives71   v;

                GetChives71(v);

                any  <<= v;
              }
              break;

    case  35: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Chives71::Rasin71");
#endif
                ::Chives71::Rasin71   v;

                GetChives71Rasin71(v);

                any  <<= v;
              }
              break;

    case  36: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Chives71::Rasin71::Cherry71");
#endif
                ::Chives71::Rasin71::Cherry71   v;

                GetChives71Rasin71Cherry71(v);

                any  <<= v;
              }
              break;

    case  37: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Damsons72");
#endif
                ::Damsons72   v;

                GetDamsons72(v);

                any  <<= v;
              }
              break;

    case  38: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::PepinoMelon72");
#endif
                ::PepinoMelon72   v;

                GetPepinoMelon72(v);

                any  <<= v;
              }
              break;

    case  39: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::PepinoMelon72::Raspberry72");
#endif
                ::PepinoMelon72::Raspberry72   v;

                GetPepinoMelon72Raspberry72(v);

                any  <<= v;
              }
              break;

    case  40: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::PepinoMelon72::Raspberry72::Peppercorn72");
#endif
                ::PepinoMelon72::Raspberry72::Peppercorn72   v;

                GetPepinoMelon72Raspberry72Peppercorn72(v);

                any  <<= v;
              }
              break;

    case  41: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::FrenchBeans73");
#endif
                ::FrenchBeans73   v;

                GetFrenchBeans73(v);

                any  <<= v;
              }
              break;

    case  42: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BeefTomatoes73");
#endif
                ::BeefTomatoes73   v;

                GetBeefTomatoes73(v);

                any  <<= v;
              }
              break;

    case  43: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BeefTomatoes73::Pear73");
#endif
                ::BeefTomatoes73::Pear73   v;

                GetBeefTomatoes73Pear73(v);

                any  <<= v;
              }
              break;

    case  44: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BeefTomatoes73::Pear73::Walnuts73");
#endif
                ::BeefTomatoes73::Pear73::Walnuts73   v;

                GetBeefTomatoes73Pear73Walnuts73(v);

                any  <<= v;
              }
              break;

    case  45: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Plantain74");
#endif
                ::Plantain74   v;

                GetPlantain74(v);

                any  <<= v;
              }
              break;

    case  46: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Okra74");
#endif
                ::Okra74   v;

                GetOkra74(v);

                any  <<= v;
              }
              break;

    case  47: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Okra74::Chickpea74");
#endif
                ::Okra74::Chickpea74   v;

                GetOkra74Chickpea74(v);

                any  <<= v;
              }
              break;

    case  48: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Okra74::Chickpea74::Uglifruit74");
#endif
                ::Okra74::Chickpea74::Uglifruit74   v;

                GetOkra74Chickpea74Uglifruit74(v);

                any  <<= v;
              }
              break;

    case  49: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BeechNut75");
#endif
                ::BeechNut75   v;

                GetBeechNut75(v);

                any  <<= v;
              }
              break;

    case  50: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::RedGrapes75");
#endif
                ::RedGrapes75   v;

                GetRedGrapes75(v);

                any  <<= v;
              }
              break;

    case  51: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::RedGrapes75::Cassava75");
#endif
                ::RedGrapes75::Cassava75   v;

                GetRedGrapes75Cassava75(v);

                any  <<= v;
              }
              break;

    case  52: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::RedGrapes75::Cassava75::Daikan75");
#endif
                ::RedGrapes75::Cassava75::Daikan75   v;

                GetRedGrapes75Cassava75Daikan75(v);

                any  <<= v;
              }
              break;

    case  53: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Tarragon76");
#endif
                ::Tarragon76   v;

                GetTarragon76(v);

                any  <<= v;
              }
              break;

    case  54: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pomegranate76");
#endif
                ::Pomegranate76   v;

                GetPomegranate76(v);

                any  <<= v;
              }
              break;

    case  55: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pomegranate76::Thyme76");
#endif
                ::Pomegranate76::Thyme76   v;

                GetPomegranate76Thyme76(v);

                any  <<= v;
              }
              break;

    case  56: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pomegranate76::Thyme76::Strawberry76");
#endif
                ::Pomegranate76::Thyme76::Strawberry76   v;

                GetPomegranate76Thyme76Strawberry76(v);

                any  <<= v;
              }
              break;

    case  57: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::EggPlant77");
#endif
                ::EggPlant77   v;

                GetEggPlant77(v);

                any  <<= v;
              }
              break;

    case  58: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GooseBerry77");
#endif
                ::GooseBerry77   v;

                GetGooseBerry77(v);

                any  <<= v;
              }
              break;

    case  59: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GooseBerry77::HazelNut77");
#endif
                ::GooseBerry77::HazelNut77   v;

                GetGooseBerry77HazelNut77(v);

                any  <<= v;
              }
              break;

    case  60: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GooseBerry77::HazelNut77::Onion77");
#endif
                ::GooseBerry77::HazelNut77::Onion77   v;

                GetGooseBerry77HazelNut77Onion77(v);

                any  <<= v;
              }
              break;

    case  61: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GoldenDelicous78");
#endif
                ::GoldenDelicous78   v;

                GetGoldenDelicous78(v);

                any  <<= v;
              }
              break;

    case  62: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Avocado78");
#endif
                ::Avocado78   v;

                GetAvocado78(v);

                any  <<= v;
              }
              break;

    case  63: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Avocado78::Zucchini78");
#endif
                ::Avocado78::Zucchini78   v;

                GetAvocado78Zucchini78(v);

                any  <<= v;
              }
              break;

    case  64: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Avocado78::Zucchini78::Plum78");
#endif
                ::Avocado78::Zucchini78::Plum78   v;

                GetAvocado78Zucchini78Plum78(v);

                any  <<= v;
              }
              break;

    case  65: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::LolloRossa79");
#endif
                ::LolloRossa79   v;

                GetLolloRossa79(v);

                any  <<= v;
              }
              break;

    case  66: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CantelopeMelon79");
#endif
                ::CantelopeMelon79   v;

                GetCantelopeMelon79(v);

                any  <<= v;
              }
              break;

    case  67: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CantelopeMelon79::Tangarine79");
#endif
                ::CantelopeMelon79::Tangarine79   v;

                GetCantelopeMelon79Tangarine79(v);

                any  <<= v;
              }
              break;

    case  68: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CantelopeMelon79::Tangarine79::Oregano79");
#endif
                ::CantelopeMelon79::Tangarine79::Oregano79   v;

                GetCantelopeMelon79Tangarine79Oregano79(v);

                any  <<= v;
              }
              break;

    case  69: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Prunes80");
#endif
                ::Prunes80   v;

                GetPrunes80(v);

                any  <<= v;
              }
              break;

    case  70: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Tofu80");
#endif
                ::Tofu80   v;

                GetTofu80(v);

                any  <<= v;
              }
              break;

    case  71: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Tofu80::Mushroom80");
#endif
                ::Tofu80::Mushroom80   v;

                GetTofu80Mushroom80(v);

                any  <<= v;
              }
              break;

    case  72: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Tofu80::Mushroom80::Almonds80");
#endif
                ::Tofu80::Mushroom80::Almonds80   v;

                GetTofu80Mushroom80Almonds80(v);

                any  <<= v;
              }
              break;

    case  73: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Aniseed81");
#endif
                ::Aniseed81   v;

                GetAniseed81(v);

                any  <<= v;
              }
              break;

    case  74: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::WhiteCabbage81");
#endif
                ::WhiteCabbage81   v;

                GetWhiteCabbage81(v);

                any  <<= v;
              }
              break;

    case  75: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::WhiteCabbage81::Parsnip81");
#endif
                ::WhiteCabbage81::Parsnip81   v;

                GetWhiteCabbage81Parsnip81(v);

                any  <<= v;
              }
              break;

    case  76: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::WhiteCabbage81::Parsnip81::Ginger81");
#endif
                ::WhiteCabbage81::Parsnip81::Ginger81   v;

                GetWhiteCabbage81Parsnip81Ginger81(v);

                any  <<= v;
              }
              break;

    case  77: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GaliaMelon82");
#endif
                ::GaliaMelon82   v;

                GetGaliaMelon82(v);

                any  <<= v;
              }
              break;

    case  78: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Asparagus82");
#endif
                ::Asparagus82   v;

                GetAsparagus82(v);

                any  <<= v;
              }
              break;

    case  79: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Asparagus82::Mint82");
#endif
                ::Asparagus82::Mint82   v;

                GetAsparagus82Mint82(v);

                any  <<= v;
              }
              break;

    case  80: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Asparagus82::Mint82::BlackEyedBeans82");
#endif
                ::Asparagus82::Mint82::BlackEyedBeans82   v;

                GetAsparagus82Mint82BlackEyedBeans82(v);

                any  <<= v;
              }
              break;

    case  81: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lychees83");
#endif
                ::Lychees83   v;

                GetLychees83(v);

                any  <<= v;
              }
              break;

    case  82: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Coconut83");
#endif
                ::Coconut83   v;

                GetCoconut83(v);

                any  <<= v;
              }
              break;

    case  83: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Coconut83::Lime83");
#endif
                ::Coconut83::Lime83   v;

                GetCoconut83Lime83(v);

                any  <<= v;
              }
              break;

    case  84: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Coconut83::Lime83::PentlandDell82");
#endif
                ::Coconut83::Lime83::PentlandDell82   v;

                GetCoconut83Lime83PentlandDell82(v);

                any  <<= v;
              }
              break;

    case  85: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Rhubarb84");
#endif
                ::Rhubarb84   v;

                GetRhubarb84(v);

                any  <<= v;
              }
              break;

    case  86: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Starfruit84");
#endif
                ::Starfruit84   v;

                GetStarfruit84(v);

                any  <<= v;
              }
              break;

    case  87: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Starfruit84::Lemon84");
#endif
                ::Starfruit84::Lemon84   v;

                GetStarfruit84Lemon84(v);

                any  <<= v;
              }
              break;

    case  88: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Starfruit84::Lemon84::Banana84");
#endif
                ::Starfruit84::Lemon84::Banana84   v;

                GetStarfruit84Lemon84Banana84(v);

                any  <<= v;
              }
              break;

    case  89: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::MarisPiper84");
#endif
                ::MarisPiper84   v;

                GetMarisPiper84(v);

                any  <<= v;
              }
              break;

    case  90: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Rooster84");
#endif
                ::Rooster84   v;

                GetRooster84(v);

                any  <<= v;
              }
              break;

    case  91: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Rooster84::Pimpernel84");
#endif
                ::Rooster84::Pimpernel84   v;

                GetRooster84Pimpernel84(v);

                any  <<= v;
              }
              break;

    case  92: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Rooster84::Pimpernel84::Clementine84");
#endif
                ::Rooster84::Pimpernel84::Clementine84   v;

                GetRooster84Pimpernel84Clementine84(v);

                any  <<= v;
              }
              break;

    case  93: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BritishQueens85");
#endif
                ::BritishQueens85   v;

                GetBritishQueens85(v);

                any  <<= v;
              }
              break;

    case  94: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Homeguard85");
#endif
                ::Homeguard85   v;

                GetHomeguard85(v);

                any  <<= v;
              }
              break;

    case  95: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Homeguard85::Potato85");
#endif
                ::Homeguard85::Potato85   v;

                GetHomeguard85Potato85(v);

                any  <<= v;
              }
              break;

    case  96: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Homeguard85::Potato85::ChineseLeaves85");
#endif
                ::Homeguard85::Potato85::ChineseLeaves85   v;

                GetHomeguard85Potato85ChineseLeaves85(v);

                any  <<= v;
              }
              break;

    case  97: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cauliflower86");
#endif
                ::Cauliflower86   v;

                GetCauliflower86(v);

                any  <<= v;
              }
              break;

    case  98: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GalaApple86");
#endif
                ::GalaApple86   v;

                GetGalaApple86(v);

                any  <<= v;
              }
              break;

    case  99: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GalaApple86::RedChilly86");
#endif
                ::GalaApple86::RedChilly86   v;

                GetGalaApple86RedChilly86(v);

                any  <<= v;
              }
              break;

    case  100: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GalaApple86::RedChilly86::Chervil86");
#endif
                ::GalaApple86::RedChilly86::Chervil86   v;

                GetGalaApple86RedChilly86Chervil86(v);

                any  <<= v;
              }
              break;

    case  101: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::IcebergLettuce87");
#endif
                ::IcebergLettuce87   v;

                GetIcebergLettuce87(v);

                any  <<= v;
              }
              break;

    case  102: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Chestnut87");
#endif
                ::Chestnut87   v;

                GetChestnut87(v);

                any  <<= v;
              }
              break;

    case  103: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Chestnut87::PricklyPear87");
#endif
                ::Chestnut87::PricklyPear87   v;

                GetChestnut87PricklyPear87(v);

                any  <<= v;
              }
              break;

    case  104: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Chestnut87::PricklyPear87::VineTomatoes87");
#endif
                ::Chestnut87::PricklyPear87::VineTomatoes87   v;

                GetChestnut87PricklyPear87VineTomatoes87(v);

                any  <<= v;
              }
              break;

    case  105: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CoxPippin88");
#endif
                ::CoxPippin88   v;

                GetCoxPippin88(v);

                any  <<= v;
              }
              break;

    case  106: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Basil88");
#endif
                ::Basil88   v;

                GetBasil88(v);

                any  <<= v;
              }
              break;

    case  107: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Basil88::Satsuma88");
#endif
                ::Basil88::Satsuma88   v;

                GetBasil88Satsuma88(v);

                any  <<= v;
              }
              break;

    case  108: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Basil88::Satsuma88::Rasin88");
#endif
                ::Basil88::Satsuma88::Rasin88   v;

                GetBasil88Satsuma88Rasin88(v);

                any  <<= v;
              }
              break;

    case  109: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Corn89");
#endif
                ::Corn89   v;

                GetCorn89(v);

                any  <<= v;
              }
              break;

    case  110: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GreenChilly89");
#endif
                ::GreenChilly89   v;

                GetGreenChilly89(v);

                any  <<= v;
              }
              break;

    case  111: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GreenChilly89::Eddo89");
#endif
                ::GreenChilly89::Eddo89   v;

                GetGreenChilly89Eddo89(v);

                any  <<= v;
              }
              break;

    case  112: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GreenChilly89::Eddo89::Chives89");
#endif
                ::GreenChilly89::Eddo89::Chives89   v;

                GetGreenChilly89Eddo89Chives89(v);

                any  <<= v;
              }
              break;

  }
}


