//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Cultra66*
idlServer_imp::Cultra66Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Cultra66* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Cultra66Attr\n");
#endif
  
  ernie.seed("Cultra66AttrCall");
  
  ernie.seed("Cultra66AttrReturn"); 
  ReturnValue = new ::Cultra66;
  GetCultra66(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Cultra66Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Cultra66Attr(const ::Cultra66 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Cultra66Attr\n");
#endif
  
  ernie.seed("Cultra66AttrCall");
  AddName("_attr");
  if (!CheckCultra66(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cultra66AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Cultra66Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Cultra66*
idlServer_imp::Cultra66Op(const ::Cultra66 &p1,::Cultra66_out p2,::Cultra66 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Cultra66* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Cultra66Op\n");
#endif
  
  ernie.seed("Cultra66OpCall");
  AddName("p1");
  if (!CheckCultra66(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCultra66(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cultra66OpReturn"); 
  {
    ::idlServer::Cultra66Excpt ex;
    GetidlServerCultra66Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Cultra66;
  GetCultra66(*ReturnValue);
  p2 = new ::Cultra66;
  GetCultra66(*(p2.ptr()));
  GetCultra66(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Cultra66Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Pimpernel66*
idlServer_imp::Pimpernel66Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Pimpernel66* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Pimpernel66Attr\n");
#endif
  
  ernie.seed("Pimpernel66AttrCall");
  
  ernie.seed("Pimpernel66AttrReturn"); 
  ReturnValue = new ::Pimpernel66;
  GetPimpernel66(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Pimpernel66Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Pimpernel66Attr(const ::Pimpernel66 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Pimpernel66Attr\n");
#endif
  
  ernie.seed("Pimpernel66AttrCall");
  AddName("_attr");
  if (!CheckPimpernel66(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Pimpernel66AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Pimpernel66Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Pimpernel66*
idlServer_imp::Pimpernel66Op(const ::Pimpernel66 &p1,::Pimpernel66_out p2,::Pimpernel66 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Pimpernel66* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Pimpernel66Op\n");
#endif
  
  ernie.seed("Pimpernel66OpCall");
  AddName("p1");
  if (!CheckPimpernel66(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPimpernel66(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Pimpernel66OpReturn"); 
  {
    ::idlServer::Pimpernel66Excpt ex;
    GetidlServerPimpernel66Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Pimpernel66;
  GetPimpernel66(*ReturnValue);
  p2 = new ::Pimpernel66;
  GetPimpernel66(*(p2.ptr()));
  GetPimpernel66(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Pimpernel66Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Pimpernel66::KerrsPinks66*
idlServer_imp::KerrsPinks66Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Pimpernel66::KerrsPinks66* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KerrsPinks66Attr\n");
#endif
  
  ernie.seed("KerrsPinks66AttrCall");
  
  ernie.seed("KerrsPinks66AttrReturn"); 
  ReturnValue = new ::Pimpernel66::KerrsPinks66;
  GetPimpernel66KerrsPinks66(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KerrsPinks66Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::KerrsPinks66Attr(const ::Pimpernel66::KerrsPinks66 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KerrsPinks66Attr\n");
#endif
  
  ernie.seed("KerrsPinks66AttrCall");
  AddName("_attr");
  if (!CheckPimpernel66KerrsPinks66(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KerrsPinks66AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KerrsPinks66Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Pimpernel66::KerrsPinks66*
idlServer_imp::KerrsPinks66Op(const ::Pimpernel66::KerrsPinks66 &p1,::Pimpernel66::KerrsPinks66_out p2,::Pimpernel66::KerrsPinks66 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Pimpernel66::KerrsPinks66* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KerrsPinks66Op\n");
#endif
  
  ernie.seed("KerrsPinks66OpCall");
  AddName("p1");
  if (!CheckPimpernel66KerrsPinks66(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPimpernel66KerrsPinks66(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KerrsPinks66OpReturn"); 
  {
    ::idlServer::KerrsPinks66Excpt ex;
    GetidlServerKerrsPinks66Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Pimpernel66::KerrsPinks66;
  GetPimpernel66KerrsPinks66(*ReturnValue);
  p2 = new ::Pimpernel66::KerrsPinks66;
  GetPimpernel66KerrsPinks66(*(p2.ptr()));
  GetPimpernel66KerrsPinks66(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KerrsPinks66Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Pimpernel66::KerrsPinks66::Wilja66*
idlServer_imp::Wilja66Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Pimpernel66::KerrsPinks66::Wilja66* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Wilja66Attr\n");
#endif
  
  ernie.seed("Wilja66AttrCall");
  
  ernie.seed("Wilja66AttrReturn"); 
  ReturnValue = new ::Pimpernel66::KerrsPinks66::Wilja66;
  GetPimpernel66KerrsPinks66Wilja66(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Wilja66Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Wilja66Attr(const ::Pimpernel66::KerrsPinks66::Wilja66 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Wilja66Attr\n");
#endif
  
  ernie.seed("Wilja66AttrCall");
  AddName("_attr");
  if (!CheckPimpernel66KerrsPinks66Wilja66(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Wilja66AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Wilja66Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Pimpernel66::KerrsPinks66::Wilja66*
idlServer_imp::Wilja66Op(const ::Pimpernel66::KerrsPinks66::Wilja66 &p1,::Pimpernel66::KerrsPinks66::Wilja66_out p2,::Pimpernel66::KerrsPinks66::Wilja66 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Pimpernel66::KerrsPinks66::Wilja66* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Wilja66Op\n");
#endif
  
  ernie.seed("Wilja66OpCall");
  AddName("p1");
  if (!CheckPimpernel66KerrsPinks66Wilja66(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPimpernel66KerrsPinks66Wilja66(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Wilja66OpReturn"); 
  {
    ::idlServer::Wilja66Excpt ex;
    GetidlServerWilja66Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Pimpernel66::KerrsPinks66::Wilja66;
  GetPimpernel66KerrsPinks66Wilja66(*ReturnValue);
  p2 = new ::Pimpernel66::KerrsPinks66::Wilja66;
  GetPimpernel66KerrsPinks66Wilja66(*(p2.ptr()));
  GetPimpernel66KerrsPinks66Wilja66(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Wilja66Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Broadbeans67*
idlServer_imp::Broadbeans67Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Broadbeans67* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Broadbeans67Attr\n");
#endif
  
  ernie.seed("Broadbeans67AttrCall");
  
  ernie.seed("Broadbeans67AttrReturn"); 
  ReturnValue = new ::Broadbeans67;
  GetBroadbeans67(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Broadbeans67Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Broadbeans67Attr(const ::Broadbeans67 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Broadbeans67Attr\n");
#endif
  
  ernie.seed("Broadbeans67AttrCall");
  AddName("_attr");
  if (!CheckBroadbeans67(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Broadbeans67AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Broadbeans67Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Broadbeans67*
idlServer_imp::Broadbeans67Op(const ::Broadbeans67 &p1,::Broadbeans67_out p2,::Broadbeans67 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Broadbeans67* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Broadbeans67Op\n");
#endif
  
  ernie.seed("Broadbeans67OpCall");
  AddName("p1");
  if (!CheckBroadbeans67(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBroadbeans67(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Broadbeans67OpReturn"); 
  {
    ::idlServer::Broadbeans67Excpt ex;
    GetidlServerBroadbeans67Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Broadbeans67;
  GetBroadbeans67(*ReturnValue);
  p2 = new ::Broadbeans67;
  GetBroadbeans67(*(p2.ptr()));
  GetBroadbeans67(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Broadbeans67Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



