//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/client.cpp
//
// Modifications:
// $Log: client.cpp,v $
// Revision 1.2  2000/03/29 17:10:27  mli
//   o   remove 'CORBA::Environment ev;'
//   o   int initialise
//
// Revision 1.1.1.1  2000/02/09 17:16:38  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1997/12/12 09:01:37  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern OrbSupport *orb;
extern char *stringifiedIOR;

static int initialised = 0;
CORBA::Object_ptr obj;
idlServer_ptr  tobj;

void
initialise()
{
    if (!initialised)
    {

#ifdef DEBUG
	  ::tet_infoline("client: connecting to proxy");
	  ::tet_printf("client: using %s", stringifiedIOR);
#endif
	  
	  try {
	      obj = orb->getObject(stringifiedIOR);
	  }
	  catch (CORBA::SystemException &ex) {
	      ::tet_infoline("client: getObj failed");
	      ::tet_printf("client: minor code %d", ex.minor());
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  if (obj == 0)
	  {
	      ::tet_infoline("client: failed connecting to proxy");
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  try {
	      tobj = idlServer::_narrow(obj);
	  }
	  catch (CORBA::Exception &ex) {
	      ::tet_infoline("client: failed to narrow object reference.");
	  }
	  initialised = 1;

	  char * tout = 0;
	  tout = getenv("VSORB_EVENT_TIMEOUT");

	  unsigned long timeout = (tout) ? atoi(tout) : 15;
	  orb->setTimeout(tobj, timeout);
      }
    
}

#ifdef VSORB_IDL_TESTS

void testIDL()
{
  char buf1[1024];

::tet_result(TET_PASS);
}
 
#endif



 
void testidlServerCherryTomatoes90Attr(void)
{
  
  ::CherryTomatoes90* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::CherryTomatoes90* ::idlServer::CherryTomatoes90Attr()");
#endif
  
  ernie.seed("CherryTomatoes90AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("CherryTomatoes90AttrReturn");
  try {
    ReturnValue = tobj->CherryTomatoes90Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::CherryTomatoes90Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckCherryTomatoes90(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCherryTomatoes90AttrW(void)
{
  
  ::CherryTomatoes90 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::CherryTomatoes90Attr(const ::CherryTomatoes90 &_attr)");
#endif
  
  ernie.seed("CherryTomatoes90AttrCall");
  GetCherryTomatoes90(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("CherryTomatoes90AttrReturn");
  try {
     tobj->CherryTomatoes90Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::CherryTomatoes90Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCherryTomatoes90Op(void)
{
  
  ::CherryTomatoes90* ReturnValue;
  ::CherryTomatoes90 p1;
  ::CherryTomatoes90* p2;
  ::CherryTomatoes90 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::CherryTomatoes90* ::idlServer::CherryTomatoes90Op(const ::CherryTomatoes90 &p1,::CherryTomatoes90 *&p2,::CherryTomatoes90 &p3)");
#endif
  
  ernie.seed("CherryTomatoes90OpCall");
  GetCherryTomatoes90(p1);
  GetCherryTomatoes90(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("CherryTomatoes90OpReturn");
  try {
    ReturnValue = tobj->CherryTomatoes90Op(p1,p2,p3);
  }
  catch (::idlServer::CherryTomatoes90Excpt &ex){
    if (!CheckidlServerCherryTomatoes90Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::CherryTomatoes90Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckCherryTomatoes90(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckCherryTomatoes90(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCherryTomatoes90(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPeanutsquash90Attr(void)
{
  
  ::Peanutsquash90* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Peanutsquash90* ::idlServer::Peanutsquash90Attr()");
#endif
  
  ernie.seed("Peanutsquash90AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Peanutsquash90AttrReturn");
  try {
    ReturnValue = tobj->Peanutsquash90Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Peanutsquash90Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPeanutsquash90(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPeanutsquash90AttrW(void)
{
  
  ::Peanutsquash90 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Peanutsquash90Attr(const ::Peanutsquash90 &_attr)");
#endif
  
  ernie.seed("Peanutsquash90AttrCall");
  GetPeanutsquash90(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Peanutsquash90AttrReturn");
  try {
     tobj->Peanutsquash90Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Peanutsquash90Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPeanutsquash90Op(void)
{
  
  ::Peanutsquash90* ReturnValue;
  ::Peanutsquash90 p1;
  ::Peanutsquash90* p2;
  ::Peanutsquash90 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Peanutsquash90* ::idlServer::Peanutsquash90Op(const ::Peanutsquash90 &p1,::Peanutsquash90 *&p2,::Peanutsquash90 &p3)");
#endif
  
  ernie.seed("Peanutsquash90OpCall");
  GetPeanutsquash90(p1);
  GetPeanutsquash90(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Peanutsquash90OpReturn");
  try {
    ReturnValue = tobj->Peanutsquash90Op(p1,p2,p3);
  }
  catch (::idlServer::Peanutsquash90Excpt &ex){
    if (!CheckidlServerPeanutsquash90Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Peanutsquash90Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPeanutsquash90(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckPeanutsquash90(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPeanutsquash90(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPepinoMelon90Attr(void)
{
  
  ::Peanutsquash90::PepinoMelon90* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Peanutsquash90::PepinoMelon90* ::idlServer::PepinoMelon90Attr()");
#endif
  
  ernie.seed("PepinoMelon90AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("PepinoMelon90AttrReturn");
  try {
    ReturnValue = tobj->PepinoMelon90Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::PepinoMelon90Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPeanutsquash90PepinoMelon90(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPepinoMelon90AttrW(void)
{
  
  ::Peanutsquash90::PepinoMelon90 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::PepinoMelon90Attr(const ::Peanutsquash90::PepinoMelon90 &_attr)");
#endif
  
  ernie.seed("PepinoMelon90AttrCall");
  GetPeanutsquash90PepinoMelon90(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("PepinoMelon90AttrReturn");
  try {
     tobj->PepinoMelon90Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::PepinoMelon90Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPepinoMelon90Op(void)
{
  
  ::Peanutsquash90::PepinoMelon90* ReturnValue;
  ::Peanutsquash90::PepinoMelon90 p1;
  ::Peanutsquash90::PepinoMelon90* p2;
  ::Peanutsquash90::PepinoMelon90 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Peanutsquash90::PepinoMelon90* ::idlServer::PepinoMelon90Op(const ::Peanutsquash90::PepinoMelon90 &p1,::Peanutsquash90::PepinoMelon90 *&p2,::Peanutsquash90::PepinoMelon90 &p3)");
#endif
  
  ernie.seed("PepinoMelon90OpCall");
  GetPeanutsquash90PepinoMelon90(p1);
  GetPeanutsquash90PepinoMelon90(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("PepinoMelon90OpReturn");
  try {
    ReturnValue = tobj->PepinoMelon90Op(p1,p2,p3);
  }
  catch (::idlServer::PepinoMelon90Excpt &ex){
    if (!CheckidlServerPepinoMelon90Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::PepinoMelon90Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPeanutsquash90PepinoMelon90(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckPeanutsquash90PepinoMelon90(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPeanutsquash90PepinoMelon90(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPear90Attr(void)
{
  
  ::Peanutsquash90::PepinoMelon90::Pear90* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Peanutsquash90::PepinoMelon90::Pear90* ::idlServer::Pear90Attr()");
#endif
  
  ernie.seed("Pear90AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Pear90AttrReturn");
  try {
    ReturnValue = tobj->Pear90Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Pear90Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPeanutsquash90PepinoMelon90Pear90(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPear90AttrW(void)
{
  
  ::Peanutsquash90::PepinoMelon90::Pear90 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Pear90Attr(const ::Peanutsquash90::PepinoMelon90::Pear90 &_attr)");
#endif
  
  ernie.seed("Pear90AttrCall");
  GetPeanutsquash90PepinoMelon90Pear90(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Pear90AttrReturn");
  try {
     tobj->Pear90Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Pear90Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPear90Op(void)
{
  
  ::Peanutsquash90::PepinoMelon90::Pear90* ReturnValue;
  ::Peanutsquash90::PepinoMelon90::Pear90 p1;
  ::Peanutsquash90::PepinoMelon90::Pear90* p2;
  ::Peanutsquash90::PepinoMelon90::Pear90 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Peanutsquash90::PepinoMelon90::Pear90* ::idlServer::Pear90Op(const ::Peanutsquash90::PepinoMelon90::Pear90 &p1,::Peanutsquash90::PepinoMelon90::Pear90 *&p2,::Peanutsquash90::PepinoMelon90::Pear90 &p3)");
#endif
  
  ernie.seed("Pear90OpCall");
  GetPeanutsquash90PepinoMelon90Pear90(p1);
  GetPeanutsquash90PepinoMelon90Pear90(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Pear90OpReturn");
  try {
    ReturnValue = tobj->Pear90Op(p1,p2,p3);
  }
  catch (::idlServer::Pear90Excpt &ex){
    if (!CheckidlServerPear90Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Pear90Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPeanutsquash90PepinoMelon90Pear90(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckPeanutsquash90PepinoMelon90Pear90(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPeanutsquash90PepinoMelon90Pear90(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPapaya91Attr(void)
{
  
  ::Papaya91* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Papaya91* ::idlServer::Papaya91Attr()");
#endif
  
  ernie.seed("Papaya91AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Papaya91AttrReturn");
  try {
    ReturnValue = tobj->Papaya91Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Papaya91Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPapaya91(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPapaya91AttrW(void)
{
  
  ::Papaya91 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Papaya91Attr(const ::Papaya91 &_attr)");
#endif
  
  ernie.seed("Papaya91AttrCall");
  GetPapaya91(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Papaya91AttrReturn");
  try {
     tobj->Papaya91Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Papaya91Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPapaya91Op(void)
{
  
  ::Papaya91* ReturnValue;
  ::Papaya91 p1;
  ::Papaya91* p2;
  ::Papaya91 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Papaya91* ::idlServer::Papaya91Op(const ::Papaya91 &p1,::Papaya91 *&p2,::Papaya91 &p3)");
#endif
  
  ernie.seed("Papaya91OpCall");
  GetPapaya91(p1);
  GetPapaya91(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Papaya91OpReturn");
  try {
    ReturnValue = tobj->Papaya91Op(p1,p2,p3);
  }
  catch (::idlServer::Papaya91Excpt &ex){
    if (!CheckidlServerPapaya91Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Papaya91Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPapaya91(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckPapaya91(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPapaya91(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCherry91Attr(void)
{
  
  ::Cherry91* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Cherry91* ::idlServer::Cherry91Attr()");
#endif
  
  ernie.seed("Cherry91AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Cherry91AttrReturn");
  try {
    ReturnValue = tobj->Cherry91Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Cherry91Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckCherry91(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCherry91AttrW(void)
{
  
  ::Cherry91 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Cherry91Attr(const ::Cherry91 &_attr)");
#endif
  
  ernie.seed("Cherry91AttrCall");
  GetCherry91(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Cherry91AttrReturn");
  try {
     tobj->Cherry91Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Cherry91Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCherry91Op(void)
{
  
  ::Cherry91* ReturnValue;
  ::Cherry91 p1;
  ::Cherry91* p2;
  ::Cherry91 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Cherry91* ::idlServer::Cherry91Op(const ::Cherry91 &p1,::Cherry91 *&p2,::Cherry91 &p3)");
#endif
  
  ernie.seed("Cherry91OpCall");
  GetCherry91(p1);
  GetCherry91(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Cherry91OpReturn");
  try {
    ReturnValue = tobj->Cherry91Op(p1,p2,p3);
  }
  catch (::idlServer::Cherry91Excpt &ex){
    if (!CheckidlServerCherry91Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Cherry91Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckCherry91(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckCherry91(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCherry91(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSharanfruit91Attr(void)
{
  
  ::Cherry91::Sharanfruit91* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Cherry91::Sharanfruit91* ::idlServer::Sharanfruit91Attr()");
#endif
  
  ernie.seed("Sharanfruit91AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sharanfruit91AttrReturn");
  try {
    ReturnValue = tobj->Sharanfruit91Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sharanfruit91Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckCherry91Sharanfruit91(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSharanfruit91AttrW(void)
{
  
  ::Cherry91::Sharanfruit91 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Sharanfruit91Attr(const ::Cherry91::Sharanfruit91 &_attr)");
#endif
  
  ernie.seed("Sharanfruit91AttrCall");
  GetCherry91Sharanfruit91(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sharanfruit91AttrReturn");
  try {
     tobj->Sharanfruit91Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sharanfruit91Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSharanfruit91Op(void)
{
  
  ::Cherry91::Sharanfruit91* ReturnValue;
  ::Cherry91::Sharanfruit91 p1;
  ::Cherry91::Sharanfruit91* p2;
  ::Cherry91::Sharanfruit91 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Cherry91::Sharanfruit91* ::idlServer::Sharanfruit91Op(const ::Cherry91::Sharanfruit91 &p1,::Cherry91::Sharanfruit91 *&p2,::Cherry91::Sharanfruit91 &p3)");
#endif
  
  ernie.seed("Sharanfruit91OpCall");
  GetCherry91Sharanfruit91(p1);
  GetCherry91Sharanfruit91(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sharanfruit91OpReturn");
  try {
    ReturnValue = tobj->Sharanfruit91Op(p1,p2,p3);
  }
  catch (::idlServer::Sharanfruit91Excpt &ex){
    if (!CheckidlServerSharanfruit91Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sharanfruit91Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckCherry91Sharanfruit91(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckCherry91Sharanfruit91(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCherry91Sharanfruit91(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerBeefTomatoes91Attr(void)
{
  
  ::Cherry91::Sharanfruit91::BeefTomatoes91* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Cherry91::Sharanfruit91::BeefTomatoes91* ::idlServer::BeefTomatoes91Attr()");
#endif
  
  ernie.seed("BeefTomatoes91AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("BeefTomatoes91AttrReturn");
  try {
    ReturnValue = tobj->BeefTomatoes91Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::BeefTomatoes91Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckCherry91Sharanfruit91BeefTomatoes91(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerBeefTomatoes91AttrW(void)
{
  
  ::Cherry91::Sharanfruit91::BeefTomatoes91 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::BeefTomatoes91Attr(const ::Cherry91::Sharanfruit91::BeefTomatoes91 &_attr)");
#endif
  
  ernie.seed("BeefTomatoes91AttrCall");
  GetCherry91Sharanfruit91BeefTomatoes91(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("BeefTomatoes91AttrReturn");
  try {
     tobj->BeefTomatoes91Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::BeefTomatoes91Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerBeefTomatoes91Op(void)
{
  
  ::Cherry91::Sharanfruit91::BeefTomatoes91* ReturnValue;
  ::Cherry91::Sharanfruit91::BeefTomatoes91 p1;
  ::Cherry91::Sharanfruit91::BeefTomatoes91* p2;
  ::Cherry91::Sharanfruit91::BeefTomatoes91 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Cherry91::Sharanfruit91::BeefTomatoes91* ::idlServer::BeefTomatoes91Op(const ::Cherry91::Sharanfruit91::BeefTomatoes91 &p1,::Cherry91::Sharanfruit91::BeefTomatoes91 *&p2,::Cherry91::Sharanfruit91::BeefTomatoes91 &p3)");
#endif
  
  ernie.seed("BeefTomatoes91OpCall");
  GetCherry91Sharanfruit91BeefTomatoes91(p1);
  GetCherry91Sharanfruit91BeefTomatoes91(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("BeefTomatoes91OpReturn");
  try {
    ReturnValue = tobj->BeefTomatoes91Op(p1,p2,p3);
  }
  catch (::idlServer::BeefTomatoes91Excpt &ex){
    if (!CheckidlServerBeefTomatoes91Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::BeefTomatoes91Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckCherry91Sharanfruit91BeefTomatoes91(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckCherry91Sharanfruit91BeefTomatoes91(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCherry91Sharanfruit91BeefTomatoes91(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


