//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/checkany.cpp
//
// Modifications:
// $Log: checkany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:38  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/26 13:51:43  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/12 09:01:39  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern char name[];

 
int CheckAny(const CORBA::Any &any)
{
  switch(ernie.getULong()%(12+40))
  {
    case   0: {
                CORBA::ULong  v;
#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::ULong");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::ULong as expected", name);
                  return 0;
                }
                if (!ernie.checkULong(v))
                {
                  tet_printf("Expected %s to contain CORBA::ULong with value %u, but found %u instead.",
                    name,ernie.getULongAgain(),v);
                  return 0;
                }
              }
              break;
    case   1: {
                CORBA::Long  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Long");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Long as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkLong(v))
                {
                  tet_printf("Expected %s to contain CORBA::Long with value %d, but found %d instead.",
                    name,ernie.getLongAgain(),v);
                  return 0;
                }
              }
              break;
    case   2: {
                CORBA::UShort  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::UShort");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::UShort as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkUShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::UShort with value %u, but found %u instead.",
                    name,ernie.getUShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   3: {
                CORBA::Short  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Short");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Short as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::Short with value %d, but found %d instead.",
                    name,ernie.getShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   4: {
                CORBA::Boolean  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Boolean");
#endif
                if (!(any >>= CORBA::Any::to_boolean(v)))
                {
                  tet_printf("%s did not contain a CORBA::Boolean as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkBoolean(v))
                {
                  tet_printf("Expected %s to contain CORBA::Boolean with value %s, but found %s instead.",
                    name,
                    BooleanToString(ernie.getBooleanAgain()),
                    BooleanToString(v));
                  return 0;
                }
              }
              break;
    case   5: {
                CORBA::Octet  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Octet");
#endif
                if (!(any >>= CORBA::Any::to_octet(v)))
                {
                  tet_printf("%s did not contain a CORBA::Octet as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkOctet(v))
                {
                  ::tet_printf("Expected %s to contain CORBA::Octet with value %s, but found %s instead.",
                    name,
                    OctetToString(ernie.getOctetAgain()),
                    OctetToString(v));
                  return 0;
                }
              }
              break;
    case   6: {
                CORBA::Char  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Char");
#endif
                if (!(any >>= CORBA::Any::to_char(v)))
                {
                  tet_printf("%s did not contain a CORBA::Char as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkChar(v))
                {
                  tet_printf("Expected %s to contain CORBA::Char with value %s, but found %s instead.",
                    name,
                    CharToString(ernie.getCharAgain()),
                    CharToString(v));
                  return 0;
                }
              }
              break;
    case   7: {
                CORBA::Float  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Float");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Float as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkFloat(v))
                {
                  tet_printf("Expected %s to contain CORBA::Float with value %g, but found %g instead.",
                    name,
                    ernie.getFloatAgain(),
                    v);
                  return 0;
                }
              }
               break;
    case   8: {
                CORBA::Double  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Double");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Double as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkDouble(v))
                {
                  tet_printf("Expected %s to contain CORBA::Double with value %g, but found %g instead.",
                    name,
                    ernie.getDoubleAgain(),
                    v);
                  return 0;
                }
              }
              break;
    case   9: {
                char *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting char*");
#endif
                if (!(any >>= CORBA::Any::to_string(v,0)))
                {
                  tet_printf("%s did not contain a char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v))
                {
                  tet_printf("Expected %s to contain char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case  10: {
                CORBA::ULong  b;
                char   *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting bounded char*");
#endif
                b = ernie.getULong()%30+1;

                if (!(any >>= CORBA::Any::to_string(v,b)))
                {
                  tet_printf("%s did not contain a bounded char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v,b))
                {
                  tet_printf("Expected %s to contain a bounded char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::TypeCode");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::TypeCode as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCORBATypeCode_ptr(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case   12: {
                CORBA::Any  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Any");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Any as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAny(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  13: {
                ::CherryTomatoes90 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CherryTomatoes90\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CherryTomatoes90 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCherryTomatoes90(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  14: {
                ::Peanutsquash90 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Peanutsquash90\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Peanutsquash90 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPeanutsquash90(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  15: {
                ::Peanutsquash90::PepinoMelon90 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Peanutsquash90::PepinoMelon90\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Peanutsquash90::PepinoMelon90 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPeanutsquash90PepinoMelon90(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  16: {
                ::Peanutsquash90::PepinoMelon90::Pear90 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Peanutsquash90::PepinoMelon90::Pear90\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Peanutsquash90::PepinoMelon90::Pear90 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPeanutsquash90PepinoMelon90Pear90(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  17: {
                ::Papaya91 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Papaya91\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Papaya91 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPapaya91(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  18: {
                ::Cherry91 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cherry91\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cherry91 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCherry91(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  19: {
                ::Cherry91::Sharanfruit91 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cherry91::Sharanfruit91\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cherry91::Sharanfruit91 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCherry91Sharanfruit91(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  20: {
                ::Cherry91::Sharanfruit91::BeefTomatoes91 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cherry91::Sharanfruit91::BeefTomatoes91\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cherry91::Sharanfruit91::BeefTomatoes91 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCherry91Sharanfruit91BeefTomatoes91(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  21: {
                ::Pineapple92 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Pineapple92\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Pineapple92 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPineapple92(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  22: {
                ::Blackcurrant92 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Blackcurrant92\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Blackcurrant92 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlackcurrant92(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  23: {
                ::Blackcurrant92::Okra92 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Blackcurrant92::Okra92\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Blackcurrant92::Okra92 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlackcurrant92Okra92(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  24: {
                ::Blackcurrant92::Okra92::Cassava92 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Blackcurrant92::Okra92::Cassava92\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Blackcurrant92::Okra92::Cassava92 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlackcurrant92Okra92Cassava92(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  25: {
                ::Fennell93 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Fennell93\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Fennell93 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckFennell93(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  26: {
                ::Walnuts93 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Walnuts93\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Walnuts93 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckWalnuts93(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  27: {
                ::Walnuts93::Elderberry93 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Walnuts93::Elderberry93\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Walnuts93::Elderberry93 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckWalnuts93Elderberry93(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  28: {
                ::Walnuts93::Elderberry93::RedGrapes93 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Walnuts93::Elderberry93::RedGrapes93\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Walnuts93::Elderberry93::RedGrapes93 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckWalnuts93Elderberry93RedGrapes93(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  29: {
                ::Mangetout94 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mangetout94\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mangetout94 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMangetout94(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  30: {
                ::Lettuce94 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lettuce94\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lettuce94 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLettuce94(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  31: {
                ::Lettuce94::Pomegranate94 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lettuce94::Pomegranate94\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lettuce94::Pomegranate94 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLettuce94Pomegranate94(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  32: {
                ::Lettuce94::Pomegranate94::HazelNut94 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lettuce94::Pomegranate94::HazelNut94\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lettuce94::Pomegranate94::HazelNut94 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLettuce94Pomegranate94HazelNut94(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  33: {
                ::Mustard95 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mustard95\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mustard95 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMustard95(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  34: {
                ::Daikan95 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Daikan95\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Daikan95 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckDaikan95(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  35: {
                ::Daikan95::JuniperBerries95 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Daikan95::JuniperBerries95\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Daikan95::JuniperBerries95 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckDaikan95JuniperBerries95(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  36: {
                ::Daikan95::JuniperBerries95::GooseBerry95 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Daikan95::JuniperBerries95::GooseBerry95\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Daikan95::JuniperBerries95::GooseBerry95 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckDaikan95JuniperBerries95GooseBerry95(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  37: {
                ::Fig96 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Fig96\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Fig96 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckFig96(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  38: {
                ::Lentil96 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lentil96\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lentil96 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLentil96(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  39: {
                ::Lentil96::Avocado96 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lentil96::Avocado96\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lentil96::Avocado96 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLentil96Avocado96(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  40: {
                ::Lentil96::Avocado96::Tangarine96 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lentil96::Avocado96::Tangarine96\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lentil96::Avocado96::Tangarine96 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLentil96Avocado96Tangarine96(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  41: {
                ::Shallots97 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Shallots97\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Shallots97 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckShallots97(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  42: {
                ::Onion97 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Onion97\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Onion97 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOnion97(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  43: {
                ::Onion97::RowanBerry97 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Onion97::RowanBerry97\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Onion97::RowanBerry97 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOnion97RowanBerry97(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  44: {
                ::Onion97::RowanBerry97::CantelopeMelon97 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Onion97::RowanBerry97::CantelopeMelon97\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Onion97::RowanBerry97::CantelopeMelon97 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOnion97RowanBerry97CantelopeMelon97(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  45: {
                ::GrannySmith98 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GrannySmith98\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GrannySmith98 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGrannySmith98(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  46: {
                ::Brocoli98 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Brocoli98\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Brocoli98 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBrocoli98(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  47: {
                ::Brocoli98::Tofu98 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Brocoli98::Tofu98\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Brocoli98::Tofu98 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBrocoli98Tofu98(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  48: {
                ::Brocoli98::Tofu98::Parsnip98 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Brocoli98::Tofu98::Parsnip98\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Brocoli98::Tofu98::Parsnip98 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBrocoli98Tofu98Parsnip98(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  49: {
                ::Beansprout99 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Beansprout99\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Beansprout99 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBeansprout99(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  50: {
                ::Oregano99 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Oregano99\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Oregano99 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOregano99(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  51: {
                ::Oregano99::Bayleaf99 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Oregano99::Bayleaf99\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Oregano99::Bayleaf99 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOregano99Bayleaf99(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  52: {
                ::Oregano99::Bayleaf99::WhiteCabbage99 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Oregano99::Bayleaf99::WhiteCabbage99\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Oregano99::Bayleaf99::WhiteCabbage99 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOregano99Bayleaf99WhiteCabbage99(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;

  }
  return 1;
}




