//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/getany.cpp
//
// Modifications:
// $Log: getany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:39  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1997/12/12 09:01:40  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"

//Header files generated by idl compiler
#include "tin.hh"

#include "types.hh"
extern Ernie ernie;


void GetAny(CORBA::Any &any)
{
  switch(ernie.getULong()%(12+40))
  {
    case   0: any <<= ernie.getULong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating ULong");
#endif
              break;
    case   1: any <<= ernie.getLong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Long");
#endif
              break;
    case   2: any <<= ernie.getUShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating UShort");
#endif
              break;
    case   3: any <<= ernie.getShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Short");
#endif
              break;
    case   4: any <<= CORBA::Any::from_boolean(ernie.getBoolean());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Boolean");
#endif
              break;
    case   5: any <<= CORBA::Any::from_octet(ernie.getOctet());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Octet");
#endif
              break;
    case   6: any <<= CORBA::Any::from_char(ernie.getChar());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Char");
#endif
              break;
    case   7: any <<= ernie.getFloat();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Float");
#endif
               break;
    case   8: any <<= ernie.getDouble();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Double");
#endif
              break;
    case   9: any <<= ernie.getString();
#ifdef DEBUG
              ::tet_infoline("GetAny creating String");
#endif
              break;
    case  10: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating BoundedString");
#endif
                CORBA::ULong  b;
                b = ernie.getULong()%30+1;
                any <<= CORBA::Any::from_string(ernie.getString(b),b);
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr _typecode;
#ifdef DEBUG
                ::tet_infoline("GetAny creating TypeCode");
#endif
                GetCORBATypeCode_ptr(_typecode);
                any <<= _typecode;
               }
                break;
    case   12: {
                CORBA::Any  _any;  
#ifdef DEBUG
                ::tet_infoline("GetAny creating Any");
#endif
                GetAny(_any);
                any <<= _any;
               }
                break;

    case  13: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CherryTomatoes90");
#endif
                ::CherryTomatoes90   v;

                GetCherryTomatoes90(v);

                any  <<= v;
              }
              break;

    case  14: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Peanutsquash90");
#endif
                ::Peanutsquash90   v;

                GetPeanutsquash90(v);

                any  <<= v;
              }
              break;

    case  15: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Peanutsquash90::PepinoMelon90");
#endif
                ::Peanutsquash90::PepinoMelon90   v;

                GetPeanutsquash90PepinoMelon90(v);

                any  <<= v;
              }
              break;

    case  16: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Peanutsquash90::PepinoMelon90::Pear90");
#endif
                ::Peanutsquash90::PepinoMelon90::Pear90   v;

                GetPeanutsquash90PepinoMelon90Pear90(v);

                any  <<= v;
              }
              break;

    case  17: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Papaya91");
#endif
                ::Papaya91   v;

                GetPapaya91(v);

                any  <<= v;
              }
              break;

    case  18: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cherry91");
#endif
                ::Cherry91   v;

                GetCherry91(v);

                any  <<= v;
              }
              break;

    case  19: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cherry91::Sharanfruit91");
#endif
                ::Cherry91::Sharanfruit91   v;

                GetCherry91Sharanfruit91(v);

                any  <<= v;
              }
              break;

    case  20: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cherry91::Sharanfruit91::BeefTomatoes91");
#endif
                ::Cherry91::Sharanfruit91::BeefTomatoes91   v;

                GetCherry91Sharanfruit91BeefTomatoes91(v);

                any  <<= v;
              }
              break;

    case  21: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pineapple92");
#endif
                ::Pineapple92   v;

                GetPineapple92(v);

                any  <<= v;
              }
              break;

    case  22: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Blackcurrant92");
#endif
                ::Blackcurrant92   v;

                GetBlackcurrant92(v);

                any  <<= v;
              }
              break;

    case  23: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Blackcurrant92::Okra92");
#endif
                ::Blackcurrant92::Okra92   v;

                GetBlackcurrant92Okra92(v);

                any  <<= v;
              }
              break;

    case  24: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Blackcurrant92::Okra92::Cassava92");
#endif
                ::Blackcurrant92::Okra92::Cassava92   v;

                GetBlackcurrant92Okra92Cassava92(v);

                any  <<= v;
              }
              break;

    case  25: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Fennell93");
#endif
                ::Fennell93   v;

                GetFennell93(v);

                any  <<= v;
              }
              break;

    case  26: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Walnuts93");
#endif
                ::Walnuts93   v;

                GetWalnuts93(v);

                any  <<= v;
              }
              break;

    case  27: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Walnuts93::Elderberry93");
#endif
                ::Walnuts93::Elderberry93   v;

                GetWalnuts93Elderberry93(v);

                any  <<= v;
              }
              break;

    case  28: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Walnuts93::Elderberry93::RedGrapes93");
#endif
                ::Walnuts93::Elderberry93::RedGrapes93   v;

                GetWalnuts93Elderberry93RedGrapes93(v);

                any  <<= v;
              }
              break;

    case  29: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mangetout94");
#endif
                ::Mangetout94   v;

                GetMangetout94(v);

                any  <<= v;
              }
              break;

    case  30: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lettuce94");
#endif
                ::Lettuce94   v;

                GetLettuce94(v);

                any  <<= v;
              }
              break;

    case  31: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lettuce94::Pomegranate94");
#endif
                ::Lettuce94::Pomegranate94   v;

                GetLettuce94Pomegranate94(v);

                any  <<= v;
              }
              break;

    case  32: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lettuce94::Pomegranate94::HazelNut94");
#endif
                ::Lettuce94::Pomegranate94::HazelNut94   v;

                GetLettuce94Pomegranate94HazelNut94(v);

                any  <<= v;
              }
              break;

    case  33: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mustard95");
#endif
                ::Mustard95   v;

                GetMustard95(v);

                any  <<= v;
              }
              break;

    case  34: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Daikan95");
#endif
                ::Daikan95   v;

                GetDaikan95(v);

                any  <<= v;
              }
              break;

    case  35: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Daikan95::JuniperBerries95");
#endif
                ::Daikan95::JuniperBerries95   v;

                GetDaikan95JuniperBerries95(v);

                any  <<= v;
              }
              break;

    case  36: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Daikan95::JuniperBerries95::GooseBerry95");
#endif
                ::Daikan95::JuniperBerries95::GooseBerry95   v;

                GetDaikan95JuniperBerries95GooseBerry95(v);

                any  <<= v;
              }
              break;

    case  37: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Fig96");
#endif
                ::Fig96   v;

                GetFig96(v);

                any  <<= v;
              }
              break;

    case  38: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lentil96");
#endif
                ::Lentil96   v;

                GetLentil96(v);

                any  <<= v;
              }
              break;

    case  39: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lentil96::Avocado96");
#endif
                ::Lentil96::Avocado96   v;

                GetLentil96Avocado96(v);

                any  <<= v;
              }
              break;

    case  40: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lentil96::Avocado96::Tangarine96");
#endif
                ::Lentil96::Avocado96::Tangarine96   v;

                GetLentil96Avocado96Tangarine96(v);

                any  <<= v;
              }
              break;

    case  41: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Shallots97");
#endif
                ::Shallots97   v;

                GetShallots97(v);

                any  <<= v;
              }
              break;

    case  42: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Onion97");
#endif
                ::Onion97   v;

                GetOnion97(v);

                any  <<= v;
              }
              break;

    case  43: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Onion97::RowanBerry97");
#endif
                ::Onion97::RowanBerry97   v;

                GetOnion97RowanBerry97(v);

                any  <<= v;
              }
              break;

    case  44: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Onion97::RowanBerry97::CantelopeMelon97");
#endif
                ::Onion97::RowanBerry97::CantelopeMelon97   v;

                GetOnion97RowanBerry97CantelopeMelon97(v);

                any  <<= v;
              }
              break;

    case  45: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GrannySmith98");
#endif
                ::GrannySmith98   v;

                GetGrannySmith98(v);

                any  <<= v;
              }
              break;

    case  46: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Brocoli98");
#endif
                ::Brocoli98   v;

                GetBrocoli98(v);

                any  <<= v;
              }
              break;

    case  47: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Brocoli98::Tofu98");
#endif
                ::Brocoli98::Tofu98   v;

                GetBrocoli98Tofu98(v);

                any  <<= v;
              }
              break;

    case  48: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Brocoli98::Tofu98::Parsnip98");
#endif
                ::Brocoli98::Tofu98::Parsnip98   v;

                GetBrocoli98Tofu98Parsnip98(v);

                any  <<= v;
              }
              break;

    case  49: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Beansprout99");
#endif
                ::Beansprout99   v;

                GetBeansprout99(v);

                any  <<= v;
              }
              break;

    case  50: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Oregano99");
#endif
                ::Oregano99   v;

                GetOregano99(v);

                any  <<= v;
              }
              break;

    case  51: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Oregano99::Bayleaf99");
#endif
                ::Oregano99::Bayleaf99   v;

                GetOregano99Bayleaf99(v);

                any  <<= v;
              }
              break;

    case  52: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Oregano99::Bayleaf99::WhiteCabbage99");
#endif
                ::Oregano99::Bayleaf99::WhiteCabbage99   v;

                GetOregano99Bayleaf99WhiteCabbage99(v);

                any  <<= v;
              }
              break;

  }
}


