//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::CherryTomatoes90*
idlServer_imp::CherryTomatoes90Attr( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  ::CherryTomatoes90* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CherryTomatoes90Attr\n");
#endif
  
  ernie.seed("CherryTomatoes90AttrCall");
  
  ernie.seed("CherryTomatoes90AttrReturn"); 
  ReturnValue = new ::CherryTomatoes90;
  GetCherryTomatoes90(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CherryTomatoes90Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::CherryTomatoes90Attr(const ::CherryTomatoes90 &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CherryTomatoes90Attr\n");
#endif
  
  ernie.seed("CherryTomatoes90AttrCall");
  AddName("_attr");
  if (!CheckCherryTomatoes90(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CherryTomatoes90AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CherryTomatoes90Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::CherryTomatoes90*
idlServer_imp::CherryTomatoes90Op(const ::CherryTomatoes90 &p1,::CherryTomatoes90_out p2,::CherryTomatoes90 &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::CherryTomatoes90* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CherryTomatoes90Op\n");
#endif
  
  ernie.seed("CherryTomatoes90OpCall");
  AddName("p1");
  if (!CheckCherryTomatoes90(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCherryTomatoes90(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CherryTomatoes90OpReturn"); 
  {
    ::idlServer::CherryTomatoes90Excpt ex;
    GetidlServerCherryTomatoes90Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::CherryTomatoes90;
  GetCherryTomatoes90(*ReturnValue);
  p2 = new ::CherryTomatoes90;
  GetCherryTomatoes90(*(p2.ptr()));
  GetCherryTomatoes90(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CherryTomatoes90Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Peanutsquash90*
idlServer_imp::Peanutsquash90Attr( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  ::Peanutsquash90* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Peanutsquash90Attr\n");
#endif
  
  ernie.seed("Peanutsquash90AttrCall");
  
  ernie.seed("Peanutsquash90AttrReturn"); 
  ReturnValue = new ::Peanutsquash90;
  GetPeanutsquash90(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Peanutsquash90Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Peanutsquash90Attr(const ::Peanutsquash90 &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Peanutsquash90Attr\n");
#endif
  
  ernie.seed("Peanutsquash90AttrCall");
  AddName("_attr");
  if (!CheckPeanutsquash90(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Peanutsquash90AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Peanutsquash90Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Peanutsquash90*
idlServer_imp::Peanutsquash90Op(const ::Peanutsquash90 &p1,::Peanutsquash90_out p2,::Peanutsquash90 &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Peanutsquash90* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Peanutsquash90Op\n");
#endif
  
  ernie.seed("Peanutsquash90OpCall");
  AddName("p1");
  if (!CheckPeanutsquash90(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPeanutsquash90(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Peanutsquash90OpReturn"); 
  {
    ::idlServer::Peanutsquash90Excpt ex;
    GetidlServerPeanutsquash90Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Peanutsquash90;
  GetPeanutsquash90(*ReturnValue);
  p2 = new ::Peanutsquash90;
  GetPeanutsquash90(*(p2.ptr()));
  GetPeanutsquash90(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Peanutsquash90Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Peanutsquash90::PepinoMelon90*
idlServer_imp::PepinoMelon90Attr( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  ::Peanutsquash90::PepinoMelon90* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PepinoMelon90Attr\n");
#endif
  
  ernie.seed("PepinoMelon90AttrCall");
  
  ernie.seed("PepinoMelon90AttrReturn"); 
  ReturnValue = new ::Peanutsquash90::PepinoMelon90;
  GetPeanutsquash90PepinoMelon90(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PepinoMelon90Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::PepinoMelon90Attr(const ::Peanutsquash90::PepinoMelon90 &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PepinoMelon90Attr\n");
#endif
  
  ernie.seed("PepinoMelon90AttrCall");
  AddName("_attr");
  if (!CheckPeanutsquash90PepinoMelon90(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PepinoMelon90AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PepinoMelon90Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Peanutsquash90::PepinoMelon90*
idlServer_imp::PepinoMelon90Op(const ::Peanutsquash90::PepinoMelon90 &p1,::Peanutsquash90::PepinoMelon90_out p2,::Peanutsquash90::PepinoMelon90 &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Peanutsquash90::PepinoMelon90* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PepinoMelon90Op\n");
#endif
  
  ernie.seed("PepinoMelon90OpCall");
  AddName("p1");
  if (!CheckPeanutsquash90PepinoMelon90(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPeanutsquash90PepinoMelon90(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PepinoMelon90OpReturn"); 
  {
    ::idlServer::PepinoMelon90Excpt ex;
    GetidlServerPepinoMelon90Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Peanutsquash90::PepinoMelon90;
  GetPeanutsquash90PepinoMelon90(*ReturnValue);
  p2 = new ::Peanutsquash90::PepinoMelon90;
  GetPeanutsquash90PepinoMelon90(*(p2.ptr()));
  GetPeanutsquash90PepinoMelon90(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PepinoMelon90Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Peanutsquash90::PepinoMelon90::Pear90*
idlServer_imp::Pear90Attr( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  ::Peanutsquash90::PepinoMelon90::Pear90* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Pear90Attr\n");
#endif
  
  ernie.seed("Pear90AttrCall");
  
  ernie.seed("Pear90AttrReturn"); 
  ReturnValue = new ::Peanutsquash90::PepinoMelon90::Pear90;
  GetPeanutsquash90PepinoMelon90Pear90(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Pear90Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Pear90Attr(const ::Peanutsquash90::PepinoMelon90::Pear90 &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Pear90Attr\n");
#endif
  
  ernie.seed("Pear90AttrCall");
  AddName("_attr");
  if (!CheckPeanutsquash90PepinoMelon90Pear90(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Pear90AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Pear90Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Peanutsquash90::PepinoMelon90::Pear90*
idlServer_imp::Pear90Op(const ::Peanutsquash90::PepinoMelon90::Pear90 &p1,::Peanutsquash90::PepinoMelon90::Pear90_out p2,::Peanutsquash90::PepinoMelon90::Pear90 &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Peanutsquash90::PepinoMelon90::Pear90* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Pear90Op\n");
#endif
  
  ernie.seed("Pear90OpCall");
  AddName("p1");
  if (!CheckPeanutsquash90PepinoMelon90Pear90(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPeanutsquash90PepinoMelon90Pear90(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Pear90OpReturn"); 
  {
    ::idlServer::Pear90Excpt ex;
    GetidlServerPear90Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Peanutsquash90::PepinoMelon90::Pear90;
  GetPeanutsquash90PepinoMelon90Pear90(*ReturnValue);
  p2 = new ::Peanutsquash90::PepinoMelon90::Pear90;
  GetPeanutsquash90PepinoMelon90Pear90(*(p2.ptr()));
  GetPeanutsquash90PepinoMelon90Pear90(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Pear90Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Papaya91*
idlServer_imp::Papaya91Attr( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  ::Papaya91* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Papaya91Attr\n");
#endif
  
  ernie.seed("Papaya91AttrCall");
  
  ernie.seed("Papaya91AttrReturn"); 
  ReturnValue = new ::Papaya91;
  GetPapaya91(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Papaya91Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Papaya91Attr(const ::Papaya91 &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Papaya91Attr\n");
#endif
  
  ernie.seed("Papaya91AttrCall");
  AddName("_attr");
  if (!CheckPapaya91(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Papaya91AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Papaya91Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Papaya91*
idlServer_imp::Papaya91Op(const ::Papaya91 &p1,::Papaya91_out p2,::Papaya91 &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Papaya91* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Papaya91Op\n");
#endif
  
  ernie.seed("Papaya91OpCall");
  AddName("p1");
  if (!CheckPapaya91(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPapaya91(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Papaya91OpReturn"); 
  {
    ::idlServer::Papaya91Excpt ex;
    GetidlServerPapaya91Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Papaya91;
  GetPapaya91(*ReturnValue);
  p2 = new ::Papaya91;
  GetPapaya91(*(p2.ptr()));
  GetPapaya91(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Papaya91Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Cherry91*
idlServer_imp::Cherry91Attr( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  ::Cherry91* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Cherry91Attr\n");
#endif
  
  ernie.seed("Cherry91AttrCall");
  
  ernie.seed("Cherry91AttrReturn"); 
  ReturnValue = new ::Cherry91;
  GetCherry91(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Cherry91Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Cherry91Attr(const ::Cherry91 &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Cherry91Attr\n");
#endif
  
  ernie.seed("Cherry91AttrCall");
  AddName("_attr");
  if (!CheckCherry91(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cherry91AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Cherry91Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Cherry91*
idlServer_imp::Cherry91Op(const ::Cherry91 &p1,::Cherry91_out p2,::Cherry91 &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Cherry91* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Cherry91Op\n");
#endif
  
  ernie.seed("Cherry91OpCall");
  AddName("p1");
  if (!CheckCherry91(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCherry91(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cherry91OpReturn"); 
  {
    ::idlServer::Cherry91Excpt ex;
    GetidlServerCherry91Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Cherry91;
  GetCherry91(*ReturnValue);
  p2 = new ::Cherry91;
  GetCherry91(*(p2.ptr()));
  GetCherry91(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Cherry91Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Cherry91::Sharanfruit91*
idlServer_imp::Sharanfruit91Attr( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  ::Cherry91::Sharanfruit91* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sharanfruit91Attr\n");
#endif
  
  ernie.seed("Sharanfruit91AttrCall");
  
  ernie.seed("Sharanfruit91AttrReturn"); 
  ReturnValue = new ::Cherry91::Sharanfruit91;
  GetCherry91Sharanfruit91(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sharanfruit91Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Sharanfruit91Attr(const ::Cherry91::Sharanfruit91 &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sharanfruit91Attr\n");
#endif
  
  ernie.seed("Sharanfruit91AttrCall");
  AddName("_attr");
  if (!CheckCherry91Sharanfruit91(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sharanfruit91AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sharanfruit91Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Cherry91::Sharanfruit91*
idlServer_imp::Sharanfruit91Op(const ::Cherry91::Sharanfruit91 &p1,::Cherry91::Sharanfruit91_out p2,::Cherry91::Sharanfruit91 &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Cherry91::Sharanfruit91* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sharanfruit91Op\n");
#endif
  
  ernie.seed("Sharanfruit91OpCall");
  AddName("p1");
  if (!CheckCherry91Sharanfruit91(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCherry91Sharanfruit91(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sharanfruit91OpReturn"); 
  {
    ::idlServer::Sharanfruit91Excpt ex;
    GetidlServerSharanfruit91Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Cherry91::Sharanfruit91;
  GetCherry91Sharanfruit91(*ReturnValue);
  p2 = new ::Cherry91::Sharanfruit91;
  GetCherry91Sharanfruit91(*(p2.ptr()));
  GetCherry91Sharanfruit91(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sharanfruit91Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Cherry91::Sharanfruit91::BeefTomatoes91*
idlServer_imp::BeefTomatoes91Attr( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  ::Cherry91::Sharanfruit91::BeefTomatoes91* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BeefTomatoes91Attr\n");
#endif
  
  ernie.seed("BeefTomatoes91AttrCall");
  
  ernie.seed("BeefTomatoes91AttrReturn"); 
  ReturnValue = new ::Cherry91::Sharanfruit91::BeefTomatoes91;
  GetCherry91Sharanfruit91BeefTomatoes91(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BeefTomatoes91Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BeefTomatoes91Attr(const ::Cherry91::Sharanfruit91::BeefTomatoes91 &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BeefTomatoes91Attr\n");
#endif
  
  ernie.seed("BeefTomatoes91AttrCall");
  AddName("_attr");
  if (!CheckCherry91Sharanfruit91BeefTomatoes91(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BeefTomatoes91AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BeefTomatoes91Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Cherry91::Sharanfruit91::BeefTomatoes91*
idlServer_imp::BeefTomatoes91Op(const ::Cherry91::Sharanfruit91::BeefTomatoes91 &p1,::Cherry91::Sharanfruit91::BeefTomatoes91_out p2,::Cherry91::Sharanfruit91::BeefTomatoes91 &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Cherry91::Sharanfruit91::BeefTomatoes91* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BeefTomatoes91Op\n");
#endif
  
  ernie.seed("BeefTomatoes91OpCall");
  AddName("p1");
  if (!CheckCherry91Sharanfruit91BeefTomatoes91(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCherry91Sharanfruit91BeefTomatoes91(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BeefTomatoes91OpReturn"); 
  {
    ::idlServer::BeefTomatoes91Excpt ex;
    GetidlServerBeefTomatoes91Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Cherry91::Sharanfruit91::BeefTomatoes91;
  GetCherry91Sharanfruit91BeefTomatoes91(*ReturnValue);
  p2 = new ::Cherry91::Sharanfruit91::BeefTomatoes91;
  GetCherry91Sharanfruit91BeefTomatoes91(*(p2.ptr()));
  GetCherry91Sharanfruit91BeefTomatoes91(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BeefTomatoes91Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



