//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/client.cpp
//
// Modifications:
// $Log: client.cpp,v $
// Revision 1.2  2000/03/29 17:10:47  mli
//   o   remove 'CORBA::Environment ev;'
//   o   int initialise
//
// Revision 1.1.1.1  2000/02/09 17:16:40  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1997/12/12 09:02:39  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern OrbSupport *orb;
extern char *stringifiedIOR;

static int initialised = 0;
CORBA::Object_ptr obj;
idlServer_ptr  tobj;

void
initialise()
{
    if (!initialised)
    {

#ifdef DEBUG
	  ::tet_infoline("client: connecting to proxy");
	  ::tet_printf("client: using %s", stringifiedIOR);
#endif
	  
	  try {
	      obj = orb->getObject(stringifiedIOR);
	  }
	  catch (CORBA::SystemException &ex) {
	      ::tet_infoline("client: getObj failed");
	      ::tet_printf("client: minor code %d", ex.minor());
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  if (obj == 0)
	  {
	      ::tet_infoline("client: failed connecting to proxy");
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  try {
	      tobj = idlServer::_narrow(obj);
	  }
	  catch (CORBA::Exception &ex) {
	      ::tet_infoline("client: failed to narrow object reference.");
	  }
	  initialised = 1;

	  char * tout = 0;
	  tout = getenv("VSORB_EVENT_TIMEOUT");

	  unsigned long timeout = (tout) ? atoi(tout) : 15;
	  orb->setTimeout(tobj, timeout);
      }
    
}

#ifdef VSORB_IDL_TESTS

void testIDL()
{
  char buf1[1024];

::tet_result(TET_PASS);
}
 
#endif



 
void testidlServerCinnamon114Attr(void)
{
  
  ::Cinnamon114* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Cinnamon114* ::idlServer::Cinnamon114Attr()");
#endif
  
  ernie.seed("Cinnamon114AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Cinnamon114AttrReturn");
  try {
    ReturnValue = tobj->Cinnamon114Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Cinnamon114Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckCinnamon114(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCinnamon114AttrW(void)
{
  
  ::Cinnamon114 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Cinnamon114Attr(const ::Cinnamon114 &_attr)");
#endif
  
  ernie.seed("Cinnamon114AttrCall");
  GetCinnamon114(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Cinnamon114AttrReturn");
  try {
     tobj->Cinnamon114Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Cinnamon114Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCinnamon114Op(void)
{
  
  ::Cinnamon114* ReturnValue;
  ::Cinnamon114 p1;
  ::Cinnamon114* p2;
  ::Cinnamon114 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Cinnamon114* ::idlServer::Cinnamon114Op(const ::Cinnamon114 &p1,::Cinnamon114 *&p2,::Cinnamon114 &p3)");
#endif
  
  ernie.seed("Cinnamon114OpCall");
  GetCinnamon114(p1);
  GetCinnamon114(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Cinnamon114OpReturn");
  try {
    ReturnValue = tobj->Cinnamon114Op(p1,p2,p3);
  }
  catch (::idlServer::Cinnamon114Excpt &ex){
    if (!CheckidlServerCinnamon114Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Cinnamon114Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckCinnamon114(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckCinnamon114(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCinnamon114(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerHazelNut114Attr(void)
{
  
  ::HazelNut114* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::HazelNut114* ::idlServer::HazelNut114Attr()");
#endif
  
  ernie.seed("HazelNut114AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("HazelNut114AttrReturn");
  try {
    ReturnValue = tobj->HazelNut114Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::HazelNut114Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckHazelNut114(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerHazelNut114AttrW(void)
{
  
  ::HazelNut114 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::HazelNut114Attr(const ::HazelNut114 &_attr)");
#endif
  
  ernie.seed("HazelNut114AttrCall");
  GetHazelNut114(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("HazelNut114AttrReturn");
  try {
     tobj->HazelNut114Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::HazelNut114Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerHazelNut114Op(void)
{
  
  ::HazelNut114* ReturnValue;
  ::HazelNut114 p1;
  ::HazelNut114* p2;
  ::HazelNut114 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::HazelNut114* ::idlServer::HazelNut114Op(const ::HazelNut114 &p1,::HazelNut114 *&p2,::HazelNut114 &p3)");
#endif
  
  ernie.seed("HazelNut114OpCall");
  GetHazelNut114(p1);
  GetHazelNut114(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("HazelNut114OpReturn");
  try {
    ReturnValue = tobj->HazelNut114Op(p1,p2,p3);
  }
  catch (::idlServer::HazelNut114Excpt &ex){
    if (!CheckidlServerHazelNut114Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::HazelNut114Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckHazelNut114(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckHazelNut114(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckHazelNut114(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCrabApple114Attr(void)
{
  
  ::HazelNut114::CrabApple114* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::HazelNut114::CrabApple114* ::idlServer::CrabApple114Attr()");
#endif
  
  ernie.seed("CrabApple114AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("CrabApple114AttrReturn");
  try {
    ReturnValue = tobj->CrabApple114Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::CrabApple114Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckHazelNut114CrabApple114(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCrabApple114AttrW(void)
{
  
  ::HazelNut114::CrabApple114 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::CrabApple114Attr(const ::HazelNut114::CrabApple114 &_attr)");
#endif
  
  ernie.seed("CrabApple114AttrCall");
  GetHazelNut114CrabApple114(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("CrabApple114AttrReturn");
  try {
     tobj->CrabApple114Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::CrabApple114Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCrabApple114Op(void)
{
  
  ::HazelNut114::CrabApple114* ReturnValue;
  ::HazelNut114::CrabApple114 p1;
  ::HazelNut114::CrabApple114* p2;
  ::HazelNut114::CrabApple114 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::HazelNut114::CrabApple114* ::idlServer::CrabApple114Op(const ::HazelNut114::CrabApple114 &p1,::HazelNut114::CrabApple114 *&p2,::HazelNut114::CrabApple114 &p3)");
#endif
  
  ernie.seed("CrabApple114OpCall");
  GetHazelNut114CrabApple114(p1);
  GetHazelNut114CrabApple114(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("CrabApple114OpReturn");
  try {
    ReturnValue = tobj->CrabApple114Op(p1,p2,p3);
  }
  catch (::idlServer::CrabApple114Excpt &ex){
    if (!CheckidlServerCrabApple114Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::CrabApple114Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckHazelNut114CrabApple114(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckHazelNut114CrabApple114(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckHazelNut114CrabApple114(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerLentil114Attr(void)
{
  
  ::HazelNut114::CrabApple114::Lentil114* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::HazelNut114::CrabApple114::Lentil114* ::idlServer::Lentil114Attr()");
#endif
  
  ernie.seed("Lentil114AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Lentil114AttrReturn");
  try {
    ReturnValue = tobj->Lentil114Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Lentil114Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckHazelNut114CrabApple114Lentil114(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerLentil114AttrW(void)
{
  
  ::HazelNut114::CrabApple114::Lentil114 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Lentil114Attr(const ::HazelNut114::CrabApple114::Lentil114 &_attr)");
#endif
  
  ernie.seed("Lentil114AttrCall");
  GetHazelNut114CrabApple114Lentil114(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Lentil114AttrReturn");
  try {
     tobj->Lentil114Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Lentil114Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerLentil114Op(void)
{
  
  ::HazelNut114::CrabApple114::Lentil114* ReturnValue;
  ::HazelNut114::CrabApple114::Lentil114 p1;
  ::HazelNut114::CrabApple114::Lentil114* p2;
  ::HazelNut114::CrabApple114::Lentil114 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::HazelNut114::CrabApple114::Lentil114* ::idlServer::Lentil114Op(const ::HazelNut114::CrabApple114::Lentil114 &p1,::HazelNut114::CrabApple114::Lentil114 *&p2,::HazelNut114::CrabApple114::Lentil114 &p3)");
#endif
  
  ernie.seed("Lentil114OpCall");
  GetHazelNut114CrabApple114Lentil114(p1);
  GetHazelNut114CrabApple114Lentil114(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Lentil114OpReturn");
  try {
    ReturnValue = tobj->Lentil114Op(p1,p2,p3);
  }
  catch (::idlServer::Lentil114Excpt &ex){
    if (!CheckidlServerLentil114Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Lentil114Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckHazelNut114CrabApple114Lentil114(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckHazelNut114CrabApple114Lentil114(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckHazelNut114CrabApple114Lentil114(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerKidneyBean115Attr(void)
{
  
  ::KidneyBean115* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::KidneyBean115* ::idlServer::KidneyBean115Attr()");
#endif
  
  ernie.seed("KidneyBean115AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("KidneyBean115AttrReturn");
  try {
    ReturnValue = tobj->KidneyBean115Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::KidneyBean115Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckKidneyBean115(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerKidneyBean115AttrW(void)
{
  
  ::KidneyBean115 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::KidneyBean115Attr(const ::KidneyBean115 &_attr)");
#endif
  
  ernie.seed("KidneyBean115AttrCall");
  GetKidneyBean115(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("KidneyBean115AttrReturn");
  try {
     tobj->KidneyBean115Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::KidneyBean115Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerKidneyBean115Op(void)
{
  
  ::KidneyBean115* ReturnValue;
  ::KidneyBean115 p1;
  ::KidneyBean115* p2;
  ::KidneyBean115 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::KidneyBean115* ::idlServer::KidneyBean115Op(const ::KidneyBean115 &p1,::KidneyBean115 *&p2,::KidneyBean115 &p3)");
#endif
  
  ernie.seed("KidneyBean115OpCall");
  GetKidneyBean115(p1);
  GetKidneyBean115(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("KidneyBean115OpReturn");
  try {
    ReturnValue = tobj->KidneyBean115Op(p1,p2,p3);
  }
  catch (::idlServer::KidneyBean115Excpt &ex){
    if (!CheckidlServerKidneyBean115Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::KidneyBean115Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckKidneyBean115(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckKidneyBean115(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckKidneyBean115(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPlum115Attr(void)
{
  
  ::Plum115* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Plum115* ::idlServer::Plum115Attr()");
#endif
  
  ernie.seed("Plum115AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Plum115AttrReturn");
  try {
    ReturnValue = tobj->Plum115Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Plum115Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPlum115(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPlum115AttrW(void)
{
  
  ::Plum115 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Plum115Attr(const ::Plum115 &_attr)");
#endif
  
  ernie.seed("Plum115AttrCall");
  GetPlum115(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Plum115AttrReturn");
  try {
     tobj->Plum115Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Plum115Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerPlum115Op(void)
{
  
  ::Plum115* ReturnValue;
  ::Plum115 p1;
  ::Plum115* p2;
  ::Plum115 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Plum115* ::idlServer::Plum115Op(const ::Plum115 &p1,::Plum115 *&p2,::Plum115 &p3)");
#endif
  
  ernie.seed("Plum115OpCall");
  GetPlum115(p1);
  GetPlum115(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Plum115OpReturn");
  try {
    ReturnValue = tobj->Plum115Op(p1,p2,p3);
  }
  catch (::idlServer::Plum115Excpt &ex){
    if (!CheckidlServerPlum115Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Plum115Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPlum115(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckPlum115(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPlum115(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerOnion115Attr(void)
{
  
  ::Plum115::Onion115* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Plum115::Onion115* ::idlServer::Onion115Attr()");
#endif
  
  ernie.seed("Onion115AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Onion115AttrReturn");
  try {
    ReturnValue = tobj->Onion115Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Onion115Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPlum115Onion115(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerOnion115AttrW(void)
{
  
  ::Plum115::Onion115 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Onion115Attr(const ::Plum115::Onion115 &_attr)");
#endif
  
  ernie.seed("Onion115AttrCall");
  GetPlum115Onion115(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Onion115AttrReturn");
  try {
     tobj->Onion115Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Onion115Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerOnion115Op(void)
{
  
  ::Plum115::Onion115* ReturnValue;
  ::Plum115::Onion115 p1;
  ::Plum115::Onion115* p2;
  ::Plum115::Onion115 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Plum115::Onion115* ::idlServer::Onion115Op(const ::Plum115::Onion115 &p1,::Plum115::Onion115 *&p2,::Plum115::Onion115 &p3)");
#endif
  
  ernie.seed("Onion115OpCall");
  GetPlum115Onion115(p1);
  GetPlum115Onion115(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Onion115OpReturn");
  try {
    ReturnValue = tobj->Onion115Op(p1,p2,p3);
  }
  catch (::idlServer::Onion115Excpt &ex){
    if (!CheckidlServerOnion115Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Onion115Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPlum115Onion115(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckPlum115Onion115(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPlum115Onion115(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerTofu115Attr(void)
{
  
  ::Plum115::Onion115::Tofu115* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Plum115::Onion115::Tofu115* ::idlServer::Tofu115Attr()");
#endif
  
  ernie.seed("Tofu115AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Tofu115AttrReturn");
  try {
    ReturnValue = tobj->Tofu115Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Tofu115Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPlum115Onion115Tofu115(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerTofu115AttrW(void)
{
  
  ::Plum115::Onion115::Tofu115 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Tofu115Attr(const ::Plum115::Onion115::Tofu115 &_attr)");
#endif
  
  ernie.seed("Tofu115AttrCall");
  GetPlum115Onion115Tofu115(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Tofu115AttrReturn");
  try {
     tobj->Tofu115Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Tofu115Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerTofu115Op(void)
{
  
  ::Plum115::Onion115::Tofu115* ReturnValue;
  ::Plum115::Onion115::Tofu115 p1;
  ::Plum115::Onion115::Tofu115* p2;
  ::Plum115::Onion115::Tofu115 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Plum115::Onion115::Tofu115* ::idlServer::Tofu115Op(const ::Plum115::Onion115::Tofu115 &p1,::Plum115::Onion115::Tofu115 *&p2,::Plum115::Onion115::Tofu115 &p3)");
#endif
  
  ernie.seed("Tofu115OpCall");
  GetPlum115Onion115Tofu115(p1);
  GetPlum115Onion115Tofu115(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Tofu115OpReturn");
  try {
    ReturnValue = tobj->Tofu115Op(p1,p2,p3);
  }
  catch (::idlServer::Tofu115Excpt &ex){
    if (!CheckidlServerTofu115Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Tofu115Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckPlum115Onion115Tofu115(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckPlum115Onion115Tofu115(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPlum115Onion115Tofu115(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerBillberries116Attr(void)
{
  
  ::Billberries116* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Billberries116* ::idlServer::Billberries116Attr()");
#endif
  
  ernie.seed("Billberries116AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Billberries116AttrReturn");
  try {
    ReturnValue = tobj->Billberries116Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Billberries116Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckBillberries116(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerBillberries116AttrW(void)
{
  
  ::Billberries116 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Billberries116Attr(const ::Billberries116 &_attr)");
#endif
  
  ernie.seed("Billberries116AttrCall");
  GetBillberries116(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Billberries116AttrReturn");
  try {
     tobj->Billberries116Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Billberries116Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerBillberries116Op(void)
{
  
  ::Billberries116* ReturnValue;
  ::Billberries116 p1;
  ::Billberries116* p2;
  ::Billberries116 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Billberries116* ::idlServer::Billberries116Op(const ::Billberries116 &p1,::Billberries116 *&p2,::Billberries116 &p3)");
#endif
  
  ernie.seed("Billberries116OpCall");
  GetBillberries116(p1);
  GetBillberries116(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Billberries116OpReturn");
  try {
    ReturnValue = tobj->Billberries116Op(p1,p2,p3);
  }
  catch (::idlServer::Billberries116Excpt &ex){
    if (!CheckidlServerBillberries116Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Billberries116Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckBillberries116(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckBillberries116(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBillberries116(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


