//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/checkany.cpp
//
// Modifications:
// $Log: checkany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:41  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/26 13:51:49  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/12 09:02:41  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern char name[];

 
int CheckAny(const CORBA::Any &any)
{
  switch(ernie.getULong()%(12+36))
  {
    case   0: {
                CORBA::ULong  v;
#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::ULong");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::ULong as expected", name);
                  return 0;
                }
                if (!ernie.checkULong(v))
                {
                  tet_printf("Expected %s to contain CORBA::ULong with value %u, but found %u instead.",
                    name,ernie.getULongAgain(),v);
                  return 0;
                }
              }
              break;
    case   1: {
                CORBA::Long  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Long");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Long as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkLong(v))
                {
                  tet_printf("Expected %s to contain CORBA::Long with value %d, but found %d instead.",
                    name,ernie.getLongAgain(),v);
                  return 0;
                }
              }
              break;
    case   2: {
                CORBA::UShort  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::UShort");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::UShort as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkUShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::UShort with value %u, but found %u instead.",
                    name,ernie.getUShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   3: {
                CORBA::Short  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Short");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Short as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::Short with value %d, but found %d instead.",
                    name,ernie.getShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   4: {
                CORBA::Boolean  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Boolean");
#endif
                if (!(any >>= CORBA::Any::to_boolean(v)))
                {
                  tet_printf("%s did not contain a CORBA::Boolean as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkBoolean(v))
                {
                  tet_printf("Expected %s to contain CORBA::Boolean with value %s, but found %s instead.",
                    name,
                    BooleanToString(ernie.getBooleanAgain()),
                    BooleanToString(v));
                  return 0;
                }
              }
              break;
    case   5: {
                CORBA::Octet  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Octet");
#endif
                if (!(any >>= CORBA::Any::to_octet(v)))
                {
                  tet_printf("%s did not contain a CORBA::Octet as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkOctet(v))
                {
                  ::tet_printf("Expected %s to contain CORBA::Octet with value %s, but found %s instead.",
                    name,
                    OctetToString(ernie.getOctetAgain()),
                    OctetToString(v));
                  return 0;
                }
              }
              break;
    case   6: {
                CORBA::Char  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Char");
#endif
                if (!(any >>= CORBA::Any::to_char(v)))
                {
                  tet_printf("%s did not contain a CORBA::Char as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkChar(v))
                {
                  tet_printf("Expected %s to contain CORBA::Char with value %s, but found %s instead.",
                    name,
                    CharToString(ernie.getCharAgain()),
                    CharToString(v));
                  return 0;
                }
              }
              break;
    case   7: {
                CORBA::Float  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Float");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Float as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkFloat(v))
                {
                  tet_printf("Expected %s to contain CORBA::Float with value %g, but found %g instead.",
                    name,
                    ernie.getFloatAgain(),
                    v);
                  return 0;
                }
              }
               break;
    case   8: {
                CORBA::Double  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Double");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Double as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkDouble(v))
                {
                  tet_printf("Expected %s to contain CORBA::Double with value %g, but found %g instead.",
                    name,
                    ernie.getDoubleAgain(),
                    v);
                  return 0;
                }
              }
              break;
    case   9: {
                char *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting char*");
#endif
                if (!(any >>= CORBA::Any::to_string(v,0)))
                {
                  tet_printf("%s did not contain a char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v))
                {
                  tet_printf("Expected %s to contain char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case  10: {
                CORBA::ULong  b;
                char   *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting bounded char*");
#endif
                b = ernie.getULong()%30+1;

                if (!(any >>= CORBA::Any::to_string(v,b)))
                {
                  tet_printf("%s did not contain a bounded char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v,b))
                {
                  tet_printf("Expected %s to contain a bounded char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::TypeCode");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::TypeCode as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCORBATypeCode_ptr(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case   12: {
                CORBA::Any  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Any");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Any as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAny(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  13: {
                ::Cinnamon114 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cinnamon114\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cinnamon114 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCinnamon114(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  14: {
                ::HazelNut114 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::HazelNut114\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::HazelNut114 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckHazelNut114(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  15: {
                ::HazelNut114::CrabApple114 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::HazelNut114::CrabApple114\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::HazelNut114::CrabApple114 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckHazelNut114CrabApple114(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  16: {
                ::HazelNut114::CrabApple114::Lentil114 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::HazelNut114::CrabApple114::Lentil114\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::HazelNut114::CrabApple114::Lentil114 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckHazelNut114CrabApple114Lentil114(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  17: {
                ::KidneyBean115 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::KidneyBean115\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::KidneyBean115 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckKidneyBean115(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  18: {
                ::Plum115 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Plum115\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Plum115 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPlum115(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  19: {
                ::Plum115::Onion115 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Plum115::Onion115\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Plum115::Onion115 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPlum115Onion115(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  20: {
                ::Plum115::Onion115::Tofu115 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Plum115::Onion115::Tofu115\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Plum115::Onion115::Tofu115 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPlum115Onion115Tofu115(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  21: {
                ::Billberries116 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Billberries116\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Billberries116 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBillberries116(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  22: {
                ::Tangarine116 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Tangarine116\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Tangarine116 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckTangarine116(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  23: {
                ::Tangarine116::BrazilNut116 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Tangarine116::BrazilNut116\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Tangarine116::BrazilNut116 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckTangarine116BrazilNut116(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  24: {
                ::Tangarine116::BrazilNut116::Brocoli116 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Tangarine116::BrazilNut116::Brocoli116\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Tangarine116::BrazilNut116::Brocoli116 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckTangarine116BrazilNut116Brocoli116(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  25: {
                ::Guava117 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Guava117\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Guava117 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGuava117(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  26: {
                ::Almonds117 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Almonds117\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Almonds117 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAlmonds117(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  27: {
                ::Almonds117::Oregano117 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Almonds117::Oregano117\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Almonds117::Oregano117 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAlmonds117Oregano117(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  28: {
                ::Almonds117::Oregano117::Asparagus117 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Almonds117::Oregano117::Asparagus117\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Almonds117::Oregano117::Asparagus117 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAlmonds117Oregano117Asparagus117(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  29: {
                ::Celery118 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Celery118\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Celery118 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCelery118(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  30: {
                ::Parsnip118 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Parsnip118\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Parsnip118 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckParsnip118(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  31: {
                ::Parsnip118::Orange118 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Parsnip118::Orange118\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Parsnip118::Orange118 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckParsnip118Orange118(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  32: {
                ::Parsnip118::Orange118::Sultana118 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Parsnip118::Orange118::Sultana118\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Parsnip118::Orange118::Sultana118 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckParsnip118Orange118Sultana118(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  33: {
                ::Leek119 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Leek119\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Leek119 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLeek119(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  34: {
                ::BlackEyedBeans119 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BlackEyedBeans119\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BlackEyedBeans119 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlackEyedBeans119(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  35: {
                ::BlackEyedBeans119::Ginger119 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BlackEyedBeans119::Ginger119\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BlackEyedBeans119::Ginger119 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlackEyedBeans119Ginger119(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  36: {
                ::BlackEyedBeans119::Ginger119::Starfruit119 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::BlackEyedBeans119::Ginger119::Starfruit119\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::BlackEyedBeans119::Ginger119::Starfruit119 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBlackEyedBeans119Ginger119Starfruit119(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  37: {
                ::Dates120 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Dates120\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Dates120 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckDates120(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  38: {
                ::Lime120 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lime120\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lime120 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLime120(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  39: {
                ::Lime120::Mango120 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lime120::Mango120\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lime120::Mango120 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLime120Mango120(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  40: {
                ::Lime120::Mango120::PassionFruit120 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lime120::Mango120::PassionFruit120\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lime120::Mango120::PassionFruit120 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLime120Mango120PassionFruit120(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  41: {
                ::Carrots121 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Carrots121\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Carrots121 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCarrots121(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  42: {
                ::Banana121 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Banana121\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Banana121 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBanana121(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  43: {
                ::Banana121::PentlandDell120 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Banana121::PentlandDell120\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Banana121::PentlandDell120 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBanana121PentlandDell120(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  44: {
                ::Banana121::PentlandDell120::Homeguard120 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Banana121::PentlandDell120::Homeguard120\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Banana121::PentlandDell120::Homeguard120 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckBanana121PentlandDell120Homeguard120(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  45: {
                ::Cultra121 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Cultra121\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Cultra121 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCultra121(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  46: {
                ::Pimpernel121 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Pimpernel121\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Pimpernel121 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPimpernel121(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  47: {
                ::Pimpernel121::KerrsPinks121 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Pimpernel121::KerrsPinks121\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Pimpernel121::KerrsPinks121 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPimpernel121KerrsPinks121(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  48: {
                ::Pimpernel121::KerrsPinks121::Wilja121 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Pimpernel121::KerrsPinks121::Wilja121\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Pimpernel121::KerrsPinks121::Wilja121 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckPimpernel121KerrsPinks121Wilja121(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;

  }
  return 1;
}




