//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/getany.cpp
//
// Modifications:
// $Log: getany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:41  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1997/12/12 09:02:42  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"

//Header files generated by idl compiler
#include "tin.hh"

#include "types.hh"
extern Ernie ernie;


void GetAny(CORBA::Any &any)
{
  switch(ernie.getULong()%(12+36))
  {
    case   0: any <<= ernie.getULong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating ULong");
#endif
              break;
    case   1: any <<= ernie.getLong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Long");
#endif
              break;
    case   2: any <<= ernie.getUShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating UShort");
#endif
              break;
    case   3: any <<= ernie.getShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Short");
#endif
              break;
    case   4: any <<= CORBA::Any::from_boolean(ernie.getBoolean());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Boolean");
#endif
              break;
    case   5: any <<= CORBA::Any::from_octet(ernie.getOctet());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Octet");
#endif
              break;
    case   6: any <<= CORBA::Any::from_char(ernie.getChar());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Char");
#endif
              break;
    case   7: any <<= ernie.getFloat();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Float");
#endif
               break;
    case   8: any <<= ernie.getDouble();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Double");
#endif
              break;
    case   9: any <<= ernie.getString();
#ifdef DEBUG
              ::tet_infoline("GetAny creating String");
#endif
              break;
    case  10: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating BoundedString");
#endif
                CORBA::ULong  b;
                b = ernie.getULong()%30+1;
                any <<= CORBA::Any::from_string(ernie.getString(b),b);
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr _typecode;
#ifdef DEBUG
                ::tet_infoline("GetAny creating TypeCode");
#endif
                GetCORBATypeCode_ptr(_typecode);
                any <<= _typecode;
               }
                break;
    case   12: {
                CORBA::Any  _any;  
#ifdef DEBUG
                ::tet_infoline("GetAny creating Any");
#endif
                GetAny(_any);
                any <<= _any;
               }
                break;

    case  13: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cinnamon114");
#endif
                ::Cinnamon114   v;

                GetCinnamon114(v);

                any  <<= v;
              }
              break;

    case  14: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::HazelNut114");
#endif
                ::HazelNut114   v;

                GetHazelNut114(v);

                any  <<= v;
              }
              break;

    case  15: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::HazelNut114::CrabApple114");
#endif
                ::HazelNut114::CrabApple114   v;

                GetHazelNut114CrabApple114(v);

                any  <<= v;
              }
              break;

    case  16: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::HazelNut114::CrabApple114::Lentil114");
#endif
                ::HazelNut114::CrabApple114::Lentil114   v;

                GetHazelNut114CrabApple114Lentil114(v);

                any  <<= v;
              }
              break;

    case  17: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::KidneyBean115");
#endif
                ::KidneyBean115   v;

                GetKidneyBean115(v);

                any  <<= v;
              }
              break;

    case  18: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Plum115");
#endif
                ::Plum115   v;

                GetPlum115(v);

                any  <<= v;
              }
              break;

    case  19: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Plum115::Onion115");
#endif
                ::Plum115::Onion115   v;

                GetPlum115Onion115(v);

                any  <<= v;
              }
              break;

    case  20: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Plum115::Onion115::Tofu115");
#endif
                ::Plum115::Onion115::Tofu115   v;

                GetPlum115Onion115Tofu115(v);

                any  <<= v;
              }
              break;

    case  21: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Billberries116");
#endif
                ::Billberries116   v;

                GetBillberries116(v);

                any  <<= v;
              }
              break;

    case  22: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Tangarine116");
#endif
                ::Tangarine116   v;

                GetTangarine116(v);

                any  <<= v;
              }
              break;

    case  23: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Tangarine116::BrazilNut116");
#endif
                ::Tangarine116::BrazilNut116   v;

                GetTangarine116BrazilNut116(v);

                any  <<= v;
              }
              break;

    case  24: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Tangarine116::BrazilNut116::Brocoli116");
#endif
                ::Tangarine116::BrazilNut116::Brocoli116   v;

                GetTangarine116BrazilNut116Brocoli116(v);

                any  <<= v;
              }
              break;

    case  25: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Guava117");
#endif
                ::Guava117   v;

                GetGuava117(v);

                any  <<= v;
              }
              break;

    case  26: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Almonds117");
#endif
                ::Almonds117   v;

                GetAlmonds117(v);

                any  <<= v;
              }
              break;

    case  27: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Almonds117::Oregano117");
#endif
                ::Almonds117::Oregano117   v;

                GetAlmonds117Oregano117(v);

                any  <<= v;
              }
              break;

    case  28: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Almonds117::Oregano117::Asparagus117");
#endif
                ::Almonds117::Oregano117::Asparagus117   v;

                GetAlmonds117Oregano117Asparagus117(v);

                any  <<= v;
              }
              break;

    case  29: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Celery118");
#endif
                ::Celery118   v;

                GetCelery118(v);

                any  <<= v;
              }
              break;

    case  30: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Parsnip118");
#endif
                ::Parsnip118   v;

                GetParsnip118(v);

                any  <<= v;
              }
              break;

    case  31: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Parsnip118::Orange118");
#endif
                ::Parsnip118::Orange118   v;

                GetParsnip118Orange118(v);

                any  <<= v;
              }
              break;

    case  32: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Parsnip118::Orange118::Sultana118");
#endif
                ::Parsnip118::Orange118::Sultana118   v;

                GetParsnip118Orange118Sultana118(v);

                any  <<= v;
              }
              break;

    case  33: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Leek119");
#endif
                ::Leek119   v;

                GetLeek119(v);

                any  <<= v;
              }
              break;

    case  34: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BlackEyedBeans119");
#endif
                ::BlackEyedBeans119   v;

                GetBlackEyedBeans119(v);

                any  <<= v;
              }
              break;

    case  35: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BlackEyedBeans119::Ginger119");
#endif
                ::BlackEyedBeans119::Ginger119   v;

                GetBlackEyedBeans119Ginger119(v);

                any  <<= v;
              }
              break;

    case  36: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BlackEyedBeans119::Ginger119::Starfruit119");
#endif
                ::BlackEyedBeans119::Ginger119::Starfruit119   v;

                GetBlackEyedBeans119Ginger119Starfruit119(v);

                any  <<= v;
              }
              break;

    case  37: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Dates120");
#endif
                ::Dates120   v;

                GetDates120(v);

                any  <<= v;
              }
              break;

    case  38: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lime120");
#endif
                ::Lime120   v;

                GetLime120(v);

                any  <<= v;
              }
              break;

    case  39: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lime120::Mango120");
#endif
                ::Lime120::Mango120   v;

                GetLime120Mango120(v);

                any  <<= v;
              }
              break;

    case  40: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lime120::Mango120::PassionFruit120");
#endif
                ::Lime120::Mango120::PassionFruit120   v;

                GetLime120Mango120PassionFruit120(v);

                any  <<= v;
              }
              break;

    case  41: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Carrots121");
#endif
                ::Carrots121   v;

                GetCarrots121(v);

                any  <<= v;
              }
              break;

    case  42: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Banana121");
#endif
                ::Banana121   v;

                GetBanana121(v);

                any  <<= v;
              }
              break;

    case  43: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Banana121::PentlandDell120");
#endif
                ::Banana121::PentlandDell120   v;

                GetBanana121PentlandDell120(v);

                any  <<= v;
              }
              break;

    case  44: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Banana121::PentlandDell120::Homeguard120");
#endif
                ::Banana121::PentlandDell120::Homeguard120   v;

                GetBanana121PentlandDell120Homeguard120(v);

                any  <<= v;
              }
              break;

    case  45: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cultra121");
#endif
                ::Cultra121   v;

                GetCultra121(v);

                any  <<= v;
              }
              break;

    case  46: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pimpernel121");
#endif
                ::Pimpernel121   v;

                GetPimpernel121(v);

                any  <<= v;
              }
              break;

    case  47: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pimpernel121::KerrsPinks121");
#endif
                ::Pimpernel121::KerrsPinks121   v;

                GetPimpernel121KerrsPinks121(v);

                any  <<= v;
              }
              break;

    case  48: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pimpernel121::KerrsPinks121::Wilja121");
#endif
                ::Pimpernel121::KerrsPinks121::Wilja121   v;

                GetPimpernel121KerrsPinks121Wilja121(v);

                any  <<= v;
              }
              break;

  }
}


