//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:41  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1999/04/26 13:51:51  james
// Changed CORBA::Char* to char*
//
// Revision 1.6  1997/12/15 10:51:58  james
// #ifdefs removed
//
// Revision 1.5  1997/12/12 09:02:42  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetCinnamon114(::Cinnamon114 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCinnamon114");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.RedOnion114.Fig114.GoldenDelicous114[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%18;
            v.RedOnion114.Fig114.GoldenDelicous114[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%18;
                    v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetChar(v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCinnamon114(const ::Cinnamon114 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCinnamon114");
#endif

  AddName("RedOnion114");
  AddName("Fig114");
  AddName("GoldenDelicous114");
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.RedOnion114.Fig114.GoldenDelicous114[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.RedOnion114.Fig114.GoldenDelicous114[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%18;
            if (l5 != v.RedOnion114.Fig114.GoldenDelicous114[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.RedOnion114.Fig114.GoldenDelicous114[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%18;
                    if (l9 != v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckChar(v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetHazelNut114(::HazelNut114 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetHazelNut114");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.RedOnion114.Fig114.GoldenDelicous114[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%18;
            v.RedOnion114.Fig114.GoldenDelicous114[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%18;
                    v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetChar(v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckHazelNut114(const ::HazelNut114 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckHazelNut114");
#endif

  AddName("RedOnion114");
  AddName("Fig114");
  AddName("GoldenDelicous114");
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.RedOnion114.Fig114.GoldenDelicous114[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.RedOnion114.Fig114.GoldenDelicous114[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%18;
            if (l5 != v.RedOnion114.Fig114.GoldenDelicous114[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.RedOnion114.Fig114.GoldenDelicous114[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%18;
                    if (l9 != v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckChar(v.RedOnion114.Fig114.GoldenDelicous114[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetHazelNut114CrabApple114(::HazelNut114::CrabApple114 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetHazelNut114CrabApple114");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Fig114.GoldenDelicous114[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%18;
            v.Fig114.GoldenDelicous114[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Fig114.GoldenDelicous114[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%18;
                    v.Fig114.GoldenDelicous114[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetChar(v.Fig114.GoldenDelicous114[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckHazelNut114CrabApple114(const ::HazelNut114::CrabApple114 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckHazelNut114CrabApple114");
#endif

  AddName("Fig114");
  AddName("GoldenDelicous114");
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Fig114.GoldenDelicous114[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Fig114.GoldenDelicous114[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%18;
            if (l5 != v.Fig114.GoldenDelicous114[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Fig114.GoldenDelicous114[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Fig114.GoldenDelicous114[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Fig114.GoldenDelicous114[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%18;
                    if (l9 != v.Fig114.GoldenDelicous114[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Fig114.GoldenDelicous114[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckChar(v.Fig114.GoldenDelicous114[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetHazelNut114CrabApple114Lentil114(::HazelNut114::CrabApple114::Lentil114 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetHazelNut114CrabApple114Lentil114");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.GoldenDelicous114[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%18;
            v.GoldenDelicous114[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.GoldenDelicous114[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%18;
                    v.GoldenDelicous114[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetChar(v.GoldenDelicous114[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckHazelNut114CrabApple114Lentil114(const ::HazelNut114::CrabApple114::Lentil114 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckHazelNut114CrabApple114Lentil114");
#endif

  AddName("GoldenDelicous114");
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.GoldenDelicous114[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GoldenDelicous114[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%18;
            if (l5 != v.GoldenDelicous114[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GoldenDelicous114[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.GoldenDelicous114[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GoldenDelicous114[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%18;
                    if (l9 != v.GoldenDelicous114[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.GoldenDelicous114[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckChar(v.GoldenDelicous114[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetKidneyBean115(::KidneyBean115 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetKidneyBean115");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Shallots115.Sweetcorn115[i1].Runnerbean115.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%11;
                v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%15;
                    v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetChar(v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckKidneyBean115(const ::KidneyBean115 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckKidneyBean115");
#endif

  AddName("Shallots115");
  AddName("Sweetcorn115");
  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      AddName("Runnerbean115");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Shallots115.Sweetcorn115[i1].Runnerbean115.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Shallots115.Sweetcorn115[i1].Runnerbean115.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            if (l5 != v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%11;
                if (l7 != v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%15;
                    if (l9 != v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckChar(v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetPlum115(::Plum115 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetPlum115");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Shallots115.Sweetcorn115[i1].Runnerbean115.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%11;
                v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%15;
                    v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetChar(v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckPlum115(const ::Plum115 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPlum115");
#endif

  AddName("Shallots115");
  AddName("Sweetcorn115");
  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      AddName("Runnerbean115");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Shallots115.Sweetcorn115[i1].Runnerbean115.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Shallots115.Sweetcorn115[i1].Runnerbean115.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            if (l5 != v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%11;
                if (l7 != v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%15;
                    if (l9 != v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckChar(v.Shallots115.Sweetcorn115[i1].Runnerbean115[i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetPlum115Onion115(::Plum115::Onion115 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetPlum115Onion115");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Sweetcorn115[i1].Runnerbean115.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            v.Sweetcorn115[i1].Runnerbean115[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%11;
                v.Sweetcorn115[i1].Runnerbean115[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%15;
                    v.Sweetcorn115[i1].Runnerbean115[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetChar(v.Sweetcorn115[i1].Runnerbean115[i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckPlum115Onion115(const ::Plum115::Onion115 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPlum115Onion115");
#endif

  AddName("Sweetcorn115");
  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      AddName("Runnerbean115");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Sweetcorn115[i1].Runnerbean115.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Sweetcorn115[i1].Runnerbean115.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            if (l5 != v.Sweetcorn115[i1].Runnerbean115[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Sweetcorn115[i1].Runnerbean115[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%11;
                if (l7 != v.Sweetcorn115[i1].Runnerbean115[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Sweetcorn115[i1].Runnerbean115[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%15;
                    if (l9 != v.Sweetcorn115[i1].Runnerbean115[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Sweetcorn115[i1].Runnerbean115[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckChar(v.Sweetcorn115[i1].Runnerbean115[i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetPlum115Onion115Tofu115(::Plum115::Onion115::Tofu115 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetPlum115Onion115Tofu115");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Runnerbean115.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.Runnerbean115[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%11;
            v.Runnerbean115[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%15;
                v.Runnerbean115[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetChar(v.Runnerbean115[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckPlum115Onion115Tofu115(const ::Plum115::Onion115::Tofu115 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPlum115Onion115Tofu115");
#endif

  AddName("Runnerbean115");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Runnerbean115.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Runnerbean115.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.Runnerbean115[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Runnerbean115[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%11;
            if (l5 != v.Runnerbean115[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Runnerbean115[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%15;
                if (l7 != v.Runnerbean115[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Runnerbean115[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckChar(v.Runnerbean115[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetBillberries116(::Billberries116 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBillberries116");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.SweetPotato116.GrannySmith116.Prunes116.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%19;
        v.SweetPotato116.GrannySmith116.Prunes116[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.SweetPotato116.GrannySmith116.Prunes116[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.SweetPotato116.GrannySmith116.Prunes116[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetBoolean(v.SweetPotato116.GrannySmith116.Prunes116[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBillberries116(const ::Billberries116 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBillberries116");
#endif

  AddName("SweetPotato116");
  AddName("GrannySmith116");
  AddName("Prunes116");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.SweetPotato116.GrannySmith116.Prunes116.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.SweetPotato116.GrannySmith116.Prunes116.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%19;
        if (l3 != v.SweetPotato116.GrannySmith116.Prunes116[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.SweetPotato116.GrannySmith116.Prunes116[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.SweetPotato116.GrannySmith116.Prunes116[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.SweetPotato116.GrannySmith116.Prunes116[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.SweetPotato116.GrannySmith116.Prunes116[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.SweetPotato116.GrannySmith116.Prunes116[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckBoolean(v.SweetPotato116.GrannySmith116.Prunes116[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetTangarine116(::Tangarine116 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTangarine116");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.SweetPotato116.GrannySmith116.Prunes116.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%19;
        v.SweetPotato116.GrannySmith116.Prunes116[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.SweetPotato116.GrannySmith116.Prunes116[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.SweetPotato116.GrannySmith116.Prunes116[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetBoolean(v.SweetPotato116.GrannySmith116.Prunes116[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckTangarine116(const ::Tangarine116 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTangarine116");
#endif

  AddName("SweetPotato116");
  AddName("GrannySmith116");
  AddName("Prunes116");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.SweetPotato116.GrannySmith116.Prunes116.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.SweetPotato116.GrannySmith116.Prunes116.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%19;
        if (l3 != v.SweetPotato116.GrannySmith116.Prunes116[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.SweetPotato116.GrannySmith116.Prunes116[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.SweetPotato116.GrannySmith116.Prunes116[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.SweetPotato116.GrannySmith116.Prunes116[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.SweetPotato116.GrannySmith116.Prunes116[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.SweetPotato116.GrannySmith116.Prunes116[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckBoolean(v.SweetPotato116.GrannySmith116.Prunes116[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetTangarine116BrazilNut116(::Tangarine116::BrazilNut116 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTangarine116BrazilNut116");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.GrannySmith116.Prunes116.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%19;
        v.GrannySmith116.Prunes116[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GrannySmith116.Prunes116[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.GrannySmith116.Prunes116[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetBoolean(v.GrannySmith116.Prunes116[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckTangarine116BrazilNut116(const ::Tangarine116::BrazilNut116 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTangarine116BrazilNut116");
#endif

  AddName("GrannySmith116");
  AddName("Prunes116");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.GrannySmith116.Prunes116.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.GrannySmith116.Prunes116.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%19;
        if (l3 != v.GrannySmith116.Prunes116[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GrannySmith116.Prunes116[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GrannySmith116.Prunes116[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GrannySmith116.Prunes116[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.GrannySmith116.Prunes116[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GrannySmith116.Prunes116[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckBoolean(v.GrannySmith116.Prunes116[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetTangarine116BrazilNut116Brocoli116(::Tangarine116::BrazilNut116::Brocoli116 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTangarine116BrazilNut116Brocoli116");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Prunes116.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%19;
        v.Prunes116[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Prunes116[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Prunes116[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetBoolean(v.Prunes116[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckTangarine116BrazilNut116Brocoli116(const ::Tangarine116::BrazilNut116::Brocoli116 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTangarine116BrazilNut116Brocoli116");
#endif

  AddName("Prunes116");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Prunes116.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Prunes116.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%19;
        if (l3 != v.Prunes116[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Prunes116[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Prunes116[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Prunes116[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Prunes116[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Prunes116[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckBoolean(v.Prunes116[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetGuava117(::Guava117 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGuava117");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 9; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%6;
            v.Beansprout117.Dill117[i1].GardenPeas117[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%12;
                    v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      {
                        CORBA::ULong	l11;
                        CORBA::ULong	i11;
                        l11 = ernie.getULong()%3;
                        v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7][i9].length(l11);
                        for(i11=0; i11 < l11; ++i11)
                        {
                          AddIndex(i11);
                          GetBoolean(v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7][i9][i11]);
                          RemoveIndex();
                        }
                      }
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckGuava117(const ::Guava117 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGuava117");
#endif

  AddName("Beansprout117");
  AddName("Dill117");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      AddName("GardenPeas117");
      {
        int	i3;
        for(i3=0; i3 < 9; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%6;
            if (l5 != v.Beansprout117.Dill117[i1].GardenPeas117[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Beansprout117.Dill117[i1].GardenPeas117[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%12;
                    if (l9 != v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      {
                        CORBA::ULong	l11;
                        CORBA::ULong	i11;
                        l11 = ernie.getULong()%3;
                        if (l11 != v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7][i9].length())
                        {
                          ::tet_printf("ERROR: %s has incorrect length",name);
                          ::tet_printf("Expected %d, but found %d instead", l11,v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7][i9].length());
                          iRetCode = 0;
                        }
                        for(i11=0; i11 < l11; ++i11)
                        {
                          AddIndex(i11);
                          if (!CheckBoolean(v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7][i9][i11]))
                            iRetCode = 0;
                          RemoveIndex();
                        }
                      }
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetAlmonds117(::Almonds117 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAlmonds117");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 9; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%6;
            v.Beansprout117.Dill117[i1].GardenPeas117[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%12;
                    v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      {
                        CORBA::ULong	l11;
                        CORBA::ULong	i11;
                        l11 = ernie.getULong()%3;
                        v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7][i9].length(l11);
                        for(i11=0; i11 < l11; ++i11)
                        {
                          AddIndex(i11);
                          GetBoolean(v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7][i9][i11]);
                          RemoveIndex();
                        }
                      }
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckAlmonds117(const ::Almonds117 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAlmonds117");
#endif

  AddName("Beansprout117");
  AddName("Dill117");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      AddName("GardenPeas117");
      {
        int	i3;
        for(i3=0; i3 < 9; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%6;
            if (l5 != v.Beansprout117.Dill117[i1].GardenPeas117[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Beansprout117.Dill117[i1].GardenPeas117[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%12;
                    if (l9 != v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      {
                        CORBA::ULong	l11;
                        CORBA::ULong	i11;
                        l11 = ernie.getULong()%3;
                        if (l11 != v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7][i9].length())
                        {
                          ::tet_printf("ERROR: %s has incorrect length",name);
                          ::tet_printf("Expected %d, but found %d instead", l11,v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7][i9].length());
                          iRetCode = 0;
                        }
                        for(i11=0; i11 < l11; ++i11)
                        {
                          AddIndex(i11);
                          if (!CheckBoolean(v.Beansprout117.Dill117[i1].GardenPeas117[i3][i5][i7][i9][i11]))
                            iRetCode = 0;
                          RemoveIndex();
                        }
                      }
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetAlmonds117Oregano117(::Almonds117::Oregano117 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAlmonds117Oregano117");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 9; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%6;
            v.Dill117[i1].GardenPeas117[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Dill117[i1].GardenPeas117[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%12;
                    v.Dill117[i1].GardenPeas117[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      {
                        CORBA::ULong	l11;
                        CORBA::ULong	i11;
                        l11 = ernie.getULong()%3;
                        v.Dill117[i1].GardenPeas117[i3][i5][i7][i9].length(l11);
                        for(i11=0; i11 < l11; ++i11)
                        {
                          AddIndex(i11);
                          GetBoolean(v.Dill117[i1].GardenPeas117[i3][i5][i7][i9][i11]);
                          RemoveIndex();
                        }
                      }
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckAlmonds117Oregano117(const ::Almonds117::Oregano117 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAlmonds117Oregano117");
#endif

  AddName("Dill117");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      AddName("GardenPeas117");
      {
        int	i3;
        for(i3=0; i3 < 9; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%6;
            if (l5 != v.Dill117[i1].GardenPeas117[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Dill117[i1].GardenPeas117[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Dill117[i1].GardenPeas117[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Dill117[i1].GardenPeas117[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%12;
                    if (l9 != v.Dill117[i1].GardenPeas117[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Dill117[i1].GardenPeas117[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      {
                        CORBA::ULong	l11;
                        CORBA::ULong	i11;
                        l11 = ernie.getULong()%3;
                        if (l11 != v.Dill117[i1].GardenPeas117[i3][i5][i7][i9].length())
                        {
                          ::tet_printf("ERROR: %s has incorrect length",name);
                          ::tet_printf("Expected %d, but found %d instead", l11,v.Dill117[i1].GardenPeas117[i3][i5][i7][i9].length());
                          iRetCode = 0;
                        }
                        for(i11=0; i11 < l11; ++i11)
                        {
                          AddIndex(i11);
                          if (!CheckBoolean(v.Dill117[i1].GardenPeas117[i3][i5][i7][i9][i11]))
                            iRetCode = 0;
                          RemoveIndex();
                        }
                      }
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetAlmonds117Oregano117Asparagus117(::Almonds117::Oregano117::Asparagus117 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAlmonds117Oregano117Asparagus117");
#endif

  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%6;
        v.GardenPeas117[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GardenPeas117[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%12;
                v.GardenPeas117[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.GardenPeas117[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetBoolean(v.GardenPeas117[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckAlmonds117Oregano117Asparagus117(const ::Almonds117::Oregano117::Asparagus117 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAlmonds117Oregano117Asparagus117");
#endif

  AddName("GardenPeas117");
  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%6;
        if (l3 != v.GardenPeas117[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GardenPeas117[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GardenPeas117[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GardenPeas117[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%12;
                if (l7 != v.GardenPeas117[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GardenPeas117[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.GardenPeas117[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.GardenPeas117[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckBoolean(v.GardenPeas117[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetCelery118(::Celery118 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCelery118");
#endif

  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%2;
        v.LoganBerry118.Turnip118.GaliaMelon118[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%4;
                    v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetBoolean(v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCelery118(const ::Celery118 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCelery118");
#endif

  AddName("LoganBerry118");
  AddName("Turnip118");
  AddName("GaliaMelon118");
  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%2;
        if (l3 != v.LoganBerry118.Turnip118.GaliaMelon118[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.LoganBerry118.Turnip118.GaliaMelon118[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%4;
                    if (l9 != v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckBoolean(v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetParsnip118(::Parsnip118 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetParsnip118");
#endif

  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%2;
        v.LoganBerry118.Turnip118.GaliaMelon118[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%4;
                    v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetBoolean(v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckParsnip118(const ::Parsnip118 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckParsnip118");
#endif

  AddName("LoganBerry118");
  AddName("Turnip118");
  AddName("GaliaMelon118");
  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%2;
        if (l3 != v.LoganBerry118.Turnip118.GaliaMelon118[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.LoganBerry118.Turnip118.GaliaMelon118[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%4;
                    if (l9 != v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckBoolean(v.LoganBerry118.Turnip118.GaliaMelon118[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetParsnip118Orange118(::Parsnip118::Orange118 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetParsnip118Orange118");
#endif

  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%2;
        v.Turnip118.GaliaMelon118[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Turnip118.GaliaMelon118[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Turnip118.GaliaMelon118[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%4;
                    v.Turnip118.GaliaMelon118[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetBoolean(v.Turnip118.GaliaMelon118[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckParsnip118Orange118(const ::Parsnip118::Orange118 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckParsnip118Orange118");
#endif

  AddName("Turnip118");
  AddName("GaliaMelon118");
  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%2;
        if (l3 != v.Turnip118.GaliaMelon118[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Turnip118.GaliaMelon118[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Turnip118.GaliaMelon118[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Turnip118.GaliaMelon118[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Turnip118.GaliaMelon118[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Turnip118.GaliaMelon118[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%4;
                    if (l9 != v.Turnip118.GaliaMelon118[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Turnip118.GaliaMelon118[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckBoolean(v.Turnip118.GaliaMelon118[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetParsnip118Orange118Sultana118(::Parsnip118::Orange118::Sultana118 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetParsnip118Orange118Sultana118");
#endif

  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%2;
        v.GaliaMelon118[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GaliaMelon118[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.GaliaMelon118[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%4;
                    v.GaliaMelon118[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetBoolean(v.GaliaMelon118[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckParsnip118Orange118Sultana118(const ::Parsnip118::Orange118::Sultana118 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckParsnip118Orange118Sultana118");
#endif

  AddName("GaliaMelon118");
  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%2;
        if (l3 != v.GaliaMelon118[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GaliaMelon118[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GaliaMelon118[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GaliaMelon118[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.GaliaMelon118[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GaliaMelon118[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%4;
                    if (l9 != v.GaliaMelon118[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.GaliaMelon118[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckBoolean(v.GaliaMelon118[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetLeek119(::Leek119 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLeek119");
#endif

  {
    int	i1;
    for(i1=0; i1 < 17; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Apricots119.Cucumber119[i1].BlackCherry119.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Apricots119.Cucumber119[i1].BlackCherry119[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetBoolean(v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLeek119(const ::Leek119 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLeek119");
#endif

  AddName("Apricots119");
  AddName("Cucumber119");
  {
    int	i1;
    for(i1=0; i1 < 17; ++i1)
    {
      AddIndex(i1);
      AddName("BlackCherry119");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Apricots119.Cucumber119[i1].BlackCherry119.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Apricots119.Cucumber119[i1].BlackCherry119.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Apricots119.Cucumber119[i1].BlackCherry119[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Apricots119.Cucumber119[i1].BlackCherry119[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                if (l7 != v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckBoolean(v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetBlackEyedBeans119(::BlackEyedBeans119 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBlackEyedBeans119");
#endif

  {
    int	i1;
    for(i1=0; i1 < 17; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Apricots119.Cucumber119[i1].BlackCherry119.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Apricots119.Cucumber119[i1].BlackCherry119[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetBoolean(v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBlackEyedBeans119(const ::BlackEyedBeans119 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBlackEyedBeans119");
#endif

  AddName("Apricots119");
  AddName("Cucumber119");
  {
    int	i1;
    for(i1=0; i1 < 17; ++i1)
    {
      AddIndex(i1);
      AddName("BlackCherry119");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Apricots119.Cucumber119[i1].BlackCherry119.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Apricots119.Cucumber119[i1].BlackCherry119.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Apricots119.Cucumber119[i1].BlackCherry119[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Apricots119.Cucumber119[i1].BlackCherry119[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                if (l7 != v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckBoolean(v.Apricots119.Cucumber119[i1].BlackCherry119[i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetBlackEyedBeans119Ginger119(::BlackEyedBeans119::Ginger119 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBlackEyedBeans119Ginger119");
#endif

  {
    int	i1;
    for(i1=0; i1 < 17; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Cucumber119[i1].BlackCherry119.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Cucumber119[i1].BlackCherry119[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                v.Cucumber119[i1].BlackCherry119[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Cucumber119[i1].BlackCherry119[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetBoolean(v.Cucumber119[i1].BlackCherry119[i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBlackEyedBeans119Ginger119(const ::BlackEyedBeans119::Ginger119 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBlackEyedBeans119Ginger119");
#endif

  AddName("Cucumber119");
  {
    int	i1;
    for(i1=0; i1 < 17; ++i1)
    {
      AddIndex(i1);
      AddName("BlackCherry119");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Cucumber119[i1].BlackCherry119.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Cucumber119[i1].BlackCherry119.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Cucumber119[i1].BlackCherry119[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Cucumber119[i1].BlackCherry119[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                if (l7 != v.Cucumber119[i1].BlackCherry119[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Cucumber119[i1].BlackCherry119[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Cucumber119[i1].BlackCherry119[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Cucumber119[i1].BlackCherry119[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckBoolean(v.Cucumber119[i1].BlackCherry119[i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetBlackEyedBeans119Ginger119Starfruit119(::BlackEyedBeans119::Ginger119::Starfruit119 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBlackEyedBeans119Ginger119Starfruit119");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.BlackCherry119.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.BlackCherry119[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%9;
            v.BlackCherry119[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.BlackCherry119[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetBoolean(v.BlackCherry119[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBlackEyedBeans119Ginger119Starfruit119(const ::BlackEyedBeans119::Ginger119::Starfruit119 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBlackEyedBeans119Ginger119Starfruit119");
#endif

  AddName("BlackCherry119");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.BlackCherry119.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.BlackCherry119.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.BlackCherry119[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.BlackCherry119[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%9;
            if (l5 != v.BlackCherry119[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.BlackCherry119[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.BlackCherry119[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.BlackCherry119[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckBoolean(v.BlackCherry119[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetDates120(::Dates120 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetDates120");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%6;
    v.WaterMelon120.Pumpkin120.Rhubarb120.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.WaterMelon120.Pumpkin120.Rhubarb120[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetOctet(v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckDates120(const ::Dates120 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckDates120");
#endif

  AddName("WaterMelon120");
  AddName("Pumpkin120");
  AddName("Rhubarb120");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%6;
    if (l1 != v.WaterMelon120.Pumpkin120.Rhubarb120.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.WaterMelon120.Pumpkin120.Rhubarb120.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.WaterMelon120.Pumpkin120.Rhubarb120[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.WaterMelon120.Pumpkin120.Rhubarb120[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckOctet(v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetLime120(::Lime120 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLime120");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%6;
    v.WaterMelon120.Pumpkin120.Rhubarb120.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.WaterMelon120.Pumpkin120.Rhubarb120[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetOctet(v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLime120(const ::Lime120 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLime120");
#endif

  AddName("WaterMelon120");
  AddName("Pumpkin120");
  AddName("Rhubarb120");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%6;
    if (l1 != v.WaterMelon120.Pumpkin120.Rhubarb120.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.WaterMelon120.Pumpkin120.Rhubarb120.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.WaterMelon120.Pumpkin120.Rhubarb120[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.WaterMelon120.Pumpkin120.Rhubarb120[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckOctet(v.WaterMelon120.Pumpkin120.Rhubarb120[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetLime120Mango120(::Lime120::Mango120 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLime120Mango120");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%6;
    v.Pumpkin120.Rhubarb120.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Pumpkin120.Rhubarb120[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Pumpkin120.Rhubarb120[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Pumpkin120.Rhubarb120[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetOctet(v.Pumpkin120.Rhubarb120[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLime120Mango120(const ::Lime120::Mango120 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLime120Mango120");
#endif

  AddName("Pumpkin120");
  AddName("Rhubarb120");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%6;
    if (l1 != v.Pumpkin120.Rhubarb120.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Pumpkin120.Rhubarb120.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Pumpkin120.Rhubarb120[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Pumpkin120.Rhubarb120[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Pumpkin120.Rhubarb120[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Pumpkin120.Rhubarb120[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Pumpkin120.Rhubarb120[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Pumpkin120.Rhubarb120[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckOctet(v.Pumpkin120.Rhubarb120[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetLime120Mango120PassionFruit120(::Lime120::Mango120::PassionFruit120 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLime120Mango120PassionFruit120");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%6;
    v.Rhubarb120.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Rhubarb120[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Rhubarb120[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Rhubarb120[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetOctet(v.Rhubarb120[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLime120Mango120PassionFruit120(const ::Lime120::Mango120::PassionFruit120 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLime120Mango120PassionFruit120");
#endif

  AddName("Rhubarb120");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%6;
    if (l1 != v.Rhubarb120.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Rhubarb120.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Rhubarb120[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Rhubarb120[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Rhubarb120[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Rhubarb120[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Rhubarb120[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Rhubarb120[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckOctet(v.Rhubarb120[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetCarrots121(::Carrots121 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCarrots121");
#endif

  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 18; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Apple121.KingEdward120[i1].Record120[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Apple121.KingEdward120[i1].Record120[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%6;
                    v.Apple121.KingEdward120[i1].Record120[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      {
                        CORBA::ULong	l11;
                        CORBA::ULong	i11;
                        l11 = ernie.getULong()%3;
                        v.Apple121.KingEdward120[i1].Record120[i3][i5][i7][i9].length(l11);
                        for(i11=0; i11 < l11; ++i11)
                        {
                          AddIndex(i11);
                          GetOctet(v.Apple121.KingEdward120[i1].Record120[i3][i5][i7][i9][i11]);
                          RemoveIndex();
                        }
                      }
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCarrots121(const ::Carrots121 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCarrots121");
#endif

  AddName("Apple121");
  AddName("KingEdward120");
  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      AddName("Record120");
      {
        int	i3;
        for(i3=0; i3 < 18; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Apple121.KingEdward120[i1].Record120[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Apple121.KingEdward120[i1].Record120[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Apple121.KingEdward120[i1].Record120[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Apple121.KingEdward120[i1].Record120[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%6;
                    if (l9 != v.Apple121.KingEdward120[i1].Record120[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Apple121.KingEdward120[i1].Record120[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      {
                        CORBA::ULong	l11;
                        CORBA::ULong	i11;
                        l11 = ernie.getULong()%3;
                        if (l11 != v.Apple121.KingEdward120[i1].Record120[i3][i5][i7][i9].length())
                        {
                          ::tet_printf("ERROR: %s has incorrect length",name);
                          ::tet_printf("Expected %d, but found %d instead", l11,v.Apple121.KingEdward120[i1].Record120[i3][i5][i7][i9].length());
                          iRetCode = 0;
                        }
                        for(i11=0; i11 < l11; ++i11)
                        {
                          AddIndex(i11);
                          if (!CheckOctet(v.Apple121.KingEdward120[i1].Record120[i3][i5][i7][i9][i11]))
                            iRetCode = 0;
                          RemoveIndex();
                        }
                      }
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetBanana121(::Banana121 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBanana121");
#endif

  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 18; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Apple121.KingEdward120[i1].Record120[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Apple121.KingEdward120[i1].Record120[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%6;
                    v.Apple121.KingEdward120[i1].Record120[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      {
                        CORBA::ULong	l11;
                        CORBA::ULong	i11;
                        l11 = ernie.getULong()%3;
                        v.Apple121.KingEdward120[i1].Record120[i3][i5][i7][i9].length(l11);
                        for(i11=0; i11 < l11; ++i11)
                        {
                          AddIndex(i11);
                          GetOctet(v.Apple121.KingEdward120[i1].Record120[i3][i5][i7][i9][i11]);
                          RemoveIndex();
                        }
                      }
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBanana121(const ::Banana121 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBanana121");
#endif

  AddName("Apple121");
  AddName("KingEdward120");
  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      AddName("Record120");
      {
        int	i3;
        for(i3=0; i3 < 18; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Apple121.KingEdward120[i1].Record120[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Apple121.KingEdward120[i1].Record120[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Apple121.KingEdward120[i1].Record120[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Apple121.KingEdward120[i1].Record120[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%6;
                    if (l9 != v.Apple121.KingEdward120[i1].Record120[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Apple121.KingEdward120[i1].Record120[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      {
                        CORBA::ULong	l11;
                        CORBA::ULong	i11;
                        l11 = ernie.getULong()%3;
                        if (l11 != v.Apple121.KingEdward120[i1].Record120[i3][i5][i7][i9].length())
                        {
                          ::tet_printf("ERROR: %s has incorrect length",name);
                          ::tet_printf("Expected %d, but found %d instead", l11,v.Apple121.KingEdward120[i1].Record120[i3][i5][i7][i9].length());
                          iRetCode = 0;
                        }
                        for(i11=0; i11 < l11; ++i11)
                        {
                          AddIndex(i11);
                          if (!CheckOctet(v.Apple121.KingEdward120[i1].Record120[i3][i5][i7][i9][i11]))
                            iRetCode = 0;
                          RemoveIndex();
                        }
                      }
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetBanana121PentlandDell120(::Banana121::PentlandDell120 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBanana121PentlandDell120");
#endif

  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 18; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.KingEdward120[i1].Record120[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.KingEdward120[i1].Record120[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%6;
                    v.KingEdward120[i1].Record120[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      {
                        CORBA::ULong	l11;
                        CORBA::ULong	i11;
                        l11 = ernie.getULong()%3;
                        v.KingEdward120[i1].Record120[i3][i5][i7][i9].length(l11);
                        for(i11=0; i11 < l11; ++i11)
                        {
                          AddIndex(i11);
                          GetOctet(v.KingEdward120[i1].Record120[i3][i5][i7][i9][i11]);
                          RemoveIndex();
                        }
                      }
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBanana121PentlandDell120(const ::Banana121::PentlandDell120 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBanana121PentlandDell120");
#endif

  AddName("KingEdward120");
  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      AddName("Record120");
      {
        int	i3;
        for(i3=0; i3 < 18; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.KingEdward120[i1].Record120[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.KingEdward120[i1].Record120[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.KingEdward120[i1].Record120[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.KingEdward120[i1].Record120[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%6;
                    if (l9 != v.KingEdward120[i1].Record120[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.KingEdward120[i1].Record120[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      {
                        CORBA::ULong	l11;
                        CORBA::ULong	i11;
                        l11 = ernie.getULong()%3;
                        if (l11 != v.KingEdward120[i1].Record120[i3][i5][i7][i9].length())
                        {
                          ::tet_printf("ERROR: %s has incorrect length",name);
                          ::tet_printf("Expected %d, but found %d instead", l11,v.KingEdward120[i1].Record120[i3][i5][i7][i9].length());
                          iRetCode = 0;
                        }
                        for(i11=0; i11 < l11; ++i11)
                        {
                          AddIndex(i11);
                          if (!CheckOctet(v.KingEdward120[i1].Record120[i3][i5][i7][i9][i11]))
                            iRetCode = 0;
                          RemoveIndex();
                        }
                      }
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetBanana121PentlandDell120Homeguard120(::Banana121::PentlandDell120::Homeguard120 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBanana121PentlandDell120Homeguard120");
#endif

  {
    int	i1;
    for(i1=0; i1 < 18; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Record120[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Record120[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%6;
                v.Record120[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Record120[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetOctet(v.Record120[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBanana121PentlandDell120Homeguard120(const ::Banana121::PentlandDell120::Homeguard120 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBanana121PentlandDell120Homeguard120");
#endif

  AddName("Record120");
  {
    int	i1;
    for(i1=0; i1 < 18; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Record120[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Record120[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Record120[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Record120[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%6;
                if (l7 != v.Record120[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Record120[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Record120[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Record120[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckOctet(v.Record120[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetCultra121(::Cultra121 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCultra121");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.GoldenWonder121.Balmoral121.BritishQueens121[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%11;
                    v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetOctet(v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCultra121(const ::Cultra121 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCultra121");
#endif

  AddName("GoldenWonder121");
  AddName("Balmoral121");
  AddName("BritishQueens121");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.GoldenWonder121.Balmoral121.BritishQueens121[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GoldenWonder121.Balmoral121.BritishQueens121[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%11;
                    if (l9 != v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckOctet(v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetPimpernel121(::Pimpernel121 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetPimpernel121");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.GoldenWonder121.Balmoral121.BritishQueens121[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%11;
                    v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetOctet(v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckPimpernel121(const ::Pimpernel121 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPimpernel121");
#endif

  AddName("GoldenWonder121");
  AddName("Balmoral121");
  AddName("BritishQueens121");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.GoldenWonder121.Balmoral121.BritishQueens121[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GoldenWonder121.Balmoral121.BritishQueens121[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%11;
                    if (l9 != v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckOctet(v.GoldenWonder121.Balmoral121.BritishQueens121[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetPimpernel121KerrsPinks121(::Pimpernel121::KerrsPinks121 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetPimpernel121KerrsPinks121");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Balmoral121.BritishQueens121[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Balmoral121.BritishQueens121[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Balmoral121.BritishQueens121[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%11;
                    v.Balmoral121.BritishQueens121[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetOctet(v.Balmoral121.BritishQueens121[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckPimpernel121KerrsPinks121(const ::Pimpernel121::KerrsPinks121 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPimpernel121KerrsPinks121");
#endif

  AddName("Balmoral121");
  AddName("BritishQueens121");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Balmoral121.BritishQueens121[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Balmoral121.BritishQueens121[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Balmoral121.BritishQueens121[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Balmoral121.BritishQueens121[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Balmoral121.BritishQueens121[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Balmoral121.BritishQueens121[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%11;
                    if (l9 != v.Balmoral121.BritishQueens121[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Balmoral121.BritishQueens121[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckOctet(v.Balmoral121.BritishQueens121[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetPimpernel121KerrsPinks121Wilja121(::Pimpernel121::KerrsPinks121::Wilja121 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetPimpernel121KerrsPinks121Wilja121");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.BritishQueens121[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.BritishQueens121[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.BritishQueens121[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%11;
                    v.BritishQueens121[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetOctet(v.BritishQueens121[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckPimpernel121KerrsPinks121Wilja121(const ::Pimpernel121::KerrsPinks121::Wilja121 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPimpernel121KerrsPinks121Wilja121");
#endif

  AddName("BritishQueens121");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.BritishQueens121[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.BritishQueens121[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.BritishQueens121[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.BritishQueens121[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.BritishQueens121[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.BritishQueens121[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%11;
                    if (l9 != v.BritishQueens121[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.BritishQueens121[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckOctet(v.BritishQueens121[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetidlServerCinnamon114Excpt(::idlServer::Cinnamon114Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerCinnamon114Excpt");
#endif

  GetCinnamon114(v.ex1);
}

int CheckidlServerCinnamon114Excpt(const ::idlServer::Cinnamon114Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerCinnamon114Excpt");
#endif

  AddName("ex1");
  if (!CheckCinnamon114(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerHazelNut114Excpt(::idlServer::HazelNut114Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerHazelNut114Excpt");
#endif

  GetHazelNut114(v.ex1);
}

int CheckidlServerHazelNut114Excpt(const ::idlServer::HazelNut114Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerHazelNut114Excpt");
#endif

  AddName("ex1");
  if (!CheckHazelNut114(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerCrabApple114Excpt(::idlServer::CrabApple114Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerCrabApple114Excpt");
#endif

  GetHazelNut114CrabApple114(v.ex1);
}

int CheckidlServerCrabApple114Excpt(const ::idlServer::CrabApple114Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerCrabApple114Excpt");
#endif

  AddName("ex1");
  if (!CheckHazelNut114CrabApple114(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerLentil114Excpt(::idlServer::Lentil114Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerLentil114Excpt");
#endif

  GetHazelNut114CrabApple114Lentil114(v.ex1);
}

int CheckidlServerLentil114Excpt(const ::idlServer::Lentil114Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerLentil114Excpt");
#endif

  AddName("ex1");
  if (!CheckHazelNut114CrabApple114Lentil114(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerKidneyBean115Excpt(::idlServer::KidneyBean115Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerKidneyBean115Excpt");
#endif

  GetKidneyBean115(v.ex1);
}

int CheckidlServerKidneyBean115Excpt(const ::idlServer::KidneyBean115Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerKidneyBean115Excpt");
#endif

  AddName("ex1");
  if (!CheckKidneyBean115(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerPlum115Excpt(::idlServer::Plum115Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerPlum115Excpt");
#endif

  GetPlum115(v.ex1);
}

int CheckidlServerPlum115Excpt(const ::idlServer::Plum115Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerPlum115Excpt");
#endif

  AddName("ex1");
  if (!CheckPlum115(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerOnion115Excpt(::idlServer::Onion115Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerOnion115Excpt");
#endif

  GetPlum115Onion115(v.ex1);
}

int CheckidlServerOnion115Excpt(const ::idlServer::Onion115Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerOnion115Excpt");
#endif

  AddName("ex1");
  if (!CheckPlum115Onion115(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerTofu115Excpt(::idlServer::Tofu115Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerTofu115Excpt");
#endif

  GetPlum115Onion115Tofu115(v.ex1);
}

int CheckidlServerTofu115Excpt(const ::idlServer::Tofu115Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerTofu115Excpt");
#endif

  AddName("ex1");
  if (!CheckPlum115Onion115Tofu115(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerBillberries116Excpt(::idlServer::Billberries116Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerBillberries116Excpt");
#endif

  GetBillberries116(v.ex1);
}

int CheckidlServerBillberries116Excpt(const ::idlServer::Billberries116Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerBillberries116Excpt");
#endif

  AddName("ex1");
  if (!CheckBillberries116(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



