//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Cinnamon114*
idlServer_imp::Cinnamon114Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Cinnamon114* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Cinnamon114Attr\n");
#endif
  
  ernie.seed("Cinnamon114AttrCall");
  
  ernie.seed("Cinnamon114AttrReturn"); 
  ReturnValue = new ::Cinnamon114;
  GetCinnamon114(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Cinnamon114Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Cinnamon114Attr(const ::Cinnamon114 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Cinnamon114Attr\n");
#endif
  
  ernie.seed("Cinnamon114AttrCall");
  AddName("_attr");
  if (!CheckCinnamon114(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cinnamon114AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Cinnamon114Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Cinnamon114*
idlServer_imp::Cinnamon114Op(const ::Cinnamon114 &p1,::Cinnamon114_out p2,::Cinnamon114 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Cinnamon114* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Cinnamon114Op\n");
#endif
  
  ernie.seed("Cinnamon114OpCall");
  AddName("p1");
  if (!CheckCinnamon114(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCinnamon114(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cinnamon114OpReturn"); 
  {
    ::idlServer::Cinnamon114Excpt ex;
    GetidlServerCinnamon114Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Cinnamon114;
  GetCinnamon114(*ReturnValue);
  p2 = new ::Cinnamon114;
  GetCinnamon114(p2);
  GetCinnamon114(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Cinnamon114Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::HazelNut114*
idlServer_imp::HazelNut114Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::HazelNut114* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::HazelNut114Attr\n");
#endif
  
  ernie.seed("HazelNut114AttrCall");
  
  ernie.seed("HazelNut114AttrReturn"); 
  ReturnValue = new ::HazelNut114;
  GetHazelNut114(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::HazelNut114Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::HazelNut114Attr(const ::HazelNut114 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::HazelNut114Attr\n");
#endif
  
  ernie.seed("HazelNut114AttrCall");
  AddName("_attr");
  if (!CheckHazelNut114(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("HazelNut114AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::HazelNut114Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::HazelNut114*
idlServer_imp::HazelNut114Op(const ::HazelNut114 &p1,::HazelNut114_out p2,::HazelNut114 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::HazelNut114* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::HazelNut114Op\n");
#endif
  
  ernie.seed("HazelNut114OpCall");
  AddName("p1");
  if (!CheckHazelNut114(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckHazelNut114(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("HazelNut114OpReturn"); 
  {
    ::idlServer::HazelNut114Excpt ex;
    GetidlServerHazelNut114Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::HazelNut114;
  GetHazelNut114(*ReturnValue);
  p2 = new ::HazelNut114;
  GetHazelNut114(p2);
  GetHazelNut114(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::HazelNut114Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::HazelNut114::CrabApple114*
idlServer_imp::CrabApple114Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::HazelNut114::CrabApple114* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CrabApple114Attr\n");
#endif
  
  ernie.seed("CrabApple114AttrCall");
  
  ernie.seed("CrabApple114AttrReturn"); 
  ReturnValue = new ::HazelNut114::CrabApple114;
  GetHazelNut114CrabApple114(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CrabApple114Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::CrabApple114Attr(const ::HazelNut114::CrabApple114 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CrabApple114Attr\n");
#endif
  
  ernie.seed("CrabApple114AttrCall");
  AddName("_attr");
  if (!CheckHazelNut114CrabApple114(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CrabApple114AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CrabApple114Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::HazelNut114::CrabApple114*
idlServer_imp::CrabApple114Op(const ::HazelNut114::CrabApple114 &p1,::HazelNut114::CrabApple114_out p2,::HazelNut114::CrabApple114 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::HazelNut114::CrabApple114* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CrabApple114Op\n");
#endif
  
  ernie.seed("CrabApple114OpCall");
  AddName("p1");
  if (!CheckHazelNut114CrabApple114(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckHazelNut114CrabApple114(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CrabApple114OpReturn"); 
  {
    ::idlServer::CrabApple114Excpt ex;
    GetidlServerCrabApple114Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::HazelNut114::CrabApple114;
  GetHazelNut114CrabApple114(*ReturnValue);
  p2 = new ::HazelNut114::CrabApple114;
  GetHazelNut114CrabApple114(p2);
  GetHazelNut114CrabApple114(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CrabApple114Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::HazelNut114::CrabApple114::Lentil114*
idlServer_imp::Lentil114Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::HazelNut114::CrabApple114::Lentil114* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lentil114Attr\n");
#endif
  
  ernie.seed("Lentil114AttrCall");
  
  ernie.seed("Lentil114AttrReturn"); 
  ReturnValue = new ::HazelNut114::CrabApple114::Lentil114;
  GetHazelNut114CrabApple114Lentil114(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lentil114Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Lentil114Attr(const ::HazelNut114::CrabApple114::Lentil114 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lentil114Attr\n");
#endif
  
  ernie.seed("Lentil114AttrCall");
  AddName("_attr");
  if (!CheckHazelNut114CrabApple114Lentil114(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lentil114AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lentil114Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::HazelNut114::CrabApple114::Lentil114*
idlServer_imp::Lentil114Op(const ::HazelNut114::CrabApple114::Lentil114 &p1,::HazelNut114::CrabApple114::Lentil114_out p2,::HazelNut114::CrabApple114::Lentil114 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::HazelNut114::CrabApple114::Lentil114* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lentil114Op\n");
#endif
  
  ernie.seed("Lentil114OpCall");
  AddName("p1");
  if (!CheckHazelNut114CrabApple114Lentil114(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckHazelNut114CrabApple114Lentil114(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lentil114OpReturn"); 
  {
    ::idlServer::Lentil114Excpt ex;
    GetidlServerLentil114Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::HazelNut114::CrabApple114::Lentil114;
  GetHazelNut114CrabApple114Lentil114(*ReturnValue);
  p2 = new ::HazelNut114::CrabApple114::Lentil114;
  GetHazelNut114CrabApple114Lentil114(p2);
  GetHazelNut114CrabApple114Lentil114(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lentil114Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::KidneyBean115*
idlServer_imp::KidneyBean115Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::KidneyBean115* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KidneyBean115Attr\n");
#endif
  
  ernie.seed("KidneyBean115AttrCall");
  
  ernie.seed("KidneyBean115AttrReturn"); 
  ReturnValue = new ::KidneyBean115;
  GetKidneyBean115(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KidneyBean115Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::KidneyBean115Attr(const ::KidneyBean115 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KidneyBean115Attr\n");
#endif
  
  ernie.seed("KidneyBean115AttrCall");
  AddName("_attr");
  if (!CheckKidneyBean115(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KidneyBean115AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KidneyBean115Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::KidneyBean115*
idlServer_imp::KidneyBean115Op(const ::KidneyBean115 &p1,::KidneyBean115_out p2,::KidneyBean115 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::KidneyBean115* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::KidneyBean115Op\n");
#endif
  
  ernie.seed("KidneyBean115OpCall");
  AddName("p1");
  if (!CheckKidneyBean115(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckKidneyBean115(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KidneyBean115OpReturn"); 
  {
    ::idlServer::KidneyBean115Excpt ex;
    GetidlServerKidneyBean115Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::KidneyBean115;
  GetKidneyBean115(*ReturnValue);
  p2 = new ::KidneyBean115;
  GetKidneyBean115(p2);
  GetKidneyBean115(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::KidneyBean115Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Plum115*
idlServer_imp::Plum115Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Plum115* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Plum115Attr\n");
#endif
  
  ernie.seed("Plum115AttrCall");
  
  ernie.seed("Plum115AttrReturn"); 
  ReturnValue = new ::Plum115;
  GetPlum115(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Plum115Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Plum115Attr(const ::Plum115 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Plum115Attr\n");
#endif
  
  ernie.seed("Plum115AttrCall");
  AddName("_attr");
  if (!CheckPlum115(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Plum115AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Plum115Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Plum115*
idlServer_imp::Plum115Op(const ::Plum115 &p1,::Plum115_out p2,::Plum115 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Plum115* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Plum115Op\n");
#endif
  
  ernie.seed("Plum115OpCall");
  AddName("p1");
  if (!CheckPlum115(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPlum115(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Plum115OpReturn"); 
  {
    ::idlServer::Plum115Excpt ex;
    GetidlServerPlum115Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Plum115;
  GetPlum115(*ReturnValue);
  p2 = new ::Plum115;
  GetPlum115(*p2);
  GetPlum115(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Plum115Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Plum115::Onion115*
idlServer_imp::Onion115Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Plum115::Onion115* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Onion115Attr\n");
#endif
  
  ernie.seed("Onion115AttrCall");
  
  ernie.seed("Onion115AttrReturn"); 
  ReturnValue = new ::Plum115::Onion115;
  GetPlum115Onion115(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Onion115Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Onion115Attr(const ::Plum115::Onion115 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Onion115Attr\n");
#endif
  
  ernie.seed("Onion115AttrCall");
  AddName("_attr");
  if (!CheckPlum115Onion115(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Onion115AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Onion115Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Plum115::Onion115*
idlServer_imp::Onion115Op(const ::Plum115::Onion115 &p1,::Plum115::Onion115_out p2,::Plum115::Onion115 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Plum115::Onion115* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Onion115Op\n");
#endif
  
  ernie.seed("Onion115OpCall");
  AddName("p1");
  if (!CheckPlum115Onion115(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPlum115Onion115(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Onion115OpReturn"); 
  {
    ::idlServer::Onion115Excpt ex;
    GetidlServerOnion115Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Plum115::Onion115;
  GetPlum115Onion115(*ReturnValue);
  p2 = new ::Plum115::Onion115;
  GetPlum115Onion115(*p2);
  GetPlum115Onion115(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Onion115Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Plum115::Onion115::Tofu115*
idlServer_imp::Tofu115Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Plum115::Onion115::Tofu115* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Tofu115Attr\n");
#endif
  
  ernie.seed("Tofu115AttrCall");
  
  ernie.seed("Tofu115AttrReturn"); 
  ReturnValue = new ::Plum115::Onion115::Tofu115;
  GetPlum115Onion115Tofu115(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Tofu115Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Tofu115Attr(const ::Plum115::Onion115::Tofu115 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Tofu115Attr\n");
#endif
  
  ernie.seed("Tofu115AttrCall");
  AddName("_attr");
  if (!CheckPlum115Onion115Tofu115(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Tofu115AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Tofu115Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Plum115::Onion115::Tofu115*
idlServer_imp::Tofu115Op(const ::Plum115::Onion115::Tofu115 &p1,::Plum115::Onion115::Tofu115_out p2,::Plum115::Onion115::Tofu115 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Plum115::Onion115::Tofu115* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Tofu115Op\n");
#endif
  
  ernie.seed("Tofu115OpCall");
  AddName("p1");
  if (!CheckPlum115Onion115Tofu115(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPlum115Onion115Tofu115(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Tofu115OpReturn"); 
  {
    ::idlServer::Tofu115Excpt ex;
    GetidlServerTofu115Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Plum115::Onion115::Tofu115;
  GetPlum115Onion115Tofu115(*ReturnValue);
  p2 = new ::Plum115::Onion115::Tofu115;
  GetPlum115Onion115Tofu115(p2);
  GetPlum115Onion115Tofu115(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Tofu115Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Billberries116*
idlServer_imp::Billberries116Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Billberries116* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Billberries116Attr\n");
#endif
  
  ernie.seed("Billberries116AttrCall");
  
  ernie.seed("Billberries116AttrReturn"); 
  ReturnValue = new ::Billberries116;
  GetBillberries116(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Billberries116Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Billberries116Attr(const ::Billberries116 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Billberries116Attr\n");
#endif
  
  ernie.seed("Billberries116AttrCall");
  AddName("_attr");
  if (!CheckBillberries116(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Billberries116AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Billberries116Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Billberries116*
idlServer_imp::Billberries116Op(const ::Billberries116 &p1,::Billberries116_out p2,::Billberries116 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Billberries116* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Billberries116Op\n");
#endif
  
  ernie.seed("Billberries116OpCall");
  AddName("p1");
  if (!CheckBillberries116(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBillberries116(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Billberries116OpReturn"); 
  {
    ::idlServer::Billberries116Excpt ex;
    GetidlServerBillberries116Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Billberries116;
  GetBillberries116(*ReturnValue);
  p2 = new ::Billberries116;
  GetBillberries116(p2);
  GetBillberries116(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Billberries116Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



