//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/client.cpp
//
// Modifications:
// $Log: client.cpp,v $
// Revision 1.2  2000/03/29 17:11:06  mli
//   o   remove 'CORBA::Environment ev;'
//   o   int initialise
//
// Revision 1.1.1.1  2000/02/09 17:16:44  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1997/12/12 09:03:46  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern OrbSupport *orb;
extern char *stringifiedIOR;

static int initialised = 0;
CORBA::Object_ptr obj;
idlServer_ptr  tobj;

void
initialise()
{
    if (!initialised)
    {

#ifdef DEBUG
	  ::tet_infoline("client: connecting to proxy");
	  ::tet_printf("client: using %s", stringifiedIOR);
#endif
	  
	  try {
	      obj = orb->getObject(stringifiedIOR);
	  }
	  catch (CORBA::SystemException &ex) {
	      ::tet_infoline("client: getObj failed");
	      ::tet_printf("client: minor code %d", ex.minor());
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  if (obj == 0)
	  {
	      ::tet_infoline("client: failed connecting to proxy");
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  try {
	      tobj = idlServer::_narrow(obj);
	  }
	  catch (CORBA::Exception &ex) {
	      ::tet_infoline("client: failed to narrow object reference.");
	  }
	  initialised = 1;

	  char * tout = 0;
	  tout = getenv("VSORB_EVENT_TIMEOUT");

	  unsigned long timeout = (tout) ? atoi(tout) : 15;
	  orb->setTimeout(tobj, timeout);
      }
    
}

#ifdef VSORB_IDL_TESTS

void testIDL()
{
  char buf1[1024];

::tet_result(TET_PASS);
}
 
#endif



 
void testidlServerEggPlant138Attr(void)
{
  
  ::EggPlant138* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::EggPlant138* ::idlServer::EggPlant138Attr()");
#endif
  
  ernie.seed("EggPlant138AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("EggPlant138AttrReturn");
  try {
    ReturnValue = tobj->EggPlant138Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::EggPlant138Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckEggPlant138(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerEggPlant138AttrW(void)
{
  
  ::EggPlant138 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::EggPlant138Attr(const ::EggPlant138 &_attr)");
#endif
  
  ernie.seed("EggPlant138AttrCall");
  GetEggPlant138(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("EggPlant138AttrReturn");
  try {
     tobj->EggPlant138Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::EggPlant138Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerEggPlant138Op(void)
{
  
  ::EggPlant138* ReturnValue;
  ::EggPlant138 p1;
  ::EggPlant138* p2;
  ::EggPlant138 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::EggPlant138* ::idlServer::EggPlant138Op(const ::EggPlant138 &p1,::EggPlant138 *&p2,::EggPlant138 &p3)");
#endif
  
  ernie.seed("EggPlant138OpCall");
  GetEggPlant138(p1);
  GetEggPlant138(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("EggPlant138OpReturn");
  try {
    ReturnValue = tobj->EggPlant138Op(p1,p2,p3);
  }
  catch (::idlServer::EggPlant138Excpt &ex){
    if (!CheckidlServerEggPlant138Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::EggPlant138Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckEggPlant138(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckEggPlant138(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckEggPlant138(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerGooseBerry138Attr(void)
{
  
  ::GooseBerry138* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::GooseBerry138* ::idlServer::GooseBerry138Attr()");
#endif
  
  ernie.seed("GooseBerry138AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("GooseBerry138AttrReturn");
  try {
    ReturnValue = tobj->GooseBerry138Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::GooseBerry138Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckGooseBerry138(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerGooseBerry138AttrW(void)
{
  
  ::GooseBerry138 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::GooseBerry138Attr(const ::GooseBerry138 &_attr)");
#endif
  
  ernie.seed("GooseBerry138AttrCall");
  GetGooseBerry138(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("GooseBerry138AttrReturn");
  try {
     tobj->GooseBerry138Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::GooseBerry138Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerGooseBerry138Op(void)
{
  
  ::GooseBerry138* ReturnValue;
  ::GooseBerry138 p1;
  ::GooseBerry138* p2;
  ::GooseBerry138 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::GooseBerry138* ::idlServer::GooseBerry138Op(const ::GooseBerry138 &p1,::GooseBerry138 *&p2,::GooseBerry138 &p3)");
#endif
  
  ernie.seed("GooseBerry138OpCall");
  GetGooseBerry138(p1);
  GetGooseBerry138(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("GooseBerry138OpReturn");
  try {
    ReturnValue = tobj->GooseBerry138Op(p1,p2,p3);
  }
  catch (::idlServer::GooseBerry138Excpt &ex){
    if (!CheckidlServerGooseBerry138Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::GooseBerry138Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckGooseBerry138(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckGooseBerry138(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry138(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerHazelNut138Attr(void)
{
  
  ::GooseBerry138::HazelNut138* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::GooseBerry138::HazelNut138* ::idlServer::HazelNut138Attr()");
#endif
  
  ernie.seed("HazelNut138AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("HazelNut138AttrReturn");
  try {
    ReturnValue = tobj->HazelNut138Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::HazelNut138Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckGooseBerry138HazelNut138(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerHazelNut138AttrW(void)
{
  
  ::GooseBerry138::HazelNut138 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::HazelNut138Attr(const ::GooseBerry138::HazelNut138 &_attr)");
#endif
  
  ernie.seed("HazelNut138AttrCall");
  GetGooseBerry138HazelNut138(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("HazelNut138AttrReturn");
  try {
     tobj->HazelNut138Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::HazelNut138Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerHazelNut138Op(void)
{
  
  ::GooseBerry138::HazelNut138* ReturnValue;
  ::GooseBerry138::HazelNut138 p1;
  ::GooseBerry138::HazelNut138* p2;
  ::GooseBerry138::HazelNut138 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::GooseBerry138::HazelNut138* ::idlServer::HazelNut138Op(const ::GooseBerry138::HazelNut138 &p1,::GooseBerry138::HazelNut138 *&p2,::GooseBerry138::HazelNut138 &p3)");
#endif
  
  ernie.seed("HazelNut138OpCall");
  GetGooseBerry138HazelNut138(p1);
  GetGooseBerry138HazelNut138(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("HazelNut138OpReturn");
  try {
    ReturnValue = tobj->HazelNut138Op(p1,p2,p3);
  }
  catch (::idlServer::HazelNut138Excpt &ex){
    if (!CheckidlServerHazelNut138Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::HazelNut138Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckGooseBerry138HazelNut138(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckGooseBerry138HazelNut138(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry138HazelNut138(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerOnion138Attr(void)
{
  
  ::GooseBerry138::HazelNut138::Onion138* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::GooseBerry138::HazelNut138::Onion138* ::idlServer::Onion138Attr()");
#endif
  
  ernie.seed("Onion138AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Onion138AttrReturn");
  try {
    ReturnValue = tobj->Onion138Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Onion138Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckGooseBerry138HazelNut138Onion138(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerOnion138AttrW(void)
{
  
  ::GooseBerry138::HazelNut138::Onion138 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Onion138Attr(const ::GooseBerry138::HazelNut138::Onion138 &_attr)");
#endif
  
  ernie.seed("Onion138AttrCall");
  GetGooseBerry138HazelNut138Onion138(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Onion138AttrReturn");
  try {
     tobj->Onion138Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Onion138Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerOnion138Op(void)
{
  
  ::GooseBerry138::HazelNut138::Onion138* ReturnValue;
  ::GooseBerry138::HazelNut138::Onion138 p1;
  ::GooseBerry138::HazelNut138::Onion138* p2;
  ::GooseBerry138::HazelNut138::Onion138 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::GooseBerry138::HazelNut138::Onion138* ::idlServer::Onion138Op(const ::GooseBerry138::HazelNut138::Onion138 &p1,::GooseBerry138::HazelNut138::Onion138 *&p2,::GooseBerry138::HazelNut138::Onion138 &p3)");
#endif
  
  ernie.seed("Onion138OpCall");
  GetGooseBerry138HazelNut138Onion138(p1);
  GetGooseBerry138HazelNut138Onion138(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Onion138OpReturn");
  try {
    ReturnValue = tobj->Onion138Op(p1,p2,p3);
  }
  catch (::idlServer::Onion138Excpt &ex){
    if (!CheckidlServerOnion138Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Onion138Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckGooseBerry138HazelNut138Onion138(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckGooseBerry138HazelNut138Onion138(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry138HazelNut138Onion138(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerRowanBerry138Attr(void)
{
  
  ::GooseBerry138::HazelNut138::Onion138::RowanBerry138* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::GooseBerry138::HazelNut138::Onion138::RowanBerry138* ::idlServer::RowanBerry138Attr()");
#endif
  
  ernie.seed("RowanBerry138AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("RowanBerry138AttrReturn");
  try {
    ReturnValue = tobj->RowanBerry138Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::RowanBerry138Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckGooseBerry138HazelNut138Onion138RowanBerry138(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerRowanBerry138AttrW(void)
{
  
  ::GooseBerry138::HazelNut138::Onion138::RowanBerry138 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::RowanBerry138Attr(const ::GooseBerry138::HazelNut138::Onion138::RowanBerry138 &_attr)");
#endif
  
  ernie.seed("RowanBerry138AttrCall");
  GetGooseBerry138HazelNut138Onion138RowanBerry138(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("RowanBerry138AttrReturn");
  try {
     tobj->RowanBerry138Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::RowanBerry138Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerRowanBerry138Op(void)
{
  
  ::GooseBerry138::HazelNut138::Onion138::RowanBerry138* ReturnValue;
  ::GooseBerry138::HazelNut138::Onion138::RowanBerry138 p1;
  ::GooseBerry138::HazelNut138::Onion138::RowanBerry138* p2;
  ::GooseBerry138::HazelNut138::Onion138::RowanBerry138 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::GooseBerry138::HazelNut138::Onion138::RowanBerry138* ::idlServer::RowanBerry138Op(const ::GooseBerry138::HazelNut138::Onion138::RowanBerry138 &p1,::GooseBerry138::HazelNut138::Onion138::RowanBerry138 *&p2,::GooseBerry138::HazelNut138::Onion138::RowanBerry138 &p3)");
#endif
  
  ernie.seed("RowanBerry138OpCall");
  GetGooseBerry138HazelNut138Onion138RowanBerry138(p1);
  GetGooseBerry138HazelNut138Onion138RowanBerry138(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("RowanBerry138OpReturn");
  try {
    ReturnValue = tobj->RowanBerry138Op(p1,p2,p3);
  }
  catch (::idlServer::RowanBerry138Excpt &ex){
    if (!CheckidlServerRowanBerry138Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::RowanBerry138Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckGooseBerry138HazelNut138Onion138RowanBerry138(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckGooseBerry138HazelNut138Onion138RowanBerry138(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry138HazelNut138Onion138RowanBerry138(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerEggPlant139Attr(void)
{
  
  ::EggPlant139* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::EggPlant139* ::idlServer::EggPlant139Attr()");
#endif
  
  ernie.seed("EggPlant139AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("EggPlant139AttrReturn");
  try {
    ReturnValue = tobj->EggPlant139Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::EggPlant139Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckEggPlant139(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerEggPlant139AttrW(void)
{
  
  ::EggPlant139 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::EggPlant139Attr(const ::EggPlant139 &_attr)");
#endif
  
  ernie.seed("EggPlant139AttrCall");
  GetEggPlant139(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("EggPlant139AttrReturn");
  try {
     tobj->EggPlant139Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::EggPlant139Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerEggPlant139Op(void)
{
  
  ::EggPlant139* ReturnValue;
  ::EggPlant139 p1;
  ::EggPlant139* p2;
  ::EggPlant139 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::EggPlant139* ::idlServer::EggPlant139Op(const ::EggPlant139 &p1,::EggPlant139 *&p2,::EggPlant139 &p3)");
#endif
  
  ernie.seed("EggPlant139OpCall");
  GetEggPlant139(p1);
  GetEggPlant139(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("EggPlant139OpReturn");
  try {
    ReturnValue = tobj->EggPlant139Op(p1,p2,p3);
  }
  catch (::idlServer::EggPlant139Excpt &ex){
    if (!CheckidlServerEggPlant139Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::EggPlant139Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckEggPlant139(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckEggPlant139(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckEggPlant139(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerGooseBerry139Attr(void)
{
  
  ::GooseBerry139* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::GooseBerry139* ::idlServer::GooseBerry139Attr()");
#endif
  
  ernie.seed("GooseBerry139AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("GooseBerry139AttrReturn");
  try {
    ReturnValue = tobj->GooseBerry139Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::GooseBerry139Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckGooseBerry139(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerGooseBerry139AttrW(void)
{
  
  ::GooseBerry139 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::GooseBerry139Attr(const ::GooseBerry139 &_attr)");
#endif
  
  ernie.seed("GooseBerry139AttrCall");
  GetGooseBerry139(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("GooseBerry139AttrReturn");
  try {
     tobj->GooseBerry139Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::GooseBerry139Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerGooseBerry139Op(void)
{
  
  ::GooseBerry139* ReturnValue;
  ::GooseBerry139 p1;
  ::GooseBerry139* p2;
  ::GooseBerry139 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::GooseBerry139* ::idlServer::GooseBerry139Op(const ::GooseBerry139 &p1,::GooseBerry139 *&p2,::GooseBerry139 &p3)");
#endif
  
  ernie.seed("GooseBerry139OpCall");
  GetGooseBerry139(p1);
  GetGooseBerry139(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("GooseBerry139OpReturn");
  try {
    ReturnValue = tobj->GooseBerry139Op(p1,p2,p3);
  }
  catch (::idlServer::GooseBerry139Excpt &ex){
    if (!CheckidlServerGooseBerry139Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::GooseBerry139Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckGooseBerry139(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckGooseBerry139(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry139(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerHazelNut139Attr(void)
{
  
  ::GooseBerry139::HazelNut139* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::GooseBerry139::HazelNut139* ::idlServer::HazelNut139Attr()");
#endif
  
  ernie.seed("HazelNut139AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("HazelNut139AttrReturn");
  try {
    ReturnValue = tobj->HazelNut139Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::HazelNut139Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckGooseBerry139HazelNut139(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerHazelNut139AttrW(void)
{
  
  ::GooseBerry139::HazelNut139 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::HazelNut139Attr(const ::GooseBerry139::HazelNut139 &_attr)");
#endif
  
  ernie.seed("HazelNut139AttrCall");
  GetGooseBerry139HazelNut139(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("HazelNut139AttrReturn");
  try {
     tobj->HazelNut139Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::HazelNut139Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerHazelNut139Op(void)
{
  
  ::GooseBerry139::HazelNut139* ReturnValue;
  ::GooseBerry139::HazelNut139 p1;
  ::GooseBerry139::HazelNut139* p2;
  ::GooseBerry139::HazelNut139 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::GooseBerry139::HazelNut139* ::idlServer::HazelNut139Op(const ::GooseBerry139::HazelNut139 &p1,::GooseBerry139::HazelNut139 *&p2,::GooseBerry139::HazelNut139 &p3)");
#endif
  
  ernie.seed("HazelNut139OpCall");
  GetGooseBerry139HazelNut139(p1);
  GetGooseBerry139HazelNut139(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("HazelNut139OpReturn");
  try {
    ReturnValue = tobj->HazelNut139Op(p1,p2,p3);
  }
  catch (::idlServer::HazelNut139Excpt &ex){
    if (!CheckidlServerHazelNut139Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::HazelNut139Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckGooseBerry139HazelNut139(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckGooseBerry139HazelNut139(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry139HazelNut139(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCrabApple139Attr(void)
{
  
  ::GooseBerry139::HazelNut139::CrabApple139* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::GooseBerry139::HazelNut139::CrabApple139* ::idlServer::CrabApple139Attr()");
#endif
  
  ernie.seed("CrabApple139AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("CrabApple139AttrReturn");
  try {
    ReturnValue = tobj->CrabApple139Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::CrabApple139Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckGooseBerry139HazelNut139CrabApple139(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCrabApple139AttrW(void)
{
  
  ::GooseBerry139::HazelNut139::CrabApple139 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::CrabApple139Attr(const ::GooseBerry139::HazelNut139::CrabApple139 &_attr)");
#endif
  
  ernie.seed("CrabApple139AttrCall");
  GetGooseBerry139HazelNut139CrabApple139(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("CrabApple139AttrReturn");
  try {
     tobj->CrabApple139Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::CrabApple139Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCrabApple139Op(void)
{
  
  ::GooseBerry139::HazelNut139::CrabApple139* ReturnValue;
  ::GooseBerry139::HazelNut139::CrabApple139 p1;
  ::GooseBerry139::HazelNut139::CrabApple139* p2;
  ::GooseBerry139::HazelNut139::CrabApple139 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::GooseBerry139::HazelNut139::CrabApple139* ::idlServer::CrabApple139Op(const ::GooseBerry139::HazelNut139::CrabApple139 &p1,::GooseBerry139::HazelNut139::CrabApple139 *&p2,::GooseBerry139::HazelNut139::CrabApple139 &p3)");
#endif
  
  ernie.seed("CrabApple139OpCall");
  GetGooseBerry139HazelNut139CrabApple139(p1);
  GetGooseBerry139HazelNut139CrabApple139(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("CrabApple139OpReturn");
  try {
    ReturnValue = tobj->CrabApple139Op(p1,p2,p3);
  }
  catch (::idlServer::CrabApple139Excpt &ex){
    if (!CheckidlServerCrabApple139Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::CrabApple139Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckGooseBerry139HazelNut139CrabApple139(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckGooseBerry139HazelNut139CrabApple139(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry139HazelNut139CrabApple139(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


