//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/checkany.cpp
//
// Modifications:
// $Log: checkany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:44  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/26 13:51:54  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/12 09:03:49  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern char name[];

 
int CheckAny(const CORBA::Any &any)
{
  switch(ernie.getULong()%(12+35))
  {
    case   0: {
                CORBA::ULong  v;
#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::ULong");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::ULong as expected", name);
                  return 0;
                }
                if (!ernie.checkULong(v))
                {
                  tet_printf("Expected %s to contain CORBA::ULong with value %u, but found %u instead.",
                    name,ernie.getULongAgain(),v);
                  return 0;
                }
              }
              break;
    case   1: {
                CORBA::Long  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Long");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Long as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkLong(v))
                {
                  tet_printf("Expected %s to contain CORBA::Long with value %d, but found %d instead.",
                    name,ernie.getLongAgain(),v);
                  return 0;
                }
              }
              break;
    case   2: {
                CORBA::UShort  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::UShort");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::UShort as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkUShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::UShort with value %u, but found %u instead.",
                    name,ernie.getUShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   3: {
                CORBA::Short  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Short");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Short as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::Short with value %d, but found %d instead.",
                    name,ernie.getShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   4: {
                CORBA::Boolean  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Boolean");
#endif
                if (!(any >>= CORBA::Any::to_boolean(v)))
                {
                  tet_printf("%s did not contain a CORBA::Boolean as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkBoolean(v))
                {
                  tet_printf("Expected %s to contain CORBA::Boolean with value %s, but found %s instead.",
                    name,
                    BooleanToString(ernie.getBooleanAgain()),
                    BooleanToString(v));
                  return 0;
                }
              }
              break;
    case   5: {
                CORBA::Octet  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Octet");
#endif
                if (!(any >>= CORBA::Any::to_octet(v)))
                {
                  tet_printf("%s did not contain a CORBA::Octet as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkOctet(v))
                {
                  ::tet_printf("Expected %s to contain CORBA::Octet with value %s, but found %s instead.",
                    name,
                    OctetToString(ernie.getOctetAgain()),
                    OctetToString(v));
                  return 0;
                }
              }
              break;
    case   6: {
                CORBA::Char  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Char");
#endif
                if (!(any >>= CORBA::Any::to_char(v)))
                {
                  tet_printf("%s did not contain a CORBA::Char as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkChar(v))
                {
                  tet_printf("Expected %s to contain CORBA::Char with value %s, but found %s instead.",
                    name,
                    CharToString(ernie.getCharAgain()),
                    CharToString(v));
                  return 0;
                }
              }
              break;
    case   7: {
                CORBA::Float  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Float");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Float as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkFloat(v))
                {
                  tet_printf("Expected %s to contain CORBA::Float with value %g, but found %g instead.",
                    name,
                    ernie.getFloatAgain(),
                    v);
                  return 0;
                }
              }
               break;
    case   8: {
                CORBA::Double  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Double");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Double as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkDouble(v))
                {
                  tet_printf("Expected %s to contain CORBA::Double with value %g, but found %g instead.",
                    name,
                    ernie.getDoubleAgain(),
                    v);
                  return 0;
                }
              }
              break;
    case   9: {
                char *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting char*");
#endif
                if (!(any >>= CORBA::Any::to_string(v,0)))
                {
                  tet_printf("%s did not contain a char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v))
                {
                  tet_printf("Expected %s to contain char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case  10: {
                CORBA::ULong  b;
                char   *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting bounded char*");
#endif
                b = ernie.getULong()%30+1;

                if (!(any >>= CORBA::Any::to_string(v,b)))
                {
                  tet_printf("%s did not contain a bounded char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v,b))
                {
                  tet_printf("Expected %s to contain a bounded char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::TypeCode");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::TypeCode as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCORBATypeCode_ptr(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case   12: {
                CORBA::Any  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Any");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Any as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAny(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  13: {
                ::EggPlant138 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::EggPlant138\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::EggPlant138 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckEggPlant138(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  14: {
                ::GooseBerry138 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GooseBerry138\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GooseBerry138 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGooseBerry138(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  15: {
                ::GooseBerry138::HazelNut138 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GooseBerry138::HazelNut138\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GooseBerry138::HazelNut138 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGooseBerry138HazelNut138(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  16: {
                ::GooseBerry138::HazelNut138::Onion138 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GooseBerry138::HazelNut138::Onion138\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GooseBerry138::HazelNut138::Onion138 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGooseBerry138HazelNut138Onion138(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  17: {
                ::GooseBerry138::HazelNut138::Onion138::RowanBerry138 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GooseBerry138::HazelNut138::Onion138::RowanBerry138\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GooseBerry138::HazelNut138::Onion138::RowanBerry138 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGooseBerry138HazelNut138Onion138RowanBerry138(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  18: {
                ::EggPlant139 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::EggPlant139\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::EggPlant139 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckEggPlant139(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  19: {
                ::GooseBerry139 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GooseBerry139\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GooseBerry139 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGooseBerry139(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  20: {
                ::GooseBerry139::HazelNut139 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GooseBerry139::HazelNut139\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GooseBerry139::HazelNut139 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGooseBerry139HazelNut139(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  21: {
                ::GooseBerry139::HazelNut139::CrabApple139 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GooseBerry139::HazelNut139::CrabApple139\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GooseBerry139::HazelNut139::CrabApple139 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGooseBerry139HazelNut139CrabApple139(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  22: {
                ::GooseBerry139::HazelNut139::CrabApple139::Lentil139 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GooseBerry139::HazelNut139::CrabApple139::Lentil139\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GooseBerry139::HazelNut139::CrabApple139::Lentil139 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGooseBerry139HazelNut139CrabApple139Lentil139(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  23: {
                ::RedOnion140 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::RedOnion140\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::RedOnion140 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRedOnion140(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  24: {
                ::CrabApple140 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CrabApple140\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CrabApple140 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCrabApple140(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  25: {
                ::CrabApple140::Lentil140 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CrabApple140::Lentil140\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CrabApple140::Lentil140 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCrabApple140Lentil140(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  26: {
                ::CrabApple140::Lentil140::CantelopeMelon140 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CrabApple140::Lentil140::CantelopeMelon140\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CrabApple140::Lentil140::CantelopeMelon140 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCrabApple140Lentil140CantelopeMelon140(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  27: {
                ::CrabApple140::Lentil140::CantelopeMelon140::Sultana140 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CrabApple140::Lentil140::CantelopeMelon140::Sultana140\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CrabApple140::Lentil140::CantelopeMelon140::Sultana140 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCrabApple140Lentil140CantelopeMelon140Sultana140(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  28: {
                ::RedOnion141 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::RedOnion141\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::RedOnion141 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckRedOnion141(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  29: {
                ::CrabApple141 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CrabApple141\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CrabApple141 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCrabApple141(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  30: {
                ::CrabApple141::Lentil141 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CrabApple141::Lentil141\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CrabApple141::Lentil141 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCrabApple141Lentil141(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  31: {
                ::CrabApple141::Lentil141::Avocado141 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CrabApple141::Lentil141::Avocado141\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CrabApple141::Lentil141::Avocado141 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCrabApple141Lentil141Avocado141(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  32: {
                ::CrabApple141::Lentil141::Avocado141::Oregano141 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::CrabApple141::Lentil141::Avocado141::Oregano141\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::CrabApple141::Lentil141::Avocado141::Oregano141 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCrabApple141Lentil141Avocado141Oregano141(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  33: {
                ::Fig142 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Fig142\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Fig142 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckFig142(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  34: {
                ::Lentil142 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lentil142\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lentil142 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLentil142(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  35: {
                ::Lentil142::Avocado142 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lentil142::Avocado142\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lentil142::Avocado142 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLentil142Avocado142(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  36: {
                ::Lentil142::Avocado142::Tangarine142 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lentil142::Avocado142::Tangarine142\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lentil142::Avocado142::Tangarine142 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLentil142Avocado142Tangarine142(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  37: {
                ::Lentil142::Avocado142::Tangarine142::BrazilNut142 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lentil142::Avocado142::Tangarine142::BrazilNut142\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lentil142::Avocado142::Tangarine142::BrazilNut142 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLentil142Avocado142Tangarine142BrazilNut142(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  38: {
                ::Fig143 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Fig143\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Fig143 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckFig143(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  39: {
                ::Lentil143 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lentil143\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lentil143 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLentil143(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  40: {
                ::Lentil143::Avocado143 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lentil143::Avocado143\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lentil143::Avocado143 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLentil143Avocado143(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  41: {
                ::Lentil143::Avocado143::Zucchini143 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lentil143::Avocado143::Zucchini143\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lentil143::Avocado143::Zucchini143 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLentil143Avocado143Zucchini143(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  42: {
                ::Lentil143::Avocado143::Zucchini143::Plum143 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Lentil143::Avocado143::Zucchini143::Plum143\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Lentil143::Avocado143::Zucchini143::Plum143 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLentil143Avocado143Zucchini143Plum143(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  43: {
                ::ButterBean144 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::ButterBean144\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::ButterBean144 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckButterBean144(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  44: {
                ::Zucchini144 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Zucchini144\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Zucchini144 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckZucchini144(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  45: {
                ::Zucchini144::Plum144 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Zucchini144::Plum144\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Zucchini144::Plum144 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckZucchini144Plum144(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  46: {
                ::Zucchini144::Plum144::Brocoli144 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Zucchini144::Plum144::Brocoli144\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Zucchini144::Plum144::Brocoli144 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckZucchini144Plum144Brocoli144(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  47: {
                ::Zucchini144::Plum144::Brocoli144::BlackEyedBeans144 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Zucchini144::Plum144::Brocoli144::BlackEyedBeans144\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Zucchini144::Plum144::Brocoli144::BlackEyedBeans144 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckZucchini144Plum144Brocoli144BlackEyedBeans144(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;

  }
  return 1;
}




