//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/getany.cpp
//
// Modifications:
// $Log: getany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:45  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1997/12/12 09:03:50  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"

//Header files generated by idl compiler
#include "tin.hh"

#include "types.hh"
extern Ernie ernie;


void GetAny(CORBA::Any &any)
{
  switch(ernie.getULong()%(12+35))
  {
    case   0: any <<= ernie.getULong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating ULong");
#endif
              break;
    case   1: any <<= ernie.getLong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Long");
#endif
              break;
    case   2: any <<= ernie.getUShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating UShort");
#endif
              break;
    case   3: any <<= ernie.getShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Short");
#endif
              break;
    case   4: any <<= CORBA::Any::from_boolean(ernie.getBoolean());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Boolean");
#endif
              break;
    case   5: any <<= CORBA::Any::from_octet(ernie.getOctet());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Octet");
#endif
              break;
    case   6: any <<= CORBA::Any::from_char(ernie.getChar());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Char");
#endif
              break;
    case   7: any <<= ernie.getFloat();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Float");
#endif
               break;
    case   8: any <<= ernie.getDouble();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Double");
#endif
              break;
    case   9: any <<= ernie.getString();
#ifdef DEBUG
              ::tet_infoline("GetAny creating String");
#endif
              break;
    case  10: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating BoundedString");
#endif
                CORBA::ULong  b;
                b = ernie.getULong()%30+1;
                any <<= CORBA::Any::from_string(ernie.getString(b),b);
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr _typecode;
#ifdef DEBUG
                ::tet_infoline("GetAny creating TypeCode");
#endif
                GetCORBATypeCode_ptr(_typecode);
                any <<= _typecode;
               }
                break;
    case   12: {
                CORBA::Any  _any;  
#ifdef DEBUG
                ::tet_infoline("GetAny creating Any");
#endif
                GetAny(_any);
                any <<= _any;
               }
                break;

    case  13: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::EggPlant138");
#endif
                ::EggPlant138   v;

                GetEggPlant138(v);

                any  <<= v;
              }
              break;

    case  14: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GooseBerry138");
#endif
                ::GooseBerry138   v;

                GetGooseBerry138(v);

                any  <<= v;
              }
              break;

    case  15: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GooseBerry138::HazelNut138");
#endif
                ::GooseBerry138::HazelNut138   v;

                GetGooseBerry138HazelNut138(v);

                any  <<= v;
              }
              break;

    case  16: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GooseBerry138::HazelNut138::Onion138");
#endif
                ::GooseBerry138::HazelNut138::Onion138   v;

                GetGooseBerry138HazelNut138Onion138(v);

                any  <<= v;
              }
              break;

    case  17: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GooseBerry138::HazelNut138::Onion138::RowanBerry138");
#endif
                ::GooseBerry138::HazelNut138::Onion138::RowanBerry138   v;

                GetGooseBerry138HazelNut138Onion138RowanBerry138(v);

                any  <<= v;
              }
              break;

    case  18: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::EggPlant139");
#endif
                ::EggPlant139   v;

                GetEggPlant139(v);

                any  <<= v;
              }
              break;

    case  19: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GooseBerry139");
#endif
                ::GooseBerry139   v;

                GetGooseBerry139(v);

                any  <<= v;
              }
              break;

    case  20: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GooseBerry139::HazelNut139");
#endif
                ::GooseBerry139::HazelNut139   v;

                GetGooseBerry139HazelNut139(v);

                any  <<= v;
              }
              break;

    case  21: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GooseBerry139::HazelNut139::CrabApple139");
#endif
                ::GooseBerry139::HazelNut139::CrabApple139   v;

                GetGooseBerry139HazelNut139CrabApple139(v);

                any  <<= v;
              }
              break;

    case  22: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GooseBerry139::HazelNut139::CrabApple139::Lentil139");
#endif
                ::GooseBerry139::HazelNut139::CrabApple139::Lentil139   v;

                GetGooseBerry139HazelNut139CrabApple139Lentil139(v);

                any  <<= v;
              }
              break;

    case  23: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::RedOnion140");
#endif
                ::RedOnion140   v;

                GetRedOnion140(v);

                any  <<= v;
              }
              break;

    case  24: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CrabApple140");
#endif
                ::CrabApple140   v;

                GetCrabApple140(v);

                any  <<= v;
              }
              break;

    case  25: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CrabApple140::Lentil140");
#endif
                ::CrabApple140::Lentil140   v;

                GetCrabApple140Lentil140(v);

                any  <<= v;
              }
              break;

    case  26: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CrabApple140::Lentil140::CantelopeMelon140");
#endif
                ::CrabApple140::Lentil140::CantelopeMelon140   v;

                GetCrabApple140Lentil140CantelopeMelon140(v);

                any  <<= v;
              }
              break;

    case  27: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CrabApple140::Lentil140::CantelopeMelon140::Sultana140");
#endif
                ::CrabApple140::Lentil140::CantelopeMelon140::Sultana140   v;

                GetCrabApple140Lentil140CantelopeMelon140Sultana140(v);

                any  <<= v;
              }
              break;

    case  28: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::RedOnion141");
#endif
                ::RedOnion141   v;

                GetRedOnion141(v);

                any  <<= v;
              }
              break;

    case  29: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CrabApple141");
#endif
                ::CrabApple141   v;

                GetCrabApple141(v);

                any  <<= v;
              }
              break;

    case  30: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CrabApple141::Lentil141");
#endif
                ::CrabApple141::Lentil141   v;

                GetCrabApple141Lentil141(v);

                any  <<= v;
              }
              break;

    case  31: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CrabApple141::Lentil141::Avocado141");
#endif
                ::CrabApple141::Lentil141::Avocado141   v;

                GetCrabApple141Lentil141Avocado141(v);

                any  <<= v;
              }
              break;

    case  32: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::CrabApple141::Lentil141::Avocado141::Oregano141");
#endif
                ::CrabApple141::Lentil141::Avocado141::Oregano141   v;

                GetCrabApple141Lentil141Avocado141Oregano141(v);

                any  <<= v;
              }
              break;

    case  33: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Fig142");
#endif
                ::Fig142   v;

                GetFig142(v);

                any  <<= v;
              }
              break;

    case  34: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lentil142");
#endif
                ::Lentil142   v;

                GetLentil142(v);

                any  <<= v;
              }
              break;

    case  35: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lentil142::Avocado142");
#endif
                ::Lentil142::Avocado142   v;

                GetLentil142Avocado142(v);

                any  <<= v;
              }
              break;

    case  36: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lentil142::Avocado142::Tangarine142");
#endif
                ::Lentil142::Avocado142::Tangarine142   v;

                GetLentil142Avocado142Tangarine142(v);

                any  <<= v;
              }
              break;

    case  37: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lentil142::Avocado142::Tangarine142::BrazilNut142");
#endif
                ::Lentil142::Avocado142::Tangarine142::BrazilNut142   v;

                GetLentil142Avocado142Tangarine142BrazilNut142(v);

                any  <<= v;
              }
              break;

    case  38: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Fig143");
#endif
                ::Fig143   v;

                GetFig143(v);

                any  <<= v;
              }
              break;

    case  39: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lentil143");
#endif
                ::Lentil143   v;

                GetLentil143(v);

                any  <<= v;
              }
              break;

    case  40: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lentil143::Avocado143");
#endif
                ::Lentil143::Avocado143   v;

                GetLentil143Avocado143(v);

                any  <<= v;
              }
              break;

    case  41: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lentil143::Avocado143::Zucchini143");
#endif
                ::Lentil143::Avocado143::Zucchini143   v;

                GetLentil143Avocado143Zucchini143(v);

                any  <<= v;
              }
              break;

    case  42: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lentil143::Avocado143::Zucchini143::Plum143");
#endif
                ::Lentil143::Avocado143::Zucchini143::Plum143   v;

                GetLentil143Avocado143Zucchini143Plum143(v);

                any  <<= v;
              }
              break;

    case  43: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::ButterBean144");
#endif
                ::ButterBean144   v;

                GetButterBean144(v);

                any  <<= v;
              }
              break;

    case  44: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Zucchini144");
#endif
                ::Zucchini144   v;

                GetZucchini144(v);

                any  <<= v;
              }
              break;

    case  45: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Zucchini144::Plum144");
#endif
                ::Zucchini144::Plum144   v;

                GetZucchini144Plum144(v);

                any  <<= v;
              }
              break;

    case  46: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Zucchini144::Plum144::Brocoli144");
#endif
                ::Zucchini144::Plum144::Brocoli144   v;

                GetZucchini144Plum144Brocoli144(v);

                any  <<= v;
              }
              break;

    case  47: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Zucchini144::Plum144::Brocoli144::BlackEyedBeans144");
#endif
                ::Zucchini144::Plum144::Brocoli144::BlackEyedBeans144   v;

                GetZucchini144Plum144Brocoli144BlackEyedBeans144(v);

                any  <<= v;
              }
              break;

  }
}


