//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:45  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1999/04/26 13:51:57  james
// Changed CORBA::Char* to char*
//
// Revision 1.6  1997/12/15 10:52:00  james
// #ifdefs removed
//
// Revision 1.5  1997/12/12 09:03:50  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetEggPlant138(::EggPlant138 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetEggPlant138");
#endif

  {
    int	i1;
    for(i1=0; i1 < 18; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Cinnamon138.RedOnion138[i1].Sweetcorn138.LolloRossa138.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetLong(v.Cinnamon138.RedOnion138[i1].Sweetcorn138.LolloRossa138[i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckEggPlant138(const ::EggPlant138 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckEggPlant138");
#endif

  AddName("Cinnamon138");
  AddName("RedOnion138");
  {
    int	i1;
    for(i1=0; i1 < 18; ++i1)
    {
      AddIndex(i1);
      AddName("Sweetcorn138");
      AddName("LolloRossa138");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Cinnamon138.RedOnion138[i1].Sweetcorn138.LolloRossa138.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Cinnamon138.RedOnion138[i1].Sweetcorn138.LolloRossa138.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckLong(v.Cinnamon138.RedOnion138[i1].Sweetcorn138.LolloRossa138[i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetGooseBerry138(::GooseBerry138 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGooseBerry138");
#endif

  {
    int	i1;
    for(i1=0; i1 < 18; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Cinnamon138.RedOnion138[i1].Sweetcorn138.LolloRossa138.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetLong(v.Cinnamon138.RedOnion138[i1].Sweetcorn138.LolloRossa138[i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckGooseBerry138(const ::GooseBerry138 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGooseBerry138");
#endif

  AddName("Cinnamon138");
  AddName("RedOnion138");
  {
    int	i1;
    for(i1=0; i1 < 18; ++i1)
    {
      AddIndex(i1);
      AddName("Sweetcorn138");
      AddName("LolloRossa138");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Cinnamon138.RedOnion138[i1].Sweetcorn138.LolloRossa138.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Cinnamon138.RedOnion138[i1].Sweetcorn138.LolloRossa138.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckLong(v.Cinnamon138.RedOnion138[i1].Sweetcorn138.LolloRossa138[i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetGooseBerry138HazelNut138(::GooseBerry138::HazelNut138 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGooseBerry138HazelNut138");
#endif

  {
    int	i1;
    for(i1=0; i1 < 18; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.RedOnion138[i1].Sweetcorn138.LolloRossa138.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetLong(v.RedOnion138[i1].Sweetcorn138.LolloRossa138[i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckGooseBerry138HazelNut138(const ::GooseBerry138::HazelNut138 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGooseBerry138HazelNut138");
#endif

  AddName("RedOnion138");
  {
    int	i1;
    for(i1=0; i1 < 18; ++i1)
    {
      AddIndex(i1);
      AddName("Sweetcorn138");
      AddName("LolloRossa138");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.RedOnion138[i1].Sweetcorn138.LolloRossa138.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.RedOnion138[i1].Sweetcorn138.LolloRossa138.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckLong(v.RedOnion138[i1].Sweetcorn138.LolloRossa138[i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetGooseBerry138HazelNut138Onion138(::GooseBerry138::HazelNut138::Onion138 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGooseBerry138HazelNut138Onion138");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Sweetcorn138.LolloRossa138.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetLong(v.Sweetcorn138.LolloRossa138[i1]);
      RemoveIndex();
    }
  }
}

int CheckGooseBerry138HazelNut138Onion138(const ::GooseBerry138::HazelNut138::Onion138 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGooseBerry138HazelNut138Onion138");
#endif

  AddName("Sweetcorn138");
  AddName("LolloRossa138");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Sweetcorn138.LolloRossa138.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Sweetcorn138.LolloRossa138.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckLong(v.Sweetcorn138.LolloRossa138[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetGooseBerry138HazelNut138Onion138RowanBerry138(::GooseBerry138::HazelNut138::Onion138::RowanBerry138 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGooseBerry138HazelNut138Onion138RowanBerry138");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.LolloRossa138.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetLong(v.LolloRossa138[i1]);
      RemoveIndex();
    }
  }
}

int CheckGooseBerry138HazelNut138Onion138RowanBerry138(const ::GooseBerry138::HazelNut138::Onion138::RowanBerry138 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGooseBerry138HazelNut138Onion138RowanBerry138");
#endif

  AddName("LolloRossa138");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.LolloRossa138.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.LolloRossa138.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckLong(v.LolloRossa138[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetEggPlant139(::EggPlant139 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetEggPlant139");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Cinnamon139.RedOnion139.Fig139.GoldenDelicous139.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetShort(v.Cinnamon139.RedOnion139.Fig139.GoldenDelicous139[i1]);
      RemoveIndex();
    }
  }
}

int CheckEggPlant139(const ::EggPlant139 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckEggPlant139");
#endif

  AddName("Cinnamon139");
  AddName("RedOnion139");
  AddName("Fig139");
  AddName("GoldenDelicous139");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Cinnamon139.RedOnion139.Fig139.GoldenDelicous139.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Cinnamon139.RedOnion139.Fig139.GoldenDelicous139.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckShort(v.Cinnamon139.RedOnion139.Fig139.GoldenDelicous139[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetGooseBerry139(::GooseBerry139 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGooseBerry139");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Cinnamon139.RedOnion139.Fig139.GoldenDelicous139.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetShort(v.Cinnamon139.RedOnion139.Fig139.GoldenDelicous139[i1]);
      RemoveIndex();
    }
  }
}

int CheckGooseBerry139(const ::GooseBerry139 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGooseBerry139");
#endif

  AddName("Cinnamon139");
  AddName("RedOnion139");
  AddName("Fig139");
  AddName("GoldenDelicous139");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Cinnamon139.RedOnion139.Fig139.GoldenDelicous139.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Cinnamon139.RedOnion139.Fig139.GoldenDelicous139.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckShort(v.Cinnamon139.RedOnion139.Fig139.GoldenDelicous139[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetGooseBerry139HazelNut139(::GooseBerry139::HazelNut139 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGooseBerry139HazelNut139");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.RedOnion139.Fig139.GoldenDelicous139.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetShort(v.RedOnion139.Fig139.GoldenDelicous139[i1]);
      RemoveIndex();
    }
  }
}

int CheckGooseBerry139HazelNut139(const ::GooseBerry139::HazelNut139 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGooseBerry139HazelNut139");
#endif

  AddName("RedOnion139");
  AddName("Fig139");
  AddName("GoldenDelicous139");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.RedOnion139.Fig139.GoldenDelicous139.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.RedOnion139.Fig139.GoldenDelicous139.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckShort(v.RedOnion139.Fig139.GoldenDelicous139[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetGooseBerry139HazelNut139CrabApple139(::GooseBerry139::HazelNut139::CrabApple139 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGooseBerry139HazelNut139CrabApple139");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Fig139.GoldenDelicous139.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetShort(v.Fig139.GoldenDelicous139[i1]);
      RemoveIndex();
    }
  }
}

int CheckGooseBerry139HazelNut139CrabApple139(const ::GooseBerry139::HazelNut139::CrabApple139 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGooseBerry139HazelNut139CrabApple139");
#endif

  AddName("Fig139");
  AddName("GoldenDelicous139");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Fig139.GoldenDelicous139.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Fig139.GoldenDelicous139.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckShort(v.Fig139.GoldenDelicous139[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetGooseBerry139HazelNut139CrabApple139Lentil139(::GooseBerry139::HazelNut139::CrabApple139::Lentil139 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGooseBerry139HazelNut139CrabApple139Lentil139");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.GoldenDelicous139.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetShort(v.GoldenDelicous139[i1]);
      RemoveIndex();
    }
  }
}

int CheckGooseBerry139HazelNut139CrabApple139Lentil139(const ::GooseBerry139::HazelNut139::CrabApple139::Lentil139 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGooseBerry139HazelNut139CrabApple139Lentil139");
#endif

  AddName("GoldenDelicous139");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.GoldenDelicous139.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.GoldenDelicous139.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckShort(v.GoldenDelicous139[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetRedOnion140(::RedOnion140 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetRedOnion140");
#endif

  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 15; ++i3)
        {
          AddIndex(i3);
          {
            int	i5;
            for(i5=0; i5 < 13; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                v.Fig140.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetShort(v.Fig140.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckRedOnion140(const ::RedOnion140 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRedOnion140");
#endif

  AddName("Fig140");
  AddName("GoldenDelicous140");
  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      AddName("Billberries140");
      {
        int	i3;
        for(i3=0; i3 < 15; ++i3)
        {
          AddIndex(i3);
          AddName("GaliaMelon140");
          {
            int	i5;
            for(i5=0; i5 < 13; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                if (l7 != v.Fig140.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Fig140.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckShort(v.Fig140.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveName();
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetCrabApple140(::CrabApple140 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCrabApple140");
#endif

  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 15; ++i3)
        {
          AddIndex(i3);
          {
            int	i5;
            for(i5=0; i5 < 13; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                v.Fig140.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetShort(v.Fig140.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCrabApple140(const ::CrabApple140 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCrabApple140");
#endif

  AddName("Fig140");
  AddName("GoldenDelicous140");
  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      AddName("Billberries140");
      {
        int	i3;
        for(i3=0; i3 < 15; ++i3)
        {
          AddIndex(i3);
          AddName("GaliaMelon140");
          {
            int	i5;
            for(i5=0; i5 < 13; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                if (l7 != v.Fig140.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Fig140.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckShort(v.Fig140.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveName();
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetCrabApple140Lentil140(::CrabApple140::Lentil140 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCrabApple140Lentil140");
#endif

  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 15; ++i3)
        {
          AddIndex(i3);
          {
            int	i5;
            for(i5=0; i5 < 13; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                v.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetShort(v.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCrabApple140Lentil140(const ::CrabApple140::Lentil140 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCrabApple140Lentil140");
#endif

  AddName("GoldenDelicous140");
  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      AddName("Billberries140");
      {
        int	i3;
        for(i3=0; i3 < 15; ++i3)
        {
          AddIndex(i3);
          AddName("GaliaMelon140");
          {
            int	i5;
            for(i5=0; i5 < 13; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                if (l7 != v.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckShort(v.GoldenDelicous140[i1].Billberries140[i3].GaliaMelon140[i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveName();
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetCrabApple140Lentil140CantelopeMelon140(::CrabApple140::Lentil140::CantelopeMelon140 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCrabApple140Lentil140CantelopeMelon140");
#endif

  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 13; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%18;
            v.Billberries140[i1].GaliaMelon140[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetShort(v.Billberries140[i1].GaliaMelon140[i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCrabApple140Lentil140CantelopeMelon140(const ::CrabApple140::Lentil140::CantelopeMelon140 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCrabApple140Lentil140CantelopeMelon140");
#endif

  AddName("Billberries140");
  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      AddName("GaliaMelon140");
      {
        int	i3;
        for(i3=0; i3 < 13; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%18;
            if (l5 != v.Billberries140[i1].GaliaMelon140[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Billberries140[i1].GaliaMelon140[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckShort(v.Billberries140[i1].GaliaMelon140[i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetCrabApple140Lentil140CantelopeMelon140Sultana140(::CrabApple140::Lentil140::CantelopeMelon140::Sultana140 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCrabApple140Lentil140CantelopeMelon140Sultana140");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%18;
        v.GaliaMelon140[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetShort(v.GaliaMelon140[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCrabApple140Lentil140CantelopeMelon140Sultana140(const ::CrabApple140::Lentil140::CantelopeMelon140::Sultana140 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCrabApple140Lentil140CantelopeMelon140Sultana140");
#endif

  AddName("GaliaMelon140");
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%18;
        if (l3 != v.GaliaMelon140[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GaliaMelon140[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckShort(v.GaliaMelon140[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetRedOnion141(::RedOnion141 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetRedOnion141");
#endif

  {
    int	i1;
    for(i1=0; i1 < 19; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 10; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            v.Fig141.GoldenDelicous141.ButterBean141[i1].Dill141[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetULong(v.Fig141.GoldenDelicous141.ButterBean141[i1].Dill141[i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckRedOnion141(const ::RedOnion141 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRedOnion141");
#endif

  AddName("Fig141");
  AddName("GoldenDelicous141");
  AddName("ButterBean141");
  {
    int	i1;
    for(i1=0; i1 < 19; ++i1)
    {
      AddIndex(i1);
      AddName("Dill141");
      {
        int	i3;
        for(i3=0; i3 < 10; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            if (l5 != v.Fig141.GoldenDelicous141.ButterBean141[i1].Dill141[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Fig141.GoldenDelicous141.ButterBean141[i1].Dill141[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckULong(v.Fig141.GoldenDelicous141.ButterBean141[i1].Dill141[i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetCrabApple141(::CrabApple141 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCrabApple141");
#endif

  {
    int	i1;
    for(i1=0; i1 < 19; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 10; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            v.Fig141.GoldenDelicous141.ButterBean141[i1].Dill141[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetULong(v.Fig141.GoldenDelicous141.ButterBean141[i1].Dill141[i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCrabApple141(const ::CrabApple141 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCrabApple141");
#endif

  AddName("Fig141");
  AddName("GoldenDelicous141");
  AddName("ButterBean141");
  {
    int	i1;
    for(i1=0; i1 < 19; ++i1)
    {
      AddIndex(i1);
      AddName("Dill141");
      {
        int	i3;
        for(i3=0; i3 < 10; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            if (l5 != v.Fig141.GoldenDelicous141.ButterBean141[i1].Dill141[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Fig141.GoldenDelicous141.ButterBean141[i1].Dill141[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckULong(v.Fig141.GoldenDelicous141.ButterBean141[i1].Dill141[i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetCrabApple141Lentil141(::CrabApple141::Lentil141 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCrabApple141Lentil141");
#endif

  {
    int	i1;
    for(i1=0; i1 < 19; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 10; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            v.GoldenDelicous141.ButterBean141[i1].Dill141[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetULong(v.GoldenDelicous141.ButterBean141[i1].Dill141[i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCrabApple141Lentil141(const ::CrabApple141::Lentil141 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCrabApple141Lentil141");
#endif

  AddName("GoldenDelicous141");
  AddName("ButterBean141");
  {
    int	i1;
    for(i1=0; i1 < 19; ++i1)
    {
      AddIndex(i1);
      AddName("Dill141");
      {
        int	i3;
        for(i3=0; i3 < 10; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            if (l5 != v.GoldenDelicous141.ButterBean141[i1].Dill141[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GoldenDelicous141.ButterBean141[i1].Dill141[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckULong(v.GoldenDelicous141.ButterBean141[i1].Dill141[i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetCrabApple141Lentil141Avocado141(::CrabApple141::Lentil141::Avocado141 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCrabApple141Lentil141Avocado141");
#endif

  {
    int	i1;
    for(i1=0; i1 < 19; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 10; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            v.ButterBean141[i1].Dill141[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetULong(v.ButterBean141[i1].Dill141[i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCrabApple141Lentil141Avocado141(const ::CrabApple141::Lentil141::Avocado141 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCrabApple141Lentil141Avocado141");
#endif

  AddName("ButterBean141");
  {
    int	i1;
    for(i1=0; i1 < 19; ++i1)
    {
      AddIndex(i1);
      AddName("Dill141");
      {
        int	i3;
        for(i3=0; i3 < 10; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            if (l5 != v.ButterBean141[i1].Dill141[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.ButterBean141[i1].Dill141[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckULong(v.ButterBean141[i1].Dill141[i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetCrabApple141Lentil141Avocado141Oregano141(::CrabApple141::Lentil141::Avocado141::Oregano141 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCrabApple141Lentil141Avocado141Oregano141");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.Dill141[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetULong(v.Dill141[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCrabApple141Lentil141Avocado141Oregano141(const ::CrabApple141::Lentil141::Avocado141::Oregano141 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCrabApple141Lentil141Avocado141Oregano141");
#endif

  AddName("Dill141");
  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.Dill141[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Dill141[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckULong(v.Dill141[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetFig142(::Fig142 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetFig142");
#endif

  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 6; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%12;
            v.GoldenDelicous142.ButterBean142[i1].SweetPotato142.GrannySmith142[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetUShort(v.GoldenDelicous142.ButterBean142[i1].SweetPotato142.GrannySmith142[i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckFig142(const ::Fig142 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckFig142");
#endif

  AddName("GoldenDelicous142");
  AddName("ButterBean142");
  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      AddName("SweetPotato142");
      AddName("GrannySmith142");
      {
        int	i3;
        for(i3=0; i3 < 6; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%12;
            if (l5 != v.GoldenDelicous142.ButterBean142[i1].SweetPotato142.GrannySmith142[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GoldenDelicous142.ButterBean142[i1].SweetPotato142.GrannySmith142[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckUShort(v.GoldenDelicous142.ButterBean142[i1].SweetPotato142.GrannySmith142[i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetLentil142(::Lentil142 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLentil142");
#endif

  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 6; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%12;
            v.GoldenDelicous142.ButterBean142[i1].SweetPotato142.GrannySmith142[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetUShort(v.GoldenDelicous142.ButterBean142[i1].SweetPotato142.GrannySmith142[i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLentil142(const ::Lentil142 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLentil142");
#endif

  AddName("GoldenDelicous142");
  AddName("ButterBean142");
  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      AddName("SweetPotato142");
      AddName("GrannySmith142");
      {
        int	i3;
        for(i3=0; i3 < 6; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%12;
            if (l5 != v.GoldenDelicous142.ButterBean142[i1].SweetPotato142.GrannySmith142[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GoldenDelicous142.ButterBean142[i1].SweetPotato142.GrannySmith142[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckUShort(v.GoldenDelicous142.ButterBean142[i1].SweetPotato142.GrannySmith142[i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetLentil142Avocado142(::Lentil142::Avocado142 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLentil142Avocado142");
#endif

  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 6; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%12;
            v.ButterBean142[i1].SweetPotato142.GrannySmith142[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetUShort(v.ButterBean142[i1].SweetPotato142.GrannySmith142[i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLentil142Avocado142(const ::Lentil142::Avocado142 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLentil142Avocado142");
#endif

  AddName("ButterBean142");
  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      AddName("SweetPotato142");
      AddName("GrannySmith142");
      {
        int	i3;
        for(i3=0; i3 < 6; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%12;
            if (l5 != v.ButterBean142[i1].SweetPotato142.GrannySmith142[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.ButterBean142[i1].SweetPotato142.GrannySmith142[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckUShort(v.ButterBean142[i1].SweetPotato142.GrannySmith142[i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetLentil142Avocado142Tangarine142(::Lentil142::Avocado142::Tangarine142 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLentil142Avocado142Tangarine142");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%12;
        v.SweetPotato142.GrannySmith142[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetUShort(v.SweetPotato142.GrannySmith142[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLentil142Avocado142Tangarine142(const ::Lentil142::Avocado142::Tangarine142 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLentil142Avocado142Tangarine142");
#endif

  AddName("SweetPotato142");
  AddName("GrannySmith142");
  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%12;
        if (l3 != v.SweetPotato142.GrannySmith142[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.SweetPotato142.GrannySmith142[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckUShort(v.SweetPotato142.GrannySmith142[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetLentil142Avocado142Tangarine142BrazilNut142(::Lentil142::Avocado142::Tangarine142::BrazilNut142 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLentil142Avocado142Tangarine142BrazilNut142");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%12;
        v.GrannySmith142[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetUShort(v.GrannySmith142[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLentil142Avocado142Tangarine142BrazilNut142(const ::Lentil142::Avocado142::Tangarine142::BrazilNut142 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLentil142Avocado142Tangarine142BrazilNut142");
#endif

  AddName("GrannySmith142");
  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%12;
        if (l3 != v.GrannySmith142[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GrannySmith142[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckUShort(v.GrannySmith142[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetFig143(::Fig143 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetFig143");
#endif

  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.GoldenDelicous143.ButterBean143.KidneyBean143.Shallots143[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetChar(v.GoldenDelicous143.ButterBean143.KidneyBean143.Shallots143[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckFig143(const ::Fig143 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckFig143");
#endif

  AddName("GoldenDelicous143");
  AddName("ButterBean143");
  AddName("KidneyBean143");
  AddName("Shallots143");
  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.GoldenDelicous143.ButterBean143.KidneyBean143.Shallots143[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GoldenDelicous143.ButterBean143.KidneyBean143.Shallots143[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckChar(v.GoldenDelicous143.ButterBean143.KidneyBean143.Shallots143[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetLentil143(::Lentil143 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLentil143");
#endif

  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.GoldenDelicous143.ButterBean143.KidneyBean143.Shallots143[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetChar(v.GoldenDelicous143.ButterBean143.KidneyBean143.Shallots143[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLentil143(const ::Lentil143 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLentil143");
#endif

  AddName("GoldenDelicous143");
  AddName("ButterBean143");
  AddName("KidneyBean143");
  AddName("Shallots143");
  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.GoldenDelicous143.ButterBean143.KidneyBean143.Shallots143[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GoldenDelicous143.ButterBean143.KidneyBean143.Shallots143[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckChar(v.GoldenDelicous143.ButterBean143.KidneyBean143.Shallots143[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetLentil143Avocado143(::Lentil143::Avocado143 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLentil143Avocado143");
#endif

  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.ButterBean143.KidneyBean143.Shallots143[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetChar(v.ButterBean143.KidneyBean143.Shallots143[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLentil143Avocado143(const ::Lentil143::Avocado143 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLentil143Avocado143");
#endif

  AddName("ButterBean143");
  AddName("KidneyBean143");
  AddName("Shallots143");
  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.ButterBean143.KidneyBean143.Shallots143[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.ButterBean143.KidneyBean143.Shallots143[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckChar(v.ButterBean143.KidneyBean143.Shallots143[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetLentil143Avocado143Zucchini143(::Lentil143::Avocado143::Zucchini143 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLentil143Avocado143Zucchini143");
#endif

  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.KidneyBean143.Shallots143[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetChar(v.KidneyBean143.Shallots143[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLentil143Avocado143Zucchini143(const ::Lentil143::Avocado143::Zucchini143 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLentil143Avocado143Zucchini143");
#endif

  AddName("KidneyBean143");
  AddName("Shallots143");
  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.KidneyBean143.Shallots143[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.KidneyBean143.Shallots143[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckChar(v.KidneyBean143.Shallots143[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetLentil143Avocado143Zucchini143Plum143(::Lentil143::Avocado143::Zucchini143::Plum143 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLentil143Avocado143Zucchini143Plum143");
#endif

  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.Shallots143[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetChar(v.Shallots143[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLentil143Avocado143Zucchini143Plum143(const ::Lentil143::Avocado143::Zucchini143::Plum143 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLentil143Avocado143Zucchini143Plum143");
#endif

  AddName("Shallots143");
  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.Shallots143[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Shallots143[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckChar(v.Shallots143[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetButterBean144(::ButterBean144 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetButterBean144");
#endif

  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 5; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            v.KidneyBean144.Shallots144[i1].Prunes144[i3].Apricots144.length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetBoolean(v.KidneyBean144.Shallots144[i1].Prunes144[i3].Apricots144[i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckButterBean144(const ::ButterBean144 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckButterBean144");
#endif

  AddName("KidneyBean144");
  AddName("Shallots144");
  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      AddName("Prunes144");
      {
        int	i3;
        for(i3=0; i3 < 5; ++i3)
        {
          AddIndex(i3);
          AddName("Apricots144");
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            if (l5 != v.KidneyBean144.Shallots144[i1].Prunes144[i3].Apricots144.length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.KidneyBean144.Shallots144[i1].Prunes144[i3].Apricots144.length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckBoolean(v.KidneyBean144.Shallots144[i1].Prunes144[i3].Apricots144[i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveName();
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetZucchini144(::Zucchini144 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetZucchini144");
#endif

  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 5; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            v.KidneyBean144.Shallots144[i1].Prunes144[i3].Apricots144.length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetBoolean(v.KidneyBean144.Shallots144[i1].Prunes144[i3].Apricots144[i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckZucchini144(const ::Zucchini144 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckZucchini144");
#endif

  AddName("KidneyBean144");
  AddName("Shallots144");
  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      AddName("Prunes144");
      {
        int	i3;
        for(i3=0; i3 < 5; ++i3)
        {
          AddIndex(i3);
          AddName("Apricots144");
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            if (l5 != v.KidneyBean144.Shallots144[i1].Prunes144[i3].Apricots144.length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.KidneyBean144.Shallots144[i1].Prunes144[i3].Apricots144.length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckBoolean(v.KidneyBean144.Shallots144[i1].Prunes144[i3].Apricots144[i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveName();
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetZucchini144Plum144(::Zucchini144::Plum144 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetZucchini144Plum144");
#endif

  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 5; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            v.Shallots144[i1].Prunes144[i3].Apricots144.length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetBoolean(v.Shallots144[i1].Prunes144[i3].Apricots144[i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckZucchini144Plum144(const ::Zucchini144::Plum144 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckZucchini144Plum144");
#endif

  AddName("Shallots144");
  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      AddName("Prunes144");
      {
        int	i3;
        for(i3=0; i3 < 5; ++i3)
        {
          AddIndex(i3);
          AddName("Apricots144");
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            if (l5 != v.Shallots144[i1].Prunes144[i3].Apricots144.length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Shallots144[i1].Prunes144[i3].Apricots144.length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckBoolean(v.Shallots144[i1].Prunes144[i3].Apricots144[i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveName();
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetZucchini144Plum144Brocoli144(::Zucchini144::Plum144::Brocoli144 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetZucchini144Plum144Brocoli144");
#endif

  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%2;
        v.Prunes144[i1].Apricots144.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetBoolean(v.Prunes144[i1].Apricots144[i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckZucchini144Plum144Brocoli144(const ::Zucchini144::Plum144::Brocoli144 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckZucchini144Plum144Brocoli144");
#endif

  AddName("Prunes144");
  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      AddName("Apricots144");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%2;
        if (l3 != v.Prunes144[i1].Apricots144.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Prunes144[i1].Apricots144.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckBoolean(v.Prunes144[i1].Apricots144[i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetZucchini144Plum144Brocoli144BlackEyedBeans144(::Zucchini144::Plum144::Brocoli144::BlackEyedBeans144 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetZucchini144Plum144Brocoli144BlackEyedBeans144");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%2;
    v.Apricots144.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetBoolean(v.Apricots144[i1]);
      RemoveIndex();
    }
  }
}

int CheckZucchini144Plum144Brocoli144BlackEyedBeans144(const ::Zucchini144::Plum144::Brocoli144::BlackEyedBeans144 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckZucchini144Plum144Brocoli144BlackEyedBeans144");
#endif

  AddName("Apricots144");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%2;
    if (l1 != v.Apricots144.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Apricots144.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckBoolean(v.Apricots144[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetidlServerEggPlant138Excpt(::idlServer::EggPlant138Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerEggPlant138Excpt");
#endif

  GetEggPlant138(v.ex1);
}

int CheckidlServerEggPlant138Excpt(const ::idlServer::EggPlant138Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerEggPlant138Excpt");
#endif

  AddName("ex1");
  if (!CheckEggPlant138(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerGooseBerry138Excpt(::idlServer::GooseBerry138Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerGooseBerry138Excpt");
#endif

  GetGooseBerry138(v.ex1);
}

int CheckidlServerGooseBerry138Excpt(const ::idlServer::GooseBerry138Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerGooseBerry138Excpt");
#endif

  AddName("ex1");
  if (!CheckGooseBerry138(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerHazelNut138Excpt(::idlServer::HazelNut138Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerHazelNut138Excpt");
#endif

  GetGooseBerry138HazelNut138(v.ex1);
}

int CheckidlServerHazelNut138Excpt(const ::idlServer::HazelNut138Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerHazelNut138Excpt");
#endif

  AddName("ex1");
  if (!CheckGooseBerry138HazelNut138(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerOnion138Excpt(::idlServer::Onion138Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerOnion138Excpt");
#endif

  GetGooseBerry138HazelNut138Onion138(v.ex1);
}

int CheckidlServerOnion138Excpt(const ::idlServer::Onion138Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerOnion138Excpt");
#endif

  AddName("ex1");
  if (!CheckGooseBerry138HazelNut138Onion138(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerRowanBerry138Excpt(::idlServer::RowanBerry138Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerRowanBerry138Excpt");
#endif

  GetGooseBerry138HazelNut138Onion138RowanBerry138(v.ex1);
}

int CheckidlServerRowanBerry138Excpt(const ::idlServer::RowanBerry138Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerRowanBerry138Excpt");
#endif

  AddName("ex1");
  if (!CheckGooseBerry138HazelNut138Onion138RowanBerry138(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerEggPlant139Excpt(::idlServer::EggPlant139Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerEggPlant139Excpt");
#endif

  GetEggPlant139(v.ex1);
}

int CheckidlServerEggPlant139Excpt(const ::idlServer::EggPlant139Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerEggPlant139Excpt");
#endif

  AddName("ex1");
  if (!CheckEggPlant139(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerGooseBerry139Excpt(::idlServer::GooseBerry139Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerGooseBerry139Excpt");
#endif

  GetGooseBerry139(v.ex1);
}

int CheckidlServerGooseBerry139Excpt(const ::idlServer::GooseBerry139Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerGooseBerry139Excpt");
#endif

  AddName("ex1");
  if (!CheckGooseBerry139(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerHazelNut139Excpt(::idlServer::HazelNut139Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerHazelNut139Excpt");
#endif

  GetGooseBerry139HazelNut139(v.ex1);
}

int CheckidlServerHazelNut139Excpt(const ::idlServer::HazelNut139Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerHazelNut139Excpt");
#endif

  AddName("ex1");
  if (!CheckGooseBerry139HazelNut139(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerCrabApple139Excpt(::idlServer::CrabApple139Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerCrabApple139Excpt");
#endif

  GetGooseBerry139HazelNut139CrabApple139(v.ex1);
}

int CheckidlServerCrabApple139Excpt(const ::idlServer::CrabApple139Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerCrabApple139Excpt");
#endif

  AddName("ex1");
  if (!CheckGooseBerry139HazelNut139CrabApple139(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



