//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::EggPlant138*
idlServer_imp::EggPlant138Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::EggPlant138* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::EggPlant138Attr\n");
#endif
  
  ernie.seed("EggPlant138AttrCall");
  
  ernie.seed("EggPlant138AttrReturn"); 
  ReturnValue = new ::EggPlant138;
  GetEggPlant138(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::EggPlant138Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::EggPlant138Attr(const ::EggPlant138 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::EggPlant138Attr\n");
#endif
  
  ernie.seed("EggPlant138AttrCall");
  AddName("_attr");
  if (!CheckEggPlant138(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("EggPlant138AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::EggPlant138Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::EggPlant138*
idlServer_imp::EggPlant138Op(const ::EggPlant138 &p1,::EggPlant138_out p2,::EggPlant138 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::EggPlant138* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::EggPlant138Op\n");
#endif
  
  ernie.seed("EggPlant138OpCall");
  AddName("p1");
  if (!CheckEggPlant138(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckEggPlant138(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("EggPlant138OpReturn"); 
  {
    ::idlServer::EggPlant138Excpt ex;
    GetidlServerEggPlant138Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::EggPlant138;
  GetEggPlant138(*ReturnValue);
  p2 = new ::EggPlant138;
  GetEggPlant138(p2);
  GetEggPlant138(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::EggPlant138Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GooseBerry138*
idlServer_imp::GooseBerry138Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry138* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GooseBerry138Attr\n");
#endif
  
  ernie.seed("GooseBerry138AttrCall");
  
  ernie.seed("GooseBerry138AttrReturn"); 
  ReturnValue = new ::GooseBerry138;
  GetGooseBerry138(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GooseBerry138Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::GooseBerry138Attr(const ::GooseBerry138 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GooseBerry138Attr\n");
#endif
  
  ernie.seed("GooseBerry138AttrCall");
  AddName("_attr");
  if (!CheckGooseBerry138(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GooseBerry138AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GooseBerry138Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::GooseBerry138*
idlServer_imp::GooseBerry138Op(const ::GooseBerry138 &p1,::GooseBerry138_out p2,::GooseBerry138 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry138* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GooseBerry138Op\n");
#endif
  
  ernie.seed("GooseBerry138OpCall");
  AddName("p1");
  if (!CheckGooseBerry138(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry138(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GooseBerry138OpReturn"); 
  {
    ::idlServer::GooseBerry138Excpt ex;
    GetidlServerGooseBerry138Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::GooseBerry138;
  GetGooseBerry138(*ReturnValue);
  p2 = new ::GooseBerry138;
  GetGooseBerry138(p2);
  GetGooseBerry138(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GooseBerry138Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GooseBerry138::HazelNut138*
idlServer_imp::HazelNut138Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry138::HazelNut138* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::HazelNut138Attr\n");
#endif
  
  ernie.seed("HazelNut138AttrCall");
  
  ernie.seed("HazelNut138AttrReturn"); 
  ReturnValue = new ::GooseBerry138::HazelNut138;
  GetGooseBerry138HazelNut138(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::HazelNut138Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::HazelNut138Attr(const ::GooseBerry138::HazelNut138 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::HazelNut138Attr\n");
#endif
  
  ernie.seed("HazelNut138AttrCall");
  AddName("_attr");
  if (!CheckGooseBerry138HazelNut138(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("HazelNut138AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::HazelNut138Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::GooseBerry138::HazelNut138*
idlServer_imp::HazelNut138Op(const ::GooseBerry138::HazelNut138 &p1,::GooseBerry138::HazelNut138_out p2,::GooseBerry138::HazelNut138 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry138::HazelNut138* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::HazelNut138Op\n");
#endif
  
  ernie.seed("HazelNut138OpCall");
  AddName("p1");
  if (!CheckGooseBerry138HazelNut138(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry138HazelNut138(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("HazelNut138OpReturn"); 
  {
    ::idlServer::HazelNut138Excpt ex;
    GetidlServerHazelNut138Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::GooseBerry138::HazelNut138;
  GetGooseBerry138HazelNut138(*ReturnValue);
  p2 = new ::GooseBerry138::HazelNut138;
  GetGooseBerry138HazelNut138(p2);
  GetGooseBerry138HazelNut138(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::HazelNut138Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GooseBerry138::HazelNut138::Onion138*
idlServer_imp::Onion138Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry138::HazelNut138::Onion138* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Onion138Attr\n");
#endif
  
  ernie.seed("Onion138AttrCall");
  
  ernie.seed("Onion138AttrReturn"); 
  ReturnValue = new ::GooseBerry138::HazelNut138::Onion138;
  GetGooseBerry138HazelNut138Onion138(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Onion138Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Onion138Attr(const ::GooseBerry138::HazelNut138::Onion138 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Onion138Attr\n");
#endif
  
  ernie.seed("Onion138AttrCall");
  AddName("_attr");
  if (!CheckGooseBerry138HazelNut138Onion138(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Onion138AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Onion138Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::GooseBerry138::HazelNut138::Onion138*
idlServer_imp::Onion138Op(const ::GooseBerry138::HazelNut138::Onion138 &p1,::GooseBerry138::HazelNut138::Onion138_out p2,::GooseBerry138::HazelNut138::Onion138 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry138::HazelNut138::Onion138* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Onion138Op\n");
#endif
  
  ernie.seed("Onion138OpCall");
  AddName("p1");
  if (!CheckGooseBerry138HazelNut138Onion138(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry138HazelNut138Onion138(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Onion138OpReturn"); 
  {
    ::idlServer::Onion138Excpt ex;
    GetidlServerOnion138Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::GooseBerry138::HazelNut138::Onion138;
  GetGooseBerry138HazelNut138Onion138(*ReturnValue);
  p2 = new ::GooseBerry138::HazelNut138::Onion138;
  GetGooseBerry138HazelNut138Onion138(p2);
  GetGooseBerry138HazelNut138Onion138(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Onion138Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GooseBerry138::HazelNut138::Onion138::RowanBerry138*
idlServer_imp::RowanBerry138Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry138::HazelNut138::Onion138::RowanBerry138* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RowanBerry138Attr\n");
#endif
  
  ernie.seed("RowanBerry138AttrCall");
  
  ernie.seed("RowanBerry138AttrReturn"); 
  ReturnValue = new ::GooseBerry138::HazelNut138::Onion138::RowanBerry138;
  GetGooseBerry138HazelNut138Onion138RowanBerry138(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RowanBerry138Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::RowanBerry138Attr(const ::GooseBerry138::HazelNut138::Onion138::RowanBerry138 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RowanBerry138Attr\n");
#endif
  
  ernie.seed("RowanBerry138AttrCall");
  AddName("_attr");
  if (!CheckGooseBerry138HazelNut138Onion138RowanBerry138(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RowanBerry138AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RowanBerry138Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::GooseBerry138::HazelNut138::Onion138::RowanBerry138*
idlServer_imp::RowanBerry138Op(const ::GooseBerry138::HazelNut138::Onion138::RowanBerry138 &p1,::GooseBerry138::HazelNut138::Onion138::RowanBerry138_out p2,::GooseBerry138::HazelNut138::Onion138::RowanBerry138 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry138::HazelNut138::Onion138::RowanBerry138* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RowanBerry138Op\n");
#endif
  
  ernie.seed("RowanBerry138OpCall");
  AddName("p1");
  if (!CheckGooseBerry138HazelNut138Onion138RowanBerry138(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry138HazelNut138Onion138RowanBerry138(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RowanBerry138OpReturn"); 
  {
    ::idlServer::RowanBerry138Excpt ex;
    GetidlServerRowanBerry138Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::GooseBerry138::HazelNut138::Onion138::RowanBerry138;
  GetGooseBerry138HazelNut138Onion138RowanBerry138(*ReturnValue);
  p2 = new ::GooseBerry138::HazelNut138::Onion138::RowanBerry138;
  GetGooseBerry138HazelNut138Onion138RowanBerry138(p2);
  GetGooseBerry138HazelNut138Onion138RowanBerry138(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RowanBerry138Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::EggPlant139*
idlServer_imp::EggPlant139Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::EggPlant139* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::EggPlant139Attr\n");
#endif
  
  ernie.seed("EggPlant139AttrCall");
  
  ernie.seed("EggPlant139AttrReturn"); 
  ReturnValue = new ::EggPlant139;
  GetEggPlant139(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::EggPlant139Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::EggPlant139Attr(const ::EggPlant139 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::EggPlant139Attr\n");
#endif
  
  ernie.seed("EggPlant139AttrCall");
  AddName("_attr");
  if (!CheckEggPlant139(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("EggPlant139AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::EggPlant139Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::EggPlant139*
idlServer_imp::EggPlant139Op(const ::EggPlant139 &p1,::EggPlant139_out p2,::EggPlant139 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::EggPlant139* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::EggPlant139Op\n");
#endif
  
  ernie.seed("EggPlant139OpCall");
  AddName("p1");
  if (!CheckEggPlant139(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckEggPlant139(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("EggPlant139OpReturn"); 
  {
    ::idlServer::EggPlant139Excpt ex;
    GetidlServerEggPlant139Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::EggPlant139;
  GetEggPlant139(*ReturnValue);
  p2 = new ::EggPlant139;
  GetEggPlant139(p2);
  GetEggPlant139(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::EggPlant139Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GooseBerry139*
idlServer_imp::GooseBerry139Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry139* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GooseBerry139Attr\n");
#endif
  
  ernie.seed("GooseBerry139AttrCall");
  
  ernie.seed("GooseBerry139AttrReturn"); 
  ReturnValue = new ::GooseBerry139;
  GetGooseBerry139(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GooseBerry139Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::GooseBerry139Attr(const ::GooseBerry139 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GooseBerry139Attr\n");
#endif
  
  ernie.seed("GooseBerry139AttrCall");
  AddName("_attr");
  if (!CheckGooseBerry139(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GooseBerry139AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GooseBerry139Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::GooseBerry139*
idlServer_imp::GooseBerry139Op(const ::GooseBerry139 &p1,::GooseBerry139_out p2,::GooseBerry139 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry139* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GooseBerry139Op\n");
#endif
  
  ernie.seed("GooseBerry139OpCall");
  AddName("p1");
  if (!CheckGooseBerry139(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry139(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GooseBerry139OpReturn"); 
  {
    ::idlServer::GooseBerry139Excpt ex;
    GetidlServerGooseBerry139Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::GooseBerry139;
  GetGooseBerry139(*ReturnValue);
  p2 = new ::GooseBerry139;
  GetGooseBerry139(p2);
  GetGooseBerry139(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GooseBerry139Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GooseBerry139::HazelNut139*
idlServer_imp::HazelNut139Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry139::HazelNut139* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::HazelNut139Attr\n");
#endif
  
  ernie.seed("HazelNut139AttrCall");
  
  ernie.seed("HazelNut139AttrReturn"); 
  ReturnValue = new ::GooseBerry139::HazelNut139;
  GetGooseBerry139HazelNut139(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::HazelNut139Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::HazelNut139Attr(const ::GooseBerry139::HazelNut139 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::HazelNut139Attr\n");
#endif
  
  ernie.seed("HazelNut139AttrCall");
  AddName("_attr");
  if (!CheckGooseBerry139HazelNut139(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("HazelNut139AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::HazelNut139Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::GooseBerry139::HazelNut139*
idlServer_imp::HazelNut139Op(const ::GooseBerry139::HazelNut139 &p1,::GooseBerry139::HazelNut139_out p2,::GooseBerry139::HazelNut139 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry139::HazelNut139* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::HazelNut139Op\n");
#endif
  
  ernie.seed("HazelNut139OpCall");
  AddName("p1");
  if (!CheckGooseBerry139HazelNut139(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry139HazelNut139(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("HazelNut139OpReturn"); 
  {
    ::idlServer::HazelNut139Excpt ex;
    GetidlServerHazelNut139Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::GooseBerry139::HazelNut139;
  GetGooseBerry139HazelNut139(*ReturnValue);
  p2 = new ::GooseBerry139::HazelNut139;
  GetGooseBerry139HazelNut139(p2);
  GetGooseBerry139HazelNut139(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::HazelNut139Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GooseBerry139::HazelNut139::CrabApple139*
idlServer_imp::CrabApple139Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry139::HazelNut139::CrabApple139* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CrabApple139Attr\n");
#endif
  
  ernie.seed("CrabApple139AttrCall");
  
  ernie.seed("CrabApple139AttrReturn"); 
  ReturnValue = new ::GooseBerry139::HazelNut139::CrabApple139;
  GetGooseBerry139HazelNut139CrabApple139(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CrabApple139Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::CrabApple139Attr(const ::GooseBerry139::HazelNut139::CrabApple139 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CrabApple139Attr\n");
#endif
  
  ernie.seed("CrabApple139AttrCall");
  AddName("_attr");
  if (!CheckGooseBerry139HazelNut139CrabApple139(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CrabApple139AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CrabApple139Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::GooseBerry139::HazelNut139::CrabApple139*
idlServer_imp::CrabApple139Op(const ::GooseBerry139::HazelNut139::CrabApple139 &p1,::GooseBerry139::HazelNut139::CrabApple139_out p2,::GooseBerry139::HazelNut139::CrabApple139 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::GooseBerry139::HazelNut139::CrabApple139* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CrabApple139Op\n");
#endif
  
  ernie.seed("CrabApple139OpCall");
  AddName("p1");
  if (!CheckGooseBerry139HazelNut139CrabApple139(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGooseBerry139HazelNut139CrabApple139(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CrabApple139OpReturn"); 
  {
    ::idlServer::CrabApple139Excpt ex;
    GetidlServerCrabApple139Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::GooseBerry139::HazelNut139::CrabApple139;
  GetGooseBerry139HazelNut139CrabApple139(*ReturnValue);
  p2 = new ::GooseBerry139::HazelNut139::CrabApple139;
  GetGooseBerry139HazelNut139CrabApple139(p2);
  GetGooseBerry139HazelNut139CrabApple139(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CrabApple139Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



