//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/client.cpp
//
// Modifications:
// $Log: client.cpp,v $
// Revision 1.2  2000/03/29 17:11:26  mli
//   o   remove 'CORBA::Environment ev;'
//   o   int initialise
//
// Revision 1.1.1.1  2000/02/09 17:16:46  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1997/12/12 09:04:42  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern OrbSupport *orb;
extern char *stringifiedIOR;

static int initialised = 0;
CORBA::Object_ptr obj;
idlServer_ptr  tobj;

void
initialise()
{
    if (!initialised)
    {

#ifdef DEBUG
	  ::tet_infoline("client: connecting to proxy");
	  ::tet_printf("client: using %s", stringifiedIOR);
#endif
	  
	  try {
	      obj = orb->getObject(stringifiedIOR);
	  }
	  catch (CORBA::SystemException &ex) {
	      ::tet_infoline("client: getObj failed");
	      ::tet_printf("client: minor code %d", ex.minor());
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  if (obj == 0)
	  {
	      ::tet_infoline("client: failed connecting to proxy");
	      ::tet_result(TET_FAIL);
	      return;
	  }
	  
	  try {
	      tobj = idlServer::_narrow(obj);
	  }
	  catch (CORBA::Exception &ex) {
	      ::tet_infoline("client: failed to narrow object reference.");
	  }
	  initialised = 1;

	  char * tout = 0;
	  tout = getenv("VSORB_EVENT_TIMEOUT");

	  unsigned long timeout = (tout) ? atoi(tout) : 15;
	  orb->setTimeout(tobj, timeout);
      }
    
}

#ifdef VSORB_IDL_TESTS

void testIDL()
{
  char buf1[1024];

::tet_result(TET_PASS);
}
 
#endif



 
void testidlServerAniseed163Attr(void)
{
  
  ::Aniseed163* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Aniseed163* ::idlServer::Aniseed163Attr()");
#endif
  
  ernie.seed("Aniseed163AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Aniseed163AttrReturn");
  try {
    ReturnValue = tobj->Aniseed163Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Aniseed163Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckAniseed163(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerAniseed163AttrW(void)
{
  
  ::Aniseed163 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Aniseed163Attr(const ::Aniseed163 &_attr)");
#endif
  
  ernie.seed("Aniseed163AttrCall");
  GetAniseed163(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Aniseed163AttrReturn");
  try {
     tobj->Aniseed163Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Aniseed163Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerAniseed163Op(void)
{
  
  ::Aniseed163* ReturnValue;
  ::Aniseed163 p1;
  ::Aniseed163* p2;
  ::Aniseed163 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Aniseed163* ::idlServer::Aniseed163Op(const ::Aniseed163 &p1,::Aniseed163 *&p2,::Aniseed163 &p3)");
#endif
  
  ernie.seed("Aniseed163OpCall");
  GetAniseed163(p1);
  GetAniseed163(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Aniseed163OpReturn");
  try {
    ReturnValue = tobj->Aniseed163Op(p1,p2,p3);
  }
  catch (::idlServer::Aniseed163Excpt &ex){
    if (!CheckidlServerAniseed163Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Aniseed163Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckAniseed163(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckAniseed163(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAniseed163(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerWhiteCabbage163Attr(void)
{
  
  ::WhiteCabbage163* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::WhiteCabbage163* ::idlServer::WhiteCabbage163Attr()");
#endif
  
  ernie.seed("WhiteCabbage163AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("WhiteCabbage163AttrReturn");
  try {
    ReturnValue = tobj->WhiteCabbage163Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::WhiteCabbage163Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckWhiteCabbage163(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerWhiteCabbage163AttrW(void)
{
  
  ::WhiteCabbage163 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::WhiteCabbage163Attr(const ::WhiteCabbage163 &_attr)");
#endif
  
  ernie.seed("WhiteCabbage163AttrCall");
  GetWhiteCabbage163(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("WhiteCabbage163AttrReturn");
  try {
     tobj->WhiteCabbage163Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::WhiteCabbage163Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerWhiteCabbage163Op(void)
{
  
  ::WhiteCabbage163* ReturnValue;
  ::WhiteCabbage163 p1;
  ::WhiteCabbage163* p2;
  ::WhiteCabbage163 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::WhiteCabbage163* ::idlServer::WhiteCabbage163Op(const ::WhiteCabbage163 &p1,::WhiteCabbage163 *&p2,::WhiteCabbage163 &p3)");
#endif
  
  ernie.seed("WhiteCabbage163OpCall");
  GetWhiteCabbage163(p1);
  GetWhiteCabbage163(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("WhiteCabbage163OpReturn");
  try {
    ReturnValue = tobj->WhiteCabbage163Op(p1,p2,p3);
  }
  catch (::idlServer::WhiteCabbage163Excpt &ex){
    if (!CheckidlServerWhiteCabbage163Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::WhiteCabbage163Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckWhiteCabbage163(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckWhiteCabbage163(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckWhiteCabbage163(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerParsnip163Attr(void)
{
  
  ::WhiteCabbage163::Parsnip163* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::WhiteCabbage163::Parsnip163* ::idlServer::Parsnip163Attr()");
#endif
  
  ernie.seed("Parsnip163AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Parsnip163AttrReturn");
  try {
    ReturnValue = tobj->Parsnip163Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Parsnip163Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckWhiteCabbage163Parsnip163(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerParsnip163AttrW(void)
{
  
  ::WhiteCabbage163::Parsnip163 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Parsnip163Attr(const ::WhiteCabbage163::Parsnip163 &_attr)");
#endif
  
  ernie.seed("Parsnip163AttrCall");
  GetWhiteCabbage163Parsnip163(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Parsnip163AttrReturn");
  try {
     tobj->Parsnip163Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Parsnip163Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerParsnip163Op(void)
{
  
  ::WhiteCabbage163::Parsnip163* ReturnValue;
  ::WhiteCabbage163::Parsnip163 p1;
  ::WhiteCabbage163::Parsnip163* p2;
  ::WhiteCabbage163::Parsnip163 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::WhiteCabbage163::Parsnip163* ::idlServer::Parsnip163Op(const ::WhiteCabbage163::Parsnip163 &p1,::WhiteCabbage163::Parsnip163 *&p2,::WhiteCabbage163::Parsnip163 &p3)");
#endif
  
  ernie.seed("Parsnip163OpCall");
  GetWhiteCabbage163Parsnip163(p1);
  GetWhiteCabbage163Parsnip163(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Parsnip163OpReturn");
  try {
    ReturnValue = tobj->Parsnip163Op(p1,p2,p3);
  }
  catch (::idlServer::Parsnip163Excpt &ex){
    if (!CheckidlServerParsnip163Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Parsnip163Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckWhiteCabbage163Parsnip163(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckWhiteCabbage163Parsnip163(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckWhiteCabbage163Parsnip163(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerOrange163Attr(void)
{
  
  ::WhiteCabbage163::Parsnip163::Orange163* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::WhiteCabbage163::Parsnip163::Orange163* ::idlServer::Orange163Attr()");
#endif
  
  ernie.seed("Orange163AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Orange163AttrReturn");
  try {
    ReturnValue = tobj->Orange163Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Orange163Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckWhiteCabbage163Parsnip163Orange163(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerOrange163AttrW(void)
{
  
  ::WhiteCabbage163::Parsnip163::Orange163 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Orange163Attr(const ::WhiteCabbage163::Parsnip163::Orange163 &_attr)");
#endif
  
  ernie.seed("Orange163AttrCall");
  GetWhiteCabbage163Parsnip163Orange163(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Orange163AttrReturn");
  try {
     tobj->Orange163Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Orange163Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerOrange163Op(void)
{
  
  ::WhiteCabbage163::Parsnip163::Orange163* ReturnValue;
  ::WhiteCabbage163::Parsnip163::Orange163 p1;
  ::WhiteCabbage163::Parsnip163::Orange163* p2;
  ::WhiteCabbage163::Parsnip163::Orange163 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::WhiteCabbage163::Parsnip163::Orange163* ::idlServer::Orange163Op(const ::WhiteCabbage163::Parsnip163::Orange163 &p1,::WhiteCabbage163::Parsnip163::Orange163 *&p2,::WhiteCabbage163::Parsnip163::Orange163 &p3)");
#endif
  
  ernie.seed("Orange163OpCall");
  GetWhiteCabbage163Parsnip163Orange163(p1);
  GetWhiteCabbage163Parsnip163Orange163(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Orange163OpReturn");
  try {
    ReturnValue = tobj->Orange163Op(p1,p2,p3);
  }
  catch (::idlServer::Orange163Excpt &ex){
    if (!CheckidlServerOrange163Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Orange163Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckWhiteCabbage163Parsnip163Orange163(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckWhiteCabbage163Parsnip163Orange163(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckWhiteCabbage163Parsnip163Orange163(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSultana163Attr(void)
{
  
  ::WhiteCabbage163::Parsnip163::Orange163::Sultana163* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::WhiteCabbage163::Parsnip163::Orange163::Sultana163* ::idlServer::Sultana163Attr()");
#endif
  
  ernie.seed("Sultana163AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sultana163AttrReturn");
  try {
    ReturnValue = tobj->Sultana163Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sultana163Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckWhiteCabbage163Parsnip163Orange163Sultana163(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSultana163AttrW(void)
{
  
  ::WhiteCabbage163::Parsnip163::Orange163::Sultana163 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Sultana163Attr(const ::WhiteCabbage163::Parsnip163::Orange163::Sultana163 &_attr)");
#endif
  
  ernie.seed("Sultana163AttrCall");
  GetWhiteCabbage163Parsnip163Orange163Sultana163(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sultana163AttrReturn");
  try {
     tobj->Sultana163Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sultana163Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSultana163Op(void)
{
  
  ::WhiteCabbage163::Parsnip163::Orange163::Sultana163* ReturnValue;
  ::WhiteCabbage163::Parsnip163::Orange163::Sultana163 p1;
  ::WhiteCabbage163::Parsnip163::Orange163::Sultana163* p2;
  ::WhiteCabbage163::Parsnip163::Orange163::Sultana163 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::WhiteCabbage163::Parsnip163::Orange163::Sultana163* ::idlServer::Sultana163Op(const ::WhiteCabbage163::Parsnip163::Orange163::Sultana163 &p1,::WhiteCabbage163::Parsnip163::Orange163::Sultana163 *&p2,::WhiteCabbage163::Parsnip163::Orange163::Sultana163 &p3)");
#endif
  
  ernie.seed("Sultana163OpCall");
  GetWhiteCabbage163Parsnip163Orange163Sultana163(p1);
  GetWhiteCabbage163Parsnip163Orange163Sultana163(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sultana163OpReturn");
  try {
    ReturnValue = tobj->Sultana163Op(p1,p2,p3);
  }
  catch (::idlServer::Sultana163Excpt &ex){
    if (!CheckidlServerSultana163Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sultana163Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckWhiteCabbage163Parsnip163Orange163Sultana163(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckWhiteCabbage163Parsnip163Orange163Sultana163(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckWhiteCabbage163Parsnip163Orange163Sultana163(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerLoganBerry164Attr(void)
{
  
  ::LoganBerry164* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::LoganBerry164* ::idlServer::LoganBerry164Attr()");
#endif
  
  ernie.seed("LoganBerry164AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("LoganBerry164AttrReturn");
  try {
    ReturnValue = tobj->LoganBerry164Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::LoganBerry164Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckLoganBerry164(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerLoganBerry164AttrW(void)
{
  
  ::LoganBerry164 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::LoganBerry164Attr(const ::LoganBerry164 &_attr)");
#endif
  
  ernie.seed("LoganBerry164AttrCall");
  GetLoganBerry164(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("LoganBerry164AttrReturn");
  try {
     tobj->LoganBerry164Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::LoganBerry164Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerLoganBerry164Op(void)
{
  
  ::LoganBerry164* ReturnValue;
  ::LoganBerry164 p1;
  ::LoganBerry164* p2;
  ::LoganBerry164 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::LoganBerry164* ::idlServer::LoganBerry164Op(const ::LoganBerry164 &p1,::LoganBerry164 *&p2,::LoganBerry164 &p3)");
#endif
  
  ernie.seed("LoganBerry164OpCall");
  GetLoganBerry164(p1);
  GetLoganBerry164(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("LoganBerry164OpReturn");
  try {
    ReturnValue = tobj->LoganBerry164Op(p1,p2,p3);
  }
  catch (::idlServer::LoganBerry164Excpt &ex){
    if (!CheckidlServerLoganBerry164Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::LoganBerry164Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckLoganBerry164(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckLoganBerry164(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckLoganBerry164(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerOrange164Attr(void)
{
  
  ::Orange164* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Orange164* ::idlServer::Orange164Attr()");
#endif
  
  ernie.seed("Orange164AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Orange164AttrReturn");
  try {
    ReturnValue = tobj->Orange164Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Orange164Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckOrange164(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerOrange164AttrW(void)
{
  
  ::Orange164 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Orange164Attr(const ::Orange164 &_attr)");
#endif
  
  ernie.seed("Orange164AttrCall");
  GetOrange164(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Orange164AttrReturn");
  try {
     tobj->Orange164Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Orange164Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerOrange164Op(void)
{
  
  ::Orange164* ReturnValue;
  ::Orange164 p1;
  ::Orange164* p2;
  ::Orange164 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Orange164* ::idlServer::Orange164Op(const ::Orange164 &p1,::Orange164 *&p2,::Orange164 &p3)");
#endif
  
  ernie.seed("Orange164OpCall");
  GetOrange164(p1);
  GetOrange164(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Orange164OpReturn");
  try {
    ReturnValue = tobj->Orange164Op(p1,p2,p3);
  }
  catch (::idlServer::Orange164Excpt &ex){
    if (!CheckidlServerOrange164Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Orange164Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckOrange164(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckOrange164(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckOrange164(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSultana164Attr(void)
{
  
  ::Orange164::Sultana164* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Orange164::Sultana164* ::idlServer::Sultana164Attr()");
#endif
  
  ernie.seed("Sultana164AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sultana164AttrReturn");
  try {
    ReturnValue = tobj->Sultana164Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sultana164Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckOrange164Sultana164(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSultana164AttrW(void)
{
  
  ::Orange164::Sultana164 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Sultana164Attr(const ::Orange164::Sultana164 &_attr)");
#endif
  
  ernie.seed("Sultana164AttrCall");
  GetOrange164Sultana164(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sultana164AttrReturn");
  try {
     tobj->Sultana164Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sultana164Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerSultana164Op(void)
{
  
  ::Orange164::Sultana164* ReturnValue;
  ::Orange164::Sultana164 p1;
  ::Orange164::Sultana164* p2;
  ::Orange164::Sultana164 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Orange164::Sultana164* ::idlServer::Sultana164Op(const ::Orange164::Sultana164 &p1,::Orange164::Sultana164 *&p2,::Orange164::Sultana164 &p3)");
#endif
  
  ernie.seed("Sultana164OpCall");
  GetOrange164Sultana164(p1);
  GetOrange164Sultana164(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Sultana164OpReturn");
  try {
    ReturnValue = tobj->Sultana164Op(p1,p2,p3);
  }
  catch (::idlServer::Sultana164Excpt &ex){
    if (!CheckidlServerSultana164Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Sultana164Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckOrange164Sultana164(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckOrange164Sultana164(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckOrange164Sultana164(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCoconut164Attr(void)
{
  
  ::Orange164::Sultana164::Coconut164* ReturnValue;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Orange164::Sultana164::Coconut164* ::idlServer::Coconut164Attr()");
#endif
  
  ernie.seed("Coconut164AttrCall");

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Coconut164AttrReturn");
  try {
    ReturnValue = tobj->Coconut164Attr();
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Coconut164Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckOrange164Sultana164Coconut164(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCoconut164AttrW(void)
{
  
  ::Orange164::Sultana164::Coconut164 _attr;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function void ::idlServer::Coconut164Attr(const ::Orange164::Sultana164::Coconut164 &_attr)");
#endif
  
  ernie.seed("Coconut164AttrCall");
  GetOrange164Sultana164Coconut164(_attr);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Coconut164AttrReturn");
  try {
     tobj->Coconut164Attr(_attr);
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Coconut164Attr");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif



  ::tet_result(TET_PASS);
  return;
}


 
void testidlServerCoconut164Op(void)
{
  
  ::Orange164::Sultana164::Coconut164* ReturnValue;
  ::Orange164::Sultana164::Coconut164 p1;
  ::Orange164::Sultana164::Coconut164* p2;
  ::Orange164::Sultana164::Coconut164 p3;
    
  initialise();

#ifdef DEBUG
  ::tet_infoline("client: testing the function ::Orange164::Sultana164::Coconut164* ::idlServer::Coconut164Op(const ::Orange164::Sultana164::Coconut164 &p1,::Orange164::Sultana164::Coconut164 *&p2,::Orange164::Sultana164::Coconut164 &p3)");
#endif
  
  ernie.seed("Coconut164OpCall");
  GetOrange164Sultana164Coconut164(p1);
  GetOrange164Sultana164Coconut164(p3);

#ifdef DEBUG
  ::tet_infoline("client: making Call");
#endif
  
  ernie.seed("Coconut164OpReturn");
  try {
    ReturnValue = tobj->Coconut164Op(p1,p2,p3);
  }
  catch (::idlServer::Coconut164Excpt &ex){
    if (!CheckidlServerCoconut164Excpt(ex))
      ::tet_result(TET_FAIL);
    else
      ::tet_result(TET_PASS);
    return;
  }
  catch (CORBA::SystemException &ex) {
    ::tet_infoline("client: Failed on ::idlServer::Coconut164Op");
    ::tet_printf("client: minor code %d", ex.minor());
    ::tet_result(TET_FAIL);
    return;
  }
#ifdef DEBUG
  ::tet_infoline("client: returned from Call");
#endif


  AddName("ReturnValue");
  if (!CheckOrange164Sultana164Coconut164(*ReturnValue))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p2");
  if (!CheckOrange164Sultana164Coconut164(*p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckOrange164Sultana164Coconut164(p3))
    ::tet_result(TET_FAIL);
  RemoveName();

  ::tet_result(TET_PASS);
  return;
}


