//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/checkany.cpp
//
// Modifications:
// $Log: checkany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:46  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/26 13:52:00  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/12 09:04:45  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern char name[];

 
int CheckAny(const CORBA::Any &any)
{
  switch(ernie.getULong()%(12+35))
  {
    case   0: {
                CORBA::ULong  v;
#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::ULong");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::ULong as expected", name);
                  return 0;
                }
                if (!ernie.checkULong(v))
                {
                  tet_printf("Expected %s to contain CORBA::ULong with value %u, but found %u instead.",
                    name,ernie.getULongAgain(),v);
                  return 0;
                }
              }
              break;
    case   1: {
                CORBA::Long  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Long");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Long as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkLong(v))
                {
                  tet_printf("Expected %s to contain CORBA::Long with value %d, but found %d instead.",
                    name,ernie.getLongAgain(),v);
                  return 0;
                }
              }
              break;
    case   2: {
                CORBA::UShort  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::UShort");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::UShort as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkUShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::UShort with value %u, but found %u instead.",
                    name,ernie.getUShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   3: {
                CORBA::Short  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Short");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Short as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkShort(v))
                {
                  tet_printf("Expected %s to contain CORBA::Short with value %d, but found %d instead.",
                    name,ernie.getShortAgain(),v);
                  return 0;
                }
              }
              break;
    case   4: {
                CORBA::Boolean  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Boolean");
#endif
                if (!(any >>= CORBA::Any::to_boolean(v)))
                {
                  tet_printf("%s did not contain a CORBA::Boolean as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkBoolean(v))
                {
                  tet_printf("Expected %s to contain CORBA::Boolean with value %s, but found %s instead.",
                    name,
                    BooleanToString(ernie.getBooleanAgain()),
                    BooleanToString(v));
                  return 0;
                }
              }
              break;
    case   5: {
                CORBA::Octet  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Octet");
#endif
                if (!(any >>= CORBA::Any::to_octet(v)))
                {
                  tet_printf("%s did not contain a CORBA::Octet as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkOctet(v))
                {
                  ::tet_printf("Expected %s to contain CORBA::Octet with value %s, but found %s instead.",
                    name,
                    OctetToString(ernie.getOctetAgain()),
                    OctetToString(v));
                  return 0;
                }
              }
              break;
    case   6: {
                CORBA::Char  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Char");
#endif
                if (!(any >>= CORBA::Any::to_char(v)))
                {
                  tet_printf("%s did not contain a CORBA::Char as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkChar(v))
                {
                  tet_printf("Expected %s to contain CORBA::Char with value %s, but found %s instead.",
                    name,
                    CharToString(ernie.getCharAgain()),
                    CharToString(v));
                  return 0;
                }
              }
              break;
    case   7: {
                CORBA::Float  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Float");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Float as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkFloat(v))
                {
                  tet_printf("Expected %s to contain CORBA::Float with value %g, but found %g instead.",
                    name,
                    ernie.getFloatAgain(),
                    v);
                  return 0;
                }
              }
               break;
    case   8: {
                CORBA::Double  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Double");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Double as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkDouble(v))
                {
                  tet_printf("Expected %s to contain CORBA::Double with value %g, but found %g instead.",
                    name,
                    ernie.getDoubleAgain(),
                    v);
                  return 0;
                }
              }
              break;
    case   9: {
                char *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting char*");
#endif
                if (!(any >>= CORBA::Any::to_string(v,0)))
                {
                  tet_printf("%s did not contain a char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v))
                {
                  tet_printf("Expected %s to contain char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case  10: {
                CORBA::ULong  b;
                char   *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting bounded char*");
#endif
                b = ernie.getULong()%30+1;

                if (!(any >>= CORBA::Any::to_string(v,b)))
                {
                  tet_printf("%s did not contain a bounded char* as expected",
                      name);
                  return 0;
                }
                if (!ernie.checkString(v,b))
                {
                  tet_printf("Expected %s to contain a bounded char* with value %s, but found %s instead.",
                    name,ernie.getStringAgain(),v);
                  return 0;
                }
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::TypeCode");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::TypeCode as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckCORBATypeCode_ptr(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case   12: {
                CORBA::Any  v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expecting CORBA::Any");
#endif
                if (!(any >>= v))
                {
                  tet_printf("%s did not contain a CORBA::Any as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAny(v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  13: {
                ::Aniseed163 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Aniseed163\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Aniseed163 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckAniseed163(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  14: {
                ::WhiteCabbage163 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::WhiteCabbage163\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::WhiteCabbage163 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckWhiteCabbage163(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  15: {
                ::WhiteCabbage163::Parsnip163 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::WhiteCabbage163::Parsnip163\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::WhiteCabbage163::Parsnip163 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckWhiteCabbage163Parsnip163(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  16: {
                ::WhiteCabbage163::Parsnip163::Orange163 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::WhiteCabbage163::Parsnip163::Orange163\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::WhiteCabbage163::Parsnip163::Orange163 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckWhiteCabbage163Parsnip163Orange163(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  17: {
                ::WhiteCabbage163::Parsnip163::Orange163::Sultana163 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::WhiteCabbage163::Parsnip163::Orange163::Sultana163\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::WhiteCabbage163::Parsnip163::Orange163::Sultana163 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckWhiteCabbage163Parsnip163Orange163Sultana163(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  18: {
                ::LoganBerry164 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::LoganBerry164\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::LoganBerry164 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLoganBerry164(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  19: {
                ::Orange164 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Orange164\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Orange164 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOrange164(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  20: {
                ::Orange164::Sultana164 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Orange164::Sultana164\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Orange164::Sultana164 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOrange164Sultana164(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  21: {
                ::Orange164::Sultana164::Coconut164 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Orange164::Sultana164::Coconut164\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Orange164::Sultana164::Coconut164 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOrange164Sultana164Coconut164(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  22: {
                ::Orange164::Sultana164::Coconut164::Wilja163 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Orange164::Sultana164::Coconut164::Wilja163\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Orange164::Sultana164::Coconut164::Wilja163 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOrange164Sultana164Coconut164Wilja163(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  23: {
                ::LoganBerry165 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::LoganBerry165\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::LoganBerry165 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckLoganBerry165(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  24: {
                ::Orange165 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Orange165\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Orange165 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOrange165(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  25: {
                ::Orange165::Sultana165 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Orange165::Sultana165\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Orange165::Sultana165 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOrange165Sultana165(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  26: {
                ::Orange165::Sultana165::Asparagus165 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Orange165::Sultana165::Asparagus165\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Orange165::Sultana165::Asparagus165 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOrange165Sultana165Asparagus165(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  27: {
                ::Orange165::Sultana165::Asparagus165::PentlandDell164 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Orange165::Sultana165::Asparagus165::PentlandDell164\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Orange165::Sultana165::Asparagus165::PentlandDell164 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckOrange165Sultana165Asparagus165PentlandDell164(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  28: {
                ::Turnip166 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Turnip166\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Turnip166 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckTurnip166(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  29: {
                ::Sultana166 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Sultana166\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Sultana166 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSultana166(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  30: {
                ::Sultana166::Asparagus166 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Sultana166::Asparagus166\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Sultana166::Asparagus166 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSultana166Asparagus166(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  31: {
                ::Sultana166::Asparagus166::Lime166 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Sultana166::Asparagus166::Lime166\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Sultana166::Asparagus166::Lime166 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSultana166Asparagus166Lime166(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  32: {
                ::Sultana166::Asparagus166::Lime166::Mango166 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Sultana166::Asparagus166::Lime166::Mango166\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Sultana166::Asparagus166::Lime166::Mango166 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSultana166Asparagus166Lime166Mango166(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  33: {
                ::Turnip167 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Turnip167\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Turnip167 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckTurnip167(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  34: {
                ::Sultana167 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Sultana167\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Sultana167 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSultana167(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  35: {
                ::Sultana167::Asparagus167 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Sultana167::Asparagus167\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Sultana167::Asparagus167 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSultana167Asparagus167(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  36: {
                ::Sultana167::Asparagus167::Mint167 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Sultana167::Asparagus167::Mint167\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Sultana167::Asparagus167::Mint167 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSultana167Asparagus167Mint167(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  37: {
                ::Sultana167::Asparagus167::Mint167::BlackEyedBeans167 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Sultana167::Asparagus167::Mint167::BlackEyedBeans167\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Sultana167::Asparagus167::Mint167::BlackEyedBeans167 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckSultana167Asparagus167Mint167BlackEyedBeans167(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  38: {
                ::GardenPeas168 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GardenPeas168\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GardenPeas168 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGardenPeas168(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  39: {
                ::Mint168 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mint168\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mint168 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMint168(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  40: {
                ::Mint168::BlackEyedBeans168 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mint168::BlackEyedBeans168\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mint168::BlackEyedBeans168 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMint168BlackEyedBeans168(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  41: {
                ::Mint168::BlackEyedBeans168::PassionFruit168 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mint168::BlackEyedBeans168::PassionFruit168\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mint168::BlackEyedBeans168::PassionFruit168 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMint168BlackEyedBeans168PassionFruit168(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  42: {
                ::Mint168::BlackEyedBeans168::PassionFruit168::ChineseLeaves167 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mint168::BlackEyedBeans168::PassionFruit168::ChineseLeaves167\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mint168::BlackEyedBeans168::PassionFruit168::ChineseLeaves167 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMint168BlackEyedBeans168PassionFruit168ChineseLeaves167(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  43: {
                ::GardenPeas169 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::GardenPeas169\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::GardenPeas169 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckGardenPeas169(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  44: {
                ::Mint169 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mint169\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mint169 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMint169(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  45: {
                ::Mint169::BlackEyedBeans169 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mint169::BlackEyedBeans169\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mint169::BlackEyedBeans169 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMint169BlackEyedBeans169(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  46: {
                ::Mint169::BlackEyedBeans169::Ginger169 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mint169::BlackEyedBeans169::Ginger169\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mint169::BlackEyedBeans169::Ginger169 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMint169BlackEyedBeans169Ginger169(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;
    case  47: {
                ::Mint169::BlackEyedBeans169::Ginger169::Pimpernel168 *v;

#ifdef DEBUG
                ::tet_infoline("CheckAny expected ::Mint169::BlackEyedBeans169::Ginger169::Pimpernel168\n");
#endif
                if (!(any  >>= v))
                {
                  tet_printf("%s did not contain a ::Mint169::BlackEyedBeans169::Ginger169::Pimpernel168 as expected",
                      name);
                  return 0;
                }
                AddName("_value");
                if (!CheckMint169BlackEyedBeans169Ginger169Pimpernel168(*v))
                {
                  RemoveName();
                  return 0;
                }
                RemoveName();
              }
              break;

  }
  return 1;
}




