//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/getany.cpp
//
// Modifications:
// $Log: getany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:46  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1997/12/12 09:04:46  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"

//Header files generated by idl compiler
#include "tin.hh"

#include "types.hh"
extern Ernie ernie;


void GetAny(CORBA::Any &any)
{
  switch(ernie.getULong()%(12+35))
  {
    case   0: any <<= ernie.getULong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating ULong");
#endif
              break;
    case   1: any <<= ernie.getLong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Long");
#endif
              break;
    case   2: any <<= ernie.getUShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating UShort");
#endif
              break;
    case   3: any <<= ernie.getShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Short");
#endif
              break;
    case   4: any <<= CORBA::Any::from_boolean(ernie.getBoolean());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Boolean");
#endif
              break;
    case   5: any <<= CORBA::Any::from_octet(ernie.getOctet());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Octet");
#endif
              break;
    case   6: any <<= CORBA::Any::from_char(ernie.getChar());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Char");
#endif
              break;
    case   7: any <<= ernie.getFloat();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Float");
#endif
               break;
    case   8: any <<= ernie.getDouble();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Double");
#endif
              break;
    case   9: any <<= ernie.getString();
#ifdef DEBUG
              ::tet_infoline("GetAny creating String");
#endif
              break;
    case  10: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating BoundedString");
#endif
                CORBA::ULong  b;
                b = ernie.getULong()%30+1;
                any <<= CORBA::Any::from_string(ernie.getString(b),b);
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr _typecode;
#ifdef DEBUG
                ::tet_infoline("GetAny creating TypeCode");
#endif
                GetCORBATypeCode_ptr(_typecode);
                any <<= _typecode;
               }
                break;
    case   12: {
                CORBA::Any  _any;  
#ifdef DEBUG
                ::tet_infoline("GetAny creating Any");
#endif
                GetAny(_any);
                any <<= _any;
               }
                break;

    case  13: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Aniseed163");
#endif
                ::Aniseed163   v;

                GetAniseed163(v);

                any  <<= v;
              }
              break;

    case  14: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::WhiteCabbage163");
#endif
                ::WhiteCabbage163   v;

                GetWhiteCabbage163(v);

                any  <<= v;
              }
              break;

    case  15: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::WhiteCabbage163::Parsnip163");
#endif
                ::WhiteCabbage163::Parsnip163   v;

                GetWhiteCabbage163Parsnip163(v);

                any  <<= v;
              }
              break;

    case  16: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::WhiteCabbage163::Parsnip163::Orange163");
#endif
                ::WhiteCabbage163::Parsnip163::Orange163   v;

                GetWhiteCabbage163Parsnip163Orange163(v);

                any  <<= v;
              }
              break;

    case  17: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::WhiteCabbage163::Parsnip163::Orange163::Sultana163");
#endif
                ::WhiteCabbage163::Parsnip163::Orange163::Sultana163   v;

                GetWhiteCabbage163Parsnip163Orange163Sultana163(v);

                any  <<= v;
              }
              break;

    case  18: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::LoganBerry164");
#endif
                ::LoganBerry164   v;

                GetLoganBerry164(v);

                any  <<= v;
              }
              break;

    case  19: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Orange164");
#endif
                ::Orange164   v;

                GetOrange164(v);

                any  <<= v;
              }
              break;

    case  20: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Orange164::Sultana164");
#endif
                ::Orange164::Sultana164   v;

                GetOrange164Sultana164(v);

                any  <<= v;
              }
              break;

    case  21: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Orange164::Sultana164::Coconut164");
#endif
                ::Orange164::Sultana164::Coconut164   v;

                GetOrange164Sultana164Coconut164(v);

                any  <<= v;
              }
              break;

    case  22: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Orange164::Sultana164::Coconut164::Wilja163");
#endif
                ::Orange164::Sultana164::Coconut164::Wilja163   v;

                GetOrange164Sultana164Coconut164Wilja163(v);

                any  <<= v;
              }
              break;

    case  23: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::LoganBerry165");
#endif
                ::LoganBerry165   v;

                GetLoganBerry165(v);

                any  <<= v;
              }
              break;

    case  24: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Orange165");
#endif
                ::Orange165   v;

                GetOrange165(v);

                any  <<= v;
              }
              break;

    case  25: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Orange165::Sultana165");
#endif
                ::Orange165::Sultana165   v;

                GetOrange165Sultana165(v);

                any  <<= v;
              }
              break;

    case  26: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Orange165::Sultana165::Asparagus165");
#endif
                ::Orange165::Sultana165::Asparagus165   v;

                GetOrange165Sultana165Asparagus165(v);

                any  <<= v;
              }
              break;

    case  27: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Orange165::Sultana165::Asparagus165::PentlandDell164");
#endif
                ::Orange165::Sultana165::Asparagus165::PentlandDell164   v;

                GetOrange165Sultana165Asparagus165PentlandDell164(v);

                any  <<= v;
              }
              break;

    case  28: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Turnip166");
#endif
                ::Turnip166   v;

                GetTurnip166(v);

                any  <<= v;
              }
              break;

    case  29: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sultana166");
#endif
                ::Sultana166   v;

                GetSultana166(v);

                any  <<= v;
              }
              break;

    case  30: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sultana166::Asparagus166");
#endif
                ::Sultana166::Asparagus166   v;

                GetSultana166Asparagus166(v);

                any  <<= v;
              }
              break;

    case  31: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sultana166::Asparagus166::Lime166");
#endif
                ::Sultana166::Asparagus166::Lime166   v;

                GetSultana166Asparagus166Lime166(v);

                any  <<= v;
              }
              break;

    case  32: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sultana166::Asparagus166::Lime166::Mango166");
#endif
                ::Sultana166::Asparagus166::Lime166::Mango166   v;

                GetSultana166Asparagus166Lime166Mango166(v);

                any  <<= v;
              }
              break;

    case  33: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Turnip167");
#endif
                ::Turnip167   v;

                GetTurnip167(v);

                any  <<= v;
              }
              break;

    case  34: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sultana167");
#endif
                ::Sultana167   v;

                GetSultana167(v);

                any  <<= v;
              }
              break;

    case  35: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sultana167::Asparagus167");
#endif
                ::Sultana167::Asparagus167   v;

                GetSultana167Asparagus167(v);

                any  <<= v;
              }
              break;

    case  36: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sultana167::Asparagus167::Mint167");
#endif
                ::Sultana167::Asparagus167::Mint167   v;

                GetSultana167Asparagus167Mint167(v);

                any  <<= v;
              }
              break;

    case  37: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Sultana167::Asparagus167::Mint167::BlackEyedBeans167");
#endif
                ::Sultana167::Asparagus167::Mint167::BlackEyedBeans167   v;

                GetSultana167Asparagus167Mint167BlackEyedBeans167(v);

                any  <<= v;
              }
              break;

    case  38: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GardenPeas168");
#endif
                ::GardenPeas168   v;

                GetGardenPeas168(v);

                any  <<= v;
              }
              break;

    case  39: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mint168");
#endif
                ::Mint168   v;

                GetMint168(v);

                any  <<= v;
              }
              break;

    case  40: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mint168::BlackEyedBeans168");
#endif
                ::Mint168::BlackEyedBeans168   v;

                GetMint168BlackEyedBeans168(v);

                any  <<= v;
              }
              break;

    case  41: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mint168::BlackEyedBeans168::PassionFruit168");
#endif
                ::Mint168::BlackEyedBeans168::PassionFruit168   v;

                GetMint168BlackEyedBeans168PassionFruit168(v);

                any  <<= v;
              }
              break;

    case  42: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mint168::BlackEyedBeans168::PassionFruit168::ChineseLeaves167");
#endif
                ::Mint168::BlackEyedBeans168::PassionFruit168::ChineseLeaves167   v;

                GetMint168BlackEyedBeans168PassionFruit168ChineseLeaves167(v);

                any  <<= v;
              }
              break;

    case  43: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GardenPeas169");
#endif
                ::GardenPeas169   v;

                GetGardenPeas169(v);

                any  <<= v;
              }
              break;

    case  44: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mint169");
#endif
                ::Mint169   v;

                GetMint169(v);

                any  <<= v;
              }
              break;

    case  45: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mint169::BlackEyedBeans169");
#endif
                ::Mint169::BlackEyedBeans169   v;

                GetMint169BlackEyedBeans169(v);

                any  <<= v;
              }
              break;

    case  46: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mint169::BlackEyedBeans169::Ginger169");
#endif
                ::Mint169::BlackEyedBeans169::Ginger169   v;

                GetMint169BlackEyedBeans169Ginger169(v);

                any  <<= v;
              }
              break;

    case  47: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mint169::BlackEyedBeans169::Ginger169::Pimpernel168");
#endif
                ::Mint169::BlackEyedBeans169::Ginger169::Pimpernel168   v;

                GetMint169BlackEyedBeans169Ginger169Pimpernel168(v);

                any  <<= v;
              }
              break;

  }
}


