//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:46  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1999/04/26 13:52:02  james
// Changed CORBA::Char* to char*
//
// Revision 1.6  1997/12/15 10:52:01  james
// #ifdefs removed
//
// Revision 1.5  1997/12/12 09:04:46  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetAniseed163(::Aniseed163 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAniseed163");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%18;
    v.Celery163.LoganBerry163.Turnip163.GaliaMelon163.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Celery163.LoganBerry163.Turnip163.GaliaMelon163[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetOctet(v.Celery163.LoganBerry163.Turnip163.GaliaMelon163[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckAniseed163(const ::Aniseed163 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAniseed163");
#endif

  AddName("Celery163");
  AddName("LoganBerry163");
  AddName("Turnip163");
  AddName("GaliaMelon163");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%18;
    if (l1 != v.Celery163.LoganBerry163.Turnip163.GaliaMelon163.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Celery163.LoganBerry163.Turnip163.GaliaMelon163.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Celery163.LoganBerry163.Turnip163.GaliaMelon163[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Celery163.LoganBerry163.Turnip163.GaliaMelon163[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckOctet(v.Celery163.LoganBerry163.Turnip163.GaliaMelon163[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetWhiteCabbage163(::WhiteCabbage163 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetWhiteCabbage163");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%18;
    v.Celery163.LoganBerry163.Turnip163.GaliaMelon163.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Celery163.LoganBerry163.Turnip163.GaliaMelon163[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetOctet(v.Celery163.LoganBerry163.Turnip163.GaliaMelon163[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckWhiteCabbage163(const ::WhiteCabbage163 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckWhiteCabbage163");
#endif

  AddName("Celery163");
  AddName("LoganBerry163");
  AddName("Turnip163");
  AddName("GaliaMelon163");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%18;
    if (l1 != v.Celery163.LoganBerry163.Turnip163.GaliaMelon163.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Celery163.LoganBerry163.Turnip163.GaliaMelon163.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Celery163.LoganBerry163.Turnip163.GaliaMelon163[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Celery163.LoganBerry163.Turnip163.GaliaMelon163[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckOctet(v.Celery163.LoganBerry163.Turnip163.GaliaMelon163[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetWhiteCabbage163Parsnip163(::WhiteCabbage163::Parsnip163 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetWhiteCabbage163Parsnip163");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%18;
    v.LoganBerry163.Turnip163.GaliaMelon163.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.LoganBerry163.Turnip163.GaliaMelon163[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetOctet(v.LoganBerry163.Turnip163.GaliaMelon163[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckWhiteCabbage163Parsnip163(const ::WhiteCabbage163::Parsnip163 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckWhiteCabbage163Parsnip163");
#endif

  AddName("LoganBerry163");
  AddName("Turnip163");
  AddName("GaliaMelon163");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%18;
    if (l1 != v.LoganBerry163.Turnip163.GaliaMelon163.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.LoganBerry163.Turnip163.GaliaMelon163.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.LoganBerry163.Turnip163.GaliaMelon163[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.LoganBerry163.Turnip163.GaliaMelon163[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckOctet(v.LoganBerry163.Turnip163.GaliaMelon163[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetWhiteCabbage163Parsnip163Orange163(::WhiteCabbage163::Parsnip163::Orange163 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetWhiteCabbage163Parsnip163Orange163");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%18;
    v.Turnip163.GaliaMelon163.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Turnip163.GaliaMelon163[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetOctet(v.Turnip163.GaliaMelon163[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckWhiteCabbage163Parsnip163Orange163(const ::WhiteCabbage163::Parsnip163::Orange163 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckWhiteCabbage163Parsnip163Orange163");
#endif

  AddName("Turnip163");
  AddName("GaliaMelon163");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%18;
    if (l1 != v.Turnip163.GaliaMelon163.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Turnip163.GaliaMelon163.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Turnip163.GaliaMelon163[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Turnip163.GaliaMelon163[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckOctet(v.Turnip163.GaliaMelon163[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetWhiteCabbage163Parsnip163Orange163Sultana163(::WhiteCabbage163::Parsnip163::Orange163::Sultana163 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetWhiteCabbage163Parsnip163Orange163Sultana163");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%18;
    v.GaliaMelon163.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.GaliaMelon163[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetOctet(v.GaliaMelon163[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckWhiteCabbage163Parsnip163Orange163Sultana163(const ::WhiteCabbage163::Parsnip163::Orange163::Sultana163 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckWhiteCabbage163Parsnip163Orange163Sultana163");
#endif

  AddName("GaliaMelon163");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%18;
    if (l1 != v.GaliaMelon163.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.GaliaMelon163.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.GaliaMelon163[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GaliaMelon163[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckOctet(v.GaliaMelon163[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetLoganBerry164(::LoganBerry164 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLoganBerry164");
#endif

  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 15; ++i3)
        {
          AddIndex(i3);
          {
            int	i5;
            for(i5=0; i5 < 13; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%18;
                    v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetOctet(v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLoganBerry164(const ::LoganBerry164 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLoganBerry164");
#endif

  AddName("Turnip164");
  AddName("GaliaMelon164");
  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      AddName("Dates164");
      {
        int	i3;
        for(i3=0; i3 < 15; ++i3)
        {
          AddIndex(i3);
          AddName("BritishQueens163");
          {
            int	i5;
            for(i5=0; i5 < 13; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%18;
                    if (l9 != v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckOctet(v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveName();
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetOrange164(::Orange164 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetOrange164");
#endif

  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 15; ++i3)
        {
          AddIndex(i3);
          {
            int	i5;
            for(i5=0; i5 < 13; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%18;
                    v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetOctet(v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckOrange164(const ::Orange164 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckOrange164");
#endif

  AddName("Turnip164");
  AddName("GaliaMelon164");
  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      AddName("Dates164");
      {
        int	i3;
        for(i3=0; i3 < 15; ++i3)
        {
          AddIndex(i3);
          AddName("BritishQueens163");
          {
            int	i5;
            for(i5=0; i5 < 13; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%18;
                    if (l9 != v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckOctet(v.Turnip164.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveName();
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetOrange164Sultana164(::Orange164::Sultana164 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetOrange164Sultana164");
#endif

  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 15; ++i3)
        {
          AddIndex(i3);
          {
            int	i5;
            for(i5=0; i5 < 13; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%18;
                    v.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetOctet(v.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckOrange164Sultana164(const ::Orange164::Sultana164 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckOrange164Sultana164");
#endif

  AddName("GaliaMelon164");
  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      AddName("Dates164");
      {
        int	i3;
        for(i3=0; i3 < 15; ++i3)
        {
          AddIndex(i3);
          AddName("BritishQueens163");
          {
            int	i5;
            for(i5=0; i5 < 13; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%18;
                    if (l9 != v.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckOctet(v.GaliaMelon164[i1].Dates164[i3].BritishQueens163[i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveName();
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetOrange164Sultana164Coconut164(::Orange164::Sultana164::Coconut164 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetOrange164Sultana164Coconut164");
#endif

  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 13; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Dates164[i1].BritishQueens163[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                v.Dates164[i1].BritishQueens163[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetOctet(v.Dates164[i1].BritishQueens163[i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckOrange164Sultana164Coconut164(const ::Orange164::Sultana164::Coconut164 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckOrange164Sultana164Coconut164");
#endif

  AddName("Dates164");
  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      AddName("BritishQueens163");
      {
        int	i3;
        for(i3=0; i3 < 13; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Dates164[i1].BritishQueens163[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Dates164[i1].BritishQueens163[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                if (l7 != v.Dates164[i1].BritishQueens163[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Dates164[i1].BritishQueens163[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckOctet(v.Dates164[i1].BritishQueens163[i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetOrange164Sultana164Coconut164Wilja163(::Orange164::Sultana164::Coconut164::Wilja163 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetOrange164Sultana164Coconut164Wilja163");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.BritishQueens163[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%18;
            v.BritishQueens163[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetOctet(v.BritishQueens163[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckOrange164Sultana164Coconut164Wilja163(const ::Orange164::Sultana164::Coconut164::Wilja163 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckOrange164Sultana164Coconut164Wilja163");
#endif

  AddName("BritishQueens163");
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.BritishQueens163[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.BritishQueens163[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%18;
            if (l5 != v.BritishQueens163[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.BritishQueens163[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckOctet(v.BritishQueens163[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetLoganBerry165(::LoganBerry165 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLoganBerry165");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 7; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLoganBerry165(const ::LoganBerry165 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLoganBerry165");
#endif

  AddName("Turnip165");
  AddName("GaliaMelon165");
  AddName("GardenPeas165");
  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      AddName("KingEdward164");
      {
        int	i3;
        for(i3=0; i3 < 7; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetOrange165(::Orange165 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetOrange165");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 7; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckOrange165(const ::Orange165 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckOrange165");
#endif

  AddName("Turnip165");
  AddName("GaliaMelon165");
  AddName("GardenPeas165");
  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      AddName("KingEdward164");
      {
        int	i3;
        for(i3=0; i3 < 7; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v.Turnip165.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetOrange165Sultana165(::Orange165::Sultana165 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetOrange165Sultana165");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 7; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckOrange165Sultana165(const ::Orange165::Sultana165 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckOrange165Sultana165");
#endif

  AddName("GaliaMelon165");
  AddName("GardenPeas165");
  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      AddName("KingEdward164");
      {
        int	i3;
        for(i3=0; i3 < 7; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v.GaliaMelon165.GardenPeas165[i1].KingEdward164[i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetOrange165Sultana165Asparagus165(::Orange165::Sultana165::Asparagus165 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetOrange165Sultana165Asparagus165");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 7; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GardenPeas165[i1].KingEdward164[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.GardenPeas165[i1].KingEdward164[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.GardenPeas165[i1].KingEdward164[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v.GardenPeas165[i1].KingEdward164[i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckOrange165Sultana165Asparagus165(const ::Orange165::Sultana165::Asparagus165 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckOrange165Sultana165Asparagus165");
#endif

  AddName("GardenPeas165");
  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      AddName("KingEdward164");
      {
        int	i3;
        for(i3=0; i3 < 7; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GardenPeas165[i1].KingEdward164[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GardenPeas165[i1].KingEdward164[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.GardenPeas165[i1].KingEdward164[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GardenPeas165[i1].KingEdward164[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.GardenPeas165[i1].KingEdward164[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.GardenPeas165[i1].KingEdward164[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v.GardenPeas165[i1].KingEdward164[i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetOrange165Sultana165Asparagus165PentlandDell164(::Orange165::Sultana165::Asparagus165::PentlandDell164 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetOrange165Sultana165Asparagus165PentlandDell164");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.KingEdward164[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.KingEdward164[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.KingEdward164[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.KingEdward164[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckOrange165Sultana165Asparagus165PentlandDell164(const ::Orange165::Sultana165::Asparagus165::PentlandDell164 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckOrange165Sultana165Asparagus165PentlandDell164");
#endif

  AddName("KingEdward164");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.KingEdward164[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.KingEdward164[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.KingEdward164[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.KingEdward164[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.KingEdward164[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.KingEdward164[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.KingEdward164[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetTurnip166(::Turnip166 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTurnip166");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 12; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%19;
                v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckTurnip166(const ::Turnip166 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTurnip166");
#endif

  AddName("GaliaMelon166");
  AddName("GardenPeas166");
  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      AddName("WaterMelon166");
      AddName("Pumpkin166");
      {
        int	i3;
        for(i3=0; i3 < 12; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%19;
                if (l7 != v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetSultana166(::Sultana166 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSultana166");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 12; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%19;
                v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckSultana166(const ::Sultana166 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSultana166");
#endif

  AddName("GaliaMelon166");
  AddName("GardenPeas166");
  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      AddName("WaterMelon166");
      AddName("Pumpkin166");
      {
        int	i3;
        for(i3=0; i3 < 12; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%19;
                if (l7 != v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v.GaliaMelon166.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetSultana166Asparagus166(::Sultana166::Asparagus166 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSultana166Asparagus166");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 12; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%19;
                v.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckSultana166Asparagus166(const ::Sultana166::Asparagus166 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSultana166Asparagus166");
#endif

  AddName("GardenPeas166");
  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      AddName("WaterMelon166");
      AddName("Pumpkin166");
      {
        int	i3;
        for(i3=0; i3 < 12; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%19;
                if (l7 != v.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v.GardenPeas166[i1].WaterMelon166.Pumpkin166[i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetSultana166Asparagus166Lime166(::Sultana166::Asparagus166::Lime166 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSultana166Asparagus166Lime166");
#endif

  {
    int	i1;
    for(i1=0; i1 < 12; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.WaterMelon166.Pumpkin166[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%19;
            v.WaterMelon166.Pumpkin166[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.WaterMelon166.Pumpkin166[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.WaterMelon166.Pumpkin166[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckSultana166Asparagus166Lime166(const ::Sultana166::Asparagus166::Lime166 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSultana166Asparagus166Lime166");
#endif

  AddName("WaterMelon166");
  AddName("Pumpkin166");
  {
    int	i1;
    for(i1=0; i1 < 12; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.WaterMelon166.Pumpkin166[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.WaterMelon166.Pumpkin166[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%19;
            if (l5 != v.WaterMelon166.Pumpkin166[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.WaterMelon166.Pumpkin166[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.WaterMelon166.Pumpkin166[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.WaterMelon166.Pumpkin166[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.WaterMelon166.Pumpkin166[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetSultana166Asparagus166Lime166Mango166(::Sultana166::Asparagus166::Lime166::Mango166 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSultana166Asparagus166Lime166Mango166");
#endif

  {
    int	i1;
    for(i1=0; i1 < 12; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Pumpkin166[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%19;
            v.Pumpkin166[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Pumpkin166[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.Pumpkin166[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckSultana166Asparagus166Lime166Mango166(const ::Sultana166::Asparagus166::Lime166::Mango166 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSultana166Asparagus166Lime166Mango166");
#endif

  AddName("Pumpkin166");
  {
    int	i1;
    for(i1=0; i1 < 12; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Pumpkin166[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Pumpkin166[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%19;
            if (l5 != v.Pumpkin166[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Pumpkin166[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Pumpkin166[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Pumpkin166[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.Pumpkin166[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetTurnip167(::Turnip167 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetTurnip167");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckTurnip167(const ::Turnip167 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTurnip167");
#endif

  AddName("GaliaMelon167");
  AddName("GardenPeas167");
  AddName("Leek167");
  AddName("Apricots167");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                if (l7 != v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetSultana167(::Sultana167 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSultana167");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckSultana167(const ::Sultana167 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSultana167");
#endif

  AddName("GaliaMelon167");
  AddName("GardenPeas167");
  AddName("Leek167");
  AddName("Apricots167");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                if (l7 != v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.GaliaMelon167.GardenPeas167.Leek167.Apricots167[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetSultana167Asparagus167(::Sultana167::Asparagus167 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSultana167Asparagus167");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.GardenPeas167.Leek167.Apricots167[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GardenPeas167.Leek167.Apricots167[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                v.GardenPeas167.Leek167.Apricots167[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.GardenPeas167.Leek167.Apricots167[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckSultana167Asparagus167(const ::Sultana167::Asparagus167 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSultana167Asparagus167");
#endif

  AddName("GardenPeas167");
  AddName("Leek167");
  AddName("Apricots167");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.GardenPeas167.Leek167.Apricots167[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GardenPeas167.Leek167.Apricots167[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GardenPeas167.Leek167.Apricots167[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GardenPeas167.Leek167.Apricots167[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                if (l7 != v.GardenPeas167.Leek167.Apricots167[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GardenPeas167.Leek167.Apricots167[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.GardenPeas167.Leek167.Apricots167[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetSultana167Asparagus167Mint167(::Sultana167::Asparagus167::Mint167 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSultana167Asparagus167Mint167");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Leek167.Apricots167[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Leek167.Apricots167[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                v.Leek167.Apricots167[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.Leek167.Apricots167[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckSultana167Asparagus167Mint167(const ::Sultana167::Asparagus167::Mint167 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSultana167Asparagus167Mint167");
#endif

  AddName("Leek167");
  AddName("Apricots167");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Leek167.Apricots167[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Leek167.Apricots167[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Leek167.Apricots167[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Leek167.Apricots167[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                if (l7 != v.Leek167.Apricots167[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Leek167.Apricots167[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.Leek167.Apricots167[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetSultana167Asparagus167Mint167BlackEyedBeans167(::Sultana167::Asparagus167::Mint167::BlackEyedBeans167 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSultana167Asparagus167Mint167BlackEyedBeans167");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Apricots167[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Apricots167[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                v.Apricots167[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.Apricots167[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckSultana167Asparagus167Mint167BlackEyedBeans167(const ::Sultana167::Asparagus167::Mint167::BlackEyedBeans167 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSultana167Asparagus167Mint167BlackEyedBeans167");
#endif

  AddName("Apricots167");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Apricots167[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Apricots167[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Apricots167[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Apricots167[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                if (l7 != v.Apricots167[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Apricots167[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.Apricots167[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetGardenPeas168(::GardenPeas168 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGardenPeas168");
#endif

  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 5; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167.length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%4;
                    v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckGardenPeas168(const ::GardenPeas168 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGardenPeas168");
#endif

  AddName("Leek168");
  AddName("Apricots168");
  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      AddName("Rhubarb168");
      {
        int	i3;
        for(i3=0; i3 < 5; ++i3)
        {
          AddIndex(i3);
          AddName("RedCabbage167");
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167.length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167.length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                if (l7 != v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%4;
                    if (l9 != v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveName();
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetMint168(::Mint168 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMint168");
#endif

  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 5; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167.length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%4;
                    v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMint168(const ::Mint168 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMint168");
#endif

  AddName("Leek168");
  AddName("Apricots168");
  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      AddName("Rhubarb168");
      {
        int	i3;
        for(i3=0; i3 < 5; ++i3)
        {
          AddIndex(i3);
          AddName("RedCabbage167");
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167.length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167.length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                if (l7 != v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%4;
                    if (l9 != v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v.Leek168.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveName();
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetMint168BlackEyedBeans168(::Mint168::BlackEyedBeans168 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMint168BlackEyedBeans168");
#endif

  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 5; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Apricots168[i1].Rhubarb168[i3].RedCabbage167.length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                v.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%4;
                    v.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMint168BlackEyedBeans168(const ::Mint168::BlackEyedBeans168 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMint168BlackEyedBeans168");
#endif

  AddName("Apricots168");
  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      AddName("Rhubarb168");
      {
        int	i3;
        for(i3=0; i3 < 5; ++i3)
        {
          AddIndex(i3);
          AddName("RedCabbage167");
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Apricots168[i1].Rhubarb168[i3].RedCabbage167.length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Apricots168[i1].Rhubarb168[i3].RedCabbage167.length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                if (l7 != v.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%4;
                    if (l9 != v.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v.Apricots168[i1].Rhubarb168[i3].RedCabbage167[i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveName();
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetMint168BlackEyedBeans168PassionFruit168(::Mint168::BlackEyedBeans168::PassionFruit168 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMint168BlackEyedBeans168PassionFruit168");
#endif

  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Rhubarb168[i1].RedCabbage167.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            v.Rhubarb168[i1].RedCabbage167[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%4;
                v.Rhubarb168[i1].RedCabbage167[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.Rhubarb168[i1].RedCabbage167[i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMint168BlackEyedBeans168PassionFruit168(const ::Mint168::BlackEyedBeans168::PassionFruit168 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMint168BlackEyedBeans168PassionFruit168");
#endif

  AddName("Rhubarb168");
  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      AddName("RedCabbage167");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Rhubarb168[i1].RedCabbage167.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Rhubarb168[i1].RedCabbage167.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            if (l5 != v.Rhubarb168[i1].RedCabbage167[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Rhubarb168[i1].RedCabbage167[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%4;
                if (l7 != v.Rhubarb168[i1].RedCabbage167[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Rhubarb168[i1].RedCabbage167[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.Rhubarb168[i1].RedCabbage167[i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetMint168BlackEyedBeans168PassionFruit168ChineseLeaves167(::Mint168::BlackEyedBeans168::PassionFruit168::ChineseLeaves167 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMint168BlackEyedBeans168PassionFruit168ChineseLeaves167");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.RedCabbage167.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%2;
        v.RedCabbage167[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%4;
            v.RedCabbage167[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetFloat(v.RedCabbage167[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMint168BlackEyedBeans168PassionFruit168ChineseLeaves167(const ::Mint168::BlackEyedBeans168::PassionFruit168::ChineseLeaves167 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMint168BlackEyedBeans168PassionFruit168ChineseLeaves167");
#endif

  AddName("RedCabbage167");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.RedCabbage167.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.RedCabbage167.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%2;
        if (l3 != v.RedCabbage167[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.RedCabbage167[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%4;
            if (l5 != v.RedCabbage167[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.RedCabbage167[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckFloat(v.RedCabbage167[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetGardenPeas169(::GardenPeas169 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGardenPeas169");
#endif

  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetDouble(v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckGardenPeas169(const ::GardenPeas169 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGardenPeas169");
#endif

  AddName("Leek169");
  AddName("Apricots169");
  AddName("Cucumber169");
  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      AddName("GoldenWonder168");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckDouble(v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetMint169(::Mint169 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMint169");
#endif

  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetDouble(v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMint169(const ::Mint169 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMint169");
#endif

  AddName("Leek169");
  AddName("Apricots169");
  AddName("Cucumber169");
  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      AddName("GoldenWonder168");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckDouble(v.Leek169.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetMint169BlackEyedBeans169(::Mint169::BlackEyedBeans169 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMint169BlackEyedBeans169");
#endif

  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Apricots169.Cucumber169[i1].GoldenWonder168.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Apricots169.Cucumber169[i1].GoldenWonder168[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetDouble(v.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMint169BlackEyedBeans169(const ::Mint169::BlackEyedBeans169 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMint169BlackEyedBeans169");
#endif

  AddName("Apricots169");
  AddName("Cucumber169");
  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      AddName("GoldenWonder168");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Apricots169.Cucumber169[i1].GoldenWonder168.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Apricots169.Cucumber169[i1].GoldenWonder168.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Apricots169.Cucumber169[i1].GoldenWonder168[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Apricots169.Cucumber169[i1].GoldenWonder168[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckDouble(v.Apricots169.Cucumber169[i1].GoldenWonder168[i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetMint169BlackEyedBeans169Ginger169(::Mint169::BlackEyedBeans169::Ginger169 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMint169BlackEyedBeans169Ginger169");
#endif

  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Cucumber169[i1].GoldenWonder168.length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Cucumber169[i1].GoldenWonder168[i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Cucumber169[i1].GoldenWonder168[i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetDouble(v.Cucumber169[i1].GoldenWonder168[i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMint169BlackEyedBeans169Ginger169(const ::Mint169::BlackEyedBeans169::Ginger169 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMint169BlackEyedBeans169Ginger169");
#endif

  AddName("Cucumber169");
  {
    int	i1;
    for(i1=0; i1 < 9; ++i1)
    {
      AddIndex(i1);
      AddName("GoldenWonder168");
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Cucumber169[i1].GoldenWonder168.length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Cucumber169[i1].GoldenWonder168.length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Cucumber169[i1].GoldenWonder168[i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Cucumber169[i1].GoldenWonder168[i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Cucumber169[i1].GoldenWonder168[i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Cucumber169[i1].GoldenWonder168[i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckDouble(v.Cucumber169[i1].GoldenWonder168[i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetMint169BlackEyedBeans169Ginger169Pimpernel168(::Mint169::BlackEyedBeans169::Ginger169::Pimpernel168 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMint169BlackEyedBeans169Ginger169Pimpernel168");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.GoldenWonder168.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.GoldenWonder168[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GoldenWonder168[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetDouble(v.GoldenWonder168[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMint169BlackEyedBeans169Ginger169Pimpernel168(const ::Mint169::BlackEyedBeans169::Ginger169::Pimpernel168 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMint169BlackEyedBeans169Ginger169Pimpernel168");
#endif

  AddName("GoldenWonder168");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.GoldenWonder168.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.GoldenWonder168.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.GoldenWonder168[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GoldenWonder168[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GoldenWonder168[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GoldenWonder168[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckDouble(v.GoldenWonder168[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetidlServerAniseed163Excpt(::idlServer::Aniseed163Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerAniseed163Excpt");
#endif

  GetAniseed163(v.ex1);
}

int CheckidlServerAniseed163Excpt(const ::idlServer::Aniseed163Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerAniseed163Excpt");
#endif

  AddName("ex1");
  if (!CheckAniseed163(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerWhiteCabbage163Excpt(::idlServer::WhiteCabbage163Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerWhiteCabbage163Excpt");
#endif

  GetWhiteCabbage163(v.ex1);
}

int CheckidlServerWhiteCabbage163Excpt(const ::idlServer::WhiteCabbage163Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerWhiteCabbage163Excpt");
#endif

  AddName("ex1");
  if (!CheckWhiteCabbage163(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerParsnip163Excpt(::idlServer::Parsnip163Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerParsnip163Excpt");
#endif

  GetWhiteCabbage163Parsnip163(v.ex1);
}

int CheckidlServerParsnip163Excpt(const ::idlServer::Parsnip163Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerParsnip163Excpt");
#endif

  AddName("ex1");
  if (!CheckWhiteCabbage163Parsnip163(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerOrange163Excpt(::idlServer::Orange163Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerOrange163Excpt");
#endif

  GetWhiteCabbage163Parsnip163Orange163(v.ex1);
}

int CheckidlServerOrange163Excpt(const ::idlServer::Orange163Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerOrange163Excpt");
#endif

  AddName("ex1");
  if (!CheckWhiteCabbage163Parsnip163Orange163(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerSultana163Excpt(::idlServer::Sultana163Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerSultana163Excpt");
#endif

  GetWhiteCabbage163Parsnip163Orange163Sultana163(v.ex1);
}

int CheckidlServerSultana163Excpt(const ::idlServer::Sultana163Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerSultana163Excpt");
#endif

  AddName("ex1");
  if (!CheckWhiteCabbage163Parsnip163Orange163Sultana163(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerLoganBerry164Excpt(::idlServer::LoganBerry164Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerLoganBerry164Excpt");
#endif

  GetLoganBerry164(v.ex1);
}

int CheckidlServerLoganBerry164Excpt(const ::idlServer::LoganBerry164Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerLoganBerry164Excpt");
#endif

  AddName("ex1");
  if (!CheckLoganBerry164(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerOrange164Excpt(::idlServer::Orange164Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerOrange164Excpt");
#endif

  GetOrange164(v.ex1);
}

int CheckidlServerOrange164Excpt(const ::idlServer::Orange164Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerOrange164Excpt");
#endif

  AddName("ex1");
  if (!CheckOrange164(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerSultana164Excpt(::idlServer::Sultana164Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerSultana164Excpt");
#endif

  GetOrange164Sultana164(v.ex1);
}

int CheckidlServerSultana164Excpt(const ::idlServer::Sultana164Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerSultana164Excpt");
#endif

  AddName("ex1");
  if (!CheckOrange164Sultana164(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerCoconut164Excpt(::idlServer::Coconut164Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerCoconut164Excpt");
#endif

  GetOrange164Sultana164Coconut164(v.ex1);
}

int CheckidlServerCoconut164Excpt(const ::idlServer::Coconut164Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerCoconut164Excpt");
#endif

  AddName("ex1");
  if (!CheckOrange164Sultana164Coconut164(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



