//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Aniseed163*
idlServer_imp::Aniseed163Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Aniseed163* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Aniseed163Attr\n");
#endif
  
  ernie.seed("Aniseed163AttrCall");
  
  ernie.seed("Aniseed163AttrReturn"); 
  ReturnValue = new ::Aniseed163;
  GetAniseed163(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Aniseed163Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Aniseed163Attr(const ::Aniseed163 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Aniseed163Attr\n");
#endif
  
  ernie.seed("Aniseed163AttrCall");
  AddName("_attr");
  if (!CheckAniseed163(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Aniseed163AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Aniseed163Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Aniseed163*
idlServer_imp::Aniseed163Op(const ::Aniseed163 &p1,::Aniseed163_out p2,::Aniseed163 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Aniseed163* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Aniseed163Op\n");
#endif
  
  ernie.seed("Aniseed163OpCall");
  AddName("p1");
  if (!CheckAniseed163(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAniseed163(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Aniseed163OpReturn"); 
  {
    ::idlServer::Aniseed163Excpt ex;
    GetidlServerAniseed163Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Aniseed163;
  GetAniseed163(*ReturnValue);
  p2 = new ::Aniseed163;
  GetAniseed163(p2);
  GetAniseed163(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Aniseed163Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::WhiteCabbage163*
idlServer_imp::WhiteCabbage163Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::WhiteCabbage163* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::WhiteCabbage163Attr\n");
#endif
  
  ernie.seed("WhiteCabbage163AttrCall");
  
  ernie.seed("WhiteCabbage163AttrReturn"); 
  ReturnValue = new ::WhiteCabbage163;
  GetWhiteCabbage163(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::WhiteCabbage163Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::WhiteCabbage163Attr(const ::WhiteCabbage163 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::WhiteCabbage163Attr\n");
#endif
  
  ernie.seed("WhiteCabbage163AttrCall");
  AddName("_attr");
  if (!CheckWhiteCabbage163(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("WhiteCabbage163AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::WhiteCabbage163Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::WhiteCabbage163*
idlServer_imp::WhiteCabbage163Op(const ::WhiteCabbage163 &p1,::WhiteCabbage163_out p2,::WhiteCabbage163 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::WhiteCabbage163* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::WhiteCabbage163Op\n");
#endif
  
  ernie.seed("WhiteCabbage163OpCall");
  AddName("p1");
  if (!CheckWhiteCabbage163(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckWhiteCabbage163(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("WhiteCabbage163OpReturn"); 
  {
    ::idlServer::WhiteCabbage163Excpt ex;
    GetidlServerWhiteCabbage163Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::WhiteCabbage163;
  GetWhiteCabbage163(*ReturnValue);
  p2 = new ::WhiteCabbage163;
  GetWhiteCabbage163(p2);
  GetWhiteCabbage163(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::WhiteCabbage163Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::WhiteCabbage163::Parsnip163*
idlServer_imp::Parsnip163Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::WhiteCabbage163::Parsnip163* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Parsnip163Attr\n");
#endif
  
  ernie.seed("Parsnip163AttrCall");
  
  ernie.seed("Parsnip163AttrReturn"); 
  ReturnValue = new ::WhiteCabbage163::Parsnip163;
  GetWhiteCabbage163Parsnip163(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Parsnip163Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Parsnip163Attr(const ::WhiteCabbage163::Parsnip163 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Parsnip163Attr\n");
#endif
  
  ernie.seed("Parsnip163AttrCall");
  AddName("_attr");
  if (!CheckWhiteCabbage163Parsnip163(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Parsnip163AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Parsnip163Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::WhiteCabbage163::Parsnip163*
idlServer_imp::Parsnip163Op(const ::WhiteCabbage163::Parsnip163 &p1,::WhiteCabbage163::Parsnip163_out p2,::WhiteCabbage163::Parsnip163 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::WhiteCabbage163::Parsnip163* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Parsnip163Op\n");
#endif
  
  ernie.seed("Parsnip163OpCall");
  AddName("p1");
  if (!CheckWhiteCabbage163Parsnip163(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckWhiteCabbage163Parsnip163(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Parsnip163OpReturn"); 
  {
    ::idlServer::Parsnip163Excpt ex;
    GetidlServerParsnip163Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::WhiteCabbage163::Parsnip163;
  GetWhiteCabbage163Parsnip163(*ReturnValue);
  p2 = new ::WhiteCabbage163::Parsnip163;
  GetWhiteCabbage163Parsnip163(p2);
  GetWhiteCabbage163Parsnip163(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Parsnip163Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::WhiteCabbage163::Parsnip163::Orange163*
idlServer_imp::Orange163Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::WhiteCabbage163::Parsnip163::Orange163* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Orange163Attr\n");
#endif
  
  ernie.seed("Orange163AttrCall");
  
  ernie.seed("Orange163AttrReturn"); 
  ReturnValue = new ::WhiteCabbage163::Parsnip163::Orange163;
  GetWhiteCabbage163Parsnip163Orange163(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Orange163Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Orange163Attr(const ::WhiteCabbage163::Parsnip163::Orange163 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Orange163Attr\n");
#endif
  
  ernie.seed("Orange163AttrCall");
  AddName("_attr");
  if (!CheckWhiteCabbage163Parsnip163Orange163(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Orange163AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Orange163Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::WhiteCabbage163::Parsnip163::Orange163*
idlServer_imp::Orange163Op(const ::WhiteCabbage163::Parsnip163::Orange163 &p1,::WhiteCabbage163::Parsnip163::Orange163_out p2,::WhiteCabbage163::Parsnip163::Orange163 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::WhiteCabbage163::Parsnip163::Orange163* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Orange163Op\n");
#endif
  
  ernie.seed("Orange163OpCall");
  AddName("p1");
  if (!CheckWhiteCabbage163Parsnip163Orange163(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckWhiteCabbage163Parsnip163Orange163(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Orange163OpReturn"); 
  {
    ::idlServer::Orange163Excpt ex;
    GetidlServerOrange163Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::WhiteCabbage163::Parsnip163::Orange163;
  GetWhiteCabbage163Parsnip163Orange163(*ReturnValue);
  p2 = new ::WhiteCabbage163::Parsnip163::Orange163;
  GetWhiteCabbage163Parsnip163Orange163(p2);
  GetWhiteCabbage163Parsnip163Orange163(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Orange163Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::WhiteCabbage163::Parsnip163::Orange163::Sultana163*
idlServer_imp::Sultana163Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::WhiteCabbage163::Parsnip163::Orange163::Sultana163* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sultana163Attr\n");
#endif
  
  ernie.seed("Sultana163AttrCall");
  
  ernie.seed("Sultana163AttrReturn"); 
  ReturnValue = new ::WhiteCabbage163::Parsnip163::Orange163::Sultana163;
  GetWhiteCabbage163Parsnip163Orange163Sultana163(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sultana163Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Sultana163Attr(const ::WhiteCabbage163::Parsnip163::Orange163::Sultana163 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sultana163Attr\n");
#endif
  
  ernie.seed("Sultana163AttrCall");
  AddName("_attr");
  if (!CheckWhiteCabbage163Parsnip163Orange163Sultana163(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sultana163AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sultana163Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::WhiteCabbage163::Parsnip163::Orange163::Sultana163*
idlServer_imp::Sultana163Op(const ::WhiteCabbage163::Parsnip163::Orange163::Sultana163 &p1,::WhiteCabbage163::Parsnip163::Orange163::Sultana163_out p2,::WhiteCabbage163::Parsnip163::Orange163::Sultana163 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::WhiteCabbage163::Parsnip163::Orange163::Sultana163* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sultana163Op\n");
#endif
  
  ernie.seed("Sultana163OpCall");
  AddName("p1");
  if (!CheckWhiteCabbage163Parsnip163Orange163Sultana163(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckWhiteCabbage163Parsnip163Orange163Sultana163(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sultana163OpReturn"); 
  {
    ::idlServer::Sultana163Excpt ex;
    GetidlServerSultana163Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::WhiteCabbage163::Parsnip163::Orange163::Sultana163;
  GetWhiteCabbage163Parsnip163Orange163Sultana163(*ReturnValue);
  p2 = new ::WhiteCabbage163::Parsnip163::Orange163::Sultana163;
  GetWhiteCabbage163Parsnip163Orange163Sultana163(p2);
  GetWhiteCabbage163Parsnip163Orange163Sultana163(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sultana163Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::LoganBerry164*
idlServer_imp::LoganBerry164Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::LoganBerry164* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LoganBerry164Attr\n");
#endif
  
  ernie.seed("LoganBerry164AttrCall");
  
  ernie.seed("LoganBerry164AttrReturn"); 
  ReturnValue = new ::LoganBerry164;
  GetLoganBerry164(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LoganBerry164Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::LoganBerry164Attr(const ::LoganBerry164 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LoganBerry164Attr\n");
#endif
  
  ernie.seed("LoganBerry164AttrCall");
  AddName("_attr");
  if (!CheckLoganBerry164(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LoganBerry164AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LoganBerry164Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::LoganBerry164*
idlServer_imp::LoganBerry164Op(const ::LoganBerry164 &p1,::LoganBerry164_out p2,::LoganBerry164 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::LoganBerry164* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LoganBerry164Op\n");
#endif
  
  ernie.seed("LoganBerry164OpCall");
  AddName("p1");
  if (!CheckLoganBerry164(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckLoganBerry164(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LoganBerry164OpReturn"); 
  {
    ::idlServer::LoganBerry164Excpt ex;
    GetidlServerLoganBerry164Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::LoganBerry164;
  GetLoganBerry164(*ReturnValue);
  p2 = new ::LoganBerry164;
  GetLoganBerry164(p2);
  GetLoganBerry164(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LoganBerry164Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Orange164*
idlServer_imp::Orange164Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Orange164* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Orange164Attr\n");
#endif
  
  ernie.seed("Orange164AttrCall");
  
  ernie.seed("Orange164AttrReturn"); 
  ReturnValue = new ::Orange164;
  GetOrange164(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Orange164Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Orange164Attr(const ::Orange164 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Orange164Attr\n");
#endif
  
  ernie.seed("Orange164AttrCall");
  AddName("_attr");
  if (!CheckOrange164(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Orange164AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Orange164Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Orange164*
idlServer_imp::Orange164Op(const ::Orange164 &p1,::Orange164_out p2,::Orange164 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Orange164* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Orange164Op\n");
#endif
  
  ernie.seed("Orange164OpCall");
  AddName("p1");
  if (!CheckOrange164(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckOrange164(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Orange164OpReturn"); 
  {
    ::idlServer::Orange164Excpt ex;
    GetidlServerOrange164Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Orange164;
  GetOrange164(*ReturnValue);
  p2 = new ::Orange164;
  GetOrange164(p2);
  GetOrange164(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Orange164Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Orange164::Sultana164*
idlServer_imp::Sultana164Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Orange164::Sultana164* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sultana164Attr\n");
#endif
  
  ernie.seed("Sultana164AttrCall");
  
  ernie.seed("Sultana164AttrReturn"); 
  ReturnValue = new ::Orange164::Sultana164;
  GetOrange164Sultana164(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sultana164Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Sultana164Attr(const ::Orange164::Sultana164 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sultana164Attr\n");
#endif
  
  ernie.seed("Sultana164AttrCall");
  AddName("_attr");
  if (!CheckOrange164Sultana164(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sultana164AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sultana164Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Orange164::Sultana164*
idlServer_imp::Sultana164Op(const ::Orange164::Sultana164 &p1,::Orange164::Sultana164_out p2,::Orange164::Sultana164 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Orange164::Sultana164* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Sultana164Op\n");
#endif
  
  ernie.seed("Sultana164OpCall");
  AddName("p1");
  if (!CheckOrange164Sultana164(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckOrange164Sultana164(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sultana164OpReturn"); 
  {
    ::idlServer::Sultana164Excpt ex;
    GetidlServerSultana164Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Orange164::Sultana164;
  GetOrange164Sultana164(*ReturnValue);
  p2 = new ::Orange164::Sultana164;
  GetOrange164Sultana164(p2);
  GetOrange164Sultana164(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Sultana164Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Orange164::Sultana164::Coconut164*
idlServer_imp::Coconut164Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Orange164::Sultana164::Coconut164* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Coconut164Attr\n");
#endif
  
  ernie.seed("Coconut164AttrCall");
  
  ernie.seed("Coconut164AttrReturn"); 
  ReturnValue = new ::Orange164::Sultana164::Coconut164;
  GetOrange164Sultana164Coconut164(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Coconut164Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Coconut164Attr(const ::Orange164::Sultana164::Coconut164 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Coconut164Attr\n");
#endif
  
  ernie.seed("Coconut164AttrCall");
  AddName("_attr");
  if (!CheckOrange164Sultana164Coconut164(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Coconut164AttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Coconut164Attr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Orange164::Sultana164::Coconut164*
idlServer_imp::Coconut164Op(const ::Orange164::Sultana164::Coconut164 &p1,::Orange164::Sultana164::Coconut164_out p2,::Orange164::Sultana164::Coconut164 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Orange164::Sultana164::Coconut164* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Coconut164Op\n");
#endif
  
  ernie.seed("Coconut164OpCall");
  AddName("p1");
  if (!CheckOrange164Sultana164Coconut164(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckOrange164Sultana164Coconut164(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Coconut164OpReturn"); 
  {
    ::idlServer::Coconut164Excpt ex;
    GetidlServerCoconut164Excpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Orange164::Sultana164::Coconut164;
  GetOrange164Sultana164Coconut164(*ReturnValue);
  p2 = new ::Orange164::Sultana164::Coconut164;
  GetOrange164Sultana164Coconut164(p2);
  GetOrange164Sultana164Coconut164(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Coconut164Op\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



