//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:48  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.9  1999/04/26 13:52:06  james
// Changed CORBA::Char* to char*
//
// Revision 1.8  1999/04/26 10:42:36  stephen
// SR# 103: Enum does not introduce new scope level so rename nested Bayleaf.
//
// Revision 1.7  1998/08/24 11:47:01  james
// ENV updates
//
// Revision 1.6  1997/12/15 10:52:02  james
// #ifdefs removed
//
// Revision 1.5  1997/12/11 19:24:33  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetKidneyBean(::KidneyBean &v)
{
#ifdef DEBUG
  ::tet_infoline("GetKidneyBean");
#endif

  GetLong(v.BlackCherry);
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.PassionFruit.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetKidneyBean(v.PassionFruit[i1]);
      RemoveIndex();
    }
  }
}

int CheckKidneyBean(const ::KidneyBean &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckKidneyBean");
#endif

  AddName("BlackCherry");
  if (!CheckLong(v.BlackCherry))
    iRetCode = 0;
  RemoveName();
  AddName("PassionFruit");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.PassionFruit.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.PassionFruit.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckKidneyBean(v.PassionFruit[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetShallots(::Shallots &v)
{
#ifdef DEBUG
  ::tet_infoline("GetShallots");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%9;
    v.KidneyBean.Tofu.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetShallots(v.KidneyBean.Tofu[i1]);
      RemoveIndex();
    }
  }
  GetFloat(v.KidneyBean.Apricots);
  GetShort(v.KidneyBean.Guava);
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%9;
    v.Brocoli.Tofu.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetShallots(v.Brocoli.Tofu[i1]);
      RemoveIndex();
    }
  }
  GetFloat(v.Brocoli.Apricots);
  GetShort(v.Brocoli.Guava);
  ::Shallots::Runnerbean RunnerbeanArray[5] = {::Shallots::WhiteCabbage,::Shallots::Mushroom,::Shallots::Tomato,::Shallots::Almonds,::Shallots::Orange};
  v.Bayleaf = RunnerbeanArray[ernie.getULong()%5];
}

int CheckShallots(const ::Shallots &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckShallots");
#endif

  AddName("KidneyBean");
  AddName("Tofu");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%9;
    if (l1 != v.KidneyBean.Tofu.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.KidneyBean.Tofu.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckShallots(v.KidneyBean.Tofu[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Apricots");
  if (!CheckFloat(v.KidneyBean.Apricots))
    iRetCode = 0;
  RemoveName();
  AddName("Guava");
  if (!CheckShort(v.KidneyBean.Guava))
    iRetCode = 0;
  RemoveName();
  RemoveName();
  AddName("Brocoli");
  AddName("Tofu");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%9;
    if (l1 != v.Brocoli.Tofu.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Brocoli.Tofu.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckShallots(v.Brocoli.Tofu[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Apricots");
  if (!CheckFloat(v.Brocoli.Apricots))
    iRetCode = 0;
  RemoveName();
  AddName("Guava");
  if (!CheckShort(v.Brocoli.Guava))
    iRetCode = 0;
  RemoveName();
  RemoveName();
  AddName("Bayleaf");
  ::Shallots::Runnerbean RunnerbeanArray[5] = {::Shallots::WhiteCabbage,::Shallots::Mushroom,::Shallots::Tomato,::Shallots::Almonds,::Shallots::Orange};
  if (v.Bayleaf != RunnerbeanArray[ernie.getULong()%5])
  {
    ::tet_printf("ERROR: %s has incorrect value",name);
    ::tet_printf("Expected %d, but found %d instead", RunnerbeanArray[ernie.getULongAgain()%5],v.Bayleaf);
    iRetCode = 0;
  }
  RemoveName();
  return iRetCode;
}

 
void GetShallotsAniseed(::Shallots::Aniseed &v)
{
#ifdef DEBUG
  ::tet_infoline("GetShallotsAniseed");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%9;
    v.Tofu.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      GetShallots(v.Tofu[i1]);
      RemoveIndex();
    }
  }
  GetFloat(v.Apricots);
  GetShort(v.Guava);
}

int CheckShallotsAniseed(const ::Shallots::Aniseed &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckShallotsAniseed");
#endif

  AddName("Tofu");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%9;
    if (l1 != v.Tofu.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Tofu.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      if (!CheckShallots(v.Tofu[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Apricots");
  if (!CheckFloat(v.Apricots))
    iRetCode = 0;
  RemoveName();
  AddName("Guava");
  if (!CheckShort(v.Guava))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetShallotsRunnerbean(::Shallots::Runnerbean &v)
{
#ifdef DEBUG
  ::tet_infoline("GetShallotsRunnerbean");
#endif

  ::Shallots::Runnerbean RunnerbeanArray[5] = {::Shallots::WhiteCabbage,::Shallots::Mushroom,::Shallots::Tomato,::Shallots::Almonds,::Shallots::Orange};
  v = RunnerbeanArray[ernie.getULong()%5];
}

int CheckShallotsRunnerbean(const ::Shallots::Runnerbean &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckShallotsRunnerbean");
#endif

  ::Shallots::Runnerbean RunnerbeanArray[5] = {::Shallots::WhiteCabbage,::Shallots::Mushroom,::Shallots::Tomato,::Shallots::Almonds,::Shallots::Orange};
  if (v != RunnerbeanArray[ernie.getULong()%5])
  {
    ::tet_printf("ERROR: %s has incorrect value",name);
    ::tet_printf("Expected %d, but found %d instead", RunnerbeanArray[ernie.getULongAgain()%5],v);
    iRetCode = 0;
  }
  return iRetCode;
}

 
void GetidlServerGoldenDelicous(::idlServer::GoldenDelicous &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerGoldenDelicous");
#endif

  GetShallots(v.CantelopeMelon);
  GetKidneyBean(v.RowanBerry);
}

int CheckidlServerGoldenDelicous(const ::idlServer::GoldenDelicous &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerGoldenDelicous");
#endif

  AddName("CantelopeMelon");
  if (!CheckShallots(v.CantelopeMelon))
    iRetCode = 0;
  RemoveName();
  AddName("RowanBerry");
  if (!CheckKidneyBean(v.RowanBerry))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



