//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Shallots*
idlServer_imp::Plum( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Shallots* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Plum\n");
#endif
  
  ernie.seed("PlumCall");
  
  ernie.seed("PlumReturn"); 
  ReturnValue = new ::Shallots;
  GetShallots(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Plum\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Plum(const ::Shallots &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Plum\n");
#endif
  
  ernie.seed("PlumCall");
  AddName("_attr");
  if (!CheckShallots(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PlumReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Plum\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::KidneyBean*
idlServer_imp::Zucchini( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::KidneyBean* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Zucchini\n");
#endif
  
  ernie.seed("ZucchiniCall");
  
  ernie.seed("ZucchiniReturn"); 
  ReturnValue = new ::KidneyBean;
  GetKidneyBean(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Zucchini\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Zucchini(const ::KidneyBean &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Zucchini\n");
#endif
  
  ernie.seed("ZucchiniCall");
  AddName("_attr");
  if (!CheckKidneyBean(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ZucchiniReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Zucchini\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Shallots*
idlServer_imp::Avocado(const ::KidneyBean &p1,::KidneyBean_out p2,::Shallots &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Shallots* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Avocado\n");
#endif
  
  ernie.seed("AvocadoCall");
  AddName("p1");
  if (!CheckKidneyBean(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckShallots(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AvocadoReturn"); 
  {
    ::idlServer::GoldenDelicous ex;
    GetidlServerGoldenDelicous(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::Shallots;
  GetShallots(*ReturnValue);
  p2 = new ::KidneyBean;
  GetKidneyBean(p2);
  GetShallots(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Avocado\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



