//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::YellowPepper*
idlServer_imp::YellowPepperAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::YellowPepper* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::YellowPepperAttr\n");
#endif
  
  ernie.seed("YellowPepperAttrCall");
  
  ernie.seed("YellowPepperAttrReturn"); 
  ReturnValue = new ::YellowPepper;
  GetYellowPepper(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::YellowPepperAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::YellowPepperAttr(const ::YellowPepper &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::YellowPepperAttr\n");
#endif
  
  ernie.seed("YellowPepperAttrCall");
  AddName("_attr");
  if (!CheckYellowPepper(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("YellowPepperAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::YellowPepperAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::YellowPepper*
idlServer_imp::YellowPepperOp(const ::YellowPepper &p1,::YellowPepper_out p2,::YellowPepper &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::YellowPepper* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::YellowPepperOp\n");
#endif
  
  ernie.seed("YellowPepperOpCall");
  AddName("p1");
  if (!CheckYellowPepper(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckYellowPepper(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("YellowPepperOpReturn"); 
  {
    ::idlServer::YellowPepperExcpt ex;
    GetidlServerYellowPepperExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::YellowPepper;
  GetYellowPepper(*ReturnValue);
  p2 = new ::YellowPepper;
  GetYellowPepper(*(p2.ptr()));
  GetYellowPepper(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::YellowPepperOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::CoxPippin_slice *
idlServer_imp::CoxPippinAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::CoxPippin_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CoxPippinAttr\n");
#endif
  
  ernie.seed("CoxPippinAttrCall");
  
  ernie.seed("CoxPippinAttrReturn"); 
  
  ReturnValue = new ::CoxPippin;
  GetCoxPippin(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CoxPippinAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::CoxPippinAttr(const ::CoxPippin _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CoxPippinAttr\n");
#endif
  
  ernie.seed("CoxPippinAttrCall");
  AddName("_attr");
  if (!CheckCoxPippin(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CoxPippinAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CoxPippinAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::CoxPippin_slice *
idlServer_imp::CoxPippinOp(const ::CoxPippin p1,::CoxPippin_out p2,::CoxPippin p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::CoxPippin_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CoxPippinOp\n");
#endif
  
  ernie.seed("CoxPippinOpCall");
  AddName("p1");
  if (!CheckCoxPippin(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCoxPippin(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CoxPippinOpReturn"); 
  {
    ::idlServer::CoxPippinExcpt ex;
    GetidlServerCoxPippinExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::CoxPippin;
  GetCoxPippin(ReturnValue);
  p2 = new ::CoxPippin;
  GetCoxPippin(p2);
  GetCoxPippin(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CoxPippinOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



