//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:52  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/26 13:52:13  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/15 10:52:03  james
// #ifdefs removed
//
// Revision 1.4  1997/12/09 11:29:09  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetAvocado(::Avocado &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAvocado");
#endif

  GetFloat(v.ButterBean);
}

int CheckAvocado(const ::Avocado &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAvocado");
#endif

  AddName("ButterBean");
  if (!CheckFloat(v.ButterBean))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetGalaApple(::GalaApple &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGalaApple");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.ButterBean[i1]);
      RemoveIndex();
    }
  }
  GetFloat(v.ChestNut);
  {
    int	i1;
    for(i1=0; i1 < 43; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Currant[i1]);
      RemoveIndex();
    }
  }
  GetFloat(v.CoxPippin);
  GetFloat(v.Chervil);
  {
    int	i1;
    for(i1=0; i1 < 23; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Scallion[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Tomato[i1]);
      RemoveIndex();
    }
  }
}

int CheckGalaApple(const ::GalaApple &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGalaApple");
#endif

  AddName("ButterBean");
  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.ButterBean[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("ChestNut");
  if (!CheckFloat(v.ChestNut))
    iRetCode = 0;
  RemoveName();
  AddName("Currant");
  {
    int	i1;
    for(i1=0; i1 < 43; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Currant[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("CoxPippin");
  if (!CheckFloat(v.CoxPippin))
    iRetCode = 0;
  RemoveName();
  AddName("Chervil");
  if (!CheckFloat(v.Chervil))
    iRetCode = 0;
  RemoveName();
  AddName("Scallion");
  {
    int	i1;
    for(i1=0; i1 < 23; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Scallion[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Tomato");
  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Tomato[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetidlServerAvocadoExcpt(::idlServer::AvocadoExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerAvocadoExcpt");
#endif

  GetAvocado(v.ex1);
}

int CheckidlServerAvocadoExcpt(const ::idlServer::AvocadoExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerAvocadoExcpt");
#endif

  AddName("ex1");
  if (!CheckAvocado(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerGalaAppleExcpt(::idlServer::GalaAppleExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerGalaAppleExcpt");
#endif

  GetGalaApple(v.ex1);
}

int CheckidlServerGalaAppleExcpt(const ::idlServer::GalaAppleExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerGalaAppleExcpt");
#endif

  AddName("ex1");
  if (!CheckGalaApple(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



