//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Avocado
idlServer_imp::AvocadoAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoAttr\n");
#endif
  
  ernie.seed("AvocadoAttrCall");
  
  ernie.seed("AvocadoAttrReturn"); 
  
  GetAvocado(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::AvocadoAttr(const ::Avocado &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoAttr\n");
#endif
  
  ernie.seed("AvocadoAttrCall");
  AddName("_attr");
  if (!CheckAvocado(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AvocadoAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Avocado
idlServer_imp::AvocadoOp(const ::Avocado &p1,::Avocado &p2,::Avocado &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Avocado ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoOp\n");
#endif
  
  ernie.seed("AvocadoOpCall");
  AddName("p1");
  if (!CheckAvocado(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAvocado(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AvocadoOpReturn"); 
  {
    ::idlServer::AvocadoExcpt ex;
    GetidlServerAvocadoExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetAvocado(ReturnValue);
  GetAvocado(p2);
  GetAvocado(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GalaApple
idlServer_imp::GalaAppleAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::GalaApple ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GalaAppleAttr\n");
#endif
  
  ernie.seed("GalaAppleAttrCall");
  
  ernie.seed("GalaAppleAttrReturn"); 
  
  GetGalaApple(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GalaAppleAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::GalaAppleAttr(const ::GalaApple &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GalaAppleAttr\n");
#endif
  
  ernie.seed("GalaAppleAttrCall");
  AddName("_attr");
  if (!CheckGalaApple(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GalaAppleAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GalaAppleAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::GalaApple
idlServer_imp::GalaAppleOp(const ::GalaApple &p1,::GalaApple &p2,::GalaApple &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::GalaApple ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GalaAppleOp\n");
#endif
  
  ernie.seed("GalaAppleOpCall");
  AddName("p1");
  if (!CheckGalaApple(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGalaApple(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GalaAppleOpReturn"); 
  {
    ::idlServer::GalaAppleExcpt ex;
    GetidlServerGalaAppleExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetGalaApple(ReturnValue);
  GetGalaApple(p2);
  GetGalaApple(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GalaAppleOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



