//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:55  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/26 13:52:18  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/15 10:52:04  james
// #ifdefs removed
//
// Revision 1.4  1997/12/09 11:29:18  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetApple(::Apple &v)
{
#ifdef DEBUG
  ::tet_infoline("GetApple");
#endif

  GetULong(v.ButterBean);
}

int CheckApple(const ::Apple &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckApple");
#endif

  AddName("ButterBean");
  if (!CheckULong(v.ButterBean))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetAvocado(::Avocado &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAvocado");
#endif

  GetULong(v.ButterBean);
}

int CheckAvocado(const ::Avocado &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAvocado");
#endif

  AddName("ButterBean");
  if (!CheckULong(v.ButterBean))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetPeanut(::Peanut &v)
{
#ifdef DEBUG
  ::tet_infoline("GetPeanut");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.ButterBean[i1]);
      RemoveIndex();
    }
  }
  GetFloat(v.ChestNut);
  {
    int	i1;
    for(i1=0; i1 < 43; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Currant[i1]);
      RemoveIndex();
    }
  }
  GetFloat(v.CoxPippin);
  GetFloat(v.Chervil);
  {
    int	i1;
    for(i1=0; i1 < 23; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Scallion[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Tomato[i1]);
      RemoveIndex();
    }
  }
}

int CheckPeanut(const ::Peanut &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPeanut");
#endif

  AddName("ButterBean");
  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.ButterBean[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("ChestNut");
  if (!CheckFloat(v.ChestNut))
    iRetCode = 0;
  RemoveName();
  AddName("Currant");
  {
    int	i1;
    for(i1=0; i1 < 43; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Currant[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("CoxPippin");
  if (!CheckFloat(v.CoxPippin))
    iRetCode = 0;
  RemoveName();
  AddName("Chervil");
  if (!CheckFloat(v.Chervil))
    iRetCode = 0;
  RemoveName();
  AddName("Scallion");
  {
    int	i1;
    for(i1=0; i1 < 23; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Scallion[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Tomato");
  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Tomato[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetSatsuma(::Satsuma v)
{
#ifdef DEBUG
  ::tet_infoline("GetSatsuma");
#endif

  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      {
        int	i3;
        for(i3=0; i3 < 6; ++i3)
        {
          AddIndex(i3);
          GetFloat(v[i1].ButterBean[i3]);
          RemoveIndex();
        }
      }
      GetFloat(v[i1].ChestNut);
      {
        int	i3;
        for(i3=0; i3 < 43; ++i3)
        {
          AddIndex(i3);
          GetFloat(v[i1].Currant[i3]);
          RemoveIndex();
        }
      }
      GetFloat(v[i1].CoxPippin);
      GetFloat(v[i1].Chervil);
      {
        int	i3;
        for(i3=0; i3 < 23; ++i3)
        {
          AddIndex(i3);
          GetFloat(v[i1].Scallion[i3]);
          RemoveIndex();
        }
      }
      {
        int	i3;
        for(i3=0; i3 < 8; ++i3)
        {
          AddIndex(i3);
          GetFloat(v[i1].Tomato[i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckSatsuma(const ::Satsuma v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSatsuma");
#endif

  {
    int	i1;
    for(i1=0; i1 < 3; ++i1)
    {
      AddIndex(i1);
      AddName("ButterBean");
      {
        int	i3;
        for(i3=0; i3 < 6; ++i3)
        {
          AddIndex(i3);
          if (!CheckFloat(v[i1].ButterBean[i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveName();
      AddName("ChestNut");
      if (!CheckFloat(v[i1].ChestNut))
        iRetCode = 0;
      RemoveName();
      AddName("Currant");
      {
        int	i3;
        for(i3=0; i3 < 43; ++i3)
        {
          AddIndex(i3);
          if (!CheckFloat(v[i1].Currant[i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveName();
      AddName("CoxPippin");
      if (!CheckFloat(v[i1].CoxPippin))
        iRetCode = 0;
      RemoveName();
      AddName("Chervil");
      if (!CheckFloat(v[i1].Chervil))
        iRetCode = 0;
      RemoveName();
      AddName("Scallion");
      {
        int	i3;
        for(i3=0; i3 < 23; ++i3)
        {
          AddIndex(i3);
          if (!CheckFloat(v[i1].Scallion[i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveName();
      AddName("Tomato");
      {
        int	i3;
        for(i3=0; i3 < 8; ++i3)
        {
          AddIndex(i3);
          if (!CheckFloat(v[i1].Tomato[i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveName();
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetRedChilly(::RedChilly &v)
{
#ifdef DEBUG
  ::tet_infoline("GetRedChilly");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.ButterBean[i1]);
      RemoveIndex();
    }
  }
  GetFloat(v.ChestNut);
  {
    int	i1;
    for(i1=0; i1 < 43; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Currant[i1]);
      RemoveIndex();
    }
  }
  GetFloat(v.CoxPippin);
  GetFloat(v.Chervil);
  {
    int	i1;
    for(i1=0; i1 < 23; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Scallion[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Tomato[i1]);
      RemoveIndex();
    }
  }
}

int CheckRedChilly(const ::RedChilly &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRedChilly");
#endif

  AddName("ButterBean");
  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.ButterBean[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("ChestNut");
  if (!CheckFloat(v.ChestNut))
    iRetCode = 0;
  RemoveName();
  AddName("Currant");
  {
    int	i1;
    for(i1=0; i1 < 43; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Currant[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("CoxPippin");
  if (!CheckFloat(v.CoxPippin))
    iRetCode = 0;
  RemoveName();
  AddName("Chervil");
  if (!CheckFloat(v.Chervil))
    iRetCode = 0;
  RemoveName();
  AddName("Scallion");
  {
    int	i1;
    for(i1=0; i1 < 23; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Scallion[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Tomato");
  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Tomato[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetCeleriac(::Celeriac &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCeleriac");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.ButterBean[i1]);
      RemoveIndex();
    }
  }
  GetFloat(v.ChestNut);
  {
    int	i1;
    for(i1=0; i1 < 43; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Currant[i1]);
      RemoveIndex();
    }
  }
  GetFloat(v.CoxPippin);
  GetFloat(v.Chervil);
  {
    int	i1;
    for(i1=0; i1 < 23; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Scallion[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Tomato[i1]);
      RemoveIndex();
    }
  }
}

int CheckCeleriac(const ::Celeriac &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCeleriac");
#endif

  AddName("ButterBean");
  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.ButterBean[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("ChestNut");
  if (!CheckFloat(v.ChestNut))
    iRetCode = 0;
  RemoveName();
  AddName("Currant");
  {
    int	i1;
    for(i1=0; i1 < 43; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Currant[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("CoxPippin");
  if (!CheckFloat(v.CoxPippin))
    iRetCode = 0;
  RemoveName();
  AddName("Chervil");
  if (!CheckFloat(v.Chervil))
    iRetCode = 0;
  RemoveName();
  AddName("Scallion");
  {
    int	i1;
    for(i1=0; i1 < 23; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Scallion[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Tomato");
  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Tomato[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetBanana(::Banana &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBanana");
#endif

  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.ButterBean[i1]);
      RemoveIndex();
    }
  }
  GetFloat(v.ChestNut);
  {
    int	i1;
    for(i1=0; i1 < 43; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Currant[i1]);
      RemoveIndex();
    }
  }
  GetFloat(v.CoxPippin);
  GetFloat(v.Chervil);
  {
    int	i1;
    for(i1=0; i1 < 23; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Scallion[i1]);
      RemoveIndex();
    }
  }
  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      GetFloat(v.Tomato[i1]);
      RemoveIndex();
    }
  }
}

int CheckBanana(const ::Banana &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBanana");
#endif

  AddName("ButterBean");
  {
    int	i1;
    for(i1=0; i1 < 6; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.ButterBean[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("ChestNut");
  if (!CheckFloat(v.ChestNut))
    iRetCode = 0;
  RemoveName();
  AddName("Currant");
  {
    int	i1;
    for(i1=0; i1 < 43; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Currant[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("CoxPippin");
  if (!CheckFloat(v.CoxPippin))
    iRetCode = 0;
  RemoveName();
  AddName("Chervil");
  if (!CheckFloat(v.Chervil))
    iRetCode = 0;
  RemoveName();
  AddName("Scallion");
  {
    int	i1;
    for(i1=0; i1 < 23; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Scallion[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  AddName("Tomato");
  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      if (!CheckFloat(v.Tomato[i1]))
        iRetCode = 0;
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetidlServerAppleExcpt(::idlServer::AppleExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerAppleExcpt");
#endif

  GetApple(v.ex1);
}

int CheckidlServerAppleExcpt(const ::idlServer::AppleExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerAppleExcpt");
#endif

  AddName("ex1");
  if (!CheckApple(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerAvocadoExcpt(::idlServer::AvocadoExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerAvocadoExcpt");
#endif

  GetAvocado(v.ex1);
}

int CheckidlServerAvocadoExcpt(const ::idlServer::AvocadoExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerAvocadoExcpt");
#endif

  AddName("ex1");
  if (!CheckAvocado(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerPeanutExcpt(::idlServer::PeanutExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerPeanutExcpt");
#endif

  GetPeanut(v.ex1);
}

int CheckidlServerPeanutExcpt(const ::idlServer::PeanutExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerPeanutExcpt");
#endif

  AddName("ex1");
  if (!CheckPeanut(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerSatsumaExcpt(::idlServer::SatsumaExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerSatsumaExcpt");
#endif

  GetSatsuma(v.ex1);
}

int CheckidlServerSatsumaExcpt(const ::idlServer::SatsumaExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerSatsumaExcpt");
#endif

  AddName("ex1");
  if (!CheckSatsuma(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerRedChillyExcpt(::idlServer::RedChillyExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerRedChillyExcpt");
#endif

  GetRedChilly(v.ex1);
}

int CheckidlServerRedChillyExcpt(const ::idlServer::RedChillyExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerRedChillyExcpt");
#endif

  AddName("ex1");
  if (!CheckRedChilly(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerCeleriacExcpt(::idlServer::CeleriacExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerCeleriacExcpt");
#endif

  GetCeleriac(v.ex1);
}

int CheckidlServerCeleriacExcpt(const ::idlServer::CeleriacExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerCeleriacExcpt");
#endif

  AddName("ex1");
  if (!CheckCeleriac(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerBananaExcpt(::idlServer::BananaExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerBananaExcpt");
#endif

  GetBanana(v.ex1);
}

int CheckidlServerBananaExcpt(const ::idlServer::BananaExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerBananaExcpt");
#endif

  AddName("ex1");
  if (!CheckBanana(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



