//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Apple
idlServer_imp::AppleAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Apple ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AppleAttr\n");
#endif
  
  ernie.seed("AppleAttrCall");
  
  ernie.seed("AppleAttrReturn"); 
  
  GetApple(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AppleAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::AppleAttr(const ::Apple &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AppleAttr\n");
#endif
  
  ernie.seed("AppleAttrCall");
  AddName("_attr");
  if (!CheckApple(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AppleAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AppleAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Apple
idlServer_imp::AppleOp(const ::Apple &p1,::Apple &p2,::Apple &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Apple ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AppleOp\n");
#endif
  
  ernie.seed("AppleOpCall");
  AddName("p1");
  if (!CheckApple(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckApple(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AppleOpReturn"); 
  {
    ::idlServer::AppleExcpt ex;
    GetidlServerAppleExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetApple(ReturnValue);
  GetApple(p2);
  GetApple(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AppleOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Avocado
idlServer_imp::AvocadoAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoAttr\n");
#endif
  
  ernie.seed("AvocadoAttrCall");
  
  ernie.seed("AvocadoAttrReturn"); 
  
  GetAvocado(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::AvocadoAttr(const ::Avocado &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoAttr\n");
#endif
  
  ernie.seed("AvocadoAttrCall");
  AddName("_attr");
  if (!CheckAvocado(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AvocadoAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Avocado
idlServer_imp::AvocadoOp(const ::Avocado &p1,::Avocado &p2,::Avocado &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Avocado ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoOp\n");
#endif
  
  ernie.seed("AvocadoOpCall");
  AddName("p1");
  if (!CheckAvocado(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAvocado(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AvocadoOpReturn"); 
  {
    ::idlServer::AvocadoExcpt ex;
    GetidlServerAvocadoExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetAvocado(ReturnValue);
  GetAvocado(p2);
  GetAvocado(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Peanut
idlServer_imp::PeanutAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Peanut ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PeanutAttr\n");
#endif
  
  ernie.seed("PeanutAttrCall");
  
  ernie.seed("PeanutAttrReturn"); 
  
  GetPeanut(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PeanutAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::PeanutAttr(const ::Peanut &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PeanutAttr\n");
#endif
  
  ernie.seed("PeanutAttrCall");
  AddName("_attr");
  if (!CheckPeanut(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PeanutAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PeanutAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Peanut
idlServer_imp::PeanutOp(const ::Peanut &p1,::Peanut &p2,::Peanut &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Peanut ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PeanutOp\n");
#endif
  
  ernie.seed("PeanutOpCall");
  AddName("p1");
  if (!CheckPeanut(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPeanut(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PeanutOpReturn"); 
  {
    ::idlServer::PeanutExcpt ex;
    GetidlServerPeanutExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetPeanut(ReturnValue);
  GetPeanut(p2);
  GetPeanut(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PeanutOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Satsuma_slice *
idlServer_imp::SatsumaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Satsuma_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SatsumaAttr\n");
#endif
  
  ernie.seed("SatsumaAttrCall");
  
  ernie.seed("SatsumaAttrReturn"); 
  
  ReturnValue = new ::Satsuma;
  GetSatsuma(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SatsumaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::SatsumaAttr(const ::Satsuma _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SatsumaAttr\n");
#endif
  
  ernie.seed("SatsumaAttrCall");
  AddName("_attr");
  if (!CheckSatsuma(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SatsumaAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SatsumaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Satsuma_slice *
idlServer_imp::SatsumaOp(const ::Satsuma p1,::Satsuma p2,::Satsuma p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Satsuma_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SatsumaOp\n");
#endif
  
  ernie.seed("SatsumaOpCall");
  AddName("p1");
  if (!CheckSatsuma(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckSatsuma(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SatsumaOpReturn"); 
  {
    ::idlServer::SatsumaExcpt ex;
    GetidlServerSatsumaExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Satsuma;
  GetSatsuma(ReturnValue);
  GetSatsuma(p2);
  GetSatsuma(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SatsumaOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::RedChilly
idlServer_imp::RedChillyAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::RedChilly ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedChillyAttr\n");
#endif
  
  ernie.seed("RedChillyAttrCall");
  
  ernie.seed("RedChillyAttrReturn"); 
  
  GetRedChilly(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedChillyAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::RedChillyAttr(const ::RedChilly &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedChillyAttr\n");
#endif
  
  ernie.seed("RedChillyAttrCall");
  AddName("_attr");
  if (!CheckRedChilly(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedChillyAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedChillyAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::RedChilly
idlServer_imp::RedChillyOp(const ::RedChilly &p1,::RedChilly &p2,::RedChilly &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::RedChilly ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::RedChillyOp\n");
#endif
  
  ernie.seed("RedChillyOpCall");
  AddName("p1");
  if (!CheckRedChilly(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckRedChilly(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedChillyOpReturn"); 
  {
    ::idlServer::RedChillyExcpt ex;
    GetidlServerRedChillyExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetRedChilly(ReturnValue);
  GetRedChilly(p2);
  GetRedChilly(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::RedChillyOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Celeriac
idlServer_imp::CeleriacAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Celeriac ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CeleriacAttr\n");
#endif
  
  ernie.seed("CeleriacAttrCall");
  
  ernie.seed("CeleriacAttrReturn"); 
  
  GetCeleriac(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CeleriacAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::CeleriacAttr(const ::Celeriac &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CeleriacAttr\n");
#endif
  
  ernie.seed("CeleriacAttrCall");
  AddName("_attr");
  if (!CheckCeleriac(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CeleriacAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CeleriacAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Celeriac
idlServer_imp::CeleriacOp(const ::Celeriac &p1,::Celeriac &p2,::Celeriac &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Celeriac ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::CeleriacOp\n");
#endif
  
  ernie.seed("CeleriacOpCall");
  AddName("p1");
  if (!CheckCeleriac(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckCeleriac(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CeleriacOpReturn"); 
  {
    ::idlServer::CeleriacExcpt ex;
    GetidlServerCeleriacExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetCeleriac(ReturnValue);
  GetCeleriac(p2);
  GetCeleriac(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::CeleriacOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Banana
idlServer_imp::BananaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Banana ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BananaAttr\n");
#endif
  
  ernie.seed("BananaAttrCall");
  
  ernie.seed("BananaAttrReturn"); 
  
  GetBanana(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BananaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BananaAttr(const ::Banana &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BananaAttr\n");
#endif
  
  ernie.seed("BananaAttrCall");
  AddName("_attr");
  if (!CheckBanana(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BananaAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BananaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Banana
idlServer_imp::BananaOp(const ::Banana &p1,::Banana &p2,::Banana &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Banana ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BananaOp\n");
#endif
  
  ernie.seed("BananaOpCall");
  AddName("p1");
  if (!CheckBanana(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBanana(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BananaOpReturn"); 
  {
    ::idlServer::BananaExcpt ex;
    GetidlServerBananaExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetBanana(ReturnValue);
  GetBanana(p2);
  GetBanana(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BananaOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



