//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/smain.cpp
//
// Modifications:
// $Log: smain.cpp,v $
// Revision 1.4  2000/10/12 16:08:49  corval2
// Readding.
//
// Revision 1.2  2000/03/28 17:51:27  mli
//   o   remove 'CORBA::Environment ev;'
//   o   use _this() on idlServer_imp
//   o   void (*tet_startup)(void) -> void (*tet_startup)()
//   o   void (*tet_cleanup)(void) -> void (*tet_cleanup)()
//
// Revision 1.1.1.1  2000/02/09 17:16:55  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1998/08/24 11:47:09  james
// ENV updates
//
// Revision 1.4  1997/12/09 11:29:19  james
// Code Regenerated
//
//
//

#include <orb_supp.hh>
#include <syncinfo.hh>
#include <stdlib.h>

#ifndef WIN32
#include <unistd.h>
#else
#include <process.h>
#endif

extern "C" {
#include <tet_api.h>
}

#include "tin.hh"
#include "server.hh"

int remSystem[] = { SSW };  

OrbSupport *orb;

char *stringifiedIOR = 0;

void
serverStartUp( void )
{
    idlServer_imp *objref;

    
    try {
	orb = new OrbSupport("idlServer");
	objref = new idlServer_imp;
	orb->server_init(objref);

        CORBA::Object_ptr objptr;
        objptr= objref->_this();
	stringifiedIOR = orb->getObjref(objptr);
    }
    catch (CORBA::Exception &sysEx) {
	tet_infoline("server: Failed to create idlServer Object ");
	return;
    }

    // Provide space for IOR
    struct tet_synmsg msg;

    // Indicate send mode to TET
    msg.tsm_flags = TET_SMSNDMSG;
    msg.tsm_dlen = strlen(stringifiedIOR) + 1;
    msg.tsm_data = stringifiedIOR;

    // Attempt to synchronise
    if (::tet_remsync(SEVENT, remSystem, 1, VS_TIMEOUT, TET_SV_YES, &msg) != 0) {
  	::tet_printf("server: sync point %d failed", SEVENT);
  	return;
    }

#ifdef DEBUG
    ::tet_printf("server: sync point %d OK", SEVENT);
#endif

}

void
testServer( void ) {
    /* wait for invocations */


    // wait for 15 seconds unless told otherwise
    char * tout = 0;
    tout = getenv("VSORB_EVENT_TIMEOUT");

    unsigned long timeout = (tout) ? atoi(tout) : 15;
    
    try {
	orb->getEvents(CORBA::Environment::_nil(), timeout);
    }
    catch (CORBA::SystemException &ex) {
	tet_infoline("server: exception on getEvents()");
	tet_printf("server: minor code %d", ex.minor());
	::tet_result(TET_FAIL);
	return;
    }
}

void 
serverCleanUp() {
    delete orb;
    return;
}    



extern "C" {
    void (*tet_startup)() = serverStartUp,
    (*tet_cleanup)() = serverCleanUp;
    struct tet_testlist tet_testlist[] = { 
		{testServer,1},
		{testServer,2},
		{testServer,3},
		{testServer,4},
		{testServer,5},
		{testServer,6},
		{testServer,7},
		{testServer,8},
		{testServer,9},
		{testServer,10},
		{testServer,11},
		{testServer,12},
		{testServer,13},
		{testServer,14},
		{testServer,15},
		{testServer,16},
		{testServer,17},
		{testServer,18},
		{testServer,19},
		{testServer,20},
		{testServer,21},
	      {NULL,0} };
}
