//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Peanutsquash_slice *
idlServer_imp::PeanutsquashAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Peanutsquash_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PeanutsquashAttr\n");
#endif
  
  ernie.seed("PeanutsquashAttrCall");
  
  ernie.seed("PeanutsquashAttrReturn"); 
  
  ReturnValue = new ::Peanutsquash;
  GetPeanutsquash(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PeanutsquashAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::PeanutsquashAttr(const ::Peanutsquash _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PeanutsquashAttr\n");
#endif
  
  ernie.seed("PeanutsquashAttrCall");
  AddName("_attr");
  if (!CheckPeanutsquash(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PeanutsquashAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PeanutsquashAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Peanutsquash_slice *
idlServer_imp::PeanutsquashOp(const ::Peanutsquash p1,::Peanutsquash_out p2,::Peanutsquash p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Peanutsquash_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::PeanutsquashOp\n");
#endif
  
  ernie.seed("PeanutsquashOpCall");
  AddName("p1");
  if (!CheckPeanutsquash(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckPeanutsquash(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PeanutsquashOpReturn"); 
  {
    ::idlServer::PeanutsquashExcpt ex;
    GetidlServerPeanutsquashExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  ReturnValue = new ::Peanutsquash;
  GetPeanutsquash(ReturnValue);
  p2 = new ::Peanutsquash;
  GetPeanutsquash(p2);
  GetPeanutsquash(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::PeanutsquashOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GreenPepper*
idlServer_imp::GreenPepperAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::GreenPepper* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GreenPepperAttr\n");
#endif
  
  ernie.seed("GreenPepperAttrCall");
  
  ernie.seed("GreenPepperAttrReturn"); 
  ReturnValue = new ::GreenPepper;
  GetGreenPepper(*ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GreenPepperAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::GreenPepperAttr(const ::GreenPepper &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GreenPepperAttr\n");
#endif
  
  ernie.seed("GreenPepperAttrCall");
  AddName("_attr");
  if (!CheckGreenPepper(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GreenPepperAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GreenPepperAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::GreenPepper*
idlServer_imp::GreenPepperOp(const ::GreenPepper &p1,::GreenPepper_out p2,::GreenPepper &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::GreenPepper* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GreenPepperOp\n");
#endif
  
  ernie.seed("GreenPepperOpCall");
  AddName("p1");
  if (!CheckGreenPepper(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckGreenPepper(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GreenPepperOpReturn"); 
  {
    ::idlServer::GreenPepperExcpt ex;
    GetidlServerGreenPepperExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  ReturnValue = new ::GreenPepper;
  GetGreenPepper(*ReturnValue);
  p2 = new ::GreenPepper;
  GetGreenPepper(p2);
  GetGreenPepper(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GreenPepperOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



