//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:58  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/04/26 13:52:23  james
// Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/15 10:52:05  james
// #ifdefs removed
//
// Revision 1.4  1997/12/09 11:29:30  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetBanana(::Banana &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBanana");
#endif

  GetFloat(v.Plum.ButterBean);
  GetDouble(v.Plum.Onion.Cinnamon);
  GetLong(v.Plum.Onion.Tofu.BreadFruit);
  GetShort(v.Plum.Onion.Tofu.Pumpkin.BambooShoot);
  GetULong(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Fennell);
  GetUShort(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Pineapple);
  GetChar(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Radish);
  GetBoolean(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Damsons);
  GetOctet(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Mint.Mullberry);
}

int CheckBanana(const ::Banana &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBanana");
#endif

  AddName("Plum");
  AddName("ButterBean");
  if (!CheckFloat(v.Plum.ButterBean))
    iRetCode = 0;
  RemoveName();
  AddName("Onion");
  AddName("Cinnamon");
  if (!CheckDouble(v.Plum.Onion.Cinnamon))
    iRetCode = 0;
  RemoveName();
  AddName("Tofu");
  AddName("BreadFruit");
  if (!CheckLong(v.Plum.Onion.Tofu.BreadFruit))
    iRetCode = 0;
  RemoveName();
  AddName("Pumpkin");
  AddName("BambooShoot");
  if (!CheckShort(v.Plum.Onion.Tofu.Pumpkin.BambooShoot))
    iRetCode = 0;
  RemoveName();
  AddName("Aniseed");
  AddName("Fennell");
  if (!CheckULong(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Fennell))
    iRetCode = 0;
  RemoveName();
  AddName("Celery");
  AddName("Pineapple");
  if (!CheckUShort(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Pineapple))
    iRetCode = 0;
  RemoveName();
  AddName("Parsnip");
  AddName("Radish");
  if (!CheckChar(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Radish))
    iRetCode = 0;
  RemoveName();
  AddName("Asparagus");
  AddName("Damsons");
  if (!CheckBoolean(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Damsons))
    iRetCode = 0;
  RemoveName();
  AddName("Mint");
  AddName("Mullberry");
  if (!CheckOctet(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Mint.Mullberry))
    iRetCode = 0;
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetAvocado(::Avocado &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAvocado");
#endif

  GetFloat(v.Plum.ButterBean);
  GetDouble(v.Plum.Onion.Cinnamon);
  GetLong(v.Plum.Onion.Tofu.BreadFruit);
  GetShort(v.Plum.Onion.Tofu.Pumpkin.BambooShoot);
  GetULong(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Fennell);
  GetUShort(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Pineapple);
  GetChar(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Radish);
  GetBoolean(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Damsons);
  GetOctet(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Mint.Mullberry);
}

int CheckAvocado(const ::Avocado &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAvocado");
#endif

  AddName("Plum");
  AddName("ButterBean");
  if (!CheckFloat(v.Plum.ButterBean))
    iRetCode = 0;
  RemoveName();
  AddName("Onion");
  AddName("Cinnamon");
  if (!CheckDouble(v.Plum.Onion.Cinnamon))
    iRetCode = 0;
  RemoveName();
  AddName("Tofu");
  AddName("BreadFruit");
  if (!CheckLong(v.Plum.Onion.Tofu.BreadFruit))
    iRetCode = 0;
  RemoveName();
  AddName("Pumpkin");
  AddName("BambooShoot");
  if (!CheckShort(v.Plum.Onion.Tofu.Pumpkin.BambooShoot))
    iRetCode = 0;
  RemoveName();
  AddName("Aniseed");
  AddName("Fennell");
  if (!CheckULong(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Fennell))
    iRetCode = 0;
  RemoveName();
  AddName("Celery");
  AddName("Pineapple");
  if (!CheckUShort(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Pineapple))
    iRetCode = 0;
  RemoveName();
  AddName("Parsnip");
  AddName("Radish");
  if (!CheckChar(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Radish))
    iRetCode = 0;
  RemoveName();
  AddName("Asparagus");
  AddName("Damsons");
  if (!CheckBoolean(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Damsons))
    iRetCode = 0;
  RemoveName();
  AddName("Mint");
  AddName("Mullberry");
  if (!CheckOctet(v.Plum.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Mint.Mullberry))
    iRetCode = 0;
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetAvocadoMango(::Avocado::Mango &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAvocadoMango");
#endif

  GetFloat(v.ButterBean);
  GetDouble(v.Onion.Cinnamon);
  GetLong(v.Onion.Tofu.BreadFruit);
  GetShort(v.Onion.Tofu.Pumpkin.BambooShoot);
  GetULong(v.Onion.Tofu.Pumpkin.Aniseed.Fennell);
  GetUShort(v.Onion.Tofu.Pumpkin.Aniseed.Celery.Pineapple);
  GetChar(v.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Radish);
  GetBoolean(v.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Damsons);
  GetOctet(v.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Mint.Mullberry);
}

int CheckAvocadoMango(const ::Avocado::Mango &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAvocadoMango");
#endif

  AddName("ButterBean");
  if (!CheckFloat(v.ButterBean))
    iRetCode = 0;
  RemoveName();
  AddName("Onion");
  AddName("Cinnamon");
  if (!CheckDouble(v.Onion.Cinnamon))
    iRetCode = 0;
  RemoveName();
  AddName("Tofu");
  AddName("BreadFruit");
  if (!CheckLong(v.Onion.Tofu.BreadFruit))
    iRetCode = 0;
  RemoveName();
  AddName("Pumpkin");
  AddName("BambooShoot");
  if (!CheckShort(v.Onion.Tofu.Pumpkin.BambooShoot))
    iRetCode = 0;
  RemoveName();
  AddName("Aniseed");
  AddName("Fennell");
  if (!CheckULong(v.Onion.Tofu.Pumpkin.Aniseed.Fennell))
    iRetCode = 0;
  RemoveName();
  AddName("Celery");
  AddName("Pineapple");
  if (!CheckUShort(v.Onion.Tofu.Pumpkin.Aniseed.Celery.Pineapple))
    iRetCode = 0;
  RemoveName();
  AddName("Parsnip");
  AddName("Radish");
  if (!CheckChar(v.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Radish))
    iRetCode = 0;
  RemoveName();
  AddName("Asparagus");
  AddName("Damsons");
  if (!CheckBoolean(v.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Damsons))
    iRetCode = 0;
  RemoveName();
  AddName("Mint");
  AddName("Mullberry");
  if (!CheckOctet(v.Onion.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Mint.Mullberry))
    iRetCode = 0;
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetAvocadoMangoStarfruit(::Avocado::Mango::Starfruit &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAvocadoMangoStarfruit");
#endif

  GetDouble(v.Cinnamon);
  GetLong(v.Tofu.BreadFruit);
  GetShort(v.Tofu.Pumpkin.BambooShoot);
  GetULong(v.Tofu.Pumpkin.Aniseed.Fennell);
  GetUShort(v.Tofu.Pumpkin.Aniseed.Celery.Pineapple);
  GetChar(v.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Radish);
  GetBoolean(v.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Damsons);
  GetOctet(v.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Mint.Mullberry);
}

int CheckAvocadoMangoStarfruit(const ::Avocado::Mango::Starfruit &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAvocadoMangoStarfruit");
#endif

  AddName("Cinnamon");
  if (!CheckDouble(v.Cinnamon))
    iRetCode = 0;
  RemoveName();
  AddName("Tofu");
  AddName("BreadFruit");
  if (!CheckLong(v.Tofu.BreadFruit))
    iRetCode = 0;
  RemoveName();
  AddName("Pumpkin");
  AddName("BambooShoot");
  if (!CheckShort(v.Tofu.Pumpkin.BambooShoot))
    iRetCode = 0;
  RemoveName();
  AddName("Aniseed");
  AddName("Fennell");
  if (!CheckULong(v.Tofu.Pumpkin.Aniseed.Fennell))
    iRetCode = 0;
  RemoveName();
  AddName("Celery");
  AddName("Pineapple");
  if (!CheckUShort(v.Tofu.Pumpkin.Aniseed.Celery.Pineapple))
    iRetCode = 0;
  RemoveName();
  AddName("Parsnip");
  AddName("Radish");
  if (!CheckChar(v.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Radish))
    iRetCode = 0;
  RemoveName();
  AddName("Asparagus");
  AddName("Damsons");
  if (!CheckBoolean(v.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Damsons))
    iRetCode = 0;
  RemoveName();
  AddName("Mint");
  AddName("Mullberry");
  if (!CheckOctet(v.Tofu.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Mint.Mullberry))
    iRetCode = 0;
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetAvocadoMangoStarfruitDates(::Avocado::Mango::Starfruit::Dates &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAvocadoMangoStarfruitDates");
#endif

  GetLong(v.BreadFruit);
  GetShort(v.Pumpkin.BambooShoot);
  GetULong(v.Pumpkin.Aniseed.Fennell);
  GetUShort(v.Pumpkin.Aniseed.Celery.Pineapple);
  GetChar(v.Pumpkin.Aniseed.Celery.Parsnip.Radish);
  GetBoolean(v.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Damsons);
  GetOctet(v.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Mint.Mullberry);
}

int CheckAvocadoMangoStarfruitDates(const ::Avocado::Mango::Starfruit::Dates &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAvocadoMangoStarfruitDates");
#endif

  AddName("BreadFruit");
  if (!CheckLong(v.BreadFruit))
    iRetCode = 0;
  RemoveName();
  AddName("Pumpkin");
  AddName("BambooShoot");
  if (!CheckShort(v.Pumpkin.BambooShoot))
    iRetCode = 0;
  RemoveName();
  AddName("Aniseed");
  AddName("Fennell");
  if (!CheckULong(v.Pumpkin.Aniseed.Fennell))
    iRetCode = 0;
  RemoveName();
  AddName("Celery");
  AddName("Pineapple");
  if (!CheckUShort(v.Pumpkin.Aniseed.Celery.Pineapple))
    iRetCode = 0;
  RemoveName();
  AddName("Parsnip");
  AddName("Radish");
  if (!CheckChar(v.Pumpkin.Aniseed.Celery.Parsnip.Radish))
    iRetCode = 0;
  RemoveName();
  AddName("Asparagus");
  AddName("Damsons");
  if (!CheckBoolean(v.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Damsons))
    iRetCode = 0;
  RemoveName();
  AddName("Mint");
  AddName("Mullberry");
  if (!CheckOctet(v.Pumpkin.Aniseed.Celery.Parsnip.Asparagus.Mint.Mullberry))
    iRetCode = 0;
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetAvocadoMangoStarfruitDatesLime(::Avocado::Mango::Starfruit::Dates::Lime &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAvocadoMangoStarfruitDatesLime");
#endif

  GetShort(v.BambooShoot);
  GetULong(v.Aniseed.Fennell);
  GetUShort(v.Aniseed.Celery.Pineapple);
  GetChar(v.Aniseed.Celery.Parsnip.Radish);
  GetBoolean(v.Aniseed.Celery.Parsnip.Asparagus.Damsons);
  GetOctet(v.Aniseed.Celery.Parsnip.Asparagus.Mint.Mullberry);
}

int CheckAvocadoMangoStarfruitDatesLime(const ::Avocado::Mango::Starfruit::Dates::Lime &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAvocadoMangoStarfruitDatesLime");
#endif

  AddName("BambooShoot");
  if (!CheckShort(v.BambooShoot))
    iRetCode = 0;
  RemoveName();
  AddName("Aniseed");
  AddName("Fennell");
  if (!CheckULong(v.Aniseed.Fennell))
    iRetCode = 0;
  RemoveName();
  AddName("Celery");
  AddName("Pineapple");
  if (!CheckUShort(v.Aniseed.Celery.Pineapple))
    iRetCode = 0;
  RemoveName();
  AddName("Parsnip");
  AddName("Radish");
  if (!CheckChar(v.Aniseed.Celery.Parsnip.Radish))
    iRetCode = 0;
  RemoveName();
  AddName("Asparagus");
  AddName("Damsons");
  if (!CheckBoolean(v.Aniseed.Celery.Parsnip.Asparagus.Damsons))
    iRetCode = 0;
  RemoveName();
  AddName("Mint");
  AddName("Mullberry");
  if (!CheckOctet(v.Aniseed.Celery.Parsnip.Asparagus.Mint.Mullberry))
    iRetCode = 0;
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetAvocadoMangoStarfruitDatesLimeLeek(::Avocado::Mango::Starfruit::Dates::Lime::Leek &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAvocadoMangoStarfruitDatesLimeLeek");
#endif

  GetULong(v.Fennell);
  GetUShort(v.Celery.Pineapple);
  GetChar(v.Celery.Parsnip.Radish);
  GetBoolean(v.Celery.Parsnip.Asparagus.Damsons);
  GetOctet(v.Celery.Parsnip.Asparagus.Mint.Mullberry);
}

int CheckAvocadoMangoStarfruitDatesLimeLeek(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAvocadoMangoStarfruitDatesLimeLeek");
#endif

  AddName("Fennell");
  if (!CheckULong(v.Fennell))
    iRetCode = 0;
  RemoveName();
  AddName("Celery");
  AddName("Pineapple");
  if (!CheckUShort(v.Celery.Pineapple))
    iRetCode = 0;
  RemoveName();
  AddName("Parsnip");
  AddName("Radish");
  if (!CheckChar(v.Celery.Parsnip.Radish))
    iRetCode = 0;
  RemoveName();
  AddName("Asparagus");
  AddName("Damsons");
  if (!CheckBoolean(v.Celery.Parsnip.Asparagus.Damsons))
    iRetCode = 0;
  RemoveName();
  AddName("Mint");
  AddName("Mullberry");
  if (!CheckOctet(v.Celery.Parsnip.Asparagus.Mint.Mullberry))
    iRetCode = 0;
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetAvocadoMangoStarfruitDatesLimeLeekGinger(::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAvocadoMangoStarfruitDatesLimeLeekGinger");
#endif

  GetUShort(v.Pineapple);
  GetChar(v.Parsnip.Radish);
  GetBoolean(v.Parsnip.Asparagus.Damsons);
  GetOctet(v.Parsnip.Asparagus.Mint.Mullberry);
}

int CheckAvocadoMangoStarfruitDatesLimeLeekGinger(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAvocadoMangoStarfruitDatesLimeLeekGinger");
#endif

  AddName("Pineapple");
  if (!CheckUShort(v.Pineapple))
    iRetCode = 0;
  RemoveName();
  AddName("Parsnip");
  AddName("Radish");
  if (!CheckChar(v.Parsnip.Radish))
    iRetCode = 0;
  RemoveName();
  AddName("Asparagus");
  AddName("Damsons");
  if (!CheckBoolean(v.Parsnip.Asparagus.Damsons))
    iRetCode = 0;
  RemoveName();
  AddName("Mint");
  AddName("Mullberry");
  if (!CheckOctet(v.Parsnip.Asparagus.Mint.Mullberry))
    iRetCode = 0;
  RemoveName();
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetAvocadoMangoStarfruitDatesLimeLeekGingerMint(::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAvocadoMangoStarfruitDatesLimeLeekGingerMint");
#endif

  GetChar(v.Radish);
  GetBoolean(v.Asparagus.Damsons);
  GetOctet(v.Asparagus.Mint.Mullberry);
}

int CheckAvocadoMangoStarfruitDatesLimeLeekGingerMint(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAvocadoMangoStarfruitDatesLimeLeekGingerMint");
#endif

  AddName("Radish");
  if (!CheckChar(v.Radish))
    iRetCode = 0;
  RemoveName();
  AddName("Asparagus");
  AddName("Damsons");
  if (!CheckBoolean(v.Asparagus.Damsons))
    iRetCode = 0;
  RemoveName();
  AddName("Mint");
  AddName("Mullberry");
  if (!CheckOctet(v.Asparagus.Mint.Mullberry))
    iRetCode = 0;
  RemoveName();
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas(::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas");
#endif

  GetBoolean(v.Damsons);
  GetOctet(v.Mint.Mullberry);
}

int CheckAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas");
#endif

  AddName("Damsons");
  if (!CheckBoolean(v.Damsons))
    iRetCode = 0;
  RemoveName();
  AddName("Mint");
  AddName("Mullberry");
  if (!CheckOctet(v.Mint.Mullberry))
    iRetCode = 0;
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana(::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana &v)
{
#ifdef DEBUG
  ::tet_infoline("GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana");
#endif

  GetOctet(v.Mullberry);
}

int CheckAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana");
#endif

  AddName("Mullberry");
  if (!CheckOctet(v.Mullberry))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerBananaExcpt(::idlServer::BananaExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerBananaExcpt");
#endif

  GetBanana(v.ex1);
}

int CheckidlServerBananaExcpt(const ::idlServer::BananaExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerBananaExcpt");
#endif

  AddName("ex1");
  if (!CheckBanana(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerAvocadoExcpt(::idlServer::AvocadoExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerAvocadoExcpt");
#endif

  GetAvocado(v.ex1);
}

int CheckidlServerAvocadoExcpt(const ::idlServer::AvocadoExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerAvocadoExcpt");
#endif

  AddName("ex1");
  if (!CheckAvocado(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerMangoExcpt(::idlServer::MangoExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerMangoExcpt");
#endif

  GetAvocadoMango(v.ex1);
}

int CheckidlServerMangoExcpt(const ::idlServer::MangoExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerMangoExcpt");
#endif

  AddName("ex1");
  if (!CheckAvocadoMango(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerStarfruitExcpt(::idlServer::StarfruitExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerStarfruitExcpt");
#endif

  GetAvocadoMangoStarfruit(v.ex1);
}

int CheckidlServerStarfruitExcpt(const ::idlServer::StarfruitExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerStarfruitExcpt");
#endif

  AddName("ex1");
  if (!CheckAvocadoMangoStarfruit(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerDatesExcpt(::idlServer::DatesExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerDatesExcpt");
#endif

  GetAvocadoMangoStarfruitDates(v.ex1);
}

int CheckidlServerDatesExcpt(const ::idlServer::DatesExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerDatesExcpt");
#endif

  AddName("ex1");
  if (!CheckAvocadoMangoStarfruitDates(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerLimeExcpt(::idlServer::LimeExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerLimeExcpt");
#endif

  GetAvocadoMangoStarfruitDatesLime(v.ex1);
}

int CheckidlServerLimeExcpt(const ::idlServer::LimeExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerLimeExcpt");
#endif

  AddName("ex1");
  if (!CheckAvocadoMangoStarfruitDatesLime(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerLeekExcpt(::idlServer::LeekExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerLeekExcpt");
#endif

  GetAvocadoMangoStarfruitDatesLimeLeek(v.ex1);
}

int CheckidlServerLeekExcpt(const ::idlServer::LeekExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerLeekExcpt");
#endif

  AddName("ex1");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeek(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerGingerExcpt(::idlServer::GingerExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerGingerExcpt");
#endif

  GetAvocadoMangoStarfruitDatesLimeLeekGinger(v.ex1);
}

int CheckidlServerGingerExcpt(const ::idlServer::GingerExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerGingerExcpt");
#endif

  AddName("ex1");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGinger(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerMintExcpt(::idlServer::MintExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerMintExcpt");
#endif

  GetAvocadoMangoStarfruitDatesLimeLeekGingerMint(v.ex1);
}

int CheckidlServerMintExcpt(const ::idlServer::MintExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerMintExcpt");
#endif

  AddName("ex1");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGingerMint(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerGardenPeasExcpt(::idlServer::GardenPeasExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerGardenPeasExcpt");
#endif

  GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas(v.ex1);
}

int CheckidlServerGardenPeasExcpt(const ::idlServer::GardenPeasExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerGardenPeasExcpt");
#endif

  AddName("ex1");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerSultanaExcpt(::idlServer::SultanaExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerSultanaExcpt");
#endif

  GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana(v.ex1);
}

int CheckidlServerSultanaExcpt(const ::idlServer::SultanaExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerSultanaExcpt");
#endif

  AddName("ex1");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



