//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Banana
idlServer_imp::BananaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Banana ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BananaAttr\n");
#endif
  
  ernie.seed("BananaAttrCall");
  
  ernie.seed("BananaAttrReturn"); 
  
  GetBanana(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BananaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BananaAttr(const ::Banana &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BananaAttr\n");
#endif
  
  ernie.seed("BananaAttrCall");
  AddName("_attr");
  if (!CheckBanana(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BananaAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BananaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Banana
idlServer_imp::BananaOp(const ::Banana &p1,::Banana &p2,::Banana &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Banana ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BananaOp\n");
#endif
  
  ernie.seed("BananaOpCall");
  AddName("p1");
  if (!CheckBanana(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBanana(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BananaOpReturn"); 
  {
    ::idlServer::BananaExcpt ex;
    GetidlServerBananaExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetBanana(ReturnValue);
  GetBanana(p2);
  GetBanana(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BananaOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Avocado
idlServer_imp::AvocadoAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoAttr\n");
#endif
  
  ernie.seed("AvocadoAttrCall");
  
  ernie.seed("AvocadoAttrReturn"); 
  
  GetAvocado(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::AvocadoAttr(const ::Avocado &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoAttr\n");
#endif
  
  ernie.seed("AvocadoAttrCall");
  AddName("_attr");
  if (!CheckAvocado(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AvocadoAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Avocado
idlServer_imp::AvocadoOp(const ::Avocado &p1,::Avocado &p2,::Avocado &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Avocado ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoOp\n");
#endif
  
  ernie.seed("AvocadoOpCall");
  AddName("p1");
  if (!CheckAvocado(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAvocado(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AvocadoOpReturn"); 
  {
    ::idlServer::AvocadoExcpt ex;
    GetidlServerAvocadoExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetAvocado(ReturnValue);
  GetAvocado(p2);
  GetAvocado(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Avocado::Mango
idlServer_imp::MangoAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MangoAttr\n");
#endif
  
  ernie.seed("MangoAttrCall");
  
  ernie.seed("MangoAttrReturn"); 
  
  GetAvocadoMango(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MangoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::MangoAttr(const ::Avocado::Mango &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MangoAttr\n");
#endif
  
  ernie.seed("MangoAttrCall");
  AddName("_attr");
  if (!CheckAvocadoMango(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MangoAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MangoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Avocado::Mango
idlServer_imp::MangoOp(const ::Avocado::Mango &p1,::Avocado::Mango &p2,::Avocado::Mango &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MangoOp\n");
#endif
  
  ernie.seed("MangoOpCall");
  AddName("p1");
  if (!CheckAvocadoMango(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAvocadoMango(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MangoOpReturn"); 
  {
    ::idlServer::MangoExcpt ex;
    GetidlServerMangoExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetAvocadoMango(ReturnValue);
  GetAvocadoMango(p2);
  GetAvocadoMango(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MangoOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Avocado::Mango::Starfruit
idlServer_imp::StarfruitAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::StarfruitAttr\n");
#endif
  
  ernie.seed("StarfruitAttrCall");
  
  ernie.seed("StarfruitAttrReturn"); 
  
  GetAvocadoMangoStarfruit(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::StarfruitAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::StarfruitAttr(const ::Avocado::Mango::Starfruit &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::StarfruitAttr\n");
#endif
  
  ernie.seed("StarfruitAttrCall");
  AddName("_attr");
  if (!CheckAvocadoMangoStarfruit(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("StarfruitAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::StarfruitAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Avocado::Mango::Starfruit
idlServer_imp::StarfruitOp(const ::Avocado::Mango::Starfruit &p1,::Avocado::Mango::Starfruit &p2,::Avocado::Mango::Starfruit &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::StarfruitOp\n");
#endif
  
  ernie.seed("StarfruitOpCall");
  AddName("p1");
  if (!CheckAvocadoMangoStarfruit(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAvocadoMangoStarfruit(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("StarfruitOpReturn"); 
  {
    ::idlServer::StarfruitExcpt ex;
    GetidlServerStarfruitExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetAvocadoMangoStarfruit(ReturnValue);
  GetAvocadoMangoStarfruit(p2);
  GetAvocadoMangoStarfruit(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::StarfruitOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Avocado::Mango::Starfruit::Dates
idlServer_imp::DatesAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit::Dates ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::DatesAttr\n");
#endif
  
  ernie.seed("DatesAttrCall");
  
  ernie.seed("DatesAttrReturn"); 
  
  GetAvocadoMangoStarfruitDates(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::DatesAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::DatesAttr(const ::Avocado::Mango::Starfruit::Dates &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::DatesAttr\n");
#endif
  
  ernie.seed("DatesAttrCall");
  AddName("_attr");
  if (!CheckAvocadoMangoStarfruitDates(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("DatesAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::DatesAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Avocado::Mango::Starfruit::Dates
idlServer_imp::DatesOp(const ::Avocado::Mango::Starfruit::Dates &p1,::Avocado::Mango::Starfruit::Dates &p2,::Avocado::Mango::Starfruit::Dates &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit::Dates ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::DatesOp\n");
#endif
  
  ernie.seed("DatesOpCall");
  AddName("p1");
  if (!CheckAvocadoMangoStarfruitDates(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAvocadoMangoStarfruitDates(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("DatesOpReturn"); 
  {
    ::idlServer::DatesExcpt ex;
    GetidlServerDatesExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetAvocadoMangoStarfruitDates(ReturnValue);
  GetAvocadoMangoStarfruitDates(p2);
  GetAvocadoMangoStarfruitDates(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::DatesOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Avocado::Mango::Starfruit::Dates::Lime
idlServer_imp::LimeAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit::Dates::Lime ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LimeAttr\n");
#endif
  
  ernie.seed("LimeAttrCall");
  
  ernie.seed("LimeAttrReturn"); 
  
  GetAvocadoMangoStarfruitDatesLime(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LimeAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::LimeAttr(const ::Avocado::Mango::Starfruit::Dates::Lime &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LimeAttr\n");
#endif
  
  ernie.seed("LimeAttrCall");
  AddName("_attr");
  if (!CheckAvocadoMangoStarfruitDatesLime(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LimeAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LimeAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Avocado::Mango::Starfruit::Dates::Lime
idlServer_imp::LimeOp(const ::Avocado::Mango::Starfruit::Dates::Lime &p1,::Avocado::Mango::Starfruit::Dates::Lime &p2,::Avocado::Mango::Starfruit::Dates::Lime &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit::Dates::Lime ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LimeOp\n");
#endif
  
  ernie.seed("LimeOpCall");
  AddName("p1");
  if (!CheckAvocadoMangoStarfruitDatesLime(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAvocadoMangoStarfruitDatesLime(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LimeOpReturn"); 
  {
    ::idlServer::LimeExcpt ex;
    GetidlServerLimeExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetAvocadoMangoStarfruitDatesLime(ReturnValue);
  GetAvocadoMangoStarfruitDatesLime(p2);
  GetAvocadoMangoStarfruitDatesLime(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LimeOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Avocado::Mango::Starfruit::Dates::Lime::Leek
idlServer_imp::LeekAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LeekAttr\n");
#endif
  
  ernie.seed("LeekAttrCall");
  
  ernie.seed("LeekAttrReturn"); 
  
  GetAvocadoMangoStarfruitDatesLimeLeek(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LeekAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::LeekAttr(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LeekAttr\n");
#endif
  
  ernie.seed("LeekAttrCall");
  AddName("_attr");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeek(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LeekAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LeekAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Avocado::Mango::Starfruit::Dates::Lime::Leek
idlServer_imp::LeekOp(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek &p1,::Avocado::Mango::Starfruit::Dates::Lime::Leek &p2,::Avocado::Mango::Starfruit::Dates::Lime::Leek &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::LeekOp\n");
#endif
  
  ernie.seed("LeekOpCall");
  AddName("p1");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeek(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeek(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LeekOpReturn"); 
  {
    ::idlServer::LeekExcpt ex;
    GetidlServerLeekExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetAvocadoMangoStarfruitDatesLimeLeek(ReturnValue);
  GetAvocadoMangoStarfruitDatesLimeLeek(p2);
  GetAvocadoMangoStarfruitDatesLimeLeek(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::LeekOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger
idlServer_imp::GingerAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GingerAttr\n");
#endif
  
  ernie.seed("GingerAttrCall");
  
  ernie.seed("GingerAttrReturn"); 
  
  GetAvocadoMangoStarfruitDatesLimeLeekGinger(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GingerAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::GingerAttr(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GingerAttr\n");
#endif
  
  ernie.seed("GingerAttrCall");
  AddName("_attr");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGinger(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GingerAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GingerAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger
idlServer_imp::GingerOp(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger &p1,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger &p2,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GingerOp\n");
#endif
  
  ernie.seed("GingerOpCall");
  AddName("p1");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGinger(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGinger(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GingerOpReturn"); 
  {
    ::idlServer::GingerExcpt ex;
    GetidlServerGingerExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetAvocadoMangoStarfruitDatesLimeLeekGinger(ReturnValue);
  GetAvocadoMangoStarfruitDatesLimeLeekGinger(p2);
  GetAvocadoMangoStarfruitDatesLimeLeekGinger(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GingerOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint
idlServer_imp::MintAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MintAttr\n");
#endif
  
  ernie.seed("MintAttrCall");
  
  ernie.seed("MintAttrReturn"); 
  
  GetAvocadoMangoStarfruitDatesLimeLeekGingerMint(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MintAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::MintAttr(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MintAttr\n");
#endif
  
  ernie.seed("MintAttrCall");
  AddName("_attr");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGingerMint(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MintAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MintAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint
idlServer_imp::MintOp(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint &p1,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint &p2,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::MintOp\n");
#endif
  
  ernie.seed("MintOpCall");
  AddName("p1");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGingerMint(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGingerMint(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MintOpReturn"); 
  {
    ::idlServer::MintExcpt ex;
    GetidlServerMintExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetAvocadoMangoStarfruitDatesLimeLeekGingerMint(ReturnValue);
  GetAvocadoMangoStarfruitDatesLimeLeekGingerMint(p2);
  GetAvocadoMangoStarfruitDatesLimeLeekGingerMint(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::MintOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas
idlServer_imp::GardenPeasAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GardenPeasAttr\n");
#endif
  
  ernie.seed("GardenPeasAttrCall");
  
  ernie.seed("GardenPeasAttrReturn"); 
  
  GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GardenPeasAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::GardenPeasAttr(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GardenPeasAttr\n");
#endif
  
  ernie.seed("GardenPeasAttrCall");
  AddName("_attr");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GardenPeasAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GardenPeasAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas
idlServer_imp::GardenPeasOp(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas &p1,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas &p2,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GardenPeasOp\n");
#endif
  
  ernie.seed("GardenPeasOpCall");
  AddName("p1");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GardenPeasOpReturn"); 
  {
    ::idlServer::GardenPeasExcpt ex;
    GetidlServerGardenPeasExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas(ReturnValue);
  GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas(p2);
  GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GardenPeasOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana
idlServer_imp::SultanaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SultanaAttr\n");
#endif
  
  ernie.seed("SultanaAttrCall");
  
  ernie.seed("SultanaAttrReturn"); 
  
  GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SultanaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::SultanaAttr(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SultanaAttr\n");
#endif
  
  ernie.seed("SultanaAttrCall");
  AddName("_attr");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SultanaAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SultanaAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana
idlServer_imp::SultanaOp(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana &p1,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana &p2,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::SultanaOp\n");
#endif
  
  ernie.seed("SultanaOpCall");
  AddName("p1");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SultanaOpReturn"); 
  {
    ::idlServer::SultanaExcpt ex;
    GetidlServerSultanaExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana(ReturnValue);
  GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana(p2);
  GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::SultanaOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



