//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Broadbeans
idlServer_imp::BroadbeansAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  
  ::Broadbeans ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BroadbeansAttr\n");
#endif
  
  ernie.seed("BroadbeansAttrCall");
  
  ernie.seed("BroadbeansAttrReturn"); 
  
  GetBroadbeans(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BroadbeansAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BroadbeansAttr(const ::Broadbeans &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BroadbeansAttr\n");
#endif
  
  ernie.seed("BroadbeansAttrCall");
  AddName("_attr");
  if (!CheckBroadbeans(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BroadbeansAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BroadbeansAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Broadbeans
idlServer_imp::BroadbeansOp(const ::Broadbeans &p1,::Broadbeans &p2,::Broadbeans &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  
  ::Broadbeans ReturnValue;
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BroadbeansOp\n");
#endif
  
  ernie.seed("BroadbeansOpCall");
  AddName("p1");
  if (!CheckBroadbeans(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBroadbeans(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BroadbeansOpReturn"); 
  {
    ::idlServer::BroadbeansExcpt ex;
    GetidlServerBroadbeansExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetBroadbeans(ReturnValue);
  GetBroadbeans(p2);
  GetBroadbeans(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BroadbeansOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Orange
idlServer_imp::OrangeAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  
  ::Orange ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::OrangeAttr\n");
#endif
  
  ernie.seed("OrangeAttrCall");
  
  ernie.seed("OrangeAttrReturn"); 
  
  GetOrange(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::OrangeAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::OrangeAttr(const ::Orange &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::OrangeAttr\n");
#endif
  
  ernie.seed("OrangeAttrCall");
  AddName("_attr");
  if (!CheckOrange(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("OrangeAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::OrangeAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Orange
idlServer_imp::OrangeOp(const ::Orange &p1,::Orange &p2,::Orange &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  
  ::Orange ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::OrangeOp\n");
#endif
  
  ernie.seed("OrangeOpCall");
  AddName("p1");
  if (!CheckOrange(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckOrange(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("OrangeOpReturn"); 
  {
    ::idlServer::OrangeExcpt ex;
    GetidlServerOrangeExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetOrange(ReturnValue);
  GetOrange(p2);
  GetOrange(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::OrangeOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



