//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:17:06  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1999/04/26 13:52:38  james
// Changed CORBA::Char* to char*
//
// Revision 1.6  1998/08/24 11:47:28  james
// ENV updates
//
// Revision 1.5  1997/12/15 10:52:08  james
// #ifdefs removed
//
// Revision 1.4  1997/12/09 11:29:58  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetBroadbeans(::Broadbeans &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBroadbeans");
#endif

  {
    int vSelection;
    ::Broadbeans::Fennell vArray[8] = {::Broadbeans::UgliFruit,::Broadbeans::Chickpea,::Broadbeans::Waterchestnut,::Broadbeans::BambooShoot,::Broadbeans::BeechNut,::Broadbeans::Sweetcorn,::Broadbeans::LolloRossa,::Broadbeans::CantelopeMelon};
    
    vSelection = ernie.getULong() % 8;
    switch (vSelection) {
      case 0 :
              {
                CORBA::Float _value2;
                
                GetFloat(_value2);
                v. ButterBean(_value2);
              }
              break;
      case 1 :
              {
                CORBA::ULong _value2;
                
                GetULong(_value2);
                v. Fig(_value2);
              }
              break;
      case 2 :
              {
                CORBA::Double _value2;
                
                GetDouble(_value2);
                v. Cinnamon(_value2);
              }
              break;
      case 3 :
              {
                CORBA::Long _value2;
                
                GetLong(_value2);
                v. BreadFruit(_value2);
              }
              break;
      case 4 :
              {
                CORBA::Long _value2;
                
                GetLong(_value2);
                v. Tarragon(_value2);
              }
              break;
      case 5 :
              {
                CORBA::UShort _value2;
                
                GetUShort(_value2);
                v. Pineapple(_value2);
              }
              break;
      case 6 :
              {
                CORBA::UShort _value2;
                
                GetUShort(_value2);
                v. RedPepper(_value2);
              }
              break;
      case 7 :
              {
                CORBA::Char _value2;
                
                GetChar(_value2);
                v. Radish(_value2);
              }
              break;
    }
    v._d(vArray[vSelection]);
  }
}

int CheckBroadbeans(const ::Broadbeans &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBroadbeans");
#endif

  {
    int vSelection;
    ::Broadbeans::Fennell vArray[8] = {::Broadbeans::UgliFruit,::Broadbeans::Chickpea,::Broadbeans::Waterchestnut,::Broadbeans::BambooShoot,::Broadbeans::BeechNut,::Broadbeans::Sweetcorn,::Broadbeans::LolloRossa,::Broadbeans::CantelopeMelon};
    
    vSelection = ernie.getULong() % 8;
    
    if (v._d() != vArray[vSelection])
    {
      ::tet_printf("ERROR: %s has an incorrect discriminator",name);
      iRetCode = 0;
    }
    switch (vSelection) {
      case 0 :
              AddName("ButterBean()");
              if (!CheckFloat(v.ButterBean()))
                iRetCode = 0;
              RemoveName();
              break;
      case 1 :
              AddName("Fig()");
              if (!CheckULong(v.Fig()))
                iRetCode = 0;
              RemoveName();
              break;
      case 2 :
              AddName("Cinnamon()");
              if (!CheckDouble(v.Cinnamon()))
                iRetCode = 0;
              RemoveName();
              break;
      case 3 :
              AddName("BreadFruit()");
              if (!CheckLong(v.BreadFruit()))
                iRetCode = 0;
              RemoveName();
              break;
      case 4 :
              AddName("Tarragon()");
              if (!CheckLong(v.Tarragon()))
                iRetCode = 0;
              RemoveName();
              break;
      case 5 :
              AddName("Pineapple()");
              if (!CheckUShort(v.Pineapple()))
                iRetCode = 0;
              RemoveName();
              break;
      case 6 :
              AddName("RedPepper()");
              if (!CheckUShort(v.RedPepper()))
                iRetCode = 0;
              RemoveName();
              break;
      case 7 :
              AddName("Radish()");
              if (!CheckChar(v.Radish()))
                iRetCode = 0;
              RemoveName();
              break;
    }
  }
  return iRetCode;
}

 
void GetBroadbeansFennell(::Broadbeans::Fennell &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBroadbeansFennell");
#endif

  ::Broadbeans::Fennell FennellArray[13] = {::Broadbeans::UgliFruit,::Broadbeans::Chickpea,::Broadbeans::Waterchestnut,::Broadbeans::Cress,::Broadbeans::BambooShoot,::Broadbeans::BeechNut,::Broadbeans::KidneyBean,::Broadbeans::Onion,::Broadbeans::Sweetcorn,::Broadbeans::LolloRossa,::Broadbeans::CantelopeMelon,::Broadbeans::Zucchini,::Broadbeans::Shallots};
  v = FennellArray[ernie.getULong()%13];
}

int CheckBroadbeansFennell(const ::Broadbeans::Fennell &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBroadbeansFennell");
#endif

  ::Broadbeans::Fennell FennellArray[13] = {::Broadbeans::UgliFruit,::Broadbeans::Chickpea,::Broadbeans::Waterchestnut,::Broadbeans::Cress,::Broadbeans::BambooShoot,::Broadbeans::BeechNut,::Broadbeans::KidneyBean,::Broadbeans::Onion,::Broadbeans::Sweetcorn,::Broadbeans::LolloRossa,::Broadbeans::CantelopeMelon,::Broadbeans::Zucchini,::Broadbeans::Shallots};
  if (v != FennellArray[ernie.getULong()%13])
  {
    ::tet_printf("ERROR: %s has incorrect value",name);
    ::tet_printf("Expected %d, but found %d instead", FennellArray[ernie.getULongAgain()%13],v);
    iRetCode = 0;
  }
  return iRetCode;
}

 
void GetidlServerBroadbeansExcpt(::idlServer::BroadbeansExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerBroadbeansExcpt");
#endif

  GetBroadbeans(v.ex1);
}

int CheckidlServerBroadbeansExcpt(const ::idlServer::BroadbeansExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerBroadbeansExcpt");
#endif

  AddName("ex1");
  if (!CheckBroadbeans(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerFennellExcpt(::idlServer::FennellExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerFennellExcpt");
#endif

  GetBroadbeansFennell(v.ex1);
}

int CheckidlServerFennellExcpt(const ::idlServer::FennellExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerFennellExcpt");
#endif

  AddName("ex1");
  if (!CheckBroadbeansFennell(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



