//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;
 


::Apple
idlServer_imp::AppleAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Apple ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AppleAttr\n");
#endif
  
  ernie.seed("AppleAttrCall");
  
  ernie.seed("AppleAttrReturn"); 
  
  GetApple(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AppleAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::AppleAttr(::Apple _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AppleAttr\n");
#endif
  
  ernie.seed("AppleAttrCall");
  AddName("_attr");
  if (!CheckApple(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AppleAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AppleAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Apple
idlServer_imp::AppleOp(::Apple p1,::Apple &p2,::Apple &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Apple ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AppleOp\n");
#endif
  
  ernie.seed("AppleOpCall");
  AddName("p1");
  if (!CheckApple(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckApple(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AppleOpReturn"); 
  {
    ::idlServer::AppleExcpt ex;
    GetidlServerAppleExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetApple(ReturnValue);
  GetApple(p2);
  GetApple(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AppleOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Broadbeans
idlServer_imp::BroadbeansAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  
  ::Broadbeans ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BroadbeansAttr\n");
#endif
  
  ernie.seed("BroadbeansAttrCall");
  
  ernie.seed("BroadbeansAttrReturn"); 
  
  GetBroadbeans(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BroadbeansAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BroadbeansAttr(const ::Broadbeans &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BroadbeansAttr\n");
#endif
  
  ernie.seed("BroadbeansAttrCall");
  AddName("_attr");
  if (!CheckBroadbeans(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BroadbeansAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BroadbeansAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Broadbeans
idlServer_imp::BroadbeansOp(const ::Broadbeans &p1,::Broadbeans &p2,::Broadbeans &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  
  ::Broadbeans ReturnValue;
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BroadbeansOp\n");
#endif
  
  ernie.seed("BroadbeansOpCall");
  AddName("p1");
  if (!CheckBroadbeans(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBroadbeans(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BroadbeansOpReturn"); 
  {
    ::idlServer::BroadbeansExcpt ex;
    GetidlServerBroadbeansExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetBroadbeans(ReturnValue);
  GetBroadbeans(p2);
  GetBroadbeans(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BroadbeansOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



