//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:17:08  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1999/04/26 13:52:43  james
// Changed CORBA::Char* to char*
//
// Revision 1.6  1998/08/24 14:26:24  james
// Scope added
//
// Revision 1.5  1997/12/15 10:52:09  james
// #ifdefs removed
//
// Revision 1.4  1997/12/09 11:30:10  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetBroadbeans(::Broadbeans &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBroadbeans");
#endif

  {
    int vSelection;
    CORBA::Long vArray[3] = {521,45,72};
    
    vSelection = ernie.getULong() % 3;
    switch (vSelection) {
      case 0 :
              {
                ::Broadbeans::Avocado _value2;
                
                GetFloat(_value2.ButterBean);
                v. Banana(_value2);
              }
              break;
      case 1 :
              {
                ::Broadbeans::GalaApple _value2;
                
                GetFloat(_value2.ButterBean);
                GetFloat(_value2.ChestNut);
                GetFloat(_value2.Currant);
                GetFloat(_value2.CoxPippin);
                GetFloat(_value2.Chervil);
                GetFloat(_value2.Scallion);
                GetFloat(_value2.Tomato);
                v. Orange(_value2);
              }
              break;
      case 2 :
              {
                CORBA::Octet _value2;
                
                GetOctet(_value2);
                v. Corn(_value2);
              }
              break;
    }
    v._d(vArray[vSelection]);
  }
}

int CheckBroadbeans(const ::Broadbeans &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBroadbeans");
#endif

  {
    int vSelection;
    CORBA::Long vArray[3] = {521,45,72};
    
    vSelection = ernie.getULong() % 3;
    
    if (v._d() != vArray[vSelection])
    {
      ::tet_printf("ERROR: %s has an incorrect discriminator",name);
      iRetCode = 0;
    }
    switch (vSelection) {
      case 0 :
              AddName("Banana()");
              AddName("ButterBean");
              if (!CheckFloat(v.Banana().ButterBean))
                iRetCode = 0;
              RemoveName();
              RemoveName();
              break;
      case 1 :
              AddName("Orange()");
              AddName("ButterBean");
              if (!CheckFloat(v.Orange().ButterBean))
                iRetCode = 0;
              RemoveName();
              AddName("ChestNut");
              if (!CheckFloat(v.Orange().ChestNut))
                iRetCode = 0;
              RemoveName();
              AddName("Currant");
              if (!CheckFloat(v.Orange().Currant))
                iRetCode = 0;
              RemoveName();
              AddName("CoxPippin");
              if (!CheckFloat(v.Orange().CoxPippin))
                iRetCode = 0;
              RemoveName();
              AddName("Chervil");
              if (!CheckFloat(v.Orange().Chervil))
                iRetCode = 0;
              RemoveName();
              AddName("Scallion");
              if (!CheckFloat(v.Orange().Scallion))
                iRetCode = 0;
              RemoveName();
              AddName("Tomato");
              if (!CheckFloat(v.Orange().Tomato))
                iRetCode = 0;
              RemoveName();
              RemoveName();
              break;
      case 2 :
              AddName("Corn()");
              if (!CheckOctet(v.Corn()))
                iRetCode = 0;
              RemoveName();
              break;
    }
  }
  return iRetCode;
}

 
void GetBroadbeansAvocado(::Broadbeans::Avocado &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBroadbeansAvocado");
#endif

  GetFloat(v.ButterBean);
}

int CheckBroadbeansAvocado(const ::Broadbeans::Avocado &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBroadbeansAvocado");
#endif

  AddName("ButterBean");
  if (!CheckFloat(v.ButterBean))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetBroadbeansGalaApple(::Broadbeans::GalaApple &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBroadbeansGalaApple");
#endif

  GetFloat(v.ButterBean);
  GetFloat(v.ChestNut);
  GetFloat(v.Currant);
  GetFloat(v.CoxPippin);
  GetFloat(v.Chervil);
  GetFloat(v.Scallion);
  GetFloat(v.Tomato);
}

int CheckBroadbeansGalaApple(const ::Broadbeans::GalaApple &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBroadbeansGalaApple");
#endif

  AddName("ButterBean");
  if (!CheckFloat(v.ButterBean))
    iRetCode = 0;
  RemoveName();
  AddName("ChestNut");
  if (!CheckFloat(v.ChestNut))
    iRetCode = 0;
  RemoveName();
  AddName("Currant");
  if (!CheckFloat(v.Currant))
    iRetCode = 0;
  RemoveName();
  AddName("CoxPippin");
  if (!CheckFloat(v.CoxPippin))
    iRetCode = 0;
  RemoveName();
  AddName("Chervil");
  if (!CheckFloat(v.Chervil))
    iRetCode = 0;
  RemoveName();
  AddName("Scallion");
  if (!CheckFloat(v.Scallion))
    iRetCode = 0;
  RemoveName();
  AddName("Tomato");
  if (!CheckFloat(v.Tomato))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerBroadbeansExcpt(::idlServer::BroadbeansExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerBroadbeansExcpt");
#endif

  GetBroadbeans(v.ex1);
}

int CheckidlServerBroadbeansExcpt(const ::idlServer::BroadbeansExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerBroadbeansExcpt");
#endif

  AddName("ex1");
  if (!CheckBroadbeans(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerAvocadoExcpt(::idlServer::AvocadoExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerAvocadoExcpt");
#endif

  GetBroadbeansAvocado(v.ex1);
}

int CheckidlServerAvocadoExcpt(const ::idlServer::AvocadoExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerAvocadoExcpt");
#endif

  AddName("ex1");
  if (!CheckBroadbeansAvocado(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerGalaAppleExcpt(::idlServer::GalaAppleExcpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerGalaAppleExcpt");
#endif

  GetBroadbeansGalaApple(v.ex1);
}

int CheckidlServerGalaAppleExcpt(const ::idlServer::GalaAppleExcpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerGalaAppleExcpt");
#endif

  AddName("ex1");
  if (!CheckBroadbeansGalaApple(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



