//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


::Broadbeans
idlServer_imp::BroadbeansAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  
  ::Broadbeans ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BroadbeansAttr\n");
#endif
  
  ernie.seed("BroadbeansAttrCall");
  
  ernie.seed("BroadbeansAttrReturn"); 
  
  GetBroadbeans(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BroadbeansAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::BroadbeansAttr(const ::Broadbeans &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BroadbeansAttr\n");
#endif
  
  ernie.seed("BroadbeansAttrCall");
  AddName("_attr");
  if (!CheckBroadbeans(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BroadbeansAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BroadbeansAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Broadbeans
idlServer_imp::BroadbeansOp(const ::Broadbeans &p1,::Broadbeans &p2,::Broadbeans &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  
  ::Broadbeans ReturnValue;
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::BroadbeansOp\n");
#endif
  
  ernie.seed("BroadbeansOpCall");
  AddName("p1");
  if (!CheckBroadbeans(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBroadbeans(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BroadbeansOpReturn"); 
  {
    ::idlServer::BroadbeansExcpt ex;
    GetidlServerBroadbeansExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetBroadbeans(ReturnValue);
  GetBroadbeans(p2);
  GetBroadbeans(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::BroadbeansOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Broadbeans::Avocado
idlServer_imp::AvocadoAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Broadbeans::Avocado ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoAttr\n");
#endif
  
  ernie.seed("AvocadoAttrCall");
  
  ernie.seed("AvocadoAttrReturn"); 
  
  GetBroadbeansAvocado(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::AvocadoAttr(const ::Broadbeans::Avocado &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoAttr\n");
#endif
  
  ernie.seed("AvocadoAttrCall");
  AddName("_attr");
  if (!CheckBroadbeansAvocado(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AvocadoAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Broadbeans::Avocado
idlServer_imp::AvocadoOp(const ::Broadbeans::Avocado &p1,::Broadbeans::Avocado &p2,::Broadbeans::Avocado &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Broadbeans::Avocado ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::AvocadoOp\n");
#endif
  
  ernie.seed("AvocadoOpCall");
  AddName("p1");
  if (!CheckBroadbeansAvocado(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBroadbeansAvocado(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("AvocadoOpReturn"); 
  {
    ::idlServer::AvocadoExcpt ex;
    GetidlServerAvocadoExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetBroadbeansAvocado(ReturnValue);
  GetBroadbeansAvocado(p2);
  GetBroadbeansAvocado(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::AvocadoOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Broadbeans::GalaApple
idlServer_imp::GalaAppleAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  ::Broadbeans::GalaApple ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GalaAppleAttr\n");
#endif
  
  ernie.seed("GalaAppleAttrCall");
  
  ernie.seed("GalaAppleAttrReturn"); 
  
  GetBroadbeansGalaApple(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GalaAppleAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::GalaAppleAttr(const ::Broadbeans::GalaApple &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GalaAppleAttr\n");
#endif
  
  ernie.seed("GalaAppleAttrCall");
  AddName("_attr");
  if (!CheckBroadbeansGalaApple(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GalaAppleAttrReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GalaAppleAttr\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Broadbeans::GalaApple
idlServer_imp::GalaAppleOp(const ::Broadbeans::GalaApple &p1,::Broadbeans::GalaApple &p2,::Broadbeans::GalaApple &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 
  ::Broadbeans::GalaApple ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::GalaAppleOp\n");
#endif
  
  ernie.seed("GalaAppleOpCall");
  AddName("p1");
  if (!CheckBroadbeansGalaApple(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  AddName("p3");
  if (!CheckBroadbeansGalaApple(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GalaAppleOpReturn"); 
  {
    ::idlServer::GalaAppleExcpt ex;
    GetidlServerGalaAppleExcpt(ex);
    ::tet_result(TET_PASS);
    throw(ex);
  }
  
  GetBroadbeansGalaApple(ReturnValue);
  GetBroadbeansGalaApple(p2);
  GetBroadbeansGalaApple(p3);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::GalaAppleOp\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}



