/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing advanced features of the valuetype construct 
// Test subgroup description: Testing scope of typedef declarations with the valuetype inheritance 

// Test case Nr. 2 
// Name: tc01 
// Testcase goal: Valuetype inheritance with typedef 
// Directory: va_t02 


extern "C"
void test1(void)
{
   /* Public Member in abstract valuetype ValA for operation op1 with in parameter of type ::TestType (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Public Member in abstract valuetype ValA for operation op1 with in parameter of type ShortValue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Public Member in abstract valuetype ValB for operation op2 with in parameter of type ValB::TestType (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Public Member in abstract valuetype ValB for operation op2 with in parameter of type LongValue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp4.run();
}

extern "C"
void test5(void)
{
   /* Public Member in  valuetype ValC for operation op3 with in parameter of type ValC::TestType (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp5.run();
}

extern "C"
void test6(void)
{
   /* Public Member in  valuetype ValC for operation op3 with in parameter of type String_var (type string defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp6.run();
}

extern "C"
void test7(void)
{
   /* Public Modifier in  valuetype ValC for member Mbr3 with in parameter of type ValC::TestType (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp7.run();
}

extern "C"
void test8(void)
{
   /* Public Member in  valuetype ValD derived from ValC for operation op4 with in parameter of type ValC::TestType (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp8.run();
}

extern "C"
void test9(void)
{
   /* Public Member in  valuetype ValD derived from ValC for operation op4 with in parameter of type String_var (type string defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp9.run();
}

extern "C"
void test10(void)
{
   /* Public Modifier in  valuetype ValD derived from ValC for member Mbr4 with in parameter of type ValC::TestType (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp10.run();
}

extern "C"
void test11(void)
{
   /* Public Member in  valuetype ValD derived from ValC for inherited operation op3 with in parameter of type ValC::TestType (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp11.run();
}

extern "C"
void test12(void)
{
   /* Public Modifier in  valuetype ValD derived from ValC for inherited member Mbr3 with in parameter of type ValC::TestType (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp12.run();
}

// Test case Nr. 3 
// Name: tc02 
// Testcase goal: Valuetype inheritance with typedef 
// Directory: va_t02 


extern "C"
void test13(void)
{
   /* Public Member in  valuetype ValE for operation op5 with in parameter of type ::TestType (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp13.run();
}

extern "C"
void test14(void)
{
   /* Public Member in  valuetype ValE for operation op5 with in parameter of type ShortValue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp14.run();
}

extern "C"
void test15(void)
{
   /* Public Member in  valuetype ValE for operation op6 with in parameter of type ValB::TestType (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp15.run();
}

extern "C"
void test16(void)
{
   /* Public Member in  valuetype ValE for operation op6 with in parameter of type LongValue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp16.run();
}

extern "C"
void test17(void)
{
   /* Public Member in  valuetype ValE for operation op7 with in parameter of type ValC::TestType (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp17.run();
}

extern "C"
void test18(void)
{
   /* Public Member in  valuetype ValE for operation op7 with in parameter of type String_var (type string defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp18.run();
}

extern "C"
void test19(void)
{
   /* Public Member in  valuetype ValE for operation op8 with in parameter of type ValC::TestType (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp19.run();
}

extern "C"
void test20(void)
{
   /* Public Member in  valuetype ValE for operation op8 with in parameter of type String_var (type string defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp20.run();
}

extern "C"
void test21(void)
{
   /* Public Member in  valuetype ValE for operation op1 (inherited from ValA) with in parameter of type ShortValue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp21.run();
}

extern "C"
void test22(void)
{
   /* Public Member in  valuetype ValE for operation op2 (inherited from ValB) with in parameter of type LongValue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp22.run();
}

extern "C"
void test23(void)
{
   /* Public Member in  valuetype ValE for operation op3 (inherited from ValC) with in parameter of type string (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp23.run();
}

extern "C"
void test24(void)
{
   /* Public Modifier in  valuetype ValE for member Mbr3 (inherited from ValC)  with in parameter of type string (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp24.run();
}

extern "C"
void test25(void)
{
   /* Public Member in  valuetype ValE for operation op4 (inherited from ValD) with in parameter of type string (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp25.run();
}

extern "C"
void test26(void)
{
   /* Public Modifier in  valuetype ValE for member Mbr4 (inherited from ValD)  with in parameter of type string (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance with typedef\n");
  tp26.run();
}
