/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing features of the value box construct 
// Test subgroup description: Testing usage of the value box construct as parameter and attribute 

// Test case Nr. 5 
// Name: tc05 
// Testcase goal: Value Box for Strings 
// Directory: vb_d04 


extern "C"
void test1(void)
{
   /* Public constructors in class created for a valuebox with String */

  tet_printf("TC: Value Box for Strings\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Public assignment operators  in class created for a valuebox with String */

  tet_printf("TC: Value Box for Strings\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Public Accessor function _value() for underlying boxed string type in class created for a valuebox with String */

  tet_printf("TC: Value Box for Strings\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Modifier functions _value for underlying boxed string type in class created for a valuebox with String */

  tet_printf("TC: Value Box for Strings\n");
  tp4.run();
}

extern "C"
void test5(void)
{
   /* Existence of explicit conversion functions _boxed_in, _boxed_inout, _boxed_out in class created for a valuebox with String */

  tet_printf("TC: Value Box for Strings\n");
  tp5.run();
}

extern "C"
void test6(void)
{
   /* Existence of public static _downcast in class created for a valuebox with String */

  tet_printf("TC: Value Box for Strings\n");
  tp6.run();
}

extern "C"
void test7(void)
{
   /* Existence of public subscription operator ([])  in class created for a valuebox with String */

  tet_printf("TC: Value Box for Strings\n");
  tp7.run();
}

extern "C"
void test8(void)
{
   /* Extraction and insertion from/to any for a valuebox with String */

  tet_printf("TC: Value Box for Strings\n");
  tp8.run();
}

extern "C"
void test9(void)
{
   /* Existence of private default assignment operator in class created for a valuebox with String */

  tet_printf("TC: Value Box for Strings\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp9.run(1);
}


// Test case Nr. 6 
// Name: tc06 
// Testcase goal: Value Box for WStrings 
// Directory: vb_d04 


extern "C"
void test10(void)
{
   /* Public constructors in class created for a valuebox with WString */

  tet_printf("TC: Value Box for WStrings\n");
  tp10.run();
}

extern "C"
void test11(void)
{
   /* Public assignment operators  in class created for a valuebox with WString */

  tet_printf("TC: Value Box for WStrings\n");
  tp11.run();
}

extern "C"
void test12(void)
{
   /* Public Accessor function _value() for underlying boxed WString type in class created for a valuebox with WString */

  tet_printf("TC: Value Box for WStrings\n");
  tp12.run();
}

extern "C"
void test13(void)
{
   /* Modifier functions _value for underlying boxed WString type in class created for a valuebox with WString */

  tet_printf("TC: Value Box for WStrings\n");
  tp13.run();
}

extern "C"
void test14(void)
{
   /* Existence of explicit conversion functions _boxed_in, _boxed_inout, _boxed_out in class created for a valuebox with WString */

  tet_printf("TC: Value Box for WStrings\n");
  tp14.run();
}

extern "C"
void test15(void)
{
   /* Existence of public static _downcast in class created for a valuebox with WString */

  tet_printf("TC: Value Box for WStrings\n");
  tp15.run();
}

extern "C"
void test16(void)
{
   /* Existence of public subscription operator ([])  in class created for a valuebox with WString */

  tet_printf("TC: Value Box for WStrings\n");
  tp16.run();
}

extern "C"
void test17(void)
{
   /* Extraction and insertion from/to any for a valuebox with WString */

  tet_printf("TC: Value Box for WStrings\n");
  tp17.run();
}

extern "C"
void test18(void)
{
   /* Existence of private default assignment operator in class created for a valuebox with WString */

  tet_printf("TC: Value Box for WStrings\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp18.run(1);
}

