/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing features of the value box construct 
// Test subgroup description: Testing usage of the value box construct as parameter and attribute 

// Test case Nr. 7 
// Name: tc07 
// Testcase goal: Value Box for Fix Union 
// Directory: vb_d05 


extern "C"
void test1(void)
{
   /* Public constructors in class created for a valuebox with fix union */

  tet_printf("TC: Value Box for Fix Union\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Public assignment operator  (with an argument _ underlying boxed type) in class created for a valuebox with fix union */

  tet_printf("TC: Value Box for Fix Union\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Public accessor function _value() for underlying boxed fix union type in class created for a valuebox with fix union */

  tet_printf("TC: Value Box for Fix Union\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Public modifier function _value for underlying boxed fix union type in class created for a valuebox with fix union */

  tet_printf("TC: Value Box for Fix Union\n");
  tp4.run();
}

extern "C"
void test5(void)
{
   /* Existence of explicit conversion functions _boxed_in, _boxed_inout, _boxed_out in class created for a valuebox with fix union */

  tet_printf("TC: Value Box for Fix Union\n");
  tp5.run();
}

extern "C"
void test6(void)
{
   /* Existence of public static _downcast in class created for a valuebox with fix union */

  tet_printf("TC: Value Box for Fix Union\n");
  tp6.run();
}

extern "C"
void test7(void)
{
   /* Extraction and insertion from/to any for a valuebox with fix union */

  tet_printf("TC: Value Box for Fix Union\n");
  tp7.run();
}

extern "C"
void test8(void)
{
   /* Existence of private default assignment operator in class created for a valuebox with fix union */

  tet_printf("TC: Value Box for Fix Union\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp8.run(1);
}

// Test case Nr. 8 
// Name: tc08 
// Testcase goal: Value Box for Sequence of Long 
// Directory: vb_d05 


extern "C"
void test9(void)
{
   /* Public constructors in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for Sequence of Long\n");
  tp9.run();
}

extern "C"
void test10(void)
{
   /* Public assignment operator  (with an argument _ underlying boxed type) in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for Sequence of Long\n");
  tp10.run();
}

extern "C"
void test11(void)
{
   /* Public accessor function _value() for underlying boxed sequence-of-long in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for Sequence of Long\n");
  tp11.run();
}

extern "C"
void test12(void)
{
   /* Public modifier function  _value for underlying boxed sequence of long type in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for Sequence of Long\n");
  tp12.run();
}

extern "C"
void test13(void)
{
   /* Existence of explicit conversion functions _boxed_in, _boxed_inout, _boxed_out in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for Sequence of Long\n");
  tp13.run();
}

extern "C"
void test14(void)
{
   /* Existence of public static _downcast in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for Sequence of Long\n");
  tp14.run();
}

extern "C"
void test15(void)
{
   /* Existence of subscript operator ([])  in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for Sequence of Long\n");
  tp15.run();
}

extern "C"
void test16(void)
{
   /* Existence of functions maximum and length  in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for Sequence of Long\n");
  tp16.run();
}

extern "C"
void test17(void)
{
   /* Extraction and insertion from/to any for a valuebox with Sequence */

  tet_printf("TC: Value Box for Sequence of Long\n");
  tp17.run();
}

extern "C"
void test18(void)
{
   /* Existence of private default assignment operator in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for Sequence of Long\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp18.run(1);
}

// Test case Nr. 9 
// Name: tc09 
// Testcase goal: Value Box for Any 
// Directory: vb_d05 


extern "C"
void test19(void)
{
   /* Public constructors in class created for a value box with Any */

  tet_printf("TC: Value Box for Any\n");
  tp19.run();
}

extern "C"
void test20(void)
{
   /* Public assignment operator  (with an argument _ underlying boxed type) in class created for a valuetype with Any */

  tet_printf("TC: Value Box for Any\n");
  tp20.run();
}

extern "C"
void test21(void)
{
   /* Public accessor function _value() for underlying boxed any type in class created for a valuetype with Any */

  tet_printf("TC: Value Box for Any\n");
  tp21.run();
}

extern "C"
void test22(void)
{
   /* Public modifier function _value for underlying boxed any type in class created for a valuetype with Any */

  tet_printf("TC: Value Box for Any\n");
  tp22.run();
}

extern "C"
void test23(void)
{
   /* Existence of explicit conversion functions _boxed_in, _boxed_inout, _boxed_out in class created for a valuetype with Any */

  tet_printf("TC: Value Box for Any\n");
  tp23.run();
}

extern "C"
void test24(void)
{
   /* Existence of public static _downcast in class created for a valuetype with Any */

  tet_printf("TC: Value Box for Any\n");
  tp24.run();
}

extern "C"
void test25(void)
{
   /*  Valuetype with Any _ possible usage with insertion/extraction operators */

  tet_printf("TC: Value Box for Any\n");
  tp25.run();
}

extern "C"
void test26(void)
{
   /* Existence of private default assignment operator in class created for a valuetype */

  tet_printf("TC: Value Box for Any\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp26.run(1);
}

// Test case Nr. 10 
// Name: tc10 
// Testcase goal: Value Box for String Sequence 
// Directory: vb_d05 


extern "C"
void test27(void)
{
   /* Public constructors in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for String Sequence\n");
  tp27.run();
}

extern "C"
void test28(void)
{
   /* Public assignment operator  (with an argument _ underlying boxed type) in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for String Sequence\n");
  tp28.run();
}

extern "C"
void test29(void)
{
   /* Public accessor function _value() for underlying boxed string sequence type in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for String Sequence\n");
  tp29.run();
}

extern "C"
void test30(void)
{
   /* Public modifier function  _value for underlying boxed string sequence type in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for String Sequence\n");
  tp30.run();
}

extern "C"
void test31(void)
{
   /* Existence of explicit conversion functions _boxed_in, _boxed_inout, _boxed_out in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for String Sequence\n");
  tp31.run();
}

extern "C"
void test32(void)
{
   /* Existence of public static _downcast in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for String Sequence\n");
  tp32.run();
}

extern "C"
void test33(void)
{
   /* Existence of subscript operator ([])  in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for String Sequence\n");
  tp33.run();
}

extern "C"
void test34(void)
{
   /* Existence of functions maximum and length  in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for String Sequence\n");
  tp34.run();
}

extern "C"
void test35(void)
{
   /* Extraction and insertion from/to any for a valuebox with Sequence */

  tet_printf("TC: Value Box for String Sequence\n");
  tp35.run();
}

extern "C"
void test36(void)
{
   /* Existence of private default assignment operator in class created for a valuebox with Sequence */

  tet_printf("TC: Value Box for String Sequence\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp36.run(1);
}

// Test case Nr. 11 
// Name: tc11 
// Testcase goal: Value Box for Var Union 
// Directory: vb_d05 


extern "C"
void test37(void)
{
   /* Public constructors in class created for a valuebox with var union */

  tet_printf("TC: Value Box for Var Union\n");
  tp37.run();
}

extern "C"
void test38(void)
{
   /* Public assignment operator  (with an argument _ underlying boxed type) in class created for a valuebox with var union */

  tet_printf("TC: Value Box for Var Union\n");
  tp38.run();
}

extern "C"
void test39(void)
{
   /* Public accessor function _value() for underlying boxed union type in class created for a valuebox with var union */

  tet_printf("TC: Value Box for Var Union\n");
  tp39.run();
}

extern "C"
void test40(void)
{
   /* Public modifier function _value for underlying boxed union type in class created for a valuebox with var union */

  tet_printf("TC: Value Box for Var Union\n");
  tp40.run();
}

extern "C"
void test41(void)
{
   /* Existence of explicit conversion functions _boxed_in, _boxed_inout, _boxed_out in class created for a valuebox with var union */

  tet_printf("TC: Value Box for Var Union\n");
  tp41.run();
}

extern "C"
void test42(void)
{
   /* Existence of public static _downcast in class created for a valuebox with var union */

  tet_printf("TC: Value Box for Var Union\n");
  tp42.run();
}

extern "C"
void test43(void)
{
   /* Extraction and insertion from/to any for a valuebox with var union */

  tet_printf("TC: Value Box for Var Union\n");
  tp43.run();
}

extern "C"
void test44(void)
{
   /* Existence of private default assignment operator in class created for a valuebox with var union */

  tet_printf("TC: Value Box for Var Union\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp44.run(1);
}
