/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing features of the value box construct 
// Test subgroup description: Testing usage of the value box construct as parameter and attribute 

// Test case Nr. 2 
// Name: tc01 
// Testcase goal: Value Box of Enum as attribute and as operation parameter 
// Directory: vb_p02 


extern "C"
void test1(void)
{
   /* Accessor function  for an attribute of the value box EnumValue */

  tet_printf("TC: Value Box of Enum as attribute and as operation parameter\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Modifier function  for an attribute of the value box EnumValue */

  tet_printf("TC: Value Box of Enum as attribute and as operation parameter\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Value box EnumValue used as in/out/inout parameter of an operation in an interface - actual parameter types */

  tet_printf("TC: Value Box of Enum as attribute and as operation parameter\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Existence of EnumValue_out for value box EnumValue */

  tet_printf("TC: Value Box of Enum as attribute and as operation parameter\n");
  tp4.run();
}

extern "C"
void test5(void)
{
   /* Base Class for Server Implementation, Value box EnumValue used as in/out/inout parameter of an operation in an interface - formal parameter types (server side), out type for value box of enum exists */

  tet_printf("TC: Value Box of Enum as attribute and as operation parameter\n");
  tp5.run();
}

extern "C"
void test6(void)
{
   /* Value box EnumValue used as in/out/inout parameter of an operation in an interface - formal parameter types (server side) */

  tet_printf("TC: Value Box of Enum as attribute and as operation parameter\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp6.run(1);
}

// Test case Nr. 3 
// Name: tc02 
// Testcase goal: Value Box of var struct as attribute and as operation parameter 
// Directory: vb_p02 


extern "C"
void test7(void)
{
   /* Accessor function for an attribute of the value box of var struct */

  tet_printf("TC: Value Box of var struct as attribute and as operation parameter\n");
  tp7.run();
}

extern "C"
void test8(void)
{
   /* Modifier function for an attribute of the value box of var struct */

  tet_printf("TC: Value Box of var struct as attribute and as operation parameter\n");
  tp8.run();
}

extern "C"
void test9(void)
{
   /* Value box of var struct used as in/out/inout parameter of an operation in an interface - actual parameter types */

  tet_printf("TC: Value Box of var struct as attribute and as operation parameter\n");
  tp9.run();
}

extern "C"
void test10(void)
{
   /* Existence of VarSValue_out for value box VarSValue */

  tet_printf("TC: Value Box of var struct as attribute and as operation parameter\n");
  tp10.run();
}

extern "C"
void test11(void)
{
   /* Base Class for Server Implementation, Value box of var struct used as in/out/inout parameter of an operation in an interface - formal parameter types (server side) */

  tet_printf("TC: Value Box of var struct as attribute and as operation parameter\n");
  tp11.run();
}

extern "C"
void test12(void)
{
   /* Value box of var struct used as in/out/inout parameter of an operation in an interface - formal parameter types (server side) */

  tet_printf("TC: Value Box of var struct as attribute and as operation parameter\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp12.run(1);
}

// Test case Nr. 4 
// Name: tc03 
// Testcase goal: Value Box of fix struct as attribute and as operation parameter 
// Directory: vb_p02 


extern "C"
void test13(void)
{
   /* Accessor function for an attribute of the value box of fix struct */

  tet_printf("TC: Value Box of fix struct as attribute and as operation parameter\n");
  tp13.run();
}

extern "C"
void test14(void)
{
   /* Modifier function for an attribute of the value box of fix struct */

  tet_printf("TC: Value Box of fix struct as attribute and as operation parameter\n");
  tp14.run();
}

extern "C"
void test15(void)
{
   /* Value box of fix struct used as in/out/inout parameter of an operation in an interface - actual parameter types */

  tet_printf("TC: Value Box of fix struct as attribute and as operation parameter\n");
  tp15.run();
}

extern "C"
void test16(void)
{
   /* Existence of FixSValue_out for value box FixSValue */

  tet_printf("TC: Value Box of fix struct as attribute and as operation parameter\n");
  tp16.run();
}

extern "C"
void test17(void)
{
   /* Base Class for Server Implementation, Value box of fix struct used as in/out/inout parameter of an operation in an interface - formal parameter types (server side) */

  tet_printf("TC: Value Box of fix struct as attribute and as operation parameter\n");
  tp17.run();
}

extern "C"
void test18(void)
{
   /* Value box of fix struct used as in/out/inout parameter of an operation in an interface - formal  parameter types (server side) */

  tet_printf("TC: Value Box of fix struct as attribute and as operation parameter\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp18.run(1);
}

// Test case Nr. 5 
// Name: tc04 
// Testcase goal: Value Box of array as attribute and as operation parameter 
// Directory: vb_p02 


extern "C"
void test19(void)
{
   /* Accessor function for an attribute of the value box of array */

  tet_printf("TC: Value Box of array as attribute and as operation parameter\n");
  tp19.run();
}

extern "C"
void test20(void)
{
   /* Modifier function  for an attribute of the value box of array */

  tet_printf("TC: Value Box of array as attribute and as operation parameter\n");
  tp20.run();
}

extern "C"
void test21(void)
{
   /* Value box of array used as in/out/inout parameter of an operation in an interface - actual parameter types */

  tet_printf("TC: Value Box of array as attribute and as operation parameter\n");
  tp21.run();
}

extern "C"
void test22(void)
{
   /* Existence of ArrayValue_out for value box ArrayValue */

  tet_printf("TC: Value Box of array as attribute and as operation parameter\n");
  tp22.run();
}

extern "C"
void test23(void)
{
   /* Base Class for Server Implementation, Value box of array used as in/out/inout parameter of an operation in an interface - formal  parameter types (server side) */

  tet_printf("TC: Value Box of array as attribute and as operation parameter\n");
  tp23.run();
}

extern "C"
void test24(void)
{
   /* Value box of array used as in/out/inout parameter of an operation in an interface - formal  parameter types (server side) */

  tet_printf("TC: Value Box of array as attribute and as operation parameter\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp24.run(1);
}

// Test case Nr. 6 
// Name: tc05 
// Testcase goal: Value Box of string as attribute and as operation parameter 
// Directory: vb_p02 


extern "C"
void test25(void)
{
   /* Accessor function for an attribute of the value box of string */

  tet_printf("TC: Value Box of string as attribute and as operation parameter\n");
  tp25.run();
}

extern "C"
void test26(void)
{
   /* Modifier function  for an attribute of the value box of string */

  tet_printf("TC: Value Box of string as attribute and as operation parameter\n");
  tp26.run();
}

extern "C"
void test27(void)
{
   /* Value box of string used as in/out/inout parameter of an operation in an interface - actual parameter types */

  tet_printf("TC: Value Box of string as attribute and as operation parameter\n");
  tp27.run();
}

extern "C"
void test28(void)
{
   /* Existence of StringValue_out for value box StringValue */

  tet_printf("TC: Value Box of string as attribute and as operation parameter\n");
  tp28.run();
}

extern "C"
void test29(void)
{
   /* Base Class for Server Implementation, Value box of string used as in/out/inout parameter of an operation in an interface - formal  parameter types (server side) */

  tet_printf("TC: Value Box of string as attribute and as operation parameter\n");
  tp29.run();
}

extern "C"
void test30(void)
{
   /* Value box of string used as in/out/inout parameter of an operation in an interface - formal  parameter types (server side) */

  tet_printf("TC: Value Box of string as attribute and as operation parameter\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp30.run(1);
}
