/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing features of the valuetype construct 
// Test subgroup description: Testing the valuetype as operation parameter 

// Test case Nr. 1 
// Name: tc01 
// Testcase goal:  Valuetype as operation_parameter in a valuetype operation 
// Directory: vt_p01 


extern "C"
void test1(void)
{
   /* Actual parameters for valuetype operation taking a valuetype as in, inout and out parameter */

  tet_printf("TC:  Valuetype as operation_parameter in a valuetype operation\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Formal  parameters for valuetype operation taking a valuetype as in, inout and out parameter */

  tet_printf("TC:  Valuetype as operation_parameter in a valuetype operation\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Formal  parameters for valuetype operation taking a valuetype as in, inout and out parameter */

  tet_printf("TC:  Valuetype as operation_parameter in a valuetype operation\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp3.run(1);
}

// Test case Nr. 2 
// Name: tc02 
// Testcase goal:  Valuetype as operation_parameter in an interface operation 
// Directory: vt_p01 


extern "C"
void test4(void)
{
   /* Actual parameters for interface operation taking a valuetype as in, inout and out parameter */

  tet_printf("TC:  Valuetype as operation_parameter in an interface operation\n");
  tp4.run();
}

extern "C"
void test5(void)
{
   /* Base Class for Server Implementation, Formal  parameters for valuetype operation taking a valuetype as in, inout and out parameter - server side */

  tet_printf("TC:  Valuetype as operation_parameter in an interface operation\n");
  tp5.run();
}

extern "C"
void test6(void)
{
   /* Formal  parameters for interface operation taking a valuetype as in, inout and out parameter */

  tet_printf("TC:  Valuetype as operation_parameter in an interface operation\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp6.run(1);
}

// Test case Nr. 3 
// Name: tc03 
// Testcase goal:  Valuetype as an attribute in valuetype/interface 
// Directory: vt_p01 


extern "C"
void test7(void)
{
   /* Accessor function for valuetype attribute ValAttr of an interface Inf */

  tet_printf("TC:  Valuetype as an attribute in valuetype/interface\n");
  tp7.run();
}

extern "C"
void test8(void)
{
   /* Modifier function for valuetype attribute ValAttr of an interface Inf */

  tet_printf("TC:  Valuetype as an attribute in valuetype/interface\n");
  tp8.run();
}

extern "C"
void test9(void)
{
   /* Accessor function for valuetype attribute ValAttr of an interface Inf */

  tet_printf("TC:  Valuetype as an attribute in valuetype/interface\n");
  tp9.run();
}

extern "C"
void test10(void)
{
   /* Modifier function for valuetype attribute ValAttr of an interface Inf */

  tet_printf("TC:  Valuetype as an attribute in valuetype/interface\n");
  tp10.run();
}
