//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/checktypecode.cpp
//
// Modifications:
// $Log: checktypecode.cpp,v $
// Revision 1.2  2000/05/23 16:58:36  mli
// remove case 60-65 in CheckCORBATypeCode_ptr
//
// Revision 1.1.1.1  2000/02/09 17:17:10  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.3  1998/09/04 14:39:25  james
// small change in how typecode are choosen
//
// Revision 1.2  1997/12/15 11:48:42  james
// Final Code Regeneration
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"


extern Ernie ernie;
extern char name[];
extern OrbSupport * orb;

 
int CheckCORBATypeCode_ptr(const CORBA::TypeCode_ptr &tc)
{
  switch(ernie.getULong()%66)
  {
    case   0: 
              if (!tc->equal(CORBA::_tc_ulong))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_ulong, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   1: 
              if (!tc->equal(CORBA::_tc_long))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_long, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   2: 
              if (!tc->equal(CORBA::_tc_ushort))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_ushort, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   3: 
              if (!tc->equal(CORBA::_tc_short))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_short, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   4: 
              if (!tc->equal(CORBA::_tc_boolean))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_boolean, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   5: 
              if (!tc->equal(CORBA::_tc_octet))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_octet, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   6: 
              if (!tc->equal(CORBA::_tc_char))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_char, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   7: 
              if (!tc->equal(CORBA::_tc_float))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_float, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
               break;
    case   8: 
              if (!tc->equal(CORBA::_tc_double))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_double, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   9: 
              if (!tc->equal(CORBA::_tc_string))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_string, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  10: 
              if (!tc->equal(orb->orb()->create_string_tc(ernie.getULong()%30+1)))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_string, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   11: 
              if (!tc->equal(CORBA::_tc_TypeCode))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_TypeCode, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case   12: 
              if (!tc->equal(CORBA::_tc_any))
              {
                 tet_printf("Expected %s to contain CORBA::_tc_any, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  13: 
              if (!tc->equal(::_tc_Record2))
              {
                 tet_printf("Expected %s to contain ::_tc_Record2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  14: 
              if (!tc->equal(::_tc_Chestnut1))
              {
                 tet_printf("Expected %s to contain ::_tc_Chestnut1, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  15: 
              if (!tc->equal(::_tc_Carrots))
              {
                 tet_printf("Expected %s to contain ::_tc_Carrots, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  16: 
              if (!tc->equal(::_tc_Damsons2))
              {
                 tet_printf("Expected %s to contain ::_tc_Damsons2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  17: 
              if (!tc->equal(::_tc_Mullberry1))
              {
                 tet_printf("Expected %s to contain ::_tc_Mullberry1, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  18: 
              if (!tc->equal(::_tc_WaterMelon3))
              {
                 tet_printf("Expected %s to contain ::_tc_WaterMelon3, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  19: 
              if (!tc->equal(::_tc_Raspberry1))
              {
                 tet_printf("Expected %s to contain ::_tc_Raspberry1, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  20: 
              if (!tc->equal(::_tc_Corn1))
              {
                 tet_printf("Expected %s to contain ::_tc_Corn1, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  21: 
              if (!tc->equal(::_tc_Pumpkin))
              {
                 tet_printf("Expected %s to contain ::_tc_Pumpkin, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  22: 
              if (!tc->equal(::_tc_Peanuts1))
              {
                 tet_printf("Expected %s to contain ::_tc_Peanuts1, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  23: 
              if (!tc->equal(::_tc_WaterMelon))
              {
                 tet_printf("Expected %s to contain ::_tc_WaterMelon, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  24: 
              if (!tc->equal(::_tc_BambooShoot3))
              {
                 tet_printf("Expected %s to contain ::_tc_BambooShoot3, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  25: 
              if (!tc->equal(::_tc_Mangosteen3))
              {
                 tet_printf("Expected %s to contain ::_tc_Mangosteen3, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  26: 
              if (!tc->equal(::_tc_Currant2))
              {
                 tet_printf("Expected %s to contain ::_tc_Currant2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  27: 
              if (!tc->equal(::_tc_Chives2))
              {
                 tet_printf("Expected %s to contain ::_tc_Chives2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  28: 
              if (!tc->equal(::_tc_GardenPeas3))
              {
                 tet_printf("Expected %s to contain ::_tc_GardenPeas3, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  29: 
              if (!tc->equal(::_tc_Squash1))
              {
                 tet_printf("Expected %s to contain ::_tc_Squash1, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  30: 
              if (!tc->equal(::_tc_YellowPepper2))
              {
                 tet_printf("Expected %s to contain ::_tc_YellowPepper2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  31: 
              if (!tc->equal(::_tc_Grapefruit2))
              {
                 tet_printf("Expected %s to contain ::_tc_Grapefruit2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  32: 
              if (!tc->equal(::_tc_BlackEyedBeans))
              {
                 tet_printf("Expected %s to contain ::_tc_BlackEyedBeans, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  33: 
              if (!tc->equal(::_tc_GardenPeas1))
              {
                 tet_printf("Expected %s to contain ::_tc_GardenPeas1, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  34: 
              if (!tc->equal(::_tc_Celeriac2))
              {
                 tet_printf("Expected %s to contain ::_tc_Celeriac2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  35: 
              if (!tc->equal(::_tc_GoldenDelicous3))
              {
                 tet_printf("Expected %s to contain ::_tc_GoldenDelicous3, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  36: 
              if (!tc->equal(::_tc_Asparagus))
              {
                 tet_printf("Expected %s to contain ::_tc_Asparagus, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  37: 
              if (!tc->equal(::_tc_Oregano3))
              {
                 tet_printf("Expected %s to contain ::_tc_Oregano3, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  38: 
              if (!tc->equal(::_tc_BeechNut2))
              {
                 tet_printf("Expected %s to contain ::_tc_BeechNut2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  39: 
              if (!tc->equal(::_tc_BritishQueens1))
              {
                 tet_printf("Expected %s to contain ::_tc_BritishQueens1, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  40: 
              if (!tc->equal(::_tc_BrazilNut3))
              {
                 tet_printf("Expected %s to contain ::_tc_BrazilNut3, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  41: 
              if (!tc->equal(::_tc_LoganBerry))
              {
                 tet_printf("Expected %s to contain ::_tc_LoganBerry, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  42: 
              if (!tc->equal(::_tc_Lychees3))
              {
                 tet_printf("Expected %s to contain ::_tc_Lychees3, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  43: 
              if (!tc->equal(::_tc_Cauliflower2))
              {
                 tet_printf("Expected %s to contain ::_tc_Cauliflower2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  44: 
              if (!tc->equal(::_tc_Beetroot2))
              {
                 tet_printf("Expected %s to contain ::_tc_Beetroot2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  45: 
              if (!tc->equal(::_tc_Fig))
              {
                 tet_printf("Expected %s to contain ::_tc_Fig, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  46: 
              if (!tc->equal(::_tc_IcebergLettuce2))
              {
                 tet_printf("Expected %s to contain ::_tc_IcebergLettuce2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  47: 
              if (!tc->equal(::_tc_Clementine2))
              {
                 tet_printf("Expected %s to contain ::_tc_Clementine2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  48: 
              if (!tc->equal(::_tc_Susander2))
              {
                 tet_printf("Expected %s to contain ::_tc_Susander2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  49: 
              if (!tc->equal(::_tc_Blackberry2))
              {
                 tet_printf("Expected %s to contain ::_tc_Blackberry2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  50: 
              if (!tc->equal(::_tc_Peppercorn))
              {
                 tet_printf("Expected %s to contain ::_tc_Peppercorn, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  51: 
              if (!tc->equal(::_tc_Tomato2))
              {
                 tet_printf("Expected %s to contain ::_tc_Tomato2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  52: 
              if (!tc->equal(::_tc_Fennell3))
              {
                 tet_printf("Expected %s to contain ::_tc_Fennell3, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  53: 
              if (!tc->equal(::_tc_Rasin2))
              {
                 tet_printf("Expected %s to contain ::_tc_Rasin2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  54: 
              if (!tc->equal(::_tc_Dates3))
              {
                 tet_printf("Expected %s to contain ::_tc_Dates3, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  55: 
              if (!tc->equal(::_tc_Squash2))
              {
                 tet_printf("Expected %s to contain ::_tc_Squash2, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  56: 
              if (!tc->equal(::_tc_GaliaMelon3))
              {
                 tet_printf("Expected %s to contain ::_tc_GaliaMelon3, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  57: 
              if (!tc->equal(::_tc_Turnip3))
              {
                 tet_printf("Expected %s to contain ::_tc_Turnip3, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  58: 
              if (!tc->equal(::_tc_Tomato))
              {
                 tet_printf("Expected %s to contain ::_tc_Tomato, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  59: 
              if (!tc->equal(::_tc_Radish))
              {
                 tet_printf("Expected %s to contain ::_tc_Radish, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
/* Generation of TypeCode constant for bounded string types
   is neither defined in mapping for string types nor in mapping
   for TypeCode.

    case  60: 
              if (!tc->equal(_tc_string_4))
              {
                 tet_printf("Expected %s to contain _tc_string_4, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  61: 
              if (!tc->equal(_tc_string_20))
              {
                 tet_printf("Expected %s to contain _tc_string_20, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  62: 
              if (!tc->equal(_tc_string_12))
              {
                 tet_printf("Expected %s to contain _tc_string_12, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  63: 
              if (!tc->equal(_tc_string_46))
              {
                 tet_printf("Expected %s to contain _tc_string_46, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  64: 
              if (!tc->equal(_tc_string_43))
              {
                 tet_printf("Expected %s to contain _tc_string_43, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
    case  65: 
              if (!tc->equal(_tc_string_25))
              {
                 tet_printf("Expected %s to contain _tc_string_25, but found %u instead.",
                    name,(unsigned long)tc->kind());
                 return 0;
              }
              break;
*/

  }
  return 1;
}
