//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/iiop/include/syncinfo.hh
//
// Modifications:
// $Log: syncinfo.hh,v $
// Revision 1.1.1.1  2000/02/09 17:17:11  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.4  1997/12/08 16:31:10  stephen
// Increased timeout.
//
// Revision 1.3  1997/11/25 16:25:39  stephen
// Synchronisation information for IIOP tests.
//
//

#ifndef VSORB_SYNC_HH
#define VSORB_SYNC_HH

// Number of second to wait for a TET remote sync
// event to complete

#define VS_TIMEOUT  30

//
// Currently there are 2 events defined
// that are used in the IIOP tests
// The server passing an IOR to the proxy and
// the proxy passing it on to the client

#define SERVER_TO_PROXY   1000  // Used in IIOP tests
#define PROXY_TO_CLIENT   2000  // Used in IIOP tests

// A third event is used to synchronise
// the server directly with the client
#define SERVER_TO_CLIENT  3000  // Used in SII tests

#define PROXY  1
#define SERVER 2
#define CLIENT 3

#define CSW PROXY
#define SSW PROXY

#define SEVENT SERVER_TO_PROXY 
#define CEVENT PROXY_TO_CLIENT

#endif
