//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/smain.cpp
//
// Modifications:
// $Log: smain.cpp,v $
// Revision 1.4  2000/07/14 16:59:50  corval2
// Fixed signatures
//
// Revision 1.3  2000/05/23 16:56:40  mli
// remove 'CORBA::Environment ev;'
//
// Revision 1.2  2000/02/11 16:15:09  mli
//   o    void (*tet_startup)(void) -> void (*tet_startup)()
//   o    void (*tet_cleanup)(void) -> void (*tet_cleanup)()
//
// Revision 1.1.1.1  2000/02/09 17:17:13  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.9  1998/09/04 15:16:46  james
// tabs removed
//
// Revision 1.8  1998/04/27 15:26:06  stephen
// Missing CORBA::Object passed to server_init call.
//
//
//

#include <orb_supp.hh>
#include <syncinfo.hh>
#include <stdlib.h>

#ifndef WIN32
#include <unistd.h>
#else
#include <process.h>
#endif

extern "C" {
#include <tet_api.h>
}

#include "tin.hh"
#include "server.hh"

int remSystem[] = { SSW };  

OrbSupport *orb;

char *stringifiedIOR = 0;

void
serverStartUp( void )
{
    iiopServer_imp *objref;

    
    try {
      orb = new OrbSupport("iiopServer");
      objref = new iiopServer_imp;
      orb->server_init(objref);
      stringifiedIOR = orb->getObjref(objref->_this());
    }
    catch (CORBA::Exception &sysEx) {
      tet_infoline("server: Failed to create iiopServer Object ");
      return;
    }

    // Provide space for IOR
    struct tet_synmsg msg;

    // Indicate send mode to TET
    msg.tsm_flags = TET_SMSNDMSG;
    msg.tsm_dlen = strlen(stringifiedIOR) + 1;
    msg.tsm_data = stringifiedIOR;

    // Attempt to synchronise
    if (::tet_remsync(SEVENT, remSystem, 1, VS_TIMEOUT, TET_SV_YES, &msg) != 0) {
      ::tet_printf("server: sync point %d failed", SEVENT);
      return;
    }

#ifdef DEBUG
    ::tet_printf("server: sync point %d OK", SEVENT);
#endif

}

void
testServer( void ) {
    /* wait for invocations */

    // wait for 15 seconds unless told otherwise
    char * tout = 0;
    tout = getenv("VSORB_EVENT_TIMEOUT");

    unsigned long timeout = (tout) ? atoi(tout) : 15;
    
    try {
      orb->getEvents(CORBA::Environment::_nil(), timeout);
    }
    catch (CORBA::SystemException &ex) {
      tet_infoline("server: exception on getEvents()");
      tet_printf("server: minor code %d", ex.minor());
      ::tet_result(TET_FAIL);
      return;
    }
}

void 
serverCleanUp() {
    delete orb;
    return;
}    



extern "C" {
    void (*tet_startup)() = serverStartUp,
    (*tet_cleanup)() = serverCleanUp;
    struct tet_testlist tet_testlist[] = { 
     {testServer,1},
     {testServer,2},
     {testServer,3},
     {testServer,4},
     {testServer,5},
     {testServer,6},
     {testServer,7},
     {testServer,8},
     {testServer,9},
     {testServer,10},
     {testServer,11},
     {testServer,12},
     {testServer,13},
     {testServer,14},
     {testServer,15},
     {testServer,16},
     {testServer,17},
     {testServer,18},
     {testServer,19},
     {testServer,20},
     {testServer,21},
     {testServer,22},
     {testServer,23},
     {testServer,24},
     {testServer,25},
     {testServer,26},
     {testServer,27},
     {testServer,28},
     {testServer,29},
     {testServer,30},
     {testServer,31},
     {testServer,32},
     {testServer,33},
     {testServer,34},
     {testServer,35},
     {testServer,36},
     {testServer,37},
     {testServer,38},
     {testServer,39},
     {testServer,40},
     {testServer,41},
     {testServer,42},
     {testServer,43},
     {testServer,44},
     {testServer,45},
     {testServer,46},
     {testServer,47},
     {testServer,48},
     {testServer,49},
     {testServer,50},
     {testServer,51},
     {testServer,52},
     {testServer,53},
     {testServer,54},
     {testServer,55},
     {testServer,56},
     {testServer,57},
     {testServer,58},
     {testServer,59},
     {testServer,60},
     {testServer,61},
     {testServer,62},
     {testServer,63},
     {testServer,64},
     {testServer,65},
     {testServer,66},
     {testServer,67},
     {testServer,68},
     {testServer,69},
     {testServer,70},
     {testServer,71},
     {testServer,72},
     {testServer,73},
     {testServer,74},
     {testServer,75},
     {testServer,76},
     {testServer,77},
     {testServer,78},
     {testServer,79},
     {testServer,80},
     {testServer,81},
     {testServer,82},
     {testServer,83},
     {testServer,84},
     {testServer,85},
     {testServer,86},
     {testServer,87},
     {testServer,88},
     {testServer,89},
     {testServer,90},
     {testServer,91},
     {testServer,92},
     {testServer,93},
     {testServer,94},
     {testServer,95},
     {testServer,96},
     {testServer,97},
     {testServer,98},
     {testServer,99},
     {testServer,100},
     {testServer,101},
     {testServer,102},
     {testServer,103},
     {testServer,104},
     {testServer,105},
     {testServer,106},
     {testServer,107},
     {testServer,108},
     {testServer,109},
     {testServer,110},
     {testServer,111},
     {testServer,112},
     {testServer,113},
     {testServer,114},
     {testServer,115},
     {testServer,116},
     {testServer,117},
     {testServer,118},
     {testServer,119},
     {testServer,120},
     {testServer,121},
     {testServer,122},
     {testServer,123},
     {testServer,124},
     {testServer,125},
     {testServer,126},
     {testServer,127},
     {testServer,128},
     {testServer,129},
     {testServer,130},
     {testServer,131},
     {testServer,132},
     {testServer,133},
     {testServer,134},
     {testServer,135},
     {testServer,136},
     {testServer,137},
     {testServer,138},
     {testServer,139},
     {testServer,140},
     {testServer,141},
     {testServer,142},
     {testServer,143},
     {testServer,144},
     {testServer,145},
     {testServer,146},
     {testServer,147},
     {testServer,148},
     {testServer,149},
     {testServer,150},
     {testServer,151},
     {testServer,152},
     {testServer,153},
     {testServer,154},
     {testServer,155},
     {testServer,156},
     {testServer,157},
     {testServer,158},
     {testServer,159},
     {testServer,160},
     {testServer,161},
     {testServer,162},
     {testServer,163},
     {testServer,164},
     {testServer,165},
     {testServer,166},
     {testServer,167},
     {testServer,168},
     {testServer,169},
     {testServer,170},
     {testServer,171},
     {testServer,172},
     {testServer,173},
     {testServer,174},
     {testServer,175},
     {testServer,176},
     {testServer,177},
     {testServer,178},
     {testServer,179},
     {testServer,180},
     {testServer,181},
     {testServer,182},
     {testServer,183},
     {testServer,184},
     {testServer,185},
     {testServer,186},
     {testServer,187},
     {testServer,188},
     {testServer,189},
     {testServer,190},
     {testServer,191},
     {testServer,192},
     {testServer,193},
     {testServer,194},
     {testServer,195},
     {testServer,196},
     {testServer,197},
     {testServer,198},
     {testServer,199},
     {testServer,200},
     {testServer,201},
     {testServer,202},
     {testServer,203},
     {testServer,204},
     {testServer,205},
     {testServer,206},
     {testServer,207},
     {testServer,208},
     {testServer,209},
     {testServer,210},
     {testServer,211},
     {testServer,212},
     {testServer,213},
     {testServer,214},
     {testServer,215},
     {testServer,216},
     {testServer,217},
     {testServer,218},
     {testServer,219},
     {testServer,220},
     {testServer,221},
     {testServer,222},
     {testServer,223},
     {testServer,224},
     {testServer,225},
     {testServer,226},
     {testServer,227},
     {testServer,228},
     {testServer,229},
     {testServer,230},
     {testServer,231},
     {testServer,232},
     {testServer,233},
     {testServer,234},
     {testServer,235},
     {testServer,236},
     {testServer,237},
     {testServer,238},
     {testServer,239},
     {testServer,240},
     {testServer,241},
     {testServer,242},
     {testServer,243},
     {testServer,244},
     {testServer,245},
     {testServer,246},
     {testServer,247},
     {testServer,248},
     {testServer,249},
     {testServer,250},
     {testServer,251},
     {testServer,252},
     {testServer,253},
     {testServer,254},
     {testServer,255},
     {testServer,256},
     {testServer,257},
     {testServer,258},
     {testServer,259},
     {testServer,260},
     {testServer,261},
     {testServer,262},
     {testServer,263},
     {testServer,264},
     {testServer,265},
     {testServer,266},
     {testServer,267},
     {testServer,268},
     {testServer,269},
     {testServer,270},
     {testServer,271},
     {testServer,272},
     {testServer,273},
     {testServer,274},
     {testServer,275},
     {testServer,276},
     {testServer,277},
     {testServer,278},
     {testServer,279},
     {testServer,280},
     {testServer,281},
     {testServer,282},
     {testServer,283},
     {testServer,284},
     {testServer,285},
     {testServer,286},
     {testServer,287},
     {testServer,288},
     {testServer,289},
     {testServer,290},
     {testServer,291},
     {testServer,292},
     {testServer,293},
     {testServer,294},
     {testServer,295},
     {testServer,296},
     {testServer,297},
     {testServer,298},
     {testServer,299},
     {testServer,300},
        {NULL,0} };
}
