/*
Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.

All rights reserved. No part of this source code may be reproduced,
stored in a retrieval system, or transmitted, in any form or by any
means, electronic, mechanical, photocopying, recording or otherwise,
except as stated in the end-user licence agreement, without the prior
permission of the copyright owners.

Developed for X/Open by ApTest Ireland Limited.

 Project: VSORB
 
 File: tset/c++/include/orb_supp.h
 
 Purpose:
 
 Modifications:
 $Log: orb_supp.hh,v $
 Revision 1.5  2001/01/10 12:57:09  mli
 Add constructor with argc, argv for OrbSupport.

 Revision 1.4  2000/07/19 09:19:36  corval2
 Fixed signatures to prevent compiler warnings

 Revision 1.3  2000/07/14 13:41:57  corval2
 Added assetion as security check, fixed signature to const char *

 Revision 1.2  2000/04/05 15:56:30  mli
   o   replace in class OrbSupport attribute m_boa
       by m_poa and m_poamgr
   o   replace server_init parameter CORBA::Object by
       PortableServer::Servant
   o   use CORBA::Environment_ptr in signature
       getEvents and orbFinish
   o   use _duplicate(m_objref) in readObjref

 Revision 1.1.1.1  2000/02/09 17:17:13  mli
 Imported TOG's VSOrb 1.1.1

 Revision 1.3  1999/04/26 14:34:03  james
 Changed CORBA::Char* to char*

 Revision 1.2  1998/04/24 15:09:36  stephen
 Added Object param to server_init.

 Revision 1.1  1997/12/05 16:20:00  cwatson
 Moved orb_supp.h to orb_supp.hh.
 ir_support.hh now uses the CORBA scope.

 Revision 1.7  1997/11/27 12:06:09  cwatson
 Added client_init and server_init methods.

 Revision 1.6  1997/10/28 15:31:12  stephen
 Added setTimeout on proxy.

 Revision 1.5  1997/10/23 13:45:34  ian
 Uped timeout to 4 hours to prevent connection errors fro API tests.

 Revision 1.4  1997/10/23 13:39:46  stephen
 Set default timeout to 1 hour.

 Revision 1.3  1997/10/22 13:26:26  stephen
 Added timout to getEvents.

 Revision 1.2  1997/10/04 17:01:26  stephen
 Updated to use corba_supp.hh.

 Revision 1.1  1997/10/04 15:54:44  cwatson
 Initial version of ORB support code.

 */

#ifndef ORB_SUPP_H
#define ORB_SUPP_H

#include <stdio.h>
#include <iostream.h>
#include <corba_supp.hh>

#ifndef TRUE
#define TRUE	1
#define FALSE 0
#endif

class IOObjref {
    
  CORBA::ORB_ptr m_orb;
  char	*m_file;
  CORBA::Object_ptr	m_objref;
public:
  IOObjref(CORBA::ORB_ptr o);
  ~IOObjref();
    
  char * readString(unsigned char proxy = 0);
  CORBA::Object_ptr	readObjref(unsigned char proxy = 0);
  int	writeObjref(CORBA::Object_ptr objref);
};

class OrbSupport {

protected:

  CORBA::ORB_ptr	m_orb;
  PortableServer::POA_var	m_poa;
  PortableServer::POAManager_var m_poamgr;
  char		*m_oid;
  IOObjref		*m_io;
  CORBA::Boolean	m_statusok;
  char		*m_name;
    
public:
    
    OrbSupport(int argc, char* argv[], const char *name = 0);
  OrbSupport(const char *name = 0);
    ~OrbSupport();
    virtual void orbFinish(const char * = NULL,CORBA::Environment_ptr = NULL);
    void client_init();
    void server_init(PortableServer::Servant = NULL);

    char * readString(unsigned char proxy = 0);
    CORBA::Object_ptr	readObjref(unsigned char proxy = 0);
    int	writeObjref(CORBA::Object_ptr objref);

    char * getObjref(CORBA::Object_ptr object);
    CORBA::Object_ptr getObject(const char * objref);

    CORBA::Boolean	statusok() { return m_statusok; }
    CORBA::ORB_ptr	orb() { return m_orb; }

    // Leave a default timeout of 1 hour
    void getEvents(CORBA::Environment_ptr, CORBA::ULong timeout = 240000);
    void setTimeout(CORBA::Object *, CORBA::ULong timeout);
};

#endif

