//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <fstream.h>
#include <ir_support.hh>

IRSupport::IRSupport()
{
  m_osupp = new OrbSupport();
  if (m_osupp)
    if(!m_osupp->statusok())
        m_osupp->orbFinish("Failed to initialise ORB", NULL);
}


IRSupport::~IRSupport()
{
    delete m_osupp;
}

CORBA::Repository_ptr IRSupport::get_repository()
{
    CORBA::Repository_ptr IR_ptr;
    CORBA::ORB_ptr 	orb = m_osupp->orb();

    char *fname = getenv("IR_IOR_NAME");
    char* refFile = CORBA::string_dup(fname ? fname : "/tmp/vsir.ior");
    ifstream in;
    in.open(refFile);
    assert(!in.fail());

    char implStr[1000];
    in >> implStr;
    in.close();
    CORBA::Object_var obj = orb->string_to_object(implStr);  

    IR_ptr = CORBA::Repository::_narrow( obj);
    assert( !CORBA::is_nil( IR_ptr ) );
    return IR_ptr;
}

CORBA::Contained_ptr IRSupport::get_contained(
    CORBA::Repository_ptr ir, CORBA::ScopedName sname)
{
    return ir->lookup(sname);
}



