//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/orbsupp/samples/irdais.cpp
//
// Purpose:
//
// Modifications:
// $Log: irdais.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:17:14  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.4  1997/12/08 14:20:24  cwatson
// Now uses .hh instead of .h
//
// Revision 1.3  1997/10/22 13:21:11  stephen
// No longer need argc and argv passed in to OrbSupport obj.
//
// Revision 1.2  1997/10/07 11:54:08  cwatson
// Modified IR support.
//
// Revision 1.1  1997/10/04 15:48:32  cwatson
// Initial version of general ORB support code.
//
//

#include	<ir_support.hh>

IRSupport::IRSupport()
{
    CORBA::Environment ev;
    int argc = 1;
    char *argv[1];
    argv[0] = strdup("test");

    try {
        m_osupp = new OrbSupport();
    }
    catch (CORBA::Exception &ex) {
        ev.exception(&ex);
        m_osupp->orbFinish("Failed to initialise ORB", &ev);
    }
    if(!m_osupp->statusok())
        m_osupp->orbFinish("Failed to initialise ORB", &ev);
}

IRSupport::~IRSupport()
{
    delete m_osupp;
}

CORBA::Repository_ptr IRSupport::get_repository()
{
    CORBA::Repository_ptr IR_ptr;
    CORBA::Object_ptr     obj_ptr;
    CORBA::ORB_ptr 				orb = m_osupp->orb();
    DAIS_Trader t;

    try {
	obj_ptr = t.import("Repository","/","");
	IR_ptr = CORBA::Repository::_narrow(obj_ptr);
    }
    catch (CORBA::Exception &ex) {
        printf("system exception caught.\n");
	return (CORBA::Repository_ptr) 0;
    }
    catch (...) {
	return (CORBA::Repository_ptr) 0;
    }

    return IR_ptr;
}

CORBA::Contained_ptr IRSupport::get_contained(
    CORBA::Repository_ptr ir, CORBA::ScopedName sname)
{
    CORBA::Contained_ptr cptr;
    CORBA::RepositoryId newid = new char[1024];
    int i = 0;
    int j = 0;
    char *str;

    if(!ir)
	return (CORBA::Contained_ptr) 0;

    strcpy(newid,"IDL:");
    str = sname;
    j = 4;

    while(strstr(str,"::")){
	while(sname[i] && (sname[i] != ':')){
	    newid[j] = sname[i];
	    i++;
	    j++;
	    newid[j] = '\0';
	}
	strcat(newid,"/");
	j++;
	newid[j] = '\0';
	i += 2;
	str = &sname[i];
    }

    while(sname[i] && (sname[i] != ':')){
	newid[j] = sname[i];
	i++;
	j++;
	newid[j] = '\0';
    }
    strcat(newid,":1.0");

    try {
	cptr = ir->lookup_id(newid);
    }
    catch (CORBA::Exception &ex) {
        printf("lookup_id(%s) failed.\n",newid);
	return (CORBA::Contained_ptr) 0;
    }
    catch (...) {
	return (CORBA::Contained_ptr) 0;
    }

    return cptr;
}



