//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/orbsupp/samples/irvisi.cpp
//
// Purpose:
//
// Modifications:
// $Log: irvisi.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:17:14  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.2  1998/04/27 15:26:41  stephen
// lookup code provided.
//
// Revision 1.1  1998/04/22 12:59:16  stephen
// Intial Visigenic wrapper code.
//
//

#include <ir_support.hh>

IRSupport::IRSupport()
{
    CORBA::Environment ev;

    try {
        m_osupp = new OrbSupport();
    }
    catch (CORBA::Exception &ex) {
        ev.exception(&ex);
        m_osupp->orbFinish("Failed to initialise ORB", &ev);
    }
    if(!m_osupp->statusok())
        m_osupp->orbFinish("Failed to initialise ORB", &ev);
}

IRSupport::~IRSupport()
{
    delete m_osupp;
}

Repository_ptr IRSupport::get_repository()
{
    Repository_ptr IR_ptr;
    CORBA::Object_ptr     obj_ptr;
    CORBA::ORB_ptr 	orb = m_osupp->orb();

    try {
	IR_ptr = CORBA::Repository::_bind();
    }
    catch (CORBA::Exception &ex) {
        printf("system exception caught.\n");
	return (Repository_ptr) 0;
    }
    catch (...) {
	return (Repository_ptr) 0;
    }

    return IR_ptr;
}

Contained_ptr IRSupport::get_contained(
    Repository_ptr ir, ScopedName sname)
{
    Contained_ptr cptr;

    if(!ir)
	return (Contained_ptr) 0;
    
    try {
	cptr = ir->lookup(sname);
    }
    catch (CORBA::Exception &ex) {
        printf("system exception caught.\n");
	return (Contained_ptr) 0;
    }
    catch (...) {
	return (Contained_ptr) 0;
    }

    return cptr;
}



