//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/orbsupp/samples/odais.cpp
//
// Purpose:
//
// Modifications:
// $Log: odais.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:17:15  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1998/04/27 15:27:01  stephen
// server_init signature updated.
//
// Revision 1.6  1997/12/08 14:18:18  cwatson
// Source files now use .hh instead of .h
//
// Revision 1.5  1997/11/27 12:05:28  cwatson
// Added server_init and client_init methods.
//
// Revision 1.4  1997/11/11 13:17:33  cwatson
// Removed a non-existant WinNT include file.
//
// Revision 1.3  1997/10/28 15:31:53  stephen
// Added setTimeout on proxy object.
//
// Revision 1.2  1997/10/22 13:20:23  stephen
// Event loop implementation for IIOP testing.
//
// Revision 1.1  1997/10/04 15:48:33  cwatson
// Initial version of general ORB support code.
//
//

#include <orb_supp.hh>
#include <thread.hpp>

void
OrbSupport::getEvents(CORBA::Environment &ev, CORBA::ULong timeout)
{
    DAIS_Thread::sleep(timeout*1000);
}

void
OrbSupport::setTimeout(CORBA::Object * proxyObj, CORBA::ULong timeout)
{
    proxyObj->_timeout(timeout);
}

void
OrbSupport::client_init()
{
		return;
}

void
OrbSupport::server_init(CORBA::Object *obj)
{
		return;
}

