//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/orbsupp/samples/oorbix.cpp
//
// Purpose:
//
// Modifications:
// $Log: oorbix.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:17:15  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1998/04/27 15:27:22  stephen
// server_init() signature updated.
//
// Revision 1.6  1997/12/08 14:18:19  cwatson
// Source files now use .hh instead of .h
//
// Revision 1.5  1997/11/27 12:05:29  cwatson
// Added server_init and client_init methods.
//
// Revision 1.4  1997/10/28 15:31:53  stephen
// Added setTimeout on proxy object.
//
// Revision 1.3  1997/10/22 13:21:37  stephen
// Added timeout support.
//
// Revision 1.2  1997/10/09 15:36:44  tet
// Added infinite timeout to leave surver running for all the tests to use.
//
// Revision 1.1  1997/10/04 15:48:35  cwatson
// Initial version of general ORB support code.
//
//

#include <orb_supp.hh>

void
OrbSupport::getEvents(CORBA::Environment &ev, CORBA::ULong timeout)
{
    m_boa->impl_is_ready(m_name, timeout*1000, ev);
}

void
OrbSupport::setTimeout(CORBA::Object *proxyObj, CORBA::ULong timeout)
{
    m_orb->defaultTxTimeout(timeout*1000);
}

void
OrbSupport::client_init()
{
		return;
}

void
OrbSupport::server_init(CORBA::Object *obj)
{
		CORBA::Orbix.setServerName(m_name);
		CORBA::Orbix.impl_is_ready(m_name,0);
		CORBA::Orbix.useTransientPort(1);
		return;
}

