//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/orbsupp/samples/ovisi.cpp
//
// Purpose:
//
// Modifications:
// $Log: ovisi.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:17:15  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1998/06/18 10:08:03  stephen
// client_init changed.
//
// Revision 1.4  1998/04/27 13:58:55  stephen
// Client side timeout implemented.
//
// Revision 1.3  1998/04/27 12:49:28  stephen
// init calls implemented.
//
// Revision 1.2  1998/04/22 14:05:23  stephen
// Header needed to prototype sleep call.
//
// Revision 1.1  1998/04/22 12:59:17  stephen
// Intial Visigenic wrapper code.
//
//

#include <orb_supp.hh>
#include <unistd.h>

void
OrbSupport::getEvents(CORBA::Environment &ev, CORBA::ULong timeout)
{
    sleep(timeout);
}

void
OrbSupport::setTimeout(CORBA::Object * proxyObj, CORBA::ULong timeout)
{
    BindOptions *b = proxyObj->_default_bind_options();

    b->send_timeout = timeout;
    return;
}

void
OrbSupport::client_init()
{
    // swap out the client to ensure the proxy has
    // time to call listen 
    sleep(1);
    return;
}

void
OrbSupport::server_init(CORBA::Object *obj)
{
    m_boa->obj_is_ready(obj);
    return;
}

