//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/getany.cpp
//
// Modifications:
// $Log: getany.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:17:18  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.8  1999/04/26 14:09:34  james
// Changed CORBA::Char* to char*
//
// Revision 1.7  1998/09/04 14:49:31  james
// limit placed on number of anys in a request
//
// Revision 1.6  1997/12/15 12:09:23  james
// Final Code Regeneration
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"

//Header files generated by idl compiler
#include "tin.hh"

#include "types.hh"
extern Ernie ernie;


void GetAny(CORBA::Any &any)
{
  CORBA::ULong choice;

  ++ernie.anyCount;

  if (ernie.anyCount < 10)
    choice = ernie.getULong()%66;
  else
    choice = ernie.getULong()%11;

  switch(choice)
  {
    case   0: any <<= ernie.getULong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating ULong");
#endif
              break;
    case   1: any <<= ernie.getLong();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Long");
#endif
              break;
    case   2: any <<= ernie.getUShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating UShort");
#endif
              break;
    case   3: any <<= ernie.getShort();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Short");
#endif
              break;
    case   4: any <<= CORBA::Any::from_boolean(ernie.getBoolean());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Boolean");
#endif
              break;
    case   5: any <<= CORBA::Any::from_octet(ernie.getOctet());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Octet");
#endif
              break;
    case   6: any <<= CORBA::Any::from_char(ernie.getChar());
#ifdef DEBUG
              ::tet_infoline("GetAny creating Char");
#endif
              break;
    case   7: any <<= ernie.getFloat();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Float");
#endif
               break;
    case   8: any <<= ernie.getDouble();
#ifdef DEBUG
              ::tet_infoline("GetAny creating Double");
#endif
              break;
    case   9: any <<= ernie.getString();
#ifdef DEBUG
              ::tet_infoline("GetAny creating String");
#endif
              break;
    case  10: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating BoundedString");
#endif
                CORBA::ULong  b;
                b = ernie.getULong()%30+1;
                any <<= CORBA::Any::from_string(ernie.getString(b),b);
              }
              break;
    case   11: {
                CORBA::TypeCode_ptr _typecode;
#ifdef DEBUG
                ::tet_infoline("GetAny creating TypeCode");
#endif
                GetCORBATypeCode_ptr(_typecode);
                any <<= _typecode;
               }
                break;
    case   12: {
                CORBA::Any  _any;  
#ifdef DEBUG
                ::tet_infoline("GetAny creating Any");
#endif
                GetAny(_any);
                any <<= _any;
               }
                break;

    case  13: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Record2");
#endif
                ::Record2_forany   v(::Record2_alloc());

                GetRecord2(v);

                any  <<= v;
              }
              break;

    case  14: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Chestnut1");
#endif
                ::Chestnut1_forany   v(::Chestnut1_alloc());

                GetChestnut1(v);

                any  <<= v;
              }
              break;

    case  15: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Carrots");
#endif
                ::Carrots_forany   v(::Carrots_alloc());

                GetCarrots(v);

                any  <<= v;
              }
              break;

    case  16: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Damsons2");
#endif
                ::Damsons2_forany   v(::Damsons2_alloc());

                GetDamsons2(v);

                any  <<= v;
              }
              break;

    case  17: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mullberry1");
#endif
                ::Mullberry1_forany   v(::Mullberry1_alloc());

                GetMullberry1(v);

                any  <<= v;
              }
              break;

    case  18: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::WaterMelon3");
#endif
                ::WaterMelon3_forany   v(::WaterMelon3_alloc());

                GetWaterMelon3(v);

                any  <<= v;
              }
              break;

    case  19: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Raspberry1");
#endif
                ::Raspberry1_forany   v(::Raspberry1_alloc());

                GetRaspberry1(v);

                any  <<= v;
              }
              break;

    case  20: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Corn1");
#endif
                ::Corn1_forany   v(::Corn1_alloc());

                GetCorn1(v);

                any  <<= v;
              }
              break;

    case  21: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Pumpkin");
#endif
                ::Pumpkin_forany   v(::Pumpkin_alloc());

                GetPumpkin(v);

                any  <<= v;
              }
              break;

    case  22: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Peanuts1");
#endif
                ::Peanuts1   v;

                GetPeanuts1(v);

                any  <<= v;
              }
              break;

    case  23: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::WaterMelon");
#endif
                ::WaterMelon   v;

                GetWaterMelon(v);

                any  <<= v;
              }
              break;

    case  24: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BambooShoot3");
#endif
                ::BambooShoot3   v;

                GetBambooShoot3(v);

                any  <<= v;
              }
              break;

    case  25: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Mangosteen3");
#endif
                ::Mangosteen3   v;

                GetMangosteen3(v);

                any  <<= v;
              }
              break;

    case  26: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Currant2");
#endif
                ::Currant2   v;

                GetCurrant2(v);

                any  <<= v;
              }
              break;

    case  27: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Chives2");
#endif
                ::Chives2   v;

                GetChives2(v);

                any  <<= v;
              }
              break;

    case  28: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GardenPeas3");
#endif
                ::GardenPeas3   v;

                GetGardenPeas3(v);

                any  <<= v;
              }
              break;

    case  29: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Squash1");
#endif
                ::Squash1   v;

                GetSquash1(v);

                any  <<= v;
              }
              break;

    case  30: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::YellowPepper2");
#endif
                ::YellowPepper2   v;

                GetYellowPepper2(v);

                any  <<= v;
              }
              break;

    case  31: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Grapefruit2");
#endif
                ::Grapefruit2   v;

                GetGrapefruit2(v);

                any  <<= v;
              }
              break;

    case  32: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BlackEyedBeans");
#endif
                ::BlackEyedBeans   v;

                GetBlackEyedBeans(v);

                any  <<= v;
              }
              break;

    case  33: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GardenPeas1");
#endif
                ::GardenPeas1   v;

                GetGardenPeas1(v);

                any  <<= v;
              }
              break;

    case  34: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Celeriac2");
#endif
                ::Celeriac2   v;

                GetCeleriac2(v);

                any  <<= v;
              }
              break;

    case  35: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GoldenDelicous3");
#endif
                ::GoldenDelicous3   v;

                GetGoldenDelicous3(v);

                any  <<= v;
              }
              break;

    case  36: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Asparagus");
#endif
                ::Asparagus   v;

                GetAsparagus(v);

                any  <<= v;
              }
              break;

    case  37: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Oregano3");
#endif
                ::Oregano3   v;

                GetOregano3(v);

                any  <<= v;
              }
              break;

    case  38: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BeechNut2");
#endif
                ::BeechNut2   v;

                GetBeechNut2(v);

                any  <<= v;
              }
              break;

    case  39: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BritishQueens1");
#endif
                ::BritishQueens1   v;

                GetBritishQueens1(v);

                any  <<= v;
              }
              break;

    case  40: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::BrazilNut3");
#endif
                ::BrazilNut3   v;

                GetBrazilNut3(v);

                any  <<= v;
              }
              break;

    case  41: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::LoganBerry");
#endif
                ::LoganBerry   v;

                GetLoganBerry(v);

                any  <<= v;
              }
              break;

    case  42: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Lychees3");
#endif
                ::Lychees3   v;

                GetLychees3(v);

                any  <<= v;
              }
              break;

    case  43: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Cauliflower2");
#endif
                ::Cauliflower2   v;

                GetCauliflower2(v);

                any  <<= v;
              }
              break;

    case  44: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Beetroot2");
#endif
                ::Beetroot2   v;

                GetBeetroot2(v);

                any  <<= v;
              }
              break;

    case  45: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Fig");
#endif
                ::Fig   v;

                GetFig(v);

                any  <<= v;
              }
              break;

    case  46: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::IcebergLettuce2");
#endif
                ::IcebergLettuce2   v;

                GetIcebergLettuce2(v);

                any  <<= v;
              }
              break;

    case  47: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Clementine2");
#endif
                ::Clementine2   v;

                GetClementine2(v);

                any  <<= v;
              }
              break;

    case  48: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Susander2");
#endif
                ::Susander2   v;

                GetSusander2(v);

                any  <<= v;
              }
              break;

    case  49: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Blackberry2");
#endif
                ::Blackberry2   v;

                GetBlackberry2(v);

                any  <<= v;
              }
              break;

    case  50: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Peppercorn");
#endif
                ::Peppercorn   v;

                GetPeppercorn(v);

                any  <<= v;
              }
              break;

    case  51: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Tomato2");
#endif
                ::Tomato2   v;

                GetTomato2(v);

                any  <<= v;
              }
              break;

    case  52: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Fennell3");
#endif
                ::Fennell3   v;

                GetFennell3(v);

                any  <<= v;
              }
              break;

    case  53: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Rasin2");
#endif
                ::Rasin2   v;

                GetRasin2(v);

                any  <<= v;
              }
              break;

    case  54: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Dates3");
#endif
                ::Dates3   v;

                GetDates3(v);

                any  <<= v;
              }
              break;

    case  55: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Squash2");
#endif
                ::Squash2   v;

                GetSquash2(v);

                any  <<= v;
              }
              break;

    case  56: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::GaliaMelon3");
#endif
                ::GaliaMelon3   v;

                GetGaliaMelon3(v);

                any  <<= v;
              }
              break;

    case  57: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Turnip3");
#endif
                ::Turnip3   v;

                GetTurnip3(v);

                any  <<= v;
              }
              break;

    case  58: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Tomato");
#endif
                ::Tomato   v;

                GetTomato(v);

                any  <<= v;
              }
              break;

    case  59: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating ::Radish");
#endif
                ::Radish   v;

                GetRadish(v);

                any  <<= v;
              }
              break;

    case  60: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating char*");
#endif
                char*   v;

                Getstring_4(v);

                any <<= CORBA::Any::from_string(v,4)
;
              }
              break;

    case  61: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating char*");
#endif
                char*   v;

                Getstring_20(v);

                any <<= CORBA::Any::from_string(v,20)
;
              }
              break;

    case  62: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating char*");
#endif
                char*   v;

                Getstring_12(v);

                any <<= CORBA::Any::from_string(v,12)
;
              }
              break;

    case  63: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating char*");
#endif
                char*   v;

                Getstring_46(v);

                any <<= CORBA::Any::from_string(v,46)
;
              }
              break;

    case  64: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating char*");
#endif
                char*   v;

                Getstring_43(v);

                any <<= CORBA::Any::from_string(v,43)
;
              }
              break;

    case  65: {
#ifdef DEBUG
                ::tet_infoline("GetAny creating char*");
#endif
                char*   v;

                Getstring_25(v);

                any <<= CORBA::Any::from_string(v,25)
;
              }
              break;

  }
}
