//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/gettypecode.cpp
//
// Modifications:
// $Log: gettypecode.cpp,v $
// Revision 1.3  2000/07/28 15:12:49  corval2
// Preliminary fixes for gettypecode switch
//
// Revision 1.2  2000/07/17 09:15:23  corval2
// Removed wrong tests (see also iIOP tests for)
//
// Revision 1.1.1.1  2000/02/09 17:17:18  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.8  1999/05/10 12:24:50  stephen
// Added duplicate call af EOF.
//
// Revision 1.7  1998/09/04 14:59:33  james
// small change in how typecode are choosen
//
// Revision 1.6  1997/12/15 12:09:25  james
// Final Code Regeneration
//
//
//

#include <stdio.h>
#include <assert.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

extern Ernie ernie;
extern OrbSupport * orb;

void GetCORBATypeCode_ptr(CORBA::TypeCode_ptr &tc)
{
  switch(ernie.getULong()%59 /*66*/)
  {
    case   0: tc = CORBA::_tc_ulong;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ULong");
#endif
              break;
    case   1: tc = CORBA::_tc_long;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating Long");
#endif
              break;
    case   2: tc = CORBA::_tc_ushort;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating UShort");
#endif
              break;
    case   3: tc = CORBA::_tc_short;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating Short");
#endif
              break;
    case   4: tc = CORBA::_tc_boolean;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating Boolean");
#endif
              break;
    case   5: tc = CORBA::_tc_octet;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating Octet");
#endif
              break;
    case   6: tc = CORBA::_tc_char;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating Char");
#endif
              break;
    case   7: tc = CORBA::_tc_float;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating Float");
#endif
               break;
    case   8: tc = CORBA::_tc_double;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating Double");
#endif
              break;
    case   9: tc = CORBA::_tc_string;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating String");
#endif
              break;
    case  10: {
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating BoundedString");
#endif
                tc = orb->orb()->create_string_tc(ernie.getULong()%30+1);
              }
              break;
    case   11: tc = CORBA::_tc_TypeCode;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating TypeCode");
#endif
              break;
    case   12: tc = CORBA::_tc_any;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating Any");
#endif
              break;

    case  13: tc = ::_tc_Record2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Record2");
#endif
              break;

    case  14: tc = ::_tc_Chestnut1;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Chestnut1");
#endif
              break;

    case  15: tc = ::_tc_Carrots;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Carrots");
#endif
              break;

    case  16: tc = ::_tc_Damsons2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Damsons2");
#endif
              break;

    case  17: tc = ::_tc_Mullberry1;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Mullberry1");
#endif
              break;

    case  18: tc = ::_tc_WaterMelon3;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_WaterMelon3");
#endif
              break;

    case  19: tc = ::_tc_Raspberry1;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Raspberry1");
#endif
              break;

    case  20: tc = ::_tc_Corn1;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Corn1");
#endif
              break;

    case  21: tc = ::_tc_Pumpkin;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Pumpkin");
#endif
              break;

    case  22: tc = ::_tc_Peanuts1;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Peanuts1");
#endif
              break;

    case  23: tc = ::_tc_WaterMelon;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_WaterMelon");
#endif
              break;

    case  24: tc = ::_tc_BambooShoot3;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_BambooShoot3");
#endif
              break;

    case  25: tc = ::_tc_Mangosteen3;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Mangosteen3");
#endif
              break;

    case  26: tc = ::_tc_Currant2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Currant2");
#endif
              break;

    case  27: tc = ::_tc_Chives2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Chives2");
#endif
              break;

    case  28: tc = ::_tc_GardenPeas3;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_GardenPeas3");
#endif
              break;

    case  29: tc = ::_tc_Squash1;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Squash1");
#endif
              break;

    case  30: tc = ::_tc_YellowPepper2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_YellowPepper2");
#endif
              break;

    case  31: tc = ::_tc_Grapefruit2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Grapefruit2");
#endif
              break;

    case  32: tc = ::_tc_BlackEyedBeans;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_BlackEyedBeans");
#endif
              break;

    case  33: tc = ::_tc_GardenPeas1;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_GardenPeas1");
#endif
              break;

    case  34: tc = ::_tc_Celeriac2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Celeriac2");
#endif
              break;

    case  35: tc = ::_tc_GoldenDelicous3;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_GoldenDelicous3");
#endif
              break;

    case  36: tc = ::_tc_Asparagus;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Asparagus");
#endif
              break;

    case  37: tc = ::_tc_Oregano3;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Oregano3");
#endif
              break;

    case  38: tc = ::_tc_BeechNut2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_BeechNut2");
#endif
              break;

    case  39: tc = ::_tc_BritishQueens1;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_BritishQueens1");
#endif
              break;

    case  40: tc = ::_tc_BrazilNut3;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_BrazilNut3");
#endif
              break;

    case  41: tc = ::_tc_LoganBerry;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_LoganBerry");
#endif
              break;

    case  42: tc = ::_tc_Lychees3;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Lychees3");
#endif
              break;

    case  43: tc = ::_tc_Cauliflower2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Cauliflower2");
#endif
              break;

    case  44: tc = ::_tc_Beetroot2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Beetroot2");
#endif
              break;

    case  45: tc = ::_tc_Fig;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Fig");
#endif
              break;

    case  46: tc = ::_tc_IcebergLettuce2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_IcebergLettuce2");
#endif
              break;

    case  47: tc = ::_tc_Clementine2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Clementine2");
#endif
              break;

    case  48: tc = ::_tc_Susander2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Susander2");
#endif
              break;

    case  49: tc = ::_tc_Blackberry2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Blackberry2");
#endif
              break;

    case  50: tc = ::_tc_Peppercorn;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Peppercorn");
#endif
              break;

    case  51: tc = ::_tc_Tomato2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Tomato2");
#endif
              break;

    case  52: tc = ::_tc_Fennell3;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Fennell3");
#endif
              break;

    case  53: tc = ::_tc_Rasin2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Rasin2");
#endif
              break;

    case  54: tc = ::_tc_Dates3;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Dates3");
#endif
              break;

    case  55: tc = ::_tc_Squash2;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Squash2");
#endif
              break;

    case  56: tc = ::_tc_GaliaMelon3;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_GaliaMelon3");
#endif
              break;

    case  57: tc = ::_tc_Turnip3;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Turnip3");
#endif
              break;

    case  58: tc = ::_tc_Tomato;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Tomato");
#endif
              break;

    case  59: tc = ::_tc_Radish;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating ::_tc_Radish");
#endif
              break;

/* Generation of TypeCode constant for bounded string types
is neither defined in mapping for string types nor in mapping
for TypeCode.

    case  60: tc = _tc_string_4;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating _tc_string_4");
#endif
              break;

    case  61: tc = _tc_string_20;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating _tc_string_20");
#endif
              break;

    case  62: tc = _tc_string_12;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating _tc_string_12");
#endif
              break;

    case  63: tc = _tc_string_46;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating _tc_string_46");
#endif
              break;

    case  64: tc = _tc_string_43;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating _tc_string_43");
#endif
              break;

    case  65: tc = _tc_string_25;
#ifdef DEBUG
              ::tet_infoline("GetTypeCode creating _tc_string_25");
#endif
              break;
*/

    default:
              assert(false);

  }
  tc = CORBA::TypeCode::_duplicate(tc);
}
