//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/types.hh
//
// Modifications:
// $Log: types.hh,v $
// Revision 1.2  2000/07/19 09:53:27  corval2
// Changed signatures to const char * to prevent compiler warnings
//
// Revision 1.1.1.1  2000/02/09 17:17:19  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1999/04/26 14:09:37  james
// Changed CORBA::Char* to char*
//
// Revision 1.6  1998/09/04 14:46:06  james
// const removed from CheckString_.. functions
//
// Revision 1.5  1997/12/15 12:09:30  james
// Final Code Regeneration
//
//
//

void AddName(const char*);
void RemoveName(void);

void GetULong(CORBA::ULong &);
int CheckULong(const CORBA::ULong);
void GetLong(CORBA::Long &);
int CheckLong(const CORBA::Long);
void GetUShort(CORBA::UShort &);
int CheckUShort(const CORBA::UShort);
void GetShort(CORBA::Short &);
int CheckShort(const CORBA::Short);
void GetBoolean(CORBA::Boolean &);
int CheckBoolean(const CORBA::Boolean);
void GetOctet(CORBA::Octet &);
int CheckOctet(const CORBA::Octet);
void GetChar(CORBA::Char &);
int CheckChar(const CORBA::Char);
void GetFloat(CORBA::Float &);
int CheckFloat(const CORBA::Float);
int CompareFloats(float one, float two);
void GetDouble(CORBA::Double &);
int CheckDouble(const CORBA::Double);
int CompareDoubles(double one,double two);
char * GetString();
int CheckString(const char*);
int CheckString(char*);
char * GetString(int);
int CheckString(const char*,int);
int CheckString(char*,int);
void GetAny(CORBA::Any &);
int CheckAny(const CORBA::Any &);
CORBA::Object_ptr Getobject(void);
int Checkobject(CORBA::Object_ptr v);
void GetCORBATypeCode_ptr(CORBA::TypeCode_ptr &);
int CheckCORBATypeCode_ptr(const CORBA::TypeCode_ptr &);

void GetRecord2(::Record2 );
int CheckRecord2(const ::Record2 );
void GetChestnut1(::Chestnut1 );
int CheckChestnut1(const ::Chestnut1 );
void GetCarrots(::Carrots );
int CheckCarrots(const ::Carrots );
void GetDamsons2(::Damsons2 );
int CheckDamsons2(const ::Damsons2 );
void GetMullberry1(::Mullberry1 );
int CheckMullberry1(const ::Mullberry1 );
void GetWaterMelon3(::WaterMelon3 );
int CheckWaterMelon3(const ::WaterMelon3 );
void GetRaspberry1(::Raspberry1 );
int CheckRaspberry1(const ::Raspberry1 );
void GetCorn1(::Corn1 );
int CheckCorn1(const ::Corn1 );
void GetPumpkin(::Pumpkin );
int CheckPumpkin(const ::Pumpkin );
void GetPeanuts1(::Peanuts1 &);
int CheckPeanuts1(const ::Peanuts1 &);
void GetWaterMelon(::WaterMelon &);
int CheckWaterMelon(const ::WaterMelon &);
void GetBambooShoot3(::BambooShoot3 &);
int CheckBambooShoot3(const ::BambooShoot3 &);
void GetMangosteen3(::Mangosteen3 &);
int CheckMangosteen3(const ::Mangosteen3 &);
void GetCurrant2(::Currant2 &);
int CheckCurrant2(const ::Currant2 &);
void GetChives2(::Chives2 &);
int CheckChives2(const ::Chives2 &);
void GetGardenPeas3(::GardenPeas3 &);
int CheckGardenPeas3(const ::GardenPeas3 &);
void GetSquash1(::Squash1 &);
int CheckSquash1(const ::Squash1 &);
void GetYellowPepper2(::YellowPepper2 &);
int CheckYellowPepper2(const ::YellowPepper2 &);
void GetGrapefruit2(::Grapefruit2 &);
int CheckGrapefruit2(const ::Grapefruit2 &);
void GetBlackEyedBeans(::BlackEyedBeans &);
int CheckBlackEyedBeans(const ::BlackEyedBeans &);
void GetGardenPeas1(::GardenPeas1 &);
int CheckGardenPeas1(const ::GardenPeas1 &);
void GetCeleriac2(::Celeriac2 &);
int CheckCeleriac2(const ::Celeriac2 &);
void GetGoldenDelicous3(::GoldenDelicous3 &);
int CheckGoldenDelicous3(const ::GoldenDelicous3 &);
void GetAsparagus(::Asparagus &);
int CheckAsparagus(const ::Asparagus &);
void GetOregano3(::Oregano3 &);
int CheckOregano3(const ::Oregano3 &);
void GetBeechNut2(::BeechNut2 &);
int CheckBeechNut2(const ::BeechNut2 &);
void GetBritishQueens1(::BritishQueens1 &);
int CheckBritishQueens1(const ::BritishQueens1 &);
void GetBrazilNut3(::BrazilNut3 &);
int CheckBrazilNut3(const ::BrazilNut3 &);
void GetLoganBerry(::LoganBerry &);
int CheckLoganBerry(const ::LoganBerry &);
void GetLychees3(::Lychees3 &);
int CheckLychees3(const ::Lychees3 &);
void GetCauliflower2(::Cauliflower2 &);
int CheckCauliflower2(const ::Cauliflower2 &);
void GetBeetroot2(::Beetroot2 &);
int CheckBeetroot2(const ::Beetroot2 &);
void GetFig(::Fig &);
int CheckFig(const ::Fig &);
void GetIcebergLettuce2(::IcebergLettuce2 &);
int CheckIcebergLettuce2(const ::IcebergLettuce2 &);
void GetClementine2(::Clementine2 &);
int CheckClementine2(const ::Clementine2 &);
void GetSusander2(::Susander2 &);
int CheckSusander2(const ::Susander2 &);
void GetBlackberry2(::Blackberry2 &);
int CheckBlackberry2(const ::Blackberry2 &);
void GetPeppercorn(::Peppercorn &);
int CheckPeppercorn(const ::Peppercorn &);
void GetTomato2(::Tomato2 &);
int CheckTomato2(const ::Tomato2 &);
void GetFennell3(::Fennell3 &);
int CheckFennell3(const ::Fennell3 &);
void GetRasin2(::Rasin2 &);
int CheckRasin2(const ::Rasin2 &);
void GetDates3(::Dates3 &);
int CheckDates3(const ::Dates3 &);
void GetSquash2(::Squash2 &);
int CheckSquash2(const ::Squash2 &);
void GetGaliaMelon3(::GaliaMelon3 &);
int CheckGaliaMelon3(const ::GaliaMelon3 &);
void GetTurnip3(::Turnip3 &);
int CheckTurnip3(const ::Turnip3 &);
void GetTomato(::Tomato &);
int CheckTomato(const ::Tomato &);
void GetBlackcurrant3(::Blackcurrant3 &);
int CheckBlackcurrant3(const ::Blackcurrant3 &);
void GetDamsons3(::Damsons3 &);
int CheckDamsons3(const ::Damsons3 &);
void GetRaspberry3(::Raspberry3 &);
int CheckRaspberry3(const ::Raspberry3 &);
void GetPeppercorn3(::Peppercorn3 &);
int CheckPeppercorn3(const ::Peppercorn3 &);
void GetCherry3(::Cherry3 &);
int CheckCherry3(const ::Cherry3 &);
void GetCherryTomatoes3(::CherryTomatoes3 &);
int CheckCherryTomatoes3(const ::CherryTomatoes3 &);
void GetPapaya3(::Papaya3 &);
int CheckPapaya3(const ::Papaya3 &);
void GetSharanfruit3(::Sharanfruit3 &);
int CheckSharanfruit3(const ::Sharanfruit3 &);
void GetElderberry3(::Elderberry3 &);
int CheckElderberry3(const ::Elderberry3 &);
void GetPeanutsquash3(::Peanutsquash3 &);
int CheckPeanutsquash3(const ::Peanutsquash3 &);
void GetRadish(::Radish &);
int CheckRadish(const ::Radish &);
void Getstring_4(char* &);
int Checkstring_4(char* &);
void Getstring_20(char* &);
int Checkstring_20(char* &);
void Getstring_12(char* &);
int Checkstring_12(char* &);
void Getstring_46(char* &);
int Checkstring_46(char* &);
void Getstring_43(char* &);
int Checkstring_43(char* &);
void Getstring_25(char* &);
int Checkstring_25(char* &);

