//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/any.cpp
//
// Modifications:
// $Log: types.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:16:32  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.8  1999/04/26 13:51:27  james
// Changed CORBA::Char* to char*
//
// Revision 1.7  1998/08/24 11:46:40  james
// ENV updates
//
// Revision 1.6  1997/12/15 10:51:52  james
// #ifdefs removed
//
// Revision 1.5  1997/12/12 08:58:00  james
// Code Regenerated
//
//
//

#include <stdio.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "ernie.hh"
#include "tin.hh"
#include "types.hh"

Ernie ernie;

extern char *stringifiedIOR;
extern OrbSupport *orb;

char  name[1024]={'\0'};

void AddName(char *p)
{
  if (strlen(name))
    strcat(name,".");
  strcat(name,p);
}

void RemoveName()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '.';
    --i)
    ;
 
  name[i] = '\0';
}

void AddIndex(int i)
{
	sprintf(name+strlen(name),"[%d]",i);
}

void RemoveIndex()
{
  int i;
 
  for (i = strlen(name);
    i > 0
      && name[i] != '[';
    --i)
    ;
 
  name[i] = '\0';
}

void GetULong(CORBA::ULong &v)
{
  v = ernie.getULong();
}

int CheckULong(const CORBA::ULong v)
{
  if (!ernie.checkULong(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getULongAgain(),v);
    return 0;
  }
  return 1;
}

void GetLong(CORBA::Long &v)
{
  v = ernie.getLong();
}

int CheckLong(const CORBA::Long v)
{
  if (!ernie.checkLong(v))
  {
    tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getLongAgain(),v);
    return 0;
  }
  return 1;
}

void GetUShort(CORBA::UShort &v)
{
  v = ernie.getUShort();
}

int CheckUShort(const CORBA::UShort v)
{
  if (!ernie.checkUShort(v))
  {
    tet_printf("Expected %s to contain %u, but found %u instead.",
      name,ernie.getUShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetShort(CORBA::Short &v)
{
  v = ernie.getShort();
}

int CheckShort(const CORBA::Short v)
{
  if (!ernie.checkShort(v))
  {
    ::tet_printf("Expected %s to contain %d, but found %d instead.",
      name,ernie.getShortAgain(),v);
    return 0;
  }
  return 1;
}

void GetBoolean(CORBA::Boolean &v)
{
  v = ernie.getBoolean();
}

int CheckBoolean(const CORBA::Boolean v)
{
  if (!ernie.checkBoolean(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,BooleanToString(ernie.getBooleanAgain()),BooleanToString(v));
    return 0;
  }
  return 1;
}

void GetOctet(CORBA::Octet &v)
{
  v = ernie.getOctet();
}

int CheckOctet(const CORBA::Octet v)
{
  if (!ernie.checkOctet(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,OctetToString(ernie.getOctetAgain()),OctetToString(v));
    return 0;
  }
  return 1;
}

void GetChar(CORBA::Char &v)
{
  v = ernie.getChar();
}

int CheckChar(const CORBA::Char v)
{
  if (!ernie.checkChar(v))
  {
    ::tet_printf("Expected %s to contain %s, but found %s instead.",
      name,CharToString(ernie.getCharAgain()),CharToString(v));
    return 0;
  }
  return 1;
}

void GetFloat(CORBA::Float &v)
{
  v = ernie.getFloat();
}

int CheckFloat(const CORBA::Float v)
{
  if (!ernie.checkFloat(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getFloatAgain(),v);
    return 0;
  }
  return 1;
}

int CompareFloats(float one, float two)
{
	float	delta;
	float	min;
	float max;

	delta = two/1000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

void GetDouble(CORBA::Double &v)
{
  v = ernie.getDouble();
}

int CheckDouble(const CORBA::Double v)
{
  if (!ernie.checkDouble(v))
  {
    tet_printf("Expected %s to contain %g, but found %g instead.",
      name,ernie.getDoubleAgain(),v);
    return 0;
  }
  return 1;
}

int CompareDoubles(double one,double two)
{
	double	delta;
	double	min;
	double	max;

	delta = two/100000;
	if (delta < 0.0)
		delta = -delta;

	max = two + delta;
	min = two - delta;

	return ((one >= min) && (one <= max));
}

char *GetString()
{
  char *v;
  v =CORBA::string_dup(ernie.getString());
  return v;
}

int CheckString(char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v)
{
  if (!ernie.checkString(v))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}


char *GetString(int b)
{
  char *v;
  v =CORBA::string_dup(ernie.getString(b));
  return v;
}

int CheckString(char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

int CheckString(const char * v,int b)
{
  if (!ernie.checkString(v,b))
  {
    tet_printf("Expected %s to contain %s, but found %s instead.",
      name,ernie.getStringAgain(),v);
    return 0;
  }
  return 1;
}

CORBA::Object_ptr Getobject()
{
  CORBA::Object_ptr v;
  v = orb->getObject(stringifiedIOR);
  return v;
}

int Checkobject(CORBA::Object_ptr v)
{
  char *s = 0;

  s = orb->getObjref(v);

  if (s == 0)
  {
    tet_printf("_object_to_string failed on Object reference %s.", name);
    return 0;
  }
#ifdef DEBUG
  tet_printf("_object_to_string returned %s",s);
#endif

  return 1;
}


 
void GetRadish22(::Radish22 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetRadish22");
#endif

  ::Sharanfruit22 Sharanfruit22Array[3] = {::BeefTomatoes22,::RedPepper22,::FrenchBeans22};
  v = Sharanfruit22Array[ernie.getULong()%3];
}

int CheckRadish22(const ::Radish22 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRadish22");
#endif

  ::Sharanfruit22 Sharanfruit22Array[3] = {::BeefTomatoes22,::RedPepper22,::FrenchBeans22};
  if (v != Sharanfruit22Array[ernie.getULong()%3])
  {
    ::tet_printf("ERROR: %s has incorrect value",name);
    ::tet_printf("Expected %d, but found %d instead", Sharanfruit22Array[ernie.getULongAgain()%3],v);
    iRetCode = 0;
  }
  return iRetCode;
}

 
void GetSharanfruit22(::Sharanfruit22 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSharanfruit22");
#endif

  ::Sharanfruit22 Sharanfruit22Array[3] = {::BeefTomatoes22,::RedPepper22,::FrenchBeans22};
  v = Sharanfruit22Array[ernie.getULong()%3];
}

int CheckSharanfruit22(const ::Sharanfruit22 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSharanfruit22");
#endif

  ::Sharanfruit22 Sharanfruit22Array[3] = {::BeefTomatoes22,::RedPepper22,::FrenchBeans22};
  if (v != Sharanfruit22Array[ernie.getULong()%3])
  {
    ::tet_printf("ERROR: %s has incorrect value",name);
    ::tet_printf("Expected %d, but found %d instead", Sharanfruit22Array[ernie.getULongAgain()%3],v);
    iRetCode = 0;
  }
  return iRetCode;
}

 
void GetTarragon23(::Tarragon23 v)
{
#ifdef DEBUG
  ::tet_infoline("GetTarragon23");
#endif

  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%13;
            v[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetSharanfruit22(v[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckTarragon23(const ::Tarragon23 v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckTarragon23");
#endif

  {
    int	i1;
    for(i1=0; i1 < 15; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%13;
            if (l5 != v[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckSharanfruit22(v[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  return iRetCode;
}

 
void GetButterBean24(::ButterBean24 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetButterBean24");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.KidneyBean24.Shallots24.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%11;
        v.KidneyBean24.Shallots24[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetBoolean(v.KidneyBean24.Shallots24[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckButterBean24(const ::ButterBean24 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckButterBean24");
#endif

  AddName("KidneyBean24");
  AddName("Shallots24");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.KidneyBean24.Shallots24.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.KidneyBean24.Shallots24.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%11;
        if (l3 != v.KidneyBean24.Shallots24[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.KidneyBean24.Shallots24[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckBoolean(v.KidneyBean24.Shallots24[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetZucchini24(::Zucchini24 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetZucchini24");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.KidneyBean24.Shallots24.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%11;
        v.KidneyBean24.Shallots24[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetBoolean(v.KidneyBean24.Shallots24[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckZucchini24(const ::Zucchini24 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckZucchini24");
#endif

  AddName("KidneyBean24");
  AddName("Shallots24");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.KidneyBean24.Shallots24.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.KidneyBean24.Shallots24.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%11;
        if (l3 != v.KidneyBean24.Shallots24[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.KidneyBean24.Shallots24[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckBoolean(v.KidneyBean24.Shallots24[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetZucchini24Plum24(::Zucchini24::Plum24 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetZucchini24Plum24");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Shallots24.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%11;
        v.Shallots24[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          GetBoolean(v.Shallots24[i1][i3]);
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckZucchini24Plum24(const ::Zucchini24::Plum24 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckZucchini24Plum24");
#endif

  AddName("Shallots24");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Shallots24.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Shallots24.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%11;
        if (l3 != v.Shallots24[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Shallots24[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          if (!CheckBoolean(v.Shallots24[i1][i3]))
            iRetCode = 0;
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetDill25(::Dill25 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetDill25");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.Aniseed25.Celery25[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Aniseed25.Celery25[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Aniseed25.Celery25[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.Aniseed25.Celery25[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckDill25(const ::Dill25 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckDill25");
#endif

  AddName("Aniseed25");
  AddName("Celery25");
  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.Aniseed25.Celery25[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Aniseed25.Celery25[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Aniseed25.Celery25[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Aniseed25.Celery25[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Aniseed25.Celery25[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Aniseed25.Celery25[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.Aniseed25.Celery25[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetBayleaf25(::Bayleaf25 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBayleaf25");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.Aniseed25.Celery25[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Aniseed25.Celery25[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Aniseed25.Celery25[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.Aniseed25.Celery25[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBayleaf25(const ::Bayleaf25 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBayleaf25");
#endif

  AddName("Aniseed25");
  AddName("Celery25");
  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.Aniseed25.Celery25[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Aniseed25.Celery25[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Aniseed25.Celery25[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Aniseed25.Celery25[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Aniseed25.Celery25[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Aniseed25.Celery25[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.Aniseed25.Celery25[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetBayleaf25WhiteCabbage25(::Bayleaf25::WhiteCabbage25 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBayleaf25WhiteCabbage25");
#endif

  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.Celery25[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Celery25[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Celery25[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.Celery25[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBayleaf25WhiteCabbage25(const ::Bayleaf25::WhiteCabbage25 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBayleaf25WhiteCabbage25");
#endif

  AddName("Celery25");
  {
    int	i1;
    for(i1=0; i1 < 10; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.Celery25[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Celery25[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Celery25[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Celery25[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Celery25[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Celery25[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.Celery25[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetWaterMelon26(::WaterMelon26 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetWaterMelon26");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%19;
    v.Pumpkin26.Rhubarb26.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Pumpkin26.Rhubarb26[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Pumpkin26.Rhubarb26[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetDouble(v.Pumpkin26.Rhubarb26[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckWaterMelon26(const ::WaterMelon26 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckWaterMelon26");
#endif

  AddName("Pumpkin26");
  AddName("Rhubarb26");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%19;
    if (l1 != v.Pumpkin26.Rhubarb26.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Pumpkin26.Rhubarb26.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Pumpkin26.Rhubarb26[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Pumpkin26.Rhubarb26[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Pumpkin26.Rhubarb26[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Pumpkin26.Rhubarb26[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckDouble(v.Pumpkin26.Rhubarb26[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetMango26(::Mango26 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMango26");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%19;
    v.Pumpkin26.Rhubarb26.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Pumpkin26.Rhubarb26[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Pumpkin26.Rhubarb26[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetDouble(v.Pumpkin26.Rhubarb26[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMango26(const ::Mango26 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMango26");
#endif

  AddName("Pumpkin26");
  AddName("Rhubarb26");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%19;
    if (l1 != v.Pumpkin26.Rhubarb26.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Pumpkin26.Rhubarb26.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Pumpkin26.Rhubarb26[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Pumpkin26.Rhubarb26[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Pumpkin26.Rhubarb26[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Pumpkin26.Rhubarb26[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckDouble(v.Pumpkin26.Rhubarb26[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetMango26PassionFruit26(::Mango26::PassionFruit26 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMango26PassionFruit26");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%19;
    v.Rhubarb26.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Rhubarb26[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Rhubarb26[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetDouble(v.Rhubarb26[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMango26PassionFruit26(const ::Mango26::PassionFruit26 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMango26PassionFruit26");
#endif

  AddName("Rhubarb26");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%19;
    if (l1 != v.Rhubarb26.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Rhubarb26.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Rhubarb26[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Rhubarb26[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Rhubarb26[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Rhubarb26[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckDouble(v.Rhubarb26[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetRecord26(::Record26 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetRecord26");
#endif

  {
    int	i1;
    for(i1=0; i1 < 12; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Broadbeans26.RedCabbage26[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Broadbeans26.RedCabbage26[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Broadbeans26.RedCabbage26[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetLong(v.Broadbeans26.RedCabbage26[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckRecord26(const ::Record26 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRecord26");
#endif

  AddName("Broadbeans26");
  AddName("RedCabbage26");
  {
    int	i1;
    for(i1=0; i1 < 12; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Broadbeans26.RedCabbage26[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Broadbeans26.RedCabbage26[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Broadbeans26.RedCabbage26[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Broadbeans26.RedCabbage26[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Broadbeans26.RedCabbage26[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Broadbeans26.RedCabbage26[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckLong(v.Broadbeans26.RedCabbage26[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetPotato26(::Potato26 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetPotato26");
#endif

  {
    int	i1;
    for(i1=0; i1 < 12; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Broadbeans26.RedCabbage26[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Broadbeans26.RedCabbage26[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Broadbeans26.RedCabbage26[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetLong(v.Broadbeans26.RedCabbage26[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckPotato26(const ::Potato26 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPotato26");
#endif

  AddName("Broadbeans26");
  AddName("RedCabbage26");
  {
    int	i1;
    for(i1=0; i1 < 12; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Broadbeans26.RedCabbage26[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Broadbeans26.RedCabbage26[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Broadbeans26.RedCabbage26[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Broadbeans26.RedCabbage26[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Broadbeans26.RedCabbage26[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Broadbeans26.RedCabbage26[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckLong(v.Broadbeans26.RedCabbage26[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetPotato26ChineseLeaves26(::Potato26::ChineseLeaves26 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetPotato26ChineseLeaves26");
#endif

  {
    int	i1;
    for(i1=0; i1 < 12; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.RedCabbage26[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.RedCabbage26[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.RedCabbage26[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetLong(v.RedCabbage26[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckPotato26ChineseLeaves26(const ::Potato26::ChineseLeaves26 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPotato26ChineseLeaves26");
#endif

  AddName("RedCabbage26");
  {
    int	i1;
    for(i1=0; i1 < 12; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.RedCabbage26[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.RedCabbage26[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.RedCabbage26[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.RedCabbage26[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.RedCabbage26[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.RedCabbage26[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckLong(v.RedCabbage26[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetBlackberry27(::Blackberry27 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBlackberry27");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.CoxPippin27.Peanuts27.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.CoxPippin27.Peanuts27[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.CoxPippin27.Peanuts27[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetShort(v.CoxPippin27.Peanuts27[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBlackberry27(const ::Blackberry27 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBlackberry27");
#endif

  AddName("CoxPippin27");
  AddName("Peanuts27");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.CoxPippin27.Peanuts27.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.CoxPippin27.Peanuts27.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.CoxPippin27.Peanuts27[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.CoxPippin27.Peanuts27[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.CoxPippin27.Peanuts27[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.CoxPippin27.Peanuts27[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckShort(v.CoxPippin27.Peanuts27[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetBlueberry27(::Blueberry27 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBlueberry27");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.CoxPippin27.Peanuts27.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.CoxPippin27.Peanuts27[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.CoxPippin27.Peanuts27[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetShort(v.CoxPippin27.Peanuts27[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBlueberry27(const ::Blueberry27 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBlueberry27");
#endif

  AddName("CoxPippin27");
  AddName("Peanuts27");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.CoxPippin27.Peanuts27.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.CoxPippin27.Peanuts27.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.CoxPippin27.Peanuts27[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.CoxPippin27.Peanuts27[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.CoxPippin27.Peanuts27[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.CoxPippin27.Peanuts27[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckShort(v.CoxPippin27.Peanuts27[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetBlueberry27Basil27(::Blueberry27::Basil27 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBlueberry27Basil27");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Peanuts27.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Peanuts27[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Peanuts27[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetShort(v.Peanuts27[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBlueberry27Basil27(const ::Blueberry27::Basil27 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBlueberry27Basil27");
#endif

  AddName("Peanuts27");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Peanuts27.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Peanuts27.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Peanuts27[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Peanuts27[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Peanuts27[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Peanuts27[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckShort(v.Peanuts27[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetGrapefruit28(::Grapefruit28 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGrapefruit28");
#endif

  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.Susander28.Papaya28[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%9;
            v.Susander28.Papaya28[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%6;
                v.Susander28.Papaya28[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetShort(v.Susander28.Papaya28[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckGrapefruit28(const ::Grapefruit28 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGrapefruit28");
#endif

  AddName("Susander28");
  AddName("Papaya28");
  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.Susander28.Papaya28[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Susander28.Papaya28[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%9;
            if (l5 != v.Susander28.Papaya28[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Susander28.Papaya28[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%6;
                if (l7 != v.Susander28.Papaya28[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Susander28.Papaya28[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckShort(v.Susander28.Papaya28[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetRaspberry28(::Raspberry28 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetRaspberry28");
#endif

  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.Susander28.Papaya28[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%9;
            v.Susander28.Papaya28[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%6;
                v.Susander28.Papaya28[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetShort(v.Susander28.Papaya28[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckRaspberry28(const ::Raspberry28 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRaspberry28");
#endif

  AddName("Susander28");
  AddName("Papaya28");
  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.Susander28.Papaya28[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Susander28.Papaya28[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%9;
            if (l5 != v.Susander28.Papaya28[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Susander28.Papaya28[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%6;
                if (l7 != v.Susander28.Papaya28[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Susander28.Papaya28[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckShort(v.Susander28.Papaya28[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetRaspberry28Peppercorn28(::Raspberry28::Peppercorn28 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetRaspberry28Peppercorn28");
#endif

  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        v.Papaya28[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%9;
            v.Papaya28[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%6;
                v.Papaya28[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetShort(v.Papaya28[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckRaspberry28Peppercorn28(const ::Raspberry28::Peppercorn28 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRaspberry28Peppercorn28");
#endif

  AddName("Papaya28");
  {
    int	i1;
    for(i1=0; i1 < 4; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%7;
        if (l3 != v.Papaya28[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Papaya28[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%9;
            if (l5 != v.Papaya28[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Papaya28[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%6;
                if (l7 != v.Papaya28[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Papaya28[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckShort(v.Papaya28[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetKumquats29(::Kumquats29 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetKumquats29");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.BeechNut29.Melon29.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%5;
        v.BeechNut29.Melon29[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%5;
            v.BeechNut29.Melon29[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetULong(v.BeechNut29.Melon29[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckKumquats29(const ::Kumquats29 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckKumquats29");
#endif

  AddName("BeechNut29");
  AddName("Melon29");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.BeechNut29.Melon29.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.BeechNut29.Melon29.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%5;
        if (l3 != v.BeechNut29.Melon29[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.BeechNut29.Melon29[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%5;
            if (l5 != v.BeechNut29.Melon29[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.BeechNut29.Melon29[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckULong(v.BeechNut29.Melon29[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetElderberry29(::Elderberry29 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetElderberry29");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.BeechNut29.Melon29.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%5;
        v.BeechNut29.Melon29[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%5;
            v.BeechNut29.Melon29[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetULong(v.BeechNut29.Melon29[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckElderberry29(const ::Elderberry29 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckElderberry29");
#endif

  AddName("BeechNut29");
  AddName("Melon29");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.BeechNut29.Melon29.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.BeechNut29.Melon29.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%5;
        if (l3 != v.BeechNut29.Melon29[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.BeechNut29.Melon29[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%5;
            if (l5 != v.BeechNut29.Melon29[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.BeechNut29.Melon29[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckULong(v.BeechNut29.Melon29[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetElderberry29RedGrapes29(::Elderberry29::RedGrapes29 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetElderberry29RedGrapes29");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Melon29.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%5;
        v.Melon29[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%5;
            v.Melon29[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetULong(v.Melon29[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckElderberry29RedGrapes29(const ::Elderberry29::RedGrapes29 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckElderberry29RedGrapes29");
#endif

  AddName("Melon29");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Melon29.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Melon29.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%5;
        if (l3 != v.Melon29[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Melon29[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%5;
            if (l5 != v.Melon29[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Melon29[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckULong(v.Melon29[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetRedOnion30(::RedOnion30 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetRedOnion30");
#endif

  {
    int	i1;
    for(i1=0; i1 < 17; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Fig30.GoldenDelicous30[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Fig30.GoldenDelicous30[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                v.Fig30.GoldenDelicous30[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetUShort(v.Fig30.GoldenDelicous30[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckRedOnion30(const ::RedOnion30 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRedOnion30");
#endif

  AddName("Fig30");
  AddName("GoldenDelicous30");
  {
    int	i1;
    for(i1=0; i1 < 17; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Fig30.GoldenDelicous30[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Fig30.GoldenDelicous30[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Fig30.GoldenDelicous30[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Fig30.GoldenDelicous30[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                if (l7 != v.Fig30.GoldenDelicous30[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Fig30.GoldenDelicous30[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckUShort(v.Fig30.GoldenDelicous30[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetCrabApple30(::CrabApple30 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCrabApple30");
#endif

  {
    int	i1;
    for(i1=0; i1 < 17; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Fig30.GoldenDelicous30[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Fig30.GoldenDelicous30[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                v.Fig30.GoldenDelicous30[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetUShort(v.Fig30.GoldenDelicous30[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCrabApple30(const ::CrabApple30 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCrabApple30");
#endif

  AddName("Fig30");
  AddName("GoldenDelicous30");
  {
    int	i1;
    for(i1=0; i1 < 17; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Fig30.GoldenDelicous30[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Fig30.GoldenDelicous30[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Fig30.GoldenDelicous30[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Fig30.GoldenDelicous30[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                if (l7 != v.Fig30.GoldenDelicous30[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Fig30.GoldenDelicous30[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckUShort(v.Fig30.GoldenDelicous30[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetCrabApple30Lentil30(::CrabApple30::Lentil30 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCrabApple30Lentil30");
#endif

  {
    int	i1;
    for(i1=0; i1 < 17; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.GoldenDelicous30[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GoldenDelicous30[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                v.GoldenDelicous30[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetUShort(v.GoldenDelicous30[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCrabApple30Lentil30(const ::CrabApple30::Lentil30 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCrabApple30Lentil30");
#endif

  AddName("GoldenDelicous30");
  {
    int	i1;
    for(i1=0; i1 < 17; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.GoldenDelicous30[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GoldenDelicous30[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GoldenDelicous30[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GoldenDelicous30[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%9;
                if (l7 != v.GoldenDelicous30[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GoldenDelicous30[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckUShort(v.GoldenDelicous30[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetRunnerbean31(::Runnerbean31 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetRunnerbean31");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Guava31.Beansprout31.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%6;
        v.Guava31.Beansprout31[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%6;
            v.Guava31.Beansprout31[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetChar(v.Guava31.Beansprout31[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckRunnerbean31(const ::Runnerbean31 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRunnerbean31");
#endif

  AddName("Guava31");
  AddName("Beansprout31");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Guava31.Beansprout31.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Guava31.Beansprout31.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%6;
        if (l3 != v.Guava31.Beansprout31[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Guava31.Beansprout31[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%6;
            if (l5 != v.Guava31.Beansprout31[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Guava31.Beansprout31[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckChar(v.Guava31.Beansprout31[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetMushroom31(::Mushroom31 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMushroom31");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Guava31.Beansprout31.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%6;
        v.Guava31.Beansprout31[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%6;
            v.Guava31.Beansprout31[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetChar(v.Guava31.Beansprout31[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMushroom31(const ::Mushroom31 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMushroom31");
#endif

  AddName("Guava31");
  AddName("Beansprout31");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Guava31.Beansprout31.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Guava31.Beansprout31.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%6;
        if (l3 != v.Guava31.Beansprout31[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Guava31.Beansprout31[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%6;
            if (l5 != v.Guava31.Beansprout31[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Guava31.Beansprout31[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckChar(v.Guava31.Beansprout31[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetMushroom31Almonds31(::Mushroom31::Almonds31 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMushroom31Almonds31");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Beansprout31.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%6;
        v.Beansprout31[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%6;
            v.Beansprout31[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetChar(v.Beansprout31[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMushroom31Almonds31(const ::Mushroom31::Almonds31 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMushroom31Almonds31");
#endif

  AddName("Beansprout31");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Beansprout31.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Beansprout31.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%6;
        if (l3 != v.Beansprout31[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Beansprout31[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%6;
            if (l5 != v.Beansprout31[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Beansprout31[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckChar(v.Beansprout31[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetCucumber32(::Cucumber32 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCucumber32");
#endif

  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%15;
        v.Lychees32.Dates32[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Lychees32.Dates32[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                v.Lychees32.Dates32[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetBoolean(v.Lychees32.Dates32[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCucumber32(const ::Cucumber32 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCucumber32");
#endif

  AddName("Lychees32");
  AddName("Dates32");
  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%15;
        if (l3 != v.Lychees32.Dates32[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Lychees32.Dates32[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Lychees32.Dates32[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Lychees32.Dates32[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                if (l7 != v.Lychees32.Dates32[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Lychees32.Dates32[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckBoolean(v.Lychees32.Dates32[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetCabbage32(::Cabbage32 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCabbage32");
#endif

  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%15;
        v.Lychees32.Dates32[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Lychees32.Dates32[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                v.Lychees32.Dates32[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetBoolean(v.Lychees32.Dates32[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCabbage32(const ::Cabbage32 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCabbage32");
#endif

  AddName("Lychees32");
  AddName("Dates32");
  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%15;
        if (l3 != v.Lychees32.Dates32[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Lychees32.Dates32[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Lychees32.Dates32[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Lychees32.Dates32[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                if (l7 != v.Lychees32.Dates32[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Lychees32.Dates32[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckBoolean(v.Lychees32.Dates32[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetCabbage32Coconut32(::Cabbage32::Coconut32 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCabbage32Coconut32");
#endif

  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%15;
        v.Dates32[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Dates32[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                v.Dates32[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetBoolean(v.Dates32[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCabbage32Coconut32(const ::Cabbage32::Coconut32 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCabbage32Coconut32");
#endif

  AddName("Dates32");
  {
    int	i1;
    for(i1=0; i1 < 11; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%15;
        if (l3 != v.Dates32[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Dates32[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Dates32[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Dates32[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%18;
                if (l7 != v.Dates32[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Dates32[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckBoolean(v.Dates32[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetGoldenWonder32(::GoldenWonder32 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGoldenWonder32");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%14;
    v.Balmoral32.BritishQueens32.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Balmoral32.BritishQueens32[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            v.Balmoral32.BritishQueens32[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetOctet(v.Balmoral32.BritishQueens32[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckGoldenWonder32(const ::GoldenWonder32 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGoldenWonder32");
#endif

  AddName("Balmoral32");
  AddName("BritishQueens32");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%14;
    if (l1 != v.Balmoral32.BritishQueens32.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Balmoral32.BritishQueens32.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Balmoral32.BritishQueens32[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Balmoral32.BritishQueens32[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            if (l5 != v.Balmoral32.BritishQueens32[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Balmoral32.BritishQueens32[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckOctet(v.Balmoral32.BritishQueens32[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetKerrsPinks32(::KerrsPinks32 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetKerrsPinks32");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%14;
    v.Balmoral32.BritishQueens32.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Balmoral32.BritishQueens32[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            v.Balmoral32.BritishQueens32[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetOctet(v.Balmoral32.BritishQueens32[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckKerrsPinks32(const ::KerrsPinks32 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckKerrsPinks32");
#endif

  AddName("Balmoral32");
  AddName("BritishQueens32");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%14;
    if (l1 != v.Balmoral32.BritishQueens32.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Balmoral32.BritishQueens32.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Balmoral32.BritishQueens32[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Balmoral32.BritishQueens32[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            if (l5 != v.Balmoral32.BritishQueens32[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Balmoral32.BritishQueens32[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckOctet(v.Balmoral32.BritishQueens32[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetKerrsPinks32Wilja32(::KerrsPinks32::Wilja32 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetKerrsPinks32Wilja32");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%14;
    v.BritishQueens32.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.BritishQueens32[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            v.BritishQueens32[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              GetOctet(v.BritishQueens32[i1][i3][i5]);
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckKerrsPinks32Wilja32(const ::KerrsPinks32::Wilja32 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckKerrsPinks32Wilja32");
#endif

  AddName("BritishQueens32");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%14;
    if (l1 != v.BritishQueens32.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.BritishQueens32.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.BritishQueens32[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.BritishQueens32[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%7;
            if (l5 != v.BritishQueens32[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.BritishQueens32[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              if (!CheckOctet(v.BritishQueens32[i1][i3][i5]))
                iRetCode = 0;
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetCurrant33(::Currant33 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCurrant33");
#endif

  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Scallion33.GreenPepper33[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Scallion33.GreenPepper33[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%11;
                v.Scallion33.GreenPepper33[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Scallion33.GreenPepper33[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v.Scallion33.GreenPepper33[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCurrant33(const ::Currant33 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCurrant33");
#endif

  AddName("Scallion33");
  AddName("GreenPepper33");
  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Scallion33.GreenPepper33[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Scallion33.GreenPepper33[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Scallion33.GreenPepper33[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Scallion33.GreenPepper33[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%11;
                if (l7 != v.Scallion33.GreenPepper33[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Scallion33.GreenPepper33[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Scallion33.GreenPepper33[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Scallion33.GreenPepper33[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v.Scallion33.GreenPepper33[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetPricklyPear33(::PricklyPear33 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetPricklyPear33");
#endif

  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Scallion33.GreenPepper33[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Scallion33.GreenPepper33[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%11;
                v.Scallion33.GreenPepper33[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Scallion33.GreenPepper33[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v.Scallion33.GreenPepper33[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckPricklyPear33(const ::PricklyPear33 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPricklyPear33");
#endif

  AddName("Scallion33");
  AddName("GreenPepper33");
  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Scallion33.GreenPepper33[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Scallion33.GreenPepper33[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Scallion33.GreenPepper33[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Scallion33.GreenPepper33[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%11;
                if (l7 != v.Scallion33.GreenPepper33[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Scallion33.GreenPepper33[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Scallion33.GreenPepper33[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Scallion33.GreenPepper33[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v.Scallion33.GreenPepper33[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetPricklyPear33VineTomatoes33(::PricklyPear33::VineTomatoes33 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetPricklyPear33VineTomatoes33");
#endif

  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.GreenPepper33[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.GreenPepper33[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%11;
                v.GreenPepper33[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.GreenPepper33[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetFloat(v.GreenPepper33[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckPricklyPear33VineTomatoes33(const ::PricklyPear33::VineTomatoes33 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPricklyPear33VineTomatoes33");
#endif

  AddName("GreenPepper33");
  {
    int	i1;
    for(i1=0; i1 < 5; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.GreenPepper33[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GreenPepper33[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.GreenPepper33[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GreenPepper33[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%11;
                if (l7 != v.GreenPepper33[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GreenPepper33[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.GreenPepper33[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.GreenPepper33[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckFloat(v.GreenPepper33[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetGreenGrapes34(::GreenGrapes34 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGreenGrapes34");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.CherryTomatoes34.Damsons34.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.CherryTomatoes34.Damsons34[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%16;
            v.CherryTomatoes34.Damsons34[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                v.CherryTomatoes34.Damsons34[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.CherryTomatoes34.Damsons34[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckGreenGrapes34(const ::GreenGrapes34 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGreenGrapes34");
#endif

  AddName("CherryTomatoes34");
  AddName("Damsons34");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.CherryTomatoes34.Damsons34.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.CherryTomatoes34.Damsons34.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.CherryTomatoes34.Damsons34[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.CherryTomatoes34.Damsons34[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%16;
            if (l5 != v.CherryTomatoes34.Damsons34[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.CherryTomatoes34.Damsons34[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                if (l7 != v.CherryTomatoes34.Damsons34[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.CherryTomatoes34.Damsons34[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.CherryTomatoes34.Damsons34[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetArtichokes34(::Artichokes34 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetArtichokes34");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.CherryTomatoes34.Damsons34.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.CherryTomatoes34.Damsons34[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%16;
            v.CherryTomatoes34.Damsons34[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                v.CherryTomatoes34.Damsons34[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.CherryTomatoes34.Damsons34[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckArtichokes34(const ::Artichokes34 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckArtichokes34");
#endif

  AddName("CherryTomatoes34");
  AddName("Damsons34");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.CherryTomatoes34.Damsons34.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.CherryTomatoes34.Damsons34.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.CherryTomatoes34.Damsons34[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.CherryTomatoes34.Damsons34[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%16;
            if (l5 != v.CherryTomatoes34.Damsons34[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.CherryTomatoes34.Damsons34[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                if (l7 != v.CherryTomatoes34.Damsons34[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.CherryTomatoes34.Damsons34[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.CherryTomatoes34.Damsons34[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetArtichokes34Peanutsquash34(::Artichokes34::Peanutsquash34 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetArtichokes34Peanutsquash34");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Damsons34.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Damsons34[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%16;
            v.Damsons34[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                v.Damsons34[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetFloat(v.Damsons34[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckArtichokes34Peanutsquash34(const ::Artichokes34::Peanutsquash34 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckArtichokes34Peanutsquash34");
#endif

  AddName("Damsons34");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Damsons34.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Damsons34.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Damsons34[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Damsons34[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%16;
            if (l5 != v.Damsons34[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Damsons34[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                if (l7 != v.Damsons34[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Damsons34[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckFloat(v.Damsons34[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetBeetroot35(::Beetroot35 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBeetroot35");
#endif

  {
    int	i1;
    for(i1=0; i1 < 14; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%5;
        v.Waterchestnut35.Fennell35[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%4;
            v.Waterchestnut35.Fennell35[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Waterchestnut35.Fennell35[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Waterchestnut35.Fennell35[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetDouble(v.Waterchestnut35.Fennell35[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBeetroot35(const ::Beetroot35 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBeetroot35");
#endif

  AddName("Waterchestnut35");
  AddName("Fennell35");
  {
    int	i1;
    for(i1=0; i1 < 14; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%5;
        if (l3 != v.Waterchestnut35.Fennell35[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Waterchestnut35.Fennell35[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%4;
            if (l5 != v.Waterchestnut35.Fennell35[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Waterchestnut35.Fennell35[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Waterchestnut35.Fennell35[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Waterchestnut35.Fennell35[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Waterchestnut35.Fennell35[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Waterchestnut35.Fennell35[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckDouble(v.Waterchestnut35.Fennell35[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetChickpea35(::Chickpea35 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetChickpea35");
#endif

  {
    int	i1;
    for(i1=0; i1 < 14; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%5;
        v.Waterchestnut35.Fennell35[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%4;
            v.Waterchestnut35.Fennell35[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Waterchestnut35.Fennell35[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Waterchestnut35.Fennell35[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetDouble(v.Waterchestnut35.Fennell35[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckChickpea35(const ::Chickpea35 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckChickpea35");
#endif

  AddName("Waterchestnut35");
  AddName("Fennell35");
  {
    int	i1;
    for(i1=0; i1 < 14; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%5;
        if (l3 != v.Waterchestnut35.Fennell35[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Waterchestnut35.Fennell35[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%4;
            if (l5 != v.Waterchestnut35.Fennell35[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Waterchestnut35.Fennell35[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Waterchestnut35.Fennell35[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Waterchestnut35.Fennell35[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Waterchestnut35.Fennell35[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Waterchestnut35.Fennell35[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckDouble(v.Waterchestnut35.Fennell35[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetChickpea35Uglifruit35(::Chickpea35::Uglifruit35 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetChickpea35Uglifruit35");
#endif

  {
    int	i1;
    for(i1=0; i1 < 14; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%5;
        v.Fennell35[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%4;
            v.Fennell35[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Fennell35[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Fennell35[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetDouble(v.Fennell35[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckChickpea35Uglifruit35(const ::Chickpea35::Uglifruit35 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckChickpea35Uglifruit35");
#endif

  AddName("Fennell35");
  {
    int	i1;
    for(i1=0; i1 < 14; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%5;
        if (l3 != v.Fennell35[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Fennell35[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%4;
            if (l5 != v.Fennell35[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Fennell35[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Fennell35[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Fennell35[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Fennell35[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Fennell35[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckDouble(v.Fennell35[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetCloves36(::Cloves36 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCloves36");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%7;
    v.EggPlant36.Cinnamon36.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%11;
        v.EggPlant36.Cinnamon36[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.EggPlant36.Cinnamon36[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                v.EggPlant36.Cinnamon36[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetDouble(v.EggPlant36.Cinnamon36[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCloves36(const ::Cloves36 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCloves36");
#endif

  AddName("EggPlant36");
  AddName("Cinnamon36");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%7;
    if (l1 != v.EggPlant36.Cinnamon36.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.EggPlant36.Cinnamon36.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%11;
        if (l3 != v.EggPlant36.Cinnamon36[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.EggPlant36.Cinnamon36[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.EggPlant36.Cinnamon36[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.EggPlant36.Cinnamon36[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                if (l7 != v.EggPlant36.Cinnamon36[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.EggPlant36.Cinnamon36[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckDouble(v.EggPlant36.Cinnamon36[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetJuniperBerries36(::JuniperBerries36 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetJuniperBerries36");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%7;
    v.EggPlant36.Cinnamon36.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%11;
        v.EggPlant36.Cinnamon36[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.EggPlant36.Cinnamon36[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                v.EggPlant36.Cinnamon36[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetDouble(v.EggPlant36.Cinnamon36[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckJuniperBerries36(const ::JuniperBerries36 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckJuniperBerries36");
#endif

  AddName("EggPlant36");
  AddName("Cinnamon36");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%7;
    if (l1 != v.EggPlant36.Cinnamon36.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.EggPlant36.Cinnamon36.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%11;
        if (l3 != v.EggPlant36.Cinnamon36[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.EggPlant36.Cinnamon36[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.EggPlant36.Cinnamon36[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.EggPlant36.Cinnamon36[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                if (l7 != v.EggPlant36.Cinnamon36[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.EggPlant36.Cinnamon36[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckDouble(v.EggPlant36.Cinnamon36[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetJuniperBerries36GooseBerry36(::JuniperBerries36::GooseBerry36 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetJuniperBerries36GooseBerry36");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%7;
    v.Cinnamon36.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%11;
        v.Cinnamon36[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Cinnamon36[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                v.Cinnamon36[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetDouble(v.Cinnamon36[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckJuniperBerries36GooseBerry36(const ::JuniperBerries36::GooseBerry36 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckJuniperBerries36GooseBerry36");
#endif

  AddName("Cinnamon36");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%7;
    if (l1 != v.Cinnamon36.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Cinnamon36.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%11;
        if (l3 != v.Cinnamon36[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Cinnamon36[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Cinnamon36[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Cinnamon36[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%2;
                if (l7 != v.Cinnamon36[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Cinnamon36[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckDouble(v.Cinnamon36[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetSweetPotato37(::SweetPotato37 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSweetPotato37");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.GrannySmith37.Prunes37[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%14;
            v.GrannySmith37.Prunes37[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.GrannySmith37.Prunes37[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.GrannySmith37.Prunes37[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetLong(v.GrannySmith37.Prunes37[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckSweetPotato37(const ::SweetPotato37 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSweetPotato37");
#endif

  AddName("GrannySmith37");
  AddName("Prunes37");
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.GrannySmith37.Prunes37[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GrannySmith37.Prunes37[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%14;
            if (l5 != v.GrannySmith37.Prunes37[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GrannySmith37.Prunes37[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.GrannySmith37.Prunes37[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GrannySmith37.Prunes37[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.GrannySmith37.Prunes37[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.GrannySmith37.Prunes37[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckLong(v.GrannySmith37.Prunes37[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetBrazilNut37(::BrazilNut37 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBrazilNut37");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.GrannySmith37.Prunes37[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%14;
            v.GrannySmith37.Prunes37[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.GrannySmith37.Prunes37[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.GrannySmith37.Prunes37[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetLong(v.GrannySmith37.Prunes37[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBrazilNut37(const ::BrazilNut37 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBrazilNut37");
#endif

  AddName("GrannySmith37");
  AddName("Prunes37");
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.GrannySmith37.Prunes37[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.GrannySmith37.Prunes37[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%14;
            if (l5 != v.GrannySmith37.Prunes37[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.GrannySmith37.Prunes37[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.GrannySmith37.Prunes37[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.GrannySmith37.Prunes37[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.GrannySmith37.Prunes37[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.GrannySmith37.Prunes37[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckLong(v.GrannySmith37.Prunes37[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetBrazilNut37Brocoli37(::BrazilNut37::Brocoli37 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetBrazilNut37Brocoli37");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Prunes37[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%14;
            v.Prunes37[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Prunes37[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Prunes37[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetLong(v.Prunes37[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckBrazilNut37Brocoli37(const ::BrazilNut37::Brocoli37 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckBrazilNut37Brocoli37");
#endif

  AddName("Prunes37");
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Prunes37[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Prunes37[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%14;
            if (l5 != v.Prunes37[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Prunes37[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Prunes37[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Prunes37[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Prunes37[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Prunes37[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckLong(v.Prunes37[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetGardenPeas38(::GardenPeas38 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetGardenPeas38");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Leek38.Apricots38.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%16;
        v.Leek38.Apricots38[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Leek38.Apricots38[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%1;
                v.Leek38.Apricots38[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetLong(v.Leek38.Apricots38[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckGardenPeas38(const ::GardenPeas38 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckGardenPeas38");
#endif

  AddName("Leek38");
  AddName("Apricots38");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Leek38.Apricots38.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Leek38.Apricots38.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%16;
        if (l3 != v.Leek38.Apricots38[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Leek38.Apricots38[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Leek38.Apricots38[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Leek38.Apricots38[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%1;
                if (l7 != v.Leek38.Apricots38[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Leek38.Apricots38[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckLong(v.Leek38.Apricots38[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetMint38(::Mint38 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMint38");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Leek38.Apricots38.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%16;
        v.Leek38.Apricots38[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Leek38.Apricots38[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%1;
                v.Leek38.Apricots38[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetLong(v.Leek38.Apricots38[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMint38(const ::Mint38 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMint38");
#endif

  AddName("Leek38");
  AddName("Apricots38");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Leek38.Apricots38.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Leek38.Apricots38.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%16;
        if (l3 != v.Leek38.Apricots38[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Leek38.Apricots38[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Leek38.Apricots38[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Leek38.Apricots38[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%1;
                if (l7 != v.Leek38.Apricots38[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Leek38.Apricots38[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckLong(v.Leek38.Apricots38[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetMint38BlackEyedBeans38(::Mint38::BlackEyedBeans38 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMint38BlackEyedBeans38");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Apricots38.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%16;
        v.Apricots38[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Apricots38[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%1;
                v.Apricots38[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetLong(v.Apricots38[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMint38BlackEyedBeans38(const ::Mint38::BlackEyedBeans38 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMint38BlackEyedBeans38");
#endif

  AddName("Apricots38");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Apricots38.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Apricots38.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%16;
        if (l3 != v.Apricots38[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Apricots38[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Apricots38[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Apricots38[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%1;
                if (l7 != v.Apricots38[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Apricots38[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckLong(v.Apricots38[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetKingEdward38(::KingEdward38 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetKingEdward38");
#endif

  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%8;
        v.MarisPiper38.Cultra38[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.MarisPiper38.Cultra38[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.MarisPiper38.Cultra38[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.MarisPiper38.Cultra38[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetShort(v.MarisPiper38.Cultra38[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckKingEdward38(const ::KingEdward38 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckKingEdward38");
#endif

  AddName("MarisPiper38");
  AddName("Cultra38");
  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%8;
        if (l3 != v.MarisPiper38.Cultra38[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.MarisPiper38.Cultra38[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.MarisPiper38.Cultra38[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.MarisPiper38.Cultra38[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.MarisPiper38.Cultra38[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.MarisPiper38.Cultra38[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.MarisPiper38.Cultra38[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.MarisPiper38.Cultra38[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckShort(v.MarisPiper38.Cultra38[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetCara38(::Cara38 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCara38");
#endif

  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%8;
        v.MarisPiper38.Cultra38[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.MarisPiper38.Cultra38[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.MarisPiper38.Cultra38[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.MarisPiper38.Cultra38[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetShort(v.MarisPiper38.Cultra38[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCara38(const ::Cara38 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCara38");
#endif

  AddName("MarisPiper38");
  AddName("Cultra38");
  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%8;
        if (l3 != v.MarisPiper38.Cultra38[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.MarisPiper38.Cultra38[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.MarisPiper38.Cultra38[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.MarisPiper38.Cultra38[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.MarisPiper38.Cultra38[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.MarisPiper38.Cultra38[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.MarisPiper38.Cultra38[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.MarisPiper38.Cultra38[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckShort(v.MarisPiper38.Cultra38[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetCara38Rooster38(::Cara38::Rooster38 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetCara38Rooster38");
#endif

  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%8;
        v.Cultra38[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Cultra38[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Cultra38[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Cultra38[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetShort(v.Cultra38[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckCara38Rooster38(const ::Cara38::Rooster38 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckCara38Rooster38");
#endif

  AddName("Cultra38");
  {
    int	i1;
    for(i1=0; i1 < 8; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%8;
        if (l3 != v.Cultra38[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Cultra38[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Cultra38[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Cultra38[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Cultra38[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Cultra38[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Cultra38[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Cultra38[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckShort(v.Cultra38[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetPippinApple39(::PippinApple39 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetPippinApple39");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Tomato39.IcebergLettuce39.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Tomato39.IcebergLettuce39[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Tomato39.IcebergLettuce39[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%5;
                v.Tomato39.IcebergLettuce39[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetShort(v.Tomato39.IcebergLettuce39[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckPippinApple39(const ::PippinApple39 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckPippinApple39");
#endif

  AddName("Tomato39");
  AddName("IcebergLettuce39");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Tomato39.IcebergLettuce39.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Tomato39.IcebergLettuce39.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Tomato39.IcebergLettuce39[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Tomato39.IcebergLettuce39[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Tomato39.IcebergLettuce39[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Tomato39.IcebergLettuce39[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%5;
                if (l7 != v.Tomato39.IcebergLettuce39[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Tomato39.IcebergLettuce39[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckShort(v.Tomato39.IcebergLettuce39[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetChayato39(::Chayato39 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetChayato39");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Tomato39.IcebergLettuce39.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Tomato39.IcebergLettuce39[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Tomato39.IcebergLettuce39[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%5;
                v.Tomato39.IcebergLettuce39[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetShort(v.Tomato39.IcebergLettuce39[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckChayato39(const ::Chayato39 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckChayato39");
#endif

  AddName("Tomato39");
  AddName("IcebergLettuce39");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Tomato39.IcebergLettuce39.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Tomato39.IcebergLettuce39.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Tomato39.IcebergLettuce39[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Tomato39.IcebergLettuce39[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Tomato39.IcebergLettuce39[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Tomato39.IcebergLettuce39[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%5;
                if (l7 != v.Tomato39.IcebergLettuce39[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Tomato39.IcebergLettuce39[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckShort(v.Tomato39.IcebergLettuce39[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetChayato39KiwanoMelon39(::Chayato39::KiwanoMelon39 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetChayato39KiwanoMelon39");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.IcebergLettuce39.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.IcebergLettuce39[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.IcebergLettuce39[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%5;
                v.IcebergLettuce39[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetShort(v.IcebergLettuce39[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckChayato39KiwanoMelon39(const ::Chayato39::KiwanoMelon39 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckChayato39KiwanoMelon39");
#endif

  AddName("IcebergLettuce39");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.IcebergLettuce39.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.IcebergLettuce39.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.IcebergLettuce39[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.IcebergLettuce39[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.IcebergLettuce39[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.IcebergLettuce39[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%5;
                if (l7 != v.IcebergLettuce39[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.IcebergLettuce39[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckShort(v.IcebergLettuce39[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetYam40(::Yam40 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetYam40");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Mullberry40.CookingApple40[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Mullberry40.CookingApple40[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Mullberry40.CookingApple40[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Mullberry40.CookingApple40[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetULong(v.Mullberry40.CookingApple40[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckYam40(const ::Yam40 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckYam40");
#endif

  AddName("Mullberry40");
  AddName("CookingApple40");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Mullberry40.CookingApple40[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Mullberry40.CookingApple40[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Mullberry40.CookingApple40[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Mullberry40.CookingApple40[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Mullberry40.CookingApple40[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Mullberry40.CookingApple40[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Mullberry40.CookingApple40[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Mullberry40.CookingApple40[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckULong(v.Mullberry40.CookingApple40[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetEddo40(::Eddo40 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetEddo40");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Mullberry40.CookingApple40[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Mullberry40.CookingApple40[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Mullberry40.CookingApple40[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.Mullberry40.CookingApple40[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetULong(v.Mullberry40.CookingApple40[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckEddo40(const ::Eddo40 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckEddo40");
#endif

  AddName("Mullberry40");
  AddName("CookingApple40");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Mullberry40.CookingApple40[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Mullberry40.CookingApple40[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Mullberry40.CookingApple40[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Mullberry40.CookingApple40[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Mullberry40.CookingApple40[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Mullberry40.CookingApple40[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.Mullberry40.CookingApple40[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Mullberry40.CookingApple40[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckULong(v.Mullberry40.CookingApple40[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetEddo40Chives40(::Eddo40::Chives40 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetEddo40Chives40");
#endif

  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.CookingApple40[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.CookingApple40[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.CookingApple40[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    v.CookingApple40[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetULong(v.CookingApple40[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckEddo40Chives40(const ::Eddo40::Chives40 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckEddo40Chives40");
#endif

  AddName("CookingApple40");
  {
    int	i1;
    for(i1=0; i1 < 7; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.CookingApple40[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.CookingApple40[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.CookingApple40[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.CookingApple40[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.CookingApple40[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.CookingApple40[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%3;
                    if (l9 != v.CookingApple40[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.CookingApple40[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckULong(v.CookingApple40[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetMangosteen41(::Mangosteen41 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetMangosteen41");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Pineapple41.Plantain41.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Pineapple41.Plantain41[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Pineapple41.Plantain41[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%6;
                v.Pineapple41.Plantain41[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetULong(v.Pineapple41.Plantain41[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckMangosteen41(const ::Mangosteen41 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckMangosteen41");
#endif

  AddName("Pineapple41");
  AddName("Plantain41");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Pineapple41.Plantain41.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Pineapple41.Plantain41.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Pineapple41.Plantain41[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Pineapple41.Plantain41[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Pineapple41.Plantain41[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Pineapple41.Plantain41[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%6;
                if (l7 != v.Pineapple41.Plantain41[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Pineapple41.Plantain41[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckULong(v.Pineapple41.Plantain41[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetLimaBean41(::LimaBean41 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLimaBean41");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Pineapple41.Plantain41.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Pineapple41.Plantain41[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Pineapple41.Plantain41[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%6;
                v.Pineapple41.Plantain41[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetULong(v.Pineapple41.Plantain41[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLimaBean41(const ::LimaBean41 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLimaBean41");
#endif

  AddName("Pineapple41");
  AddName("Plantain41");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Pineapple41.Plantain41.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Pineapple41.Plantain41.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Pineapple41.Plantain41[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Pineapple41.Plantain41[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Pineapple41.Plantain41[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Pineapple41.Plantain41[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%6;
                if (l7 != v.Pineapple41.Plantain41[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Pineapple41.Plantain41[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckULong(v.Pineapple41.Plantain41[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetLimaBean41Blackcurrant41(::LimaBean41::Blackcurrant41 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetLimaBean41Blackcurrant41");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Plantain41.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        v.Plantain41[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            v.Plantain41[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%6;
                v.Plantain41[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetULong(v.Plantain41[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckLimaBean41Blackcurrant41(const ::LimaBean41::Blackcurrant41 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckLimaBean41Blackcurrant41");
#endif

  AddName("Plantain41");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Plantain41.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Plantain41.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%3;
        if (l3 != v.Plantain41[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Plantain41[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%3;
            if (l5 != v.Plantain41[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Plantain41[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%6;
                if (l7 != v.Plantain41[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Plantain41[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckULong(v.Plantain41[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetSweedes42(::Sweedes42 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSweedes42");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%14;
        v.BreadFruit42.Mustard42[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            v.BreadFruit42.Mustard42[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.BreadFruit42.Mustard42[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%5;
                    v.BreadFruit42.Mustard42[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetULong(v.BreadFruit42.Mustard42[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckSweedes42(const ::Sweedes42 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSweedes42");
#endif

  AddName("BreadFruit42");
  AddName("Mustard42");
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%14;
        if (l3 != v.BreadFruit42.Mustard42[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.BreadFruit42.Mustard42[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            if (l5 != v.BreadFruit42.Mustard42[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.BreadFruit42.Mustard42[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.BreadFruit42.Mustard42[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.BreadFruit42.Mustard42[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%5;
                    if (l9 != v.BreadFruit42.Mustard42[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.BreadFruit42.Mustard42[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckULong(v.BreadFruit42.Mustard42[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetThyme42(::Thyme42 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetThyme42");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%14;
        v.BreadFruit42.Mustard42[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            v.BreadFruit42.Mustard42[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.BreadFruit42.Mustard42[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%5;
                    v.BreadFruit42.Mustard42[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetULong(v.BreadFruit42.Mustard42[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckThyme42(const ::Thyme42 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckThyme42");
#endif

  AddName("BreadFruit42");
  AddName("Mustard42");
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%14;
        if (l3 != v.BreadFruit42.Mustard42[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.BreadFruit42.Mustard42[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            if (l5 != v.BreadFruit42.Mustard42[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.BreadFruit42.Mustard42[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.BreadFruit42.Mustard42[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.BreadFruit42.Mustard42[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%5;
                    if (l9 != v.BreadFruit42.Mustard42[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.BreadFruit42.Mustard42[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckULong(v.BreadFruit42.Mustard42[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetThyme42Strawberry42(::Thyme42::Strawberry42 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetThyme42Strawberry42");
#endif

  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%14;
        v.Mustard42[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            v.Mustard42[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Mustard42[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%5;
                    v.Mustard42[i1][i3][i5][i7].length(l9);
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      GetULong(v.Mustard42[i1][i3][i5][i7][i9]);
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckThyme42Strawberry42(const ::Thyme42::Strawberry42 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckThyme42Strawberry42");
#endif

  AddName("Mustard42");
  {
    int	i1;
    for(i1=0; i1 < 13; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%14;
        if (l3 != v.Mustard42[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Mustard42[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            if (l5 != v.Mustard42[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Mustard42[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Mustard42[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Mustard42[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  {
                    CORBA::ULong	l9;
                    CORBA::ULong	i9;
                    l9 = ernie.getULong()%5;
                    if (l9 != v.Mustard42[i1][i3][i5][i7].length())
                    {
                      ::tet_printf("ERROR: %s has incorrect length",name);
                      ::tet_printf("Expected %d, but found %d instead", l9,v.Mustard42[i1][i3][i5][i7].length());
                      iRetCode = 0;
                    }
                    for(i9=0; i9 < l9; ++i9)
                    {
                      AddIndex(i9);
                      if (!CheckULong(v.Mustard42[i1][i3][i5][i7][i9]))
                        iRetCode = 0;
                      RemoveIndex();
                    }
                  }
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetSweetcorn43(::Sweetcorn43 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetSweetcorn43");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.LolloRossa43.Billberries43.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%4;
        v.LolloRossa43.Billberries43[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            v.LolloRossa43.Billberries43[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.LolloRossa43.Billberries43[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetUShort(v.LolloRossa43.Billberries43[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckSweetcorn43(const ::Sweetcorn43 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckSweetcorn43");
#endif

  AddName("LolloRossa43");
  AddName("Billberries43");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.LolloRossa43.Billberries43.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.LolloRossa43.Billberries43.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%4;
        if (l3 != v.LolloRossa43.Billberries43[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.LolloRossa43.Billberries43[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            if (l5 != v.LolloRossa43.Billberries43[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.LolloRossa43.Billberries43[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.LolloRossa43.Billberries43[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.LolloRossa43.Billberries43[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckUShort(v.LolloRossa43.Billberries43[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetRowanBerry43(::RowanBerry43 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetRowanBerry43");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.LolloRossa43.Billberries43.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%4;
        v.LolloRossa43.Billberries43[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            v.LolloRossa43.Billberries43[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.LolloRossa43.Billberries43[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetUShort(v.LolloRossa43.Billberries43[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckRowanBerry43(const ::RowanBerry43 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRowanBerry43");
#endif

  AddName("LolloRossa43");
  AddName("Billberries43");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.LolloRossa43.Billberries43.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.LolloRossa43.Billberries43.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%4;
        if (l3 != v.LolloRossa43.Billberries43[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.LolloRossa43.Billberries43[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            if (l5 != v.LolloRossa43.Billberries43[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.LolloRossa43.Billberries43[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.LolloRossa43.Billberries43[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.LolloRossa43.Billberries43[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckUShort(v.LolloRossa43.Billberries43[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  RemoveName();
  return iRetCode;
}

 
void GetRowanBerry43CantelopeMelon43(::RowanBerry43::CantelopeMelon43 &v)
{
#ifdef DEBUG
  ::tet_infoline("GetRowanBerry43CantelopeMelon43");
#endif

  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    v.Billberries43.length(l1);
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%4;
        v.Billberries43[i1].length(l3);
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            v.Billberries43[i1][i3].length(l5);
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                v.Billberries43[i1][i3][i5].length(l7);
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  GetUShort(v.Billberries43[i1][i3][i5][i7]);
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
}

int CheckRowanBerry43CantelopeMelon43(const ::RowanBerry43::CantelopeMelon43 &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckRowanBerry43CantelopeMelon43");
#endif

  AddName("Billberries43");
  {
    CORBA::ULong	l1;
    CORBA::ULong	i1;
    l1 = ernie.getULong()%3;
    if (l1 != v.Billberries43.length())
    {
      ::tet_printf("ERROR: %s has incorrect length",name);
      ::tet_printf("Expected %d, but found %d instead", l1,v.Billberries43.length());
      iRetCode = 0;
    }
    for(i1=0; i1 < l1; ++i1)
    {
      AddIndex(i1);
      {
        CORBA::ULong	l3;
        CORBA::ULong	i3;
        l3 = ernie.getULong()%4;
        if (l3 != v.Billberries43[i1].length())
        {
          ::tet_printf("ERROR: %s has incorrect length",name);
          ::tet_printf("Expected %d, but found %d instead", l3,v.Billberries43[i1].length());
          iRetCode = 0;
        }
        for(i3=0; i3 < l3; ++i3)
        {
          AddIndex(i3);
          {
            CORBA::ULong	l5;
            CORBA::ULong	i5;
            l5 = ernie.getULong()%2;
            if (l5 != v.Billberries43[i1][i3].length())
            {
              ::tet_printf("ERROR: %s has incorrect length",name);
              ::tet_printf("Expected %d, but found %d instead", l5,v.Billberries43[i1][i3].length());
              iRetCode = 0;
            }
            for(i5=0; i5 < l5; ++i5)
            {
              AddIndex(i5);
              {
                CORBA::ULong	l7;
                CORBA::ULong	i7;
                l7 = ernie.getULong()%3;
                if (l7 != v.Billberries43[i1][i3][i5].length())
                {
                  ::tet_printf("ERROR: %s has incorrect length",name);
                  ::tet_printf("Expected %d, but found %d instead", l7,v.Billberries43[i1][i3][i5].length());
                  iRetCode = 0;
                }
                for(i7=0; i7 < l7; ++i7)
                {
                  AddIndex(i7);
                  if (!CheckUShort(v.Billberries43[i1][i3][i5][i7]))
                    iRetCode = 0;
                  RemoveIndex();
                }
              }
              RemoveIndex();
            }
          }
          RemoveIndex();
        }
      }
      RemoveIndex();
    }
  }
  RemoveName();
  return iRetCode;
}

 
void GetidlServerRadish22Excpt(::idlServer::Radish22Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerRadish22Excpt");
#endif

  GetRadish22(v.ex1);
}

int CheckidlServerRadish22Excpt(const ::idlServer::Radish22Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerRadish22Excpt");
#endif

  AddName("ex1");
  if (!CheckRadish22(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerSharanfruit22Excpt(::idlServer::Sharanfruit22Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerSharanfruit22Excpt");
#endif

  GetSharanfruit22(v.ex1);
}

int CheckidlServerSharanfruit22Excpt(const ::idlServer::Sharanfruit22Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerSharanfruit22Excpt");
#endif

  AddName("ex1");
  if (!CheckSharanfruit22(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerTarragon23Excpt(::idlServer::Tarragon23Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerTarragon23Excpt");
#endif

  GetTarragon23(v.ex1);
}

int CheckidlServerTarragon23Excpt(const ::idlServer::Tarragon23Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerTarragon23Excpt");
#endif

  AddName("ex1");
  if (!CheckTarragon23(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerButterBean24Excpt(::idlServer::ButterBean24Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerButterBean24Excpt");
#endif

  GetButterBean24(v.ex1);
}

int CheckidlServerButterBean24Excpt(const ::idlServer::ButterBean24Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerButterBean24Excpt");
#endif

  AddName("ex1");
  if (!CheckButterBean24(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerZucchini24Excpt(::idlServer::Zucchini24Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerZucchini24Excpt");
#endif

  GetZucchini24(v.ex1);
}

int CheckidlServerZucchini24Excpt(const ::idlServer::Zucchini24Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerZucchini24Excpt");
#endif

  AddName("ex1");
  if (!CheckZucchini24(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerPlum24Excpt(::idlServer::Plum24Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerPlum24Excpt");
#endif

  GetZucchini24Plum24(v.ex1);
}

int CheckidlServerPlum24Excpt(const ::idlServer::Plum24Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerPlum24Excpt");
#endif

  AddName("ex1");
  if (!CheckZucchini24Plum24(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerDill25Excpt(::idlServer::Dill25Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerDill25Excpt");
#endif

  GetDill25(v.ex1);
}

int CheckidlServerDill25Excpt(const ::idlServer::Dill25Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerDill25Excpt");
#endif

  AddName("ex1");
  if (!CheckDill25(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerBayleaf25Excpt(::idlServer::Bayleaf25Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerBayleaf25Excpt");
#endif

  GetBayleaf25(v.ex1);
}

int CheckidlServerBayleaf25Excpt(const ::idlServer::Bayleaf25Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerBayleaf25Excpt");
#endif

  AddName("ex1");
  if (!CheckBayleaf25(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}

 
void GetidlServerWhiteCabbage25Excpt(::idlServer::WhiteCabbage25Excpt &v)
{
#ifdef DEBUG
  ::tet_infoline("GetidlServerWhiteCabbage25Excpt");
#endif

  GetBayleaf25WhiteCabbage25(v.ex1);
}

int CheckidlServerWhiteCabbage25Excpt(const ::idlServer::WhiteCabbage25Excpt &v)
{
  int  iRetCode= 1;
#ifdef DEBUG
  ::tet_infoline("CheckidlServerWhiteCabbage25Excpt");
#endif

  AddName("ex1");
  if (!CheckBayleaf25WhiteCabbage25(v.ex1))
    iRetCode = 0;
  RemoveName();
  return iRetCode;
}



