//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2000 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;


void
siiServer_imp::Prunes1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Prunes1");
#endif
  
  ernie.seed("Prunes1Call");
  
  ernie.seed("Prunes1Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Prunes1");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Float
siiServer_imp::Brocoli1(CORBA::Float p1,CORBA::Float &p2,CORBA::Float &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Float ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Brocoli1");
#endif
  
  ernie.seed("Brocoli1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckFloat(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckFloat(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Brocoli1Return"); 
  
  GetFloat(ReturnValue);
  ernie.mode(0);
  GetFloat(p2);
  ernie.mode(2);
  GetFloat(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Brocoli1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Double
siiServer_imp::GrannySmith1(CORBA::Double p1,CORBA::Double &p2,CORBA::Double &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Double ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::GrannySmith1");
#endif
  
  ernie.seed("GrannySmith1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckDouble(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckDouble(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GrannySmith1Return"); 
  
  GetDouble(ReturnValue);
  ernie.mode(0);
  GetDouble(p2);
  ernie.mode(2);
  GetDouble(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::GrannySmith1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Long
siiServer_imp::BrazilNut1(CORBA::Long p1,CORBA::Long &p2,CORBA::Long &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Long ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::BrazilNut1");
#endif
  
  ernie.seed("BrazilNut1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckLong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckLong(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BrazilNut1Return"); 
  
  GetLong(ReturnValue);
  ernie.mode(0);
  GetLong(p2);
  ernie.mode(2);
  GetLong(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::BrazilNut1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Short
siiServer_imp::SweetPotato1(CORBA::Short p1,CORBA::Short &p2,CORBA::Short &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Short ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::SweetPotato1");
#endif
  
  ernie.seed("SweetPotato1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckShort(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckShort(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SweetPotato1Return"); 
  
  GetShort(ReturnValue);
  ernie.mode(0);
  GetShort(p2);
  ernie.mode(2);
  GetShort(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::SweetPotato1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::ULong
siiServer_imp::Tangarine1(CORBA::ULong p1,CORBA::ULong &p2,CORBA::ULong &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::ULong ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Tangarine1");
#endif
  
  ernie.seed("Tangarine1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckULong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckULong(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Tangarine1Return"); 
  
  GetULong(ReturnValue);
  ernie.mode(0);
  GetULong(p2);
  ernie.mode(2);
  GetULong(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Tangarine1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::UShort
siiServer_imp::Billberries1(CORBA::UShort p1,CORBA::UShort &p2,CORBA::UShort &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::UShort ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Billberries1");
#endif
  
  ernie.seed("Billberries1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckUShort(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckUShort(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Billberries1Return"); 
  
  GetUShort(ReturnValue);
  ernie.mode(0);
  GetUShort(p2);
  ernie.mode(2);
  GetUShort(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Billberries1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Char
siiServer_imp::CantelopeMelon1(CORBA::Char p1,CORBA::Char &p2,CORBA::Char &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Char ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::CantelopeMelon1");
#endif
  
  ernie.seed("CantelopeMelon1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckChar(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckChar(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CantelopeMelon1Return"); 
  
  GetChar(ReturnValue);
  ernie.mode(0);
  GetChar(p2);
  ernie.mode(2);
  GetChar(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::CantelopeMelon1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Boolean
siiServer_imp::LolloRossa1(CORBA::Boolean p1,CORBA::Boolean &p2,CORBA::Boolean &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Boolean ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::LolloRossa1");
#endif
  
  ernie.seed("LolloRossa1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckBoolean(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckBoolean(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LolloRossa1Return"); 
  
  GetBoolean(ReturnValue);
  ernie.mode(0);
  GetBoolean(p2);
  ernie.mode(2);
  GetBoolean(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::LolloRossa1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Octet
siiServer_imp::RowanBerry1(CORBA::Octet p1,CORBA::Octet &p2,CORBA::Octet &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Octet ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::RowanBerry1");
#endif
  
  ernie.seed("RowanBerry1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckOctet(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckOctet(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RowanBerry1Return"); 
  
  GetOctet(ReturnValue);
  ernie.mode(0);
  GetOctet(p2);
  ernie.mode(2);
  GetOctet(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::RowanBerry1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Object_ptr
siiServer_imp::Sweetcorn1(CORBA::Object_ptr p1,CORBA::Object_out p2,CORBA::Object_ptr &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Object_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Sweetcorn1");
#endif
  
  ernie.seed("Sweetcorn1Call");
  ernie.mode(0);
  AddName("p1");
  if (!Checkobject(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!Checkobject(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sweetcorn1Return"); 
  
  ReturnValue = Getobject();
  ernie.mode(0);
  p2 = Getobject();
  ernie.mode(2);
  p3 = Getobject();

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Sweetcorn1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
siiServer_imp::Onion1(const char * p1,CORBA::String_out p2,char * &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Onion1");
#endif
  
  ernie.seed("Onion1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckString(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckString(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Onion1Return"); 
  
  ReturnValue = GetString();
  ernie.mode(0);
  p2 = GetString();
  ernie.mode(2);
  p3 = GetString();

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Onion1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
siiServer_imp::Shallots1(const char * p1,CORBA::String_out p2,char * &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Shallots1");
#endif
  
  ernie.seed("Shallots1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckString(p1,20))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckString(p3,46))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Shallots1Return"); 
  
  ReturnValue = GetString(4);
  ernie.mode(0);
  p2 = GetString(12);
  ernie.mode(2);
  p3 = GetString(46);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Shallots1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Long
siiServer_imp::Plum1(CORBA::Boolean &p1,CORBA::Octet p2,CORBA::UShort p3,CORBA::Boolean &p4 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Long ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Plum1");
#endif
  
  ernie.seed("Plum1Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckOctet(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckUShort(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckBoolean(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Plum1Return"); 
  
  GetLong(ReturnValue);
  ernie.mode(0);
  GetBoolean(p1);
  ernie.mode(2);
  GetBoolean(p4);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Plum1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::UShort
siiServer_imp::KidneyBean1(CORBA::ULong &p1,const char * p2,CORBA::Double &p3,CORBA::String_out p4,CORBA::Boolean &p5,CORBA::Char &p6,CORBA::Short &p7,CORBA::Octet &p8,const char * p9,CORBA::Octet p10,CORBA::Short &p11,CORBA::UShort &p12,CORBA::Float &p13,CORBA::UShort &p14 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::UShort ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::KidneyBean1");
#endif
  
  ernie.seed("KidneyBean1Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckString(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckString(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckOctet(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckUShort(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckUShort(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KidneyBean1Return"); 
  
  GetUShort(ReturnValue);
  ernie.mode(0);
  GetULong(p1);
  ernie.mode(0);
  GetDouble(p3);
  ernie.mode(0);
  p4 = GetString();
  ernie.mode(0);
  GetBoolean(p5);
  ernie.mode(0);
  GetChar(p6);
  ernie.mode(0);
  GetShort(p7);
  ernie.mode(0);
  GetOctet(p8);
  ernie.mode(0);
  GetShort(p11);
  ernie.mode(2);
  GetUShort(p12);
  ernie.mode(0);
  GetFloat(p13);
  ernie.mode(2);
  GetUShort(p14);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::KidneyBean1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::UShort
siiServer_imp::Zucchini1(CORBA::Long &p1,char * &p2,const char * p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::UShort ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Zucchini1");
#endif
  
  ernie.seed("Zucchini1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckLong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckString(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckString(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Zucchini1Return"); 
  
  GetUShort(ReturnValue);
  ernie.mode(2);
  GetLong(p1);
  ernie.mode(2);
  p2 = GetString();

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Zucchini1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
siiServer_imp::ButterBean1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::ButterBean1");
#endif
  
  ernie.seed("ButterBean1Call");
  
  ernie.seed("ButterBean1Return"); 
  
  ReturnValue = GetString();

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::ButterBean1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Octet
siiServer_imp::Avocado1(CORBA::Boolean &p1,CORBA::Char p2,CORBA::Char &p3,CORBA::Octet &p4,CORBA::Char p5,CORBA::Boolean &p6,CORBA::Double p7,CORBA::Boolean &p8,const char * p9,CORBA::Long &p10,CORBA::UShort &p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Octet ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Avocado1");
#endif
  
  ernie.seed("Avocado1Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckChar(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckOctet(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckChar(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckBoolean(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckDouble(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckBoolean(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckString(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Avocado1Return"); 
  
  GetOctet(ReturnValue);
  ernie.mode(0);
  GetBoolean(p1);
  ernie.mode(0);
  GetChar(p3);
  ernie.mode(2);
  GetOctet(p4);
  ernie.mode(2);
  GetBoolean(p6);
  ernie.mode(2);
  GetBoolean(p8);
  ernie.mode(0);
  GetLong(p10);
  ernie.mode(0);
  GetUShort(p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Avocado1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
siiServer_imp::GoldenDelicous1(CORBA::Boolean p1,CORBA::Long p2,CORBA::Octet p3,CORBA::Boolean &p4,CORBA::Long &p5,CORBA::UShort &p6,CORBA::Short p7,CORBA::Float p8,CORBA::Boolean &p9,CORBA::ULong &p10,char * &p11,CORBA::ULong &p12,CORBA::Double p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::GoldenDelicous1");
#endif
  
  ernie.seed("GoldenDelicous1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckBoolean(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckLong(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckOctet(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckShort(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckFloat(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckBoolean(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckULong(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckString(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckULong(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckDouble(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GoldenDelicous1Return"); 
  
  ReturnValue = GetString();
  ernie.mode(0);
  GetBoolean(p4);
  ernie.mode(0);
  GetLong(p5);
  ernie.mode(0);
  GetUShort(p6);
  ernie.mode(2);
  GetBoolean(p9);
  ernie.mode(2);
  GetULong(p10);
  ernie.mode(2);
  p11 = GetString();
  ernie.mode(2);
  GetULong(p12);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::GoldenDelicous1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
siiServer_imp::Lentil1(char * &p1,CORBA::Float p2,CORBA::Boolean &p3,CORBA::Long &p4,CORBA::Octet &p5,CORBA::ULong &p6 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Lentil1");
#endif
  
  ernie.seed("Lentil1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckString(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckFloat(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckBoolean(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lentil1Return"); 
  
  ReturnValue = GetString();
  ernie.mode(2);
  p1 = GetString();
  ernie.mode(2);
  GetBoolean(p3);
  ernie.mode(0);
  GetLong(p4);
  ernie.mode(0);
  GetOctet(p5);
  ernie.mode(0);
  GetULong(p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Lentil1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::UShort
siiServer_imp::Fig1(CORBA::Float &p1,CORBA::Float &p2,CORBA::Float p3,CORBA::Double p4,CORBA::Char &p5,CORBA::Short &p6,CORBA::ULong p7,CORBA::Double &p8,CORBA::UShort &p9,CORBA::Char &p10,CORBA::ULong &p11,CORBA::UShort p12,char * &p13,CORBA::Float p14 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::UShort ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Fig1");
#endif
  
  ernie.seed("Fig1Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckFloat(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckFloat(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckDouble(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckChar(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckShort(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckULong(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckULong(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckUShort(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckString(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckFloat(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Fig1Return"); 
  
  GetUShort(ReturnValue);
  ernie.mode(0);
  GetFloat(p1);
  ernie.mode(2);
  GetFloat(p2);
  ernie.mode(2);
  GetChar(p5);
  ernie.mode(2);
  GetShort(p6);
  ernie.mode(0);
  GetDouble(p8);
  ernie.mode(0);
  GetUShort(p9);
  ernie.mode(0);
  GetChar(p10);
  ernie.mode(2);
  GetULong(p11);
  ernie.mode(2);
  p13 = GetString();

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Fig1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Char
siiServer_imp::CrabApple1(CORBA::Double p1,CORBA::Octet &p2,CORBA::Boolean &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Char ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::CrabApple1");
#endif
  
  ernie.seed("CrabApple1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckDouble(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CrabApple1Return"); 
  
  GetChar(ReturnValue);
  ernie.mode(0);
  GetOctet(p2);
  ernie.mode(0);
  GetBoolean(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::CrabApple1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
siiServer_imp::RedOnion1(CORBA::ULong &p1,CORBA::Short &p2,CORBA::Double &p3,CORBA::Short &p4,CORBA::Boolean &p5,CORBA::Float p6,CORBA::Char p7,CORBA::Octet p8,CORBA::Double &p9,CORBA::Octet &p10,CORBA::Long &p11,CORBA::Float p12,CORBA::UShort &p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::RedOnion1");
#endif
  
  ernie.seed("RedOnion1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckULong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckShort(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckFloat(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckChar(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckOctet(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckLong(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckFloat(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedOnion1Return"); 
  
  ReturnValue = GetString();
  ernie.mode(2);
  GetULong(p1);
  ernie.mode(2);
  GetShort(p2);
  ernie.mode(0);
  GetDouble(p3);
  ernie.mode(0);
  GetShort(p4);
  ernie.mode(0);
  GetBoolean(p5);
  ernie.mode(0);
  GetDouble(p9);
  ernie.mode(0);
  GetOctet(p10);
  ernie.mode(2);
  GetLong(p11);
  ernie.mode(0);
  GetUShort(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::RedOnion1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Octet
siiServer_imp::HazelNut1(CORBA::Short &p1,CORBA::Octet &p2,CORBA::Double p3,const char * p4,CORBA::Short p5,CORBA::Double &p6,CORBA::Double &p7,CORBA::ULong p8,CORBA::Boolean &p9,CORBA::ULong &p10,CORBA::Float &p11,CORBA::Float &p12,CORBA::UShort &p13,CORBA::Octet &p14,CORBA::UShort p15,CORBA::Long &p16,CORBA::Short p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Octet ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::HazelNut1");
#endif
  
  ernie.seed("HazelNut1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckShort(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckOctet(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckDouble(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckString(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckShort(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckDouble(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckDouble(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckULong(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckULong(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckFloat(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckUShort(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p15");
  if (!CheckUShort(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p17");
  if (!CheckShort(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("HazelNut1Return"); 
  
  GetOctet(ReturnValue);
  ernie.mode(2);
  GetShort(p1);
  ernie.mode(2);
  GetOctet(p2);
  ernie.mode(2);
  GetDouble(p6);
  ernie.mode(2);
  GetDouble(p7);
  ernie.mode(0);
  GetBoolean(p9);
  ernie.mode(2);
  GetULong(p10);
  ernie.mode(0);
  GetFloat(p11);
  ernie.mode(2);
  GetFloat(p12);
  ernie.mode(2);
  GetUShort(p13);
  ernie.mode(0);
  GetOctet(p14);
  ernie.mode(0);
  GetLong(p16);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::HazelNut1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Short
siiServer_imp::Cinnamon1(CORBA::Long &p1,CORBA::Short &p2,CORBA::Octet p3,CORBA::ULong p4,CORBA::ULong &p5,CORBA::Double p6,CORBA::Char &p7,CORBA::Short &p8,CORBA::Char p9,CORBA::UShort &p10,CORBA::Char &p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Short ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Cinnamon1");
#endif
  
  ernie.seed("Cinnamon1Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckShort(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckOctet(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckULong(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckDouble(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckChar(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckUShort(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckChar(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cinnamon1Return"); 
  
  GetShort(ReturnValue);
  ernie.mode(0);
  GetLong(p1);
  ernie.mode(2);
  GetShort(p2);
  ernie.mode(0);
  GetULong(p5);
  ernie.mode(0);
  GetChar(p7);
  ernie.mode(0);
  GetShort(p8);
  ernie.mode(2);
  GetUShort(p10);
  ernie.mode(2);
  GetChar(p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Cinnamon1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Long
siiServer_imp::GooseBerry1(CORBA::Boolean &p1,CORBA::ULong p2,CORBA::Double &p3,CORBA::UShort &p4,const char * p5,CORBA::Float &p6,CORBA::UShort p7,CORBA::Long &p8,CORBA::UShort p9,CORBA::Long &p10,CORBA::Boolean &p11,CORBA::Octet &p12,CORBA::Short &p13,CORBA::Char p14 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Long ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::GooseBerry1");
#endif
  
  ernie.seed("GooseBerry1Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckULong(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckDouble(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckString(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckFloat(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckUShort(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckLong(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckUShort(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckLong(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckOctet(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckShort(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckChar(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GooseBerry1Return"); 
  
  GetLong(ReturnValue);
  ernie.mode(0);
  GetBoolean(p1);
  ernie.mode(2);
  GetDouble(p3);
  ernie.mode(0);
  GetUShort(p4);
  ernie.mode(2);
  GetFloat(p6);
  ernie.mode(2);
  GetLong(p8);
  ernie.mode(2);
  GetLong(p10);
  ernie.mode(0);
  GetBoolean(p11);
  ernie.mode(2);
  GetOctet(p12);
  ernie.mode(2);
  GetShort(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::GooseBerry1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Double
siiServer_imp::EggPlant1(CORBA::Long &p1,CORBA::UShort &p2,CORBA::Short &p3,CORBA::Short p4,CORBA::UShort &p5,CORBA::Double &p6,CORBA::Float &p7,CORBA::Octet p8,CORBA::String_out p9,CORBA::Char &p10,CORBA::Short &p11,CORBA::ULong p12,CORBA::Short &p13,CORBA::ULong &p14,CORBA::Long &p15,CORBA::Char &p16,CORBA::ULong p17,CORBA::Float &p18 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Double ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::EggPlant1");
#endif
  
  ernie.seed("EggPlant1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckLong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckUShort(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckShort(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckUShort(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckFloat(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckOctet(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckULong(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckShort(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p15");
  if (!CheckLong(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p17");
  if (!CheckULong(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("EggPlant1Return"); 
  
  GetDouble(ReturnValue);
  ernie.mode(2);
  GetLong(p1);
  ernie.mode(2);
  GetUShort(p2);
  ernie.mode(0);
  GetShort(p3);
  ernie.mode(2);
  GetUShort(p5);
  ernie.mode(0);
  GetDouble(p6);
  ernie.mode(2);
  GetFloat(p7);
  ernie.mode(0);
  p9 = GetString();
  ernie.mode(0);
  GetChar(p10);
  ernie.mode(0);
  GetShort(p11);
  ernie.mode(2);
  GetShort(p13);
  ernie.mode(0);
  GetULong(p14);
  ernie.mode(2);
  GetLong(p15);
  ernie.mode(0);
  GetChar(p16);
  ernie.mode(0);
  GetFloat(p18);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::EggPlant1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Short
siiServer_imp::JuniperBerries1(CORBA::Double &p1,CORBA::Boolean &p2,CORBA::Octet &p3,CORBA::Float &p4,CORBA::Short &p5,CORBA::UShort &p6 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Short ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::JuniperBerries1");
#endif
  
  ernie.seed("JuniperBerries1Call");
  ernie.mode(1);
  AddName("p3");
  if (!CheckOctet(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckFloat(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckUShort(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("JuniperBerries1Return"); 
  
  GetShort(ReturnValue);
  ernie.mode(0);
  GetDouble(p1);
  ernie.mode(0);
  GetBoolean(p2);
  ernie.mode(2);
  GetOctet(p3);
  ernie.mode(2);
  GetFloat(p4);
  ernie.mode(0);
  GetShort(p5);
  ernie.mode(2);
  GetUShort(p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::JuniperBerries1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::UShort
siiServer_imp::Cloves1(CORBA::Double p1 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::UShort ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Cloves1");
#endif
  
  ernie.seed("Cloves1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckDouble(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cloves1Return"); 
  
  GetUShort(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Cloves1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
siiServer_imp::Daikan1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Daikan1");
#endif
  
  ernie.seed("Daikan1Call");
  
  ernie.seed("Daikan1Return"); 
  
  ReturnValue = GetString();

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Daikan1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Float
siiServer_imp::Mustard1(CORBA::Octet p1,CORBA::Boolean p2,const char * p3,CORBA::Double p4,CORBA::Float &p5,CORBA::Char p6,CORBA::Char &p7,CORBA::Octet p8,CORBA::Long &p9,CORBA::UShort &p10 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Float ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Mustard1");
#endif
  
  ernie.seed("Mustard1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckOctet(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckBoolean(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckString(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckDouble(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckFloat(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckChar(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckOctet(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Mustard1Return"); 
  
  GetFloat(ReturnValue);
  ernie.mode(2);
  GetFloat(p5);
  ernie.mode(0);
  GetChar(p7);
  ernie.mode(0);
  GetLong(p9);
  ernie.mode(0);
  GetUShort(p10);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Mustard1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::UShort
siiServer_imp::Strawberry1(CORBA::Long p1,CORBA::Char &p2,CORBA::Double p3,const char * p4,CORBA::Long &p5,CORBA::Boolean &p6,CORBA::Octet &p7,CORBA::Long &p8,CORBA::ULong p9,CORBA::Float &p10,CORBA::UShort &p11,CORBA::Short &p12 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::UShort ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Strawberry1");
#endif
  
  ernie.seed("Strawberry1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckLong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckDouble(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckString(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckLong(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckBoolean(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckOctet(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckULong(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckShort(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Strawberry1Return"); 
  
  GetUShort(ReturnValue);
  ernie.mode(0);
  GetChar(p2);
  ernie.mode(2);
  GetLong(p5);
  ernie.mode(2);
  GetBoolean(p6);
  ernie.mode(2);
  GetOctet(p7);
  ernie.mode(0);
  GetLong(p8);
  ernie.mode(0);
  GetFloat(p10);
  ernie.mode(0);
  GetUShort(p11);
  ernie.mode(2);
  GetShort(p12);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Strawberry1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
siiServer_imp::BreadFruit1(CORBA::Char p1 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::BreadFruit1");
#endif
  
  ernie.seed("BreadFruit1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckChar(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BreadFruit1Return"); 
  
  ReturnValue = GetString();

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::BreadFruit1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::UShort
siiServer_imp::Thyme1(CORBA::Long &p1,CORBA::Float &p2,char * &p3,CORBA::Short &p4,CORBA::Double p5,CORBA::Octet &p6,const char * p7,CORBA::Char &p8,CORBA::Long p9,CORBA::Octet p10,CORBA::Long &p11,CORBA::Boolean p12,CORBA::ULong &p13,CORBA::ULong &p14,CORBA::Long &p15 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::UShort ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Thyme1");
#endif
  
  ernie.seed("Thyme1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckLong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckFloat(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckString(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckDouble(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckString(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckLong(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckOctet(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckLong(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckBoolean(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p15");
  if (!CheckLong(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Thyme1Return"); 
  
  GetUShort(ReturnValue);
  ernie.mode(2);
  GetLong(p1);
  ernie.mode(2);
  GetFloat(p2);
  ernie.mode(2);
  p3 = GetString();
  ernie.mode(0);
  GetShort(p4);
  ernie.mode(0);
  GetOctet(p6);
  ernie.mode(0);
  GetChar(p8);
  ernie.mode(2);
  GetLong(p11);
  ernie.mode(0);
  GetULong(p13);
  ernie.mode(0);
  GetULong(p14);
  ernie.mode(2);
  GetLong(p15);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Thyme1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
siiServer_imp::Sweedes1(CORBA::Float &p1,CORBA::Short p2,CORBA::Char p3,CORBA::Octet &p4,CORBA::Short p5,CORBA::Float &p6,CORBA::Long p7,CORBA::Short &p8,CORBA::Float &p9,CORBA::Boolean &p10,CORBA::Char p11,CORBA::Boolean &p12,CORBA::Short p13,CORBA::Char &p14,CORBA::Long &p15,CORBA::Float p16,CORBA::Long &p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Sweedes1");
#endif
  
  ernie.seed("Sweedes1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckFloat(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckShort(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckChar(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckShort(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckLong(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckShort(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckFloat(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckBoolean(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckChar(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckShort(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckChar(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckFloat(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sweedes1Return"); 
  
  ReturnValue = GetString();
  ernie.mode(2);
  GetFloat(p1);
  ernie.mode(0);
  GetOctet(p4);
  ernie.mode(0);
  GetFloat(p6);
  ernie.mode(2);
  GetShort(p8);
  ernie.mode(2);
  GetFloat(p9);
  ernie.mode(2);
  GetBoolean(p10);
  ernie.mode(0);
  GetBoolean(p12);
  ernie.mode(2);
  GetChar(p14);
  ernie.mode(0);
  GetLong(p15);
  ernie.mode(0);
  GetLong(p17);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Sweedes1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Double
siiServer_imp::Pomegranate1(CORBA::UShort &p1,CORBA::Boolean &p2,const char * p3,CORBA::Double p4,CORBA::Long &p5,CORBA::ULong &p6,CORBA::Char &p7,CORBA::Short &p8,CORBA::String_out p9,CORBA::Long p10,CORBA::ULong p11,CORBA::Float &p12,CORBA::Double &p13,CORBA::Octet &p14,CORBA::Long &p15,CORBA::Boolean p16,CORBA::ULong p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Double ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Pomegranate1");
#endif
  
  ernie.seed("Pomegranate1Call");
  ernie.mode(0);
  AddName("p3");
  if (!CheckString(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckDouble(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckLong(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckShort(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckLong(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckULong(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckFloat(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckDouble(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckOctet(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckBoolean(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p17");
  if (!CheckULong(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Pomegranate1Return"); 
  
  GetDouble(ReturnValue);
  ernie.mode(0);
  GetUShort(p1);
  ernie.mode(0);
  GetBoolean(p2);
  ernie.mode(2);
  GetLong(p5);
  ernie.mode(0);
  GetULong(p6);
  ernie.mode(0);
  GetChar(p7);
  ernie.mode(2);
  GetShort(p8);
  ernie.mode(0);
  p9 = GetString();
  ernie.mode(2);
  GetFloat(p12);
  ernie.mode(2);
  GetDouble(p13);
  ernie.mode(2);
  GetOctet(p14);
  ernie.mode(0);
  GetLong(p15);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Pomegranate1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::ULong
siiServer_imp::Tarragon1(CORBA::Long p1,CORBA::Octet p2,CORBA::Octet p3,CORBA::Long p4,CORBA::Octet &p5,CORBA::ULong p6,CORBA::UShort &p7 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::ULong ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Tarragon1");
#endif
  
  ernie.seed("Tarragon1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckLong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckOctet(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckOctet(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckLong(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckOctet(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckULong(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Tarragon1Return"); 
  
  GetULong(ReturnValue);
  ernie.mode(2);
  GetOctet(p5);
  ernie.mode(0);
  GetUShort(p7);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Tarragon1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Char
siiServer_imp::Lettuce1(CORBA::Char &p1,CORBA::ULong p2,CORBA::Double p3,CORBA::Char &p4,CORBA::Octet p5,CORBA::Char &p6,CORBA::String_out p7,CORBA::Float p8,CORBA::Octet p9,CORBA::Boolean p10,CORBA::Boolean &p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Char ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Lettuce1");
#endif
  
  ernie.seed("Lettuce1Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckULong(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckDouble(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckOctet(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckFloat(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckOctet(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckBoolean(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckBoolean(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lettuce1Return"); 
  
  GetChar(ReturnValue);
  ernie.mode(0);
  GetChar(p1);
  ernie.mode(0);
  GetChar(p4);
  ernie.mode(0);
  GetChar(p6);
  ernie.mode(0);
  p7 = GetString();
  ernie.mode(2);
  GetBoolean(p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Lettuce1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::UShort
siiServer_imp::Mangetout1(CORBA::Float &p1,CORBA::Float &p2,CORBA::UShort &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::UShort ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Mangetout1");
#endif
  
  ernie.seed("Mangetout1Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckFloat(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckUShort(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Mangetout1Return"); 
  
  GetUShort(ReturnValue);
  ernie.mode(0);
  GetFloat(p1);
  ernie.mode(2);
  GetFloat(p2);
  ernie.mode(2);
  GetUShort(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Mangetout1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Double
siiServer_imp::Cress1(CORBA::String_out p1,CORBA::Char &p2,CORBA::Double &p3,CORBA::Char &p4,CORBA::Long p5,CORBA::Double &p6,CORBA::Long p7,CORBA::ULong p8 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Double ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Cress1");
#endif
  
  ernie.seed("Cress1Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckChar(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckChar(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckLong(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckDouble(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckLong(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckULong(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cress1Return"); 
  
  GetDouble(ReturnValue);
  ernie.mode(0);
  p1 = GetString();
  ernie.mode(2);
  GetChar(p2);
  ernie.mode(0);
  GetDouble(p3);
  ernie.mode(2);
  GetChar(p4);
  ernie.mode(2);
  GetDouble(p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Cress1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Short
siiServer_imp::BambooShoot1(const char * p1 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Short ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::BambooShoot1");
#endif
  
  ernie.seed("BambooShoot1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckString(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BambooShoot1Return"); 
  
  GetShort(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::BambooShoot1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Octet
siiServer_imp::Cassava1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Octet ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Cassava1");
#endif
  
  ernie.seed("Cassava1Call");
  
  ernie.seed("Cassava1Return"); 
  
  GetOctet(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Cassava1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Float
siiServer_imp::Melon1(CORBA::UShort &p1,CORBA::Boolean &p2,CORBA::UShort &p3,CORBA::Long p4,CORBA::Short p5 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Float ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::BasicTests::Melon1");
#endif
  
  ernie.seed("Melon1Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckBoolean(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckUShort(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckLong(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckShort(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Melon1Return"); 
  
  GetFloat(ReturnValue);
  ernie.mode(0);
  GetUShort(p1);
  ernie.mode(2);
  GetBoolean(p2);
  ernie.mode(2);
  GetUShort(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::BasicTests::Melon1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Float
siiServer_imp::RedGrapes1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Float ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::RedGrapes1");
#endif
  
  ernie.seed("RedGrapes1Call");
  
  ernie.seed("RedGrapes1Return"); 
  
  GetFloat(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::RedGrapes1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::RedGrapes1(CORBA::Float _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::RedGrapes1");
#endif
  
  ernie.seed("RedGrapes1Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckFloat(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedGrapes1Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::RedGrapes1");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Double
siiServer_imp::BeechNut1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Double ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::BeechNut1");
#endif
  
  ernie.seed("BeechNut1Call");
  
  ernie.seed("BeechNut1Return"); 
  
  GetDouble(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::BeechNut1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::BeechNut1(CORBA::Double _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::BeechNut1");
#endif
  
  ernie.seed("BeechNut1Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckDouble(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BeechNut1Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::BeechNut1");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Long
siiServer_imp::Elderberry1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Long ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Elderberry1");
#endif
  
  ernie.seed("Elderberry1Call");
  
  ernie.seed("Elderberry1Return"); 
  
  GetLong(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Elderberry1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Elderberry1(CORBA::Long _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Elderberry1");
#endif
  
  ernie.seed("Elderberry1Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckLong(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Elderberry1Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Elderberry1");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Short
siiServer_imp::Kumquats1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Short ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Kumquats1");
#endif
  
  ernie.seed("Kumquats1Call");
  
  ernie.seed("Kumquats1Return"); 
  
  GetShort(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Kumquats1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Kumquats1(CORBA::Short _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Kumquats1");
#endif
  
  ernie.seed("Kumquats1Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckShort(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Kumquats1Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Kumquats1");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::ULong
siiServer_imp::Walnuts1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::ULong ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Walnuts1");
#endif
  
  ernie.seed("Walnuts1Call");
  
  ernie.seed("Walnuts1Return"); 
  
  GetULong(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Walnuts1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Walnuts1(CORBA::ULong _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Walnuts1");
#endif
  
  ernie.seed("Walnuts1Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckULong(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Walnuts1Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Walnuts1");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::UShort
siiServer_imp::Fennell1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::UShort ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Fennell1");
#endif
  
  ernie.seed("Fennell1Call");
  
  ernie.seed("Fennell1Return"); 
  
  GetUShort(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Fennell1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Fennell1(CORBA::UShort _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Fennell1");
#endif
  
  ernie.seed("Fennell1Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckUShort(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Fennell1Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Fennell1");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Char
siiServer_imp::Uglifruit1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Char ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Uglifruit1");
#endif
  
  ernie.seed("Uglifruit1Call");
  
  ernie.seed("Uglifruit1Return"); 
  
  GetChar(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Uglifruit1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Uglifruit1(CORBA::Char _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Uglifruit1");
#endif
  
  ernie.seed("Uglifruit1Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckChar(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Uglifruit1Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Uglifruit1");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Boolean
siiServer_imp::Waterchestnut1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Boolean ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Waterchestnut1");
#endif
  
  ernie.seed("Waterchestnut1Call");
  
  ernie.seed("Waterchestnut1Return"); 
  
  GetBoolean(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Waterchestnut1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Waterchestnut1(CORBA::Boolean _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Waterchestnut1");
#endif
  
  ernie.seed("Waterchestnut1Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckBoolean(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Waterchestnut1Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Waterchestnut1");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Octet
siiServer_imp::Chickpea1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Octet ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Chickpea1");
#endif
  
  ernie.seed("Chickpea1Call");
  
  ernie.seed("Chickpea1Return"); 
  
  GetOctet(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Chickpea1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Chickpea1(CORBA::Octet _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Chickpea1");
#endif
  
  ernie.seed("Chickpea1Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckOctet(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Chickpea1Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Chickpea1");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Object_ptr
siiServer_imp::Beetroot1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Object_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Beetroot1");
#endif
  
  ernie.seed("Beetroot1Call");
  
  ernie.seed("Beetroot1Return"); 
  
  ReturnValue = Getobject();

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Beetroot1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Beetroot1(CORBA::Object_ptr _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Beetroot1");
#endif
  
  ernie.seed("Beetroot1Call");
  ernie.mode(0);
  AddName("_attr");
  if (!Checkobject(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Beetroot1Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Beetroot1");
#endif
  ::tet_result(TET_PASS);
  
  
}

char *
siiServer_imp::Okra1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Okra1");
#endif
  
  ernie.seed("Okra1Call");
  
  ernie.seed("Okra1Return"); 
  
  ReturnValue = GetString();

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Okra1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Okra1(const char * _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Okra1");
#endif
  
  ernie.seed("Okra1Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckString(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Okra1Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Okra1");
#endif
  ::tet_result(TET_PASS);
  
  
}

char *
siiServer_imp::Plantain1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Plantain1");
#endif
  
  ernie.seed("Plantain1Call");
  
  ernie.seed("Plantain1Return"); 
  
  ReturnValue = GetString(43);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Plantain1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Plantain1(const char * _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Plantain1");
#endif
  
  ernie.seed("Plantain1Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckString(_attr,43))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Plantain1Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Plantain1");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Float
siiServer_imp::Blackcurrant1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Float ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Blackcurrant1");
#endif
  
  ernie.seed("Blackcurrant1Call");
  
  ernie.seed("Blackcurrant1Return"); 
  
  GetFloat(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Blackcurrant1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Double
siiServer_imp::Pineapple1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Double ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Pineapple1");
#endif
  
  ernie.seed("Pineapple1Call");
  
  ernie.seed("Pineapple1Return"); 
  
  GetDouble(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Pineapple1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Long
siiServer_imp::LimaBean1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Long ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::LimaBean1");
#endif
  
  ernie.seed("LimaBean1Call");
  
  ernie.seed("LimaBean1Return"); 
  
  GetLong(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::LimaBean1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Short
siiServer_imp::Mangosteen1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Short ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Mangosteen1");
#endif
  
  ernie.seed("Mangosteen1Call");
  
  ernie.seed("Mangosteen1Return"); 
  
  GetShort(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Mangosteen1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::ULong
siiServer_imp::Pear1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::ULong ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Pear1");
#endif
  
  ernie.seed("Pear1Call");
  
  ernie.seed("Pear1Return"); 
  
  GetULong(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Pear1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::UShort
siiServer_imp::RedPepper1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::UShort ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::RedPepper1");
#endif
  
  ernie.seed("RedPepper1Call");
  
  ernie.seed("RedPepper1Return"); 
  
  GetUShort(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::RedPepper1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Char
siiServer_imp::BeefTomatoes1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Char ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::BeefTomatoes1");
#endif
  
  ernie.seed("BeefTomatoes1Call");
  
  ernie.seed("BeefTomatoes1Return"); 
  
  GetChar(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::BeefTomatoes1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Boolean
siiServer_imp::FrenchBeans1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Boolean ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::FrenchBeans1");
#endif
  
  ernie.seed("FrenchBeans1Call");
  
  ernie.seed("FrenchBeans1Return"); 
  
  GetBoolean(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::FrenchBeans1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Octet
siiServer_imp::Sharanfruit1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Octet ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Sharanfruit1");
#endif
  
  ernie.seed("Sharanfruit1Call");
  
  ernie.seed("Sharanfruit1Return"); 
  
  GetOctet(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Sharanfruit1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Object_ptr
siiServer_imp::Radish1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Object_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Radish1");
#endif
  
  ernie.seed("Radish1Call");
  
  ernie.seed("Radish1Return"); 
  
  ReturnValue = Getobject();

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Radish1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
siiServer_imp::Cherry1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Cherry1");
#endif
  
  ernie.seed("Cherry1Call");
  
  ernie.seed("Cherry1Return"); 
  
  ReturnValue = GetString();

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Cherry1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
siiServer_imp::Papaya1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AttrTests::Papaya1");
#endif
  
  ernie.seed("Papaya1Call");
  
  ernie.seed("Papaya1Return"); 
  
  ReturnValue = GetString(25);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AttrTests::Papaya1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Record2_slice *
siiServer_imp::Susander1(CORBA::String_out p1,const ::Radish &p2,const ::GaliaMelon3 &p3,::Rasin2 &p4 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Record2_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Susander1");
#endif
  
  ernie.seed("Susander1Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckRadish(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckGaliaMelon3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckRasin2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Susander1Return"); 
  
  ReturnValue = new ::Record2;
  GetRecord2(ReturnValue);
  ernie.mode(0);
  p1 = GetString();
  ernie.mode(2);
  GetRasin2(p4);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Susander1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Raspberry1_slice *
siiServer_imp::Grapefruit1(::Fig_out p1,const ::Chestnut1 p2,::Squash2_out p3,::GoldenDelicous3_out p4,::Fig_out p5,::Peppercorn &p6,CORBA::UShort &p7,::Cauliflower2_out p8,const ::BlackEyedBeans &p9,const ::WaterMelon3 p10,::Turnip3_out p11,::Fig &p12,::Cauliflower2_out p13,::Radish &p14 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Raspberry1_slice * ReturnValue;
  
  
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Grapefruit1");
#endif
  
  ernie.seed("Grapefruit1Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckChestnut1(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckBlackEyedBeans(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckWaterMelon3(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckFig(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckRadish(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Grapefruit1Return"); 
  
  ReturnValue = new ::Raspberry1;
  GetRaspberry1(ReturnValue);
  p1 = new ::Fig;
  ernie.mode(0);
  GetFig(*p1);
  p3 = new ::Squash2;
  ernie.mode(0);
  GetSquash2(*p3);
  p4 = new ::GoldenDelicous3;
  ernie.mode(0);
  GetGoldenDelicous3(*p4);
  p5 = new ::Fig;
  ernie.mode(0);
  GetFig(*p5);
  ernie.mode(0);
  GetPeppercorn(p6);
  ernie.mode(0);
  GetUShort(p7);
  p8 = new ::Cauliflower2;
  ernie.mode(0);
  GetCauliflower2(*p8);
  p11 = new ::Turnip3;
  ernie.mode(0);
  GetTurnip3(*p11);
  ernie.mode(2);
  GetFig(p12);
  p13 = new ::Cauliflower2;
  ernie.mode(0);
  GetCauliflower2(*p13);
  ernie.mode(2);
  GetRadish(p14);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Grapefruit1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::UShort
siiServer_imp::PepinoMelon1(CORBA::Long &p1,::Tomato2 &p2,const ::Fig &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::UShort ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::PepinoMelon1");
#endif
  
  ernie.seed("PepinoMelon1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckLong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckTomato2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckFig(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PepinoMelon1Return"); 
  
  GetUShort(ReturnValue);
  ernie.mode(2);
  GetLong(p1);
  ernie.mode(2);
  GetTomato2(p2);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::PepinoMelon1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Cauliflower2*
siiServer_imp::Peanutsquash1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  ::Cauliflower2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Peanutsquash1");
#endif
  
  ernie.seed("Peanutsquash1Call");
  
  ernie.seed("Peanutsquash1Return"); 
  ReturnValue = new ::Cauliflower2;
  GetCauliflower2(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Peanutsquash1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Tomato2*
siiServer_imp::Artichokes1(::Squash1_out p1,CORBA::ULong p2,CORBA::ULong &p3,::GardenPeas1 &p4,const ::Tomato2 &p5,::YellowPepper2 &p6,const ::Dates3 &p7,::Radish &p8,const ::Blackberry2 &p9,::Rasin2_out p10,::Mangosteen3_out p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Tomato2* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Artichokes1");
#endif
  
  ernie.seed("Artichokes1Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckULong(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckGardenPeas1(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckTomato2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckYellowPepper2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckDates3(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckRadish(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckBlackberry2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Artichokes1Return"); 
  ReturnValue = new ::Tomato2;
  GetTomato2(*ReturnValue);
  p1 = new ::Squash1;
  ernie.mode(0);
  GetSquash1(*p1);
  ernie.mode(0);
  GetULong(p3);
  ernie.mode(2);
  GetGardenPeas1(p4);
  ernie.mode(2);
  GetYellowPepper2(p6);
  ernie.mode(2);
  GetRadish(p8);
  p10 = new ::Rasin2;
  ernie.mode(0);
  GetRasin2(*p10);
  p11 = new ::Mangosteen3;
  ernie.mode(0);
  GetMangosteen3(*p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Artichokes1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Damsons2_slice *
siiServer_imp::Rasin1(const ::Raspberry1 p1,const ::Mangosteen3 &p2,const ::Fig &p3,::Lychees3_out p4,::Carrots p5,::Rasin2_out p6,const ::GoldenDelicous3 &p7,const ::Mullberry1 p8,::Squash1 &p9,::YellowPepper2 &p10,::YellowPepper2 &p11,::GardenPeas3 &p12,const ::Tomato2 &p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Damsons2_slice * ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Rasin1");
#endif
  
  ernie.seed("Rasin1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckRaspberry1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckMangosteen3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckFig(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckGoldenDelicous3(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckMullberry1(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckSquash1(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckYellowPepper2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckYellowPepper2(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckGardenPeas3(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckTomato2(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Rasin1Return"); 
  
  ReturnValue = new ::Damsons2;
  GetDamsons2(ReturnValue);
  p4 = new ::Lychees3;
  ernie.mode(0);
  GetLychees3(*p4);
  ernie.mode(0);
  GetCarrots(p5);
  p6 = new ::Rasin2;
  ernie.mode(0);
  GetRasin2(*p6);
  ernie.mode(2);
  GetSquash1(p9);
  ernie.mode(2);
  GetYellowPepper2(p10);
  ernie.mode(2);
  GetYellowPepper2(p11);
  ernie.mode(2);
  GetGardenPeas3(p12);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Rasin1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Chives2*
siiServer_imp::Chives1(::Tomato &p1,::Peanuts1 p2,::Clementine2 &p3,::Squash1_out p4,::Squash2_out p5,::Oregano3_out p6 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Chives2* ReturnValue;
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Chives1");
#endif
  
  ernie.seed("Chives1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckTomato(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckPeanuts1(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckClementine2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Chives1Return"); 
  ReturnValue = new ::Chives2;
  GetChives2(*ReturnValue);
  ernie.mode(2);
  GetTomato(p1);
  ernie.mode(2);
  GetClementine2(p3);
  p4 = new ::Squash1;
  ernie.mode(0);
  GetSquash1(*p4);
  p5 = new ::Squash2;
  ernie.mode(0);
  GetSquash2(*p5);
  p6 = new ::Oregano3;
  ernie.mode(0);
  GetOregano3(*p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Chives1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Mullberry1_slice *
siiServer_imp::Eddo1(::Chestnut1 p1,::Dates3 &p2,const ::Oregano3 &p3,const ::Rasin2 &p4,::Mangosteen3 &p5,::Squash2 &p6,const ::Oregano3 &p7,::Tomato2_out p8,::BambooShoot3_out p9,::Turnip3_out p10,::Rasin2 &p11,const ::Fennell3 &p12,::GoldenDelicous3 &p13,const ::Mullberry1 p14 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Mullberry1_slice * ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Eddo1");
#endif
  
  ernie.seed("Eddo1Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckDates3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckOregano3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckRasin2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckMangosteen3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckSquash2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckOregano3(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckRasin2(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckFennell3(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckGoldenDelicous3(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckMullberry1(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Eddo1Return"); 
  
  ReturnValue = new ::Mullberry1;
  GetMullberry1(ReturnValue);
  ernie.mode(0);
  GetChestnut1(p1);
  ernie.mode(2);
  GetDates3(p2);
  ernie.mode(2);
  GetMangosteen3(p5);
  ernie.mode(2);
  GetSquash2(p6);
  p8 = new ::Tomato2;
  ernie.mode(0);
  GetTomato2(*p8);
  p9 = new ::BambooShoot3;
  ernie.mode(0);
  GetBambooShoot3(*p9);
  p10 = new ::Turnip3;
  ernie.mode(0);
  GetTurnip3(*p10);
  ernie.mode(2);
  GetRasin2(p11);
  ernie.mode(2);
  GetGoldenDelicous3(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Eddo1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Chives2*
siiServer_imp::GreenChilly1(const ::Chestnut1 p1,::Carrots p2,::Dates3_out p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Chives2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::GreenChilly1");
#endif
  
  ernie.seed("GreenChilly1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckChestnut1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GreenChilly1Return"); 
  ReturnValue = new ::Chives2;
  GetChives2(*ReturnValue);
  ernie.mode(0);
  GetCarrots(p2);
  p3 = new ::Dates3;
  ernie.mode(0);
  GetDates3(*p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::GreenChilly1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Corn1_slice *
siiServer_imp::Peach1(CORBA::Long &p1,::Tomato2 &p2,::Tomato_out p3,::Asparagus_out p4,::Cauliflower2_out p5,const ::Raspberry1 p6,const ::Peppercorn &p7,const ::WaterMelon &p8,::Cauliflower2_out p9,::Chives2_out p10,::Mullberry1 p11,const ::Blackberry2 &p12,::Fennell3_out p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Corn1_slice * ReturnValue;
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Peach1");
#endif
  
  ernie.seed("Peach1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckLong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckTomato2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckRaspberry1(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckPeppercorn(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckWaterMelon(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckMullberry1(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckBlackberry2(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Peach1Return"); 
  
  ReturnValue = new ::Corn1;
  GetCorn1(ReturnValue);
  ernie.mode(2);
  GetLong(p1);
  ernie.mode(2);
  GetTomato2(p2);
  p3 = new ::Tomato;
  ernie.mode(0);
  GetTomato(*p3);
  p4 = new ::Asparagus;
  ernie.mode(0);
  GetAsparagus(*p4);
  p5 = new ::Cauliflower2;
  ernie.mode(0);
  GetCauliflower2(*p5);
  p9 = new ::Cauliflower2;
  ernie.mode(0);
  GetCauliflower2(*p9);
  p10 = new ::Chives2;
  ernie.mode(0);
  GetChives2(*p10);
  ernie.mode(2);
  GetMullberry1(p11);
  p13 = new ::Fennell3;
  ernie.mode(0);
  GetFennell3(*p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Peach1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Squash1*
siiServer_imp::Parsley1(::GardenPeas3 &p1,::Squash2 &p2,const ::Dates3 &p3,::Peanuts1 p4,CORBA::Long p5,::Grapefruit2 &p6,::WaterMelon3 p7,CORBA::ULong p8,::WaterMelon3 p9,::Squash2 &p10,::Radish_out p11,::Mangosteen3 &p12,::BlackEyedBeans &p13,CORBA::UShort &p14,const ::BritishQueens1 &p15,::YellowPepper2_out p16,CORBA::UShort p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Squash1* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Parsley1");
#endif
  
  ernie.seed("Parsley1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckGardenPeas3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckSquash2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckDates3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckPeanuts1(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckLong(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckGrapefruit2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckWaterMelon3(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckULong(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckSquash2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckMangosteen3(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckBlackEyedBeans(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p15");
  if (!CheckBritishQueens1(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p17");
  if (!CheckUShort(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Parsley1Return"); 
  ReturnValue = new ::Squash1;
  GetSquash1(*ReturnValue);
  ernie.mode(2);
  GetGardenPeas3(p1);
  ernie.mode(2);
  GetSquash2(p2);
  ernie.mode(2);
  GetGrapefruit2(p6);
  ernie.mode(2);
  GetWaterMelon3(p7);
  ernie.mode(0);
  GetWaterMelon3(p9);
  ernie.mode(2);
  GetSquash2(p10);
  p11 = new ::Radish;
  ernie.mode(0);
  GetRadish(*p11);
  ernie.mode(2);
  GetMangosteen3(p12);
  ernie.mode(2);
  GetBlackEyedBeans(p13);
  ernie.mode(0);
  GetUShort(p14);
  p16 = new ::YellowPepper2;
  ernie.mode(0);
  GetYellowPepper2(*p16);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Parsley1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GaliaMelon3*
siiServer_imp::Satsuma1(::Pumpkin p1,CORBA::Short &p2,const ::Mullberry1 p3,const ::Clementine2 &p4,::BambooShoot3_out p5,const ::BlackEyedBeans &p6,::Raspberry1 p7,::Oregano3_out p8,const ::Record2 p9,::Celeriac2 &p10,::Grapefruit2 &p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::GaliaMelon3* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Satsuma1");
#endif
  
  ernie.seed("Satsuma1Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckShort(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckMullberry1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckClementine2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckBlackEyedBeans(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckRecord2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckCeleriac2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckGrapefruit2(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Satsuma1Return"); 
  ReturnValue = new ::GaliaMelon3;
  GetGaliaMelon3(*ReturnValue);
  ernie.mode(0);
  GetPumpkin(p1);
  ernie.mode(2);
  GetShort(p2);
  p5 = new ::BambooShoot3;
  ernie.mode(0);
  GetBambooShoot3(*p5);
  ernie.mode(0);
  GetRaspberry1(p7);
  p8 = new ::Oregano3;
  ernie.mode(0);
  GetOregano3(*p8);
  ernie.mode(2);
  GetCeleriac2(p10);
  ernie.mode(2);
  GetGrapefruit2(p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Satsuma1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Peanuts1
siiServer_imp::Basil1(::Mullberry1 p1,const ::Dates3 &p2,::Blackberry2 &p3,::Squash2_out p4,const ::Damsons2 p5,::Corn1 p6,const ::Oregano3 &p7,::Turnip3 &p8,const ::Mullberry1 p9,::Clementine2 &p10,::Grapefruit2_out p11,::Peanuts1 &p12,::Tomato2 &p13,const ::Dates3 &p14 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Peanuts1 ReturnValue;
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Basil1");
#endif
  
  ernie.seed("Basil1Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckDates3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckBlackberry2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckDamsons2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckCorn1(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckOregano3(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckTurnip3(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckMullberry1(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckClementine2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckPeanuts1(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckTomato2(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckDates3(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Basil1Return"); 
  
  GetPeanuts1(ReturnValue);
  ernie.mode(0);
  GetMullberry1(p1);
  ernie.mode(2);
  GetBlackberry2(p3);
  p4 = new ::Squash2;
  ernie.mode(0);
  GetSquash2(*p4);
  ernie.mode(2);
  GetCorn1(p6);
  ernie.mode(2);
  GetTurnip3(p8);
  ernie.mode(2);
  GetClementine2(p10);
  p11 = new ::Grapefruit2;
  ernie.mode(0);
  GetGrapefruit2(*p11);
  ernie.mode(2);
  GetPeanuts1(p12);
  ernie.mode(2);
  GetTomato2(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Basil1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Octet
siiServer_imp::CoxPippin1(::YellowPepper2 &p1,::BrazilNut3 &p2,::Grapefruit2_out p3,CORBA::Double p4,::Corn1 p5,::Fig_out p6,::Susander2 &p7,::Peanuts1 p8,::Mullberry1 p9,::Celeriac2_out p10,::Cauliflower2_out p11,const ::Beetroot2 &p12,::Clementine2 &p13,::WaterMelon3 p14,::Dates3 &p15,::Squash2_out p16,CORBA::ULong p17,::Damsons2 p18 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Octet ReturnValue;
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::CoxPippin1");
#endif
  
  ernie.seed("CoxPippin1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckYellowPepper2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckBrazilNut3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckDouble(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckCorn1(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckSusander2(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckPeanuts1(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckBeetroot2(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckClementine2(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p15");
  if (!CheckDates3(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p17");
  if (!CheckULong(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CoxPippin1Return"); 
  
  GetOctet(ReturnValue);
  ernie.mode(2);
  GetYellowPepper2(p1);
  ernie.mode(2);
  GetBrazilNut3(p2);
  p3 = new ::Grapefruit2;
  ernie.mode(0);
  GetGrapefruit2(*p3);
  ernie.mode(2);
  GetCorn1(p5);
  p6 = new ::Fig;
  ernie.mode(0);
  GetFig(*p6);
  ernie.mode(2);
  GetSusander2(p7);
  ernie.mode(0);
  GetMullberry1(p9);
  p10 = new ::Celeriac2;
  ernie.mode(0);
  GetCeleriac2(*p10);
  p11 = new ::Cauliflower2;
  ernie.mode(0);
  GetCauliflower2(*p11);
  ernie.mode(2);
  GetClementine2(p13);
  ernie.mode(0);
  GetWaterMelon3(p14);
  ernie.mode(2);
  GetDates3(p15);
  p16 = new ::Squash2;
  ernie.mode(0);
  GetSquash2(*p16);
  ernie.mode(0);
  GetDamsons2(p18);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::CoxPippin1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Chives2*
siiServer_imp::Blackberry1(::Rasin2_out p1,::Squash1_out p2,::BritishQueens1 &p3,::Fennell3 &p4,::Tomato2_out p5,::Blackberry2 &p6 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Chives2* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Blackberry1");
#endif
  
  ernie.seed("Blackberry1Call");
  ernie.mode(1);
  AddName("p3");
  if (!CheckBritishQueens1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckFennell3(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckBlackberry2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Blackberry1Return"); 
  ReturnValue = new ::Chives2;
  GetChives2(*ReturnValue);
  p1 = new ::Rasin2;
  ernie.mode(0);
  GetRasin2(*p1);
  p2 = new ::Squash1;
  ernie.mode(0);
  GetSquash1(*p2);
  ernie.mode(2);
  GetBritishQueens1(p3);
  ernie.mode(2);
  GetFennell3(p4);
  p5 = new ::Tomato2;
  ernie.mode(0);
  GetTomato2(*p5);
  ernie.mode(2);
  GetBlackberry2(p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Blackberry1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Tomato2*
siiServer_imp::GreenPepper1(const ::Mullberry1 p1 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Tomato2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::GreenPepper1");
#endif
  
  ernie.seed("GreenPepper1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckMullberry1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GreenPepper1Return"); 
  ReturnValue = new ::Tomato2;
  GetTomato2(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::GreenPepper1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Chives2*
siiServer_imp::Scallion1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  ::Chives2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Scallion1");
#endif
  
  ernie.seed("Scallion1Call");
  
  ernie.seed("Scallion1Return"); 
  ReturnValue = new ::Chives2;
  GetChives2(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Scallion1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::YellowPepper2*
siiServer_imp::Currant1(const ::Asparagus &p1,const ::LoganBerry &p2,const ::Squash2 &p3,const ::Lychees3 &p4,CORBA::ULong &p5,const ::Corn1 p6,::BlackEyedBeans_out p7,const ::GardenPeas3 &p8,::Dates3_out p9,CORBA::Float &p10 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::YellowPepper2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Currant1");
#endif
  
  ernie.seed("Currant1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckAsparagus(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckLoganBerry(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckSquash2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckLychees3(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckULong(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckCorn1(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckGardenPeas3(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Currant1Return"); 
  ReturnValue = new ::YellowPepper2;
  GetYellowPepper2(*ReturnValue);
  ernie.mode(2);
  GetULong(p5);
  p7 = new ::BlackEyedBeans;
  ernie.mode(0);
  GetBlackEyedBeans(*p7);
  p9 = new ::Dates3;
  ernie.mode(0);
  GetDates3(*p9);
  ernie.mode(0);
  GetFloat(p10);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Currant1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Chestnut1_slice *
siiServer_imp::IcebergLettuce1(const ::Susander2 &p1,::Squash2_out p2,CORBA::Boolean p3,const ::Fig &p4,CORBA::Long &p5,CORBA::Double &p6,::Dates3 &p7,::Oregano3_out p8,const ::BritishQueens1 &p9,::Tomato2_out p10,::Squash2_out p11,::Peanuts1 &p12 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Chestnut1_slice * ReturnValue;
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::IcebergLettuce1");
#endif
  
  ernie.seed("IcebergLettuce1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckSusander2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckBoolean(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckFig(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckLong(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckDouble(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckDates3(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckBritishQueens1(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckPeanuts1(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("IcebergLettuce1Return"); 
  
  ReturnValue = new ::Chestnut1;
  GetChestnut1(ReturnValue);
  p2 = new ::Squash2;
  ernie.mode(0);
  GetSquash2(*p2);
  ernie.mode(2);
  GetLong(p5);
  ernie.mode(2);
  GetDouble(p6);
  ernie.mode(2);
  GetDates3(p7);
  p8 = new ::Oregano3;
  ernie.mode(0);
  GetOregano3(*p8);
  p10 = new ::Tomato2;
  ernie.mode(0);
  GetTomato2(*p10);
  p11 = new ::Squash2;
  ernie.mode(0);
  GetSquash2(*p11);
  ernie.mode(2);
  GetPeanuts1(p12);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::IcebergLettuce1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Fennell3*
siiServer_imp::Tomato1(const ::Squash2 &p1 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Fennell3* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Tomato1");
#endif
  
  ernie.seed("Tomato1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckSquash2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Tomato1Return"); 
  ReturnValue = new ::Fennell3;
  GetFennell3(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Tomato1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Celeriac2*
siiServer_imp::PippinApple1(::BambooShoot3 &p1,::BeechNut2 &p2,CORBA::Float &p3,::Chestnut1 p4,const ::BambooShoot3 &p5,::Corn1 p6,CORBA::Long p7,::Blackberry2_out p8,const ::Tomato2 &p9,const ::Fig &p10,::Squash1 &p11,const ::Clementine2 &p12,::Squash1_out p13,::GaliaMelon3_out p14,::Fig &p15 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Celeriac2* ReturnValue;
  
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::PippinApple1");
#endif
  
  ernie.seed("PippinApple1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckBambooShoot3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckBeechNut2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckFloat(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckBambooShoot3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckLong(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckTomato2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckFig(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckSquash1(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckClementine2(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p15");
  if (!CheckFig(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PippinApple1Return"); 
  ReturnValue = new ::Celeriac2;
  GetCeleriac2(*ReturnValue);
  ernie.mode(2);
  GetBambooShoot3(p1);
  ernie.mode(2);
  GetBeechNut2(p2);
  ernie.mode(2);
  GetFloat(p3);
  ernie.mode(0);
  GetChestnut1(p4);
  ernie.mode(0);
  GetCorn1(p6);
  p8 = new ::Blackberry2;
  ernie.mode(0);
  GetBlackberry2(*p8);
  ernie.mode(2);
  GetSquash1(p11);
  p13 = new ::Squash1;
  ernie.mode(0);
  GetSquash1(*p13);
  p14 = new ::GaliaMelon3;
  ernie.mode(0);
  GetGaliaMelon3(*p14);
  ernie.mode(2);
  GetFig(p15);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::PippinApple1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Rasin2*
siiServer_imp::Celeriac1(::Corn1 p1,const ::Dates3 &p2,const ::Squash2 &p3,::Fig_out p4,const ::LoganBerry &p5,::BritishQueens1_out p6,const ::Record2 p7,::Mullberry1 p8,::YellowPepper2 &p9,::GaliaMelon3 &p10,const ::BrazilNut3 &p11,CORBA::UShort &p12,const ::Fig &p13,::BeechNut2 &p14,CORBA::Float &p15,const ::Grapefruit2 &p16,CORBA::Long &p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Rasin2* ReturnValue;
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Celeriac1");
#endif
  
  ernie.seed("Celeriac1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckCorn1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckDates3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckSquash2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckLoganBerry(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckRecord2(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckMullberry1(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckYellowPepper2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckGaliaMelon3(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckBrazilNut3(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckFig(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckBeechNut2(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckGrapefruit2(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Celeriac1Return"); 
  ReturnValue = new ::Rasin2;
  GetRasin2(*ReturnValue);
  ernie.mode(2);
  GetCorn1(p1);
  p4 = new ::Fig;
  ernie.mode(0);
  GetFig(*p4);
  p6 = new ::BritishQueens1;
  ernie.mode(0);
  GetBritishQueens1(*p6);
  ernie.mode(2);
  GetMullberry1(p8);
  ernie.mode(2);
  GetYellowPepper2(p9);
  ernie.mode(2);
  GetGaliaMelon3(p10);
  ernie.mode(0);
  GetUShort(p12);
  ernie.mode(2);
  GetBeechNut2(p14);
  ernie.mode(0);
  GetFloat(p15);
  ernie.mode(0);
  GetLong(p17);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Celeriac1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Tomato2*
siiServer_imp::Cauliflower1(::Dates3_out p1,::LoganBerry_out p2,const ::Lychees3 &p3,const ::Celeriac2 &p4,::BambooShoot3 &p5,::Susander2_out p6,::Peanuts1 &p7,CORBA::Double &p8,::Currant2_out p9,const ::Tomato2 &p10,const ::BeechNut2 &p11,CORBA::UShort &p12,::YellowPepper2 &p13,::GaliaMelon3 &p14,CORBA::ULong &p15,const ::GaliaMelon3 &p16,const ::Beetroot2 &p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Tomato2* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Cauliflower1");
#endif
  
  ernie.seed("Cauliflower1Call");
  ernie.mode(0);
  AddName("p3");
  if (!CheckLychees3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckCeleriac2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckBambooShoot3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckDouble(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckTomato2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckBeechNut2(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckUShort(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckYellowPepper2(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckGaliaMelon3(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckGaliaMelon3(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p17");
  if (!CheckBeetroot2(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cauliflower1Return"); 
  ReturnValue = new ::Tomato2;
  GetTomato2(*ReturnValue);
  p1 = new ::Dates3;
  ernie.mode(0);
  GetDates3(*p1);
  p2 = new ::LoganBerry;
  ernie.mode(0);
  GetLoganBerry(*p2);
  ernie.mode(2);
  GetBambooShoot3(p5);
  p6 = new ::Susander2;
  ernie.mode(0);
  GetSusander2(*p6);
  ernie.mode(0);
  GetPeanuts1(p7);
  ernie.mode(2);
  GetDouble(p8);
  p9 = new ::Currant2;
  ernie.mode(0);
  GetCurrant2(*p9);
  ernie.mode(2);
  GetUShort(p12);
  ernie.mode(2);
  GetYellowPepper2(p13);
  ernie.mode(2);
  GetGaliaMelon3(p14);
  ernie.mode(0);
  GetULong(p15);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Cauliflower1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Lychees3*
siiServer_imp::Corriander1(const ::Record2 p1,const ::BambooShoot3 &p2,const ::Oregano3 &p3,CORBA::ULong p4,::Chives2 &p5,const ::Turnip3 &p6,::Cauliflower2_out p7 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Lychees3* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Corriander1");
#endif
  
  ernie.seed("Corriander1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckRecord2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckBambooShoot3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckOregano3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckULong(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckChives2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckTurnip3(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Corriander1Return"); 
  ReturnValue = new ::Lychees3;
  GetLychees3(*ReturnValue);
  ernie.mode(2);
  GetChives2(p5);
  p7 = new ::Cauliflower2;
  ernie.mode(0);
  GetCauliflower2(*p7);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Corriander1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::BrazilNut3*
siiServer_imp::RedCabbage1(::BritishQueens1_out p1,const ::Celeriac2 &p2,const ::Squash2 &p3,CORBA::Octet &p4,const ::Fig &p5,::Record2 p6,::Turnip3_out p7,CORBA::Float p8,const ::BritishQueens1 &p9,const ::YellowPepper2 &p10,::Cauliflower2 &p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::BrazilNut3* ReturnValue;
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::RedCabbage1");
#endif
  
  ernie.seed("RedCabbage1Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckCeleriac2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckSquash2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckFig(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckFloat(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckBritishQueens1(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckYellowPepper2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckCauliflower2(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedCabbage1Return"); 
  ReturnValue = new ::BrazilNut3;
  GetBrazilNut3(*ReturnValue);
  p1 = new ::BritishQueens1;
  ernie.mode(0);
  GetBritishQueens1(*p1);
  ernie.mode(0);
  GetOctet(p4);
  ernie.mode(0);
  GetRecord2(p6);
  p7 = new ::Turnip3;
  ernie.mode(0);
  GetTurnip3(*p7);
  ernie.mode(2);
  GetCauliflower2(p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::RedCabbage1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Radish*
siiServer_imp::ChineseLeaves1(::BritishQueens1_out p1,::GaliaMelon3 &p2,::Mangosteen3 &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Radish* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::ChineseLeaves1");
#endif
  
  ernie.seed("ChineseLeaves1Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckGaliaMelon3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckMangosteen3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ChineseLeaves1Return"); 
  ReturnValue = new ::Radish;
  GetRadish(*ReturnValue);
  p1 = new ::BritishQueens1;
  ernie.mode(0);
  GetBritishQueens1(*p1);
  ernie.mode(2);
  GetGaliaMelon3(p2);
  ernie.mode(2);
  GetMangosteen3(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::ChineseLeaves1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Squash2*
siiServer_imp::Potato1(::Squash2_out p1,::Lychees3 &p2,::Turnip3_out p3,::Mangosteen3 &p4,const ::Currant2 &p5,::WaterMelon3 p6,const ::Lychees3 &p7,const ::BritishQueens1 &p8 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Squash2* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Potato1");
#endif
  
  ernie.seed("Potato1Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckLychees3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckMangosteen3(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckCurrant2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckWaterMelon3(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckLychees3(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckBritishQueens1(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Potato1Return"); 
  ReturnValue = new ::Squash2;
  GetSquash2(*ReturnValue);
  p1 = new ::Squash2;
  ernie.mode(0);
  GetSquash2(*p1);
  ernie.mode(2);
  GetLychees3(p2);
  p3 = new ::Turnip3;
  ernie.mode(0);
  GetTurnip3(*p3);
  ernie.mode(2);
  GetMangosteen3(p4);
  ernie.mode(2);
  GetWaterMelon3(p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Potato1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::BrazilNut3*
siiServer_imp::Homeguard1(const ::Chives2 &p1 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::BrazilNut3* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Homeguard1");
#endif
  
  ernie.seed("Homeguard1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckChives2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Homeguard1Return"); 
  ReturnValue = new ::BrazilNut3;
  GetBrazilNut3(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Homeguard1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::BritishQueens1*
siiServer_imp::Wilja1( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  ::BritishQueens1* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::Wilja1");
#endif
  
  ernie.seed("Wilja1Call");
  
  ernie.seed("Wilja1Return"); 
  ReturnValue = new ::BritishQueens1;
  GetBritishQueens1(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::Wilja1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Grapefruit2*
siiServer_imp::KerrsPinks1(::Dates3_out p1,char * &p2,::Squash1 &p3,const ::Clementine2 &p4,const ::Cauliflower2 &p5 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Grapefruit2* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ConstructedTypeTests::KerrsPinks1");
#endif
  
  ernie.seed("KerrsPinks1Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckString(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckSquash1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckClementine2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckCauliflower2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KerrsPinks1Return"); 
  ReturnValue = new ::Grapefruit2;
  GetGrapefruit2(*ReturnValue);
  p1 = new ::Dates3;
  ernie.mode(0);
  GetDates3(*p1);
  ernie.mode(2);
  p2 = GetString();
  ernie.mode(2);
  GetSquash1(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ConstructedTypeTests::KerrsPinks1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::GoldenWonder1(CORBA::TypeCode_ptr p1,CORBA::TypeCode_out p2,CORBA::TypeCode_out p3,CORBA::TypeCode_ptr p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_out p6,CORBA::TypeCode_ptr p7,CORBA::TypeCode_ptr p8,CORBA::TypeCode_ptr p9,CORBA::TypeCode_ptr p10,CORBA::TypeCode_out p11,CORBA::TypeCode_out p12,CORBA::TypeCode_ptr p13,CORBA::TypeCode_ptr &p14,CORBA::TypeCode_out p15,CORBA::TypeCode_ptr p16,CORBA::TypeCode_ptr &p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::GoldenWonder1");
#endif
  
  ernie.seed("GoldenWonder1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckCORBATypeCode_ptr(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckCORBATypeCode_ptr(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckCORBATypeCode_ptr(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckCORBATypeCode_ptr(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckCORBATypeCode_ptr(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckCORBATypeCode_ptr(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckCORBATypeCode_ptr(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p17");
  if (!CheckCORBATypeCode_ptr(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GoldenWonder1Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p2);
	p2=CORBA::TypeCode::_duplicate(p2);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p6);
	p6=CORBA::TypeCode::_duplicate(p6);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p11);
	p11=CORBA::TypeCode::_duplicate(p11);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p12);
	p12=CORBA::TypeCode::_duplicate(p12);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p14);
	p14=CORBA::TypeCode::_duplicate(p14);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p15);
	p15=CORBA::TypeCode::_duplicate(p15);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p17);
	p17=CORBA::TypeCode::_duplicate(p17);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::GoldenWonder1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Pimpernel1(CORBA::TypeCode_out p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_ptr p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_out p6 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Pimpernel1");
#endif
  
  ernie.seed("Pimpernel1Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Pimpernel1Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p6);
	p6=CORBA::TypeCode::_duplicate(p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Pimpernel1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Cultra1(CORBA::TypeCode_ptr &p1 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Cultra1");
#endif
  
  ernie.seed("Cultra1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cultra1Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Cultra1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Rooster1(CORBA::TypeCode_out p1,CORBA::TypeCode_ptr &p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_ptr p5,CORBA::TypeCode_ptr &p6,CORBA::TypeCode_out p7,CORBA::TypeCode_out p8,CORBA::TypeCode_ptr &p9,CORBA::TypeCode_out p10,CORBA::TypeCode_ptr &p11,CORBA::TypeCode_out p12 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Rooster1");
#endif
  
  ernie.seed("Rooster1Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckCORBATypeCode_ptr(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckCORBATypeCode_ptr(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Rooster1Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p2);
	p2=CORBA::TypeCode::_duplicate(p2);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p6);
	p6=CORBA::TypeCode::_duplicate(p6);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p7);
	p7=CORBA::TypeCode::_duplicate(p7);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p8);
	p8=CORBA::TypeCode::_duplicate(p8);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p9);
	p9=CORBA::TypeCode::_duplicate(p9);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p10);
	p10=CORBA::TypeCode::_duplicate(p10);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p11);
	p11=CORBA::TypeCode::_duplicate(p11);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p12);
	p12=CORBA::TypeCode::_duplicate(p12);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Rooster1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::MarisPiper1(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_out p4,CORBA::TypeCode_out p5,CORBA::TypeCode_out p6,CORBA::TypeCode_ptr &p7,CORBA::TypeCode_out p8,CORBA::TypeCode_out p9,CORBA::TypeCode_ptr p10,CORBA::TypeCode_ptr &p11,CORBA::TypeCode_out p12,CORBA::TypeCode_ptr &p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::MarisPiper1");
#endif
  
  ernie.seed("MarisPiper1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckCORBATypeCode_ptr(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckCORBATypeCode_ptr(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckCORBATypeCode_ptr(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckCORBATypeCode_ptr(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MarisPiper1Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p6);
	p6=CORBA::TypeCode::_duplicate(p6);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p7);
	p7=CORBA::TypeCode::_duplicate(p7);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p8);
	p8=CORBA::TypeCode::_duplicate(p8);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p9);
	p9=CORBA::TypeCode::_duplicate(p9);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p11);
	p11=CORBA::TypeCode::_duplicate(p11);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p12);
	p12=CORBA::TypeCode::_duplicate(p12);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p13);
	p13=CORBA::TypeCode::_duplicate(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::MarisPiper1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Cara1(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr &p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_out p4,CORBA::TypeCode_ptr p5 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Cara1");
#endif
  
  ernie.seed("Cara1Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cara1Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p2);
	p2=CORBA::TypeCode::_duplicate(p2);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Cara1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::KingEdward1(CORBA::TypeCode_ptr &p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_ptr p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_ptr &p6,CORBA::TypeCode_ptr &p7,CORBA::TypeCode_ptr p8,CORBA::TypeCode_out p9,CORBA::TypeCode_out p10,CORBA::TypeCode_ptr &p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::KingEdward1");
#endif
  
  ernie.seed("KingEdward1Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckCORBATypeCode_ptr(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckCORBATypeCode_ptr(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckCORBATypeCode_ptr(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KingEdward1Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p6);
	p6=CORBA::TypeCode::_duplicate(p6);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p7);
	p7=CORBA::TypeCode::_duplicate(p7);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p9);
	p9=CORBA::TypeCode::_duplicate(p9);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p10);
	p10=CORBA::TypeCode::_duplicate(p10);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p11);
	p11=CORBA::TypeCode::_duplicate(p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::KingEdward1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::PentlandDell1(CORBA::TypeCode_out p1,CORBA::TypeCode_out p2,CORBA::TypeCode_out p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_ptr p5,CORBA::TypeCode_ptr &p6,CORBA::TypeCode_ptr p7,CORBA::TypeCode_ptr p8 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::PentlandDell1");
#endif
  
  ernie.seed("PentlandDell1Call");
  ernie.mode(1);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckCORBATypeCode_ptr(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckCORBATypeCode_ptr(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PentlandDell1Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p2);
	p2=CORBA::TypeCode::_duplicate(p2);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p6);
	p6=CORBA::TypeCode::_duplicate(p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::PentlandDell1");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Apple2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr &p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_out p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_ptr &p7,CORBA::TypeCode_ptr p8,CORBA::TypeCode_ptr &p9,CORBA::TypeCode_out p10,CORBA::TypeCode_ptr p11,CORBA::TypeCode_ptr p12,CORBA::TypeCode_ptr &p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Apple2");
#endif
  
  ernie.seed("Apple2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckCORBATypeCode_ptr(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckCORBATypeCode_ptr(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckCORBATypeCode_ptr(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckCORBATypeCode_ptr(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckCORBATypeCode_ptr(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckCORBATypeCode_ptr(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Apple2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p2);
	p2=CORBA::TypeCode::_duplicate(p2);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p7);
	p7=CORBA::TypeCode::_duplicate(p7);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p9);
	p9=CORBA::TypeCode::_duplicate(p9);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p10);
	p10=CORBA::TypeCode::_duplicate(p10);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p13);
	p13=CORBA::TypeCode::_duplicate(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Apple2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Banana2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_out p5 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Banana2");
#endif
  
  ernie.seed("Banana2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Banana2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Banana2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Carrots2(CORBA::TypeCode_ptr &p1,CORBA::TypeCode_out p2,CORBA::TypeCode_out p3,CORBA::TypeCode_ptr p4,CORBA::TypeCode_out p5,CORBA::TypeCode_out p6,CORBA::TypeCode_ptr &p7,CORBA::TypeCode_ptr &p8,CORBA::TypeCode_out p9 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Carrots2");
#endif
  
  ernie.seed("Carrots2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckCORBATypeCode_ptr(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckCORBATypeCode_ptr(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Carrots2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p2);
	p2=CORBA::TypeCode::_duplicate(p2);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p6);
	p6=CORBA::TypeCode::_duplicate(p6);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p7);
	p7=CORBA::TypeCode::_duplicate(p7);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p8);
	p8=CORBA::TypeCode::_duplicate(p8);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p9);
	p9=CORBA::TypeCode::_duplicate(p9);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Carrots2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Lemon2(CORBA::TypeCode_ptr &p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_out p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_out p7,CORBA::TypeCode_out p8,CORBA::TypeCode_ptr p9,CORBA::TypeCode_ptr p10 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Lemon2");
#endif
  
  ernie.seed("Lemon2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckCORBATypeCode_ptr(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckCORBATypeCode_ptr(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lemon2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p7);
	p7=CORBA::TypeCode::_duplicate(p7);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p8);
	p8=CORBA::TypeCode::_duplicate(p8);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Lemon2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::BlackCherry2(CORBA::TypeCode_out p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_out p4,CORBA::TypeCode_ptr p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_ptr p7,CORBA::TypeCode_ptr &p8,CORBA::TypeCode_out p9 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::BlackCherry2");
#endif
  
  ernie.seed("BlackCherry2Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckCORBATypeCode_ptr(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckCORBATypeCode_ptr(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlackCherry2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p8);
	p8=CORBA::TypeCode::_duplicate(p8);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p9);
	p9=CORBA::TypeCode::_duplicate(p9);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::BlackCherry2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Starfruit2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr &p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_out p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_out p6,CORBA::TypeCode_out p7,CORBA::TypeCode_ptr p8,CORBA::TypeCode_out p9,CORBA::TypeCode_ptr p10,CORBA::TypeCode_ptr &p11,CORBA::TypeCode_ptr &p12 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Starfruit2");
#endif
  
  ernie.seed("Starfruit2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckCORBATypeCode_ptr(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckCORBATypeCode_ptr(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckCORBATypeCode_ptr(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckCORBATypeCode_ptr(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Starfruit2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p2);
	p2=CORBA::TypeCode::_duplicate(p2);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p6);
	p6=CORBA::TypeCode::_duplicate(p6);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p7);
	p7=CORBA::TypeCode::_duplicate(p7);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p9);
	p9=CORBA::TypeCode::_duplicate(p9);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p11);
	p11=CORBA::TypeCode::_duplicate(p11);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p12);
	p12=CORBA::TypeCode::_duplicate(p12);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Starfruit2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Rhubarb2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_out p6,CORBA::TypeCode_out p7 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Rhubarb2");
#endif
  
  ernie.seed("Rhubarb2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Rhubarb2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p6);
	p6=CORBA::TypeCode::_duplicate(p6);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p7);
	p7=CORBA::TypeCode::_duplicate(p7);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Rhubarb2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::PassionFruit2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::PassionFruit2");
#endif
  
  ernie.seed("PassionFruit2Call");
  
  ernie.seed("PassionFruit2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::PassionFruit2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Pumpkin2(CORBA::TypeCode_out p1,CORBA::TypeCode_out p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_out p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_ptr p7,CORBA::TypeCode_ptr p8,CORBA::TypeCode_out p9,CORBA::TypeCode_ptr &p10,CORBA::TypeCode_ptr p11,CORBA::TypeCode_ptr p12,CORBA::TypeCode_out p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Pumpkin2");
#endif
  
  ernie.seed("Pumpkin2Call");
  ernie.mode(1);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckCORBATypeCode_ptr(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckCORBATypeCode_ptr(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckCORBATypeCode_ptr(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckCORBATypeCode_ptr(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckCORBATypeCode_ptr(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Pumpkin2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p2);
	p2=CORBA::TypeCode::_duplicate(p2);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p9);
	p9=CORBA::TypeCode::_duplicate(p9);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p10);
	p10=CORBA::TypeCode::_duplicate(p10);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p13);
	p13=CORBA::TypeCode::_duplicate(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Pumpkin2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Mango2(CORBA::TypeCode_out p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_out p4,CORBA::TypeCode_out p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_out p7,CORBA::TypeCode_ptr p8,CORBA::TypeCode_out p9,CORBA::TypeCode_ptr &p10,CORBA::TypeCode_ptr &p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Mango2");
#endif
  
  ernie.seed("Mango2Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckCORBATypeCode_ptr(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckCORBATypeCode_ptr(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckCORBATypeCode_ptr(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Mango2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p7);
	p7=CORBA::TypeCode::_duplicate(p7);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p9);
	p9=CORBA::TypeCode::_duplicate(p9);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p10);
	p10=CORBA::TypeCode::_duplicate(p10);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p11);
	p11=CORBA::TypeCode::_duplicate(p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Mango2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::WaterMelon2(CORBA::TypeCode_ptr &p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_out p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_ptr p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_ptr p7,CORBA::TypeCode_out p8,CORBA::TypeCode_out p9,CORBA::TypeCode_ptr p10,CORBA::TypeCode_ptr p11,CORBA::TypeCode_ptr &p12,CORBA::TypeCode_ptr &p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::WaterMelon2");
#endif
  
  ernie.seed("WaterMelon2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckCORBATypeCode_ptr(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckCORBATypeCode_ptr(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckCORBATypeCode_ptr(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckCORBATypeCode_ptr(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckCORBATypeCode_ptr(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("WaterMelon2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p8);
	p8=CORBA::TypeCode::_duplicate(p8);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p9);
	p9=CORBA::TypeCode::_duplicate(p9);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p12);
	p12=CORBA::TypeCode::_duplicate(p12);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p13);
	p13=CORBA::TypeCode::_duplicate(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::WaterMelon2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Lime2(CORBA::TypeCode_ptr &p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_ptr &p6,CORBA::TypeCode_ptr &p7 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Lime2");
#endif
  
  ernie.seed("Lime2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckCORBATypeCode_ptr(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lime2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p6);
	p6=CORBA::TypeCode::_duplicate(p6);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p7);
	p7=CORBA::TypeCode::_duplicate(p7);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Lime2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Dates2(CORBA::TypeCode_out p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_out p5,CORBA::TypeCode_ptr &p6,CORBA::TypeCode_out p7,CORBA::TypeCode_ptr p8 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Dates2");
#endif
  
  ernie.seed("Dates2Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckCORBATypeCode_ptr(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Dates2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p6);
	p6=CORBA::TypeCode::_duplicate(p6);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p7);
	p7=CORBA::TypeCode::_duplicate(p7);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Dates2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Coconut2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Coconut2");
#endif
  
  ernie.seed("Coconut2Call");
  
  ernie.seed("Coconut2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Coconut2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Lychees2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_out p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_ptr &p5 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Lychees2");
#endif
  
  ernie.seed("Lychees2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lychees2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p2);
	p2=CORBA::TypeCode::_duplicate(p2);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Lychees2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Cabbage2(CORBA::TypeCode_ptr &p1,CORBA::TypeCode_ptr &p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_ptr p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_out p6,CORBA::TypeCode_ptr p7 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Cabbage2");
#endif
  
  ernie.seed("Cabbage2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckCORBATypeCode_ptr(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cabbage2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p2);
	p2=CORBA::TypeCode::_duplicate(p2);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p6);
	p6=CORBA::TypeCode::_duplicate(p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Cabbage2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Cucumber2(CORBA::TypeCode_out p1,CORBA::TypeCode_out p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_out p4 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Cucumber2");
#endif
  
  ernie.seed("Cucumber2Call");
  ernie.mode(1);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cucumber2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p2);
	p2=CORBA::TypeCode::_duplicate(p2);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Cucumber2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Ginger2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr p2 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Ginger2");
#endif
  
  ernie.seed("Ginger2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Ginger2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Ginger2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Apricots2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_out p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_out p4,CORBA::TypeCode_out p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_ptr p7,CORBA::TypeCode_out p8,CORBA::TypeCode_out p9,CORBA::TypeCode_ptr &p10,CORBA::TypeCode_ptr &p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Apricots2");
#endif
  
  ernie.seed("Apricots2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckCORBATypeCode_ptr(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckCORBATypeCode_ptr(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckCORBATypeCode_ptr(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Apricots2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p2);
	p2=CORBA::TypeCode::_duplicate(p2);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p5);
	p5=CORBA::TypeCode::_duplicate(p5);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p8);
	p8=CORBA::TypeCode::_duplicate(p8);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p9);
	p9=CORBA::TypeCode::_duplicate(p9);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p10);
	p10=CORBA::TypeCode::_duplicate(p10);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p11);
	p11=CORBA::TypeCode::_duplicate(p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Apricots2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::BlackEyedBeans2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_out p2,CORBA::TypeCode_out p3,CORBA::TypeCode_ptr p4,CORBA::TypeCode_ptr p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_out p7,CORBA::TypeCode_out p8,CORBA::TypeCode_out p9,CORBA::TypeCode_ptr p10 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::BlackEyedBeans2");
#endif
  
  ernie.seed("BlackEyedBeans2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckCORBATypeCode_ptr(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckCORBATypeCode_ptr(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlackEyedBeans2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p2);
	p2=CORBA::TypeCode::_duplicate(p2);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p7);
	p7=CORBA::TypeCode::_duplicate(p7);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p8);
	p8=CORBA::TypeCode::_duplicate(p8);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p9);
	p9=CORBA::TypeCode::_duplicate(p9);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::BlackEyedBeans2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Leek2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_out p4 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Leek2");
#endif
  
  ernie.seed("Leek2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckCORBATypeCode_ptr(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Leek2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Leek2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Mint2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Mint2");
#endif
  
  ernie.seed("Mint2Call");
  
  ernie.seed("Mint2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Mint2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::GardenPeas2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::GardenPeas2");
#endif
  
  ernie.seed("GardenPeas2Call");
  
  ernie.seed("GardenPeas2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::GardenPeas2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::GardenPeas2(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::GardenPeas2");
#endif
  
  ernie.seed("GardenPeas2Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckCORBATypeCode_ptr(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GardenPeas2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::GardenPeas2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::TypeCode_ptr
siiServer_imp::Asparagus2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Asparagus2");
#endif
  
  ernie.seed("Asparagus2Call");
  
  ernie.seed("Asparagus2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Asparagus2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Asparagus2(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Asparagus2");
#endif
  
  ernie.seed("Asparagus2Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckCORBATypeCode_ptr(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Asparagus2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Asparagus2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::TypeCode_ptr
siiServer_imp::GaliaMelon2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::GaliaMelon2");
#endif
  
  ernie.seed("GaliaMelon2Call");
  
  ernie.seed("GaliaMelon2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::GaliaMelon2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::GaliaMelon2(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::GaliaMelon2");
#endif
  
  ernie.seed("GaliaMelon2Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckCORBATypeCode_ptr(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GaliaMelon2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::GaliaMelon2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::TypeCode_ptr
siiServer_imp::Sultana2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Sultana2");
#endif
  
  ernie.seed("Sultana2Call");
  
  ernie.seed("Sultana2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Sultana2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Sultana2(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Sultana2");
#endif
  
  ernie.seed("Sultana2Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckCORBATypeCode_ptr(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sultana2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Sultana2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::TypeCode_ptr
siiServer_imp::Turnip2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Turnip2");
#endif
  
  ernie.seed("Turnip2Call");
  
  ernie.seed("Turnip2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Turnip2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Turnip2(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Turnip2");
#endif
  
  ernie.seed("Turnip2Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckCORBATypeCode_ptr(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Turnip2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Turnip2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::TypeCode_ptr
siiServer_imp::Orange2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Orange2");
#endif
  
  ernie.seed("Orange2Call");
  
  ernie.seed("Orange2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Orange2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Orange2(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Orange2");
#endif
  
  ernie.seed("Orange2Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckCORBATypeCode_ptr(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Orange2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Orange2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::TypeCode_ptr
siiServer_imp::LoganBerry2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::LoganBerry2");
#endif
  
  ernie.seed("LoganBerry2Call");
  
  ernie.seed("LoganBerry2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::LoganBerry2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::LoganBerry2(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::LoganBerry2");
#endif
  
  ernie.seed("LoganBerry2Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckCORBATypeCode_ptr(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LoganBerry2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::LoganBerry2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::TypeCode_ptr
siiServer_imp::Parsnip2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Parsnip2");
#endif
  
  ernie.seed("Parsnip2Call");
  
  ernie.seed("Parsnip2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Parsnip2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Celery2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Celery2");
#endif
  
  ernie.seed("Celery2Call");
  
  ernie.seed("Celery2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Celery2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::WhiteCabbage2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::WhiteCabbage2");
#endif
  
  ernie.seed("WhiteCabbage2Call");
  
  ernie.seed("WhiteCabbage2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::WhiteCabbage2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Aniseed2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Aniseed2");
#endif
  
  ernie.seed("Aniseed2Call");
  
  ernie.seed("Aniseed2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Aniseed2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Bayleaf2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Bayleaf2");
#endif
  
  ernie.seed("Bayleaf2Call");
  
  ernie.seed("Bayleaf2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Bayleaf2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Dill2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Dill2");
#endif
  
  ernie.seed("Dill2Call");
  
  ernie.seed("Dill2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Dill2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Oregano2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::TypeCodeTests::Oregano2");
#endif
  
  ernie.seed("Oregano2Call");
  
  ernie.seed("Oregano2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::TypeCodeTests::Oregano2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Beansprout2(const CORBA::Any &p1,CORBA::Any_out p2,CORBA::Any &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Beansprout2");
#endif
  
  ernie.seed("Beansprout2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Beansprout2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  ernie.mode(2);
  GetAny(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Beansprout2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Almonds2(CORBA::Any &p1,CORBA::Any_out p2,CORBA::Any_out p3,const CORBA::Any &p4,CORBA::Any &p5,const CORBA::Any &p6,const CORBA::Any &p7,const CORBA::Any &p8,CORBA::Any_out p9,const CORBA::Any &p10,const CORBA::Any &p11,CORBA::Any &p12,const CORBA::Any &p13,const CORBA::Any &p14,const CORBA::Any &p15 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Almonds2");
#endif
  
  ernie.seed("Almonds2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckAny(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckAny(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckAny(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckAny(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckAny(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckAny(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckAny(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p15");
  if (!CheckAny(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Almonds2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p1);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  p3 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p3);
  ernie.mode(2);
  GetAny(p5);
  p9 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p9);
  ernie.mode(2);
  GetAny(p12);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Almonds2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Guava2(const CORBA::Any &p1,CORBA::Any_out p2,const CORBA::Any &p3,const CORBA::Any &p4,CORBA::Any_out p5,CORBA::Any_out p6,CORBA::Any_out p7,CORBA::Any &p8,CORBA::Any_out p9,CORBA::Any_out p10,const CORBA::Any &p11,CORBA::Any &p12,CORBA::Any_out p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Guava2");
#endif
  
  ernie.seed("Guava2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckAny(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckAny(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckAny(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Guava2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  p5 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p5);
  p6 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p6);
  p7 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p7);
  ernie.mode(2);
  GetAny(p8);
  p9 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p9);
  p10 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p10);
  ernie.mode(2);
  GetAny(p12);
  p13 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Guava2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Mushroom2(CORBA::Any &p1,const CORBA::Any &p2,CORBA::Any &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Mushroom2");
#endif
  
  ernie.seed("Mushroom2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Mushroom2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p1);
  ernie.mode(2);
  GetAny(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Mushroom2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Runnerbean2(CORBA::Any_out p1,CORBA::Any_out p2,const CORBA::Any &p3,CORBA::Any &p4,const CORBA::Any &p5,const CORBA::Any &p6 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Runnerbean2");
#endif
  
  ernie.seed("Runnerbean2Call");
  ernie.mode(0);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Runnerbean2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p1 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p1);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  ernie.mode(2);
  GetAny(p4);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Runnerbean2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Tofu2(CORBA::Any &p1,const CORBA::Any &p2,const CORBA::Any &p3,CORBA::Any &p4,CORBA::Any &p5,const CORBA::Any &p6,CORBA::Any_out p7,CORBA::Any &p8,const CORBA::Any &p9,CORBA::Any &p10,CORBA::Any_out p11,CORBA::Any_out p12,const CORBA::Any &p13,CORBA::Any_out p14,CORBA::Any_out p15,const CORBA::Any &p16,const CORBA::Any &p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Tofu2");
#endif
  
  ernie.seed("Tofu2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckAny(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckAny(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckAny(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckAny(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckAny(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p17");
  if (!CheckAny(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Tofu2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p1);
  ernie.mode(2);
  GetAny(p4);
  ernie.mode(2);
  GetAny(p5);
  p7 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p7);
  ernie.mode(2);
  GetAny(p8);
  ernie.mode(2);
  GetAny(p10);
  p11 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p11);
  p12 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p12);
  p14 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p14);
  p15 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p15);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Tofu2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Prunes2(CORBA::Any_out p1,CORBA::Any_out p2,CORBA::Any_out p3,CORBA::Any &p4,CORBA::Any &p5,CORBA::Any &p6,CORBA::Any_out p7,CORBA::Any_out p8,CORBA::Any &p9,CORBA::Any_out p10 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Prunes2");
#endif
  
  ernie.seed("Prunes2Call");
  ernie.mode(1);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckAny(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Prunes2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p1 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p1);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  p3 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p3);
  ernie.mode(2);
  GetAny(p4);
  ernie.mode(2);
  GetAny(p5);
  ernie.mode(2);
  GetAny(p6);
  p7 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p7);
  p8 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p8);
  ernie.mode(2);
  GetAny(p9);
  p10 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p10);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Prunes2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Brocoli2(CORBA::Any &p1,CORBA::Any_out p2,const CORBA::Any &p3,CORBA::Any_out p4,CORBA::Any_out p5,CORBA::Any_out p6,const CORBA::Any &p7,const CORBA::Any &p8,CORBA::Any &p9,CORBA::Any_out p10,CORBA::Any_out p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Brocoli2");
#endif
  
  ernie.seed("Brocoli2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckAny(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckAny(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckAny(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Brocoli2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p1);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  p4 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p4);
  p5 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p5);
  p6 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p6);
  ernie.mode(2);
  GetAny(p9);
  p10 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p10);
  p11 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Brocoli2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::GrannySmith2(const CORBA::Any &p1,CORBA::Any_out p2,const CORBA::Any &p3,CORBA::Any_out p4,CORBA::Any_out p5 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::GrannySmith2");
#endif
  
  ernie.seed("GrannySmith2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GrannySmith2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  p4 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p4);
  p5 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p5);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::GrannySmith2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::BrazilNut2(CORBA::Any_out p1,CORBA::Any_out p2,CORBA::Any &p3,CORBA::Any &p4,CORBA::Any &p5,CORBA::Any &p6,const CORBA::Any &p7,const CORBA::Any &p8 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::BrazilNut2");
#endif
  
  ernie.seed("BrazilNut2Call");
  ernie.mode(1);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckAny(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckAny(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BrazilNut2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p1 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p1);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  ernie.mode(2);
  GetAny(p3);
  ernie.mode(2);
  GetAny(p4);
  ernie.mode(2);
  GetAny(p5);
  ernie.mode(2);
  GetAny(p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::BrazilNut2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::SweetPotato2(CORBA::Any_out p1,CORBA::Any &p2,CORBA::Any_out p3,CORBA::Any &p4,const CORBA::Any &p5,CORBA::Any_out p6,const CORBA::Any &p7,CORBA::Any_out p8,CORBA::Any_out p9,CORBA::Any_out p10,CORBA::Any_out p11,CORBA::Any_out p12,const CORBA::Any &p13,CORBA::Any &p14,CORBA::Any &p15 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::SweetPotato2");
#endif
  
  ernie.seed("SweetPotato2Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckAny(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckAny(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckAny(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p15");
  if (!CheckAny(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SweetPotato2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p1 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p1);
  ernie.mode(2);
  GetAny(p2);
  p3 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p3);
  ernie.mode(2);
  GetAny(p4);
  p6 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p6);
  p8 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p8);
  p9 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p9);
  p10 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p10);
  p11 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p11);
  p12 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p12);
  ernie.mode(2);
  GetAny(p14);
  ernie.mode(2);
  GetAny(p15);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::SweetPotato2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Tangarine2(const CORBA::Any &p1,const CORBA::Any &p2,const CORBA::Any &p3,const CORBA::Any &p4,CORBA::Any &p5,const CORBA::Any &p6 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Tangarine2");
#endif
  
  ernie.seed("Tangarine2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Tangarine2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p5);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Tangarine2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Billberries2(const CORBA::Any &p1,const CORBA::Any &p2,CORBA::Any &p3,CORBA::Any_out p4,CORBA::Any &p5,const CORBA::Any &p6,CORBA::Any_out p7,const CORBA::Any &p8,CORBA::Any &p9,const CORBA::Any &p10,CORBA::Any &p11,CORBA::Any_out p12,CORBA::Any &p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Billberries2");
#endif
  
  ernie.seed("Billberries2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckAny(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckAny(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckAny(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckAny(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckAny(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Billberries2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p3);
  p4 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p4);
  ernie.mode(2);
  GetAny(p5);
  p7 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p7);
  ernie.mode(2);
  GetAny(p9);
  ernie.mode(2);
  GetAny(p11);
  p12 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p12);
  ernie.mode(2);
  GetAny(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Billberries2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::CantelopeMelon2(CORBA::Any &p1,const CORBA::Any &p2,CORBA::Any_out p3,CORBA::Any &p4,const CORBA::Any &p5,CORBA::Any &p6,CORBA::Any_out p7 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::CantelopeMelon2");
#endif
  
  ernie.seed("CantelopeMelon2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CantelopeMelon2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p1);
  p3 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p3);
  ernie.mode(2);
  GetAny(p4);
  ernie.mode(2);
  GetAny(p6);
  p7 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p7);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::CantelopeMelon2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::LolloRossa2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::LolloRossa2");
#endif
  
  ernie.seed("LolloRossa2Call");
  
  ernie.seed("LolloRossa2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::LolloRossa2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::RowanBerry2(CORBA::Any &p1,CORBA::Any &p2,CORBA::Any_out p3,CORBA::Any &p4,const CORBA::Any &p5,CORBA::Any &p6,CORBA::Any_out p7,CORBA::Any_out p8,const CORBA::Any &p9,const CORBA::Any &p10,CORBA::Any_out p11,CORBA::Any &p12,CORBA::Any_out p13,CORBA::Any_out p14,CORBA::Any &p15,CORBA::Any &p16,CORBA::Any_out p17,const CORBA::Any &p18 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::RowanBerry2");
#endif
  
  ernie.seed("RowanBerry2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckAny(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckAny(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckAny(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p15");
  if (!CheckAny(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p16");
  if (!CheckAny(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p18");
  if (!CheckAny(p18))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RowanBerry2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p1);
  ernie.mode(2);
  GetAny(p2);
  p3 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p3);
  ernie.mode(2);
  GetAny(p4);
  ernie.mode(2);
  GetAny(p6);
  p7 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p7);
  p8 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p8);
  p11 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p11);
  ernie.mode(2);
  GetAny(p12);
  p13 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p13);
  p14 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p14);
  ernie.mode(2);
  GetAny(p15);
  ernie.mode(2);
  GetAny(p16);
  p17 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p17);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::RowanBerry2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Sweetcorn2(CORBA::Any_out p1,const CORBA::Any &p2,CORBA::Any_out p3,CORBA::Any_out p4,CORBA::Any &p5,CORBA::Any_out p6,const CORBA::Any &p7 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Sweetcorn2");
#endif
  
  ernie.seed("Sweetcorn2Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckAny(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Sweetcorn2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p1 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p1);
  p3 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p3);
  p4 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p4);
  ernie.mode(2);
  GetAny(p5);
  p6 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Sweetcorn2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Onion2(const CORBA::Any &p1,CORBA::Any_out p2,const CORBA::Any &p3,CORBA::Any_out p4,CORBA::Any_out p5,CORBA::Any_out p6,const CORBA::Any &p7,CORBA::Any &p8,CORBA::Any &p9,CORBA::Any_out p10,CORBA::Any_out p11,const CORBA::Any &p12,CORBA::Any &p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Onion2");
#endif
  
  ernie.seed("Onion2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckAny(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckAny(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckAny(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckAny(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckAny(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Onion2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  p4 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p4);
  p5 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p5);
  p6 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p6);
  ernie.mode(2);
  GetAny(p8);
  ernie.mode(2);
  GetAny(p9);
  p10 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p10);
  p11 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p11);
  ernie.mode(2);
  GetAny(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Onion2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Shallots2(CORBA::Any &p1,CORBA::Any &p2,CORBA::Any &p3,const CORBA::Any &p4,CORBA::Any_out p5,CORBA::Any &p6,CORBA::Any_out p7,CORBA::Any_out p8,CORBA::Any_out p9,const CORBA::Any &p10,const CORBA::Any &p11,CORBA::Any &p12,const CORBA::Any &p13,CORBA::Any &p14,const CORBA::Any &p15,CORBA::Any_out p16,CORBA::Any_out p17,const CORBA::Any &p18 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Shallots2");
#endif
  
  ernie.seed("Shallots2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckAny(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckAny(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckAny(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckAny(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckAny(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p15");
  if (!CheckAny(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p18");
  if (!CheckAny(p18))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Shallots2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p1);
  ernie.mode(2);
  GetAny(p2);
  ernie.mode(2);
  GetAny(p3);
  p5 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p5);
  ernie.mode(2);
  GetAny(p6);
  p7 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p7);
  p8 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p8);
  p9 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p9);
  ernie.mode(2);
  GetAny(p12);
  ernie.mode(2);
  GetAny(p14);
  p16 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p16);
  p17 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p17);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Shallots2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Plum2(CORBA::Any &p1,CORBA::Any_out p2,const CORBA::Any &p3,const CORBA::Any &p4,const CORBA::Any &p5,CORBA::Any_out p6,CORBA::Any_out p7,const CORBA::Any &p8,CORBA::Any_out p9,const CORBA::Any &p10,const CORBA::Any &p11,const CORBA::Any &p12,const CORBA::Any &p13,CORBA::Any &p14,CORBA::Any &p15,CORBA::Any_out p16 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Plum2");
#endif
  
  ernie.seed("Plum2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckAny(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckAny(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckAny(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckAny(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckAny(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckAny(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p15");
  if (!CheckAny(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Plum2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p1);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  p6 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p6);
  p7 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p7);
  p9 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p9);
  ernie.mode(2);
  GetAny(p14);
  ernie.mode(2);
  GetAny(p15);
  p16 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p16);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Plum2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::KidneyBean2(CORBA::Any &p1,const CORBA::Any &p2,const CORBA::Any &p3,CORBA::Any_out p4,CORBA::Any_out p5,const CORBA::Any &p6,CORBA::Any &p7 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::KidneyBean2");
#endif
  
  ernie.seed("KidneyBean2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckAny(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KidneyBean2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p1);
  p4 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p4);
  p5 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p5);
  ernie.mode(2);
  GetAny(p7);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::KidneyBean2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Zucchini2(CORBA::Any &p1,CORBA::Any_out p2,CORBA::Any &p3,const CORBA::Any &p4,CORBA::Any_out p5 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Zucchini2");
#endif
  
  ernie.seed("Zucchini2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Zucchini2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p1);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  ernie.mode(2);
  GetAny(p3);
  p5 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p5);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Zucchini2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::ButterBean2(CORBA::Any &p1,CORBA::Any_out p2,CORBA::Any_out p3,CORBA::Any &p4,CORBA::Any_out p5,CORBA::Any_out p6,const CORBA::Any &p7,CORBA::Any_out p8,CORBA::Any &p9,CORBA::Any &p10,const CORBA::Any &p11,const CORBA::Any &p12,CORBA::Any &p13,CORBA::Any_out p14,const CORBA::Any &p15,CORBA::Any_out p16,const CORBA::Any &p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::ButterBean2");
#endif
  
  ernie.seed("ButterBean2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckAny(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckAny(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckAny(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckAny(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckAny(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckAny(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p15");
  if (!CheckAny(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p17");
  if (!CheckAny(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("ButterBean2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p1);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  p3 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p3);
  ernie.mode(2);
  GetAny(p4);
  p5 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p5);
  p6 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p6);
  p8 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p8);
  ernie.mode(2);
  GetAny(p9);
  ernie.mode(2);
  GetAny(p10);
  ernie.mode(2);
  GetAny(p13);
  p14 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p14);
  p16 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p16);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::ButterBean2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Avocado2(CORBA::Any_out p1,CORBA::Any_out p2,CORBA::Any_out p3,CORBA::Any &p4,const CORBA::Any &p5,CORBA::Any &p6,CORBA::Any &p7,const CORBA::Any &p8,const CORBA::Any &p9,CORBA::Any_out p10,CORBA::Any_out p11,const CORBA::Any &p12,CORBA::Any &p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Avocado2");
#endif
  
  ernie.seed("Avocado2Call");
  ernie.mode(1);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckAny(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckAny(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckAny(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckAny(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckAny(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Avocado2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p1 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p1);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  p3 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p3);
  ernie.mode(2);
  GetAny(p4);
  ernie.mode(2);
  GetAny(p6);
  ernie.mode(2);
  GetAny(p7);
  p10 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p10);
  p11 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p11);
  ernie.mode(2);
  GetAny(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Avocado2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::GoldenDelicous2(CORBA::Any_out p1,CORBA::Any_out p2,CORBA::Any_out p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::GoldenDelicous2");
#endif
  
  ernie.seed("GoldenDelicous2Call");
  
  ernie.seed("GoldenDelicous2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p1 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p1);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  p3 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::GoldenDelicous2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Lentil2(CORBA::Any &p1,CORBA::Any &p2,const CORBA::Any &p3,const CORBA::Any &p4,CORBA::Any &p5,CORBA::Any &p6,CORBA::Any &p7 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Lentil2");
#endif
  
  ernie.seed("Lentil2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckAny(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lentil2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p1);
  ernie.mode(2);
  GetAny(p2);
  ernie.mode(2);
  GetAny(p5);
  ernie.mode(2);
  GetAny(p6);
  ernie.mode(2);
  GetAny(p7);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Lentil2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Fig2(CORBA::Any_out p1,const CORBA::Any &p2,CORBA::Any &p3,CORBA::Any_out p4,const CORBA::Any &p5,CORBA::Any &p6,CORBA::Any_out p7,CORBA::Any_out p8,const CORBA::Any &p9,const CORBA::Any &p10,CORBA::Any &p11,CORBA::Any_out p12,CORBA::Any &p13,const CORBA::Any &p14,CORBA::Any &p15,const CORBA::Any &p16,CORBA::Any &p17,CORBA::Any &p18,CORBA::Any_out p19 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Fig2");
#endif
  
  ernie.seed("Fig2Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckAny(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckAny(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckAny(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckAny(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckAny(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p15");
  if (!CheckAny(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckAny(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p17");
  if (!CheckAny(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p18");
  if (!CheckAny(p18))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Fig2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p1 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p1);
  ernie.mode(2);
  GetAny(p3);
  p4 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p4);
  ernie.mode(2);
  GetAny(p6);
  p7 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p7);
  p8 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p8);
  ernie.mode(2);
  GetAny(p11);
  p12 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p12);
  ernie.mode(2);
  GetAny(p13);
  ernie.mode(2);
  GetAny(p15);
  ernie.mode(2);
  GetAny(p17);
  ernie.mode(2);
  GetAny(p18);
  p19 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p19);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Fig2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::CrabApple2(CORBA::Any_out p1,CORBA::Any_out p2,CORBA::Any &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::CrabApple2");
#endif
  
  ernie.seed("CrabApple2Call");
  ernie.mode(1);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CrabApple2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p1 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p1);
  p2 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p2);
  ernie.mode(2);
  GetAny(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::CrabApple2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::RedOnion2(CORBA::Any_out p1,CORBA::Any &p2,CORBA::Any_out p3,const CORBA::Any &p4,CORBA::Any &p5,const CORBA::Any &p6,CORBA::Any &p7,CORBA::Any &p8,CORBA::Any_out p9,CORBA::Any &p10,const CORBA::Any &p11,CORBA::Any &p12,CORBA::Any &p13,const CORBA::Any &p14 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::RedOnion2");
#endif
  
  ernie.seed("RedOnion2Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckAny(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckAny(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckAny(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckAny(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckAny(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckAny(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckAny(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckAny(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedOnion2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p1 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p1);
  ernie.mode(2);
  GetAny(p2);
  p3 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p3);
  ernie.mode(2);
  GetAny(p5);
  ernie.mode(2);
  GetAny(p7);
  ernie.mode(2);
  GetAny(p8);
  p9 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p9);
  ernie.mode(2);
  GetAny(p10);
  ernie.mode(2);
  GetAny(p12);
  ernie.mode(2);
  GetAny(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::RedOnion2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::HazelNut2(const CORBA::Any &p1,CORBA::Any &p2,CORBA::Any &p3,CORBA::Any &p4,const CORBA::Any &p5,CORBA::Any_out p6,CORBA::Any_out p7,const CORBA::Any &p8,CORBA::Any &p9,const CORBA::Any &p10,CORBA::Any_out p11,CORBA::Any &p12,CORBA::Any_out p13,CORBA::Any_out p14,CORBA::Any_out p15,CORBA::Any_out p16,CORBA::Any_out p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::HazelNut2");
#endif
  
  ernie.seed("HazelNut2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckAny(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckAny(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckAny(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckAny(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckAny(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("HazelNut2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  ernie.mode(2);
  GetAny(p2);
  ernie.mode(2);
  GetAny(p3);
  ernie.mode(2);
  GetAny(p4);
  p6 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p6);
  p7 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p7);
  ernie.mode(2);
  GetAny(p9);
  p11 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p11);
  ernie.mode(2);
  GetAny(p12);
  p13 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p13);
  p14 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p14);
  p15 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p15);
  p16 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p16);
  p17 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p17);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::HazelNut2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Cinnamon2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Cinnamon2");
#endif
  
  ernie.seed("Cinnamon2Call");
  
  ernie.seed("Cinnamon2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Cinnamon2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Cinnamon2(const CORBA::Any &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Cinnamon2");
#endif
  
  ernie.seed("Cinnamon2Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckAny(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cinnamon2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Cinnamon2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Any*
siiServer_imp::GooseBerry2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::GooseBerry2");
#endif
  
  ernie.seed("GooseBerry2Call");
  
  ernie.seed("GooseBerry2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::GooseBerry2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::GooseBerry2(const CORBA::Any &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::GooseBerry2");
#endif
  
  ernie.seed("GooseBerry2Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckAny(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GooseBerry2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::GooseBerry2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Any*
siiServer_imp::EggPlant2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::EggPlant2");
#endif
  
  ernie.seed("EggPlant2Call");
  
  ernie.seed("EggPlant2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::EggPlant2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::EggPlant2(const CORBA::Any &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::EggPlant2");
#endif
  
  ernie.seed("EggPlant2Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckAny(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("EggPlant2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::EggPlant2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Any*
siiServer_imp::JuniperBerries2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::JuniperBerries2");
#endif
  
  ernie.seed("JuniperBerries2Call");
  
  ernie.seed("JuniperBerries2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::JuniperBerries2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::JuniperBerries2(const CORBA::Any &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::JuniperBerries2");
#endif
  
  ernie.seed("JuniperBerries2Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckAny(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("JuniperBerries2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::JuniperBerries2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Any*
siiServer_imp::Cloves2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Cloves2");
#endif
  
  ernie.seed("Cloves2Call");
  
  ernie.seed("Cloves2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Cloves2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Cloves2(const CORBA::Any &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Cloves2");
#endif
  
  ernie.seed("Cloves2Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckAny(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cloves2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Cloves2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Any*
siiServer_imp::Daikan2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Daikan2");
#endif
  
  ernie.seed("Daikan2Call");
  
  ernie.seed("Daikan2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Daikan2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Daikan2(const CORBA::Any &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Daikan2");
#endif
  
  ernie.seed("Daikan2Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckAny(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Daikan2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Daikan2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Any*
siiServer_imp::Mustard2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Mustard2");
#endif
  
  ernie.seed("Mustard2Call");
  
  ernie.seed("Mustard2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Mustard2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Mustard2(const CORBA::Any &_attr VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Mustard2");
#endif
  
  ernie.seed("Mustard2Call");
  ernie.mode(0);
  AddName("_attr");
  if (!CheckAny(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Mustard2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Mustard2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Any*
siiServer_imp::Strawberry2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Strawberry2");
#endif
  
  ernie.seed("Strawberry2Call");
  
  ernie.seed("Strawberry2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Strawberry2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::BreadFruit2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::BreadFruit2");
#endif
  
  ernie.seed("BreadFruit2Call");
  
  ernie.seed("BreadFruit2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::BreadFruit2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Thyme2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Thyme2");
#endif
  
  ernie.seed("Thyme2Call");
  
  ernie.seed("Thyme2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Thyme2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Sweedes2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Sweedes2");
#endif
  
  ernie.seed("Sweedes2Call");
  
  ernie.seed("Sweedes2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Sweedes2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Pomegranate2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Pomegranate2");
#endif
  
  ernie.seed("Pomegranate2Call");
  
  ernie.seed("Pomegranate2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Pomegranate2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Tarragon2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Tarragon2");
#endif
  
  ernie.seed("Tarragon2Call");
  
  ernie.seed("Tarragon2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Tarragon2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Lettuce2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AnyTests::Lettuce2");
#endif
  
  ernie.seed("Lettuce2Call");
  
  ernie.seed("Lettuce2Return"); 
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AnyTests::Lettuce2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Mangetout2(::YellowPepper2_out p1,const ::Dates3 &p2,const ::Pumpkin p3,::Record2 p4 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Mangetout2");
#endif
  
  ernie.seed("Mangetout2Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckDates3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckPumpkin(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckRecord2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Mangetout2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  p1 = new ::YellowPepper2;
  ernie.mode(0);
  GetYellowPepper2(*p1);
  ernie.mode(2);
  GetRecord2(p4);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Mangetout2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Turnip3*
siiServer_imp::BambooShoot2(::Currant2_out p1,const ::Fennell3 &p2,::Peanuts1 &p3,::GardenPeas3_out p4,::Squash2_out p5,::BritishQueens1_out p6,::Celeriac2_out p7,::Rasin2_out p8,::Peanuts1 p9,const ::Fennell3 &p10,::Dates3_out p11,::Squash1 &p12,CORBA::UShort &p13,::Dates3 &p14 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  ::Turnip3* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::BambooShoot2");
#endif
  
  ernie.seed("BambooShoot2Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckFennell3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckPeanuts1(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckFennell3(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckSquash1(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckDates3(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BambooShoot2Return"); 
  ReturnValue = new ::Turnip3;
  GetTurnip3(*ReturnValue);
  p1 = new ::Currant2;
  ernie.mode(0);
  GetCurrant2(*p1);
  ernie.mode(0);
  GetPeanuts1(p3);
  p4 = new ::GardenPeas3;
  ernie.mode(0);
  GetGardenPeas3(*p4);
  p5 = new ::Squash2;
  ernie.mode(0);
  GetSquash2(*p5);
  p6 = new ::BritishQueens1;
  ernie.mode(0);
  GetBritishQueens1(*p6);
  p7 = new ::Celeriac2;
  ernie.mode(0);
  GetCeleriac2(*p7);
  p8 = new ::Rasin2;
  ernie.mode(0);
  GetRasin2(*p8);
  p11 = new ::Dates3;
  ernie.mode(0);
  GetDates3(*p11);
  ernie.mode(2);
  GetSquash1(p12);
  ernie.mode(0);
  GetUShort(p13);
  ernie.mode(2);
  GetDates3(p14);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::BambooShoot2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Squash2*
siiServer_imp::Melon2(::Asparagus &p1,::Peanuts1 &p2,const ::Fennell3 &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Squash2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Melon2");
#endif
  
  ernie.seed("Melon2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckAsparagus(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckPeanuts1(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckFennell3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Melon2Return"); 
  ReturnValue = new ::Squash2;
  GetSquash2(*ReturnValue);
  ernie.mode(2);
  GetAsparagus(p1);
  ernie.mode(2);
  GetPeanuts1(p2);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Melon2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

char *
siiServer_imp::RedGrapes2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  char * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::RedGrapes2");
#endif
  
  ernie.seed("RedGrapes2Call");
  
  ernie.seed("RedGrapes2Return"); 
  
  ReturnValue = GetString();

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::RedGrapes2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::BeechNut2*
siiServer_imp::Elderberry2(::Oregano3_out p1,const ::Squash2 &p2,CORBA::TypeCode_out p3,::GoldenDelicous3 &p4,const ::Corn1 p5,::GardenPeas3 &p6,const ::Chives2 &p7,::Squash2 &p8,CORBA::Long p9,::Raspberry1 p10,::Corn1 p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::BeechNut2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Elderberry2");
#endif
  
  ernie.seed("Elderberry2Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckSquash2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckGoldenDelicous3(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckCorn1(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckGardenPeas3(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckChives2(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckSquash2(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckLong(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Elderberry2Return"); 
  ReturnValue = new ::BeechNut2;
  GetBeechNut2(*ReturnValue);
  p1 = new ::Oregano3;
  ernie.mode(0);
  GetOregano3(*p1);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(2);
  GetGoldenDelicous3(p4);
  ernie.mode(2);
  GetGardenPeas3(p6);
  ernie.mode(2);
  GetSquash2(p8);
  ernie.mode(0);
  GetRaspberry1(p10);
  ernie.mode(0);
  GetCorn1(p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Elderberry2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Char
siiServer_imp::Kumquats2(const ::Rasin2 &p1,const ::Squash2 &p2,const ::Mullberry1 p3,CORBA::Double &p4,::GaliaMelon3_out p5,CORBA::Double &p6,const ::Pumpkin p7,::Peanuts1 p8,CORBA::Any &p9,::Oregano3 &p10,::GaliaMelon3 &p11,CORBA::UShort &p12,CORBA::Float p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Char ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Kumquats2");
#endif
  
  ernie.seed("Kumquats2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckRasin2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckSquash2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckMullberry1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckPumpkin(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckPeanuts1(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckAny(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckOregano3(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckGaliaMelon3(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckUShort(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckFloat(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Kumquats2Return"); 
  
  GetChar(ReturnValue);
  ernie.mode(0);
  GetDouble(p4);
  p5 = new ::GaliaMelon3;
  ernie.mode(0);
  GetGaliaMelon3(*p5);
  ernie.mode(0);
  GetDouble(p6);
  ernie.mode(2);
  GetAny(p9);
  ernie.mode(2);
  GetOregano3(p10);
  ernie.mode(2);
  GetGaliaMelon3(p11);
  ernie.mode(2);
  GetUShort(p12);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Kumquats2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Cauliflower2*
siiServer_imp::Fennell2(::Beetroot2 &p1,const ::Mullberry1 p2,::Carrots p3,CORBA::TypeCode_out p4,::BeechNut2_out p5,CORBA::Long &p6 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Cauliflower2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Fennell2");
#endif
  
  ernie.seed("Fennell2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckBeetroot2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckMullberry1(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckCarrots(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Fennell2Return"); 
  ReturnValue = new ::Cauliflower2;
  GetCauliflower2(*ReturnValue);
  ernie.mode(2);
  GetBeetroot2(p1);
  ernie.mode(2);
  GetCarrots(p3);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p4);
	p4=CORBA::TypeCode::_duplicate(p4);
  p5 = new ::BeechNut2;
  ernie.mode(0);
  GetBeechNut2(*p5);
  ernie.mode(0);
  GetLong(p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Fennell2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Uglifruit2(CORBA::String_out p1,::Turnip3 &p2,const ::Peppercorn &p3,CORBA::ULong p4,::GardenPeas1 &p5,::Squash2 &p6,const ::Raspberry1 p7,::Susander2_out p8,CORBA::Object_out p9,::BrazilNut3_out p10,::Corn1 p11,const ::GaliaMelon3 &p12,::BritishQueens1 &p13,const ::BritishQueens1 &p14 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Uglifruit2");
#endif
  
  ernie.seed("Uglifruit2Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckTurnip3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckPeppercorn(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckULong(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckGardenPeas1(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckSquash2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckRaspberry1(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckCorn1(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckGaliaMelon3(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckBritishQueens1(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckBritishQueens1(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Uglifruit2Return"); 
  
  ernie.mode(0);
  p1 = GetString();
  ernie.mode(2);
  GetTurnip3(p2);
  ernie.mode(2);
  GetGardenPeas1(p5);
  ernie.mode(2);
  GetSquash2(p6);
  p8 = new ::Susander2;
  ernie.mode(0);
  GetSusander2(*p8);
  ernie.mode(0);
  p9 = Getobject();
  p10 = new ::BrazilNut3;
  ernie.mode(0);
  GetBrazilNut3(*p10);
  ernie.mode(2);
  GetCorn1(p11);
  ernie.mode(2);
  GetBritishQueens1(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Uglifruit2");
#endif
  ::tet_result(TET_PASS);
  
  
}

::Dates3*
siiServer_imp::Chickpea2(const ::Squash1 &p1,::Tomato2_out p2,CORBA::String_out p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Dates3* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Chickpea2");
#endif
  
  ernie.seed("Chickpea2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckSquash1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Chickpea2Return"); 
  ReturnValue = new ::Dates3;
  GetDates3(*ReturnValue);
  p2 = new ::Tomato2;
  ernie.mode(0);
  GetTomato2(*p2);
  ernie.mode(0);
  p3 = GetString();

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Chickpea2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Beetroot2*
siiServer_imp::Okra2(::Squash1 &p1,CORBA::Float &p2,::Tomato2_out p3,::Chives2_out p4,::GaliaMelon3_out p5,CORBA::Object_ptr p6,const ::Blackberry2 &p7,const ::Rasin2 &p8,::Fennell3_out p9,CORBA::String_out p10,::Oregano3 &p11,const ::GaliaMelon3 &p12,::Peanuts1 &p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Beetroot2* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Okra2");
#endif
  
  ernie.seed("Okra2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckSquash1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckFloat(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!Checkobject(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckBlackberry2(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckRasin2(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckOregano3(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckGaliaMelon3(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Okra2Return"); 
  ReturnValue = new ::Beetroot2;
  GetBeetroot2(*ReturnValue);
  ernie.mode(2);
  GetSquash1(p1);
  ernie.mode(2);
  GetFloat(p2);
  p3 = new ::Tomato2;
  ernie.mode(0);
  GetTomato2(*p3);
  p4 = new ::Chives2;
  ernie.mode(0);
  GetChives2(*p4);
  p5 = new ::GaliaMelon3;
  ernie.mode(0);
  GetGaliaMelon3(*p5);
  p9 = new ::Fennell3;
  ernie.mode(0);
  GetFennell3(*p9);
  ernie.mode(0);
  p10 = GetString();
  ernie.mode(2);
  GetOregano3(p11);
  ernie.mode(0);
  GetPeanuts1(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Okra2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Float
siiServer_imp::Plantain2(CORBA::Long &p1,::Susander2 &p2,const ::Fig &p3,const ::Tomato2 &p4,const ::Cauliflower2 &p5,::Oregano3 &p6,::Mangosteen3 &p7,const ::Squash1 &p8,::LoganBerry_out p9,::Squash2 &p10,::Tomato_out p11,::LoganBerry &p12,::Tomato2 &p13,::GaliaMelon3_out p14,CORBA::TypeCode_ptr p15,::BritishQueens1_out p16,const ::Susander2 &p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Float ReturnValue;
  
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Plantain2");
#endif
  
  ernie.seed("Plantain2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckLong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckSusander2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckFig(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckTomato2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckCauliflower2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckOregano3(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckMangosteen3(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckSquash1(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckSquash2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckLoganBerry(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckTomato2(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p15");
  if (!CheckCORBATypeCode_ptr(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p17");
  if (!CheckSusander2(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Plantain2Return"); 
  
  GetFloat(ReturnValue);
  ernie.mode(2);
  GetLong(p1);
  ernie.mode(2);
  GetSusander2(p2);
  ernie.mode(2);
  GetOregano3(p6);
  ernie.mode(2);
  GetMangosteen3(p7);
  p9 = new ::LoganBerry;
  ernie.mode(0);
  GetLoganBerry(*p9);
  ernie.mode(2);
  GetSquash2(p10);
  p11 = new ::Tomato;
  ernie.mode(0);
  GetTomato(*p11);
  ernie.mode(2);
  GetLoganBerry(p12);
  ernie.mode(2);
  GetTomato2(p13);
  p14 = new ::GaliaMelon3;
  ernie.mode(0);
  GetGaliaMelon3(*p14);
  p16 = new ::BritishQueens1;
  ernie.mode(0);
  GetBritishQueens1(*p16);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Plantain2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Blackcurrant2(::Susander2_out p1,::Chives2 &p2,const ::Damsons2 p3,const ::GardenPeas1 &p4,::Tomato_out p5,const ::WaterMelon3 p6,::Susander2_out p7,CORBA::TypeCode_out p8,const ::Damsons2 p9,::Currant2 &p10,CORBA::Boolean &p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Blackcurrant2");
#endif
  
  ernie.seed("Blackcurrant2Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckChives2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckDamsons2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckGardenPeas1(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckWaterMelon3(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckDamsons2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckCurrant2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckBoolean(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Blackcurrant2Return"); 
  
  p1 = new ::Susander2;
  ernie.mode(0);
  GetSusander2(*p1);
  ernie.mode(2);
  GetChives2(p2);
  p5 = new ::Tomato;
  ernie.mode(0);
  GetTomato(*p5);
  p7 = new ::Susander2;
  ernie.mode(0);
  GetSusander2(*p7);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p8);
	p8=CORBA::TypeCode::_duplicate(p8);
  ernie.mode(2);
  GetCurrant2(p10);
  ernie.mode(2);
  GetBoolean(p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Blackcurrant2");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Object_ptr
siiServer_imp::Pineapple2(::Fennell3_out p1,const ::Carrots p2,::Chestnut1 p3,::GardenPeas1_out p4,CORBA::Float p5,CORBA::TypeCode_ptr &p6,const ::Dates3 &p7,::BeechNut2 &p8,CORBA::Float p9,::Rasin2 &p10,CORBA::Char &p11,::Mullberry1 p12,::BlackEyedBeans &p13,const ::Squash2 &p14 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Object_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Pineapple2");
#endif
  
  ernie.seed("Pineapple2Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckCarrots(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckChestnut1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckFloat(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckDates3(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckBeechNut2(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckFloat(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckRasin2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckMullberry1(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckBlackEyedBeans(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckSquash2(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Pineapple2Return"); 
  
  ReturnValue = Getobject();
  p1 = new ::Fennell3;
  ernie.mode(0);
  GetFennell3(*p1);
  ernie.mode(2);
  GetChestnut1(p3);
  p4 = new ::GardenPeas1;
  ernie.mode(0);
  GetGardenPeas1(*p4);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p6);
	p6=CORBA::TypeCode::_duplicate(p6);
  ernie.mode(2);
  GetBeechNut2(p8);
  ernie.mode(2);
  GetRasin2(p10);
  ernie.mode(0);
  GetChar(p11);
  ernie.mode(2);
  GetMullberry1(p12);
  ernie.mode(2);
  GetBlackEyedBeans(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Pineapple2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Cauliflower2*
siiServer_imp::Mangosteen2(CORBA::Octet &p1,CORBA::Any &p2,::Fig_out p3,const ::Damsons2 p4,CORBA::Double &p5,::GaliaMelon3_out p6,CORBA::Object_ptr &p7,CORBA::Short p8,::WaterMelon3 p9,::Currant2_out p10,::Peanuts1 &p11,CORBA::Float p12,::BrazilNut3 &p13,::WaterMelon3 p14,::Susander2 &p15,::Tomato2_out p16,const ::GaliaMelon3 &p17,::Fennell3_out p18 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Cauliflower2* ReturnValue;
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Mangosteen2");
#endif
  
  ernie.seed("Mangosteen2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckOctet(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckDamsons2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckDouble(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!Checkobject(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckShort(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckFloat(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckBrazilNut3(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p15");
  if (!CheckSusander2(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p17");
  if (!CheckGaliaMelon3(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Mangosteen2Return"); 
  ReturnValue = new ::Cauliflower2;
  GetCauliflower2(*ReturnValue);
  ernie.mode(2);
  GetOctet(p1);
  ernie.mode(2);
  GetAny(p2);
  p3 = new ::Fig;
  ernie.mode(0);
  GetFig(*p3);
  ernie.mode(2);
  GetDouble(p5);
  p6 = new ::GaliaMelon3;
  ernie.mode(0);
  GetGaliaMelon3(*p6);
  ernie.mode(2);
  p7 = Getobject();
  ernie.mode(0);
  GetWaterMelon3(p9);
  p10 = new ::Currant2;
  ernie.mode(0);
  GetCurrant2(*p10);
  ernie.mode(0);
  GetPeanuts1(p11);
  ernie.mode(2);
  GetBrazilNut3(p13);
  ernie.mode(0);
  GetWaterMelon3(p14);
  ernie.mode(2);
  GetSusander2(p15);
  p16 = new ::Tomato2;
  ernie.mode(0);
  GetTomato2(*p16);
  p18 = new ::Fennell3;
  ernie.mode(0);
  GetFennell3(*p18);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Mangosteen2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Pear2(::Squash1_out p1,::Fig_out p2,CORBA::TypeCode_ptr &p3,CORBA::Octet &p4,::BritishQueens1_out p5,::Dates3 &p6 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Pear2");
#endif
  
  ernie.seed("Pear2Call");
  ernie.mode(1);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckOctet(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckDates3(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Pear2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  p1 = new ::Squash1;
  ernie.mode(0);
  GetSquash1(*p1);
  p2 = new ::Fig;
  ernie.mode(0);
  GetFig(*p2);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);
  ernie.mode(2);
  GetOctet(p4);
  p5 = new ::BritishQueens1;
  ernie.mode(0);
  GetBritishQueens1(*p5);
  ernie.mode(2);
  GetDates3(p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Pear2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Celeriac2*
siiServer_imp::BeefTomatoes2(const ::Fig &p1 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Celeriac2* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::BeefTomatoes2");
#endif
  
  ernie.seed("BeefTomatoes2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckFig(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BeefTomatoes2Return"); 
  ReturnValue = new ::Celeriac2;
  GetCeleriac2(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::BeefTomatoes2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Fennell3*
siiServer_imp::Sharanfruit2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  ::Fennell3* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Sharanfruit2");
#endif
  
  ernie.seed("Sharanfruit2Call");
  
  ernie.seed("Sharanfruit2Return"); 
  ReturnValue = new ::Fennell3;
  GetFennell3(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Sharanfruit2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Cauliflower2*
siiServer_imp::Cherry2(const ::GoldenDelicous3 &p1,CORBA::Object_ptr p2,const ::Susander2 &p3,CORBA::TypeCode_ptr p4,::Cauliflower2 &p5,const ::Fig &p6,::Fennell3_out p7,const ::Rasin2 &p8,::Currant2_out p9,CORBA::Boolean &p10 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Cauliflower2* ReturnValue;
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Cherry2");
#endif
  
  ernie.seed("Cherry2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckGoldenDelicous3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!Checkobject(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckSusander2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckCORBATypeCode_ptr(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckCauliflower2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckFig(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckRasin2(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cherry2Return"); 
  ReturnValue = new ::Cauliflower2;
  GetCauliflower2(*ReturnValue);
  ernie.mode(2);
  GetCauliflower2(p5);
  p7 = new ::Fennell3;
  ernie.mode(0);
  GetFennell3(*p7);
  p9 = new ::Currant2;
  ernie.mode(0);
  GetCurrant2(*p9);
  ernie.mode(0);
  GetBoolean(p10);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Cherry2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Oregano3*
siiServer_imp::Peppercorn2(const ::GoldenDelicous3 &p1,::Dates3_out p2,const ::Tomato2 &p3,const ::Fennell3 &p4,CORBA::Octet &p5,::Peanuts1 &p6,::Raspberry1 p7,CORBA::Short &p8,const ::WaterMelon &p9,CORBA::Any_out p10,::Fennell3_out p11,::Fennell3 &p12 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Oregano3* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Peppercorn2");
#endif
  
  ernie.seed("Peppercorn2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckGoldenDelicous3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckTomato2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckFennell3(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckOctet(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckPeanuts1(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckRaspberry1(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckWaterMelon(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckFennell3(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Peppercorn2Return"); 
  ReturnValue = new ::Oregano3;
  GetOregano3(*ReturnValue);
  p2 = new ::Dates3;
  ernie.mode(0);
  GetDates3(*p2);
  ernie.mode(2);
  GetOctet(p5);
  ernie.mode(2);
  GetPeanuts1(p6);
  ernie.mode(2);
  GetRaspberry1(p7);
  ernie.mode(0);
  GetShort(p8);
  p10 = new CORBA::Any;
  ernie.mode(0);
  GetAny(*p10);
  p11 = new ::Fennell3;
  ernie.mode(0);
  GetFennell3(*p11);
  ernie.mode(2);
  GetFennell3(p12);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Peppercorn2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Susander2*
siiServer_imp::Raspberry2(const ::Mullberry1 p1 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  ::Susander2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Raspberry2");
#endif
  
  ernie.seed("Raspberry2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckMullberry1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Raspberry2Return"); 
  ReturnValue = new ::Susander2;
  GetSusander2(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Raspberry2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Grapefruit2*
siiServer_imp::PepinoMelon2(::Dates3 &p1,::Peppercorn &p2,::Fig &p3,::Tomato2_out p4,const ::Cauliflower2 &p5,::BritishQueens1_out p6,CORBA::ULong p7,::Mullberry1 p8,const ::Cauliflower2 &p9,const ::Squash2 &p10,::Asparagus &p11,const ::Squash2 &p12,::Beetroot2_out p13,CORBA::Object_out p14,::Rasin2 &p15 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Grapefruit2* ReturnValue;
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::PepinoMelon2");
#endif
  
  ernie.seed("PepinoMelon2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckDates3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckPeppercorn(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckFig(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckCauliflower2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckULong(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckCauliflower2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckSquash2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckAsparagus(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckSquash2(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p15");
  if (!CheckRasin2(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PepinoMelon2Return"); 
  ReturnValue = new ::Grapefruit2;
  GetGrapefruit2(*ReturnValue);
  ernie.mode(2);
  GetDates3(p1);
  ernie.mode(2);
  GetPeppercorn(p2);
  ernie.mode(2);
  GetFig(p3);
  p4 = new ::Tomato2;
  ernie.mode(0);
  GetTomato2(*p4);
  p6 = new ::BritishQueens1;
  ernie.mode(0);
  GetBritishQueens1(*p6);
  ernie.mode(0);
  GetMullberry1(p8);
  ernie.mode(2);
  GetAsparagus(p11);
  p13 = new ::Beetroot2;
  ernie.mode(0);
  GetBeetroot2(*p13);
  ernie.mode(0);
  p14 = Getobject();
  ernie.mode(2);
  GetRasin2(p15);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::PepinoMelon2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Damsons2_slice *
siiServer_imp::Peanutsquash2(::Rasin2 &p1,CORBA::ULong p2,const ::Mangosteen3 &p3,::Chestnut1 p4,const ::Dates3 &p5,CORBA::ULong &p6,const ::Squash2 &p7,::Susander2 &p8,::Fig &p9,::Grapefruit2 &p10,CORBA::Object_ptr p11,::Turnip3_out p12,const ::Peppercorn &p13,::Squash2 &p14,::Dates3_out p15,const ::Rasin2 &p16,::Tomato_out p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Damsons2_slice * ReturnValue;
  
  
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Peanutsquash2");
#endif
  
  ernie.seed("Peanutsquash2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckRasin2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckULong(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckMangosteen3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckDates3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckSquash2(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckSusander2(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckFig(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckGrapefruit2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!Checkobject(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckPeppercorn(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckSquash2(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckRasin2(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Peanutsquash2Return"); 
  
  ReturnValue = new ::Damsons2;
  GetDamsons2(ReturnValue);
  ernie.mode(2);
  GetRasin2(p1);
  ernie.mode(0);
  GetChestnut1(p4);
  ernie.mode(0);
  GetULong(p6);
  ernie.mode(2);
  GetSusander2(p8);
  ernie.mode(2);
  GetFig(p9);
  ernie.mode(2);
  GetGrapefruit2(p10);
  p12 = new ::Turnip3;
  ernie.mode(0);
  GetTurnip3(*p12);
  ernie.mode(2);
  GetSquash2(p14);
  p15 = new ::Dates3;
  ernie.mode(0);
  GetDates3(*p15);
  p17 = new ::Tomato;
  ernie.mode(0);
  GetTomato(*p17);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Peanutsquash2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GaliaMelon3*
siiServer_imp::Artichokes2(::Blackberry2_out p1,::Dates3_out p2,const ::Tomato2 &p3,const ::Squash1 &p4,::Mangosteen3 &p5,::WaterMelon_out p6,CORBA::Octet &p7,::Susander2 &p8,CORBA::UShort &p9,CORBA::TypeCode_ptr p10,const ::Grapefruit2 &p11,::Cauliflower2 &p12,::Currant2 &p13,::Fig &p14,CORBA::TypeCode_out p15,const ::Chestnut1 p16,const ::Corn1 p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::GaliaMelon3* ReturnValue;
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Artichokes2");
#endif
  
  ernie.seed("Artichokes2Call");
  ernie.mode(0);
  AddName("p3");
  if (!CheckTomato2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckSquash1(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckMangosteen3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckSusander2(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckCORBATypeCode_ptr(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckGrapefruit2(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckCauliflower2(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckCurrant2(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckFig(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckChestnut1(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p17");
  if (!CheckCorn1(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Artichokes2Return"); 
  ReturnValue = new ::GaliaMelon3;
  GetGaliaMelon3(*ReturnValue);
  p1 = new ::Blackberry2;
  ernie.mode(0);
  GetBlackberry2(*p1);
  p2 = new ::Dates3;
  ernie.mode(0);
  GetDates3(*p2);
  ernie.mode(2);
  GetMangosteen3(p5);
  p6 = new ::WaterMelon;
  ernie.mode(0);
  GetWaterMelon(*p6);
  ernie.mode(0);
  GetOctet(p7);
  ernie.mode(2);
  GetSusander2(p8);
  ernie.mode(0);
  GetUShort(p9);
  ernie.mode(2);
  GetCauliflower2(p12);
  ernie.mode(2);
  GetCurrant2(p13);
  ernie.mode(2);
  GetFig(p14);
  ernie.mode(0);
  GetCORBATypeCode_ptr(p15);
	p15=CORBA::TypeCode::_duplicate(p15);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Artichokes2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::GreenGrapes2(const ::WaterMelon &p1,const ::Fig &p2,const ::Celeriac2 &p3,const ::Corn1 p4,char * &p5,const ::GoldenDelicous3 &p6,::GaliaMelon3_out p7 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::GreenGrapes2");
#endif
  
  ernie.seed("GreenGrapes2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckWaterMelon(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckFig(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckCeleriac2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckCorn1(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckString(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckGoldenDelicous3(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GreenGrapes2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(2);
  p5 = GetString();
  p7 = new ::GaliaMelon3;
  ernie.mode(0);
  GetGaliaMelon3(*p7);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::GreenGrapes2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Rasin2*
siiServer_imp::CookingApple2(CORBA::Long &p1,const ::Cauliflower2 &p2,const ::Tomato2 &p3,::Tomato2_out p4,const ::Celeriac2 &p5,::BambooShoot3_out p6,::Currant2_out p7,const ::Cauliflower2 &p8,const ::BlackEyedBeans &p9,const ::BlackEyedBeans &p10,::Dates3 &p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Rasin2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::CookingApple2");
#endif
  
  ernie.seed("CookingApple2Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckCauliflower2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckTomato2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckCeleriac2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckCauliflower2(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckBlackEyedBeans(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckBlackEyedBeans(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckDates3(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("CookingApple2Return"); 
  ReturnValue = new ::Rasin2;
  GetRasin2(*ReturnValue);
  ernie.mode(0);
  GetLong(p1);
  p4 = new ::Tomato2;
  ernie.mode(0);
  GetTomato2(*p4);
  p6 = new ::BambooShoot3;
  ernie.mode(0);
  GetBambooShoot3(*p6);
  p7 = new ::Currant2;
  ernie.mode(0);
  GetCurrant2(*p7);
  ernie.mode(2);
  GetDates3(p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::CookingApple2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Chives2*
siiServer_imp::Mullberry2(CORBA::Object_out p1,::Cauliflower2 &p2,::Tomato2 &p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Chives2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Mullberry2");
#endif
  
  ernie.seed("Mullberry2Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckCauliflower2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckTomato2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Mullberry2Return"); 
  ReturnValue = new ::Chives2;
  GetChives2(*ReturnValue);
  ernie.mode(0);
  p1 = Getobject();
  ernie.mode(2);
  GetCauliflower2(p2);
  ernie.mode(2);
  GetTomato2(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Mullberry2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GoldenDelicous3*
siiServer_imp::Yam2(::WaterMelon3 p1,CORBA::Any &p2,CORBA::String_out p3,::IcebergLettuce2 &p4,CORBA::UShort p5,::Dates3 &p6,CORBA::Boolean p7,const ::GaliaMelon3 &p8 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::GoldenDelicous3* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Yam2");
#endif
  
  ernie.seed("Yam2Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckAny(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckIcebergLettuce2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckUShort(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckDates3(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckBoolean(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckGaliaMelon3(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Yam2Return"); 
  ReturnValue = new ::GoldenDelicous3;
  GetGoldenDelicous3(*ReturnValue);
  ernie.mode(0);
  GetWaterMelon3(p1);
  ernie.mode(2);
  GetAny(p2);
  ernie.mode(0);
  p3 = GetString();
  ernie.mode(2);
  GetIcebergLettuce2(p4);
  ernie.mode(2);
  GetDates3(p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Yam2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Short
siiServer_imp::GreenChilly2(const ::Mullberry1 p1 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Short ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::GreenChilly2");
#endif
  
  ernie.seed("GreenChilly2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckMullberry1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GreenChilly2Return"); 
  
  GetShort(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::GreenChilly2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Corn2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Corn2");
#endif
  
  ernie.seed("Corn2Call");
  
  ernie.seed("Corn2Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Corn2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Char
siiServer_imp::Peach2(CORBA::Double &p1,::Asparagus &p2,::Carrots p3,::Peanuts1 p4,const ::GaliaMelon3 &p5 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Char ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Peach2");
#endif
  
  ernie.seed("Peach2Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckAsparagus(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckCarrots(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckPeanuts1(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckGaliaMelon3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Peach2Return"); 
  
  GetChar(ReturnValue);
  ernie.mode(0);
  GetDouble(p1);
  ernie.mode(2);
  GetAsparagus(p2);
  ernie.mode(2);
  GetCarrots(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Peach2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Squash2*
siiServer_imp::Parsley2(const ::Pumpkin p1,const ::LoganBerry &p2,const ::Cauliflower2 &p3,::YellowPepper2_out p4,const ::Mangosteen3 &p5,::Susander2 &p6,::Asparagus &p7,CORBA::Float &p8,CORBA::Octet &p9 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Squash2* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Parsley2");
#endif
  
  ernie.seed("Parsley2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckPumpkin(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckLoganBerry(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckCauliflower2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckMangosteen3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckSusander2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckAsparagus(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckFloat(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckOctet(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Parsley2Return"); 
  ReturnValue = new ::Squash2;
  GetSquash2(*ReturnValue);
  p4 = new ::YellowPepper2;
  ernie.mode(0);
  GetYellowPepper2(*p4);
  ernie.mode(2);
  GetSusander2(p6);
  ernie.mode(2);
  GetAsparagus(p7);
  ernie.mode(2);
  GetFloat(p8);
  ernie.mode(2);
  GetOctet(p9);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Parsley2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::YellowPepper2*
siiServer_imp::Satsuma2(const ::Susander2 &p1,const ::Squash1 &p2,::GardenPeas3_out p3 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::YellowPepper2* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Satsuma2");
#endif
  
  ernie.seed("Satsuma2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckSusander2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckSquash1(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Satsuma2Return"); 
  ReturnValue = new ::YellowPepper2;
  GetYellowPepper2(*ReturnValue);
  p3 = new ::GardenPeas3;
  ernie.mode(0);
  GetGardenPeas3(*p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Satsuma2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::BambooShoot3*
siiServer_imp::Basil2(::Peppercorn &p1,::Oregano3 &p2,::Fig &p3,::Dates3 &p4,const ::Clementine2 &p5,CORBA::Boolean p6,::Carrots p7,::Raspberry1 p8,::Rasin2 &p9,::Clementine2 &p10,::Mangosteen3_out p11,::Pumpkin p12,CORBA::Float &p13,::Chestnut1 p14 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::BambooShoot3* ReturnValue;
  
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Basil2");
#endif
  
  ernie.seed("Basil2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckPeppercorn(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckOregano3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckFig(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckDates3(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckClementine2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckBoolean(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckRaspberry1(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckRasin2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckClementine2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckPumpkin(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckFloat(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckChestnut1(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Basil2Return"); 
  ReturnValue = new ::BambooShoot3;
  GetBambooShoot3(*ReturnValue);
  ernie.mode(2);
  GetPeppercorn(p1);
  ernie.mode(2);
  GetOregano3(p2);
  ernie.mode(2);
  GetFig(p3);
  ernie.mode(2);
  GetDates3(p4);
  ernie.mode(0);
  GetCarrots(p7);
  ernie.mode(2);
  GetRaspberry1(p8);
  ernie.mode(2);
  GetRasin2(p9);
  ernie.mode(2);
  GetClementine2(p10);
  p11 = new ::Mangosteen3;
  ernie.mode(0);
  GetMangosteen3(*p11);
  ernie.mode(2);
  GetPumpkin(p12);
  ernie.mode(2);
  GetFloat(p13);
  ernie.mode(2);
  GetChestnut1(p14);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Basil2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Record2_slice *
siiServer_imp::Blueberry2(const ::Cauliflower2 &p1,::Asparagus &p2,::WaterMelon3 p3,::WaterMelon3 p4,::Dates3_out p5,::Lychees3_out p6 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Record2_slice * ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Blueberry2");
#endif
  
  ernie.seed("Blueberry2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCauliflower2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckAsparagus(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Blueberry2Return"); 
  
  ReturnValue = new ::Record2;
  GetRecord2(ReturnValue);
  ernie.mode(2);
  GetAsparagus(p2);
  ernie.mode(0);
  GetWaterMelon3(p3);
  ernie.mode(0);
  GetWaterMelon3(p4);
  p5 = new ::Dates3;
  ernie.mode(0);
  GetDates3(*p5);
  p6 = new ::Lychees3;
  ernie.mode(0);
  GetLychees3(*p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Blueberry2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Blackberry2*
siiServer_imp::Chervil2(CORBA::Long &p1,const ::Susander2 &p2,CORBA::TypeCode_ptr &p3,const ::Peppercorn &p4,const ::Cauliflower2 &p5 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  ::Blackberry2* ReturnValue;
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Chervil2");
#endif
  
  ernie.seed("Chervil2Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckSusander2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckCORBATypeCode_ptr(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckPeppercorn(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckCauliflower2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Chervil2Return"); 
  ReturnValue = new ::Blackberry2;
  GetBlackberry2(*ReturnValue);
  ernie.mode(0);
  GetLong(p1);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p3);
	p3=CORBA::TypeCode::_duplicate(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Chervil2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Boolean
siiServer_imp::GreenPepper2(::Lychees3 &p1,CORBA::Float &p2,const ::BambooShoot3 &p3,::Record2 p4,const char * p5,::Tomato_out p6,::LoganBerry &p7,CORBA::Long &p8,const ::Corn1 p9,CORBA::Float &p10,CORBA::Long &p11,CORBA::Float &p12,const ::GardenPeas3 &p13,::BambooShoot3_out p14,CORBA::ULong &p15,const ::Squash1 &p16,::BrazilNut3_out p17,::Cauliflower2_out p18,const ::GardenPeas3 &p19 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Boolean ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::GreenPepper2");
#endif
  
  ernie.seed("GreenPepper2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckLychees3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckBambooShoot3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckString(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckLoganBerry(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckLong(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckCorn1(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckGardenPeas3(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p15");
  if (!CheckULong(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckSquash1(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p19");
  if (!CheckGardenPeas3(p19))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("GreenPepper2Return"); 
  
  GetBoolean(ReturnValue);
  ernie.mode(2);
  GetLychees3(p1);
  ernie.mode(0);
  GetFloat(p2);
  ernie.mode(0);
  GetRecord2(p4);
  p6 = new ::Tomato;
  ernie.mode(0);
  GetTomato(*p6);
  ernie.mode(2);
  GetLoganBerry(p7);
  ernie.mode(2);
  GetLong(p8);
  ernie.mode(0);
  GetFloat(p10);
  ernie.mode(0);
  GetLong(p11);
  ernie.mode(0);
  GetFloat(p12);
  p14 = new ::BambooShoot3;
  ernie.mode(0);
  GetBambooShoot3(*p14);
  ernie.mode(2);
  GetULong(p15);
  p17 = new ::BrazilNut3;
  ernie.mode(0);
  GetBrazilNut3(*p17);
  p18 = new ::Cauliflower2;
  ernie.mode(0);
  GetCauliflower2(*p18);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::GreenPepper2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Mangosteen3*
siiServer_imp::Scallion2(::Squash1 &p1,::Chestnut1 p2,::Raspberry1 p3,::Cauliflower2_out p4,::Oregano3_out p5,const ::Dates3 &p6,CORBA::Boolean p7 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Mangosteen3* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Scallion2");
#endif
  
  ernie.seed("Scallion2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckSquash1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckRaspberry1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckDates3(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckBoolean(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Scallion2Return"); 
  ReturnValue = new ::Mangosteen3;
  GetMangosteen3(*ReturnValue);
  ernie.mode(2);
  GetSquash1(p1);
  ernie.mode(0);
  GetChestnut1(p2);
  ernie.mode(2);
  GetRaspberry1(p3);
  p4 = new ::Cauliflower2;
  ernie.mode(0);
  GetCauliflower2(*p4);
  p5 = new ::Oregano3;
  ernie.mode(0);
  GetOregano3(*p5);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Scallion2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Char
siiServer_imp::PricklyPear2(::Asparagus &p1,const ::Fig &p2,::Fig &p3,const ::Beetroot2 &p4,::GoldenDelicous3 &p5,::GaliaMelon3_out p6,::Squash2 &p7,::Beetroot2 &p8,::Clementine2 &p9,::Tomato &p10,const ::GoldenDelicous3 &p11,::BeechNut2_out p12 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Char ReturnValue;
  
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::PricklyPear2");
#endif
  
  ernie.seed("PricklyPear2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckAsparagus(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckFig(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckFig(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckBeetroot2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckGoldenDelicous3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckSquash2(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckBeetroot2(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckClementine2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckTomato(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckGoldenDelicous3(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PricklyPear2Return"); 
  
  GetChar(ReturnValue);
  ernie.mode(2);
  GetAsparagus(p1);
  ernie.mode(2);
  GetFig(p3);
  ernie.mode(2);
  GetGoldenDelicous3(p5);
  p6 = new ::GaliaMelon3;
  ernie.mode(0);
  GetGaliaMelon3(*p6);
  ernie.mode(2);
  GetSquash2(p7);
  ernie.mode(2);
  GetBeetroot2(p8);
  ernie.mode(2);
  GetClementine2(p9);
  ernie.mode(2);
  GetTomato(p10);
  p12 = new ::BeechNut2;
  ernie.mode(0);
  GetBeechNut2(*p12);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::PricklyPear2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Currant2*
siiServer_imp::Chestnut2(::Carrots p1,const ::Grapefruit2 &p2,CORBA::Boolean p3,const ::Fig &p4,::Fennell3_out p5,const ::Cauliflower2 &p6,CORBA::Any &p7,::GaliaMelon3 &p8,::Turnip3_out p9 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Currant2* ReturnValue;
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Chestnut2");
#endif
  
  ernie.seed("Chestnut2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckCarrots(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckGrapefruit2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckBoolean(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckFig(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckCauliflower2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckAny(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckGaliaMelon3(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Chestnut2Return"); 
  ReturnValue = new ::Currant2;
  GetCurrant2(*ReturnValue);
  ernie.mode(2);
  GetCarrots(p1);
  p5 = new ::Fennell3;
  ernie.mode(0);
  GetFennell3(*p5);
  ernie.mode(2);
  GetAny(p7);
  ernie.mode(2);
  GetGaliaMelon3(p8);
  p9 = new ::Turnip3;
  ernie.mode(0);
  GetTurnip3(*p9);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Chestnut2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::IcebergLettuce2*
siiServer_imp::KiwanoMelon2(::Asparagus_out p1,const ::Corn1 p2,::Peppercorn &p3,::Peppercorn &p4,::Fennell3 &p5,::Peanuts1 &p6,::Squash1 &p7,const ::Turnip3 &p8,CORBA::Any &p9,const ::BambooShoot3 &p10,::Lychees3_out p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  ::IcebergLettuce2* ReturnValue;
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::KiwanoMelon2");
#endif
  
  ernie.seed("KiwanoMelon2Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckCorn1(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckFennell3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckSquash1(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckTurnip3(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckAny(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckBambooShoot3(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KiwanoMelon2Return"); 
  ReturnValue = new ::IcebergLettuce2;
  GetIcebergLettuce2(*ReturnValue);
  p1 = new ::Asparagus;
  ernie.mode(0);
  GetAsparagus(*p1);
  ernie.mode(0);
  GetPeppercorn(p3);
  ernie.mode(0);
  GetPeppercorn(p4);
  ernie.mode(2);
  GetFennell3(p5);
  ernie.mode(0);
  GetPeanuts1(p6);
  ernie.mode(2);
  GetSquash1(p7);
  ernie.mode(2);
  GetAny(p9);
  p11 = new ::Lychees3;
  ernie.mode(0);
  GetLychees3(*p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::KiwanoMelon2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Tomato2*
siiServer_imp::Chayato2(::Beetroot2 &p1,::BambooShoot3_out p2,::BlackEyedBeans_out p3,const ::Squash2 &p4,::Turnip3 &p5,CORBA::TypeCode_ptr &p6,::Chestnut1 p7,char * &p8,::Record2 p9,::Tomato_out p10,const ::IcebergLettuce2 &p11,::Squash1 &p12,const ::Fennell3 &p13,const ::Pumpkin p14,CORBA::Char &p15,CORBA::TypeCode_ptr &p16,::BritishQueens1 &p17,::Turnip3_out p18 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Tomato2* ReturnValue;
  
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Chayato2");
#endif
  
  ernie.seed("Chayato2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckBeetroot2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckSquash2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckTurnip3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckCORBATypeCode_ptr(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckChestnut1(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckString(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckIcebergLettuce2(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckSquash1(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckFennell3(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckPumpkin(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p16");
  if (!CheckCORBATypeCode_ptr(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p17");
  if (!CheckBritishQueens1(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Chayato2Return"); 
  ReturnValue = new ::Tomato2;
  GetTomato2(*ReturnValue);
  ernie.mode(2);
  GetBeetroot2(p1);
  p2 = new ::BambooShoot3;
  ernie.mode(0);
  GetBambooShoot3(*p2);
  p3 = new ::BlackEyedBeans;
  ernie.mode(0);
  GetBlackEyedBeans(*p3);
  ernie.mode(2);
  GetTurnip3(p5);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p6);
	p6=CORBA::TypeCode::_duplicate(p6);
  ernie.mode(2);
  GetChestnut1(p7);
  ernie.mode(2);
  p8 = GetString();
  ernie.mode(0);
  GetRecord2(p9);
  p10 = new ::Tomato;
  ernie.mode(0);
  GetTomato(*p10);
  ernie.mode(2);
  GetSquash1(p12);
  ernie.mode(0);
  GetChar(p15);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p16);
	p16=CORBA::TypeCode::_duplicate(p16);
  ernie.mode(2);
  GetBritishQueens1(p17);
  p18 = new ::Turnip3;
  ernie.mode(0);
  GetTurnip3(*p18);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Chayato2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GaliaMelon3*
siiServer_imp::RedChilly2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  ::GaliaMelon3* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::RedChilly2");
#endif
  
  ernie.seed("RedChilly2Call");
  
  ernie.seed("RedChilly2Return"); 
  ReturnValue = new ::GaliaMelon3;
  GetGaliaMelon3(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::RedChilly2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Celeriac2*
siiServer_imp::GalaApple2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  ::Celeriac2* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::GalaApple2");
#endif
  
  ernie.seed("GalaApple2Call");
  
  ernie.seed("GalaApple2Return"); 
  ReturnValue = new ::Celeriac2;
  GetCeleriac2(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::GalaApple2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Cauliflower2*
siiServer_imp::Kiwi2(const ::Record2 p1,CORBA::Short p2,const ::Mullberry1 p3,::Susander2 &p4,const ::Tomato &p5,::Squash2_out p6,::Cauliflower2 &p7,::Carrots p8,::Record2 p9 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Cauliflower2* ReturnValue;
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Kiwi2");
#endif
  
  ernie.seed("Kiwi2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckRecord2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckShort(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckMullberry1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckSusander2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckTomato(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckCauliflower2(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckRecord2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Kiwi2Return"); 
  ReturnValue = new ::Cauliflower2;
  GetCauliflower2(*ReturnValue);
  ernie.mode(2);
  GetSusander2(p4);
  p6 = new ::Squash2;
  ernie.mode(0);
  GetSquash2(*p6);
  ernie.mode(2);
  GetCauliflower2(p7);
  ernie.mode(0);
  GetCarrots(p8);
  ernie.mode(2);
  GetRecord2(p9);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Kiwi2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::ULong
siiServer_imp::Corriander2(::Peppercorn &p1,const ::Susander2 &p2 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::ULong ReturnValue;
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Corriander2");
#endif
  
  ernie.seed("Corriander2Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckSusander2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Corriander2Return"); 
  
  GetULong(ReturnValue);
  ernie.mode(0);
  GetPeppercorn(p1);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Corriander2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Clementine2*
siiServer_imp::RedCabbage2(::Peanuts1 &p1,::Tomato2_out p2,CORBA::Object_ptr &p3,const ::Cauliflower2 &p4,::Asparagus_out p5,::Raspberry1 p6,::Record2 p7,::Susander2 &p8,const ::Asparagus &p9,::Rasin2_out p10,const ::Mangosteen3 &p11,const ::Chives2 &p12,::GaliaMelon3_out p13,const ::Grapefruit2 &p14,const ::Dates3 &p15,::BlackEyedBeans_out p16,::WaterMelon3 p17,CORBA::Object_ptr &p18,const ::WaterMelon3 p19 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  ::Clementine2* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::RedCabbage2");
#endif
  
  ernie.seed("RedCabbage2Call");
  ernie.mode(1);
  AddName("p3");
  if (!Checkobject(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckCauliflower2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckRaspberry1(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckSusander2(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckAsparagus(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckMangosteen3(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckChives2(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckGrapefruit2(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p15");
  if (!CheckDates3(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p17");
  if (!CheckWaterMelon3(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p18");
  if (!Checkobject(p18))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p19");
  if (!CheckWaterMelon3(p19))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("RedCabbage2Return"); 
  ReturnValue = new ::Clementine2;
  GetClementine2(*ReturnValue);
  ernie.mode(0);
  GetPeanuts1(p1);
  p2 = new ::Tomato2;
  ernie.mode(0);
  GetTomato2(*p2);
  ernie.mode(2);
  p3 = Getobject();
  p5 = new ::Asparagus;
  ernie.mode(0);
  GetAsparagus(*p5);
  ernie.mode(2);
  GetRaspberry1(p6);
  ernie.mode(0);
  GetRecord2(p7);
  ernie.mode(2);
  GetSusander2(p8);
  p10 = new ::Rasin2;
  ernie.mode(0);
  GetRasin2(*p10);
  p13 = new ::GaliaMelon3;
  ernie.mode(0);
  GetGaliaMelon3(*p13);
  p16 = new ::BlackEyedBeans;
  ernie.mode(0);
  GetBlackEyedBeans(*p16);
  ernie.mode(2);
  GetWaterMelon3(p17);
  ernie.mode(2);
  p18 = Getobject();

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::RedCabbage2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Dates3*
siiServer_imp::Broadbeans2(::WaterMelon_out p1,::Fennell3 &p2,::Oregano3 &p3,const ::Squash2 &p4,::Fig_out p5,::Grapefruit2_out p6,const ::WaterMelon &p7,::Fig &p8 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Dates3* ReturnValue;
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Broadbeans2");
#endif
  
  ernie.seed("Broadbeans2Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckFennell3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckOregano3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckSquash2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckWaterMelon(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckFig(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Broadbeans2Return"); 
  ReturnValue = new ::Dates3;
  GetDates3(*ReturnValue);
  p1 = new ::WaterMelon;
  ernie.mode(0);
  GetWaterMelon(*p1);
  ernie.mode(2);
  GetFennell3(p2);
  ernie.mode(2);
  GetOregano3(p3);
  p5 = new ::Fig;
  ernie.mode(0);
  GetFig(*p5);
  p6 = new ::Grapefruit2;
  ernie.mode(0);
  GetGrapefruit2(*p6);
  ernie.mode(2);
  GetFig(p8);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Broadbeans2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::ULong
siiServer_imp::Potato2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 
  CORBA::ULong ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Potato2");
#endif
  
  ernie.seed("Potato2Call");
  
  ernie.seed("Potato2Return"); 
  
  GetULong(ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Potato2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Record2_slice *
siiServer_imp::Homeguard2(CORBA::Boolean &p1,::Lychees3 &p2,::Susander2 &p3,::Grapefruit2_out p4,CORBA::Char &p5,const ::Dates3 &p6,CORBA::Double p7,::GaliaMelon3 &p8,::Grapefruit2 &p9,const ::GardenPeas1 &p10,::Mullberry1 p11,CORBA::Long &p12,const CORBA::Any &p13,CORBA::ULong &p14,::Peanuts1 p15 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Record2_slice * ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Homeguard2");
#endif
  
  ernie.seed("Homeguard2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckBoolean(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckLychees3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckSusander2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckChar(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckDates3(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckDouble(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckGaliaMelon3(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckGrapefruit2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckGardenPeas1(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckMullberry1(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckLong(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckAny(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p15");
  if (!CheckPeanuts1(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Homeguard2Return"); 
  
  ReturnValue = new ::Record2;
  GetRecord2(ReturnValue);
  ernie.mode(2);
  GetBoolean(p1);
  ernie.mode(2);
  GetLychees3(p2);
  ernie.mode(2);
  GetSusander2(p3);
  p4 = new ::Grapefruit2;
  ernie.mode(0);
  GetGrapefruit2(*p4);
  ernie.mode(2);
  GetChar(p5);
  ernie.mode(2);
  GetGaliaMelon3(p8);
  ernie.mode(2);
  GetGrapefruit2(p9);
  ernie.mode(2);
  GetMullberry1(p11);
  ernie.mode(2);
  GetLong(p12);
  ernie.mode(0);
  GetULong(p14);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Homeguard2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::WaterMelon3_slice *
siiServer_imp::Wilja2(::Fig &p1 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::WaterMelon3_slice * ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::AllTypesTests::Wilja2");
#endif
  
  ernie.seed("Wilja2Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckFig(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Wilja2Return"); 
  
  ReturnValue = new ::WaterMelon3;
  GetWaterMelon3(ReturnValue);
  ernie.mode(2);
  GetFig(p1);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::AllTypesTests::Wilja2");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
siiServer_imp::Balmoral2(const ::Currant2 &p1,const ::Turnip3 &p2,const ::BlackEyedBeans &p3,CORBA::Double p4,const ::Dates3 &p5,const ::Tomato2 &p6,const ::Raspberry1 p7,::Peanuts1 p8,CORBA::TypeCode_ptr p9 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::Balmoral2");
#endif
  
  ernie.seed("Balmoral2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCurrant2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckTurnip3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckBlackEyedBeans(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckDouble(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckDates3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckTomato2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckRaspberry1(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckPeanuts1(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckCORBATypeCode_ptr(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Balmoral2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::Balmoral2");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::KerrsPinks2(const ::WaterMelon3 p1,const ::GaliaMelon3 &p2 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::KerrsPinks2");
#endif
  
  ernie.seed("KerrsPinks2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckWaterMelon3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckGaliaMelon3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KerrsPinks2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::KerrsPinks2");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::GoldenWonder2( VSORB_SRC_ENV2)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::GoldenWonder2");
#endif
  
  ernie.seed("GoldenWonder2Call");
  
  ernie.seed("GoldenWonder2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::GoldenWonder2");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::Pimpernel2(const ::Tomato &p1,const ::Clementine2 &p2 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::Pimpernel2");
#endif
  
  ernie.seed("Pimpernel2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckTomato(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckClementine2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Pimpernel2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::Pimpernel2");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::Cultra2(const ::Chestnut1 p1,CORBA::Char p2,CORBA::ULong p3,const ::IcebergLettuce2 &p4,CORBA::Short p5,const ::WaterMelon &p6,const ::Cauliflower2 &p7,const ::GardenPeas1 &p8,const ::Cauliflower2 &p9,const ::Corn1 p10,const ::Corn1 p11,CORBA::TypeCode_ptr p12,const ::WaterMelon3 p13,const ::Lychees3 &p14 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::Cultra2");
#endif
  
  ernie.seed("Cultra2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckChestnut1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckChar(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckULong(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckIcebergLettuce2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckShort(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckWaterMelon(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckCauliflower2(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckGardenPeas1(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckCauliflower2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckCorn1(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckCorn1(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckCORBATypeCode_ptr(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckWaterMelon3(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckLychees3(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cultra2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::Cultra2");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::Rooster2(const ::GaliaMelon3 &p1,const ::Celeriac2 &p2,const CORBA::Any &p3,const ::BeechNut2 &p4,const ::BeechNut2 &p5,const ::Fennell3 &p6,const ::Dates3 &p7,const ::Blackberry2 &p8,const ::Fennell3 &p9,CORBA::UShort p10,const ::Cauliflower2 &p11,const ::WaterMelon3 p12,const ::Rasin2 &p13,const ::Dates3 &p14,const ::Fig &p15,const ::GaliaMelon3 &p16,const ::BritishQueens1 &p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::Rooster2");
#endif
  
  ernie.seed("Rooster2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckGaliaMelon3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckCeleriac2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckBeechNut2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckBeechNut2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckFennell3(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckDates3(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckBlackberry2(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckFennell3(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckUShort(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckCauliflower2(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckWaterMelon3(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckRasin2(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckDates3(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p15");
  if (!CheckFig(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckGaliaMelon3(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p17");
  if (!CheckBritishQueens1(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Rooster2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::Rooster2");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::MarisPiper2(const ::BeechNut2 &p1,const ::Pumpkin p2,CORBA::Double p3,const ::Tomato2 &p4,CORBA::Octet p5,const ::Record2 p6,CORBA::Double p7,const ::WaterMelon3 p8,const ::Squash2 &p9,const ::Record2 p10 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::MarisPiper2");
#endif
  
  ernie.seed("MarisPiper2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckBeechNut2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckPumpkin(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckDouble(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckTomato2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckOctet(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckRecord2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckDouble(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckWaterMelon3(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckSquash2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckRecord2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("MarisPiper2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::MarisPiper2");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::Cara2(CORBA::Short p1,const ::BrazilNut3 &p2,CORBA::Char p3,const ::GardenPeas3 &p4,const ::Fennell3 &p5,CORBA::Boolean p6,const ::Mullberry1 p7,const ::Susander2 &p8,CORBA::UShort p9 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::Cara2");
#endif
  
  ernie.seed("Cara2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckShort(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckBrazilNut3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckChar(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckGardenPeas3(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckFennell3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckBoolean(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckMullberry1(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckSusander2(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckUShort(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cara2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::Cara2");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::KingEdward2(const ::Squash2 &p1,CORBA::Float p2,const ::Cauliflower2 &p3,const ::Chives2 &p4,const ::Turnip3 &p5,const ::Squash2 &p6,const ::Tomato &p7,const ::Fig &p8,CORBA::Char p9,const ::GaliaMelon3 &p10,const ::Carrots p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::KingEdward2");
#endif
  
  ernie.seed("KingEdward2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckSquash2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckFloat(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckCauliflower2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckChives2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckTurnip3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckSquash2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckTomato(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckFig(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckChar(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckGaliaMelon3(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckCarrots(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KingEdward2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::KingEdward2");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::PentlandDell2(const char * p1,const ::Tomato2 &p2,const ::Asparagus &p3,const ::Dates3 &p4,const ::Tomato2 &p5,const ::Tomato2 &p6,CORBA::Octet p7,const ::Peppercorn &p8,const ::IcebergLettuce2 &p9 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::PentlandDell2");
#endif
  
  ernie.seed("PentlandDell2Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckString(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckTomato2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckAsparagus(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckDates3(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckTomato2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckTomato2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckOctet(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckPeppercorn(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckIcebergLettuce2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PentlandDell2Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::PentlandDell2");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::Apple3(const ::Oregano3 &p1 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::Apple3");
#endif
  
  ernie.seed("Apple3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckOregano3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Apple3Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::Apple3");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::Banana3(const ::Rasin2 &p1,CORBA::Double p2,const ::Fennell3 &p3,const ::IcebergLettuce2 &p4 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::Banana3");
#endif
  
  ernie.seed("Banana3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckRasin2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckDouble(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckFennell3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckIcebergLettuce2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Banana3Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::Banana3");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::Carrots3(CORBA::Boolean p1,const ::Damsons2 p2,const ::Corn1 p3,::Peanuts1 p4,const ::Rasin2 &p5,const ::Chestnut1 p6,const ::WaterMelon3 p7,CORBA::Long p8 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::Carrots3");
#endif
  
  ernie.seed("Carrots3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckBoolean(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckDamsons2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckCorn1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckPeanuts1(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckRasin2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckChestnut1(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckWaterMelon3(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckLong(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Carrots3Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::Carrots3");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::Lemon3(const ::Fennell3 &p1 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::Lemon3");
#endif
  
  ernie.seed("Lemon3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckFennell3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lemon3Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::Lemon3");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::BlackCherry3(const ::IcebergLettuce2 &p1,const ::Squash2 &p2,const ::Raspberry1 p3,const ::Susander2 &p4,const ::IcebergLettuce2 &p5,const ::Tomato2 &p6,const ::Mangosteen3 &p7,const ::BlackEyedBeans &p8,const ::Tomato2 &p9,const ::Record2 p10,CORBA::TypeCode_ptr p11,const ::Tomato2 &p12,const ::Fennell3 &p13,const ::Tomato2 &p14,const ::Tomato2 &p15,const ::Tomato2 &p16 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::BlackCherry3");
#endif
  
  ernie.seed("BlackCherry3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckIcebergLettuce2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckSquash2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckRaspberry1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckSusander2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckIcebergLettuce2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckTomato2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckMangosteen3(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckBlackEyedBeans(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckTomato2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckRecord2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckCORBATypeCode_ptr(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckTomato2(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckFennell3(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckTomato2(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p15");
  if (!CheckTomato2(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckTomato2(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("BlackCherry3Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::BlackCherry3");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::Starfruit3(const ::Asparagus &p1,const ::Squash2 &p2,const ::Tomato2 &p3,const ::Turnip3 &p4 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::Starfruit3");
#endif
  
  ernie.seed("Starfruit3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckAsparagus(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckSquash2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckTomato2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckTurnip3(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Starfruit3Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::Starfruit3");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::Rhubarb3(const ::IcebergLettuce2 &p1 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::Rhubarb3");
#endif
  
  ernie.seed("Rhubarb3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckIcebergLettuce2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Rhubarb3Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::Rhubarb3");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::PassionFruit3(const ::Cauliflower2 &p1,const ::WaterMelon &p2,::Peanuts1 p3,const ::GoldenDelicous3 &p4,CORBA::Long p5,const ::Oregano3 &p6,const ::Record2 p7,const ::Squash1 &p8,const ::Asparagus &p9,const ::Chives2 &p10,CORBA::Boolean p11,const ::BrazilNut3 &p12,const ::Susander2 &p13,CORBA::ULong p14,const ::Chives2 &p15 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::PassionFruit3");
#endif
  
  ernie.seed("PassionFruit3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCauliflower2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckWaterMelon(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckPeanuts1(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckGoldenDelicous3(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckLong(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckOregano3(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckRecord2(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckSquash1(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckAsparagus(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckChives2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckBoolean(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckBrazilNut3(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckSusander2(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckULong(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p15");
  if (!CheckChives2(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("PassionFruit3Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::PassionFruit3");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
siiServer_imp::Pumpkin3(const ::Turnip3 &p1,const ::Tomato2 &p2,const ::Cauliflower2 &p3,const ::Chives2 &p4,const ::Susander2 &p5,const ::Pumpkin p6,const ::Tomato &p7,const ::Mullberry1 p8,const ::Tomato2 &p9,const ::LoganBerry &p10,const ::GaliaMelon3 &p11,const ::Grapefruit2 &p12,const ::Record2 p13,const ::GaliaMelon3 &p14,const ::Cauliflower2 &p15,const ::Rasin2 &p16,const ::IcebergLettuce2 &p17,const ::Cauliflower2 &p18 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::OneWayTests::Pumpkin3");
#endif
  
  ernie.seed("Pumpkin3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckTurnip3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckTomato2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckCauliflower2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckChives2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckSusander2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckPumpkin(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckTomato(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckMullberry1(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckTomato2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckLoganBerry(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckGaliaMelon3(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckGrapefruit2(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckRecord2(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p14");
  if (!CheckGaliaMelon3(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p15");
  if (!CheckCauliflower2(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckRasin2(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p17");
  if (!CheckIcebergLettuce2(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p18");
  if (!CheckCauliflower2(p18))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Pumpkin3Return"); 
  

#ifdef DEBUG
  ::tet_infoline("server: returning from ::OneWayTests::Pumpkin3");
#endif
  ::tet_result(TET_PASS);
  
  
}

CORBA::Double
siiServer_imp::Mango3(::LoganBerry_out p1,CORBA::Context_ptr ctx VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Double ReturnValue;
  CORBA::NVList_ptr ctxNVList;
  CORBA::NamedValue_ptr ctxNamedValue;
  CORBA::Any *ctxAny;
  const char *ctxString;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ContextTests::Mango3");
#endif
  
  ernie.seed("Mango3Call");
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Rasin1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Rasin1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Rasin1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Eddo1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Eddo1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Eddo1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Leek1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Leek1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Leek1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Mango1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Mango1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Mango1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  
  ernie.seed("Mango3Return"); 
  
  GetDouble(ReturnValue);
  p1 = new ::LoganBerry;
  ernie.mode(0);
  GetLoganBerry(*p1);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ContextTests::Mango3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::WaterMelon3_slice *
siiServer_imp::Lime3(CORBA::ULong p1,::Grapefruit2 &p2,const ::GaliaMelon3 &p3,CORBA::Any &p4,const CORBA::Any &p5,::LoganBerry_out p6,::Cauliflower2_out p7,CORBA::Float p8,const ::Currant2 &p9,::BritishQueens1_out p10,const char * p11,::Corn1 p12,const ::Mangosteen3 &p13,::Fig_out p14,::Pumpkin p15,const ::Chives2 &p16,::Fennell3_out p17,::Fig &p18,CORBA::Context_ptr ctx VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::WaterMelon3_slice * ReturnValue;
  
  
  CORBA::NVList_ptr ctxNVList;
  CORBA::NamedValue_ptr ctxNamedValue;
  CORBA::Any *ctxAny;
  const char *ctxString;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ContextTests::Lime3");
#endif
  
  ernie.seed("Lime3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckULong(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckGrapefruit2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckGaliaMelon3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckAny(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckAny(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckFloat(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckCurrant2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckString(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckCorn1(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckMangosteen3(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckChives2(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p18");
  if (!CheckFig(p18))
    ::tet_result(TET_FAIL);
  RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Sultana1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Sultana1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Sultana1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Rasin1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Rasin1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Rasin1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Banana1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Banana1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Banana1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Dates1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Dates1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Dates1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  
  ernie.seed("Lime3Return"); 
  
  ReturnValue = new ::WaterMelon3;
  GetWaterMelon3(ReturnValue);
  ernie.mode(2);
  GetGrapefruit2(p2);
  ernie.mode(2);
  GetAny(p4);
  p6 = new ::LoganBerry;
  ernie.mode(0);
  GetLoganBerry(*p6);
  p7 = new ::Cauliflower2;
  ernie.mode(0);
  GetCauliflower2(*p7);
  p10 = new ::BritishQueens1;
  ernie.mode(0);
  GetBritishQueens1(*p10);
  ernie.mode(2);
  GetCorn1(p12);
  p14 = new ::Fig;
  ernie.mode(0);
  GetFig(*p14);
  ernie.mode(0);
  GetPumpkin(p15);
  p17 = new ::Fennell3;
  ernie.mode(0);
  GetFennell3(*p17);
  ernie.mode(2);
  GetFig(p18);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ContextTests::Lime3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Dates3*
siiServer_imp::Coconut3(CORBA::Context_ptr ctx VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Dates3* ReturnValue;
  CORBA::NVList_ptr ctxNVList;
  CORBA::NamedValue_ptr ctxNamedValue;
  CORBA::Any *ctxAny;
  const char *ctxString;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ContextTests::Coconut3");
#endif
  
  ernie.seed("Coconut3Call");
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Chervil1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Chervil1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Chervil1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Coconut1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Coconut1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Coconut1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"GardenPeas1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","GardenPeas1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("GardenPeas1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  
  ernie.seed("Coconut3Return"); 
  ReturnValue = new ::Dates3;
  GetDates3(*ReturnValue);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ContextTests::Coconut3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Lychees3*
siiServer_imp::Cabbage3(const ::IcebergLettuce2 &p1,::Cauliflower2_out p2,::Rasin2 &p3,::Susander2 &p4,::Currant2 &p5,::Squash2 &p6,const ::Fennell3 &p7,::Record2 p8,CORBA::Context_ptr ctx VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Lychees3* ReturnValue;
  
  
  CORBA::NVList_ptr ctxNVList;
  CORBA::NamedValue_ptr ctxNamedValue;
  CORBA::Any *ctxAny;
  const char *ctxString;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ContextTests::Cabbage3");
#endif
  
  ernie.seed("Cabbage3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckIcebergLettuce2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckRasin2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckSusander2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckCurrant2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckSquash2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p7");
  if (!CheckFennell3(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckRecord2(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"LoganBerry1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","LoganBerry1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("LoganBerry1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"PassionFruit1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","PassionFruit1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("PassionFruit1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Strawberry1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Strawberry1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Strawberry1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"KiwanoMelon1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","KiwanoMelon1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("KiwanoMelon1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  
  ernie.seed("Cabbage3Return"); 
  ReturnValue = new ::Lychees3;
  GetLychees3(*ReturnValue);
  p2 = new ::Cauliflower2;
  ernie.mode(0);
  GetCauliflower2(*p2);
  ernie.mode(2);
  GetRasin2(p3);
  ernie.mode(2);
  GetSusander2(p4);
  ernie.mode(2);
  GetCurrant2(p5);
  ernie.mode(2);
  GetSquash2(p6);
  ernie.mode(2);
  GetRecord2(p8);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ContextTests::Cabbage3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GaliaMelon3*
siiServer_imp::Ginger3(const ::Squash2 &p1,const char * p2,::BrazilNut3_out p3,::Cauliflower2_out p4,::BlackEyedBeans_out p5,::BambooShoot3_out p6,CORBA::Context_ptr ctx VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::GaliaMelon3* ReturnValue;
  CORBA::NVList_ptr ctxNVList;
  CORBA::NamedValue_ptr ctxNamedValue;
  CORBA::Any *ctxAny;
  const char *ctxString;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ContextTests::Ginger3");
#endif
  
  ernie.seed("Ginger3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckSquash2(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckString(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"BlackCherry1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","BlackCherry1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("BlackCherry1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Scallion1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Scallion1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Scallion1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Carrots1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Carrots1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Carrots1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Orange1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Orange1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Orange1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Rasin1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Rasin1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Rasin1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"WaterMelon1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","WaterMelon1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("WaterMelon1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Eddo1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Eddo1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Eddo1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Parsnip1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Parsnip1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Parsnip1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Asparagus1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Asparagus1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Asparagus1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  
  ernie.seed("Ginger3Return"); 
  ReturnValue = new ::GaliaMelon3;
  GetGaliaMelon3(*ReturnValue);
  p3 = new ::BrazilNut3;
  ernie.mode(0);
  GetBrazilNut3(*p3);
  p4 = new ::Cauliflower2;
  ernie.mode(0);
  GetCauliflower2(*p4);
  p5 = new ::BlackEyedBeans;
  ernie.mode(0);
  GetBlackEyedBeans(*p5);
  p6 = new ::BambooShoot3;
  ernie.mode(0);
  GetBambooShoot3(*p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ContextTests::Ginger3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Mangosteen3*
siiServer_imp::BlackEyedBeans3(const ::WaterMelon3 p1,const ::Dates3 &p2,::Dates3 &p3,const ::Squash2 &p4,const ::Pumpkin p5,CORBA::Boolean &p6,::Beetroot2 &p7,::BritishQueens1 &p8,const ::Fig &p9,CORBA::Long p10,CORBA::Context_ptr ctx VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Mangosteen3* ReturnValue;
  
  CORBA::NVList_ptr ctxNVList;
  CORBA::NamedValue_ptr ctxNamedValue;
  CORBA::Any *ctxAny;
  const char *ctxString;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ContextTests::BlackEyedBeans3");
#endif
  
  ernie.seed("BlackEyedBeans3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckWaterMelon3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckDates3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckDates3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckSquash2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckPumpkin(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckBoolean(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckBeetroot2(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckBritishQueens1(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckFig(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckLong(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"PassionFruit1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","PassionFruit1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("PassionFruit1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Eddo1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Eddo1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Eddo1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Rasin1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Rasin1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Rasin1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Parsley1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Parsley1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Parsley1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Lime1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Lime1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Lime1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"WaterMelon1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","WaterMelon1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("WaterMelon1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Banana1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Banana1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Banana1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  
  ernie.seed("BlackEyedBeans3Return"); 
  ReturnValue = new ::Mangosteen3;
  GetMangosteen3(*ReturnValue);
  ernie.mode(2);
  GetDates3(p3);
  ernie.mode(2);
  GetBoolean(p6);
  ernie.mode(2);
  GetBeetroot2(p7);
  ernie.mode(2);
  GetBritishQueens1(p8);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ContextTests::BlackEyedBeans3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Fig*
siiServer_imp::Leek3(::Corn1 p1,::Chives2 &p2,::Fennell3 &p3,::Cauliflower2_out p4,CORBA::Long &p5,const ::Damsons2 p6,::BritishQueens1_out p7,const ::Chestnut1 p8,::GaliaMelon3 &p9,::WaterMelon3 p10,CORBA::Context_ptr ctx VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  ::Fig* ReturnValue;
  CORBA::NVList_ptr ctxNVList;
  CORBA::NamedValue_ptr ctxNamedValue;
  CORBA::Any *ctxAny;
  const char *ctxString;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ContextTests::Leek3");
#endif
  
  ernie.seed("Leek3Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckChives2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckFennell3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckDamsons2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckChestnut1(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckGaliaMelon3(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Coconut1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Coconut1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Coconut1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Ginger1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Ginger1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Ginger1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Eddo1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Eddo1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Eddo1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"PassionFruit1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","PassionFruit1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("PassionFruit1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Turnip1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Turnip1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Turnip1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"LoganBerry1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","LoganBerry1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("LoganBerry1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"WaterMelon1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","WaterMelon1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("WaterMelon1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Lemon1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Lemon1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Lemon1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  
  ernie.seed("Leek3Return"); 
  ReturnValue = new ::Fig;
  GetFig(*ReturnValue);
  ernie.mode(0);
  GetCorn1(p1);
  ernie.mode(2);
  GetChives2(p2);
  ernie.mode(2);
  GetFennell3(p3);
  p4 = new ::Cauliflower2;
  ernie.mode(0);
  GetCauliflower2(*p4);
  ernie.mode(0);
  GetLong(p5);
  p7 = new ::BritishQueens1;
  ernie.mode(0);
  GetBritishQueens1(*p7);
  ernie.mode(2);
  GetGaliaMelon3(p9);
  ernie.mode(0);
  GetWaterMelon3(p10);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ContextTests::Leek3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::TypeCode_ptr
siiServer_imp::Mint3(::Chestnut1 p1,::Dates3 &p2,const ::Chives2 &p3,const ::GoldenDelicous3 &p4,::Oregano3_out p5,const ::Mullberry1 p6,CORBA::Context_ptr ctx VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::TypeCode_ptr ReturnValue;
  CORBA::NVList_ptr ctxNVList;
  CORBA::NamedValue_ptr ctxNamedValue;
  CORBA::Any *ctxAny;
  const char *ctxString;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ContextTests::Mint3");
#endif
  
  ernie.seed("Mint3Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckDates3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckChives2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckGoldenDelicous3(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckMullberry1(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Banana1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Banana1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Banana1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Lime1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Lime1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Lime1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Strawberry1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Strawberry1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Strawberry1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  
  ernie.seed("Mint3Return"); 
  
  GetCORBATypeCode_ptr(ReturnValue);
	ReturnValue=CORBA::TypeCode::_duplicate(ReturnValue);
  ernie.mode(0);
  GetChestnut1(p1);
  ernie.mode(2);
  GetDates3(p2);
  p5 = new ::Oregano3;
  ernie.mode(0);
  GetOregano3(*p5);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ContextTests::Mint3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GardenPeas3*
siiServer_imp::Asparagus3(::Raspberry1 p1,CORBA::Context_ptr ctx VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::GardenPeas3* ReturnValue;
  CORBA::NVList_ptr ctxNVList;
  CORBA::NamedValue_ptr ctxNamedValue;
  CORBA::Any *ctxAny;
  const char *ctxString;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ContextTests::Asparagus3");
#endif
  
  ernie.seed("Asparagus3Call");
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"BlackEyedBeans1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","BlackEyedBeans1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("BlackEyedBeans1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Scallion1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Scallion1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Scallion1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Peanuts1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Peanuts1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Peanuts1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Lychees1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Lychees1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Lychees1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Melon1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Melon1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Melon1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  
  ernie.seed("Asparagus3Return"); 
  ReturnValue = new ::GardenPeas3;
  GetGardenPeas3(*ReturnValue);
  ernie.mode(0);
  GetRaspberry1(p1);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ContextTests::Asparagus3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GaliaMelon3*
siiServer_imp::Sultana3(const ::GaliaMelon3 &p1,const ::Pumpkin p2,CORBA::Long &p3,::Fig &p4,::Beetroot2_out p5,const ::Chives2 &p6,::Squash1_out p7,::Tomato2_out p8,::Celeriac2 &p9,const ::Rasin2 &p10,CORBA::UShort p11,::GaliaMelon3 &p12,::Raspberry1 p13,::Mullberry1 p14,::Squash2 &p15,::Rasin2_out p16,CORBA::Context_ptr ctx VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::GaliaMelon3* ReturnValue;
  
  CORBA::NVList_ptr ctxNVList;
  CORBA::NamedValue_ptr ctxNamedValue;
  CORBA::Any *ctxAny;
  const char *ctxString;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ContextTests::Sultana3");
#endif
  
  ernie.seed("Sultana3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckGaliaMelon3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckPumpkin(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckFig(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p6");
  if (!CheckChives2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckCeleriac2(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckRasin2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckUShort(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckGaliaMelon3(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckRaspberry1(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckMullberry1(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p15");
  if (!CheckSquash2(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Peanuts1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Peanuts1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Peanuts1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"KiwanoMelon1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","KiwanoMelon1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("KiwanoMelon1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Eddo1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Eddo1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Eddo1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  ctx->get_values("",CORBA::CTX_RESTRICT_SCOPE,"Currant1",ctxNVList);
  ctxNamedValue = ctxNVList->item(0);
  ctxAny = ctxNamedValue->value();
  if (!(*ctxAny >>= ctxString))
  {
    ::tet_printf("Unable to locate Context value for %s","Currant1");
    ::tet_result(TET_FAIL);
  }
  AddName("Context");AddName("Currant1");
  if (!CheckString(ctxString))
  {
    ::tet_result(TET_FAIL);
  }
  RemoveName();RemoveName();
  
  ernie.seed("Sultana3Return"); 
  ReturnValue = new ::GaliaMelon3;
  GetGaliaMelon3(*ReturnValue);
  ernie.mode(0);
  GetLong(p3);
  ernie.mode(2);
  GetFig(p4);
  p5 = new ::Beetroot2;
  ernie.mode(0);
  GetBeetroot2(*p5);
  p7 = new ::Squash1;
  ernie.mode(0);
  GetSquash1(*p7);
  p8 = new ::Tomato2;
  ernie.mode(0);
  GetTomato2(*p8);
  ernie.mode(2);
  GetCeleriac2(p9);
  ernie.mode(2);
  GetGaliaMelon3(p12);
  ernie.mode(2);
  GetRaspberry1(p13);
  ernie.mode(2);
  GetMullberry1(p14);
  ernie.mode(2);
  GetSquash2(p15);
  p16 = new ::Rasin2;
  ernie.mode(0);
  GetRasin2(*p16);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ContextTests::Sultana3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Turnip3*
siiServer_imp::Orange3(const ::Lychees3 &p1,const ::Rasin2 &p2,::Grapefruit2_out p3,::GaliaMelon3 &p4,const ::Fennell3 &p5 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  
  ::Turnip3* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ExceptionTests::Orange3");
#endif
  
  ernie.seed("Orange3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckLychees3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckRasin2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckGaliaMelon3(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckFennell3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Orange3Return"); 
  switch (ernie.getULong() % 6)
  {
    case 0:
          {
            ::CherryTomatoes3 ex;
            GetCherryTomatoes3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 1:
          {
            ::Raspberry3 ex;
            GetRaspberry3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 2:
          {
            ::Peppercorn3 ex;
            GetPeppercorn3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 3:
          {
            ::Elderberry3 ex;
            GetElderberry3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 4:
          {
            ::Peanutsquash3 ex;
            GetPeanutsquash3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 5:
          {
            ::Damsons3 ex;
            GetDamsons3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
  }
  ReturnValue = new ::Turnip3;
  GetTurnip3(*ReturnValue);
  p3 = new ::Grapefruit2;
  ernie.mode(0);
  GetGrapefruit2(*p3);
  ernie.mode(2);
  GetGaliaMelon3(p4);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ExceptionTests::Orange3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Oregano3*
siiServer_imp::Beansprout3(::Rasin2_out p1,CORBA::Octet &p2,const ::Oregano3 &p3,::Rasin2_out p4,const ::BlackEyedBeans &p5,::GaliaMelon3 &p6,::Squash2_out p7,const ::GoldenDelicous3 &p8,::Peanuts1 &p9,const ::Squash1 &p10,CORBA::Long &p11 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Oregano3* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ExceptionTests::Beansprout3");
#endif
  
  ernie.seed("Beansprout3Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckOctet(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckOregano3(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckBlackEyedBeans(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckGaliaMelon3(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p8");
  if (!CheckGoldenDelicous3(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckPeanuts1(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckSquash1(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Beansprout3Return"); 
  switch (ernie.getULong() % 4)
  {
    case 0:
          {
            ::Cherry3 ex;
            GetCherry3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 1:
          {
            ::Papaya3 ex;
            GetPapaya3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 2:
          {
            ::Sharanfruit3 ex;
            GetSharanfruit3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 3:
          {
            ::Raspberry3 ex;
            GetRaspberry3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
  }
  ReturnValue = new ::Oregano3;
  GetOregano3(*ReturnValue);
  p1 = new ::Rasin2;
  ernie.mode(0);
  GetRasin2(*p1);
  ernie.mode(2);
  GetOctet(p2);
  p4 = new ::Rasin2;
  ernie.mode(0);
  GetRasin2(*p4);
  ernie.mode(2);
  GetGaliaMelon3(p6);
  p7 = new ::Squash2;
  ernie.mode(0);
  GetSquash2(*p7);
  ernie.mode(2);
  GetPeanuts1(p9);
  ernie.mode(0);
  GetLong(p11);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ExceptionTests::Beansprout3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::BrazilNut3*
siiServer_imp::SweetPotato3(::Oregano3 &p1,::Tomato_out p2,const ::Cauliflower2 &p3,const ::YellowPepper2 &p4,::GardenPeas3_out p5,::Chives2_out p6 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::BrazilNut3* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ExceptionTests::SweetPotato3");
#endif
  
  ernie.seed("SweetPotato3Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckOregano3(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckCauliflower2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckYellowPepper2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("SweetPotato3Return"); 
  switch (ernie.getULong() % 5)
  {
    case 0:
          {
            ::Raspberry3 ex;
            GetRaspberry3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 1:
          {
            ::Sharanfruit3 ex;
            GetSharanfruit3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 2:
          {
            ::Blackcurrant3 ex;
            GetBlackcurrant3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 3:
          {
            ::Damsons3 ex;
            GetDamsons3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 4:
          {
            ::Papaya3 ex;
            GetPapaya3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
  }
  ReturnValue = new ::BrazilNut3;
  GetBrazilNut3(*ReturnValue);
  ernie.mode(2);
  GetOregano3(p1);
  p2 = new ::Tomato;
  ernie.mode(0);
  GetTomato(*p2);
  p5 = new ::GardenPeas3;
  ernie.mode(0);
  GetGardenPeas3(*p5);
  p6 = new ::Chives2;
  ernie.mode(0);
  GetChives2(*p6);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ExceptionTests::SweetPotato3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::ULong
siiServer_imp::KidneyBean3(::GoldenDelicous3_out p1,const ::Rasin2 &p2,::Cauliflower2 &p3,const ::Dates3 &p4,const ::Pumpkin p5 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::ULong ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ExceptionTests::KidneyBean3");
#endif
  
  ernie.seed("KidneyBean3Call");
  ernie.mode(0);
  AddName("p2");
  if (!CheckRasin2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckCauliflower2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckDates3(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckPumpkin(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("KidneyBean3Return"); 
  switch (ernie.getULong() % 3)
  {
    case 0:
          {
            ::Papaya3 ex;
            GetPapaya3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 1:
          {
            ::CherryTomatoes3 ex;
            GetCherryTomatoes3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 2:
          {
            ::Peanutsquash3 ex;
            GetPeanutsquash3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
  }
  
  GetULong(ReturnValue);
  p1 = new ::GoldenDelicous3;
  ernie.mode(0);
  GetGoldenDelicous3(*p1);
  ernie.mode(2);
  GetCauliflower2(p3);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ExceptionTests::KidneyBean3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::GoldenDelicous3*
siiServer_imp::Lentil3(char * &p1,const ::Squash2 &p2,const CORBA::Any &p3,::WaterMelon3 p4,::Fig_out p5,::WaterMelon &p6,::Celeriac2 &p7,CORBA::Octet &p8,::Fig_out p9,::Blackberry2 &p10,::Rasin2 &p11,const ::Squash2 &p12,::Pumpkin p13 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::GoldenDelicous3* ReturnValue;
  
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ExceptionTests::Lentil3");
#endif
  
  ernie.seed("Lentil3Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckString(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckSquash2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p3");
  if (!CheckAny(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckWaterMelon(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckCeleriac2(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckBlackberry2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p11");
  if (!CheckRasin2(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckSquash2(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Lentil3Return"); 
  switch (ernie.getULong() % 7)
  {
    case 0:
          {
            ::Elderberry3 ex;
            GetElderberry3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 1:
          {
            ::Cherry3 ex;
            GetCherry3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 2:
          {
            ::Peanutsquash3 ex;
            GetPeanutsquash3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 3:
          {
            ::CherryTomatoes3 ex;
            GetCherryTomatoes3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 4:
          {
            ::Peppercorn3 ex;
            GetPeppercorn3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 5:
          {
            ::Raspberry3 ex;
            GetRaspberry3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 6:
          {
            ::Blackcurrant3 ex;
            GetBlackcurrant3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
  }
  ReturnValue = new ::GoldenDelicous3;
  GetGoldenDelicous3(*ReturnValue);
  ernie.mode(2);
  p1 = GetString();
  ernie.mode(0);
  GetWaterMelon3(p4);
  p5 = new ::Fig;
  ernie.mode(0);
  GetFig(*p5);
  ernie.mode(2);
  GetWaterMelon(p6);
  ernie.mode(2);
  GetCeleriac2(p7);
  ernie.mode(0);
  GetOctet(p8);
  p9 = new ::Fig;
  ernie.mode(0);
  GetFig(*p9);
  ernie.mode(2);
  GetBlackberry2(p10);
  ernie.mode(2);
  GetRasin2(p11);
  ernie.mode(0);
  GetPumpkin(p13);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ExceptionTests::Lentil3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Short
siiServer_imp::Daikan3(CORBA::TypeCode_ptr &p1,CORBA::Octet &p2,::Chestnut1 p3,::Asparagus &p4,::GaliaMelon3 &p5 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Short ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ExceptionTests::Daikan3");
#endif
  
  ernie.seed("Daikan3Call");
  ernie.mode(1);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p2");
  if (!CheckOctet(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p4");
  if (!CheckAsparagus(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckGaliaMelon3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Daikan3Return"); 
  switch (ernie.getULong() % 7)
  {
    case 0:
          {
            ::Raspberry3 ex;
            GetRaspberry3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 1:
          {
            ::Damsons3 ex;
            GetDamsons3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 2:
          {
            ::CherryTomatoes3 ex;
            GetCherryTomatoes3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 3:
          {
            ::Cherry3 ex;
            GetCherry3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 4:
          {
            ::Sharanfruit3 ex;
            GetSharanfruit3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 5:
          {
            ::Papaya3 ex;
            GetPapaya3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 6:
          {
            ::Blackcurrant3 ex;
            GetBlackcurrant3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
  }
  
  GetShort(ReturnValue);
  ernie.mode(2);
  GetCORBATypeCode_ptr(p1);
	CORBA::TypeCode::_duplicate(p1);
  ernie.mode(2);
  GetOctet(p2);
  ernie.mode(0);
  GetChestnut1(p3);
  ernie.mode(2);
  GetAsparagus(p4);
  ernie.mode(2);
  GetGaliaMelon3(p5);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ExceptionTests::Daikan3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::BambooShoot3*
siiServer_imp::Cassava3(CORBA::TypeCode_ptr p1,const ::Chives2 &p2,CORBA::UShort &p3,const ::Squash1 &p4,::LoganBerry_out p5,::Chestnut1 p6,::Tomato2 &p7,::Tomato2 &p8,const CORBA::Any &p9,::Oregano3 &p10,const ::Asparagus &p11,const ::Rasin2 &p12 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::BambooShoot3* ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::ExceptionTests::Cassava3");
#endif
  
  ernie.seed("Cassava3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckCORBATypeCode_ptr(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p2");
  if (!CheckChives2(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckUShort(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckSquash1(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckTomato2(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckTomato2(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p9");
  if (!CheckAny(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckOregano3(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckAsparagus(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p12");
  if (!CheckRasin2(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Cassava3Return"); 
  switch (ernie.getULong() % 6)
  {
    case 0:
          {
            ::Sharanfruit3 ex;
            GetSharanfruit3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 1:
          {
            ::CherryTomatoes3 ex;
            GetCherryTomatoes3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 2:
          {
            ::Peanutsquash3 ex;
            GetPeanutsquash3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 3:
          {
            ::Elderberry3 ex;
            GetElderberry3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 4:
          {
            ::Blackcurrant3 ex;
            GetBlackcurrant3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 5:
          {
            ::Peppercorn3 ex;
            GetPeppercorn3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
  }
  ReturnValue = new ::BambooShoot3;
  GetBambooShoot3(*ReturnValue);
  ernie.mode(2);
  GetUShort(p3);
  p5 = new ::LoganBerry;
  ernie.mode(0);
  GetLoganBerry(*p5);
  ernie.mode(0);
  GetChestnut1(p6);
  ernie.mode(2);
  GetTomato2(p7);
  ernie.mode(2);
  GetTomato2(p8);
  ernie.mode(2);
  GetOregano3(p10);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ExceptionTests::Cassava3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Fennell3*
siiServer_imp::Uglifruit3(CORBA::Long &p1,::BlackEyedBeans &p2,CORBA::UShort &p3,const ::IcebergLettuce2 &p4,::Asparagus &p5,::Rasin2 &p6,::Oregano3_out p7,::Squash1_out p8,::Fennell3 &p9 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Fennell3* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ExceptionTests::Uglifruit3");
#endif
  
  ernie.seed("Uglifruit3Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckBlackEyedBeans(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckUShort(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p4");
  if (!CheckIcebergLettuce2(p4))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckAsparagus(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckRasin2(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckFennell3(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Uglifruit3Return"); 
  switch (ernie.getULong() % 7)
  {
    case 0:
          {
            ::CherryTomatoes3 ex;
            GetCherryTomatoes3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 1:
          {
            ::Papaya3 ex;
            GetPapaya3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 2:
          {
            ::Peanutsquash3 ex;
            GetPeanutsquash3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 3:
          {
            ::Sharanfruit3 ex;
            GetSharanfruit3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 4:
          {
            ::Blackcurrant3 ex;
            GetBlackcurrant3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 5:
          {
            ::Damsons3 ex;
            GetDamsons3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 6:
          {
            ::Peppercorn3 ex;
            GetPeppercorn3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
  }
  ReturnValue = new ::Fennell3;
  GetFennell3(*ReturnValue);
  ernie.mode(0);
  GetLong(p1);
  ernie.mode(2);
  GetBlackEyedBeans(p2);
  ernie.mode(2);
  GetUShort(p3);
  ernie.mode(2);
  GetAsparagus(p5);
  ernie.mode(2);
  GetRasin2(p6);
  p7 = new ::Oregano3;
  ernie.mode(0);
  GetOregano3(*p7);
  p8 = new ::Squash1;
  ernie.mode(0);
  GetSquash1(*p8);
  ernie.mode(2);
  GetFennell3(p9);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ExceptionTests::Uglifruit3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

::Mangosteen3*
siiServer_imp::Pear3(const ::Raspberry1 p1,::BeechNut2_out p2,::Tomato2 &p3,::Cauliflower2_out p4,::Blackberry2 &p5,::Oregano3_out p6,::Chives2 &p7,::GaliaMelon3 &p8,CORBA::Octet &p9,const ::Corn1 p10,const ::Cauliflower2 &p11,::BritishQueens1 &p12,const ::BeechNut2 &p13,::Rasin2 &p14,::GaliaMelon3 &p15,const ::LoganBerry &p16,::GaliaMelon3 &p17 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  ::Mangosteen3* ReturnValue;
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ExceptionTests::Pear3");
#endif
  
  ernie.seed("Pear3Call");
  ernie.mode(0);
  AddName("p1");
  if (!CheckRaspberry1(p1))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckTomato2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p5");
  if (!CheckBlackberry2(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckChives2(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p8");
  if (!CheckGaliaMelon3(p8))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p10");
  if (!CheckCorn1(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckCauliflower2(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckBritishQueens1(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p13");
  if (!CheckBeechNut2(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p14");
  if (!CheckRasin2(p14))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p15");
  if (!CheckGaliaMelon3(p15))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p16");
  if (!CheckLoganBerry(p16))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p17");
  if (!CheckGaliaMelon3(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Pear3Return"); 
  switch (ernie.getULong() % 6)
  {
    case 0:
          {
            ::CherryTomatoes3 ex;
            GetCherryTomatoes3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 1:
          {
            ::Sharanfruit3 ex;
            GetSharanfruit3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 2:
          {
            ::Raspberry3 ex;
            GetRaspberry3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 3:
          {
            ::Cherry3 ex;
            GetCherry3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 4:
          {
            ::Papaya3 ex;
            GetPapaya3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 5:
          {
            ::Peppercorn3 ex;
            GetPeppercorn3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
  }
  ReturnValue = new ::Mangosteen3;
  GetMangosteen3(*ReturnValue);
  p2 = new ::BeechNut2;
  ernie.mode(0);
  GetBeechNut2(*p2);
  ernie.mode(2);
  GetTomato2(p3);
  p4 = new ::Cauliflower2;
  ernie.mode(0);
  GetCauliflower2(*p4);
  ernie.mode(2);
  GetBlackberry2(p5);
  p6 = new ::Oregano3;
  ernie.mode(0);
  GetOregano3(*p6);
  ernie.mode(2);
  GetChives2(p7);
  ernie.mode(2);
  GetGaliaMelon3(p8);
  ernie.mode(0);
  GetOctet(p9);
  ernie.mode(2);
  GetBritishQueens1(p12);
  ernie.mode(2);
  GetRasin2(p14);
  ernie.mode(2);
  GetGaliaMelon3(p15);
  ernie.mode(2);
  GetGaliaMelon3(p17);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ExceptionTests::Pear3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

CORBA::Any*
siiServer_imp::Susander3(::BambooShoot3_out p1,::Turnip3 &p2,::Beetroot2 &p3,::Turnip3_out p4,const ::BambooShoot3 &p5,::BlackEyedBeans &p6,::Fennell3 &p7,::Cauliflower2_out p8,::Dates3 &p9,::Squash2 &p10,const ::Cauliflower2 &p11,::LoganBerry &p12,::BeechNut2 &p13,::Dates3_out p14,::GardenPeas3_out p15,::Asparagus_out p16,const ::Currant2 &p17,const ::Raspberry1 p18,::BrazilNut3 &p19 VSORB_SRC_ENV)
     throw(CORBA::SystemException)
{ 
  CORBA::Any* ReturnValue;
  
  

#ifdef DEBUG
  ::tet_infoline("server: executing ::ExceptionTests::Susander3");
#endif
  
  ernie.seed("Susander3Call");
  ernie.mode(1);
  AddName("p2");
  if (!CheckTurnip3(p2))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p3");
  if (!CheckBeetroot2(p3))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p5");
  if (!CheckBambooShoot3(p5))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p6");
  if (!CheckBlackEyedBeans(p6))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p7");
  if (!CheckFennell3(p7))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p9");
  if (!CheckDates3(p9))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p10");
  if (!CheckSquash2(p10))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p11");
  if (!CheckCauliflower2(p11))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p12");
  if (!CheckLoganBerry(p12))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p13");
  if (!CheckBeechNut2(p13))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p17");
  if (!CheckCurrant2(p17))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(0);
  AddName("p18");
  if (!CheckRaspberry1(p18))
    ::tet_result(TET_FAIL);
  RemoveName();
  ernie.mode(1);
  AddName("p19");
  if (!CheckBrazilNut3(p19))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("Susander3Return"); 
  switch (ernie.getULong() % 4)
  {
    case 0:
          {
            ::Raspberry3 ex;
            GetRaspberry3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 1:
          {
            ::Damsons3 ex;
            GetDamsons3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 2:
          {
            ::Peanutsquash3 ex;
            GetPeanutsquash3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
    case 3:
          {
            ::CherryTomatoes3 ex;
            GetCherryTomatoes3(ex);
            ::tet_result(TET_PASS);
            throw(ex);
          }
  }
  ReturnValue = new CORBA::Any;
  GetAny(*ReturnValue);
  p1 = new ::BambooShoot3;
  ernie.mode(0);
  GetBambooShoot3(*p1);
  ernie.mode(2);
  GetTurnip3(p2);
  ernie.mode(2);
  GetBeetroot2(p3);
  p4 = new ::Turnip3;
  ernie.mode(0);
  GetTurnip3(*p4);
  ernie.mode(2);
  GetBlackEyedBeans(p6);
  ernie.mode(2);
  GetFennell3(p7);
  p8 = new ::Cauliflower2;
  ernie.mode(0);
  GetCauliflower2(*p8);
  ernie.mode(2);
  GetDates3(p9);
  ernie.mode(2);
  GetSquash2(p10);
  ernie.mode(2);
  GetLoganBerry(p12);
  ernie.mode(2);
  GetBeechNut2(p13);
  p14 = new ::Dates3;
  ernie.mode(0);
  GetDates3(*p14);
  p15 = new ::GardenPeas3;
  ernie.mode(0);
  GetGardenPeas3(*p15);
  p16 = new ::Asparagus;
  ernie.mode(0);
  GetAsparagus(*p16);
  ernie.mode(2);
  GetBrazilNut3(p19);

#ifdef DEBUG
  ::tet_infoline("server: returning from ::ExceptionTests::Susander3");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

